subroutine output_tmp
  use ac_parameter
  use scf_negf
  use hamiltonian_temp
  use ac_mpi_module
  use gf_se_c

  integer i
  integer count, rcount, icount

  write(6,*) 'atom', Param%Data%natom
  write(6,*) 'base', Base%npao

  rcount=0
  icount=0

  count = size(Base%vnpao) + size(Base%vipao)
  rcount=rcount+count
  write(6,'(a,t30,f15.5,i20)') 'Base%vnpao', count*8/1e6, count
  count = size(Base%vpao)
  rcount=rcount+count
  write(6,'(a,t30,f15.5,i20)') 'Base%vpao', count*8/1e6, count

  count=0
  do i=1,size(Base%vpao)
     count=count+size(Base%vpao(i)%wave)     
  end do
  rcount=rcount+count
  write(6,'(a,t30,f15.5,i20)') 'Base%vpao%wave', count*8/1e6, count
  count=0
  do i=1,size(Base%vpao)
     count=count+size(Base%vpao(i)%gwave)     
  end do
  rcount=rcount+count
  write(6,'(a,t30,f15.5,i20)') 'Base%vpao%gwave', count*8/1e6, count

  count = size(Density%rhoLS) + size(Density%rho) + size(Density%rhoval) + size(Density%rhopcc)
  rcount=rcount+count
  write(6,'(a,t30,f15.5,i20)') 'rho,rhoval,rhopcc', count*8/1e6, count

  count = size(Potential%Vext) + size(Potential%dVhar) + size(Potential%Vtot)
  rcount=rcount+count
  write(6,'(a,t30,f15.5,i20)') 'vext,dfhar,vtot', count*8/1e6, count

  count=0
  do l=0, Param%Cell%nL-1
     do a=MPI%isatom, MPI%ieatom
        do b=1, Param%Data%natom
           if(associated(Hamiltonian%vAtomMatrix(b,a,l)%Ptr)) then
              count=count+size(Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0) &
                   +size(Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H) &
                   +size(Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDM)
           end if
        end do
     end do
  end do
  rcount=rcount+count
  write(6,'(a,t30,f15.5,i20)') 'h%amat%h0,h,cdm,edm', count*8/1e6, count

  count = size(v_ext) + size(rhoval) + size(rhopcc) + size(v_hartree)
  rcount=rcount+count
  write(6,'(a,t30,f15.5,i20)') 'v_ext,rhoval,rhopcc,v_hartree', count*8/1e6, count
  count = size(rho_temp)
  rcount=rcount+count
  write(6,'(a,t30,f15.5,i20)') 'rho_temp', count*8/1e6, count

  count = size(v_tot) + size(r_cell_dk) + size(g2_temp)
  rcount=rcount+count
  write(6,'(a,t30,f15.5,i20)') 'v_tot,r_cell_dk,g2_temp', count*8/1e6, count
  count = size(cell_lr) 
  icount=icount+count
  write(6,'(a,t30,f15.5,i20)') 'cell_lr', count*4/1e6, count

  count = size(hv_atom_matrix)
  rcount=rcount+count
  write(6,'(a,t30,f15.5,i20)') 'hv_atom_matrix', count*8/1e6, count

  count = size(ht_hs_c) + size(rac_c)
  rcount=rcount+count
  write(6,'(a,t30,f15.5,i20)') 'ht_hs_c,rac_c', count*8/1e6, count
  count = size(i_over_c) + size(i_orb_c)
  icount=icount+count
  write(6,'(a,t30,f15.5,i20)') 'i_over_c,i_orb_c', count*4/1e6, count

  count = size(ht_hs_l) + size(rac_l)
  rcount=rcount+count
  write(6,'(a,t30,f15.5,i20)') 'ht_hs_l,rac_l', count*8/1e6, count
  count = size(i_over_l) + size(i_orb_l)
  icount=icount+count
  write(6,'(a,t30,f15.5,i20)') 'i_over_l,i_orb_l', count*4/1e6, count

  count = size(ht_hs_r) + size(rac_r)
  rcount=rcount+count
  write(6,'(a,t30,f15.5,i20)') 'ht_hs_r,rac_r', count*8/1e6, count
  count = size(i_over_r) + size(i_orb_r)
  icount=icount+count
  write(6,'(a,t30,f15.5,i20)') 'i_over_r,i_orb_r', count*4/1e6, count

  count = size(vh_l) + size(v0_l) + size(dens_temp_l) + size(v_tot_l) + size(vh_temp_l) + size(vh_l_f)
  rcount=rcount+count
  write(6,'(a,t30,f15.5,i20)') 'vh_l,v0_l,dens_temp_l,v_tot_l,vh_temp_l', count*8/1e6, count
  count = size(den_l)
  rcount=rcount+count
  write(6,'(a,t30,f15.5,i20)') 'dens_l', count*8/1e6, count  

  count = size(se_l_mat_per) + size(se_r_mat_per)
  rcount=rcount+count
  write(6,'(a,t30,f15.5,i20)') 'se_l_mat_per,se_r_mat_per', count*8/1e6, count
  count = size(tr_gr_l) + size(tr_gr_r) + size(tr_gr_c) + size(tr_tr) + size(tr_grc_block)
  rcount=rcount+count
  write(6,'(a,t30,f15.5,i20)') 'tr_gr_l,tr_gr_r,tr_gr_c,tr_tr,tr_grc_block', count*8/1e6, count

  count = size(h_cc_scf) + size(s_cc_scf) 
  rcount=rcount+count*2
  write(6,'(a,t30,f15.5,i20)') 'h_cc_scf,s_cc_scf', count*8/1e6, count

  count = size(hcc_t) + size(scc_t) &
       + size(s00_l_t) + size(s01_l_t) + size(s10_l_t) &
       + size(s00_r_t) + size(s01_r_t) + size(s10_r_t) &
       + size(h00_l_t) + size(h01_l_t) + size(h10_l_t) &
       + size(h00_r_t) + size(h01_r_t) + size(h10_r_t)
  rcount=rcount+count*2
  write(6,'(a,t30,f15.5,i20)') 'hcc_t,scc_t,...', count*8/1e6, count

  count = size(rho) + size(rhols)
  rcount=rcount+count
  write(6,'(a,t30,f15.5,i20)') 'rho,rhols', count*8/1e6, count

  write(6,'(a,t30,f15.5,i20)') 'total', (rcount*8+icount*4)/1e6, rcount+icount/2

end subroutine output_tmp

subroutine Potential__deallocate2
  use ac_parameter

  implicit none

  if( associated(Potential%Vext) ) deallocate( Potential%Vext )
  if( associated(Potential%dVhar) ) deallocate( Potential%dVhar )
  if( associated(Potential%Vexc) ) deallocate( Potential%Vexc )
  if( associated(Potential%vnVpsnon) ) deallocate( Potential%vnVpsnon )
  if( associated(Potential%viVpsnon) ) deallocate( Potential%viVpsnon )
  if( associated(Potential%vVpsnon) ) deallocate( Potential%vVpsnon )
  if( associated(Potential%vVpsloc) ) deallocate( Potential%vVpsloc )
  if( associated(Potential%vnVpsloc) ) deallocate( Potential%vnVpsloc )
  if( associated(Potential%viVpsloc) ) deallocate( Potential%viVpsloc )

  if( Param%Option%cluster ) then
     call Screening__deallocate
  endif

  return
end subroutine Potential__deallocate2

subroutine Density__deallocate2
  use ac_parameter

  implicit none
  integer :: n

  if( Param%Option%spin_orbit ) then
  else
  end if

  if( associated(Density%rhoval) ) deallocate(Density%rhoval)
  if( associated(Density%rhopcc) ) deallocate(Density%rhopcc)
  if( associated(Density%vpast) ) then
     if( Param%Option%spin_orbit ) then
        do n=1, size(Density%vpast)
        end do
     else
        do n=1, size(Density%vpast)
        end do
     end if
  end if

  return
end subroutine Density__deallocate2

subroutine Base__deallocate2
  use ac_parameter
  use ac_mpi_module

  implicit none
  integer :: a, i, i1
  type(PAO_type), pointer :: pao

  if( associated(Base%vpao)  ) then
     do a=1, Param%Data%natom
        if( a<MPI%isatom .or. MPI%ieatom<a ) cycle

        i=Base%vipao(a)
        do i1=MPI%ispao(a), MPI%iepao(a)
           pao => Base%vpao(i+i1-1)
        end do
     end do

  end if

  call SphericalHarmonic__deallocate

  return
end subroutine Base__deallocate2

subroutine Base__deallocate3
  use ac_parameter
  use ac_mpi_module

  implicit none
  integer :: a, i, i1
  type(PAO_type), pointer :: pao

  if( associated(Base%vpao)  ) then
     do a=1, Param%Data%natom
        if( a<MPI%isatom .or. MPI%ieatom<a ) cycle

        i=Base%vipao(a)
        do i1=MPI%ispao(a), MPI%iepao(a)
           call PAO__deallocate( Base%vpao(i+i1-1) )
           pao => Base%vpao(i+i1-1)
           if( associated(pao%wave) ) deallocate(pao%wave)
        end do
     end do

     deallocate( Base%vpao )
  end if
  if( associated(Base%vipao) ) deallocate( Base%vipao )
  if( associated(Base%vnpao) ) deallocate( Base%vnpao )

  return
end subroutine Base__deallocate3

subroutine Param__deallocate2
  use ac_parameter
  implicit none

  integer :: a, i

  if( associated(Param%SCF%vbloch) )   deallocate( Param%SCF%vbloch )
  if( associated(Param%SCF%vK) )   deallocate( Param%SCF%vK )
  if( associated(Param%SCF%i_vK) )   deallocate( Param%SCF%i_vK )

  if( associated(Param%Band%vKpath) ) deallocate( Param%Band%vKpath )
  if( associated(Param%Band%vK) ) deallocate( Param%Band%vK )

  if( associated(Param%MO%vK) ) deallocate( Param%MO%vK )

  do i=1, Param%Data%nelem
     call Element__deallocate2( Param%Data%velem(i) )
  end do
  do a=1, Param%Data%natom
     call Atom__deallocate( Param%Data%vatom(a) )
  end do

  if( associated(Param%Data%vnpao) ) deallocate( Param%Data%vnpao )
  if( associated(Param%Data%vipao) ) deallocate( Param%Data%vipao )

  if( associated(Param%Data%velem_file) ) deallocate( Param%Data%velem_file )

  call SphericalBessel__deallocate

  return
end subroutine Param__deallocate2

subroutine Element__deallocate2( elem )
  use ac_parameter

  implicit none
  type(Element_type), intent(out) :: elem
  integer :: n

  call RadialFunc__deallocate( elem%rhoval )
  call RadialFunc__deallocate( elem%Vval )

  do n=1, elem%npao
     call RadialFunc__deallocate( elem%vpao(n) )
  end do

  call RadialFunc__deallocate( elem%Vloc )

  do n=1, elem%nVnon
     if( elem%dirac ) then
        call RadialFunc__deallocate( elem%vVnon(n,1) )
        call RadialFunc__deallocate( elem%vVnon(n,2) )
     else
        call RadialFunc__deallocate( elem%vVnon(n,1) )
     end if
  end do
  if( associated(elem%vVnon) ) deallocate(elem%vVnon)

  if( Param%Option%projection ) then
     do n=1, elem%nVloc
        call RadialFunc__deallocate( elem%vVloc(n) )
     end do
     if( associated(elem%vVloc) ) deallocate(elem%vVloc)

     do n=1, elem%npao2
        call RadialFunc__deallocate( elem%vpao2(n) )
        call RadialFunc__deallocate( elem%vpao2bar(n) )
     end do
     if( associated(elem%vpao2) ) deallocate(elem%vpao2)
     if( associated(elem%vpao2bar) ) deallocate(elem%vpao2bar)
  end if

  if( elem%pcc ) then
     call RadialFunc__deallocate( elem%rhopcc )
  end if

  return
end subroutine Element__deallocate2

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine selfenergy_r(w,iw_do,qx,qy,ispin,kt)

  use hamiltonian_sgf
  use hamiltonian_c
  use gf_se_c
  use constant
  use condition_ini
  use scf_negf

  implicit none
  integer, intent(in) :: iw_do,ispin,kt
  integer, intent(in) :: qx,qy
  complex(8) :: w

  integer :: i1_do,i2_do,ier,i_smd,i_block
  complex(8), allocatable :: amat_temp1(:,:),amat_temp2(:,:)
  complex(8), allocatable :: amat_temp3(:,:),amat_temp4(:,:)
  complex(8), allocatable :: amat_temp5(:,:)
  complex(8), allocatable :: bmat_temp1(:,:),bmat_temp2(:,:)
  complex(8), allocatable :: bmat_temp3(:,:),bmat_temp4(:,:)
  complex(8), allocatable :: bmat_temp5(:,:)

  allocate(bmat_temp2(m_mat_max_r,m_mat_max_r),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: selfenergy_r 1'
     stop
  end if

  call surf_gf_r(w,bmat_temp2,m_mat_max_r,qx,qy,ispin)
  if( gra_onoff /= 'off') then
     call cal_print_text12(iw_do,bmat_temp2,ispin,kt)
  end if

  call alo_hami_c2
  if( ham_model_ini == 'input' .or. ham_model_ini == 'scf_accel') then
     call set_hami_c_rr_input(ispin)
  else
     call set_hami_c_rr(qx,qy)
  end if
  allocate(bmat_temp1(m_mat_max_c,m_mat_max_r)                                 &
       ,bmat_temp4(m_mat_max_r,m_mat_max_c),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: selfenergy_r 2'
     stop
  end if
  do i2_do=1,m_mat_max_r
     do i1_do=1,m_mat_max_c
        bmat_temp1(i1_do,i2_do)=w*scr_mat(i1_do,i2_do)-hcr_mat(i1_do,i2_do)
     end do
  end do
  if( m_mat_max_c .ge. 8 ) then
     i_block=m_mat_max_c/4
  else
     i_block=1
  end if
  do i_smd=1,m_mat_max_c,i_block
     do i1_do=1,m_mat_max_r
        do i2_do=i_smd,min(i_smd+i_block-1,m_mat_max_c)
           bmat_temp4(i1_do,i2_do)=w*dconjg(scr_mat(i2_do,i1_do))                 &
                -dconjg(hcr_mat(i2_do,i1_do))
        end do
     end do
  end do
  call unset_hami_c2

  allocate(bmat_temp3(m_mat_max_c,m_mat_max_r),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: selfenergy_r 3'
     stop
  end if

  call mat_mul2(m_mat_max_c,m_mat_max_r,m_mat_max_r,m_mat_max_r                &
       ,m_mat_max_c,m_mat_max_r,bmat_temp1,bmat_temp2,bmat_temp3)

  deallocate(bmat_temp1,bmat_temp2,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error deallocate: selfenergy_r 1'
     stop
  end if
  allocate(bmat_temp5(m_mat_max_c,m_mat_max_c),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: selfenergy_r 4'
     stop
  end if

  call mat_mul2(m_mat_max_c,m_mat_max_r,m_mat_max_r,m_mat_max_c                &
       ,m_mat_max_c,m_mat_max_c,bmat_temp3,bmat_temp4,bmat_temp5)
  do i2_do=1,m_mat_max_c
     do i1_do=1,m_mat_max_c
        se_r_mat_per(i1_do,i2_do,qx,qy)=bmat_temp5(i1_do,i2_do)
     end do
  end do

  deallocate(bmat_temp4,bmat_temp3,bmat_temp5,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error deallocate: selfenergy_r 2'
     stop
  end if

  return
end subroutine selfenergy_r

subroutine surf_gf_r(w,bmat_temp2,m_mat_max_r,kx,ky,ispin)

  use condition_ini
  use surface_green_function
  use hamiltonian_sgf
  use hamiltonian_e

  implicit none
  integer, intent(in) :: m_mat_max_r,kx,ky,ispin
  complex(8), intent(in) :: w
  complex(8), intent(out) :: bmat_temp2(m_mat_max_r,m_mat_max_r)

  integer :: i2_do,i3_do

  mat_max=mat_max_rr

  call set_condition_r
  call set_hamiltonian_r(kx,ky,ispin)

  if( sgf_method_ini == 'transfer' ) then
     call alo_surface_gf_transefer(mat_max_rr)
  else
     if( sgf_method_ini == 'direct' ) then
        call alo_surface_gf_direct(mat_max_rr)
     else
        write(6,*) 'error - sgf_method_r'
     end if
  end if

  !                       ------------------------------------                       !

  if( sgf_method_ini == 'transfer' ) then
     call su_gf_trans(iteration_max_ini,mat_max_rr,eps_ini                      &
          ,h00_mat,h01_mat,h10_mat,s00_mat,s01_mat,s10_mat,w)
  else
     if( sgf_method_ini == 'direct' ) then
        call su_gf_direct(iteration_max_ini,mat_max_rr,eps_ini                   &
             ,h00_mat,h01_mat,h10_mat,s00_mat,s01_mat,s10_mat,w)
     end if
  end if
  do i3_do=1,mat_max_rr
     do i2_do=1,mat_max_rr
        bmat_temp2(i2_do,i3_do)=gr00(i2_do,i3_do)
     end do
  end do

  !                       ------------------------------------                       !

  if( sgf_method_ini == 'transfer' ) then
     call unset_surface_gf_transefer
  else
     if( sgf_method_ini == 'direct' ) then
        call unset_surface_gf_direct
     end if
  end if

  call unset_hamiltonian
  call unset_condition_r

  return
end subroutine surf_gf_r

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Naoki WATANABE, Nobutaka NISHIKAWA (Mizuho I.R.)   @@ !
! @@             Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine vector3d__save1( v, fname )
  use ac_misc_module

  implicit none
  real(8), intent(in)  :: v(Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)
  character(len=*), intent(in) :: fname

  if( index( fname, ".cube", .true. ) + 4 == len_trim(fname) ) then
     call vector3d__save1Cube( v, fname )
  else
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,999) trim(fname)
999  format('      +++++++ Error! vecter3d::save1 : unknown format: ',a)
     close(16)
     stop
  end if

  return
end subroutine vector3d__save1

subroutine vector3d__save2( v, fname )
  use ac_misc_module

  implicit none
  real(8), intent(in)  :: v(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)
  character(len=*), intent(in) :: fname

  if( index( fname, ".cube", .true. ) + 4 == len_trim(fname) ) then
     call vector3d__save2Cube( v, fname )
  else
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,999) trim(fname)
999  format('      +++++++ Error! vecter3d::save2 : unknown format: ',a)
     close(16)
     stop
  end if

  return
end subroutine vector3d__save2

subroutine vector3d__save4( v, fname )
  use ac_misc_module

  implicit none
  complex(8), intent(in) :: v(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)
  character(len=*), intent(in) :: fname

  if( index( fname, ".cube", .true. ) + 4 == len_trim(fname) ) then
     call vector3d__save4Cube( v, fname )
  else
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,999) trim(fname)
999  format('      +++++++ Error! vecter3d::save4 : unknown format: ',a)
     close(16)
     stop
  end if

  return
end subroutine vector3d__save4

subroutine vector3d__load1( v, fname )
  use ac_misc_module

  implicit none
  real(8), intent(out) :: v(Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)
  character(len=*), intent(in) :: fname

  if( index( fname, ".cube", .true. ) + 4 == len_trim(fname) ) then
     call vector3d__load2Cube( v, fname )
  else
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,999) trim(fname)
999  format('      +++++++ Error! vecter3d::load1 : unknown format: ',a)
     close(16)
     stop
  end if

  return
end subroutine vector3d__load1

subroutine vector3d__load2( v, fname )
  use ac_misc_module

  implicit none
  real(8), intent(out) :: v(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)
  character(len=*), intent(in) :: fname

  if( index( fname, ".cube", .true. ) + 4 == len_trim(fname) ) then
     call vector3d__load2Cube( v, fname )
  else
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,999) trim(fname)
999  format('      +++++++ Error! vecter3d::load2 : unknown format: ',a)
     close(16)
     stop
  end if

  return
end subroutine vector3d__load2

subroutine vector3d__load4( v, fname )
  use ac_misc_module

  implicit none
  complex(8), intent(out) :: v(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)
  character(len=*), intent(in) :: fname

  if( index( fname, ".cube", .true. ) + 4 == len_trim(fname) ) then
     call vector3d__load4Cube( v, fname )
  else
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,999) trim(fname)
999  format('      +++++++ Error! vecter3d::load4 : unknown format: ',a)
     close(16)
     stop
  end if

  return
end subroutine vector3d__load4

subroutine vector3d__save1Cube( v, fname )
  use ac_misc_module
  implicit none
  real(8), intent(in)  :: v(Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)

  character(len=*), intent(in) :: fname
  integer :: ia, ib, ic, i
  integer :: iunit

  iunit = 1
  open(iunit,file=fname)
  write(iunit,*) 'ACCEL'
  write(iunit,*) trim(fname)
  write(iunit,993) Param%Data%natom, Param%Cell%Lo(:)
  write(iunit,993) Param%Cell%Na, Param%Cell%dLa(:)
  write(iunit,993) Param%Cell%Nb, Param%Cell%dLb(:)
  write(iunit,993) Param%Cell%Nc, Param%Cell%dLc(:)
  do i=1, Param%Data%natom
     write(iunit,992) Param%Data%vatom(i)%number, Param%Data%vatom(i)%Q                  &
          , Param%Data%vatom(i)%Ro(:)
  end do
  do ia=1,Param%Cell%Na
     do ib=1,Param%Cell%Nb
        write(iunit,999) (v(ia,ib,ic),ic=1,Param%Cell%Nc)
     end do
  end do

  close(iunit)

999 format(6f17.10)
993 format(i4,3f17.10)
992 format(i4,4f17.10)

  return
end subroutine vector3d__save1Cube

subroutine vector3d__save2Cube( v, fname )
  use ac_misc_module

  implicit none
  real(8), intent(in)  :: v(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)

  character(len=*), intent(in) :: fname
  integer :: ia, ib, ic
  integer :: iunit

  iunit = 1
  open(iunit,file=fname)

  write(iunit,'(a)') 'ACCEL'
  write(iunit,'(a)') trim(fname)
  write(iunit,'(i5,3f20.15)') 0, Param%Cell%Lo(:)*AU_TO_AA 

  write(iunit,'(i5,3f20.15)') Param%Cell%Na, Param%Cell%dLa(:)*AU_TO_AA 

  write(iunit,'(i5,3f20.15)') Param%Cell%Nb, Param%Cell%dLb(:)*AU_TO_AA 

  write(iunit,'(i5,3f20.15)') Param%Cell%Nc, Param%Cell%dLc(:)*AU_TO_AA 

  do ia=1, Param%Cell%Na
     do ib = 1, Param%Cell%Nb
        do ic = 1, Param%Cell%Nc
           write(iunit,'(2e25.15)') v(:,ia,ib,ic)
        end do
     end do
  end do

  close(iunit)

  return
end subroutine vector3d__save2Cube

subroutine vector3d__save4Cube( v, fname )
  use ac_misc_module

  implicit none
  complex(8), intent(in)  :: v(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)

  character(len=*), intent(in) :: fname
  integer :: ia, ib, ic
  integer :: iunit

  iunit = 1
  open(iunit,file=fname)

  write(iunit,'(a)') 'ACCEL'
  write(iunit,'(a)') trim(fname)
  write(iunit,'(i5,3f20.15)') 0, Param%Cell%Lo(:)*AU_TO_AA 

  write(iunit,'(i5,3f20.15)') Param%Cell%Na, Param%Cell%dLa(:)*AU_TO_AA 

  write(iunit,'(i5,3f20.15)') Param%Cell%Nb, Param%Cell%dLb(:)*AU_TO_AA 

  write(iunit,'(i5,3f20.15)') Param%Cell%Nc, Param%Cell%dLc(:)*AU_TO_AA 

  do ia=1, Param%Cell%Na
     do ib = 1, Param%Cell%Nb
        do ic = 1, Param%Cell%Nc
           write(iunit,'(8e25.15)') v(:,ia,ib,ic)
        end do
     end do
  end do

  close(iunit)

  return
end subroutine vector3d__save4Cube

subroutine vector3d__load1Cube( v, fname )
  use ac_misc_module

  implicit none
  real(8), intent(out) :: v(Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)

  character(len=*), intent(in) :: fname

  integer          :: natom, n
  integer          :: nx, ny, nz
  integer          :: ia, ib, ic, i
  integer          :: iunit
  logical          :: ex
  character(128)   :: buf


  inquire( file=fname, exist = ex )
  if( .not. ex ) then
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,899) trim(fname)
899  format('      +++++++ Error! vecter3d::loadCube : can not open file: ',a)
     close(16)
     stop
  end if

  iunit = 1
  open(iunit,file=fname)
  read(iunit,*) 
  read(iunit,*) 
  read(iunit,*) natom
  read(iunit,*) nx
  read(iunit,*) ny
  read(iunit,*) nz
  if( natom < 0 ) natom = -natom
  if( nx < 0 ) nx = -nx
  if( ny < 0 ) ny = -ny
  if( nz < 0 ) nz = -nz

  if( nx /= Param%Cell%Na .or. ny /= Param%Cell%Nb .or. nz /= Param%Cell%Nc ) then
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,888) trim(fname)
888  format('      +++++++ Error! vecter3d::loadCube : size mismatch in: ',a)
     close(16)
     close(iunit)
     stop
  end if

  do i=1, natom
     read(iunit,*)
  end do

  do ia=1,Param%Cell%Na
     do ib=1,Param%Cell%Nb
        read(iunit,999) (v(ia,ib,ic),ic=1,Param%Cell%Nc)
     end do
  end do

  close(iunit)

999 format(6f17.10)

  return
end subroutine vector3d__load1Cube

subroutine vector3d__load2Cube( v, fname )
  use ac_misc_module

  implicit none
  real(8), intent(out) :: v(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)

  character(len=*), intent(in) :: fname

  integer          :: natom, n
  integer          :: nx, ny, nz
  integer          :: ia, ib, ic
  integer          :: iunit
  logical          :: ex
  character(128)   :: buf

  inquire( file=fname, exist = ex )
  if( .not. ex ) then
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,899) trim(fname)
899  format('      +++++++ Error! vecter3d::loadCube : can not open file: ',a)
     close(16)
     stop
  end if
  iunit = 1
  open(iunit,file=fname)

  read(iunit,'(a)') buf
  read(iunit,'(a)') buf

  read(iunit,'(a)') buf
  read(buf,*) natom
  if( natom < 0 ) natom = -natom

  read(iunit,'(a)') buf
  read(buf,*) nx
  if( nx < 0 ) nx = -nx

  read(iunit,'(a)') buf
  read(buf,*) ny
  if( ny < 0 ) ny = -ny

  read(iunit,'(a)') buf
  read(buf,*) nz
  if( nz < 0 ) nz = -nz

  if( nx /= Param%Cell%Na .or. ny /= Param%Cell%Nb .or. nz /= Param%Cell%Nc ) then
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,888) trim(fname)
888  format('      +++++++ Error! vecter3d::loadCube : size mismatch in: ',a)
     close(16)
     close(iunit)
     stop
  end if

  do n=1, natom
     read(iunit,'(a)') buf
  end do

  do ia=1, Param%Cell%Na
     do ib=1, Param%Cell%Nb
        do ic=1, Param%Cell%Nc
           read(iunit,'(a)') buf
           read(buf,*) v(:,ia,ib,ic)
        end do
     end do
  end do

  close(iunit)

  return
end subroutine vector3d__load2Cube

subroutine vector3d__load4Cube( v, fname )
  use ac_misc_module

  implicit none
  complex(8), intent(out) :: v(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)

  character(len=*), intent(in) :: fname

  integer          :: natom, n
  integer          :: nx, ny, nz
  integer          :: ia, ib, ic
  integer          :: iunit
  logical          :: ex
  character(128)   :: buf

  inquire( file=fname, exist = ex )
  if( .not. ex ) then
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,899) trim(fname)
899  format('      +++++++ Error! vecter3d::loadCube : can not open file: ',a)
     close(16)
     stop
  end if
  iunit = 1
  open(iunit,file=fname)

  read(iunit,'(a)') buf
  read(iunit,'(a)') buf

  read(iunit,'(a)') buf
  read(buf,*) natom
  if( natom < 0 ) natom = -natom

  read(iunit,'(a)') buf
  read(buf,*) nx
  if( nx < 0 ) nx = -nx

  read(iunit,'(a)') buf
  read(buf,*) ny
  if( ny < 0 ) ny = -ny

  read(iunit,'(a)') buf
  read(buf,*) nz
  if( nz < 0 ) nz = -nz

  if( nx /= Param%Cell%Na .or. ny /= Param%Cell%Nb .or. nz /= Param%Cell%Nc ) then
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,888) trim(fname)
888  format('      +++++++ Error! vecter3d::loadCube : size mismatch in: ',a)
     close(16)
     close(iunit)
     stop
  end if

  do n=1, natom
     read(iunit,'(a)') buf
  end do

  do ia=1, Param%Cell%Na
     do ib=1, Param%Cell%Nb
        do ic=1, Param%Cell%Nc
           read(iunit,'(a)') buf
           read(buf,*) v(:,ia,ib,ic)
        end do
     end do
  end do

  close(iunit)

  return
end subroutine vector3d__load4Cube

subroutine vector3d__save_mo( v, fname )
  use ac_misc_module

  implicit none
  real(8), intent(in)  :: v(Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)
  character(len=*), intent(in) :: fname

  call vector3d__saveCube_mo( v, fname )

  return
end subroutine vector3d__save_mo

subroutine vector3d__saveCube_mo( v, fname )
  use ac_misc_module

  implicit none
  real(8), intent(in)  :: v(Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)
  character(len=*), intent(in) :: fname
  integer :: ia, ib, ic, i, ii, i4
  integer :: iunit

  iunit = 1
  open(iunit,file=fname)
  write(iunit,*) 'SYS1'
  write(iunit,*) 'SYS1'
  write(iunit,993) Param%Data%natom, Param%Cell%Lo(:)
  write(iunit,993) Param%Cell%Na, Param%Cell%dLa(:)
  write(iunit,993) Param%Cell%Nb, Param%Cell%dLb(:)
  write(iunit,993) Param%Cell%Nc, Param%Cell%dLc(:)
  do i=1, Param%Data%natom
     write(iunit,992) Param%Data%vatom(i)%number, Param%Data%vatom(i)%Q                  &
          , Param%Data%vatom(i)%Ro(:)
  end do
  do ia=1,Param%Cell%Na
     do ib=1,Param%Cell%Nb
        write(iunit,999) (v(ia,ib,ic),ic=1,Param%Cell%Nc)
     end do
  end do

  close(iunit)

999 format(6f13.6)
993 format(i4,3f13.6)
992 format(i4,4f13.6)

  return
end subroutine vector3d__saveCube_mo

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@             Naoki WATANABE (Mizuho I.R.)                       @@ !
! @@             Nobutaka NISHIKAWA (Mizuho I.R.)                   @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine set_hami_c_cc_scf( desc, ispin )
  use condition_ini
  use hamiltonian_sgf
  use hamiltonian_c
  use hamiltonian_temp
  use scf_negf
  use ac_mpi_module

  implicit none
  type(MPI_MatDesc), intent(in) :: desc
  integer, intent(in) :: ispin

  hcc_mat(:,:) = h_cc_scf(:,:,ispin) 
  scc_mat(:,:) = s_cc_scf(:,:) 

  return
end subroutine set_hami_c_cc_scf

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Naoki WATANABE, Nobutaka NISHIKAWA (Mizuho I.R.)   @@ !
! @@             Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

program accel
  use ac_misc_module
  use ac_mpi_module
  implicit none
  character(64) :: argv

  call MPI__Initialize

  call gen_outf_accel
  open(unit=16,file=Param%Option%file_ac_tempout,position='append')
  write(16,*) ':-:-:-:-:-:-:-:-:-:-:-:-:-:-:-::-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:'
  write(16,*) ':-:-:-:-:-:-:-:-:-:-:-:-:-:-:-::-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:'
  write(16,*) ':-:-:-:-:-:-:-:-:                            :-:-:-:-:-:-:-:-:'
  write(16,*) ':-:-:-:-:-:-:-:-: Welcome to ACCEL ver. 4.4  :-:-:-:-:-:-:-:-:'
  write(16,*) ':-:-:-:-:-:-:-:-:                            :-:-:-:-:-:-:-:-:'
  write(16,*) ':-:-:-:-:-:-:-:-:-:-:-:-:-:-:-::-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:'
  write(16,*) ':-:-:-:-:-:-:-:-:-:-:-:-:-:-:-::-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:'
  !write(16,*)
  close(16)

  if( MPI%root ) then
     if( command_argument_count() == 0 ) then
        call MPI__Finalize

        open(unit=16,file=Param%Option%file_ac_tempout,position='append')
        write(16,'(a)') "# usage"
        write(16,'(a)') "# mpirun -np <number> accel <input file>"
        close(16)
        stop
     end if

     call get_command_argument(1,argv)
  end if
  call MPI__Bcast_Inputfile( argv )

  call ac_main(argv)

  call MPI__Finalize

contains

  function command_argument_count() result(argc)
    implicit none
    integer :: argc, iargc

    argc = iargc()
    if( argc < 0 ) then
       !**********************
       !write(*,'(a)') "# Error! : iargc function is not working."
       open(unit=16,file=Param%Option%file_ac_tempout,position='append')
       write(16,'(a)') "# Error! : iargc function is not working."
       close(16)
       !**********************
       stop
    end if
    return
  end function command_argument_count

  subroutine get_command_argument(index,argv)
    implicit none
    integer, intent(in) :: index
    character(len=*), intent(out) :: argv

    call getarg(index,argv)

    return
  end subroutine get_command_argument

end program accel

subroutine gen_outf_accel
  use ac_misc_module
  use ac_mpi_module

  implicit none
  integer :: i2,i_temp1,i_temp2
  character(1) :: character_temp(4),a(10)

  a(1)='0'
  a(2)='1'
  a(3)='2'
  a(4)='3'
  a(5)='4'
  a(6)='5'
  a(7)='6'
  a(8)='7'
  a(9)='8'
  a(10)='9'

  i_temp1=MPI%rank+1
  do i2=1,4
     i_temp2=i_temp1/(10**(4-i2))
     character_temp(i2)=a(i_temp2+1)
     i_temp1=i_temp1-(10**(4-i2))*i_temp2
  end do
  Param%Option%file_ac_tempout='g.output'//'_'//character_temp(1)//character_temp(2)     &
       //character_temp(3)//character_temp(4)

  return
end subroutine gen_outf_accel

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@             Naoki WATANABE (Mizuho I.R.)                       @@ !
! @@             Nobutaka NISHIKAWA (Mizuho I.R.)                   @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine selfenergy_l( descCC, descCL, descLL, w,iw_do,px,py,ispin,kt )
  use hamiltonian_sgf
  use hamiltonian_c
  use gf_se_c
  use constant
  use condition_ini
  use scf_negf
  use ac_mpi_module

  implicit none
  type(MPI_MatDesc), intent(in) :: descLL, descCL, descCC
  integer, intent(in) :: iw_do,ispin,kt
  integer, intent(in) :: px,py
  complex(8), intent(in) :: w

  integer :: ier
  integer :: i, j
  complex(8), allocatable :: amat_temp1(:,:),amat_temp2(:,:)
  complex(8), allocatable :: amat_temp3(:,:),amat_temp4(:,:)
  complex(8), allocatable :: amat_temp5(:,:)

  complex(8) :: trace

  allocate(amat_temp1(descCL%nrow,descCL%scol:descCL%ecol),stat=ier)
  allocate(amat_temp2(descLL%nrow,descLL%scol:descLL%ecol),stat=ier)
  allocate(amat_temp4(descCL%nrow,descCL%scol:descCL%ecol),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: selfenergy_l'
     stop
  end if

  call surf_gf_l(descLL,w,amat_temp2,px,py,ispin)

  if( gra_onoff /= 'off' ) then
     call MPI__ZLATRA_ASCOT( descLL, amat_temp2, trace )
     call cal_print_text11(iw_do,trace,ispin,kt)
  end if

  call alo_hami_c1(descCL)

  if( ham_model_ini == 'input' .or. ham_model_ini == 'scf_accel') then
     call set_hami_c_ll_input(descCL,descLL,ispin)
  else
     call set_hami_c_ll(descCL,px,py)
  end if

  amat_temp1(:,:) = w*scl_mat(:,:) - hcl_mat(:,:) 
  amat_temp4(:,:) = dconjg(w)*scl_mat(:,:) - hcl_mat(:,:) 

  call unset_hami_c1

  allocate(amat_temp3(descCL%nrow,descCL%scol:descCL%ecol),stat=ier)
  allocate(amat_temp5(descCC%nrow,descCC%scol:descCC%ecol),stat=ier)

  call MPI__ZGEMM2_ASCOT( 'N', 'N', descCL, descLL, descCL, &
       C1, amat_temp1, amat_temp2, C0, amat_temp3 )
  call MPI__ZGEMM2_ASCOT( 'N', 'C', descCL, descCL, descCC, &
       C1, amat_temp3, amat_temp4, C0, amat_temp5 )

  se_l_mat_per(:,:,px,py) = amat_temp5(:,:) 

  deallocate(amat_temp1,amat_temp2,amat_temp3,amat_temp4,amat_temp5,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error deallocate: selfenergy_l'
     stop
  end if

  return
end subroutine selfenergy_l
subroutine surf_gf_l(descLL,w,amat_temp2,kx,ky,ispin)

  use condition_ini
  use surface_green_function
  use hamiltonian_sgf
  use hamiltonian_e
  use ac_mpi_module

  implicit none
  type(MPI_MatDesc), intent(in) :: descLL
  complex(8), intent(in) :: w
  complex(8), intent(out) :: amat_temp2(descLL%nrow,descLL%scol:descLL%ecol)
  integer, intent(in) :: kx,ky,ispin

  integer :: i, j

  mat_max=mat_max_ll

  call set_condition_l
  call set_hamiltonian_l(descLL,kx,ky,ispin)

  if( sgf_method_ini == 'transfer' ) then
     call alo_surface_gf_transefer(descLL)
  else
     if( sgf_method_ini == 'direct' ) then
        call alo_surface_gf_direct(descLL)
     else
        write(6,*) 'error - sgf_method_l'
     end if
  end if

  if( sgf_method_ini == 'transfer' ) then
     call su_gf_trans(descLL,iteration_max_ini,eps_ini, &
          h00_mat,h01_mat,h10_mat,s00_mat,s01_mat,s10_mat,w) 
  else
     if( sgf_method_ini == 'direct' ) then
        call su_gf_direct(descLL,iteration_max_ini,eps_ini, &
             h00_mat,h01_mat,h10_mat,s00_mat,s01_mat,s10_mat,w) 
     end if
  end if

  amat_temp2(:,:) = gr00(:,:)

  if( sgf_method_ini == 'transfer' ) then
     call unset_surface_gf_transefer
  else
     if( sgf_method_ini == 'direct' ) then
        call unset_surface_gf_direct
     end if
  end if

  call unset_hamiltonian
  call unset_condition_l

  return
end subroutine surf_gf_l

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine cal_iv

  use condition_ini
  use hamiltonian_sgf
  use gf_se_c
  use hamiltonian_c
  use constant

  implicit none
  integer :: iw_do,ispin,kt,i_spin_c
  complex(8) :: current1
  complex(8) :: current2
  complex(8) :: current3

  if( spin_switch_cc == 2 ) then
     i_spin_c=2
  else
     i_spin_c=1
  end if

  current1=dcmplx(0.d0,0.d0)
  current2=dcmplx(0.d0,0.d0)
  current3=dcmplx(0.d0,0.d0)
  do kt=1,ka_tr*kb_tr
     do ispin=1,i_spin_c
        do iw_do=1,num_iv_mesh
           current1=current1+tr_tr(ispin,iw_do,kt)
        end do
        do iw_do=2,num_iv_mesh,2
           current2=current2+tr_tr(ispin,iw_do,kt)
        end do
        do iw_do=1,num_iv_mesh-1,2
           current3=current3+tr_tr(ispin,iw_do,kt)
        end do
     end do
  end do
  current1=(e/h)*current1*(cp_l-cp_r)/dfloat(num_iv_mesh*ka_tr*kb_tr)
  current2=(e/h)*current2*(cp_l-cp_r)/dfloat(num_iv_mesh/2*ka_tr*kb_tr)
  current3=(e/h)*current3*(cp_l-cp_r)/dfloat(num_iv_mesh/2*ka_tr*kb_tr)
  if( spin_switch_cc == 1 ) then
     current1=current1+current1
     current2=current2+current2
     current3=current3+current3
  end if

  open(unit=30,file='iv.dat')
  write(30,*) 'V     real     imag'
  write(30,*) cp_l-cp_r,dreal(current1),dimag(current1)
  write(30,*)
  write(30,*) 'half mesh'
  write(30,*) cp_l-cp_r,dreal(current2),dimag(current2)
  write(30,*) cp_l-cp_r,dreal(current3),dimag(current3)
  close(30)

end subroutine cal_iv

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Naoki WATANABE, Nobutaka NISHIKAWA (Mizuho I.R.)   @@ !
! @@             Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine ZFFT1D_forward( nx, data )
  use ac_mpi_module

  implicit none
  integer, intent(in) :: nx
  complex(8), intent(inout) :: data (nx)

  integer(8)         :: pf
  integer, parameter :: FFTW_ESTIMATE = 64 
  integer, parameter :: FFTW_FORWARD  = -1

  integer scount, ecount, rate, count_max

  call system_clock(scount, rate, count_max )

  call dfftw_plan_dft_1d( pf, nx, data, data, FFTW_FORWARD, FFTW_ESTIMATE )
  call dfftw_execute_dft( pf, data, data )
  call dfftw_destroy_plan(pf)

  call system_clock(ecount, rate, count_max )
  time_fft = time_fft + real(ecount-scount)/rate

  return
end subroutine ZFFT1D_forward

subroutine ZFFT1D_backward( nx, data )
  use ac_mpi_module

  implicit none
  integer, intent(in) :: nx
  complex(8), intent(inout) :: data (nx)

  integer(8)         :: pb
  integer, parameter :: FFTW_ESTIMATE = 64 
  integer, parameter :: FFTW_BACKWARD = +1

  integer scount, ecount, rate, count_max

  call system_clock(scount, rate, count_max )

  call dfftw_plan_dft_1d( pb, nx, data, data, FFTW_BACKWARD, FFTW_ESTIMATE )
  call dfftw_execute_dft( pb, data, data )
  call dfftw_destroy_plan(pb)

  call system_clock(ecount, rate, count_max )
  time_fft = time_fft + real(ecount-scount)/rate

  return
end subroutine ZFFT1D_backward

subroutine ZFFT2D_forward( nx, ny, data )
  use ac_mpi_module

  implicit none
  integer, intent(in) :: nx, ny
  complex(8), intent(inout) :: data (nx,ny)

  integer(8)         :: pf
  integer, parameter :: FFTW_ESTIMATE = 64 
  integer, parameter :: FFTW_FORWARD  = -1

  integer scount, ecount, rate, count_max

  call system_clock(scount, rate, count_max )

  call dfftw_plan_dft_2d( pf, nx, ny, data, data, FFTW_FORWARD, FFTW_ESTIMATE )
  call dfftw_execute_dft( pf, data, data )
  call dfftw_destroy_plan(pf)

  call system_clock(ecount, rate, count_max )
  time_fft = time_fft + real(ecount-scount)/rate

  return
end subroutine ZFFT2D_forward

subroutine ZFFT2D_backward( nx, ny, data )
  use ac_mpi_module

  implicit none
  integer, intent(in) :: nx, ny
  complex(8), intent(inout) :: data (nx,ny)

  integer(8)         :: pb
  integer, parameter :: FFTW_ESTIMATE = 64 
  integer, parameter :: FFTW_BACKWARD = +1

  integer scount, ecount, rate, count_max

  call system_clock(scount, rate, count_max )

  call dfftw_plan_dft_2d( pb, nx, ny, data, data, FFTW_BACKWARD, FFTW_ESTIMATE )
  call dfftw_execute_dft( pb, data, data )
  call dfftw_destroy_plan(pb)

  call system_clock(ecount, rate, count_max )
  time_fft = time_fft + real(ecount-scount)/rate

  return
end subroutine ZFFT2D_backward

subroutine ZFFT3D_forward( nx, ny, nz, data )
  use ac_mpi_module

  implicit none
  integer, intent(in) :: nx, ny, nz
  complex(8), intent(inout) :: data (nx,ny,nz)

  integer(8)         :: pf
  integer, parameter :: FFTW_ESTIMATE = 64 
  integer, parameter :: FFTW_FORWARD  = -1

  integer scount, ecount, rate, count_max

  call system_clock(scount, rate, count_max )

  call dfftw_plan_dft_3d( pf, nx, ny, nz, data, data, FFTW_FORWARD, FFTW_ESTIMATE )
  call dfftw_execute_dft( pf, data, data )
  call dfftw_destroy_plan(pf)

  call system_clock(ecount, rate, count_max )
  time_fft = time_fft + real(ecount-scount)/rate

  return
end subroutine ZFFT3D_forward

subroutine ZFFT3D_backward( nx, ny, nz, data )
  use ac_mpi_module

  implicit none
  integer, intent(in) :: nx, ny, nz
  complex(8), intent(inout) :: data (nx,ny,nz)

  integer(8)         :: pb
  integer, parameter :: FFTW_ESTIMATE = 64 
  integer, parameter :: FFTW_BACKWARD = +1

  integer scount, ecount, rate, count_max

  call system_clock(scount, rate, count_max )

  call dfftw_plan_dft_3d( pb, nx, ny, nz, data, data, FFTW_BACKWARD, FFTW_ESTIMATE )
  call dfftw_execute_dft( pb, data, data )
  call dfftw_destroy_plan(pb)

  call system_clock(ecount, rate, count_max )
  time_fft = time_fft + real(ecount-scount)/rate

  return
end subroutine ZFFT3D_backward

subroutine RFFT3D__forward( nx, ny, nz, data_in, data_out )
  use ac_mpi_module

  implicit none

  integer, intent(in)  :: nx, ny, nz
  real(8), intent(in)  :: data_in (nx,ny,nz)
  real(8), intent(out) :: data_out(2*(nx/2+1),ny,nz)

  integer(8)           :: pf
  integer, parameter   :: FFTW_ESTIMATE = 64 

  integer scount, ecount, rate, count_max

  call system_clock(scount, rate, count_max )

  call dfftw_plan_dft_r2c_3d( pf, &
       nx, ny, nz, data_in, data_out, FFTW_ESTIMATE )
  call dfftw_execute( pf )
  call dfftw_destroy_plan( pf )

  call system_clock(ecount, rate, count_max )
  time_fft = time_fft + real(ecount-scount)/rate

  return
end subroutine RFFT3D__forward

subroutine RFFT3D__backward( nx, ny, nz, data_in, data_out )
  use ac_mpi_module

  implicit none
  integer, intent(in)    :: nx, ny, nz
  real(8), intent(inout) :: data_in (2*(nx/2+1),ny,nz)
  real(8), intent(out)   :: data_out(nx,ny,nz)

  integer(8)             :: pb
  integer, parameter     :: FFTW_ESTIMATE = 64 

  integer scount, ecount, rate, count_max

  call system_clock(scount, rate, count_max )

  call dfftw_plan_dft_c2r_3d( pb, &
       nx, ny, nz, data_in, data_out, FFTW_ESTIMATE )
  call dfftw_execute( pb )
  call dfftw_destroy_plan( pb )

  call system_clock(ecount, rate, count_max )
  time_fft = time_fft + real(ecount-scount)/rate

  return
end subroutine RFFT3D__backward

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@             Naoki WATANABE (Mizuho I.R.)                       @@ !
! @@             Nobutaka NISHIKAWA (Mizuho I.R.)                   @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

module gf_se_c

  implicit none
  complex(8), pointer :: se_l_mat_per(:,:,:,:) 
  complex(8), pointer :: se_r_mat_per(:,:,:,:) 

  integer :: num_gra_gs,iw_max_gs
  integer, pointer :: omega_par_gs(:),omega_par_num_gs(:)
  complex(8), pointer :: omega_gs(:),omega_weight(:)

  integer :: num_block_gr
  complex(8), pointer :: tr_gr_l(:,:,:),tr_gr_r(:,:,:),tr_gr_c(:,:,:),tr_tr(:,:,:)
  complex(8), pointer :: tr_grc_block(:,:,:,:)

  integer :: kt_tr
  real(8), pointer :: po_ka_tr(:,:),po_kb_tr(:,:)
  real(8), pointer :: po_kt_tr(:,:)
contains
  subroutine alo_tr_negf_kpoint(ka_tr,kb_tr)

    implicit none
    integer, intent(in) :: ka_tr,kb_tr
    integer :: ier

    allocate(po_ka_tr(3,ka_tr),po_kb_tr(3,kb_tr)                                 &
         ,po_kt_tr(3,ka_tr*kb_tr),stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_scf_negf_kpoint'
       stop
    end if

    return
  end subroutine alo_tr_negf_kpoint

  subroutine dealo_tr_negf_kpoint

    implicit none
    integer :: ier

    deallocate(po_ka_tr,po_kb_tr,po_kt_tr,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_scf_negf_kpoint'
       stop
    end if

    return
  end subroutine dealo_tr_negf_kpoint

  subroutine alo_gf_se_c(descCC,kx_max_l,ky_max_l,kx_max_r,ky_max_r)
    use ac_mpi_module
    implicit none

    type(MPI_MatDesc), intent(in) :: descCC
    integer, intent(in) :: kx_max_l,ky_max_l,kx_max_r,ky_max_r
    integer :: ier,kx,ky,i1_do,i2_do


    allocate(se_l_mat_per(descCC%nrow,descCC%scol:descCC%ecol,ky_max_l,kx_max_l),stat=ier)    
    allocate(se_r_mat_per(descCC%nrow,descCC%scol:descCC%ecol,ky_max_r,kx_max_r),stat=ier)    
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_gf_se_c'
       stop
    end if

    do kx=1,kx_max_l
       do ky=1,ky_max_l
          se_l_mat_per(:,:,ky,kx) = dcmplx(0.d0,0.d0)    
       end do
    end do

    do kx=1,kx_max_r
       do ky=1,ky_max_r
          se_r_mat_per(:,:,ky,kx) = dcmplx(0.d0,0.d0)    
       end do
    end do

    return
  end subroutine alo_gf_se_c

  subroutine unset_gf_se_c

    implicit none
    integer :: ier

    deallocate(se_l_mat_per,se_r_mat_per,stat=ier) 
    if( ier /= 0 ) then
       write(6,*) 'error deallocate: unset_gf_se_c'
       stop
    end if

    return
  end subroutine unset_gf_se_c

  subroutine alo_condition_omega_gs(om_block_num)

    implicit none
    integer,intent(in) :: om_block_num
    integer :: ier

    allocate(omega_par_gs(om_block_num),omega_par_num_gs(om_block_num)           &
         ,omega_gs(iw_max_gs),omega_weight(iw_max_gs),stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_condition_omega_gs'
       stop
    end if

    return
  end subroutine alo_condition_omega_gs

  subroutine unset_condition_omega_gs

    implicit none
    integer :: ier

    deallocate(omega_par_gs,omega_par_num_gs,omega_gs,omega_weight,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: unset_condition_omega_gs'
       stop
    end if

    return
  end subroutine unset_condition_omega_gs

  subroutine alo_gf_se_gra(spin_t,kt_num)

    implicit none
    integer,intent(in) :: spin_t,kt_num
    integer :: ier,i1_do,i2_do,i3_do,kt,spin

    if( spin_t == 2 ) then
       spin=2
    else
       spin=1
    end if

    allocate(tr_gr_l(spin,iw_max_gs,kt_num),tr_gr_r(spin,iw_max_gs,kt_num)       &
         ,tr_gr_c(spin,iw_max_gs,kt_num),tr_tr(spin,iw_max_gs,kt_num)         &
         ,tr_grc_block(spin,num_block_gr,iw_max_gs,kt_num),stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_gf_se_gra'
       stop
    end if

    do kt=1,kt_num
       do i3_do=1,spin
          do i1_do=1,iw_max_gs
             tr_gr_l(i3_do,i1_do,kt)=dcmplx(0.d0,0.d0)
          end do
          do i1_do=1,iw_max_gs
             tr_gr_r(i3_do,i1_do,kt)=dcmplx(0.d0,0.d0)
          end do
          do i1_do=1,iw_max_gs
             tr_gr_c(i3_do,i1_do,kt)=dcmplx(0.d0,0.d0)
          end do
          do i1_do=1,iw_max_gs
             tr_tr(i3_do,i1_do,kt)=dcmplx(0.d0,0.d0)
          end do
          do i2_do=1,iw_max_gs
             do i1_do=1,num_block_gr
                tr_grc_block(i3_do,i1_do,i2_do,kt)=dcmplx(0.d0,0.d0)
             end do
          end do
       end do
    end do

    return
  end subroutine alo_gf_se_gra

  subroutine unset_gf_se_gra

    implicit none
    integer :: ier

    deallocate(tr_gr_l,tr_gr_r,tr_gr_c,tr_tr,tr_grc_block,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: unset_gf_se_gra'
       stop
    end if

    return
  end subroutine unset_gf_se_gra

end module gf_se_c

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@             Naoki WATANABE (Mizuho I.R.)                       @@ !
! @@             Nobutaka NISHIKAWA (Mizuho I.R.)                   @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

module surface_green_function

  implicit none
  complex(8), pointer :: gr00(:,:),gr01(:,:),gr02(:,:),temp(:,:)
  complex(8), pointer :: tr1(:,:),tr2(:,:),tm(:,:),tm_temp(:,:)
  complex(8), pointer :: es0(:,:),e00(:,:),alp(:,:),bet(:,:)

contains
  subroutine alo_surface_gf_transefer(descCC)
    use ac_mpi_module

    implicit none
    type(MPI_MatDesc), intent(in) :: descCC

    integer :: ier

    allocate(gr00(descCC%nrow, descCC%scol:descCC%ecol),stat=ier)
    allocate(gr01(descCC%nrow, descCC%scol:descCC%ecol),stat=ier)
    allocate(gr02(descCC%nrow, descCC%scol:descCC%ecol),stat=ier)
    allocate( tr1(descCC%nrow, descCC%scol:descCC%ecol),stat=ier)
    allocate( tr2(descCC%nrow, descCC%scol:descCC%ecol),stat=ier)
    allocate(  tm(descCC%nrow, descCC%scol:descCC%ecol),stat=ier)
    allocate(tm_temp(descCC%nrow, descCC%scol:descCC%ecol),stat=ier)
    allocate(temp(descCC%nrow, descCC%scol:descCC%ecol),stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_surface_gf_transefer'
       stop
    end if

    return
  end subroutine alo_surface_gf_transefer

  subroutine unset_surface_gf_transefer

    implicit none
    integer :: ier

    deallocate(gr00,gr01,gr02,tr1,tr2,tm,tm_temp,temp,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error deallocate: unset_surface_gf_transefer'
       stop
    end if

    return
  end subroutine unset_surface_gf_transefer

  subroutine alo_surface_gf_direct(descCC)
    use ac_mpi_module

    implicit none
    type(MPI_MatDesc), intent(in) :: descCC
    integer :: ier

    allocate(gr00(descCC%nrow, descCC%scol:descCC%ecol),stat=ier)
    allocate(gr01(descCC%nrow, descCC%scol:descCC%ecol),stat=ier)
    allocate(gr02(descCC%nrow, descCC%scol:descCC%ecol),stat=ier)
    allocate(es0(descCC%nrow, descCC%scol:descCC%ecol),stat=ier)
    allocate(e00(descCC%nrow, descCC%scol:descCC%ecol),stat=ier)
    allocate(alp(descCC%nrow, descCC%scol:descCC%ecol),stat=ier)
    allocate(bet(descCC%nrow, descCC%scol:descCC%ecol),stat=ier)
    allocate(temp(descCC%nrow, descCC%scol:descCC%ecol),stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_surface_gf_direct'
       stop
    end if

    return
  end subroutine alo_surface_gf_direct

  subroutine unset_surface_gf_direct

    implicit none
    integer :: ier

    deallocate(gr00,gr01,gr02,es0,e00,alp,bet,temp,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error deallocate: unset_surface_gf_direct'
       stop
    end if

    return
  end subroutine unset_surface_gf_direct
end module surface_green_function

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Naoki WATANABE, Nobutaka NISHIKAWA (Mizuho I.R.)   @@ !
! @@             Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine Element__readPAO_adpack( elem, name, fname, mode, mode2 )
  use ac_parameter

  implicit none
  type(Element_type), intent(out) :: elem
  character(len=*), intent(in) :: name
  character(len=*), intent(in) :: fname
  character(len=*), intent(in) :: mode
  character(len=*), intent(in) :: mode2

  integer        :: iunit
  logical        :: ex
  character(256) :: buf, tag

  real(8)  :: Rc
  integer        :: nr
  real(8), allocatable :: vr(:)
  integer, parameter :: npaoLmax=3 
  integer, parameter :: npao2Lmax=6 
  integer        :: npaoL (0:npaoLmax)
  integer        :: ipaoL (0:npaoLmax)
  integer        :: npao2L(0:npao2Lmax)
  integer        :: ipao2L(0:npao2Lmax)
  real(8)  :: logr
  real(8)  :: R(10)
  character(32) :: dummy
  character(1024) :: msg
  integer        :: i, l, n
  integer        :: maxLpao, numpao

  elem%name = name

  inquire( file=fname, exist=ex )
  if( .not. ex ) then
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,999) trim(fname)
999  format('      ++++++ Error readPAO/ can not open file: ',a)
     close(16)
     stop
  end if

  iunit=2
  open(iunit,file=fname)

  Rc = 0.d0
  nr = 0

  do 
     read(iunit,'(a)',end=100) buf
     if( buf=='' ) cycle
     read(buf,*) tag

     select case(tag)
     case('#')
     case('grid.num.output')
        read(buf,*) tag, nr
     case('maxL.pao')
        read(buf,*) tag, maxLpao
     case('num.pao')
        read(buf,*) tag, numpao

     case('radial.cutoff.pao')
        read(buf,*) tag, Rc
     end select

     if( nr /= 0 .and. Rc /= 0.d0 ) exit
  end do
100 continue

  if( nr == 0 ) then
     msg = "grid.num.output is not given"
     goto 1111
  end if
  if( Rc == 0.d0 ) then
     msg = "radial.cutoff is not given"
     goto 1111
  end if

  allocate( vr(nr) )

  do l=0, npaoLmax
     npaoL(l) = 0
  end do

  if( mode == "" ) then
     do l = 0, maxLpao
        npaoL(l) = numpao
     end do
  else if( mode(1:1) /= 's' ) then
     if( len_trim(mode) == 1 ) then
        npaoL(0) = numpao 
     else
        read(mode(2:2),*) npao2L(0)
     end if

     select case( mode(1:1) )
     case('p')
        npaoL(1:1) = npaoL(0)
     case('d')
        npaoL(1:2) = npaoL(0)
     case('f')
        npaoL(1:3) = npaoL(0)
     end select
  else
     do i=1, len_trim(mode), 2
        select case( mode(i:i) )
        case('s')
           read( mode(i+1:i+1), * ) npaoL(0)
        case('p')
           read( mode(i+1:i+1), * ) npaoL(1)
        case('d')
           read( mode(i+1:i+1), * ) npaoL(2)
        case('f')
           read( mode(i+1:i+1), * ) npaoL(3)
        end select
     end do
  end if

  do l=0, npaoLmax
     if( npaoL(l) > numpao ) then
        open(unit=16,file=Param%Option%file_ac_tempout,position='append')
        write(16,*) '      ++++++ Warning: too many radial PAO bases requested for band calculations. Reduced to', numpao
        close(16)
        npaoL(l) = numpao
     end if
  end do

  do l=0, npao2Lmax
     npao2L(l)=0
  end do

  if( mode2 == "" ) then
     do l = 0, npao2Lmax
        npao2L(l) = numpao
     end do
  else if( mode2(1:1) /= 's' ) then
     if( len_trim(mode2) == 1 ) then
        npao2L(0) = numpao 
     else
        read(mode2(2:2),*) npao2L(0)
     end if

     select case( mode2(1:1) )
     case('p')
        npao2L(1:1) = npao2L(0)
     case('d')
        npao2L(1:2) = npao2L(0)
     case('f')
        npao2L(1:3) = npao2L(0)
     case('g')
        npao2L(1:4) = npao2L(0)
     case('h')
        npao2L(1:5) = npao2L(0)
     case('i')
        npao2L(1:6) = npao2L(0)
     end select
  else
     do i=1, len_trim(mode2), 2
        select case( mode2(i:i) )
        case('s')
           read( mode2(i+1:i+1), * ) npao2L(0)
        case('p')
           read( mode2(i+1:i+1), * ) npao2L(1)
        case('d')
           read( mode2(i+1:i+1), * ) npao2L(2)
        case('f')
           read( mode2(i+1:i+1), * ) npao2L(3)
        case('g')
           read( mode2(i+1:i+1), * ) npao2L(4)
        case('h')
           read( mode2(i+1:i+1), * ) npao2L(5)
        case('i')
           read( mode2(i+1:i+1), * ) npao2L(6)
        end select
     end do
  end if

  do l=0, npao2Lmax
     if( npao2L(l) > numpao ) then
        open(unit=16,file=Param%Option%file_ac_tempout,position='append')
        write(16,*) '      ++++++ Warning: too many radial PAO bases requested for projection. Reduced to', numpao
        close(16)
        npao2L(l) = numpao
     end if
  end do

  elem%npao=0
  do l=0, npaoLmax
     ipaoL(l) = elem%npao+1
     elem%npao = elem%npao + npaoL(l)
  end do
  elem%npao2=0
  do l=0, npao2Lmax
     ipao2L(l) = elem%npao2+1
     elem%npao2 = elem%npao2 + npao2L(l)
  end do

  allocate(elem%vpao(elem%npao))

  if( Param%Option%projection ) then
     allocate(elem%vpao2(elem%npao2))
     allocate(elem%vpao2bar(elem%npao2))
  end if

  do
     read(iunit,'(a)',end=200) buf

     if(buf=='') cycle
     if(buf=='#') cycle
     read(buf,*) tag

     select case(tag)
     case('<valence.charge.density')
        elem%rhoval%l  = 0
        elem%rhoval%Rc = Rc
        allocate( elem%rhoval%vR(nr) )

        do i=1, nr
           read(iunit,'(a)') buf
           read(buf,*) logr, dummy, elem%rhoval%vR(i)
           if( dummy == dummy ) then 
           endif

           vr(i) = exp(logr)
        end do
        read(iunit,'(a)') buf

        call RadialFunc__set(elem%rhoval, vr, nr)

     case('<pseudo.atomic.orbitals.L=0', '<pseudo.atomic.orbitals.L=1', &
          '<pseudo.atomic.orbitals.L=2', '<pseudo.atomic.orbitals.L=3')
        select case(tag)
        case('<pseudo.atomic.orbitals.L=0')
           l = 0
        case('<pseudo.atomic.orbitals.L=1')
           l = 1
        case('<pseudo.atomic.orbitals.L=2')
           l = 2
        case('<pseudo.atomic.orbitals.L=3')
           l = 3
        end select

        if( npaoL(l)>0 ) then
           do n=1, npaoL(l)
              elem%vpao(ipaoL(l)+n-1)%l  = l
              elem%vpao(ipaoL(l)+n-1)%Rc = Rc
              allocate( elem%vpao(ipaoL(l)+n-1)%vR(nr) )
           end do
        end if

        if( npao2L(l)>0 .and. Param%Option%projection ) then
           do n=1, npao2L(l)
              elem%vpao2(ipao2L(l)+n-1)%l  = l
              elem%vpao2(ipao2L(l)+n-1)%Rc = Rc
              allocate( elem%vpao2(ipao2L(l)+n-1)%vR(nr) )

              elem%vpao2bar(ipao2L(l)+n-1)%l  = l
              elem%vpao2bar(ipao2L(l)+n-1)%Rc = Rc
              allocate( elem%vpao2bar(ipao2L(l)+n-1)%vR(nr) )
           end do
        end if

        if( npaoL(l)>0 .or. npao2L(l)>0 ) then
           do i=1, nr
              read(iunit,'(a)') buf
              read(buf,*) dummy, dummy, R(1:max(npaoL(l),npao2L(l)))

              do n=1, npaoL(l)
                 elem%vpao(ipaoL(l)+n-1)%vR(i) = R(n)
              end do

              if( Param%Option%projection ) then
                 do n=1, npao2L(l)
                    elem%vpao2(ipao2L(l)+n-1)%vR(i) = R(n)
                 end do
              end if
           end do

           read(iunit,'(a)') buf
        end if

        if( npaoL(l)>0 ) then
           do n=1, npaoL(l)
              call RadialFunc__set(elem%vpao(ipaoL(l)+n-1), vr, nr)
           end do
        end if

        if( npao2L(l)>0 .and. Param%Option%projection ) then
           do n=1, npao2L(l)
              call RadialFunc__set(elem%vpao2(ipao2L(l)+n-1), vr, nr)
           end do
        end if

     end select
  end do

200 continue

  if( Param%Option%projection ) then
     do l = maxLpao+1, npao2Lmax
        if( npao2L(l) == 0 ) cycle

        do n=1, npao2L(l)
           elem%vpao2(ipao2L(l)+n-1)%l  = l
           elem%vpao2(ipao2L(l)+n-1)%Rc = Rc
           allocate( elem%vpao2(ipao2L(l)+n-1)%vR(nr) )

           elem%vpao2bar(ipao2L(l)+n-1)%l  = l
           elem%vpao2bar(ipao2L(l)+n-1)%Rc = Rc
           allocate( elem%vpao2bar(ipao2L(l)+n-1)%vR(nr) )
        end do

        do n=1, npao2L(l)
           do i=1, nr
              elem%vpao2(ipao2L(l)+n-1)%vR(i) = &
                   vr(i)**(l-maxLpao) * elem%vpao2(ipao2L(maxLpao)+n-1)%vR(i)
           end do
        end do

        do n=1, npao2L(l)
           call RadialFunc__set(elem%vpao2(ipao2L(l)+n-1), vr, nr)
        end do
     end do
  end if

  if(allocated(vr)) deallocate(vr)

  if( .not. associated(elem%rhoval%vR) ) then
     msg = "valence.charge.density is not given"
     goto 1111
  end if

  do n=1, elem%npao
     if( .not. associated(elem%vpao(n)%vR) ) then
        msg = "pseudo.atomic.orbitals is not given"
        goto 1111
     endif
  end do

  close(iunit)
  return

1111 continue 
  close(iunit)

  write(*,'(a,a,a)') '# Error : PAO data ', msg, fname
  open(unit=16,file=Param%Option%file_ac_tempout,position='append')
  write(16,998) msg,fname
998 format('      ++++++ Error PAO data: ',a,a)
  close(16)
  stop

end subroutine Element__readPAO_adpack

subroutine Element__readVPS_adpack( elem, name, fname )
  use ac_parameter

  implicit none
  type(Element_type), intent(out)   :: elem
  character(len=*), intent(in) :: name
  character(len=*), intent(in) :: fname

  integer         :: iunit
  logical         :: ex
  character(1024) :: buf
  character(32)   :: tag

  real(8)  :: Q
  real(8)  :: Rc
  integer        :: nr
  real(8), allocatable :: vr(:)
  real(8)  :: logr
  real(8)  :: vnon(2,12)
  character(8)   :: str
  character(32) :: dummy
  character(1024) :: msg
  integer        :: i, n

  elem%name = name

  inquire(file=fname,exist=ex)
  if( .not. ex ) then
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,999) trim(fname)
999  format('      ++++++ Error readVPS/ can not open file: ',a)
     close(16)
     stop
  end if

  iunit = 3
  open(iunit,file=fname)

  Q  = 0.d0
  Rc = 0.d0
  nr = 0

  elem%pcc = .false.
  elem%nVnon = -1

  do 
     read(iunit,'(a)',end=100) buf
     if( buf=='') cycle
     if( buf=='#') cycle
     read(buf,*) tag

     select case(tag)
     case('eq.type')
        read(buf,*) tag, str
        select case(str)
        case('dirac2')
           elem%dirac = .true.
        case('sch')
           elem%dirac = .false.
        case default
           elem%dirac = .false.
        end select
     case('AtomSpecies')
        read(buf,*) tag, elem%atomic_number
     case('valence.electron')
        read(buf,*) tag, Q
     case('grid.num.output')
        read(buf,*) tag, nr
     case('local.cutoff')
        read(buf,*) tag, Rc
     case('charge.pcc.calc')
        read(buf,*) tag, str
        if( str == 'on' .or. str == 'On' .or. str == 'ON' ) then
           elem%pcc = .true.
        else
           elem%pcc = .false.
        end if

        if( .not. Rc == 0.d0 ) exit 
     case('radial.cutoff.pao')
        if( Rc == 0.d0 ) then 
           read(buf,*) tag, Rc
        end if
        exit 
     end select

  end do
100 continue

  if( nr == 0 ) then
     msg = 'Parameter grid.num.output is not given'
     go to 1111
  end if
  if( Rc == 0.d0 ) then
     msg = 'Parameter local.cutoff is not given'
     go to 1111
  end if
  if( Q  == 0.d0 ) then
     msg = 'Parameter valence.electron is not given'
     go to 1111
  end if

  allocate( vr(nr) )

  do 
     read(iunit,'(a)',end=200) buf

     if( buf=='') cycle
     if( buf=='#') cycle
     read(buf,*) tag

     select case(tag)
     case('num.projector')
        read(buf,*) tag, elem%nVnon

     case('<project.energies','<projection.energies')
        select case(tag)
        case('<project.energies')
           if( elem%nVnon == -1 ) then
              read(iunit,'(a)',end=200) buf
              read(buf,*) elem%nVnon
           end if
           if( elem%nVnon == -1 ) then
              msg = 'project.energies is broken or num.projector is not given'
              go to 1111
           end if

        case('<projection.energies')
           if( elem%nVnon == -1 ) then
              msg = 'Parameter num.projector is not given'
              go to 1111
           end if

        end select

        if( elem%nVnon>0 ) then
           if( elem%dirac ) then
              allocate(elem%vVnon(elem%nVnon,2))
           else
              allocate(elem%vVnon(elem%nVnon,1))
           end if

           elem%vVnon(:,:)%l = 0
           elem%vVnon(:,:)%Q = 0.0
        end if

        if( elem%nVnon>0 ) then
           do n=1, elem%nVnon
              read(iunit,'(a)') buf
              if( elem%dirac ) then
                 read(buf,*) elem%vVnon(n,1)%l, elem%vVnon(n,1:2)%Q
                 elem%vVnon(n,2)%l = elem%vVnon(n,1)%l
              else
                 read(buf,*) elem%vVnon(n,1)%l, elem%vVnon(n,1)%Q
              end if
           end do
        end if
        read(iunit,'(a)') buf

     case('<Pseudo.Potentials')
        elem%Vloc%l  = 0
        elem%Vloc%Q  = -Q
        elem%Vloc%Rc = Rc
        allocate( elem%Vloc%vR(nr) )

        do n=1, elem%nVnon
           if( elem%dirac ) then
              elem%vVnon(n,1)%Rc = Rc
              allocate(elem%vVnon(n,1)%vR(nr))
              elem%vVnon(n,2)%Rc = Rc
              allocate(elem%vVnon(n,2)%vR(nr))
           else
              elem%vVnon(n,1)%Rc = Rc
              allocate(elem%vVnon(n,1)%vR(nr))
           end if
        end do

        do i=1, nr
           read(iunit,'(a)') buf

           if( elem%dirac ) then
              read(buf,*) logr, dummy, elem%Vloc%vR(i), vnon(1:2,1:elem%nVnon)
              do n=1, elem%nVnon
                 elem%vVnon(n,1)%vR(i) = vnon(1,n)
                 elem%vVnon(n,2)%vR(i) = vnon(2,n)
              end do
           else
              read(buf,*) logr, dummy, elem%Vloc%vR(i), vnon(1,1:elem%nVnon)
              do n=1, elem%nVnon
                 elem%vVnon(n,1)%vR(i) = vnon(1,n)
              end do
           end if

           vr(i) = exp(logr)
           if( i<4 ) then
              write(*,*) i, vr(i), elem%Vloc%vR(i)
           end if

           if( dummy == dummy ) then 
           endif
        end do

        read(iunit,'(a)') buf

        call RadialFunc__set( elem%Vloc, vr, nr )
        do n=1, elem%nVnon
           if( elem%dirac ) then
              call RadialFunc__set( elem%vVnon(n,1), vr, nr )
              call RadialFunc__set( elem%vVnon(n,2), vr, nr )
           else
              call RadialFunc__set( elem%vVnon(n,1), vr, nr )
           end if
        end do

     case('<density.PCC')
        if( elem%pcc ) then
           elem%rhopcc%l  = 0
           elem%rhopcc%Rc = elem%vpao(1)%Rc 
           allocate( elem%rhopcc%vR(nr) )

           do i=1, nr
              read(iunit,'(a)') buf
              read(buf,*) dummy, dummy, elem%rhopcc%vR(i) 
           end do
           read(iunit,'(a)') buf

           call RadialFunc__set( elem%rhopcc, vr, nr )
        end if
     end select
  end do
200 continue

  if(allocated(vr)) deallocate(vr)

  if( .not. associated(elem%Vloc%vR) ) then
     msg = "Pseudo.Potentials is not given"
     goto 1111
  end if

  do n=1, elem%nVnon
     if( .not. associated(elem%vVnon(n,1)%vR) ) then
        msg = "Pseudo.Potentials is not given"
        goto 1111
     end if
  end do

  if( elem%pcc .and. (.not. associated(elem%rhopcc%vR)) ) then
     msg = "density.PCC not given"
     goto 1111
  end if

  close(iunit)
  return

1111 continue 
  close(iunit)

  open(unit=16,file=Param%Option%file_ac_tempout,position='append')
  write(16,998) msg,fname 
998 format(' +++++++ Error VPS data: ',a,a)
  close(16)
  stop

end subroutine Element__readVPS_adpack

subroutine Element__VBHSR( Vr, elem, bhs_c1, bhs_c2, bhs_a1, bhs_a2, r )
  use ac_parameter

  implicit none
  real(8), intent(out) :: Vr
  type(Element_type), intent(in)   :: elem
  real(8), intent(in)  :: bhs_c1, bhs_c2, bhs_a1, bhs_a2
  real(8), intent(in)  :: r
  real(8) :: derf 

  if( r < 1.d-14 ) then
     Vr = elem%Vloc%Q * M_2_SQRTPI * ( bhs_c1*sqrt(bhs_a1) +  bhs_c2*sqrt(bhs_a2) )
  else
     Vr = elem%Vloc%Q/r *( bhs_c1*derf(sqrt(bhs_a1)*r) + bhs_c2*derf(sqrt(bhs_a2)*r) )
  end if

  return
end subroutine Element__VBHSR

subroutine Element__VBHSK( Vk, elem, bhs_c1, bhs_c2, bhs_a1, bhs_a2, k )
  use ac_parameter

  implicit none
  real(8), intent(out)   :: Vk
  type(Element_type), intent(in)   :: elem
  real(8), intent(in)  :: bhs_c1, bhs_c2, bhs_a1, bhs_a2
  real(8), intent(in)  :: k

  if( k < 1.d-14 ) then
     Vk = M_2_SQRTPI*M_SQRT1_2 &
          * elem%Vloc%Q *( -bhs_c1/(4.0d0*bhs_a1) -  bhs_c2/(4.0d0*bhs_a2) )
  else
     Vk = M_2_SQRTPI*M_SQRT1_2 &
          * elem%Vloc%Q/k**2 *( bhs_c1*(exp(-k**2/(4.0d0*bhs_a1))-1.0d0) +  bhs_c2*(exp(-k**2/(4.0d0*bhs_a2))-1.0d0) )
  end if

  return
end subroutine Element__VBHSK

subroutine Element__setup( elem )
  use ac_parameter

  implicit none
  type(Element_type), intent(out) :: elem
  integer n, i
  real(8) :: r, k, Vr, Vk

  do n=1, elem%npao
     call RadialFunc__transpose( elem%vpao(n) )
  end do
  if( Param%Option%projection ) then
     do n=1, elem%npao2
        call RadialFunc__transpose( elem%vpao2(n) )
     end do
  end if

  call Element__setupVval( elem )

  if( Param%Option%projection ) then
     call Element__setupVloc( elem )
  end if

  call RadialFunc__transpose( elem%Vval )
  call RadialFunc__transposetail( elem%Vval )
  call RadialFunc__transpose( elem%rhoval )

  if( .false. ) then
     do i=1, elem%Vloc%fR%N
        r = elem%Vloc%fR%vx(i)

        call Element__VBHSR( Vr, elem, 1.0d0, 0.0d0, 1.0d0, 1.0d0, r )

        elem%Vloc%vR(i) = elem%Vloc%vR(i) - Vr
     end do

     call RadialFunc__reset(elem%Vloc)

     call RadialFunc__transpose( elem%Vloc )

     do i=1, SphericalBessel%Nk
        k = SphericalBessel%vkx(i)
        call Element__VBHSK( Vk, elem, 1.0d0, 0.0d0, 1.0d0, 1.0d0, k )
        elem%Vloc%vK(i) = elem%Vloc%vK(i) + Vk
     end do

     do i=1, elem%Vloc%fR%N
        r = elem%Vloc%fR%vx(i)

        call Element__VBHSR( Vr, elem, 1.0d0, 0.0d0, 1.0d0, 1.0d0, r )

        elem%Vloc%vR(i) = elem%Vloc%vR(i) + Vr
     end do

     call RadialFunc__reset(elem%Vloc)
  else
     call RadialFunc__transpose( elem%Vloc )
     call RadialFunc__transposetail( elem%Vloc )
  end if

  do n=1, elem%nVnon
     if( elem%dirac ) then
        call RadialFunc__transpose( elem%vVnon(n,1) )
        call RadialFunc__transpose( elem%vVnon(n,2) )
     else
        call RadialFunc__transpose( elem%vVnon(n,1) )
     end if
  end do

  if( elem%pcc ) then
     call RadialFunc__transpose( elem%rhopcc )
  end if

  return
end subroutine Element__setup

subroutine Element__setupVval( elem )
  use ac_parameter

  implicit none
  type(Element_type), intent(out) :: elem

  integer, parameter :: Nr = 96
  real(8) :: vx_t(Nr), vw_t(Nr)
  integer :: N
  integer :: i, j
  real(8) :: Inside, Outside
  real(8) :: xmin, xmax
  real(8) :: Sx, Dx
  real(8) :: r, x, w, f

  real(8), allocatable :: vr(:)
  real(8) :: loc, val

  call GaussLegendre__getPoints( Nr, -1.d0, 1.d0, vx_t, vw_t )

  N = elem%rhoval%fR%N

  elem%Vval%l  =  0
  elem%Vval%Q  = -elem%Vloc%Q
  elem%Vval%Rc =  elem%rhoval%Rc
  allocate( elem%Vval%vR(N) )

  allocate( vr(N) )
  do i=1, N
     vr(i) = elem%rhoval%fR%vx(i)
  end do

  do i=1, N
     if( vr(i) > elem%rhoval%Rc ) then
        elem%Vval%vR(i) = elem%Vval%Q/vr(i)
        cycle
     end if

     Inside = 0.d0
     xmin = log(elem%rhoval%fR%vx(1))
     xmax = log(vr(i))
     Sx = xmax + xmin
     Dx = xmax - xmin
     do j=1, Nr
        x = 0.50*(Dx*vx_t(j) + Sx)
        r = exp(x)
        w = vw_t(j)
        call Spline__evaluate( elem%rhoval%fR,r,f )
        Inside = Inside + w*r*r*r* f
     end do
     Inside = 0.5D0*Dx*4.D0*M_PI/vr(i) * Inside

     Outside = 0.d0
     xmin = log(vr(i))
     xmax = log(elem%rhoval%fR%vx(elem%rhoval%fR%N))
     Sx = xmax + xmin
     Dx = xmax - xmin
     do j=1, Nr
        x = 0.50*(Dx*vx_t(j) + Sx)
        r = exp(x)
        w = vw_t(j)
        call Spline__evaluate( elem%rhoval%fR, r, f )
        Outside = Outside + w*r*r* f
     end do
     Outside = 0.5D0*Dx*4.D0*M_PI * Outside

     elem%Vval%vR(i) = Inside + Outside
  end do

  call RadialFunc__set( elem%Vval, vr, N )

  if(allocated(vr)) deallocate( vr )

  return
end subroutine Element__setupVval

subroutine Element__setupVloc( elem )
  use ac_parameter

  implicit none
  type(Element_type), intent(out) :: elem

  integer :: nr
  integer :: n, m, i
  real(8), allocatable :: vr(:)
  type(RadialFunc_type) :: Vtemp
  real(8) :: S
  real(8) :: f1, f2

  if( .not. Param%Option%projection ) return

  nr = elem%vpao(1)%fR%N

  allocate( vr(nr) )
  do i=1, nr
     vr(i) = elem%vpao(1)%fR%vx(i)
  end do

  allocate( Vtemp%vR(nr) )
  do i=1, nr
     call Spline__evaluate( elem%Vloc%fR, vr(i), f1 )
     call Spline__evaluate( elem%Vval%fR, vr(i), f2 )
     Vtemp%vR(i) = f1 + f2
  end do

  elem%nVloc = elem%npao2
  allocate(elem%vVloc(elem%nVloc))

  do n=1, elem%nVloc
     call RadialFunc__bracketS( S, elem%vpao2(n), elem%vpao2(n) )
     S = 1.0/sqrt(S)

     do i=1, nr
        elem%vpao2(n)%vR(i) = elem%vpao2(n)%vR(i) * S
     end do
     call RadialFunc__reset(elem%vpao2(n))
     call RadialFunc__transpose( elem%vpao2(n) )

     do i=1, nr
        elem%vpao2bar(n)%vR(i) = elem%vpao2(n)%vR(i)
     end do

     do m=1, n-1
        if( elem%vpao2(m)%l /= elem%vpao2(n)%l ) cycle

        call RadialFunc__bracketS( S, elem%vpao2(n), elem%vVloc(m) )
        S = elem%vVloc(m)%Q * S

        do i=1, nr
           elem%vpao2bar(n)%vR(i) = elem%vpao2bar(n)%vR(i) &
                - elem%vpao2bar(m)%vR(i) * S
        end do
     end do

     elem%vpao2bar(n)%l  = elem%vpao2(n)%l
     elem%vpao2bar(n)%Rc = elem%vpao2(n)%Rc

     call RadialFunc__set( elem%vpao2bar(n), vr, nr )
     call RadialFunc__transpose( elem%vpao2bar(n) )

     allocate( elem%vVloc(n)%vR(nr) )
     do i=1, nr
        elem%vVloc(n)%vR(i) = Vtemp%vR(i) * elem%vpao2bar(n)%vR(i)
     end do

     elem%vVloc(n)%l  = elem%vpao2(n)%l
     elem%vVloc(n)%Rc = elem%vpao(1)%Rc

     call RadialFunc__set( elem%vVloc(n), vr, nr )
     call RadialFunc__transpose( elem%vVloc(n) )

     call RadialFunc__bracketS( S, elem%vpao2bar(n), elem%vVloc(n) )
     elem%vVloc(n)%Q  = 1.0d0/S

  end do

  deallocate( Vtemp%vR )
  deallocate( vr )

  return
end subroutine Element__setupVloc


subroutine Element__deallocate( elem )
  use ac_parameter

  implicit none
  type(Element_type), intent(out) :: elem
  integer :: n

  call RadialFunc__deallocate( elem%rhoval )
  call RadialFunc__deallocate( elem%Vval )

  do n=1, elem%npao
     call RadialFunc__deallocate( elem%vpao(n) )
  end do
  if( associated(elem%vpao) ) deallocate(elem%vpao)

  call RadialFunc__deallocate( elem%Vloc )

  do n=1, elem%nVnon
     if( elem%dirac ) then
        call RadialFunc__deallocate( elem%vVnon(n,1) )
        call RadialFunc__deallocate( elem%vVnon(n,2) )
     else
        call RadialFunc__deallocate( elem%vVnon(n,1) )
     end if
  end do
  if( associated(elem%vVnon) ) deallocate(elem%vVnon)

  if( Param%Option%projection ) then
     do n=1, elem%nVloc
        call RadialFunc__deallocate( elem%vVloc(n) )
     end do
     if( associated(elem%vVloc) ) deallocate(elem%vVloc)

     do n=1, elem%npao2
        call RadialFunc__deallocate( elem%vpao2(n) )
        call RadialFunc__deallocate( elem%vpao2bar(n) )
     end do
     if( associated(elem%vpao2) ) deallocate(elem%vpao2)
     if( associated(elem%vpao2bar) ) deallocate(elem%vpao2bar)
  end if

  if( elem%pcc ) then
     call RadialFunc__deallocate( elem%rhopcc )
  end if

  return
end subroutine Element__deallocate

subroutine Element__readPAO_ciao( elem, name, fname, mode, mode2 )
  use ac_parameter

  implicit none
  type(Element_type), intent(out)   :: elem
  character(len=*), intent(in) :: name
  character(len=*), intent(in) :: fname
  character(len=*), intent(in) :: mode
  character(len=*), intent(in) :: mode2

  integer        :: iunit
  logical        :: ex
  character(256) :: buf, tag

  real(8)  :: Rc
  integer        :: nr
  real(8), allocatable :: vr(:)
  integer, parameter :: npaoLmax=3
  integer, parameter :: npao2Lmax=6
  integer        :: npaoL(0:npaoLmax)
  integer        :: ipaoL(0:npaoLmax)
  integer        :: npao2L(0:npao2Lmax)
  integer        :: ipao2L(0:npao2Lmax)
  real(8)  :: R(10)
  character(1024):: msg
  integer        :: i, l, n, m
  real(8)  :: dummy_r

  integer        :: npaoL_t(0:npao2Lmax), num_l_pao, n_temp

  inquire( file=fname, exist=ex )
  if( .not. ex ) then
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,999) trim(fname)
999  format('      ++++++ Error readPAO/ can not open file: ',a)
     close(16)
     stop
  end if

  iunit=2
  open(iunit,file=fname)

  elem%name = name

  do i = 0,npao2Lmax
     npaoL_t(i)=0
  end do

  Rc = -10.d0
  nr = 0

  read(iunit,*) num_l_pao
  do i = 1,num_l_pao
     read(iunit,*) l, n
     npaoL_t(l)=n
  end do
  read(iunit,*) elem%namexc_pao 
  read(iunit,*) nr,Rc
  read(iunit,*)

  if( nr == 0 ) then
     msg = "grid num output is not given"
     goto 1111
  end if
  if( Rc < 0.d0 ) then
     msg = "radial cutoff is not given"
     goto 1111
  end if

  do l=0, npaoLmax
     npaoL(l)=0
  end do

  if( mode == "" ) then
     do l = 0, num_l_pao-1
        npaoL(l) = npaoL_t(l)
     end do
  else if( mode(1:1) /= 's' ) then
     if( len_trim(mode) == 1 ) then
        npaoL(0) = npaoL_t(0)
     else
        read(mode(2:2),*) npao2L(0)
     end if

     select case( mode(1:1) )
     case('p')
        npaoL(1:1) = npaoL(0)
     case('d')
        npaoL(1:2) = npaoL(0)
     case('f')
        npaoL(1:3) = npaoL(0)
     end select
  else
     do i=1, len_trim(mode), 2
        select case( mode(i:i) )
        case('s')
           read( mode(i+1:i+1), * ) npaoL(0)
        case('p')
           read( mode(i+1:i+1), * ) npaoL(1)
        case('d')
           read( mode(i+1:i+1), * ) npaoL(2)
        case('f')
           read( mode(i+1:i+1), * ) npaoL(3)
        end select
     end do
  end if

  do l=0, npaoLmax
     if( npaoL(l) > npaoL_t(l) ) then
        open(unit=16,file=Param%Option%file_ac_tempout,position='append')
        write(16,*) &
             '      ++++++ Warning: too many radial PAO bases requested for band calculations. Reduced to' &
             , npaoL_t(l)
        close(16)
        npaoL(l) = npaoL_t(l)
     end if
  end do

  do l=0, npao2Lmax
     npao2L(l)=0
  end do

  if( mode2 == "" .or. (.not. Param%Option%projection) ) then
     do l = 0, num_l_pao-1
        npao2L(l) = 0
     end do
  else if( mode2(1:1) /= 's' ) then
     if( len_trim(mode2) == 1 ) then
        npao2L(0) = npaoL_t(0)
     else
        read(mode2(2:2),*) npao2L(0)
     end if

     select case( mode2(1:1) )
     case('p')
        npao2L(1:1) = npao2L(0)
     case('d')
        npao2L(1:2) = npao2L(0)
     case('f')
        npao2L(1:3) = npao2L(0)
     case('g')
        npao2L(1:4) = npao2L(0)
     case('h')
        npao2L(1:5) = npao2L(0)
     case('i')
        npao2L(1:6) = npao2L(0)
     end select
  else
     do i=1, len_trim(mode2), 2
        select case( mode2(i:i) )
        case('s')
           read( mode2(i+1:i+1), * ) npao2L(0)
        case('p')
           read( mode2(i+1:i+1), * ) npao2L(1)
        case('d')
           read( mode2(i+1:i+1), * ) npao2L(2)
        case('f')
           read( mode2(i+1:i+1), * ) npao2L(3)
        case('g')
           read( mode2(i+1:i+1), * ) npao2L(4)
        case('h')
           read( mode2(i+1:i+1), * ) npao2L(5)
        case('i')
           read( mode2(i+1:i+1), * ) npao2L(6)
        end select
     end do
  end if

  do l=0, num_l_pao-1 
     if( npao2L(l) > npaoL_t(l) ) then
        open(unit=16,file=Param%Option%file_ac_tempout,position='append')
        write(16,*) &
             '      ++++++ Warning: too many radial PAO bases requested for projection. Reduced to' &
             , npaoL_t(l),l
        close(16)
        npao2L(l) = npaoL_t(l)
     end if
  end do

  elem%npao=0
  do l=0, npaoLmax
     ipaoL(l) = elem%npao+1
     elem%npao = elem%npao + npaoL(l)
  end do

  allocate(elem%vpao(elem%npao))

  elem%npao2=0
  do l=0, npao2Lmax
     ipao2L(l) = elem%npao2+1
     elem%npao2 = elem%npao2 + npao2L(l)
  end do

  if( Param%Option%projection ) then
     allocate(elem%vpao2(elem%npao2))
     allocate(elem%vpao2bar(elem%npao2))
  end if

  allocate( vr(nr) )

  elem%rhoval%l  = 0
  elem%rhoval%Rc = Rc
  allocate( elem%rhoval%vR(nr) )

  read(iunit,*)
  read(iunit,*)
  do i=1, nr
     read(iunit,*) vr(i), dummy_r, elem%rhoval%vR(i)
  end do

  call RadialFunc__set(elem%rhoval, vr, nr)

  do m = 0, num_l_pao - 1
     read(iunit,*)
     read(iunit,*) buf,tag,l

     do n=1, npaoL(l)
        elem%vpao(ipaoL(l)+n-1)%l  = l
        elem%vpao(ipaoL(l)+n-1)%Rc = Rc
        allocate( elem%vpao(ipaoL(l)+n-1)%vR(nr) )
     end do

     if( Param%Option%projection ) then
        do n=1, npao2L(l)
           elem%vpao2(ipao2L(l)+n-1)%l  = l
           elem%vpao2(ipao2L(l)+n-1)%Rc = Rc
           allocate( elem%vpao2(ipao2L(l)+n-1)%vR(nr) )

           elem%vpao2bar(ipao2L(l)+n-1)%l  = l
           elem%vpao2bar(ipao2L(l)+n-1)%Rc = Rc
           allocate( elem%vpao2bar(ipao2L(l)+n-1)%vR(nr) )
        end do
     end if

     n_temp=max(npaoL(l),npao2L(l))
     do i=1, nr
        read(iunit,*) dummy_r, R(1:n_temp)
        do n=1, npaoL(l)
           elem%vpao(ipaoL(l)+n-1)%vR(i) = R(n)/dummy_r
        end do
        if( Param%Option%projection ) then
           do n=1, npao2L(l)
              elem%vpao2(ipao2L(l)+n-1)%vR(i) = R(n)/dummy_r
           end do
        end if
     end do

     do n=1, npaoL(l)
        call RadialFunc__set(elem%vpao(ipaoL(l)+n-1), vr, nr)
     end do
     if( Param%Option%projection ) then
        do n=1, npao2L(l)
           call RadialFunc__set(elem%vpao2(ipao2L(l)+n-1), vr, nr)
        end do
     end if
  end do

  if( Param%Option%projection ) then
     do l = num_l_pao, npao2Lmax
        if( npao2L(l) == 0 ) cycle

        do n=1, npao2L(l)
           elem%vpao2(ipao2L(l)+n-1)%l  = l
           elem%vpao2(ipao2L(l)+n-1)%Rc = Rc
           allocate( elem%vpao2(ipao2L(l)+n-1)%vR(nr) )

           elem%vpao2bar(ipao2L(l)+n-1)%l  = l
           elem%vpao2bar(ipao2L(l)+n-1)%Rc = Rc
           allocate( elem%vpao2bar(ipao2L(l)+n-1)%vR(nr) )
        end do

        do n=1, npao2L(l)
           do i=1, nr
              elem%vpao2(ipao2L(l)+n-1)%vR(i) = &
                   vr(i)**(l-(num_l_pao-1)) * elem%vpao2(ipao2L(num_l_pao-1)+n-1)%vR(i)
           end do
        end do

        do n=1, npao2L(l)
           call RadialFunc__set(elem%vpao2(ipao2L(l)+n-1), vr, nr)
        end do
     end do
  end if

  if(allocated(vr)) deallocate(vr)

  buf=tag
  tag=buf

  close(iunit)
  return

1111 continue 
  close(iunit)

  open(unit=16,file=Param%Option%file_ac_tempout,position='append')
  write(16,998) msg,fname 
998 format(' +++++++ Error PAO data: ',a,a)
  close(16)
  stop

end subroutine Element__readPAO_ciao

subroutine Element__readVPS_ciao( elem, name, fname )
  use ac_parameter

  implicit none
  type(Element_type)    :: elem
  character(len=*) :: name
  character(len=*) :: fname

  logical        :: ex
  character(256) :: buf
  character(8)   :: str
  integer        :: iunit
  integer        :: ll, i, n

  real(8)  :: Q
  real(8)  :: Rc
  integer        :: nr

  integer        :: l_loc, i_pcc, i_pp, lpsmax, i_start, mord
  real(8)  :: xh
  real(8)  :: dummy_r
  real(8), allocatable :: chir(:,:), phir(:,:)
  real(8), allocatable :: vr(:), anorm_chir(:), c_pol_pc(:)
  real(8), allocatable :: t_rc(:)

  elem%name = name
  elem%dirac = .false.

  inquire(file=fname,exist=ex)
  if( .not. ex ) then
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,999) trim(fname)
999  format(' +++++++ Error readVPS/ can not open file: ',a)
     close(16)
     stop
  end if

  iunit = 3
  open(iunit,file=fname)

  elem%pcc = .false.
  elem%nVnon = 0

  read(iunit,*) elem%atomic_number, Q, l_loc, i_pcc, i_pp
  if( iabs(i_pp) /= 2 ) then
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,*) 'not supported:: gncpp',i_pp
     close(16)
     stop
  end if
  if( i_pcc == 0 ) then
     elem%pcc = .false.
  else if( i_pcc == 1 ) then
     elem%pcc = .true.
  else
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,*) 'not supported:: pcc',i_pcc
     close(16)
  end if
  read(iunit,*) elem%namexc_vps 
  read(iunit,*)
  read(iunit,*) nr, xh, Rc

  allocate( vr(nr) )
  do i=1, nr
     vr(i) = Rc*dexp(dfloat(i-nr)/xh)
  enddo

  elem%Vloc%l  = l_loc-1
  elem%Vloc%Q  = -Q
  elem%Vloc%Rc = Rc

  allocate( elem%Vloc%vR(nr) )

  read(iunit,*)
  read(iunit,*) (dummy_r,i=1,nr)
  read(iunit,*) (dummy_r,i=1,nr)
  read(iunit,*) (elem%Vloc%vR(i),i=1,nr)
  read(iunit,*) (dummy_r,i=1,nr)

  read(iunit,'(a)') buf
  read(buf,*) str
  if(l_loc == 4) then
     lpsmax = l_loc
  else
     lpsmax = 3
  endif
  if( str == 'F-STATE' ) then
     lpsmax = 4
  endif

  allocate( phir(nr,lpsmax) )
  allocate( chir(nr,lpsmax) )
  allocate( anorm_chir(lpsmax) )
  allocate( t_rc(lpsmax) )

  elem%nVnon=0
  do ll=1,lpsmax
     if( ll == 1 .and. str /= 'F-STATE' ) then
        read(buf,*)
     else
        read(iunit,*)
     endif
     read(iunit,*)
     if( i_pp == -2 ) then
        read(iunit,*) (dummy_r,i=1,nr)
     end if
     read(iunit,*) (phir(i,ll),i=1,nr)
     read(iunit,*) (chir(i,ll),i=1,nr)
     anorm_chir(ll)=0.d0
     do i=1,nr
        if( dabs(chir(i,ll)-elem%Vloc%vR(i)) > 1.d-14 ) then
           t_rc(ll)=vr(i)
        end if
        chir(i,ll)=(chir(i,ll)-elem%Vloc%vR(i))*phir(i,ll)
        anorm_chir(ll)=anorm_chir(ll)+chir(i,ll)*chir(i,ll)
     end do
     if( anorm_chir(ll) > 1.d-14 ) then
        elem%nVnon=elem%nVnon+1
     end if
  end do

  if( elem%nVnon > 0 ) then
     allocate(elem%vVnon(elem%nVnon,1))
     do n=1, elem%nVnon
        allocate(elem%vVnon(n,1)%vR(nr))
     end do
  end if

  n=0
  do ll=1,lpsmax
     if( anorm_chir(ll) < 1.d-14 ) then
        cycle
     end if
     n=n+1
     elem%vVnon(n,1)%l=ll-1
     elem%vVnon(n,1)%Rc = t_rc(ll)
     do i=1, nr
        elem%vVnon(n,1)%vR(i) = chir(i,ll)/vr(i)
     end do
     elem%vVnon(n,1)%Q = 0.d0
     do i=1, nr 
        elem%vVnon(n,1)%Q = elem%vVnon(n,1)%Q + vr(i)*phir(i,ll)*chir(i,ll)/xh
     end do
     elem%vVnon(n,1)%Q = 1.d0/elem%vVnon(n,1)%Q
  end do

  if( (n-elem%nVnon) /= 0 ) then
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,*) 'error:: elem%nVnon',n,elem%nVnon
     close(16)
     stop
  end if

  call RadialFunc__set( elem%Vloc, vr, nr )
  do n=1, elem%nVnon
     call RadialFunc__set( elem%vVnon(n,1), vr, nr )
  end do

  if( elem%pcc ) then
     elem%rhopcc%l  = 0
     elem%rhopcc%Rc = Rc
     allocate( elem%rhopcc%vR(nr) )
     read(iunit,*) dummy_r,i_start,mord
     if( i_start == 0 ) then
        read(iunit,*) (elem%rhopcc%vR(i),i=1,nr)
     else
        allocate(c_pol_pc(0:mord))
        read(iunit,*) (c_pol_pc(i),i=0,mord)

        do i=1,i_start
           elem%rhopcc%vR(i) = c_pol_pc(mord)
        end do
        do n=mord-1,0,-1
           do i=1,i_start
              elem%rhopcc%vR(i) = elem%rhopcc%vR(i)*vr(i)*vr(i) &
                   + c_pol_pc(n)
           end do
        end do
        do i=1,i_start
           elem%rhopcc%vR(i) = elem%rhopcc%vR(i)*vr(i)*vr(i)
        end do

        read(iunit,*) (elem%rhopcc%vR(i),i=i_start+1,nr)
        if(allocated(c_pol_pc)) deallocate(c_pol_pc)
     end if
     do i=1,nr
        elem%rhopcc%vR(i)=elem%rhopcc%vR(i)/(4.d0*M_PI*vr(i)*vr(i))
     end do
     call RadialFunc__set( elem%rhopcc, vr, nr )
  end if

  if(allocated(vr)) deallocate(vr)
  if(allocated(chir)) deallocate(chir)
  if(allocated(phir)) deallocate(phir)
  if(allocated(anorm_chir)) deallocate(anorm_chir)
  if(allocated(t_rc)) deallocate( t_rc )

  close(iunit)

  Rc=dummy_r

  return
end subroutine Element__readVPS_ciao

subroutine Element__averageVPS( elem )
  use ac_parameter

  implicit none
  type(Element_type), intent(out)   :: elem

  real(8)  :: Q(2)
  real(8)  :: vnon(2)
  integer  :: l, nr
  integer  :: i, n

  if( .not. elem%dirac ) return

  do n=1, elem%nVnon
     l    = elem%vVnon(n,1)%l
     Q(1) = elem%vVnon(n,1)%Q
     Q(2) = elem%vVnon(n,2)%Q
     nr   = elem%vVnon(n,1)%fR%N

     if( Param%Data%element_type == 'ciao_test' ) then
        if( elem%Vloc%l /= l ) then
           elem%vVnon(n,1)%Q = 1.d0 / (( (l+1)/Q(1) + (l)/Q(2) )/(2*l+1)) 
        else
           elem%vVnon(n,1)%Q = 0.d0
        end if
     else
        elem%vVnon(n,1)%Q = 1.d0 / (( (l+1)/Q(1) + (l)/Q(2) )/(2*l+1)) 
     end if
     elem%vVnon(n,2)%Q = elem%vVnon(n,1)%Q

     do i=1, nr
        vnon(1) = elem%vVnon(n,1)%vR(i)
        vnon(2) = elem%vVnon(n,2)%vR(i)

        elem%vVnon(n,1)%vR(i) = &
             ( (l+1)*vnon(1) + (l)*vnon(2) )/(2*l+1)
        elem%vVnon(n,2)%vR(i) = elem%vVnon(n,1)%vR(i)
     end do

     call RadialFunc__reset( elem%vVnon(n,1) )
     call RadialFunc__reset( elem%vVnon(n,2) )
     call RadialFunc__transpose( elem%vVnon(n,1) )
     call RadialFunc__transpose( elem%vVnon(n,2) )
  end do

  return
end subroutine Element__averageVPS

subroutine Element__readVPS_ciao_test( elem, name, fname )
  use ac_parameter

  implicit none
  type(Element_type), intent(out)   :: elem
  character(len=*), intent(in) :: name
  character(len=*), intent(in) :: fname

  integer :: nr
  integer :: l_loc,lpsmax
  real(8) :: Q

  logical :: ex
  integer :: iunit
  integer :: ll,n,i,iso_sw
  real(8) :: dummy1,dummy2,dummy3,dummy4,dummy5,dummy6
  character(1024) :: msg

  real(8), allocatable :: chir(:,:,:), phir(:,:,:)
  real(8), allocatable :: vr(:), anorm_chir(:,:)
  real(8), allocatable :: t_rc(:)

  elem%name = name

  inquire(file=fname,exist=ex)
  if( .not. ex ) then
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,999) trim(fname)
999  format('      ++++++ Error readVPS/ can not open file: ',a)
     close(16)
     stop
  end if

  iunit = 3
  open(iunit,file=fname)

  elem%dirac = .true.
  elem%pcc = .false.
  lpsmax=3

  read(iunit,*)  elem%atomic_number, Q, elem%namexc_vps
  read(iunit,*)  l_loc, nr

  allocate( vr(nr) )
  allocate( phir(nr,2,lpsmax) )
  allocate( chir(nr,2,lpsmax) )
  allocate( anorm_chir(2,lpsmax) )
  allocate( t_rc(lpsmax) )

  do ll=1,lpsmax
     read(iunit,*)
     read(iunit,*)

     do n=1,nr
        read(iunit,*) vr(n),dummy1                       &
             ,phir(n,1,ll),phir(n,2,ll)          &
             ,dummy2,dummy3,dummy4,dummy5,dummy6 &
             ,chir(n,1,ll),chir(n,2,ll)
        phir(n,2,ll)=phir(n,1,ll)
     end do
  end do
  close(iunit)


  elem%Vloc%l  = l_loc-1
  elem%Vloc%Q  = -Q
  elem%Vloc%Rc = vr(nr)
  allocate( elem%Vloc%vR(nr) )

  do ll=1,lpsmax
     anorm_chir(1,ll)=0.d0
     anorm_chir(2,ll)=0.d0
  end do
  do n=1, nr
     elem%Vloc%vR(n)=chir(n,1,l_loc)
     do ll=1,lpsmax
        dummy1=chir(n,1,ll)+chir(n,2,ll)*dfloat(ll)*.5d0
        dummy2=chir(n,1,ll)-chir(n,2,ll)*dfloat(ll+1)*.5d0
        chir(n,1,ll)=(dummy1-elem%Vloc%vR(n))*phir(n,1,ll)
        chir(n,2,ll)=(dummy2-elem%Vloc%vR(n))*phir(n,2,ll)
        if( dabs(dummy1-elem%Vloc%vR(n)) > 1.d-14 ) then
           t_rc(ll)=vr(n)
        end if
        if( dabs(dummy2-elem%Vloc%vR(n)) > 1.d-14 ) then
           t_rc(ll)=vr(n)
        end if
        anorm_chir(1,ll)=anorm_chir(1,ll)+chir(n,1,ll)*chir(n,1,ll)
        anorm_chir(2,ll)=anorm_chir(2,ll)+chir(n,2,ll)*chir(n,2,ll)
     end do
  end do
  elem%nVnon=0
  do ll=1,lpsmax
     if( anorm_chir(1,ll)+anorm_chir(2,ll) > 1.d-14 ) then
        elem%nVnon = elem%nVnon + 1
     end if
  end do

  if( elem%nVnon>0 ) then
     allocate(elem%vVnon(elem%nVnon,2))
     do n=1, elem%nVnon
        allocate(elem%vVnon(n,1)%vR(nr))
        allocate(elem%vVnon(n,2)%vR(nr))
     end do
  end if

  n=0
  do ll=1,lpsmax
     if( anorm_chir(1,ll)+anorm_chir(2,ll) < 1.d-14 ) then
        cycle
     end if
     n=n+1
     elem%vVnon(n,1)%l = ll-1
     elem%vVnon(n,2)%l = ll-1
     elem%vVnon(n,1)%Rc = t_rc(ll)
     elem%vVnon(n,2)%Rc = t_rc(ll)
     do i=1, nr
        elem%vVnon(n,1)%vR(i) = chir(i,1,ll)/vr(i)
        elem%vVnon(n,2)%vR(i) = chir(i,2,ll)/vr(i)
     end do
     elem%vVnon(n,1)%Q = 0.d0
     elem%vVnon(n,2)%Q = 0.d0
     do i=1, nr
        if( i > 1 ) then
           dummy1=vr(i-1)
        else
           dummy1=0.d0
        end if
        elem%vVnon(n,1)%Q = elem%vVnon(n,1)%Q + phir(i,1,ll)*chir(i,1,ll)*(vr(i)-dummy1)
        elem%vVnon(n,2)%Q = elem%vVnon(n,2)%Q + phir(i,2,ll)*chir(i,2,ll)*(vr(i)-dummy1)
     end do
     elem%vVnon(n,1)%Q = 1.d0/elem%vVnon(n,1)%Q
     elem%vVnon(n,2)%Q = 1.d0/elem%vVnon(n,2)%Q
  end do

  if( (n-elem%nVnon) /= 0 ) then
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,*) 'error:: elem%nVnon',n,elem%nVnon
     close(16)
     stop
  end if

  call RadialFunc__set( elem%Vloc, vr, nr )
  do n=1, elem%nVnon
     call RadialFunc__set( elem%vVnon(n,1), vr, nr )
     call RadialFunc__set( elem%vVnon(n,2), vr, nr )
  end do

  iunit = 3
  open(iunit,file=fname)
  read(iunit,*)
  read(iunit,*)

  do ll=1,lpsmax
     read(iunit,*)
     read(iunit,*)

     anorm_chir(2,ll)=0.d0
     do n=1,nr
        read(iunit,*) dummy1,dummy2,dummy3,dummy4,dummy5,chir(n,1,ll)
        if( ll == 1 ) then
           anorm_chir(2,ll)=anorm_chir(2,ll)+chir(n,1,ll)*chir(n,1,ll)
        else
           anorm_chir(2,ll)=anorm_chir(2,ll)+(chir(n,1,ll)-chir(n,1,1))*(chir(n,1,ll)-chir(n,1,1))
        end if
     end do
     if( ll == 1 ) then
        if( anorm_chir(2,ll) > 1.d-14 ) then
           elem%pcc = .true.
        else
           elem%pcc = .false.
           exit
        end if
     else
        if( elem%pcc .and. anorm_chir(2,ll) > 1.d-14 ) then
           open(unit=16,file=Param%Option%file_ac_tempout,position='append')
           write(16,*) 'ciao_test: pcc -> stop'
           close(16)
           stop
        end if
     end if
  end do
  close(iunit)
  if( elem%pcc ) then
     elem%rhopcc%l  = 0
     elem%rhopcc%Rc = elem%Vloc%Rc
     allocate( elem%rhopcc%vR(nr) )
     do n=1, nr
        elem%rhopcc%vR(n) = chir(n,1,1)
     end do
     call RadialFunc__set( elem%rhopcc, vr, nr )
  end if

  if(allocated(vr)) deallocate(vr)
  if(allocated(chir)) deallocate(chir)
  if(allocated(phir)) deallocate(phir)
  if(allocated(anorm_chir)) deallocate(anorm_chir)
  if(allocated(t_rc)) deallocate( t_rc )

  if( .not. associated(elem%Vloc%vR) ) then
     msg = "Pseudo.Potentials is not given"
     goto 1111
  end if

  do n=1, elem%nVnon
     if( .not. associated(elem%vVnon(n,1)%vR) ) then
        msg = "Pseudo.Potentials is not given"
        goto 1111
     end if
  end do

  if( elem%pcc .and. (.not. associated(elem%rhopcc%vR)) ) then
     msg = "density.PCC not given"
     goto 1111
  end if

  return

1111 continue 
  close(iunit)

  open(unit=16,file=Param%Option%file_ac_tempout,position='append')
  write(16,998) msg,fname 
998 format(' +++++++ Error VPS data: ',a,a)
  close(16)
  stop

end subroutine Element__readVPS_ciao_test

function Element__getNumberOfPAO( elem ) result(npao)
  use ac_parameter

  implicit none
  type(Element_type), intent(in) :: elem
  integer :: npao
  integer :: i

  npao = 0
  do i=1, elem%npao
     npao = npao + 2*(elem%vpao(i)%l) + 1
  end do

  return
end function Element__getNumberOfPAO

function Element__getNumberOfPAO2( elem ) result(npao)
  use ac_parameter

  implicit none
  type(Element_type), intent(in) :: elem
  integer :: npao
  integer :: i

  npao = 0
  do i=1, elem%npao2
     npao = npao + 2*(elem%vpao2(i)%l) + 1
  end do

  return
end function Element__getNumberOfPAO2

function Element__getNumberOfVPS( elem ) result(nvps)
  use ac_parameter

  implicit none
  type(Element_type), intent(in) :: elem
  integer :: nvps
  integer :: i

  nvps = 0
  do i=1, elem%nVnon
     if((Param%Data%element_type=='ciao_test') &
          .and.(.not. Param%Option%spin_orbit) &
          .and.(elem%dirac) &
          .and.(elem%vVnon(i,1)%l==elem%Vloc%l)) then
        cycle
     end if
     nvps = nvps + 2*(elem%vVnon(i,1)%l) + 1
  end do

  return
end function Element__getNumberOfVPS

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Naoki WATANABE, Nobutaka NISHIKAWA (Mizuho I.R.)   @@ !
! @@             Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

module ac_misc_module
  implicit none

  real(8), parameter :: M_PI       = 3.141592653589793238462d0 
  real(8), parameter :: SQRT_PI    = 1.77245385090551602729d0 
  real(8), parameter :: M_2_SQRTPI = 1.12837916709551257390d0 
  real(8), parameter :: M_1_PI     = 0.31830988618379067154d0 
  real(8), parameter :: M_SQRT1_2  = 0.70710678118654752440d0 
  real(8), parameter :: M_LN2      = 0.69314718055994530942d0 
  real(8), parameter :: M_CBRT2    = 1.259921049894873191d0 
  real(8), parameter :: M_CBRT3    = 1.442249570307408302d0 
  real(8), parameter :: M_CBRTPI   = 1.464591887561523142d0 

  real(8), parameter :: RY_TO_AU = 1.d0/2.d0 
  real(8), parameter :: AU_TO_RY = 1.d0/RY_TO_AU 
  real(8), parameter :: AU_TO_AA = 0.529177249d0 
  real(8), parameter :: AA_TO_AU = 1.d0/AU_TO_AA 
  real(8), parameter :: AU_TO_EV = 27.211396212 
  real(8), parameter :: EV_TO_AU = 1.d0/AU_TO_EV 
  real(8), parameter :: KELVIN_TO_AU = 3.166829936860255d-06 
  real(8), parameter :: AU_TO_KELVIN = 1.d0/KELVIN_TO_AU 

  complex(8), parameter :: C1 = (1.0d0, 0.0d0 )
  complex(8), parameter :: C0 = (0.0d0, 0.0d0 )

  real(8), private, parameter :: C00 = 0.282094791773878d0 
  real(8), private, parameter :: C10 = 0.488602511902920d0 
  real(8), private, parameter :: C11 = 0.488602511902920d0 
  real(8), private, parameter :: C20 = 0.315391565252520d0 
  real(8), private, parameter :: C21 = 1.092548430592079d0 
  real(8), private, parameter :: C22 = 0.546274215296040d0 
  real(8), private, parameter :: C30 = 0.373176332590115d0 
  real(8), private, parameter :: C31 = 0.457045799464466d0 
  real(8), private, parameter :: C32 = 1.445305721320277d0 
  real(8), private, parameter :: C33 = 0.590043589926644d0 
  real(8), private, parameter :: C40 = 0.105785546915204d0 
  real(8), private, parameter :: C41 = 0.669046543557289d0 
  real(8), private, parameter :: C42 = 0.473087347878780d0 
  real(8), private, parameter :: C43 = 1.770130769779931d0 
  real(8), private, parameter :: C44 = 0.625835735449176d0 
  real(8), private, parameter :: C50 = 0.116950322453424d0 
  real(8), private, parameter :: C51 = 0.452946651195697d0 
  real(8), private, parameter :: C52 = 2.396768392486662d0 
  real(8), private, parameter :: C53 = 0.489238299435250d0 
  real(8), private, parameter :: C54 = 2.075662314881042d0 
  real(8), private, parameter :: C55 = 0.656382056840170d0 
  real(8), private, parameter :: C60 = 0.063569202267628d0 
  real(8), private, parameter :: C61 = 0.582621362518731d0 
  real(8), private, parameter :: C62 = 0.460602629757462d0 
  real(8), private, parameter :: C63 = 0.921205259514924d0 
  real(8), private, parameter :: C64 = 0.504564900728724d0 
  real(8), private, parameter :: C65 = 2.366619162231752d0 
  real(8), private, parameter :: C66 = 0.683184105191914d0 

  integer, private, parameter :: N = 64  
  real(8), pointer ::  vshx(:)  
  real(8), pointer ::  vshw(:)  


  type Atom_type
     character(5)   :: name   
     integer        :: number 
     real(8)  :: Ro(3)  
     real(8)  :: Rc     
     real(8)  :: Q      
     real(8)  :: polarization 
     real(8)  :: force(3)  
     logical  :: optimize     
     real(8) :: opt_position(3)  
     real(8) :: opt_direction(3) 
     real(8), pointer :: force_past(:,:) 
  end type Atom_type

  type Spline_type
     integer :: N 
     real(8), pointer ::  vx(:) 
     real(8), pointer ::  vf(:) 
     real(8), pointer ::  vb(:) 
     real(8), pointer ::  vc(:) 
     real(8), pointer ::  vd(:) 
  end type Spline_type

  type RadialFunc_type
     integer          ::  l    
     real(8)          ::  Rc   
     real(8), pointer :: vR(:) 
     type(Spline_type):: fR    
     real(8), pointer :: vK(:) 
     real(8)          ::  Q    
  end type RadialFunc_type

  type SphericalBessel_type
     integer          :: Nr     
     integer          :: Nk     
     real(8), pointer :: vrx(:) 
     real(8), pointer :: vrw(:) 
     real(8), pointer :: vkx(:) 
     real(8), pointer :: vkw(:) 
  end type SphericalBessel_type

  type Element_type
     character(5)     :: name 
     integer          :: atomic_number 

     type(RadialFunc_type) :: rhoval 
     type(RadialFunc_type) :: Vval   

     integer          :: npao 
     type(RadialFunc_type), pointer :: vpao(:) 

     type(RadialFunc_type) :: Vloc 

     logical          :: dirac 
     integer          :: nVnon 
     type(RadialFunc_type), pointer :: vVnon(:,:) 


     integer          :: npao2 
     type(RadialFunc_type), pointer :: vpao2(:) 
     type(RadialFunc_type), pointer :: vpao2bar(:) 

     integer          :: nVloc 
     type(RadialFunc_type), pointer :: vVloc(:) 

     logical          :: pcc 
     type(RadialFunc_type) :: rhopcc 

     character(10)    :: namexc_pao 
     character(10)    :: namexc_vps 
  end type Element_type

  type Option_type
     logical :: na      = .true.           
     logical :: cluster = .false.          
     logical :: pcc     = .false.          
     logical :: spin_polar = .false.          
     logical :: spin_orbit = .false.          
     integer :: nspin   = 0                
     logical :: nohar   = .false.          
     logical :: noexc   = .false.          
     logical :: indirect_overlap = .false. 
     logical :: mx      = .false.          
     logical :: projection = .false.      
     logical :: ascot_negf = .false.       
     logical :: optimize   = .false.       
     logical :: atom_move   = .false. 
     character(50) :: optimize_method = "cg" 

     character(50) :: fname_accel_c  = ""  
     character(50) :: fname_accel_r  = ""  
     character(50) :: fname_accel_l  = ""  
     character(50) :: fname_ascot_vd = ""  
     character(50) :: fname_ascot_in = ""  

     character(50) :: fname_rhoscf_in   = "" 
     character(50) :: fname_matrices_in = "" 

     character(10) :: saveat = "every" 
     character(50) :: field_format = ".cube" 
     character(50) :: fname_rhoscf   = "" 
     character(50) :: fname_rhopcc = "" 
     character(50) :: fname_rhoval = "" 
     character(50) :: fname_vext = "" 
     character(50) :: fname_vhar = "" 
     character(50) :: fname_vexc = "" 
     character(50) :: fname_vtot = "" 
     character(50) :: fname_matrices = "" 

     character(50) :: file_ac_tempout
  end type Option_type

  type Cell_type
     real(8) :: La(3)    
     real(8) :: Lb(3)    
     real(8) :: Lc(3)    
     real(8) :: Lo(3)    
     integer        :: Na    
     integer        :: Nb    
     integer        :: Nc    
     real(8) :: dLa(3)   
     real(8) :: dLb(3)   
     real(8) :: dLc(3)   
     real(8) :: dKa(3)   
     real(8) :: dKb(3)   
     real(8) :: dKc(3)   
     real(8)        :: dKa1  
     real(8)        :: dKb1  
     real(8)        :: dKc1  
     real(8)        :: V     
     real(8)        :: dV    
     integer        :: nL    

     real(8), pointer :: vL(:,:) 
     integer, pointer :: vLna(:) 
     integer, pointer :: vLnb(:) 
     integer, pointer :: vLnc(:) 
  end type Cell_type

  type SCF_type
     character(10) :: exc_type = 'PZ81'     
     real(8) :: Te = 300.d0 * KELVIN_TO_AU  
     real(8) :: Ecutoff = 150.d0 * RY_TO_AU 
     integer :: Nka = 1 
     integer :: Nkb = 1 
     integer :: Nkc = 1 
     integer :: nK = 1                      
     real(8), pointer :: vK(:,:)       
     integer, pointer :: i_vK(:)
     complex(8), pointer :: vbloch(:,:)     

     character(16) :: mix_type = 'Simple'   
     character(16) :: mix_target = 'density_matrix'   
     real(8) :: mix_weight  =  0.3d0 
     real(8) :: mix_weight_s  =  -0.3d0
     integer :: mix_history = 4      
     integer :: mix_start   = 4      

     character(16) :: cri_type = 'fermi'    
     real(8) :: criterion = 1.e-6           
     integer ::  iter_max =  100 

     real(8) :: force_criterion = 1.0e-3    
     integer :: opt_iter_max =  0 
  end type SCF_type

  type Integral1D_type
     integer       ::  Nr = 900        
     integer       ::  Nk = 900        
     real(8) :: Ecutoff = 2500.d0 * RY_TO_AU 
  end type Integral1D_type

  type Kpath_type
     real(8) :: ks(3)   
     real(8) :: ke(3)   
     integer :: mesh 
  end type Kpath_type

  type Band_type
     character(64)  :: fname = ""                    
     character(64)  :: fname1 = ""                    
     real(8) :: La(3) = (/0,0,0/)          
     real(8) :: Lb(3) = (/0,0,0/)          
     real(8) :: Lc(3) = (/0,0,0/)          
     real(8) :: dKa(3)                           
     real(8) :: dKb(3)                           
     real(8) :: dKc(3)                           

     integer        :: nKpath                        
     type(Kpath_type), pointer :: vKpath(:)               
     integer        :: nK = 1                        
     real(8), pointer :: vK(:,:)                
     integer        :: num_band = 0                  
  end type Band_type

  type DOS_type
     character(50) :: fname = ""           
     real(8) :: Emin = -10.d0 * EV_TO_AU   
     real(8) :: Emax = +10.d0 * EV_TO_AU   
     real(8) :: GB = 0.1 * EV_TO_AU
     real(8) :: dE                         
     integer :: Ne = 101                   
     integer :: Nka = 0                    
     integer :: Nkb = 0                    
     integer :: Nkc = 0                    
     integer :: nK = 0                     
     character(16) :: method = 'gaussian' 
  end type DOS_type

  type MO_type
     character(50)  :: fbase = ""                    
     character(16)  :: method = 'ho_lumo'            
     integer        :: band_min=0                    
     integer        :: band_max=0                    
     real(8) :: La(3) = (/0,0,0/)          
     real(8) :: Lb(3) = (/0,0,0/)          
     real(8) :: Lc(3) = (/0,0,0/)          
     real(8) :: dKa(3)                           
     real(8) :: dKb(3)                           
     real(8) :: dKc(3)                           
     integer        :: nK = 0                        
     real(8), pointer :: vK(:,:)                 
  end type MO_type

  type Data_type
     character(50) :: path_pao = "." 
     character(50) :: path_vps = "." 
     character(50) :: element_type  = "ciao" 

     real(8) :: Ne_extra 
     real(8) :: Ne 
     real(8) :: g 
     integer                :: nelem    
     type(Element_type), pointer :: velem(:) 
     integer                :: natom    
     type(Atom_type), pointer    :: vatom(:) 

     integer       :: natom_left  = 0   
     integer       :: natom_right = 0   
     character(50), pointer, dimension(:,:) :: velem_file 

     integer          :: npao     
     integer, pointer :: vnpao(:) 
     integer, pointer :: vipao(:) 
     integer          :: nvps     
  end type Data_type

  type Param_type
     character(20)         :: name  = "" 
     type(Option_type)     :: Option     
     type(Cell_type)       :: Cell       
     type(SCF_type)        :: SCF        
     type(Integral1D_type) :: Integral1D 
     type(Band_type)       :: Band       
     type(DOS_type)        :: DOS        
     type(MO_type)         :: MO         
     type(Data_type)       :: Data       
  end type Param_type

  type Screening_type
     real(8) :: alpha 
     real(8), pointer :: PhiK(:,:,:) 
  end type Screening_type

  type Ewald_type
     real(8) :: alpha 
  end type Ewald_type

  type PAO_type
     real(8) :: Ro(3) 
     integer          :: m  
     integer          :: l  
     real(8)          :: Rc 
     type(RadialFunc_type), pointer :: RF 
     integer          :: range(6) 
     real(8), pointer :: wave(:,:,:) 
     real(8), pointer :: waveV(:,:,:) 
     real(8), pointer :: gwave(:,:,:,:) 
     real(8), pointer :: gwaveV(:,:,:,:) 
  end type PAO_type

  type Base_type
     integer            :: npao     
     type(PAO_type), pointer :: vpao(:)  
     integer, pointer   :: vnpao(:) 
     integer, pointer   :: vipao(:) 
  end type Base_type

  type PPcharge_type
     real(8) :: Ro(3) 
     real(8) :: Rc 
     type(RadialFunc_type), pointer :: RF 
  end type PPcharge_type

  type DensityPast_type
     real(8), pointer :: rho(:,:,:,:)    
     real(8), pointer :: drho(:,:,:,:)   
     complex(8), pointer :: rhoLS(:,:,:,:)    
     complex(8), pointer :: drhoLS(:,:,:,:)   
  end type DensityPast_type

  type Density_type
     real(8), pointer :: rho(:,:,:,:)    
     complex(8), pointer :: rhoLS(:,:,:,:)    
     real(8), pointer :: rhoval(:,:,:) 
     real(8), pointer :: rhopcc(:,:,:) 
     type(DensityPast_type), pointer :: vpast(:) 
  end type Density_type

  type PPloc_type
     real(8)        :: Ro(3) 
     real(8)        ::  Q 
     real(8)        :: Rc 
     type(RadialFunc_type), pointer ::  RF 
  end type PPloc_type

  type PPnon_type
     real(8) :: Ro(3) 
     integer        :: m  
     real(8)        :: E  
     integer        :: l  
     real(8)        :: Rc 
     type(RadialFunc_type), pointer :: RF 
  end type PPnon_type

  type Potential_type
     integer :: nVpsnon 
     type(PPnon_type), pointer :: vVpsnon(:,:) 
     integer, pointer :: vnVpsnon(:) 
     integer, pointer :: viVpsnon(:) 

     integer :: nVpsloc 
     integer, pointer :: vnVpsloc(:) 
     integer, pointer :: viVpsloc(:) 
     type(PPnon_type), pointer :: vVpsloc(:) 

     real(8), pointer :: Vext(:,:,:) 
     real(8), pointer :: dVhar(:,:,:) 
     real(8), pointer :: Vexc(:,:,:,:) 
     real(8), pointer :: Vtot(:,:,:,:) 
  end type Potential_type

  type Energy_type
     real(8) :: Ef 
     real(8) :: Etot 
  end type Energy_type

  type DensityMatrixPast_type
     real(8), pointer :: CDM(:,:,:)    
     real(8), pointer :: dCDM(:,:,:)   
     complex(8), pointer :: CDMLS(:,:,:)    
     complex(8), pointer :: dCDMLS(:,:,:)   
  end type DensityMatrixPast_type

  type AtomMatrix_type
     real(8), pointer :: S(:,:)     
     real(8), pointer :: H0(:,:,:)  
     real(8), pointer :: H (:,:,:)  
     complex(8), pointer :: H0LS(:,:,:)  
     complex(8), pointer :: HLS (:,:,:)  
     real(8), pointer :: CDM(:,:,:) 
     real(8), pointer :: EDM(:,:)   
     complex(8), pointer :: CDMLS(:,:,:) 
     real(8), pointer :: EDMLS(:,:)   
     type(DensityMatrixPast_type), pointer :: vpast(:) 
  end type AtomMatrix_type

  type AtomMatrix_Ptr_type
     type(AtomMatrix_type), pointer :: Ptr 
  end type AtomMatrix_Ptr_type

  type BandMatrix_type
     complex(8), pointer :: S(:,:)   
     complex(8), pointer :: H(:,:,:) 
     real(8),    pointer :: E(:,:)   
     real(8),    pointer :: F(:,:)   
  end type BandMatrix_type

  type Hamiltonian_type
     type(AtomMatrix_Ptr_type), pointer :: vAtomMatrix(:,:,:) 
     type(BandMatrix_type), pointer     :: vBandMatrix(:)     
  end type Hamiltonian_type

  type(Param_type), save, public     :: Param 
  type(Base_type), public            :: Base 
  type(Hamiltonian_type), public     :: Hamiltonian 
  type(Density_type), public         :: Density 
  type(Potential_type), public       :: Potential 
  type(Energy_type), public          :: Energy 
  type(Ewald_type), public           :: Ewald 
  type(SphericalBessel_type), public :: SphericalBessel 
  type(Screening_type), public       :: Screening 


  type SpinMatrix_type
     complex(8) :: element(2,2)
  end type SpinMatrix_type

contains

  function uncomment( line ) result(flag)
    character(len=*), intent(inout) :: line
    logical :: flag

    integer :: i
    integer :: len

    flag = .false.
    len = len_trim(line)

    if( len == 0 ) then
       flag = .true.
       return
    end if

    do i=1, len
       if( line(i:i) == '!' .or. line(i:i) == '#' .or. line(i:i) == '$' ) then
          line(i:len) = ' '
          if( i==1 ) then
             flag = .true.
          end if
          exit
       end if
       if( line(i:i) == '=' ) then
          line(i:i) = ' '
       end if
    end do

    if( len_trim(line) == 0 ) then
       flag = .true.
    end if

    return
  end function uncomment


  function TO_AU( unit ) result(c)
    character(len=*), intent(in) :: unit
    real(8) :: c

    c = 1.d0
    select case(unit)
    case("au", "AU", "a.u.", "A.U.")
       c = 1.d0
    case("hartree", "Hartree", "HARTREE")
       c = 1.d0
    case("hartree/bohr", "Hartree/Bohr", "HARTREE/BOHR")
       c = 1.d0
    case("eV", "ev", "EV")
       c = EV_TO_AU
    case("ry", "Ry", "RY", "rydberg", "Rydberg")
       c = RY_TO_AU
    case("K","kelvin","Kelvin")
       c = KELVIN_TO_AU
    case("ang","Ang","angstrom","Angstrom")
       c = AA_TO_AU
    case default
       open(unit=16,file=Param%Option%file_ac_tempout,position='append')
       write(16,'(a,a)') '      ++++++ Error: unknown unit ', trim(unit)
       close(16)
       stop
    end select

    return
  end function TO_AU


  function AU_TO( unit ) result(c)
    character(len=*), intent(in) :: unit
    real(8) :: c

    c = 1.d0
    select case(unit)
    case("au", "AU", "a.u.", "A.U.")
       c = 1.d0
    case("hartree", "Hartree", "HARTREE")
       c = 1.d0
    case("hartree/bohr", "Hartree/Bohr", "HARTREE/BOHR")
       c = 1.d0
    case("eV", "ev", "EV")
       c = AU_TO_EV
    case("ry", "Ry", "RY", "rydberg", "Rydberg")
       c = AU_TO_RY
    case("K","kelvin","Kelvin")
       c = AU_TO_KELVIN
    case("ang","Ang","angstrom","Angstrom")
       c = AU_TO_AA
    case default
       open(unit=16,file=Param%Option%file_ac_tempout,position='append')
       write(16,'(a,a)') '      ++++++ Error: unknown unit ', trim(unit)
       close(16)
       stop
    end select

    return
  end function AU_TO



  function Position__iszero( r ) result(flag)
    real(8), intent(in) :: r(3)
    logical :: flag

    if( r(1) == 0.0d0 .and. r(2) == 0.0d0 .and. r(3) == 0.0d0 ) then
       flag = .true.
    else
       flag = .false.
    end if

    return
  end function Position__iszero

  function Position__iprod( r1, r2 ) result(d)
    real(8), intent(in) :: r1(3), r2(3)
    real(8) :: d

    d = r1(1)*r2(1) + r1(2)*r2(2) + r1(3)*r2(3)

    return
  end function Position__iprod

  function Position__oprod( r1, r2 ) result(r)
    real(8), intent(in) :: r1(3), r2(3)
    real(8) :: r(3)

    r(1) = r1(2)*r2(3) - r1(3)*r2(2)
    r(2) = r1(3)*r2(1) - r1(1)*r2(3)
    r(3) = r1(1)*r2(2) - r1(2)*r2(1)

    return
  end function Position__oprod

  function Position__length( r ) result(d)
    real(8), intent(in) :: r(3)
    real(8) :: d

    d = sqrt(r(1)*r(1) + r(2)*r(2) + r(3)*r(3)) 

    return
  end function Position__length

  function Position__length2( r ) result(d)
    real(8), intent(in) :: r(3)
    real(8) :: d

    d = r(1)*r(1) + r(2)*r(2) + r(3)*r(3)

    return
  end function Position__length2

  function modp( n, m ) result(r)
    implicit none
    integer, intent(in) :: n, m
    integer :: r

    if( n>=1 ) then
       r=mod(n-1,m)+1
       return
    end if

    r=mod(n-1,m)
    r=mod(r+m,m)+1

    return
  end function modp

  function polar( theta ) result(c)
    implicit none
    real(8), intent(in) :: theta
    complex(8) :: c

    c = Cmplx( cos(theta), sin(theta) )

    return
  end function polar

  function cbrt(a) result(b)
    implicit none
    real(8), intent(in) :: a
    real(8) :: b

    if( a<0.d0 ) then
       b = (-1.0d0)*((-1.0d0)*a)**(1.d0/3.d0)
    else
       b = a**(1.d0/3.d0)
    end if

    return
  end function cbrt

  function log1p(a) result(b)
    implicit none
    real(8), intent(in) :: a
    real(8) :: b

    b = log(1.d0+a)

    return
  end function log1p

  function expm1(a) result(b)
    implicit none
    real(8), intent(in) :: a
    real(8) :: b

    b = exp(a) - 1.d0

    return
  end function expm1

  function Spline__evaluate( spline, x ) result(f)
    implicit none
    type(Spline_type), intent(in)  :: spline
    real(8), intent(in) :: x

    real(8) :: f
    real(8) :: dx
    integer :: i, ia, ib, ic

    if( Param%Option%mx ) then
       f = Spline__evaluateMX(spline,x)
       return
    end if

    if( x < spline%vx(1) ) then
       i=1
    elseif( x > spline%vx(spline%N) ) then
       i=spline%N
    else
       ia=1
       ib=spline%N
       do while( ia+1 < ib )
          ic = (ia+ib)/2
          if( x<spline%vx(ic) ) then
             ib=ic
          else
             ia=ic
          end if
       end do
       i=ia
    end if

    dx = x - spline%vx(i)

    f = spline%vf(i) + dx*(spline%vb(i) + dx*(spline%vc(i) + dx*spline%vd(i)))

    return
  end function Spline__evaluate

  function Spline__derivative( spline, x ) result(df)
    implicit none
    type(Spline_type), intent(in)  :: spline
    real(8), intent(in) :: x

    real(8) :: df

    integer       :: i, ia, ib, ic
    real(8) :: dx

    if( Param%Option%mx ) then
       df = Spline__derivativeMX(spline,x)
       return
    end if

    if( x < spline%vx(1) ) then
       i=1
    elseif( x > spline%vx(spline%N) ) then
       i=spline%N
    else
       ia=1
       ib=spline%N
       do while( ia+1 < ib )
          ic = (ia+ib)/2
          if( x<spline%vx(ic) ) then
             ib=ic
          else
             ia=ic
          end if
       end do
       i=ia
    end if

    dx = x - spline%vx(i)

    df = spline%vb(i) + 2*dx*spline%vc(i) + 3*dx*dx*spline%vd(i)

    return
  end function Spline__derivative

  function Spline__size( spline ) result(N)
    implicit none
    type(Spline_type), intent(in) :: spline

    integer      :: N

    N = spline%N

    return
  end function Spline__size

  function Spline__x(spline, i) result(x)
    implicit none
    type(Spline_type), intent(in)  :: spline
    integer, intent(in)       :: i

    real(8) :: x

    x = spline%vx(i)

    return
  end function Spline__x

  function Spline__xfront(spline) result(x)
    implicit none
    type(Spline_type), intent(in) :: spline
    real(8) :: x

    x = spline%vx(1)

    return
  end function Spline__xfront

  function Spline__xback(spline) result(x)
    implicit none
    type(Spline_type), intent(in)  :: spline
    real(8) :: x

    x = spline%vx(spline%N)

    return
  end function Spline__xback

  function Spline__evaluateMX( spline, x ) result(f)
    implicit none
    type(Spline_type), intent(in)  :: spline
    real(8), intent(in) :: x

    real(8) :: f
    integer :: i, ia, ib, ic
    real(8) :: h1,h2,h3,f1,f2,f3,f4
    real(8) :: g1,g2,x1,x2,y1,y2

    if( spline%vx(spline%N) < x ) then
       i=spline%N
    else if( x < spline%vx(1) ) then
       i=1
    else
       ia=1
       ib=spline%N
       do while( ia+1 < ib )
          ic = (ia+ib)/2
          if( x<spline%vx(ic) )then
             ib=ic
          else
             ia=ic
          end if
       end do
       i=ib
    end if

    if(i<2)then
       i = 3
    else if( spline%N<i )then
       i = spline%N-1
    end if

    if( i==2 ) then
       h2 = spline%vx(i)   - spline%vx(i-1)
       h3 = spline%vx(i+1) - spline%vx(i)

       f2 = spline%vf(i-1)
       f3 = spline%vf(i)
       f4 = spline%vf(i+1)

       h1 = -(h2+h3)
       f1 = f4
    else if (i==spline%N) then
       h1 = spline%vx(i-1) - spline%vx(i-2)
       h2 = spline%vx(i)   - spline%vx(i-1)

       f1 = spline%vf(i-2)
       f2 = spline%vf(i-1)
       f3 = spline%vf(i)

       h3 = -(h1+h2)
       f4 = f1
    else
       h1 = spline%vx(i-1) - spline%vx(i-2)
       h2 = spline%vx(i)   - spline%vx(i-1)
       h3 = spline%vx(i+1) - spline%vx(i)

       f1 = spline%vf(i-2)
       f2 = spline%vf(i-1)
       f3 = spline%vf(i)
       f4 = spline%vf(i+1)
    end if

    g1 = ((f3-f2)*h1/h2 + (f2-f1)*h2/h1)/(h1+h2)
    g2 = ((f4-f3)*h2/h3 + (f3-f2)*h3/h2)/(h2+h3)

    x1 = x - spline%vx(i-1)
    x2 = x - spline%vx(i)
    y1 = x1/h2
    y2 = x2/h2

    f = y2*y2*(3.0*f2 + h2*g1 + (2.0*f2 + h2*g1)*y2) &
         + y1*y1*(3.0*f3 - h2*g2 - (2.0*f3 - h2*g2)*y1)

    return
  end function Spline__evaluateMX

  function Spline__derivativeMX( spline, x ) result(df)
    implicit none
    type(Spline_type), intent(in)  :: spline
    real(8), intent(in) :: x

    real(8) :: df
    integer :: i, ia, ib, ic
    real(8) :: h1,h2,h3,f1,f2,f3,f4
    real(8) :: g1,g2,x1,x2,y1,y2

    if( spline%vx(spline%N) < x ) then
       i=spline%N
    else if( x < spline%vx(1) ) then
       i=1
    else
       ia=1
       ib=spline%N
       do while( ia+1 < ib )
          ic = (ia+ib)/2
          if( x<spline%vx(ic) )then
             ib=ic
          else
             ia=ic
          end if
       end do
       i=ib
    end if

    if(i<3)then
       i = 3
    else if( spline%N<i )then
       i = spline%N-1
    end if

    if( i==2 ) then
       h2 = spline%vx(i)   - spline%vx(i-1)
       h3 = spline%vx(i+1) - spline%vx(i)

       f2 = spline%vf(i-1)
       f3 = spline%vf(i)
       f4 = spline%vf(i+1)

       h1 = -(h2+h3)
       f1 = f4
    else if (i==spline%N) then
       h1 = spline%vx(i-1) - spline%vx(i-2)
       h2 = spline%vx(i)   - spline%vx(i-1)

       f1 = spline%vf(i-2)
       f2 = spline%vf(i-1)
       f3 = spline%vf(i)

       h3 = -(h1+h2)
       f4 = f1
    else
       h1 = spline%vx(i-1) - spline%vx(i-2)
       h2 = spline%vx(i)   - spline%vx(i-1)
       h3 = spline%vx(i+1) - spline%vx(i)

       f1 = spline%vf(i-2)
       f2 = spline%vf(i-1)
       f3 = spline%vf(i)
       f4 = spline%vf(i+1)
    end if

    g1 = ((f3-f2)*h1/h2 + (f2-f1)*h2/h1)/(h1+h2)
    g2 = ((f4-f3)*h2/h3 + (f3-f2)*h3/h2)/(h2+h3)

    x1 = x - spline%vx(i-1)
    x2 = x - spline%vx(i)
    y1 = x1/h2
    y2 = x2/h2

    df = y2*(2.0*(3.0*f2 + h2*g1) + 3.0*(2.0*f2 + h2*g1)*y2)/h2 &
         + y1*(2.0*(3.0*f3 - h2*g2) - 3.0*(2.0*f3 - h2*g2)*y1)/h2

    return
  end function Spline__derivativeMX

  function SphericalBessel__J( l, x ) result(J)
    implicit none
    integer, intent(in) :: l
    real(8), intent(in) :: x
    real(8) :: J

    real(8) :: ix1, ix2

    select case(l)
    case(0)
       if( x<1.0e-2 ) then
          J = 1.0 - 1.0/6.0*x*x
       else
          J = sin(x)/x
       endif

    case(1)
       if( x<1.0e-6 ) then
          J = 1.0/3.0*x - 1.0/30.0*(x**3)
       else
          ix1 = 1.0/x
          J = (sin(x)*ix1-cos(x))*ix1
       endif

    case(2)
       if( x<4.0e-3 ) then
          J = 1.0/15.0*(x**2) - 1.0/210.0*(x**4)
       else
          ix1 = 1.0/x
          ix2 = ix1*ix1
          J = + (sin(x)*ix1)*(3.0*ix2-1.0) - (cos(x)*ix2)*3.0
       endif

    case(3)
       if( x<2.0e-2 ) then
          J = 1.0/105.0*(x**3) - 1.0/1890.0*(x**5)
       else
          ix1 = 1.0/x
          ix2 = ix1*ix1
          J = + (sin(x)*ix2)*(15.0*ix2-6.0) &
               - (cos(x)*ix1)*(15.0*ix2-1.0)
       endif

    case(4)
       if( x<6.0e-2 ) then
          J = 1.0/945.0*(x**4) - 1.0/20790.0*(x**6)
       else
          ix1 = 1.0/x
          ix2 = ix1*ix1
          J = + (sin(x)*ix1)*((105.0*ix2-45.0)*ix2+1.0) &
               - (cos(x)*ix2)*(105.0*ix2-10.0)
       endif

    case(5)
       if( x<1.0e-1 ) then
          J = 1.0/(10395.0)*(x**5) - 1.0/270270.0*(x**7)
       else
          ix1 = 1.0/x
          ix2 = ix1*ix1
          J = + (sin(x)*ix2)*((945.0*ix2-420.0)*ix2+15.0) &
               - (cos(x)*ix1)*((945.0*ix2-105.0)*ix2+1.0)
       endif

    case(6)
       if( x<5.0e-1 ) then
          J = 1.0/(135135.0)*(x**6) - 1.0/4054050.0*(x**8)
       else
          ix1 = 1.0/x
          ix2 = ix1*ix1
          J = + (sin(x)*ix1)*(((945.0*11.0*ix2-4725.0)*ix2+210.0)*ix2-1.0) &
               - (cos(x)*ix2)*((945.0*11.0*ix2-1260.0)*ix2+21.0)
       endif

    case default
       J = 0.d0
       write(*,'(a70)') '# Sorry : spherical Bessel function for l>6 is not implemented'
       stop
    end select

    return
  end function SphericalBessel__J

  function SphericalBessel__Jx2( l, x ) result(Jx2)
    implicit none
    integer, intent(in)       :: l
    real(8), intent(in) :: x
    real(8) :: Jx2

    real(8) :: ix1, ix2


    select case(l)
    case(0)
       Jx2 = sin(x)*x

    case(1)
       Jx2 = sin(x) - cos(x)*x

    case(2)
       if( x<4.0e-3 ) then
          Jx2 = 1.0/15.0*(x**4) - 1.0/210.0*(x**6)
       else
          ix1 = 1.0/x
          ix2 = ix1*ix1
          Jx2 = (sin(x)*x)*(3.0*ix2-1.0) - (cos(x))*3.0
       endif

    case(3)
       if( x<2.0e-2 ) then
          Jx2 = 1.0/105.0*(x**5) - 1.0/1890.0*(x**7)
       else
          ix1 = 1.0/x
          ix2 = ix1*ix1
          Jx2 = (sin(x))*(15.0*ix2-6.0) - (cos(x)*x)*(15.0*ix2-1.0)
       endif

    case(4)
       if( x<6.0e-2 ) then
          Jx2 = 1.0/945.0*(x**6) - 1.0/20790.0*(x**8)
       else
          ix1 = 1.0/x
          ix2 = ix1*ix1
          Jx2 = (sin(x)*x)*((105.0*ix2-45.0)*ix2+1.0) &
               - (cos(x))*(105.0*ix2-10.0)
       endif

    case(5)
       if( x<1.0e-1 ) then
          Jx2 = 1.0/(10395.0)*(x**7) - 1.0/270270.0*(x**9)
       else
          ix1 = 1.0/x
          ix2 = ix1*ix1
          Jx2 = (sin(x))*((945.0*ix2-420.0)*ix2+15.0) &
               - (cos(x)*x)*((945.0*ix2-105.0)*ix2+1.0)
       endif

    case(6)
       if( x<5.0e-1 ) then
          Jx2 = 1.0/(135135.0)*(x**8) - 1.0/4054050.0*(x**10)
       else
          ix1 = 1.0/x
          ix2 = ix1*ix1
          Jx2 = + (sin(x)*x)*(((945.0*11.0*ix2-4725.0)*ix2+210.0)*ix2-1.0) &
               - (cos(x))*((945.0*11.0*ix2-1260.0)*ix2+21.0)
       endif

    case default
       Jx2 = 0.d0
       write(*,'(a70)') '# Sorry : spherical Bessel function for l>6 is not implemented'
       stop
    end select

    return
  end function SphericalBessel__Jx2

  function SphericalBessel__Jxl( l, x ) result(Jxl)
    implicit none
    integer, intent(in) :: l
    real(8), intent(in) :: x
    real(8) :: Jxl

    real(8) :: ix1, ix2

    select case(l)
    case(0)
       if( x<1.0e-2 ) then
          Jxl = 1.0 - 1.0/6.0*(x**2)
       else
          Jxl = sin(x)/x
       endif

    case(1)
       if( x<1.0e-6 ) then
          Jxl = 1.0/3.0 - 1.0/30.0*(x**2)
       else
          ix1 = 1.0/x
          ix2 = ix1*ix1
          Jxl = (sin(x)*ix1-cos(x))*ix2
       endif

    case(2)
       if( x<4.0e-3 ) then
          Jxl = 1.0/15.0 - 1.0/210.0*(x**2)
       else
          ix1 = 1.0/x
          ix2 = ix1*ix1
          Jxl = ((sin(x)*ix1)*(3.0*ix2-1.0) &
               - (cos(x)*ix2)*3.0)*ix2
       endif

    case(3)
       if( x<2.0e-2 ) then
          Jxl = 1.0/105.0 - 1.0/1890.0*(x**2)
       else
          ix1 = 1.0/x
          ix2 = ix1*ix1
          Jxl = ((sin(x)*ix1)*(15.0*ix2-6.0) &
               - (cos(x))*(15.0*ix2-1.0))*ix2*ix2
       endif

    case(4)
       if( x<6.0e-2 ) then
          Jxl = 1.0/945.0 - 1.0/20790.0*(x**2)
       else
          ix1 = 1.0/x
          ix2 = ix1*ix1
          Jxl = ((sin(x)*ix1)*((105.0*ix2-45.0)*ix2+1.0) &
               - (cos(x)*ix2)*(105.0*ix2-10.0))*ix2*ix2
       endif

    case(5)
       if( x<1.0e-1 ) then
          Jxl = 1.0/(10395.0) - 1.0/270270.0*(x**2)
       else
          ix1 = 1.0/x
          ix2 = ix1*ix1
          Jxl = ((sin(x)*ix1)*((945.0*ix2-420.0)*ix2+15.0) &
               - (cos(x))*((945.0*ix2-105.0)*ix2+1.0))*ix2*ix2*ix2
       endif

    case(6)
       if( x<5.0e-1 ) then
          Jxl = 1.0/(135135.0) - 1.0/4054050.0*(x**2)
       else
          ix1 = 1.0/x
          ix2 = ix1*ix1
          Jxl = ((sin(x)*ix1)*(((945.0*11.0*ix2-4725.0)*ix2+210.0)*ix2-1.0) &
               - (cos(x)*ix2)*((945.0*11.0*ix2-1260.0)*ix2+21.0))*ix2*ix2*ix2
       endif

    case default
       Jxl = 0.d0
       write(*,'(a70)') '# Sorry : spherical Bessel function for l>6 is not implemented'
       stop
    end select

    return
  end function SphericalBessel__Jxl

  function SphericalBessel__dJx2( l, x ) result(dJx2)
    implicit none
    integer, intent(in)       :: l
    real(8), intent(in) :: x
    real(8) :: dJx2

    real(8) :: ix1, ix2

    select case(l)
    case(0)
       dJx2 = sin(x) + cos(x)*x

    case(1)
       dJx2 = sin(x)*x

    case(2)
       if( x<4.0e-3 ) then
          dJx2 = 4.0/15.0*(x**3) - 6.0/210.0*(x**5)
       else
          ix1 = 1.0/x
          ix2 = ix1*ix1
          dJx2 = sin(x)*(-3.0*ix2+2.0) + cos(x)*(3.0*ix1-x)
       endif

    case(3)
       if( x<2.0e-2 ) then
          dJx2 = 1.0/21.0*(x**4) - 7.0/1890.0*(x**6)
       else
          ix1 = 1.0/x
          ix2 = ix1*ix1
          dJx2 = sin(x)*((-30.0*ix2+15.0)*ix1-x) + cos(x)*(30.0*ix2-5.0)
       endif

    case(4)
       if( x<6.0e-2 ) then
          dJx2 = 6.0/945.0*(x**5) - 8.0/20790.0*(x**7)
       else
          ix1 = 1.0/x
          ix2 = ix1*ix1
          dJx2 = sin(x)*((-315.0*ix2+150.0)*ix2-9.0)  &
               + cos(x)*((315.0*ix2-45.0)*ix1+x)
       endif

    case(5)
       if( x<1.0e-1 ) then
          dJx2 = 7.0/10395.0*(x**6) - 9.0/270270.0*(x**8)
       else
          ix1 = 1.0/x
          ix2 = ix1*ix1
          dJx2 = sin(x)*(((-3780.0*ix2+1785.0)*ix2-105.0)*ix1+x) &
               + cos(x)*((945.0*4.0*ix2-525.0)*ix2+14.0)
       endif

    case(6)
       if( x<5.0e-1 ) then
          dJx2 = 8.0/135135.0*(x**7) - 10.0/4054050.0*(x**9)
       else
          ix1 = 1.0/x
          ix2 = ix1*ix1
          dJx2 = sin(x)*(((-51975.0*ix2+24570.0)*ix2-1470.0)*ix2+20.0) &
               + cos(x)*((( 51975.0*ix2-7245.0)*ix2+210.0)*ix1-x)
       endif


    case default
       dJx2 = 0.d0
       write(*,'(a70)') '# Sorry : spherical Bessel function for l>6 is not implemented'
       stop
    end select

    return
  end function SphericalBessel__dJx2


  function SphericalBessel__dJxlx( l, x ) result(dJxlx)
    implicit none
    integer, intent(in)       :: l
    real(8), intent(in) :: x
    real(8) :: dJxlx
    real(8) :: ix1, ix2

    select case(l)
    case(0)
       if( x<1.0e-2 ) then
          dJxlx = - 2.0/6.0
       else
          ix1 = 1.0/x
          ix2 = ix1*ix1
          dJxlx = (cos(x)-(sin(x)*ix1))*ix2
       endif

    case(1)
       if( x<1.0e-6 ) then
          dJxlx = - 2.0/30.0
       else
          ix1 = 1.0/x
          ix2 = ix1*ix1
          dJxlx = ((1-3*ix2)*(sin(x)*ix1) + 3*(cos(x)*ix2) )*ix2
       endif

    case(2)
       if( x<4.0e-3 ) then
          dJxlx = - 2.0/210.0
       else
          ix1 = 1.0/x
          ix2 = ix1*ix1
          dJxlx = ((6-15*ix2)*(sin(x)*ix1) &
               + (15*ix2-1)*cos(x))*ix2*ix2
       endif

    case(3)
       if( x<2.0e-2 ) then
          dJxlx = - 2.0/1890.0
       else
          ix1 = 1.0/x
          ix2 = ix1*ix1
          dJxlx = ( - (1-45*ix2+105*ix2*ix2)*(sin(x)*ix1) &
               - (10*ix2-105)*(cos(x)*ix2) )*ix2*ix2
       endif

    case(4)
       if( x<6.0e-2 ) then
          dJxlx = - 2.0/20790.0
       else
          ix1 = 1.0/x
          ix2 = ix1*ix1
          dJxlx = -((15-420*ix2+945*ix2*ix2)*(sin(x)*ix1) &
               + (-1+105*ix2-945*ix2*ix2)*cos(x))*ix2*ix2*ix2
       endif

    case(5)
       if( x<1.0e-1 ) then
          dJxlx = - 2.0/270270.0
       else
          ix1 = 1.0/x
          ix2 = ix1*ix1
          dJxlx = ((1-210*ix2+4725*ix2*ix2-10395*ix2*ix2*ix2)*(sin(x)*ix1) &
               + (21-1260*ix2+10395*ix2*ix2)*(cos(x)*ix2))*ix2*ix2*ix2
       endif

    case(6)
       if( x<5.0e-1 ) then
          dJxlx = - 2.0/4054050.0
       else
          ix1 = 1.0/x
          ix2 = ix1*ix1
          dJxlx = ((28-3150*ix2+62370*ix2*ix2-135135*ix2*ix2*ix2)*(sin(x)*ix1) &
               + (-1+378*ix2-17325*ix2*ix2+135135*ix2*ix2*ix2)*cos(x))*ix2*ix2*ix2*ix2
       endif

    case default
       dJxlx = 0.d0
       write(*,'(a70)') '# Sorry : spherical Bessel function for l>6 is not implemented'
       stop
    end select

    return

  end function SphericalBessel__dJxlx

  function SphericalBessel__integrateS( Ra, Rb, l, r ) result(sum)
    implicit none
    real(8), intent(in) :: Ra(SphericalBessel%Nk)
    real(8), intent(in) :: Rb(SphericalBessel%Nk)
    integer, intent(in) :: l
    real(8), intent(in) :: r

    real(8) :: sum
    integer :: ik
    real(8) :: k, w

    sum=0.d0

    if( r < 1.d-14 ) then
       do ik=1, SphericalBessel%Nk
          k = SphericalBessel%vkx(ik)
          w = SphericalBessel%vkw(ik)

          sum = sum + w*(k**(l+2)) * Ra(ik)*Rb(ik)
       end do

       sum = sum*4*M_PI*SphericalBessel__Jxl(l,0.d0)
       return
    end if

    do ik=1, SphericalBessel%Nk
       k = SphericalBessel%vkx(ik)
       w = SphericalBessel%vkw(ik)

       sum = sum + w*SphericalBessel__Jx2(l,k*r) * Ra(ik)*Rb(ik)
    end do

    sum = sum*4*M_PI/r**(l+2)

    return
  end function SphericalBessel__integrateS

  function SphericalBessel__integrateK( Ra, Rb, l, r ) result(sum)
    implicit none
    real(8), intent(in) :: Ra(SphericalBessel%Nk)
    real(8), intent(in) :: Rb(SphericalBessel%Nk)
    integer, intent(in) :: l
    real(8), intent(in) :: r

    real(8) :: sum
    integer :: ik
    real(8) :: k, w

    sum=0.d0

    if( r < 1.d-14 ) then
       do ik=1, SphericalBessel%Nk
          k = SphericalBessel%vkx(ik)
          w = SphericalBessel%vkw(ik)

          sum = sum + w*(k**(l+4)) * Ra(ik)*Rb(ik)
       end do

       sum = sum*2*M_PI*SphericalBessel__Jxl(l,0.d0)
       return
    end if

    do ik=1, SphericalBessel%Nk
       k = SphericalBessel%vkx(ik)
       w = SphericalBessel%vkw(ik)

       sum = sum + w*k*k*SphericalBessel__Jx2(l,k*r) * Ra(ik)*Rb(ik)
    end do

    sum = sum*2*M_PI/r**(l+2)

    return
  end function SphericalBessel__integrateK

  function SphericalBessel__integratedS( Ra, Rb, l, r ) result(sum)
    implicit none
    real(8), intent(in) :: Ra(SphericalBessel%Nk)
    real(8), intent(in) :: Rb(SphericalBessel%Nk)
    integer, intent(in) :: l
    real(8), intent(in) :: r

    real(8) :: sum
    integer       :: ik
    real(8) :: k, w

    sum=0.d0

    if( r < 1.d-14 ) then
       do ik=1, SphericalBessel%Nk
          k = SphericalBessel%vkx(ik)
          w = SphericalBessel%vkw(ik)

          sum = sum + w*(k**(l+2)) * k**2 * Ra(ik)*Rb(ik)
       end do

       sum = sum*4*M_PI*SphericalBessel__dJxlx(l,0.d0)
       return
    end if

    do ik=1, SphericalBessel%Nk
       k = SphericalBessel%vkx(ik)
       w = SphericalBessel%vkw(ik)

       sum = sum - w*Ra(ik)*Rb(ik)*(l+2)*SphericalBessel__Jx2 (l,k*r)
       sum = sum + w*Ra(ik)*Rb(ik)*(k*r)*SphericalBessel__dJx2(l,k*r)
    end do

    sum = sum*4*M_PI/r**(l+4)

    return 
  end function SphericalBessel__integratedS

  function SphericalBessel__integratedK( Ra, Rb, l, r ) result(sum)
    implicit none
    real(8), intent(in) :: Ra(SphericalBessel%Nk)
    real(8), intent(in) :: Rb(SphericalBessel%Nk)
    integer, intent(in) :: l
    real(8), intent(in) :: r

    real(8) :: sum
    integer :: ik
    real(8) :: k, w

    sum=0.d0

    if( r < 1.d-14 ) then
       do ik=1, SphericalBessel%Nk
          k = SphericalBessel%vkx(ik)
          w = SphericalBessel%vkw(ik)

          sum = sum + w*(k**(l+4)) * k**2 * Ra(ik)*Rb(ik)
       end do

       sum = sum*2*M_PI*SphericalBessel__dJxlx(l,0.d0)
       return
    end if

    do ik=1, SphericalBessel%Nk
       k = SphericalBessel%vkx(ik)
       w = SphericalBessel%vkw(ik)

       sum = sum - w*k*k*Ra(ik)*Rb(ik)* (l+2)*SphericalBessel__Jx2 (l,k*r)
       sum = sum + w*k*k*Ra(ik)*Rb(ik)*(k*r)*SphericalBessel__dJx2(l,k*r)
    end do

    sum = sum*2*M_PI/r**(l+4)

    return
  end function SphericalBessel__integratedK

  function SphericalHarmonic__Theta(l,m,th) result(Theta)
    implicit none
    integer, intent(in) :: l, m
    real(8) :: th
    real(8) :: Theta

    real(8) :: c, s

    c = cos(th)
    s = sin(th)

    Theta = 0.d0

    select case(l)

    case(0)
       select case(abs(m))
       case(0)
          Theta = C00
       end select

    case(1)
       select case(abs(m))
       case(0)
          Theta = C10*c
       case(1)
          Theta = C11*s
       end select

    case(2)
       select case(abs(m))
       case(0)
          Theta = C20*( 3*c*c - 1.0 )
       case(1)
          Theta = C21*( c*s )
       case(2)
          Theta = C22*( s*s )
       end select

    case(3)
       select case(abs(m))
       case(0)
          Theta = C30*c*( 5*c*c - 3.0 )
       case(1)
          Theta = C31*s*( 5*c*c - 1.0 )
       case(2)
          Theta = C32*c*( s*s )
       case(3)
          Theta = C33*s*( s*s )
       end select

    case (4)
       select case(abs(m))
       case(0)
          Theta = C40*( 35*c*c*c*c - 30*c*c + 3 )
       case(1)
          Theta = C41*s*( 7*c*c*c - 3*c )
       case(2)
          Theta = C42*s*s*( 7*c*c - 1 )
       case(3)
          Theta = C43*c*s*s*s
       case(4)
          Theta = C44*s*s*s*s
       end select

    case (5)
       select case(abs(m))
       case(0)
          Theta = C50*c*( 63*c*c*c*c - 70*c*c + 15 )
       case(1)
          Theta = C51*s*( 21*c*c*c*c - 14*c*c + 1 )
       case(2)
          Theta = C52*c*s*s*( 3*c*c - 1 )
       case(3)
          Theta = C53*s*s*s*( 9*c*c - 1 )
       case(4)
          Theta = C54*c*s*s*s*s
       case(5)
          Theta = C55*s*s*s*s*s
       end select

    case(6)
       select case(abs(m))
       case(0)
          Theta = &
               C60*( 231*c*c*c*c*c*c - 315*c*c*c*c + 105*c*c - 5 )
       case(1)
          Theta = &
               C61*c*s*( 33*c*c*c*c - 30*c*c + 5 )
       case(2)
          Theta = &
               C62*s*s*( 33*c*c*c*c - 18*c*c + 1 )
       case(3)
          Theta = &
               C63*c*s*s*s*( 11*c*c - 3 )
       case(4)
          Theta = &
               C64*s*s*s*s*( 11*c*c - 1 )
       case(5)
          Theta = &
               C65*c*s*s*s*s*s
       case(6)
          Theta = &
               C66*s*s*s*s*s*s
       end select

    case default
       Theta = 0.d0
       write(*,'(a70)') '# Sorry : Spherical Harmonic function for l>6 is not implemented.'
       stop

    end select


    return
  end function SphericalHarmonic__Theta

  function SphericalHarmonic__Phi(m,ph) result(Phi)
    implicit none
    integer       :: m
    real(8) :: ph
    real(8) :: Phi

    if( m == 0 ) then
       Phi = 1.d0
    elseif( m > 0 ) then 
       Phi = cos(m*ph)
    else 
       Phi = sin(m*ph)
    endif

    return
  end function SphericalHarmonic__Phi

  function SphericalHarmonic__Gaunt( la, ma, lb, mb, l, m ) result(g)
    implicit none
    integer, intent(in) :: l, la, lb
    integer, intent(in) :: m, ma, mb
    real(8) :: g

    real(8) :: tsum, psum
    integer :: it, ip
    real(8) :: th, ph, weight

    if( abs(abs(ma)-abs(mb)) /= abs(m) .and. abs(ma)+abs(mb) /= abs(m) ) then
       g = 0.d0
       return
    end if

    if( abs(mod(la-lb-l,4)) /= 0 .and. abs(mod(la-lb-l,4)) /= 2 ) then
       g = 0.d0
       return
    end if

    if( (.not. associated(vshx)) ) then
       allocate( vshx(N) )
       allocate( vshw(N) )
       call GaussLegendre__getPoints( N, 0.d0, M_PI, vshx, vshw )
    endif

    tsum=0.d0
    do it=1, N
       th  = vshx(it)
       weight = vshw(it)
       tsum = tsum + weight*sin(th)* &
            SphericalHarmonic__Theta(la,ma,th)* &
            SphericalHarmonic__Theta(lb,mb,th)* &
            SphericalHarmonic__Theta(l,m,th)
    end do

    if( tsum == 0.0 ) then
       g = 0.d0
       return
    endif

    psum=0.d0
    do ip=1, N
       ph     = vshx(ip)*2
       weight = vshw(ip)*2
       psum = psum + weight* &
            SphericalHarmonic__Phi(ma,ph)* &
            SphericalHarmonic__Phi(mb,ph)* &
            SphericalHarmonic__Phi(m,ph)
    end do

    if( psum == 0.0 ) then
       g = 0.d0
       return
    endif

    if( mod(la-lb-l,4) == +2 .or. mod(la-lb-l,4) == -2 ) then
       tsum = -tsum
    endif

    g = tsum*psum


    return
  end function SphericalHarmonic__Gaunt

  function SphericalHarmonic__rlY( l, m, R ) result(rlY)
    implicit none
    integer, intent(in) :: l, m
    real(8), intent(in) :: R(3)
    real(8)  :: rlY
    real(8)  :: x, y, z, dR2

    x = R(1)
    y = R(2)
    z = R(3)
    dR2 = Position__length2(R)
    rlY = 0.d0

    select case(l)
    case(0) 
       rlY = C00 

    case(1) 
       select case(m)
       case(+1)
          rlY = C11*x 
       case(-1)
          rlY = C11*y 
       case( 0)
          rlY = C10*z 
       end select

    case(2) 
       select case(m)
       case( 0)
          rlY = C20*(3*z*z-dR2) 
       case(+2)
          rlY = C22*(x*x-y*y) 
       case(-2)
          rlY = C22*2.0*x*y 
       case(+1)
          rlY = C21*z*x 
       case(-1)
          rlY = C21*y*z 
       end select

    case(3) 
       select case(m)
       case( 0)
          rlY = C30*z * (5*z*z-3*dR2)
       case(+1)
          rlY = C31*x * (5*z*z-dR2)
       case(-1)
          rlY = C31*y * (5*z*z-dR2)
       case(+2)
          rlY = C32*z * (x*x-y*y)
       case(-2)
          rlY = C32*z * (2.0*x*y)
       case(+3)
          rlY = C33*x * (x*x - 3*y*y)
       case(-3)
          rlY = C33*y * (3*x*x - y*y)
       end select


    case(4) 
       select case(m)
       case(0)
          rlY = C40*(35*z*z*z*z - 30*z*z*dR2 + 3*dR2*dR2 )
       case(+1)
          rlY = C41*x*z * (7*z*z-3*dR2)

       case(-1)
          rlY = C41*y*z * (7*z*z-3*dR2)

       case(+2)
          rlY = C42*(x*x-y*y) * (7*z*z-dR2)

       case(-2)
          rlY = C42*2*x*y * (7*z*z-dR2)

       case(+3)
          rlY = C43*x*z * (x*x-3*y*y)

       case(-3)
          rlY = C43*y*z * (3*x*x-y*y)

       case(+4)
          rlY = C44 * (x*x-2*x*y-y*y) * &
               (x*x+2*x*y-y*y)
       case(-4)
          rlY = C44 * (4*x*y) * (x*x-y*y)

       end select


    case(5) 
       select case(m)
       case(0)
          rlY = C50*z* (63*z*z*z*z-70*z*z*dR2+15*dR2*dR2)
       case(+1)
          rlY = C51*x* (21*z*z*z*z-14*z*z*dR2+dR2*dR2 )
       case(-1)
          rlY = C51*y* (21*z*z*z*z-14*z*z*dR2+dR2*dR2 )
       case(+2)
          rlY = C52*z* (x*x-y*y) * (3*z*z-dR2)
       case(-2)
          rlY = C52*z* (2*x*y) * (3*z*z-dR2)
       case(+3)
          rlY = C53*x* (x*x-3*y*y) * (9*z*z-dR2)
       case(-3)
          rlY = C53*y* (3*x*x-y*y) * (9*z*z-dR2)
       case(+4)
          rlY = C54*z* (x*x-2*x*y-y*y) * &
               (x*x+2*x*y-y*y)
       case(-4)
          rlY = C54*z* (4*x*y) * (x*x-y*y)
       case(+5)
          rlY = C55*x* (x*x*x*x-10*x*x*y*y+5*y*y*y*y)
       case(-5)
          rlY = C55*y* (5*x*x*x*x-10*x*x*y*y+y*y*y*y)
       end select

    case(6) 
       select case(m)
       case(0)
          rlY = C60*( 231*z*z*z*z*z*z &
               - 315*z*z*z*z*dR2 + 105*z*z*dR2*dR2 &
               - 5*dR2*dR2*dR2 )
       case(+1)
          rlY = C61*z*x * &
               (33*z*z*z*z-30*z*z*dR2+5*dR2*dR2)
       case(-1)
          rlY = C61*z*y * &
               (33*z*z*z*z-30*z*z*dR2+5*dR2*dR2)
       case(+2)
          rlY = C62*(x*x-y*y) * &
               (33*z*z*z*z-18*z*z*dR2+dR2*dR2)
       case(-2)
          rlY = C62*(2*x*y)* &
               (33*z*z*z*z-18*z*z*dR2+dR2*dR2)
       case(+3)
          rlY = C63*z*x * &
               (x*x-3*y*y) * (11*z*z-3*dR2)
       case(-3)
          rlY = C63*z*y * &
               (3*x*x-y*y) * (11*z*z-3*dR2)
       case(+4)
          rlY = C64*(11*z*z-dR2) * &
               (x*x-2*x*y-y*y) * (x*x+2*x*y-y*y)
       case(-4)
          rlY = C64*(11*z*z-dR2) * &
               4*x*y * (x*x-y*y)
       case(+5)
          rlY = C65*z*x * &
               (x*x*x*x-10*x*x*y*y+5*y*y*y*y)
       case(-5)
          rlY = C65*z*y * &
               (5*x*x*x*x-10*x*x*y*y+y*y*y*y)
       case(+6)
          rlY = C66*(x*x-y*y) * &
               (x*x-4*x*y+y*y) * (x*x+4*x*y+y*y)
       case(-6)
          rlY = C66*2*x*y * &
               (3*x*x-y*y) * (x*x-3*y*y)
       end select

    case default
       rlY = 0.d0
       write(*,'(a70)') &
            '# Sorry : Spherical Harmonic function for l>6 is not implemented.'
       stop

    end select

    return
  end function SphericalHarmonic__rlY


  function SphericalHarmonic__drlY( l, m, R ) result(drlY)
    implicit none
    integer, intent(in) :: l, m
    real(8), intent(in) :: R(3)
    real(8)  :: drlY(3)

    real(8)  :: x, y, z, dR2, dR4

    x = R(1)
    y = R(2)
    z = R(3)
    drlY = (/ 0.d0, 0.d0, 0.d0 /)
    dR2  = Position__length2(R)

    select case(l)
    case(0) 
       drlY = (/ 0.d0, 0.d0, 0.d0 /)

    case(1) 
       select case(m)
       case( 0)
          drlY = (/ 0.d0, 0.d0, C10 /)
       case(+1)
          drlY = (/ C11, 0.d0, 0.d0 /)
       case(-1)
          drlY = (/ 0.d0, C11, 0.d0 /)
       end select

    case(2) 
       select case(m)
       case( 0)
          drlY = C20*(/ -2*x, -2*y, 4*z /) 
       case(+1)
          drlY = C21*(/    z,   0.d0,   x /) 
       case(-1)
          drlY = C21*(/   0.d0,    z,   y /) 
       case(+2)
          drlY = C22*(/  2*x,- 2*y,  0.d0 /) 
       case(-2)
          drlY = C22*(/  2*y,  2*x,  0.d0 /) 
       end select

    case(3) 
       select case(m)
       case( 0)
          drlY = C30*(/ -6*x*z, -6*y*z, 9*z*z-3*dR2 /) 
       case(+1)
          drlY = C31*(/ -2*x*x + 5*z*z - dR2, -2*x*y, 8*x*z /)
       case(-1)
          drlY = C31*(/ -2*x*y,  -2*y*y + 5*z*z - dR2, 8*y*z /)
       case(+2)
          drlY = C32*(/ 2*x*z      , -2*y*z     , x*x-y*y /)
       case(-2)
          drlY = C32*(/ 2*y*z      ,  2*z*x     , 2*x*y /)
       case(+3)
          drlY = C33*(/ 3*(x*x-y*y), -6*x*y     , 0.d0 /)
       case(-3)
          drlY = C33*(/ 6*x*y      , 3*(x*x-y*y), 0.d0 /)
       end select

    case(4) 
       select case(m)
       case( 0)
          drlY = C40*(/ &
               -60*z*z*x + 12*x*dR2, &
               -60*z*z*y + 12*y*dR2, &
               80*z*z*z - 48*z*dR2 /)
       case(+1)
          drlY = C41*(/ &
               z*(7*z*z-3*dR2) - 6*x*x*z, &
               -6*x*y*z, &
               x*(7*z*z-3*dR2) + 8*x*z*z /)
       case(-1)
          drlY = C41*(/ &
               -6*x*y*z, &
               z*( 4*z*z - 3*x*x - 9*y*y), &
               y*(15*z*z-3*dR2)  /)
       case(+2)
          drlY = C42*(/ &
               4*x*(3*z*z - x*x), &
               4*y*( y*y - 3*z*z), &
               12*z*(x*x-y*y) /)
       case(-2)
          drlY = C42*(/ &
               2*y*(6*z*z - 3*x*x - y*y), &
               2*x*(6*z*z -   x*x - 3*y*y), &
               24*x*y*z /)
       case(+3)
          drlY = C43*(/ &
               3*z*(x*x-y*y), &
               -6*x*y*z, &
               x*(x*x-3*y*y) /)
       case(-3)
          drlY = C43*(/ &
               6*x*y*z, &
               3*z*(x*x-y*y), &
               y*(3*x*x-y*y) /)
       case(+4)
          drlY = C44*(/ &
               4*x*(x*x-3*y*y), &
               4*y*(y*y-3*x*x), &
               0.d0 /)
       case(-4)
          drlY = C44*(/ &
               4*y*(3*x*x - y*y), &
               4*x*(x*x - 3*y*y), &
               0.d0 /)
       end select

    case(5) 
       select case(m)
       case( 0)
          drlY = C50*(/ &
               z*(-140*x*z*z + 60*x*dR2), &
               z*(-140*y*z*z + 60*y*dR2), &
               175*z*z*z*z - 150*z*z*dR2 + 15*dR2*dR2 /)
       case(+1)
          drlY = C51*(/ &
               21*z*z*z*z - 14*z*z*dR2 + dR2*dR2 + 4*x*x*(dR2-7*z*z), &
               4*x*y*(dR2-7*z*z), &
               8*x*z*(7*z*z - 3*dR2) /)
       case(-1)
          drlY = C51*(/ &
               4*x*y*(dR2-7*z*z), &
               21*z*z*z*z - 14*z*z*dR2 + dR2*dR2 + 4*y*y*(dR2-7*z*z), &
               8*y*z*(7*z*z - 3*dR2) /)
       case(+2)
          drlY = C52*(/ &
               4*x*z*(z*z-x*x), &
               4*y*z*(y*y-z*z), &
               (7*z*z-dR2)*(x*x-y*y) /)
       case(-2)
          drlY = C52*(/ &
               2*y*z*(2*z*z - 3*x*x - y*y), &
               2*z*x*(2*z*z - 3*y*y - x*x), &
               2*x*y*(6*z*z - x*x - y*y) /)
       case(+3)
          drlY = C53*(/ &
               3*(x*x-y*y)*(9*z*z-dR2) - 2*x*x*(x*x-3*y*y), &
               - 4*x*y*(12*z*z-x*x-3*y*y), &
               + 16*x*z*(x*x-3*y*y) /)
       case(-3)
          drlY = C53*(/ &
               4*x*y*(12*z*z-3*x*x-y*y), &
               3*(x*x-y*y)*(9*z*z-dR2) - 2*y*y*(3*x*x-y*y), &
               16*y*z*(3*x*x-y*y) /)
       case(+4)
          drlY = C54*(/ &
               4*x*z*(x*x-3*y*y), &
               4*y*z*(y*y-3*x*x), &
               (x*x-2*x*y-y*y)*(x*x+2*x*y-y*y) /)
       case(-4)
          drlY = C54*(/ &
               4*y*z*(3*x*x-y*y), &
               4*z*x*(x*x-3*y*y), &
               4*x*y*(x*x-y*y) /)
       case(+5)
          drlY = C55*(/ &
               5*(x*x-2*x*y-y*y)*(x*x+2*x*y-y*y), &
               -20*x*y*(x*x-y*y), &
               0.d0 /)
       case(-5)
          drlY = C55*(/ &
               20*x*y*(x*x-y*y), &
               5*(x*x-2*x*y-y*y)*(x*x+2*x*y-y*y), &
               0.d0 /)
       end select

    case(6) 
       dR4 = dR2*dR2
       select case(m)
       case( 0)
          drlY = C60*(/ &
               -630*x*z*z*z*z + 420*x*z*z*dR2 - 30*x*dR4, &
               -630*y*z*z*z*z + 420*y*z*z*dR2 - 30*y*dR4, &
               756*z*z*z*z*z - 840*z*z*z*dR2 +180*z*dR4 /)
       case(+1)
          drlY = C61*(/ &
               + z*(33*z*z*z*z-30*z*z*dR2+5*dR4) - 20*z*x*x*(3*z*z-dR2), &
               -20*x*y*z*(3*z*z-dR2), &
               x*(105*z*z*z*z-70*z*z*dR2+5*dR4) /)
       case(-1)
          drlY = C61*(/ &
               -20*x*y*z*(3*z*z-dR2), &
               + z*(33*z*z*z*z-30*z*z*dR2+5*dR4) - 20*z*y*y*(3*z*z-dR2), &
               + y*(33*z*z*z*z-30*z*z*dR2+5*dR4)  + 8*z*z*y*(9*z*z-5*dR2) /)
       case(+2)
          drlY = C62*(/ &
               + 2*x*(33*z*z*z*z-18*z*z*dR2+dR4) - 4*x*(x*x-y*y)*(9*z*z-dR2), &
               - 2*y*(33*z*z*z*z-18*z*z*dR2+dR4) - 4*y*(x*x-y*y)*(9*z*z-dR2), &
               32*z*(x*x-y*y)*(3*z*z-dR2) /)
       case(-2) 
          drlY = C62*(/ &
               + 2*y*(33*z*z*z*z-18*z*z*dR2+dR4) - 8*x*x*y*(9*z*z-dR2), &
               + 2*x*(33*z*z*z*z-18*z*z*dR2+dR4) - 8*x*y*y*(9*z*z-dR2), &
               64*x*y*z*(3*z*z-dR2) /)
       case(+3)
          drlY = C63*(/ &
               3*(x*x-y*y)*z*(11*z*z-3*dR2) - 6*x*x*z*(x*x-3*y*y), &
               - 6*x*y*z*((11*z*z-3*dR2)+(x*x-3*y*y)), &
               x*(x*x-3*y*y)*(11*z*z-3*dR2) + 16*x*z*z*(x*x-3*y*y) /)
       case(-3)
          drlY = C63*(/ &
               12*x*y*z*(4*z*z-3*x*x-y*y), &
               3*(x*x-y*y)*z*(11*z*z-3*dR2) - 6*y*y*z*(3*x*x-y*y), &
               y*(3*x*x-y*y)*(11*z*z-3*dR2) + 16*y*z*z*(3*x*x-y*y) /)
       case(+4)
          drlY = C64*(/ &
               2*x*( 20*x*x*z*z - 60*y*y*z*z -3*x*x*x*x + 10*x*x*y*y + 5*y*y*y*y), &
               2*y*( 20*y*y*z*z - 60*x*x*z*z -3*y*y*y*y + 10*x*x*y*y + 5*x*x*x*x), &
               20*z*(x*x-2*x*y-y*y)*(x*x+2*x*y-y*y) /)
       case(-4)
          drlY = C64*(/ &
               + 4*y*( 30*x*x*z*z - 10*y*y*z*z - 5*x*x*x*x + y*y*y*y), &
               - 4*x*( 30*y*y*z*z - 10*x*x*z*z - 5*y*y*y*y + x*x*x*x), &
               80*x*y*z*(x*x-y*y) /)
       case(+5)
          drlY = C65*(/ &
               5*z*(x*x-2*x*y-y*y)*(x*x+2*x*y-y*y), &
               -20*x*y*z*(x*x-y*y), &
               x*(x*x*x*x-10*x*x*y*y+5*y*y*y*y) /)
       case(-5)
          drlY = C65*(/ &
               20*x*y*z*(x*x-y*y), &
               5*z*(x*x-2*x*y-y*y)*(x*x+2*x*y-y*y), &
               y*(5*x*x*x*x-10*x*x*y*y+y*y*y*y) /)
       case(+6)
          drlY = C66*(/ &
               +6*x*(5*y*y*y*y-10*x*x*y*y+x*x*x*x), &
               -6*y*(5*x*x*x*x-10*x*x*y*y+y*y*y*y), &
               0.d0 /)
       case(-6)
          drlY = C66*(/ &
               +6*y*(y*y*y*y-10*x*x*y*y+5*x*x*x*x), &
               +6*x*(x*x*x*x-10*x*x*y*y+5*y*y*y*y), &
               0.d0 /)
       end select

    case default
       drlY = (/ 0.d0, 0.d0, 0.d0 /) 
       write(*,'(a70)') &
            '# Sorry : Spherical Harmonic function for l>6 is not implemented.'
       stop

    end select

    return
  end function SphericalHarmonic__drlY

  subroutine SphericalHarmonic__deallocate
    implicit none

    if( associated(vshx) ) deallocate(vshx)
    if( associated(vshw) ) deallocate(vshw)

    return
  end subroutine SphericalHarmonic__deallocate

  function Param__Cell__inside( Ro, Rc ) result(flag)
    implicit none
    real(8), intent(in) :: Ro(3)
    real(8), intent(in) :: Rc
    logical :: flag
    integer :: range(6)

    call Param__Cell__getRange( range, Ro, Rc )

    if( range(1)<1 .or. Param%Cell%Na<range(2) ) then
       flag = .false.
       return
    end if
    if( range(3)<1 .or. Param%Cell%Nb<range(4) ) then
       flag = .false.
       return
    end if
    if( range(5)<1 .or. Param%Cell%Nc<range(6) ) then
       flag = .false.
       return
    end if

    flag = .true.

    return
  end function Param__Cell__inside

  function Param__Cell__intersect( Ro1, Rc1, Ro2, Rc2 ) result(flag)
    implicit none
    real(8), intent(in) :: Ro1(3), Ro2(3)
    real(8), intent(in)   :: Rc1, Rc2
    logical         :: flag

    flag = ( Position__length2(Ro2-Ro1) < (Rc1+Rc2)*(Rc1+Rc2) )

    return
  end function Param__Cell__intersect

  function Param__Cell__mergeRange1( range, range1, range2 ) result(flag)
    implicit none
    integer, intent(out) :: range(6)
    integer, intent(in)  :: range1(6), range2(6)
    logical :: flag

    range(1) = max(range1(1),range2(1))
    range(2) = min(range1(2),range2(2))

    if( range(1) > range(2) ) then
       flag = .false.
       return
    end if

    range(3) = max(range1(3),range2(3))
    range(4) = min(range1(4),range2(4))

    if( range(3) > range(4) ) then
       flag = .false.
       return
    end if

    range(5) = max(range1(5),range2(5))
    range(6) = min(range1(6),range2(6))

    if( range(5) > range(6) ) then
       flag = .false.
       return
    end if

    flag = .true.

    return
  end function Param__Cell__mergeRange1

  function Param__Cell__mergeRange2( range, Ro1, Rc1, Ro2, l, Rc2 ) result(flag)
    implicit none
    integer, intent(out)       :: range(6)
    real(8), intent(in) :: Ro1(3), Ro2(3)
    real(8), intent(in)  :: Rc1, Rc2
    integer, intent(in)  :: l

    real(8) :: R(3)
    real(8)        :: dR
    logical        :: flag
    integer        :: range1(6), range2(6)

    R(:)  = Ro2 + Param%Cell%vL(:,l) - Ro1(:)
    dR = Position__length(R)

    if( dR > Rc1 + Rc2 ) then
       flag = .false.
       return
    end if

    call Param__Cell__getRange( range1, Ro1, Rc1 )
    call Param__Cell__getRange( range2, Ro2, Rc2 )
    range2(1) = range2(1) + Param%Cell%vLna(l)
    range2(2) = range2(2) + Param%Cell%vLna(l)
    range2(3) = range2(3) + Param%Cell%vLnb(l)
    range2(4) = range2(4) + Param%Cell%vLnb(l)
    range2(5) = range2(5) + Param%Cell%vLnc(l)
    range2(6) = range2(6) + Param%Cell%vLnc(l)

    flag = Param__Cell__mergeRange1( range, range1, range2 )

    return
  end function Param__Cell__mergeRange2

  subroutine Param__Cell__mergeRange3( range, range1, range2 )
    implicit none
    integer, intent(out) :: range(6)
    integer, intent(in)  :: range1(6), range2(6)

    range(1) = min(range1(1),range2(1))
    range(2) = max(range1(2),range2(2))

    range(3) = min(range1(3),range2(3))
    range(4) = max(range1(4),range2(4))

    range(5) = min(range1(5),range2(5))
    range(6) = max(range1(6),range2(6))

    return
  end subroutine Param__Cell__mergeRange3

  function Param__Cell__relative( la, lb ) result(lab)
    integer, intent(in) :: la, lb
    integer :: lab

    do lab=1-Param%Cell%nL, Param%Cell%nL-1
       if(Position__length(Param%Cell%vL(:,lab) - Param%Cell%vL(:,lb) + Param%Cell%vL(:,la))<1.d-10) then
          return
       end if
    end do

    lab = -100 

    return
  end function Param__Cell__relative

  function Base__intersect( pao1, pao2, L ) result(flag)
    implicit none
    type(PAO_type), intent(in)      :: pao1, pao2
    real(8), intent(in) :: L(3)

    logical        :: flag
    real(8) :: R(3)
    real(8)  :: dR

    R  = pao2%Ro + L - pao1%Ro
    dR = Position__length(R)

    flag = dR < pao1%Rc + pao2%Rc

    return
  end function Base__intersect

  function Potential__intersect( pao1, pao2, L ) result(flag)
    implicit none
    type(PAO_type), intent(in)      :: pao1
    type(PPnon_type), intent(in)    :: pao2
    real(8), intent(in) :: L(3)

    logical        :: flag
    real(8) :: R(3)
    real(8)  :: dR

    R  = pao2%Ro + L - pao1%Ro
    dR = Position__length(R)

    flag = dR < pao1%Rc + pao2%Rc

    return
  end function Potential__intersect

  function Potential__intersectI( pao1, pao2, L ) result(flag)
    implicit none
    type(PPnon_type), intent(in)    :: pao1
    type(PAO_type), intent(in)      :: pao2
    real(8), intent(in) :: L(3)

    logical        :: flag
    real(8) :: R(3)
    real(8)  :: dR

    R  = pao2%Ro + L - pao1%Ro
    dR = Position__length(R)

    flag = dR < pao1%Rc + pao2%Rc

    return
  end function Potential__intersectI

  function Param__Data__getElement(name) result(elem)
    implicit none
    character(len=*), intent(in) :: name
    type(Element_type), pointer :: elem
    integer :: i

    do i=1, Param%Data%nelem
       if( Param%Data%velem(i)%name == name ) then
          elem => Param%Data%velem(i)
          return
       end if
    end do
    elem => Param%Data%velem(1) 

    write(*,*) '# Error: atom ', trim(name), ' is not available'
    stop
  end function Param__Data__getElement

  function Element__getNumberOfPAO( elem ) result(npao)
    implicit none
    type(Element_type), intent(in) :: elem
    integer :: npao
    integer :: i

    npao = 0
    do i=1, elem%npao
       npao = npao + 2*(elem%vpao(i)%l) + 1
    end do

    return
  end function Element__getNumberOfPAO

  function Element__getNumberOfPAO2( elem ) result(npao)
    implicit none
    type(Element_type), intent(in) :: elem
    integer :: npao
    integer :: i

    npao = 0
    do i=1, elem%npao2
       npao = npao + 2*(elem%vpao2(i)%l) + 1
    end do

    return
  end function Element__getNumberOfPAO2

  function Element__getNumberOfVPS( elem ) result(nvps)
    implicit none
    type(Element_type), intent(in) :: elem
    integer :: nvps
    integer :: i

    nvps = 0
    do i=1, elem%nVnon
       if((Param%Data%element_type=='ciao_test') &
            .and.(.not. Param%Option%spin_orbit) &
            .and.(elem%dirac) &
            .and.(elem%vVnon(i,1)%l==elem%Vloc%l)) then
          cycle
       end if
       nvps = nvps + 2*(elem%vVnon(i,1)%l) + 1
    end do

    return
  end function Element__getNumberOfVPS

end module ac_misc_module

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

module rtbh_parameter

  implicit none
  real(8) :: a,b,r1,r2
  character(4), pointer :: atomh_parameter(:)
  real(8), pointer :: v_ss(:),v_ps(:),v_pp(:),v_ds(:),v_dp(:),v_dd(:)
  real(8), pointer :: u_ss(:),u_ps(:),u_pp(:),u_ds(:),u_dp(:),u_dd(:)
  real(8), pointer :: r_ss(:),r_ps(:),r_pp(:),r_ds(:),r_dp(:),r_dd(:)
  real(8), pointer :: h_s(:),h_p(:),h_d(:)

contains
  subroutine alo_rtbh_parameter(num_atom_kind)

    implicit none
    integer, intent(in) :: num_atom_kind
    integer :: i_temp,ier

    i_temp=num_atom_kind

    allocate(v_ss(i_temp),v_ps(i_temp),v_pp(i_temp),v_ds(i_temp),v_dp(i_temp)    &
         ,v_dd(i_temp),u_ss(i_temp),u_ps(i_temp),u_pp(i_temp),u_ds(i_temp)    &
         ,u_dp(i_temp),u_dd(i_temp),r_ss(i_temp),r_ps(i_temp),r_pp(i_temp)    &
         ,r_ds(i_temp),r_dp(i_temp),r_dd(i_temp),h_s(i_temp),h_p(i_temp)      &
         ,h_d(i_temp),atomh_parameter(i_temp),stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_rtbh_parameter'
       stop
    end if

    return
  end subroutine alo_rtbh_parameter

  subroutine unset_rtbh_parameter

    implicit none
    integer :: ier

    deallocate(atomh_parameter,v_ss,v_ps,v_pp,v_ds,v_dp,v_dd,u_ss,u_ps,u_pp      &
         ,u_ds,u_dp,u_dd,r_ss,r_ps,r_pp,r_ds,r_dp,r_dd,h_s,h_p,h_d            &
         ,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error deallocate: unset_rtbh_parameter'
       stop
    end if

    return
  end subroutine unset_rtbh_parameter

end module rtbh_parameter

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Naoki WATANABE, Nobutaka NISHIKAWA (Mizuho I.R.)   @@ !
! @@             Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine PAO__set(pao,Ro,m,RF,range)
  use ac_misc_module

  implicit none
  type(PAO_type), intent(inout)   :: pao
  real(8), intent(in) :: Ro(3)
  integer, intent(in)        :: m
  type(RadialFunc_type), target, intent(in) :: RF
  integer, intent(in) :: range(6)

  pao%Ro =  Ro
  pao%m  =  m
  pao%l  =  RF%l
  pao%Rc =  RF%Rc
  pao%RF => RF

  call PAO__setW(pao, range)

  return
end subroutine PAO__set

subroutine PAO__W( wave, pao, Rg )
  use ac_misc_module

  implicit none
  type(PAO_type), intent(in)    :: pao
  real(8), intent(in) :: Rg(3)
  real(8), intent(out)  :: wave

  real(8) :: R(3)
  real(8) :: dR
  real(8) :: fRrl

  R  = Rg-pao%Ro
  dR = sqrt(dot_product(R,R))

  if( dR > pao%Rc ) then
     wave = 0.d0
  else if( dR < 1.d-14 .and. pao%l > 0 ) then
     wave = 0.d0
  else if( dR < 1.d-14 .and. pao%l == 0 ) then
     fRrl = Spline__evaluate(pao%RF%fR,dR)
     wave = fRrl * SphericalHarmonic__rlY(pao%l,pao%m,R)
  else
     fRrl = Spline__evaluate(pao%RF%fR,dR) /(dR**pao%l)
     wave = fRrl * SphericalHarmonic__rlY(pao%l,pao%m,R)
  end if

  return
end subroutine PAO__W

subroutine PAO__gW( gwave, pao, Rg )
  use ac_misc_module

  implicit none
  type(PAO_type), intent(in)    :: pao
  real(8), intent(in) :: Rg(3)
  real(8), intent(out) :: gwave(3)

  real(8) :: R(3)
  real(8) :: dR
  real(8) :: fRrl, dfRrl

  R  = Rg-pao%Ro
  dR = sqrt(dot_product(R,R))

  if( dR > pao%Rc ) then
     gwave = 0.d0
  else if( dR < 1.d-14 ) then
     gwave = 0.d0
  else
     fRrl = Spline__evaluate(pao%RF%fR,dR)/(dR**pao%l)
     dfRrl = Spline__derivative(pao%RF%fR,dR)/(dR**pao%l) - pao%l * fRrl/dR

     gwave = dfRrl * SphericalHarmonic__rlY(pao%l,pao%m,R) / dR * R &
          + fRrl * SphericalHarmonic__drlY(pao%l,pao%m,R)
  end if

  return
end subroutine PAO__gW

subroutine PAO__setW( pao, range )
  use ac_misc_module

  implicit none
  type(PAO_type), intent(out) :: pao
  integer, intent(in) :: range(6)

  integer :: ia, ib, ic
  real(8) :: R(3)

  pao%range = range
  if( pao%range(1) > pao%range(2) ) return
  if( pao%range(3) > pao%range(4) ) return
  if( pao%range(5) > pao%range(6) ) return

  allocate(pao%wave(pao%range(1):pao%range(2), &
       pao%range(3):pao%range(4),pao%range(5):pao%range(6)))

  do ic = pao%range(5), pao%range(6)
     do ib = pao%range(3), pao%range(4)
        do ia = pao%range(1), pao%range(2)
           call Param__Cell__R(R,ia,ib,ic)
           call PAO__W( pao%wave(ia,ib,ic), pao, R )
        end do
     end do
  end do

  allocate(pao%gwave(3,pao%range(1):pao%range(2), &
       pao%range(3):pao%range(4),pao%range(5):pao%range(6)))

  do ic = pao%range(5), pao%range(6)
     do ib = pao%range(3), pao%range(4)
        do ia = pao%range(1), pao%range(2)
           call Param__Cell__R(R,ia,ib,ic)
           call PAO__gW( pao%gwave(:,ia,ib,ic), pao, R )
        end do
     end do
  end do

  return
end subroutine PAO__setW

subroutine PAO__calcWaveV(pao,spin)
  use ac_misc_module

  implicit none
  type(PAO_type), intent(out) :: pao
  integer, intent(in) :: spin

  integer :: ia, ib, ic
  integer :: ia0, ib0, ic0

  allocate(pao%waveV(pao%range(1):pao%range(2), &
       pao%range(3):pao%range(4), pao%range(5):pao%range(6)))

  do ic = pao%range(5), pao%range(6)
     ic0 = modp(ic,Param%Cell%Nc)
     do ib = pao%range(3), pao%range(4)
        ib0 = modp(ib,Param%Cell%Nb)
        do ia = pao%range(1), pao%range(2)
           ia0 = modp(ia,Param%Cell%Na)

           pao%waveV(ia,ib,ic) = pao%wave(ia,ib,ic) * Potential%Vtot(spin,ia0,ib0,ic0)
        end do
     end do
  end do

  return
end subroutine PAO__calcWaveV

subroutine PAO__freeWaveV(pao)
  use ac_misc_module

  implicit none
  type(PAO_type), intent(inout) :: pao

  if( associated(pao%waveV) ) deallocate(pao%waveV)

  return
end subroutine PAO__freeWaveV

subroutine PAO__calcgWaveV(pao,spin)
  use ac_misc_module

  implicit none
  type(PAO_type), intent(out) :: pao
  integer, intent(in) :: spin

  integer :: ia, ib, ic
  integer :: ia0, ib0, ic0

  allocate(pao%gwaveV(3,pao%range(1):pao%range(2), &
       pao%range(3):pao%range(4), pao%range(5):pao%range(6)))

  do ic = pao%range(5), pao%range(6)
     ic0 = modp(ic,Param%Cell%Nc)
     do ib = pao%range(3), pao%range(4)
        ib0 = modp(ib,Param%Cell%Nb)
        do ia = pao%range(1), pao%range(2)
           ia0 = modp(ia,Param%Cell%Na)

           pao%gwaveV(:,ia,ib,ic) = pao%gwave(:,ia,ib,ic) * Potential%Vtot(spin,ia0,ib0,ic0)
        end do
     end do
  end do

  return
end subroutine PAO__calcgWaveV

subroutine PAO__freegWaveV(pao)
  use ac_misc_module

  implicit none
  type(PAO_type), intent(inout) :: pao

  if( associated(pao%gwaveV) ) deallocate(pao%gwaveV)

  return
end subroutine PAO__freegWaveV

subroutine PAO__deallocate(pao)
  use ac_misc_module

  implicit none
  type(PAO_type), intent(inout) :: pao

  if( associated(pao%wave) ) deallocate(pao%wave)
  if( associated(pao%gwave) ) deallocate(pao%gwave)

  return
end subroutine PAO__deallocate

subroutine Base__bracketSK(S,K,pao1,pao2,L)
  use ac_misc_module

  implicit none
  real(8) :: S,K
  type(PAO_type), intent(in) :: pao1,pao2
  real(8), intent(in) :: L(3)

  real(8) :: R(3)
  real(8) :: dR
  integer :: l0,m0
  real(8) :: g,gy,y
  real(8) :: intS,intK

  S = 0.d0
  K = 0.d0

  R  = pao2%Ro + L - pao1%Ro
  dR = sqrt(dot_product(R,R))

  if( dR > pao1%Rc + pao2%Rc ) then
     return
  end if

  do l0=0, min( 2*max( pao1%l, pao2%l ), 6 )
     gy=0.d0
     do m0=-l0, +l0
        g = SphericalHarmonic__Gaunt( pao1%l, pao1%m, pao2%l, pao2%m, l0, m0 )
        if( g == 0.d0 ) cycle
        y = SphericalHarmonic__rlY( l0, m0, R )
        gy = gy + g*y
     end do
     if( gy == 0.d0 ) cycle

     call SphericalBessel__integrateSK( intS, intK, pao1%RF%vK, pao2%RF%vK, l0, dR )
     S = S + gy * intS
     K = K + gy * intK
  end do

  return
end subroutine Base__bracketSK

subroutine Base__bracketdSK( dS, dK, pao1, pao2, L )
  use ac_misc_module

  implicit none
  real(8), intent(out) :: dS(3), dK(3)
  type(PAO_type), intent(in)      :: pao1, pao2
  real(8), intent(in) :: L(3)

  real(8) :: R(3)
  real(8)        :: dR
  integer        :: l0, m0
  real(8)        :: g, gy, y
  real(8) :: dgy(3), dy(3)
  real(8)        :: intS, intK
  real(8)        :: intdS, intdK

  dS = 0.d0
  dK = 0.d0

  R  = pao2%Ro + L - pao1%Ro
  dR = sqrt(dot_product(R,R))

  if( dR > pao1%Rc + pao2%Rc ) then
     return
  end if

  do l0=0, min( 2*max( pao1%l, pao2%l ), 6 )
     gy=0.d0
     dgy=0.d0
     do m0=-l0, +l0
        g = SphericalHarmonic__Gaunt( pao1%l, pao1%m, pao2%l, pao2%m, l0, m0 )
        if( g == 0.d0 ) cycle
        y = SphericalHarmonic__rlY( l0, m0, R )
        dy = SphericalHarmonic__drlY( l0, m0, R )

        gy = gy + g*y
        dgy = dgy + g*dy
     end do
     if( .not. gy == 0.d0 ) then
        call SphericalBessel__integratedSK( intdS, intdK, pao1%RF%vK, pao2%RF%vK, l0, dR )
        dS = dS + gy * intdS * R
        dK = dK + gy * intdK * R
     end if
     if( .not. dot_product(dgy,dgy) == 0.0d0 ) then
        call SphericalBessel__integrateSK( intS, intK, pao1%RF%vK, pao2%RF%vK, l0, dR )
        dS = dS + dgy * intS
        dK = dK + dgy * intK
     end if
  end do

  return
end subroutine Base__bracketdSK

subroutine Base__bracketV( V, a, b, l )
  use ac_misc_module
  use ac_mpi_module

  implicit none
  integer, intent(in) :: a, b, l
  real(8), intent(out) :: V(Base%vnpao(b),Base%vnpao(a))
  real(8), pointer :: vpaoVat(:), vpaoat(:)

  integer :: na, nb, nc
  integer :: i, i1
  integer :: j, j1
  integer :: range(6)
  integer :: ia, ib, ic
  integer :: ja, jb, jc
  real(8) :: wiV, wj

  na = Param%Cell%vLna(l)
  nb = Param%Cell%vLnb(l)
  nc = Param%Cell%vLnc(l)

  i=Base%vipao(a)
  j=Base%vipao(b)

  do i1=MPI%ispao(a), MPI%iepao(a)
     do j1=1, Base%vnpao(b)
        V(j1,i1) = 0.d0
     end do
  end do

  if( .not. Param__Cell__mergeRange2( range, &
       Base%vpao(i)%Ro, Base%vpao(i)%Rc, &
       Base%vpao(j)%Ro, l, &
       Base%vpao(j)%Rc ) ) then
     return
  end if

  allocate( vpaoVat(Base%vnpao(a)) )
  allocate( vpaoat (Base%vnpao(b)) )

  do ic = range(5), range(6)
     jc = ic-nc

     do ib = range(3), range(4)
        jb = ib-nb

        do ia = range(1), range(2)
           ja = ia-na

           do i1=MPI%ispao(a), MPI%iepao(a)
              vpaoVat(i1) = Base%vpao(i+i1-1)%waveV(ia,ib,ic)
           end do

           do j1=1, Base%vnpao(b)
              vpaoat(j1) = Base%vpao(j+j1-1)%wave(ja,jb,jc)
           end do

           do i1=MPI%ispao(a), MPI%iepao(a)
              wiV = vpaoVat(i1)
              if( wiV == 0.d0 ) cycle

              do j1=1, Base%vnpao(b)
                 wj = vpaoat(j1)
                 if( wj == 0.d0 ) cycle

                 V(j1,i1) = V(j1,i1) + wiV*wj
              end do
           end do

        end do
     end do
  end do

  do i1=MPI%ispao(a), MPI%iepao(a)
     do j1=1, Base%vnpao(b)
        V(j1,i1) = V(j1,i1) * Param%Cell%dV
     end do
  end do

  if( associated(vpaoat) )  deallocate(vpaoat)
  if( associated(vpaoVat) ) deallocate(vpaoVat)

  return 
end subroutine Base__bracketV

subroutine Base__bracketdV( dV, a, b, l )
  use ac_misc_module
  use ac_mpi_module

  implicit none
  integer, intent(in) :: a, b, l
  real(8), intent(out) :: dV(3,Base%vnpao(b),Base%vnpao(a))
  real(8), pointer :: vgpaoVat(:,:)
  real(8), pointer :: vpaoat(:)

  integer :: na, nb, nc
  integer :: i, i1
  integer :: j, j1
  integer :: range(6)
  integer :: ia, ib, ic
  integer :: ja, jb, jc

  real(8) :: wj
  real(8) :: gwiV(3)

  na = Param%Cell%vLna(l)
  nb = Param%Cell%vLnb(l)
  nc = Param%Cell%vLnc(l)

  i=Base%vipao(a)
  j=Base%vipao(b)

  do i1=MPI%ispao(a), MPI%iepao(a)
     do j1=1, Base%vnpao(b)
        dV(:,j1,i1) = 0.d0
     end do
  end do

  if( .not. Param__Cell__mergeRange2( range, &
       Base%vpao(i+MPI%ispao(a)-1)%Ro, Base%vpao(i+MPI%ispao(a)-1)%Rc, &
       Base%vpao(j)%Ro, l, &
       Base%vpao(j)%Rc ) ) then
     return
  end if

  allocate( vgpaoVat(3,Base%vnpao(a)) )
  allocate( vpaoat  (Base%vnpao(b)) )


  do ic = range(5), range(6)
     jc = ic-nc
     do ib = range(3), range(4)
        jb = ib-nb
        do ia = range(1), range(2)
           ja = ia-na

           do i1=MPI%ispao(a), MPI%iepao(a)
              vgpaoVat(:,i1) = Base%vpao(i+i1-1)%gwaveV(:,ia,ib,ic)
           end do

           do j1=1, Base%vnpao(b)
              vpaoat(j1) = Base%vpao(j+j1-1)%wave(ja,jb,jc)
           end do

           do i1=MPI%ispao(a), MPI%iepao(a)
              gwiV(:) = vgpaoVat(:,i1)
              if( dot_product( gwiV,gwiV ) == 0.0d0 ) cycle

              do j1=1, Base%vnpao(b)
                 wj = vpaoat(j1)
                 if( wj == 0.d0 ) cycle

                 dV(:,j1,i1) = dV(:,j1,i1) + gwiV(:)*wj
              end do
           end do
        end do
     end do
  end do

  do i1=MPI%ispao(a), MPI%iepao(a)
     do j1=1, Base%vnpao(b)
        dV(:,j1,i1) = dV(:,j1,i1) * Param%Cell%dV
     end do
  end do

  if( associated(vgpaoVat) ) deallocate(vgpaoVat)
  if( associated(vpaoat)   ) deallocate(vpaoat)

  return 
end subroutine Base__bracketdV

subroutine Base__bracketVd( dV, a, b, l )
  use ac_misc_module
  use ac_mpi_module

  implicit none
  integer, intent(in) :: a, b, l
  real(8), intent(out) :: dV(3,Base%vnpao(b),Base%vnpao(a))
  real(8), pointer :: vpaoVat(:)
  real(8), pointer :: vgpaoat(:,:)

  integer :: na, nb, nc
  integer :: i, i1
  integer :: j, j1
  integer :: range(6)
  integer :: ia, ib, ic
  integer :: ja, jb, jc

  real(8) :: wiV
  real(8) :: gwj(3)

  na = Param%Cell%vLna(l)
  nb = Param%Cell%vLnb(l)
  nc = Param%Cell%vLnc(l)

  i=Base%vipao(a)
  j=Base%vipao(b)

  do i1=MPI%ispao(a), MPI%iepao(a)
     do j1=1, Base%vnpao(b)
        dV(:,j1,i1) = 0.d0
     end do
  end do

  if( .not. Param__Cell__mergeRange2( range, &
       Base%vpao(i+MPI%ispao(a)-1)%Ro, Base%vpao(i+MPI%ispao(a)-1)%Rc, &
       Base%vpao(j)%Ro, l, &
       Base%vpao(j)%Rc ) ) then
     return
  end if

  allocate( vpaoVat(Base%vnpao(a)) )
  allocate( vgpaoat(3,Base%vnpao(b)) )


  do ic = range(5), range(6)
     jc = ic-nc
     do ib = range(3), range(4)
        jb = ib-nb
        do ia = range(1), range(2)
           ja = ia-na

           do i1=MPI%ispao(a), MPI%iepao(a)
              vpaoVat(i1) = Base%vpao(i+i1-1)%waveV(ia,ib,ic)
           end do

           do j1=1, Base%vnpao(b)
              vgpaoat(:,j1) = Base%vpao(j+j1-1)%gwave(:,ja,jb,jc)
           end do

           do i1=MPI%ispao(a), MPI%iepao(a)
              wiV = vpaoVat(i1)
              if( wiV == 0.d0 ) cycle

              do j1=1, Base%vnpao(b)
                 gwj(:) = vgpaoat(:,j1)
                 if( dot_product( gwj,gwj ) == 0.0d0 ) cycle

                 dV(:,j1,i1) = dV(:,j1,i1) + wiV*gwj(:)
              end do
           end do
        end do
     end do
  end do

  do i1=MPI%ispao(a), MPI%iepao(a)
     do j1=1, Base%vnpao(b)
        dV(:,j1,i1) = dV(:,j1,i1) * Param%Cell%dV
     end do
  end do

  if( associated(vpaoVat) ) deallocate(vpaoVat)
  if( associated(vgpaoat) ) deallocate(vgpaoat)

  return 
end subroutine Base__bracketVd

subroutine Base__setup
  use ac_misc_module
  use ac_mpi_module

  implicit none
  integer :: a, b, l
  integer :: i, j, n, m
  logical :: overlap, allocgrid
  integer rangeAND(6), rangeOR(6)

  type(Element_type), pointer :: elem

  call Base__deallocate

  Base%npao=0
  allocate( Base%vnpao(Param%Data%natom) )
  allocate( Base%vipao(Param%Data%natom) )

  Base%vipao(:) = Param%Data%vipao(:)
  Base%vnpao(:) = Param%Data%vnpao(:)
  Base%npao     = Param%Data%npao

  allocate( Base%vpao(Param%Data%npao) )

  do a=1, Param%Data%natom
     if( MPI%isatom<=a .and. a<=MPI%ieatom ) then
        call Param__Cell__getRange( rangeOR, & 
                   Param%Data%vatom(a)%Ro, &
                   Param%Data%vatom(a)%Rc )
        allocgrid = .true.
     else
        overlap = .false.

        rangeOR(1) = +10000
        rangeOR(2) = -10000
        rangeOR(3) = +10000
        rangeOR(4) = -10000
        rangeOR(5) = +10000
        rangeOR(6) = -10000

        do b=MPI%isatom, MPI%ieatom
           do l=0, Param%Cell%nL-1
              if( Param__Cell__mergeRange2( &
                   rangeAND, &
                   Param%Data%vatom(a)%Ro, &
                   Param%Data%vatom(a)%Rc, &
                   Param%Data%vatom(b)%Ro, -l, &
                   Param%Data%vatom(b)%Rc ) ) then
                 call Param__Cell__mergeRange3( rangeOR, rangeOR, rangeAND )
                 overlap = .true.
              end if
           end do
        end do

        if( overlap ) then
           allocgrid = .true.
        else
           allocgrid = .false.
        end if
     end if

     elem => Param__Data__getElement( Param%Data%vatom(a)%name )

     i = Param%Data%vipao(a)
     do n=1, elem%npao
        do m=-elem%vpao(n)%l, +elem%vpao(n)%l
           call PAO__set( Base%vpao(i), Param%Data%vatom(a)%Ro, m, elem%vpao(n), rangeOR )
           i = i + 1
        end do
     end do
  end do

  return
end subroutine Base__setup


subroutine Base__calcWave( waver, wavei, c, k, n_npao )
  use ac_misc_module
  use ac_mpi_module

  implicit none
  integer, intent(in) :: n_npao
  real(8), intent(out) :: waver(Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)
  real(8), intent(out) :: wavei(Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)
  complex(8), intent(in) :: c(n_npao)
  real(8), intent(in) :: k(3)

  integer :: i, l
  integer :: na, nb, nc
  integer :: ia, ib, ic
  integer range(6), range0(6), rangei(6)
  complex(8) :: cc

  complex(8), allocatable :: temp_s(:,:,:),temp_r(:,:,:)

  real(8) :: rnorm,pnorm
  integer :: i_max
  integer :: i_mpi

  allocate( temp_s(n_npao,1,1) )
  allocate( temp_r(n_npao,1,1) )

  do i=1, n_npao
    temp_s(i,1,1)=c(i)
    temp_r(i,1,1)=dcmplx(0.d0,0.d0)
  end do
  i_mpi=n_npao

  call MPI_ALLREDUCE(temp_s,temp_r,i_mpi,MPI_DOUBLE_COMPLEX,MPI_SUM,MPI_COMM_WORLD,MPI%info)

  rnorm=0.d0
  do i=1, n_npao
    pnorm=dreal(temp_r(i,1,1))**2+dimag(temp_r(i,1,1))**2
    if( rnorm < pnorm ) then
      rnorm=pnorm
      i_max=i
    end if
  end do
  pnorm=datan2(dimag(temp_r(i_max,1,1)),dreal(temp_r(i_max,1,1)))

  waver = 0.d0
  wavei = 0.d0

  do i=MPI%smat,MPI%emat
     do l=1-Param%Cell%nL, Param%Cell%nL-1

        na = Param%Cell%vLna(l)
        nb = Param%Cell%vLnb(l)
        nc = Param%Cell%vLnc(l)

        range0(1) = 1; range0(2) = Param%Cell%Na
        range0(3) = 1; range0(4) = Param%Cell%Nb
        range0(5) = 1; range0(6) = Param%Cell%Nc

        call Param__Cell__getRange( rangei, &
             Base%vpao(i)%Ro+Param%Cell%vL(:,l), Base%vpao(i)%Rc )

        if( .not. Param__Cell__mergeRange1( range, range0, rangei ) ) cycle

        cc = temp_r(i,1,1) * polar( dot_product(k(:),Param%Cell%vL(:,l)) ) * dcmplx(dcos(pnorm),-dsin(pnorm))

        do ic=range(5), range(6)
           do ib=range(3), range(4)
              do ia=range(1), range(2)
                 waver(ia,ib,ic) = waver(ia,ib,ic) &
                      + Base%vpao(i)%wave(ia-na,ib-nb,ic-nc) * dreal(cc)
                 wavei(ia,ib,ic) = wavei(ia,ib,ic) &
                      + Base%vpao(i)%wave(ia-na,ib-nb,ic-nc) * dimag(cc)
              end do
           end do
        end do
     end do
  end do

  deallocate( temp_s,temp_r )
  allocate( temp_s(Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc) )
  allocate( temp_r(Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc) )
  do ic=1,Param%Cell%Nc
    do ib=1,Param%Cell%Nb
      do ia=1,Param%Cell%Na
        temp_s(ia,ib,ic)=dcmplx(waver(ia,ib,ic),wavei(ia,ib,ic))
        temp_r(ia,ib,ic)=dcmplx(0.d0,0.d0)
      end do
    end do
  end do
  i_mpi=Param%Cell%Na*Param%Cell%Nb*Param%Cell%Nc

  call MPI_ALLREDUCE(temp_s,temp_r,i_mpi,MPI_DOUBLE_COMPLEX,MPI_SUM,MPI_COMM_WORLD,MPI%info)

  do ic=1,Param%Cell%Nc
    do ib=1,Param%Cell%Nb
      do ia=1,Param%Cell%Na
        waver(ia,ib,ic)=dreal(temp_r(ia,ib,ic))
        wavei(ia,ib,ic)=dimag(temp_r(ia,ib,ic))
      end do
    end do
  end do
  deallocate( temp_s,temp_r )

  rnorm=0.d0
  do ic=1, Param%Cell%Nc
    do ib=1, Param%Cell%Nb
      do ia=1, Param%Cell%Na
        rnorm=rnorm+waver(ia,ib,ic)**2+wavei(ia,ib,ic)**2
      end do
    end do
  end do
  rnorm=1.d0/dsqrt(rnorm*Param%Cell%dV)
  do ic=1, Param%Cell%Nc
    do ib=1, Param%Cell%Nb
      do ia=1, Param%Cell%Na
        waver(ia,ib,ic)=waver(ia,ib,ic)*rnorm
        wavei(ia,ib,ic)=wavei(ia,ib,ic)*rnorm
      end do
    end do
  end do

  return
end subroutine Base__calcWave

subroutine Base__deallocate
  use ac_misc_module
  use ac_mpi_module

  implicit none
!!  integer :: i
  integer :: a, i, i1

  if( associated(Base%vpao)  ) then
!!     do i=1, Base%npao
!!        call PAO__deallocate( Base%vpao(i) )
!!     end do
     do a=1, Param%Data%natom
        if( a<MPI%isatom .or. MPI%ieatom<a ) cycle

        i=Base%vipao(a)
        do i1=MPI%ispao(a), MPI%iepao(a)
           call PAO__deallocate( Base%vpao(i+i1-1) )
        end do
     end do
     deallocate( Base%vpao )
  end if
  if( associated(Base%vipao) ) deallocate( Base%vipao )
  if( associated(Base%vnpao) ) deallocate( Base%vnpao )

  call SphericalHarmonic__deallocate

  return
end subroutine Base__deallocate

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Naoki WATANABE, Nobutaka NISHIKAWA (Mizuho I.R.)   @@ !
! @@             Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine Force__calcSK
  use ac_parameter
  use ac_mpi_module
  implicit none

  integer :: l
  integer :: a, i, i1
  integer :: b, j, j1
  real(8) :: force(3)
  real(8) :: dS(3), dK(3)
  real(8) :: CDM, EDM

  do a=MPI%isatom, MPI%ieatom
     i=Base%vipao(a)

     do l=0, Param%Cell%nL-1
        do b=1, Param%Data%natom
           if( a==b ) cycle 
           if( l==0 .and. a<b ) cycle 

           if( .not. associated(Hamiltonian%vAtomMatrix(b,a,l)%Ptr) ) then
              cycle 
           end if

           j=Base%vipao(b)

           force(:) = 0.d0
           do i1=MPI%ispao(a), MPI%iepao(a)
              do j1=1, Base%vnpao(b)
                 call Base__bracketdSK( dS, dK, &
                      Base%vpao(i+i1-1), Base%vpao(j+j1-1), Param%Cell%vL(:,l) )

                 if( Param%Option%spin_orbit ) then
                    CDM = dreal(Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDMLS(j1,i1,1)) &
                         +dreal(Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDMLS(j1,i1,4))
                    EDM = Hamiltonian%vAtomMatrix(b,a,l)%Ptr%EDMLS(j1,i1)
                 else
                    CDM = sum(Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDM(j1,i1,:))
                    EDM = Hamiltonian%vAtomMatrix(b,a,l)%Ptr%EDM(j1,i1)
                 end if

                 force(:) = force(:) + CDM*2.d0 * dK(:) - EDM*2.d0 * dS(:)
              end do
           end do

           Param%Data%vatom(a)%force(:) = &
                Param%Data%vatom(a)%force(:) + force(:)
           Param%Data%vatom(b)%force(:) = &
                Param%Data%vatom(b)%force(:) - force(:)
        end do
     end do
  end do

  return
end subroutine Force__calcSK

subroutine Force__calcT
  use ac_parameter
  use ac_mpi_module
  implicit none

  integer :: spin
  integer :: l
  integer :: a, i, i1
  integer :: b, j1
  integer :: ia, ib, ic

  type(Element_type), pointer :: elem
  type(PPloc_type) :: Vpsloc, Vpsval
  real(8), allocatable :: gVext(:,:,:,:)

  real(8), pointer :: dVA(:,:,:), dVB(:,:,:)
  real(8) :: force(3), forceA(3), forceB(3)
  real(8) :: CDM, rho

  !!type(Element_type), pointer :: Param__Data__getElement

  do a=MPI%isatom, MPI%ieatom
     i=Base%vipao(a)

     do spin=1, Param%Option%nspin
        do i1=MPI%ispao(a), MPI%iepao(a)
           call PAO__calcgWaveV( Base%vpao(i+i1-1), spin )
           call PAO__calcWaveV ( Base%vpao(i+i1-1), spin )
        end do

        do l=0, Param%Cell%nL-1
           do b=1, Param%Data%natom
              if( .not. associated(Hamiltonian%vAtomMatrix(b,a,l)%Ptr) ) then
                 cycle 
              end if

              allocate( dVA(3,Base%vnpao(b),Base%vnpao(a)) )
              allocate( dVB(3,Base%vnpao(b),Base%vnpao(a)) )

              call Base__bracketdV( dVA, a, b, l )
              call Base__bracketVd( dVB, a, b, l )

              forceA(:) = 0.d0
              forceB(:) = 0.d0
              do i1=MPI%ispao(a), MPI%iepao(a)
                 do j1=1, Base%vnpao(b)
                    if( Param%Option%spin_orbit ) then
                       select case(spin)
                       case(1)
                          CDM = dreal(Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDMLS(j1,i1,1))
                       case(2)
                          CDM = +2.d0*dreal(Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDMLS(j1,i1,2))
                       case(3)
                          CDM = -2.d0*dimag(Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDMLS(j1,i1,2))
                       case(4)
                          CDM = dreal(Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDMLS(j1,i1,4))
                       end select
                    else
                       CDM = Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDM(j1,i1,spin)
                    end if

                    forceA(:) = forceA(:) + CDM*2.d0 * dVA(:,j1,i1)
                    forceB(:) = forceB(:) + CDM*2.d0 * dVB(:,j1,i1)
                 end do
              end do

              if( l==0 ) then
                 forceA(:) = forceA(:) * 0.5d0
                 forceB(:) = forceB(:) * 0.5d0
              end if
              Param%Data%vatom(a)%force(:) = &
                   Param%Data%vatom(a)%force(:) + forceA(:)
              Param%Data%vatom(b)%force(:) = &
                   Param%Data%vatom(b)%force(:) + forceB(:)

              if(associated(dVA)) deallocate(dVA)
              if(associated(dVB)) deallocate(dVB)
           end do
        end do

        do i1=MPI%ispao(a), MPI%iepao(a)
           call PAO__freegWaveV( Base%vpao(i+i1-1) )
           call PAO__freeWaveV ( Base%vpao(i+i1-1) )
        end do

     end do
  end do

  if( .not. Param%Option%projection ) then
     allocate( gVext(3,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc) )

     do a=MPI%isatom, MPI%ieatom
        if ( MPI%ispao(a) /= 1 ) cycle
        elem => Param__Data__getElement( Param%Data%vatom(a)%name )

        gVext = 0.d0
        if( Param%Option%na .and. (.not. Param%Option%nohar) ) then
           call PPloc__set( Vpsloc, Param%Data%vatom(a)%Ro, elem%Vloc )
           call PPloc__set( Vpsval, Param%Data%vatom(a)%Ro, elem%Vval )
           call Potential__setGradient2( gVext, Vpsloc, Vpsval )
        else
           call PPloc__set( Vpsloc, Param%Data%vatom(a)%Ro, elem%Vloc )
           call Potential__setGradient1( gVext, Vpsloc )
        end if

        force(:) = 0.d0
        do ic=1, Param%Cell%Nc
           do ib=1, Param%Cell%Nb
              do ia=1, Param%Cell%Na
                 if( Param%Option%spin_orbit ) then
                    rho =  dreal(Density%rhoLS(1,ia,ib,ic)) &
                         + dreal(Density%rhoLS(4,ia,ib,ic))
                 else
                    rho = sum(Density%rho(:,ia,ib,ic))
                 end if
                 force(:) = force(:) + rho * gVext(:,ia,ib,ic)
              end do
           end do
        end do

        Param%Data%vatom(a)%force(:) = &
             Param%Data%vatom(a)%force(:) + force(:) * Param%Cell%dV
     end do

     deallocate( gVext )
  end if

  return
end subroutine Force__calcT

subroutine Force__calcN
  use ac_parameter
  use ac_mpi_module
  implicit none

  integer :: l, a, i, i1
  integer :: b, j, j1
  integer :: c, k, k1
  integer :: lc, lbc
  real(8) :: forceA(3), forceB(3)
  real(8) :: CDM
  complex(8) :: CDMLS(4)

  type UVMatrix_type
     real(8), pointer :: uv(:,:)
     complex(8), pointer :: uvLS(:,:,:) 
     real(8), pointer :: duv(:,:,:)
     complex(8), pointer :: duvLS(:,:,:,:) 
     real(8), pointer ::  E(:,:)
  end type UVMatrix_type
  type UVMatrix_Ptr_type
     type(UVMatrix_type), pointer :: Ptr
  end type UVMatrix_Ptr_type
  type(UVMatrix_Ptr_type), pointer :: vUV(:,:,:)

  real(8) :: uv0, uvm
  integer :: psm, psl, spin
  real(8) :: duv0(3), duvm(3)
  complex(8), parameter :: CI = ( 0.0d0, 1.0d0 )
  complex(8) :: dVnonLS(3)
  real(8) :: gVnon(3)

  integer Param__Cell__relative
  logical Potential__intersect

  allocate( vUV(Param%Data%natom, 1-Param%Cell%nL:Param%Cell%nL-1, Param%Data%natom ) )

  do a=1, Param%Data%natom
     do l=1-Param%Cell%nL, Param%Cell%nL-1
        do c=1, Param%Data%natom
           vUV(a,l,c)%Ptr => null()
        end do
     end do
  end do

  do l=0, Param%Cell%nL-1
     do a=MPI%isatom, MPI%ieatom
        i=Base%vipao(a)

        do b=1, Param%Data%natom
           j=Base%vipao(b)

           if( .not. associated(Hamiltonian%vAtomMatrix(b,a,l)%Ptr) ) then
              cycle 
           end if

           do lc=1-Param%Cell%nL, Param%Cell%nL-1
              lbc = Param__Cell__relative( l, lc )
              if( lbc == -100 ) cycle

              do c=1, Param%Data%natom
                 if( Potential%vnVpsnon(c) == 0 ) cycle

                 k=Potential%viVpsnon(c) 

                 if( .not. Potential__intersect( Base%vpao(i), &
                      Potential%vVpsnon(k,1),  Param%Cell%vL(:,lc) ) ) then
                    cycle
                 end if

                 if( .not. Potential__intersect( Base%vpao(j), &
                      Potential%vVpsnon(k,1),  Param%Cell%vL(:,lbc) ) ) then
                    cycle
                 end if

                 if( .not. associated( vUV(c,lc,a)%Ptr ) ) then
                    if( Param%Option%spin_orbit ) then
                       allocate( vUV(c,lc,a)%Ptr )
                       allocate( vUV(c,lc,a)%Ptr%uvLS  ( Potential%vnVpsnon(c), Base%vnpao(a), 2 ) )
                       allocate( vUV(c,lc,a)%Ptr%duvLS( 3, Potential%vnVpsnon(c), Base%vnpao(a), 2 ) )
                       allocate( vUV(c,lc,a)%Ptr%E( Potential%vnVpsnon(c), 2 ) )

                       do k1=1, Potential%vnVpsnon(c)
                          psm = Potential%vVpsnon(k+k1-1,1)%m
                          do i1=1, Base%vnpao(a)
                             do spin=1, 2  
                                call Potential__bracketS (  uvm, &
                                     Base%vpao(i+i1-1), Potential%vVpsnon(k+k1-1-2*psm,spin), Param%Cell%vL(:,lc) )
                                call Potential__bracketS (  uv0, &
                                     Base%vpao(i+i1-1), Potential%vVpsnon(k+k1-1,spin), Param%Cell%vL(:,lc) )
                                call Potential__bracketdS( duvm, &
                                     Base%vpao(i+i1-1), Potential%vVpsnon(k+k1-1-2*psm,spin), Param%Cell%vL(:,lc) )
                                call Potential__bracketdS( duv0, &
                                     Base%vpao(i+i1-1), Potential%vVpsnon(k+k1-1,spin), Param%Cell%vL(:,lc) )

                                if( psm > 0 ) then
                                   vUV(c,lc,a)%Ptr% uvLS(  k1,i1,spin) = (-M_SQRT1_2)*(uv0 + CI*uvm)
                                   vUV(c,lc,a)%Ptr%duvLS(:,k1,i1,spin) = (-M_SQRT1_2)*(duv0(:) + CI*duvm(:))
                                else if( psm < 0 ) then
                                   vUV(c,lc,a)%Ptr% uvLS(  k1,i1,spin) = (+M_SQRT1_2)*(uvm - CI*uv0)
                                   vUV(c,lc,a)%Ptr%duvLS(:,k1,i1,spin) = (+M_SQRT1_2)*(duvm(:) - CI*duv0(:))
                                else if( psm == 0 ) then
                                   vUV(c,lc,a)%Ptr%uvLS (  k1,i1,spin) = uv0
                                   vUV(c,lc,a)%Ptr%duvLS(:,k1,i1,spin) = duv0(:)
                                end if
                             end do
                          end do
                          vUV(c,lc,a)%Ptr%E(k1,1) = Potential%vVpsnon(k+k1-1,1)%E
                          vUV(c,lc,a)%Ptr%E(k1,2) = Potential%vVpsnon(k+k1-1,2)%E
                       end do
                    else
                       allocate( vUV(c,lc,a)%Ptr )
                       allocate( vUV(c,lc,a)%Ptr%uv ( Potential%vnVpsnon(c), Base%vnpao(a) ) )
                       allocate( vUV(c,lc,a)%Ptr%duv( 3, Potential%vnVpsnon(c), Base%vnpao(a) ) )
                       allocate( vUV(c,lc,a)%Ptr%E  ( Potential%vnVpsnon(c), 1 ) )

                       do k1=1, Potential%vnVpsnon(c)
                          do i1=1, Base%vnpao(a)
                             call Potential__bracketS (  uv0, Base%vpao(i+i1-1), Potential%vVpsnon(k+k1-1,1), Param%Cell%vL(:,lc) )
                             call Potential__bracketdS( duv0, Base%vpao(i+i1-1), Potential%vVpsnon(k+k1-1,1), Param%Cell%vL(:,lc) )
                             vUV(c,lc,a)%Ptr%uv (k1,i1) = uv0
                             vUV(c,lc,a)%Ptr%duv(:,k1,i1) = duv0
                          end do
                          vUV(c,lc,a)%Ptr%E(k1,1) = Potential%vVpsnon(k+k1-1,1)%E
                       end do
                    end if
                 end if

                 if( .not. associated( vUV(c,lbc,b)%Ptr ) ) then
                    if( Param%Option%spin_orbit ) then
                       allocate( vUV(c,lbc,b)%Ptr )
                       allocate( vUV(c,lbc,b)%Ptr% uvLS  ( Potential%vnVpsnon(c), Base%vnpao(b), 2 ) )
                       allocate( vUV(c,lbc,b)%Ptr%duvLS( 3,Potential%vnVpsnon(c), Base%vnpao(b), 2 ) )
                       allocate( vUV(c,lbc,b)%Ptr%E    (   Potential%vnVpsnon(c), 2 ) )

                       do k1=1, Potential%vnVpsnon(c)
                          psm = Potential%vVpsnon(k+k1-1,1)%m
                          do j1=1, Base%vnpao(b)
                             do spin=1, 2  
                                call Potential__bracketS (  uvm, &
                                     Base%vpao(j+j1-1), Potential%vVpsnon(k+k1-1-2*psm,spin), Param%Cell%vL(:,lbc) )
                                call Potential__bracketS (  uv0, &
                                     Base%vpao(j+j1-1), Potential%vVpsnon(k+k1-1,spin), Param%Cell%vL(:,lbc) )
                                call Potential__bracketdS( duvm, &
                                     Base%vpao(j+j1-1), Potential%vVpsnon(k+k1-1-2*psm,spin), Param%Cell%vL(:,lbc) )
                                call Potential__bracketdS( duv0, &
                                     Base%vpao(j+j1-1), Potential%vVpsnon(k+k1-1,spin), Param%Cell%vL(:,lbc) )

                                if( psm > 0 ) then
                                   vUV(c,lbc,b)%Ptr% uvLS(  k1,j1,spin) = (-M_SQRT1_2)*(uv0 + CI*uvm)
                                   vUV(c,lbc,b)%Ptr%duvLS(:,k1,j1,spin) = (-M_SQRT1_2)*(duv0(:) + CI*duvm(:))
                                else if( psm < 0 ) then
                                   vUV(c,lbc,b)%Ptr% uvLS(  k1,j1,spin) = (+M_SQRT1_2)*(uvm - CI*uv0)
                                   vUV(c,lbc,b)%Ptr%duvLS(:,k1,j1,spin) = (+M_SQRT1_2)*(duvm(:) - CI*duv0(:))
                                else if( psm == 0 ) then
                                   vUV(c,lbc,b)%Ptr% uvLS(  k1,j1,spin) = uv0
                                   vUV(c,lbc,b)%Ptr%duvLS(:,k1,j1,spin) = duv0(:)
                                end if
                             end do
                          end do
                          vUV(c,lbc,b)%Ptr%E(k1,1) = Potential%vVpsnon(k+k1-1,1)%E
                          vUV(c,lbc,b)%Ptr%E(k1,2) = Potential%vVpsnon(k+k1-1,2)%E
                       end do
                    else
                       allocate( vUV(c,lbc,b)%Ptr )
                       allocate( vUV(c,lbc,b)%Ptr%uv ( Potential%vnVpsnon(c), Base%vnpao(b) ) )
                       allocate( vUV(c,lbc,b)%Ptr%duv( 3, Potential%vnVpsnon(c), Base%vnpao(b) ) )
                       allocate( vUV(c,lbc,b)%Ptr%E  ( Potential%vnVpsnon(c), 1 ) )

                       do k1=1, Potential%vnVpsnon(c)
                          do j1=1, Base%vnpao(b)
                             call Potential__bracketS (  uv0, Base%vpao(j+j1-1), Potential%vVpsnon(k+k1-1,1), Param%Cell%vL(:,lbc) )
                             call Potential__bracketdS( duv0, Base%vpao(j+j1-1), Potential%vVpsnon(k+k1-1,1), Param%Cell%vL(:,lbc) )
                             vUV(c,lbc,b)%Ptr%uv (k1,j1) = uv0
                             vUV(c,lbc,b)%Ptr%duv(:,k1,j1) = duv0
                          end do
                          vUV(c,lbc,b)%Ptr%E(k1,1) = Potential%vVpsnon(k+k1-1,1)%E
                       end do
                    end if
                 end if

                 forceA(:) = 0.d0
                 forceB(:) = 0.d0

                 if( Param%Option%spin_orbit ) then
                    do i1=MPI%ispao(a), MPI%iepao(a)
                       do j1=1, Base%vnpao(b)
                          CDMLS(:) = Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDMLS(j1,i1,:)
                          do k1=1, Potential%vnVpsnon(c)
                             psl = Potential%vVpsnon(k+k1-1,1)%l
                             psm = Potential%vVpsnon(k+k1-1,1)%m

                             dVnonLS(:) = &
                                  + vUV(c,lbc,b)%Ptr%E(k1,1) * (dble(psl+psm+1)/dble(2*psl+1)) &
                                  * vUV(c,lbc,b)%Ptr%uvLS(k1,j1,1) * dconjg(vUV(c,lc,a)%Ptr%duvLS(:,k1,i1,1))

                             forceA(:) = forceA(:) + 2.d0*dreal(CDMLS(1)*dVnonLS(:))

                             dVnonLS(:) = &
                                  + vUV(c,lc, a)%Ptr%E(k1,1) * (dble(psl+psm+1)/dble(2*psl+1)) &
                                  * vUV(c,lc, a)%Ptr%uvLS(k1,i1,1) * dconjg(vUV(c,lbc,b)%Ptr%duvLS(:,k1,j1,1))

                             forceB(:) = forceB(:) + 2.d0*dreal(CDMLS(1)*dVnonLS(:))

                             dVnonLS(:) = &
                                  + vUV(c,lbc,b)%Ptr%E(k1,2) * (dble(psl-psm)/dble(2*psl+1)) &
                                  * vUV(c,lbc,b)%Ptr%uvLS(k1,j1,2) * dconjg(vUV(c,lc,a)%Ptr%duvLS(:,k1,i1,2))

                             forceA(:) = forceA(:) + 2.d0*dreal(CDMLS(1)*dVnonLS(:))

                             dVnonLS(:) = &
                                  + vUV(c,lc, a)%Ptr%E(k1,2) * (dble(psl-psm)/dble(2*psl+1)) &
                                  * vUV(c,lc, a)%Ptr%uvLS(k1,i1,2) * dconjg(vUV(c,lbc,b)%Ptr%duvLS(:,k1,j1,2))

                             forceB(:) = forceB(:) + 2.d0*dreal(CDMLS(1)*dVnonLS(:))

                             if( psl > psm ) then
                                dVnonLS(:) = &
                                     + vUV(c,lbc,b)%Ptr%E(k1,1) &
                                     * sqrt(dble(psl+psm+1)/dble(2*psl+1)) * sqrt(dble(psl-psm)/dble(2*psl+1)) &
                                     * vUV(c,lbc,b)%Ptr%uvLS(k1,j1,1) * dconjg(vUV(c,lc,a)%Ptr%duvLS(:,k1,i1,1))

                                forceA(:) = forceA(:) + 2.d0*dreal(CDMLS(2)*dVnonLS(:))

                                dVnonLS(:) = &
                                     + vUV(c,lc, a)%Ptr%E(k1,1) &
                                     * sqrt(dble(psl+psm+1)/dble(2*psl+1)) * sqrt(dble(psl-psm)/dble(2*psl+1)) &
                                     * vUV(c,lc, a)%Ptr%uvLS(k1,i1,1) * dconjg(vUV(c,lbc,b)%Ptr%duvLS(:,k1,j1,1))

                                forceB(:) = forceB(:) + 2.d0*dreal(CDMLS(2)*dVnonLS(:))

                                dVnonLS(:) = &
                                     + vUV(c,lbc,b)%Ptr%E(k1,2) &
                                     * sqrt(dble(psl+psm+1)/dble(2*psl+1)) * sqrt(dble(psl-psm)/dble(2*psl+1)) &
                                     * vUV(c,lbc,b)%Ptr%uvLS(k1,j1,2) * dconjg(vUV(c,lc,a)%Ptr%duvLS(:,k1,i1,2))

                                forceA(:) = forceA(:) - 2.d0*dreal(CDMLS(2)*dVnonLS(:))

                                dVnonLS(:) = &
                                     + vUV(c,lc, a)%Ptr%E(k1,2) &
                                     * sqrt(dble(psl+psm+1)/dble(2*psl+1)) * sqrt(dble(psl-psm)/dble(2*psl+1)) &
                                     * vUV(c,lc, a)%Ptr%uvLS(k1,i1,2) * dconjg(vUV(c,lbc,b)%Ptr%duvLS(:,k1,j1,2))

                                forceB(:) = forceB(:) - 2.d0*dreal(CDMLS(2)*dVnonLS(:))
                             end if

                             if( psl > psm ) then
                                dVnonLS(:) = &
                                     + vUV(c,lbc,b)%Ptr%E(k1,1) &
                                     * sqrt(dble(psl+psm+1)/dble(2*psl+1)) * sqrt(dble(psl-psm)/dble(2*psl+1)) &
                                     * vUV(c,lbc,b)%Ptr%uvLS(k1,j1,1) * dconjg(vUV(c,lc,a)%Ptr%duvLS(:,k1,i1,1))

                                forceA(:) = forceA(:) + 2.d0*dreal(CDMLS(3)*dVnonLS(:))

                                dVnonLS(:) = &
                                     + vUV(c,lc, a)%Ptr%E(k1,1) &
                                     * sqrt(dble(psl+psm+1)/dble(2*psl+1)) * sqrt(dble(psl-psm)/dble(2*psl+1)) &
                                     * vUV(c,lc, a)%Ptr%uvLS(k1,i1,1) * dconjg(vUV(c,lbc,b)%Ptr%duvLS(:,k1,j1,1))

                                forceB(:) = forceB(:) + 2.d0*dreal(CDMLS(3)*dVnonLS(:))

                                dVnonLS(:) = &
                                     + vUV(c,lbc,b)%Ptr%E(k1,2) &
                                     * sqrt(dble(psl+psm+1)/dble(2*psl+1)) * sqrt(dble(psl-psm)/dble(2*psl+1)) &
                                     * vUV(c,lbc,b)%Ptr%uvLS(k1,j1,2) * dconjg(vUV(c,lc,a)%Ptr%duvLS(:,k1,i1,2))

                                forceA(:) = forceA(:) - 2.d0*dreal(CDMLS(3)*dVnonLS(:))

                                dVnonLS(:) = &
                                     + vUV(c,lc, a)%Ptr%E(k1,2) &
                                     * sqrt(dble(psl+psm+1)/dble(2*psl+1)) * sqrt(dble(psl-psm)/dble(2*psl+1)) &
                                     * vUV(c,lc, a)%Ptr%uvLS(k1,i1,2) * dconjg(vUV(c,lbc,b)%Ptr%duvLS(:,k1,j1,2))

                                forceB(:) = forceB(:) - 2.d0*dreal(CDMLS(3)*dVnonLS(:))
                             end if

                             dVnonLS(:) = &
                                  + vUV(c,lbc,b)%Ptr%E(k1,1) &
                                  * (dble(psl-psm+1)/dble(2*psl+1)) &
                                  * vUV(c,lbc,b)%Ptr%uvLS(k1,j1,1) * dconjg(vUV(c,lc,a)%Ptr%duvLS(:,k1,i1,1))

                             forceA(:) = forceA(:) + 2.d0*dreal(CDMLS(4)*dVnonLS(:))

                             dVnonLS(:) = &
                                  + vUV(c,lc, a)%Ptr%E(k1,1) &
                                  * (dble(psl-psm+1)/dble(2*psl+1)) &
                                  * vUV(c,lc, a)%Ptr%uvLS(k1,i1,1) * dconjg(vUV(c,lbc,b)%Ptr%duvLS(:,k1,j1,1))

                             forceB(:) = forceB(:) + 2.d0*dreal(CDMLS(4)*dVnonLS(:))


                             dVnonLS(:) = &
                                  + vUV(c,lbc,b)%Ptr%E(k1,2) &
                                  * (dble(psl+psm)/dble(2*psl+1)) &
                                  * vUV(c,lbc,b)%Ptr%uvLS(k1,j1,2) * dconjg(vUV(c,lc,a)%Ptr%duvLS(:,k1,i1,2))

                             forceA(:) = forceA(:) + 2.d0*dreal(CDMLS(4)*dVnonLS(:))

                             dVnonLS(:) = &
                                  + vUV(c,lc, a)%Ptr%E(k1,2) &
                                  * (dble(psl+psm)/dble(2*psl+1)) &
                                  * vUV(c,lc, a)%Ptr%uvLS(k1,i1,2) * dconjg(vUV(c,lbc,b)%Ptr%duvLS(:,k1,j1,2))

                             forceB(:) = forceB(:) + 2.d0*dreal(CDMLS(4)*dVnonLS(:))

                          end do
                       end do
                    end do
                 else 
                    do i1=MPI%ispao(a), MPI%iepao(a)
                       do j1=1, Base%vnpao(b)
                          CDM = sum(Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDM(j1,i1,:))
                          do k1=1, Potential%vnVpsnon(c)

                             gVnon = &
                                  vUV(c,lbc,b)%Ptr%E(k1,1) &
                                  * vUV(c,lbc,b)%Ptr%uv(k1,j1) * vUV(c,lc,a)%Ptr%duv(:,k1,i1)
                             forceA(:) = forceA(:) + CDM * 2.d0 * gVnon(:)

                             gVnon = &
                                  vUV(c,lc, a)%Ptr%E(k1,1) &
                                  * vUV(c,lc, a)%Ptr%uv(k1,i1) * vUV(c,lbc,b)%Ptr%duv(:,k1,j1)
                             forceB(:) = forceB(:) + CDM * 2.d0 * gVnon(:)
                          end do
                       end do
                    end do
                 end if

                 if( l==0 ) then
                    forceA(:) = forceA(:) * 0.5d0
                    forceB(:) = forceB(:) * 0.5d0
                 end if

                 Param%Data%vatom(a)%force(:) = &
                      Param%Data%vatom(a)%force(:) + forceA(:)
                 Param%Data%vatom(b)%force(:) = &
                      Param%Data%vatom(b)%force(:) + forceB(:)
                 Param%Data%vatom(c)%force(:) = &
                      Param%Data%vatom(c)%force(:) - forceA(:) - forceB(:)

              end do
           end do
        end do
     end do
  end do

  do a=1, Param%Data%natom
     do l=1-Param%Cell%nL, Param%Cell%nL-1
        do c=1, Param%Data%natom
           if( associated( vUV(c,l,a)%Ptr ) ) then
              if( Param%Option%spin_orbit ) then
                 deallocate( vUV(c,l,a)%Ptr% uvLS )
                 deallocate( vUV(c,l,a)%Ptr%duvLS )
              else
                 deallocate( vUV(c,l,a)%Ptr%uv )
                 deallocate( vUV(c,l,a)%Ptr%duv )
              end if
              deallocate( vUV(c,l,a)%Ptr%E )
              deallocate( vUV(c,l,a)%Ptr )
           end if
        end do
     end do
  end do

  if( associated(vUV) ) deallocate(vUV)

  return
end subroutine Force__calcN

subroutine Force__calcL
  use ac_parameter
  use ac_mpi_module
  implicit none

  integer :: l, a, i, i1 
  integer :: b, j, j1 
  integer :: c, k, k1
  integer :: lc, lbc
  real(8) :: forceA(3), forceB(3)
  real(8) :: CDM

  type UVMatrix_type
     real(8), pointer :: uv(:,:)
     real(8), pointer :: duv(:,:,:)
     real(8), pointer ::  E(:)
  end type UVMatrix_type
  type UVMatrix_Ptr_type
     type(UVMatrix_type), pointer :: Ptr
  end type UVMatrix_Ptr_type
  type(UVMatrix_Ptr_type), pointer :: vUV(:,:,:)

  integer Param__Cell__relative
  logical Potential__intersect

  allocate( vUV(Param%Data%natom, 1-Param%Cell%nL:Param%Cell%nL-1, Param%Data%natom ) )

  do a=1, Param%Data%natom
     do l=1-Param%Cell%nL, Param%Cell%nL-1
        do c=1, Param%Data%natom
           vUV(a,l,c)%Ptr => null()
        end do
     end do
  end do

  do l=0, Param%Cell%nL-1
     do a=MPI%isatom, MPI%ieatom
        i=Base%vipao(a)

        do b=1, Param%Data%natom
           j=Base%vipao(b)

           if( .not. associated(Hamiltonian%vAtomMatrix(b,a,l)%Ptr) ) then
              cycle 
           end if

           do lc=1-Param%Cell%nL, Param%Cell%nL-1
              lbc = Param__Cell__relative( l, lc )
              if( lbc == -100 ) cycle

              do c=1, Param%Data%natom
                 if( Potential%vnVpsloc(c) == 0 ) cycle

                 k=Potential%viVpsloc(c) 

                 if( .not. Potential__intersect( Base%vpao(i), &
                      Potential%vVpsloc(k),  Param%Cell%vL(:,lc) ) ) then
                    cycle
                 end if

                 if( .not. Potential__intersect( Base%vpao(j), &
                      Potential%vVpsloc(k),  Param%Cell%vL(:,lbc) ) ) then
                    cycle
                 end if

                 if( .not. associated( vUV(c,lc,a)%Ptr ) ) then
                    allocate( vUV(c,lc,a)%Ptr )
                    allocate( vUV(c,lc,a)%Ptr%uv(  Potential%vnVpsloc(c), Base%vnpao(a) ) )
                    allocate( vUV(c,lc,a)%Ptr%duv( 3, Potential%vnVpsloc(c), Base%vnpao(a) ) )
                    allocate( vUV(c,lc,a)%Ptr%E(   Potential%vnVpsloc(c) ) )

                    do k1=1, Potential%vnVpsloc(c)
                       do i1=1, Base%vnpao(a)
                          call Potential__bracketS ( vUV(c,lc,a)%Ptr%uv(k1,i1), &
                               Base%vpao(i+i1-1), Potential%vVpsloc(k+k1-1), Param%Cell%vL(:,lc) )
                          call Potential__bracketdS( vUV(c,lc,a)%Ptr%duv(:,k1,i1), &
                               Base%vpao(i+i1-1), Potential%vVpsloc(k+k1-1), Param%Cell%vL(:,lc) )
                       end do
                       vUV(c,lc,a)%Ptr%E(k1) = Potential%vVpsloc(k+k1-1)%E
                    end do
                 end if

                 if( .not. associated( vUV(c,lbc,b)%Ptr ) ) then
                    allocate( vUV(c,lbc,b)%Ptr )
                    allocate( vUV(c,lbc,b)%Ptr%uv(  Potential%vnVpsloc(c), Base%vnpao(b) ) )
                    allocate( vUV(c,lbc,b)%Ptr%duv( 3, Potential%vnVpsloc(c), Base%vnpao(b) ) )
                    allocate( vUV(c,lbc,b)%Ptr%E(   Potential%vnVpsloc(c) ) )

                    do k1=1, Potential%vnVpsloc(c)
                       do j1=1, Base%vnpao(b)
                          call Potential__bracketS ( vUV(c,lbc,b)%Ptr%uv(k1,j1), &
                               Base%vpao(j+j1-1), Potential%vVpsloc(k+k1-1), Param%Cell%vL(:,lbc) )
                          call Potential__bracketdS( vUV(c,lbc,b)%Ptr%duv(:,k1,j1), &
                               Base%vpao(j+j1-1), Potential%vVpsloc(k+k1-1), Param%Cell%vL(:,lbc) )
                       end do
                       vUV(c,lbc,b)%Ptr%E(k1) = Potential%vVpsloc(k+k1-1)%E
                    end do
                 end if

                 forceA(:) = 0.d0
                 forceB(:) = 0.d0

                 do i1=MPI%ispao(a), MPI%iepao(a)
                    do j1=1, Base%vnpao(b)
                       if( Param%Option%spin_orbit ) then
                          CDM = dreal(Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDMLS(j1,i1,1) &
                               +Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDMLS(j1,i1,4))
                       else
                          if( Param%Option%spin_polar ) then
                             CDM = Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDM(j1,i1,1) &
                                  +Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDM(j1,i1,2)
                          else
                             CDM = Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDM(j1,i1,1)
                          end if
                       end if

                       do k1=1, Potential%vnVpsloc(c)
                          forceA(:) = forceA(:) + CDM * 2.d0 * &
                               vUV(c,lbc,b)%Ptr%E (k1) * &
                               vUV(c,lbc,b)%Ptr%uv(k1,j1) * vUV(c,lc,a)%Ptr%duv(:,k1,i1)
                          forceB(:) = forceB(:) + CDM * 2.d0 * &
                               vUV(c,lc,a )%Ptr%E (k1) * &
                               vUV(c,lc,a )%Ptr%uv(k1,i1) * vUV(c,lbc,b)%Ptr%duv(:,k1,j1)
                       end do


                    end do
                 end do

                 if( l==0 ) then
                    forceA(:) = forceA(:) * 0.5d0
                    forceB(:) = forceB(:) * 0.5d0
                 end if

                 Param%Data%vatom(a)%force(:) = &
                      Param%Data%vatom(a)%force(:) + forceA(:)
                 Param%Data%vatom(b)%force(:) = &
                      Param%Data%vatom(b)%force(:) + forceB(:)
                 Param%Data%vatom(c)%force(:) = &
                      Param%Data%vatom(c)%force(:) - forceA(:) - forceB(:)

              end do
           end do
        end do
     end do
  end do

  do a=1, Param%Data%natom
     do l=1-Param%Cell%nL, Param%Cell%nL-1
        do c=1, Param%Data%natom
           if( associated( vUV(c,l,a)%Ptr ) ) then
              deallocate( vUV(c,l,a)%Ptr%uv )
              deallocate( vUV(c,l,a)%Ptr%duv )
              deallocate( vUV(c,l,a)%Ptr%E  )
              deallocate( vUV(c,l,a)%Ptr )
           end if
        end do
     end do
  end do

  if( associated(vUV) ) deallocate(vUV)

  return
end subroutine Force__calcL

subroutine Force__calcI
  use ac_parameter
  use ac_mpi_module
  implicit none

  integer :: a
  integer :: ia, ib, ic
  integer :: ia0, ib0, ic0
  type(Element_type), pointer :: elem
  type(PPcharge_type) :: rrhoval 
  type(PPcharge_type) :: rrhopcc 
  real(8) :: R(3)
  integer        :: range(6)
  real(8) :: grhovalat(3), grhopccat(3)
  real(8) :: force(3)
  real(8)        :: Vexc

  !!type(Element_type), pointer :: Param__Data__getElement

  do a=MPI%isatom, MPI%ieatom
     if ( MPI%ispao(a) /= 1 ) cycle
     elem => Param__Data__getElement( Param%Data%vatom(a)%name )
     force(:) = 0.d0

     if( Param%Option%na ) then
        call PPcharge__set( rrhoval, Param%Data%vatom(a)%Ro, elem%rhoval )
        call Param__Cell__getRange( range, rrhoval%Ro, rrhoval%Rc )

        do ic = range(5), range(6)
           ic0 = modp(ic,Param%Cell%Nc)
           do ib = range(3), range(4)
              ib0 = modp(ib,Param%Cell%Nb)
              do ia = range(1), range(2)
                 ia0 = modp(ia,Param%Cell%Na)

                 call Param__Cell__R(R,ia,ib,ic)
                 call PPcharge__gW(grhovalat(:),rrhoval,R)

                 force(:) = force(:) - Potential%dVhar(ia0,ib0,ic0) * grhovalat(:)
              end do
           end do
        end do
     end if

     if( elem%pcc ) then
        call PPcharge__set( rrhopcc, Param%Data%vatom(a)%Ro, elem%rhopcc )
        call Param__Cell__getRange( range, rrhopcc%Ro, rrhopcc%Rc )

        do ic = range(5), range(6)
           ic0 = modp(ic,Param%Cell%Nc)
           do ib = range(3), range(4)
              ib0 = modp(ib,Param%Cell%Nb)
              do ia = range(1), range(2)
                 ia0 = modp(ia,Param%Cell%Na)

                 call Param__Cell__R(R,ia,ib,ic)
                 call PPcharge__gW(grhopccat(:),rrhopcc,R)

                 if( Param%Option%spin_orbit ) then
                    grhopccat(:) = grhopccat(:)*0.5d0
                 else if( Param%Option%spin_polar ) then
                    grhopccat(:) = grhopccat(:)*0.5d0
                 else
                 end if


                 if( Param%Option%spin_orbit ) then
                    Vexc = Potential%Vexc(1,ia0,ib0,ic0) + Potential%Vexc(4,ia0,ib0,ic0)
                 else if( Param%Option%spin_polar ) then
                    Vexc = Potential%Vexc(1,ia0,ib0,ic0) + Potential%Vexc(2,ia0,ib0,ic0)
                 else
                    Vexc = Potential%Vexc(1,ia0,ib0,ic0)
                 end if

                 force(:) = force(:) + Vexc * grhopccat(:)
              end do
           end do
        end do
     end if

     Param%Data%vatom(a)%force(:) = &
          Param%Data%vatom(a)%force(:) + force(:) * Param%Cell%dV

  end do

  return
end subroutine Force__calcI

subroutine Force__calcQ
  use ac_parameter
  use ac_mpi_module
  implicit none

  integer        :: l, a, b
  type(Element_type), pointer :: elema
  type(Element_type), pointer :: elemb
  real(8) :: R(3)
  real(8)        :: dR
  type(PPcharge_type) :: rrhovalA, rrhovalB
  type(PPloc_type)    :: VvalA, VvalB
  real(8) :: force(3)

  !!type(Element_type), pointer :: Param__Data__getElement

  if( Param%Option%na ) then

     do a=MPI%isatom, MPI%ieatom
        if ( MPI%ispao(a) /= 1 ) cycle
        elema => Param__Data__getElement( Param%Data%vatom(a)%name )
        call PPcharge__set( rrhovalA, Param%Data%vatom(a)%Ro, elema%rhoval )
        call PPloc__set( VvalA, Param%Data%vatom(a)%Ro, elema%Vval )

        do b=1, Param%Data%natom
           if( a == b ) cycle

           elemb => Param__Data__getElement( Param%Data%vatom(b)%name )
           call PPloc__set( VvalB, Param%Data%vatom(b)%Ro, elemb%Vval )
           call PPcharge__set( rrhovalB, Param%Data%vatom(b)%Ro, elemb%rhoval )

           do l=0, Param%Cell%nL-1 
              if( l==0 .and. a<b ) cycle 

              R = Param%Data%vatom(a)%Ro - Param%Data%vatom(b)%Ro &
                   - Param%Cell%vL(:,l)
              dR = sqrt(dot_product(R,R))

              if( dR > rrhovalA%Rc + VvalB%Rc ) cycle

              force(:) = Param%Data%vatom(a)%Q*Param%Data%vatom(b)%Q/dR**3*R

              Param%Data%vatom(a)%force(:) = &
                   Param%Data%vatom(a)%force(:) + force(:)
              Param%Data%vatom(b)%force(:) = &
                   Param%Data%vatom(b)%force(:) - force(:)

              call Density__bracketdS( force, rrhovalA, VvalB, Param%Cell%vL(:,l) )

              Param%Data%vatom(a)%force(:) = &
                   Param%Data%vatom(a)%force(:) - force(:)

              call Density__bracketdS( force, rrhovalB, VvalA, Param%Cell%vL(:,l)*(-1.d0) )

              Param%Data%vatom(b)%force(:) = &
                   Param%Data%vatom(b)%force(:) - force(:)
           end do
        end do
     end do

  else 

     do a=MPI%isatom, MPI%ieatom
        if ( MPI%ispao(a) /= 1 ) cycle
        do b=1, Param%Data%natom
           if( a == b ) cycle

           R = Param%Data%vatom(a)%Ro - Param%Data%vatom(b)%Ro
           dR = sqrt(dot_product(R,R))

           force(:) = Param%Data%vatom(a)%Q * Param%Data%vatom(b)%Q / dR**3 * R(:)

           Param%Data%vatom(a)%force(:) = &
                Param%Data%vatom(a)%force(:) + force(:)
        end do
     end do

     if( .not. Param%Option%cluster ) then
        do a=MPI%isatom, MPI%ieatom
           if ( MPI%ispao(a) /= 1 ) cycle
           do b=1, Param%Data%natom
              call Ewald__calcForce( force(:), Param%Data%vatom(b)%Q, &
                   Param%Data%vatom(b)%Ro, Param%Data%vatom(a)%Ro )

              Param%Data%vatom(a)%force(:) = &
                   Param%Data%vatom(a)%force(:) + force(:) * Param%Data%vatom(a)%Q
           end do
        end do
     end if

  end if

  return
end subroutine Force__calcQ

subroutine Force__calc
  use ac_parameter
  use ac_mpi_module
  implicit none
  integer :: a

  open(unit=16,file=Param%Option%file_ac_tempout,position='append')
  write(16,*)
  write(16,*) '**************************************************************'
  write(16,*) '************ start calculating forces on each atom'
  write(16,*) '**************************************************************'
  close(16)

  do a=1, Param%Data%natom
     Param%Data%vatom(a)%force(:) = 0.d0
  end do

  call Force__calcSK 

  call Force__calcT 

  call Force__calcN 

  call Force__calcI 

  call Force__calcQ 

  if( Param%Option%projection ) then
     call Force__calcL 
  end if

  call MPI__Allreduce_Force( Param%Data%vatom )

  return
end subroutine Force__calc

subroutine Force__calcNorm( norm )
  use ac_parameter
  use ac_mpi_module
  implicit none

  real(8), intent(out) :: norm
  integer :: a
  integer :: natom

  norm = 0.d0
  natom = 0
  if( .not. Param%Option%optimize ) return

  do a=1, Param%Data%natom
     if( .not. Param%Data%vatom(a)%optimize ) cycle

     norm = norm + dot_product( Param%Data%vatom(a)%force(:),Param%Data%vatom(a)%force(:) )
     natom = natom + 1
  end do

  if( natom > 0 ) then
     norm = norm/natom
  end if

  return
end subroutine Force__calcNorm

subroutine Force__show
  use ac_parameter
  use ac_mpi_module

  implicit none
  integer :: a 

  if( MPI%root ) then
     open(unit=60,file='force.dat')
     write(60,*) '--------------------------------------------------------------'
     write(60,*) '------------   Atoms:'
     write(60,*) '--------------------------------------------------------------'



     write(60,*) ' atom    Force'
     do a=1, Param%Data%natom
        write(60,933) a+1-1,Param%Data%vatom(a)%name, &
             Param%Data%vatom(a)%force(:)
     end do

     write(60,*) '--------------------------------------------------------------'
     write(60,*)
     close(60)
  end if
933 format(i4,'  ',a2,6f20.15)

  open(unit=16,file=Param%Option%file_ac_tempout,position='append')
  write(16,*) '--------------------------------------------------------------'
  write(16,*) '------------   Atoms:'
  write(16,*) '--------------------------------------------------------------'

  write(16,*) ' atom   Ro                            Force'
  do a=1, Param%Data%natom
     write(16,932) a+1-1,Param%Data%vatom(a)%name, &
          Param%Data%vatom(a)%Ro*AU_TO_AA, Param%Data%vatom(a)%force(:)
  end do

  write(16,*) '--------------------------------------------------------------'
  write(16,*)
932 format(i4,'  ',a2,6f10.5)
  close(16)

  return
end subroutine Force__show

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine iteration_ini

  use scf_negf
  use fft
  use dft
  use condition_ini
  use hamiltonian_sgf
  use hamiltonian_c
  use hamiltonian_temp
  use gf_se_c
  use constant
  use mod_mpi

  implicit none
  integer :: i1,i2,i3,ispin,ier,gn
  real(8) :: st1,st2,stdel
  real(8), allocatable :: temp_rho(:,:,:,:)
  complex(8), allocatable :: temp_rhols(:,:,:,:)

  open(unit=16,file=file_tempout,position='append')
  write(16,*) '++++++++++++ DM -> charge ...'
  close(16)

  open(unit=16,file=file_tempout,position='append')
  call myclock(st1)

  if( ispin_pol_scf < 4 ) then
     allocate(temp_rho(n_a,n_b,n_c,ispin_pol_scf),stat=ier)
  else
     allocate(temp_rhols(n_a,n_b,n_c,ispin_pol_scf),stat=ier)
  end if
  if( ier /= 0 ) then
     write(6,*) 'error allocate: dens_atom2cell_lr'
     stop
  end if

  do ispin=1,ispin_pol_scf
     do i1=1,n_a
        do i2=1,n_b
           do i3=1,n_c
              if( ispin_pol_scf < 4 ) then
                 temp_rho(i1,i2,i3,ispin)=0.d0
              else
                 temp_rhols(i1,i2,i3,ispin)=dcmplx(0.d0,0.d0)
              end if
           end do
        end do
     end do
  end do

  call Density__calc
  if( ispin_pol_scf < 4 ) then
     call Hamiltonian__calcD__acbas(temp_rho)
  else
     call Hamiltonian__calcD_ls__acbas(temp_rhols)
  end if

  do ispin=1,ispin_pol_scf
     do i1=0,n_a-1
        do i2=0,n_b-1
           do i3=0,n_c-1
              if( i3+1 > l_cell_l_bound .and. i3+1 < r_cell_l_bound ) then
                 gn=i1*n_b*n_c+i2*n_c+i3+1
                 if( ispin_pol_scf < 4 ) then
                    rho(gn,ispin)=temp_rho(i1+1,i2+1,i3+1,ispin)
                 else
                    rhols(gn,ispin)=temp_rhols(i1+1,i2+1,i3+1,ispin)
                 end if
              end if
           end do
        end do
     end do
  end do

  if( ispin_pol_scf < 4 ) then
     deallocate(temp_rho,stat=ier)
  else
     deallocate(temp_rhols,stat=ier)
  end if
  if( ier /= 0 ) then
     write(6,*) 'error allocate: dens_atom2cell_lr'
     stop
  end if

  call myclock(st2)
  stdel=st2-st1
  close(16)

  return
end subroutine iteration_ini

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Naoki WATANABE, Nobutaka NISHIKAWA (Mizuho I.R.)   @@ !
! @@             Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine ac_main( filename )
  use ac_misc_module
  use ac_mpi_module
  implicit none

  character(len=*), intent(in) :: filename

  call Param__read(filename)
  !!call Param__readMX(filename)

  call Param__setup(0)
  call Param__show

  if( Param%Option%optimize ) then

     if( Param%SCF%opt_iter_max == 0 ) then
        call ac_solve
        call Force__calc
        call Force__show
     else
        call ac_optimize
     end if
  else
     call ac_solve
  end if

  if( Param%Option%phonon ) then
     call ac_phonon
  end if

  if( Param%Band%fname /= "" ) then
     call Hamiltonian__calcBandMap
  end if

  if( Param%DOS%fname /= "" ) then
     call Hamiltonian__calcDOS
  end if

  if( Param%MO%fbase /= "" ) then
     call Hamiltonian__calcMO
  end if

  call Hamiltonian__deallocate

  call Potential__deallocate
  call Density__deallocate
  call Base__deallocate
  call Param__deallocate


  open(unit=16,file=Param%Option%file_ac_tempout,position='append')
  write(16,*)
  write(16,*) '******************** **************** ********************'
  write(16,*) '*                      output files                      *'
  write(16,*) '******************** **************** ********************'
  write(16,*)
  write(16,*) '          Chemical potential & Total energy -> energy.dat'
  write(16,*) '                               Energy level -> level_**.dat'
  write(16,*) '                             charge at site -> charge_per.dat'
  if( Param%Option%optimize ) then
     write(16,*) '                                 Force data -> force.dat'
     if( Param%SCF%opt_iter_max /= 0 ) then
        write(16,*) '                             Structure data -> structure.dat'
     end if
  end if
  write(16,*)
  write(16,*)
  write(16,*)
  write(16,*) ':-:-:-:-:-:-:-:-:-:-:-:-:-:-:-::-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:'
  write(16,*) ':-:-:-:-:-:-:-:-:-:-:-:-:-:-:-::-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:'
  write(16,*) ':-:-:-:-:-:-:-:-:                            :-:-:-:-:-:-:-:-:'
  write(16,*) ':-:-:-:-:-:-:-:-:           finished         :-:-:-:-:-:-:-:-:'
  write(16,*) ':-:-:-:-:-:-:-:-:                            :-:-:-:-:-:-:-:-:'
  write(16,*) ':-:-:-:-:-:-:-:-:-:-:-:-:-:-:-::-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:'
  write(16,*) ':-:-:-:-:-:-:-:-:-:-:-:-:-:-:-::-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:'
  write(16,*)
  close(16)

  return
end subroutine ac_main

subroutine ac_solve
  use ac_misc_module
  use ac_mpi_module
  implicit none

  call MPI__setup
  call Base__setup
  call Density__setup
  call Potential__setup
  call Hamiltonian__calcSCF

  return
end subroutine ac_solve

subroutine backupOptimizePosition
  use ac_misc_module
  implicit none

  integer :: a

  do a=0, Param%Data%natom-1
     Param%Data%vatom(a)%opt_position = Param%Data%vatom(a)%Ro
  end do

  return
end subroutine backupOptimizePosition

subroutine calcOptimizeDirectionSD( iter )
  use ac_misc_module
  implicit none

  integer, intent(in) :: iter
  integer :: a

  do a=1, Param%Data%natom
     if( .not. Param%Data%vatom(a)%optimize ) then
        Param%Data%vatom(a)%opt_direction = 0.d0
     else
        Param%Data%vatom(a)%opt_direction = Param%Data%vatom(a)%force
     end if
  end do

  return
end subroutine calcOptimizeDirectionSD

subroutine calcOptimizeDirectionCG( iter )
  use ac_misc_module
  implicit none

  integer, intent(in) :: iter
  integer :: a

  real(8) :: norm_force
  real(8), save :: norm_force_prev

  call Force__calcNorm(norm_force)

  if( iter == 1 ) then
     do a=1, Param%Data%natom
        if( .not. Param%Data%vatom(a)%optimize ) then
           Param%Data%vatom(a)%opt_direction = 0.d0
        else
           Param%Data%vatom(a)%opt_direction = Param%Data%vatom(a)%force
        end if
     end do
  else
     do a=1, Param%Data%natom
        if( .not. Param%Data%vatom(a)%optimize ) then
           Param%Data%vatom(a)%opt_direction = 0.d0
        else
           Param%Data%vatom(a)%opt_direction &
                = Param%Data%vatom(a)%opt_direction * (norm_force/norm_force_prev) + Param%Data%vatom(a)%force
        end if
     end do
  end if

  norm_force_prev = norm_force

  return
end subroutine calcOptimizeDirectionCG

subroutine calcOptimizeDirectionDIIS( iter )
  use ac_misc_module
  implicit none

  integer, intent(in) :: iter
  integer :: a
  real(8), allocatable :: matrix(:,:)
  real(8), allocatable :: alpha(:)
  integer, allocatable :: ipiv(:)
  real(8), allocatable :: work(:)
  integer :: n, m
  integer :: info

  if( Param%SCF%mix_start < Param%SCF%mix_history ) then
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,*) '      ++++++ Error!: too small mixing start for Pulay mixing'
     close(16)
     Param%SCF%mix_start = Param%SCF%mix_history
  end if

  if( iter==1 ) then
     do a=1, Param%Data%natom
        allocate( Param%Data%vatom(a)%force_past(3,Param%SCF%mix_history) )
     end do
  end if

  do n=Param%SCF%mix_history, 2, -1
     do a=1, Param%Data%natom
        Param%Data%vatom(a)%force_past(:,n)  = Param%Data%vatom(a)%force_past(:,n-1)
     end do
  end do
  do a=1, Param%Data%natom
     if( .not. Param%Data%vatom(a)%optimize ) then
        Param%Data%vatom(a)%force_past(:,1) = 0.d0
     else
        Param%Data%vatom(a)%force_past(:,1) = Param%Data%vatom(a)%force
     end if
  end do

  if( iter < Param%SCF%mix_history ) then
     do a=1, Param%Data%natom
        Param%Data%vatom(a)%opt_direction = Param%Data%vatom(a)%force_past(:,1)
     end do
  else
     allocate( matrix(Param%SCF%mix_history,Param%SCF%mix_history) )
     allocate( alpha(Param%SCF%mix_history) )
     allocate( ipiv(Param%SCF%mix_history) )
     allocate( work(4*Param%SCF%mix_history) )

     do n=1, Param%SCF%mix_history
        do m=n, Param%SCF%mix_history
           matrix(n,m) = 0.0d0
           do a=1, Param%Data%natom
              matrix(n,m) = matrix(n,m) &
                   + sum(Param%Data%vatom(a)%force_past(:,n) * Param%Data%vatom(a)%force_past(:,m))
           end do
        end do
     end do

     do n=1, Param%SCF%mix_history
        alpha(n) = 1.d0
     end do

     call dsysv( 'U', Param%SCF%mix_history, 1, matrix, &
          Param%SCF%mix_history, ipiv, alpha, &
          Param%SCF%mix_history, work, 4*Param%SCF%mix_history, info, 1 )

     alpha(:) = alpha(:)*(1.d0/sum(alpha(:)))

     do a=1, Param%Data%natom
        Param%Data%vatom(a)%opt_direction = 0.d0
     end do

     do a=1, Param%Data%natom
        if( .not. Param%Data%vatom(a)%optimize ) cycle

        do n=1, Param%SCF%mix_history
           Param%Data%vatom(a)%opt_direction = &
                Param%Data%vatom(a)%opt_direction &
                + Param%Data%vatom(a)%force_past(:,n) * alpha(n)
        end do
     end do

     deallocate( matrix )
     deallocate( alpha )
     deallocate( ipiv )
     deallocate( work )
  end if

  return
end subroutine calcOptimizeDirectionDIIS

subroutine moveOptimizeDirection( alpha )
  use ac_misc_module
  implicit none

  real(8), intent(in) :: alpha
  integer :: a

  do a=0, Param%Data%natom-1
     if( .not. Param%Data%vatom(a)%optimize ) cycle

     Param%Data%vatom(a)%Ro = &
          Param%Data%vatom(a)%opt_position + alpha * Param%Data%vatom(a)%opt_direction
  end do

  return
end subroutine moveOptimizeDirection

subroutine ac_optimize
  use ac_misc_module
  use ac_mpi_module
  implicit none

  integer :: a
  real(8) :: norm_force
  real(8) :: alpha, beta
  real(8) :: Ea, dEba, dEca
  integer :: iter

  open(unit=16,file=Param%Option%file_ac_tempout,position='append')
  write(16,*)
  write(16,*)
  write(16,*)
  write(16,*) '>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<'
  write(16,*) '>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<'
  write(16,*) '>>>>>>>>>>>> START OPTIMIZING GEOMETRIC STRUCTURE <<<<<<<<<<<<'
  write(16,*) '>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<'
  write(16,*) '>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<'
  write(16,*)
  close(16)

  alpha=0.d0
  beta=0.d0

  do iter=1, Param%SCF%opt_iter_max
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,*)
     write(16,*) '>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<'
     write(16,*) '>>>>>>>>>>>> iterations (optimize):',iter
     write(16,*) '>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<'
     close(16)

     call backupOptimizePosition

     call Param__Structure__show
     call ac_solve
     Ea = Energy%Etot

     call Force__calc
     call Force__show
     call Force__calcNorm(norm_force)

     norm_force = sqrt(norm_force)

     if( norm_force < Param%SCF%force_criterion ) then
        open(unit=16,file=Param%Option%file_ac_tempout,position='append')
        write(16,*)'   ### :: optimization :: converged #################################'
        write(16,973) Param%SCF%force_criterion,alpha,beta
973     format('    #ab###            ',f20.13,2f10.4,'  ###ba#')
        write(16,974) iter,norm_force,Ea
974     format('    #fc###       ',i5,f20.13,f20.6,'  ###cf#')
        write(16,*)'   ##################################################################'
        close(16)
        exit
     else
        open(unit=16,file=Param%Option%file_ac_tempout,position='append')
        write(16,*)'   ### :: optimization ##############################################'
        write(16,975) Param%SCF%force_criterion,alpha,beta
975     format('    #ab###            ',f20.13,2f10.4,'  ###ba#')
        write(16,976) iter,norm_force,Ea
        write(16,*)'   ##################################################################'
976     format('    #fn###       ',i5,f20.13,f20.6,'  ###nf#')
        close(16)
     end if

     select case( Param%Option%optimize_method )
     case('sd')
        call calcOptimizeDirectionSD( iter )
     case('cg')
        call calcOptimizeDirectionCG( iter )
     case('diis')
        call calcOptimizeDirectionDIIS( iter )
     end select

     alpha = 0.10d0 / norm_force

100  continue

     call moveOptimizeDirection( alpha )

     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,*)
     write(16,*) '>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<'
     close(16)
     call ac_solve
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,*) '>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<'
     write(16,*)
     close(16)
     dEba = Energy%Etot - Ea
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,978) alpha*norm_force,dEba
978  format('   **ea1**   point B: ',f20.13,f20.6,'  **1ae**')
     close(16)

     if( dEba > 0.0d0 ) then
        alpha = alpha*0.25d0
        open(unit=16,file=Param%Option%file_ac_tempout,position='append')
        write(16,*) '>>>>>>>>>>>>>>>>>>>>>>>>>> retry B <<<<<<<<<<<<<<<<<<<<<<<<<<<'
        close(16)
        goto 100
     end if

     call moveOptimizeDirection( alpha*2.0d0 )

     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,*)
     write(16,*) '>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<'
     close(16)
     call ac_solve
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,*) '>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<'
     write(16,*)
     close(16)
     dEca = Energy%Etot - Ea
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,977) alpha*2.0d0*norm_force,dEca
977  format('   **ea2**   point C: ',f20.13,f20.6,'  **2ae**')
     close(16)

     if( dEca < 2*dEba ) then
        alpha = alpha*4.00d0
        open(unit=16,file=Param%Option%file_ac_tempout,position='append')
        write(16,*) '>>>>>>>>>>>>>>>>>>>>>>>>>> retry C <<<<<<<<<<<<<<<<<<<<<<<<<<<'
        close(16)
        goto 100
     end if

     beta = 0.5d0 * (dEca-4.0d0*dEba)/(dEca-2.0d0*dEba)

     if( beta > 4.0d0 ) then
        alpha = alpha*4.00d0
        open(unit=16,file=Param%Option%file_ac_tempout,position='append')
        write(16,*) '>>>>>>>>>>>>>>>>>>>>>>>>>> retry D <<<<<<<<<<<<<<<<<<<<<<<<<<<'
        close(16)
        goto 100
     end if

     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,979) alpha*beta*norm_force,beta
979  format('   **mov**        D : ',f20.13,f20.6,'  **mov**')
     close(16)
     call moveOptimizeDirection( alpha*beta )

  end do

  if( norm_force < Param%SCF%force_criterion ) then
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,*)
     write(16,*)
     write(16,*)
     write(16,*) '>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<'
     write(16,*) '>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<'
     write(16,*) '>>>>>>>>>> FINISHED: OPTIMIZING GEOMETRIC STRUCTURE <<<<<<<<<<'
     write(16,*) '>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<'
     write(16,*) '>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<'
     write(16,*)
     close(16)
  else
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,*)
     write(16,*)
     write(16,*)
     write(16,*) '>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<'
     write(16,*) '>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<'
     write(16,*) '>>>>>>>>>> FINISHED     :: not yet converged ::     <<<<<<<<<<'
     write(16,*) '>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<'
     write(16,*) '>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<'
     write(16,*)
     close(16)
  end if

  return
end subroutine ac_optimize

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@             Nobutaka NISHIKAWA (Mizuho I.R.)                   @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine set_scf_accel

  use scf_negf
  use hamiltonian_sgf
  use hamiltonian_c
  use hamiltonian_temp
  use constant
  use mod_mpi


  implicit none
  real(8) :: tempr,tempi,tempr1,tempi1
  real(8) :: temp,omega_del_temp,omega_ef_temp,min_level_temp
  integer :: i_do,i1_do,i2_do,i3_do,i_hartree_temp,ispin_pol_scf_temp
  integer :: i_bios_minomega,i_omega_switch,i_omega_switch2
  integer :: itemp_ka_l,itemp_kb_l,itemp_ka_r,itemp_kb_r

  call set_scf_general(i_omega_switch,i_omega_switch2,omega_del_temp           &
       ,omega_ef_temp)


  call Param__read__ASCOT(file_parameter_ham_pot)

  call alo_scf_negf_parameter_1
  call Param__setup(1)
  call Param__setup__ASCOT

  call MPI__setup_ASCOT

  call Base__setup
  call Base__setup__ASCOT
  call alo_scf_accel_parameter
  call alo_potential

  call Param__show__ASCOT

  call Density__setup
  call Density__setup__ASCOT

  call Potential__setup
  call Potential__setup__ASCOT

  call h_v_atom
  call Hamiltonian__setup
  call Hamiltonian__setup__ASCOT                                               &
       (num_atom_scf,param_cell_nl,hv_atom_matrix,n_v_atom_matrix,n_v_nim_max)
  call Hamiltonian__loadAM_ASCOT

  call set_ham_negf_c1(file_parameter_hc_scf)
  call set_ham_negf_l(file_parameter_hl_scf,v_scf_l,i_rotspin_l)
  call set_ham_negf_r(file_parameter_hr_scf,v_scf_r,i_rotspin_r)

  open(unit=16,file=file_tempout,position='append')
  write(16,*)
  write(16,*) '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'
  write(16,*) '++++++++++++ calculating overlap and kinetic matrices ...'
  close(16)

  call AtomMatrix__calcSK

  if( param_option_projection == 'on' ) then
     open(unit=16,file=file_tempout,position='append')
     write(16,*) '++++++++++++ calculating local pseudo potential matrices ...'
     close(16)
     call AtomMatrix__calcL
  end if
  open(unit=16,file=file_tempout,position='append')
  write(16,*) '++++++++++++ calculating nonlocal psudo potential matrices ...'
  close(16)
  call AtomMatrix__calcN
  open(unit=16,file=file_tempout,position='append')
  write(16,*) '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'
  write(16,*)
  close(16)

  if( (i_rotspin_l == 1 .or. i_rotspin_r == 1) .and. ispin_pol_scf == 2 ) then
     call Hamiltonian__rotAM_ASCOT
  end if

  call Potential__deallocate2
  call Base__deallocate2

  do i1_do=1, num_atom_scf
     sum_charge(i1_do)=vatom_q(i1_do)
  end do

  if( spin_ll /= ispin_pol_scf ) then
     write(6,*) 'error: spin_ll(set_scf_accel)',spin_ll,ispin_pol_scf
     stop
  end if
  if( spin_rr /= ispin_pol_scf ) then
     write(6,*) 'error: spin_rr(set_scf_accel)',spin_rr,ispin_pol_scf
     stop
  end if


  open(unit=19,file=file_parameter_cv1_pot)

  read(19,*) ispin_pol_scf_temp
  read(19,*)
  read(19,*)
  read(19,*)
  read(19,*)
  read(19,*)
  read(19,*)

  if( ispin_pol_scf_temp+1 /= ispin_pol_scf ) then
     write(*,*) 'error: spin_vh'
     close(19)
     stop
  end if

  read(19,*)
  read(19,*) cp_scf_c
  read(19,*) min_level_c
  read(19,*)
  do i1_do=0,n_a-1
     do i2_do=0,n_b-1
        do i3_do=0,n_c-1
           read(19,*) v_hartree(i1_do*n_b*n_c+i2_do*n_c+i3_do+1)
        end do
     end do
  end do
  read(19,*)
  do i1_do=0,n_a-1
     do i2_do=0,n_b-1
        do i3_do=0,n_c-1
           if( ispin_pol_scf == 1 ) then
              read(19,*) temp
              v_tot(i1_do*n_b*n_c+i2_do*n_c+i3_do+1,1)=temp
           else
              if( ispin_pol_scf == 2 ) then
                 read(19,*) tempr,tempi
                 v_tot(i1_do*n_b*n_c+i2_do*n_c+i3_do+1,1)=tempr
                 v_tot(i1_do*n_b*n_c+i2_do*n_c+i3_do+1,2)=tempi
                 if( i_rotspin_l /= 0                                             &
                      .and. i3_do < n_c*shift_cell_l1/shift_cell_l2 ) then
                    v_tot(i1_do*n_b*n_c+i2_do*n_c+i3_do+1,2)=tempr
                    v_tot(i1_do*n_b*n_c+i2_do*n_c+i3_do+1,1)=tempi
                 end if
                 if( i_rotspin_r /= 0                                             &
                      .and. i3_do >= n_c*shift_cell_l1/shift_cell_l2 ) then
                    v_tot(i1_do*n_b*n_c+i2_do*n_c+i3_do+1,2)=tempr
                    v_tot(i1_do*n_b*n_c+i2_do*n_c+i3_do+1,1)=tempi
                 end if
              else
                 read(19,*) tempr,tempi,tempr1,tempi1
                 v_tot(i1_do*n_b*n_c+i2_do*n_c+i3_do+1,1)=tempr
                 v_tot(i1_do*n_b*n_c+i2_do*n_c+i3_do+1,2)=tempi
                 v_tot(i1_do*n_b*n_c+i2_do*n_c+i3_do+1,3)=tempr1
                 v_tot(i1_do*n_b*n_c+i2_do*n_c+i3_do+1,4)=tempi1
              end if
           end if
        end do
     end do
  end do
  read(19,*)
  do i1_do=0,n_a-1
     do i2_do=0,n_b-1
        do i3_do=0,n_c-1
           if( ispin_pol_scf == 1 ) then
              read(19,*) temp
              rho_temp(i1_do*n_b*n_c+i2_do*n_c+i3_do+1,1)=temp
           else
              if( ispin_pol_scf == 2 ) then
                 read(19,*) tempr,tempi
                 rho_temp(i1_do*n_b*n_c+i2_do*n_c+i3_do+1,1)=tempr
                 rho_temp(i1_do*n_b*n_c+i2_do*n_c+i3_do+1,2)=tempi
                 if( i_rotspin_l /= 0                                             &
                      .and. i3_do < n_c*shift_cell_l1/shift_cell_l2 ) then
                    rho_temp(i1_do*n_b*n_c+i2_do*n_c+i3_do+1,2)=tempr
                    rho_temp(i1_do*n_b*n_c+i2_do*n_c+i3_do+1,1)=tempi
                 end if
                 if( i_rotspin_r /= 0                                             &
                      .and. i3_do >= n_c*shift_cell_l1/shift_cell_l2 ) then
                    rho_temp(i1_do*n_b*n_c+i2_do*n_c+i3_do+1,2)=tempr
                    rho_temp(i1_do*n_b*n_c+i2_do*n_c+i3_do+1,1)=tempi
                 end if
              else
                 read(19,*) tempr,tempi,tempr1,tempi1
                 rhols_temp(i1_do*n_b*n_c+i2_do*n_c+i3_do+1,1)                    &
                      =dcmplx(tempr,tempi)
                 rhols_temp(i1_do*n_b*n_c+i2_do*n_c+i3_do+1,2)                    &
                      =dcmplx(tempr1,tempi1)
                 read(19,*) tempr,tempi,tempr1,tempi1
                 rhols_temp(i1_do*n_b*n_c+i2_do*n_c+i3_do+1,3)                    &
                      =dcmplx(tempr,tempi)
                 rhols_temp(i1_do*n_b*n_c+i2_do*n_c+i3_do+1,4)                    &
                      =dcmplx(tempr1,tempi1)
              end if
           end if
        end do
     end do
  end do

  close(19)


  open(unit=19,file=file_parameter_lv1_scf,status='old')

  read(19,*) ispin_pol_scf_l,itemp_ka_l,itemp_kb_l
  read(19,*)
  read(19,*) n_a_l,n_b_l,n_c_l
  read(19,*)

  ispin_pol_scf_l=ispin_pol_scf_l+1

  if( ispin_pol_scf_l /= ispin_pol_scf ) then
     write(*,*) 'error: spin_vh_l'
     close(19)
     stop
  end if

  if( n_a_l /= n_a ) then
     open(unit=36,file=file_tempout,position='append')
     write(36,*) '          n_a_l /= n_a:'
     write(36,*) '               n_a_l=',n_a_l,'n_a=',n_a
     close(36)
  end if
  if( n_b_l /= n_b ) then
     open(unit=36,file=file_tempout,position='append')
     write(36,*) '          n_b_l /= n_b:'
     write(36,*) '               n_b_l=',n_b_l,'n_b=',n_b
     close(36)
  end if

  call alo_potential_l

  read(19,*) cell_labc_l(1,1),cell_labc_l(1,2),cell_labc_l(1,3)
  read(19,*) cell_labc_l(2,1),cell_labc_l(2,2),cell_labc_l(2,3)
  read(19,*) cell_labc_l(3,1),cell_labc_l(3,2),cell_labc_l(3,3)

  call bound_cell_lr_l

  i_hartree_temp=l_cell_l_bound_l-1

  read(19,*)
  read(19,*) cp_scf_l
  read(19,*) min_level_l

  read(19,*)
  do i1_do=0,n_a_l-1
     do i2_do=0,n_b_l-1
        do i3_do=0,n_c_l-1
           read(19,*) tempr
           if( scf_bias /= 'off' ) then
              tempr=tempr+v_scf_l/ene_scale
           end if
           vh_temp_l(i1_do*n_b_l*n_c_l+i2_do*n_c_l+i3_do+1)=tempr
           if( i3_do == i_hartree_temp ) then
              vh_l(i1_do*n_b_l+i2_do+1)=tempr
           end if
        end do
     end do
  end do
  read(19,*)
  do i1_do=0,n_a_l-1
     do i2_do=0,n_b_l-1
        do i3_do=0,n_c_l-1
           if( ispin_pol_scf_l == 1 ) then
              read(19,*) tempr
              if( scf_bias /= 'off' ) then
                 tempr=tempr+v_scf_l/ene_scale
              end if
              v_tot_l(i1_do*n_b_l*n_c_l+i2_do*n_c_l+i3_do+1,1)=tempr
              if( i3_do == i_hartree_temp ) then
                 v0_l(i1_do*n_b_l+i2_do+1,1)=tempr
              end if
           else
              if( ispin_pol_scf_l == 2 ) then
                 read(19,*) tempr,tempi
                 if( scf_bias /= 'off' ) then
                    tempr=tempr+v_scf_l/ene_scale
                    tempi=tempi+v_scf_l/ene_scale
                 end if
                 if( i_rotspin_l == 0 ) then
                    v_tot_l(i1_do*n_b_l*n_c_l+i2_do*n_c_l+i3_do+1,1)=tempr
                    v_tot_l(i1_do*n_b_l*n_c_l+i2_do*n_c_l+i3_do+1,2)=tempi
                    if( i3_do == i_hartree_temp ) then
                       v0_l(i1_do*n_b_l+i2_do+1,1)=tempr
                       v0_l(i1_do*n_b_l+i2_do+1,2)=tempi
                    end if
                 else
                    v_tot_l(i1_do*n_b_l*n_c_l+i2_do*n_c_l+i3_do+1,2)=tempr
                    v_tot_l(i1_do*n_b_l*n_c_l+i2_do*n_c_l+i3_do+1,1)=tempi
                    if( i3_do == i_hartree_temp ) then
                       v0_l(i1_do*n_b_l+i2_do+1,2)=tempr
                       v0_l(i1_do*n_b_l+i2_do+1,1)=tempi
                    end if
                 end if
              else
                 read(19,*) tempr,tempi,tempr1,tempi1
                 if( scf_bias /= 'off' ) then
                    tempr=tempr+v_scf_l/ene_scale
                    tempi1=tempi1+v_scf_l/ene_scale
                 end if
                 v_tot_l(i1_do*n_b_l*n_c_l+i2_do*n_c_l+i3_do+1,1)=tempr
                 v_tot_l(i1_do*n_b_l*n_c_l+i2_do*n_c_l+i3_do+1,2)=tempi
                 v_tot_l(i1_do*n_b_l*n_c_l+i2_do*n_c_l+i3_do+1,3)=tempr1
                 v_tot_l(i1_do*n_b_l*n_c_l+i2_do*n_c_l+i3_do+1,4)=tempi1
                 if( i3_do == i_hartree_temp ) then
                    v0_l(i1_do*n_b_l+i2_do+1,1)=tempr
                    v0_l(i1_do*n_b_l+i2_do+1,2)=tempi
                    v0_l(i1_do*n_b_l+i2_do+1,3)=tempr1
                    v0_l(i1_do*n_b_l+i2_do+1,4)=tempi1
                 end if
              end if
           end if
        end do
     end do
  end do
  read(19,*)
  do i1_do=0,n_a_l-1
     do i2_do=0,n_b_l-1
        do i3_do=0,n_c_l-1
           if( ispin_pol_scf_l == 1 ) then
              read(19,*) tempr
              den_l(i1_do*n_b_l*n_c_l+i2_do*n_c_l+i3_do+1,1)=tempr
           else
              if( ispin_pol_scf_l == 2 ) then
                 read(19,*) tempr,tempi
                 if( i_rotspin_l == 0 ) then
                    den_l(i1_do*n_b_l*n_c_l+i2_do*n_c_l+i3_do+1,1)=tempr
                    den_l(i1_do*n_b_l*n_c_l+i2_do*n_c_l+i3_do+1,2)=tempi
                 else
                    den_l(i1_do*n_b_l*n_c_l+i2_do*n_c_l+i3_do+1,2)=tempr
                    den_l(i1_do*n_b_l*n_c_l+i2_do*n_c_l+i3_do+1,1)=tempi
                 end if
              else
                 read(19,*) tempr,tempi,tempr1,tempi1
                 denls_l(i1_do*n_b_l*n_c_l+i2_do*n_c_l+i3_do+1,1)                 &
                      =dcmplx(tempr,tempi)
                 denls_l(i1_do*n_b_l*n_c_l+i2_do*n_c_l+i3_do+1,2)                 &
                      =dcmplx(tempr1,tempi1)
                 read(19,*) tempr,tempi,tempr1,tempi1
                 denls_l(i1_do*n_b_l*n_c_l+i2_do*n_c_l+i3_do+1,3)                 &
                      =dcmplx(tempr,tempi)
                 denls_l(i1_do*n_b_l*n_c_l+i2_do*n_c_l+i3_do+1,4)                 &
                      =dcmplx(tempr1,tempi1)
              end if
           end if
        end do
     end do
  end do

  close(19)

  open(unit=19,file=file_parameter_rv1_scf,status='old')

  read(19,*) ispin_pol_scf_r,itemp_ka_r,itemp_kb_r
  read(19,*)
  read(19,*) n_a_r,n_b_r,n_c_r
  read(19,*)

  ispin_pol_scf_r=ispin_pol_scf_r+1

  if( ispin_pol_scf_r /= ispin_pol_scf ) then
     write(*,*) 'error: spin_vh_r'
     close(19)
     stop
  end if

  if( n_a_r /= n_a ) then
     open(unit=36,file=file_tempout,position='append')
     write(36,*) '          n_a_r /= n_a:'
     write(36,*) '               n_a_r=',n_a_r,'n_a=',n_a
     close(36)
  end if
  if( n_b_r /= n_b ) then
     open(unit=36,file=file_tempout,position='append')
     write(36,*) '          n_b_r /= n_b:'
     write(36,*) '               n_b_r=',n_b_r,'n_b=',n_b
     close(36)
  end if

  call alo_potential_r

  read(19,*) cell_labc_r(1,1),cell_labc_r(1,2),cell_labc_r(1,3)
  read(19,*) cell_labc_r(2,1),cell_labc_r(2,2),cell_labc_r(2,3)
  read(19,*) cell_labc_r(3,1),cell_labc_r(3,2),cell_labc_r(3,3)

  call bound_cell_lr_r

  i_hartree_temp=r_cell_l_bound_r-1

  read(19,*)
  read(19,*) cp_scf_r
  read(19,*) min_level_r

  read(19,*)
  do i1_do=0,n_a_r-1
     do i2_do=0,n_b_r-1
        do i3_do=0,n_c_r-1
           read(19,*) tempr
           if( scf_bias /= 'off' ) then
              tempr=tempr+v_scf_r/ene_scale
           end if
           vh_temp_r(i1_do*n_b_r*n_c_r+i2_do*n_c_r+i3_do+1)=tempr
           if( i3_do == i_hartree_temp ) then
              vh_r(i1_do*n_b_r+i2_do+1)=tempr
           end if
        end do
     end do
  end do
  read(19,*)
  do i1_do=0,n_a_r-1
     do i2_do=0,n_b_r-1
        do i3_do=0,n_c_r-1
           if( ispin_pol_scf_r == 1 ) then
              read(19,*) tempr
              if( scf_bias /= 'off' ) then
                 tempr=tempr+v_scf_r/ene_scale
              end if
              v_tot_r(i1_do*n_b_r*n_c_r+i2_do*n_c_r+i3_do+1,1)=tempr
              if( i3_do == i_hartree_temp ) then
                 v0_r(i1_do*n_b_r+i2_do+1,1)=tempr
              end if
           else
              if( ispin_pol_scf_r == 2 ) then
                 read(19,*) tempr,tempi
                 if( scf_bias /= 'off' ) then
                    tempr=tempr+v_scf_r/ene_scale
                    tempi=tempi+v_scf_r/ene_scale
                 end if
                 if( i_rotspin_r == 0 ) then
                    v_tot_r(i1_do*n_b_r*n_c_r+i2_do*n_c_r+i3_do+1,1)=tempr
                    v_tot_r(i1_do*n_b_r*n_c_r+i2_do*n_c_r+i3_do+1,2)=tempi
                    if( i3_do == i_hartree_temp ) then
                       v0_r(i1_do*n_b_r+i2_do+1,1)=tempr
                       v0_r(i1_do*n_b_r+i2_do+1,2)=tempi
                    end if
                 else
                    v_tot_r(i1_do*n_b_r*n_c_r+i2_do*n_c_r+i3_do+1,2)=tempr
                    v_tot_r(i1_do*n_b_r*n_c_r+i2_do*n_c_r+i3_do+1,1)=tempi
                    if( i3_do == i_hartree_temp ) then
                       v0_r(i1_do*n_b_r+i2_do+1,2)=tempr
                       v0_r(i1_do*n_b_r+i2_do+1,1)=tempi
                    end if
                 end if
              else
                 read(19,*) tempr,tempi,tempr1,tempi1
                 if( scf_bias /= 'off' ) then
                    tempr=tempr+v_scf_r/ene_scale
                    tempi1=tempi1+v_scf_r/ene_scale
                 end if
                 v_tot_r(i1_do*n_b_r*n_c_r+i2_do*n_c_r+i3_do+1,1)=tempr
                 v_tot_r(i1_do*n_b_r*n_c_r+i2_do*n_c_r+i3_do+1,2)=tempi
                 v_tot_r(i1_do*n_b_r*n_c_r+i2_do*n_c_r+i3_do+1,3)=tempr1
                 v_tot_r(i1_do*n_b_r*n_c_r+i2_do*n_c_r+i3_do+1,4)=tempi1
                 if( i3_do == i_hartree_temp ) then
                    v0_r(i1_do*n_b_r+i2_do+1,1)=tempr
                    v0_r(i1_do*n_b_r+i2_do+1,2)=tempi
                    v0_r(i1_do*n_b_r+i2_do+1,3)=tempr1
                    v0_r(i1_do*n_b_r+i2_do+1,4)=tempi1
                 end if
              end if
           end if
        end do
     end do
  end do
  read(19,*)
  do i1_do=0,n_a_r-1
     do i2_do=0,n_b_r-1
        do i3_do=0,n_c_r-1
           if( ispin_pol_scf_r == 1 ) then
              read(19,*) tempr
              den_r(i1_do*n_b_r*n_c_r+i2_do*n_c_r+i3_do+1,1)=tempr
           else
              if( ispin_pol_scf_r == 2 ) then
                 read(19,*) tempr,tempi
                 if( i_rotspin_r == 0 ) then
                    den_r(i1_do*n_b_r*n_c_r+i2_do*n_c_r+i3_do+1,1)=tempr
                    den_r(i1_do*n_b_r*n_c_r+i2_do*n_c_r+i3_do+1,2)=tempi
                 else
                    den_r(i1_do*n_b_r*n_c_r+i2_do*n_c_r+i3_do+1,2)=tempr
                    den_r(i1_do*n_b_r*n_c_r+i2_do*n_c_r+i3_do+1,1)=tempi
                 end if
              else
                 read(19,*) tempr,tempi,tempr1,tempi1
                 denls_r(i1_do*n_b_r*n_c_r+i2_do*n_c_r+i3_do+1,1)                 &
                      =dcmplx(tempr,tempi)
                 denls_r(i1_do*n_b_r*n_c_r+i2_do*n_c_r+i3_do+1,2)                 &
                      =dcmplx(tempr1,tempi1)
                 read(19,*) tempr,tempi,tempr1,tempi1
                 denls_r(i1_do*n_b_r*n_c_r+i2_do*n_c_r+i3_do+1,3)                 &
                      =dcmplx(tempr,tempi)
                 denls_r(i1_do*n_b_r*n_c_r+i2_do*n_c_r+i3_do+1,4)                 &
                      =dcmplx(tempr1,tempi1)
              end if
           end if
        end do
     end do
  end do

  close(19)

  if( ka_scf*kb_scf == 0 ) then
     ka_scf=max0(itemp_ka_l,itemp_ka_r)
     kb_scf=max0(itemp_kb_l,itemp_kb_r)
  end if

  call make_scf_ksampling_scf


  call set_bound_cell_lr
  call make_cell_lr


  if( dabs(cp_scf_l-cp_scf_r) > 1.d-10 ) then
     open(unit=36,file=file_tempout,position='append')
     write(36,*)
     write(36,*) '         ###################################################'
     write(36,*) '         #####         cp_scf_l =',cp_scf_l
     write(36,*) '         #####         cp_scf_r =',cp_scf_r
     if( sw_shift_chem == 'on' ) then
        write(36,*) '         ##### cp_scf_r <- cp_scf_l'
        write(36,*) '         #####         shift_chem :: V & H'
        call shift_chem
     else
        if( cp_scf_l > cp_scf_r ) then
           write(36,*) '         ##### cp <- cp_scf_r'
        else
           write(36,*) '         ##### cp <- cp_scf_l'
        end if
     end if
     write(36,*) '         ###################################################'
     close(36)
  end if


  if( scf_bias /= 'off' ) then
     cp_l=cp_scf_l*ene_scale+v_scf_l
     cp_r=cp_scf_r*ene_scale+v_scf_r
  else
     cp_l=cp_scf_l*ene_scale
     cp_r=cp_scf_r*ene_scale
  end if

  if( method_sum_om_scf == 1 ) then
     min_level_temp=min_level_c
     if( min_level_temp > min_level_l ) then
        min_level_temp=min_level_l
     end if
     if( min_level_temp > min_level_r ) then
        min_level_temp=min_level_r
     end if
     if( i_omega_switch == 1 ) then
        omega_if_scf(1,1)=min_level_temp*ene_scale-dabs(omega_del_temp)
     else
        if( i_omega_switch == 0 ) then
           if( omega_del_temp > min_level_temp*ene_scale ) then
              write(*,*) 'stop: omega_del_temp',omega_del_temp                     &
                   ,min_level_temp*ene_scale
              stop
           end if
           omega_if_scf(1,1)=omega_del_temp
        else
           write(*,*) 'stop: i_omega_switch'
           stop
        end if
     end if
     i_bios_minomega=1
     do i_do=1,om_block_num_scf
        if( omega_if_scf(i_do,2) < omega_if_scf(i_do,1) ) then
           write(*,*) 'stop: omega_if_scf(2) < omega_if_scf(1)'
           stop
        end if
        if( omega_if_scf(i_bios_minomega,2) < omega_if_scf(i_do,2) ) then
           i_bios_minomega=i_do
        end if
     end do
     if( cp_l > cp_r ) then
        omega_if_scf(i_bios_minomega,2)=cp_r
     else
        omega_if_scf(i_bios_minomega,2)=cp_l
     end if
     if( scf_bias /= 'off' ) then
        omega_if_scf(i_bios_minomega,2)                                          &
             =omega_if_scf(i_bios_minomega,2)-om_del_bias
     end if
     call make_scf_omega_c1(i_bios_minomega,cp_l,cp_r)
  else
     if( method_sum_om_scf == 2 ) then
        min_level_temp=min_level_c
        if( min_level_temp > min_level_l ) then
           min_level_temp=min_level_l
        end if
        if( min_level_temp > min_level_r ) then
           min_level_temp=min_level_r
        end if
        if( i_omega_switch == 1 ) then
           omega_if_scf(1,1)=min_level_temp*ene_scale-dabs(omega_del_temp)
        else
           if( i_omega_switch == 0 ) then
              if( omega_del_temp > min_level_temp*ene_scale ) then
                 write(*,*) 'stop: omega_del_temp',omega_del_temp                   &
                      ,min_level_temp*ene_scale
                 stop
              end if
              omega_if_scf(1,1)=omega_del_temp
           else
              write(*,*) 'stop: i_omega_switch'
              stop
           end if
        end if
        if( cp_l > cp_r ) then
           min_level_temp=cp_l
        else
           min_level_temp=cp_r
        end if
        if( i_omega_switch2 == 1 ) then
           omega_if_scf(1,2)=min_level_temp+dabs(omega_ef_temp)
        else
           if( i_omega_switch2 == 0 ) then
              if( omega_ef_temp < min_level_temp ) then
                 write(*,*) 'stop: omega_ef_temp',omega_ef_temp,min_level_temp
                 stop
              end if
              omega_if_scf(1,2)=omega_ef_temp
           else
              write(*,*) 'stop: i_omega_switch2'
              stop
           end if
        end if
        i_bios_minomega=1
        call make_scf_omega_c2(cp_l,cp_r)
     else
        write(*,*) 'stop: omega method'
        stop
     end if
  end if


  open(unit=36,file=file_tempout,position='append')
  write(36,*)
  write(36,*)
  write(36,980) res_bound_l*dis_scale
  write(36,981) res_bound_r*dis_scale
  write(36,*)
  write(36,982) atom_parlay_l
  write(36,983) atom_parlay_r
  write(36,*)
  write(36,984) l_cell_l_bound
  write(36,985) r_cell_l_bound
  write(36,*)
  write(36,*)
  close(36)

980 format('         *****  bulk  boundary ( left):',f11.6,'  *****')
981 format('         *****  bulk  boundary (right):',f11.6,'  *****')
982 format('         *****  bulk atom num. ( left):',i11,'  *****')
983 format('         *****  bulk atom num. (right):',i11,'  *****')
984 format('         *****  bulk c_lr num. ( left):',i11,'  *****')
985 format('         *****  bulk c_lr num. (right):',i11,'  *****')

  return
end subroutine set_scf_accel

subroutine shift_chem

  use scf_negf
  use hamiltonian_sgf
  use hamiltonian_c
  use hamiltonian_temp
  use constant
  use mod_mpi

  use ac_mpi_module

  implicit none
  integer :: a,b,l,i1,j1,i1_do,i2_do,i3_do,ispin

  do a=MPI%rankE+1,natom_ac_rt,MPI%sizeE
     do l=1,nl_ac_r
        do b=1,natom_ac_rt
           if( i_over_r(b,a,l) == 1 ) then
              cycle
           end if
           do i1=1,i_orb_r(a)
              do j1=1,i_orb_r(b)
                 if( spin_rr == 1 ) then
                    ht_hs_r(b,a,l)%h(1,j1,i1)=ht_hs_r(b,a,l)%h(1,j1,i1)              &
                         +(cp_scf_l-cp_scf_r)*ht_hs_r(b,a,l)%s(j1,i1)
                 else
                    ht_hs_r(b,a,l)%h(1,j1,i1)=ht_hs_r(b,a,l)%h(1,j1,i1)              &
                         +(cp_scf_l-cp_scf_r)*ht_hs_r(b,a,l)%s(j1,i1)
                    ht_hs_r(b,a,l)%h(2,j1,i1)=ht_hs_r(b,a,l)%h(2,j1,i1)              &
                         +(cp_scf_l-cp_scf_r)*ht_hs_r(b,a,l)%s(j1,i1)
                 end if
              end do
           end do
        end do
     end do
  end do

  do i1_do=0,n_a_r-1
     do i2_do=0,n_b_r-1
        do i3_do=0,n_c_r-1
           vh_temp_r(i1_do*n_b_r*n_c_r+i2_do*n_c_r+i3_do+1)                       &
                =vh_temp_r(i1_do*n_b_r*n_c_r+i2_do*n_c_r+i3_do+1)             &
                +(cp_scf_l-cp_scf_r)
           if( i3_do == r_cell_l_bound_r-1 ) then
              vh_r(i1_do*n_b_r+i2_do+1)                                            &
                   =vh_temp_r(i1_do*n_b_r*n_c_r+i2_do*n_c_r+i3_do+1)
           end if
        end do
     end do
  end do
  do i1_do=0,n_a_r-1
     do i2_do=0,n_b_r-1
        do i3_do=0,n_c_r-1
           do ispin=1,ispin_pol_scf_r
              v_tot_r(i1_do*n_b_r*n_c_r+i2_do*n_c_r+i3_do+1,ispin)                 &
                   =v_tot_r(i1_do*n_b_r*n_c_r+i2_do*n_c_r+i3_do+1,ispin)         &
                   +(cp_scf_l-cp_scf_r)
              if( i3_do == r_cell_l_bound_r-1 ) then
                 v0_r(i1_do*n_b_r+i2_do+1,ispin)                                    &
                      =v_tot_r(i1_do*n_b_r*n_c_r+i2_do*n_c_r+i3_do+1,ispin)
              end if
           end do
        end do
     end do
  end do

  min_level_r=min_level_r+(cp_scf_l-cp_scf_r)
  cp_scf_r=cp_scf_l

  return
end subroutine shift_chem

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine set_hami_c_ll(px,py)

  use condition_ini
  use hamiltonian_sgf
  use locate_atom
  use hamiltonian_c

  implicit none
  integer, intent(in) :: px,py

  integer :: max_atom_orbital
  complex(8), allocatable :: h_ijmn(:,:),s_ijmn(:,:)

  integer :: kx,ky,lx,ly
  integer :: ier
  integer :: i1_do,i3_do,i4_do,i5_do
  integer :: i1_count,i2_count,j2_count,num_unit_temp1,num_unit_temp2
  integer :: num_unit_temp11,num_unit_temp12,num_unit_temp21,num_unit_temp22
  integer :: jr_do
  real(8) :: r_per_temp(3)
  real(8) :: cs,sn
  real(8) :: pai

  max_atom_orbital=0
  do i1_do=1,num_atom_kind_ini
     if( max_atom_orbital < atom_orbital_ini(i1_do) ) then
        max_atom_orbital=atom_orbital_ini(i1_do)
     end if
  end do

  allocate(h_ijmn(max_atom_orbital,max_atom_orbital)                           &
       ,s_ijmn(max_atom_orbital,max_atom_orbital),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: set_hami_c_ll'
     stop
  end if

  !                       ------------------------------------                       !

  pai=datan(1.d0)*4.d0

  !                       ------------------------------------                       !

  if( p_or_f_l == 'free' ) then
     num_unit_temp1=num_unit_r(1)
     num_unit_temp2=num_unit_r(2)
     num_unit_temp11=0
     num_unit_temp12=0
     num_unit_temp21=num_unit_l(1)-1
     num_unit_temp22=num_unit_l(2)-1
  else
     if( p_or_f_l == 'periodic' ) then
        num_unit_temp1=1
        num_unit_temp2=1
        num_unit_temp11=-neighbor_x_max_l
        num_unit_temp12=-neighbor_y_max_l
        num_unit_temp21=neighbor_x_max_l
        num_unit_temp22=neighbor_y_max_l
     else
        write(6,*) 'error_locate: set_hami_c_ll'
        stop
     end if
  end if

  j2_count=0
  do lx=1,num_unit_temp1
     do ly=1,num_unit_temp2
        do i5_do=1,num_atom_l
           j2_count=j2_count+1
           i2_count=itemp_c(j2_count)
           do kx=num_unit_temp11,num_unit_temp21
              do ky=num_unit_temp12,num_unit_temp22
                 do i1_do=1,num_atom_l
                    if( p_or_f_l == 'free' ) then
                       i1_count=itemp_l(kx+1,ky+1,i1_do)
                       r_per_temp=0.d0
                       cs=1.d0
                       sn=0.d0
                    else
                       if( p_or_f_l == 'periodic' ) then
                          i1_count=itemp_l(1,1,i1_do)
                          do jr_do=1,3
                             r_per_temp(jr_do)=dfloat(kx)*unit_block_l(1,jr_do)       &
                                  +dfloat(ky)*unit_block_l(2,jr_do)
                          end do
                          cs=dcos(2.d0*pai*(dfloat((px-1)*kx)/dfloat(kx_max_l)       &
                               +dfloat((py-1)*ky)/dfloat(ky_max_l)))
                          sn=dsin(2.d0*pai*(dfloat((px-1)*kx)/dfloat(kx_max_l)       &
                               +dfloat((py-1)*ky)/dfloat(ky_max_l)))
                       end if
                    end if
                    if( ham_model_ini .eq. 'gsp' ) then
                       call off_gsp_hami_lc(i1_do,i5_do,j2_count                    &
                            ,max_atom_orbital,h_ijmn,s_ijmn,r_per_temp)
                    else
                       if( ham_model_ini .eq. 'rtb_h' ) then
                          call off_rtbh_hami_lc(i1_do,j2_count,max_atom_orbital      &
                               ,h_ijmn,s_ijmn,r_per_temp)
                       else
                          write(6,*) 'error - ham_model: set_hami_c_ll 1'
                          stop
                       end if
                    end if
                    do i3_do=1,atom_orbital_ini(atom_kindn_l(i1_do))
                       do i4_do=1,atom_orbital_ini(atom_kindn_ccal(j2_count))
                          hcl_mat(i2_count+i4_do,i1_count+i3_do)                     &
                               =hcl_mat(i2_count+i4_do,i1_count+i3_do)               &
                               +dconjg(h_ijmn(i3_do,i4_do)*dcmplx(cs,sn))
                          scl_mat(i2_count+i4_do,i1_count+i3_do)                     &
                               =scl_mat(i2_count+i4_do,i1_count+i3_do)               &
                               +dconjg(s_ijmn(i3_do,i4_do)*dcmplx(cs,sn))
                       end do
                    end do
                 end do
              end do
           end do
        end do
     end do
  end do

  !                       ------------------------------------                       !

  deallocate(h_ijmn,s_ijmn,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error deallocate: set_hami_c_ll'
     stop
  end if

  return
end subroutine set_hami_c_ll

subroutine set_hami_c_rr(px,py)

  use condition_ini
  use hamiltonian_sgf
  use locate_atom
  use hamiltonian_c

  implicit none
  integer, intent(in) :: px,py

  integer :: max_atom_orbital
  complex(8), allocatable :: h_ijmn(:,:),s_ijmn(:,:)

  integer :: kx,ky,lx,ly
  integer :: ier
  integer :: i1_do,i3_do,i4_do,i5_do
  integer :: i1_count,i2_count,j2_count,num_unit_temp1,num_unit_temp2
  integer :: num_unit_temp11,num_unit_temp12,num_unit_temp21,num_unit_temp22
  integer :: num_unit_temp_l,num_unit_temp_r
  integer :: jr_do
  real(8) :: r_per_temp(3)
  real(8) :: cs,sn
  real(8) :: pai

  max_atom_orbital=0
  do i1_do=1,num_atom_kind_ini
     if( max_atom_orbital < atom_orbital_ini(i1_do) ) then
        max_atom_orbital=atom_orbital_ini(i1_do)
     end if
  end do

  allocate(h_ijmn(max_atom_orbital,max_atom_orbital)                           &
       ,s_ijmn(max_atom_orbital,max_atom_orbital),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: set_hami_c_rr'
     stop
  end if

  !                       ------------------------------------                       !

  pai=datan(1.d0)*4.d0

  !                       ------------------------------------                       !

  if( p_or_f_r == 'free' ) then
     num_unit_temp1=num_unit_r(1)
     num_unit_temp2=num_unit_r(2)
     num_unit_temp11=0
     num_unit_temp12=0
     num_unit_temp21=num_unit_r(1)-1
     num_unit_temp22=num_unit_r(2)-1
     num_unit_temp_l=num_unit_l(1)*num_unit_l(2)
     num_unit_temp_r=num_unit_r(1)*num_unit_r(2)
  else
     if( p_or_f_r == 'periodic' ) then
        num_unit_temp1=1
        num_unit_temp2=1
        num_unit_temp11=-neighbor_x_max_r
        num_unit_temp12=-neighbor_y_max_r
        num_unit_temp21=neighbor_x_max_r
        num_unit_temp22=neighbor_y_max_r
        num_unit_temp_l=1
        num_unit_temp_r=1
     else
        write(6,*) 'error_locate: set_hami_c_rr'
        stop
     end if
  end if

  j2_count=num_atom_l*num_unit_temp_l*m_num_block_l                            &
       +num_atom_c*m_num_block_m                                            &
       +num_atom_r*num_unit_temp_r*(m_num_block_r-1)
  do lx=1,num_unit_temp1
     do ly=1,num_unit_temp2
        do i5_do=1,num_atom_r
           j2_count=j2_count+1
           i2_count=itemp_c(j2_count)
           do kx=num_unit_temp11,num_unit_temp21
              do ky=num_unit_temp12,num_unit_temp22
                 do i1_do=1,num_atom_r
                    if( p_or_f_r == 'free' ) then
                       i1_count=itemp_r(kx+1,ky+1,i1_do)
                       r_per_temp=0.d0
                       cs=1.d0
                       sn=0.d0
                    else
                       if( p_or_f_r == 'periodic' ) then
                          i1_count=itemp_r(1,1,i1_do)
                          do jr_do=1,3
                             r_per_temp(jr_do)=dfloat(kx)*unit_block_r(1,jr_do)       &
                                  +dfloat(ky)*unit_block_r(2,jr_do)
                          end do
                          cs=dcos(2.d0*pai*(dfloat((px-1)*kx)/dfloat(kx_max_r)       &
                               +dfloat((py-1)*ky)/dfloat(ky_max_r)))
                          sn=dsin(2.d0*pai*(dfloat((px-1)*kx)/dfloat(kx_max_r)       &
                               +dfloat((py-1)*ky)/dfloat(ky_max_r)))
                       end if
                    end if
                    if( ham_model_ini .eq. 'gsp' ) then
                       call off_gsp_hami_rc(i1_do,i5_do,j2_count                    &
                            ,max_atom_orbital,h_ijmn,s_ijmn,r_per_temp)
                    else
                       if( ham_model_ini .eq. 'rtb_h' ) then
                          call off_rtbh_hami_rc(i1_do,j2_count,max_atom_orbital      &
                               ,h_ijmn,s_ijmn,r_per_temp)
                       else
                          write(6,*) 'error - ham_model: set_hami_c_ll 1'
                          stop
                       end if
                    end if
                    do i3_do=1,atom_orbital_ini(atom_kindn_r(i1_do))
                       do i4_do=1,atom_orbital_ini(atom_kindn_ccal(j2_count))
                          hcr_mat(i2_count+i4_do,i1_count+i3_do)                     &
                               =hcr_mat(i2_count+i4_do,i1_count+i3_do)               &
                               +dconjg(h_ijmn(i3_do,i4_do)*dcmplx(cs,sn))
                          scr_mat(i2_count+i4_do,i1_count+i3_do)                     &
                               =scr_mat(i2_count+i4_do,i1_count+i3_do)               &
                               +dconjg(s_ijmn(i3_do,i4_do)*dcmplx(cs,sn))
                       end do
                    end do
                 end do
              end do
           end do
        end do
     end do
  end do

  !                       ------------------------------------                       !

  deallocate(h_ijmn,s_ijmn,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error deallocate: set_hami_c_rr'
     stop
  end if

  return
end subroutine set_hami_c_rr

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Naoki WATANABE, Nobutaka NISHIKAWA (Mizuho I.R.)   @@ !
! @@             Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine BandMatrix__allocate( bmat )
  use ac_misc_module
  use ac_mpi_module
  implicit none
  type(BandMatrix_type) :: bmat
  integer :: i, j

  allocate( bmat%S(Base%npao, MPI%smat:MPI%emat) )
  allocate( bmat%H(Base%npao, MPI%smat:MPI%emat, Param%Option%nspin) )

  if( Param%Option%spin_orbit ) then
     allocate( bmat%E(Base%npao*2, 1) )
     allocate( bmat%F(Base%npao*2, 1) )
  else
     allocate( bmat%E(Base%npao, Param%Option%nspin) )
     allocate( bmat%F(Base%npao, Param%Option%nspin) )
  end if

  return
end subroutine BandMatrix__allocate

subroutine BandMatrix__deallocate( bmat )
  use ac_misc_module
  use ac_mpi_module
  implicit none
  type(BandMatrix_type) :: bmat

  if( associated(bmat%S) ) deallocate(bmat%S)
  if( associated(bmat%H) ) deallocate(bmat%H)
  if( associated(bmat%E) ) deallocate(bmat%E)
  if( associated(bmat%F) ) deallocate(bmat%F)

  return
end subroutine BandMatrix__deallocate

subroutine BandMatrix__calc( bmat, k )
  use ac_misc_module
  use ac_mpi_module
  implicit none
  type(BandMatrix_type), intent(out) :: bmat
  real(8), intent(in)    :: k(3)

  integer    :: spin
  integer    :: l
  integer    :: a, i, i1
  integer    :: b, j, j1
  complex(8) :: bloch

  bmat%S = 0.d0
  bmat%H = 0.d0

  do l=0, Param%Cell%nL-1

     bloch =  polar( dot_product(k,Param%Cell%vL(:,l)) )
     if( l==0 ) then
        bloch = 0.5d0 * bloch
     end if

     do a=MPI%isatom, MPI%ieatom
        i=Base%vipao(a)

        do b=1, Param%Data%natom
           j=Base%vipao(b)

           if( .not. associated(Hamiltonian%vAtomMatrix(b,a,l)%Ptr) ) then
              cycle
           end if

           do i1=MPI%ispao(a), MPI%iepao(a)
              do j1=1, Base%vnpao(b)

                 if( Param%Option%spin_orbit ) then
                    bmat%S(j+j1-1,i+i1-1) = bmat%S(j+j1-1,i+i1-1) &
                         + Hamiltonian%vAtomMatrix(b,a,l)%Ptr%S(j1,i1) * bloch
                    bmat%H(j+j1-1,i+i1-1,:) = bmat%H(j+j1-1,i+i1-1,:) &
                         + Hamiltonian%vAtomMatrix(b,a,l)%Ptr%HLS(j1,i1,:) * bloch
                 else
                    bmat%S(j+j1-1,i+i1-1) = bmat%S(j+j1-1,i+i1-1) &
                         + Hamiltonian%vAtomMatrix(b,a,l)%Ptr%S(j1,i1) * bloch
                    bmat%H(j+j1-1,i+i1-1,:) = bmat%H(j+j1-1,i+i1-1,:) &
                         + Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H(j1,i1,:) * bloch
                 end if
              end do
           end do

        end do
     end do
  end do


  if( Param%Option%spin_orbit ) then
     call MPI__AlltoAll_Matrix( bmat%S )
     call MPI__AlltoAll_Matrix( bmat%H(:,:,1) )
     call MPI__AlltoAll_Matrix( bmat%H(:,:,4) )
     call MPI__AlltoAll_Matrix2( bmat%H(:,:,2), bmat%H(:,:,3) )
  else
     call MPI__AlltoAll_Matrix( bmat%S )
     do spin=1, Param%Option%nspin
        call MPI__AlltoAll_Matrix( bmat%H(:,:,spin) )
     end do
  end if

  return
end subroutine BandMatrix__calc

subroutine BandMatrix__solve( bmat, iter )
  use ac_misc_module
  use ac_mpi_module
  implicit none
  type(BandMatrix_type), intent(inout) :: bmat
  integer, intent(in) :: iter

  integer    :: spin, ispin, jspin
  integer    :: i, j
  complex(8), allocatable :: H_LS(:,:), S_LS(:,:)
  complex(8), allocatable :: work1(:)
  real(8),    allocatable :: work2(:)
  integer  :: info

  if( Param%Option%spin_orbit ) then

     allocate( H_LS(2*Base%npao,2*MPI%smat-1:2*MPI%emat-0) )
     allocate( S_LS(2*Base%npao,2*MPI%smat-1:2*MPI%emat-0) )

     do i=MPI%smat, MPI%emat
        do j=1, Base%npao
           H_LS(2*j-1,2*i-1) = bmat%H(j,i,1)
           H_LS(2*j-1,2*i-0) = bmat%H(j,i,2)
           H_LS(2*j-0,2*i-1) = bmat%H(j,i,3)
           H_LS(2*j-0,2*i-0) = bmat%H(j,i,4)
           S_LS(2*j-1,2*i-1) = bmat%S(j,i)
           S_LS(2*j-1,2*i-0) = 0.0d0
           S_LS(2*j-0,2*i-1) = 0.0d0
           S_LS(2*j-0,2*i-0) = bmat%S(j,i)
        end do
     end do

     call MPI__ZHEGVLS( Base%npao, H_LS, S_LS, bmat%E, iter )

     do i=MPI%smat, MPI%emat
        do j=1, Base%npao
           bmat%H(j,i,1) = H_LS(2*j-1,2*i-1)
           bmat%H(j,i,2) = H_LS(2*j-0,2*i-1)
           bmat%H(j,i,3) = H_LS(2*j-1,2*i-0)
           bmat%H(j,i,4) = H_LS(2*j-0,2*i-0)
        end do
     end do

     deallocate( H_LS, S_LS )
  else
     do spin=1, Param%Option%nspin
        call MPI__ZHEGV( Base%npao, bmat%H(:,:,spin), bmat%S, bmat%E(:,spin), iter )
     end do
  end if

  return
end subroutine BandMatrix__solve

subroutine BandMatrix__calcCDM( bmat )
  use ac_misc_module
  use ac_mpi_module
  implicit none
  type(BandMatrix_type), intent(out) :: bmat

  integer :: m, i, j, spin, ispin, jspin, kspin
  real(8) :: F
  complex(8), allocatable :: tempS(:,:), tempH(:,:)
  complex(8), allocatable :: tempQ(:,:,:),tempR(:,:)
  complex(8), parameter   :: C1 = dcmplx(1.0d0,0.d0), C0 = dcmplx(0.0d0,0.d0)


  allocate( tempS(Param%Data%npao,MPI%smat:MPI%smat+MPI%localsize1-1) )
  allocate( tempH(Param%Data%npao,MPI%smat:MPI%smat+MPI%localsize1-1) )
  allocate( tempQ(Param%Data%npao,MPI%smat:MPI%smat+MPI%localsize1-1, Param%Option%nspin) )
  allocate( tempR(Param%Data%npao,MPI%smat:MPI%smat+MPI%localsize1-1) )

  if( Param%Option%spin_orbit ) then
     do m=1, Base%npao
        call Energy__fermifunc(F,bmat%E(2*m-1,1))
        bmat%F(2*m-1,1) = Param%Data%g * F 
        call Energy__fermifunc(F,bmat%E(2*m-0,1))
        bmat%F(2*m-0,1) = Param%Data%g * F 
     end do

     tempR=0.d0
     do spin=1, Param%Option%nspin

        select case(spin)
        case(1)
           ispin = 1
           jspin = 1
        case(2)
           ispin = 1
           jspin = 2
        case(3)
           ispin = 2
           jspin = 1
        case(4)
           ispin = 2
           jspin = 2
        end select

        tempQ(:,:,spin) = 0.d0
        tempH=0.d0
        tempS=0.d0

        do kspin=0,1
           do m=MPI%smat, MPI%emat
              do j=1, Base%npao
                 tempH(j,m) = dconjg(bmat%H(j,m,jspin+kspin*2))
              end do
              do i=1, Base%npao
                 tempS(i,m) = bmat%H(i,m,ispin+kspin*2) * bmat%F(2*m-1+kspin,1)
              end do
           end do

           call MPI__ZGEMM('N', 'T', Base%npao, &
                C1, tempH, tempS, C1*dfloat(kspin), tempQ(:,:,spin) )

           if( spin == 1 .or. spin == 4 ) then
              do m=MPI%smat, MPI%emat
                 do i=1, Base%npao
                    tempS(i,m) = tempS(i,m) * bmat%E(2*m-1+kspin,1)
                 end do
              end do

              call MPI__ZGEMM('N', 'T', Base%npao, &
                   C1, tempH, tempS, C1, tempR )
           end if
        end do

     end do

     do m=MPI%smat, MPI%emat
        do j=1, Base%npao
           do spin=1, Param%Option%nspin
              bmat%H(j,m,spin) = tempQ(j,m,spin)
           end do
           bmat%S(j,m) = tempR(j,m)
        end do
     end do
  else
     do m=MPI%smat, MPI%emat
        do spin=1, Param%Option%nspin
           call Energy__fermifunc(F,bmat%E(m,spin))
           bmat%F(m,spin) = Param%Data%g*F
        end do
     end do
     tempR=0.d0
     do spin=1, Param%Option%nspin
        tempQ(:,:,spin) = 0.d0
        tempH=0.d0
        tempS=0.d0

        do m=MPI%smat, MPI%emat
           do j=1, Base%npao
              tempH(j,m) = dconjg(bmat%H(j,m,spin))
           end do
           do i=1, Base%npao
              tempS(i,m) = bmat%H(i,m,spin) * bmat%F(m,spin)
           end do
        end do

        call MPI__ZGEMM('N', 'T', Base%npao, &
             C1, tempH, tempS, C0, tempQ(:,:,spin) )

        do m=MPI%smat, MPI%emat
           do i=1, Base%npao
              tempS(i,m) = tempS(i,m) * bmat%E(m,spin)
           end do
        end do

        call MPI__ZGEMM('N', 'T', Base%npao, &
             C1, tempH, tempS, C1, tempR )
     end do

     do m=MPI%smat, MPI%emat
        do j=1, Base%npao
           do spin=1, Param%Option%nspin
              bmat%H(j,m,spin) = tempQ(j,m,spin)
           end do
           bmat%S(j,m) = tempR(j,m)
        end do
     end do

  end if

  deallocate( tempQ, tempR )
  deallocate( tempS, tempH )

  return
end subroutine BandMatrix__calcCDM

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine print_site_sel(w,amat_temp6,bmat_temp6,ispin)

  use condition_ini
  use hamiltonian_c
  use gf_se_c

  implicit none
  integer, intent(in) :: ispin
  complex(8), intent(in) :: w
  complex(8), intent(in) :: amat_temp6(m_mat_max_c,m_mat_max_c)
  complex(8), intent(in) :: bmat_temp6(m_mat_max_c,m_mat_max_c)
  integer :: i1_do,i2_do
  complex(8) :: temp

  if( calc_type == 'trans' .or. calc_type == 'iv' ) then

     if( switch_out_gf == 'diagonal' ) then
        if( w == omega_gs(1) ) then
           if( ispin == 1 ) then
              write(50,*) m_num_block_l,m_num_block_m,m_num_block_r
              write(50,*) num_atom_l,num_atom_c,num_atom_r
              write(50,*) iw_max_gs,m_mat_max_c
           else
              write(52,*) m_num_block_l,m_num_block_m,m_num_block_r
              write(52,*) num_atom_l,num_atom_c,num_atom_r
              write(52,*) iw_max_gs,m_mat_max_c
           end if
        end if
        do i1_do=1,m_mat_max_c
           temp=amat_temp6(i1_do,i1_do)
           if( ispin == 1 ) then
              write(50,999) dreal(w),i1_do,dreal(temp),dimag(temp)
           else
              write(52,999) dreal(w),i1_do,dreal(temp),dimag(temp)
           end if
        end do
     end if
999  format(d27.17,i5,d27.17,d27.17)

     if( switch_out_gf == 'all' ) then
        if( w == omega_gs(1) ) then
           if( ispin == 1 ) then
              write(50,*) m_num_block_l,m_num_block_m,m_num_block_r
              write(50,*) num_atom_l,num_atom_c,num_atom_r
              write(50,*) iw_max_gs,m_mat_max_c
           else
              write(52,*) m_num_block_l,m_num_block_m,m_num_block_r
              write(52,*) num_atom_l,num_atom_c,num_atom_r
              write(52,*) iw_max_gs,m_mat_max_c
           end if
        end if
        do i1_do=1,m_mat_max_c
           if( ispin == 1 ) then
              write(50,*) i1_do,dreal(w),'****************************************'
           else
              write(52,*) i1_do,dreal(w),'****************************************'
           end if
           do i2_do=1,m_mat_max_c
              temp=amat_temp6(i1_do,i2_do)
              if( ispin == 1 ) then
                 write(50,*) i2_do,dreal(temp),dimag(temp)
              else
                 write(52,*) i2_do,dreal(temp),dimag(temp)
              end if
           end do
        end do
     end if

     if( switch_out_tr == 'all' ) then
        if( w == omega_gs(1) ) then
           if( ispin == 1 ) then
              write(46,*) m_num_block_l,m_num_block_m,m_num_block_r
              write(46,*) num_atom_l,num_atom_c,num_atom_r
              write(46,*) iw_max_gs,m_mat_max_c
           else
              write(47,*) m_num_block_l,m_num_block_m,m_num_block_r
              write(47,*) num_atom_l,num_atom_c,num_atom_r
              write(47,*) iw_max_gs,m_mat_max_c
           end if
        end if
        do i1_do=1,m_mat_max_c
           if( ispin == 1 ) then
              write(46,*) i1_do,dreal(w),'****************************************'
           else
              write(47,*) i1_do,dreal(w),'****************************************'
           end if
           do i2_do=1,m_mat_max_c
              temp=bmat_temp6(i1_do,i2_do)
              if( ispin == 1 ) then
                 write(46,*) i2_do,dreal(temp),dimag(temp)
              else
                 write(47,*) i2_do,dreal(temp),dimag(temp)
              end if
           end do
        end do
     end if

  end if

  return
end subroutine print_site_sel

subroutine print_site_tra(w,amat_temp5,ispin)

  use condition_ini
  use hamiltonian_sgf
  use hamiltonian_c
  use gf_se_c

  implicit none
  integer, intent(in) :: ispin
  complex(8), intent(in) :: w
  complex(8), intent(in) :: amat_temp5(m_mat_max_c,m_mat_max_c)
  integer :: i1_do,i2_do,px,py,icou_l,qx,qy,icou_r
  complex(8) :: temp

  if( calc_type == 'trans' .or. calc_type == 'iv' ) then

     if( switch_out_tr == 'diagonal' ) then
        if( w == omega_gs(1) ) then
           if( ispin == 1 ) then
              write(51,*) m_num_block_l,m_num_block_m,m_num_block_r
              write(51,*) num_atom_l,num_atom_c,num_atom_r
              write(51,*) iw_max_gs,m_mat_max_c
           else
              write(53,*) m_num_block_l,m_num_block_m,m_num_block_r
              write(53,*) num_atom_l,num_atom_c,num_atom_r
              write(53,*) iw_max_gs,m_mat_max_c
           end if
        end if
        do i1_do=1,m_mat_max_c
           temp=amat_temp5(i1_do,i1_do)
           if( ispin == 1 ) then
              write(51,999) dreal(w),i1_do,dreal(temp),dimag(temp)
           else
              write(53,999) dreal(w),i1_do,dreal(temp),dimag(temp)
           end if
        end do
     end if
999  format(d27.17,i5,d27.17,d27.17)

     if( switch_out_tr == 'tr' .or. switch_out_tr == 'all' ) then
        if( w == omega_gs(1) ) then
           if( ispin == 1 ) then
              write(51,*) m_num_block_l,m_num_block_m,m_num_block_r
              write(51,*) num_atom_l,num_atom_c,num_atom_r
              write(51,*) iw_max_gs,m_mat_max_c
           else
              write(53,*) m_num_block_l,m_num_block_m,m_num_block_r
              write(53,*) num_atom_l,num_atom_c,num_atom_r
              write(53,*) iw_max_gs,m_mat_max_c
           end if
        end if
        icou_l=0
        do i2_do=1,m_mat_max_c
           do i1_do=1,m_mat_max_c
              if( amat_temp5(i1_do,i2_do) /= dcmplx(0.d0,0.d0) ) then
                 icou_l=icou_l+1
              end if
           end do
        end do
        if( ispin == 1 ) then
           write(51,*) icou_l,dreal(w),'****************************************'
        else
           write(53,*) icou_l,dreal(w),'****************************************'
        end if
        do i1_do=1,m_mat_max_c
           do i2_do=1,m_mat_max_c
              temp=amat_temp5(i1_do,i2_do)
              if( ispin == 1 ) then
                 if( amat_temp5(i1_do,i2_do) /= dcmplx(0.d0,0.d0) ) then
                    write(51,*) i1_do,i2_do,dreal(temp),dimag(temp)
                 end if
              else
                 if( amat_temp5(i1_do,i2_do) /= dcmplx(0.d0,0.d0) ) then
                    write(53,*) i1_do,i2_do,dreal(temp),dimag(temp)
                 end if
              end if
           end do
        end do
     end if

     if( switch_out_tr == 'all' ) then
        if( w == omega_gs(1) ) then
           if( ispin == 1 ) then
              write(48,*) m_num_block_l,m_num_block_m,m_num_block_r
              write(48,*) num_atom_l,num_atom_c,num_atom_r
              write(48,*) iw_max_gs,m_mat_max_c
           else
              write(49,*) m_num_block_l,m_num_block_m,m_num_block_r
              write(49,*) num_atom_l,num_atom_c,num_atom_r
              write(49,*) iw_max_gs,m_mat_max_c
           end if
        end if
        icou_l=0
        do px=1,kx_max_ll                                         ! kx_max_ll = 1
           do py=1,ky_max_ll                                       ! ky_max_ll = 1
              do i2_do=1,m_mat_max_c
                 do i1_do=1,m_mat_max_c
                    if( se_l_mat_per(i1_do,i2_do,px,py) /= dcmplx(0.d0,0.d0) ) then
                       icou_l=icou_l+1
                    end if
                 end do
              end do
           end do
        end do
        do px=1,kx_max_ll
           do py=1,ky_max_ll
              if( ispin == 1 ) then
                 write(48,*) icou_l,dreal(w),dimag(w)                               &
                      ,'****************************************'
              else
                 write(49,*) icou_l,dreal(w),dimag(w)                               &
                      ,'****************************************'
              end if
              do i2_do=1,m_mat_max_c
                 do i1_do=1,m_mat_max_c
                    if( se_l_mat_per(i1_do,i2_do,px,py) /= dcmplx(0.d0,0.d0) ) then
                       temp=se_l_mat_per(i1_do,i2_do,px,py)
                       if( ispin == 1 ) then
                          write(48,*) i1_do,i2_do,dreal(temp),dimag(temp)
                       else
                          write(49,*) i1_do,i2_do,dreal(temp),dimag(temp)
                       end if
                    end if
                 end do
              end do
           end do
        end do
        icou_r=0
        do qx=1,kx_max_rr                                         ! kx_max_rr = 1
           do qy=1,ky_max_rr                                       ! ky_max_rr = 1
              do i2_do=1,m_mat_max_c
                 do i1_do=1,m_mat_max_c
                    if( se_r_mat_per(i1_do,i2_do,qx,qy) /= dcmplx(0.d0,0.d0) ) then
                       icou_r=icou_r+1
                    end if
                 end do
              end do
           end do
        end do
        do qx=1,kx_max_rr
           do qy=1,ky_max_rr
              if( ispin == 1 ) then
                 write(48,*) icou_l,dreal(w),dimag(w)                               &
                      ,'****************************************'
              else
                 write(49,*) icou_l,dreal(w),dimag(w)                               &
                      ,'****************************************'
              end if
              do i2_do=1,m_mat_max_c
                 do i1_do=1,m_mat_max_c
                    if( se_r_mat_per(i1_do,i2_do,qx,qy) /= dcmplx(0.d0,0.d0) ) then
                       temp=se_r_mat_per(i1_do,i2_do,qx,qy)
                       if( ispin == 1 ) then
                          write(48,*) i1_do,i2_do,dreal(temp),dimag(temp)
                       else
                          write(49,*) i1_do,i2_do,dreal(temp),dimag(temp)
                       end if
                    end if
                 end do
              end do
           end do
        end do
     end if

  end if

  return
end subroutine print_site_tra

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine inverse_mat1(mat_max,amat_in,A)

  implicit none
  integer, intent(in) :: mat_max
  complex(8), intent(in) :: amat_in(mat_max,mat_max)
  complex(8), intent(out) :: A(mat_max,mat_max)

  integer :: i1_do,i2_do,ier

  integer :: M, N, LDA, INFO, LWORK
  integer, allocatable :: IPIV(:)
  complex(8), allocatable :: WORK(:)

  do i2_do=1,mat_max
     do i1_do=1,mat_max
        A(i1_do,i2_do)=amat_in(i1_do,i2_do)
     end do
  end do

  allocate(IPIV(mat_max),WORK(mat_max),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: inverse_mat1 3'
     stop
  end if

  M=mat_max
  N=mat_max
  LDA=mat_max
  INFO=100
  call ZGETRF( M, N, A, LDA, IPIV, INFO )
  if( INFO /= 0 ) then
     write(*,*) 'error :: CGETRF',INFO
  end if

  LWORK=mat_max
  M=mat_max
  N=mat_max
  LDA=mat_max
  INFO=100
  call ZGETRI( N, A, LDA, IPIV, WORK, LWORK, INFO )
  if( INFO /= 0 ) then
     write(*,*) 'error :: CGETRI',INFO
  end if

  deallocate(IPIV,WORK,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error deallocate: inverse_mat1 3'
     stop
  end if

  return
end subroutine inverse_mat1

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Naoki WATANABE, Nobutaka NISHIKAWA (Mizuho I.R.)   @@ !
! @@             Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine SphericalBessel__setup( Nr, Nk, Ecutoff )
  use ac_parameter

  implicit none
  integer, intent(in)       :: Nr, Nk
  real(8), intent(in) :: Ecutoff
  real(8) :: Kcutoff

  SphericalBessel%Nr = Nr
  SphericalBessel%Nk = Nk
  allocate( SphericalBessel%vrx(SphericalBessel%Nr) )
  allocate( SphericalBessel%vrw(SphericalBessel%Nr) )
  allocate( SphericalBessel%vkx(SphericalBessel%Nk) )
  allocate( SphericalBessel%vkw(SphericalBessel%Nk) )

  Kcutoff = sqrt(2*Ecutoff)

  if( Param%Option%mx ) then
     call GaussLegendre__getPointsMX( SphericalBessel%Nk, 0.d0, Kcutoff, SphericalBessel%vkx, SphericalBessel%vkw ) 

     call GaussLegendre__getPointsMX( SphericalBessel%Nr, 0.d0, 1.d0, SphericalBessel%vrx, SphericalBessel%vrw )
  else
     call GaussLegendre__getPoints( SphericalBessel%Nk, 0.d0, Kcutoff, SphericalBessel%vkx, SphericalBessel%vkw ) 

     call GaussLegendre__getPoints( SphericalBessel%Nr, 0.d0, 1.d0, SphericalBessel%vrx, SphericalBessel%vrw )
  end if

  return
end subroutine SphericalBessel__setup

subroutine SphericalBessel__transpose( vK, fR, l )
  use ac_parameter

  implicit none
  real(8), intent(out) :: vK(SphericalBessel%Nk)
  type(Spline_type), intent(in)   :: fR
  integer, intent(in)        :: l

  integer :: ik, i
  real(8) :: k, r, w, sumk
  real(8) :: f

  real(8) SphericalBessel__J

  do ik=1, SphericalBessel%Nk
     k = SphericalBessel%vkx(ik)

     sumk=0.d0
     do i=1, SphericalBessel%Nr
        r = fR%vx(fR%N) * SphericalBessel%vrx(i)
        w = fR%vx(fR%N) * SphericalBessel%vrw(i)

        call Spline__evaluate(fR, r, f)
        sumk = sumk + w*r*r* f * SphericalBessel__J(l,k*r)
     end do
     vK(ik) = sumk*M_2_SQRTPI*M_SQRT1_2     
  end do

  return
end subroutine SphericalBessel__transpose

subroutine SphericalBessel__transposetail( vK, fR, Q )
  use ac_parameter

  implicit none
  real(8), intent(out) :: vK(SphericalBessel%Nk)
  type(Spline_type), intent(in)   :: fR
  real(8), intent(in)  :: Q

  integer       :: ik
  real(8) :: k, rs, re, sum

  do ik=1, SphericalBessel%Nk
     k  = SphericalBessel%vkx(ik)
     rs = fR%vx(fR%N)
     re = fR%vx(fR%N)*3

     if( k<1.d-14 ) then
        sum = 0.5*(re*re-rs*rs)
     else
        sum = (cos(k*rs)-cos(k*re))/(k*k)
     endif
     vK(ik) = vK(ik) + sum*Q*M_2_SQRTPI*M_SQRT1_2
  end do

  return
end subroutine SphericalBessel__transposetail

function SphericalBessel__J( l, x ) result(J)
  implicit none
  integer, intent(in) :: l
  real(8), intent(in) :: x
  real(8) :: J

  real(8) :: ix1, ix2

  select case(l)
  case(0)
     if( x<1.0e-2 ) then
        J = 1.0 - 1.0/6.0*x*x
     else
        J = sin(x)/x
     endif

  case(1)
     if( x<1.0e-6 ) then
        J = 1.0/3.0*x - 1.0/30.0*(x**3)
     else
        ix1 = 1.0/x
        J = (sin(x)*ix1-cos(x))*ix1
     endif

  case(2)
     if( x<4.0e-3 ) then
        J = 1.0/15.0*(x**2) - 1.0/210.0*(x**4)
     else
        ix1 = 1.0/x
        ix2 = ix1*ix1
        J = + (sin(x)*ix1)*(3.0*ix2-1.0) - (cos(x)*ix2)*3.0
     endif

  case(3)
     if( x<2.0e-2 ) then
        J = 1.0/105.0*(x**3) - 1.0/1890.0*(x**5)
     else
        ix1 = 1.0/x
        ix2 = ix1*ix1
        J = + (sin(x)*ix2)*(15.0*ix2-6.0) &
             - (cos(x)*ix1)*(15.0*ix2-1.0)
     endif

  case(4)
     if( x<6.0e-2 ) then
        J = 1.0/945.0*(x**4) - 1.0/20790.0*(x**6)
     else
        ix1 = 1.0/x
        ix2 = ix1*ix1
        J = + (sin(x)*ix1)*((105.0*ix2-45.0)*ix2+1.0) &
             - (cos(x)*ix2)*(105.0*ix2-10.0)
     endif

  case(5)
     if( x<1.0e-1 ) then
        J = 1.0/(10395.0)*(x**5) - 1.0/270270.0*(x**7)
     else
        ix1 = 1.0/x
        ix2 = ix1*ix1
        J = + (sin(x)*ix2)*((945.0*ix2-420.0)*ix2+15.0) &
             - (cos(x)*ix1)*((945.0*ix2-105.0)*ix2+1.0)
     endif

  case(6)
     if( x<5.0e-1 ) then
        J = 1.0/(135135.0)*(x**6) - 1.0/4054050.0*(x**8)
     else
        ix1 = 1.0/x
        ix2 = ix1*ix1
        J = + (sin(x)*ix1)*(((945.0*11.0*ix2-4725.0)*ix2+210.0)*ix2-1.0) &
             - (cos(x)*ix2)*((945.0*11.0*ix2-1260.0)*ix2+21.0)
     endif

  case default
     J = 0.d0
     write(*,'(a70)') '# Sorry : spherical Bessel function for l>6 is not implemented'
     stop
  end select

  return
end function SphericalBessel__J

function SphericalBessel__Jxl( l, x ) result(Jxl)
  implicit none
  integer, intent(in) :: l
  real(8), intent(in) :: x
  real(8) :: Jxl

  real(8) :: ix1, ix2

  select case(l)
  case(0)
     if( x<1.0e-2 ) then
        Jxl = 1.0 - 1.0/6.0*(x**2)
     else
        Jxl = sin(x)/x
     endif

  case(1)
     if( x<1.0e-6 ) then
        Jxl = 1.0/3.0 - 1.0/30.0*(x**2)
     else
        ix1 = 1.0/x
        ix2 = ix1*ix1
        Jxl = (sin(x)*ix1-cos(x))*ix2
     endif

  case(2)
     if( x<4.0e-3 ) then
        Jxl = 1.0/15.0 - 1.0/210.0*(x**2)
     else
        ix1 = 1.0/x
        ix2 = ix1*ix1
        Jxl = ((sin(x)*ix1)*(3.0*ix2-1.0) &
             - (cos(x)*ix2)*3.0)*ix2
     endif

  case(3)
     if( x<2.0e-2 ) then
        Jxl = 1.0/105.0 - 1.0/1890.0*(x**2)
     else
        ix1 = 1.0/x
        ix2 = ix1*ix1
        Jxl = ((sin(x)*ix1)*(15.0*ix2-6.0) &
             - (cos(x))*(15.0*ix2-1.0))*ix2*ix2
     endif

  case(4)
     if( x<6.0e-2 ) then
        Jxl = 1.0/945.0 - 1.0/20790.0*(x**2)
     else
        ix1 = 1.0/x
        ix2 = ix1*ix1
        Jxl = ((sin(x)*ix1)*((105.0*ix2-45.0)*ix2+1.0) &
             - (cos(x)*ix2)*(105.0*ix2-10.0))*ix2*ix2
     endif

  case(5)
     if( x<1.0e-1 ) then
        Jxl = 1.0/(10395.0) - 1.0/270270.0*(x**2)
     else
        ix1 = 1.0/x
        ix2 = ix1*ix1
        Jxl = ((sin(x)*ix1)*((945.0*ix2-420.0)*ix2+15.0) &
             - (cos(x))*((945.0*ix2-105.0)*ix2+1.0))*ix2*ix2*ix2
     endif

  case(6)
     if( x<5.0e-1 ) then
        Jxl = 1.0/(135135.0) - 1.0/4054050.0*(x**2)
     else
        ix1 = 1.0/x
        ix2 = ix1*ix1
        Jxl = ((sin(x)*ix1)*(((945.0*11.0*ix2-4725.0)*ix2+210.0)*ix2-1.0) &
             - (cos(x)*ix2)*((945.0*11.0*ix2-1260.0)*ix2+21.0))*ix2*ix2*ix2
     endif

  case default
     Jxl = 0.d0
     write(*,'(a70)') '# Sorry : spherical Bessel function for l>6 is not implemented'
     stop
  end select

  return
end function SphericalBessel__Jxl

function SphericalBessel__Jx2( l, x ) result(Jx2)
  implicit none
  integer, intent(in)       :: l
  real(8), intent(in) :: x
  real(8) :: Jx2

  real(8) :: ix1, ix2


  select case(l)
  case(0)
     Jx2 = sin(x)*x

  case(1)
     Jx2 = sin(x) - cos(x)*x

  case(2)
     if( x<4.0e-3 ) then
        Jx2 = 1.0/15.0*(x**4) - 1.0/210.0*(x**6)
     else
        ix1 = 1.0/x
        ix2 = ix1*ix1
        Jx2 = (sin(x)*x)*(3.0*ix2-1.0) - (cos(x))*3.0
     endif

  case(3)
     if( x<2.0e-2 ) then
        Jx2 = 1.0/105.0*(x**5) - 1.0/1890.0*(x**7)
     else
        ix1 = 1.0/x
        ix2 = ix1*ix1
        Jx2 = (sin(x))*(15.0*ix2-6.0) - (cos(x)*x)*(15.0*ix2-1.0)
     endif

  case(4)
     if( x<6.0e-2 ) then
        Jx2 = 1.0/945.0*(x**6) - 1.0/20790.0*(x**8)
     else
        ix1 = 1.0/x
        ix2 = ix1*ix1
        Jx2 = (sin(x)*x)*((105.0*ix2-45.0)*ix2+1.0) &
             - (cos(x))*(105.0*ix2-10.0)
     endif

  case(5)
     if( x<1.0e-1 ) then
        Jx2 = 1.0/(10395.0)*(x**7) - 1.0/270270.0*(x**9)
     else
        ix1 = 1.0/x
        ix2 = ix1*ix1
        Jx2 = (sin(x))*((945.0*ix2-420.0)*ix2+15.0) &
             - (cos(x)*x)*((945.0*ix2-105.0)*ix2+1.0)
     endif

  case(6)
     if( x<5.0e-1 ) then
        Jx2 = 1.0/(135135.0)*(x**8) - 1.0/4054050.0*(x**10)
     else
        ix1 = 1.0/x
        ix2 = ix1*ix1
        Jx2 = + (sin(x)*x)*(((945.0*11.0*ix2-4725.0)*ix2+210.0)*ix2-1.0) &
             - (cos(x))*((945.0*11.0*ix2-1260.0)*ix2+21.0)
     endif

  case default
     Jx2 = 0.d0
     write(*,'(a70)') '# Sorry : spherical Bessel function for l>6 is not implemented'
     stop
  end select

  return
end function SphericalBessel__Jx2

function SphericalBessel__dJx2( l, x ) result(dJx2)
  implicit none
  integer, intent(in)       :: l
  real(8), intent(in) :: x
  real(8) :: dJx2

  real(8) :: ix1, ix2

  select case(l)
  case(0)
     dJx2 = sin(x) + cos(x)*x

  case(1)
     dJx2 = sin(x)*x

  case(2)
     if( x<4.0e-3 ) then
        dJx2 = 4.0/15.0*(x**3) - 6.0/210.0*(x**5)
     else
        ix1 = 1.0/x
        ix2 = ix1*ix1
        dJx2 = sin(x)*(-3.0*ix2+2.0) + cos(x)*(3.0*ix1-x)
     endif

  case(3)
     if( x<2.0e-2 ) then
        dJx2 = 1.0/21.0*(x**4) - 7.0/1890.0*(x**6)
     else
        ix1 = 1.0/x
        ix2 = ix1*ix1
        dJx2 = sin(x)*((-30.0*ix2+15.0)*ix1-x) + cos(x)*(30.0*ix2-5.0)
     endif

  case(4)
     if( x<6.0e-2 ) then
        dJx2 = 6.0/945.0*(x**5) - 8.0/20790.0*(x**7)
     else
        ix1 = 1.0/x
        ix2 = ix1*ix1
        dJx2 = sin(x)*((-315.0*ix2+150.0)*ix2-9.0)  &
             + cos(x)*((315.0*ix2-45.0)*ix1+x)
     endif

  case(5)
     if( x<1.0e-1 ) then
        dJx2 = 7.0/10395.0*(x**6) - 9.0/270270.0*(x**8)
     else
        ix1 = 1.0/x
        ix2 = ix1*ix1
        dJx2 = sin(x)*(((-3780.0*ix2+1785.0)*ix2-105.0)*ix1+x) &
             + cos(x)*((945.0*4.0*ix2-525.0)*ix2+14.0)
     endif

  case(6)
     if( x<5.0e-1 ) then
        dJx2 = 8.0/135135.0*(x**7) - 10.0/4054050.0*(x**9)
     else
        ix1 = 1.0/x
        ix2 = ix1*ix1
        dJx2 = sin(x)*(((-51975.0*ix2+24570.0)*ix2-1470.0)*ix2+20.0) &
             + cos(x)*((( 51975.0*ix2-7245.0)*ix2+210.0)*ix1-x)
     endif


  case default
     dJx2 = 0.d0
     write(*,'(a70)') '# Sorry : spherical Bessel function for l>6 is not implemented'
     stop
  end select

  return
end function SphericalBessel__dJx2

function SphericalBessel__dJxlx( l, x ) result(dJxlx)
  implicit none
  integer, intent(in)       :: l
  real(8), intent(in) :: x
  real(8) :: dJxlx
  real(8) :: ix1, ix2

  select case(l)
  case(0)
     if( x<1.0e-2 ) then
        dJxlx = - 2.0/6.0
     else
        ix1 = 1.0/x
        ix2 = ix1*ix1
        dJxlx = (cos(x)-(sin(x)*ix1))*ix2
     endif

  case(1)
     if( x<1.0e-6 ) then
        dJxlx = - 2.0/30.0
     else
        ix1 = 1.0/x
        ix2 = ix1*ix1
        dJxlx = ((1-3*ix2)*(sin(x)*ix1) + 3*(cos(x)*ix2) )*ix2
     endif

  case(2)
     if( x<4.0e-3 ) then
        dJxlx = - 2.0/210.0
     else
        ix1 = 1.0/x
        ix2 = ix1*ix1
        dJxlx = ((6-15*ix2)*(sin(x)*ix1) &
             + (15*ix2-1)*cos(x))*ix2*ix2
     endif

  case(3)
     if( x<2.0e-2 ) then
        dJxlx = - 2.0/1890.0
     else
        ix1 = 1.0/x
        ix2 = ix1*ix1
        dJxlx = ( - (1-45*ix2+105*ix2*ix2)*(sin(x)*ix1) &
             - (10*ix2-105)*(cos(x)*ix2) )*ix2*ix2
     endif

  case(4)
     if( x<6.0e-2 ) then
        dJxlx = - 2.0/20790.0
     else
        ix1 = 1.0/x
        ix2 = ix1*ix1
        dJxlx = -((15-420*ix2+945*ix2*ix2)*(sin(x)*ix1) &
             + (-1+105*ix2-945*ix2*ix2)*cos(x))*ix2*ix2*ix2
     endif

  case(5)
     if( x<1.0e-1 ) then
        dJxlx = - 2.0/270270.0
     else
        ix1 = 1.0/x
        ix2 = ix1*ix1
        dJxlx = ((1-210*ix2+4725*ix2*ix2-10395*ix2*ix2*ix2)*(sin(x)*ix1) &
             + (21-1260*ix2+10395*ix2*ix2)*(cos(x)*ix2))*ix2*ix2*ix2
     endif

  case(6)
     if( x<5.0e-1 ) then
        dJxlx = - 2.0/4054050.0
     else
        ix1 = 1.0/x
        ix2 = ix1*ix1
        dJxlx = ((28-3150*ix2+62370*ix2*ix2-135135*ix2*ix2*ix2)*(sin(x)*ix1) &
             + (-1+378*ix2-17325*ix2*ix2+135135*ix2*ix2*ix2)*cos(x))*ix2*ix2*ix2*ix2
     endif

  case default
     dJxlx = 0.d0
     write(*,'(a70)') '# Sorry : spherical Bessel function for l>6 is not implemented'
     stop
  end select

  return

end function SphericalBessel__dJxlx

subroutine SphericalBessel__integrateS( sumS, Ra, Rb, l, r ) 
  use ac_parameter

  implicit none
  real(8), intent(in) :: Ra(SphericalBessel%Nk)
  real(8), intent(in) :: Rb(SphericalBessel%Nk)
  integer, intent(in) :: l
  real(8), intent(in) :: r

  real(8) :: sumS
  integer :: ik
  real(8) :: k, w

  real(8) SphericalBessel__Jxl
  real(8) SphericalBessel__Jx2

  sumS=0.d0

  if( r < 1.d-14 ) then
     do ik=1, SphericalBessel%Nk
        k = SphericalBessel%vkx(ik)
        w = SphericalBessel%vkw(ik)

        sumS = sumS + w*(k**(l+2)) * Ra(ik)*Rb(ik)
     end do

     sumS = sumS*4*M_PI*SphericalBessel__Jxl(l,0.d0)
     return
  end if

  do ik=1, SphericalBessel%Nk
     k = SphericalBessel%vkx(ik)
     w = SphericalBessel%vkw(ik)

     sumS = sumS + w*SphericalBessel__Jx2(l,k*r) * Ra(ik)*Rb(ik)
  end do

  sumS = sumS*4*M_PI/r**(l+2)

  return
end subroutine SphericalBessel__integrateS

subroutine SphericalBessel__integrateK( sumK, Ra, Rb, l, r )
  use ac_parameter

  implicit none
  real(8), intent(in) :: Ra(SphericalBessel%Nk)
  real(8), intent(in) :: Rb(SphericalBessel%Nk)
  integer, intent(in) :: l
  real(8), intent(in) :: r

  real(8) :: sumK
  integer :: ik
  real(8) :: k, w

  real(8) SphericalBessel__Jxl
  real(8) SphericalBessel__Jx2

  sumK=0.d0

  if( r < 1.d-14 ) then
     do ik=1, SphericalBessel%Nk
        k = SphericalBessel%vkx(ik)
        w = SphericalBessel%vkw(ik)

        sumK = sumK + w*(k**(l+4)) * Ra(ik)*Rb(ik)
     end do

     sumK = sumK*2*M_PI*SphericalBessel__Jxl(l,0.d0)
     return
  end if

  do ik=1, SphericalBessel%Nk
     k = SphericalBessel%vkx(ik)
     w = SphericalBessel%vkw(ik)

     sumK = sumK + w*k*k*SphericalBessel__Jx2(l,k*r) * Ra(ik)*Rb(ik)
  end do

  sumK = sumK*2*M_PI/r**(l+2)

  return
end subroutine SphericalBessel__integrateK

subroutine SphericalBessel__integratedS( sumdS, Ra, Rb, l, r )
  use ac_parameter

  implicit none
  real(8), intent(in) :: Ra(SphericalBessel%Nk)
  real(8), intent(in) :: Rb(SphericalBessel%Nk)
  integer, intent(in) :: l
  real(8), intent(in) :: r

  real(8) :: sumdS
  integer       :: ik
  real(8) :: k, w

  real(8) SphericalBessel__dJxlx
  real(8) SphericalBessel__Jx2
  real(8) SphericalBessel__dJx2

  sumdS=0.d0

  if( r < 1.d-14 ) then
     do ik=1, SphericalBessel%Nk
        k = SphericalBessel%vkx(ik)
        w = SphericalBessel%vkw(ik)

        sumdS = sumdS + w*(k**(l+2)) * k**2 * Ra(ik)*Rb(ik)
     end do

     sumdS = sumdS*4*M_PI*SphericalBessel__dJxlx(l,0.d0)
     return
  end if

  do ik=1, SphericalBessel%Nk
     k = SphericalBessel%vkx(ik)
     w = SphericalBessel%vkw(ik)

     sumdS = sumdS - w*Ra(ik)*Rb(ik)*(l+2)*SphericalBessel__Jx2 (l,k*r)
     sumdS = sumdS + w*Ra(ik)*Rb(ik)*(k*r)*SphericalBessel__dJx2(l,k*r)
  end do

  sumdS = sumdS*4*M_PI/r**(l+4)

  return 
end subroutine SphericalBessel__integratedS

subroutine SphericalBessel__integratedK( sumdK, Ra, Rb, l, r )
  use ac_parameter

  implicit none
  real(8), intent(in) :: Ra(SphericalBessel%Nk)
  real(8), intent(in) :: Rb(SphericalBessel%Nk)
  integer, intent(in) :: l
  real(8), intent(in) :: r

  real(8) :: sumdK
  integer :: ik
  real(8) :: k, w

  real(8) SphericalBessel__dJxlx
  real(8) SphericalBessel__Jx2
  real(8) SphericalBessel__dJx2

  sumdK=0.d0

  if( r < 1.d-14 ) then
     do ik=1, SphericalBessel%Nk
        k = SphericalBessel%vkx(ik)
        w = SphericalBessel%vkw(ik)

        sumdK = sumdK + w*(k**(l+4)) * k**2 * Ra(ik)*Rb(ik)
     end do

     sumdK = sumdK*2*M_PI*SphericalBessel__dJxlx(l,0.d0)
     return
  end if

  do ik=1, SphericalBessel%Nk
     k = SphericalBessel%vkx(ik)
     w = SphericalBessel%vkw(ik)

     sumdK = sumdK - w*k*k*Ra(ik)*Rb(ik)* (l+2)*SphericalBessel__Jx2 (l,k*r)
     sumdK = sumdK + w*k*k*Ra(ik)*Rb(ik)*(k*r)*SphericalBessel__dJx2(l,k*r)
  end do

  sumdK = sumdK*2*M_PI/r**(l+4)

  return
end subroutine SphericalBessel__integratedK

subroutine SphericalBessel__integrateSK( sumS, sumK, Ra, Rb, l, r )
  use ac_parameter

  implicit none
  real(8) :: sumS, sumK
  real(8), intent(in) :: Ra(SphericalBessel%Nk)
  real(8), intent(in) :: Rb(SphericalBessel%Nk)
  integer, intent(in) :: l
  real(8), intent(in) :: r

  integer :: ik
  real(8) :: k, w, f

  real(8) SphericalBessel__Jxl
  real(8) SphericalBessel__Jx2

  sumS=0.d0
  sumK=0.d0

  if( r < 1.d-14 ) then
     do ik=1, SphericalBessel%Nk
        k = SphericalBessel%vkx(ik)
        w = SphericalBessel%vkw(ik)
        f = w*(k**(l+2)) * Ra(ik)*Rb(ik)

        sumS = sumS + f
        sumK = sumK + f*k*k
     end do

     sumS = sumS*4*M_PI*SphericalBessel__Jxl(l,0.d0)
     sumK = sumK*2*M_PI*SphericalBessel__Jxl(l,0.d0)

     return
  end if

  do ik=1, SphericalBessel%Nk
     k = SphericalBessel%vkx(ik)
     w = SphericalBessel%vkw(ik)
     f = w*SphericalBessel__Jx2(l,k*r) * Ra(ik)*Rb(ik)
     sumS = sumS + f
     sumK = sumK + f*k*k
  end do

  sumS = sumS*4*M_PI/r**(l+2)
  sumK = sumK*2*M_PI/r**(l+2)

  return
end subroutine SphericalBessel__integrateSK

subroutine SphericalBessel__integratedSK( sumdS, sumdK, Ra, Rb, l, r )
  use ac_parameter

  implicit none
  real(8) :: sumdS, sumdK
  real(8), intent(in) :: Ra(SphericalBessel%Nk)
  real(8), intent(in) :: Rb(SphericalBessel%Nk)
  integer, intent(in) :: l
  real(8), intent(in) :: r

  integer :: ik
  real(8) :: k, w, f, df

  real(8) SphericalBessel__dJxlx
  real(8) SphericalBessel__Jx2
  real(8) SphericalBessel__dJx2

  sumdS = 0.d0
  sumdK = 0.d0

  if( r < 1.d-14 ) then
     do ik=1, SphericalBessel%Nk
        k = SphericalBessel%vkx(ik)
        w = SphericalBessel%vkw(ik)

        sumdS = sumdS + w*(k**(l+2)) * k**2 * Ra(ik)*Rb(ik)
        sumdK = sumdK + w*(k**(l+4)) * k**2 * Ra(ik)*Rb(ik)
     end do

     sumdS = sumdS*4*M_PI*SphericalBessel__dJxlx(l,0.d0)
     sumdK = sumdK*2*M_PI*SphericalBessel__dJxlx(l,0.d0)
     return
  end if

  do ik=1, SphericalBessel%Nk
     k = SphericalBessel%vkx(ik)
     w = SphericalBessel%vkw(ik)

     f  = w*SphericalBessel__Jx2 (l,k*r) * Ra(ik)*Rb(ik)
     df = w*SphericalBessel__dJx2(l,k*r) * Ra(ik)*Rb(ik)
     sumdS = sumdS + (df*(k*r) - f*(l+2))
     sumdK = sumdK + (df*(k*r) - f*(l+2))* k*k
  end do

  sumdS = sumdS*4*M_PI/r**(l+4)
  sumdK = sumdK*2*M_PI/r**(l+4)

end subroutine SphericalBessel__integratedSK

subroutine SphericalBessel__deallocate
  use ac_parameter

  implicit none
  if(associated(SphericalBessel%vrx)) deallocate( SphericalBessel%vrx )
  if(associated(SphericalBessel%vrw)) deallocate( SphericalBessel%vrw )
  if(associated(SphericalBessel%vkx)) deallocate( SphericalBessel%vkx )
  if(associated(SphericalBessel%vkw)) deallocate( SphericalBessel%vkw )

  return
end subroutine SphericalBessel__deallocate

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine read_input_tb_cordinate

  use condition_ini
  use scf_negf
  use hamiltonian_c
  use mod_mpi

  implicit none
  real(8) :: ra_temp(3)
  integer :: i_do,j_do,jr_do,i_temp
  integer :: i_r_l,i_r_c,i_r_r

  integer :: i_check,j_check
  character(256) :: buf
  character(50) :: dummy1,dummy2
  character(50) :: tag1,tag2,tag3

  open(unit=16,file=file_tempout,position='append')
  write(16,*)
  write(16,*)
  write(16,*) '********************** **************** **********************'
  write(16,*) '*         input  condition   ! tb- atomic stracture !        *'
  write(16,*) '********************** **************** **********************'
  write(16,*)
  close(16)


  v_l=0.d0
  v_c=0.d0
  v_r=0.d0
  open(unit=19,file=file_parameter_co,status='old')
  do 
     read(19,'(a)',end=100) buf
     if( buf == '' ) then
        cycle
     end if
     read(buf,*) tag1
     if( tag1(1:1) == '#' ) then
        cycle
     end if
     select case(tag1)
     case('tb_bias{')
        do 
           read(19,'(a)',end=100) buf
           if( buf == '' ) then
              cycle
           end if
           read(buf,*) tag2
           if( tag2(1:1) == '#' ) then
              cycle
           end if
           select case(tag2)
           case('left_region')
              read(buf,*) dummy1,dummy2,v_l
           case('junc_region','central_region')
              read(buf,*) dummy1,dummy2,v_c
           case('right_region')
              read(buf,*) dummy1,dummy2,v_r
           case('}tb_bias')
              go to 100
           end select
        end do
     end select
  end do
100 continue
  close(19)

  m_num_block_l=1
  m_num_block_m=1
  m_num_block_r=1
  open(unit=19,file=file_parameter_co,status='old')
  do 
     read(19,'(a)',end=110) buf
     if( buf == '' ) then
        cycle
     end if
     read(buf,*) tag1
     if( tag1(1:1) == '#' ) then
        cycle
     end if
     select case(tag1)
     case('tb_buffer_size{')
        do 
           read(19,'(a)',end=110) buf
           if( buf == '' ) then
              cycle
           end if
           read(buf,*) tag2
           if( tag2(1:1) == '#' ) then
              cycle
           end if
           select case(tag2)
           case('left_region')
              read(buf,*) dummy1,dummy2,m_num_block_l
           case('junc_region','central_region')
              read(buf,*) dummy1,dummy2,m_num_block_m
           case('right_region')
              read(buf,*) dummy1,dummy2,m_num_block_r
           case('}tb_buffer_size')
              go to 110
           end select
        end do
     end select
  end do
110 continue
  close(19)

  r_dis_l=0.d0
  r_dis_r=0.d0
  i_check=0
  j_check=0
  open(unit=19,file=file_parameter_co,status='old')
  do 
     read(19,'(a)',end=120) buf
     if( buf == '' ) then
        cycle
     end if
     read(buf,*) tag1
     if( tag1(1:1) == '#' ) then
        cycle
     end if
     select case(tag1)
     case('tb_distance{')
        do 
           read(19,'(a)',end=120) buf
           if( buf == '' ) then
              cycle
           end if
           read(buf,*) tag2
           if( tag2(1:1) == '#' ) then
              cycle
           end if
           select case(tag2)
           case('between_l_c')
              read(buf,*) dummy1,dummy2,r_dis_l
              i_check=1
           case('between_c_r')
              read(buf,*) dummy1,dummy2,r_dis_r
              j_check=1
           case('}tb_distance')
              go to 120
           end select
        end do
     end select
  end do
120 continue
  close(19)
  if( i_check == 0 ) then
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //distance/between_l_c// => def'
     close(17)
  end if
  if( j_check == 0 ) then
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //distance/between_c_r// => def'
     close(17)
  end if


  num_atom_c=0
  i_r_c=2
  i_check=0
  open(unit=19,file=file_parameter_co,status='old')
  do 
     read(19,'(a)',end=130) buf
     if( buf == '' ) then
        cycle
     end if
     read(buf,*) tag1
     if( tag1(1:1) == '#' ) then
        cycle
     end if
     select case(tag1)
     case('tb_junc_region{','tb_central_region{')
        do 
           read(19,'(a)',end=130) buf
           if( buf == '' ) then
              cycle
           end if
           read(buf,*) tag2
           if( tag2(1:1) == '#' ) then
              cycle
           end if
           select case(tag2)
           case('atom_number')
              read(buf,*) dummy1,dummy2,num_atom_c
           case('coordinate_system')
              read(buf,*) dummy1,dummy2,tag3
              if( tag3 == 'cartesian' ) then
                 i_r_c=0
              end if
              if( tag3 == 'pucv' ) then
                 i_r_c=1
              end if
           case('unit_vector{')
              do
                 read(19,'(a)',end=130) buf
                 if( buf == '' ) then
                    cycle
                 end if
                 read(buf,*) tag2
                 if( tag2(1:1) == '#' ) then
                    cycle
                 end if
                 if( tag2 == '}unit_vector' ) then
                    exit
                 end if
                 i_check=i_check+1
                 i_do=i_check
                 read(buf,*) unit_block_c(i_check,1),unit_block_c(i_check,2)  &
                      ,unit_block_c(i_check,3)
                 if( i_do == 1 ) then
                    if( unit_block_c(i_do,3) /= 0.d0 ) then
                       open(unit=17,file=file_tempout,position='append')
                       write(17,*) 'error unit (m)::: ',unit_block_c(i_do,3)
                       close(17)
                       stop
                    end if
                 end if
                 if( i_do == 2 ) then
                    if( unit_block_c(i_do,3) /= 0.d0 ) then
                       open(unit=17,file=file_tempout,position='append')
                       write(17,*) 'error unit (m)::: ',unit_block_c(i_do,3)
                       close(17)
                       stop
                    end if
                 end if
                 if( i_do == 3 ) then
                    if( unit_block_c(i_do,1) /= 0.d0 ) then
                       open(unit=17,file=file_tempout,position='append')
                       write(17,*) 'error unit (m)::: ',unit_block_c(i_do,1)
                       close(17)
                       stop
                    end if
                    if( unit_block_c(i_do,2) /= 0.d0 ) then
                       open(unit=17,file=file_tempout,position='append')
                       write(17,*) 'error unit (m)::: ',unit_block_c(i_do,2)
                       close(17)
                       stop
                    end if
                 end if
              end do
           case('}tb_junc_region','}tb_central_region')
              go to 130
           end select
        end do
     end select
  end do
130 continue
  close(19)

  if( num_atom_c == 0 ) then
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //junc_region/atom_number// => stop'
     close(17)
     stop
  end if
  if( i_check /= 3 ) then
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //junc_region/unit_vector// => stop'
     close(17)
     stop
  end if
  if( i_r_c == 2 ) then
     i_r_c=0
     open(unit=17,file=file_tempout,position='append')
     write(17,*)                                                              &
          '??? broken ??? //junc_region/coordinate_system// => cartesian'
     close(17)
  end if

  num_atom_l=0
  i_r_l=2
  i_check=0
  p_or_f_l=''
  open(unit=19,file=file_parameter_co,status='old')
  do 
     read(19,'(a)',end=140) buf
     if( buf == '' ) then
        cycle
     end if
     read(buf,*) tag1
     if( tag1(1:1) == '#' ) then
        cycle
     end if
     select case(tag1)
     case('tb_left_region{')
        do 
           read(19,'(a)',end=140) buf
           if( buf == '' ) then
              cycle
           end if
           read(buf,*) tag2
           if( tag2(1:1) == '#' ) then
              cycle
           end if
           select case(tag2)
           case('atom_number')
              read(buf,*) dummy1,dummy2,num_atom_l
           case('boundary')
              read(buf,*) dummy1,dummy2,p_or_f_l
           case('coordinate_system')
              read(buf,*) dummy1,dummy2,tag3
              if( tag3 == 'cartesian' ) then
                 i_r_l=0
              end if
              if( tag3 == 'pucv' ) then
                 i_r_l=1
              end if
           case('unit_vector{')
              do
                 read(19,'(a)',end=140) buf
                 if( buf == '' ) then
                    cycle
                 end if
                 read(buf,*) tag2
                 if( tag2(1:1) == '#' ) then
                    cycle
                 end if
                 if( tag2 == '}unit_vector' ) then
                    exit
                 end if
                 i_check=i_check+1
                 i_do=i_check
                 read(buf,*) unit_block_l(i_check,1),unit_block_l(i_check,2)  &
                      ,unit_block_l(i_check,3)
                 if( i_do == 1 ) then
                    if( unit_block_l(i_do,3) /= 0.d0 ) then
                       open(unit=17,file=file_tempout,position='append')
                       write(17,*) 'error unit (l)::: ',unit_block_l(i_do,3)
                       close(17)
                       stop
                    end if
                 end if
                 if( i_do == 2 ) then
                    if( unit_block_l(i_do,3) /= 0.d0 ) then
                       open(unit=17,file=file_tempout,position='append')
                       write(17,*) 'error unit (l)::: ',unit_block_l(i_do,3)
                       close(17)
                       stop
                    end if
                 end if
                 if( i_do == 3 ) then
                    if( unit_block_l(i_do,1) /= 0.d0 ) then
                       open(unit=17,file=file_tempout,position='append')
                       write(17,*) 'error unit (l)::: ',unit_block_l(i_do,1)
                       close(17)
                       stop
                    end if
                    if( unit_block_l(i_do,2) /= 0.d0 ) then
                       open(unit=17,file=file_tempout,position='append')
                       write(17,*) 'error unit (l)::: ',unit_block_l(i_do,2)
                       close(17)
                       stop
                    end if
                 end if
              end do
           case('}tb_left_region')
              go to 140
           end select
        end do
     end select
  end do
140 continue
  close(19)

  if( num_atom_l == 0 ) then
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //left_region/atom_number// => stop'
     close(17)
     stop
  end if
  if( i_check /= 3 ) then
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //left_region/unit_vector// => stop'
     close(17)
     stop
  end if
  if( p_or_f_l == '' ) then
     p_or_f_l='free'
  end if
  if( i_r_l == 2 ) then
     i_r_l=0
     open(unit=17,file=file_tempout,position='append')
     write(17,*)                                                              &
          '??? broken ??? //left_region/coordinate_system// => cartesian'
     close(17)
  end if

  num_atom_r=0
  i_r_r=2
  i_check=0
  p_or_f_r=''
  open(unit=19,file=file_parameter_co,status='old')
  do 
     read(19,'(a)',end=150) buf
     if( buf == '' ) then
        cycle
     end if
     read(buf,*) tag1
     if( tag1(1:1) == '#' ) then
        cycle
     end if
     select case(tag1)
     case('tb_right_region{')
        do 
           read(19,'(a)',end=150) buf
           if( buf == '' ) then
              cycle
           end if
           read(buf,*) tag2
           if( tag2(1:1) == '#' ) then
              cycle
           end if
           select case(tag2)
           case('atom_number')
              read(buf,*) dummy1,dummy2,num_atom_r
           case('boundary')
              read(buf,*) dummy1,dummy2,p_or_f_r
           case('coordinate_system')
              read(buf,*) dummy1,dummy2,tag3
              if( tag3 == 'cartesian' ) then
                 i_r_r=0
              end if
              if( tag3 == 'pucv' ) then
                 i_r_r=1
              end if
           case('unit_vector{')
              do
                 read(19,'(a)',end=150) buf
                 if( buf == '' ) then
                    cycle
                 end if
                 read(buf,*) tag2
                 if( tag2(1:1) == '#' ) then
                    cycle
                 end if
                 if( tag2 == '}unit_vector' ) then
                    exit
                 end if
                 i_check=i_check+1
                 i_do=i_check
                 read(buf,*) unit_block_r(i_check,1),unit_block_r(i_check,2)  &
                      ,unit_block_r(i_check,3)
                 if( i_do == 1 ) then
                    if( unit_block_r(i_do,3) /= 0.d0 ) then
                       open(unit=17,file=file_tempout,position='append')
                       write(17,*) 'error unit (r)::: ',unit_block_r(i_do,3)
                       close(17)
                       stop
                    end if
                 end if
                 if( i_do == 2 ) then
                    if( unit_block_r(i_do,3) /= 0.d0 ) then
                       open(unit=17,file=file_tempout,position='append')
                       write(17,*) 'error unit (r)::: ',unit_block_r(i_do,3)
                       close(17)
                       stop
                    end if
                 end if
                 if( i_do == 3 ) then
                    if( unit_block_r(i_do,1) /= 0.d0 ) then
                       open(unit=17,file=file_tempout,position='append')
                       write(17,*) 'error unit (r)::: ',unit_block_r(i_do,1)
                       close(17)
                       stop
                    end if
                    if( unit_block_r(i_do,2) /= 0.d0 ) then
                       open(unit=17,file=file_tempout,position='append')
                       write(17,*) 'error unit (r)::: ',unit_block_r(i_do,2)
                       close(17)
                       stop
                    end if
                 end if
              end do
           case('}tb_right_region')
              go to 150
           end select
        end do
     end select
  end do
150 continue
  close(19)

  if( num_atom_r == 0 ) then
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //right_region/atom_number// => stop'
     close(17)
     stop
  end if
  if( i_check /= 3 ) then
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //right_region/unit_vector// => stop'
     close(17)
     stop
  end if
  if( p_or_f_r == '' ) then
     p_or_f_r='free'
  end if
  if( i_r_r == 2 ) then
     i_r_r=0
     open(unit=17,file=file_tempout,position='append')
     write(17,*)                                                              &
          '??? broken ??? //right_region/coordinate_system// => cartesian'
     close(17)
  end if

  call alo_input_condition_3
  call alo_input_condition_4
  call alo_input_condition_5


  i_check=0
  open(unit=19,file=file_parameter_co,status='old')
  do 
     read(19,'(a)',end=160) buf
     if( buf == '' ) then
        cycle
     end if
     read(buf,*) tag1
     if( tag1(1:1) == '#' ) then
        cycle
     end if
     select case(tag1)
     case('tb_junc_region{','tb_central_region{')
        do 
           read(19,'(a)',end=160) buf
           if( buf == '' ) then
              cycle
           end if
           read(buf,*) tag2
           if( tag2(1:1) == '#' ) then
              cycle
           end if
           select case(tag2)
           case('atom_list{')
              do
                 read(19,'(a)',end=160) buf
                 if( buf == '' ) then
                    cycle
                 end if
                 read(buf,*) tag2
                 if( tag2(1:1) == '#' ) then
                    cycle
                 end if
                 if( tag2 == '}atom_list' ) then
                    exit
                 end if
                 i_check=i_check+1
                 i_do=i_check
                 read(buf,*) i_temp,atom_kind_c(i_do)                         &
                      ,ra_temp(1),ra_temp(2),ra_temp(3)
                 if( i_r_c == 1 ) then
                    do jr_do=1,3
                       ra_c(i_do,jr_do)=ra_temp(1)*unit_block_c(1,jr_do)        &
                            +ra_temp(2)*unit_block_c(2,jr_do)        &
                            +ra_temp(3)*unit_block_c(3,jr_do)
                    end do
                 else
                    if( i_r_c == 0 ) then
                       ra_c(i_do,1)=ra_temp(1)
                       ra_c(i_do,2)=ra_temp(2)
                       ra_c(i_do,3)=ra_temp(3)
                    else
                       write(6,*) 'error _ r-c'
                    end if
                 end if
                 do j_do=1,num_atom_kind_ini
                    if( atom_kind_c(i_do) == atom_sign_ini(j_do) ) then
                       atom_kindn_c(i_do)=j_do
                       exit
                    end if
                 end do
              end do
           case('}tb_junc_region','}tb_central_region')
              go to 160
           end select
        end do
     end select
  end do
160 continue
  close(19)

  if( num_atom_c /= i_check ) then
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //junc_region/atom_list// => stop'
     close(17)
     stop
  end if

  num_unit_l(3)=1
  neighbor_z_max_l=1

  num_unit_l(1)=1
  num_unit_l(2)=1
  neighbor_x_max_l=1
  neighbor_y_max_l=1
  kx_max_l=1
  ky_max_l=1
  i_check=0
  open(unit=19,file=file_parameter_co,status='old')
  do 
     read(19,'(a)',end=170) buf
     if( buf == '' ) then
        cycle
     end if
     read(buf,*) tag1
     if( tag1(1:1) == '#' ) then
        cycle
     end if
     select case(tag1)
     case('tb_left_region{')
        do 
           read(19,'(a)',end=170) buf
           if( buf == '' ) then
              cycle
           end if
           read(buf,*) tag2
           if( tag2(1:1) == '#' ) then
              cycle
           end if
           select case(tag2)
           case('buffer_a')
              read(buf,*) dummy1,dummy2,num_unit_l(1)
           case('buffer_b')
              read(buf,*) dummy1,dummy2,num_unit_l(2)
           case('ka_max')
              read(buf,*) dummy1,dummy2,kx_max_l
           case('kb_max')
              read(buf,*) dummy1,dummy2,ky_max_l
           case('neighbor_a_max')
              read(buf,*) dummy1,dummy2,neighbor_x_max_l
           case('neighbor_b_max')
              read(buf,*) dummy1,dummy2,neighbor_y_max_l
           case('atom_list{')
              do
                 read(19,'(a)',end=170) buf
                 if( buf == '' ) then
                    cycle
                 end if
                 read(buf,*) tag2
                 if( tag2(1:1) == '#' ) then
                    cycle
                 end if
                 if( tag2 == '}atom_list' ) then
                    exit
                 end if
                 i_check=i_check+1
                 i_do=i_check
                 read(buf,*) i_temp,atom_kind_l(i_do)                         &
                      ,ra_temp(1),ra_temp(2),ra_temp(3)
                 if( i_r_l == 1 ) then
                    do jr_do=1,3
                       ra_l(i_do,jr_do)=ra_temp(1)*unit_block_l(1,jr_do)        &
                            +ra_temp(2)*unit_block_l(2,jr_do)        &
                            +ra_temp(3)*unit_block_l(3,jr_do)
                       if( jr_do == 3 ) then
                          ra_l(i_do,jr_do)=ra_l(i_do,jr_do)-unit_block_l(3,3)
                       end if
                    end do
                 else
                    if( i_r_l == 0 ) then
                       ra_l(i_do,1)=ra_temp(1)
                       ra_l(i_do,2)=ra_temp(2)
                       ra_l(i_do,3)=ra_temp(3)-unit_block_l(3,3)
                    else
                       write(6,*) 'error _ r-l'
                    end if
                 end if
                 do j_do=1,num_atom_kind_ini
                    if( atom_kind_l(i_do) == atom_sign_ini(j_do) ) then
                       atom_kindn_l(i_do)=j_do
                       exit
                    end if
                 end do
              end do
           case('}tb_left_region')
              go to 170
           end select
        end do
     end select
  end do
170 continue
  close(19)

  if( num_atom_l /= i_check ) then
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //left_region/atom_list// => stop'
     close(17)
     stop
  end if
  if( p_or_f_l == 'free' .and. num_unit_l(1) == 0 ) then
     num_unit_l(1)=1
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //left_region/buffer_a// => def'
     close(17)
  end if
  if( p_or_f_l == 'free' .and. num_unit_l(2) == 0 ) then
     num_unit_l(2)=1
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //left_region/buffer_b// => def'
     close(17)
  end if
  if( p_or_f_l == 'periodic' .and. neighbor_x_max_l == 0 ) then
     neighbor_x_max_l=1
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //left_region/neighbor_a_max// => def'
     close(17)
  end if
  if( p_or_f_l == 'periodic' .and. neighbor_y_max_l == 0 ) then
     neighbor_y_max_l=1
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //left_region/neighbor_b_max// => def'
     close(17)
  end if
  if( p_or_f_l == 'periodic' .and. kx_max_l == 0 ) then
     kx_max_l=1
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //left_region/ka_max// => def'
     close(17)
  end if
  if( p_or_f_l == 'periodic' .and. ky_max_l == 0 ) then
     ky_max_l=1
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //left_region/kb_max// => def'
     close(17)
  end if
  if( p_or_f_l == 'free' ) then
     neighbor_x_max_l=1
     neighbor_y_max_l=1
     kx_max_l=1
     ky_max_l=1
  end if
  if( p_or_f_l == 'periodic' ) then
     num_unit_l(1)=1
     num_unit_l(2)=1
  end if

  num_unit_r(3)=1
  neighbor_z_max_r=1

  num_unit_r(1)=1
  num_unit_r(2)=1
  neighbor_x_max_r=1
  neighbor_y_max_r=1
  kx_max_r=1
  ky_max_r=1
  i_check=0
  open(unit=19,file=file_parameter_co,status='old')
  do 
     read(19,'(a)',end=180) buf
     if( buf == '' ) then
        cycle
     end if
     read(buf,*) tag1
     if( tag1(1:1) == '#' ) then
        cycle
     end if
     select case(tag1)
     case('tb_right_region{')
        do 
           read(19,'(a)',end=180) buf
           if( buf == '' ) then
              cycle
           end if
           read(buf,*) tag2
           if( tag2(1:1) == '#' ) then
              cycle
           end if
           select case(tag2)
           case('buffer_a')
              read(buf,*) dummy1,dummy2,num_unit_r(1)
           case('buffer_b')
              read(buf,*) dummy1,dummy2,num_unit_r(2)
           case('ka_max')
              read(buf,*) dummy1,dummy2,kx_max_r
           case('kb_max')
              read(buf,*) dummy1,dummy2,ky_max_r
           case('neighbor_a_max')
              read(buf,*) dummy1,dummy2,neighbor_x_max_r
           case('neighbor_b_max')
              read(buf,*) dummy1,dummy2,neighbor_y_max_r
           case('atom_list{')
              do
                 read(19,'(a)',end=180) buf
                 if( buf == '' ) then
                    cycle
                 end if
                 read(buf,*) tag2
                 if( tag2(1:1) == '#' ) then
                    cycle
                 end if
                 if( tag2 == '}atom_list' ) then
                    exit
                 end if
                 i_check=i_check+1
                 i_do=i_check
                 read(buf,*) i_temp,atom_kind_r(i_do)                         &
                      ,ra_temp(1),ra_temp(2),ra_temp(3)
                 if( i_r_r == 1 ) then
                    do jr_do=1,3
                       ra_r(i_do,jr_do)=ra_temp(1)*unit_block_r(1,jr_do)        &
                            +ra_temp(2)*unit_block_r(2,jr_do)        &
                            +ra_temp(3)*unit_block_r(3,jr_do)
                    end do
                 else
                    if( i_r_r == 0 ) then
                       ra_r(i_do,1)=ra_temp(1)
                       ra_r(i_do,2)=ra_temp(2)
                       ra_r(i_do,3)=ra_temp(3)
                    else
                       write(6,*) 'error _ r-r'
                    end if
                 end if
                 do j_do=1,num_atom_kind_ini
                    if( atom_kind_r(i_do) == atom_sign_ini(j_do) ) then
                       atom_kindn_r(i_do)=j_do
                       exit
                    end if
                 end do
              end do
           case('}tb_right_region')
              go to 180
           end select
        end do
     end select
  end do
180 continue
  close(19)

  if( num_atom_r /= i_check ) then
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //right_region/atom_list// => stop'
     close(17)
     stop
  end if
  if( p_or_f_r == 'free' .and. num_unit_r(1) == 0 ) then
     num_unit_r(1)=1
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //right_region/buffer_a// => def'
     close(17)
  end if
  if( p_or_f_r == 'free' .and. num_unit_r(2) == 0 ) then
     num_unit_r(2)=1
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //right_region/buffer_b// => def'
     close(17)
  end if
  if( p_or_f_r == 'periodic' .and. neighbor_x_max_r == 0 ) then
     neighbor_x_max_r=1
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //right_region/neighbor_a_max// => def'
     close(17)
  end if
  if( p_or_f_r == 'periodic' .and. neighbor_y_max_r == 0 ) then
     neighbor_y_max_r=1
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //right_region/neighbor_b_max// => def'
     close(17)
  end if
  if( p_or_f_r == 'periodic' .and. kx_max_r == 0 ) then
     kx_max_r=1
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //right_region/ka_max// => def'
     close(17)
  end if
  if( p_or_f_r == 'periodic' .and. ky_max_r == 0 ) then
     ky_max_r=1
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //right_region/kb_max// => def'
     close(17)
  end if
  if( p_or_f_r == 'free' ) then
     neighbor_x_max_r=1
     neighbor_y_max_r=1
     kx_max_r=1
     ky_max_r=1
  end if
  if( p_or_f_r == 'periodic' ) then
     num_unit_r(1)=1
     num_unit_r(2)=1
  end if


  open(unit=16,file=file_tempout,position='append')

  write(16,*)
  write(16,*)                                                               &
       '====================== atomic stracture ======================'
  write(16,*) '                z:  direction of transport                '
  write(16,*)
  do i_do=1,num_atom_kind_ini
     write(16,909) i_do,atom_sign_ini(i_do)
  end do
909 format('                atom_kind: ',i4,5x,a5)

  write(16,*)
  if( p_or_f_l /= 'free' .or. p_or_f_r /= 'free' ) then
     write(16,920) p_or_f_l,p_or_f_r
920  format('  boundary condition(l,r): ',a10,a10)
  end if
  if( p_or_f_l == 'free'                                                     &
       .and. ( num_unit_l(1) /= 1 .or. num_unit_l(2) /= 1 ) ) then
     write(16,933) num_unit_l(1),num_unit_l(2)
933  format(' buffer size / left/(a,b): ',i5,i5)
  end if
  if( p_or_f_r == 'free'                                                     &
       .and. ( num_unit_r(1) /= 1 .or. num_unit_r(2) /= 1 ) ) then
     write(16,932) num_unit_r(1),num_unit_r(2)
932  format(' buffer size /right/(a,b): ',i5,i5)
  end if
  if( p_or_f_l == 'periodic' ) then
     write(16,921) kx_max_l,ky_max_l
921  format('k-point mesh / left/(a,b): ',i5,i5)
     write(16,934) neighbor_x_max_l,neighbor_y_max_l
934  format('neighbor_max / left/(a,b): ',i5,i5)
  end if
  if( p_or_f_r == 'periodic' ) then
     write(16,922) kx_max_r,ky_max_r
922  format('k-point mesh /right/(a,b): ',i5,i5)
     write(16,935) neighbor_x_max_r,neighbor_y_max_r
935  format('neighbor_max /right/(a,b): ',i5,i5)
  end if

  write(16,*)
  write(16,913) r_dis_l,r_dis_r
913 format('            distance(l,r): ',f10.5,f10.5,'  (Ang)')
  write(16,912) m_num_block_l,m_num_block_m,m_num_block_r
912 format('       buffer size(l,m,r): ',i5,i5,i5)
  if( dabs(v_l)+dabs(v_c)+dabs(v_r) > 1.d-10 ) then
     write(16,930) v_l,v_c,v_r
930  format('              bias(l,m,r): ',f8.3,f8.3,f8.3,'  (V)')
  end if

  write(16,*) 
  write(16,*)                                                                &
       '++++++++++++++++++++++   unit    cell   ++++++++++++++++++++++'
  write(16,*)

  write(16,*) '  ---  left   (Ang) ---'
  do i_do=1,3
     write(16,910) unit_block_l(i_do,1),unit_block_l(i_do,2)                  &
          ,unit_block_l(i_do,3)
  end do
  write(16,*) 
  write(16,*) '  ---  right  (Ang) ---'
  do i_do=1,3
     write(16,910) unit_block_r(i_do,1),unit_block_r(i_do,2)                  &
          ,unit_block_r(i_do,3)
  end do
  write(16,*) 
  write(16,*) '  ---  junc   (Ang) ---'
  do i_do=1,3
     write(16,910) unit_block_c(i_do,1),unit_block_c(i_do,2)                  &
          ,unit_block_c(i_do,3)
  end do
910 format(10x,f10.5,f10.5,f10.5)

  write(16,*) 
  write(16,*)                                                                &
       '++++++++++++++++++++++    coordinate    ++++++++++++++++++++++'
  write(16,*)
  write(16,931) num_atom_l,num_atom_c,num_atom_r
931 format('    number of atom(l,m,r): ',i5,i5,i5)
  write(16,*)
  write(16,*) '  ---  left   (Ang) ---'
  do i_do=1,num_atom_l
     write(16,911) i_do,atom_kind_l(i_do)                                     &
          ,ra_l(i_do,1),ra_l(i_do,2),ra_l(i_do,3)+unit_block_l(3,3)
  end do

  write(16,*)
  write(16,*) '  ---  right  (Ang) ---'
  do i_do=1,num_atom_r
     write(16,911) i_do,atom_kind_r(i_do)                                     &
          ,ra_r(i_do,1),ra_r(i_do,2),ra_r(i_do,3)
  end do
  write(16,*) 
  write(16,*) '  ---  junc   (Ang) ---'
  do i_do=1,num_atom_c
     write(16,911) i_do,atom_kind_c(i_do)                                     &
          ,ra_c(i_do,1),ra_c(i_do,2),ra_c(i_do,3)
  end do
911 format(10x,i5,5x,a5,f10.5,f10.5,f10.5)

  write(16,*)

  close(16)


  if( p_or_f_l == 'free' ) then
     kx_max_l=1
     ky_max_l=1
  end if
  if( p_or_f_r == 'free' ) then
     kx_max_r=1
     ky_max_r=1
  end if
  spin_switch_cc=1

  return
end subroutine read_input_tb_cordinate

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine set_hamiltonian_temp(file_parameter1,file_parameter2,file_parameter3)

  use hamiltonian_sgf
  use hamiltonian_c
  use hamiltonian_temp

  implicit none
  include 'mpif.h'
  character(50), intent(in) :: file_parameter1,file_parameter2,file_parameter3
  real(8) :: vv_temp
  integer :: i_spin_temp

  vv_temp=0.d0
  i_spin_temp=0

  call set_ham_negf_c(file_parameter1)
  call set_ham_negf_l(file_parameter2,vv_temp,i_spin_temp)
  call set_ham_negf_r(file_parameter3,vv_temp,i_spin_temp)

  if( spin_ll /= spin_cc .or. spin_cc /= spin_rr ) then
     write(6,*) 'error: spin1',spin_ll,spin_cc,spin_rr
     stop
  end if

  return
end subroutine set_hamiltonian_temp

subroutine set_ham_negf_c1(file_parameter)
  use hamiltonian_sgf
  use hamiltonian_c
  use hamiltonian_temp
  use scf_negf
  use mod_mpi

  implicit none
  character(50), intent(in) :: file_parameter

  logical :: ex
  integer :: l
  character(55) :: fname1

  open(unit=16,file=file_tempout,position='append')
  write(16,*) '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'
  write(16,*) '+++++++++++        loading hamiltonian matrices: scattering'
  write(16,999) trim(file_parameter)
  write(16,*) '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'
999 format(' +++++++++++        read file:: ',a)
  close(16)

  fname1=trim(file_parameter)//'_0001'
  inquire(file=fname1,exist=ex)
  if( .not. ex ) then
     open(unit=16,file=file_tempout,position='append')
     write(16,'(a,a)') '      ++++++ Error!: can not open file ', fname1
     close(16)
     stop
  end if
  inquire(file=fname1,exist=ex)
  open(unit=19,file=fname1,status='old')
  read(19,*) natom_ac_ct,natom_ac_cl,natom_ac_cr,nl_ac_c,spin_cc             &
       ,m_mat_max_l,m_mat_max_c,m_mat_max_r
  read(19,*) cell_tempabc(1,1),cell_tempabc(1,2),cell_tempabc(1,3)
  read(19,*) cell_tempabc(2,1),cell_tempabc(2,2),cell_tempabc(2,3)
  read(19,*) cell_tempabc(3,1),cell_tempabc(3,2),cell_tempabc(3,3)
  close(19)
  spin_cc=spin_cc+1
  spin_switch_cc=spin_cc

  if( ispin_pol_scf /= spin_switch_cc ) then
     open(unit=16,file=file_tempout,position='append')
     write(16,'(a,a)') '      ++++++ Error!: spin ...'                        &
          ,ispin_pol_scf,spin_switch_cc
     close(16)
     stop
  end if

  call alo_ham_negf_type_c1

  do l=1,param_cell_nl
     rac_c(1,l)=param_cell_vl(l,1)
     rac_c(2,l)=param_cell_vl(l,2)
     rac_c(3,l)=param_cell_vl(l,3)
  end do

  return
end subroutine set_ham_negf_c1

subroutine set_ham_negf_c(file_parameter)
  use hamiltonian_sgf
  use hamiltonian_c
  use hamiltonian_temp
  use mod_mpi

  implicit none
  character(50), intent(in) :: file_parameter

  logical :: ex

  integer :: l,a,b,l_t,a_t,b_t,i1,j1
  integer :: i2,i_temp1,i_temp2
  real(8) :: temp1,temp2,temp3,temp4
  character(1) :: character_temp(4),a_c(10)
  character(55) :: fname,fname1

  open(unit=16,file=file_tempout,position='append')
  write(16,*) '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'
  write(16,*) '+++++++++++        loading hamiltonian matrices: scattering'
  write(16,999) trim(file_parameter)
  write(16,*) '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'
999 format(' +++++++++++        read file:: ',a)
  close(16)

  fname1=trim(file_parameter)//'_0001'
  inquire(file=fname1,exist=ex)
  if( .not. ex ) then
     open(unit=16,file=file_tempout,position='append')
     write(16,'(a,a)') '      ++++++ Error!: can not open file ', fname1
     close(16)
     stop
  end if
  inquire(file=fname1,exist=ex)
  open(unit=19,file=fname1,status='old')
  read(19,*) natom_ac_ct,natom_ac_cl,natom_ac_cr,nl_ac_c,spin_cc             &
       ,m_mat_max_l,m_mat_max_c,m_mat_max_r
  read(19,*) cell_tempabc(1,1),cell_tempabc(1,2),cell_tempabc(1,3)
  read(19,*) cell_tempabc(2,1),cell_tempabc(2,2),cell_tempabc(2,3)
  read(19,*) cell_tempabc(3,1),cell_tempabc(3,2),cell_tempabc(3,3)
  close(19)
  spin_cc=spin_cc+1
  spin_switch_cc=spin_cc
  call alo_ham_negf_type_c1

  a_c(1)='0'
  a_c(2)='1'
  a_c(3)='2'
  a_c(4)='3'
  a_c(5)='4'
  a_c(6)='5'
  a_c(7)='6'
  a_c(8)='7'
  a_c(9)='8'
  a_c(10)='9'

  do a=myrank+1,natom_ac_ct,nprocs

     i_temp1=a
     do i2=1,4
        i_temp2=i_temp1/(10**(4-i2))
        character_temp(i2)=a_c(i_temp2+1)
        i_temp1=i_temp1-(10**(4-i2))*i_temp2
     end do
     fname=trim(file_parameter)//'_'//character_temp(1)//character_temp(2)     &
          //character_temp(3)//character_temp(4)
     inquire(file=fname,exist=ex)
     if( .not. ex ) then
        open(unit=16,file=file_tempout,position='append')
        write(16,'(a,a)') '      ++++++ Error!: can not open file ', fname
        close(16)
        stop
     end if

     open(unit=19,file=fname,status='old')
     read(19,*) 
     read(19,*) 
     read(19,*) 
     read(19,*) 
     do l=1,nl_ac_c
        do b=1,natom_ac_ct
           read(19,*)
           read(19,*) a_t,l_t,b_t,i_over_c(b,a,l),i_orb_c(a),i_orb_c(b)
           read(19,*) rac_c(1,l),rac_c(2,l),rac_c(3,l)

           if(l/=l_t+1) then
              open(unit=16,file=file_tempout,position='append')
              write(16,'(a,a)') '      ++++++ Error!: l ', fname
              close(16)
              stop
           end if
           if(a/=a_t+1) then
              open(unit=16,file=file_tempout,position='append')
              write(16,'(a,a)') '      ++++++ Error!: a ', fname
              close(16)
              stop
           end if
           if(b/=b_t+1) then
              open(unit=16,file=file_tempout,position='append')
              write(16,'(a,a)') '      ++++++ Error!: b ', fname
              close(16)
              stop
           end if

           if( i_over_c(b,a,l) == 1 ) then
              cycle
           end if

           call alo_ham_negf_type_c2(a,b,l,i_orb_c(a),i_orb_c(b))

           do i1=1,i_orb_c(a)
              do j1=1,i_orb_c(b)
                 if( spin_cc == 1 ) then
                    read(19,*) ht_hs_c(b,a,l)%s(j1,i1),temp2                       &
                         ,ht_hs_c(b,a,l)%h(1,j1,i1) 
                 else
                    if( spin_cc == 2 ) then
                       read(19,*) ht_hs_c(b,a,l)%s(j1,i1),temp2                     &
                            ,ht_hs_c(b,a,l)%h(1,j1,i1),ht_hs_c(b,a,l)%h(2,j1,i1)
                    else
                       read(19,*) ht_hs_c(b,a,l)%s(j1,i1)
                       read(19,*)
                       read(19,*)
                       read(19,*) temp1,temp2,temp3,temp4
                       ht_hs_c(b,a,l)%hls(1,j1,i1)=dcmplx(temp1,temp2)
                       ht_hs_c(b,a,l)%hls(2,j1,i1)=dcmplx(temp3,temp4)
                       read(19,*) temp1,temp2,temp3,temp4
                       ht_hs_c(b,a,l)%hls(3,j1,i1)=dcmplx(temp1,temp2)
                       ht_hs_c(b,a,l)%hls(4,j1,i1)=dcmplx(temp3,temp4)
                       read(19,*)
                       read(19,*)
                    end if
                 end if
              end do
           end do
        end do
     end do
     close(19)
  end do

  return
end subroutine set_ham_negf_c

subroutine set_ham_negf_l(file_parameter,vv_temp,i_rotspin_l)
  use hamiltonian_sgf
  use hamiltonian_c
  use hamiltonian_temp
  use constant
  use mod_mpi

  implicit none
  character(50), intent(in) :: file_parameter
  integer, intent(in) :: i_rotspin_l
  real(8), intent(in) :: vv_temp

  logical :: ex

  integer :: l,a,b,l_t,a_t,b_t,i1,j1
  integer :: i2,i_temp1,i_temp2
  real(8) :: temp1,temp2,temp3,temp4
  character(1) :: character_temp(4),a_c(10)
  character(55) :: fname,fname1

  open(unit=16,file=file_tempout,position='append')
  write(16,*) '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'
  write(16,*) '+++++++++++        loading hamiltonian matrices: left lead'
  write(16,999) trim(file_parameter)
  write(16,*) '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'
999 format(' +++++++++++        read file:: ',a)
  close(16)

  fname1=trim(file_parameter)//'_0001'
  inquire(file=fname1,exist=ex)
  if( .not. ex ) then
     open(unit=16,file=file_tempout,position='append')
     write(16,'(a,a)') '      ++++++ Error!: can not open file ', fname1
     close(16)
     stop
  end if
  open(unit=19,file=fname1,status='old')
  read(19,*) natom_ac_lt,natom_ac_ll,natom_ac_lr,nl_ac_l,spin_ll             &
       ,mat_max_ll,i_temp1,i_temp2,ele_num_ll,temp1
  spin_ll=spin_ll+1
  close(19)
  call alo_ham_negf_type_l1

  a_c(1)='0'
  a_c(2)='1'
  a_c(3)='2'
  a_c(4)='3'
  a_c(5)='4'
  a_c(6)='5'
  a_c(7)='6'
  a_c(8)='7'
  a_c(9)='8'
  a_c(10)='9'

  do a=myrank+1,natom_ac_lt,nprocs

     i_temp1=a
     do i2=1,4
        i_temp2=i_temp1/(10**(4-i2))
        character_temp(i2)=a_c(i_temp2+1)
        i_temp1=i_temp1-(10**(4-i2))*i_temp2
     end do
     fname=trim(file_parameter)//'_'//character_temp(1)//character_temp(2)     &
          //character_temp(3)//character_temp(4)
     inquire(file=fname,exist=ex)
     if( .not. ex ) then
        open(unit=16,file=file_tempout,position='append')
        write(16,'(a,a)') '      ++++++ Error!: can not open file ', fname
        close(16)
        stop
     end if

     open(unit=19,file=fname,status='old')
     read(19,*)
     read(19,*) 
     read(19,*) 
     read(19,*) 

     do l=1,nl_ac_l
        do b=1,natom_ac_lt
           read(19,*)
           read(19,*) a_t,l_t,b_t,i_over_l(b,a,l),i_orb_l(a),i_orb_l(b)
           read(19,*) rac_l(1,l),rac_l(2,l),rac_l(3,l)

           if(l/=l_t+1) then
              open(unit=16,file=file_tempout,position='append')
              write(16,'(a,a)') '      ++++++ Error!: l ', fname
              close(16)
              stop
           end if
           if(a/=a_t+1) then
              open(unit=16,file=file_tempout,position='append')
              write(16,'(a,a)') '      ++++++ Error!: a ', fname
              close(16)
              stop
           end if
           if(b/=b_t+1) then
              open(unit=16,file=file_tempout,position='append')
              write(16,'(a,a)') '      ++++++ Error!: b ', fname
              close(16)
              stop
           end if

           if( i_over_l(b,a,l) == 1 ) then
              cycle
           end if

           call alo_ham_negf_type_l2(a,b,l,i_orb_l(a),i_orb_l(b))

           do i1=1,i_orb_l(a)
              do j1=1,i_orb_l(b)
                 if( spin_ll == 1 ) then
                    read(19,*) ht_hs_l(b,a,l)%s(j1,i1),temp2                       &
                         ,ht_hs_l(b,a,l)%h(1,j1,i1)
                    ht_hs_l(b,a,l)%h(1,j1,i1)=ht_hs_l(b,a,l)%h(1,j1,i1)            &
                         +vv_temp*ht_hs_l(b,a,l)%s(j1,i1)/ene_scale
                 else
                    if( spin_cc == 2 ) then
                       if( i_rotspin_l == 0 ) then
                          read(19,*) ht_hs_l(b,a,l)%s(j1,i1),temp2                   &
                               ,ht_hs_l(b,a,l)%h(1,j1,i1),ht_hs_l(b,a,l)%h(2,j1,i1)
                       else
                          read(19,*) ht_hs_l(b,a,l)%s(j1,i1),temp2                   &
                               ,ht_hs_l(b,a,l)%h(2,j1,i1),ht_hs_l(b,a,l)%h(1,j1,i1)
                       end if
                       ht_hs_l(b,a,l)%h(1,j1,i1)=ht_hs_l(b,a,l)%h(1,j1,i1)          &
                            +vv_temp*ht_hs_l(b,a,l)%s(j1,i1)/ene_scale
                       ht_hs_l(b,a,l)%h(2,j1,i1)=ht_hs_l(b,a,l)%h(2,j1,i1)          &
                            +vv_temp*ht_hs_l(b,a,l)%s(j1,i1)/ene_scale
                    else
                       read(19,*) ht_hs_l(b,a,l)%s(j1,i1)
                       read(19,*)
                       read(19,*)
                       read(19,*) temp1,temp2,temp3,temp4
                       ht_hs_l(b,a,l)%hls(1,j1,i1)                                  &
                            =dcmplx(temp1+vv_temp*ht_hs_l(b,a,l)%s(j1,i1)/ene_scale &
                            ,temp2)
                       ht_hs_l(b,a,l)%hls(2,j1,i1)=dcmplx(temp3,temp4)
                       read(19,*) temp1,temp2,temp3,temp4
                       ht_hs_l(b,a,l)%hls(3,j1,i1)=dcmplx(temp1,temp2)
                       ht_hs_l(b,a,l)%hls(4,j1,i1)                                  &
                            =dcmplx(temp3+vv_temp*ht_hs_l(b,a,l)%s(j1,i1)/ene_scale &
                            ,temp4)
                       read(19,*)
                       read(19,*)
                    end if
                 end if
              end do
           end do
        end do
     end do

     close(19)
  end do

  return
end subroutine set_ham_negf_l

subroutine set_ham_negf_r(file_parameter,vv_temp,i_rotspin_r)
  use hamiltonian_sgf
  use hamiltonian_c
  use hamiltonian_temp
  use constant
  use mod_mpi

  implicit none
  character(50), intent(in) :: file_parameter
  integer, intent(in) :: i_rotspin_r
  real(8), intent(in) :: vv_temp

  logical :: ex

  integer :: l,a,b,l_t,a_t,b_t,i1,j1
  integer :: i2,i_temp1,i_temp2
  real(8) :: temp1,temp2,temp3,temp4
  character(1) :: character_temp(4),a_c(10)
  character(55) :: fname,fname1

  open(unit=16,file=file_tempout,position='append')
  write(16,*) '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'
  write(16,*) '+++++++++++        loading hamiltonian matrices: right lead'
  write(16,999) trim(file_parameter)
  write(16,*) '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'
999 format(' +++++++++++        read file:: ',a)
  close(16)

  fname1=trim(file_parameter)//'_0001'
  inquire(file=fname1,exist=ex)
  if( .not. ex ) then
     open(unit=16,file=file_tempout,position='append')
     write(16,'(a,a)') '      ++++++ Error!: can not open file ', fname1
     close(16)
     stop
  end if
  open(unit=19,file=fname1,status='old')
  read(19,*) natom_ac_rt,natom_ac_rl,natom_ac_rr,nl_ac_r,spin_rr             &
       ,i_temp1,i_temp2,mat_max_rr,temp1,ele_num_rr
  spin_rr=spin_rr+1
  close(19)
  call alo_ham_negf_type_r1

  a_c(1)='0'
  a_c(2)='1'
  a_c(3)='2'
  a_c(4)='3'
  a_c(5)='4'
  a_c(6)='5'
  a_c(7)='6'
  a_c(8)='7'
  a_c(9)='8'
  a_c(10)='9'

  do a=myrank+1,natom_ac_rt,nprocs

     i_temp1=a
     do i2=1,4
        i_temp2=i_temp1/(10**(4-i2))
        character_temp(i2)=a_c(i_temp2+1)
        i_temp1=i_temp1-(10**(4-i2))*i_temp2
     end do
     fname=trim(file_parameter)//'_'//character_temp(1)//character_temp(2)     &
          //character_temp(3)//character_temp(4)
     inquire(file=fname,exist=ex)
     if( .not. ex ) then
        open(unit=16,file=file_tempout,position='append')
        write(16,'(a,a)') '      ++++++ Error!: can not open file ', fname
        close(16)
        stop
     end if

     open(unit=19,file=fname,status='old')
     read(19,*) 
     read(19,*) 
     read(19,*) 
     read(19,*) 

     do l=1,nl_ac_r
        do b=1,natom_ac_rt
           read(19,*)
           read(19,*) a_t,l_t,b_t,i_over_r(b,a,l),i_orb_r(a),i_orb_r(b)
           read(19,*) rac_r(1,l),rac_r(2,l),rac_r(3,l)

           if(l/=l_t+1) then
              open(unit=16,file=file_tempout,position='append')
              write(16,'(a,a)') '      ++++++ Error!: l ', fname
              close(16)
              stop
           end if
           if(a/=a_t+1) then
              open(unit=16,file=file_tempout,position='append')
              write(16,'(a,a)') '      ++++++ Error!: a ', fname
              close(16)
              stop
           end if
           if(b/=b_t+1) then
              open(unit=16,file=file_tempout,position='append')
              write(16,'(a,a)') '      ++++++ Error!: b ', fname
              close(16)
              stop
           end if

           if( i_over_r(b,a,l) == 1 ) then
              cycle
           end if

           call alo_ham_negf_type_r2(a,b,l,i_orb_r(a),i_orb_r(b))

           do i1=1,i_orb_r(a)
              do j1=1,i_orb_r(b)
                 if( spin_rr == 1 ) then
                    read(19,*) ht_hs_r(b,a,l)%s(j1,i1),temp2                       &
                         ,ht_hs_r(b,a,l)%h(1,j1,i1)
                    ht_hs_r(b,a,l)%h(1,j1,i1)=ht_hs_r(b,a,l)%h(1,j1,i1)            &
                         +vv_temp*ht_hs_r(b,a,l)%s(j1,i1)/ene_scale
                 else
                    if( spin_cc == 2 ) then
                       if( i_rotspin_r == 0 ) then
                          read(19,*) ht_hs_r(b,a,l)%s(j1,i1),temp2                   &
                               ,ht_hs_r(b,a,l)%h(1,j1,i1),ht_hs_r(b,a,l)%h(2,j1,i1)
                       else
                          read(19,*) ht_hs_r(b,a,l)%s(j1,i1),temp2                   &
                               ,ht_hs_r(b,a,l)%h(2,j1,i1),ht_hs_r(b,a,l)%h(1,j1,i1)
                       end if
                       ht_hs_r(b,a,l)%h(1,j1,i1)=ht_hs_r(b,a,l)%h(1,j1,i1)          &
                            +vv_temp*ht_hs_r(b,a,l)%s(j1,i1)/ene_scale
                       ht_hs_r(b,a,l)%h(2,j1,i1)=ht_hs_r(b,a,l)%h(2,j1,i1)          &
                            +vv_temp*ht_hs_r(b,a,l)%s(j1,i1)/ene_scale
                    else
                       read(19,*) ht_hs_r(b,a,l)%s(j1,i1)
                       read(19,*)
                       read(19,*)
                       read(19,*) temp1,temp2,temp3,temp4
                       ht_hs_r(b,a,l)%hls(1,j1,i1)                                  &
                            =dcmplx(temp1+vv_temp*ht_hs_r(b,a,l)%s(j1,i1)/ene_scale &
                            ,temp2)
                       ht_hs_r(b,a,l)%hls(2,j1,i1)=dcmplx(temp3,temp4)
                       read(19,*) temp1,temp2,temp3,temp4
                       ht_hs_r(b,a,l)%hls(3,j1,i1)=dcmplx(temp1,temp2)
                       ht_hs_r(b,a,l)%hls(4,j1,i1)                                  &
                            =dcmplx(temp3+vv_temp*ht_hs_r(b,a,l)%s(j1,i1)/ene_scale &
                            ,temp4)
                       read(19,*)
                       read(19,*)
                    end if
                 end if
              end do
           end do
        end do
     end do

     close(19)
  end do

  return
end subroutine set_ham_negf_r

subroutine set_ham_temp_ham_c(qx_st,qy_st)
  use hamiltonian_sgf
  use hamiltonian_c
  use hamiltonian_temp
  use constant
  use mod_mpi

  implicit none
  include 'mpif.h'
  real(8), intent(in) :: qx_st,qy_st

  integer, allocatable :: i_orb_lr(:)
  complex(8), allocatable :: h_cc(:,:,:)
  complex(8), allocatable :: s_cc(:,:)
  complex(8), allocatable :: temp_sen(:)
  complex(8), allocatable :: temp_rec(:)

  integer :: i1,j1,ier,a,b,l,ispin,i1_do,i2_do,i3_do,num_sum_mat,i_cou,ls_spin
  complex(8) :: const
  real(8) :: co,sn

  allocate(i_orb_lr(natom_ac_ct+1),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: alo_ham_negf_type_c1'
     stop
  end if

  i_orb_lr(1)=0
  do i1=1,natom_ac_ct
     i_orb_lr(i1+1)=i_orb_lr(i1)+i_orb_c(i1)
  end do


  if( spin_cc /= 2 ) then
     ls_spin=1
  else
     ls_spin=2
  end if

  allocate(h_cc(ls_spin,m_mat_max_c,m_mat_max_c),s_cc(m_mat_max_c,m_mat_max_c) &
       ,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: alo_ham_negf_type_c1'
     stop
  end if

  do i1_do=1,m_mat_max_c
     do i2_do=1,m_mat_max_c
        do i3_do=1,ls_spin
           h_cc(i3_do,i2_do,i1_do)=dcmplx(0.d0,0.d0)
        end do
        s_cc(i2_do,i1_do)=dcmplx(0.d0,0.d0)
     end do
  end do


  do a=1,natom_ac_ct
     do b=1,natom_ac_ct
        if( a <= natom_ac_cl .and. b > natom_ac_ct-natom_ac_cr ) then
           cycle
        end if
        if( b <= natom_ac_cl .and. a > natom_ac_ct-natom_ac_cr ) then
           cycle
        end if
        do l=1,nl_ac_c
           if( i_over_c(a,b,l) == 1 ) then
              cycle
           end if
           co=dcos(qx_st*rac_c(2,l)+qy_st*rac_c(3,l))
           sn=dsin(qx_st*rac_c(2,l)+qy_st*rac_c(3,l))
           if( l /= 1 ) then
              const=dcmplx(co,sn)
           else
              const=dcmplx(.5d0*co,.5d0*sn)
           end if
           do i1=1,i_orb_c(a)
              do j1=1,i_orb_c(b)
                 if( spin_cc /= 4 ) then
                    do ispin=1,ls_spin
                       h_cc(ispin,i_orb_lr(a)+i1,i_orb_lr(b)+j1)                      &
                            =h_cc(ispin,i_orb_lr(a)+i1,i_orb_lr(b)+j1)                 &
                            +const*dcmplx(ht_hs_c(a,b,l)%h(ispin,i1,j1)*ene_scale,0.d0)
                    end do
                    s_cc(i_orb_lr(a)+i1,i_orb_lr(b)+j1)                              &
                         =s_cc(i_orb_lr(a)+i1,i_orb_lr(b)+j1)                       &
                         +const*dcmplx(ht_hs_c(a,b,l)%s(i1,j1),0.d0)
                 else
                    h_cc(1,(i_orb_lr(a)+i1)*2-1,(i_orb_lr(b)+j1)*2-1)                &
                         =h_cc(1,(i_orb_lr(a)+i1)*2-1,(i_orb_lr(b)+j1)*2-1)         &
                         +const*ht_hs_c(a,b,l)%hls(1,i1,j1)*ene_scale
                    h_cc(1,(i_orb_lr(a)+i1)*2-1,(i_orb_lr(b)+j1)*2)                  &
                         =h_cc(1,(i_orb_lr(a)+i1)*2-1,(i_orb_lr(b)+j1)*2)           &
                         +const*ht_hs_c(a,b,l)%hls(2,i1,j1)*ene_scale
                    h_cc(1,(i_orb_lr(a)+i1)*2,(i_orb_lr(b)+j1)*2-1)                  &
                         =h_cc(1,(i_orb_lr(a)+i1)*2,(i_orb_lr(b)+j1)*2-1)           &
                         +const*ht_hs_c(a,b,l)%hls(3,i1,j1)*ene_scale
                    h_cc(1,(i_orb_lr(a)+i1)*2,(i_orb_lr(b)+j1)*2)                    &
                         =h_cc(1,(i_orb_lr(a)+i1)*2,(i_orb_lr(b)+j1)*2)             &
                         +const*ht_hs_c(a,b,l)%hls(4,i1,j1)*ene_scale
                    s_cc((i_orb_lr(a)+i1)*2-1,(i_orb_lr(b)+j1)*2-1)                  &
                         =s_cc((i_orb_lr(a)+i1)*2-1,(i_orb_lr(b)+j1)*2-1)           &
                         +const*dcmplx(ht_hs_c(a,b,l)%s(i1,j1),0.d0)
                    s_cc((i_orb_lr(a)+i1)*2,(i_orb_lr(b)+j1)*2)                      &
                         =s_cc((i_orb_lr(a)+i1)*2,(i_orb_lr(b)+j1)*2)               &
                         +const*dcmplx(ht_hs_c(a,b,l)%s(i1,j1),0.d0)
                 end if
              end do
           end do
        end do
     end do
  end do


  num_sum_mat=(ls_spin+1)*m_mat_max_c*m_mat_max_c

  allocate(temp_sen(num_sum_mat),temp_rec(num_sum_mat),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: alo_ham_negf_type_c1'
     stop
  end if
  do i1_do=1,num_sum_mat
     temp_sen(i1_do)=dcmplx(0.d0,0.d0)
  end do
  do i1_do=1,num_sum_mat
     temp_rec(i1_do)=dcmplx(0.d0,0.d0)
  end do

  i_cou=0
  do i1_do=1,m_mat_max_c
     do i2_do=1,m_mat_max_c
        do i3_do=1,ls_spin
           i_cou=i_cou+1
           temp_sen(i_cou)=h_cc(i3_do,i2_do,i1_do)
        end do
     end do
  end do
  do i1_do=1,m_mat_max_c
     do i2_do=1,m_mat_max_c
        i_cou=i_cou+1
        temp_sen(i_cou)=s_cc(i2_do,i1_do)
     end do
  end do

  call MPI_ALLREDUCE(temp_sen,temp_rec,num_sum_mat,MPI_DOUBLE_COMPLEX          &
       ,MPI_SUM,mpi_comm_world,ierr)

  i_cou=0
  do i1_do=1,m_mat_max_c
     do i2_do=1,m_mat_max_c
        do i3_do=1,ls_spin
           i_cou=i_cou+1
           h_cc(i3_do,i2_do,i1_do)=temp_rec(i_cou)
        end do
     end do
  end do
  do i1_do=1,m_mat_max_c
     do i2_do=1,m_mat_max_c
        i_cou=i_cou+1
        s_cc(i2_do,i1_do)=temp_rec(i_cou)
     end do
  end do

  do i3_do=1,m_mat_max_c
     do i2_do=i3_do,m_mat_max_c
        do i1_do=1,ls_spin
           h_cc(i1_do,i2_do,i3_do)=h_cc(i1_do,i2_do,i3_do)                        &
                +dconjg(h_cc(i1_do,i3_do,i2_do))
           h_cc(i1_do,i3_do,i2_do)=dconjg(h_cc(i1_do,i2_do,i3_do))
        end do
        s_cc(i2_do,i3_do)=s_cc(i2_do,i3_do)+dconjg(s_cc(i3_do,i2_do))
        s_cc(i3_do,i2_do)=dconjg(s_cc(i2_do,i3_do))
     end do
  end do

  deallocate(temp_sen,temp_rec,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: alo_ham_negf_type_c1'
     stop
  end if


  do i3_do=1,m_mat_max_c
     do i2_do=1,m_mat_max_c
        do i1_do=1,ls_spin
           hcc_t(i1_do,i2_do,i3_do)=h_cc(i1_do,i2_do,i3_do)
        end do
        scc_t(i2_do,i3_do)=s_cc(i2_do,i3_do)
     end do
  end do


  deallocate(i_orb_lr,h_cc,s_cc,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: alo_ham_negf_type_c1'
     stop
  end if

  return
end subroutine set_ham_temp_ham_c

subroutine set_ham_temp_ham_l(qx_st,qy_st)
  use hamiltonian_sgf
  use hamiltonian_c
  use hamiltonian_temp
  use constant
  use scf_negf
  use mod_mpi

  implicit none
  include 'mpif.h'
  real(8), intent(in) :: qx_st,qy_st

  integer, allocatable :: i_orb_lr(:)
  complex(8), allocatable :: h_00l(:,:,:)
  complex(8), allocatable :: s_00l(:,:)
  complex(8), allocatable :: h_01l(:,:,:)
  complex(8), allocatable :: s_01l(:,:)
  complex(8), allocatable :: h_10l(:,:,:)
  complex(8), allocatable :: s_10l(:,:)
  complex(8), allocatable :: temp_sen(:)
  complex(8), allocatable :: temp_rec(:)

  integer :: i1,j1,ier,a,b,l,ispin,i1_do,i2_do,i3_do,num_sum_mat,i_cou,ls_spin
  complex(8) :: const
  real(8) :: co,sn

  allocate(i_orb_lr(natom_ac_lt+1),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: alo_ham_negf_type_c1'
     stop
  end if

  i_orb_lr(1)=0
  do i1=1, natom_ac_lt
     i_orb_lr(i1+1)=i_orb_lr(i1)+i_orb_l(i1)
  end do


  if( spin_ll /= 2 ) then
     ls_spin=1
  else
     ls_spin=2
  end if

  allocate(h_00l(ls_spin,mat_max_ll,mat_max_ll),s_00l(mat_max_ll,mat_max_ll)   &
       ,h_01l(ls_spin,mat_max_ll,mat_max_ll),s_01l(mat_max_ll,mat_max_ll)   &
       ,h_10l(ls_spin,mat_max_ll,mat_max_ll),s_10l(mat_max_ll,mat_max_ll)   &
       ,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: alo_ham_negf_type_c1'
     stop
  end if

  do i1_do=1,mat_max_ll
     do i2_do=1,mat_max_ll
        do i3_do=1,ls_spin
           h_00l(i3_do,i2_do,i1_do)=dcmplx(0.d0,0.d0)
           h_01l(i3_do,i2_do,i1_do)=dcmplx(0.d0,0.d0)
           h_10l(i3_do,i2_do,i1_do)=dcmplx(0.d0,0.d0)
        end do
        s_00l(i2_do,i1_do)=dcmplx(0.d0,0.d0)
        s_01l(i2_do,i1_do)=dcmplx(0.d0,0.d0)
        s_10l(i2_do,i1_do)=dcmplx(0.d0,0.d0)
     end do
  end do


  do a=1,natom_ac_ll
     do b=1,natom_ac_ll
        do l=1,nl_ac_l
           if( i_over_l(a,b,l) == 1 ) then
              cycle
           end if
           co=dcos(qx_st*rac_l(2,l)+qy_st*rac_l(3,l))
           sn=dsin(qx_st*rac_l(2,l)+qy_st*rac_l(3,l))
           if( l /= 1 ) then
              const=dcmplx(co,sn)
           else
              const=dcmplx(.5d0*co,.5d0*sn)
           end if
           do i1=1,i_orb_l(a)
              do j1=1,i_orb_l(b)
                 if( spin_ll < 4 ) then
                    do ispin=1,ls_spin
                       h_00l(ispin,i_orb_lr(a)+i1,i_orb_lr(b)+j1)                     &
                            =h_00l(ispin,i_orb_lr(a)+i1,i_orb_lr(b)+j1)                &
                            +const*dcmplx(ht_hs_l(a,b,l)%h(ispin,i1,j1)*ene_scale,0.d0)
                    end do
                    s_00l(i_orb_lr(a)+i1,i_orb_lr(b)+j1)                             &
                         =s_00l(i_orb_lr(a)+i1,i_orb_lr(b)+j1)                      &
                         +const*dcmplx(ht_hs_l(a,b,l)%s(i1,j1),0.d0)
                 else
                    h_00l(1,(i_orb_lr(a)+i1)*2-1,(i_orb_lr(b)+j1)*2-1)               &
                         =h_00l(1,(i_orb_lr(a)+i1)*2-1,(i_orb_lr(b)+j1)*2-1)        &
                         +const*ht_hs_l(a,b,l)%hls(1,i1,j1)*ene_scale
                    h_00l(1,(i_orb_lr(a)+i1)*2-1,(i_orb_lr(b)+j1)*2)                 &
                         =h_00l(1,(i_orb_lr(a)+i1)*2-1,(i_orb_lr(b)+j1)*2)          &
                         +const*ht_hs_l(a,b,l)%hls(2,i1,j1)*ene_scale
                    h_00l(1,(i_orb_lr(a)+i1)*2,(i_orb_lr(b)+j1)*2-1)                 &
                         =h_00l(1,(i_orb_lr(a)+i1)*2,(i_orb_lr(b)+j1)*2-1)          &
                         +const*ht_hs_l(a,b,l)%hls(3,i1,j1)*ene_scale
                    h_00l(1,(i_orb_lr(a)+i1)*2,(i_orb_lr(b)+j1)*2)                   &
                         =h_00l(1,(i_orb_lr(a)+i1)*2,(i_orb_lr(b)+j1)*2)            &
                         +const*ht_hs_l(a,b,l)%hls(4,i1,j1)*ene_scale
                    s_00l((i_orb_lr(a)+i1)*2-1,(i_orb_lr(b)+j1)*2-1)                 &
                         =s_00l((i_orb_lr(a)+i1)*2-1,(i_orb_lr(b)+j1)*2-1)          &
                         +const*dcmplx(ht_hs_l(a,b,l)%s(i1,j1),0.d0)
                    s_00l((i_orb_lr(a)+i1)*2,(i_orb_lr(b)+j1)*2)                     &
                         =s_00l((i_orb_lr(a)+i1)*2,(i_orb_lr(b)+j1)*2)              &
                         +const*dcmplx(ht_hs_l(a,b,l)%s(i1,j1),0.d0)
                 end if
              end do
           end do
        end do
     end do
  end do

  i1_do=i_orb_lr(natom_ac_lt-natom_ac_ll+1)
  do a=1,natom_ac_ll
     do b=natom_ac_lt-natom_ac_ll+1,natom_ac_lt
        do l=1,nl_ac_l
           if( i_over_l(a,b,l) == 1 ) then
              cycle
           end if
           co=dcos(qx_st*rac_l(2,l)+qy_st*rac_l(3,l))
           sn=dsin(qx_st*rac_l(2,l)+qy_st*rac_l(3,l))
           if( l /= 1 ) then
              const=dcmplx(co,sn)
           else
              const=dcmplx(.5d0*co,.5d0*sn)
           end if
           do i1=1,i_orb_l(a)
              do j1=1,i_orb_l(b)
                 if( spin_ll < 4 ) then
                    do ispin=1,ls_spin
                       h_01l(ispin,i_orb_lr(a)+i1,i_orb_lr(b)-i1_do+j1)               &
                            =h_01l(ispin,i_orb_lr(a)+i1,i_orb_lr(b)-i1_do+j1)          &
                            +const*dcmplx(ht_hs_l(a,b,l)%h(ispin,i1,j1)*ene_scale,0.d0)
                    end do
                    s_01l(i_orb_lr(a)+i1,i_orb_lr(b)-i1_do+j1)                       &
                         =s_01l(i_orb_lr(a)+i1,i_orb_lr(b)-i1_do+j1)                &
                         +const*dcmplx(ht_hs_l(a,b,l)%s(i1,j1),0.d0)
                 else
                    h_01l(1,(i_orb_lr(a)+i1)*2-1,(i_orb_lr(b)-i1_do+j1)*2-1)         &
                         =h_01l(1,(i_orb_lr(a)+i1)*2-1,(i_orb_lr(b)-i1_do+j1)*2-1)  &
                         +const*ht_hs_l(a,b,l)%hls(1,i1,j1)*ene_scale
                    h_01l(1,(i_orb_lr(a)+i1)*2-1,(i_orb_lr(b)-i1_do+j1)*2)           &
                         =h_01l(1,(i_orb_lr(a)+i1)*2-1,(i_orb_lr(b)-i1_do+j1)*2)    &
                         +const*ht_hs_l(a,b,l)%hls(2,i1,j1)*ene_scale
                    h_01l(1,(i_orb_lr(a)+i1)*2,(i_orb_lr(b)-i1_do+j1)*2-1)           &
                         =h_01l(1,(i_orb_lr(a)+i1)*2,(i_orb_lr(b)-i1_do+j1)*2-1)    &
                         +const*ht_hs_l(a,b,l)%hls(3,i1,j1)*ene_scale
                    h_01l(1,(i_orb_lr(a)+i1)*2,(i_orb_lr(b)-i1_do+j1)*2)             &
                         =h_01l(1,(i_orb_lr(a)+i1)*2,(i_orb_lr(b)-i1_do+j1)*2)      &
                         +const*ht_hs_l(a,b,l)%hls(4,i1,j1)*ene_scale
                    s_01l((i_orb_lr(a)+i1)*2-1,(i_orb_lr(b)-i1_do+j1)*2-1)           &
                         =s_01l((i_orb_lr(a)+i1)*2-1,(i_orb_lr(b)-i1_do+j1)*2-1)    &
                         +const*dcmplx(ht_hs_l(a,b,l)%s(i1,j1),0.d0)
                    s_01l((i_orb_lr(a)+i1)*2,(i_orb_lr(b)-i1_do+j1)*2)               &
                         =s_01l((i_orb_lr(a)+i1)*2,(i_orb_lr(b)-i1_do+j1)*2)        &
                         +const*dcmplx(ht_hs_l(a,b,l)%s(i1,j1),0.d0)
                 end if
              end do
           end do
        end do
     end do
  end do

  i1_do=i_orb_lr(natom_ac_lt-natom_ac_ll+1)
  do a=natom_ac_lt-natom_ac_ll+1,natom_ac_lt
     do b=1,natom_ac_ll
        do l=1,nl_ac_l
           if( i_over_l(a,b,l) == 1 ) then
              cycle
           end if
           co=dcos(qx_st*rac_l(2,l)+qy_st*rac_l(3,l))
           sn=dsin(qx_st*rac_l(2,l)+qy_st*rac_l(3,l))
           if( l /= 1 ) then
              const=dcmplx(co,sn)
           else
              const=dcmplx(.5d0*co,.5d0*sn)
           end if
           do i1=1,i_orb_l(a)
              do j1=1,i_orb_l(b)
                 if( spin_ll < 4 ) then
                    do ispin=1,ls_spin
                       h_10l(ispin,i_orb_lr(a)-i1_do+i1,i_orb_lr(b)+j1)               &
                            =h_10l(ispin,i_orb_lr(a)-i1_do+i1,i_orb_lr(b)+j1)          &
                            +const*dcmplx(ht_hs_l(a,b,l)%h(ispin,i1,j1)*ene_scale,0.d0)
                    end do
                    s_10l(i_orb_lr(a)-i1_do+i1,i_orb_lr(b)+j1)                       &
                         =s_10l(i_orb_lr(a)-i1_do+i1,i_orb_lr(b)+j1)                &
                         +const*dcmplx(ht_hs_l(a,b,l)%s(i1,j1),0.d0)
                 else
                    h_10l(1,(i_orb_lr(a)-i1_do+i1)*2-1,(i_orb_lr(b)+j1)*2-1)         &
                         =h_10l(1,(i_orb_lr(a)-i1_do+i1)*2-1,(i_orb_lr(b)+j1)*2-1)  &
                         +const*ht_hs_l(a,b,l)%hls(1,i1,j1)*ene_scale
                    h_10l(1,(i_orb_lr(a)-i1_do+i1)*2-1,(i_orb_lr(b)+j1)*2)           &
                         =h_10l(1,(i_orb_lr(a)-i1_do+i1)*2-1,(i_orb_lr(b)+j1)*2)    &
                         +const*ht_hs_l(a,b,l)%hls(2,i1,j1)*ene_scale
                    h_10l(1,(i_orb_lr(a)-i1_do+i1)*2,(i_orb_lr(b)+j1)*2-1)           &
                         =h_10l(1,(i_orb_lr(a)-i1_do+i1)*2,(i_orb_lr(b)+j1)*2-1)    &
                         +const*ht_hs_l(a,b,l)%hls(3,i1,j1)*ene_scale
                    h_10l(1,(i_orb_lr(a)-i1_do+i1)*2,(i_orb_lr(b)+j1)*2)             &
                         =h_10l(1,(i_orb_lr(a)-i1_do+i1)*2,(i_orb_lr(b)+j1)*2)      &
                         +const*ht_hs_l(a,b,l)%hls(4,i1,j1)*ene_scale
                    s_10l((i_orb_lr(a)-i1_do+i1)*2-1,(i_orb_lr(b)+j1)*2-1)           &
                         =s_10l((i_orb_lr(a)-i1_do+i1)*2-1,(i_orb_lr(b)+j1)*2-1)    &
                         +const*dcmplx(ht_hs_l(a,b,l)%s(i1,j1),0.d0)
                    s_10l((i_orb_lr(a)-i1_do+i1)*2,(i_orb_lr(b)+j1)*2)               &
                         =s_10l((i_orb_lr(a)-i1_do+i1)*2,(i_orb_lr(b)+j1)*2)        &
                         +const*dcmplx(ht_hs_l(a,b,l)%s(i1,j1),0.d0)
                 end if
              end do
           end do
        end do
     end do
  end do


  num_sum_mat=3*(ls_spin+1)*mat_max_ll*mat_max_ll

  allocate(temp_sen(num_sum_mat),temp_rec(num_sum_mat),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: alo_ham_negf_type_c1'
     stop
  end if
  do i1_do=1,num_sum_mat
     temp_sen(i1_do)=dcmplx(0.0d0,0.d0)
  end do
  do i1_do=1,num_sum_mat
     temp_rec(i1_do)=dcmplx(0.0d0,0.d0)
  end do

  i_cou=0
  do i1_do=1,mat_max_ll
     do i2_do=1,mat_max_ll
        do i3_do=1,ls_spin
           i_cou=i_cou+1
           temp_sen(i_cou)=h_00l(i3_do,i2_do,i1_do)
        end do
     end do
  end do
  do i1_do=1,mat_max_ll
     do i2_do=1,mat_max_ll
        i_cou=i_cou+1
        temp_sen(i_cou)=s_00l(i2_do,i1_do)
     end do
  end do
  do i1_do=1,mat_max_ll
     do i2_do=1,mat_max_ll
        do i3_do=1,ls_spin
           i_cou=i_cou+1
           temp_sen(i_cou)=h_01l(i3_do,i2_do,i1_do)
        end do
     end do
  end do
  do i1_do=1,mat_max_ll
     do i2_do=1,mat_max_ll
        i_cou=i_cou+1
        temp_sen(i_cou)=s_01l(i2_do,i1_do)
     end do
  end do
  do i1_do=1,mat_max_ll
     do i2_do=1,mat_max_ll
        do i3_do=1,ls_spin
           i_cou=i_cou+1
           temp_sen(i_cou)=h_10l(i3_do,i2_do,i1_do)
        end do
     end do
  end do
  do i1_do=1,mat_max_ll
     do i2_do=1,mat_max_ll
        i_cou=i_cou+1
        temp_sen(i_cou)=s_10l(i2_do,i1_do)
     end do
  end do

  call MPI_ALLREDUCE(temp_sen,temp_rec,num_sum_mat,MPI_DOUBLE_COMPLEX          &
       ,MPI_SUM,mpi_comm_world,ierr)

  i_cou=0
  do i1_do=1,mat_max_ll
     do i2_do=1,mat_max_ll
        do i3_do=1,ls_spin
           i_cou=i_cou+1
           h_00l(i3_do,i2_do,i1_do)=temp_rec(i_cou)
        end do
     end do
  end do
  do i1_do=1,mat_max_ll
     do i2_do=1,mat_max_ll
        i_cou=i_cou+1
        s_00l(i2_do,i1_do)=temp_rec(i_cou)
     end do
  end do
  do i1_do=1,mat_max_ll
     do i2_do=1,mat_max_ll
        do i3_do=1,ls_spin
           i_cou=i_cou+1
           h_01l(i3_do,i2_do,i1_do)=temp_rec(i_cou)
        end do
     end do
  end do
  do i1_do=1,mat_max_ll
     do i2_do=1,mat_max_ll
        i_cou=i_cou+1
        s_01l(i2_do,i1_do)=temp_rec(i_cou)
     end do
  end do
  do i1_do=1,mat_max_ll
     do i2_do=1,mat_max_ll
        do i3_do=1,ls_spin
           i_cou=i_cou+1
           h_10l(i3_do,i2_do,i1_do)=temp_rec(i_cou)
        end do
     end do
  end do
  do i1_do=1,mat_max_ll
     do i2_do=1,mat_max_ll
        i_cou=i_cou+1
        s_10l(i2_do,i1_do)=temp_rec(i_cou)
     end do
  end do

  do i3_do=1,mat_max_ll
     do i2_do=i3_do,mat_max_ll
        do i1_do=1,ls_spin
           h_00l(i1_do,i2_do,i3_do)=h_00l(i1_do,i2_do,i3_do)                      &
                +dconjg(h_00l(i1_do,i3_do,i2_do))
           h_00l(i1_do,i3_do,i2_do)=dconjg(h_00l(i1_do,i2_do,i3_do))
        end do
        s_00l(i2_do,i3_do)=s_00l(i2_do,i3_do)+dconjg(s_00l(i3_do,i2_do))
        s_00l(i3_do,i2_do)=dconjg(s_00l(i2_do,i3_do))
     end do
  end do
  do i3_do=1,mat_max_ll
     do i2_do=1,mat_max_ll
        do i1_do=1,ls_spin
           h_10l(i1_do,i2_do,i3_do)=h_10l(i1_do,i2_do,i3_do)                      &
                +dconjg(h_01l(i1_do,i3_do,i2_do))
           h_01l(i1_do,i3_do,i2_do)=dconjg(h_10l(i1_do,i2_do,i3_do))
        end do
        s_10l(i2_do,i3_do)=s_10l(i2_do,i3_do)+dconjg(s_01l(i3_do,i2_do))
        s_01l(i3_do,i2_do)=dconjg(s_10l(i2_do,i3_do))
     end do
  end do

  deallocate(temp_sen,temp_rec,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: alo_ham_negf_type_c1'
     stop
  end if


  do i3_do=1,mat_max_ll
     do i2_do=1,mat_max_ll
        do i1_do=1,ls_spin
           h00_l_t(i1_do,i2_do,i3_do)=h_00l(i1_do,i2_do,i3_do)
           h01_l_t(i1_do,i2_do,i3_do)=h_01l(i1_do,i2_do,i3_do)
           h10_l_t(i1_do,i2_do,i3_do)=h_10l(i1_do,i2_do,i3_do)
        end do
        s00_l_t(i2_do,i3_do)=s_00l(i2_do,i3_do)
        s01_l_t(i2_do,i3_do)=s_01l(i2_do,i3_do)
        s10_l_t(i2_do,i3_do)=s_10l(i2_do,i3_do)
     end do
  end do


  deallocate(i_orb_lr,h_00l,s_00l,h_01l,s_01l,h_10l,s_10l,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: alo_ham_negf_type_c1'
     stop
  end if

  return
end subroutine set_ham_temp_ham_l

subroutine set_ham_temp_ham_r(qx_st,qy_st)
  use hamiltonian_sgf
  use hamiltonian_c
  use hamiltonian_temp
  use constant
  use scf_negf
  use mod_mpi

  implicit none
  include 'mpif.h'
  real(8), intent(in) :: qx_st,qy_st

  integer, allocatable :: i_orb_lr(:)
  complex(8), allocatable :: h_00r(:,:,:)
  complex(8), allocatable :: s_00r(:,:)
  complex(8), allocatable :: h_01r(:,:,:)
  complex(8), allocatable :: s_01r(:,:)
  complex(8), allocatable :: h_10r(:,:,:)
  complex(8), allocatable :: s_10r(:,:)
  complex(8), allocatable :: temp_sen(:)
  complex(8), allocatable :: temp_rec(:)

  integer :: i1,j1,ier,a,b,l,ispin,i1_do,i2_do,i3_do,num_sum_mat,i_cou,ls_spin
  complex(8) :: const
  real(8) :: co,sn

  allocate(i_orb_lr(natom_ac_rt+1),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: alo_ham_negf_type_c1'
     stop
  end if

  i_orb_lr(1)=0
  do i1=1, natom_ac_rt
     i_orb_lr(i1+1)=i_orb_lr(i1)+i_orb_r(i1)
  end do


  if( spin_rr /= 2 ) then
     ls_spin=1
  else
     ls_spin=2
  end if

  allocate(h_00r(ls_spin,mat_max_rr,mat_max_rr),s_00r(mat_max_rr,mat_max_rr)   &
       ,h_01r(ls_spin,mat_max_rr,mat_max_rr),s_01r(mat_max_rr,mat_max_rr)   &
       ,h_10r(ls_spin,mat_max_rr,mat_max_rr),s_10r(mat_max_rr,mat_max_rr)   &
       ,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: alo_ham_negf_type_c1'
     stop
  end if

  do i1_do=1,mat_max_rr
     do i2_do=1,mat_max_rr
        do i3_do=1,ls_spin
           h_00r(i3_do,i2_do,i1_do)=dcmplx(0.0d0,0.d0)
           h_01r(i3_do,i2_do,i1_do)=dcmplx(0.0d0,0.d0)
           h_10r(i3_do,i2_do,i1_do)=dcmplx(0.0d0,0.d0)
        end do
        s_00r(i2_do,i1_do)=dcmplx(0.0d0,0.d0)
        s_01r(i2_do,i1_do)=dcmplx(0.0d0,0.d0)
        s_10r(i2_do,i1_do)=dcmplx(0.0d0,0.d0)
     end do
  end do


  i1_do=i_orb_lr(natom_ac_rt-natom_ac_rr+1)
  do a=natom_ac_rt-natom_ac_rr+1,natom_ac_rt
     do b=natom_ac_rt-natom_ac_rr+1,natom_ac_rt
        do l=1,nl_ac_r
           if( i_over_r(a,b,l) == 1 ) then
              cycle
           end if
           co=dcos(qx_st*rac_r(2,l)+qy_st*rac_r(3,l))
           sn=dsin(qx_st*rac_r(2,l)+qy_st*rac_r(3,l))
           if( l /= 1 ) then
              const=dcmplx(co,sn)
           else
              const=dcmplx(.5d0*co,.5d0*sn)
           end if
           do i1=1,i_orb_r(a)
              do j1=1,i_orb_r(b)
                 if( spin_ll < 4 ) then
                    do ispin=1,ls_spin
                       h_00r(ispin,i_orb_lr(a)-i1_do+i1,i_orb_lr(b)-i1_do+j1)         &
                            =h_00r(ispin,i_orb_lr(a)-i1_do+i1,i_orb_lr(b)-i1_do+j1)    &
                            +const*dcmplx(ht_hs_r(a,b,l)%h(ispin,i1,j1)*ene_scale,0.d0)
                    end do
                    s_00r(i_orb_lr(a)-i1_do+i1,i_orb_lr(b)-i1_do+j1)                 &
                         =s_00r(i_orb_lr(a)-i1_do+i1,i_orb_lr(b)-i1_do+j1)          &
                         +const*dcmplx(ht_hs_r(a,b,l)%s(i1,j1),0.d0)
                 else
                    h_00r(1,(i_orb_lr(a)-i1_do+i1)*2-1,(i_orb_lr(b)-i1_do+j1)*2-1)   &
                         =h_00r(1,(i_orb_lr(a)-i1_do+i1)*2-1,(i_orb_lr(b)-i1_do+j1)*2-1) &
                         +const*ht_hs_r(a,b,l)%hls(1,i1,j1)*ene_scale
                    h_00r(1,(i_orb_lr(a)-i1_do+i1)*2-1,(i_orb_lr(b)-i1_do+j1)*2)     &
                         =h_00r(1,(i_orb_lr(a)-i1_do+i1)*2-1,(i_orb_lr(b)-i1_do+j1)*2)   &
                         +const*ht_hs_r(a,b,l)%hls(2,i1,j1)*ene_scale
                    h_00r(1,(i_orb_lr(a)-i1_do+i1)*2,(i_orb_lr(b)-i1_do+j1)*2-1)     &
                         =h_00r(1,(i_orb_lr(a)-i1_do+i1)*2,(i_orb_lr(b)-i1_do+j1)*2-1)   &
                         +const*ht_hs_r(a,b,l)%hls(3,i1,j1)*ene_scale
                    h_00r(1,(i_orb_lr(a)-i1_do+i1)*2,(i_orb_lr(b)-i1_do+j1)*2)       &
                         =h_00r(1,(i_orb_lr(a)-i1_do+i1)*2,(i_orb_lr(b)-i1_do+j1)*2)     &
                         +const*ht_hs_r(a,b,l)%hls(4,i1,j1)*ene_scale
                    s_00r((i_orb_lr(a)-i1_do+i1)*2-1,(i_orb_lr(b)-i1_do+j1)*2-1)     &
                         =s_00r((i_orb_lr(a)-i1_do+i1)*2-1,(i_orb_lr(b)-i1_do+j1)*2-1)   &
                         +const*dcmplx(ht_hs_r(a,b,l)%s(i1,j1),0.d0)
                    s_00r((i_orb_lr(a)-i1_do+i1)*2,(i_orb_lr(b)-i1_do+j1)*2)         &
                         =s_00r((i_orb_lr(a)-i1_do+i1)*2,(i_orb_lr(b)-i1_do+j1)*2)       &
                         +const*dcmplx(ht_hs_r(a,b,l)%s(i1,j1),0.d0)
                 end if
              end do
           end do
        end do
     end do
  end do

  i1_do=i_orb_lr(natom_ac_rt-natom_ac_rr+1)
  do a=natom_ac_rt-natom_ac_rr+1,natom_ac_rt
     do b=1,natom_ac_rr
        do l=1,nl_ac_r
           if( i_over_r(a,b,l) == 1 ) then
              cycle
           end if
           co=dcos(qx_st*rac_r(2,l)+qy_st*rac_r(3,l))
           sn=dsin(qx_st*rac_r(2,l)+qy_st*rac_r(3,l))
           if( l /= 1 ) then
              const=dcmplx(co,sn)
           else
              const=dcmplx(.5d0*co,.5d0*sn)
           end if
           do i1=1,i_orb_r(a)
              do j1=1,i_orb_r(b)
                 if( spin_ll < 4 ) then
                    do ispin=1,ls_spin
                       h_01r(ispin,i_orb_lr(a)-i1_do+i1,i_orb_lr(b)+j1)               &
                            =h_01r(ispin,i_orb_lr(a)-i1_do+i1,i_orb_lr(b)+j1)          &
                            +const*dcmplx(ht_hs_r(a,b,l)%h(ispin,i1,j1)*ene_scale,0.d0)
                    end do
                    s_01r(i_orb_lr(a)-i1_do+i1,i_orb_lr(b)+j1)                       &
                         =s_01r(i_orb_lr(a)-i1_do+i1,i_orb_lr(b)+j1)                &
                         +const*dcmplx(ht_hs_r(a,b,l)%s(i1,j1),0.d0)
                 else
                    h_01r(1,(i_orb_lr(a)-i1_do+i1)*2-1,(i_orb_lr(b)+j1)*2-1)         &
                         =h_01r(1,(i_orb_lr(a)-i1_do+i1)*2-1,(i_orb_lr(b)+j1)*2-1)  &
                         +const*ht_hs_r(a,b,l)%hls(1,i1,j1)*ene_scale
                    h_01r(1,(i_orb_lr(a)-i1_do+i1)*2-1,(i_orb_lr(b)+j1)*2)           &
                         =h_01r(1,(i_orb_lr(a)-i1_do+i1)*2-1,(i_orb_lr(b)+j1)*2)    &
                         +const*ht_hs_r(a,b,l)%hls(2,i1,j1)*ene_scale
                    h_01r(1,(i_orb_lr(a)-i1_do+i1)*2,(i_orb_lr(b)+j1)*2-1)           &
                         =h_01r(1,(i_orb_lr(a)-i1_do+i1)*2,(i_orb_lr(b)+j1)*2-1)    &
                         +const*ht_hs_r(a,b,l)%hls(3,i1,j1)*ene_scale
                    h_01r(1,(i_orb_lr(a)-i1_do+i1)*2,(i_orb_lr(b)+j1)*2)             &
                         =h_01r(1,(i_orb_lr(a)-i1_do+i1)*2,(i_orb_lr(b)+j1)*2)      &
                         +const*ht_hs_r(a,b,l)%hls(4,i1,j1)*ene_scale
                    s_01r((i_orb_lr(a)-i1_do+i1)*2-1,(i_orb_lr(b)+j1)*2-1)           &
                         =s_01r((i_orb_lr(a)-i1_do+i1)*2-1,(i_orb_lr(b)+j1)*2-1)    &
                         +const*dcmplx(ht_hs_r(a,b,l)%s(i1,j1),0.d0)
                    s_01r((i_orb_lr(a)-i1_do+i1)*2,(i_orb_lr(b)+j1)*2)               &
                         =s_01r((i_orb_lr(a)-i1_do+i1)*2,(i_orb_lr(b)+j1)*2)        &
                         +const*dcmplx(ht_hs_r(a,b,l)%s(i1,j1),0.d0)
                 end if
              end do
           end do
        end do
     end do
  end do

  i1_do=i_orb_lr(natom_ac_rt-natom_ac_rr+1)
  do a=1,natom_ac_rr
     do b=natom_ac_rt-natom_ac_rr+1,natom_ac_rt
        do l=1,nl_ac_r
           if( i_over_r(a,b,l) == 1 ) then
              cycle
           end if
           co=dcos(qx_st*rac_r(2,l)+qy_st*rac_r(3,l))
           sn=dsin(qx_st*rac_r(2,l)+qy_st*rac_r(3,l))
           if( l /= 1 ) then
              const=dcmplx(co,sn)
           else
              const=dcmplx(.5d0*co,.5d0*sn)
           end if
           do i1=1,i_orb_r(a)
              do j1=1,i_orb_r(b)
                 if( spin_ll < 4 ) then
                    do ispin=1,ls_spin
                       h_10r(ispin,i_orb_lr(a)+i1,i_orb_lr(b)-i1_do+j1)               &
                            =h_10r(ispin,i_orb_lr(a)+i1,i_orb_lr(b)-i1_do+j1)          &
                            +const*dcmplx(ht_hs_r(a,b,l)%h(ispin,i1,j1)*ene_scale,0.d0)
                    end do
                    s_10r(i_orb_lr(a)+i1,i_orb_lr(b)-i1_do+j1)                       &
                         =s_10r(i_orb_lr(a)+i1,i_orb_lr(b)-i1_do+j1)                &
                         +const*dcmplx(ht_hs_r(a,b,l)%s(i1,j1),0.d0)
                 else
                    h_10r(1,(i_orb_lr(a)+i1)*2-1,(i_orb_lr(b)-i1_do+j1)*2-1)         &
                         =h_10r(1,(i_orb_lr(a)+i1)*2-1,(i_orb_lr(b)-i1_do+j1)*2-1)  &
                         +const*ht_hs_r(a,b,l)%hls(1,i1,j1)*ene_scale
                    h_10r(1,(i_orb_lr(a)+i1)*2-1,(i_orb_lr(b)-i1_do+j1)*2)           &
                         =h_10r(1,(i_orb_lr(a)+i1)*2-1,(i_orb_lr(b)-i1_do+j1)*2)    &
                         +const*ht_hs_r(a,b,l)%hls(2,i1,j1)*ene_scale
                    h_10r(1,(i_orb_lr(a)+i1)*2,(i_orb_lr(b)-i1_do+j1)*2-1)           &
                         =h_10r(1,(i_orb_lr(a)+i1)*2,(i_orb_lr(b)-i1_do+j1)*2-1)    &
                         +const*ht_hs_r(a,b,l)%hls(3,i1,j1)*ene_scale
                    h_10r(1,(i_orb_lr(a)+i1)*2,(i_orb_lr(b)-i1_do+j1)*2)             &
                         =h_10r(1,(i_orb_lr(a)+i1)*2,(i_orb_lr(b)-i1_do+j1)*2)      &
                         +const*ht_hs_r(a,b,l)%hls(4,i1,j1)*ene_scale
                    s_10r((i_orb_lr(a)+i1)*2-1,(i_orb_lr(b)-i1_do+j1)*2-1)           &
                         =s_10r((i_orb_lr(a)+i1)*2-1,(i_orb_lr(b)-i1_do+j1)*2-1)    &
                         +const*dcmplx(ht_hs_r(a,b,l)%s(i1,j1),0.d0)
                    s_10r((i_orb_lr(a)+i1)*2,(i_orb_lr(b)-i1_do+j1)*2)               &
                         =s_10r((i_orb_lr(a)+i1)*2,(i_orb_lr(b)-i1_do+j1)*2)        &
                         +const*dcmplx(ht_hs_r(a,b,l)%s(i1,j1),0.d0)
                 end if
              end do
           end do
        end do
     end do
  end do


  num_sum_mat=3*(ls_spin+1)*mat_max_rr*mat_max_rr

  allocate(temp_sen(num_sum_mat),temp_rec(num_sum_mat),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: alo_ham_negf_type_c1'
     stop
  end if
  do i1_do=1,num_sum_mat
     temp_sen(i1_do)=dcmplx(0.d0,0.d0)
  end do
  do i1_do=1,num_sum_mat
     temp_rec(i1_do)=dcmplx(0.d0,0.d0)
  end do

  i_cou=0
  do i1_do=1,mat_max_rr
     do i2_do=1,mat_max_rr
        do i3_do=1,ls_spin
           i_cou=i_cou+1
           temp_sen(i_cou)=h_00r(i3_do,i2_do,i1_do)
        end do
     end do
  end do
  do i1_do=1,mat_max_rr
     do i2_do=1,mat_max_rr
        i_cou=i_cou+1
        temp_sen(i_cou)=s_00r(i2_do,i1_do)
     end do
  end do
  do i1_do=1,mat_max_rr
     do i2_do=1,mat_max_rr
        do i3_do=1,ls_spin
           i_cou=i_cou+1
           temp_sen(i_cou)=h_01r(i3_do,i2_do,i1_do)
        end do
     end do
  end do
  do i1_do=1,mat_max_rr
     do i2_do=1,mat_max_rr
        i_cou=i_cou+1
        temp_sen(i_cou)=s_01r(i2_do,i1_do)
     end do
  end do
  do i1_do=1,mat_max_rr
     do i2_do=1,mat_max_rr
        do i3_do=1,ls_spin
           i_cou=i_cou+1
           temp_sen(i_cou)=h_10r(i3_do,i2_do,i1_do)
        end do
     end do
  end do
  do i1_do=1,mat_max_rr
     do i2_do=1,mat_max_rr
        i_cou=i_cou+1
        temp_sen(i_cou)=s_10r(i2_do,i1_do)
     end do
  end do

  call MPI_ALLREDUCE(temp_sen,temp_rec,num_sum_mat,MPI_DOUBLE_COMPLEX          &
       ,MPI_SUM,mpi_comm_world,ierr)

  i_cou=0
  do i1_do=1,mat_max_rr
     do i2_do=1,mat_max_rr
        do i3_do=1,ls_spin
           i_cou=i_cou+1
           h_00r(i3_do,i2_do,i1_do)=temp_rec(i_cou)
        end do
     end do
  end do
  do i1_do=1,mat_max_rr
     do i2_do=1,mat_max_rr
        i_cou=i_cou+1
        s_00r(i2_do,i1_do)=temp_rec(i_cou)
     end do
  end do
  do i1_do=1,mat_max_rr
     do i2_do=1,mat_max_rr
        do i3_do=1,ls_spin
           i_cou=i_cou+1
           h_01r(i3_do,i2_do,i1_do)=temp_rec(i_cou)
        end do
     end do
  end do
  do i1_do=1,mat_max_rr
     do i2_do=1,mat_max_rr
        i_cou=i_cou+1
        s_01r(i2_do,i1_do)=temp_rec(i_cou)
     end do
  end do
  do i1_do=1,mat_max_rr
     do i2_do=1,mat_max_rr
        do i3_do=1,ls_spin
           i_cou=i_cou+1
           h_10r(i3_do,i2_do,i1_do)=temp_rec(i_cou)
        end do
     end do
  end do
  do i1_do=1,mat_max_rr
     do i2_do=1,mat_max_rr
        i_cou=i_cou+1
        s_10r(i2_do,i1_do)=temp_rec(i_cou)
     end do
  end do

  do i3_do=1,mat_max_rr
     do i2_do=i3_do,mat_max_rr
        do i1_do=1,ls_spin
           h_00r(i1_do,i2_do,i3_do)=h_00r(i1_do,i2_do,i3_do)                      &
                +dconjg(h_00r(i1_do,i3_do,i2_do))
           h_00r(i1_do,i3_do,i2_do)=dconjg(h_00r(i1_do,i2_do,i3_do))
        end do
        s_00r(i2_do,i3_do)=s_00r(i2_do,i3_do)+dconjg(s_00r(i3_do,i2_do))
        s_00r(i3_do,i2_do)=dconjg(s_00r(i2_do,i3_do))
     end do
  end do
  do i3_do=1,mat_max_rr
     do i2_do=1,mat_max_rr
        do i1_do=1,ls_spin
           h_10r(i1_do,i2_do,i3_do)=h_10r(i1_do,i2_do,i3_do)                      &
                +dconjg(h_01r(i1_do,i3_do,i2_do))
           h_01r(i1_do,i3_do,i2_do)=dconjg(h_10r(i1_do,i2_do,i3_do))
        end do
        s_10r(i2_do,i3_do)=s_10r(i2_do,i3_do)+dconjg(s_01r(i3_do,i2_do))
        s_01r(i3_do,i2_do)=dconjg(s_10r(i2_do,i3_do))
     end do
  end do

  deallocate(temp_sen,temp_rec,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error deallocate: alo_ham_negf_type_r1'
     stop
  end if


  do i3_do=1,mat_max_rr
     do i2_do=1,mat_max_rr
        do i1_do=1,ls_spin
           h00_r_t(i1_do,i2_do,i3_do)=h_00r(i1_do,i2_do,i3_do)
           h01_r_t(i1_do,i2_do,i3_do)=h_01r(i1_do,i2_do,i3_do)
           h10_r_t(i1_do,i2_do,i3_do)=h_10r(i1_do,i2_do,i3_do)
        end do
        s00_r_t(i2_do,i3_do)=s_00r(i2_do,i3_do)
        s01_r_t(i2_do,i3_do)=s_01r(i2_do,i3_do)
        s10_r_t(i2_do,i3_do)=s_10r(i2_do,i3_do)
     end do
  end do


  deallocate(i_orb_lr,h_00r,s_00r,h_01r,s_01r,h_10r,s_10r,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error deallocate: alo_ham_negf_type_r1'
     stop
  end if

  return
end subroutine set_ham_temp_ham_r

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

module hamiltonian_zper

  implicit none
  integer :: mat_max_zper
  integer, pointer :: itemp(:,:,:),jtemp(:)
  complex(8), pointer :: h00_mat(:,:),s00_mat(:,:)

contains
  subroutine alo_hamiltonian_zper_input
    implicit none
    integer :: ier,i1_do,i2_do

    allocate(h00_mat(mat_max_zper,mat_max_zper)                                  &
         ,s00_mat(mat_max_zper,mat_max_zper),stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_hamiltonian_zper_input'
       stop
    end if

    do i1_do=1,mat_max_zper
       do i2_do=1,mat_max_zper
          h00_mat(i2_do,i1_do)=dcmplx(0.d0,0.d0)
       end do
    end do
    do i1_do=1,mat_max_zper
       do i2_do=1,mat_max_zper
          s00_mat(i2_do,i1_do)=dcmplx(0.d0,0.d0)
       end do
    end do

    return
  end subroutine alo_hamiltonian_zper_input

  subroutine unset_hamiltonian_zper_input

    implicit none
    integer :: ier

    deallocate(h00_mat,s00_mat,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error deallocate: unset_hamiltonian_zper_input'
       stop
    end if

    return
  end subroutine unset_hamiltonian_zper_input

  subroutine alo_hamiltonian_zper_free(num_atom,num_unit)

    implicit none
    integer, intent(in) :: num_atom,num_unit(3)
    integer :: ier,i1_do,i2_do

    allocate(h00_mat(mat_max_zper,mat_max_zper)                                  &
         ,s00_mat(mat_max_zper,mat_max_zper)                                  &
         ,itemp(num_unit(1),num_unit(2),num_atom),stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_hamiltonian_zper_free'
       stop
    end if

    do i1_do=1,mat_max_zper
       do i2_do=1,mat_max_zper
          h00_mat(i2_do,i1_do)=dcmplx(0.d0,0.d0)
       end do
    end do
    do i1_do=1,mat_max_zper
       do i2_do=1,mat_max_zper
          s00_mat(i2_do,i1_do)=dcmplx(0.d0,0.d0)
       end do
    end do

    return
  end subroutine alo_hamiltonian_zper_free

  subroutine unset_hamiltonian_zper_free

    implicit none
    integer :: ier

    deallocate(h00_mat,s00_mat,itemp,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error deallocate: unset_hamiltonian_zper_free'
       stop
    end if

    return
  end subroutine unset_hamiltonian_zper_free

  subroutine alo_hamiltonian_zper_periodic(num_atom)

    implicit none
    integer, intent(in) :: num_atom
    integer :: ier,i1_do,i2_do

    allocate(h00_mat(mat_max_zper,mat_max_zper)                                  &
         ,s00_mat(mat_max_zper,mat_max_zper)                                  &
         ,jtemp(num_atom),stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_hamiltonian_zper_periodic'
       stop
    end if

    do i1_do=1,mat_max_zper
       do i2_do=1,mat_max_zper
          h00_mat(i2_do,i1_do)=dcmplx(0.d0,0.d0)
       end do
    end do
    do i1_do=1,mat_max_zper
       do i2_do=1,mat_max_zper
          s00_mat(i2_do,i1_do)=dcmplx(0.d0,0.d0)
       end do
    end do

    return
  end subroutine alo_hamiltonian_zper_periodic

  subroutine unset_hamiltonian_zper_periodic

    implicit none
    integer :: ier

    deallocate(h00_mat,s00_mat,jtemp,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error deallocate: unset_hamiltonian_zper_periodic'
       stop
    end if

    return
  end subroutine unset_hamiltonian_zper_periodic
end module hamiltonian_zper

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Naoki WATANABE, Nobutaka NISHIKAWA (Mizuho I.R.)   @@ !
! @@             Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine Hamiltonian__setup
  use ac_misc_module
  use ac_mpi_module

  implicit none

  integer       :: l, a, i, b, j
  integer       :: li, c, k
  logical       :: overlap

  call Hamiltonian__deallocate

  allocate( Hamiltonian%vAtomMatrix(Param%Data%natom, Param%Data%natom,0:Param%Cell%nL-1) )

  do l=0, Param%Cell%nL-1
     do a=MPI%isatom, MPI%ieatom
        i=Base%vipao(a)
        do b=1, Param%Data%natom
           j=Base%vipao(b)

           if( Base__intersect( Base%vpao(i), Base%vpao(j), &
                Param%Cell%vL(:,l) ) ) then
              overlap = .true.

           else if( Param%Option%indirect_overlap ) then
              vpsloop: do li=1-Param%Cell%nL, Param%Cell%nL-1
                 do c=1, Param%Data%natom
                    k=Potential%viVpsnon(c)
                    if( .not. Potential__intersect( Base%vpao(i), &
                         Potential%vVpsnon(k,1),  Param%Cell%vL(:,li) ) ) then
                       cycle
                    end if

                    if(  Potential__intersect( Base%vpao(j), &
                         Potential%vVpsnon(k,1),  Param%Cell%vL(:,li) ) ) then
                       overlap = .true.
                       go to 100
                    end if
                 end do
              end do vpsloop
100           continue
           else
              overlap = .false.
           end if

           if( overlap ) then
              allocate( Hamiltonian%vAtomMatrix(b,a,l)%Ptr )
              call AtomMatrix__allocate( Hamiltonian%vAtomMatrix(b,a,l)%Ptr, Base%vnpao(b), Base%vnpao(a) )
           else
              Hamiltonian%vAtomMatrix(b,a,l)%Ptr => null()
           end if
        end do
     end do
  end do

  return
end subroutine Hamiltonian__setup

subroutine Hamiltonian__calcSCF
  use ac_misc_module
  use ac_mpi_module
  implicit none
  integer :: iter, iter_st
  integer :: k

  integer          :: nE
  real(8), pointer :: vE(:)

  real(8) :: Eorb, Elat, Eint
  real(8) :: Efer_prev, Eorb_prev, Etot_prev, dEden

  integer :: i,spin,j_con

  call Hamiltonian__setup

  allocate( Hamiltonian%vBandMatrix(Param%SCF%nK) )

  do k=1, Param%SCF%nK
     call BandMatrix__allocate( Hamiltonian%vBandMatrix(k) )
  end do

  if( .not. Param%Option%spin_polar ) then
     nE = Param%SCF%nK*Base%npao * 1
  else
     nE = Param%SCF%nK*Base%npao * 2
  end if
  allocate( vE(0:nE-1) )

  if( Param%Option%fname_matrices_in /= "" ) then
     call AtomMatrix__load
     call Density__calc()
     iter_st=1
     Param%Option%fname_matrices_in = ""
  else
     iter_st=0
  end if

  open(unit=16,file=Param%Option%file_ac_tempout,position='append')
  write(16,*) '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'
  write(16,*) '++++++++++++ calculating overlap and kinetic matrices ...'
  close(16)
  call AtomMatrix__calcSK

  if( Param%Option%projection ) then
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,*) '++++++++++++ calculating local pseudo potential matrices ...'
     close(16)
     call AtomMatrix__calcL
  end if

  open(unit=16,file=Param%Option%file_ac_tempout,position='append')
  write(16,*) '++++++++++++ calculating nonlocal psudo potential matrices ...'
  close(16)
  call AtomMatrix__calcN

  open(unit=16,file=Param%Option%file_ac_tempout,position='append')
  write(16,*) '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'
  write(16,*)
  write(16,*) '**************************************************************'
  write(16,*) '************ start iteration: processe num =', MPI%size
  write(16,*) '**************************************************************'
  close(16)

  Efer_prev = 0.d0
  Eorb_prev = 0.d0
  Etot_prev = 0.d0

  if( Param%SCF%mix_target == 'density' ) then
     if(iter_st==1) then
        call Density__update( dEden, 0 )
     end if
  else if( Param%SCF%mix_target == 'density_matrix' ) then
     call DensityMatrix__update( dEden, iter_st-1 )
  end if

  j_con=100
  do iter=iter_st, Param%SCF%iter_max

     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,*)
     write(16,*) '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'
     write(16,*) '++++++++++++ iterations:',iter
     write(16,*) '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'
     close(16)

     call Potential__update

     call AtomMatrix__calcT

     do k=1, Param%SCF%nK
        if( Param%SCF%i_vK(k) < 0 ) then
           call BandMatrix__calc( Hamiltonian%vBandMatrix(k), Param%SCF%vK(:,k) )
           call BandMatrix__solve( Hamiltonian%vBandMatrix(k), iter )
        else
           if( .not. Param%Option%spin_orbit ) then
              do spin=1, Param%Option%nspin
                 do i=1, Base%npao
                    Hamiltonian%vBandMatrix(k)%E(i,spin) &
                         =Hamiltonian%vBandMatrix(Param%SCF%i_vK(k))%E(i,spin)
                 end do
              end do
           else
              do i=1, Base%npao*2
                 Hamiltonian%vBandMatrix(k)%E(i,1) &
                      =Hamiltonian%vBandMatrix(Param%SCF%i_vK(k))%E(i,1)
              end do
           end if
        end if
     end do

     call Energy__sort(nE,vE)
     call Energy__findFermi(Energy%Ef,nE,vE)

     do k=1, Param%SCF%nK
        if( Param%SCF%i_vK(k) >= 0 ) then
           cycle
        end if
        call BandMatrix__calcCDM( Hamiltonian%vBandMatrix(k) )
     end do

     call DensityMatrix__calc()

     if( Param%SCF%mix_target == 'density' ) then
        call Density__calc()

        call Density__update( dEden, iter )
     else if( Param%SCF%mix_target == 'density_matrix' ) then
        call DensityMatrix__update( dEden, iter )
        call Density__calc()
     end if

     call Energy__sort(nE,vE)
     call Energy__findFermi(Energy%Ef,nE,vE)
     call Energy__calcOrbital(Eorb,nE,vE)
     call Energy__calcLattice(Elat)
     call Energy__calcInternal(Eint)
     Energy%Etot = Eorb + Elat - Eint

     if( MPI%root ) then
        call Hamiltonian__level__out(Eorb,Elat,Eint)
     end if
     call Hamiltonian__showCharge

     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,*) '                     * Efermi =', Energy%Ef
     write(16,*) '                  * Eorb/Nele =', Eorb/Param%Data%Ne
     write(16,*) '                  * Etot/Natm =', Energy%Etot/Param%Data%natom
     close(16)

     if( Param%SCF%cri_type == 'fermi' ) then
        open(unit=16,file=Param%Option%file_ac_tempout,position='append')
        write(16,*)'   ###### Efermi ####################################################'
        write(16,976) Param%SCF%criterion
        write(16,977) iter,Energy%Ef-Efer_prev,Energy%Ef
        write(16,*)'   ##################################################################'
976     format('    ######  criterion:',f25.16,'                 ######')
977     format('    #d####       ',i5,f25.16,f15.6,'  ####d#')
        close(16)
     end if

     if( Param%SCF%cri_type == 'orbital' ) then
        open(unit=16,file=Param%Option%file_ac_tempout,position='append')
        write(16,*)'   ###### Eorb/Nele #################################################'
        write(16,974) Param%SCF%criterion
        write(16,975) iter,(Eorb-Eorb_prev)/Param%Data%Ne,Eorb/Param%Data%Ne
        write(16,*)'   ##################################################################'
974     format('    ######  criterion:',f25.16,'                 ######')
975     format('    #d####       ',i5,f25.16,f15.6,'  ####d#')
        close(16)
     end if

     if( Param%SCF%cri_type == 'total' ) then
        open(unit=16,file=Param%Option%file_ac_tempout,position='append')
        write(16,*)'   ###### Etot/Natom ################################################'
        write(16,972) Param%SCF%criterion
        write(16,973) iter,(Energy%Etot-Etot_prev)/Param%Data%natom,Energy%Etot/Param%Data%natom
        write(16,*)'   ##################################################################'
972     format('    ######  criterion:',f25.16,'                 ######')
973     format('    #d####       ',i5,f25.16,f15.6,'  ####d#')
        close(16)
     end if

     if( Param%SCF%cri_type == 'density' ) then
        open(unit=16,file=Param%Option%file_ac_tempout,position='append')
        write(16,*)'   ###### drho ######################################################'
        write(16,970) Param%SCF%criterion,(Eorb-Eorb_prev)/Param%Data%Ne
        write(16,971) iter,dEden,dabs(Energy%Etot-Etot_prev)/Param%Data%natom
        write(16,*)'   ##################################################################'
970     format('    ######            ',f21.12,f20.11,' ######')
971     format('    #d####       ',i5,f21.12,f20.11,' ####d#')
        close(16)
     end if

     if( iter /= 0 ) then
        select case( Param%SCF%cri_type )
        case('fermi')
           if( dabs(Energy%Ef-Efer_prev) < Param%SCF%criterion ) then
              j_con=0
              open(unit=16,file=Param%Option%file_ac_tempout,position='append')
              write(16,*)
              write(16,*) '**************************************************************'
              write(16,*) '************   end iterations:',iter
              write(16,*) '**************************************************************'
              close(16)
              exit
           end if
        case('orbital')
           if( dabs(Eorb-Eorb_prev)/Param%Data%Ne < Param%SCF%criterion )  then
              j_con=0
              open(unit=16,file=Param%Option%file_ac_tempout,position='append')
              write(16,*)
              write(16,*) '**************************************************************'
              write(16,*) '************   end iterations:',iter
              write(16,*) '**************************************************************'
              close(16)
              exit
           end if
        case('total')
           if( dabs(Energy%Etot-Etot_prev)/Param%Data%natom  < Param%SCF%criterion )  then
              j_con=0
              open(unit=16,file=Param%Option%file_ac_tempout,position='append')
              write(16,*)
              write(16,*) '**************************************************************'
              write(16,*) '************   end iterations:',iter
              write(16,*) '**************************************************************'
              close(16)
              exit
           end if
        case('density')
           if( dEden < Param%SCF%criterion )  then
              j_con=0
              open(unit=16,file=Param%Option%file_ac_tempout,position='append')
              write(16,*)
              write(16,*) '**************************************************************'
              write(16,*) '************   end iterations:',iter
              write(16,*) '**************************************************************'
              close(16)
              exit
           end if
        end select
     end if

     Efer_prev = Energy%Ef
     Eorb_prev = Eorb
     Etot_prev = Energy%Etot

     if( Param%Option%saveat == "everystep" ) then
        call Hamiltonian__save
     end if
  end do

  if( j_con/=0 ) then
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,*)
     write(16,*) '**************************************************************'
     write(16,*) '************   end iterations: !!! NOT YET CONVERGED !!!'
     write(16,*) '**************************************************************'
     close(16)
  end if

  if( MPI%root ) then
     call Energy__sort(nE,vE)
     call Energy__findFermi(Energy%Ef,nE,vE)
     call Energy__calcOrbital(Eorb,nE,vE)
     call Energy__calcLattice(Elat)
     call Energy__calcInternal(Eint)
     Energy%Etot = Eorb + Elat - Eint
     call Hamiltonian__level__out(Eorb,Elat,Eint)

  end if

  call Hamiltonian__showCharge

  if( Param%Option%saveat == "finalstep" ) then
     call Hamiltonian__save
  end if
  if( Param%Option%saveat /= "never" ) then
     Param%Option%fname_matrices_in=Param%Option%fname_matrices
  end if

  if( Param%Option%ascot_negf ) then
     if( MPI%root ) then
        call Param__readdata_ASCOT
        call Hamiltonian__outdata2( vE,nE )
     end if
  end if
  if( Param%Option%fname_accel_c /= "" ) then
     call Hamiltonian__outdata3
  end if

  if(associated(vE)) deallocate(vE)

  do k=1, Param%SCF%nK
     call BandMatrix__deallocate(Hamiltonian%vBandMatrix(k))
  end do
  if(associated(Hamiltonian%vBandMatrix)) deallocate( Hamiltonian%vBandMatrix )

  return
end subroutine Hamiltonian__calcSCF

subroutine Hamiltonian__save
  use ac_misc_module
  use ac_mpi_module
  implicit none

  if( Param%Option%fname_matrices /= '' ) then
     call AtomMatrix__save
  end if

  if( .not. MPI%root ) return

  if( Param%Option%fname_rhoscf /= "" ) then
     if( Param%Option%spin_orbit ) then
        call vector3d__save4( Density%rhoLS, Param%Option%fname_rhoscf )
     else if( Param%Option%spin_polar ) then
        call vector3d__save2( Density%rho, Param%Option%fname_rhoscf )
     else
        call vector3d__save1( Density%rho, Param%Option%fname_rhoscf )
     end if
  end if

  if(Param%Option%na .and. Param%Option%fname_rhoval /= "" ) then
     call vector3d__save1( Density%rhoval, Param%Option%fname_rhoval )
  end if

  if( Param%Option%pcc .and. Param%Option%fname_rhopcc /= '' ) then
     call vector3d__save1( Density%rhopcc, Param%Option%fname_rhopcc )
  end if

  if( Param%Option%fname_vext /= '' ) then
     call vector3d__save1( Potential%Vext, Param%Option%fname_vext )
  end if

  if( (.not. Param%Option%nohar) .and. Param%Option%fname_vhar /= '' ) then
     call vector3d__save1( Potential%dVhar, Param%Option%fname_vhar )
  end if

  if( (.not. Param%Option%noexc) .and. Param%Option%fname_vexc /= '' ) then
     call vector3d__save2( Potential%Vexc, Param%Option%fname_vexc )
  end if

  if( Param%Option%fname_vtot /= '' ) then
     call vector3d__save2( Potential%Vtot, Param%Option%fname_vtot )
  end if

  return 
end subroutine Hamiltonian__save

subroutine Hamiltonian__calcBandMap
  use ac_misc_module
  use ac_mpi_module

  implicit none
  integer :: iunit,iunit1
  integer :: spin
  integer :: k, m
  type(BandMatrix_type) :: band

  open(unit=16,file=Param%Option%file_ac_tempout,position='append')
  write(16,*)
  write(16,*) '**************************************************************'
  write(16,*) '************ start calculation: band energies'
  write(16,*) '**************************************************************'
  close(16)

  call BandMatrix__allocate( band )

  iunit = 1
  iunit1 = 2
  open(iunit,file=Param%Band%fname)
  if( Param%Option%nspin == 2 ) then
     open(iunit1,file=Param%Band%fname1)
  end if

  if( MPI%root ) then
     write(iunit,*) '* cp= ',Energy%Ef*AU_TO_EV,' [eV]'
     write(iunit,*) '**************************************************'
     if( Param%Option%nspin == 2 ) then
        write(iunit,*) '  UP  spin +++++++++++++++++++++++++++++++++++++++'
        write(iunit1,*) '* cp= ',Energy%Ef*AU_TO_EV,' [eV]'
        write(iunit1,*) '**************************************************'
        write(iunit1,*) ' DOWN spin +++++++++++++++++++++++++++++++++++++++'
     end if
  end if

  do k=1, Param%Band%nK

     call BandMatrix__calc( band, Param%Band%vK(:,k) )
     call BandMatrix__solve( band, 0 )

     band%E(:,:) = band%E(:,:)

     if( MPI%root ) then
        if( Param%Option%nspin /= 2 ) then
           write(iunit,'(i3,$)') k
           do m=1, Param%Band%num_band
              write(iunit,'(f16.10,$)') band%E(m,1)*AU_TO_EV
           end do
        else 
           write(iunit,'(i3,$)') k
           do m=1, Param%Band%num_band
              write(iunit,'(f16.10,$)') band%E(m,1)*AU_TO_EV
           end do
           write(iunit1,'(i3,$)') k
           do m=1, Param%Band%num_band
              write(iunit1,'(f16.10,$)') band%E(m,2)*AU_TO_EV
           end do
        end if

        write(iunit,*)
        if( Param%Option%nspin == 2 ) then
           write(iunit1,*)
        end if
     end if
  end do

  close(iunit)
  if( Param%Option%nspin == 2 ) then
     close(iunit1)
  end if

  call BandMatrix__deallocate( band )

  return
end subroutine Hamiltonian__calcBandMap

subroutine Hamiltonian__calcDOS
  use ac_misc_module
  use ac_mpi_module

  implicit none
  integer :: iunit
  integer :: spin
  integer :: ika, ikb, ikc, b
  type(BandMatrix_type) :: band

  real(8), pointer :: vE(:,:,:,:,:)
  real(8), pointer :: vdos(:,:)

  integer :: n_npao,n_spin
  real(8) :: pdbe_t
  real(8) :: pdosk(3)

  open(unit=16,file=Param%Option%file_ac_tempout,position='append')
  write(16,*)
  write(16,*) '**************************************************************'
  write(16,*) '************ start calculation: density of states'
  write(16,*) '**************************************************************'
  close(16)

  call BandMatrix__allocate( band )

  if( Param%Option%nspin < 3 ) then
     n_npao=Base%npao
     n_spin=Param%Option%nspin
  else
     n_npao=Base%npao*2
     n_spin=1
  end if

  allocate( vE(Param%DOS%Nka, Param%DOS%Nkb, Param%DOS%Nkc, n_npao, n_spin ) )

  do ikc=1, Param%DOS%Nkc
     do ikb=1, Param%DOS%Nkb
        do ika=1, Param%DOS%Nka
           call Param__DOS__K(pdosk,ika,ikb,ikc)
           call BandMatrix__calc( band, pdosk )
           call BandMatrix__solve( band, 0 )
           vE(ika,ikb,ikc,:,:) = band%E(:,:)
        end do
     end do
  end do

  allocate( vdos(Param%DOS%Ne, n_spin ) )

  do spin=1, n_spin
     call DOS__calc( vdos(:,spin), vE(:,:,:,:,spin), n_npao )
  end do

  if( MPI%root ) then

     iunit = 1
     open(iunit,file=Param%DOS%fname)

     write(iunit,'(a,a)') ' + Density of States: ', Param%DOS%method
     write(iunit,'(a)') ' ++++++++++++++++++++++++++++++++++++++++++++++++++'

     write(iunit,*) '* cp= ',Energy%Ef*AU_TO_EV,' [eV]'
     write(iunit,*) '**************************************************'

     if( Param%Option%nspin == 1 ) then
        do b=1, Param%DOS%Ne
           call Param__DOS__binEnergy(pdbe_t,b)
           write(iunit,*) pdbe_t*AU_TO_EV, vdos(b,1)/AU_TO_EV, vdos(b,1)/AU_TO_EV
        end do
     else
        if( Param%Option%nspin == 2 ) then
           do b=1, Param%DOS%Ne
              call Param__DOS__binEnergy(pdbe_t,b)
              write(iunit,*) pdbe_t*AU_TO_EV, vdos(b,1)/AU_TO_EV, vdos(b,2)/AU_TO_EV
           end do
        else
           do b=1, Param%DOS%Ne
              call Param__DOS__binEnergy(pdbe_t,b)
              write(iunit,*) pdbe_t*AU_TO_EV, vdos(b,1)/AU_TO_EV
           end do
        end if
     end if

     close(iunit)

  end if

  close(iunit)

  deallocate( vE )
  deallocate( vdos )

  call BandMatrix__deallocate( band )

  return
end subroutine Hamiltonian__calcDOS

subroutine Hamiltonian__calcMO
  use ac_misc_module
  use ac_mpi_module

  implicit none
  type(BandMatrix_type) :: band

  integer :: n_npao,n_spin

  integer :: spin
  integer :: k, m, l
  integer :: i1,i2,i3

  character(len=4)   :: spinlabel
  character(len=8)   :: klabel, mlabel
  character(len=128) :: fnamer, fnamei

  complex(8), allocatable :: temp(:)
  real(8), pointer :: waver(:,:,:), wavei(:,:,:)

  if( Param%Option%nspin < 4 ) then
     n_npao=Base%npao
     n_spin=Param%Option%nspin
  else
     n_npao=Base%npao*2
     n_spin=1
  end if

  open(unit=16,file=Param%Option%file_ac_tempout,position='append')
  write(16,*)
  write(16,*) '**************************************************************'
  write(16,*) '************ start calculation: molecule orbital'
  write(16,*) '**************************************************************'
  close(16)

  call BandMatrix__allocate( band )

  allocate( waver(Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc) )
  allocate( wavei(Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc) )

  allocate( temp(0:Base%npao-1) )

  do k=1, Param%MO%nK
     call BandMatrix__calc( band, Param%MO%vK(:,k) )
     call BandMatrix__solve( band, 0 )

     do spin=1, n_spin
        do m=1, n_npao
           if( Param%MO%method == "band_num" ) then
              if( m-1 < Param%MO%band_min-1 ) cycle
              if( Param%MO%band_max-1 < m ) cycle
           else if( Param%MO%method == "ho_lumo" ) then
              if( m-1 - Param%MO%band_min < 0 ) cycle
              if( m-1 - Param%MO%band_min < n_npao .and. &
                   band%E(m - Param%MO%band_min,spin) < Energy%Ef ) cycle
              if( m-1 - Param%MO%band_max >= n_npao ) cycle
              if( m-1 - Param%MO%band_max >= 0 .and. &
                   band%E(m - Param%MO%band_max,spin) > Energy%Ef ) cycle
           end if

           open(unit=16,file=Param%Option%file_ac_tempout,position='append')
           write(16,999) m+1,k,spin
999        format('                 ++++++ level:',i8,' (k=',i5,', s=',i3,')')
           close(16)

           if( .not. Param%Option%spin_polar ) then
              spinlabel = ""
           else if( spin==1 ) then
              spinlabel = ".up"
           else if( spin==2 ) then
              spinlabel = ".dw"
           end if
           write(klabel,'(a2i3.3)') ".k", k
           write(mlabel,'(a2i3.3)') ".m", m+1

           fnamei = trim(Param%MO%fbase) &
                // trim(spinlabel) // trim(klabel) // trim(mlabel)

           fnamer = trim(fnamei) &
                // '.real' // trim(Param%Option%field_format)
           fnamei = trim(fnamei) &
                // '.imag' // trim(Param%Option%field_format)

           if( Param%Option%nspin < 4 ) then
              if( m >= MPI%smat .and. m <= MPI%emat ) then
                 do l=1, Base%npao
                    temp(l)=band%H(l,m,spin)
                 end do
              else
                 do l=1, Base%npao
                    temp(l)=0.d0
                 end do
              end if
           else
              if( MPI%root ) then
                 if( m-1 < Base%npao ) then
                    do l=1, Base%npao
                       temp(l)=band%H(l,m,1)+band%H(l,m,2)
                    end do
                 else
                    do l=1, Base%npao
                       temp(l)=band%H(l,m-Base%npao,3)+band%H(l,m-Base%npao,4)
                    end do
                 end if
              else
                 do l=1, Base%npao
                    temp(l)=0.d0
                 end do
              end if
           end if
           call Base__calcWave( waver, wavei, temp, Param%MO%vK(:,k), Base%npao )

           if( MPI%root ) then
              call vector3d__save_mo( waver, fnamer )
              call vector3d__save_mo( wavei, fnamei )
           end if
        end do
     end do
  end do

  deallocate( waver, wavei )
  deallocate( temp )

  call BandMatrix__deallocate( band )

  return
end subroutine Hamiltonian__calcMO

subroutine Hamiltonian__deallocate
  use ac_misc_module
  use ac_mpi_module
  implicit none
  integer :: l, a, b

  if( associated(Hamiltonian%vAtomMatrix) ) then

     do l=0, Param%Cell%nL-1
        do a=MPI%isatom, MPI%ieatom
           do b=1, Param%Data%natom
              if( .not. associated(Hamiltonian%vAtomMatrix(b,a,l)%Ptr) ) then
                 cycle
              end if
              call AtomMatrix__deallocate(Hamiltonian%vAtomMatrix(b,a,l)%Ptr)
              deallocate(Hamiltonian%vAtomMatrix(b,a,l)%Ptr)
           end do
        end do
     end do

     deallocate( Hamiltonian%vAtomMatrix )
  end if

  return
end subroutine Hamiltonian__deallocate

subroutine Hamiltonian__level__out(Eorb,Elat,Eint)
  use ac_misc_module
  use ac_mpi_module

  implicit none
  real(8), intent(in) :: Eorb,Elat,Eint

  integer, allocatable :: i_temp(:,:)
  integer :: j_temp,k,n,n1,spin
  integer :: n_npao,n_spin

  open(unit=60,file='energy.dat')
  write(60,'(a)') 'Fermi energy'
  write(60,'(a,f25.16,a,f29.16,a)') '     Ef =', Energy%Ef,' [au];',Energy%Ef*AU_TO_EV,' [eV]'
  write(60,*)
  write(60,'(a)') 'Energy (Etot = Eorb + Elat - Eint)'
  write(60,'(a,f25.16,a,f29.16,a)') '   Etot =', Eorb + Elat - Eint,' [au]:',(Eorb + Elat - Eint)*AU_TO_EV,' [eV]'
  write(60,'(a,f25.16,a,f29.16,a)') '   Eorb =', Eorb,' [au];',Eorb*AU_TO_EV,' [eV]'
  write(60,'(a,f25.16,a,f29.16,a)') '   Elat =', Elat,' [au];',Elat*AU_TO_EV,' [eV]'
  write(60,'(a,f25.16,a,f29.16,a)') '   Eint =', Eint,' [au];',Eint*AU_TO_EV,' [eV]'
  write(60,*)
  close(60)

  if( .not. Param%Option%spin_orbit ) then
     n_npao=Base%npao
     n_spin=Param%Option%nspin
  else
     n_npao=Base%npao*2
     n_spin=1
  end if
  allocate( i_temp(n_npao,n_spin) )
  do n=1, n_npao
     do spin=1, n_spin
        i_temp(n,spin)=n
     end do
  end do

  open(unit=60,file='level_au.dat')
  open(unit=61,file='level_ev.dat')
  write(60,'(a)') '     *********************************'
  write(60,'(a,f25.16,a)') '     ** Ef =', Energy%Ef,'     [au]'
  write(60,'(a)') '     *********************************'
  write(60,*)
  write(61,'(a)') '     *********************************'
  write(61,'(a,f25.16,a)') '     ** Ef =', Energy%Ef*AU_TO_EV,'     [eV]'
  write(61,'(a)') '     *********************************'
  write(61,*)
  do k=1, Param%SCF%nK
     write(60,'(a)') '     *********************************'
     write(60,'(a,3f15.6)') '     ** K =', Param%SCF%vK(:,k)
     write(60,'(a)') '     *********************************'
     write(61,'(a)') '     *********************************'
     write(61,'(a,3f15.6)') '     ** K =', Param%SCF%vK(:,k)
     write(61,'(a)') '     *********************************'
     if( .not. Param%Option%spin_orbit ) then
        write(60,'(a)') '          [au]:          up spin                  down spin'
        write(61,'(a)') '          [eV]:          up spin                  down spin'
     else
        write(60,'(a)') '          [au]:'
        write(61,'(a)') '          [eV]:'
     end if
     do spin=1, n_spin
        do n=1, n_npao
           do n1=n+1, n_npao
              if( Hamiltonian%vBandMatrix(k)%E(i_temp(n,spin),spin)  &
                   > Hamiltonian%vBandMatrix(k)%E(i_temp(n1,spin),spin) ) then
                 j_temp=i_temp(n,spin)
                 i_temp(n,spin)=i_temp(n1,spin)
                 i_temp(n1,spin)=j_temp
              end if
           end do
        end do
     end do
     if( .not. Param%Option%spin_orbit ) then
        if( Param%Option%nspin == 1 ) then
           do n=1, n_npao
              write(60,999) n+1-1,Hamiltonian%vBandMatrix(k)%E(i_temp(n,1),1) &
                   ,Hamiltonian%vBandMatrix(k)%E(i_temp(n,1),1)
              write(61,999) n+1-1,Hamiltonian%vBandMatrix(k)%E(i_temp(n,1),1)*AU_TO_EV &
                   ,Hamiltonian%vBandMatrix(k)%E(i_temp(n,1),1)*AU_TO_EV
           end do
        else
           do n=1, n_npao
              write(60,999) n+1-1,Hamiltonian%vBandMatrix(k)%E(i_temp(n,1),1) &
                   ,Hamiltonian%vBandMatrix(k)%E(i_temp(n,2),2)
              write(61,999) n+1-1,Hamiltonian%vBandMatrix(k)%E(i_temp(n,1),1)*AU_TO_EV &
                   ,Hamiltonian%vBandMatrix(k)%E(i_temp(n,2),2)*AU_TO_EV
           end do
        end if
     else
        do n=1, n_npao
           write(60,998) n+1-1,Hamiltonian%vBandMatrix(k)%E(i_temp(n,1),1)
           write(61,998) n+1-1,Hamiltonian%vBandMatrix(k)%E(i_temp(n,1),1)*AU_TO_EV
        end do
     end if
     write(60,*)
     write(61,*)
  end do
  close(60)
  close(61)

  deallocate( i_temp )
999 format('              ',i5,2f25.15)
998 format('              ',i5,f25.15)

  return
end subroutine Hamiltonian__level__out

subroutine Hamiltonian__showCharge
  use ac_misc_module
  use ac_mpi_module
  implicit none
  real(8), pointer :: CA(:,:),CA_sen(:,:),CA_rec(:,:)
  real(8) :: sum_u,sum_d

  integer :: l
  integer :: a, i1
  integer :: b, j1
  integer :: i_temp, ispin
  real(8) :: const

  if( Param%Option%spin_orbit ) then
     call Hamiltonian__showCharge_ls
     return
  end if

  allocate( CA(2,Param%Data%natom) )
  do a=1,Param%Data%natom
     do ispin=1, 2
        CA(ispin,a)=0.d0
     end do
  end do

  do l=0, Param%Cell%nL-1
     do a=MPI%isatom, MPI%ieatom
        do b=1, Param%Data%natom
           if( .not. associated(Hamiltonian%vAtomMatrix(b,a,l)%Ptr) ) then
              cycle
           end if
           do i1=MPI%ispao(a), MPI%iepao(a)
              do j1=1, Base%vnpao(b)
                 do ispin=1, Param%Option%nspin
                    CA(ispin,a)=CA(ispin,a) &
                         +Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDM(j1,i1,ispin) &
                         *Hamiltonian%vAtomMatrix(b,a,l)%Ptr%S(j1,i1)
                    if( l > 0 ) then
                       CA(ispin,b)=CA(ispin,b) &
                            +Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDM(j1,i1,ispin) &
                            *Hamiltonian%vAtomMatrix(b,a,l)%Ptr%S(j1,i1)
                    end if
                 end do
              end do
           end do
        end do
     end do
  end do

  if( Param%Option%nspin == 1 ) then
     do a=MPI%isatom, MPI%ieatom
        CA(1,a)=CA(1,a)*.5d0
        CA(2,a)=CA(1,a)
     end do
  end if

  allocate(CA_sen(2,Param%Data%natom))
  allocate(CA_rec(2,Param%Data%natom))
  do a=1,Param%Data%natom
     CA_sen(1,a)=CA(1,a)
     CA_sen(2,a)=CA(2,a)
     CA_rec(1,a)=0.d0
     CA_rec(2,a)=0.d0
  end do
  i_temp=2*Param%Data%natom
  call MPI_ALLREDUCE(CA_sen,CA_rec,i_temp,MPI_DOUBLE_PRECISION,MPI_SUM,MPI_COMM_WORLD,MPI%info)
  do a=1,Param%Data%natom
     CA(1,a)=CA_rec(1,a)
     CA(2,a)=CA_rec(2,a)
  end do
  deallocate(CA_sen)
  deallocate(CA_rec)

  if( MPI%root ) then
     sum_u=0.d0
     sum_d=0.d0
     open(unit=37,file='charge_per.dat')
     write(37,*) '--------------------------------------------------------------'
     write(37,*) '------------   Charge:'
     write(37,*) '--------------------------------------------------------------'
     write(37,*) '   number    up             down           total          diff'
     do a=1,Param%Data%natom
        write(37,980) a,CA(1,a),CA(2,a),CA(1,a)+CA(2,a),CA(1,a)-CA(2,a)
980     format(5x,i5,4f15.6)
        sum_u=sum_u+CA(1,a)
        sum_d=sum_d+CA(2,a)
     end do
     write(37,*)
     write(37,*) '--------------------------------------------------------------'
     write(37,*)
     write(37,*) '   TOTAL:    up             down           total          diff'
     write(37,981) sum_u,sum_d,sum_u+sum_d,sum_u-sum_d
     write(37,*) '--------------------------------------------------------------'
981  format(10x,4f15.6)
     close(37)
  end if

  if(associated(CA)) deallocate(CA)

  return
end subroutine Hamiltonian__showCharge

subroutine Hamiltonian__showCharge_ls
  use ac_misc_module
  use ac_mpi_module
  implicit none
  complex(8), pointer :: CA(:,:),CA_sen(:,:),CA_rec(:,:)
  real(8) :: sum_u,sum_d,sum_x,sum_y

  integer :: l
  integer :: a, i1
  integer :: b, j1
  integer :: i_temp, ispin
  real(8) :: const

  allocate( CA(4,Param%Data%natom) )
  do a=1,Param%Data%natom
     do ispin=1, 4
        CA(ispin,a)=dcmplx(0.d0,0.d0)
     end do
  end do
  const=0.5d0

  do l=0, Param%Cell%nL-1
     do a=MPI%isatom, MPI%ieatom
        do b=1, Param%Data%natom
           if( .not. associated(Hamiltonian%vAtomMatrix(b,a,l)%Ptr) ) then
              cycle
           end if
           do i1=MPI%ispao(a), MPI%iepao(a)
              do j1=1, Base%vnpao(b)
                 do ispin=1, Param%Option%nspin
                    CA(ispin,a)=CA(ispin,a) &
                         +Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDMLS(j1,i1,ispin) &
                         *Hamiltonian%vAtomMatrix(b,a,l)%Ptr%S(j1,i1) * const
                    if( l > 0 ) then
                       CA(ispin,b)=CA(ispin,b) &
                            +Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDMLS(j1,i1,ispin) &
                            *Hamiltonian%vAtomMatrix(b,a,l)%Ptr%S(j1,i1) * const
                    end if
                 end do
              end do
           end do
        end do
     end do
  end do

  allocate(CA_sen(4,Param%Data%natom))
  allocate(CA_rec(4,Param%Data%natom))
  do a=1,Param%Data%natom
     do ispin=1, Param%Option%nspin
        CA_sen(ispin,a)=CA(ispin,a)
        CA_rec(ispin,a)=dcmplx(0.d0,0.d0)
     end do
  end do
  i_temp=4*Param%Data%natom
  call MPI_ALLREDUCE(CA_sen,CA_rec,i_temp,MPI_DOUBLE_COMPLEX,MPI_SUM,MPI_COMM_WORLD,MPI%info)
  do a=1,Param%Data%natom
     do ispin=1, Param%Option%nspin
        CA(ispin,a)=CA_rec(ispin,a)
     end do
  end do
  deallocate(CA_sen)
  deallocate(CA_rec)

  do a=1,Param%Data%natom
     CA(1,a)=CA(1,a)+dconjg(CA(1,a))
     CA(2,a)=CA(2,a)+dconjg(CA(3,a))
     CA(3,a)=dconjg(CA(2,a))
     CA(4,a)=CA(4,a)+dconjg(CA(4,a))
  end do

  if( MPI%root ) then
     sum_u=0.d0
     sum_d=0.d0
     sum_x=0.d0
     sum_y=0.d0
     open(unit=37,file='charge_per.dat')
     write(37,*) '--------------------------------------------------------------'
     write(37,*) '------------   Charge:'
     write(37,*) '--------------------------------------------------------------'
     write(37,*) '   number    total          Mz             Mx             My'
     do a=1,Param%Data%natom
        write(37,980) a,dreal(CA(1,a)+CA(4,a)),dreal(CA(1,a)-CA(4,a))            &
             ,dreal(CA(2,a)+CA(3,a)),dimag(CA(2,a)-CA(3,a))
980     format(5x,i5,4f15.6)
        sum_u=sum_u+dreal(CA(1,a))
        sum_d=sum_d+dreal(CA(4,a))
        sum_x=sum_x+dreal(CA(2,a))
        sum_y=sum_y+dimag(CA(2,a))
     end do
     write(37,*)
     write(37,*) '--------------------------------------------------------------'
     write(37,*)
     write(37,*) '   TOTAL:    total          Sz             Sx             Sy'
     write(37,981) sum_u+sum_d,sum_u-sum_d,sum_x,sum_y
     write(37,*) '--------------------------------------------------------------'
981  format(10x,4f15.6)
     close(37)
  end if

  if(associated(CA)) deallocate(CA)

  return
end subroutine Hamiltonian__showCharge_ls

subroutine Hamiltonian__outdata2(vE,nE)
  use ac_misc_module

  implicit none
  integer :: nE
  real(8) :: vE( nE )
  real(8) :: e_min_level
  integer :: i1_do,i2_do,i3_do

  e_min_level=100000.d0
  do i1_do=1,nE
     if( e_min_level > vE(i1_do) ) then
        e_min_level = vE(i1_do)
     end if
  end do

  open(unit=36,file=Param%Option%fname_ascot_vd)

  write(36,*) Param%Option%nspin-1,Param%SCF%Nka,Param%SCF%Nkb,Param%SCF%Nkc
  write(36,*)
  write(36,*) Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc
  write(36,*)
  write(36,*) Param%Cell%La
  write(36,*) Param%Cell%Lb
  write(36,*) Param%Cell%Lc

  write(36,*)
  write(36,*) Energy%Ef,'     = Chemical Potential'
  write(36,*) e_min_level,'     = minimum energy'
  write(36,*)
  do i1_do=1,Param%Cell%Na
     do i2_do=1,Param%Cell%Nb
        do i3_do=1,Param%Cell%Nc
           write(36,991) Potential%dVhar(i1_do,i2_do,i3_do)
        end do
     end do
  end do
  write(36,*)
  do i1_do=1,Param%Cell%Na
     do i2_do=1,Param%Cell%Nb
        do i3_do=1,Param%Cell%Nc
           if( Param%Option%nspin-1 == 0 ) then
              write(36,991) Potential%Vtot(1,i1_do,i2_do,i3_do)
           else
              if( Param%Option%nspin-1 == 1 ) then
                 write(36,992) Potential%Vtot(1,i1_do,i2_do,i3_do) &
                      ,Potential%Vtot(2,i1_do,i2_do,i3_do)
              else
                 write(36,994) Potential%Vtot(1,i1_do,i2_do,i3_do) &
                      ,Potential%Vtot(2,i1_do,i2_do,i3_do) &
                      ,Potential%Vtot(3,i1_do,i2_do,i3_do) &
                      ,Potential%Vtot(4,i1_do,i2_do,i3_do)
              end if
           end if
        end do
     end do
  end do
  write(36,*)
  do i1_do=1,Param%Cell%Na
     do i2_do=1,Param%Cell%Nb
        do i3_do=1,Param%Cell%Nc
           if( Param%Option%nspin-1 == 0 ) then
              write(36,991) Density%rho(1,i1_do,i2_do,i3_do)*.5d0
           else
              if( Param%Option%nspin-1 == 1 ) then
                 write(36,992) Density%rho(1,i1_do,i2_do,i3_do) &
                      ,Density%rho(2,i1_do,i2_do,i3_do)
              else
                 write(36,994) Density%rhoLS(1,i1_do,i2_do,i3_do) &
                      ,Density%rhoLS(2,i1_do,i2_do,i3_do)
                 write(36,994) Density%rhoLS(3,i1_do,i2_do,i3_do) &
                      ,Density%rhoLS(4,i1_do,i2_do,i3_do)
              end if
           end if
        end do
     end do
  end do

  close(36)

994 format(4d25.15)
993 format(3d25.15)
992 format(2d25.15)
991 format(1d25.15)

  return
end subroutine Hamiltonian__outdata2

subroutine Hamiltonian__outdata3
  use ac_misc_module
  use ac_mpi_module

  implicit none
  type(Element_type), pointer :: elem
  real(8), parameter :: ene_scale=27.211396212d0
  real(8), parameter :: eps=1.d-15

  integer :: n,i_do,j_do,i1_do,i2_do,i3_do,i7_do,i_c,itemp1
  integer :: a,b,l,i1,j1
  real(8) :: temp_dd,temp_r,const

  integer :: ispin

  integer :: mat_max_ll,mat_max_rr,mat_max_cc,ele_num_ll,ele_num_rr
  integer :: num_hcc1,num_hcl1,num_hcr1
  integer :: num_hcc2,num_hcl2,num_hcr2
  integer :: num_scc,num_scl,num_scr
  integer :: num_h00_l1,num_h01_l1,num_h10_l1
  integer :: num_h00_l2,num_h01_l2,num_h10_l2
  integer :: num_s00_l,num_s01_l,num_s10_l
  integer :: num_h00_r1,num_h01_r1,num_h10_r1
  integer :: num_h00_r2,num_h01_r2,num_h10_r2
  integer :: num_s00_r,num_s01_r,num_s10_r

  integer, allocatable :: i_orb(:)

  complex(8), allocatable :: h_cc(:,:,:)
  complex(8), allocatable :: s_cc(:,:)
  complex(8), allocatable :: h_cl(:,:,:)
  complex(8), allocatable :: s_cl(:,:)
  complex(8), allocatable :: h_cr(:,:,:)
  complex(8), allocatable :: s_cr(:,:)

  complex(8), allocatable :: h_00l(:,:,:)
  complex(8), allocatable :: s_00l(:,:)
  complex(8), allocatable :: h_01l(:,:,:)
  complex(8), allocatable :: s_01l(:,:)
  complex(8), allocatable :: h_10l(:,:,:)
  complex(8), allocatable :: s_10l(:,:)

  complex(8), allocatable :: h_00r(:,:,:)
  complex(8), allocatable :: s_00r(:,:)
  complex(8), allocatable :: h_01r(:,:,:)
  complex(8), allocatable :: s_01r(:,:)
  complex(8), allocatable :: h_10r(:,:,:)
  complex(8), allocatable :: s_10r(:,:)

  integer :: num_sum_mat,i_cou
  complex(8), allocatable :: temp_sen(:)
  complex(8), allocatable :: temp_rec(:)

  if( Param%Option%spin_orbit ) then
     return
  end if

  allocate( i_orb(0:Param%Data%natom) )

  i_orb(0)=0
  do a=1, Param%Data%natom
     elem => Param__Data__getElement( Param%Data%vatom(a)%name )
     i_c=0
     do n=1, elem%npao
        i_c = i_c + 2*(elem%vpao(n)%l) + 1
     end do
     i_orb(a)=i_orb(a-1)+i_c
  end do

  if( Param%Option%nspin < 4 ) then
     ispin=Param%Option%nspin-1
     mat_max_cc=Base%npao
     mat_max_ll=i_orb(Param%Data%natom_left)
     mat_max_rr=Base%npao-i_orb(Param%Data%natom-Param%Data%natom_right)
  else
     ispin=0
     mat_max_cc=Base%npao*2
     mat_max_ll=i_orb(Param%Data%natom_left)*2
     mat_max_rr=(Base%npao-i_orb(Param%Data%natom-Param%Data%natom_right))*2
  end if

  ele_num_ll=0
  do a=1, Param%Data%natom_left
     elem => Param__Data__getElement( Param%Data%vatom(a)%name )
     ele_num_ll=ele_num_ll+Param%Data%vatom(a)%Q
  end do
  ele_num_rr=0
  do a=Param%Data%natom-Param%Data%natom_right+1, Param%Data%natom-1+1
     elem => Param__Data__getElement( Param%Data%vatom(a)%name )
     ele_num_rr=ele_num_rr+Param%Data%vatom(a)%Q
  end do

  allocate( h_01l(ispin+1,mat_max_ll,mat_max_ll) )
  allocate( s_01l(mat_max_ll,mat_max_ll) )
  allocate( h_10l(ispin+1,mat_max_ll,mat_max_ll) )
  allocate( s_10l(mat_max_ll,mat_max_ll) )

  do i1_do=1,mat_max_ll
     do i2_do=1,mat_max_ll
        do i3_do=1,ispin+1
           h_01l(i3_do,i2_do,i1_do)=dcmplx(0.d0,0.d0)
           h_10l(i3_do,i2_do,i1_do)=dcmplx(0.d0,0.d0)
        end do
        s_01l(i2_do,i1_do)=dcmplx(0.d0,0.d0)
        s_10l(i2_do,i1_do)=dcmplx(0.d0,0.d0)
     end do
  end do

  i1_do=i_orb(Param%Data%natom-Param%Data%natom_left)
  do a=1, Param%Data%natom_left
     if( a>=MPI%isatom .and. a<=MPI%ieatom ) then
        do b=Param%Data%natom-Param%Data%natom_left+1, Param%Data%natom-1+1
           do l=0, Param%Cell%nL-1
              if( .not. associated(Hamiltonian%vAtomMatrix(b,a,l)%Ptr) ) then
                 cycle
              end if
              if( l == 0 ) then
                 const=dcmplx(.5d0,0.d0)
              else
                 const=dcmplx(1.d0,0.d0)
              end if
              do i1=1, Base%vnpao(a)
                 do j1=1, Base%vnpao(b)
                    if( .not. Param%Option%spin_orbit ) then
                       do i3_do=1, ispin+1
                          h_01l(i3_do,i_orb(b)+j1,i_orb(a)-i1_do+i1) &
                               =h_01l(i3_do,i_orb(b)+j1,i_orb(a)-i1_do+i1) &
                               +dcmplx(Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H(j1,i1,i3_do)*const,0.d0)
                       end do
                       s_01l(i_orb(b)+j1,i_orb(a)-i1_do+i1) &
                            =s_01l(i_orb(b)+j1,i_orb(a)-i1_do+i1) &
                            +dcmplx(Hamiltonian%vAtomMatrix(b,a,l)%Ptr%S(j1,i1)*const,0.d0)
                    else
                       h_01l(1,(i_orb(b)+j1)*2-1,(i_orb(a)-i1_do+i1)*2-1) &
                            =h_01l(1,(i_orb(b)+j1)*2-1,(i_orb(a)-i1_do+i1)*2-1) &
                            +Hamiltonian%vAtomMatrix(b,a,l)%Ptr%HLS(j1,i1,1)*const
                       h_01l(1,(i_orb(b)+j1)*2-1,(i_orb(a)-i1_do+i1)*2) &
                            =h_01l(1,(i_orb(b)+j1)*2-1,(i_orb(a)-i1_do+i1)*2) &
                            +Hamiltonian%vAtomMatrix(b,a,l)%Ptr%HLS(j1,i1,2)*const
                       h_01l(1,(i_orb(b)+j1)*2,(i_orb(a)-i1_do+i1)*2-1) &
                            =h_01l(1,(i_orb(b)+j1)*2,(i_orb(a)-i1_do+i1)*2-1) &
                            +Hamiltonian%vAtomMatrix(b,a,l)%Ptr%HLS(j1,i1,3)*const
                       h_01l(1,(i_orb(b)+j1)*2,(i_orb(a)-i1_do+i1)*2) &
                            =h_01l(1,(i_orb(b)+j1)*2,(i_orb(a)-i1_do+i1)*2) &
                            +Hamiltonian%vAtomMatrix(b,a,l)%Ptr%HLS(j1,i1,4)*const
                       s_01l((i_orb(b)+j1)*2-1,(i_orb(a)-i1_do+i1)*2-1) &
                            =s_01l((i_orb(b)+j1)*2-1,(i_orb(a)-i1_do+i1)*2-1) &
                            +dcmplx(Hamiltonian%vAtomMatrix(b,a,l)%Ptr%S(j1,i1)*const,0.d0)
                       s_01l((i_orb(b)+j1)*2,(i_orb(a)-i1_do+i1)*2) &
                            =s_01l((i_orb(b)+j1)*2,(i_orb(a)-i1_do+i1)*2) &
                            +dcmplx(Hamiltonian%vAtomMatrix(b,a,l)%Ptr%S(j1,i1)*const,0.d0)
                    end if
                 end do
              end do
           end do
        end do
     end if
  end do
  do i_do=1,mat_max_ll
     do j_do=1,mat_max_ll
        do i1=1,ispin+1
           h_01l(i1,i_do,j_do)=h_01l(i1,i_do,j_do)*ene_scale
        end do
     end do
  end do

  i1_do=i_orb(Param%Data%natom-Param%Data%natom_left)
  do a=Param%Data%natom-Param%Data%natom_left+1, Param%Data%natom-1+1
     if( a>=MPI%isatom .and. a<=MPI%ieatom ) then
        do b=1, Param%Data%natom_left
           do l=0, Param%Cell%nL-1
              if( .not. associated(Hamiltonian%vAtomMatrix(b,a,l)%Ptr) ) then
                 cycle
              end if
              if( l == 0 ) then
                 const=dcmplx(.5d0,0.d0)
              else
                 const=dcmplx(1.d0,0.d0)
              end if
              do i1=1, Base%vnpao(a)
                 do j1=1, Base%vnpao(b)
                    if( .not. Param%Option%spin_orbit ) then
                       do i3_do=1, ispin+1
                          h_10l(i3_do,i_orb(b)-i1_do+j1,i_orb(a)+i1) &
                               =h_10l(i3_do,i_orb(b)-i1_do+j1,i_orb(a)+i1) &
                               +dcmplx(Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H(j1,i1,i3_do)*const,0.d0)
                       end do
                       s_10l(i_orb(b)-i1_do+j1,i_orb(a)+i1) &
                            =s_10l(i_orb(b)-i1_do+j1,i_orb(a)+i1) &
                            +dcmplx(Hamiltonian%vAtomMatrix(b,a,l)%Ptr%S(j1,i1)*const,0.d0)
                    else
                       h_10l(1,(i_orb(b)-i1_do+j1)*2-1,(i_orb(a)+i1)*2-1) &
                            =h_10l(1,(i_orb(b)-i1_do+j1)*2-1,(i_orb(a)+i1)*2-1) &
                            +Hamiltonian%vAtomMatrix(b,a,l)%Ptr%HLS(j1,i1,1)*const
                       h_10l(1,(i_orb(b)-i1_do+j1)*2-1,(i_orb(a)+i1)*2) &
                            =h_10l(1,(i_orb(b)-i1_do+j1)*2-1,(i_orb(a)+i1)*2) &
                            +Hamiltonian%vAtomMatrix(b,a,l)%Ptr%HLS(j1,i1,2)*const
                       h_10l(1,(i_orb(b)-i1_do+j1)*2,(i_orb(a)+i1)*2-1) &
                            =h_10l(1,(i_orb(b)-i1_do+j1)*2,(i_orb(a)+i1+1)*2-1) &
                            +Hamiltonian%vAtomMatrix(b,a,l)%Ptr%HLS(j1,i1,3)*const
                       h_10l(1,(i_orb(b)-i1_do+j1)*2,(i_orb(a)+i1)*2) &
                            =h_10l(1,(i_orb(b)-i1_do+j1)*2,(i_orb(a)+i1)*2) &
                            +Hamiltonian%vAtomMatrix(b,a,l)%Ptr%HLS(j1,i1,4)*const
                       s_10l((i_orb(b)-i1_do+j1)*2-1,(i_orb(a)+i1)*2-1) &
                            =s_10l((i_orb(b)-i1_do+j1)*2-1,(i_orb(a)+i1)*2-1) &
                            +dcmplx(Hamiltonian%vAtomMatrix(b,a,l)%Ptr%S(j1,i1)*const,0.d0)
                       s_10l((i_orb(b)-i1_do+j1)*2,(i_orb(a)+i1)*2) &
                            =s_10l((i_orb(b)-i1_do+j1)*2,(i_orb(a)+i1)*2) &
                            +dcmplx(Hamiltonian%vAtomMatrix(b,a,l)%Ptr%S(j1,i1)*const,0.d0)
                    end if
                 end do
              end do
           end do
        end do
     end if
  end do
  do i_do=1,mat_max_ll
     do j_do=1,mat_max_ll
        do i1=1,ispin+1
           h_10l(i1,i_do,j_do)=h_10l(i1,i_do,j_do)*ene_scale
        end do
     end do
  end do


  allocate( h_01r(ispin+1,mat_max_rr,mat_max_rr) )
  allocate( s_01r(mat_max_rr,mat_max_rr) )
  allocate( h_10r(ispin+1,mat_max_rr,mat_max_rr) )
  allocate( s_10r(mat_max_rr,mat_max_rr) )

  do i1_do=1,mat_max_rr
     do i2_do=1,mat_max_rr
        do i3_do=1,ispin+1
           h_01r(i3_do,i2_do,i1_do)=dcmplx(0.d0,0.d0)
           h_10r(i3_do,i2_do,i1_do)=dcmplx(0.d0,0.d0)
        end do
        s_01r(i2_do,i1_do)=dcmplx(0.d0,0.d0)
        s_10r(i2_do,i1_do)=dcmplx(0.d0,0.d0)
     end do
  end do

  i1_do=i_orb(Param%Data%natom-Param%Data%natom_right)
  do a=Param%Data%natom-Param%Data%natom_right+1, Param%Data%natom-1+1
     if( a>=MPI%isatom .and. a<=MPI%ieatom ) then
        do b=1, Param%Data%natom_right
           do l=0, Param%Cell%nL-1
              if( .not. associated(Hamiltonian%vAtomMatrix(b,a,l)%Ptr) ) then
                 cycle
              end if
              if( l == 0 ) then
                 const=dcmplx(.5d0,0.d0)
              else
                 const=dcmplx(1.d0,0.d0)
              end if
              do i1=1, Base%vnpao(a)
                 do j1=1, Base%vnpao(b)
                    if( .not. Param%Option%spin_orbit ) then
                       do i3_do=1, ispin+1
                          h_01r(i3_do,i_orb(b)-i1_do+j1,i_orb(a)+i1) &
                               =h_01r(i3_do,i_orb(b)-i1_do+j1,i_orb(a)+i1) &
                               +dcmplx(Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H(j1,i1,i3_do)*const,0.d0)
                       end do
                       s_01r(i_orb(b)-i1_do+j1,i_orb(a)+i1) &
                            =s_01r(i_orb(b)-i1_do+j1,i_orb(a)+i1) &
                            +dcmplx(Hamiltonian%vAtomMatrix(b,a,l)%Ptr%S(j1,i1)*const,0.d0)
                    else
                       h_01r(1,(i_orb(b)-i1_do+j1)*2-1,(i_orb(a)+i1)*2-1) &
                            =h_01r(1,(i_orb(b)-i1_do+j1)*2-1,(i_orb(a)+i1)*2-1) &
                            +Hamiltonian%vAtomMatrix(b,a,l)%Ptr%HLS(j1,i1,1)*const
                       h_01r(1,(i_orb(b)-i1_do+j1)*2-1,(i_orb(a)+i1)*2) &
                            =h_01r(1,(i_orb(b)-i1_do+j1)*2-1,(i_orb(a)+i1)*2) &
                            +Hamiltonian%vAtomMatrix(b,a,l)%Ptr%HLS(j1,i1,2)*const
                       h_01r(1,(i_orb(b)-i1_do+j1)*2,(i_orb(a)+i1)*2-1) &
                            =h_01r(1,(i_orb(b)-i1_do+j1+1)*2,(i_orb(a)+i1+1)*2-1) &
                            +Hamiltonian%vAtomMatrix(b,a,l)%Ptr%HLS(j1,i1,3)*const
                       h_01r(1,(i_orb(b)-i1_do+j1)*2,(i_orb(a)+i1)*2) &
                            =h_01r(1,(i_orb(b)-i1_do+j1)*2,(i_orb(a)+i1)*2) &
                            +Hamiltonian%vAtomMatrix(b,a,l)%Ptr%HLS(j1,i1,4)*const
                       s_01r((i_orb(b)-i1_do+j1)*2-1,(i_orb(a)+i1)*2-1) &
                            =s_01r((i_orb(b)-i1_do+j1)*2-1,(i_orb(a)+i1)*2-1) &
                            +dcmplx(Hamiltonian%vAtomMatrix(b,a,l)%Ptr%S(j1,i1)*const,0.d0)
                       s_01r((i_orb(b)-i1_do+j1)*2,(i_orb(a)+i1)*2) &
                            =s_01r((i_orb(b)-i1_do+j1)*2,(i_orb(a)+i1)*2) &
                            +dcmplx(Hamiltonian%vAtomMatrix(b,a,l)%Ptr%S(j1,i1)*const,0.d0)
                    end if
                 end do
              end do
           end do
        end do
     end if
  end do
  do i_do=1,mat_max_rr
     do j_do=1,mat_max_rr
        do i1=1,ispin+1
           h_01r(i1,i_do,j_do)=h_01r(i1,i_do,j_do)*ene_scale
        end do
     end do
  end do

  i1_do=i_orb(Param%Data%natom-Param%Data%natom_right)
  do a=1, Param%Data%natom_right
     if( a>=MPI%isatom .and. a<=MPI%ieatom ) then
        do b=Param%Data%natom-Param%Data%natom_right+1, Param%Data%natom-1+1
           do l=0, Param%Cell%nL-1
              if( .not. associated(Hamiltonian%vAtomMatrix(b,a,l)%Ptr) ) then
                 cycle
              end if
              if( l == 0 ) then
                 const=dcmplx(.5d0,0.d0)
              else
                 const=dcmplx(1.d0,0.d0)
              end if
              do i1=1, Base%vnpao(a)
                 do j1=1, Base%vnpao(b)
                    if( .not. Param%Option%spin_orbit ) then
                       do i3_do=1, ispin+1
                          h_10r(i3_do,i_orb(b)+j1,i_orb(a)-i1_do+i1) &
                               =h_10r(i3_do,i_orb(b)+j1,i_orb(a)-i1_do+i1) &
                               +dcmplx(Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H(j1,i1,i3_do)*const,0.d0)
                       end do
                       s_10r(i_orb(b)+j1,i_orb(a)-i1_do+i1) &
                            =s_10r(i_orb(b)+j1,i_orb(a)-i1_do+i1) &
                            +dcmplx(Hamiltonian%vAtomMatrix(b,a,l)%Ptr%S(j1,i1)*const,0.d0)
                    else
                       h_10r(1,(i_orb(b)+j1)*2-1,(i_orb(a)-i1_do+i1)*2-1) &
                            =h_10r(1,(i_orb(b)+j1)*2-1,(i_orb(a)-i1_do+i1)*2-1) &
                            +Hamiltonian%vAtomMatrix(b,a,l)%Ptr%HLS(j1,i1,1)*const
                       h_10r(1,(i_orb(b)+j1)*2-1,(i_orb(a)-i1_do+i1)*2) &
                            =h_10r(1,(i_orb(b)+j1)*2-1,(i_orb(a)-i1_do+i1)*2) &
                            +Hamiltonian%vAtomMatrix(b,a,l)%Ptr%HLS(j1,i1,2)*const
                       h_10r(1,(i_orb(b)+j1)*2,(i_orb(a)-i1_do+i1)*2-1) &
                            =h_10r(1,(i_orb(b)+j1)*2,(i_orb(a)-i1_do+i1)*2-1) &
                            +Hamiltonian%vAtomMatrix(b,a,l)%Ptr%HLS(j1,i1,3)*const
                       h_10r(1,(i_orb(b)+j1)*2,(i_orb(a)-i1_do+i1)*2) &
                            =h_10r(1,(i_orb(b)+j1)*2,(i_orb(a)-i1_do+i1)*2) &
                            +Hamiltonian%vAtomMatrix(b,a,l)%Ptr%HLS(j1,i1,4)*const
                       s_10r((i_orb(b)+j1)*2-1,(i_orb(a)-i1_do+i1)*2-1) &
                            =s_10r((i_orb(b)+j1)*2-1,(i_orb(a)-i1_do+i1)*2-1) &
                            +dcmplx(Hamiltonian%vAtomMatrix(b,a,l)%Ptr%S(j1,i1)*const,0.d0)
                       s_10r((i_orb(b)+j1)*2,(i_orb(a)-i1_do+i1)*2) &
                            =s_10r((i_orb(b)+j1)*2,(i_orb(a)-i1_do+i1)*2) &
                            +dcmplx(Hamiltonian%vAtomMatrix(b,a,l)%Ptr%S(j1,i1)*const,0.d0)
                    end if
                 end do
              end do
           end do
        end do
     end if
  end do
  do i_do=1,mat_max_rr
     do j_do=1,mat_max_rr
        do i1=1,ispin+1
           h_10r(i1,i_do,j_do)=h_10r(i1,i_do,j_do)*ene_scale
        end do
     end do
  end do

  allocate( h_cc(ispin+1,mat_max_cc,mat_max_cc) )
  allocate( s_cc(mat_max_cc,mat_max_cc) )
  allocate( h_cl(ispin+1,mat_max_ll,mat_max_ll) )
  allocate( s_cl(mat_max_ll,mat_max_ll) )
  allocate( h_cr(ispin+1,mat_max_rr,mat_max_rr) )
  allocate( s_cr(mat_max_rr,mat_max_rr) )

  do i_do=1,mat_max_cc
     do j_do=1,mat_max_cc
        do i1=1,ispin+1
           h_cc(i1,i_do,j_do)=dcmplx(0.d0,0.d0)
        end do
        s_cc(i_do,j_do)=dcmplx(0.d0,0.d0)
     end do
  end do

  do a=1, Param%Data%natom
     if( a>=MPI%isatom .and. a<=MPI%ieatom ) then
        do b=1, Param%Data%natom
           if( a <= Param%Data%natom_left &
                .and. b > Param%Data%natom-Param%Data%natom_right ) then
              cycle
           end if
           if( b <= Param%Data%natom_left &
                .and. a > Param%Data%natom-Param%Data%natom_right ) then
              cycle
           end if
           do l=0, Param%Cell%nL-1
              if( .not. associated(Hamiltonian%vAtomMatrix(b,a,l)%Ptr) ) then
                 cycle
              end if
              if( l == 0 ) then
                 const=dcmplx(.5d0,0.d0)
              else
                 const=dcmplx(1.d0,0.d0)
              end if
              do i1=1, Base%vnpao(a)
                 do j1=1, Base%vnpao(b)
                    if( .not. Param%Option%spin_orbit ) then
                       do i3_do=1, ispin+1
                          h_cc(i3_do,i_orb(b)+j1,i_orb(a)+i1) &
                               =h_cc(i3_do,i_orb(b)+j1,i_orb(a)+i1) &
                               +dcmplx(Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H(j1,i1,i3_do)*const,0.d0)
                       end do
                       s_cc(i_orb(b)+j1,i_orb(a)+i1) &
                            =s_cc(i_orb(b)+j1,i_orb(a)+i1) &
                            +dcmplx(Hamiltonian%vAtomMatrix(b,a,l)%Ptr%S(j1,i1)*const,0.d0)
                    else
                       h_cc(1,(i_orb(b)+j1)*2-1,(i_orb(a)+i1)*2-1) &
                            =h_cc(1,(i_orb(b)+j1)*2-1,(i_orb(a)+i1)*2-1) &
                            +Hamiltonian%vAtomMatrix(b,a,l)%Ptr%HLS(j1,i1,1)*const
                       h_cc(1,(i_orb(b)+j1)*2-1,(i_orb(a)+i1)*2) &
                            =h_cc(1,(i_orb(b)+j1)*2-1,(i_orb(a)+i1)*2) &
                            +Hamiltonian%vAtomMatrix(b,a,l)%Ptr%HLS(j1,i1,2)*const
                       h_cc(1,(i_orb(b)+j1)*2,(i_orb(a)+i1)*2-1) &
                            =h_cc(1,(i_orb(b)+j1)*2,(i_orb(a)+i1)*2-1) &
                            +Hamiltonian%vAtomMatrix(b,a,l)%Ptr%HLS(j1,i1,3)*const
                       h_cc(1,(i_orb(b)+j1)*2,(i_orb(a)+i1)*2) &
                            =h_cc(1,(i_orb(b)+j1)*2,(i_orb(a)+i1)*2) &
                            +Hamiltonian%vAtomMatrix(b,a,l)%Ptr%HLS(j1,i1,4)*const
                       s_cc((i_orb(b)+j1)*2-1,(i_orb(a)+i1)*2-1) &
                            =s_cc((i_orb(b)+j1)*2-1,(i_orb(a)+i1)*2-1) &
                            +dcmplx(Hamiltonian%vAtomMatrix(b,a,l)%Ptr%S(j1,i1)*const,0.d0)
                       s_cc((i_orb(b)+j1)*2,(i_orb(a)+i1)*2) &
                            =s_cc((i_orb(b)+j1)*2,(i_orb(a)+i1)*2) &
                            +dcmplx(Hamiltonian%vAtomMatrix(b,a,l)%Ptr%S(j1,i1)*const,0.d0)
                    end if
                 end do
              end do
           end do
        end do
     end if
  end do
  do i_do=1,mat_max_cc
     do j_do=1,mat_max_cc
        do i1=1,ispin+1
           h_cc(i1,i_do,j_do)=h_cc(i1,i_do,j_do)*ene_scale
        end do
     end do
  end do

  num_sum_mat=1*(ispin+2)*mat_max_cc*mat_max_cc &
       +2*(ispin+2)*mat_max_ll*mat_max_ll &
       +2*(ispin+2)*mat_max_rr*mat_max_rr
  allocate( temp_sen(num_sum_mat) )
  allocate( temp_rec(num_sum_mat) )
  do i_do=1,num_sum_mat
     temp_sen(i_do)=dcmplx(0.d0,0.d0)
     temp_rec(i_do)=dcmplx(0.d0,0.d0)
  end do
  i_cou=0
  do i1_do=1,mat_max_cc
     do i2_do=1,mat_max_cc
        do i3_do=1,ispin+1
           i_cou=i_cou+1
           temp_sen(i_cou)=h_cc(i3_do,i2_do,i1_do)
        end do
     end do
  end do
  do i1_do=1,mat_max_cc
     do i2_do=1,mat_max_cc
        i_cou=i_cou+1
        temp_sen(i_cou)=s_cc(i2_do,i1_do)
     end do
  end do

  do i1_do=1,mat_max_ll
     do i2_do=1,mat_max_ll
        do i3_do=1,ispin+1
           i_cou=i_cou+1
           temp_sen(i_cou)=h_01l(i3_do,i2_do,i1_do)
        end do
     end do
  end do
  do i1_do=1,mat_max_ll
     do i2_do=1,mat_max_ll
        i_cou=i_cou+1
        temp_sen(i_cou)=s_01l(i2_do,i1_do)
     end do
  end do
  do i1_do=1,mat_max_ll
     do i2_do=1,mat_max_ll
        do i3_do=1,ispin+1
           i_cou=i_cou+1
           temp_sen(i_cou)=h_10l(i3_do,i2_do,i1_do)
        end do
     end do
  end do
  do i1_do=1,mat_max_ll
     do i2_do=1,mat_max_ll
        i_cou=i_cou+1
        temp_sen(i_cou)=s_10l(i2_do,i1_do)
     end do
  end do

  do i1_do=1,mat_max_rr
     do i2_do=1,mat_max_rr
        do i3_do=1,ispin+1
           i_cou=i_cou+1
           temp_sen(i_cou)=h_01r(i3_do,i2_do,i1_do)
        end do
     end do
  end do
  do i1_do=1,mat_max_rr
     do i2_do=1,mat_max_rr
        i_cou=i_cou+1
        temp_sen(i_cou)=s_01r(i2_do,i1_do)
     end do
  end do
  do i1_do=1,mat_max_rr
     do i2_do=1,mat_max_rr
        do i3_do=1,ispin+1
           i_cou=i_cou+1
           temp_sen(i_cou)=h_10r(i3_do,i2_do,i1_do)
        end do
     end do
  end do
  do i1_do=1,mat_max_rr
     do i2_do=1,mat_max_rr
        i_cou=i_cou+1
        temp_sen(i_cou)=s_10r(i2_do,i1_do)
     end do
  end do

  call MPI_ALLREDUCE(temp_sen,temp_rec,num_sum_mat,MPI_DOUBLE_COMPLEX,MPI_SUM,MPI_COMM_WORLD,MPI%info)

  i_cou=0
  do i1_do=1,mat_max_cc
     do i2_do=1,mat_max_cc
        do i3_do=1,ispin+1
           i_cou=i_cou+1
           h_cc(i3_do,i2_do,i1_do)=temp_rec(i_cou)
        end do
     end do
  end do
  do i1_do=1,mat_max_cc
     do i2_do=1,mat_max_cc
        i_cou=i_cou+1
        s_cc(i2_do,i1_do)=temp_rec(i_cou)
     end do
  end do
  do i3_do=1,mat_max_cc
     do i2_do=i3_do,mat_max_cc
        do i1_do=1,ispin+1
           h_cc(i1_do,i2_do,i3_do)=h_cc(i1_do,i2_do,i3_do)                          &
                +dconjg(h_cc(i1_do,i3_do,i2_do))
           h_cc(i1_do,i3_do,i2_do)=dconjg(h_cc(i1_do,i2_do,i3_do))
        end do
        s_cc(i2_do,i3_do)=s_cc(i2_do,i3_do)+dconjg(s_cc(i3_do,i2_do))
        s_cc(i3_do,i2_do)=dconjg(s_cc(i2_do,i3_do))
     end do
  end do

  do i1_do=1,mat_max_ll
     do i2_do=1,mat_max_ll
        do i3_do=1,ispin+1
           i_cou=i_cou+1
           h_01l(i3_do,i2_do,i1_do)=temp_rec(i_cou)
        end do
     end do
  end do
  do i1_do=1,mat_max_ll
     do i2_do=1,mat_max_ll
        i_cou=i_cou+1
        s_01l(i2_do,i1_do)=temp_rec(i_cou)
     end do
  end do

  do i1_do=1,mat_max_ll
     do i2_do=1,mat_max_ll
        do i3_do=1,ispin+1
           i_cou=i_cou+1
           h_10l(i3_do,i2_do,i1_do)=temp_rec(i_cou)
        end do
     end do
  end do
  do i1_do=1,mat_max_ll
     do i2_do=1,mat_max_ll
        i_cou=i_cou+1
        s_10l(i2_do,i1_do)=temp_rec(i_cou)
     end do
  end do
  do i3_do=1,mat_max_ll
     do i2_do=1,mat_max_ll
        do i1_do=1,ispin+1
           h_10l(i1_do,i2_do,i3_do)=h_10l(i1_do,i2_do,i3_do)                          &
                +dconjg(h_01l(i1_do,i3_do,i2_do))
           h_01l(i1_do,i3_do,i2_do)=dconjg(h_10l(i1_do,i2_do,i3_do))
        end do
        s_10l(i2_do,i3_do)=s_10l(i2_do,i3_do)+dconjg(s_01l(i3_do,i2_do))
        s_01l(i3_do,i2_do)=dconjg(s_10l(i2_do,i3_do))
     end do
  end do

  do i1_do=1,mat_max_rr
     do i2_do=1,mat_max_rr
        do i3_do=1,ispin+1
           i_cou=i_cou+1
           h_01r(i3_do,i2_do,i1_do)=temp_rec(i_cou)
        end do
     end do
  end do
  do i1_do=1,mat_max_rr
     do i2_do=1,mat_max_rr
        i_cou=i_cou+1
        s_01r(i2_do,i1_do)=temp_rec(i_cou)
     end do
  end do

  do i1_do=1,mat_max_rr
     do i2_do=1,mat_max_rr
        do i3_do=1,ispin+1
           i_cou=i_cou+1
           h_10r(i3_do,i2_do,i1_do)=temp_rec(i_cou)
        end do
     end do
  end do
  do i1_do=1,mat_max_rr
     do i2_do=1,mat_max_rr
        i_cou=i_cou+1
        s_10r(i2_do,i1_do)=temp_rec(i_cou)
     end do
  end do
  do i3_do=1,mat_max_rr
     do i2_do=1,mat_max_rr
        do i1_do=1,ispin+1
           h_10r(i1_do,i2_do,i3_do)=h_10r(i1_do,i2_do,i3_do)                          &
                +dconjg(h_01r(i1_do,i3_do,i2_do))
           h_01r(i1_do,i3_do,i2_do)=dconjg(h_10r(i1_do,i2_do,i3_do))
        end do
        s_10r(i2_do,i3_do)=s_10r(i2_do,i3_do)+dconjg(s_01r(i3_do,i2_do))
        s_01r(i3_do,i2_do)=dconjg(s_10r(i2_do,i3_do))
     end do
  end do

  do i1_do=1,mat_max_ll
     do i2_do=1,mat_max_ll
        do i3_do=1,ispin+1
           h_cl(i3_do,i2_do,i1_do)=h_01l(i3_do,i2_do,i1_do)
        end do
        s_cl(i2_do,i1_do)=s_01l(i2_do,i1_do)
     end do
  end do

  do i1_do=1,mat_max_rr
     do i2_do=1,mat_max_rr
        do i3_do=1,ispin+1
           h_cr(i3_do,i2_do,i1_do)=h_01r(i3_do,i2_do,i1_do)
        end do
        s_cr(i2_do,i1_do)=s_01r(i2_do,i1_do)
     end do
  end do

  deallocate( temp_sen )
  deallocate( temp_rec )

  if(MPI%root) then

     num_hcc1=0
     num_hcc2=0
     do i1_do=1,mat_max_cc
        do i2_do=1,mat_max_cc
           if( cdabs(h_cc(1,i1_do,i2_do)) > eps ) then
              num_hcc1=num_hcc1+1
           end if
           if( ispin == 1 ) then
              if( cdabs(h_cc(2,i1_do,i2_do)) > eps ) then
                 num_hcc2=num_hcc2+1
              end if
           end if
        end do
     end do
     num_scc=0
     do i1_do=1,mat_max_cc
        do i2_do=1,mat_max_cc
           if( cdabs(s_cc(i1_do,i2_do)) > eps ) then
              num_scc=num_scc+1
           end if
        end do
     end do

     num_hcl1=0
     num_hcl2=0
     do i1_do=1,mat_max_ll
        do i2_do=1,mat_max_ll
           if( cdabs(h_cl(1,i1_do,i2_do)) > eps ) then
              num_hcl1=num_hcl1+1
           end if
           if( ispin == 1 ) then
              if( cdabs(h_cl(2,i1_do,i2_do)) > eps ) then
                 num_hcl2=num_hcl2+1
              end if
           end if
        end do
     end do
     num_scl=0
     do i1_do=1,mat_max_ll
        do i2_do=1,mat_max_ll
           if( cdabs(s_cl(i1_do,i2_do)) > eps ) then
              num_scl=num_scl+1
           end if
        end do
     end do

     num_hcr1=0
     num_hcr2=0
     do i1_do=1,mat_max_rr
        do i2_do=1,mat_max_rr
           if( cdabs(h_cr(1,i1_do,i2_do)) > eps ) then
              num_hcr1=num_hcr1+1
           end if
           if( ispin == 1 ) then
              if( cdabs(h_cr(2,i1_do,i2_do)) > eps ) then
                 num_hcr2=num_hcr2+1
              end if
           end if
        end do
     end do
     num_scr=0
     do i1_do=1,mat_max_rr
        do i2_do=1,mat_max_rr
           if( cdabs(s_cr(i1_do,i2_do)) > eps ) then
              num_scr=num_scr+1
           end if
        end do
     end do

     open(unit=16,file=Param%Option%fname_accel_c)

     write(16,*) mat_max_ll,mat_max_cc,mat_max_rr
     write(16,*) ispin
     write(16,*) num_hcc1,num_hcc2,num_scc
     write(16,*) num_hcl1,num_hcl2,num_scl
     write(16,*) num_hcr1,num_hcr2,num_scr

     do i7_do=1,ispin+1
        write(16,*) '                      Hamiltonian',i7_do
        itemp1=0
        do i1_do=1,mat_max_cc
           do i2_do=1,mat_max_cc
              if( cdabs(h_cc(i7_do,i1_do,i2_do)) > eps ) then
                 itemp1=itemp1+1
                 write(16,999) itemp1,i1_do,i2_do,h_cc(i7_do,i1_do,i2_do)
              end if
           end do
        end do
     end do
     write(16,*) '                      Overlap'
     itemp1=0
     do i1_do=1,mat_max_cc
        do i2_do=1,mat_max_cc
           if( cdabs(s_cc(i1_do,i2_do)) > eps ) then
              itemp1=itemp1+1
              write(16,999) itemp1,i1_do,i2_do,s_cc(i1_do,i2_do)
           end if
        end do
     end do

     do i7_do=1,ispin+1
        write(16,*) '                      Hamiltonian',i7_do
        itemp1=0
        do i1_do=1,mat_max_ll
           do i2_do=1,mat_max_ll
              if( cdabs(h_cl(i7_do,i1_do,i2_do)) > eps ) then
                 itemp1=itemp1+1
                 write(16,999) itemp1,i1_do,i2_do,h_cl(i7_do,i1_do,i2_do)
              end if
           end do
        end do
     end do
     write(16,*) '                      Overlap'
     itemp1=0
     do i1_do=1,mat_max_ll
        do i2_do=1,mat_max_ll
           if( cdabs(s_cl(i1_do,i2_do)) > eps ) then
              itemp1=itemp1+1
              write(16,999) itemp1,i1_do,i2_do,s_cl(i1_do,i2_do)
           end if
        end do
     end do

     do i7_do=1,ispin+1
        write(16,*) '                      Hamiltonian',i7_do
        itemp1=0
        do i1_do=1,mat_max_rr
           do i2_do=1,mat_max_rr
              if( cdabs(h_cr(i7_do,i1_do,i2_do)) > eps ) then
                 itemp1=itemp1+1
                 write(16,999) itemp1,mat_max_cc-mat_max_rr+i1_do,i2_do &
                      ,h_cr(i7_do,i1_do,i2_do)
              end if
           end do
        end do
     end do
     write(16,*) '                      Overlap'
     itemp1=0
     do i1_do=1,mat_max_rr
        do i2_do=1,mat_max_rr
           if( cdabs(s_cr(i1_do,i2_do)) > eps ) then
              itemp1=itemp1+1
              write(16,999) itemp1,mat_max_cc-mat_max_rr+i1_do,i2_do &
                   ,s_cr(i1_do,i2_do)
           end if
        end do
     end do

     close(16)

  end if

  deallocate( h_cc )
  deallocate( s_cc )
  deallocate( h_cl )
  deallocate( s_cl )
  deallocate( h_cr )
  deallocate( s_cr )

  deallocate( h_01r )
  deallocate( s_01r )
  deallocate( h_10r )
  deallocate( s_10r )

  deallocate( h_01l )
  deallocate( s_01l )
  deallocate( h_10l )
  deallocate( s_10l )

  deallocate( i_orb )

999 format(i10,i10,i10,d28.19,d28.19)

  return
end subroutine Hamiltonian__outdata3

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

module condition_ini

  implicit none
  character(50) :: file_parameter
  character(50) :: file_parameter_co
  character(50) :: file_parameter_tb_par
  character(50) :: file_parameter1
  character(50) :: file_parameter2
  character(50) :: file_parameter3
  character(50) :: file_selfenergy
  character(50) :: file_selfe_outsw

  integer :: num_atom_kind_ini
  integer :: iteration_max_ini
  real(8) :: eps_ini
  character(50) :: sgf_method_ini
  character(50) :: ham_model_ini
  integer, pointer :: atom_orbital_ini(:)
  integer, pointer :: atom_num_ini(:)
  integer, pointer :: atom_electron_ini(:)
  real(8), pointer :: atom_mass_ini(:)
  character(4), pointer :: atom_sign_ini(:)

  integer :: method_sum_om
  integer :: om_block_num
  integer :: num_gra
  integer, pointer :: num_om_par(:)
  complex(8), pointer :: omega_if(:,:)
  character(50), pointer :: om_con_method(:)

  integer :: num_iv_mesh
  real(8) :: om_sum
  character(50) :: calc_type
  character(50) :: dos_on_off_ini_l,dos_on_off_ini_r
  character(50) :: eigen_s_as_ini
  character(50) :: switch_l_eigen
  character(50) :: switch_r_eigen
  character(50) :: switch_out_gf,switch_out_tr,switch_out_ham

  integer :: num_atom_l
  integer :: neighbor_x_max_l
  integer :: neighbor_y_max_l
  integer :: neighbor_z_max_l
  integer :: kx_max_l
  integer :: ky_max_l
  integer :: kz_max_l
  integer :: num_unit_l(3)
  real(8) :: v_l
  real(8) :: unit_block_l(3,3)
  character(50) :: p_or_f_l
  integer, pointer :: atom_kindn_l(:)
  integer, pointer :: pair_num_l(:,:)
  real(8), pointer :: ra_l(:,:)
  character(4), pointer :: atom_kind_l(:)

  integer :: num_atom_r
  integer :: neighbor_x_max_r
  integer :: neighbor_y_max_r
  integer :: neighbor_z_max_r
  integer :: kx_max_r
  integer :: ky_max_r
  integer :: kz_max_r
  integer :: num_unit_r(3)
  real(8) :: v_r
  real(8) :: unit_block_r(3,3)
  character(50) :: p_or_f_r
  integer, pointer :: atom_kindn_r(:)
  integer, pointer :: pair_num_r(:,:)
  real(8), pointer :: ra_r(:,:)
  character(4), pointer :: atom_kind_r(:)

  integer :: num_atom_c
  integer :: m_num_block_l
  integer :: m_num_block_m
  integer :: m_num_block_r
  real(8) :: r_dis_l
  real(8) :: r_dis_r
  real(8) :: unit_block_c(3,3)
  real(8) :: v_c
  integer, pointer :: atom_kindn_c(:)
  integer, pointer :: pair_num_cl(:,:)
  integer, pointer :: pair_num_cc(:,:)
  integer, pointer :: pair_num_cr(:,:)
  real(8), pointer :: ra_c(:,:)
  character(4), pointer :: atom_kind_c(:)

  real(8) :: cur_ene
  real(8) :: cur_om
  real(8) :: cur_l
  real(8) :: cur_r
  character(10) :: cur_lr

  character(50) :: filename_kpoint
  integer :: ka_tr,kb_tr

contains
  subroutine alo_input_condition_1

    implicit none
    integer :: ier

    allocate(atom_sign_ini(num_atom_kind_ini),atom_num_ini(num_atom_kind_ini)    &
         ,atom_mass_ini(num_atom_kind_ini)                                    &
         ,atom_electron_ini(num_atom_kind_ini)                                &
         ,atom_orbital_ini(num_atom_kind_ini),stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_input_condition_1'
       stop
    end if

    return
  end subroutine alo_input_condition_1

  subroutine alo_input_condition_2

    implicit none
    integer :: ier

    allocate(num_om_par(om_block_num),om_con_method(om_block_num)                &
         ,omega_if(om_block_num,2),stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_input_condition_2'
       stop
    end if

    return
  end subroutine alo_input_condition_2

  subroutine alo_input_condition_3

    implicit none
    integer :: ier

    allocate(ra_l(num_atom_l,3),atom_kind_l(num_atom_l)                          &
         ,atom_kindn_l(num_atom_l),stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_input_condition_3'
       stop
    end if

    return
  end subroutine alo_input_condition_3

  subroutine alo_input_condition_4

    implicit none
    integer :: ier

    allocate(ra_r(num_atom_r,3),atom_kind_r(num_atom_r)                          &
         ,atom_kindn_r(num_atom_r),stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_input_condition_4'
       stop
    end if

    return
  end subroutine alo_input_condition_4

  subroutine alo_input_condition_5

    implicit none
    integer :: ier

    allocate(ra_c(num_atom_c,3),atom_kind_c(num_atom_c)                          &
         ,atom_kindn_c(num_atom_c),stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_input_condition_5'
       stop
    end if

    return
  end subroutine alo_input_condition_5

  subroutine alo_pair_ini                                            ! for GSP model

    implicit none
    integer :: ier

    allocate(pair_num_l(num_atom_l,num_atom_l),pair_num_r(num_atom_r,num_atom_r) &
         ,pair_num_cl(num_atom_c,num_atom_l),pair_num_cc(num_atom_c,num_atom_c) &
         ,pair_num_cr(num_atom_c,num_atom_r),stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_pair_ini'
       stop
    end if

    return
  end subroutine alo_pair_ini

  subroutine unset_condition_ini

    implicit none
    integer :: ier

    deallocate(atom_sign_ini,atom_num_ini,atom_mass_ini,atom_electron_ini        &
         ,atom_orbital_ini                                                   &
         ,ra_l,atom_kind_l,atom_kindn_l,ra_r,atom_kind_r,atom_kindn_r        &
         ,ra_c,atom_kind_c,atom_kindn_c,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error deallocate: unset_condition_ini'
       stop
    end if

    return
  end subroutine unset_condition_ini

  subroutine unset_condition_ini_1

    implicit none
    integer :: ier

    deallocate(num_om_par,om_con_method,omega_if,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error deallocate: unset_condition_ini'
       stop
    end if

    return
  end subroutine unset_condition_ini_1

  subroutine unset_pair_ini                                          ! for GSP model

    implicit none
    integer :: ier

    deallocate(pair_num_l,pair_num_r,pair_num_cl,pair_num_cc,pair_num_cr         &
         ,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error deallocate: unset_pair_ini'
       stop
    end if

    return
  end subroutine unset_pair_ini

end module condition_ini

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine cal_gf_se_c

  use condition_ini
  use hamiltonian_sgf
  use hamiltonian_c
  use hamiltonian_temp
  use gf_se_c
  use constant
  use mod_mpi
  use scf_negf

  implicit none
  include 'mpif.h'
  integer :: ic_spin
  integer :: iw_max_mpi
  integer :: iw_do,i1_do,i2_do,i3_do,icou_l,icou_r
  integer :: px,py,qx,qy,ispin
  complex(8) :: w

  real(8) :: st1,st2,stdel,t_tot

  complex(8), allocatable :: tr_temp11(:,:,:,:),tr_temp12(:,:,:,:)
  integer :: i_temp,ier

  integer :: kt
  real(8) :: qx_tr,qy_tr

  if( file_selfe_outsw == 'on' ) then
     call alo_mod_sftr(kt_tr,file_selfenergy)
  end if
  call alo_ham_temp_ham(m_mat_max_c,mat_max_ll,mat_max_rr)

  open(unit=16,file=file_tempout,position='append')
  write(16,*)
  write(16,*) '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'
  write(16,*) '++++++++++++ start calculation:'
  write(16,*) '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'
  write(16,*)
  close(16)

  call show_ksampling

  if( spin_switch_cc /= 2) then
     ic_spin=1
  else
     ic_spin=2
  end if

  !                                +++++++++++++++++++++++++++++++++++++++++++++++++++

  do kt=1,ka_tr*kb_tr
     if( ham_model_ini /= 'rtb_h' .and. ham_model_ini /= 'gsp' ) then
        qx_tr=po_kt_tr(2,kt)
        qy_tr=po_kt_tr(3,kt)
     else
        qx_tr=0.d0
        qy_tr=0.d0
     end if

     open(unit=16,file=file_tempout,position='append')
     write(16,*) '--------------------------------------------------------------'
     write(16,800) kt,qx_tr,qy_tr
800  format(' ------------  ',i5,2f13.8)
     write(16,*) '--------------------------------------------------------------'
     close(16)

     if( file_selfe_outsw == 'on' ) then
        open(unit=60,file=file_sf_tr(kt,myrank+1))
        write(60,995) m_mat_max_c,iw_max_gs
        write(60,996) omega_gs(1)
        write(60,996) omega_gs(iw_max_gs)
        close(60)
     end if

     call set_ham_temp_ham_l(qx_tr,qy_tr)
     call set_ham_temp_ham_r(qx_tr,qy_tr)
     if( ham_model_ini == 'input' ) then
        call set_ham_temp_ham_c(qx_tr,qy_tr)
        if( myrank == 0 ) then
           if( switch_out_ham /= 'off' ) then
              call outham(kt,ic_spin,m_mat_max_c,hcc_t,scc_t)
           end if
        end if
     end if
     if( ham_model_ini == 'scf_accel' ) then
        call set_ham_scf_ham_c(qx_tr,qy_tr)
        if( myrank == 0 ) then
           if( switch_out_ham /= 'off' ) then
              call outham(kt,ic_spin,m_mat_max_c,h_cc_scf,s_cc_scf)
           end if
        end if
     end if

     if( mod(iw_max_gs,nprocs) == 0 ) then
        iw_max_mpi=iw_max_gs
     else
        iw_max_mpi=iw_max_gs+nprocs-mod(iw_max_gs,nprocs)
     end if
     iw_max_mpi=(iw_max_mpi/nprocs)*nprocs
     do iw_do=1+myrank,iw_max_mpi,nprocs

        open(unit=16,file=file_tempout,position='append')
        write(16,*) '     ------- cal_gf_se_c:',iw_do
        close(16)

        !                       - - - - - - - - - - - - - - - - - -                       !

        do ispin=1,ic_spin

           if( iw_do > iw_max_gs ) then
              go to 100
           end if
           w=omega_gs(iw_do)

           t_tot=0.d0

           open(unit=16,file=file_tempout,position='append')
           call myclock(st1)
           do px=1,kx_max_ll                                       ! kx_max_ll = 1
              do py=1,ky_max_ll                                     ! ky_max_ll = 1
                 call selfenergy_l(w,iw_do,px,py,ispin,kt)

                 if( file_selfe_outsw == 'on' ) then
                    icou_l=0
                    do i2_do=1,m_mat_max_c
                       do i1_do=1,m_mat_max_c
                          if( se_l_mat_per(i1_do,i2_do,px,py) /= dcmplx(0.d0,0.d0) )then
                             icou_l=icou_l+1
                          end if
                       end do
                    end do
                 end if
              end do
           end do

           call myclock(st2)
           stdel=st2-st1
           t_tot=t_tot+stdel
           close(16)

           open(unit=16,file=file_tempout,position='append')
           call myclock(st1)

           do qx=1,kx_max_rr                                       ! kx_max_rr = 1
              do qy=1,ky_max_rr                                     ! ky_max_rr = 1
                 call selfenergy_r(w,iw_do,qx,qy,ispin,kt)

                 if( file_selfe_outsw == 'on' ) then
                    icou_r=0
                    do i2_do=1,m_mat_max_c
                       do i1_do=1,m_mat_max_c
                          if( se_r_mat_per(i1_do,i2_do,qx,qy) /= dcmplx(0.d0,0.d0) )then
                             icou_r=icou_r+1
                          end if
                       end do
                    end do
                 end if
              end do
           end do

           !                       - - - - - - - - - - - - - - - - - -                        !

100        continue

           if( file_selfe_outsw == 'on' ) then
              if( iw_do <= iw_max_gs ) then
                 do px=1,kx_max_ll
                    do py=1,ky_max_ll
                       open(unit=60,file=file_sf_tr(kt,myrank+1),position='append')
                       write(60,997) w,ispin
                       write(60,*) icou_l
                       do i2_do=1,m_mat_max_c
                          do i1_do=1,m_mat_max_c
                             if( se_l_mat_per(i1_do,i2_do,px,py)                        &
                                  /= dcmplx(0.d0,0.d0) ) then
                                write(60,999)i1_do,i2_do,se_l_mat_per(i1_do,i2_do,px,py)
                             end if
                          end do
                       end do
                       close(60)
                    end do
                 end do
                 do qx=1,kx_max_rr
                    do qy=1,ky_max_rr
                       open(unit=60,file=file_sf_tr(kt,myrank+1),position='append')
                       write(60,998) w,ispin
                       write(60,*) icou_r
                       do i2_do=1,m_mat_max_c
                          do i1_do=1,m_mat_max_c
                             if( se_r_mat_per(i1_do,i2_do,qx,qy)                        &
                                  /= dcmplx(0.d0,0.d0) ) then
                                write(60,999)i1_do,i2_do,se_r_mat_per(i1_do,i2_do,qx,qy)
                             end if
                          end do
                       end do
                       close(60)
                    end do
                 end do
              end if
           end if

           !                       - - - - - - - - - - - - - - - - - -                        !

           call myclock(st2)
           stdel=st2-st1
           t_tot=t_tot+stdel
           close(16)

           open(unit=16,file=file_tempout,position='append')
           call myclock(st1)

           do px=1,kx_max_ll                                       ! kx_max_ll = 1
              do py=1,ky_max_ll                                     ! ky_max_ll = 1
                 do qx=1,kx_max_rr                                   ! kx_max_rr = 1
                    do qy=1,ky_max_rr                                 ! ky_max_rr = 1
                       call trans(w,iw_do,px,py,qx,qy,ispin,kt)
                    end do
                 end do
              end do
           end do

           call myclock(st2)
           stdel=st2-st1
           t_tot=t_tot+stdel
           write(16,*) '           t(spin:',ispin,')=',t_tot
           close(16)

        end do

        !                       - - - - - - - - - - - - - - - - - -                       !

     end do

  end do

  if( file_selfe_outsw == 'on' ) then
     call dealo_mod_sftr
  end if
  call dealo_ham_temp_ham

  !                       - - - - - - - - - - - - - - - - - -                        !

  allocate(tr_temp11(4+num_block_gr,ic_spin,iw_max_gs,ka_tr*kb_tr)           &
       ,tr_temp12(4+num_block_gr,ic_spin,iw_max_gs,ka_tr*kb_tr)           &
       ,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: alo_density_temp'
     stop
  end if

  do kt=1,ka_tr*kb_tr
     do i1_do=1,iw_max_gs
        do i2_do=1,ic_spin
           tr_temp11(1,i2_do,i1_do,kt)=tr_gr_l(i2_do,i1_do,kt)
           tr_temp11(2,i2_do,i1_do,kt)=tr_gr_r(i2_do,i1_do,kt)
           tr_temp11(3,i2_do,i1_do,kt)=tr_gr_c(i2_do,i1_do,kt)
           tr_temp11(4,i2_do,i1_do,kt)=tr_tr(i2_do,i1_do,kt)
           do i3_do=1,num_block_gr
              tr_temp11(4+i3_do,i2_do,i1_do,kt)=tr_grc_block(i2_do,i3_do,i1_do,kt)
           end do
        end do
     end do
  end do

  i_temp=(4+num_block_gr)*ic_spin*iw_max_gs*ka_tr*kb_tr
  call MPI_REDUCE(tr_temp11,tr_temp12,i_temp,MPI_DOUBLE_COMPLEX,MPI_SUM,0    &
       ,mpi_comm_world,ierr)

  do kt=1,ka_tr*kb_tr
     do i1_do=1,iw_max_gs
        do i2_do=1,ic_spin
           tr_gr_l(i2_do,i1_do,kt)=tr_temp12(1,i2_do,i1_do,kt)
           tr_gr_r(i2_do,i1_do,kt)=tr_temp12(2,i2_do,i1_do,kt)
           tr_gr_c(i2_do,i1_do,kt)=tr_temp12(3,i2_do,i1_do,kt)
           tr_tr(i2_do,i1_do,kt)=tr_temp12(4,i2_do,i1_do,kt)
           do i3_do=1,num_block_gr
              tr_grc_block(i2_do,i3_do,i1_do,kt)=tr_temp12(4+i3_do,i2_do,i1_do,kt)
           end do
        end do
     end do
  end do

  deallocate(tr_temp11,tr_temp12,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error deallocate: alo_density_temp'
     stop
  end if

  !                       - - - - - - - - - - - - - - - - - -                        !

  open(unit=16,file=file_tempout,position='append')
  write(16,*) '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'
  write(16,*) '++++++++++++  end  calculation:'
  write(16,*) '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'
  close(16)

  !                       - - - - - - - - - - - - - - - - - -                       !

995 format(i10,i10)
996 format(d28.19,d28.19)
997 format(d28.19,d28.19,i5,'    ** left  *******************************')
998 format(d28.19,d28.19,i5,'    ** right *******************************')
999 format(i10,i10,d28.19,d28.19)

  return
end subroutine cal_gf_se_c

subroutine cal_gf_se_read

  use condition_ini
  use hamiltonian_sgf
  use hamiltonian_c
  use hamiltonian_temp
  use gf_se_c
  use constant
  use mod_mpi
  use scf_negf

  implicit none
  include 'mpif.h'
  integer :: ic_spin
  integer :: iw_max_mpi
  integer :: iw_do,i1_do,i2_do,icou,i3_do,ier
  integer :: px,py,qx,qy,ispin
  integer :: m_mat_max_read,itemp
  real(8) :: temp1,temp2
  complex(8) :: w,w1

  real(8) :: st1,st2,stdel

  complex(8), allocatable :: tr_temp11(:,:,:,:),tr_temp12(:,:,:,:)
  integer :: i_temp

  integer :: kt
  real(8) :: qx_tr,qy_tr

  call alo_mod_sftr(kt_tr,file_selfenergy)
  call alo_ham_temp_ham(m_mat_max_c,mat_max_ll,mat_max_rr)

  open(unit=16,file=file_tempout,position='append')
  write(16,*)
  write(16,*) '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'
  write(16,*) '++++++++++++ start calculation:'
  write(16,*) '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'
  close(16)

  call show_ksampling

  if( spin_switch_cc /= 2) then
     ic_spin=1
  else
     ic_spin=2
  end if

  do kt=1,ka_tr*kb_tr
     qx_tr=po_kt_tr(2,kt)
     qy_tr=po_kt_tr(3,kt)

     open(unit=16,file=file_tempout,position='append')
     write(16,*) '--------------------------------------------------------------'
     write(16,800) kt,qx_tr,qy_tr
800  format(' -------- K:   ',i5,2f13.8)
     write(16,*) '--------------------------------------------------------------'
     close(16)

     open(unit=60,file=file_sf_tr(kt,myrank+1))
     read(60,*) m_mat_max_read,iw_max_gs
     read(60,*)
     read(60,*)
     if( ham_model_ini == 'input' ) then
        call set_ham_temp_ham_c(qx_tr,qy_tr)
        if( myrank == 0 ) then
           if( switch_out_ham /= 'off' ) then
              call outham(kt,ic_spin,m_mat_max_c,hcc_t,scc_t)
           end if
        end if
     end if
     if( ham_model_ini == 'scf_accel' ) then
        call set_ham_temp_ham_l(qx_tr,qy_tr)
        call set_ham_temp_ham_r(qx_tr,qy_tr)
        call set_ham_scf_ham_c(qx_tr,qy_tr)
        if( myrank == 0 ) then
           if( switch_out_ham /= 'off' ) then
              call outham(kt,ic_spin,m_mat_max_c,h_cc_scf,s_cc_scf)
           end if
        end if
     end if

     itemp=m_mat_max_c-m_mat_max_read

     if( mod(iw_max_gs,nprocs) == 0 ) then
        iw_max_mpi=iw_max_gs
     else
        iw_max_mpi=iw_max_gs+nprocs-mod(iw_max_gs,nprocs)
     end if
     iw_max_mpi=(iw_max_mpi/nprocs)*nprocs
     do iw_do=1+myrank,iw_max_mpi,nprocs

        open(unit=16,file=file_tempout,position='append')
        write(16,*) '     ------- cal_gf_se_c:',iw_do
        close(16)

        !                       - - - - - - - - - - - - - - - - - -                       !

        do ispin=1,ic_spin

           if( iw_do > iw_max_gs ) then
              go to 100
           end if

           do px=1,kx_max_ll
              do py=1,ky_max_ll
                 do i2_do=1,m_mat_max_c
                    do i1_do=1,m_mat_max_c
                       se_l_mat_per(i1_do,i2_do,px,py)=dcmplx(0.d0,0.d0)
                    end do
                 end do
              end do
           end do

           do qx=1,kx_max_rr
              do qy=1,ky_max_rr
                 do i2_do=1,m_mat_max_c
                    do i1_do=1,m_mat_max_c
                       se_r_mat_per(i1_do,i2_do,qx,qy)=dcmplx(0.d0,0.d0)
                    end do
                 end do
              end do
           end do

100        continue

           if( iw_do <= iw_max_gs ) then
              do px=1,kx_max_ll
                 do py=1,ky_max_ll
                    read(60,996) temp1,temp2
                    w=dcmplx(temp1,temp2)
                    read(60,*) icou
                    do i3_do=1,icou
                       read(60,999) i1_do,i2_do,temp1,temp2
                       se_l_mat_per(i1_do,i2_do,px,py)=dcmplx(temp1,temp2)
                    end do
                 end do
              end do
              do qx=1,kx_max_rr
                 do qy=1,ky_max_rr
                    read(60,996) temp1,temp2
                    w1=dcmplx(temp1,temp2)
                    if( w /= w1 ) then
                       open(unit=16,file=file_tempout,position='append')
                       write(16,*) 'error--  w /= w1'
                       close(16)
                       stop
                    end if
                    read(60,*) icou
                    do i3_do=1,icou
                       read(60,999) i1_do,i2_do,temp1,temp2
                       se_r_mat_per(itemp+i1_do,itemp+i2_do,qx,qy)=dcmplx(temp1,temp2)
                    end do
                 end do
              end do
           end if

           open(unit=16,file=file_tempout,position='append')
           call myclock(st1)

           do px=1,kx_max_ll
              do py=1,ky_max_ll
                 do qx=1,kx_max_rr
                    do qy=1,ky_max_rr
                       call trans(w,iw_do,px,py,qx,qy,ispin,kt)
                    end do
                 end do
              end do
           end do
           call myclock(st2)
           stdel=st2-st1
           write(16,*) '           t=',stdel

           close(16)

        end do

        !                       - - - - - - - - - - - - - - - - - -                       !

     end do
  end do

  close(60)

  call dealo_mod_sftr
  call dealo_ham_temp_ham

  allocate(tr_temp11(4+num_block_gr,ic_spin,iw_max_gs,ka_tr*kb_tr)           &
       ,tr_temp12(4+num_block_gr,ic_spin,iw_max_gs,ka_tr*kb_tr)           &
       ,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: alo_density_temp'
     stop
  end if

  do kt=1,ka_tr*kb_tr
     do i1_do=1,iw_max_gs
        do i2_do=1,ic_spin
           tr_temp11(1,i2_do,i1_do,kt)=tr_gr_l(i2_do,i1_do,kt)
           tr_temp11(2,i2_do,i1_do,kt)=tr_gr_r(i2_do,i1_do,kt)
           tr_temp11(3,i2_do,i1_do,kt)=tr_gr_c(i2_do,i1_do,kt)
           tr_temp11(4,i2_do,i1_do,kt)=tr_tr(i2_do,i1_do,kt)
           do i3_do=1,num_block_gr
              tr_temp11(4+i3_do,i2_do,i1_do,kt)=tr_grc_block(i2_do,i3_do,i1_do,kt)
           end do
        end do
     end do
  end do

  i_temp=(4+num_block_gr)*ic_spin*iw_max_gs*ka_tr*kb_tr
  call MPI_REDUCE(tr_temp11,tr_temp12,i_temp,MPI_DOUBLE_COMPLEX,MPI_SUM,0    &
       ,mpi_comm_world,ierr)

  do kt=1,ka_tr*kb_tr
     do i1_do=1,iw_max_gs
        do i2_do=1,ic_spin
           tr_gr_l(i2_do,i1_do,kt)=tr_temp12(1,i2_do,i1_do,kt)
           tr_gr_r(i2_do,i1_do,kt)=tr_temp12(2,i2_do,i1_do,kt)
           tr_gr_c(i2_do,i1_do,kt)=tr_temp12(3,i2_do,i1_do,kt)
           tr_tr(i2_do,i1_do,kt)=tr_temp12(4,i2_do,i1_do,kt)
           do i3_do=1,num_block_gr
              tr_grc_block(i2_do,i3_do,i1_do,kt)=tr_temp12(4+i3_do,i2_do,i1_do,kt)
           end do
        end do
     end do
  end do

  deallocate(tr_temp11,tr_temp12,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error deallocate: alo_density_temp'
     stop
  end if

  !                       - - - - - - - - - - - - - - - - - -                        !

  open(unit=16,file=file_tempout,position='append')
  write(16,*)
  write(16,*)
  write(16,*)
  write(16,*) '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'
  write(16,*) '++++++++++++  end  calculation:'
  write(16,*) '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'
  close(16)

  !                       - - - - - - - - - - - - - - - - - -                       !

996 format(d28.19,d28.19)
999 format(i10,i10,d28.19,d28.19)

  return
end subroutine cal_gf_se_read

subroutine outham(kt,ic_spin,m_mat_max_c,hcc,scc)

  implicit none
  integer, intent(in) :: kt,ic_spin,m_mat_max_c
  complex(8), intent(in) :: hcc(ic_spin,m_mat_max_c,m_mat_max_c)
  complex(8), intent(in) :: scc(m_mat_max_c,m_mat_max_c)

  character(50) :: nfile_shs
  integer :: i_hcc_1,i_hcc_2,i_scc,i_temp1,i_temp2
  integer :: ispin,icou,i1_do,i2_do

  call makefilename_outham(kt,nfile_shs)

  i_hcc_1=0
  i_hcc_2=0
  do ispin=1,ic_spin
     do i1_do=1,m_mat_max_c
        do i2_do=1,m_mat_max_c
           if( cdabs(hcc(ispin,i1_do,i2_do)) > 1.d-16 ) then
              if( ispin == 1 ) then
                 i_hcc_1=i_hcc_1+1
              else
                 i_hcc_2=i_hcc_2+1
              end if
           end if
        end do
     end do
  end do
  i_scc=0
  do i1_do=1,m_mat_max_c
     do i2_do=1,m_mat_max_c
        if( cdabs(scc(i1_do,i2_do)) > 1.d-16 ) then
           i_scc=i_scc+1
        end if
     end do
  end do

  i_temp1=0
  i_temp2=0
  open(unit=36,file=nfile_shs)

  write(36,*) i_temp1,m_mat_max_c,i_temp2
  write(36,*) ic_spin-1
  write(36,*) i_hcc_1,i_hcc_2,i_scc
  write(36,*)
  write(36,*)

  do ispin=1,ic_spin
     write(36,*)
     icou=0
     do i1_do=1,m_mat_max_c
        do i2_do=1,m_mat_max_c
           if( cdabs(hcc(ispin,i1_do,i2_do)) > 1.d-16 ) then
              icou=icou+1
              write(36,999) icou,i1_do,i2_do,hcc(ispin,i1_do,i2_do)
           end if
        end do
     end do
  end do

  write(36,*)
  icou=0
  do i1_do=1,m_mat_max_c
     do i2_do=1,m_mat_max_c
        if( cdabs(scc(i1_do,i2_do)) > 1.d-16 ) then
           icou=icou+1
           write(36,999) icou,i1_do,i2_do,scc(i1_do,i2_do)
        end if
     end do
  end do

999 format(i10,i10,i10,d28.19,d28.19)

  close(36)

  return
end subroutine outham

subroutine makefilename_outham(kt,nfile_strans)

  implicit none
  integer, intent(in) :: kt
  character(50), intent(out) :: nfile_strans

  character(1) :: character_temk(4),a(10)
  integer :: i1,i2,k1,i_temp1,i_temp2

  a(1)='0'
  a(2)='1'
  a(3)='2'
  a(4)='3'
  a(5)='4'
  a(6)='5'
  a(7)='6'
  a(8)='7'
  a(9)='8'
  a(10)='9'

  nfile_strans='hss'

  i_temp1=kt
  do i2=1,4
     i_temp2=i_temp1/(10**(4-i2))
     character_temk(i2)=a(i_temp2+1)
     i_temp1=i_temp1-(10**(4-i2))*i_temp2
  end do
  nfile_strans=trim(nfile_strans)                                         &
       //'_'//character_temk(1)//character_temk(2)                &
       //character_temk(3)//character_temk(4)//'.data'

  return
end subroutine makefilename_outham

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Naoki WATANABE, Nobutaka NISHIKAWA (Mizuho I.R.)   @@ !
! @@             Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine Spline__set( spline, vf, vx_out, N )
  use ac_parameter

  implicit none
  type(Spline_type), intent(out) :: spline
  integer, intent(in)       :: N
  real(8), intent(in)       :: vf(N)
  real(8), intent(in)       :: vx_out(N)

  real(8), allocatable :: vdx(:)
  real(8), allocatable :: vdf(:)
  real(8), allocatable ::  vu(:)
  integer       :: i

  spline%N = N 

  allocate( vdx(spline%N) )
  allocate( vdf(spline%N) )
  allocate(  vu(spline%N) )

  allocate( spline%vf(spline%N) )
  allocate( spline%vx(spline%N) )

  do i=1, spline%N
     spline%vf(i) = vf(i)
     spline%vx(i) = vx_out(i)
  end do

  allocate( spline%vb(spline%N) )
  allocate( spline%vc(spline%N) )
  allocate( spline%vd(spline%N) )

  do i=1, spline%N-1
     vdx(i) = vx_out(i+1) - vx_out(i+0)
  end do
  vdx(spline%N)=0.d0

  do i=1, spline%N-1
     vdf(i) = (vf(i+1)-vf(i))*(1.0/vdx(i))
  end do
  vdf(spline%N) = 0.d0

  spline%vc(1) = 0.d0
  do i=2, spline%N-1
     spline%vc(i) = (vdf(i+0)-vdf(i-1))*3.0
  end do
  spline%vc(spline%N) = 0.d0

  vu(1) = 0.d0
  do i=2, spline%N-1
     vu(i) = 1.0/( 2*(vdx(i+1)+vdx(i)) - vdx(i)*vdx(i)*vu(i-1) )
  end do
  vu(spline%N) = 0.d0

  do i=2, spline%N-1
     spline%vc(i) = spline%vc(i) - spline%vc(i-1)*(vdx(i-1)*vu(i-1))
  end do
  do i=spline%N-1, 2, -1
     spline%vc(i) = (spline%vc(i) - spline%vc(i+1)*vdx(i))*vu(i)
  end do

  do i=1, spline%N-1
     spline%vd(i) = (spline%vc(i+1)-spline%vc(i))*(1.0/(3.0*vdx(i)))
     spline%vb(i) = vdf(i) - spline%vc(i)*vdx(i) - spline%vd(i)*(vdx(i)*vdx(i))
  end do
  spline%vb(spline%N) = 0.d0
  spline%vd(spline%N) = 0.d0

  deallocate( vdx, vdf, vu )

  return
end subroutine Spline__set



subroutine Spline__reset( spline, vf )
  use ac_parameter

  implicit none
  type(Spline_type), intent(inout) :: spline
  real(8), intent(in)       :: vf(spline%N)


  real(8), allocatable :: vdx(:)
  real(8), allocatable :: vdf(:)
  real(8), allocatable ::  vu(:)
  integer       :: i

  allocate( vdx(spline%N) )
  allocate( vdf(spline%N) )
  allocate(  vu(spline%N) )

  do i=1, spline%N
     spline%vf(i) = vf(i)
  end do

  do i=1, spline%N-1
     vdx(i) = spline%vx(i+1) - spline%vx(i+0)
  end do
  vdx(spline%N)=0.d0

  do i=1, spline%N-1
     vdf(i) = (vf(i+1)-vf(i))*(1.0/vdx(i))
  end do
  vdf(spline%N) = 0.d0

  spline%vc(1) = 0.d0
  do i=2, spline%N-1
     spline%vc(i) = (vdf(i+0)-vdf(i-1))*3.0
  end do
  spline%vc(spline%N) = 0.d0

  vu(1) = 0.d0
  do i=2, spline%N-1
     vu(i) = 1.0/( 2*(vdx(i+1)+vdx(i)) - vdx(i)*vdx(i)*vu(i-1) )
  end do
  vu(spline%N) = 0.d0

  do i=2, spline%N-1
     spline%vc(i) = spline%vc(i) - spline%vc(i-1)*(vdx(i-1)*vu(i-1))
  end do
  do i=spline%N-1, 2, -1
     spline%vc(i) = (spline%vc(i) - spline%vc(i+1)*vdx(i))*vu(i)
  end do

  do i=1, spline%N-1
     spline%vd(i) = (spline%vc(i+1)-spline%vc(i))*(1.0/(3.0*vdx(i)))
     spline%vb(i) = vdf(i) - spline%vc(i)*vdx(i) - spline%vd(i)*(vdx(i)*vdx(i))
  end do
  spline%vb(spline%N) = 0.d0
  spline%vd(spline%N) = 0.d0

  deallocate( vdx, vdf, vu )

  return
end subroutine Spline__reset

subroutine Spline_deallocate(spline)
  use ac_parameter

  implicit none
  type(Spline_type) :: spline

  if( associated(spline%vx) ) deallocate(spline%vx)
  if( associated(spline%vf) ) deallocate(spline%vf)
  if( associated(spline%vb) ) deallocate(spline%vb)
  if( associated(spline%vc) ) deallocate(spline%vc)
  if( associated(spline%vd) ) deallocate(spline%vd)

  return
end subroutine Spline_deallocate

subroutine Spline__evaluate( spline, x, f )
  use ac_parameter

  implicit none
  type(Spline_type), intent(in)  :: spline
  real(8), intent(in) :: x

  real(8) :: f
  real(8) :: dx
  integer :: i, ia, ib, ic

  if( Param%Option%mx ) then
     call Spline__evaluateMX(spline,x,f)
     return
  end if

  if( x < spline%vx(1) ) then
     i=1
  elseif( x > spline%vx(spline%N) ) then
     i=spline%N
  else
     ia=1
     ib=spline%N
     do while( ia+1 < ib )
        ic = (ia+ib)/2
        if( x<spline%vx(ic) ) then
           ib=ic
        else
           ia=ic
        end if
     end do
     i=ia
  end if

  dx = x - spline%vx(i)

  f = spline%vf(i) + dx*(spline%vb(i) + dx*(spline%vc(i) + dx*spline%vd(i)))

  return
end subroutine Spline__evaluate

subroutine Spline__derivative( spline, x, df )
  use ac_parameter

  implicit none
  type(Spline_type), intent(in)  :: spline
  real(8), intent(in) :: x

  real(8) :: df

  integer       :: i, ia, ib, ic
  real(8) :: dx

  if( Param%Option%mx ) then
     call Spline__derivativeMX(spline,x,df)
     return
  end if

  if( x < spline%vx(1) ) then
     i=1
  elseif( x > spline%vx(spline%N) ) then
     i=spline%N
  else
     ia=1
     ib=spline%N
     do while( ia+1 < ib )
        ic = (ia+ib)/2
        if( x<spline%vx(ic) ) then
           ib=ic
        else
           ia=ic
        end if
     end do
     i=ia
  end if

  dx = x - spline%vx(i)

  df = spline%vb(i) + 2*dx*spline%vc(i) + 3*dx*dx*spline%vd(i)

  return
end subroutine Spline__derivative

subroutine Spline__evaluateMX( spline, x, f )
  use ac_parameter

  implicit none
  type(Spline_type), intent(in)  :: spline
  real(8), intent(in) :: x

  real(8) :: f
  integer :: i, ia, ib, ic
  real(8) :: h1,h2,h3,f1,f2,f3,f4
  real(8) :: g1,g2,x1,x2,y1,y2

  if( spline%vx(spline%N) < x ) then
     i=spline%N
  else if( x < spline%vx(1) ) then
     i=1
  else
     ia=1
     ib=spline%N
     do while( ia+1 < ib )
        ic = (ia+ib)/2
        if( x<spline%vx(ic) )then
           ib=ic
        else
           ia=ic
        end if
     end do
     i=ib
  end if

  if(i<2)then
     i = 3
  else if( spline%N<i )then
     i = spline%N-1
  end if

  if( i==2 ) then
     h2 = spline%vx(i)   - spline%vx(i-1)
     h3 = spline%vx(i+1) - spline%vx(i)

     f2 = spline%vf(i-1)
     f3 = spline%vf(i)
     f4 = spline%vf(i+1)

     h1 = -(h2+h3)
     f1 = f4
  else if (i==spline%N) then
     h1 = spline%vx(i-1) - spline%vx(i-2)
     h2 = spline%vx(i)   - spline%vx(i-1)

     f1 = spline%vf(i-2)
     f2 = spline%vf(i-1)
     f3 = spline%vf(i)

     h3 = -(h1+h2)
     f4 = f1
  else
     h1 = spline%vx(i-1) - spline%vx(i-2)
     h2 = spline%vx(i)   - spline%vx(i-1)
     h3 = spline%vx(i+1) - spline%vx(i)

     f1 = spline%vf(i-2)
     f2 = spline%vf(i-1)
     f3 = spline%vf(i)
     f4 = spline%vf(i+1)
  end if

  g1 = ((f3-f2)*h1/h2 + (f2-f1)*h2/h1)/(h1+h2)
  g2 = ((f4-f3)*h2/h3 + (f3-f2)*h3/h2)/(h2+h3)

  x1 = x - spline%vx(i-1)
  x2 = x - spline%vx(i)
  y1 = x1/h2
  y2 = x2/h2

  f = y2*y2*(3.0*f2 + h2*g1 + (2.0*f2 + h2*g1)*y2) &
       + y1*y1*(3.0*f3 - h2*g2 - (2.0*f3 - h2*g2)*y1)

  return
end subroutine Spline__evaluateMX

subroutine Spline__derivativeMX( spline, x, df )
  use ac_parameter

  implicit none
  type(Spline_type), intent(in)  :: spline
  real(8), intent(in) :: x

  real(8) :: df
  integer :: i, ia, ib, ic
  real(8) :: h1,h2,h3,f1,f2,f3,f4
  real(8) :: g1,g2,x1,x2,y1,y2

  if( spline%vx(spline%N) < x ) then
     i=spline%N
  else if( x < spline%vx(1) ) then
     i=1
  else
     ia=1
     ib=spline%N
     do while( ia+1 < ib )
        ic = (ia+ib)/2
        if( x<spline%vx(ic) )then
           ib=ic
        else
           ia=ic
        end if
     end do
     i=ib
  end if

  if(i<3)then
     i = 3
  else if( spline%N<i )then
     i = spline%N-1
  end if

  if( i==2 ) then
     h2 = spline%vx(i)   - spline%vx(i-1)
     h3 = spline%vx(i+1) - spline%vx(i)

     f2 = spline%vf(i-1)
     f3 = spline%vf(i)
     f4 = spline%vf(i+1)

     h1 = -(h2+h3)
     f1 = f4
  else if (i==spline%N) then
     h1 = spline%vx(i-1) - spline%vx(i-2)
     h2 = spline%vx(i)   - spline%vx(i-1)

     f1 = spline%vf(i-2)
     f2 = spline%vf(i-1)
     f3 = spline%vf(i)

     h3 = -(h1+h2)
     f4 = f1
  else
     h1 = spline%vx(i-1) - spline%vx(i-2)
     h2 = spline%vx(i)   - spline%vx(i-1)
     h3 = spline%vx(i+1) - spline%vx(i)

     f1 = spline%vf(i-2)
     f2 = spline%vf(i-1)
     f3 = spline%vf(i)
     f4 = spline%vf(i+1)
  end if

  g1 = ((f3-f2)*h1/h2 + (f2-f1)*h2/h1)/(h1+h2)
  g2 = ((f4-f3)*h2/h3 + (f3-f2)*h3/h2)/(h2+h3)

  x1 = x - spline%vx(i-1)
  x2 = x - spline%vx(i)
  y1 = x1/h2
  y2 = x2/h2

  df = y2*(2.0*(3.0*f2 + h2*g1) + 3.0*(2.0*f2 + h2*g1)*y2)/h2 &
       + y1*(2.0*(3.0*f3 - h2*g2) - 3.0*(2.0*f3 - h2*g2)*y1)/h2

  return
end subroutine Spline__derivativeMX

function Spline__size( spline ) result(N)
  use ac_parameter

  implicit none
  type(Spline_type), intent(in) :: spline

  integer      :: N

  N = spline%N

  return
end function Spline__size

function Spline__x(spline, i) result(x)
  use ac_parameter

  implicit none
  type(Spline_type), intent(in)  :: spline
  integer, intent(in)       :: i

  real(8) :: x

  x = spline%vx(i)

  return
end function Spline__x

function Spline__xfront(spline) result(x)
  use ac_parameter

  implicit none
  type(Spline_type), intent(in) :: spline
  real(8) :: x

  x = spline%vx(1)

  return
end function Spline__xfront

function Spline__xback(spline) result(x)
  use ac_parameter

  implicit none
  type(Spline_type), intent(in)  :: spline
  real(8) :: x

  x = spline%vx(spline%N)

  return
end function Spline__xback

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@             Naoki WATANABE (Mizuho I.R.)                       @@ !
! @@             Nobutaka NISHIKAWA (Mizuho I.R.)                   @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine cal_vother(cutene_vt_ok)

  use scf_negf
  use fft
  use dft
  use condition_ini
  use hamiltonian_sgf
  use hamiltonian_c
  use gf_se_c
  use constant
  use ac_mpi_module
  use mod_mpi

  implicit none
  integer, intent(inout) :: cutene_vt_ok

  integer :: gn

  integer :: i1,i2,i3,i4,ii,gnj,ispin

  call cal_vother_accel

  if( MPI%root ) then

     if( ispin_pol_scf == 1 ) then
        open(unit=90,file='negf_vtot.cube')
        write(90,*) 'SYS1'
        write(90,*) 'SYS1'
        write(90,993) num_atom_scf,cell_lo(1),cell_lo(2),cell_lo(3)
        write(90,993) n_a,cell_dlabc(1,1),cell_dlabc(1,2),cell_dlabc(1,3)
        write(90,993) n_b,cell_dlabc(2,1),cell_dlabc(2,2),cell_dlabc(2,3)
        write(90,993) n_c,cell_dlabc(3,1),cell_dlabc(3,2),cell_dlabc(3,3)
        do i1=1,num_atom_scf
           write(90,992) atom_name_num(i1)                                      &
                ,vatom_q(i1)-sum_charge(i1)                               &
                ,atom_ro(i1,1),atom_ro(i1,2),atom_ro(i1,3)
        end do
        do i1=0,n_a-1
           do i2=0,n_b-1
              ii=n_c+6
              do i3=0,n_c-1,6
                 gnj=i1*n_b*n_c+i2*n_c+i3
                 ii=ii-6
                 if( ii >= 6 ) then
                    write(90,999) (v_tot_temp(gnj+i4,1),i4=1,6)
                 else
                    if( ii == 5 ) write(90,998) (v_tot_temp(gnj+i4,1),i4=1,ii)
                    if( ii == 4 ) write(90,997) (v_tot_temp(gnj+i4,1),i4=1,ii)
                    if( ii == 3 ) write(90,996) (v_tot_temp(gnj+i4,1),i4=1,ii)
                    if( ii == 2 ) write(90,995) (v_tot_temp(gnj+i4,1),i4=1,ii)
                    if( ii == 1 ) write(90,994) (v_tot_temp(gnj+i4,1),i4=1,ii)
                 end if
              end do
           end do
        end do
        close(90)
     end if
     if( ispin_pol_scf == 2 ) then
        open(unit=90,file='negf_vtot_up.cube')
        write(90,*) 'SYS1'
        write(90,*) 'SYS1'
        write(90,993) num_atom_scf,cell_lo(1),cell_lo(2),cell_lo(3)
        write(90,993) n_a,cell_dlabc(1,1),cell_dlabc(1,2),cell_dlabc(1,3)
        write(90,993) n_b,cell_dlabc(2,1),cell_dlabc(2,2),cell_dlabc(2,3)
        write(90,993) n_c,cell_dlabc(3,1),cell_dlabc(3,2),cell_dlabc(3,3)
        do i1=1,num_atom_scf
           write(90,992) atom_name_num(i1)                                        &
                ,vatom_q(i1)-sum_charge(i1)                               &
                ,atom_ro(i1,1),atom_ro(i1,2),atom_ro(i1,3)
        end do
        do i1=0,n_a-1
           do i2=0,n_b-1
              ii=n_c+6
              do i3=0,n_c-1,6
                 gnj=i1*n_b*n_c+i2*n_c+i3
                 ii=ii-6
                 if( ii >= 6 ) then
                    write(90,999) (v_tot_temp(gnj+i4,1),i4=1,6)
                 else
                    if( ii == 5 ) write(90,998) (v_tot_temp(gnj+i4,1),i4=1,ii)
                    if( ii == 4 ) write(90,997) (v_tot_temp(gnj+i4,1),i4=1,ii)
                    if( ii == 3 ) write(90,996) (v_tot_temp(gnj+i4,1),i4=1,ii)
                    if( ii == 2 ) write(90,995) (v_tot_temp(gnj+i4,1),i4=1,ii)
                    if( ii == 1 ) write(90,994) (v_tot_temp(gnj+i4,1),i4=1,ii)
                 end if
              end do
           end do
        end do
        close(90)
        open(unit=90,file='negf_vtot_do.cube')
        write(90,*) 'SYS1'
        write(90,*) 'SYS1'
        write(90,993) num_atom_scf,cell_lo(1),cell_lo(2),cell_lo(3)
        write(90,993) n_a,cell_dlabc(1,1),cell_dlabc(1,2),cell_dlabc(1,3)
        write(90,993) n_b,cell_dlabc(2,1),cell_dlabc(2,2),cell_dlabc(2,3)
        write(90,993) n_c,cell_dlabc(3,1),cell_dlabc(3,2),cell_dlabc(3,3)
        do i1=1,num_atom_scf
           write(90,992) atom_name_num(i1)                                      &
                ,vatom_q(i1)-sum_charge(i1)                               &
                ,atom_ro(i1,1),atom_ro(i1,2),atom_ro(i1,3)
        end do
        do i1=0,n_a-1
           do i2=0,n_b-1
              ii=n_c+6
              do i3=0,n_c-1,6
                 gnj=i1*n_b*n_c+i2*n_c+i3
                 ii=ii-6
                 if( ii >= 6 ) then
                    write(90,999) (v_tot_temp(gnj+i4,2),i4=1,6)
                 else
                    if( ii == 5 ) write(90,998) (v_tot_temp(gnj+i4,2),i4=1,ii)
                    if( ii == 4 ) write(90,997) (v_tot_temp(gnj+i4,2),i4=1,ii)
                    if( ii == 3 ) write(90,996) (v_tot_temp(gnj+i4,2),i4=1,ii)
                    if( ii == 2 ) write(90,995) (v_tot_temp(gnj+i4,2),i4=1,ii)
                    if( ii == 1 ) write(90,994) (v_tot_temp(gnj+i4,2),i4=1,ii)
                 end if
              end do
           end do
        end do
        close(90)
     end if
     if( ispin_pol_scf == 4 ) then
        open(unit=90,file='negf_vtot_up.cube')
        write(90,*) 'SYS1'
        write(90,*) 'SYS1'
        write(90,993) num_atom_scf,cell_lo(1),cell_lo(2),cell_lo(3)
        write(90,993) n_a,cell_dlabc(1,1),cell_dlabc(1,2),cell_dlabc(1,3)
        write(90,993) n_b,cell_dlabc(2,1),cell_dlabc(2,2),cell_dlabc(2,3)
        write(90,993) n_c,cell_dlabc(3,1),cell_dlabc(3,2),cell_dlabc(3,3)
        do i1=1,num_atom_scf
           write(90,992) atom_name_num(i1)                                        &
                ,vatom_q(i1)-sum_charge(i1)                               &
                ,atom_ro(i1,1),atom_ro(i1,2),atom_ro(i1,3)
        end do
        do i1=0,n_a-1
           do i2=0,n_b-1
              ii=n_c+6
              do i3=0,n_c-1,6
                 gnj=i1*n_b*n_c+i2*n_c+i3
                 ii=ii-6
                 if( ii >= 6 ) then
                    write(90,999) (v_tot_temp(gnj+i4,1),i4=1,6)
                 else
                    if( ii == 5 ) write(90,998) (v_tot_temp(gnj+i4,1),i4=1,ii)
                    if( ii == 4 ) write(90,997) (v_tot_temp(gnj+i4,1),i4=1,ii)
                    if( ii == 3 ) write(90,996) (v_tot_temp(gnj+i4,1),i4=1,ii)
                    if( ii == 2 ) write(90,995) (v_tot_temp(gnj+i4,1),i4=1,ii)
                    if( ii == 1 ) write(90,994) (v_tot_temp(gnj+i4,1),i4=1,ii)
                 end if
              end do
           end do
        end do
        close(90)
        open(unit=90,file='negf_vtot_sx.cube')
        write(90,*) 'SYS1'
        write(90,*) 'SYS1'
        write(90,993) num_atom_scf,cell_lo(1),cell_lo(2),cell_lo(3)
        write(90,993) n_a,cell_dlabc(1,1),cell_dlabc(1,2),cell_dlabc(1,3)
        write(90,993) n_b,cell_dlabc(2,1),cell_dlabc(2,2),cell_dlabc(2,3)
        write(90,993) n_c,cell_dlabc(3,1),cell_dlabc(3,2),cell_dlabc(3,3)
        do i1=1,num_atom_scf
           write(90,992) atom_name_num(i1)                                      &
                ,vatom_q(i1)-sum_charge(i1)                               &
                ,atom_ro(i1,1),atom_ro(i1,2),atom_ro(i1,3)
        end do
        do i1=0,n_a-1
           do i2=0,n_b-1
              ii=n_c+6
              do i3=0,n_c-1,6
                 gnj=i1*n_b*n_c+i2*n_c+i3
                 ii=ii-6
                 if( ii >= 6 ) then
                    write(90,999) (v_tot_temp(gnj+i4,2),i4=1,6)
                 else
                    if( ii == 5 ) write(90,998) (v_tot_temp(gnj+i4,2),i4=1,ii)
                    if( ii == 4 ) write(90,997) (v_tot_temp(gnj+i4,2),i4=1,ii)
                    if( ii == 3 ) write(90,996) (v_tot_temp(gnj+i4,2),i4=1,ii)
                    if( ii == 2 ) write(90,995) (v_tot_temp(gnj+i4,2),i4=1,ii)
                    if( ii == 1 ) write(90,994) (v_tot_temp(gnj+i4,2),i4=1,ii)
                 end if
              end do
           end do
        end do
        close(90)
        open(unit=90,file='negf_vtot_sy.cube')
        write(90,*) 'SYS1'
        write(90,*) 'SYS1'
        write(90,993) num_atom_scf,cell_lo(1),cell_lo(2),cell_lo(3)
        write(90,993) n_a,cell_dlabc(1,1),cell_dlabc(1,2),cell_dlabc(1,3)
        write(90,993) n_b,cell_dlabc(2,1),cell_dlabc(2,2),cell_dlabc(2,3)
        write(90,993) n_c,cell_dlabc(3,1),cell_dlabc(3,2),cell_dlabc(3,3)
        do i1=1,num_atom_scf
           write(90,992) atom_name_num(i1)                                        &
                ,vatom_q(i1)-sum_charge(i1)                               &
                ,atom_ro(i1,1),atom_ro(i1,2),atom_ro(i1,3)
        end do
        do i1=0,n_a-1
           do i2=0,n_b-1
              ii=n_c+6
              do i3=0,n_c-1,6
                 gnj=i1*n_b*n_c+i2*n_c+i3
                 ii=ii-6
                 if( ii >= 6 ) then
                    write(90,999) (v_tot_temp(gnj+i4,3),i4=1,6)
                 else
                    if( ii == 5 ) write(90,998) (v_tot_temp(gnj+i4,3),i4=1,ii)
                    if( ii == 4 ) write(90,997) (v_tot_temp(gnj+i4,3),i4=1,ii)
                    if( ii == 3 ) write(90,996) (v_tot_temp(gnj+i4,3),i4=1,ii)
                    if( ii == 2 ) write(90,995) (v_tot_temp(gnj+i4,3),i4=1,ii)
                    if( ii == 1 ) write(90,994) (v_tot_temp(gnj+i4,3),i4=1,ii)
                 end if
              end do
           end do
        end do
        close(90)
        open(unit=90,file='negf_vtot_do.cube')
        write(90,*) 'SYS1'
        write(90,*) 'SYS1'
        write(90,993) num_atom_scf,cell_lo(1),cell_lo(2),cell_lo(3)
        write(90,993) n_a,cell_dlabc(1,1),cell_dlabc(1,2),cell_dlabc(1,3)
        write(90,993) n_b,cell_dlabc(2,1),cell_dlabc(2,2),cell_dlabc(2,3)
        write(90,993) n_c,cell_dlabc(3,1),cell_dlabc(3,2),cell_dlabc(3,3)
        do i1=1,num_atom_scf
           write(90,992) atom_name_num(i1)                                      &
                ,vatom_q(i1)-sum_charge(i1)                               &
                ,atom_ro(i1,1),atom_ro(i1,2),atom_ro(i1,3)
        end do
        do i1=0,n_a-1
           do i2=0,n_b-1
              ii=n_c+6
              do i3=0,n_c-1,6
                 gnj=i1*n_b*n_c+i2*n_c+i3
                 ii=ii-6
                 if( ii >= 6 ) then
                    write(90,999) (v_tot_temp(gnj+i4,4),i4=1,6)
                 else
                    if( ii == 5 ) write(90,998) (v_tot_temp(gnj+i4,4),i4=1,ii)
                    if( ii == 4 ) write(90,997) (v_tot_temp(gnj+i4,4),i4=1,ii)
                    if( ii == 3 ) write(90,996) (v_tot_temp(gnj+i4,4),i4=1,ii)
                    if( ii == 2 ) write(90,995) (v_tot_temp(gnj+i4,4),i4=1,ii)
                    if( ii == 1 ) write(90,994) (v_tot_temp(gnj+i4,4),i4=1,ii)
                 end if
              end do
           end do
        end do
        close(90)
     end if
  end if

999 format(f13.6,f13.6,f13.6,f13.6,f13.6,f13.6)
998 format(f13.6,f13.6,f13.6,f13.6,f13.6)
997 format(f13.6,f13.6,f13.6,f13.6)
996 format(f13.6,f13.6,f13.6)
995 format(f13.6,f13.6)
994 format(f13.6)
993 format(i4,f13.6,f13.6,f13.6)
992 format(i4,f13.6,f13.6,f13.6,f13.6)

  return
end subroutine cal_vother

subroutine cal_vother_accel
  use scf_negf

  implicit none
  real(8), allocatable :: vexc(:,:,:,:)
  real(8), allocatable :: rho1(:,:,:,:),rho2(:,:,:)
  complex(8), allocatable :: rho1ls(:,:,:,:)

  real(8) :: eexc,const
  integer :: i1,i2,i3,ispin,gn,ier

  if( ispin_pol_scf < 4 ) then
     allocate(vexc(ispin_pol_scf,0:n_a-1,0:n_b-1,0:n_c-1)                     &
          ,rho1(ispin_pol_scf,0:n_a-1,0:n_b-1,0:n_c-1)                     &
          ,rho2(0:n_a-1,0:n_b-1,0:n_c-1)                                   &
          ,stat=ier)
     if( ier /= 0 ) then
        write(6,*) 'error allocate: cal_vother_accel'
        stop
     end if

     const=3.0d0-dfloat(ispin_pol_scf)
     do i3=0,n_c-1
        do i2=0,n_b-1
           do i1=0,n_a-1
              gn=i1*n_b*n_c+i2*n_c+i3+1
              do ispin=1,ispin_pol_scf
                 rho1(ispin,i1,i2,i3)=rho(gn,ispin)*const
              end do
              rho2(i1,i2,i3)=rhopcc(gn)*2.d0
           end do
        end do
     end do

     call Exchange__calcPotential(eexc,vexc,rho1,rho2)

     do ispin=1,ispin_pol_scf
        do i3=l_cell_l_bound+1,r_cell_l_bound-1
           do i2=0,n_b-1
              do i1=0,n_a-1
                 gn=i1*n_b*n_c+i2*n_c+i3+1
                 v_tot_temp(gn,ispin)=v_hartree(gn)+vexc(ispin,i1,i2,i3)+v_ext(gn)
              end do
           end do
        end do
     end do

     deallocate(vexc,rho1,rho2,stat=ier)
     if( ier /= 0 ) then
        write(6,*) 'error deallocate: cal_vother_accel'
        stop
     end if
  else
     allocate(vexc(ispin_pol_scf,0:n_a-1,0:n_b-1,0:n_c-1)                     &
          ,rho1ls(ispin_pol_scf,0:n_a-1,0:n_b-1,0:n_c-1)                   &
          ,rho2(0:n_a-1,0:n_b-1,0:n_c-1)                                   &
          ,stat=ier)
     if( ier /= 0 ) then
        write(6,*) 'error allocate: cal_vother_accel'
        stop
     end if

     do ispin=1,ispin_pol_scf
        do i3=0,n_c-1
           do i2=0,n_b-1
              do i1=0,n_a-1
                 gn=i1*n_b*n_c+i2*n_c+i3+1
                 rho1ls(ispin,i1,i2,i3)=rhols(gn,ispin)
                 rho2(i1,i2,i3)=rhopcc(gn)*2.d0
              end do
           end do
        end do
     end do

     call ExchangeLS__calcPotential(eexc,vexc,rho1ls,rho2)

     do ispin=1,ispin_pol_scf
        do i3=l_cell_l_bound+1,r_cell_l_bound-1
           do i2=0,n_b-1
              do i1=0,n_a-1
                 gn=i1*n_b*n_c+i2*n_c+i3+1
                 if( ispin == 1 .or. ispin == 4 ) then
                    v_tot_temp(gn,ispin)                                           &
                         =v_hartree(gn)+vexc(ispin,i1,i2,i3)+v_ext(gn)
                 else
                    v_tot_temp(gn,ispin)=vexc(ispin,i1,i2,i3)
                 end if
              end do
           end do
        end do
     end do

     deallocate(vexc,rho1ls,rho2,stat=ier)
     if( ier /= 0 ) then
        write(6,*) 'error deallocate: cal_vother_accel'
        stop
     end if
  end if

  return
end subroutine cal_vother_accel

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

module gsp_parameter

  implicit none
  character(4), pointer :: atom_parameter(:,:)
  real(8), pointer :: r0(:),n(:),e_0(:),hs(:),hp(:),hd_t2g(:),hd_eg(:)
  real(8), pointer :: h_sss(:),h_sps(:),h_pps(:),h_ppp(:),h_sds(:)
  real(8), pointer :: h_pds(:),h_pdp(:),h_dds(:),h_ddp(:),h_ddd(:)
  real(8), pointer :: nc_sss(:),nc_sps(:),nc_pps(:),nc_ppp(:),nc_sds(:)
  real(8), pointer :: nc_pds(:),nc_pdp(:),nc_dds(:),nc_ddp(:),nc_ddd(:)
  real(8), pointer :: rc_sss(:),rc_sps(:),rc_pps(:),rc_ppp(:),rc_sds(:)
  real(8), pointer :: rc_pds(:),rc_pdp(:),rc_dds(:),rc_ddp(:),rc_ddd(:)
  real(8), pointer :: m(:),mc(:),dc(:),c1(:),c2(:),c3(:),c4(:)
  real(8), pointer :: phi0(:),d0(:),r1(:),tsc0(:),tsc1(:),tsc2(:),tsc3(:)
  real(8), pointer :: d1(:),tpc0(:),tpc1(:),tpc2(:),tpc3(:),cutoff_r(:)

contains
  subroutine alo_gsp_parameter(num_atom_kind)

    implicit none
    integer, intent(in) :: num_atom_kind
    integer :: i_temp,ier

    i_temp=num_atom_kind*num_atom_kind

    allocate(atom_parameter(i_temp,2),r0(i_temp),n(i_temp),e_0(i_temp)           &
         ,hs(i_temp),hp(i_temp),hd_t2g(i_temp),hd_eg(i_temp)                        &
         ,h_sss(i_temp),h_sps(i_temp),h_pps(i_temp),h_ppp(i_temp),h_sds(i_temp)     &
         ,h_pds(i_temp),h_pdp(i_temp),h_dds(i_temp),h_ddp(i_temp),h_ddd(i_temp)     &
         ,nc_sss(i_temp),nc_sps(i_temp),nc_pps(i_temp),nc_ppp(i_temp),nc_sds(i_temp)&
         ,nc_pds(i_temp),nc_pdp(i_temp),nc_dds(i_temp),nc_ddp(i_temp),nc_ddd(i_temp)&
         ,rc_sss(i_temp),rc_sps(i_temp),rc_pps(i_temp),rc_ppp(i_temp),rc_sds(i_temp)&
         ,rc_pds(i_temp),rc_pdp(i_temp),rc_dds(i_temp),rc_ddp(i_temp),rc_ddd(i_temp)&
         ,m(i_temp),mc(i_temp),dc(i_temp),c1(i_temp),c2(i_temp),c3(i_temp)          &
         ,c4(i_temp),phi0(i_temp),r1(i_temp),tsc0(i_temp),tsc1(i_temp),tsc2(i_temp) &
         ,tsc3(i_temp),d1(i_temp),tpc0(i_temp),tpc1(i_temp),tpc2(i_temp)            &
         ,tpc3(i_temp),d0(i_temp),cutoff_r(i_temp),stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_gsp_parameter'
       stop
    end if

    return
  end subroutine alo_gsp_parameter

  subroutine unset_gsp_parameter

    implicit none
    integer :: ier

    deallocate(atom_parameter,r0,n,e_0,hs,hp,hd_t2g,hd_eg                        &
         ,h_sss,h_sps,h_pps,h_ppp,h_sds,h_pds,h_pdp,h_dds,h_ddp,h_ddd           &
         ,nc_sss,nc_sps,nc_pps,nc_ppp,nc_sds,nc_pds,nc_pdp,nc_dds,nc_ddp,nc_ddd &
         ,rc_sss,rc_sps,rc_pps,rc_ppp,rc_sds,rc_pds,rc_pdp,rc_dds,rc_ddp,rc_ddd &
         ,m,mc,dc,c1,c2,c3,c4,phi0,r1,tsc0,tsc1,tsc2,tsc3,d1,tpc0,tpc1,tpc2,tpc3&
         ,d0,cutoff_r,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error deallocate: unset_gsp_parameter'
       stop
    end if

    return
  end subroutine unset_gsp_parameter

end module gsp_parameter

subroutine output_time
  use ac_mpi_module
  integer scount, ecount, rate, count_max

  write(*,'(a)') 'time (sec)'
  write(*,'(a,t10,2f20.5)') 'la', time_la, time_la-time_la0
  write(*,'(a,t10,2f20.5)') 'fft', time_fft, time_fft-time_fft0
  write(*,'(a,t10,2f20.5)') 'mpi', time_mpi, time_mpi-time_mpi0

  call system_clock(ecount, rate, count_max )
  if(ecount > time_scount) then
     time_total = real(ecount-time_scount)/rate
  else
     time_total = real(ecount+count_max-time_scount)/rate
  end if
  time_as = time_total - time_la - time_fft - time_mpi
  write(*,'(a,t10,2f20.5)') 'as', time_as, time_as-time_as0
  write(*,'(a,t10,2f20.5)') 'total', time_total, time_total-time_total0

  time_la0 = time_la
  time_fft0 = time_fft
  time_mpi0 = time_mpi
  time_as0 = time_as
  time_total0 = time_total

end subroutine output_time

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine onsite_gsp_hamiltonian(max_atom_orbital,i1_do,i2_do,h_ijmn,s_ijmn)

  use condition
  use gsp_parameter

  implicit none
  integer, intent(in) :: max_atom_orbital,i1_do,i2_do
  complex(8), intent(out) :: h_ijmn(max_atom_orbital,max_atom_orbital)
  complex(8), intent(out) :: s_ijmn(max_atom_orbital,max_atom_orbital)
  integer :: id

  id=pair_num(i1_do,i2_do)

  h_ijmn=dcmplx(0.d0,0.d0)
  s_ijmn=dcmplx(0.d0,0.d0)

  h_ijmn(1,1)=dcmplx(hs(id)+v_lr,0.d0)
  h_ijmn(2,2)=dcmplx(hp(id)+v_lr,0.d0)
  h_ijmn(3,3)=dcmplx(hp(id)+v_lr,0.d0)
  h_ijmn(4,4)=dcmplx(hp(id)+v_lr,0.d0)

  s_ijmn(1,1)=dcmplx(1.d0,0.d0)
  s_ijmn(2,2)=dcmplx(1.d0,0.d0)
  s_ijmn(3,3)=dcmplx(1.d0,0.d0)
  s_ijmn(4,4)=dcmplx(1.d0,0.d0)

  return
end subroutine onsite_gsp_hamiltonian

subroutine off_gsp_hamiltonian(iz,kx,ky,lx,ly,i1_do,i2_do,max_atom_orbital         &
     ,h_ijmn,s_ijmn)

  use condition
  use gsp_parameter

  implicit none
  integer, intent(in) :: max_atom_orbital,kx,ky,lx,ly,iz,i1_do,i2_do
  complex(8), intent(out) :: h_ijmn(max_atom_orbital,max_atom_orbital)
  complex(8), intent(out) :: s_ijmn(max_atom_orbital,max_atom_orbital)

  integer :: id,j_do,jr_do
  real(8) :: r_distance,rab_distance(3),r_temp_a(3),r_temp_b(3)

  id=pair_num(i1_do,i2_do)

  do jr_do=1,3
     r_temp_a(jr_do)=dfloat(kx)*unit_block(1,jr_do)                             &
          +dfloat(ky)*unit_block(2,jr_do)                             &
          +dfloat(iz)*unit_block(3,jr_do)+ra(i1_do,jr_do)
     r_temp_b(jr_do)=dfloat(lx)*unit_block(1,jr_do)                             &
          +dfloat(ly)*unit_block(2,jr_do)+ra(i2_do,jr_do)
  end do

  do jr_do=1,3
     rab_distance(jr_do)=r_temp_b(jr_do)-r_temp_a(jr_do)
  end do

  r_distance=0.d0
  do j_do=1,3
     r_distance=r_distance+rab_distance(j_do)**2
  end do
  r_distance=dsqrt(r_distance)

  rab_distance=rab_distance/r_distance

  call set_off_gsp(r_distance,rab_distance,id,max_atom_orbital,h_ijmn,s_ijmn)

  return
end subroutine off_gsp_hamiltonian

subroutine set_off_gsp(r_distance,rab_distance,id,max_atom_orbital,h_ijmn,s_ijmn)

  use condition
  use gsp_parameter

  implicit none
  integer, intent(in) :: max_atom_orbital
  integer, intent(in) :: id
  real(8), intent(in) :: r_distance,rab_distance(3)
  complex(8), intent(out) :: h_ijmn(max_atom_orbital,max_atom_orbital)
  complex(8), intent(out) :: s_ijmn(max_atom_orbital,max_atom_orbital)

  integer :: j_do

  real(8) :: hsss,hsps,hpps,hppp
  real(8) :: hsss_b,hsps_b,hpps_b,hppp_b
  real(8) :: h_r0(2)

  if( r_distance > cutoff_r(id) ) then
     h_ijmn=dcmplx(0.d0,0.d0)
     s_ijmn=dcmplx(0.d0,0.d0)
     return
  end if

  h_ijmn=dcmplx(0.d0,0.d0)

  call h_ss_sigma_gsp(id,r_distance,hsss)
  call h_ss_sigma_gsp(id,r_distance,hsss_b)

  call h_sp_sigma_gsp(id,r_distance,hsps)
  call h_sp_sigma_gsp(id,r_distance,hsps_b)

  call h_pp_sigma_gsp(id,r_distance,hpps)
  call h_pp_sigma_gsp(id,r_distance,hpps_b)
  call h_pp_pi_gsp(id,r_distance,hppp)
  call h_pp_pi_gsp(id,r_distance,hppp_b)

  h_ijmn(1,1)=hsss

  do j_do=1,3
     h_ijmn(1,j_do+1)=hsps*rab_distance(j_do)
     h_ijmn(j_do+1,1)=-1.d0*hsps_b*rab_distance(j_do)
  end do

  do j_do= 1 , 3
     h_r0(1)=hpps*rab_distance(j_do)**2
     h_r0(2)=hppp*(1.d0-rab_distance(j_do)**2)
     h_ijmn(j_do+1,j_do+1)=h_r0(1)+h_r0(2) 
  end do

  do j_do = 2 , 3
     h_r0(1)=hpps*rab_distance(1)*rab_distance(j_do)
     h_r0(2)=hppp*rab_distance(1)*rab_distance(j_do)
     h_ijmn(2,j_do+1)=h_r0(1)-h_r0(2) 

     h_r0(1)=hpps_b*rab_distance(1)*rab_distance(j_do)
     h_r0(2)=hppp_b*rab_distance(1)*rab_distance(j_do)
     h_ijmn(j_do+1,2)=h_r0(1)-h_r0(2) 
  end do

  h_r0(1)=hpps*rab_distance(2)*rab_distance(3)
  h_r0(2)=hppp*rab_distance(2)*rab_distance(3)
  h_ijmn(3,4)=h_r0(1)-h_r0(2) 

  h_r0(1)=hpps_b*rab_distance(2)*rab_distance(3)
  h_r0(2)=hppp_b*rab_distance(2)*rab_distance(3)
  h_ijmn(4,3)=h_r0(1)-h_r0(2) 


  s_ijmn=dcmplx(0.d0,0.d0)

  return
end subroutine set_off_gsp

subroutine h_ss_sigma_gsp(id,r,hsss)

  use gsp_parameter

  implicit none
  integer, intent(in) :: id
  real(8), intent(in) :: r
  real(8), intent(out) :: hsss
  real(8) :: rc,nc,gr

  if( r <= r1(id) ) then
     nc=nc_sss(id)
     rc=rc_sss(id)
     gr=(r0(id)/r)**n(id)*dexp(n(id)*(-1.d0*(r/rc)**nc+(r0(id)/rc)**nc))
  else
     rc=r1(id)
     gr=tsc0(id)+tsc1(id)*(r-rc)+tsc2(id)*(r-rc)**2+tsc3(id)*(r-rc)**3
  end if

  hsss=h_sss(id)*gr

  return
end subroutine h_ss_sigma_gsp

subroutine h_sp_sigma_gsp(id,r,hsps)

  use gsp_parameter

  implicit none
  integer, intent(in) :: id
  real(8), intent(in) :: r
  real(8), intent(out) :: hsps
  real(8) :: rc,nc,gr

  if( r <= r1(id) ) then
     nc=nc_sps(id)
     rc=rc_sps(id)
     gr=(r0(id)/r)**n(id)*dexp(n(id)*(-1.d0*(r/rc)**nc+(r0(id)/rc)**nc))
  else
     rc=r1(id)
     gr=tsc0(id)+tsc1(id)*(r-rc)+tsc2(id)*(r-rc)**2+tsc3(id)*(r-rc)**3
  end if

  hsps=h_sps(id)*gr

  return
end subroutine h_sp_sigma_gsp

subroutine h_pp_sigma_gsp(id,r,hpps)

  use gsp_parameter

  implicit none
  integer, intent(in) :: id
  real(8), intent(in) :: r
  real(8), intent(out) :: hpps
  real(8) :: rc,nc,gr

  if( r <= r1(id) ) then
     nc=nc_pps(id)
     rc=rc_pps(id)
     gr=(r0(id)/r)**n(id)*dexp(n(id)*(-1.d0*(r/rc)**nc+(r0(id)/rc)**nc))
  else
     rc=r1(id)
     gr=tsc0(id)+tsc1(id)*(r-rc)+tsc2(id)*(r-rc)**2+tsc3(id)*(r-rc)**3
  end if

  hpps=h_pps(id)*gr

  return
end subroutine h_pp_sigma_gsp

subroutine h_pp_pi_gsp(id,r,hppp)

  use gsp_parameter

  implicit none
  integer, intent(in) :: id
  real(8), intent(in) :: r
  real(8), intent(out) :: hppp
  real(8) :: rc,nc,gr

  if( r <= r1(id) ) then
     nc=nc_ppp(id)
     rc=rc_ppp(id)
     gr=(r0(id)/r)**n(id)*dexp(n(id)*(-1.d0*(r/rc)**nc+(r0(id)/rc)**nc))
  else
     rc=r1(id)
     gr=tsc0(id)+tsc1(id)*(r-rc)+tsc2(id)*(r-rc)**2+tsc3(id)*(r-rc)**3
  end if

  hppp=h_ppp(id)*gr

  return
end subroutine h_pp_pi_gsp

subroutine h_sd_sigma_gsp(id,r,hsds)

  use gsp_parameter

  implicit none
  integer, intent(in) :: id
  real(8), intent(in) :: r
  real(8), intent(out) :: hsds
  real(8) :: rc,nc,gr

  if( r <= r1(id) ) then
     nc=nc_sds(id)
     rc=rc_sds(id)
     gr=(r0(id)/r)**n(id)*dexp(n(id)*(-1.d0*(r/rc)**nc+(r0(id)/rc)**nc))
  else
     rc=r1(id)
     gr=tsc0(id)+tsc1(id)*(r-rc)+tsc2(id)*(r-rc)**2+tsc3(id)*(r-rc)**3
  end if

  hsds=h_sds(id)*gr

  return
end subroutine h_sd_sigma_gsp

subroutine h_pd_sigma_gsp(id,r,hpds)

  use gsp_parameter

  implicit none
  integer, intent(in) :: id
  real(8), intent(in) :: r
  real(8), intent(out) :: hpds
  real(8) :: rc,nc,gr

  if( r <= r1(id) ) then
     nc=nc_pds(id)
     rc=rc_pds(id)
     gr=(r0(id)/r)**n(id)*dexp(n(id)*(-1.d0*(r/rc)**nc+(r0(id)/rc)**nc))
  else
     rc=r1(id)
     gr=tsc0(id)+tsc1(id)*(r-rc)+tsc2(id)*(r-rc)**2+tsc3(id)*(r-rc)**3
  end if

  hpds=h_pds(id)*gr

  return
end subroutine h_pd_sigma_gsp

subroutine h_pd_pi_gsp(id,r,hpdp)

  use gsp_parameter

  implicit none
  integer, intent(in) :: id
  real(8), intent(in) :: r
  real(8), intent(out) :: hpdp
  real(8) :: rc,nc,gr

  if( r <= r1(id) ) then
     nc=nc_pdp(id)
     rc=rc_pdp(id)
     gr=(r0(id)/r)**n(id)*dexp(n(id)*(-1.d0*(r/rc)**nc+(r0(id)/rc)**nc))
  else
     rc=r1(id)
     gr=tsc0(id)+tsc1(id)*(r-rc)+tsc2(id)*(r-rc)**2+tsc3(id)*(r-rc)**3
  end if

  hpdp=h_pdp(id)*gr

  return
end subroutine h_pd_pi_gsp

subroutine h_dd_sigma_gsp(id,r,hdds)

  use gsp_parameter

  implicit none
  integer, intent(in) :: id
  real(8), intent(in) :: r
  real(8), intent(out) :: hdds
  real(8) :: rc,nc,gr

  if( r <= r1(id) ) then
     nc=nc_dds(id)
     rc=rc_dds(id)
     gr=(r0(id)/r)**n(id)*dexp(n(id)*(-1.d0*(r/rc)**nc+(r0(id)/rc)**nc))
  else
     rc=r1(id)
     gr=tsc0(id)+tsc1(id)*(r-rc)+tsc2(id)*(r-rc)**2+tsc3(id)*(r-rc)**3
  end if

  hdds=h_dds(id)*gr

  return
end subroutine h_dd_sigma_gsp

subroutine h_dd_pi_gsp(id,r,hddp)

  use gsp_parameter

  implicit none
  integer, intent(in) :: id
  real(8), intent(in) :: r
  real(8), intent(out) :: hddp
  real(8) :: rc,nc,gr

  if( r <= r1(id) ) then
     nc=nc_ddp(id)
     rc=rc_ddp(id)
     gr=(r0(id)/r)**n(id)*dexp(n(id)*(-1.d0*(r/rc)**nc+(r0(id)/rc)**nc))
  else
     rc=r1(id)
     gr=tsc0(id)+tsc1(id)*(r-rc)+tsc2(id)*(r-rc)**2+tsc3(id)*(r-rc)**3
  end if

  hddp=h_ddp(id)*gr

  return
end subroutine h_dd_pi_gsp

subroutine h_dd_delta_gsp(id,r,hddd)

  use gsp_parameter

  implicit none
  integer, intent(in) :: id
  real(8), intent(in) :: r
  real(8), intent(out) :: hddd
  real(8) :: rc,nc,gr

  if( r <= r1(id) ) then
     nc=nc_ddd(id)
     rc=rc_ddd(id)
     gr=(r0(id)/r)**n(id)*dexp(n(id)*(-1.d0*(r/rc)**nc+(r0(id)/rc)**nc))
  else
     rc=r1(id)
     gr=tsc0(id)+tsc1(id)*(r-rc)+tsc2(id)*(r-rc)**2+tsc3(id)*(r-rc)**3
  end if

  hddd=h_ddd(id)*gr

  return
end subroutine h_dd_delta_gsp

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Naoki WATANABE, Nobutaka NISHIKAWA (Mizuho I.R.)   @@ !
! @@             Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

module ac_mpi_module
  use ac_misc_module
  implicit none
  include "mpif.h"

  type MPI_type
     integer :: size  
     integer :: rank  
     integer :: sizeE, sizeM 
     integer :: rankE, rankM 
     integer :: info  
     logical :: root  

     integer :: npao   
     integer :: isatom 
     integer :: ieatom 

     integer,pointer :: ispao(:) 
     integer,pointer :: iepao(:) 
     integer,pointer :: vnpao(:) 

     integer,pointer :: vsmat(:) 
     integer,pointer :: vemat(:) 
     integer,pointer :: vnmat(:) 

     integer         ::  smat    
     integer         ::  emat    
     integer         ::  nmat    

     integer,pointer :: vmatcount(:) 
     integer,pointer :: vmatdispl(:) 

     integer :: SL_ID         
     integer :: SL_DESC(9)    
     integer :: SL_DESCLS(9)  

     integer :: localsize1
     integer :: localsize2

     integer :: group  
     integer :: groupM 
     integer :: groupE 
     integer :: commM  
     integer :: commE  

     real(8) :: num_sc_work2space = -1000.d0
     integer :: num_check_sc = 1


  end type MPI_type

  type(MPI_type), public, save :: MPI 

  type MPI_MatDesc
     integer :: nrow 
     integer :: ncol 

     integer :: srow 
     integer :: erow 
     integer :: scol 
     integer :: ecol 
     integer, allocatable :: vsele(:)
     integer, allocatable :: vnele(:)

     integer :: SL_DESC(9) 
  end type MPI_MatDesc

contains
  subroutine DescInit( DESC, M, N, MB, NB, IRSRC, ICSRC, ICTXT, LLD, INFO )
    implicit none

    integer, intent(out) :: DESC(9)
    integer, intent(in)  :: M, N, MB, NB, IRSRC, ICSRC, ICTXT, LLD, INFO

    DESC(:) = 0

    return
  end subroutine DescInit


  subroutine MPI__setupMatDesc( desc, nrow, ncol )
    implicit none

    type(MPI_MatDesc), intent(out) :: desc
    integer, intent(in) :: nrow, ncol

    integer :: nrow_local, ncol_local, p

    desc%nrow = nrow
    desc%ncol = ncol



    nrow_local = nrow
    ncol_local = int(ceiling(dble(ncol) / dble(MPI%sizeM)))


    call DescInit( desc%SL_DESC, nrow, ncol, ncol_local, ncol_local, &
         0, 0, MPI%SL_ID, nrow, MPI%info )

    desc%srow = 1
    desc%erow = nrow

    desc%scol = 1+(MPI%rankM+0)*ncol_local
    desc%ecol = 0+(MPI%rankM+1)*ncol_local

    if( desc%scol <= ncol .and. desc%ecol > ncol ) then
       desc%ecol = ncol
    else if( desc%scol > ncol .and. desc%ecol > ncol ) then
       desc%scol = ncol
       desc%ecol = ncol
    end if


    allocate( desc%vsele(0:MPI%sizeM-1) )
    allocate( desc%vnele(0:MPI%sizeM-1) )

    do p=0, MPI%sizeM-1
       desc%vsele(p) = nrow * ncol_local * p
       desc%vnele(p) = nrow * ncol_local

       if( desc%vsele(p) > nrow*ncol-1 ) then
          desc%vsele(p) = nrow*ncol-1
       else if( desc%vsele(p) + desc%vnele(p) > nrow*ncol-1 ) then
          desc%vnele(p) = nrow*ncol-1 - desc%vsele(p) + 1
       end if
    end do


    return
  end subroutine MPI__setupMatDesc

  subroutine MPI__unsetMatDesc( desc )
    implicit none
    type(MPI_MatDesc), intent(out) :: desc

    if( allocated(desc%vsele) ) deallocate( desc%vsele )
    if( allocated(desc%vnele) ) deallocate( desc%vnele )

    desc%SL_DESC(:) = 0

    return
  end subroutine MPI__unsetMatDesc

  subroutine MPI__Initialize
    implicit none

    call MPI_Init( MPI%info )
    call MPI_Comm_rank( MPI_COMM_WORLD, MPI%rank, MPI%info )
    call MPI_Comm_size( MPI_COMM_WORLD, MPI%size, MPI%info )
    call MPI_Comm_group( MPI_COMM_WORLD, MPI%group, MPI%info )

    if( MPI%rank == 0 ) then
       MPI%root = .true.
    else
       MPI%root = .false.
    end if

    return
  end subroutine MPI__Initialize

  subroutine MPI__Finalize
    implicit none

    call MPI_Finalize ( MPI%info )

    if( associated(MPI%vnmat) ) then
       deallocate( MPI%vnmat, MPI%vsmat, MPI%vemat )
    end if

    if( associated(MPI%ispao) ) then
       deallocate(MPI%ispao,MPI%iepao,MPI%vnpao)
    end if

    return
  end subroutine MPI__Finalize

  subroutine MPI__setup( sizeE, sizeM )
    implicit none
    integer, intent(in) :: sizeE, sizeM 
    integer :: p, a, i, n
    integer, allocatable :: rankM(:), rankE(:)

    if( Param%Data%npao < MPI%sizeM ) then
       write(*,'(a)') "# warning! : too many processors for MPI"
    end if

    MPI%sizeE = sizeE
    MPI%sizeM = sizeM

    if( associated(MPI%vmatcount) ) then
       deallocate( MPI%vmatcount, MPI%vmatdispl )
    end if
    allocate( MPI%vmatcount(0:MPI%sizeM-1), MPI%vmatdispl(0:MPI%sizeM-1) )

    if( associated(MPI%vnmat) ) then
       deallocate( MPI%vnmat, MPI%vsmat, MPI%vemat )
    end if
    allocate( MPI%vnmat(0:MPI%sizeM-1), MPI%vsmat(0:MPI%sizeM-1), MPI%vemat(0:MPI%sizeM-1) )

    if( associated(MPI%vnpao) ) then
       deallocate(MPI%vnpao, MPI%ispao, MPI%iepao)
    end if
    allocate( MPI%vnpao(0:MPI%sizeM-1), MPI%ispao(Param%Data%natom), MPI%iepao(Param%Data%natom) )

    if( MPI%size /= MPI%sizeE * MPI%sizeM ) then
       write(*,*) "# Error : MPI%size mismatch ", &
            MPI%size, MPI%sizeE, MPI%sizeM
       stop
    end if

    MPI%rankE = int(MPI%rank/MPI%sizeM)
    MPI%rankM = mod(MPI%rank,MPI%sizeM)

    allocate( rankM(0:MPI%sizeM-1), rankE(0:MPI%sizeE-1) )

    do p=0, MPI%sizeM-1
       rankM(p) = p + MPI%rankE*MPI%sizeM
    end do
    do p=0, MPI%sizeE-1
       rankE(p) = p*MPI%sizeM + MPI%rankM
    end do

    call MPI_Group_incl( MPI%group, MPI%sizeM, rankM, MPI%groupM, MPI%info )
    call MPI_Comm_create( MPI_COMM_WORLD, MPI%groupM, MPI%commM, MPI%info )

    call MPI_Group_incl( MPI%group, MPI%sizeE, rankE, MPI%groupE, MPI%info )
    call MPI_Comm_create( MPI_COMM_WORLD, MPI%groupE, MPI%commE, MPI%info )

    deallocate(rankM,rankE)

    MPI%localsize1 = int(ceiling(dble(Param%Data%npao) / dble(MPI%sizeM)))
    MPI%localsize2 = 2*int(ceiling(dble(Param%Data%npao) / dble(MPI%sizeM)))

    if( MPI%localsize1*(MPI%sizeM-1) >= Param%Data%npao ) then
       open(unit=16,file=Param%Option%file_ac_tempout,position='append')
       write(16,999)  MPI%sizeM
999    format("      ++++++ Sorry : This program can not be parallelized by processors of ",i5)
       close(16)
       call MPI__Finalize
       stop
    end if

    call DescInit( MPI%SL_DESC, Param%Data%npao, Param%Data%npao, &
         MPI%localsize1, MPI%localsize1, 0, 0, MPI%SL_ID, Param%Data%npao, MPI%info )
    call DescInit( MPI%SL_DESCLS, 2*Param%Data%npao, 2*Param%Data%npao, &
         MPI%localsize2, MPI%localsize2, 0, 0, MPI%SL_ID, 2*Param%Data%npao, MPI%info )

    n=0
    do p=0, MPI%sizeM-1
       if( n + MPI%localsize1 > Param%Data%npao ) then
          MPI%vnpao(p) = Param%Data%npao - n
       else
          MPI%vnpao(p) = MPI%localsize1
       end if
       n = n + MPI%vnpao(p)
    end do
    MPI%npao = MPI%vnpao(MPI%rankM)

    i=0
    do p=0, MPI%sizeM-1
       MPI%vsmat(p) = i+1
       MPI%vemat(p) = MPI%vsmat(p) + MPI%vnpao(p) - 1
       MPI%vnmat(p) = MPI%vnpao(p)
       i = i + MPI%vnpao(p)
    end do
    MPI%smat = MPI%vsmat(MPI%rankM)
    MPI%emat = MPI%vemat(MPI%rankM)
    MPI%nmat = MPI%vnmat(MPI%rankM)

    do p=0, MPI%sizeM-1
       MPI%vmatcount(p) = MPI%vnmat(p) * MPI%nmat
       MPI%vmatdispl(p) = MPI%vsmat(p) * MPI%nmat - MPI%vsmat(0) * MPI%nmat
    end do

    do a=1, Param%Data%natom
       MPI%ispao(a) = 0+1
       MPI%iepao(a) = Param%Data%vnpao(a)-1+1
    end do

    n=0
    do a=1, Param%Data%natom
       n=n+Param%Data%vnpao(a)
       if( MPI%vsmat(MPI%rankM)-1 < n ) then
          MPI%isatom = a
          MPI%ispao(a) = (MPI%vsmat(MPI%rankM)-1) - (Param%Data%vipao(a)-1) + 1
          exit
       end if
    end do

    n=0
    do a=1, Param%Data%natom
       n=n+Param%Data%vnpao(a)
       if( MPI%vemat(MPI%rankM)-1 < n ) then
          MPI%ieatom = a
          MPI%iepao(a) = (MPI%vemat(MPI%rankM)-1) - (Param%Data%vipao(a)-1) + 1
          exit
       end if
    end do

    if( MPI%num_sc_work2space >= -1.d0 ) then
       if( Param%Option%spin_orbit ) then
          p=(2*Base%npao/sqrt(dfloat(1*MPI%sizeM))-1.d0)*2*Base%npao
       else
          p=(Base%npao/sqrt(dfloat(1*MPI%sizeM))-1.d0)*Base%npao
       end if
       if( MPI%num_sc_work2space > 0.d0 ) then
          if( MPI%num_sc_work2space > dfloat(p) ) then
             MPI%num_sc_work2space = dfloat(p)
          end if
       else
          MPI%num_sc_work2space = -dfloat(p) * MPI%num_sc_work2space
          if( MPI%num_sc_work2space > dfloat(p) ) then
             MPI%num_sc_work2space = dfloat(p)
          end if
       end if
    else
       MPI%num_sc_work2space=0.d0
    end if


    return
  end subroutine MPI__setup


  subroutine MPI__Bcast_Inputfile( filename )
    implicit none
    character(64), intent(inout) :: filename

    if( MPI%size == 1 ) return

    call MPI_Bcast( filename, 64, MPI_CHARACTER, 0, MPI_COMM_WORLD, MPI%info )

    return
  end subroutine MPI__Bcast_Inputfile

  subroutine MPI__Allreduce_DensityLS( densityLS )
    implicit none
    complex(8), intent(inout) :: densityLS(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)
    complex(8), allocatable :: densityLS_mpi(:,:,:,:) 

    if( MPI%sizeM == 1 ) return

    allocate(densityLS_mpi(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc))
    densityLS_mpi = densityLS

    call MPI_Allreduce( &
         densityLS_mpi, densityLS, &
         Param%Option%nspin * Param%Cell%Na * Param%Cell%Nb * Param%Cell%Nc, &
         MPI_DOUBLE_COMPLEX, &
         MPI_SUM, &
         MPI_COMM_WORLD, MPI%info )

    deallocate( densityLS_mpi )

    return
  end subroutine MPI__Allreduce_DensityLS

  subroutine MPI__Allreduce_Density( density )
    implicit none
    real(8), intent(inout) :: density (Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)
    real(8), allocatable :: density_mpi(:,:,:,:) 

    if( MPI%sizeM == 1 ) return

    allocate(density_mpi(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc))
    density_mpi = density

    call MPI_Allreduce( &
         density_mpi, density, &
         Param%Option%nspin * Param%Cell%Na * Param%Cell%Nb * Param%Cell%Nc, &
         MPI_DOUBLE_PRECISION, &
         MPI_SUM, &
         MPI_COMM_WORLD, MPI%info )

    deallocate( density_mpi )

    return
  end subroutine MPI__Allreduce_Density

  subroutine MPI__AlltoAll_Matrix( matrix )
    implicit none
    complex(8), intent(inout) :: matrix(Param%Data%npao,MPI%smat:MPI%emat)
    complex(8), allocatable :: pack_send(:)
    complex(8), allocatable :: pack_recv(:)
    integer :: i, j, p, index

    if( MPI%sizeM == 1 ) then
       do i=1, Param%Data%npao
          do j=i, Param%Data%npao
             matrix(i,j) = dconjg(matrix(i,j)) + matrix(j,i)
             matrix(j,i) = dconjg(matrix(i,j))
          end do
       end do

       return
    end if

    allocate(pack_send(MPI%nmat*Param%Data%npao))
    allocate(pack_recv(MPI%nmat*Param%Data%npao))

    index=0
    do p=0, MPI%sizeM-1
       do i=MPI%smat, MPI%emat
          do j=MPI%vsmat(p), MPI%vemat(p)
             index=index+1
             pack_send(index) = matrix(j,i)
          end do
       end do
    end do

    call MPI_AlltoAllv( &
         pack_send, MPI%vmatcount, MPI%vmatdispl, MPI_DOUBLE_COMPLEX, &
         pack_recv, MPI%vmatcount, MPI%vmatdispl, MPI_DOUBLE_COMPLEX, &
         MPI_COMM_WORLD, MPI%info )

    index=0
    do p=0, MPI%sizeM-1
       do j=MPI%vsmat(p), MPI%vemat(p)
          do i=MPI%smat, MPI%emat
             index=index+1
             matrix(j,i) = dconjg(matrix(j,i)) + pack_recv(index)
          end do
       end do
    end do

    deallocate( pack_send, pack_recv )

    return
  end subroutine MPI__AlltoAll_Matrix

  subroutine MPI__AlltoAll_Matrix2( matrix2, matrix3 )
    implicit none
    complex(8), intent(inout) :: matrix2(Param%Data%npao,MPI%smat:MPI%emat)
    complex(8), intent(inout) :: matrix3(Param%Data%npao,MPI%smat:MPI%emat)
    complex(8), allocatable :: pack_send(:)
    complex(8), allocatable :: pack_recv(:)
    integer :: i, j, p, index

    if( MPI%sizeM == 1 ) then
       do i=1, Param%Data%npao
          do j=1, Param%Data%npao
             matrix2(i,j) = dconjg(matrix2(i,j)) + matrix3(j,i)
             matrix3(j,i) = dconjg(matrix2(i,j))
          end do
       end do

       return
    end if

    allocate(pack_send(MPI%nmat*Param%Data%npao))
    allocate(pack_recv(MPI%nmat*Param%Data%npao))

    index=0
    do p=0, MPI%sizeM-1
       do i=MPI%smat, MPI%emat
          do j=MPI%vsmat(p), MPI%vemat(p)
             index=index+1
             pack_send(index) = matrix3(j,i)
          end do
       end do
    end do

    call MPI_AlltoAllv( &
         pack_send, MPI%vmatcount, MPI%vmatdispl, MPI_DOUBLE_COMPLEX, &
         pack_recv, MPI%vmatcount, MPI%vmatdispl, MPI_DOUBLE_COMPLEX, &
         MPI_COMM_WORLD, MPI%info )

    index=0
    do p=0, MPI%sizeM-1
       do i=MPI%smat, MPI%emat
          do j=MPI%vsmat(p), MPI%vemat(p)
             index=index+1
             pack_send(index) = matrix2(j,i)
          end do
       end do
    end do

    index=0
    do p=0, MPI%sizeM-1
       do j=MPI%vsmat(p), MPI%vemat(p)
          do i=MPI%smat, MPI%emat
             index=index+1
             matrix2(j,i) = dconjg(matrix2(j,i)) + pack_recv(index)
          end do
       end do
    end do

    call MPI_AlltoAllv( &
         pack_send, MPI%vmatcount, MPI%vmatdispl, MPI_DOUBLE_COMPLEX, &
         pack_recv, MPI%vmatcount, MPI%vmatdispl, MPI_DOUBLE_COMPLEX, &
         MPI_COMM_WORLD, MPI%info )


    index=0
    do p=0, MPI%sizeM-1
       do j=MPI%vsmat(p), MPI%vemat(p)
          do i=MPI%smat, MPI%emat
             index=index+1
             matrix3(j,i) = dconjg(matrix3(j,i)) + pack_recv(index)
          end do
       end do
    end do

    deallocate( pack_send, pack_recv )

    return
  end subroutine MPI__AlltoAll_Matrix2

  subroutine MPI__Allreduce_Force( vatom )
    implicit none
    type(Atom_type), intent(inout) :: vatom(Param%Data%natom)
    real(8), allocatable :: force_mpi(:,:), force_sum(:,:)
    integer :: a

    if( MPI%size == 1 ) return

    allocate( force_mpi(3,Param%Data%natom), force_sum(3,Param%Data%natom) )
    do a=1, Param%Data%natom
       force_mpi(:,a) = vatom(a)%force(:)
    end do

    call MPI_Allreduce( &
         force_mpi, force_sum, 3*Param%Data%natom, MPI_DOUBLE_PRECISION, &
         MPI_SUM, MPI_COMM_WORLD, MPI%info )

    do a=1, Param%Data%natom
       vatom(a)%force(:) = force_sum(:,a)
    end do

    deallocate( force_mpi, force_sum )

    return
  end subroutine MPI__Allreduce_Force


  subroutine MPI__Allreduce_HistoryPulay( A )
    implicit none
    real(8), intent(inout) :: A(Param%SCF%mix_history,Param%SCF%mix_history)
    real(8), allocatable :: A_mpi(:,:) 

    if( MPI%sizeM == 1 ) return

    allocate( A_mpi(Param%SCF%mix_history,Param%SCF%mix_history) )
    A_mpi = A

    call MPI_Allreduce( &
         A_mpi, A, Param%SCF%mix_history * Param%SCF%mix_history, &
         MPI_DOUBLE_PRECISION, MPI_SUM, MPI_COMM_WORLD, MPI%info )

    deallocate( A_mpi )

    return
  end subroutine MPI__Allreduce_HistoryPulay

  subroutine MPI__Allreduce_HistoryAnderson( A )
    implicit none
    real(8), intent(inout) :: A(2:3,3)
    real(8) :: A_mpi(2:3,3) 

    if( MPI%sizeM == 1 ) return

    A_mpi = A

    call MPI_Allreduce( &
         A_mpi, A, 2*3, &
         MPI_DOUBLE_PRECISION, MPI_SUM, MPI_COMM_WORLD, MPI%info )

    return
  end subroutine MPI__Allreduce_HistoryAnderson

  subroutine MPI__Allreduce_Error( dEden )
    implicit none
    real(8), intent(inout) :: dEden
    real(8) :: dEden_mpi

    if( MPI%sizeM == 1 ) return

    dEden_mpi = dEden

    call MPI_Allreduce( &
         dEden_mpi, dEden, 1, &
         MPI_DOUBLE_PRECISION, MPI_SUM, MPI_COMM_WORLD, MPI%info )

    return
  end subroutine MPI__Allreduce_Error

  subroutine MPI__Barrier
    implicit none

    if( MPI%sizeM == 1 ) return
    call MPI_Barrier(MPI_COMM_WORLD, MPI%info)

    return
  end subroutine MPI__Barrier

  subroutine MPI__ZHEGV( size, matrixH, matrixS, vectorE, iter )
    implicit none

    integer, intent(in)       :: size 
    complex(8), intent(inout) :: matrixH(size,size) 
    complex(8), intent(in)    :: matrixS(size,size) 
    real(8),    intent(out)   :: vectorE(size) 

    complex(8), allocatable   :: localS(:,:)
    complex(8), allocatable   :: work1(:)
    real(8),    allocatable   :: work2(:)

    integer, intent(in) :: iter

    allocate( work1(4*size), work2(7*size) )
    allocate( localS(size,size) )
    localS = matrixS 

    call ZHEGV( 1, 'V', 'L', size, matrixH, size, localS, size, &
         vectorE, work1, 4*size, work2, MPI%info )

    deallocate( localS )
    deallocate( work1, work2 )

    return
  end subroutine MPI__ZHEGV

  subroutine MPI__ZHEGVLS( size, matrixH, matrixS, vectorE, iter )
    implicit none

    integer, intent(in)       :: size 
    complex(8), intent(inout) :: matrixH(2*size,2*size) 
    complex(8), intent(in)    :: matrixS(2*size,2*size) 
    real(8),    intent(out)   :: vectorE(2*size) 

    integer, intent(in) :: iter

    complex(8), allocatable :: localS(:,:)
    complex(8), allocatable :: work1(:)
    real(8),    allocatable :: work2(:)

    allocate( work1(4*2*size), work2(7*2*size) )
    allocate( localS(2*size,2*size) )
    localS = matrixS 

    call ZHEGV( 1, 'V', 'L', 2*size, matrixH, 2*size, localS, 2*size, &
         vectorE, work1, 4*2*size, work2, MPI%info )

    deallocate( localS )
    deallocate( work1, work2 )

    return
  end subroutine MPI__ZHEGVLS

  subroutine MPI__ZGEMM( transa, transb, size, &
       alpha, matrixA, matrixB, beta, matrixC )
    implicit none

    character, intent(in)     :: transa, transb
    integer, intent(in)       :: size 
    complex(8), intent(in)    :: matrixA(size,size) 
    complex(8), intent(in)    :: matrixB(size,size) 
    complex(8), intent(out)   :: matrixC(size,size) 
    complex(8), intent(in)    :: alpha, beta 

    call ZGEMM( transa, transb, size, size, size, &
         alpha, matrixA, size, matrixB, size, &
         beta,  matrixC, size )

    return
  end subroutine MPI__ZGEMM



  subroutine MPI__ZGEMM_ASCOT( transa, transb, desc, &
       alpha, matrixA, matrixB, beta, matrixC )
    implicit none

    character, intent(in)     :: transa, transb
    type(MPI_MatDesc), intent(in) :: desc
    complex(8), intent(inout) :: matrixA(desc%nrow,desc%scol:desc%ecol)
    complex(8), intent(inout) :: matrixB(desc%nrow,desc%scol:desc%ecol)
    complex(8), intent(inout) :: matrixC(desc%nrow,desc%scol:desc%ecol)
    complex(8), intent(in)    :: alpha, beta

    call ZGEMM( transa, transb, desc%nrow, desc%ncol, desc%ncol, &
         alpha, matrixA, desc%nrow, matrixB, desc%nrow, &
         beta,  matrixC, desc%nrow )

    return
  end subroutine MPI__ZGEMM_ASCOT

  subroutine MPI__ZGEMM2_ASCOT( transa, transb, descA, descB, descC, &
       alpha, matrixA, matrixB, beta, matrixC )
    implicit none

    character, intent(in)     :: transa, transb
    type(MPI_MatDesc), intent(in) :: descA, descB, descC
    complex(8), intent(inout) :: matrixA(descA%nrow,descA%scol:descA%ecol)
    complex(8), intent(inout) :: matrixB(descB%nrow,descB%scol:descB%ecol)
    complex(8), intent(inout) :: matrixC(descC%nrow,descC%scol:descC%ecol)
    complex(8), intent(in)    :: alpha, beta

    call ZGEMM( transa, transb, descA%nrow, descB%ncol, descA%ncol, &
         alpha, matrixA, descA%nrow, matrixB, descB%nrow, &
         beta,  matrixC, descC%nrow )

    return
  end subroutine MPI__ZGEMM2_ASCOT

  subroutine MPI__ZTRANC_ASCOT( desc, alpha, matrixA, beta, matrixB )
    implicit none

    type(MPI_MatDesc), intent(in) :: desc
    complex(8), intent(inout) :: matrixA(desc%nrow,desc%scol:desc%ecol)
    complex(8), intent(in)    :: matrixB(desc%nrow,desc%scol:desc%ecol)
    complex(8), intent(in)    :: beta, alpha
    integer :: i, j

    do j=desc%scol, desc%ecol
       do i=1, desc%nrow
          matrixA(i,j) = alpha*matrixA(i,j) + beta*dconjg(matrixB(j,i))
       end do
    end do

    return
  end subroutine MPI__ZTRANC_ASCOT

  subroutine MPI__ZLATRA_ASCOT( desc, matrixA, trace )
    implicit none

    type(MPI_MatDesc), intent(in) :: desc
    complex(8), intent(in)    :: matrixA(desc%nrow,desc%scol:desc%ecol)
    complex(8), intent(out)   :: trace
    integer :: i
    complex(8) :: trace_mpi

    trace_mpi = 0.0d0
    do i=desc%scol, desc%ecol
       trace_mpi = trace_mpi + matrixA(i,i)
    end do

    call MPI_Allreduce( trace_mpi, trace, 1, &
         MPI_DOUBLE_COMPLEX, MPI_SUM, MPI%commM, MPI%info )

    return
  end subroutine MPI__ZLATRA_ASCOT

  subroutine MPI__ZGETRI_ASCOT( desc, matrixA )
    implicit none

    type(MPI_MatDesc), intent(in) :: desc
    complex(8), intent(inout) :: matrixA(desc%nrow,desc%scol:desc%ecol)

    integer, allocatable :: ipiv(:)
    complex(8), allocatable :: work1(:)
    integer, allocatable :: work2(:)
    integer :: lwork1, lwork2
    complex(8), allocatable :: tempA(:,:)

    allocate( tempA(desc%nrow,desc%ncol) )
    tempA(:,desc%scol:desc%ecol ) = matrixA(:,desc%scol:desc%ecol )

    call MPI__Allgather_MatrixM_ASCOT( desc, tempA )

    allocate( ipiv(desc%nrow) )

    call ZGETRF( desc%nrow, desc%ncol, tempA, desc%nrow, &
         ipiv, MPI%info )

    allocate( work1(1), work2(1) )
    lwork1=-1; lwork2=-1

    call ZGETRI( desc%nrow, tempA, desc%nrow, &
         ipiv, work1, lwork1, work2, lwork2, MPI%info )

    lwork1 = int(work1(1))
    lwork2 = int(work2(1))
    lwork1 = (lwork1+100)*2 
    lwork2 = (lwork2+100)*2 
    deallocate( work1, work2 )

    allocate( work1(lwork1), work2(lwork2) )

    call ZGETRI( desc%nrow, tempA, desc%nrow, &
         ipiv, work1, lwork1, work2, lwork2, MPI%info )

    deallocate( ipiv )
    deallocate( work1, work2 )

    matrixA(:,desc%scol:desc%ecol ) = tempA(:,desc%scol:desc%ecol )

    return
  end subroutine MPI__ZGETRI_ASCOT

  subroutine MPI__Allgather_MatrixM_ASCOT( desc, matrixA )
    implicit none
    type(MPI_MatDesc), intent(in) :: desc
    complex(8), intent(inout) :: matrixA(desc%nrow,desc%ncol)
    integer :: i

    if( MPI%sizeM == 1 ) return

    call MPI_Allgatherv( &
         matrixA(desc%vsele(MPI%rankM)+1,1), desc%vnele(MPI%rankM), MPI_DOUBLE_COMPLEX, &
         matrixA, desc%vnele, desc%vsele, &
         MPI_DOUBLE_COMPLEX, MPI_COMM_WORLD, MPI%info )

    return
  end subroutine MPI__Allgather_MatrixM_ASCOT

  subroutine MPI__Allreduce_MatrixE_ASCOT( desc, matrixA )
    implicit none
    type(MPI_MatDesc), intent(in) :: desc
    complex(8), intent(inout) :: matrixA(desc%nrow,desc%scol:desc%ecol)
    complex(8), allocatable :: matrixA_mpi(:,:) 

    if( MPI%sizeE == 1 ) return

    allocate(matrixA_mpi(desc%nrow,desc%scol:desc%ecol))

    matrixA_mpi(:,:) = matrixA(:,:)

    call MPI_Allreduce( matrixA_mpi, matrixA, desc%nrow*(desc%ecol-desc%scol+1), &
         MPI_DOUBLE_COMPLEX, MPI_SUM, MPI%commE, MPI%info )

    deallocate(matrixA_mpi)

    return
  end subroutine MPI__Allreduce_MatrixE_ASCOT

  subroutine MPI__Allreduce_MatrixT_ASCOT( desc, matrixA )
    implicit none
    type(MPI_MatDesc), intent(in) :: desc
    complex(8), intent(inout) :: matrixA(desc%nrow,desc%ncol)
    complex(8), allocatable   :: matrixA_mpi(:,:) 

    if( MPI%size == 1 ) return

    allocate(matrixA_mpi(desc%nrow,desc%ncol))

    matrixA_mpi(:,:) = matrixA(:,:)

    call MPI_Allreduce( matrixA_mpi, matrixA, desc%nrow*desc%ncol, &
         MPI_DOUBLE_COMPLEX, MPI_SUM, MPI_COMM_WORLD, MPI%info )

    deallocate(matrixA_mpi)

    return
  end subroutine MPI__Allreduce_MatrixT_ASCOT


end module ac_mpi_module

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Naoki WATANABE, Nobutaka NISHIKAWA (Mizuho I.R.)   @@ !
! @@             Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine GaussLegendre__getPoints( N, x1, x2, vx_out, vw_out )
  use ac_misc_module

  implicit none
  integer, intent(in)        :: N
  real(8), intent(in)  :: x1, x2
  real(8), intent(out) :: vx_out(N), vw_out(N)

  integer       :: i, j
  real(8), parameter :: eps = 1.0e-12
  real(8) :: p1, p2, p3, pp
  real(8) :: z, dz

  do i=1, (N+1)/2
     z = cos(M_PI*(dble(i)-0.25d0)/(dble(N)+0.5d0))

     do 
        p1=1.d0
        p2=0.d00
        do j=1, N
           p3 = p2
           p2 = p1
           p1 = (dble(2*j-1)*z*p2-dble(j-1)*p3)/dble(j)
        end do
        pp = dble(N)*(z*p1-p2)/(z*z-1.d0)

        dz = p1/pp
        z = z - dz
        if( abs(dz) <= eps ) exit
     end do

     vx_out(i)     = 0.5d0*(x2+x1) - 0.5d0*(x2-x1)*z
     vx_out(N+1-i) = 0.5d0*(x2+x1) + 0.5d0*(x2-x1)*z
     vw_out(i)     = (x2-x1)/((1.0-z*z)*pp*pp)
     vw_out(N+1-i) = vw_out(i)
  end do

  return
end subroutine GaussLegendre__getPoints

subroutine GaussLegendre__getPointsMX( N, x1, x2, vx_out, vw_out )
  use ac_misc_module

  implicit none
  integer, intent(in)        :: N
  real(8), intent(in)  :: x1, x2
  real(8), intent(out) :: vx_out(N), vw_out(N)

  real(8) :: dx
  integer       :: i

  dx = (x2-x1)/(N-1)
  do i=1, N
     vx_out(i) = x1 + dx*(i-1)
     if( i==1 .or. i==N ) then
        vw_out(i) = dx*0.5d0
     else
        vw_out(i) = dx
     end if
  end do

end subroutine GaussLegendre__getPointsMX

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@             Naoki WATANABE (Mizuho I.R.)                       @@ !
! @@             Nobutaka NISHIKAWA (Mizuho I.R.)                   @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine su_gf_trans(desc,iteration_max,eps, &
     h00_mat,h01_mat,h10_mat,s00_mat,s01_mat,s10_mat,w)

  use surface_green_function
  use ac_mpi_module

  implicit none
  type(MPI_MatDesc), intent(in) :: desc 
  integer, intent(in) :: iteration_max
  real(8), intent(in) :: eps
  complex(8), intent(in) :: h00_mat(desc%nrow, desc%scol:desc%ecol) 
  complex(8), intent(in) :: h01_mat(desc%nrow, desc%scol:desc%ecol) 
  complex(8), intent(in) :: h10_mat(desc%nrow, desc%scol:desc%ecol) 
  complex(8), intent(in) :: s00_mat(desc%nrow, desc%scol:desc%ecol) 
  complex(8), intent(in) :: s01_mat(desc%nrow, desc%scol:desc%ecol) 
  complex(8), intent(in) :: s10_mat(desc%nrow, desc%scol:desc%ecol) 
  complex(8), intent(in) :: w

  integer :: i_do
  integer :: i, j
  real(8) :: del_gr00, del_gr00_mpi

  gr02(:,:) =  w*s00_mat(:,:) - h00_mat(:,:) 

  call MPI__ZGETRI_ASCOT( desc, gr02 )

  gr01(:,:) = -w*s10_mat(:,:) + h10_mat(:,:) 

  call MPI__ZGEMM_ASCOT( 'N', 'N', desc, &
       C1, gr02, gr01, C0, tr1 )

  gr01(:,:) = -w*s01_mat(:,:) + h01_mat(:,:) 

  call MPI__ZGEMM_ASCOT( 'N', 'N', desc, &
       C1, gr02, gr01, C0, tr2 )

  tm(:,:) = tr1(:,:)

  tm_temp(:,:) = tr2(:,:)

  gr02(:,:) = -w*s01_mat(:,:) + h01_mat(:,:) 

  call MPI__ZGEMM_ASCOT( 'N', 'N', desc, &
       C1, gr02, tm, C0, gr01 )

  gr00(:,:) = w*s00_mat(:,:) - h00_mat(:,:) - gr01(:,:) 

  call MPI__ZGETRI_ASCOT( desc, gr00 )

  temp(:,:) = gr00(:,:)

  do i_do=1,iteration_max

     call MPI__ZGEMM_ASCOT( 'N', 'N', desc, C1, tr1, tr2, C0, gr01 )

     call MPI__ZGEMM_ASCOT( 'N', 'N', desc, C1, tr2, tr1, C0, gr02 )

     gr01(:,:) = -gr01(:,:) - gr02(:,:)

     gr02(:,:) = gr01(:,:)
     do j=desc%scol,desc%ecol
        gr02(j,j) = gr01(j,j) + dcmplx(1.d0,0.d0)
     end do

     call MPI__ZGETRI_ASCOT( desc, gr02 )

     call MPI__ZGEMM_ASCOT( 'N', 'N', desc, C1, tr1, tr1, C0, gr01 )
     call MPI__ZGEMM_ASCOT( 'N', 'N', desc, C1, gr02, gr01, C0, tr1 )
     call MPI__ZGEMM_ASCOT( 'N', 'N', desc, C1, tr2, tr2, C0, gr01 )
     call MPI__ZGEMM_ASCOT( 'N', 'N', desc, C1, gr02, gr01, C0, tr2 )
     call MPI__ZGEMM_ASCOT( 'N', 'N', desc, C1, tm_temp, tr1, C0, gr01 )

     tm(:,:) = tm(:,:) + gr01(:,:)

     call MPI__ZGEMM_ASCOT( 'N', 'N', desc, C1, tm_temp, tr2, C0, gr01 )

     tm_temp(:,:) = gr01(:,:)

     gr02(:,:) = -w*s01_mat(:,:) + h01_mat(:,:) 

     call MPI__ZGEMM_ASCOT( 'N', 'N', desc, C1, gr02, tm, C0, gr01 )

     gr00(:,:) = w*s00_mat(:,:) - h00_mat(:,:) - gr01(:,:) 

     call MPI__ZGETRI_ASCOT( desc, gr00 )


     del_gr00_mpi = maxval(cdabs(temp(:,:)-gr00(:,:)))
     call MPI_Allreduce( del_gr00_mpi, del_gr00, 1, &
          MPI_DOUBLE_PRECISION, MPI_MAX, MPI%commM, MPI%info )
     if( del_gr00 < eps ) then
        exit
     else
        temp(:,:)=gr00(:,:)
     end if

     if( i_do == iteration_max ) then
        write(16,*) 'error transfer_su-gr-fu',w,del_gr00
     end if

  end do

  gr02(:,:) = -w*s01_mat(:,:) + h01_mat(:,:) 

  call MPI__ZGEMM_ASCOT( 'N', 'N', desc, C1, gr02, tm, C0, gr01 )

  gr00(:,:) = w*s00_mat(:,:) - h00_mat(:,:) - gr01(:,:) 

  call MPI__ZGETRI_ASCOT( desc, gr00 )

  return
end subroutine su_gf_trans

subroutine su_gf_direct(desc,iteration_max,eps, &
     h00_mat,h01_mat,h10_mat,s00_mat,s01_mat,s10_mat,w)

  use surface_green_function
  use ac_mpi_module
  implicit none

  type(MPI_MatDesc), intent(in) :: desc 
  integer, intent(in) :: iteration_max
  real(8), intent(in) :: eps
  complex(8), intent(in) :: h00_mat(desc%nrow, desc%scol:desc%ecol) 
  complex(8), intent(in) :: h01_mat(desc%nrow, desc%scol:desc%ecol) 
  complex(8), intent(in) :: h10_mat(desc%nrow, desc%scol:desc%ecol) 
  complex(8), intent(in) :: s00_mat(desc%nrow, desc%scol:desc%ecol) 
  complex(8), intent(in) :: s01_mat(desc%nrow, desc%scol:desc%ecol) 
  complex(8), intent(in) :: s10_mat(desc%nrow, desc%scol:desc%ecol) 
  complex(8), intent(in) :: w

  integer :: i_do
  integer :: i, j
  real(8) :: del_gr00, del_gr00_mpi


  es0(:,:) =  w*s00_mat(:,:) - h00_mat(:,:) 
  e00(:,:) =  w*s00_mat(:,:) - h00_mat(:,:) 
  alp(:,:) = -w*s01_mat(:,:) + h01_mat(:,:) 
  bet(:,:) = -w*s10_mat(:,:) + h10_mat(:,:) 

  gr00(:,:) = es0(:,:)
  call MPI__ZGETRI_ASCOT( desc, gr00 )

  temp(:,:)=gr00(:,:)

  do i_do=1,iteration_max
     gr02(:,:) = e00(:,:)
     call MPI__ZGETRI_ASCOT( desc, gr02 )

     call MPI__ZGEMM_ASCOT( 'N', 'N', desc, C1, gr02, bet, C0, gr01 )

     call MPI__ZGEMM_ASCOT( 'N', 'N', desc, C1, alp, gr01, C0, gr00 )

     es0(:,:) = es0(:,:) - gr00(:,:)

     call MPI__ZGEMM_ASCOT( 'N', 'N', desc, C1, gr02, alp, C0, gr01 )

     call MPI__ZGEMM_ASCOT( 'N', 'N', desc, C1, gr02, bet, C0, gr00 )

     call MPI__ZGEMM_ASCOT( 'N', 'N', desc, C1, bet, gr01, C0, gr02 )

     e00(:,:) = e00(:,:) - gr02(:,:)

     call MPI__ZGEMM_ASCOT( 'N', 'N', desc, C1, alp, gr00, C0, gr02 )

     e00(:,:) = e00(:,:) - gr02(:,:)

     call MPI__ZGEMM_ASCOT( 'N', 'N', desc, C1, alp, gr01, C0, gr02 )

     alp(:,:) = gr02(:,:)

     call MPI__ZGEMM_ASCOT( 'N', 'N', desc, C1, bet, gr00, C0, gr02 )

     bet(:,:) = gr02(:,:)

     gr00(:,:) = es0(:,:)
     call MPI__ZGETRI_ASCOT( desc, gr00 )

     del_gr00_mpi = maxval(cdabs(temp(:,:)-gr00(:,:)))
     call MPI_Allreduce( del_gr00_mpi, del_gr00, 1, &
          MPI_DOUBLE_PRECISION, MPI_MAX, MPI%commM, MPI%info )
     if( del_gr00 < eps ) then
        exit
     else
        temp(:,:) = gr00(:,:)
     end if

     if( i_do == iteration_max ) then
        write(16,*) 'error direct_su-gr-fu',w,del_gr00
     end if

  end do

  return
end subroutine su_gf_direct

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine mat_mul(mat_max,amat_in_1,amat_in_2,amat_out)

  implicit none
  integer, intent(in) :: mat_max
  complex(8), intent(in) :: amat_in_1(mat_max,mat_max)
  complex(8), intent(in) :: amat_in_2(mat_max,mat_max)
  complex(8), intent(out) :: amat_out(mat_max,mat_max)
  integer :: mat1_do,mat2_do,i_do

  do mat2_do=1,mat_max
     do mat1_do=1,mat_max
        amat_out(mat1_do,mat2_do)=dcmplx(0.d0,0.d0)
     end do
  end do

  do mat2_do=1,mat_max
     do i_do=1,mat_max
        do mat1_do=1,mat_max
           amat_out(mat1_do,mat2_do)=amat_out(mat1_do,mat2_do)                    &
                +amat_in_1(mat1_do,i_do)*amat_in_2(i_do,mat2_do)
        end do
     end do
  end do

  return
end subroutine mat_mul

subroutine mat_mul2(mat_max1,mat_max2,mat_max3,mat_max4,mat_max5,mat_max6          &
     ,amat_in_1,amat_in_2,amat_out)

  implicit none
  integer, intent(in) :: mat_max1,mat_max2,mat_max3,mat_max4,mat_max5,mat_max6
  complex(8), intent(in) :: amat_in_1(mat_max1,mat_max2)
  complex(8), intent(in) :: amat_in_2(mat_max3,mat_max4)
  complex(8), intent(out) :: amat_out(mat_max5,mat_max6)
  integer :: mat1_do,mat2_do,i_do

  if( mat_max2 /= mat_max3 ) then
     write(6,*) 'error - matmul2_1',mat_max2,mat_max3
     stop
  end if
  if( mat_max1 /= mat_max5 ) then
     write(6,*) 'error - matmul2_2',mat_max2,mat_max3
     stop
  end if
  if( mat_max4 /= mat_max6 ) then
     write(6,*) 'error - matmul2_3',mat_max2,mat_max3
     stop
  end if

  do mat2_do=1,mat_max6
     do mat1_do=1,mat_max5
        amat_out(mat1_do,mat2_do)=dcmplx(0.d0,0.d0)
     end do
  end do

  do mat2_do=1,mat_max4
     do i_do=1,mat_max2
        do mat1_do=1,mat_max1
           amat_out(mat1_do,mat2_do)=amat_out(mat1_do,mat2_do)                    &
                +amat_in_1(mat1_do,i_do)*amat_in_2(i_do,mat2_do)
        end do
     end do
  end do

  return
end subroutine mat_mul2

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine fourier_pot

  use scf_negf
  use fft
  use dft
  use hamiltonian_sgf
  use hamiltonian_c
  use gf_se_c
  use constant
  use condition_ini
  use mod_mpi

  implicit none
  integer :: interp_l,interp_r
  integer :: i1_do,i2_do,i1,i2,m3,i3,gn,i_do,ier,ispin,gn1
  real(8) :: r1,gx
  complex(8) :: temp_l,temp_r

  real(8), allocatable :: v_tot_l_int(:,:),vh_temp_l_int(:)
  real(8), allocatable :: v_tot_r_int(:,:),vh_temp_r_int(:)
  complex(8), allocatable :: den_l_int(:,:),den_r_int(:,:)

  open(unit=16,file=file_tempout,position='append')
  write(16,*) '++++++++++++ interpolate ...'
  close(16)

  interp_l=0
  if( n_a /= n_a_l .or. n_b /= n_b_l ) then
     interp_l=1
     allocate(v_tot_l_int(n_a*n_b*n_c_l,ispin_pol_scf)                          &
          ,vh_temp_l_int(n_a*n_b*n_c_l)                                      &
          ,den_l_int(n_a*n_b*n_c_l,ispin_pol_scf),stat=ier)
     if( ier /= 0 ) then
        write(6,*) 'error allocate: cal_hamiltonian'
        stop
     end if
     call interpo_l(v_tot_l_int,vh_temp_l_int,den_l_int)
  end if
  interp_r=0
  if( n_a /= n_a_r .or. n_b /= n_b_r ) then
     interp_r=1
     allocate(v_tot_r_int(n_a*n_b*n_c_r,ispin_pol_scf)                          &
          ,vh_temp_r_int(n_a*n_b*n_c_r)                                      &
          ,den_r_int(n_a*n_b*n_c_r,ispin_pol_scf),stat=ier)
     if( ier /= 0 ) then
        write(6,*) 'error allocate: cal_hamiltonian'
        stop
     end if
     call interpo_r(v_tot_r_int,vh_temp_r_int,den_r_int)
  end if

  !                       ------------------------------------                       !

  if( ft_switch == 'f_2_ft' .or. ft_switch == 'fft' ) then
     do i2_do=0,n_b-1
        do i1_do=0,n_a-1
           if( interp_l == 0 ) then
              fft1(i1_do+1)=dcmplx(vh_l(i1_do*n_b_l+i2_do+1),0.d0)
           else
              fft1(i1_do+1)                                                        &
                   =dcmplx(vh_temp_l_int(i1_do*n_b*n_c_l+i2_do*n_c_l              &
                   +l_cell_l_bound_l-1+1),0.d0)
           end if
        end do
        if( ft_switch == 'f_2_ft' ) then
           call made_fourier(fft1,wxn,n_a,ix_fft)
        else
           call made_fourier_arb(fft1,wxn,n_a)
        end if
        do i1_do=0,n_a-1
           vh_l_f(i1_do*n_b+i2_do+1)=fft1(i1_do+1)
        end do
     end do
     do i1_do=0,n_a-1
        do i2_do=0,n_b-1
           fft2(i2_do+1)=vh_l_f(i1_do*n_b_l+i2_do+1)
        end do
        if( ft_switch == 'f_2_ft' ) then
           call made_fourier(fft2,wyn,n_b,iy_fft)
        else
           call made_fourier_arb(fft2,wyn,n_b)
        end if
        do i2_do=0,n_b-1
           vh_l_f(i1_do*n_b+i2_do+1)=fft2(i2_do+1)
        end do
     end do
  else
     do i2=0,n_b_l-1
        do i1=0,n_a_l-1
           r_tem(1,i1*n_b+i2+1)=dfloat(i1)
           r_tem(2,i1*n_b+i2+1)=dfloat(i2)
           p_tem(1,i1*n_b+i2+1)=dfloat(i1)*2.d0*pai/dfloat(n_a)
           p_tem(2,i1*n_b+i2+1)=dfloat(i2)*2.d0*pai/dfloat(n_b)
           if( interp_l == 0 ) then
              fft_in(i1*n_b+i2+1)=dcmplx(vh_l(i1*n_b_l+i2+1),0.d0)
           else
              fft_in(i1*n_b+i2+1)                                                  &
                   =dcmplx(vh_temp_l_int(i1*n_b*n_c_l+i2*n_c_l                  &
                   +l_cell_l_bound_l-1+1),0.d0)
           end if
        end do
     end do
     call made_dft(fft_in,fft_out,r_tem,p_tem,n_a*n_b,2,1)
     do i2=0,n_b-1
        do i1=0,n_a-1
           vh_l_f(i1*n_b+i2+1)=fft_out(i1*n_b+i2+1)
        end do
     end do
  end if

  if( ft_switch == 'f_2_ft' .or. ft_switch == 'fft' ) then
     do i2_do=0,n_b-1
        do i1_do=0,n_a-1
           if( interp_r == 0 ) then
              fft1(i1_do+1)=dcmplx(vh_r(i1_do*n_b_r+i2_do+1),0.d0)
           else
              fft1(i1_do+1)                                                        &
                   =dcmplx(vh_temp_r_int(i1_do*n_b*n_c_r+i2_do*n_c_r              &
                   +r_cell_l_bound_r-1+1),0.d0)
           end if
        end do
        if( ft_switch == 'f_2_ft' ) then
           call made_fourier(fft1,wxn,n_a,ix_fft)
        else
           call made_fourier_arb(fft1,wxn,n_a)
        end if
        do i1_do=0,n_a-1
           vh_r_f(i1_do*n_b+i2_do+1)=fft1(i1_do+1)
        end do
     end do
     do i1_do=0,n_a-1
        do i2_do=0,n_b-1
           fft2(i2_do+1)=vh_r_f(i1_do*n_b+i2_do+1)
        end do
        if( ft_switch == 'f_2_ft' ) then
           call made_fourier(fft2,wyn,n_b,iy_fft)
        else
           call made_fourier_arb(fft2,wyn,n_b)
        end if
        do i2_do=0,n_b-1
           vh_r_f(i1_do*n_b+i2_do+1)=fft2(i2_do+1)
        end do
     end do
  else
     do i2=0,n_b-1
        do i1=0,n_a-1
           r_tem(1,i1*n_b+i2+1)=dfloat(i1)
           r_tem(2,i1*n_b+i2+1)=dfloat(i2)
           p_tem(1,i1*n_b+i2+1)=dfloat(i1)*2.d0*pai/dfloat(n_a)
           p_tem(2,i1*n_b+i2+1)=dfloat(i2)*2.d0*pai/dfloat(n_b)
           if( interp_r == 0 ) then
              fft_in(i1*n_b+i2+1)=dcmplx(vh_r(i1*n_b_r+i2+1),0.d0)
           else
              fft_in(i1*n_b+i2+1)                                                  &
                   =dcmplx(vh_temp_r_int(i1*n_b*n_c_r+i2*n_c_r                    &
                   +r_cell_l_bound_r-1+1),0.d0)
           end if
        end do
     end do
     call made_dft(fft_in,fft_out,r_tem,p_tem,n_a*n_b,2,1)
     do i2=0,n_b-1
        do i1=0,n_a-1
           vh_r_f(i1*n_b+i2+1)=fft_out(i1*n_b+i2+1)
        end do
     end do
  end if
  !                       ------------------------------------                       !

  pai=datan(1.d0)*4.d0

  !                       ------------------------------------                       !

  if( ft_switch == 'f_2_ft' .or. ft_switch == 'fft' ) then
     call alo_fft_zz(n_c_l)
     do i1=0,n_a-1
        do i2=0,n_b-1
           do i3=0,n_c_l-1
              if( interp_l == 0 ) then
                 fft3(i3+1)                                                         &
                      =dcmplx(vh_temp_l(i1*n_b_l*n_c_l+i2*n_c_l+i3+1),0.d0)
              else
                 fft3(i3+1)                                                         &
                      =dcmplx(vh_temp_l_int(i1*n_b*n_c_l+i2*n_c_l+i3+1),0.d0)
              end if
           end do
           if( ft_switch == 'f_2_ft' ) then
              call made_fourier(fft3,wzn,n_c_l,iz_fft_l)
           else
              call made_fourier_arb(fft3,wzn,n_c_l)
           end if
           do i_do=0,l_cell_l_bound
              gn=i1*n_b*n_c+i2*n_c+i_do+1
              r1=cell_lr(1,i_do+1)+cell_labc(3,1)/dfloat(2*n_c)                    &
                   -cell_labc_l(3,1)/dfloat(2*n_c_l)
              temp_l=dcmplx(0.d0,0.d0)
              do i3=0,n_c_l-1
                 if( i3 < n_c_l/2 ) then
                    m3=i3
                 else
                    m3=i3-n_c_l
                 end if
                 gx=dfloat(m3)*2.d0*pai/cell_labc_l(3,1)
                 temp_l=temp_l+fft3(i3+1)*dcmplx(dcos(gx*r1),-dsin(gx*r1))
              end do
              v_hartree(gn)=dreal(temp_l)/dfloat(n_c_l)
           end do
        end do
     end do
     call unset_fft_zz
  else
     call alo_dft_z(n_c_l)
     do i1=0,n_a-1
        do i2=0,n_b-1
           do i3=0,n_c_l-1
              r_tem_z(1,i3+1)=dfloat(i3)
              p_tem_z(1,i3+1)=dfloat(i3)*2.d0*pai/dfloat(n_c_l)
              if( interp_l == 0 ) then
                 fft_in_z(i3+1)                                                     &
                      =dcmplx(vh_temp_l(i1*n_b_l*n_c_l+i2*n_c_l+i3+1),0.d0)
              else
                 fft_in_z(i3+1)                                                     &
                      =dcmplx(vh_temp_l_int(i1*n_b*n_c_l+i2*n_c_l+i3+1),0.d0)
              end if
           end do
           call made_dft(fft_in_z,fft_out_z,r_tem_z,p_tem_z,n_c_l,1,1)
           do i_do=0,l_cell_l_bound
              gn=i1*n_b*n_c+i2*n_c+i_do+1
              r1=cell_lr(1,i_do+1)+cell_labc(3,1)/dfloat(2*n_c)                    &
                   -cell_labc_l(3,1)/dfloat(2*n_c_l)
              temp_l=dcmplx(0.d0,0.d0)
              do i3=0,n_c_l-1
                 if( i3 < n_c_l/2 ) then
                    m3=i3
                 else
                    m3=i3-n_c_l
                 end if
                 gx=dfloat(m3)*2.d0*pai/cell_labc_l(3,1)
                 temp_l=temp_l+fft_out_z(i3+1)*dcmplx(dcos(gx*r1),-dsin(gx*r1))
              end do
              v_hartree(gn)=dreal(temp_l)/dfloat(n_c_l)
           end do
        end do
     end do
     call unset_dft_z
  end if

  if( ft_switch == 'f_2_ft' .or. ft_switch == 'fft' ) then
     call alo_fft_zz(n_c_r)
     do i1=0,n_a-1
        do i2=0,n_b-1
           do i3=0,n_c_r-1
              if( interp_r == 0 ) then
                 fft3(i3+1)                                                         &
                      =dcmplx(vh_temp_r(i1*n_b_r*n_c_r+i2*n_c_r+i3+1),0.d0)
              else
                 fft3(i3+1)                                                         &
                      =dcmplx(vh_temp_r_int(i1*n_b*n_c_r+i2*n_c_r+i3+1),0.d0)
              end if
           end do
           if( ft_switch == 'f_2_ft' ) then
              call made_fourier(fft3,wzn,n_c_r,iz_fft_r)
           else
              call made_fourier_arb(fft3,wzn,n_c_r)
           end if
           do i_do=r_cell_l_bound-1,n_c-1
              gn=i1*n_b*n_c+i2*n_c+i_do+1
              r1=cell_lr(1,i_do+1)-cell_labc(3,1)+cell_labc(3,1)/dfloat(2*n_c)     &
                   -cell_labc_r(3,1)/dfloat(2*n_c_r)
              temp_r=dcmplx(0.d0,0.d0)
              do i3=0,n_c_r-1
                 if( i3 < n_c_r/2 ) then
                    m3=i3
                 else
                    m3=i3-n_c_r
                 end if
                 gx=dfloat(m3)*2.d0*pai/cell_labc_r(3,1)
                 temp_r=temp_r+fft3(i3+1)*dcmplx(dcos(gx*r1),-dsin(gx*r1))
              end do
              v_hartree(gn)=dreal(temp_r)/dfloat(n_c_r)
           end do
        end do
     end do
     call unset_fft_zz
  else
     call alo_dft_z(n_c)
     do i1=0,n_a-1
        do i2=0,n_b-1
           do i3=0,n_c_r-1
              r_tem_z(1,i3+1)=dfloat(i3)
              p_tem_z(1,i3+1)=dfloat(i3)*2.d0*pai/dfloat(n_c_r)
              if( interp_r == 0 ) then
                 fft_in_z(i3+1)                                                     &
                      =dcmplx(vh_temp_r(i1*n_b_r*n_c_r+i2*n_c_r+i3+1),0.d0)
              else
                 fft_in_z(i3+1)                                                     &
                      =dcmplx(vh_temp_r_int(i1*n_b*n_c_r+i2*n_c_r+i3+1),0.d0)
              end if
           end do
           call made_dft(fft_in_z,fft_out_z,r_tem_z,p_tem_z,n_c_r,1,1)
           do i_do=r_cell_l_bound-1,n_c-1
              gn=i1*n_b*n_c+i2*n_c+i_do+1
              r1=cell_lr(1,i_do+1)-cell_labc(3,1)+cell_labc(3,1)/dfloat(2*n_c)     &
                   -cell_labc_r(3,1)/dfloat(2*n_c_r)
              temp_r=dcmplx(0.d0,0.d0)
              do i3=0,n_c_r-1
                 if( i3 < n_c_r/2 ) then
                    m3=i3
                 else
                    m3=i3-n_c_r
                 end if
                 gx=dfloat(m3)*2.d0*pai/cell_labc_r(3,1)
                 temp_r=temp_r+fft3(i3+1)*dcmplx(dcos(gx*r1),-dsin(gx*r1))
              end do
              v_hartree(gn)=dreal(temp_r)/dfloat(n_c_r)
           end do
        end do
     end do
     call unset_dft_z
  end if

  !                       ------------------------------------                       !

  if( ft_switch == 'f_2_ft' .or. ft_switch == 'fft' ) then
     call alo_fft_zz(n_c_l)
     do ispin=1,ispin_pol_scf
        do i1=0,n_a-1
           do i2=0,n_b-1
              do i3=0,n_c_l-1
                 if( interp_l == 0 ) then
                    gn1=i1*n_b_l*n_c_l+i2*n_c_l+i3+1
                    fft3(i3+1)=dcmplx(v_tot_l(gn1,ispin),0.d0)
                 else
                    gn1=i1*n_b*n_c_l+i2*n_c_l+i3+1
                    fft3(i3+1)=dcmplx(v_tot_l_int(gn1,ispin),0.d0)
                 end if
              end do
              if( ft_switch == 'f_2_ft' ) then
                 call made_fourier(fft3,wzn,n_c_l,iz_fft_l)
              else
                 call made_fourier_arb(fft3,wzn,n_c_l)
              end if
              do i_do=0,l_cell_l_bound
                 gn=i1*n_b*n_c+i2*n_c+i_do+1
                 r1=cell_lr(1,i_do+1)+cell_labc(3,1)/dfloat(2*n_c)                  &
                      -cell_labc_l(3,1)/dfloat(2*n_c_l)
                 temp_l=dcmplx(0.d0,0.d0)
                 do i3=0,n_c_l-1
                    if( i3 < n_c_l/2 ) then
                       m3=i3
                    else
                       m3=i3-n_c_l
                    end if
                    gx=dfloat(m3)*2.d0*pai/cell_labc_l(3,1)
                    temp_l=temp_l+fft3(i3+1)*dcmplx(dcos(gx*r1),-dsin(gx*r1))
                 end do
                 v_tot(gn,ispin)=dreal(temp_l)/dfloat(n_c_l)
              end do
           end do
        end do
     end do
     call unset_fft_zz
  else
     call alo_dft_z(n_c_l)
     do ispin=1,ispin_pol_scf
        do i1=0,n_a-1
           do i2=0,n_b-1
              do i3=0,n_c_l-1
                 r_tem_z(1,i3+1)=dfloat(i3)
                 p_tem_z(1,i3+1)=dfloat(i3)*2.d0*pai/dfloat(n_c_l)
                 if( interp_l == 0 ) then
                    gn1=i1*n_b_l*n_c_l+i2*n_c_l+i3+1
                    fft_in_z(i3+1)=dcmplx(v_tot_l(gn1,ispin),0.d0)
                 else
                    gn1=i1*n_b*n_c_l+i2*n_c_l+i3+1
                    fft_in_z(i3+1)=dcmplx(v_tot_l_int(gn1,ispin),0.d0)
                 end if
              end do
              call made_dft(fft_in_z,fft_out_z,r_tem_z,p_tem_z,n_c_l,1,1)
              do i_do=0,l_cell_l_bound
                 gn=i1*n_b*n_c+i2*n_c+i_do+1
                 r1=cell_lr(1,i_do+1)+cell_labc(3,1)/dfloat(2*n_c)                  &
                      -cell_labc_l(3,1)/dfloat(2*n_c_l)
                 temp_l=dcmplx(0.d0,0.d0)
                 do i3=0,n_c_l-1
                    if( i3 < n_c_l/2 ) then
                       m3=i3
                    else
                       m3=i3-n_c_l
                    end if
                    gx=dfloat(m3)*2.d0*pai/cell_labc_l(3,1)
                    temp_l=temp_l+fft_out_z(i3+1)*dcmplx(dcos(gx*r1),-dsin(gx*r1))
                 end do
                 v_tot(gn,ispin)=dreal(temp_l)/dfloat(n_c_l)
              end do
           end do
        end do
     end do
     call unset_dft_z
  end if

  if( ft_switch == 'f_2_ft' .or. ft_switch == 'fft' ) then
     call alo_fft_zz(n_c_r)
     do ispin=1,ispin_pol_scf
        do i1=0,n_a-1
           do i2=0,n_b-1
              do i3=0,n_c_r-1
                 if( interp_r == 0 ) then
                    gn1=i1*n_b_r*n_c_r+i2*n_c_r+i3+1
                    fft3(i3+1)=dcmplx(v_tot_r(gn1,ispin),0.d0)
                 else
                    gn1=i1*n_b*n_c_r+i2*n_c_r+i3+1
                    fft3(i3+1)=dcmplx(v_tot_r_int(gn1,ispin),0.d0)
                 end if
              end do
              if( ft_switch == 'f_2_ft' ) then
                 call made_fourier(fft3,wzn,n_c_r,iz_fft_r)
              else
                 call made_fourier_arb(fft3,wzn,n_c_r)
              end if
              do i_do=r_cell_l_bound-1,n_c-1
                 gn=i1*n_b*n_c+i2*n_c+i_do+1
                 r1=cell_lr(1,i_do+1)-cell_labc(3,1)+cell_labc(3,1)/dfloat(2*n_c)   &
                      -cell_labc_r(3,1)/dfloat(2*n_c_r)
                 temp_r=dcmplx(0.d0,0.d0)
                 do i3=0,n_c_r-1
                    if( i3 < n_c_r/2 ) then
                       m3=i3
                    else
                       m3=i3-n_c_r
                    end if
                    gx=dfloat(m3)*2.d0*pai/cell_labc_r(3,1)
                    temp_r=temp_r+fft3(i3+1)*dcmplx(dcos(gx*r1),-dsin(gx*r1))
                 end do
                 v_tot(gn,ispin)=dreal(temp_r)/dfloat(n_c_r)
              end do
           end do
        end do
     end do
     call unset_fft_zz
  else
     call alo_dft_z(n_c)
     do ispin=1,ispin_pol_scf
        do i1=0,n_a-1
           do i2=0,n_b-1
              do i3=0,n_c_r-1
                 r_tem_z(1,i3+1)=dfloat(i3)
                 p_tem_z(1,i3+1)=dfloat(i3)*2.d0*pai/dfloat(n_c_r)
                 if( interp_r == 0 ) then
                    gn1=i1*n_b_r*n_c_r+i2*n_c_r+i3+1
                    fft_in_z(i3+1)=dcmplx(v_tot_r(gn1,ispin),0.d0)
                 else
                    gn1=i1*n_b*n_c_r+i2*n_c_r+i3+1
                    fft_in_z(i3+1)=dcmplx(v_tot_r_int(gn1,ispin),0.d0)
                 end if
              end do
              call made_dft(fft_in_z,fft_out_z,r_tem_z,p_tem_z,n_c_r,1,1)
              do i_do=r_cell_l_bound-1,n_c-1
                 gn=i1*n_b*n_c+i2*n_c+i_do+1
                 r1=cell_lr(1,i_do+1)-cell_labc(3,1)+cell_labc(3,1)/dfloat(2*n_c)   &
                      -cell_labc_r(3,1)/dfloat(2*n_c_r)
                 temp_r=dcmplx(0.d0,0.d0)
                 do i3=0,n_c_r-1
                    if( i3 < n_c_r/2 ) then
                       m3=i3
                    else
                       m3=i3-n_c_r
                    end if
                    gx=dfloat(m3)*2.d0*pai/cell_labc_r(3,1)
                    temp_r=temp_r+fft3(i3+1)*dcmplx(dcos(gx*r1),-dsin(gx*r1))
                 end do
                 v_tot(gn,ispin)=dreal(temp_r)/dfloat(n_c_r)
              end do
           end do
        end do
     end do
     call unset_dft_z
  end if

  !                       ------------------------------------                       !

  if( ft_switch == 'f_2_ft' .or. ft_switch == 'fft' ) then
     call alo_fft_zz(n_c_l)
     do ispin=1,ispin_pol_scf
        do i1=0,n_a-1
           do i2=0,n_b-1
              do i3=0,n_c_l-1
                 if( interp_l == 0 ) then
                    gn1=i1*n_b_l*n_c_l+i2*n_c_l+i3+1
                    if( ispin_pol_scf < 4 ) then
                       fft3(i3+1)=dcmplx(den_l(gn1,ispin),0.d0)
                    else
                       fft3(i3+1)=denls_l(gn1,ispin)
                    end if
                 else
                    gn1=i1*n_b*n_c_l+i2*n_c_l+i3+1
                    fft3(i3+1)=den_l_int(gn1,ispin)
                 end if
              end do
              if( ft_switch == 'f_2_ft' ) then
                 call made_fourier(fft3,wzn,n_c_l,iz_fft_l)
              else
                 call made_fourier_arb(fft3,wzn,n_c_l)
              end if
              do i_do=0,l_cell_l_bound
                 gn=i1*n_b*n_c+i2*n_c+i_do+1
                 r1=cell_lr(1,i_do+1)+cell_labc(3,1)/dfloat(2*n_c)                  &
                      -cell_labc_l(3,1)/dfloat(2*n_c_l)
                 temp_l=dcmplx(0.d0,0.d0)
                 do i3=0,n_c_l-1
                    if( i3 < n_c_l/2 ) then
                       m3=i3
                    else
                       m3=i3-n_c_l
                    end if
                    gx=dfloat(m3)*2.d0*pai/cell_labc_l(3,1)
                    temp_l=temp_l+fft3(i3+1)*dcmplx(dcos(gx*r1),-dsin(gx*r1))
                 end do
                 if( ispin_pol_scf < 4 ) then
                    rho(gn,ispin)=dcmplx(dreal(temp_l)/dfloat(n_c_l),0.d0)
                 else
                    rhols(gn,ispin)=temp_l/dfloat(n_c_l)
                 end if
              end do
           end do
        end do
     end do
     call unset_fft_zz
  else
     call alo_dft_z(n_c_l)
     do ispin=1,ispin_pol_scf
        do i1=0,n_a-1
           do i2=0,n_b-1
              do i3=0,n_c_l-1
                 r_tem_z(1,i3+1)=dfloat(i3)
                 p_tem_z(1,i3+1)=dfloat(i3)*2.d0*pai/dfloat(n_c_l)
                 if( interp_l == 0 ) then
                    gn1=i1*n_b_l*n_c_l+i2*n_c_l+i3+1
                    if( ispin_pol_scf < 4 ) then
                       fft_in_z(i3+1)=dcmplx(den_l(gn1,ispin),0.d0)
                    else
                       fft_in_z(i3+1)=denls_l(gn1,ispin)
                    end if
                 else
                    gn1=i1*n_b*n_c_l+i2*n_c_l+i3+1
                    fft_in_z(i3+1)=den_l_int(gn1,ispin)
                 end if
              end do
              call made_dft(fft_in_z,fft_out_z,r_tem_z,p_tem_z,n_c_l,1,1)
              do i_do=0,l_cell_l_bound
                 gn=i1*n_b*n_c+i2*n_c+i_do+1
                 r1=cell_lr(1,i_do+1)+cell_labc(3,1)/dfloat(2*n_c)                  &
                      -cell_labc_l(3,1)/dfloat(2*n_c_l)
                 temp_l=dcmplx(0.d0,0.d0)
                 do i3=0,n_c_l-1
                    if( i3 < n_c_l/2 ) then
                       m3=i3
                    else
                       m3=i3-n_c_l
                    end if
                    gx=dfloat(m3)*2.d0*pai/cell_labc_l(3,1)
                    temp_l=temp_l+fft_out_z(i3+1)*dcmplx(dcos(gx*r1),-dsin(gx*r1))
                 end do
                 if( ispin_pol_scf < 4 ) then
                    rho(gn,ispin)=dreal(temp_l)/dfloat(n_c_l)
                 else
                    rhols(gn,ispin)=temp_l/dfloat(n_c_l)
                 end if
              end do
           end do
        end do
     end do
     call unset_dft_z
  end if

  if( ft_switch == 'f_2_ft' .or. ft_switch == 'fft' ) then
     call alo_fft_zz(n_c_r)
     do ispin=1,ispin_pol_scf
        do i1=0,n_a-1
           do i2=0,n_b-1
              do i3=0,n_c_r-1
                 if( interp_r == 0 ) then
                    gn1=i1*n_b_r*n_c_r+i2*n_c_r+i3+1
                    if( ispin_pol_scf < 4 ) then
                       fft3(i3+1)=dcmplx(den_r(gn1,ispin),0.d0)
                    else
                       fft3(i3+1)=denls_r(gn1,ispin)
                    end if
                 else
                    gn1=i1*n_b*n_c_r+i2*n_c_r+i3+1
                    fft3(i3+1)=den_r_int(gn1,ispin)
                 end if
              end do
              if( ft_switch == 'f_2_ft' ) then
                 call made_fourier(fft3,wzn,n_c_r,iz_fft_r)
              else
                 call made_fourier_arb(fft3,wzn,n_c_r)
              end if
              do i_do=r_cell_l_bound-1,n_c-1
                 gn=i1*n_b*n_c+i2*n_c+i_do+1
                 r1=cell_lr(1,i_do+1)-cell_labc(3,1)+cell_labc(3,1)/dfloat(2*n_c)   &
                      -cell_labc_r(3,1)/dfloat(2*n_c_r)
                 temp_r=dcmplx(0.d0,0.d0)
                 do i3=0,n_c_r-1
                    if( i3 < n_c_r/2 ) then
                       m3=i3
                    else
                       m3=i3-n_c_r
                    end if
                    gx=dfloat(m3)*2.d0*pai/cell_labc_r(3,1)
                    temp_r=temp_r+fft3(i3+1)*dcmplx(dcos(gx*r1),-dsin(gx*r1))
                 end do
                 if( ispin_pol_scf < 4 ) then
                    rho(gn,ispin)=dreal(temp_r)/dfloat(n_c_r)
                 else
                    rhols(gn,ispin)=temp_r/dfloat(n_c_r)
                 end if
              end do
           end do
        end do
     end do
     call unset_fft_zz
  else
     call alo_dft_z(n_c)
     do ispin=1,ispin_pol_scf
        do i1=0,n_a-1
           do i2=0,n_b-1
              do i3=0,n_c_r-1
                 r_tem_z(1,i3+1)=dfloat(i3)
                 p_tem_z(1,i3+1)=dfloat(i3)*2.d0*pai/dfloat(n_c_r)
                 if( interp_r == 0 ) then
                    gn1=i1*n_b_r*n_c_r+i2*n_c_r+i3+1
                    if( ispin_pol_scf < 4 ) then
                       fft_in_z(i3+1)=dcmplx(den_r(gn1,ispin),0.d0)
                    else
                       fft_in_z(i3+1)=denls_r(gn1,ispin)
                    end if
                 else
                    gn1=i1*n_b*n_c_r+i2*n_c_r+i3+1
                    fft_in_z(i3+1)=den_r_int(gn1,ispin)
                 end if
              end do
              call made_dft(fft_in_z,fft_out_z,r_tem_z,p_tem_z,n_c_r,1,1)
              do i_do=r_cell_l_bound-1,n_c-1
                 gn=i1*n_b*n_c+i2*n_c+i_do+1
                 r1=cell_lr(1,i_do+1)-cell_labc(3,1)+cell_labc(3,1)/dfloat(2*n_c)   &
                      -cell_labc_r(3,1)/dfloat(2*n_c_r)
                 temp_r=dcmplx(0.d0,0.d0)
                 do i3=0,n_c_r-1
                    if( i3 < n_c_r/2 ) then
                       m3=i3
                    else
                       m3=i3-n_c_r
                    end if
                    gx=dfloat(m3)*2.d0*pai/cell_labc_r(3,1)
                    temp_r=temp_r+fft3(i3+1)*dcmplx(dcos(gx*r1),-dsin(gx*r1))
                 end do
                 if( ispin_pol_scf < 4 ) then
                    rho(gn,ispin)=dreal(temp_r)/dfloat(n_c_r)
                 else
                    rhols(gn,ispin)=temp_r/dfloat(n_c_r)
                 end if
              end do
           end do
        end do
     end do
     call unset_dft_z
  end if

  !                       ------------------------------------                       !

  do ispin=1,ispin_pol_scf
     do i1=0,n_a-1
        do i2=0,n_b-1
           do i3=0,n_c-1
              gn=i1*n_b*n_c+i2*n_c+i3+1
              if( ispin_pol_scf < 4 ) then
                 if( i3+1 > l_cell_l_bound .and. i3+1 < r_cell_l_bound ) then
                    rho(gn,ispin)=rho_temp(gn,ispin)
                 else
                    rho_temp(gn,ispin)=rho(gn,ispin)
                 end if
              else
                 if( i3+1 > l_cell_l_bound .and. i3+1 < r_cell_l_bound ) then
                    rhols(gn,ispin)=rhols_temp(gn,ispin)
                 else
                    rhols_temp(gn,ispin)=rhols(gn,ispin)
                 end if
              end if
           end do
        end do
     end do
  end do

  !                       ------------------------------------                       !

  if( n_a /= n_a_l .or. n_b /= n_b_l ) then
     deallocate(v_tot_l_int,vh_temp_l_int,den_l_int,stat=ier)
     if( ier /= 0 ) then
        write(6,*) 'error allocate: cal_hamiltonian'
        stop
     end if
  end if
  if( n_a /= n_a_r .or. n_b /= n_b_r ) then
     deallocate(v_tot_r_int,vh_temp_r_int,den_r_int,stat=ier)
     if( ier /= 0 ) then
        write(6,*) 'error allocate: cal_hamiltonian'
        stop
     end if
  end if

  return
end subroutine fourier_pot

subroutine interpo_l(v_tot_l_int,vh_temp_l_int,den_l_int)

  use scf_negf
  use fft
  use dft
  use hamiltonian_sgf
  use hamiltonian_c
  use gf_se_c
  use constant
  use condition_ini

  implicit none
  real(8), intent(inout) :: v_tot_l_int(n_a*n_b*n_c_l,ispin_pol_scf)
  real(8), intent(inout) :: vh_temp_l_int(n_a*n_b*n_c_l)
  complex(8), intent(inout) :: den_l_int(n_a*n_b*n_c_l,ispin_pol_scf)

  real(8), allocatable :: temp_forier(:),temp_forier1(:)

  integer :: i1,i2,i3,m1,m2,gn,i_do,ier,i1_fft_l,i2_fft_l,ispin
  real(8) :: r1,gx
  complex(8) :: temp_l

  pai=datan(1.d0)*4.d0

  if( ft_switch == 'f_2_ft' ) then
     call set_f_2_ft_intl(n_a_l,i1_fft_l)
     call set_f_2_ft_intl(n_b_l,i2_fft_l)
  end if

  allocate(temp_forier(n_a*n_b_l),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: cal_hamiltonian'
     stop
  end if
  if( ispin_pol_scf == 4 ) then
     allocate(temp_forier1(n_a*n_b_l),stat=ier)
     if( ier /= 0 ) then
        write(6,*) 'error allocate: cal_hamiltonian'
        stop
     end if
  end if

  !                       ------------------------------------                       !

  if( ft_switch == 'f_2_ft' .or. ft_switch == 'fft' ) then
     do i3=0,n_c_l-1
        call alo_fft_zz(n_a_l)
        do i2=0,n_b_l-1
           do i1=0,n_a_l-1
              fft3(i1+1)                                                           &
                   =dcmplx(vh_temp_l(i1*n_b_l*n_c_l+i2*n_c_l+i3+1),0.d0)
           end do
           if( ft_switch == 'f_2_ft' ) then
              call made_fourier(fft3,wzn,n_a_l,i1_fft_l)
           else
              call made_fourier_arb(fft3,wzn,n_a_l)
           end if
           do i_do=0,n_a-1
              gn=i_do*n_b_l+i2+1
              r1=dfloat(i_do*n_a_l)/dfloat(n_a)                                    &
                   +dfloat(n_a_l)/dfloat(2*n_a)-0.5d0
              temp_l=dcmplx(0.d0,0.d0)
              do i1=0,n_a_l-1
                 if( i1 < n_a_l/2 ) then
                    m1=i1
                 else
                    m1=i1-n_a_l
                 end if
                 gx=dfloat(m1)*2.d0*pai/dfloat(n_a_l)
                 temp_l=temp_l+fft3(i1+1)*dcmplx(dcos(gx*r1),-dsin(gx*r1))
              end do
              temp_forier(gn)=dreal(temp_l)/dfloat(n_a_l)
           end do
        end do
        call unset_fft_zz
        call alo_fft_zz(n_b_l)
        do i1=0,n_a-1
           do i2=0,n_b_l-1
              gn=i1*n_b_l+i2+1
              fft3(i2+1)=dcmplx(temp_forier(gn),0.d0)
           end do
           if( ft_switch == 'f_2_ft' ) then
              call made_fourier(fft3,wzn,n_b_l,i2_fft_l)
           else
              call made_fourier_arb(fft3,wzn,n_b_l)
           end if
           do i_do=0,n_b-1
              r1=dfloat(i_do*n_b_l)/dfloat(n_b)                                    &
                   +dfloat(n_b_l)/dfloat(2*n_b)-0.5d0
              temp_l=dcmplx(0.d0,0.d0)
              do i2=0,n_b_l-1
                 if( i2 < n_b_l/2 ) then
                    m2=i2
                 else
                    m2=i2-n_b_l
                 end if
                 gx=dfloat(m2)*2.d0*pai/dfloat(n_b_l)
                 temp_l=temp_l+fft3(i2+1)*dcmplx(dcos(gx*r1),-dsin(gx*r1))
              end do
              gn=i1*n_b*n_c_l+i_do*n_c_l+i3+1
              vh_temp_l_int(gn)=dreal(temp_l)/dfloat(n_b_l)
           end do
        end do
        call unset_fft_zz
     end do
  else
     do i3=0,n_c_l-1
        call alo_dft_z(n_a_l)
        do i2=0,n_b_l-1
           do i1=0,n_a_l-1
              r_tem_z(1,i1+1)=dfloat(i1)
              p_tem_z(1,i1+1)=dfloat(i1)*2.d0*pai/dfloat(n_a_l)
              fft_in_z(i1+1)                                                       &
                   =dcmplx(vh_temp_l(i1*n_b_l*n_c_l+i2*n_c_l+i3+1),0.d0)
           end do
           call made_dft(fft_in_z,fft_out_z,r_tem_z,p_tem_z,n_a_l,1,1)
           do i_do=0,n_a-1
              gn=i_do*n_b_l+i2+1
              r1=dfloat(i_do*n_a_l)/dfloat(n_a)                                    &
                   +dfloat(n_a_l)/dfloat(2*n_a)-0.5d0
              temp_l=dcmplx(0.d0,0.d0)
              do i1=0,n_a_l-1
                 if( i1 < n_a_l/2 ) then
                    m1=i1
                 else
                    m1=i1-n_a_l
                 end if
                 gx=dfloat(m1)*2.d0*pai/dfloat(n_a_l)
                 temp_l=temp_l+fft_out_z(i1+1)*dcmplx(dcos(gx*r1),-dsin(gx*r1))
              end do
              temp_forier(gn)=dreal(temp_l)/dfloat(n_a_l)
           end do
        end do
        call unset_dft_z
        call alo_dft_z(n_b_l)
        do i1=0,n_a-1
           do i2=0,n_b_l-1
              r_tem_z(1,i2+1)=dfloat(i2)
              p_tem_z(1,i2+1)=dfloat(i2)*2.d0*pai/dfloat(n_b_l)
              gn=i_do*n_b_l+i2+1
              fft_in_z(i2+1)=dcmplx(temp_forier(gn),0.d0)
           end do
           call made_dft(fft_in_z,fft_out_z,r_tem_z,p_tem_z,n_b_l,1,1)
           do i_do=0,n_b-1
              r1=dfloat(i_do*n_b_l)/dfloat(n_b)                                    &
                   +dfloat(n_b_l)/dfloat(2*n_b)-0.5d0
              temp_l=dcmplx(0.d0,0.d0)
              do i2=0,n_b_l-1
                 if( i2 < n_b_l/2 ) then
                    m2=i2
                 else
                    m2=i2-n_b_l
                 end if
                 gx=dfloat(m2)*2.d0*pai/dfloat(n_b_l)
                 temp_l=temp_l+fft_out_z(i2+1)*dcmplx(dcos(gx*r1),-dsin(gx*r1))
              end do
              gn=i1*n_b*n_c_l+i_do*n_c_l+i3+1
              vh_temp_l_int(gn)=dreal(temp_l)/dfloat(n_b_l)
           end do
        end do
        call unset_dft_z
     end do
  end if

  !                       ------------------------------------                       !

  if( ft_switch == 'f_2_ft' .or. ft_switch == 'fft' ) then
     do ispin=1,ispin_pol_scf
        do i3=0,n_c_l-1
           call alo_fft_zz(n_a_l)
           do i2=0,n_b_l-1
              do i1=0,n_a_l-1
                 fft3(i1+1)                                                         &
                      =dcmplx(v_tot_l(i1*n_b_l*n_c_l+i2*n_c_l+i3+1,ispin),0.d0)
              end do
              if( ft_switch == 'f_2_ft' ) then
                 call made_fourier(fft3,wzn,n_a_l,i1_fft_l)
              else
                 call made_fourier_arb(fft3,wzn,n_a_l)
              end if
              do i_do=0,n_a-1
                 gn=i_do*n_b_l+i2+1
                 r1=dfloat(i_do*n_a_l)/dfloat(n_a)                                  &
                      +dfloat(n_a_l)/dfloat(2*n_a)-0.5d0
                 temp_l=dcmplx(0.d0,0.d0)
                 do i1=0,n_a_l-1
                    if( i1 < n_a_l/2 ) then
                       m1=i1
                    else
                       m1=i1-n_a_l
                    end if
                    gx=dfloat(m1)*2.d0*pai/dfloat(n_a_l)
                    temp_l=temp_l+fft3(i1+1)*dcmplx(dcos(gx*r1),-dsin(gx*r1))
                 end do
                 temp_forier(gn)=dreal(temp_l)/dfloat(n_a_l)
              end do
           end do
           call unset_fft_zz
           call alo_fft_zz(n_b_l)
           do i1=0,n_a-1
              do i2=0,n_b_l-1
                 gn=i1*n_b_l+i2+1
                 fft3(i2+1)=dcmplx(temp_forier(gn),0.d0)
              end do
              if( ft_switch == 'f_2_ft' ) then
                 call made_fourier(fft3,wzn,n_b_l,i2_fft_l)
              else
                 call made_fourier_arb(fft3,wzn,n_b_l)
              end if
              do i_do=0,n_b-1
                 r1=dfloat(i_do*n_b_l)/dfloat(n_b)                                  &
                      +dfloat(n_b_l)/dfloat(2*n_b)-0.5d0
                 temp_l=dcmplx(0.d0,0.d0)
                 do i2=0,n_b_l-1
                    if( i2 < n_b_l/2 ) then
                       m2=i2
                    else
                       m2=i2-n_b_l
                    end if
                    gx=dfloat(m2)*2.d0*pai/dfloat(n_b_l)
                    temp_l=temp_l+fft3(i2+1)*dcmplx(dcos(gx*r1),-dsin(gx*r1))
                 end do
                 gn=i1*n_b*n_c_l+i_do*n_c_l+i3+1
                 v_tot_l_int(gn,ispin)=dreal(temp_l)/dfloat(n_b_l)
              end do
           end do
           call unset_fft_zz
        end do
     end do
  else
     do ispin=1,ispin_pol_scf
        do i3=0,n_c_l-1
           call alo_dft_z(n_a_l)
           do i2=0,n_b_l-1
              do i1=0,n_a_l-1
                 r_tem_z(1,i1+1)=dfloat(i1)
                 p_tem_z(1,i1+1)=dfloat(i1)*2.d0*pai/dfloat(n_a_l)
                 fft_in_z(i1+1)                                                     &
                      =dcmplx(v_tot_l(i1*n_b_l*n_c_l+i2*n_c_l+i3+1,ispin),0.d0)
              end do
              call made_dft(fft_in_z,fft_out_z,r_tem_z,p_tem_z,n_a_l,1,1)
              do i_do=0,n_a-1
                 gn=i_do*n_b_l+i2+1
                 r1=dfloat(i_do*n_a_l)/dfloat(n_a)                                  &
                      +dfloat(n_a_l)/dfloat(2*n_a)-0.5d0
                 temp_l=dcmplx(0.d0,0.d0)
                 do i1=0,n_a_l-1
                    if( i1 < n_a_l/2 ) then
                       m1=i1
                    else
                       m1=i1-n_a_l
                    end if
                    gx=dfloat(m1)*2.d0*pai/dfloat(n_a_l)
                    temp_l=temp_l+fft_out_z(i1+1)*dcmplx(dcos(gx*r1),-dsin(gx*r1))
                 end do
                 temp_forier(gn)=dreal(temp_l)/dfloat(n_a_l)
              end do
           end do
           call unset_dft_z
           call alo_dft_z(n_b_l)
           do i1=0,n_a-1
              do i2=0,n_b_l-1
                 r_tem_z(1,i2+1)=dfloat(i2)
                 p_tem_z(1,i2+1)=dfloat(i2)*2.d0*pai/dfloat(n_b_l)
                 gn=i_do*n_b_l+i2+1
                 fft_in_z(i2+1)=dcmplx(temp_forier(gn),0.d0)
              end do
              call made_dft(fft_in_z,fft_out_z,r_tem_z,p_tem_z,n_b_l,1,1)
              do i_do=0,n_b-1
                 r1=dfloat(i_do*n_b_l)/dfloat(n_b)                                  &
                      +dfloat(n_b_l)/dfloat(2*n_b)-0.5d0
                 temp_l=dcmplx(0.d0,0.d0)
                 do i2=0,n_b_l-1
                    if( i2 < n_b_l/2 ) then
                       m2=i2
                    else
                       m2=i2-n_b_l
                    end if
                    gx=dfloat(m2)*2.d0*pai/dfloat(n_b_l)
                    temp_l=temp_l+fft_out_z(i2+1)*dcmplx(dcos(gx*r1),-dsin(gx*r1))
                 end do
                 gn=i1*n_b*n_c_l+i_do*n_c_l+i3+1
                 v_tot_l_int(gn,ispin)=dreal(temp_l)/dfloat(n_b_l)
              end do
           end do
           call unset_dft_z
        end do
     end do
  end if

  !                       ------------------------------------                       !

  if( ft_switch == 'f_2_ft' .or. ft_switch == 'fft' ) then
     do ispin=1,ispin_pol_scf
        do i3=0,n_c_l-1
           call alo_fft_zz(n_a_l)
           do i2=0,n_b_l-1
              do i1=0,n_a_l-1
                 if( ispin_pol_scf < 4 ) then
                    fft3(i1+1)                                                       &
                         =dcmplx(den_l(i1*n_b_l*n_c_l+i2*n_c_l+i3+1,ispin),0.d0)
                 else
                    fft3(i1+1)=denls_l(i1*n_b_l*n_c_l+i2*n_c_l+i3+1,ispin)
                 end if
              end do
              if( ft_switch == 'f_2_ft' ) then
                 call made_fourier(fft3,wzn,n_a_l,i1_fft_l)
              else
                 call made_fourier_arb(fft3,wzn,n_a_l)
              end if
              do i_do=0,n_a-1
                 gn=i_do*n_b_l+i2+1
                 r1=dfloat(i_do*n_a_l)/dfloat(n_a)                                  &
                      +dfloat(n_a_l)/dfloat(2*n_a)-0.5d0
                 temp_l=dcmplx(0.d0,0.d0)
                 do i1=0,n_a_l-1
                    if( i1 < n_a_l/2 ) then
                       m1=i1
                    else
                       m1=i1-n_a_l
                    end if
                    gx=dfloat(m1)*2.d0*pai/dfloat(n_a_l)
                    temp_l=temp_l+fft3(i1+1)*dcmplx(dcos(gx*r1),-dsin(gx*r1))
                 end do
                 temp_forier(gn)=dreal(temp_l)/dfloat(n_a_l)
                 if( ispin_pol_scf == 4 ) then
                    temp_forier1(gn)=dimag(temp_l)/dfloat(n_a_l)
                 end if
              end do
           end do
           call unset_fft_zz
           call alo_fft_zz(n_b_l)
           do i1=0,n_a-1
              do i2=0,n_b_l-1
                 gn=i1*n_b_l+i2+1
                 if( ispin_pol_scf < 4 ) then
                    fft3(i2+1)=dcmplx(temp_forier(gn),0.d0)
                 else
                    fft3(i2+1)=dcmplx(temp_forier(gn),temp_forier1(gn))
                 end if
              end do
              if( ft_switch == 'f_2_ft' ) then
                 call made_fourier(fft3,wzn,n_b_l,i2_fft_l)
              else
                 call made_fourier_arb(fft3,wzn,n_b_l)
              end if
              do i_do=0,n_b-1
                 r1=dfloat(i_do*n_b_l)/dfloat(n_b)                                  &
                      +dfloat(n_b_l)/dfloat(2*n_b)-0.5d0
                 temp_l=dcmplx(0.d0,0.d0)
                 do i2=0,n_b_l-1
                    if( i2 < n_b_l/2 ) then
                       m2=i2
                    else
                       m2=i2-n_b_l
                    end if
                    gx=dfloat(m2)*2.d0*pai/dfloat(n_b_l)
                    temp_l=temp_l+fft3(i2+1)*dcmplx(dcos(gx*r1),-dsin(gx*r1))
                 end do
                 gn=i1*n_b*n_c_l+i_do*n_c_l+i3+1
                 if( ispin_pol_scf < 4 ) then
                    den_l_int(gn,ispin)=dcmplx(dreal(temp_l)/dfloat(n_b_l),0.d0)
                 else
                    den_l_int(gn,ispin)=temp_l/dfloat(n_b_l)
                 end if
              end do
           end do
           call unset_fft_zz
        end do
     end do
  else
     do ispin=1,ispin_pol_scf
        do i3=0,n_c_l-1
           call alo_dft_z(n_a_l)
           do i2=0,n_b_l-1
              do i1=0,n_a_l-1
                 r_tem_z(1,i1+1)=dfloat(i1)
                 p_tem_z(1,i1+1)=dfloat(i1)*2.d0*pai/dfloat(n_a_l)
                 if( ispin_pol_scf < 4 ) then
                    fft_in_z(i1+1)                                                   &
                         =dcmplx(den_l(i1*n_b_l*n_c_l+i2*n_c_l+i3+1,ispin),0.d0)
                 else
                    fft_in_z(i1+1)=denls_l(i1*n_b_l*n_c_l+i2*n_c_l+i3+1,ispin)
                 end if
              end do
              call made_dft(fft_in_z,fft_out_z,r_tem_z,p_tem_z,n_a_l,1,1)
              do i_do=0,n_a-1
                 gn=i_do*n_b_l+i2+1
                 r1=dfloat(i_do*n_a_l)/dfloat(n_a)                                  &
                      +dfloat(n_a_l)/dfloat(2*n_a)-0.5d0
                 temp_l=dcmplx(0.d0,0.d0)
                 do i1=0,n_a_l-1
                    if( i1 < n_a_l/2 ) then
                       m1=i1
                    else
                       m1=i1-n_a_l
                    end if
                    gx=dfloat(m1)*2.d0*pai/dfloat(n_a_l)
                    temp_l=temp_l+fft_out_z(i1+1)*dcmplx(dcos(gx*r1),-dsin(gx*r1))
                 end do
                 temp_forier(gn)=dreal(temp_l)/dfloat(n_a_l)
                 if( ispin_pol_scf == 4 ) then
                    temp_forier1(gn)=dimag(temp_l)/dfloat(n_a_l)
                 end if
              end do
           end do
           call unset_dft_z
           call alo_dft_z(n_b_l)
           do i1=0,n_a-1
              do i2=0,n_b_l-1
                 r_tem_z(1,i2+1)=dfloat(i2)
                 p_tem_z(1,i2+1)=dfloat(i2)*2.d0*pai/dfloat(n_b_l)
                 gn=i_do*n_b_l+i2+1
                 if( ispin_pol_scf < 4 ) then
                    fft_in_z(i2+1)=dcmplx(temp_forier(gn),0.d0)
                 else
                    fft_in_z(i2+1)=dcmplx(temp_forier(gn),temp_forier1(gn))
                 end if
              end do
              call made_dft(fft_in_z,fft_out_z,r_tem_z,p_tem_z,n_b_l,1,1)
              do i_do=0,n_b-1
                 r1=dfloat(i_do*n_b_l)/dfloat(n_b)                                  &
                      +dfloat(n_b_l)/dfloat(2*n_b)-0.5d0
                 temp_l=dcmplx(0.d0,0.d0)
                 do i2=0,n_b_l-1
                    if( i2 < n_b_l/2 ) then
                       m2=i2
                    else
                       m2=i2-n_b_l
                    end if
                    gx=dfloat(m2)*2.d0*pai/dfloat(n_b_l)
                    temp_l=temp_l+fft_out_z(i2+1)*dcmplx(dcos(gx*r1),-dsin(gx*r1))
                 end do
                 gn=i1*n_b*n_c_l+i_do*n_c_l+i3+1
                 if( ispin_pol_scf < 4 ) then
                    den_l_int(gn,ispin)=dcmplx(dreal(temp_l)/dfloat(n_b_l),0.d0)
                 else
                    den_l_int(gn,ispin)=temp_l/dfloat(n_b_l)
                 end if
              end do
           end do
           call unset_dft_z
        end do
     end do
  end if

  !                       ------------------------------------                       !

  deallocate(temp_forier,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: cal_hamiltonian'
     stop
  end if
  if( ispin_pol_scf == 4 ) then
     deallocate(temp_forier1,stat=ier)
     if( ier /= 0 ) then
        write(6,*) 'error allocate: cal_hamiltonian'
        stop
     end if
  end if

  return
end subroutine interpo_l

subroutine set_f_2_ft_intl(ngrid_l,i_fft_l)

  implicit none
  integer, intent(in) :: ngrid_l
  integer, intent(inout) :: i_fft_l

  integer :: i_do,j_do,i_temp,j_temp,ier
  integer, allocatable :: n(:)

  allocate(n(4),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: set_fft'
     stop
  end if

  n(1)=7
  n(2)=5
  n(3)=3
  n(4)=2

  i_temp=ngrid_l
  i_fft_l=1
  j_temp=1
  do j_do=1,ngrid_l
     do i_do=1,4
        if( mod(i_temp,n(i_do)) == 0 ) then
           if( i_fft_l > j_temp ) then
              j_temp=j_temp*n(i_do)
           else
              i_fft_l=i_fft_l*n(i_do)
           end if
           i_temp=i_temp/n(i_do)
           exit
        end if
     end do
     if( i_temp == 1 ) then
        exit
     end if
  end do

  deallocate(n,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: set_fft'
     stop
  end if

  return
end subroutine set_f_2_ft_intl

subroutine interpo_r(v_tot_r_int,vh_temp_r_int,den_r_int)

  use scf_negf
  use fft
  use dft
  use hamiltonian_sgf
  use hamiltonian_c
  use gf_se_c
  use constant
  use condition_ini

  implicit none
  real(8), intent(inout) :: v_tot_r_int(n_a*n_b*n_c_r,ispin_pol_scf)
  real(8), intent(inout) :: vh_temp_r_int(n_a*n_b*n_c_r)
  complex(8), intent(inout) :: den_r_int(n_a*n_b*n_c_r,ispin_pol_scf)

  real(8), allocatable :: temp_forier(:),temp_forier1(:)

  integer :: i1,i2,i3,m1,m2,gn,i_do,ier,i1_fft_r,i2_fft_r,ispin
  real(8) :: r1,gx
  complex(8) :: temp_r

  pai=datan(1.d0)*4.d0

  if( ft_switch == 'f_2_ft' ) then
     call set_f_2_ft_intr(n_a_r,i1_fft_r)
     call set_f_2_ft_intr(n_b_r,i2_fft_r)
  end if

  allocate(temp_forier(n_a*n_b_r),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: cal_hamiltonian'
     stop
  end if
  if( ispin_pol_scf == 4 ) then
     allocate(temp_forier1(n_a*n_b_r),stat=ier)
     if( ier /= 0 ) then
        write(6,*) 'error allocate: cal_hamiltonian'
        stop
     end if
  end if

  !                       ------------------------------------                       !

  if( ft_switch == 'f_2_ft' .or. ft_switch == 'fft' ) then
     do i3=0,n_c_r-1
        call alo_fft_zz(n_a_r)
        do i2=0,n_b_r-1
           do i1=0,n_a_r-1
              fft3(i1+1)                                                           &
                   =dcmplx(vh_temp_r(i1*n_b_r*n_c_r+i2*n_c_r+i3+1),0.d0)
           end do
           if( ft_switch == 'f_2_ft' ) then
              call made_fourier(fft3,wzn,n_a_r,i1_fft_r)
           else
              call made_fourier_arb(fft3,wzn,n_a_r)
           end if
           do i_do=0,n_a-1
              gn=i_do*n_b_r+i2+1
              r1=dfloat(i_do*n_a_r)/dfloat(n_a)                                    &
                   +dfloat(n_a_r)/dfloat(2*n_a)-0.5d0
              temp_r=dcmplx(0.d0,0.d0)
              do i1=0,n_a_r-1
                 if( i1 < n_a_r/2 ) then
                    m1=i1
                 else
                    m1=i1-n_a_r
                 end if
                 gx=dfloat(m1)*2.d0*pai/dfloat(n_a_r)
                 temp_r=temp_r+fft3(i1+1)*dcmplx(dcos(gx*r1),-dsin(gx*r1))
              end do
              temp_forier(gn)=dreal(temp_r)/dfloat(n_a_r)
           end do
        end do
        call unset_fft_zz
        call alo_fft_zz(n_b_r)
        do i1=0,n_a-1
           do i2=0,n_b_r-1
              gn=i1*n_b_r+i2+1
              fft3(i2+1)=dcmplx(temp_forier(gn),0.d0)
           end do
           if( ft_switch == 'f_2_ft' ) then
              call made_fourier(fft3,wzn,n_b_r,i2_fft_r)
           else
              call made_fourier_arb(fft3,wzn,n_b_r)
           end if
           do i_do=0,n_b-1
              r1=dfloat(i_do*n_b_r)/dfloat(n_b)                                    &
                   +dfloat(n_b_r)/dfloat(2*n_b)-0.5d0
              temp_r=dcmplx(0.d0,0.d0)
              do i2=0,n_b_r-1
                 if( i2 < n_b_r/2 ) then
                    m2=i2
                 else
                    m2=i2-n_b_r
                 end if
                 gx=dfloat(m2)*2.d0*pai/dfloat(n_b_r)
                 temp_r=temp_r+fft3(i2+1)*dcmplx(dcos(gx*r1),-dsin(gx*r1))
              end do
              gn=i1*n_b*n_c_r+i_do*n_c_r+i3+1
              vh_temp_r_int(gn)=dreal(temp_r)/dfloat(n_b_r)
           end do
        end do
        call unset_fft_zz
     end do
  else
     do i3=0,n_c_r-1
        call alo_dft_z(n_a_r)
        do i2=0,n_b_r-1
           do i1=0,n_a_r-1
              r_tem_z(1,i1+1)=dfloat(i1)
              p_tem_z(1,i1+1)=dfloat(i1)*2.d0*pai/dfloat(n_a_r)
              fft_in_z(i1+1)                                                       &
                   =dcmplx(vh_temp_r(i1*n_b_r*n_c_r+i2*n_c_r+i3+1),0.d0)
           end do
           call made_dft(fft_in_z,fft_out_z,r_tem_z,p_tem_z,n_a_r,1,1)
           do i_do=0,n_a-1
              gn=i_do*n_b_r+i2+1
              r1=dfloat(i_do*n_a_r)/dfloat(n_a)                                    &
                   +dfloat(n_a_r)/dfloat(2*n_a)-0.5d0
              temp_r=dcmplx(0.d0,0.d0)
              do i1=0,n_a_r-1
                 if( i1 < n_a_r/2 ) then
                    m1=i1
                 else
                    m1=i1-n_a_r
                 end if
                 gx=dfloat(m1)*2.d0*pai/dfloat(n_a_r)
                 temp_r=temp_r+fft_out_z(i1+1)*dcmplx(dcos(gx*r1),-dsin(gx*r1))
              end do
              temp_forier(gn)=dreal(temp_r)/dfloat(n_a_r)
           end do
        end do
        call unset_dft_z
        call alo_dft_z(n_b_r)
        do i1=0,n_a-1
           do i2=0,n_b_r-1
              r_tem_z(1,i2+1)=dfloat(i2)
              p_tem_z(1,i2+1)=dfloat(i2)*2.d0*pai/dfloat(n_b_r)
              gn=i_do*n_b_r+i2+1
              fft_in_z(i2+1)=dcmplx(temp_forier(gn),0.d0)
           end do
           call made_dft(fft_in_z,fft_out_z,r_tem_z,p_tem_z,n_b_r,1,1)
           do i_do=0,n_b-1
              r1=dfloat(i_do*n_b_r)/dfloat(n_b)                                    &
                   +dfloat(n_b_r)/dfloat(2*n_b)-0.5d0
              temp_r=dcmplx(0.d0,0.d0)
              do i2=0,n_b_r-1
                 if( i2 < n_b_r/2 ) then
                    m2=i2
                 else
                    m2=i2-n_b_r
                 end if
                 gx=dfloat(m2)*2.d0*pai/dfloat(n_b_r)
                 temp_r=temp_r+fft_out_z(i2+1)*dcmplx(dcos(gx*r1),-dsin(gx*r1))
              end do
              gn=i1*n_b*n_c_r+i_do*n_c_r+i3+1
              vh_temp_r_int(gn)=dreal(temp_r)/dfloat(n_b_r)
           end do
        end do
        call unset_dft_z
     end do
  end if

  !                       ------------------------------------                       !

  if( ft_switch == 'f_2_ft' .or. ft_switch == 'fft' ) then
     do ispin=1,ispin_pol_scf
        do i3=0,n_c_r-1
           call alo_fft_zz(n_a_r)
           do i2=0,n_b_r-1
              do i1=0,n_a_r-1
                 fft3(i1+1)                                                         &
                      =dcmplx(v_tot_r(i1*n_b_r*n_c_r+i2*n_c_r+i3+1,ispin),0.d0)
              end do
              if( ft_switch == 'f_2_ft' ) then
                 call made_fourier(fft3,wzn,n_a_r,i1_fft_r)
              else
                 call made_fourier_arb(fft3,wzn,n_a_r)
              end if
              do i_do=0,n_a-1
                 gn=i_do*n_b_r+i2+1
                 r1=dfloat(i_do*n_a_r)/dfloat(n_a)                                  &
                      +dfloat(n_a_r)/dfloat(2*n_a)-0.5d0
                 temp_r=dcmplx(0.d0,0.d0)
                 do i1=0,n_a_r-1
                    if( i1 < n_a_r/2 ) then
                       m1=i1
                    else
                       m1=i1-n_a_r
                    end if
                    gx=dfloat(m1)*2.d0*pai/dfloat(n_a_r)
                    temp_r=temp_r+fft3(i1+1)*dcmplx(dcos(gx*r1),-dsin(gx*r1))
                 end do
                 temp_forier(gn)=dreal(temp_r)/dfloat(n_a_r)
              end do
           end do
           call unset_fft_zz
           call alo_fft_zz(n_b_r)
           do i1=0,n_a-1
              do i2=0,n_b_r-1
                 gn=i1*n_b_r+i2+1
                 fft3(i2+1)=dcmplx(temp_forier(gn),0.d0)
              end do
              if( ft_switch == 'f_2_ft' ) then
                 call made_fourier(fft3,wzn,n_b_r,i2_fft_r)
              else
                 call made_fourier_arb(fft3,wzn,n_b_r)
              end if
              do i_do=0,n_b-1
                 r1=dfloat(i_do*n_b_r)/dfloat(n_b)                                  &
                      +dfloat(n_b_r)/dfloat(2*n_b)-0.5d0
                 temp_r=dcmplx(0.d0,0.d0)
                 do i2=0,n_b_r-1
                    if( i2 < n_b_r/2 ) then
                       m2=i2
                    else
                       m2=i2-n_b_r
                    end if
                    gx=dfloat(m2)*2.d0*pai/dfloat(n_b_r)
                    temp_r=temp_r+fft3(i2+1)*dcmplx(dcos(gx*r1),-dsin(gx*r1))
                 end do
                 gn=i1*n_b*n_c_r+i_do*n_c_r+i3+1
                 v_tot_r_int(gn,ispin)=dreal(temp_r)/dfloat(n_b_r)
              end do
           end do
           call unset_fft_zz
        end do
     end do
  else
     do ispin=1,ispin_pol_scf
        do i3=0,n_c_r-1
           call alo_dft_z(n_a_r)
           do i2=0,n_b_r-1
              do i1=0,n_a_r-1
                 r_tem_z(1,i1+1)=dfloat(i1)
                 p_tem_z(1,i1+1)=dfloat(i1)*2.d0*pai/dfloat(n_a_r)
                 fft_in_z(i1+1)                                                     &
                      =dcmplx(v_tot_r(i1*n_b_r*n_c_r+i2*n_c_r+i3+1,ispin),0.d0)
              end do
              call made_dft(fft_in_z,fft_out_z,r_tem_z,p_tem_z,n_a_r,1,1)
              do i_do=0,n_a-1
                 gn=i_do*n_b_r+i2+1
                 r1=dfloat(i_do*n_a_r)/dfloat(n_a)                                  &
                      +dfloat(n_a_r)/dfloat(2*n_a)-0.5d0
                 temp_r=dcmplx(0.d0,0.d0)
                 do i1=0,n_a_r-1
                    if( i1 < n_a_r/2 ) then
                       m1=i1
                    else
                       m1=i1-n_a_r
                    end if
                    gx=dfloat(m1)*2.d0*pai/dfloat(n_a_r)
                    temp_r=temp_r+fft_out_z(i1+1)*dcmplx(dcos(gx*r1),-dsin(gx*r1))
                 end do
                 temp_forier(gn)=dreal(temp_r)/dfloat(n_a_r)
              end do
           end do
           call unset_dft_z
           call alo_dft_z(n_b_r)
           do i1=0,n_a-1
              do i2=0,n_b_r-1
                 r_tem_z(1,i2+1)=dfloat(i2)
                 p_tem_z(1,i2+1)=dfloat(i2)*2.d0*pai/dfloat(n_b_r)
                 gn=i_do*n_b_r+i2+1
                 fft_in_z(i2+1)=dcmplx(temp_forier(gn),0.d0)
              end do
              call made_dft(fft_in_z,fft_out_z,r_tem_z,p_tem_z,n_b_r,1,1)
              do i_do=0,n_b-1
                 r1=dfloat(i_do*n_b_r)/dfloat(n_b)                                  &
                      +dfloat(n_b_r)/dfloat(2*n_b)-0.5d0
                 temp_r=dcmplx(0.d0,0.d0)
                 do i2=0,n_b_r-1
                    if( i2 < n_b_r/2 ) then
                       m2=i2
                    else
                       m2=i2-n_b_r
                    end if
                    gx=dfloat(m2)*2.d0*pai/dfloat(n_b_r)
                    temp_r=temp_r+fft_out_z(i2+1)*dcmplx(dcos(gx*r1),-dsin(gx*r1))
                 end do
                 gn=i1*n_b*n_c_r+i_do*n_c_r+i3+1
                 v_tot_r_int(gn,ispin)=dreal(temp_r)/dfloat(n_b_r)
              end do
           end do
           call unset_dft_z
        end do
     end do
  end if

  !                       ------------------------------------                       !

  if( ft_switch == 'f_2_ft' .or. ft_switch == 'fft' ) then
     do ispin=1,ispin_pol_scf
        do i3=0,n_c_r-1
           call alo_fft_zz(n_a_r)
           do i2=0,n_b_r-1
              do i1=0,n_a_r-1
                 if( ispin_pol_scf < 4 ) then
                    fft3(i1+1)                                                       &
                         =dcmplx(den_r(i1*n_b_r*n_c_r+i2*n_c_r+i3+1,ispin),0.d0)
                 else
                    fft3(i1+1)=denls_r(i1*n_b_r*n_c_r+i2*n_c_r+i3+1,ispin)
                 end if
              end do
              if( ft_switch == 'f_2_ft' ) then
                 call made_fourier(fft3,wzn,n_a_r,i1_fft_r)
              else
                 call made_fourier_arb(fft3,wzn,n_a_r)
              end if
              do i_do=0,n_a-1
                 gn=i_do*n_b_r+i2+1
                 r1=dfloat(i_do*n_a_r)/dfloat(n_a)                                  &
                      +dfloat(n_a_r)/dfloat(2*n_a)-0.5d0
                 temp_r=dcmplx(0.d0,0.d0)
                 do i1=0,n_a_r-1
                    if( i1 < n_a_r/2 ) then
                       m1=i1
                    else
                       m1=i1-n_a_r
                    end if
                    gx=dfloat(m1)*2.d0*pai/dfloat(n_a_r)
                    temp_r=temp_r+fft3(i1+1)*dcmplx(dcos(gx*r1),-dsin(gx*r1))
                 end do
                 temp_forier(gn)=dreal(temp_r)/dfloat(n_a_r)
                 if( ispin_pol_scf == 4 ) then
                    temp_forier1(gn)=dimag(temp_r)/dfloat(n_a_r)
                 end if
              end do
           end do
           call unset_fft_zz
           call alo_fft_zz(n_b_r)
           do i1=0,n_a-1
              do i2=0,n_b_r-1
                 gn=i1*n_b_r+i2+1
                 if( ispin_pol_scf < 4 ) then
                    fft3(i2+1)=dcmplx(temp_forier(gn),0.d0)
                 else
                    fft3(i2+1)=dcmplx(temp_forier(gn),temp_forier1(gn))
                 end if
              end do
              if( ft_switch == 'f_2_ft' ) then
                 call made_fourier(fft3,wzn,n_b_r,i2_fft_r)
              else
                 call made_fourier_arb(fft3,wzn,n_b_r)
              end if
              do i_do=0,n_b-1
                 r1=dfloat(i_do*n_b_r)/dfloat(n_b)                                  &
                      +dfloat(n_b_r)/dfloat(2*n_b)-0.5d0
                 temp_r=dcmplx(0.d0,0.d0)
                 do i2=0,n_b_r-1
                    if( i2 < n_b_r/2 ) then
                       m2=i2
                    else
                       m2=i2-n_b_r
                    end if
                    gx=dfloat(m2)*2.d0*pai/dfloat(n_b_r)
                    temp_r=temp_r+fft3(i2+1)*dcmplx(dcos(gx*r1),-dsin(gx*r1))
                 end do
                 gn=i1*n_b*n_c_r+i_do*n_c_r+i3+1
                 if( ispin_pol_scf < 4 ) then
                    den_r_int(gn,ispin)=dcmplx(dreal(temp_r)/dfloat(n_b_r),0.d0)
                 else
                    den_r_int(gn,ispin)=temp_r/dfloat(n_b_r)
                 end if
              end do
           end do
           call unset_fft_zz
        end do
     end do
  else
     do ispin=1,ispin_pol_scf
        do i3=0,n_c_r-1
           call alo_dft_z(n_a_r)
           do i2=0,n_b_r-1
              do i1=0,n_a_r-1
                 r_tem_z(1,i1+1)=dfloat(i1)
                 p_tem_z(1,i1+1)=dfloat(i1)*2.d0*pai/dfloat(n_a_r)
                 if( ispin_pol_scf < 4 ) then
                    fft_in_z(i1+1)                                                   &
                         =dcmplx(den_r(i1*n_b_r*n_c_r+i2*n_c_r+i3+1,ispin),0.d0)
                 else
                    fft_in_z(i1+1)=denls_r(i1*n_b_r*n_c_r+i2*n_c_r+i3+1,ispin)
                 end if
              end do
              call made_dft(fft_in_z,fft_out_z,r_tem_z,p_tem_z,n_a_r,1,1)
              do i_do=0,n_a-1
                 gn=i_do*n_b_r+i2+1
                 r1=dfloat(i_do*n_a_r)/dfloat(n_a)                                  &
                      +dfloat(n_a_r)/dfloat(2*n_a)-0.5d0
                 temp_r=dcmplx(0.d0,0.d0)
                 do i1=0,n_a_r-1
                    if( i1 < n_a_r/2 ) then
                       m1=i1
                    else
                       m1=i1-n_a_r
                    end if
                    gx=dfloat(m1)*2.d0*pai/dfloat(n_a_r)
                    temp_r=temp_r+fft_out_z(i1+1)*dcmplx(dcos(gx*r1),-dsin(gx*r1))
                 end do
                 temp_forier(gn)=dreal(temp_r)/dfloat(n_a_r)
                 if( ispin_pol_scf == 4 ) then
                    temp_forier1(gn)=dimag(temp_r)/dfloat(n_a_r)
                 end if
              end do
           end do
           call unset_dft_z
           call alo_dft_z(n_b_r)
           do i1=0,n_a-1
              do i2=0,n_b_r-1
                 r_tem_z(1,i2+1)=dfloat(i2)
                 p_tem_z(1,i2+1)=dfloat(i2)*2.d0*pai/dfloat(n_b_r)
                 gn=i_do*n_b_r+i2+1
                 if( ispin_pol_scf < 4 ) then
                    fft_in_z(i2+1)=dcmplx(temp_forier(gn),0.d0)
                 else
                    fft_in_z(i2+1)=dcmplx(temp_forier(gn),temp_forier1(gn))
                 end if
              end do
              call made_dft(fft_in_z,fft_out_z,r_tem_z,p_tem_z,n_b_r,1,1)
              do i_do=0,n_b-1
                 r1=dfloat(i_do*n_b_r)/dfloat(n_b)                                  &
                      +dfloat(n_b_r)/dfloat(2*n_b)-0.5d0
                 temp_r=dcmplx(0.d0,0.d0)
                 do i2=0,n_b_r-1
                    if( i2 < n_b_r/2 ) then
                       m2=i2
                    else
                       m2=i2-n_b_r
                    end if
                    gx=dfloat(m2)*2.d0*pai/dfloat(n_b_r)
                    temp_r=temp_r+fft_out_z(i2+1)*dcmplx(dcos(gx*r1),-dsin(gx*r1))
                 end do
                 gn=i1*n_b*n_c_r+i_do*n_c_r+i3+1
                 if( ispin_pol_scf < 4 ) then
                    den_r_int(gn,ispin)=dcmplx(dreal(temp_r)/dfloat(n_b_r),0.d0)
                 else
                    den_r_int(gn,ispin)=temp_r/dfloat(n_b_r)
                 end if
              end do
           end do
           call unset_dft_z
        end do
     end do
  end if

  !                       ------------------------------------                       !

  deallocate(temp_forier,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: cal_hamiltonian'
     stop
  end if
  if( ispin_pol_scf == 4 ) then
     deallocate(temp_forier1,stat=ier)
     if( ier /= 0 ) then
        write(6,*) 'error allocate: cal_hamiltonian'
        stop
     end if
  end if

  return
end subroutine interpo_r

subroutine set_f_2_ft_intr(ngrid_r,i_fft_r)

  implicit none
  integer, intent(in) :: ngrid_r
  integer, intent(inout) :: i_fft_r

  integer :: i_do,j_do,i_temp,j_temp,ier
  integer, allocatable :: n(:)

  allocate(n(4),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: set_fft'
     stop
  end if

  n(1)=7
  n(2)=5
  n(3)=3
  n(4)=2

  i_temp=ngrid_r
  i_fft_r=1
  j_temp=1
  do j_do=1,ngrid_r
     do i_do=1,4
        if( mod(i_temp,n(i_do)) == 0 ) then
           if( i_fft_r > j_temp ) then
              j_temp=j_temp*n(i_do)
           else
              i_fft_r=i_fft_r*n(i_do)
           end if
           i_temp=i_temp/n(i_do)
           exit
        end if
     end do
     if( i_temp == 1 ) then
        exit
     end if
  end do

  deallocate(n,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: set_fft'
     stop
  end if

  return
end subroutine set_f_2_ft_intr

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

module hamiltonian_sgf

  implicit none

  integer :: iw_max_ll,kx_max_ll,ky_max_ll,kz_max_ll,mat_max_ll,iw_dos_ll
  integer :: spin_switch_ll
  real(8) :: cp_l

  integer :: iw_max_rr,kx_max_rr,ky_max_rr,kz_max_rr,mat_max_rr,iw_dos_rr
  integer :: spin_switch_rr
  real(8) :: cp_r

end module hamiltonian_sgf

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

module eigen_values

  implicit none
  integer :: mat_ev_max

  integer, pointer :: i_num(:)

  real(8), pointer :: a(:,:),d(:)

  real(8), pointer :: e_temp(:)
  complex(8), pointer :: ev_vec_temp(:,:)

  real(8), pointer :: s_ev(:)
  complex(8), pointer :: ev_vec(:,:)

  real(8), pointer :: a_as(:,:)
  complex(8), pointer :: d_as(:)

contains
  subroutine alo_eigen_values_1

    implicit none
    integer :: ier

    allocate(a(mat_ev_max,mat_ev_max),d(mat_ev_max),i_num(mat_ev_max),stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_eigen_values_1'
       stop
    end if

    return
  end subroutine alo_eigen_values_1

  subroutine unset_eigen_values_1

    implicit none
    integer :: ier

    deallocate(a,d,i_num,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error deallocate: unset_eigen_values_1'
       stop
    end if

    return
  end subroutine unset_eigen_values_1

  subroutine alo_eigen_values_2

    implicit none
    integer :: ier

    allocate(e_temp(mat_ev_max),ev_vec_temp(mat_ev_max/2,mat_ev_max),stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_eigen_values_2'
       stop
    end if

    return
  end subroutine alo_eigen_values_2

  subroutine unset_eigen_values_2

    implicit none
    integer :: ier

    deallocate(e_temp,ev_vec_temp,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error deallocate: unset_eigen_values_2'
       stop
    end if

    return
  end subroutine unset_eigen_values_2

  subroutine alo_eigen_values_3

    implicit none
    integer :: ier

    allocate(s_ev(mat_ev_max/2),ev_vec(mat_ev_max/2,mat_ev_max/2),stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_eigen_values_3'
       stop
    end if

    return
  end subroutine alo_eigen_values_3

  subroutine unset_eigen_values_3

    implicit none
    integer :: ier

    deallocate(s_ev,ev_vec,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error deallocate: unset_eigen_values_3'
       stop
    end if

    return
  end subroutine unset_eigen_values_3

  subroutine alo_eigen_values_as

    implicit none
    integer :: ier

    allocate(a_as(mat_ev_max,mat_ev_max),d_as(mat_ev_max),i_num(mat_ev_max)      &
         ,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_eigen_values_as'
       stop
    end if

    return
  end subroutine alo_eigen_values_as

  subroutine unset_eigen_values_as

    implicit none
    integer :: ier

    deallocate(a_as,d_as,i_num,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error deallocate: unset_eigen_values_as'
       stop
    end if

    return
  end subroutine unset_eigen_values_as
end module eigen_values

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine linear_equation(mat_max,amat_in,b_in,b_out)

  implicit none
  integer, intent(in) :: mat_max
  complex(8), intent(in) :: amat_in(mat_max,mat_max),b_in(mat_max)
  complex(8), intent(out) :: b_out(mat_max)

  integer :: i1_do,i2_do,i3_do,mat1_max,mat2_max,mat_temp,ier,i_smd,i_block
  integer, allocatable :: mat1(:),mat2(:)
  complex(8) :: temp,temp1
  complex(8), allocatable :: amat_temp(:,:),vec_temp(:)

  allocate(amat_temp(mat_max+2,mat_max),vec_temp(mat_max)                      &
       ,mat1(mat_max),mat2(mat_max),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: leaner_equation'
     stop
  end if

  do i1_do=1,mat_max
     mat1(i1_do)=i1_do
     mat2(i1_do)=i1_do
  end do

  do i1_do=1,mat_max
     vec_temp(i1_do)=b_in(i1_do)
  end do

  i_block=64
  do i_smd=1,mat_max,i_block
     do i1_do=1,mat_max
        do i2_do=i_smd,min(i_smd+i_block-1,mat_max)
           amat_temp(i1_do,i2_do)=amat_in(i1_do,i2_do)
        end do
     end do
  end do

  do i1_do=1,mat_max
     mat1_max=i1_do
     mat2_max=i1_do
     temp=amat_temp(mat2(i1_do),mat1(i1_do))
     do i2_do=i1_do,mat_max
        do i3_do=i1_do,mat_max
           if( cdabs(temp) < cdabs(amat_temp(mat2(i3_do),mat1(i2_do))) ) then
              mat1_max=i2_do
              mat2_max=i3_do
              temp=amat_temp(mat2(i3_do),mat1(i2_do))
           end if
        end do
     end do
     if( mat1_max /= i1_do ) then
        mat_temp=mat1(i1_do)
        mat1(i1_do)=mat1(mat1_max)
        mat1(mat1_max)=mat_temp
     end if
     if( mat2_max /= i1_do ) then
        mat_temp=mat2(i1_do)
        mat2(i1_do)=mat2(mat2_max)
        mat2(mat2_max)=mat_temp
     end if
     if( cdabs(amat_temp(mat2(i1_do),mat1(i1_do))) < 1.d-16 ) then
        write(6,*) 'error_ leaner_eq. -- LU:'                                    &
             ,cdabs(amat_temp(mat2(i1_do),mat1(i1_do)))
        stop
     end if

     temp1=1.d0/amat_temp(mat2(i1_do),mat1(i1_do))
     do i2_do=i1_do+1,mat_max
        amat_temp(mat2(i1_do),mat1(i2_do))                                       &
             =amat_temp(mat2(i1_do),mat1(i2_do))*temp1
        do i3_do=i1_do+1,mat_max
           amat_temp(mat2(i3_do),mat1(i2_do))=amat_temp(mat2(i3_do),mat1(i2_do))  &
                -amat_temp(mat2(i1_do),mat1(i2_do))                       &
                *amat_temp(mat2(i3_do),mat1(i1_do))
        end do
     end do
     vec_temp(mat2(i1_do))=vec_temp(mat2(i1_do))*temp1
     do i2_do=i1_do+1,mat_max
        vec_temp(mat2(i2_do))=vec_temp(mat2(i2_do))                              &
             -amat_temp(mat2(i2_do),mat1(i1_do))*vec_temp(mat2(i1_do))
     end do
  end do

  b_out(mat1(mat_max))=vec_temp(mat2(mat_max))
  do i1_do=mat_max-1,1,-1
     b_out(mat1(i1_do))=vec_temp(mat2(i1_do))
     do i2_do=i1_do+1,mat_max
        b_out(mat1(i1_do))=b_out(mat1(i1_do))                                    &
             -amat_temp(mat2(i1_do),mat1(i2_do))*b_out(mat1(i2_do))
     end do
  end do

  deallocate(amat_temp,vec_temp,mat1,mat2,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error deallocate: leaner_equation'
     stop
  end if

  return
end subroutine linear_equation

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@             Naoki WATANABE (Mizuho I.R.)                       @@ !
! @@             Nobutaka NISHIKAWA (Mizuho I.R.)                   @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

module hamiltonian_zper

  implicit none
  integer :: mat_max_zper
  integer, pointer :: itemp(:,:,:),jtemp(:)
  complex(8), pointer :: h00_mat(:,:), s00_mat(:,:) 

contains
  subroutine alo_hamiltonian_zper_input(descZZ)
    use ac_mpi_module
    implicit none

    type(MPI_MatDesc), intent(in) :: descZZ

    integer :: ier,i1_do,i2_do

    allocate(h00_mat(descZZ%nrow, descZZ%scol:descZZ%ecol),stat=ier) 
    allocate(s00_mat(descZZ%nrow, descZZ%scol:descZZ%ecol),stat=ier) 
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_hamiltonian_zper_input'
       stop
    end if

    h00_mat(:,:) = dcmplx(0.d0,0.d0) 
    s00_mat(:,:) = dcmplx(0.d0,0.d0) 

    return
  end subroutine alo_hamiltonian_zper_input

  subroutine unset_hamiltonian_zper_input

    implicit none
    integer :: ier

    deallocate(h00_mat,s00_mat,stat=ier) 
    if( ier /= 0 ) then
       write(6,*) 'error deallocate: unset_hamiltonian_zper_input'
       stop
    end if

    return
  end subroutine unset_hamiltonian_zper_input

  subroutine alo_hamiltonian_zper_free(descZZ,num_atom,num_unit)
    use ac_mpi_module
    implicit none

    type(MPI_MatDesc), intent(in) :: descZZ
    integer, intent(in) :: num_atom,num_unit(3)
    integer :: ier,i1_do,i2_do

    allocate(itemp(num_unit(1),num_unit(2),num_atom),stat=ier)
    allocate(h00_mat(descZZ%nrow, descZZ%scol:descZZ%ecol),stat=ier) 
    allocate(s00_mat(descZZ%nrow, descZZ%scol:descZZ%ecol),stat=ier) 

    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_hamiltonian_zper_free'
       stop
    end if

    h00_mat(:,:) = dcmplx(0.d0,0.d0) 
    s00_mat(:,:) = dcmplx(0.d0,0.d0) 

    return
  end subroutine alo_hamiltonian_zper_free

  subroutine unset_hamiltonian_zper_free

    implicit none
    integer :: ier

    deallocate(h00_mat,s00_mat,itemp,stat=ier) 
    if( ier /= 0 ) then
       write(6,*) 'error deallocate: unset_hamiltonian_zper_free'
       stop
    end if

    return
  end subroutine unset_hamiltonian_zper_free

  subroutine alo_hamiltonian_zper_periodic(descZZ,num_atom)
    use ac_mpi_module
    implicit none

    type(MPI_MatDesc), intent(in) :: descZZ
    integer, intent(in) :: num_atom
    integer :: ier,i1_do,i2_do

    allocate(jtemp(num_atom),stat=ier)
    allocate(h00_mat(descZZ%nrow, descZZ%scol:descZZ%ecol),stat=ier) 
    allocate(s00_mat(descZZ%nrow, descZZ%scol:descZZ%ecol),stat=ier) 
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_hamiltonian_zper_periodic'
       stop
    end if

    h00_mat(:,:) = dcmplx(0.d0,0.d0) 
    s00_mat(:,:) = dcmplx(0.d0,0.d0) 

    return
  end subroutine alo_hamiltonian_zper_periodic

  subroutine unset_hamiltonian_zper_periodic

    implicit none
    integer :: ier

    deallocate(h00_mat,s00_mat,jtemp,stat=ier) 
    if( ier /= 0 ) then
       write(6,*) 'error deallocate: unset_hamiltonian_zper_periodic'
       stop
    end if

    return
  end subroutine unset_hamiltonian_zper_periodic

end module hamiltonian_zper

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@             Naoki WATANABE (Mizuho I.R.)                       @@ !
! @@             Nobutaka NISHIKAWA (Mizuho I.R.)                   @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine set_parameter(file_name)

  use condition_ini
  use gsp_parameter
  use rtbh_parameter
  use mod_mpi

  use ac_mpi_module

  implicit none

  character(50), intent(in) :: file_name
  real(8) :: st1,st2,stdel
  integer p
  integer, allocatable :: rankM(:), rankE(:)

  open(unit=16,file=file_tempout,position='append')
  write(16,*) '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'
  write(16,999) file_name
  write(16,*)
999 format(' +++++++++++ start: read file:: ',a30)
  call myclock(st1)
  close(16)

  call read_input_condition_ini(file_name)
  if( ham_model_ini .eq. 'gsp' ) then
     call read_gsp_parameter
     call read_input_tb_cordinate
     call alo_pair_ini
     call set_pair_ini(atom_parameter)
  end if
  if( ham_model_ini .eq. 'rtb_h' ) then
     call read_rtbh_parameter
     call read_input_tb_cordinate
  end if
  if( ham_model_ini .eq. 'input' ) then
     MPI%rankE = int(MPI%rank2/MPI%sizeM)
     MPI%rankM = mod(MPI%rank2,MPI%sizeM)
     allocate( rankM(0:MPI%sizeM-1), rankE(0:MPI%sizeE-1) )
     do p=0, MPI%sizeM-1
        rankM(p) = p + MPI%rankE*MPI%sizeM
     end do
     do p=0, MPI%sizeE-1
        rankE(p) = p*MPI%sizeM + MPI%rankM
     end do
     call BLACS_GET( 0, 0, MPI%SL_ID )
     call BLACS_GRIDMAP( MPI%SL_ID, rankM, 1, 1, MPI%sizeM )
     call MPI_Group_incl( MPI%group2, MPI%sizeM, rankM, MPI%groupM, MPI%info )
     call MPI_Comm_create( MPI_COMM_WORLD, MPI%groupM, MPI%commM, MPI%info )
     call MPI_Group_incl( MPI%group2, MPI%sizeE, rankE, MPI%groupE, MPI%info )
     call MPI_Comm_create( MPI_COMM_WORLD, MPI%groupE, MPI%commE, MPI%info )
     deallocate(rankM,rankE)

     call set_hamiltonian_temp(file_parameter1,file_parameter2,file_parameter3)
     call set_ksampling_tr
  end if
  if( ham_model_ini .eq. 'scf_accel' ) then
     call set_scf_accel
     call set_ksampling_tr
  end if

  open(unit=16,file=file_tempout,position='append')
  call myclock(st2)
  stdel=st2-st1
  write(16,*) '++++++++++++  end : read file'
  write(16,*) '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'
  write(16,*) '                t=',stdel
  close(16)

  return
end subroutine set_parameter

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine su_gf_trans(iteration_max,mat_max,eps,h00_mat,h01_mat,h10_mat           &
     ,s00_mat,s01_mat,s10_mat,w)

  use surface_green_function

  implicit none
  integer, intent(in) :: iteration_max,mat_max
  real(8), intent(in) :: eps
  complex(8), intent(in) :: h00_mat(mat_max,mat_max)
  complex(8), intent(in) :: h01_mat(mat_max,mat_max)
  complex(8), intent(in) :: h10_mat(mat_max,mat_max)
  complex(8), intent(in) :: s00_mat(mat_max,mat_max)
  complex(8), intent(in) :: s01_mat(mat_max,mat_max)
  complex(8), intent(in) :: s10_mat(mat_max,mat_max)
  complex(8), intent(in) :: w
  integer :: i_do,mat1_do,mat2_do
  integer :: i1_do,i2_do
  real(8) :: del_gr00_temp

  do i2_do=1,mat_max
     do i1_do=1,mat_max
        gr01(i1_do,i2_do)=w*s00_mat(i1_do,i2_do)-h00_mat(i1_do,i2_do)
     end do
  end do
  call inverse_mat1(mat_max,gr01,gr02)

  do i2_do=1,mat_max
     do i1_do=1,mat_max
        gr01(i1_do,i2_do)=-w*s10_mat(i1_do,i2_do)+h10_mat(i1_do,i2_do)
     end do
  end do
  call mat_mul(mat_max,gr02,gr01,tr1)
  do i2_do=1,mat_max
     do i1_do=1,mat_max
        gr01(i1_do,i2_do)=-w*s01_mat(i1_do,i2_do)+h01_mat(i1_do,i2_do)
     end do
  end do
  call mat_mul(mat_max,gr02,gr01,tr2)
  do i2_do=1,mat_max
     do i1_do=1,mat_max
        tm(i1_do,i2_do)=tr1(i1_do,i2_do)
     end do
  end do
  do i2_do=1,mat_max
     do i1_do=1,mat_max
        tm_temp(i1_do,i2_do)=tr2(i1_do,i2_do)
     end do
  end do

  do i2_do=1,mat_max
     do i1_do=1,mat_max
        gr02(i1_do,i2_do)=-w*s01_mat(i1_do,i2_do)+h01_mat(i1_do,i2_do)
     end do
  end do
  call mat_mul(mat_max,gr02,tm,gr01)
  do i2_do=1,mat_max
     do i1_do=1,mat_max
        gr01(i1_do,i2_do)=(w*s00_mat(i1_do,i2_do)-h00_mat(i1_do,i2_do))          &
             -gr01(i1_do,i2_do)
     end do
  end do
  call inverse_mat1(mat_max,gr01,gr00)
  do i2_do=1,mat_max
     do i1_do=1,mat_max
        temp(i1_do,i2_do)=gr00(i1_do,i2_do)
     end do
  end do

  do i_do=1,iteration_max

     call mat_mul(mat_max,tr1,tr2,gr01)
     call mat_mul(mat_max,tr2,tr1,gr02)
     do i2_do=1,mat_max
        do i1_do=1,mat_max
           gr01(i1_do,i2_do)=-gr01(i1_do,i2_do)-gr02(i1_do,i2_do)
        end do
        gr01(i2_do,i2_do)=dcmplx(1.d0,0.d0)+gr01(i2_do,i2_do)
     end do
     call inverse_mat1(mat_max,gr01,gr02)

     call mat_mul(mat_max,tr1,tr1,gr01)
     call mat_mul(mat_max,gr02,gr01,tr1)
     call mat_mul(mat_max,tr2,tr2,gr01)
     call mat_mul(mat_max,gr02,gr01,tr2)

     call mat_mul(mat_max,tm_temp,tr1,gr01)
     do i2_do=1,mat_max
        do i1_do=1,mat_max
           tm(i1_do,i2_do)=tm(i1_do,i2_do)+gr01(i1_do,i2_do)
        end do
     end do
     call mat_mul(mat_max,tm_temp,tr2,gr01)
     do i2_do=1,mat_max
        do i1_do=1,mat_max
           tm_temp(i1_do,i2_do)=gr01(i1_do,i2_do)
        end do
     end do

     do i2_do=1,mat_max
        do i1_do=1,mat_max
           gr02(i1_do,i2_do)=-w*s01_mat(i1_do,i2_do)+h01_mat(i1_do,i2_do)
        end do
     end do
     call mat_mul(mat_max,gr02,tm,gr01)
     do i2_do=1,mat_max
        do i1_do=1,mat_max
           gr01(i1_do,i2_do)=(w*s00_mat(i1_do,i2_do)-h00_mat(i1_do,i2_do))        &
                -gr01(i1_do,i2_do)
        end do
     end do
     call inverse_mat1(mat_max,gr01,gr00)

     del_gr00_temp=0.d0
     do mat2_do=1,mat_max
        do mat1_do=1,mat_max
           del_gr00_temp=max(del_gr00_temp                                        &
                ,cdabs(temp(mat1_do,mat2_do)-gr00(mat1_do,mat2_do)))
        end do
     end do
     if( del_gr00_temp < eps ) then
        exit
     else
        do i2_do=1,mat_max
           do i1_do=1,mat_max
              temp(i1_do,i2_do)=gr00(i1_do,i2_do)
           end do
        end do
     end if
     if( i_do == iteration_max ) then
        write(16,*) 'error transfer_su-gr-fu'
     end if

  end do

  do i2_do=1,mat_max
     do i1_do=1,mat_max
        gr02(i1_do,i2_do)=-w*s01_mat(i1_do,i2_do)+h01_mat(i1_do,i2_do)
     end do
  end do
  call mat_mul(mat_max,gr02,tm,gr01)
  do i2_do=1,mat_max
     do i1_do=1,mat_max
        gr01(i1_do,i2_do)=(w*s00_mat(i1_do,i2_do)-h00_mat(i1_do,i2_do))          &
             -gr01(i1_do,i2_do)
     end do
  end do
  call inverse_mat1(mat_max,gr01,gr00)

  return
end subroutine su_gf_trans

subroutine su_gf_direct(iteration_max,mat_max,eps,h00_mat,h01_mat,h10_mat          &
     ,s00_mat,s01_mat,s10_mat,w)

  use surface_green_function

  implicit none
  integer, intent(in) :: iteration_max,mat_max
  real(8), intent(in) :: eps
  complex(8), intent(in) :: h00_mat(mat_max,mat_max)
  complex(8), intent(in) :: h01_mat(mat_max,mat_max)
  complex(8), intent(in) :: h10_mat(mat_max,mat_max)
  complex(8), intent(in) :: s00_mat(mat_max,mat_max)
  complex(8), intent(in) :: s01_mat(mat_max,mat_max)
  complex(8), intent(in) :: s10_mat(mat_max,mat_max)
  complex(8), intent(in) :: w
  integer :: i_do,mat1_do,mat2_do
  integer :: i1_do,i2_do
  real(8) :: del_gr00_temp

  do i2_do=1,mat_max
     do i1_do=1,mat_max
        es0(i1_do,i2_do)=w*s00_mat(i1_do,i2_do)-h00_mat(i1_do,i2_do)
     end do
  end do
  do i2_do=1,mat_max
     do i1_do=1,mat_max
        e00(i1_do,i2_do)=w*s00_mat(i1_do,i2_do)-h00_mat(i1_do,i2_do)
     end do
  end do
  do i2_do=1,mat_max
     do i1_do=1,mat_max
        alp(i1_do,i2_do)=-w*s01_mat(i1_do,i2_do)+h01_mat(i1_do,i2_do)
     end do
  end do
  do i2_do=1,mat_max
     do i1_do=1,mat_max
        bet(i1_do,i2_do)=-w*s10_mat(i1_do,i2_do)+h10_mat(i1_do,i2_do)
     end do
  end do

  call inverse_mat1(mat_max,es0,gr00)
  do i2_do=1,mat_max
     do i1_do=1,mat_max
        temp(i1_do,i2_do)=gr00(i1_do,i2_do)
     end do
  end do

  do i_do=1,iteration_max
     call inverse_mat1(mat_max,e00,gr02)

     call mat_mul(mat_max,gr02,bet,gr01)
     call mat_mul(mat_max,alp,gr01,gr00)
     do i2_do=1,mat_max
        do i1_do=1,mat_max
           es0(i1_do,i2_do)=es0(i1_do,i2_do)-gr00(i1_do,i2_do)
        end do
     end do

     call mat_mul(mat_max,gr02,alp,gr01)
     call mat_mul(mat_max,gr02,bet,gr00)

     call mat_mul(mat_max,bet,gr01,gr02)
     do i2_do=1,mat_max
        do i1_do=1,mat_max
           e00(i1_do,i2_do)=e00(i1_do,i2_do)-gr02(i1_do,i2_do)
        end do
     end do
     call mat_mul(mat_max,alp,gr00,gr02)
     do i2_do=1,mat_max
        do i1_do=1,mat_max
           e00(i1_do,i2_do)=e00(i1_do,i2_do)-gr02(i1_do,i2_do)
        end do
     end do

     call mat_mul(mat_max,alp,gr01,gr02)
     do i2_do=1,mat_max
        do i1_do=1,mat_max
           alp(i1_do,i2_do)=gr02(i1_do,i2_do)
        end do
     end do

     call mat_mul(mat_max,bet,gr00,gr02)
     do i2_do=1,mat_max
        do i1_do=1,mat_max
           bet(i1_do,i2_do)=gr02(i1_do,i2_do)
        end do
     end do

     call inverse_mat1(mat_max,es0,gr00)

     del_gr00_temp=0.d0
     do mat2_do=1,mat_max
        do mat1_do=1,mat_max
           del_gr00_temp=max(del_gr00_temp                                        &
                ,cdabs(temp(mat1_do,mat2_do)-gr00(mat1_do,mat2_do)))
        end do
     end do
     if( del_gr00_temp < eps ) then
        exit
     else
        do i2_do=1,mat_max
           do i1_do=1,mat_max
              temp(i1_do,i2_do)=gr00(i1_do,i2_do)
           end do
        end do
     end if
     if( i_do == iteration_max ) then
        write(16,*) 'error direct_su-gr-fu',w,del_gr00_temp
     end if

  end do

  return
end subroutine su_gf_direct

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@             Naoki WATANABE (Mizuho I.R.)                       @@ !
! @@             Nobutaka NISHIKAWA (Mizuho I.R.)                   @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine dens_atom2cell_lr(dif_max_rho,iter)

  use scf_negf
  use fft
  use hamiltonian_sgf
  use hamiltonian_c
  use gf_se_c
  use constant
  use condition_ini
  use ac_mpi_module
  use mod_mpi

  implicit none
  real(8), intent(inout) :: dif_max_rho
  integer, intent(inout) :: iter

  integer, parameter :: i_write=20
  integer, parameter :: i_write_h=20
  integer, parameter :: i_write_p=1

  real(8) :: temp,rho_max
  integer :: gn,i1,i2,i3,i4,ii,gnj,i,ispin

  call calc_charge_open
  call dens_atom2cell_lr_accel(dif_max_rho,rho_max,iter)
  call ss_cube_charge

  if( iter_conv > 10 .and. iter_conv < 20 ) then
     i=iter
     call Hamiltonian__delDM(dif_max_rho,rho_max)
     if( dif_max_rho < eps_scf ) then
        iter=0
     else
        iter=1
     end if
     write(16,*)                                                                &
          '   ##################################################################'
     write(16,972) eps_scf
     write(16,973) i,dif_max_rho,rho_max
     write(16,*)                                                                &
          '   ##################################################################'
  end if

972 format('    ######  criterion:',f25.16,'                 ######')
973 format('    #dm###       ',i5,f25.16,f15.6,'  ###dm#')

  if( iter_conv > 20 .and. iter_conv < 30 ) then
     i=iter
     call Hamiltonian__delDR2(dif_max_rho,rho_max)
     if( dif_max_rho < eps_scf ) then
        iter=0
     else
        iter=1
     end if
     write(16,*)                                                                &
          '   ##################################################################'
     write(16,974) eps_scf
     write(16,975) i,dif_max_rho,rho_max
     write(16,*)                                                                &
          '   ##################################################################'
  end if

974 format('    ######  criterion:',f25.16,'                 ######')
975 format('    #dr###       ',i5,f25.16,f15.6,'  ###dr#')

  if( iter_conv == 1 ) then
     i=iter
     dif_max_rho=0.d0
     do i1=0,n_a-1
        do i2=0,n_b-1
           do i3=0,n_c-1
              gn=i1*n_b*n_c+i2*n_c+i3+1
              do ispin=1,ispin_pol_scf
                 temp=rho(gn,ispin)-rho_temp(gn,ispin)
                 rho(gn,ispin)=rho_temp(gn,ispin)+mixing_rho*temp
                 rho_temp(gn,ispin)=rho(gn,ispin)
                 if( dabs(temp) > dif_max_rho ) then
                    dif_max_rho=dabs(temp)
                    rho_max=rho_temp(gn,ispin)
                 end if
              end do
           end do
        end do
     end do

     if( dif_max_rho < eps_scf ) then
        iter=0
     else
        iter=1
     end if
     write(16,*)                                                                &
          '   ##################################################################'
     write(16,970) eps_scf
     write(16,971) i,dif_max_rho,rho_max
     write(16,*)                                                                &
          '   ##################################################################'
  end if

970 format('    ######  criterion:',f25.16,'                 ######')
971 format('    #dr###       ',i5,f25.16,f15.6,'  ###dr#')


  if( iter == 0 .or. (iter == 1 .and. mod(i,i_write_p) == 0)                     &
       .or. i == max_num_scf ) then
     write(16,*) '                               +++++ save Potential' 
     call dens_atom2cell_lr_save
  end if
  if( iter == 0 .or. (iter == 1 .and. mod(i,i_write_h) == 0)                     &
       .or. i == max_num_scf ) then
     write(16,*) '                               +++++ save Hamiltonian matrix' 
     call Hamiltonian__saveAM_ASCOT
  end if

  return
end subroutine dens_atom2cell_lr

subroutine dens_atom2cell_lr_accel(del_den,rho_max,iter)

  use scf_negf
  use fft
  use hamiltonian_sgf
  use hamiltonian_c
  use gf_se_c
  use constant
  use condition_ini
  use ac_mpi_module
  use mod_mpi

  implicit none
  real(8), intent(out) :: del_den,rho_max
  integer, intent(in) :: iter

  integer :: gn,i_con
  integer :: i1,i2,i3,ier,ispin
  integer :: i1_do,i2_do,i3_do
  real(8), allocatable :: temp_rho(:,:,:,:)
  complex(8), allocatable :: temp_rhols(:,:,:,:)

  rho_max=0.d0

  if( ispin_pol_scf < 4 ) then
     allocate(temp_rho(n_a,n_b,n_c,ispin_pol_scf),stat=ier)
  else
     allocate(temp_rhols(n_a,n_b,n_c,ispin_pol_scf),stat=ier)
  end if
  if( ier /= 0 ) then
     write(6,*) 'error allocate: dens_atom2cell_lr'
     stop
  end if

  do ispin=1,ispin_pol_scf
     do i1=1,n_a
        do i2=1,n_b
           do i3=1,n_c
              if( ispin_pol_scf < 4 ) then
                 temp_rho(i1,i2,i3,ispin)=0.d0
              else
                 temp_rhols(i1,i2,i3,ispin)=dcmplx(0.d0,0.d0)
              end if
           end do
        end do
     end do
  end do

  if( iter_conv > 10 .and. iter_conv < 20 ) then
     call DensityMatrix__update(del_den,iter)
  end if
  call Density__calc

  if( iter_conv > 20 .and. iter_conv < 30 ) then
     call Density__update(del_den,iter)
  end if
  if( ispin_pol_scf < 4 ) then
     call Hamiltonian__calcD__acbas(temp_rho)
  else
     call Hamiltonian__calcD_ls__acbas(temp_rhols)
  end if
  do ispin=1,ispin_pol_scf
     do i1=0,n_a-1
        do i2=0,n_b-1
           do i3=0,n_c-1
              if( i3+1 > l_cell_l_bound .and. i3+1 < r_cell_l_bound ) then
                 gn=i1*n_b*n_c+i2*n_c+i3+1
                 if( ispin_pol_scf < 4 ) then
                    rho(gn,ispin)=temp_rho(i1+1,i2+1,i3+1,ispin)
                 else
                    rhols(gn,ispin)=temp_rhols(i1+1,i2+1,i3+1,ispin)
                 end if
              end if
           end do
        end do
     end do
  end do

  call Hamiltonian__calcD__ac2as

  if( ispin_pol_scf < 4 ) then
     deallocate(temp_rho,stat=ier)
  else
     deallocate(temp_rhols,stat=ier)
  end if
  if( ier /= 0 ) then
     write(6,*) 'error allocate: dens_atom2cell_lr'
     stop
  end if

  return
end subroutine dens_atom2cell_lr_accel

subroutine dens_atom2cell_lr_save

  use scf_negf
  use fft
  use hamiltonian_sgf
  use hamiltonian_c
  use gf_se_c
  use constant
  use condition_ini
  use ac_mpi_module
  use mod_mpi

  implicit none
  integer :: gn,i_con
  integer :: i1,i2,i3,ier,ispin
  integer :: i1_do,i2_do,i3_do
  real(8), allocatable :: temp_rho(:,:,:,:)
  complex(8), allocatable :: temp_rhols(:,:,:,:)

  if( MPI%root ) then

     open(unit=36,file=file_parameter_out_pot)
     write(36,*) spin_switch_cc-1,ka_scf,kb_scf
     write(36,*)
     write(36,*) n_a,n_b,n_c
     write(36,*)
     write(36,*) cell_labc(1,1),cell_labc(1,2),cell_labc(1,3)
     write(36,*) cell_labc(2,1),cell_labc(2,2),cell_labc(2,3)
     write(36,*) cell_labc(3,1),cell_labc(3,2),cell_labc(3,3)
     write(36,*)
     write(36,*) cp_scf_c,'     = Chemical Potential'
     write(36,*) min_level_c,'     = minimum energy'
     write(36,*)
     do i1_do=0,n_a-1
        do i2_do=0,n_b-1
           do i3_do=0,n_c-1
              write(36,991) v_hartree(i1_do*n_b*n_c+i2_do*n_c+i3_do+1)
           end do
        end do
     end do
     write(36,*)
     do i1_do=0,n_a-1
        do i2_do=0,n_b-1
           do i3_do=0,n_c-1
              if( spin_switch_cc == 1 ) then
                 write(36,991) v_tot(i1_do*n_b*n_c+i2_do*n_c+i3_do+1,1)
              else
                 if( spin_switch_cc == 2 ) then
                    write(36,992) v_tot(i1_do*n_b*n_c+i2_do*n_c+i3_do+1,1)           &
                         ,v_tot(i1_do*n_b*n_c+i2_do*n_c+i3_do+1,2)
                 else
                    write(36,994) v_tot(i1_do*n_b*n_c+i2_do*n_c+i3_do+1,1)           &
                         ,v_tot(i1_do*n_b*n_c+i2_do*n_c+i3_do+1,2)           &
                         ,v_tot(i1_do*n_b*n_c+i2_do*n_c+i3_do+1,3)           &
                         ,v_tot(i1_do*n_b*n_c+i2_do*n_c+i3_do+1,4)
                 end if
              end if
           end do
        end do
     end do
     write(36,*)
     do i1_do=0,n_a-1
        do i2_do=0,n_b-1
           do i3_do=0,n_c-1
              if( spin_switch_cc == 1 ) then
                 write(36,991) rho(i1_do*n_b*n_c+i2_do*n_c+i3_do+1,1)
              else
                 if( spin_switch_cc == 2 ) then
                    write(36,992) rho(i1_do*n_b*n_c+i2_do*n_c+i3_do+1,1)           &
                         ,rho(i1_do*n_b*n_c+i2_do*n_c+i3_do+1,2)
                 else
                    write(36,994) rhols(i1_do*n_b*n_c+i2_do*n_c+i3_do+1,1)         &
                         ,rhols(i1_do*n_b*n_c+i2_do*n_c+i3_do+1,2)
                    write(36,994) rhols(i1_do*n_b*n_c+i2_do*n_c+i3_do+1,3)         &
                         ,rhols(i1_do*n_b*n_c+i2_do*n_c+i3_do+1,4)
                 end if
              end if
           end do
        end do
     end do
     close(36)

  end if

994 format(4d25.15)
993 format(3d25.15)
992 format(2d25.15)
991 format(1d25.15)

  return
end subroutine dens_atom2cell_lr_save

subroutine ss_cube_charge

  use scf_negf
  use fft
  use hamiltonian_sgf
  use hamiltonian_c
  use gf_se_c
  use constant
  use condition_ini
  use ac_mpi_module
  use mod_mpi

  implicit none
  real(8) :: temp,rho_max
  integer :: gn,i1,i2,i3,i4,ii,gnj,i,ispin


  if( MPI%root ) then

     if( ispin_pol_scf == 1 ) then
        open(unit=90,file='negf_den.cube')
        write(90,*) 'SYS1'
        write(90,*) 'SYS1'
        write(90,993) num_atom_scf,cell_lo(1),cell_lo(2),cell_lo(3)
        write(90,993) n_a,cell_dlabc(1,1),cell_dlabc(1,2),cell_dlabc(1,3)
        write(90,993) n_b,cell_dlabc(2,1),cell_dlabc(2,2),cell_dlabc(2,3)
        write(90,993) n_c,cell_dlabc(3,1),cell_dlabc(3,2),cell_dlabc(3,3)
        do i1=1,num_atom_scf
           write(90,992) atom_name_num(i1)                                      &
                ,vatom_q(i1)-sum_charge(i1)                               &
                ,atom_ro(i1,1),atom_ro(i1,2),atom_ro(i1,3)
        end do
        do i1=0,n_a-1
           do i2=0,n_b-1
              ii=n_c+6
              do i3=0,n_c-1,6
                 gnj=i1*n_b*n_c+i2*n_c+i3
                 ii=ii-6
                 if( ii >= 6 ) then
                    write(90,999) (2.0*rho(gnj+i4,1),i4=1,6)
                 else
                    if( ii == 5 ) write(90,998) (2.0*rho(gnj+i4,1),i4=1,ii)
                    if( ii == 4 ) write(90,997) (2.0*rho(gnj+i4,1),i4=1,ii)
                    if( ii == 3 ) write(90,996) (2.0*rho(gnj+i4,1),i4=1,ii)
                    if( ii == 2 ) write(90,995) (2.0*rho(gnj+i4,1),i4=1,ii)
                    if( ii == 1 ) write(90,994) (2.0*rho(gnj+i4,1),i4=1,ii)
                 end if
              end do
           end do
        end do
        close(90)
     end if
     if( ispin_pol_scf == 2 ) then
        open(unit=90,file='negf_den_up.cube')
        write(90,*) 'SYS1'
        write(90,*) 'SYS1'
        write(90,993) num_atom_scf,cell_lo(1),cell_lo(2),cell_lo(3)
        write(90,993) n_a,cell_dlabc(1,1),cell_dlabc(1,2),cell_dlabc(1,3)
        write(90,993) n_b,cell_dlabc(2,1),cell_dlabc(2,2),cell_dlabc(2,3)
        write(90,993) n_c,cell_dlabc(3,1),cell_dlabc(3,2),cell_dlabc(3,3)
        do i1=1,num_atom_scf
           write(90,992) atom_name_num(i1)                                      &
                ,vatom_q(i1)-sum_charge(i1)                               &
                ,atom_ro(i1,1),atom_ro(i1,2),atom_ro(i1,3)
        end do
        do i1=0,n_a-1
           do i2=0,n_b-1
              ii=n_c+6
              do i3=0,n_c-1,6
                 gnj=i1*n_b*n_c+i2*n_c+i3
                 ii=ii-6
                 if( ii >= 6 ) then
                    write(90,999) (rho(gnj+i4,1),i4=1,6)
                 else
                    if( ii == 5 ) write(90,998) (rho(gnj+i4,1),i4=1,ii)
                    if( ii == 4 ) write(90,997) (rho(gnj+i4,1),i4=1,ii)
                    if( ii == 3 ) write(90,996) (rho(gnj+i4,1),i4=1,ii)
                    if( ii == 2 ) write(90,995) (rho(gnj+i4,1),i4=1,ii)
                    if( ii == 1 ) write(90,994) (rho(gnj+i4,1),i4=1,ii)
                 end if
              end do
           end do
        end do
        close(90)
        open(unit=90,file='negf_den_do.cube')
        write(90,*) 'SYS1'
        write(90,*) 'SYS1'
        write(90,993) num_atom_scf,cell_lo(1),cell_lo(2),cell_lo(3)
        write(90,993) n_a,cell_dlabc(1,1),cell_dlabc(1,2),cell_dlabc(1,3)
        write(90,993) n_b,cell_dlabc(2,1),cell_dlabc(2,2),cell_dlabc(2,3)
        write(90,993) n_c,cell_dlabc(3,1),cell_dlabc(3,2),cell_dlabc(3,3)
        do i1=1,num_atom_scf
           write(90,992) atom_name_num(i1)                                      &
                ,vatom_q(i1)-sum_charge(i1)                               &
                ,atom_ro(i1,1),atom_ro(i1,2),atom_ro(i1,3)
        end do
        do i1=0,n_a-1
           do i2=0,n_b-1
              ii=n_c+6
              do i3=0,n_c-1,6
                 gnj=i1*n_b*n_c+i2*n_c+i3
                 ii=ii-6
                 if( ii >= 6 ) then
                    write(90,999) (rho(gnj+i4,2),i4=1,6)
                 else
                    if( ii == 5 ) write(90,998) (rho(gnj+i4,2),i4=1,ii)
                    if( ii == 4 ) write(90,997) (rho(gnj+i4,2),i4=1,ii)
                    if( ii == 3 ) write(90,996) (rho(gnj+i4,2),i4=1,ii)
                    if( ii == 2 ) write(90,995) (rho(gnj+i4,2),i4=1,ii)
                    if( ii == 1 ) write(90,994) (rho(gnj+i4,2),i4=1,ii)
                 end if
              end do
           end do
        end do
        close(90)
     end if
     if( ispin_pol_scf == 4 ) then
        open(unit=90,file='negf_den_to.cube')
        write(90,*) 'SYS1'
        write(90,*) 'SYS1'
        write(90,993) num_atom_scf,cell_lo(1),cell_lo(2),cell_lo(3)
        write(90,993) n_a,cell_dlabc(1,1),cell_dlabc(1,2),cell_dlabc(1,3)
        write(90,993) n_b,cell_dlabc(2,1),cell_dlabc(2,2),cell_dlabc(2,3)
        write(90,993) n_c,cell_dlabc(3,1),cell_dlabc(3,2),cell_dlabc(3,3)
        do i1=1,num_atom_scf
           write(90,992) atom_name_num(i1)                                      &
                ,vatom_q(i1)-sum_charge(i1)                               &
                ,atom_ro(i1,1),atom_ro(i1,2),atom_ro(i1,3)
        end do
        do i1=0,n_a-1
           do i2=0,n_b-1
              ii=n_c+6
              do i3=0,n_c-1,6
                 gnj=i1*n_b*n_c+i2*n_c+i3
                 ii=ii-6
                 if( ii >= 6 ) then
                    write(90,999) (dreal(rhols(gnj+i4,1)+rhols(gnj+i4,4)),i4=1,6)
                 else
                    if( ii == 5 ) write(90,998)                                    &
                         (dreal(rhols(gnj+i4,1)+rhols(gnj+i4,4)),i4=1,ii)
                    if( ii == 4 ) write(90,997)                                    &
                         (dreal(rhols(gnj+i4,1)+rhols(gnj+i4,4)),i4=1,ii)
                    if( ii == 3 ) write(90,996)                                    &
                         (dreal(rhols(gnj+i4,1)+rhols(gnj+i4,4)),i4=1,ii)
                    if( ii == 2 ) write(90,995)                                    &
                         (dreal(rhols(gnj+i4,1)+rhols(gnj+i4,4)),i4=1,ii)
                    if( ii == 1 ) write(90,994)                                    &
                         (dreal(rhols(gnj+i4,1)+rhols(gnj+i4,4)),i4=1,ii)
                 end if
              end do
           end do
        end do
        close(90)
        open(unit=90,file='negf_den_sz.cube')
        write(90,*) 'SYS1'
        write(90,*) 'SYS1'
        write(90,993) num_atom_scf,cell_lo(1),cell_lo(2),cell_lo(3)
        write(90,993) n_a,cell_dlabc(1,1),cell_dlabc(1,2),cell_dlabc(1,3)
        write(90,993) n_b,cell_dlabc(2,1),cell_dlabc(2,2),cell_dlabc(2,3)
        write(90,993) n_c,cell_dlabc(3,1),cell_dlabc(3,2),cell_dlabc(3,3)
        do i1=1,num_atom_scf
           write(90,992) atom_name_num(i1)                                      &
                ,vatom_q(i1)-sum_charge(i1)                               &
                ,atom_ro(i1,1),atom_ro(i1,2),atom_ro(i1,3)
        end do
        do i1=0,n_a-1
           do i2=0,n_b-1
              ii=n_c+6
              do i3=0,n_c-1,6
                 gnj=i1*n_b*n_c+i2*n_c+i3
                 ii=ii-6
                 if( ii >= 6 ) then
                    write(90,999) (dreal(rhols(gnj+i4,1)-rhols(gnj+i4,4)),i4=1,6)
                 else
                    if( ii == 5 ) write(90,998)                                    &
                         (dreal(rhols(gnj+i4,1)-rhols(gnj+i4,4)),i4=1,ii)
                    if( ii == 4 ) write(90,997)                                    &
                         (dreal(rhols(gnj+i4,1)-rhols(gnj+i4,4)),i4=1,ii)
                    if( ii == 3 ) write(90,996)                                    &
                         (dreal(rhols(gnj+i4,1)-rhols(gnj+i4,4)),i4=1,ii)
                    if( ii == 2 ) write(90,995)                                    &
                         (dreal(rhols(gnj+i4,1)-rhols(gnj+i4,4)),i4=1,ii)
                    if( ii == 1 ) write(90,994)                                    &
                         (dreal(rhols(gnj+i4,1)-rhols(gnj+i4,4)),i4=1,ii)
                 end if
              end do
           end do
        end do
        close(90)
        open(unit=90,file='negf_den_sx.cube')
        write(90,*) 'SYS1'
        write(90,*) 'SYS1'
        write(90,993) num_atom_scf,cell_lo(1),cell_lo(2),cell_lo(3)
        write(90,993) n_a,cell_dlabc(1,1),cell_dlabc(1,2),cell_dlabc(1,3)
        write(90,993) n_b,cell_dlabc(2,1),cell_dlabc(2,2),cell_dlabc(2,3)
        write(90,993) n_c,cell_dlabc(3,1),cell_dlabc(3,2),cell_dlabc(3,3)
        do i1=1,num_atom_scf
           write(90,992) atom_name_num(i1)                                      &
                ,vatom_q(i1)-sum_charge(i1)                               &
                ,atom_ro(i1,1),atom_ro(i1,2),atom_ro(i1,3)
        end do
        do i1=0,n_a-1
           do i2=0,n_b-1
              ii=n_c+6
              do i3=0,n_c-1,6
                 gnj=i1*n_b*n_c+i2*n_c+i3
                 ii=ii-6
                 if( ii >= 6 ) then
                    write(90,999) (dreal(rhols(gnj+i4,2)+rhols(gnj+i4,3)),i4=1,6)
                 else
                    if( ii == 5 ) write(90,998)                                    &
                         (dreal(rhols(gnj+i4,2)+rhols(gnj+i4,3)),i4=1,ii)
                    if( ii == 4 ) write(90,997)                                    &
                         (dreal(rhols(gnj+i4,2)+rhols(gnj+i4,3)),i4=1,ii)
                    if( ii == 3 ) write(90,996)                                    &
                         (dreal(rhols(gnj+i4,2)+rhols(gnj+i4,3)),i4=1,ii)
                    if( ii == 2 ) write(90,995)                                    &
                         (dreal(rhols(gnj+i4,2)+rhols(gnj+i4,3)),i4=1,ii)
                    if( ii == 1 ) write(90,994)                                    &
                         (dreal(rhols(gnj+i4,2)+rhols(gnj+i4,3)),i4=1,ii)
                 end if
              end do
           end do
        end do
        close(90)
        open(unit=90,file='negf_den_sy.cube')
        write(90,*) 'SYS1'
        write(90,*) 'SYS1'
        write(90,993) num_atom_scf,cell_lo(1),cell_lo(2),cell_lo(3)
        write(90,993) n_a,cell_dlabc(1,1),cell_dlabc(1,2),cell_dlabc(1,3)
        write(90,993) n_b,cell_dlabc(2,1),cell_dlabc(2,2),cell_dlabc(2,3)
        write(90,993) n_c,cell_dlabc(3,1),cell_dlabc(3,2),cell_dlabc(3,3)
        do i1=1,num_atom_scf
           write(90,992) atom_name_num(i1)                                      &
                ,vatom_q(i1)-sum_charge(i1)                               &
                ,atom_ro(i1,1),atom_ro(i1,2),atom_ro(i1,3)
        end do
        do i1=0,n_a-1
           do i2=0,n_b-1
              ii=n_c+6
              do i3=0,n_c-1,6
                 gnj=i1*n_b*n_c+i2*n_c+i3
                 ii=ii-6
                 if( ii >= 6 ) then
                    write(90,999) (dimag(rhols(gnj+i4,2)-rhols(gnj+i4,3)),i4=1,6)
                 else
                    if( ii == 5 ) write(90,998)                                    &
                         (dimag(rhols(gnj+i4,2)-rhols(gnj+i4,3)),i4=1,ii)
                    if( ii == 4 ) write(90,997)                                    &
                         (dimag(rhols(gnj+i4,2)-rhols(gnj+i4,3)),i4=1,ii)
                    if( ii == 3 ) write(90,996)                                    &
                         (dimag(rhols(gnj+i4,2)-rhols(gnj+i4,3)),i4=1,ii)
                    if( ii == 2 ) write(90,995)                                    &
                         (dimag(rhols(gnj+i4,2)-rhols(gnj+i4,3)),i4=1,ii)
                    if( ii == 1 ) write(90,994)                                    &
                         (dimag(rhols(gnj+i4,2)-rhols(gnj+i4,3)),i4=1,ii)
                 end if
              end do
           end do
        end do
        close(90)
     end if
  end if

999 format(f13.6,f13.6,f13.6,f13.6,f13.6,f13.6)
998 format(f13.6,f13.6,f13.6,f13.6,f13.6)
997 format(f13.6,f13.6,f13.6,f13.6)
996 format(f13.6,f13.6,f13.6)
995 format(f13.6,f13.6)
994 format(f13.6)
993 format(i4,f13.6,f13.6,f13.6)
992 format(i4,f13.6,f13.6,f13.6,f13.6)

  return
end subroutine ss_cube_charge

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@             Naoki WATANABE (Mizuho I.R.)                       @@ !
! @@             Nobutaka NISHIKAWA (Mizuho I.R.)                   @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine scf_main_negf_ac

  use scf_negf
  use fft
  use dft
  use condition_ini
  use hamiltonian_sgf
  use hamiltonian_c
  use hamiltonian_temp
  use gf_se_c
  use constant
  use ac_mpi_module
  use mod_mpi

  implicit none

  integer :: i_do,iter,cutene_vt_ok,ispin
  real(8) :: dif_max_rho
  real(8) :: st1,st2,stdel

  integer :: i_conv_ok,i_temp,ier,i1_do,i2_do,i3_do,kt,ic_spin

  real(8) :: qx_scf,qy_scf,qq_con
  type(MPI_MatDesc) :: descCC, descLL, descRR, descCR, descCL

  call MPI__setupMatDesc( descCC, m_mat_max_c,m_mat_max_c )
  call MPI__setupMatDesc( descLL, mat_max_ll, mat_max_ll )
  call MPI__setupMatDesc( descRR, mat_max_rr, mat_max_rr )
  call MPI__setupMatDesc( descCL, m_mat_max_c, mat_max_ll )
  call MPI__setupMatDesc( descCR, m_mat_max_c, mat_max_rr )

  if( ispin_pol_scf /= 2 ) then
     ic_spin=1
  else
     ic_spin=2
  end if

  call alo_mod_mpi(i_total_omega,ic_spin,kt_num,file_selfenergy_scf)

  call alo_scf_ham(descCC)

  call alo_ham_temp_ham(descCC,descLL,descRR)

  if( ft_switch == 'f_2_ft' .or. ft_switch == 'fft' .or. ft_switch == 'fftw' ) then
     call set_fft
  else
     call alo_dft(n_a,n_b,2)
  end if

  open(unit=16,file=file_tempout,position='append')
  write(16,*)
  write(16,*) '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'
  call myclock(st1)
  close(16)

  call alo_density_ini
  call fourier_pot

  if( restart_onoff /= 'on' ) then
     call iteration_ini
  end if

  call calc_charge_open

  open(unit=16,file=file_tempout,position='append')
  write(16,*) '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'
  call myclock(st2)
  stdel=st2-st1
  write(16,*) '                t=',stdel
  close(16)

  if( iter_conv > 10 .and. iter_conv < 20 ) then
     call DensityMatrix__update(dif_max_rho,0)
  else
     if( iter_conv > 20 .and. iter_conv < 30 ) then
        call Hamiltonian__calcD__ac2as
        call Density__update(dif_max_rho,0)
     end if
  end if

  call Density__deallocate2
  call Param__deallocate2

  !!call output_tmp
  !!if(MPI%root) then
  !!   write(*,*) 'time (negf scf) (sec)'
  !!   call output_time
  !!end if

  gra_onoff='off'
  cutene_vt_ok=0

  i_conv_ok=1

  open(unit=16,file=file_tempout,position='append')
  write(16,*)
  write(16,*) '**************************************************************'
  write(16,*) '************ start iteration:'
  write(16,*) '**************************************************************'
  close(16)

  do i_do=1,max_num_scf

     !!if(MPI%root) write(*,*) 'i_do', i_do

     open(unit=16,file=file_tempout,position='append')
     write(16,*)
     write(16,*) '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'
     write(16,*) '++++++++++++ iterations:',i_do
     write(16,*) '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'
     close(16)

     open(unit=16,file=file_tempout,position='append')
     call myclock(st1)

     cutene_vt_ok=0
     iter=i_do

     call alo_density_2
     if( hartree_switch == 0 ) then
        call alo_use_scf_4
        call cal_vhart_easier
        call unset_use_scf_4
     else
        call cal_vhartree
     end if
     call unset_density_21

     call alo_use_scf_3(m_mat_max_c)
     call cal_vother(cutene_vt_ok)

     call cal_hamiltonian_accel
     call unset_use_scf_32

     call myclock(st2)
     stdel=st2-st1
     write(16,*) '                t=',stdel
     close(16)

     iter=i_do
     call alo_density_1(descCC)


     do kt=1,ka_scf*kb_scf
        if( ksw_po_kt_scf(kt) == 0 ) then
           cycle
        end if

        qx_scf=po_kt_scf(2,kt)
        qy_scf=po_kt_scf(3,kt)
        qq_con=dfloat(ksw_po_kt_scf(kt))

        open(unit=16,file=file_tempout,position='append')
        write(16,*) '         >>>>>>>>>>>>    k:',kt,'<<<<<<<<<<<<'
        close(16)

        call set_ham_temp_ham_l(descLL,qx_scf,qy_scf)
        call set_ham_temp_ham_r(descRR,qx_scf,qy_scf)
        call set_ham_scf_ham_c (descCC,descLL,descRR,qx_scf,qy_scf)

        do ispin=1,ic_spin
           if( file_selfenergy_onoff /= 'on' .and. i_do == 1 ) then
              call cal_gf_se_c_scf(descCC,descCL,descLL,descCR,descRR,ispin,kt)
           else
              call cal_gf_se_read_scf(descCC,ispin,kt)
           end if
           !!call cal_gf_se_c2_scf(descCC,descCL,descLL,descCR,descRR,ispin,kt)
        end do

        do ispin=1,ic_spin
           call MPI__Allreduce_MatrixE_ASCOT( descCC, cdens(:,:,ispin) )
           call MPI__Allreduce_MatrixE_ASCOT( descCC, edens(:,:,ispin) )
        end do

        call Hamiltonian__calcD__as2ac(descCC,qx_scf,qy_scf,qq_con,kt)
     end do


     open(unit=16,file=file_tempout,position='append')
     call myclock(st1)

     call dens_atom2cell_lr(dif_max_rho,iter)
     call unset_density_1

     call myclock(st2)
     stdel=st2-st1
     write(16,*) '                t=',stdel

     if( (iter_conv == 1 .or. iter_conv > 10)                                   &
          .and. iter == 0 .and. cutene_vt_ok == 0 ) then
        write(16,*)
        write(16,*)                                                              &
             '**************************************************************'
        write(16,*) '************   end iterations:',i_do
        write(16,*)                                                              &
             '**************************************************************'
        i_conv_ok=0
     end if
100  continue

     close(16)

     if( i_conv_ok == 0 ) then
        exit
     end if

     !!if(MPI%root) then
     !!   write(*,*) 'time (negf scf) (sec)', i_do
     !!   call output_time
     !!end if

  end do

  if( force_calc_onoff == 'on' ) then
     call Force__calc__negf
  end if

  call unset_density_ini
  gra_onoff='on'

  call unset_scf_accel_parameter
  call dealo_ham_temp_ham

  if( ft_switch == 'f_2_ft' .or. ft_switch == 'fft' .or. ft_switch == 'fftw' ) then
     call unset_fft
  else
     call unset_dft
  end if

  call dealo_mod_mpi

  call Base__deallocate3

  call MPI__unsetMatDesc( descCC )
  call MPI__unsetMatDesc( descLL )
  call MPI__unsetMatDesc( descRR )
  call MPI__unsetMatDesc( descCL )
  call MPI__unsetMatDesc( descCR )

  return
end subroutine scf_main_negf_ac

subroutine scf_main_unset_negf

  use scf_negf

  implicit none

  call unset_scf_ham
  call unset_scf_accel_parameter1

  return
end subroutine scf_main_unset_negf

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine set_hami_c_cc_input(ispin)

  use condition_ini
  use hamiltonian_sgf
  use hamiltonian_c
  use hamiltonian_temp
  use constant
  use mod_mpi

  implicit none
  include 'mpif.h'
  integer, intent(in) :: ispin
  integer :: i2_do,i3_do

  do i3_do=1,m_mat_max_c
     do i2_do=1,m_mat_max_c
        hcc_mat(i2_do,i3_do)=hcc_t(ispin,i2_do,i3_do)
     end do
  end do
  do i3_do=1,m_mat_max_c
     do i2_do=1,m_mat_max_c
        scc_mat(i2_do,i3_do)=scc_t(i2_do,i3_do)
     end do
  end do

  return
end subroutine set_hami_c_cc_input

subroutine set_hami_c_ll_input(ispin)

  use condition_ini
  use hamiltonian_sgf
  use hamiltonian_c
  use hamiltonian_e
  use hamiltonian_temp
  use scf_negf
  use constant
  use mod_mpi

  implicit none
  include 'mpif.h'
  integer, intent(in) :: ispin
  integer :: i_do,j_do,i2_do,i3_do

  do i3_do=1,mat_max_ll
     do i2_do=1,mat_max_ll
        hcl_mat(i3_do,i2_do)=h01_l_t(ispin,i3_do,i2_do)
     end do
  end do

  do i3_do=1,mat_max_ll
     do i2_do=1,mat_max_ll
        scl_mat(i3_do,i2_do)=s01_l_t(i3_do,i2_do)
     end do
  end do

  return
end subroutine set_hami_c_ll_input

subroutine set_hami_c_rr_input(ispin)

  use condition_ini
  use hamiltonian_sgf
  use hamiltonian_c
  use hamiltonian_e
  use hamiltonian_temp
  use scf_negf
  use constant
  use mod_mpi

  implicit none
  include 'mpif.h'
  integer, intent(in) :: ispin
  integer :: i_do,j_do,i2_do,i3_do

  do i3_do=1,mat_max_rr
     do i2_do=1,mat_max_rr
        hcr_mat(m_mat_max_c-m_mat_max_r+i3_do,i2_do)                             &
             =h01_r_t(ispin,i3_do,i2_do)
     end do
  end do

  do i3_do=1,mat_max_rr
     do i2_do=1,mat_max_rr
        scr_mat(m_mat_max_c-m_mat_max_r+i3_do,i2_do)                             &
             =s01_r_t(i3_do,i2_do)
     end do
  end do

  return
end subroutine set_hami_c_rr_input

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Naoki WATANABE, Nobutaka NISHIKAWA (Mizuho I.R.)   @@ !
! @@             Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine FFT__forward( nx, ny, nz, data_in, data_out )
  use ac_misc_module
  implicit none

  integer, intent(in)  :: nx, ny, nz
  real(8), intent(in)  :: data_in (nx,ny,nz)
  real(8), intent(out) :: data_out(2*(nx/2+1),ny,nz)

  integer(8)           :: pf
  integer, parameter   :: FFTW_ESTIMATE = 64 

  call dfftw_plan_dft_r2c_3d( pf, &
       nx, ny, nz, data_in, data_out, FFTW_ESTIMATE )
  call dfftw_execute( pf )
  call dfftw_destroy_plan( pf )

  return
end subroutine FFT__forward

subroutine FFT__backward( nx, ny, nz, data_in, data_out )
  use ac_misc_module

  implicit none
  integer, intent(in)    :: nx, ny, nz
  real(8), intent(inout) :: data_in (2*(nx/2+1),ny,nz)
  real(8), intent(out)   :: data_out(nx,ny,nz)

  integer(8)             :: pb
  integer, parameter :: FFTW_ESTIMATE = 64 

  call dfftw_plan_dft_c2r_3d( pb, &
       nx, ny, nz, data_in, data_out, FFTW_ESTIMATE )
  call dfftw_execute( pb )
  call dfftw_destroy_plan( pb )

  return
end subroutine FFT__backward

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine make_scf_omega_c1(i_bios_minomega,cp_l,cp_r)

  use scf_negf
  use constant
  use mod_mpi

  implicit none
  integer, intent(in) :: i_bios_minomega
  real(8), intent(in) :: cp_l,cp_r

  integer :: i1_do,i2_do,i_w_num
  real(8) :: temp,th1,th2,temp_om,temp_del
  complex(8) :: w_int

  pai=datan(1.d0)*4.d0

  !                       ------------------------------------                       !

  i_total_omega=0
  do i1_do=1,om_block_num_scf
     do i2_do=1,3
        i_total_omega=i_total_omega+num_om_par_scf(i1_do,i2_do)
     end do
     i_total_omega=i_total_omega
  end do

  if( scf_bias == 'on' ) then
     i_total_omega=i_total_omega+num_om_bias
  end if

  call alo_scf_negf_omega2

  temp=.5d0/pai

  i_w_num=0
  do i1_do=1,om_block_num_scf
     if( num_om_par_scf(i1_do,1) /= 0 ) then
        i_w_num=i_w_num+1
        w_int=dcmplx(0.d0,omega_if_scf(i1_do,4)-omega_if_scf(i1_do,3))           &
             /dfloat(num_om_par_scf(i1_do,1))
        omega_scf(i_w_num)=dcmplx(omega_if_scf(i1_do,1)                          &
             ,omega_if_scf(i1_do,3))+w_int*.5d0
        omega_weight_scf(i_w_num)=w_int*dcmplx(0.d0,temp)
        i_bios_omega_scf(i_w_num)=1
        do i2_do=1,num_om_par_scf(i1_do,1)-1
           i_w_num=i_w_num+1
           omega_scf(i_w_num)=omega_scf(i_w_num-1)+w_int
           omega_weight_scf(i_w_num)=w_int*dcmplx(0.d0,temp)
           i_bios_omega_scf(i_w_num)=1
        end do
     end if

     w_int=dcmplx(omega_if_scf(i1_do,2)-omega_if_scf(i1_do,1),0.d0)             &
          /dfloat(num_om_par_scf(i1_do,2))
     i_w_num=i_w_num+1
     omega_scf(i_w_num)=dcmplx(omega_if_scf(i1_do,1)                            &
          ,omega_if_scf(i1_do,4))+w_int*.5d0
     omega_weight_scf(i_w_num)=w_int*dcmplx(0.d0,temp)
     i_bios_omega_scf(i_w_num)=1
     do i2_do=1,num_om_par_scf(i1_do,2)-1
        i_w_num=i_w_num+1
        omega_scf(i_w_num)=omega_scf(i_w_num-1)+w_int
        omega_weight_scf(i_w_num)=w_int*dcmplx(0.d0,temp)
        i_bios_omega_scf(i_w_num)=1
     end do

     if( num_om_par_scf(i1_do,3) /= 0) then
        if( om_con_method_scf(i1_do) == 'linear' ) then
           w_int=dcmplx(0.d0,omega_if_scf(i1_do,3)-omega_if_scf(i1_do,4))         &
                /dfloat(num_om_par_scf(i1_do,3))
           i_w_num=i_w_num+1
           omega_scf(i_w_num)=dcmplx(omega_if_scf(i1_do,2)                        &
                ,omega_if_scf(i1_do,4))+w_int*.5d0
           omega_weight_scf(i_w_num)=w_int*dcmplx(0.d0,temp)
           i_bios_omega_scf(i_w_num)=1
           do i2_do=1,num_om_par_scf(i1_do,3)-1
              i_w_num=i_w_num+1
              omega_scf(i_w_num)=omega_scf(i_w_num-1)+w_int
              omega_weight_scf(i_w_num)=w_int*dcmplx(0.d0,temp)
              i_bios_omega_scf(i_w_num)=1
           end do
        else
           if( om_con_method_scf(i1_do) == 'log' ) then
              th1=dlog(omega_if_scf(i1_do,4))
              th2=dlog(omega_if_scf(i1_do,3))
              temp_del=(th2-th1)/dfloat(num_om_par_scf(i1_do,3))
              i_w_num=i_w_num+1
              temp_om=th1+temp_del*.5d0
              omega_scf(i_w_num)=dcmplx(omega_if_scf(i1_do,2),dexp(temp_om))
              omega_weight_scf(i_w_num)                                            &
                   =dcmplx(0.d0,temp_del*dexp(temp_om))*dcmplx(0.d0,temp)
              i_bios_omega_scf(i_w_num)=1
              do i2_do=1,num_om_par_scf(i1_do,3)-1
                 i_w_num=i_w_num+1
                 temp_om=temp_om+temp_del
                 omega_scf(i_w_num)=dcmplx(omega_if_scf(i1_do,2),dexp(temp_om))
                 omega_weight_scf(i_w_num)                                          &
                      =dcmplx(0.d0,temp_del*dexp(temp_om))*dcmplx(0.d0,temp)
                 i_bios_omega_scf(i_w_num)=1
              end do
           else
              write(6,*) 'error: method omega'
              stop
           end if
        end if
     end if

  end do

  if( scf_bias == 'on' ) then
     temp=0.5d0/pai
     i_w_num=i_w_num+1
     w_int=dcmplx((dabs(cp_l-cp_r)+om_del_bias)/dfloat(num_om_bias),0.d0)
     omega_scf(i_w_num)=dcmplx(omega_if_scf(i_bios_minomega,2),om_im_bias)      &
          +w_int*.5d0
     omega_weight_scf(i_w_num)=w_int*dcmplx(0.d0,-temp)
     i_bios_omega_scf(i_w_num)=2
     do i2_do=1,num_om_bias-1
        i_w_num=i_w_num+1
        omega_scf(i_w_num)=omega_scf(i_w_num-1)+w_int
        omega_weight_scf(i_w_num)=w_int*dcmplx(0.d0,-temp)
        i_bios_omega_scf(i_w_num)=2
     end do
  end if

  !                       ------------------------------------                       !

  open(unit=16,file=file_tempout,position='append')
  write(16,*)
  write(16,*) '--------------------------------------------------------------'
  write(16,*) '------------   Integration contour:'
  write(16,*) '--------------------------------------------------------------'
  do i1_do=1,i_total_omega
     write(16,999) i1_do,i_bios_omega_scf(i1_do),omega_scf(i1_do)
  end do
  write(16,*) '--------------------------------------------------------------'
  write(16,*)
999 format(i5,i4,d25.15,'  + i',d23.15)
  close(16)

  return
end subroutine make_scf_omega_c1

subroutine make_scf_omega_c2(cp_l,cp_r)

  use scf_negf
  use constant
  use mod_mpi

  implicit none
  real(8), intent(in) :: cp_l,cp_r

  integer :: i1_do,i2_do,i_w_num
  real(8) :: temp
  complex(8) :: w_int
  real(8) :: alp1r,alp1i,alp2r,alp2i,a,b,th1,th2,th,th_del,cp
  integer :: i_matsubara

  pai=datan(1.d0)*4.d0

  !                       ------------------------------------                       !

  cp=cp_l
  if( cp > cp_r ) then
     cp=cp_r
  end if
  if( scf_bias == 'on' ) then
     cp=cp-om_del_bias
  end if

  do i2_do=1,100
     i_matsubara=i2_do-1
     th=dfloat(2*i_matsubara+1)*pai*omega_tem(1)
     if( th > omega_if_scf(1,4) )then
        exit
     end if
  end do

  i_total_omega=0
  do i1_do=1,om_block_num_scf
     do i2_do=1,2
        i_total_omega=i_total_omega+num_om_par_scf(i1_do,i2_do)
     end do
     i_total_omega=i_total_omega+i_matsubara
  end do

  if( scf_bias == 'on' ) then
     i_total_omega=i_total_omega+num_om_bias
  end if

  call alo_scf_negf_omega2

  temp=.5d0/pai

  alp1r=omega_if_scf(1,1)
  alp1i=omega_if_scf(1,3)
  alp2r=omega_if_scf(1,2)-omega_gamm(1)
  alp2i=omega_if_scf(1,4)

  b=(alp1r*alp1r+alp1i*alp1i-alp2r*alp2r-alp2i*alp2i)*.5d0/(alp1r-alp2r)
  a=dsqrt(alp1i*alp1i+(alp1r-b)*(alp1r-b))
  th1=dacos((alp1r-b)/a)
  th2=dasin(alp2i/a)

  th_del=(th2-th1)/(dfloat(num_om_par_scf(1,1)-1))
  th=th1
  i_w_num=1
  omega_scf(i_w_num)=dcmplx(a*dcos(th)+b,a*dsin(th))
  omega_weight_scf(i_w_num)                                                    &
       =dcmplx(0.d0,temp*a*th_del*.5d0)*dcmplx(-dsin(th),dcos(th))              &
       /(cdexp((omega_scf(i_w_num)-dcmplx(cp,0.d0))/dcmplx(omega_tem(1),0.d0)) &
       +dcmplx(1.d0,0.d0))
  i_bios_omega_scf(i_w_num)=1
  do i2_do=1,num_om_par_scf(1,1)-1
     i_w_num=i_w_num+1
     th=th+th_del
     omega_scf(i_w_num)=dcmplx(a*dcos(th)+b,a*dsin(th))
     omega_weight_scf(i_w_num)                                                  &
          =dcmplx(0.d0,temp*a*th_del)*dcmplx(-dsin(th),dcos(th))                   &
          /(cdexp((omega_scf(i_w_num)-dcmplx(cp,0.d0))/dcmplx(omega_tem(1),0.d0)) &
          +dcmplx(1.d0,0.d0))
     i_bios_omega_scf(i_w_num)=1
  end do
  omega_weight_scf(i_w_num)=omega_weight_scf(i_w_num)*.5d0

  w_int=dcmplx(omega_gamm(1)/dfloat(num_om_par_scf(1,2)),0.d0)
  i_w_num=i_w_num+1
  omega_scf(i_w_num)=dcmplx(omega_if_scf(1,2)-omega_gamm(1),omega_if_scf(1,4)) &
       +w_int*dcmplx(0.5d0,0.d0)
  omega_weight_scf(i_w_num)=w_int*dcmplx(0.d0,temp)                            &
       /(cdexp((omega_scf(i_w_num)-dcmplx(cp,0.d0))/dcmplx(omega_tem(1),0.d0)) &
       +dcmplx(1.d0,0.d0))
  i_bios_omega_scf(i_w_num)=1
  do i2_do=1,num_om_par_scf(1,2)-1
     i_w_num=i_w_num+1
     omega_scf(i_w_num)=omega_scf(i_w_num-1)+w_int
     omega_weight_scf(i_w_num)=w_int*dcmplx(0.d0,temp)                          &
          /(cdexp((omega_scf(i_w_num)-dcmplx(cp,0.d0))/dcmplx(omega_tem(1),0.d0)) &
          +dcmplx(1.d0,0.d0))
     i_bios_omega_scf(i_w_num)=1
  end do

  do i2_do=i_matsubara-1,0,-1
     i_w_num=i_w_num+1
     th=dfloat(2*i2_do+1)*pai*omega_tem(1)
     omega_scf(i_w_num)=dcmplx(cp,th)
     omega_weight_scf(i_w_num)=dcmplx(omega_tem(1),0.d0)
     i_bios_omega_scf(i_w_num)=1
  end do

  if( scf_bias == 'on' ) then
     temp=0.5d0/pai
     i_w_num=i_w_num+1
     w_int=dcmplx((dabs(cp_l-cp_r)+om_del_bias)/dfloat(num_om_bias),0.d0)
     omega_scf(i_w_num)=dcmplx(cp,om_im_bias)+w_int*.5d0
     omega_weight_scf(i_w_num)=w_int*dcmplx(0.d0,-temp)
     i_bios_omega_scf(i_w_num)=2
     do i2_do=1,num_om_bias-1
        i_w_num=i_w_num+1
        omega_scf(i_w_num)=omega_scf(i_w_num-1)+w_int
        omega_weight_scf(i_w_num)=w_int*dcmplx(0.d0,-temp)
        i_bios_omega_scf(i_w_num)=2
     end do
  end if

  !                       ------------------------------------                       !

  open(unit=16,file=file_tempout,position='append')
  write(16,*)
  write(16,*) '--------------------------------------------------------------'
  write(16,*) '------------   Integration contour:'
  write(16,*) '--------------------------------------------------------------'
  do i1_do=1,i_total_omega
     write(16,999) i1_do,i_bios_omega_scf(i1_do),omega_scf(i1_do)
  end do
  write(16,*) '--------------------------------------------------------------'
  write(16,*)
999 format(i5,i4,d25.15,'  + i',d23.15)
  close(16)

  return
end subroutine make_scf_omega_c2

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine cal_gf_se_c_scf(ispin,kt)

  use scf_negf
  use condition_ini
  use hamiltonian_sgf
  use hamiltonian_c
  use gf_se_c
  use constant
  use mod_mpi

  implicit none
  integer, intent(in) :: ispin,kt
  integer :: iw_do,i1_do,i2_do,i3_do,icou,i_w_st
  integer :: px,py,qx,qy
  complex(8) :: w,w_weight

  real(8) :: st1,st2,stdel,tot_t

  open(unit=16,file=file_tempout,position='append')
  write(16,*) '         ------------ spin:',ispin,'------------'
  close(16)

  do i3_do=1,m_mat_max_c
     do i2_do=1,m_mat_max_c
        dens(ispin,i2_do,i3_do)=0.d0
        dens2(ispin,i2_do,i3_do)=0.d0
        edens(ispin,i2_do,i3_do)=0.d0
        edens2(ispin,i2_do,i3_do)=0.d0
     end do
  end do

  tot_t=0.d0

  if( ispin == 1 ) then
     i_w_st=myrank
  else
     i_w_st=myrank-mod(i_total_omega,nprocs)
     if( i_w_st < 0 ) then
        i_w_st=i_w_st+nprocs
     end if
  end if

  do iw_do=1+i_w_st,i_total_omega,nprocs

     open(unit=60,file=file_sf_scf(ispin,kt,iw_do))
     write(60,995) m_mat_max_c,i_total_omega
     close(60)

     w=omega_scf(iw_do)
     w_weight=omega_weight_scf(iw_do)

     !                       - - - - - - - - - - - - - - - - - -                       !

     call myclock(st1)

     open(unit=16,file=file_tempout,position='append')
     open(unit=60,file=file_sf_scf(ispin,kt,iw_do),position='append')
     write(60,997) w,w_weight,ispin
     close(60)
     do px=1,kx_max_ll                                           ! kx_max_ll = 1
        do py=1,ky_max_ll                                         ! ky_max_ll = 1
           call selfenergy_l(w,iw_do,px,py,ispin,kt)
           icou=0
           do i2_do=1,m_mat_max_c
              do i1_do=1,m_mat_max_c
                 if( se_l_mat_per(i1_do,i2_do,px,py) /= dcmplx(0.d0,0.d0) ) then
                    icou=icou+1
                 end if
              end do
           end do
           open(unit=60,file=file_sf_scf(ispin,kt,iw_do),position='append')
           write(60,*) icou
           do i2_do=1,m_mat_max_c
              do i1_do=1,m_mat_max_c
                 if( se_l_mat_per(i1_do,i2_do,px,py) /= dcmplx(0.d0,0.d0) ) then
                    write(60,999) i1_do,i2_do,se_l_mat_per(i1_do,i2_do,px,py)
                 end if
              end do
           end do
           close(60)

        end do
     end do
     close(16)

     call myclock(st2)
     stdel=st2-st1
     tot_t=tot_t+stdel

     call myclock(st1)

     open(unit=16,file=file_tempout,position='append')
     open(unit=60,file=file_sf_scf(ispin,kt,iw_do),position='append')
     write(60,998) w,w_weight,ispin
     close(60)
     do qx=1,kx_max_rr                                           ! kx_max_rr = 1
        do qy=1,ky_max_rr                                         ! ky_max_rr = 1
           call selfenergy_r(w,iw_do,qx,qy,ispin,kt)
           icou=0
           do i2_do=1,m_mat_max_c
              do i1_do=1,m_mat_max_c
                 if( se_r_mat_per(i1_do,i2_do,qx,qy) /= dcmplx(0.d0,0.d0) ) then
                    icou=icou+1
                 end if
              end do
           end do
           open(unit=60,file=file_sf_scf(ispin,kt,iw_do),position='append')
           write(60,*) icou
           do i2_do=1,m_mat_max_c
              do i1_do=1,m_mat_max_c
                 if( se_r_mat_per(i1_do,i2_do,qx,qy) /= dcmplx(0.d0,0.d0) ) then
                    write(60,999) i1_do,i2_do,se_r_mat_per(i1_do,i2_do,qx,qy)
                 end if
              end do
           end do
           close(60)

        end do
     end do
     close(16)

     call myclock(st2)
     stdel=st2-st1
     tot_t=tot_t+stdel

     call myclock(st1)

     open(unit=16,file=file_tempout,position='append')
     do px=1,kx_max_ll                                           ! kx_max_ll = 1
        do py=1,ky_max_ll                                         ! ky_max_ll = 1
           do qx=1,kx_max_rr                                       ! kx_max_rr = 1
              do qy=1,ky_max_rr                                     ! ky_max_rr = 1
                 call green_function_scf(w,w_weight,iw_do,px,py,qx,qy,ispin)
              end do
           end do
        end do
     end do
     close(16)

     call myclock(st2)
     stdel=st2-st1
     tot_t=tot_t+stdel

     !                       - - - - - - - - - - - - - - - - - -                        !

  end do

  call myclock(st1)
  call calc_edm(ispin)
  call myclock(st2)
  stdel=st2-st1
  tot_t=tot_t+stdel

  open(unit=16,file=file_tempout,position='append')
  write(16,*) '                t=',tot_t
  close(16)

  !                       - - - - - - - - - - - - - - - - - -                        !

995 format(i10,i10)
997 format(d28.19,d28.19,d28.19,d28.19,i5                                        &
       ,'    ** left  *******************************')
998 format(d28.19,d28.19,d28.19,d28.19,i5                                        &
       ,'    ** right *******************************')
999 format(i10,i10,d28.19,d28.19)

  return
end subroutine cal_gf_se_c_scf

subroutine cal_gf_se_read_scf(ispin,kt)

  use scf_negf
  use condition_ini
  use hamiltonian_sgf
  use hamiltonian_c
  use gf_se_c
  use constant
  use mod_mpi

  implicit none
  integer, intent(in) :: ispin,kt
  integer :: iw_do,i1_do,i2_do,i3_do,icou,i_total_omega_tt,i_w_st
  integer :: px,py,qx,qy
  integer :: m_mat_max_read,itemp
  real(8) :: temp1,temp2,temp3,temp4
  complex(8) :: w,w_weight,w1

  real(8) :: st1,st2,stdel,tot_t

  open(unit=16,file=file_tempout,position='append')
  write(16,*) '         ------------ spin:',ispin,'------------'
  close(16)

  do i3_do=1,m_mat_max_c
     do i2_do=1,m_mat_max_c
        dens(ispin,i2_do,i3_do)=0.d0
        dens2(ispin,i2_do,i3_do)=0.d0
        edens(ispin,i2_do,i3_do)=0.d0
        edens2(ispin,i2_do,i3_do)=0.d0
     end do
  end do

  tot_t=0.d0

  if( ispin == 1 ) then
     i_w_st=myrank
  else
     i_w_st=myrank-mod(i_total_omega,nprocs)
     if( i_w_st < 0 ) then
        i_w_st=i_w_st+nprocs
     end if
  end if

  do iw_do=1+i_w_st,i_total_omega,nprocs

     open(unit=60,file=file_sf_scf(ispin,kt,iw_do))
     read(60,*) m_mat_max_read,i_total_omega_tt

     if( i_total_omega /= i_total_omega_tt ) then
        close(60)
        open(unit=16,file=file_tempout,position='append')
        write(16,*) 'error- (i_total_omega /= i_total_omega_t)',iw_do
        write(16,*) '                 re-cal.'
        close(16)
        stop
     end if

     itemp=m_mat_max_c-m_mat_max_read

     !                       - - - - - - - - - - - - - - - - - -                        !

     do px=1,kx_max_ll
        do py=1,ky_max_ll
           do i2_do=1,m_mat_max_c
              do i1_do=1,m_mat_max_c
                 se_l_mat_per(i1_do,i2_do,px,py)=dcmplx(0.d0,0.d0)
              end do
           end do
        end do
     end do

     read(60,996) temp1,temp2,temp3,temp4
     w=dcmplx(temp1,temp2)
     w_weight=dcmplx(temp3,temp4)
     do px=1,kx_max_ll
        do py=1,ky_max_ll
           read(60,*) icou
           do i3_do=1,icou
              read(60,999) i1_do,i2_do,temp1,temp2
              se_l_mat_per(i1_do,i2_do,px,py)=dcmplx(temp1,temp2)
           end do
        end do
     end do

     do qx=1,kx_max_rr
        do qy=1,ky_max_rr
           do i2_do=1,m_mat_max_c
              do i1_do=1,m_mat_max_c
                 se_r_mat_per(i1_do,i2_do,qx,qy)=dcmplx(0.d0,0.d0)
              end do
           end do
        end do
     end do

     read(60,996) temp1,temp2,temp3,temp4
     w1=dcmplx(temp1,temp2)
     if( w /= w1 ) then
        write(6,*) 'error--  w /= w1'
     end if
     do qx=1,kx_max_rr
        do qy=1,ky_max_rr
           read(60,*) icou
           do i3_do=1,icou
              read(60,999) i1_do,i2_do,temp1,temp2
              se_r_mat_per(itemp+i1_do,itemp+i2_do,qx,qy)=dcmplx(temp1,temp2)
           end do
        end do
     end do

     call myclock(st1)

     open(unit=16,file=file_tempout,position='append')
     do px=1,kx_max_ll
        do py=1,ky_max_ll
           do qx=1,kx_max_rr
              do qy=1,ky_max_rr
                 call green_function_scf(w,w_weight,iw_do,px,py,qx,qy,ispin)
              end do
           end do
        end do
     end do
     close(16)

     call myclock(st2)
     stdel=st2-st1
     tot_t=tot_t+stdel

     !                       - - - - - - - - - - - - - - - - - -                        !

  end do

  call myclock(st1)
  call calc_edm(ispin)
  call myclock(st2)
  stdel=st2-st1
  tot_t=tot_t+stdel

  close(60)

  open(unit=16,file=file_tempout,position='append')
  write(16,*) '                t=',tot_t
  close(16)

  !                       - - - - - - - - - - - - - - - - - -                        !

996 format(d28.19,d28.19,d28.19,d28.19)
999 format(i10,i10,d28.19,d28.19)

  return
end subroutine cal_gf_se_read_scf

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

module hamiltonian_c

  implicit none
  integer :: m_mat_max_l,m_mat_max_c,m_mat_max_r
  integer :: spin_switch_cc

  integer, allocatable :: itemp_l(:,:,:)
  integer, allocatable :: itemp_r(:,:,:)
  integer, allocatable :: itemp_c(:)

  complex(8), pointer :: hcc_mat(:,:)
  complex(8), pointer :: hcl_mat(:,:)
  complex(8), pointer :: hcr_mat(:,:)
  complex(8), pointer :: scc_mat(:,:)
  complex(8), pointer :: scl_mat(:,:)
  complex(8), pointer :: scr_mat(:,:)

contains
  subroutine alo_hami_c(num_atom_ctotal,num_atom_l,num_atom_r                       &
       ,num_unit_temp11,num_unit_temp12,num_unit_temp21,num_unit_temp22)

    implicit none
    integer, intent(in) :: num_atom_ctotal
    integer, intent(in) :: num_atom_l,num_atom_r
    integer, intent(in) :: num_unit_temp11,num_unit_temp12
    integer, intent(in) :: num_unit_temp21,num_unit_temp22
    integer :: ier

    allocate(itemp_l(num_unit_temp11,num_unit_temp12,num_atom_l)                 &
         ,itemp_r(num_unit_temp21,num_unit_temp22,num_atom_r)                 &
         ,itemp_c(num_atom_ctotal),stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_hami_c'
       stop
    end if

    return
  end subroutine alo_hami_c

  subroutine unset_hami_c

    implicit none
    integer :: ier

    deallocate(itemp_l,itemp_r,itemp_c,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error deallocate: unset_hami_c'
       stop
    end if

    return
  end subroutine unset_hami_c

  subroutine alo_hami_c1

    implicit none
    integer :: ier,i1_do,i2_do

    allocate(hcl_mat(m_mat_max_c,m_mat_max_l),scl_mat(m_mat_max_c,m_mat_max_l)   &
         ,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_hami_c1'
       stop
    end if

    do i2_do=1,m_mat_max_l
       do i1_do=1,m_mat_max_c
          hcl_mat(i1_do,i2_do)=dcmplx(0.d0,0.d0)
       end do
    end do
    do i2_do=1,m_mat_max_l
       do i1_do=1,m_mat_max_c
          scl_mat(i1_do,i2_do)=dcmplx(0.d0,0.d0)
       end do
    end do

    return
  end subroutine alo_hami_c1

  subroutine unset_hami_c1

    implicit none
    integer :: ier

    deallocate(hcl_mat,scl_mat,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error deallocate: unset_hami_c1'
       stop
    end if

    return
  end subroutine unset_hami_c1

  subroutine alo_hami_c2

    implicit none
    integer :: ier,i1_do,i2_do

    allocate(hcr_mat(m_mat_max_c,m_mat_max_r),scr_mat(m_mat_max_c,m_mat_max_r)   &
         ,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_hami_c2'
       stop
    end if

    do i2_do=1,m_mat_max_r
       do i1_do=1,m_mat_max_c
          hcr_mat(i1_do,i2_do)=dcmplx(0.d0,0.d0)
       end do
    end do
    do i2_do=1,m_mat_max_r
       do i1_do=1,m_mat_max_c
          scr_mat(i1_do,i2_do)=dcmplx(0.d0,0.d0)
       end do
    end do

    return
  end subroutine alo_hami_c2

  subroutine unset_hami_c2

    implicit none
    integer :: ier

    deallocate(hcr_mat,scr_mat,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error deallocate: unset_hami_c2'
       stop
    end if

    return
  end subroutine unset_hami_c2

  subroutine alo_hami_c3

    implicit none
    integer :: ier,i1_do,i2_do

    allocate(hcc_mat(m_mat_max_c,m_mat_max_c),scc_mat(m_mat_max_c,m_mat_max_c)   &
         ,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_hami_c3'
       stop
    end if

    do i2_do=1,m_mat_max_c
       do i1_do=1,m_mat_max_c
          hcc_mat(i1_do,i2_do)=dcmplx(0.d0,0.d0)
       end do
    end do
    do i2_do=1,m_mat_max_c
       do i1_do=1,m_mat_max_c
          scc_mat(i1_do,i2_do)=dcmplx(0.d0,0.d0)
       end do
    end do

    return
  end subroutine alo_hami_c3

  subroutine unset_hami_c31

    implicit none
    integer :: ier

    deallocate(hcc_mat,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error deallocate: unset_hami_c3'
       stop
    end if

    return
  end subroutine unset_hami_c31

  subroutine unset_hami_c32

    implicit none
    integer :: ier

    deallocate(scc_mat,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error deallocate: unset_hami_c3'
       stop
    end if

    return
  end subroutine unset_hami_c32
end module hamiltonian_c

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Naoki WATANABE, Nobutaka NISHIKAWA (Mizuho I.R.)   @@ !
! @@             Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine Atom__set(atom,name,Ro,Rc,Q,number,polarization,optimize)
  use ac_misc_module

  implicit none
  type(Atom_type), intent(out) :: atom
  real(8), intent(in) :: Ro(3)
  character(5), intent(in) :: name
  real(8), intent(in) :: Rc
  real(8), intent(in) :: Q
  real(8), intent(in) :: polarization
  integer, intent(in) :: number
  logical, intent(in) :: optimize
  
  atom%name     = name
  atom%Ro       = Ro
  atom%Rc       = Rc
  atom%Q        = Q
  atom%number   = number
  atom%polarization = polarization
  atom%force    = 0.d0
  atom%optimize = optimize
  atom%opt_position = Ro
  atom%opt_direction = 0.d0
  atom%force_past => null()

  return
end subroutine Atom__set

subroutine Atom__deallocate( atom )
  use ac_misc_module

  implicit none
  type(Atom_type), intent(out) :: atom

  if( associated(atom%force_past) ) deallocate(atom%force_past)

  return
end subroutine Atom__deallocate

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine save_hamiltonian_sgf_l

  use condition_ini
  use condition
  use hamiltonian_e
  use hamiltonian_sgf

  implicit none

  if( ham_model_ini  /= 'input' .and. ham_model_ini /= 'scf_accel' ) then
     call set_mat_max(p_or_f,num_unit,num_atom_kind,atom_kindn,atom_orbital     &
          ,num_atom)
     mat_max_ll=mat_max
     cp_l=cp
  end if

  iw_max_ll=iw_max
  kx_max_ll=kx_max
  ky_max_ll=ky_max
  kz_max_ll=kz_max
  spin_switch_ll=spin_switch_temp
  iw_dos_ll=omega_par_num(num_gra_te)

  return
end subroutine save_hamiltonian_sgf_l

subroutine save_hamiltonian_sgf_r

  use condition_ini
  use condition
  use hamiltonian_e
  use hamiltonian_sgf

  implicit none

  if( ham_model_ini  /= 'input' .and. ham_model_ini /= 'scf_accel' ) then
     call set_mat_max(p_or_f,num_unit,num_atom_kind,atom_kindn,atom_orbital     &
          ,num_atom)
     mat_max_rr=mat_max
     cp_r=cp
  end if

  iw_max_rr=iw_max
  kx_max_rr=kx_max
  ky_max_rr=ky_max
  kz_max_rr=kz_max
  spin_switch_rr=spin_switch_temp
  iw_dos_rr=omega_par_num(num_gra_te)

  return
end subroutine save_hamiltonian_sgf_r

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Naoki WATANABE, Nobutaka NISHIKAWA (Mizuho I.R.)   @@ !
! @@             Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine PPcharge__set( ppchg, Ro, RF )
  use ac_misc_module

  implicit none
  type(PPcharge_type), intent(out) :: ppchg
  real(8), intent(in)  :: Ro(3)
  type(RadialFunc_type), intent(in), target :: RF

  ppchg%Ro = Ro
  ppchg%Rc = RF%Rc
  ppchg%RF => RF

  return
end subroutine PPcharge__set

subroutine PPcharge__W( W, ppchg, Rg )
  use ac_misc_module

  implicit none
  type(PPcharge_type), intent(in) :: ppchg
  real(8), intent(in) :: Rg(3)

  real(8), intent(out)  :: W
  real(8) :: R(3)
  real(8)  :: dR

  R  = Rg-ppchg%Ro
  dR = sqrt(dot_product(R,R))

  if( dR > ppchg%Rc ) then
     W = 0.d0
     return
  end if

  W  = Spline__evaluate( ppchg%RF%fR, dR )

  return
end subroutine PPcharge__W

subroutine PPcharge__gW( gW, ppchg, Rg )
  use ac_misc_module

  implicit none
  type(PPcharge_type), intent(in) :: ppchg
  real(8), intent(in) :: Rg(3)

  real(8), intent(out)  :: gW(3)
  real(8) :: R(3)
  real(8)  :: dR

  R  = Rg-ppchg%Ro
  dR = sqrt(dot_product(R,R))

    if( dR < 1.d-14 ) then
     gW = 0.0d0
  else
     gW = Spline__derivative( ppchg%RF%fR, dR ) / dR * R
  end if

  return
end subroutine PPcharge__gW

subroutine Density__addVal( rrhoval, polarization )
  use ac_misc_module

  implicit none
  type(PPcharge_type), intent(in) :: rrhoval
  real(8)  :: polarization

  integer        :: spin
  integer        :: ia, ib, ic
  integer        :: ia0, ib0, ic0
  real(8) :: R(3)
  real(8)        :: rhoat, zeta(2)
  integer        :: range(6)

  call Param__Cell__getRange( range, rrhoval%Ro, rrhoval%Rc )
  
  if( .not. Param%Option%spin_polar ) then
     zeta(1) = 1.0d0
  else
     zeta(1) = 0.5d0*(1.0d0+polarization)
     zeta(2) = 0.5d0*(1.0d0-polarization)
  end if

  do ic = range(5), range(6)
     ic0 = modp(ic,Param%Cell%Nc)
     do ib = range(3), range(4)
        ib0 = modp(ib,Param%Cell%Nb)
        do ia = range(1), range(2)
           ia0 = modp(ia,Param%Cell%Na)

           call Param__Cell__R(R,ia,ib,ic)
           call PPcharge__W(rhoat,rrhoval,R)

           if( Param%Option%na ) then
              Density%rhoval(ia0,ib0,ic0) = &
                   Density%rhoval(ia0,ib0,ic0) + rhoat
           end if

           if( Param%Option%spin_orbit ) then
              Density%rhoLS(1,ia0,ib0,ic0) = &
                   Density%rhoLS(1,ia0,ib0,ic0) + rhoat*zeta(1)
              Density%rhoLS(4,ia0,ib0,ic0) = &
                   Density%rhoLS(4,ia0,ib0,ic0) + rhoat*zeta(2)
           else
              do spin=1, Param%Option%nspin
                 Density%rho(spin,ia0,ib0,ic0) = &
                      Density%rho(spin,ia0,ib0,ic0) + rhoat*zeta(spin)
              end do
           end if

        end do
     end do
  end do

  return
end subroutine Density__addVal

subroutine Density__addPCC( rrhopcc )
  use ac_misc_module

  implicit none
  type(PPcharge_type), intent(in) :: rrhopcc

  integer        :: ia, ib, ic
  integer        :: ia0, ib0, ic0
  real(8) :: R(3)
  integer        :: range(6)

  real(8)        :: rhoat

  call Param__Cell__getRange( range, rrhopcc%Ro, rrhopcc%Rc )

  do ic = range(5), range(6)
     ic0 = modp(ic,Param%Cell%Nc)
     do ib = range(3), range(4)
        ib0 = modp(ib,Param%Cell%Nb)
        do ia = range(1), range(2)
           ia0 = modp(ia,Param%Cell%Na)

           call Param__Cell__R(R,ia,ib,ic)

           call PPcharge__W(rhoat,rrhopcc,R)

           Density%rhopcc(ia0,ib0,ic0) = Density%rhopcc(ia0,ib0,ic0) + rhoat
        end do
     end do
  end do

  return
end subroutine Density__addPCC

subroutine Density__setup
  use ac_misc_module

  implicit none
  integer :: a
  type(Element_type), pointer :: elem
  type(PPcharge_type) :: rrhoval
  type(PPcharge_type) :: rrhopcc

  call Density__deallocate

  if( Param%Option%spin_orbit ) then
     allocate(Density%rhoLS(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc))
     Density%rhoLS = 0.d0
  else
     allocate(Density%rho(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc))
     Density%rho   = 0.d0
  end if

  if( Param%Option%na ) then
     allocate(Density%rhoval(Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc))
     Density%rhoval = 0.d0
  end if

  Param%Option%pcc = .false.

  do a=1, Param%Data%natom
     elem => Param__Data__getElement( Param%Data%vatom(a)%name )

     call PPcharge__set( rrhoval, Param%Data%vatom(a)%Ro, elem%rhoval )
     call Density__addVal( rrhoval, Param%Data%vatom(a)%polarization );

     if( .not. associated(Density%rhopcc) ) then
        allocate(Density%rhopcc(Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc))
        Density%rhopcc = 0.d0
     end if
     if( elem%pcc ) then
        Param%Option%pcc = .true.
!!        if( .not. associated(Density%rhopcc) ) then
!!           allocate(Density%rhopcc(Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc))
!!           Density%rhopcc = 0.d0
!!        end if

        call PPcharge__set( rrhopcc, Param%Data%vatom(a)%Ro, elem%rhopcc )
        call Density__addPCC( rrhopcc )
     end if
  end do

  return
end subroutine Density__setup

subroutine Density__calc
  use ac_misc_module
  use ac_mpi_module
  implicit none
  integer :: a, i, i1
  integer :: l, b, j, j1

  real(8) :: lL(3)
  integer        :: na, nb, nc
  integer        :: range(6)

  integer :: spin
  integer :: ia, ib, ic
  integer :: ia0, ib0, ic0
  integer :: ja, jb, jc

  real(8), pointer :: vpaoiat(:)
  real(8), pointer :: vpaojat(:)
  real(8) :: wi, wj
  real(8) :: sum_t
  real(8) :: rhoat
  complex(8) :: sum_tLS
  complex(8) :: rhoatLS

  if( Param%Option%spin_orbit ) then
     Density%rhoLS = 0.d0
  else
     Density%rho   = 0.d0
  end if

  allocate( vpaoiat(Base%npao) )
  allocate( vpaojat(Base%npao) )

  do l=0, Param%Cell%nL-1
     do a=MPI%isatom, MPI%ieatom
        i=Base%vipao(a)

        lL = Param%Cell%vL(:,l)
        na = Param%Cell%vLna(l)
        nb = Param%Cell%vLnb(l)
        nc = Param%Cell%vLnc(l)

        do b=1, Param%Data%natom
           j=Base%vipao(b)

           if( .not. associated(Hamiltonian%vAtomMatrix(b,a,l)%Ptr) ) then
              cycle
           end if

           if( .not. Param__Cell__mergeRange2( range, &
                Base%vpao(i)%Ro, Base%vpao(i)%Rc, &
                Base%vpao(j)%Ro, l, &
                Base%vpao(j)%Rc ) ) then
              cycle
           end if

           do ic = range(5), range(6)
              jc = ic-nc
              ic0 = modp(ic,Param%Cell%Nc)

              do ib = range(3), range(4)
                 jb = ib-nb
                 ib0 = modp(ib,Param%Cell%Nb)

                 do ia = range(1), range(2)
                    ja = ia-na
                    ia0 = modp(ia,Param%Cell%Na)

                    if( Base%vpao(i)%wave(ia,ib,ic) == 0.d0 ) cycle

                    if( Base%vpao(j)%wave(ja,jb,jc) == 0.d0 ) cycle

                    do i1=MPI%ispao(a), MPI%iepao(a)
                       vpaoiat(i+i1-1) = Base%vpao(i+i1-1)%wave(ia,ib,ic)
                    end do

                    do j1=1, Base%vnpao(b)
                       vpaojat(j+j1-1) = Base%vpao(j+j1-1)%wave(ja,jb,jc)
                    end do

                    do spin=1, Param%Option%nspin
                       if( Param%Option%spin_orbit ) then
                          rhoatLS = 0.d0
                          do i1=MPI%ispao(a), MPI%iepao(a)
                             wi = vpaoiat(i+i1-1)
                             if( wi == 0.d0 ) cycle

                             sum_tLS=0.d0
                             do j1=1, Base%vnpao(b)
                                wj = vpaojat(j+j1-1)
                                if( wj == 0.d0 ) cycle

                                sum_tLS = sum_tLS + &
                                     Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDMLS(j1,i1,spin) * wj
                             end do
                             rhoatLS = rhoatLS + wi*sum_tLS
                          end do

                          if( l==0 ) then
                             rhoatLS = rhoatLS*0.5d0
                          end if
                          Density%rhoLS(spin,ia0,ib0,ic0) = &
                               Density%rhoLS(spin,ia0,ib0,ic0) + rhoatLS

                       else
                          rhoat = 0.d0
                          do i1=MPI%ispao(a), MPI%iepao(a)
                             wi = vpaoiat(i+i1-1)
                             if( wi == 0.d0 ) cycle

                             sum_t=0.d0
                             do j1=1, Base%vnpao(b)
                                wj = vpaojat(j+j1-1)
                                if( wj == 0.d0 ) cycle

                                sum_t = sum_t + &
                                     Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDM(j1,i1,spin) * wj
                             end do
                             rhoat = rhoat + wi*sum_t
                          end do

                          if( l>0 ) then
                             rhoat = rhoat*2.d0
                          end if
                          Density%rho(spin,ia0,ib0,ic0) = &
                               Density%rho(spin,ia0,ib0,ic0) + rhoat
                       end if
                    end do
                 end do
              end do
           end do
        end do
     end do
  end do

  if(associated(vpaoiat)) deallocate( vpaoiat )
  if(associated(vpaojat)) deallocate( vpaojat )

  if( Param%Option%spin_orbit ) then
     Density%rhoLS(1,:,:,:) = &
          Density%rhoLS(1,:,:,:) + dconjg(Density%rhoLS(1,:,:,:))
     Density%rhoLS(4,:,:,:) = &
          Density%rhoLS(4,:,:,:) + dconjg(Density%rhoLS(4,:,:,:))
     Density%rhoLS(2,:,:,:) = &
          Density%rhoLS(2,:,:,:) + dconjg(Density%rhoLS(3,:,:,:))
     Density%rhoLS(3,:,:,:) = &
          dconjg(Density%rhoLS(2,:,:,:))

     call MPI__Allreduce_DensityLS( Density%rhoLS )
  else
     call MPI__Allreduce_Density( Density%rho )
  end if

  return
end subroutine Density__calc

subroutine Density__update( dEden, iter )
  use ac_misc_module

  implicit none
  integer, intent(in) :: iter
  real(8), intent(out) :: dEden

  select case( Param%SCF%mix_type )
  case('Simple')
     call Density__updateSimple( dEden, iter )
  case('Pulay')
     call Density__updatePulay( dEden, iter )
  case('Anderson')
     call Density__updateAnderson( dEden, iter )
  end select

  return
end subroutine Density__update

subroutine Density__updateSimple( dEden, iter )
  use ac_misc_module

  implicit none
  integer, intent(in) :: iter
  real(8), intent(out) :: dEden

  if( Param%SCF%mix_history /= 1 ) then
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
        write(16,*) '      ++++++ Warning!: mixing history should be 1 for Simple mixing'
     close(16)
     Param%SCF%mix_history=1
  end if

  if( iter==0 ) then
     allocate( Density%vpast(Param%SCF%mix_history) )

     if( Param%Option%spin_orbit ) then
        allocate( Density%vpast(1)% rhoLS(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc) )
        allocate( Density%vpast(1)%drhoLS(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc) )

        Density%vpast(1)%rhoLS = Density%rhoLS
        dEden = sum(cdabs(Density%vpast(1)%rhoLS)) * Param%Cell%dV/Param%Data%Ne
     else
        allocate( Density%vpast(1)% rho(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc) )
        allocate( Density%vpast(1)%drho(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc) )

        Density%vpast(1)%rho = Density%rho
        dEden = sum(abs(Density%vpast(1)%rho)) * Param%Cell%dV/Param%Data%Ne
     end if
     return
  end if

  if( Param%Option%spin_orbit ) then
     Density%vpast(1)%drhoLS = Density%rhoLS - Density%vpast(1)%rhoLS
     Density%rhoLS = Density%rhoLS + Density%vpast(1)%drhoLS * (Param%SCF%mix_weight-1.0)
     Density%vpast(1)%rhoLS = Density%rhoLS
     dEden = sum(cdabs(Density%vpast(1)%drhoLS)) * Param%Cell%dV/Param%Data%Ne
  else
     Density%vpast(1)%drho = Density%rho - Density%vpast(1)%rho
     Density%rho = Density%rho + Density%vpast(1)%drho * (Param%SCF%mix_weight-1.0)
     Density%vpast(1)%rho = Density%rho
     dEden = sum(abs(Density%vpast(1)%drho)) * Param%Cell%dV/Param%Data%Ne
  end if

  return
end subroutine Density__updateSimple

subroutine Density__updatePulay( dEden, iter )
  use ac_misc_module

  implicit none
  integer, intent(in) :: iter
  real(8), intent(out) :: dEden

  real(8), allocatable :: matrix(:,:)
  real(8), allocatable :: alpha(:)
  integer, allocatable :: ipiv(:)
  real(8), allocatable :: work(:)
  integer :: n, m
  integer :: info
  real(8) :: sumalpha

  real(8) :: v3dp_t,v3dp_t1,v3dp_t2

  if( Param%SCF%mix_start < Param%SCF%mix_history ) then
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
        write(16,*) '      ++++++ Warning!: too small mixing start for Pulay mixing'
     close(16)
     Param%SCF%mix_start = Param%SCF%mix_history
  end if

  if( iter==0 ) then
     allocate( Density%vpast(Param%SCF%mix_history) )

     if( Param%Option%spin_orbit ) then
        do n=1, Param%SCF%mix_history
           allocate( Density%vpast(n)% rhoLS(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc) )
           allocate( Density%vpast(n)%drhoLS(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc) )
        end do

        Density%vpast(1)%rhoLS = Density%rhoLS
        dEden = sum(cdabs(Density%vpast(1)%rhoLS)) * Param%Cell%dV/Param%Data%Ne
     else
        do n=1, Param%SCF%mix_history
           allocate( Density%vpast(n)% rho(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc) )
           allocate( Density%vpast(n)%drho(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc) )
        end do

        Density%vpast(1)%rho = Density%rho
        dEden = sum(abs(Density%vpast(1)%rho)) * Param%Cell%dV/Param%Data%Ne
     end if
     return
  end if

  if( Param%Option%spin_orbit ) then
     Density%vpast(1)%drhoLS = Density%rhoLS - Density%vpast(1)%rhoLS
  else
     Density%vpast(1)%drho = Density%rho - Density%vpast(1)%rho
  end if

  if( iter <= Param%SCF%mix_start ) then
     if( Param%Option%spin_orbit ) then
        Density%rhoLS = Density%rhoLS + Density%vpast(1)%drhoLS * (Param%SCF%mix_weight-1.0)
     else
        Density%rho = Density%rho + Density%vpast(1)%drho * (Param%SCF%mix_weight-1.0)
     end if

  else
     allocate( matrix(Param%SCF%mix_history,Param%SCF%mix_history) )
     allocate( alpha(Param%SCF%mix_history) )
     allocate( ipiv(Param%SCF%mix_history) )
     allocate( work(4*Param%SCF%mix_history) )

     do n=1, Param%SCF%mix_history
        do m=n, Param%SCF%mix_history
           if( Param%Option%spin_orbit ) then
              matrix(n,m) = sum( Density%vpast(n)%drhoLS * Density%vpast(m)%drhoLS )
           else
              matrix(n,m) = sum( Density%vpast(n)%drho * Density%vpast(m)%drho )
           end if
        end do
     end do

     do n=1, Param%SCF%mix_history
        alpha(n) = 1.d0
     end do

     call dsysv( 'U', Param%SCF%mix_history, 1, matrix, &
          Param%SCF%mix_history, ipiv, alpha, &
          Param%SCF%mix_history, work, 4*Param%SCF%mix_history, info, 1 )

     sumalpha=0.d0
     do n=1, Param%SCF%mix_history
        sumalpha = sumalpha + alpha(n)
     end do
     sumalpha = 1.d0/sumalpha
     do n=1, Param%SCF%mix_history
        alpha(n) = alpha(n)*sumalpha
     end do

     if( Param%Option%spin_orbit ) then
        Density%rhoLS = 0.d0
        do n=1, Param%SCF%mix_history
           Density%rhoLS = Density%rhoLS + Density%vpast(n)%rhoLS * alpha(n)
           Density%rhoLS = Density%rhoLS + Density%vpast(n)%drhoLS * (alpha(n)*Param%SCF%mix_weight)
        end do
     else
        Density%rho = 0.d0
        do n=1, Param%SCF%mix_history
           Density%rho = Density%rho + Density%vpast(n)%rho * alpha(n)
           Density%rho = Density%rho + Density%vpast(n)%drho * (alpha(n)*Param%SCF%mix_weight)
        end do
     end if

     deallocate( matrix )
     deallocate( alpha )
     deallocate( ipiv )
     deallocate( work )
  end if

  if( Param%Option%spin_orbit ) then
     do n=Param%SCF%mix_history, 2, -1
        Density%vpast(n)%rhoLS  = Density%vpast(n-1)%rhoLS
        Density%vpast(n)%drhoLS = Density%vpast(n-1)%drhoLS
     end do
     Density%vpast(1)%rhoLS = Density%rhoLS

     dEden = sum(cdabs(Density%vpast(1)%drhoLS)) * Param%Cell%dV/Param%Data%Ne
  else
     do n=Param%SCF%mix_history, 2, -1
        Density%vpast(n)%rho  = Density%vpast(n-1)%rho
        Density%vpast(n)%drho = Density%vpast(n-1)%drho
     end do
     Density%vpast(1)%rho = Density%rho

     dEden = sum(abs(Density%vpast(1)%drho)) * Param%Cell%dV/Param%Data%Ne
  end if
  return
end subroutine Density__updatePulay

subroutine Density__updateAnderson( dEden, iter )
  use ac_misc_module

  implicit none
  integer, intent(in) :: iter
  real(8), intent(out) :: dEden

  real(kind=8), parameter :: detol = 1d-9
  real(kind=8) :: theta1, theta2, det
  real(kind=8) :: matrix(2:3,3)
  integer :: n

  if( Param%SCF%mix_history /= 3 ) then
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
        write(16,*) '      ++++++ Warning!: mixing history should be 3 for Anderson mixing'
     close(16)
     Param%SCF%mix_history = 3
  end if


  if( iter==0 ) then
     allocate( Density%vpast(Param%SCF%mix_history) )

     if( Param%Option%spin_orbit ) then
        do n=1, Param%SCF%mix_history
           allocate( Density%vpast(n)% rhoLS(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc) )
           allocate( Density%vpast(n)%drhoLS(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc) )
        end do

        Density%vpast(1)%rhoLS = Density%rhoLS
        dEden = sum(cdabs(Density%vpast(1)%rhoLS)) * Param%Cell%dV/Param%Data%Ne
     else
        do n=1, Param%SCF%mix_history
           allocate( Density%vpast(n)% rho(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc) )
           allocate( Density%vpast(n)%drho(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc) )
        end do

        Density%vpast(1)%rho = Density%rho
        dEden = sum(abs(Density%vpast(1)%rho))* Param%Cell%dV/Param%Data%Ne
     end if

     return
  end if

  if( Param%Option%spin_orbit ) then
     Density%vpast(1)%drhoLS = Density%rhoLS - Density%vpast(1)%rhoLS
     Density%vpast(2)%rhoLS  = Density%vpast(2)%rhoLS  - Density%vpast(1)%rhoLS
     Density%vpast(2)%drhoLS = Density%vpast(2)%drhoLS - Density%vpast(1)%drhoLS
  else
     Density%vpast(1)%drho = Density%rho - Density%vpast(0)%rho
     Density%vpast(2)%rho  = Density%vpast(2)%rho  - Density%vpast(1)%rho
     Density%vpast(2)%drho = Density%vpast(2)%drho - Density%vpast(1)%drho
  end if

  if( iter==1 .or. Param%SCF%mix_history == 1 ) then
     theta1 = 0.0d0
     theta2 = 0.0d0
  else if( iter==2 .or. Param%SCF%mix_history == 2 ) then
     if( Param%Option%spin_orbit ) then
        matrix(:,:) = 0.d0
        matrix(2,2) = matrix(2,2) + sum( Density%vpast(2)%drhoLS * Density%vpast(2)%drhoLS )
        matrix(2,1) = matrix(2,1) + sum( Density%vpast(2)%drhoLS * Density%vpast(1)%drhoLS )
        theta1 = -matrix(2,1)/matrix(2,2)
        theta2 = 0.0d0
     else
        matrix(:,:) = 0.d0
        matrix(2,2) = matrix(2,2) + sum( Density%vpast(2)%drho * Density%vpast(2)%drho )
        matrix(2,1) = matrix(2,1) + sum( Density%vpast(2)%drho * Density%vpast(1)%drho )
        theta1 = -matrix(2,1)/matrix(2,2)
        theta2 = 0.0d0
     end if
  else
     if( Param%Option%spin_orbit ) then
        matrix(:,:) = 0.d0
        matrix(2,2) = matrix(2,2) + sum( Density%vpast(2)%drhoLS * Density%vpast(2)%drhoLS )
        matrix(2,3) = matrix(2,3) + sum( Density%vpast(2)%drhoLS * Density%vpast(3)%drhoLS )
        matrix(3,3) = matrix(3,3) + sum( Density%vpast(3)%drhoLS * Density%vpast(3)%drhoLS )
        matrix(2,1) = matrix(2,1) + sum( Density%vpast(2)%drhoLS * Density%vpast(1)%drhoLS )
        matrix(3,1) = matrix(3,1) + sum( Density%vpast(3)%drhoLS * Density%vpast(1)%drhoLS )
     else
        matrix(:,:) = 0.d0
        matrix(2,2) = matrix(2,2) + sum( Density%vpast(2)%drho * Density%vpast(2)%drho )
        matrix(2,3) = matrix(2,3) + sum( Density%vpast(2)%drho * Density%vpast(3)%drho )
        matrix(3,3) = matrix(3,3) + sum( Density%vpast(3)%drho * Density%vpast(3)%drho )
        matrix(2,1) = matrix(2,1) + sum( Density%vpast(2)%drho * Density%vpast(1)%drho )
        matrix(3,1) = matrix(3,1) + sum( Density%vpast(3)%drho * Density%vpast(1)%drho )
     end if

     det = matrix(2,2)*matrix(3,3) - matrix(2,3)*matrix(2,3)

     if( dabs(det/(matrix(2,2)*matrix(3,3))) < detol ) then
        theta1 = -matrix(2,1)/matrix(2,2)
        theta2 = 0.0d0
     else
        theta1 = (-matrix(3,3)*matrix(2,1)+matrix(2,3)*matrix(3,1))/det
        theta2 = (+matrix(2,3)*matrix(2,1)-matrix(2,2)*matrix(3,1))/det
     end if
  end if
  
  if( Param%Option%spin_orbit ) then
     Density%rhoLS = Density%vpast(1)%rhoLS &
          + theta1*Density%vpast(2)%rhoLS  + theta2*Density%vpast(3)%rhoLS &
          + Param%SCF%mix_weight* &
          ( Density%vpast(1)%drhoLS &
          + theta1*Density%vpast(2)%drhoLS + theta2*Density%vpast(3)%drhoLS )

     Density%vpast(3)%rhoLS  = Density%vpast(2)%rhoLS
     Density%vpast(2)%rhoLS  = Density%vpast(1)%rhoLS
     Density%vpast(1)%rhoLS  = Density%rhoLS
     Density%vpast(3)%drhoLS = Density%vpast(2)%drhoLS
     Density%vpast(2)%drhoLS = Density%vpast(1)%drhoLS

     dEden = sum(cdabs(Density%vpast(1)%drhoLS)) * Param%Cell%dV/Param%Data%Ne
  else
     Density%rho = Density%vpast(1)%rho &
          + theta1*Density%vpast(2)%rho  + theta2*Density%vpast(3)%rho &
          + Param%SCF%mix_weight* &
          ( Density%vpast(1)%drho &
          + theta1*Density%vpast(2)%drho + theta2*Density%vpast(3)%drho )

     Density%vpast(3)%rho  = Density%vpast(2)%rho
     Density%vpast(2)%rho  = Density%vpast(1)%rho
     Density%vpast(1)%rho  = Density%rho
     Density%vpast(3)%drho = Density%vpast(2)%drho
     Density%vpast(2)%drho = Density%vpast(1)%drho

     dEden = sum(abs(Density%vpast(1)%drho)) * Param%Cell%dV/Param%Data%Ne
  end if

  return
end subroutine Density__updateAnderson

subroutine Density__deallocate
  use ac_misc_module

  implicit none
  integer :: n

  if( Param%Option%spin_orbit ) then
     if( associated(Density%rhoLS) ) deallocate(Density%rhoLS)
  else
     if( associated(Density%rho) ) deallocate(Density%rho)
  end if

  if( associated(Density%rhoval) ) deallocate(Density%rhoval)
  if( associated(Density%rhopcc) ) deallocate(Density%rhopcc)
  if( associated(Density%vpast) ) then
     if( Param%Option%spin_orbit ) then
        do n=1, size(Density%vpast)
           if(associated(Density%vpast(n)%rhoLS)) deallocate(Density%vpast(n)%rhoLS)
           if(associated(Density%vpast(n)%drhoLS)) deallocate(Density%vpast(n)%drhoLS)
        end do
     else
        do n=1, size(Density%vpast)
           if(associated(Density%vpast(n)%rho)) deallocate(Density%vpast(n)%rho)
           if(associated(Density%vpast(n)%drho)) deallocate(Density%vpast(n)%drho)
        end do
     end if
     deallocate(Density%vpast)
  end if

  return
end subroutine Density__deallocate

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine set_mat_max(p_or_f,num_unit,num_atom_kind,atom_kindn,atom_orbital       &
     ,num_atom)

  use hamiltonian_e

  implicit none
  character(50), intent(in) :: p_or_f
  integer, intent(in) :: num_atom,num_atom_kind
  integer, intent(in) :: atom_orbital(num_atom_kind),atom_kindn(num_atom)
  integer, intent(in) :: num_unit(3)
  integer :: i1_do

  mat_max=0
  do i1_do=1,num_atom
     mat_max=mat_max+atom_orbital(atom_kindn(i1_do))
  end do
  if( p_or_f == 'free' ) then
     mat_max=mat_max*num_unit(1)*num_unit(2)
  end if

  return
end subroutine set_mat_max

subroutine set_mat_zper(p_or_f,num_unit,num_atom_kind,atom_kindn,atom_orbital      &
     ,num_atom)

  use hamiltonian_zper

  implicit none
  character(50), intent(in) :: p_or_f
  integer, intent(in) :: num_atom,num_atom_kind
  integer, intent(in) :: atom_orbital(num_atom_kind),atom_kindn(num_atom)
  integer, intent(in) :: num_unit(3)
  integer :: i1_do

  mat_max_zper=0
  do i1_do=1,num_atom
     mat_max_zper=mat_max_zper+atom_orbital(atom_kindn(i1_do))
  end do
  if( p_or_f == 'free' ) then
     mat_max_zper=mat_max_zper*num_unit(1)*num_unit(2)
  end if

  return
end subroutine set_mat_zper

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@             Naoki WATANABE (Mizuho I.R.)                       @@ !
! @@             Nobutaka NISHIKAWA (Mizuho I.R.)                   @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine trans(descCC,w,iw_do,px,py,qx,qy,ispin,kt)

  use hamiltonian_sgf
  use hamiltonian_c
  use gf_se_c
  use constant
  use condition_ini
  use mod_mpi
  use ac_mpi_module

  implicit none

  type(MPI_MatDesc), intent(in) :: descCC
  integer, intent(in) :: iw_do
  integer, intent(in) :: px,py,qx,qy,ispin,kt
  complex(8), intent(in) :: w

  integer :: i1_do,i2_do,ier
  complex(8), allocatable :: amat_temp5(:,:),amat_temp6(:,:)
  complex(8), allocatable :: bmat_temp5(:,:),bmat_temp6(:,:)
  complex(8), parameter :: CI = (0.0d0, 1.0d0)
  character(50) :: nfile_strans

  integer :: i, j
  complex(8) :: trace



  if( iw_do > iw_max_gs ) then
     go to 100
  end if

  call alo_hami_c3(descCC)
  if( ham_model_ini == 'input' .or. ham_model_ini == 'scf_accel' ) then
     if( ham_model_ini == 'input' ) then
        call set_hami_c_cc_input(descCC,ispin)
     else
        call set_hami_c_cc_scf(descCC,ispin)
     end if
  else
     call set_hami_c_cc(descCC,px,py,qx,qy)
  end if

  allocate(amat_temp6(descCC%nrow, descCC%scol:descCC%ecol),stat=ier)
  allocate(bmat_temp6(descCC%nrow, descCC%scol:descCC%ecol),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: trans 1'
     stop
  end if

  amat_temp6(:,:) = w*scc_mat(:,:) - hcc_mat(:,:)

  call unset_hami_c31

  bmat_temp6(:,:) = se_l_mat_per(:,:,px,py) + se_r_mat_per(:,:,qx,qy) 

  bmat_temp6(:,:) = amat_temp6(:,:) - bmat_temp6(:,:) 

  call MPI__ZGETRI_ASCOT( descCC, bmat_temp6 )

  call MPI__ZGEMM_ASCOT( 'N', 'N', descCC, &
       C1, bmat_temp6, scc_mat, C0, amat_temp6 )

  call unset_hami_c32

  call MPI__ZLATRA_ASCOT( descCC, amat_temp6, trace )
  call cal_print_text2(iw_do,trace,ispin,kt)

100 continue

  do i1_do=1,MPI%sizeE
     call MPI_BARRIER(mpi_comm_world,MPI%info)
     if( iw_do > iw_max_gs ) then
        cycle
     end if
     if( i1_do == MPI%rankE+1 ) then
        if( iw_do /= 1 ) then
           if( spin_switch_cc /= 2 ) then
              if( switch_out_gf /= 'off' ) then
                 nfile_strans='gfc'
                 call makefilename_strans(kt,nfile_strans)
                 open(unit=50,file=nfile_strans,position='append')
              end if
              if( switch_out_tr == 'all' ) then
                 nfile_strans='ftg'
                 call makefilename_strans(kt,nfile_strans)
                 open(unit=46,file=nfile_strans,position='append')
              end if
           else
              if( switch_out_gf /= 'off' ) then
                 nfile_strans='gfc_up'
                 call makefilename_strans(kt,nfile_strans)
                 open(unit=50,file=nfile_strans,position='append')
                 nfile_strans='gfc_do'
                 call makefilename_strans(kt,nfile_strans)
                 open(unit=52,file=nfile_strans,position='append')
              end if
              if( switch_out_tr == 'all' ) then
                 nfile_strans='ftg_up'
                 call makefilename_strans(kt,nfile_strans)
                 open(unit=46,file=nfile_strans,position='append')
                 nfile_strans='ftg_do'
                 call makefilename_strans(kt,nfile_strans)
                 open(unit=47,file=nfile_strans,position='append')
              end if
           end if
        else
           if( spin_switch_cc /= 2 ) then
              if( switch_out_gf /= 'off' ) then
                 nfile_strans='gfc'
                 call makefilename_strans(kt,nfile_strans)
                 open(unit=50,file=nfile_strans)
              end if
              if( switch_out_tr == 'all' ) then
                 nfile_strans='ftg'
                 call makefilename_strans(kt,nfile_strans)
                 open(unit=46,file=nfile_strans)
              end if
           else
              if( switch_out_gf /= 'off' ) then
                 nfile_strans='gfc_up'
                 call makefilename_strans(kt,nfile_strans)
                 open(unit=50,file=nfile_strans)
                 nfile_strans='gfc_do'
                 call makefilename_strans(kt,nfile_strans)
                 open(unit=52,file=nfile_strans)
              end if
              if( switch_out_tr == 'all' ) then
                 nfile_strans='ftg_up'
                 call makefilename_strans(kt,nfile_strans)
                 open(unit=46,file=nfile_strans)
                 nfile_strans='ftg_do'
                 call makefilename_strans(kt,nfile_strans)
                 open(unit=47,file=nfile_strans)
              end if
           end if
        end if
        call print_site_sel(descCC,w,amat_temp6,bmat_temp6,ispin)
        if( spin_switch_cc /= 2 ) then
           if( switch_out_gf /= 'off' ) then
              close(50)
           end if
           if( switch_out_tr == 'all' ) then
              close(46)
           end if
        else
           if( switch_out_gf /= 'off' ) then
              close(50)
              close(52)
           end if
           if( switch_out_tr == 'all' ) then
              close(46)
              close(47)
           end if
        end if
     end if
  end do

  if( iw_do > iw_max_gs ) then
     go to 110
  end if

  allocate(amat_temp5(descCC%nrow, descCC%scol:descCC%ecol),stat=ier)
  allocate(bmat_temp5(descCC%nrow, descCC%scol:descCC%ecol),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: trans 3'
     stop
  end if


  amat_temp5(:,:) = +se_r_mat_per(:,:,qx,qy) 
  bmat_temp5(:,:) = -se_r_mat_per(:,:,qx,qy) 

  call MPI__ZTRANC_ASCOT( descCC, C1, amat_temp5, C1, bmat_temp5 )

  amat_temp5(:,:) = amat_temp5(:,:) * CI


  call MPI__ZGEMM_ASCOT( 'N', 'C', descCC, &
       C1, amat_temp5, bmat_temp6,C0, amat_temp6 )

  amat_temp5(:,:) = +se_l_mat_per(:,:,qx,qy) 
  bmat_temp5(:,:) = -se_l_mat_per(:,:,qx,qy) 

  call MPI__ZTRANC_ASCOT( descCC, C1, amat_temp5, C1, bmat_temp5 )

  amat_temp5(:,:) = amat_temp5(:,:) * CI

  call MPI__ZGEMM_ASCOT( 'N', 'N', descCC, &
       C1, amat_temp5, bmat_temp6, C0, bmat_temp5 )
  call MPI__ZGEMM_ASCOT( 'N', 'N', descCC, &
       C1, bmat_temp5, amat_temp6,C0, amat_temp5 )

  call MPI__ZLATRA_ASCOT( descCC, amat_temp5, trace )

  call cal_print_text3(iw_do,trace,ispin,kt)

110 continue

  do i1_do=1,MPI%sizeE
     call MPI_BARRIER( MPI_COMM_WORLD, MPI%info )
     if( iw_do > iw_max_gs ) then
        cycle
     end if
     if( i1_do == MPI%rankE+1 ) then
        if( iw_do /= 1 ) then
           if( spin_switch_cc /= 2 ) then
              if( switch_out_tr /= 'off' ) then
                 nfile_strans='tra'
                 call makefilename_strans(kt,nfile_strans)
                 open(unit=51,file=nfile_strans,position='append')
              end if
              if( switch_out_tr == 'all' ) then
                 nfile_strans='gam'
                 call makefilename_strans(kt,nfile_strans)
                 open(unit=48,file=nfile_strans,position='append')
              end if
              open(unit=55,file='sf_gf.dat',position='append')
           else
              if( switch_out_tr /= 'off' ) then
                 nfile_strans='tra_up'
                 call makefilename_strans(kt,nfile_strans)
                 open(unit=51,file=nfile_strans,position='append')
                 nfile_strans='tra_do'
                 call makefilename_strans(kt,nfile_strans)
                 open(unit=53,file=nfile_strans,position='append')
              end if
              if( switch_out_tr == 'all' ) then
                 nfile_strans='gam_up'
                 call makefilename_strans(kt,nfile_strans)
                 open(unit=48,file=nfile_strans,position='append')
                 nfile_strans='gam_do'
                 call makefilename_strans(kt,nfile_strans)
                 open(unit=49,file=nfile_strans,position='append')
              end if
              open(unit=55,file='sf_gf_up.dat',position='append')
              open(unit=56,file='sf_gf_do.dat',position='append')
           end if
           open(unit=57,file='em_gf.dat',position='append')
           open(unit=58,file='trans.dat',position='append')
        else
           if( spin_switch_cc /= 2 ) then
              if( switch_out_tr /= 'off' ) then
                 nfile_strans='tra'
                 call makefilename_strans(kt,nfile_strans)
                 open(unit=51,file=nfile_strans)
              end if
              if( kt /= 1 ) then
                 open(unit=55,file='sf_gf.dat',position='append')
              else
                 open(unit=55,file='sf_gf.dat')
              end if
              if( switch_out_tr == 'all' ) then
                 nfile_strans='gam'
                 call makefilename_strans(kt,nfile_strans)
                 open(unit=48,file=nfile_strans)
              end if
           else
              if( switch_out_tr /= 'off' ) then
                 nfile_strans='tra_up'
                 call makefilename_strans(kt,nfile_strans)
                 open(unit=51,file=nfile_strans)
                 nfile_strans='tra_do'
                 call makefilename_strans(kt,nfile_strans)
                 open(unit=53,file=nfile_strans)
              end if
              if( switch_out_tr == 'all' ) then
                 nfile_strans='gam_up'
                 call makefilename_strans(kt,nfile_strans)
                 open(unit=48,file=nfile_strans)
                 nfile_strans='gam_do'
                 call makefilename_strans(kt,nfile_strans)
                 open(unit=49,file=nfile_strans)
              end if
              if( kt /= 1 ) then
                 open(unit=55,file='sf_gf_up.dat',position='append')
                 open(unit=56,file='sf_gf_do.dat',position='append')
              else
                 open(unit=55,file='sf_gf_up.dat')
                 open(unit=56,file='sf_gf_do.dat')
              end if
           end if
           if( kt /= 1 ) then
              open(unit=57,file='em_gf.dat',position='append')
              open(unit=58,file='trans.dat',position='append')
           else
              open(unit=57,file='em_gf.dat')
              open(unit=58,file='trans.dat')
           end if
        end if
        call print_site_tra(descCC,w,amat_temp5,ispin)
        call print_text_t(w,iw_do,ispin,kt)
        if( spin_switch_cc /= 2 ) then
           if( switch_out_tr /= 'off' ) then
              close(51)
           end if
           close(55)
           close(57)
           close(58)
           if( switch_out_tr == 'all' ) then
              close(48)
           end if
        else
           if( switch_out_tr /= 'off' ) then
              close(51)
              close(53)
           end if
           close(55)
           close(56)
           close(57)
           close(58)
           if( switch_out_tr == 'all' ) then
              close(48)
              close(49)
           end if
        end if
     end if
  end do

  if( iw_do > iw_max_gs ) then
     go to 120
  end if

  deallocate(amat_temp5,amat_temp6,bmat_temp5,bmat_temp6,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error deallocate: trans'
     stop
  end if

120 continue

  return
end subroutine trans

subroutine makefilename_strans(kt,nfile_strans)
  use ac_mpi_module
  implicit none

  integer, intent(in) :: kt
  character(50), intent(inout) :: nfile_strans

  character(60) :: filename_com

  write( filename_com,'("_k",i4.4,"_p",i4.4,".data")') kt, MPI%rank2  
  nfile_strans = adjustl(trim(nfile_strans)//filename_com)



  return
end subroutine makefilename_strans

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Naoki WATANABE, Nobutaka NISHIKAWA (Mizuho I.R.)   @@ !
! @@             Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

module ac_mpi_module
  use ac_parameter
  implicit none
  include "mpif.h"

  type MPI_type
     integer :: size 
     integer :: rank 
     integer :: sizeE, sizeM 
     integer :: rankE, rankM 
     integer :: info 
     logical :: root 

     integer :: isatom 
     integer :: ieatom 

     integer,pointer :: vnmat(:), vsmat(:), vemat(:)
     integer         ::  nmat,     smat,    emat
     integer,pointer :: ispao(:) 
     integer,pointer :: iepao(:) 

     integer :: localsize1
     integer :: localsize2

     real(8) :: num_sc_work2space = -1000.d0
     integer :: num_check_sc = 1

  end type MPI_type

  type(MPI_type), public, save :: MPI 

contains

  subroutine MPI__Initialize
    implicit none

    MPI%rank = 0
    MPI%size = 1
    MPI%root = .true.

    return
  end subroutine MPI__Initialize

  subroutine MPI__Finalize
    implicit none

    if( associated(MPI%vnmat) ) then
       deallocate( MPI%vnmat, MPI%vsmat, MPI%vemat )
    end if

    if( associated(MPI%ispao) ) then
       deallocate(MPI%ispao,MPI%iepao)
    end if

    return
  end subroutine MPI__Finalize

  subroutine MPI__setup
    implicit none
    integer :: a

    MPI%sizeE = 1
    MPI%sizeM = 1

    MPI%isatom = 1
    MPI%ieatom = Param%Data%natom

    if( associated(MPI%ispao) ) then
       deallocate(MPI%ispao, MPI%iepao)
    end if
    allocate( MPI%ispao(Param%Data%natom), MPI%iepao(Param%Data%natom) )

    do a=1, Param%Data%natom
       MPI%ispao(a) = 0+1
       MPI%iepao(a) = Param%Data%vnpao(a)-1+1
    end do

    if( associated(MPI%vnmat) ) then
       deallocate( MPI%vnmat, MPI%vsmat, MPI%vemat )
    end if
    allocate( MPI%vnmat(0:0), MPI%vsmat(0:0), MPI%vemat(0:0) )

    MPI%vsmat(0) = 0+1
    MPI%vemat(0) = MPI%vsmat(0) + Param%Data%npao - 1
    MPI%vnmat(0) = Param%Data%npao

    MPI%smat = MPI%vsmat(0)
    MPI%emat = MPI%vemat(0)
    MPI%nmat = MPI%vnmat(0)

    MPI%localsize1 = Param%Data%npao
    MPI%localsize2 = 2*Param%Data%npao

    return
  end subroutine MPI__setup

  subroutine MPI__show
    implicit none

    write(*,'(a)')    '# disabled MPI parallelization'

    return
  end subroutine MPI__show

  subroutine MPI__Bcast_Inputfile( filename )
    implicit none
    character(64), intent(inout) :: filename

    return
  end subroutine MPI__Bcast_Inputfile

  subroutine MPI__Allreduce_Density( density )
    implicit none
    real(8), intent(inout) :: density (Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)

    return
  end subroutine MPI__Allreduce_Density

  subroutine MPI__Allreduce_DensityLS( densityLS )
    implicit none
    complex(8), intent(inout) :: densityLS(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)

    return
  end subroutine MPI__Allreduce_DensityLS

  subroutine MPI__Allgather_Matrix( matrix )
    implicit none
    complex(8), intent(inout) :: matrix(0:Param%Data%npao-1,0:Param%Data%npao-1)

    return
  end subroutine MPI__Allgather_Matrix

  subroutine MPI__AlltoAll_Matrix( matrix )
    implicit none
    complex(8), intent(inout) :: matrix(Param%Data%npao,Param%Data%npao)
    integer :: i, j

    do i=1, Param%Data%npao
       do j=i, Param%Data%npao
          matrix(i,j) = dconjg(matrix(i,j)) + matrix(j,i)
          matrix(j,i) = dconjg(matrix(i,j))
       end do
    end do

    return
  end subroutine MPI__AlltoAll_Matrix

  subroutine MPI__AlltoAll_Matrix2( matrix2, matrix3 )
    implicit none
    complex(8), intent(inout) :: matrix2(Param%Data%npao,Param%Data%npao)
    complex(8), intent(inout) :: matrix3(Param%Data%npao,Param%Data%npao)
    integer :: i, j

    do i=1, Param%Data%npao
       do j=1, Param%Data%npao
          matrix2(i,j) = dconjg(matrix2(i,j)) + matrix3(j,i)
          matrix3(j,i) = dconjg(matrix2(i,j))
       end do
    end do

    return
  end subroutine MPI__AlltoAll_Matrix2

  subroutine MPI__Allreduce_Force( vatom )
    implicit none
    type(Atom_type), intent(inout) :: vatom(Param%Data%natom)

    return
  end subroutine MPI__Allreduce_Force

  subroutine MPI__Allreduce_HistoryPulay( A )
    implicit none
    real(8), intent(inout) :: A(Param%SCF%mix_history,Param%SCF%mix_history)
    return
  end subroutine MPI__Allreduce_HistoryPulay

  subroutine MPI__Allreduce_HistoryAnderson( A )
    implicit none
    real(8), intent(inout) :: A(Param%SCF%mix_history,Param%SCF%mix_history)
    return
  end subroutine MPI__Allreduce_HistoryAnderson

  subroutine MPI__Allreduce_Error( dEden )
    implicit none
    real(8), intent(inout) :: dEden

    return
  end subroutine MPI__Allreduce_Error

  subroutine MPI__Barrier
    implicit none

    return
  end subroutine MPI__Barrier

  subroutine MPI__ZHEGV( size, matrixH, matrixS, vectorE, iter )
    implicit none

    integer, intent(in)       :: size 
    complex(8), intent(inout) :: matrixH(size,size) 
    complex(8), intent(in)    :: matrixS(size,size) 
    real(8),    intent(out)   :: vectorE(size) 

    complex(8), allocatable   :: localS(:,:)
    complex(8), allocatable   :: work1(:)
    real(8),    allocatable   :: work2(:)

    integer, intent(in) :: iter

    allocate( work1(4*size), work2(7*size) )
    allocate( localS(size,size) )
    localS = matrixS 

    call ZHEGV( 1, 'V', 'L', size, matrixH, size, localS, size, &
         vectorE, work1, 4*size, work2, MPI%info )

    deallocate( localS )
    deallocate( work1, work2 )

    return
  end subroutine MPI__ZHEGV

  subroutine MPI__ZHEGVLS( size, matrixH, matrixS, vectorE, iter )
    implicit none

    integer, intent(in)       :: size 
    complex(8), intent(inout) :: matrixH(2*size,2*size) 
    complex(8), intent(in)    :: matrixS(2*size,2*size) 
    real(8),    intent(out)   :: vectorE(2*size) 

    integer, intent(in) :: iter

    complex(8), allocatable   :: localS(:,:)
    complex(8), allocatable :: work1(:)
    real(8),    allocatable :: work2(:)

    allocate( work1(4*2*size), work2(7*2*size) )
    allocate( localS(2*size,2*size) )
    localS = matrixS 

    call ZHEGV( 1, 'V', 'L', 2*size, matrixH, 2*size, localS, 2*size, &
         vectorE, work1, 4*2*size, work2, MPI%info )

    deallocate( localS )
    deallocate( work1, work2 )

    return
  end subroutine MPI__ZHEGVLS

  subroutine MPI__ZGEMM( transa, transb, size, &
       alpha, matrixA, matrixB, beta, matrixC )
    implicit none

    character, intent(in)     :: transa, transb
    integer, intent(in)       :: size 
    complex(8), intent(in)    :: matrixA(size,size) 
    complex(8), intent(in)    :: matrixB(size,size) 
    complex(8), intent(out)   :: matrixC(size,size) 
    complex(8), intent(in)    :: alpha, beta 

    call ZGEMM( transa, transb, size, size, size, &
         alpha, matrixA, size, matrixB, size, &
         beta,  matrixC, size )

    return
  end subroutine MPI__ZGEMM

  subroutine MPI__ZHEMM( size, &
       alpha, matrixA, matrixB, beta, matrixC )
    implicit none

    integer, intent(in)       :: size 
    complex(8), intent(in)    :: matrixA(size,size) 
    complex(8), intent(in)    :: matrixB(size,size) 
    complex(8), intent(out)   :: matrixC(size,size) 
    complex(8), intent(in)    :: alpha, beta 

    call ZHEMM( 'L', 'L', size, size, size, &
         alpha, matrixA, size, matrixB, size, &
         beta,  matrixC, size )

    return
  end subroutine MPI__ZHEMM

  subroutine MPI__ZPOTRI( size, matrixA )
    implicit none

    integer, intent(in)       :: size 
    complex(8), intent(inout) :: matrixA(size,size) 

    call ZPOTRF( 'L', size, matrixA, size, MPI%info )
    call ZPOTRI( 'L', size, matrixA, size, MPI%info )

    return
  end subroutine MPI__ZPOTRI

  subroutine MPI__ZGETRI( size, matrixA )
    implicit none

    integer, intent(in)       :: size 
    complex(8), intent(inout) :: matrixA(size,size) 

    integer, allocatable :: ipiv(:)
    complex(8), allocatable :: work1(:)
    integer, allocatable :: work2(:)
    integer :: lwork1, lwork2

    allocate( work1(1), work2(1) )
    lwork1=-1; lwork2=-1

    call ZGETRI( size, matrixA, size, &
         ipiv, work1, lwork1, work2, lwork2, MPI%info )

    lwork1 = int(work1(1))+100
    lwork2 = int(work2(1))+100
    deallocate( work1, work2 )

    allocate( work1(lwork1), work2(lwork2) )
    allocate( ipiv(size) )

    call ZGETRF( size, size, matrixA, size, &
         ipiv, MPI%info )

    call ZGETRI( size, matrixA, size, &
         ipiv, work1, lwork1, work2, lwork2, MPI%info )

    deallocate( ipiv )
    deallocate( work1, work2 )

    return
  end subroutine MPI__ZGETRI

end module ac_mpi_module

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

module condition

  implicit none
  integer :: num_atom,num_atom_kind,num_unit(3)
  integer :: neighbor_x_max,neighbor_y_max,neighbor_z_max
  integer :: kx_max,ky_max
  integer :: kz_max,iteration_max
  real(8) :: unit_block(3,3),eps
  real(8) :: cp,v_lr
  character(50) :: p_or_f,sgf_method,ham_model
  integer, pointer :: atom_orbital(:),atom_num(:),atom_electron(:)
  integer, pointer :: atom_kindn(:),pair_num(:,:)
  real(8), pointer :: ra(:,:),atom_mass(:)
  character(4), pointer :: atom_kind(:),atom_sign(:)

  integer, pointer :: omega_par(:),omega_par_num(:)
  complex(8), pointer :: omega(:)
  integer :: num_gra_te,iw_max

  real(8), pointer :: dos(:,:,:)

  integer :: mat_max_eigen
  real(8), pointer :: ev_mat(:,:,:,:,:,:)

  integer :: l_or_r
  character(50) :: calc_type_c
  character(50) :: dos_on_off
  character(50) :: eigen_s_as

  integer :: num_h00(2),num_h01(2),num_h10(2),num_s00,num_s01,num_s10
  real(8) :: ele_num_temp
  complex(8), pointer :: h00(:,:),h01(:,:),h10(:,:)
  complex(8), pointer :: s00(:),s01(:),s10(:)
  integer, pointer :: l1_h00(:,:),l1_h01(:,:),l1_h10(:,:)
  integer, pointer :: l1_s00(:),l1_s01(:),l1_s10(:)
  integer, pointer :: l2_h00(:,:),l2_h01(:,:),l2_h10(:,:)
  integer, pointer :: l2_s00(:),l2_s01(:),l2_s10(:)

  integer :: spin_switch_temp

  integer :: lr_switch

contains

  subroutine alo_condition(num_atom_kind,num_atom)

    implicit none
    integer, intent(in) :: num_atom_kind,num_atom
    integer :: ier

    allocate(atom_sign(num_atom_kind),atom_num(num_atom_kind)                    &
         ,atom_mass(num_atom_kind),atom_electron(num_atom_kind)               &
         ,atom_orbital(num_atom_kind),ra(num_atom,3)                          &
         ,atom_kind(num_atom),atom_kindn(num_atom),stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_condition 1'
       stop
    end if

    if( ham_model == 'gsp' ) then
       allocate(pair_num(num_atom,num_atom),stat=ier)
       if( ier /= 0 ) then
          write(6,*) 'error allocate: alo_condition 2'
          stop
       end if
    end if

    return
  end subroutine alo_condition

  subroutine unset_condition

    implicit none
    integer :: ier

    deallocate(atom_sign,atom_num,atom_mass,atom_electron                        &
         ,atom_orbital,ra,atom_kind,atom_kindn,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error deallocate: unset_condition 1'
       stop
    end if

    if( ham_model == 'gsp' ) then
       deallocate(pair_num,stat=ier)
       if( ier /= 0 ) then
          write(6,*) 'error allocate: unset_condition 2'
          stop
       end if
    end if

    return
  end subroutine unset_condition

  subroutine alo_condition_omega(i_w_num,om_block_num)

    implicit none
    integer,intent(in) :: i_w_num,om_block_num
    integer :: ier

    iw_max=i_w_num

    allocate(omega_par(om_block_num),omega_par_num(om_block_num),omega(iw_max)   &
         ,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_condition_omega'
       stop
    end if

    return
  end subroutine alo_condition_omega

  subroutine unset_condition_omega

    implicit none
    integer :: ier

    deallocate(omega_par,omega,omega_par_num,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error deallocate: unset_condition_omega'
       stop
    end if

    return
  end subroutine unset_condition_omega

  subroutine alo_condition_dos(kt_num)

    implicit none
    integer, intent(in) :: kt_num
    integer :: ier

    allocate(dos(omega_par_num(num_gra_te),spin_switch_temp,kt_num)              &
         ,ev_mat(mat_max_eigen,kz_max,ky_max,kx_max,spin_switch_temp,kt_num)  &
         ,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_condition_dos'
       stop
    end if

    dos=0.d0
    ev_mat=0.d0

    return
  end subroutine alo_condition_dos

  subroutine unset_condition_dos

    implicit none
    integer :: ier

    deallocate(dos,ev_mat,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error deallocate: unset_condition_dos'
       stop
    end if

    return
  end subroutine unset_condition_dos

  subroutine alo_condition_hami_temp

    implicit none
    integer :: ier,num_h00_temp,num_h01_temp,num_h10_temp

    num_h00_temp=num_h00(1)
    if( num_h00_temp < num_h00(2) ) then
       num_h00_temp=num_h00(2)
    end if
    num_h01_temp=num_h01(1)
    if( num_h01_temp < num_h01(2) ) then
       num_h01_temp=num_h01(2)
    end if
    num_h10_temp=num_h10(1)
    if( num_h10_temp < num_h10(2) ) then
       num_h10_temp=num_h10(2)
    end if

    allocate(h00(spin_switch_temp,num_h00_temp+1)                                &
         ,h01(spin_switch_temp,num_h01_temp+1)                                &
         ,h10(spin_switch_temp,num_h10_temp+1)                                &
         ,s00(num_s00+1),s01(num_s01+1),s10(num_s10+1)                        &
         ,l1_h00(spin_switch_temp,num_h00_temp+1)                             &
         ,l1_h01(spin_switch_temp,num_h01_temp+1)                             &
         ,l1_h10(spin_switch_temp,num_h10_temp+1)                             &
         ,l1_s00(num_s00+1),l1_s01(num_s01+1),l1_s10(num_s10+1)               &
         ,l2_h00(spin_switch_temp,num_h00_temp+1)                             &
         ,l2_h01(spin_switch_temp,num_h01_temp+1)                             &
         ,l2_h10(spin_switch_temp,num_h10_temp+1)                             &
         ,l2_s00(num_s00+1),l2_s01(num_s01+1),l2_s10(num_s10+1)               &
         ,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_condition_hami_temp'
       stop
    end if

    return
  end subroutine alo_condition_hami_temp

  subroutine unset_condition_hami_temp

    implicit none
    integer :: ier

    deallocate(h00,h01,h10,s00,s01,s10                                           &
         ,l1_h00,l1_h01,l1_h10,l1_s00,l1_s01,l1_s10                         &
         ,l2_h00,l2_h01,l2_h10,l2_s00,l2_s01,l2_s10,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error deallocate: unset_condition_hami_temp'
       stop
    end if

    return
  end subroutine unset_condition_hami_temp
end module condition

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine set_hamiltonian_l(qx,qy,ispin)

  use condition
  use hamiltonian_e
  use hamiltonian_sgf

  implicit none
  integer, intent(in) :: qx,qy,ispin
  integer :: i1_do,i2_do,ier
  complex(8), allocatable :: temp(:,:)

  if( ham_model == 'input' .or. ham_model == 'scf_accel' ) then
     call set_hamiltonian_input_l(ispin)
     return
  end if

  !                       ------------------------------------                       !

  if( p_or_f == 'free' ) then
     call set_hamiltonian_free
  else
     if( p_or_f == 'periodic' ) then
        call set_hamiltonian_periodic(qx,qy)
     else
        write(6,*) 'error: set_hamiltonian_l'
        stop
     end if
  end if

  allocate(temp(mat_max,mat_max),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: set_hamiltonian_l'
     stop
  end if

  do i2_do=1,mat_max
     do i1_do=1,mat_max
        temp(i1_do,i2_do)=h01_mat(i1_do,i2_do)
     end do
  end do
  do i2_do=1,mat_max
     do i1_do=1,mat_max
        h01_mat(i1_do,i2_do)=h10_mat(i1_do,i2_do)
     end do
  end do
  do i2_do=1,mat_max
     do i1_do=1,mat_max
        h10_mat(i1_do,i2_do)=temp(i1_do,i2_do)
     end do
  end do

  do i2_do=1,mat_max
     do i1_do=1,mat_max
        temp(i1_do,i2_do)=s01_mat(i1_do,i2_do)
     end do
  end do
  do i2_do=1,mat_max
     do i1_do=1,mat_max
        s01_mat(i1_do,i2_do)=s10_mat(i1_do,i2_do)
     end do
  end do
  do i2_do=1,mat_max
     do i1_do=1,mat_max
        s10_mat(i1_do,i2_do)=temp(i1_do,i2_do)
     end do
  end do

  deallocate(temp,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error deallocate: set_hamiltonian_l'
     stop
  end if

  return
end subroutine set_hamiltonian_l

subroutine set_hamiltonian_r(qx,qy,ispin)

  use condition
  use hamiltonian_e
  use hamiltonian_sgf

  implicit none
  integer, intent(in) :: qx,qy,ispin

  if( ham_model == 'input' .or. ham_model == 'scf_accel' ) then
     call set_hamiltonian_input_r(ispin)
  else
     if( p_or_f == 'free' ) then
        call set_hamiltonian_free
     else
        if( p_or_f == 'periodic' ) then
           call set_hamiltonian_periodic(qx,qy)
        else
           write(6,*) 'error: set_hamiltonian_r'
           stop
        end if
     end if
  end if

  return
end subroutine set_hamiltonian_r

subroutine unset_hamiltonian

  use condition
  use hamiltonian_e

  implicit none

  if( ham_model == 'input' .or. ham_model == 'scf_accel' ) then
     call unset_hamiltonian_input
  else
     if( p_or_f == 'free' ) then
        call unset_hamiltonian_free
     end if
     if( p_or_f == 'periodic' .or.  p_or_f == 'periodic-1d' ) then
        call unset_hamiltonian_periodic
     end if
  end if

  return
end subroutine unset_hamiltonian

subroutine set_hamiltonian_input_l(ispin)

  use condition
  use hamiltonian_e
  use hamiltonian_sgf
  use hamiltonian_c
  use hamiltonian_temp
  use scf_negf
  use constant
  use mod_mpi

  implicit none
  include 'mpif.h'
  integer, intent(in) :: ispin
  integer :: i2_do,i3_do

  call alo_hamiltonian_input


  do i2_do=1,mat_max_ll
     do i3_do=1,mat_max_ll
        h00_mat(i3_do,i2_do)=h00_l_t(ispin,i3_do,i2_do)
     end do
  end do
  do i2_do=1,mat_max_ll
     do i3_do=1,mat_max_ll
        h01_mat(i3_do,i2_do)=h01_l_t(ispin,i3_do,i2_do)
     end do
  end do
  do i2_do=1,mat_max_ll
     do i3_do=1,mat_max_ll
        h10_mat(i3_do,i2_do)=h10_l_t(ispin,i3_do,i2_do)
     end do
  end do

  do i2_do=1,mat_max_ll
     do i3_do=1,mat_max_ll
        s00_mat(i3_do,i2_do)=s00_l_t(i3_do,i2_do)
     end do
  end do
  do i2_do=1,mat_max_ll
     do i3_do=1,mat_max_ll
        s01_mat(i3_do,i2_do)=s01_l_t(i3_do,i2_do)
     end do
  end do
  do i2_do=1,mat_max_ll
     do i3_do=1,mat_max_ll
        s10_mat(i3_do,i2_do)=s10_l_t(i3_do,i2_do)
     end do
  end do

  return
end subroutine set_hamiltonian_input_l

subroutine set_hamiltonian_input_r(ispin)

  use condition
  use hamiltonian_sgf
  use hamiltonian_c
  use hamiltonian_e
  use hamiltonian_temp
  use scf_negf
  use constant
  use mod_mpi

  implicit none
  include 'mpif.h'
  integer, intent(in) :: ispin
  integer :: i2_do,i3_do

  call alo_hamiltonian_input

  !                       ------------------------------------                       !

  do i2_do=1,mat_max_rr
     do i3_do=1,mat_max_rr
        h00_mat(i3_do,i2_do)=h00_r_t(ispin,i3_do,i2_do)
     end do
  end do
  do i2_do=1,mat_max_rr
     do i3_do=1,mat_max_rr
        h01_mat(i3_do,i2_do)=h01_r_t(ispin,i3_do,i2_do)
     end do
  end do
  do i2_do=1,mat_max_rr
     do i3_do=1,mat_max_rr
        h10_mat(i3_do,i2_do)=h10_r_t(ispin,i3_do,i2_do)
     end do
  end do

  do i2_do=1,mat_max_rr
     do i3_do=1,mat_max_rr
        s00_mat(i3_do,i2_do)=s00_r_t(i3_do,i2_do)
     end do
  end do
  do i2_do=1,mat_max_rr
     do i3_do=1,mat_max_rr
        s01_mat(i3_do,i2_do)=s01_r_t(i3_do,i2_do)
     end do
  end do
  do i2_do=1,mat_max_rr
     do i3_do=1,mat_max_rr
        s10_mat(i3_do,i2_do)=s10_r_t(i3_do,i2_do)
     end do
  end do

  return
end subroutine set_hamiltonian_input_r

subroutine set_hamiltonian_free

  use condition
  use hamiltonian_e

  implicit none
  integer :: max_atom_orbital
  integer :: kx,ky,lx,ly,iz
  integer :: i1_do,i2_do,i3_do,i4_do,i1_count,i2_count,ier
  complex(8), allocatable :: h_ijmn(:,:),s_ijmn(:,:)

  max_atom_orbital=0
  do i1_do=1,num_atom_kind
     if( max_atom_orbital < atom_orbital(i1_do) ) then
        max_atom_orbital=atom_orbital(i1_do)
     end if
  end do

  call alo_hamiltonian_free(num_atom,num_unit)

  allocate(h_ijmn(max_atom_orbital,max_atom_orbital)                           &
       ,s_ijmn(max_atom_orbital,max_atom_orbital),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: set_hamiltonian_free'
     stop
  end if

  !                       ------------------------------------                       !

  i1_count=0
  do kx=1,num_unit(1)
     do ky=1,num_unit(2)
        do i1_do=1,num_atom
           itemp(kx,ky,i1_do)=i1_count
           i1_count=i1_count+atom_orbital(atom_kindn(i1_do))
        end do
     end do
  end do

  do kx=0,num_unit(1)-1
     do ky=0,num_unit(2)-1
        do i1_do=1,num_atom
           i1_count=itemp(kx+1,ky+1,i1_do)
           do lx=0,num_unit(1)-1
              do ly=0,num_unit(2)-1
                 do i2_do=1,num_atom
                    i2_count=itemp(lx+1,ly+1,i2_do)
                    if( i1_count == i2_count ) then
                       if( ham_model .eq. 'gsp' ) then
                          call onsite_gsp_hamiltonian(max_atom_orbital,i1_do,i2_do     &
                               ,h_ijmn,s_ijmn)
                       else
                          if( ham_model .eq. 'rtb_h' ) then
                             call onsite_rtbh_hamiltonian(max_atom_orbital,i1_do        &
                                  ,h_ijmn,s_ijmn)
                          else
                             write(6,*) 'error - ham_model: set_hamiltonian_free 1'
                             stop
                          end if
                       end if
                    else
                       iz=0
                       if( ham_model .eq. 'gsp' ) then
                          call off_gsp_hamiltonian(iz,kx,ky,lx,ly,i1_do,i2_do          &
                               ,max_atom_orbital,h_ijmn,s_ijmn)
                       else
                          if( ham_model .eq. 'rtb_h' ) then
                             call off_rtbh_hamiltonian(iz,kx,ky,lx,ly,i1_do,i2_do       &
                                  ,max_atom_orbital,h_ijmn,s_ijmn)
                          else
                             write(6,*) 'error - ham_model: set_hamiltonian_free 2'
                             stop
                          end if
                       end if
                    end if
                    do i3_do=1,atom_orbital(atom_kindn(i1_do))
                       do i4_do=1,atom_orbital(atom_kindn(i2_do))
                          h00_mat(i1_count+i3_do,i2_count+i4_do)=h_ijmn(i3_do,i4_do)
                          s00_mat(i1_count+i3_do,i2_count+i4_do)=s_ijmn(i3_do,i4_do)
                       end do
                    end do
                    iz=l_or_r
                    if( ham_model .eq. 'gsp' ) then
                       call off_gsp_hamiltonian(iz,kx,ky,lx,ly,i1_do,i2_do            &
                            ,max_atom_orbital,h_ijmn,s_ijmn)
                    else
                       if( ham_model .eq. 'rtb_h' ) then
                          call off_rtbh_hamiltonian(iz,kx,ky,lx,ly,i1_do,i2_do         &
                               ,max_atom_orbital,h_ijmn,s_ijmn)
                       else
                          write(6,*) 'error - ham_model: set_hamiltonian_free 3'
                          stop
                       end if
                    end if
                    do i3_do=1,atom_orbital(atom_kindn(i1_do))
                       do i4_do=1,atom_orbital(atom_kindn(i2_do))
                          h10_mat(i1_count+i3_do,i2_count+i4_do)=h_ijmn(i3_do,i4_do)
                          h01_mat(i2_count+i4_do,i1_count+i3_do)                       &
                               =dconjg(h_ijmn(i3_do,i4_do))
                          s10_mat(i1_count+i3_do,i2_count+i4_do)=s_ijmn(i3_do,i4_do)
                          s01_mat(i2_count+i4_do,i1_count+i3_do)                       &
                               =dconjg(s_ijmn(i3_do,i4_do))
                       end do
                    end do
                 end do
              end do
           end do
        end do
     end do
  end do

  !                       ------------------------------------                       !

  deallocate(h_ijmn,s_ijmn,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error deallocate: set_hamiltonian_free'
     stop
  end if

  return
end subroutine set_hamiltonian_free

subroutine set_hamiltonian_periodic(qx,qy)

  use condition
  use hamiltonian_e

  implicit none
  integer, intent(in) :: qx,qy

  integer :: max_atom_orbital
  integer :: kx,ky,lx,ly,iz
  integer :: i1_do,i2_do,i3_do,i4_do,i1_count,i2_count,ier
  real(8) :: pai,cs,sn
  complex(8), allocatable :: h_ijmn(:,:),s_ijmn(:,:)

  pai=datan(1.d0)*4.d0

  max_atom_orbital=0
  do i1_do=1,num_atom_kind
     if( max_atom_orbital < atom_orbital(i1_do) ) then
        max_atom_orbital=atom_orbital(i1_do)
     end if
  end do

  call alo_hamiltonian_periodic(num_atom)

  allocate(h_ijmn(max_atom_orbital,max_atom_orbital)                           &
       ,s_ijmn(max_atom_orbital,max_atom_orbital),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: set_hamiltonian_periodic'
     stop
  end if

  !                       ------------------------------------                       !

  i1_count=0
  do i1_do=1,num_atom
     jtemp(i1_do)=i1_count
     i1_count=i1_count+atom_orbital(atom_kindn(i1_do))
  end do

  kx=qx
  ky=qy
  do i1_do=1,num_atom
     i1_count=jtemp(i1_do)
     do i2_do=1,num_atom
        i2_count=jtemp(i2_do)
        do lx=-neighbor_x_max,neighbor_x_max
           do ly=-neighbor_y_max,neighbor_y_max
              if( i1_do == i2_do .and. lx == 0 .and. ly == 0 ) then
                 if( ham_model .eq. 'gsp' ) then
                    call onsite_gsp_hamiltonian(max_atom_orbital,i1_do,i2_do         &
                         ,h_ijmn,s_ijmn)
                 else
                    if( ham_model .eq. 'rtb_h' ) then
                       call onsite_rtbh_hamiltonian(max_atom_orbital,i1_do            &
                            ,h_ijmn,s_ijmn)
                    else
                       write(6,*) 'error - ham_model: set_hamiltonian_periodic 1'
                       stop
                    end if
                 end if
                 cs=1.d0
                 sn=0.d0
              else
                 iz=0
                 if( ham_model .eq. 'gsp' ) then
                    call off_gsp_hamiltonian(iz,lx,ly,0,0,i1_do,i2_do                &
                         ,max_atom_orbital,h_ijmn,s_ijmn)
                 else
                    if( ham_model .eq. 'rtb_h' ) then
                       call off_rtbh_hamiltonian(iz,lx,ly,0,0,i1_do,i2_do             &
                            ,max_atom_orbital,h_ijmn,s_ijmn)
                    else
                       write(6,*) 'error - ham_model: set_hamiltonian_periodic 2'
                       stop
                    end if
                 end if
                 cs=dcos(2.d0*pai*(dfloat((kx-1)*lx)/dfloat(kx_max)                 &
                      +dfloat((ky-1)*ly)/dfloat(ky_max)))
                 sn=dsin(2.d0*pai*(dfloat((kx-1)*lx)/dfloat(kx_max)                 &
                      +dfloat((ky-1)*ly)/dfloat(ky_max)))
              end if
              do i3_do=1,atom_orbital(atom_kindn(i1_do))
                 do i4_do=1,atom_orbital(atom_kindn(i2_do))
                    h00_mat(i1_count+i3_do,i2_count+i4_do)                           &
                         =h00_mat(i1_count+i3_do,i2_count+i4_do)               &
                         +h_ijmn(i3_do,i4_do)*dcmplx(cs,sn)
                    s00_mat(i1_count+i3_do,i2_count+i4_do)                           &
                         =s00_mat(i1_count+i3_do,i2_count+i4_do)               &
                         +s_ijmn(i3_do,i4_do)*dcmplx(cs,sn)
                 end do
              end do
              iz=l_or_r
              if( ham_model .eq. 'gsp' ) then
                 call off_gsp_hamiltonian(iz,lx,ly,0,0,i1_do,i2_do                  &
                      ,max_atom_orbital,h_ijmn,s_ijmn)
              else
                 if( ham_model .eq. 'rtb_h' ) then
                    call off_rtbh_hamiltonian(iz,lx,ly,0,0,i1_do,i2_do               &
                         ,max_atom_orbital,h_ijmn,s_ijmn)
                 else
                    write(6,*) 'error - ham_model: set_hamiltonian_periodic 3'
                    stop
                 end if
              end if
              do i3_do=1,atom_orbital(atom_kindn(i1_do))
                 do i4_do=1,atom_orbital(atom_kindn(i2_do))
                    h10_mat(i1_count+i3_do,i2_count+i4_do)                           &
                         =h10_mat(i1_count+i3_do,i2_count+i4_do)                 &
                         +h_ijmn(i3_do,i4_do)*dcmplx(cs,sn)
                    h01_mat(i2_count+i4_do,i1_count+i3_do)                           &
                         =h01_mat(i2_count+i4_do,i1_count+i3_do)                 &
                         +dconjg(h_ijmn(i3_do,i4_do)*dcmplx(cs,sn))
                    s10_mat(i1_count+i3_do,i2_count+i4_do)                           &
                         =s10_mat(i1_count+i3_do,i2_count+i4_do)                 &
                         +s_ijmn(i3_do,i4_do)*dcmplx(cs,sn)
                    s01_mat(i2_count+i4_do,i1_count+i3_do)                           &
                         =s01_mat(i2_count+i4_do,i1_count+i3_do)                 &
                         +dconjg(s_ijmn(i3_do,i4_do)*dcmplx(cs,sn))
                 end do
              end do
           end do
        end do
     end do
  end do

  !                       ------------------------------------                       !

  deallocate(h_ijmn,s_ijmn,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error deallocate: set_hamiltonian_periodic'
     stop
  end if

  return
end subroutine set_hamiltonian_periodic

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine scf_main_negf_ac

  use scf_negf
  use fft
  use dft
  use condition_ini
  use hamiltonian_sgf
  use hamiltonian_c
  use hamiltonian_temp
  use gf_se_c
  use constant
  use mod_mpi

  implicit none
  include 'mpif.h'
  integer :: i_do,iter,cutene_vt_ok,ispin
  real(8) :: dif_max_rho
  real(8) :: st1,st2,stdel

  integer :: i_conv_ok,i_temp,ier,i1_do,i2_do,i3_do,kt,ic_spin
  real(8), allocatable :: dens_temp1(:,:,:,:)
  real(8), allocatable :: dens_temp2(:,:,:,:)

  real(8) :: qx_scf,qy_scf,qq_con

  if( ispin_pol_scf /= 2 ) then
     ic_spin=1
  else
     ic_spin=2
  end if

  call alo_mod_mpi(i_total_omega,ic_spin,kt_num,file_selfenergy_scf)

  call alo_scf_ham(m_mat_max_c)
  call alo_ham_temp_ham(m_mat_max_c,mat_max_ll,mat_max_rr)

  if( ft_switch == 'f_2_ft' .or. ft_switch == 'fft' ) then
     call set_fft
  else
     call alo_dft(n_a,n_b,2)
  end if

  open(unit=16,file=file_tempout,position='append')
  write(16,*)
  write(16,*) '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'
  call myclock(st1)
  close(16)

  call alo_density_ini
  call fourier_pot

  if( restart_onoff /= 'on' ) then
     call iteration_ini
  end if
  call calc_charge_open

  open(unit=16,file=file_tempout,position='append')
  write(16,*) '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'
  call myclock(st2)
  stdel=st2-st1
  write(16,*) '                t=',stdel
  close(16)

  if( iter_conv > 10 .and. iter_conv < 20 ) then
     call DensityMatrix__update(dif_max_rho,0)
  else
     if( iter_conv > 20 .and. iter_conv < 30 ) then
        call Hamiltonian__calcD__ac2as
        call Density__update(dif_max_rho,0)
     end if
  end if

  gra_onoff='off'
  cutene_vt_ok=0

  i_conv_ok=1

  open(unit=16,file=file_tempout,position='append')
  write(16,*)
  write(16,*) '**************************************************************'
  write(16,*) '************ start iteration:'
  write(16,*) '**************************************************************'
  close(16)

  do i_do=1,max_num_scf

     open(unit=16,file=file_tempout,position='append')
     write(16,*)
     write(16,*) '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'
     write(16,*) '++++++++++++ iterations:',i_do
     write(16,*) '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'
     close(16)

     open(unit=16,file=file_tempout,position='append')
     call myclock(st1)

     cutene_vt_ok=0
     iter=i_do

     call alo_density_2
     if( hartree_switch == 0 ) then
        call alo_use_scf_4
        call cal_vhart_easier
        call unset_use_scf_4
     else
        call cal_vhartree
     end if
     call unset_density_21

     call alo_use_scf_3(m_mat_max_c)
     call cal_vother(cutene_vt_ok)

     call cal_hamiltonian_accel
     call unset_use_scf_32

     call myclock(st2)
     stdel=st2-st1
     write(16,*) '                t=',stdel
     close(16)

     iter=i_do
     call alo_density_1(m_mat_max_c)

     !                                +++++++++++++++++++++++++++++++++++++++++++++++++++

     do kt=1,ka_scf*kb_scf
        if( ksw_po_kt_scf(kt) == 0 ) then
           cycle
        end if

        qx_scf=po_kt_scf(2,kt)
        qy_scf=po_kt_scf(3,kt)
        qq_con=dfloat(ksw_po_kt_scf(kt))

        open(unit=16,file=file_tempout,position='append')
        write(16,*) '         >>>>>>>>>>>>    k:',kt,'<<<<<<<<<<<<'
        close(16)

        call set_ham_temp_ham_l(qx_scf,qy_scf)
        call set_ham_temp_ham_r(qx_scf,qy_scf)
        call set_ham_scf_ham_c(qx_scf,qy_scf)

        do ispin=1,ic_spin
           if( file_selfenergy_onoff /= 'on' .and. i_do == 1 ) then
              call cal_gf_se_c_scf(ispin,kt)
           else
              call cal_gf_se_read_scf(ispin,kt)
           end if
        end do

        allocate(dens_temp1(4,ic_spin,m_mat_max_c,m_mat_max_c)                   &
             ,dens_temp2(4,ic_spin,m_mat_max_c,m_mat_max_c),stat=ier)
        if( ier /= 0 ) then
           write(6,*) 'error allocate: alo_density_temp'
           stop
        end if
        do i3_do=1,m_mat_max_c
           do i2_do=1,m_mat_max_c
              do i1_do=1,ic_spin
                 dens_temp1(1,i1_do,i2_do,i3_do)=dens(i1_do,i2_do,i3_do)
                 dens_temp1(2,i1_do,i2_do,i3_do)=dens2(i1_do,i2_do,i3_do)
                 dens_temp1(3,i1_do,i2_do,i3_do)=edens(i1_do,i2_do,i3_do)
                 dens_temp1(4,i1_do,i2_do,i3_do)=edens2(i1_do,i2_do,i3_do)
                 dens_temp2(1,i1_do,i2_do,i3_do)=0.d0
                 dens_temp2(2,i1_do,i2_do,i3_do)=0.d0
                 dens_temp2(3,i1_do,i2_do,i3_do)=0.d0
                 dens_temp2(4,i1_do,i2_do,i3_do)=0.d0
              end do
           end do
        end do
        i_temp=4*ic_spin*m_mat_max_c*m_mat_max_c
        call MPI_ALLREDUCE(dens_temp1,dens_temp2,i_temp,MPI_DOUBLE_PRECISION     &
             ,MPI_SUM,mpi_comm_world,ierr)
        do i3_do=1,m_mat_max_c
           do i2_do=1,m_mat_max_c
              do i1_do=1,ic_spin
                 dens(i1_do,i2_do,i3_do)=dens_temp2(1,i1_do,i2_do,i3_do)
                 dens2(i1_do,i2_do,i3_do)=dens_temp2(2,i1_do,i2_do,i3_do)
                 edens(i1_do,i2_do,i3_do)=dens_temp2(3,i1_do,i2_do,i3_do)
                 edens2(i1_do,i2_do,i3_do)=dens_temp2(4,i1_do,i2_do,i3_do)
              end do
           end do
        end do
        deallocate(dens_temp1,dens_temp2,stat=ier)
        if( ier /= 0 ) then
           write(6,*) 'error deallocate: alo_density_temp'
           stop
        end if

        call Hamiltonian__calcD__as2ac(qx_scf,qy_scf,qq_con,kt)

     end do

     !                                +++++++++++++++++++++++++++++++++++++++++++++++++++

     open(unit=16,file=file_tempout,position='append')
     call myclock(st1)

     call dens_atom2cell_lr(dif_max_rho,iter)
     call unset_density_1

     call myclock(st2)
     stdel=st2-st1
     write(16,*) '                t=',stdel

     if( (iter_conv == 1 .or. iter_conv > 10)                                   &
          .and. iter == 0 .and. cutene_vt_ok == 0 ) then
        write(16,*)
        write(16,*)                                                              &
             '**************************************************************'
        write(16,*) '************   end iterations:',i_do
        write(16,*)                                                              &
             '**************************************************************'
        i_conv_ok=0
     end if
100  continue

     close(16)

     if( i_conv_ok == 0 ) then
        exit
     end if

  end do

  if( force_calc_onoff == 'on' ) then
     call Force__calc__negf
  end if

  call unset_density_ini
  gra_onoff='on'

  call unset_scf_accel_parameter
  call dealo_ham_temp_ham

  if( ft_switch == 'f_2_ft' .or. ft_switch == 'fft'  ) then
     call unset_fft
  else
     call unset_dft
  end if

  call dealo_mod_mpi

  return
end subroutine scf_main_negf_ac

subroutine scf_main_unset_negf

  use scf_negf

  implicit none

  call unset_scf_ham
  call unset_scf_accel_parameter1

  return
end subroutine scf_main_unset_negf

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Naoki WATANABE, Nobutaka NISHIKAWA (Mizuho I.R.)   @@ !
! @@             Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine DensityMatrix__calc
  use ac_misc_module
  use ac_mpi_module
  implicit none

  integer :: k, m
  integer :: spin, ispin, jspin
  integer :: l
  integer :: a, i, i1
  integer :: b, j, j1

  complex(8) :: bloch

  complex(8) :: ci, cj
  real(8)    :: E, F

  do l=0, Param%Cell%nL-1
     do a=MPI%isatom, MPI%ieatom
        do b=1, Param%Data%natom
           if( .not. associated(Hamiltonian%vAtomMatrix(b,a,l)%Ptr) ) then
              cycle
           end if

           if( Param%Option%spin_orbit ) then
              Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDMLS(:,:,:) = 0.d0
              if( Param%Option%optimize ) then
                 Hamiltonian%vAtomMatrix(b,a,l)%Ptr%EDMLS(:,:) = 0.d0
              end if
           else
              Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDM(:,:,:) = 0.d0
              if( Param%Option%optimize ) then
                 Hamiltonian%vAtomMatrix(b,a,l)%Ptr%EDM(:,:) = 0.d0
              end if
           end if
        end do
     end do
  end do

  do k=1, Param%SCF%nK
     if( Param%SCF%i_vK(k) >= 0 ) then
        cycle
     end if
     do a=MPI%isatom, MPI%ieatom
        i=Base%vipao(a)

        do b=1, Param%Data%natom
           j=Base%vipao(b)

           do i1=MPI%ispao(a), MPI%iepao(a)
              do j1=1, Base%vnpao(b)

                 do l=0, Param%Cell%nL-1

                    bloch = Param%SCF%vbloch(k,l)/Param%SCF%nK * dfloat(-Param%SCF%i_vK(k))

                    if( .not. associated(Hamiltonian%vAtomMatrix(b,a,l)%Ptr) ) then
                       cycle
                    end if

                    if( Param%Option%spin_orbit ) then
                       Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDMLS(j1,i1,:) = &
                            Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDMLS(j1,i1,:) &
                            + bloch*Hamiltonian%vBandMatrix(k)%H(j+j1-1,i+i1-1,:)

                       if( Param%Option%optimize ) then
                          Hamiltonian%vAtomMatrix(b,a,l)%Ptr%EDMLS(j1,i1) = &
                               Hamiltonian%vAtomMatrix(b,a,l)%Ptr%EDMLS(j1,i1) &
                               + real(bloch*Hamiltonian%vBandMatrix(k)%S(j+j1-1,i+i1-1))
                       end if
                    else
                       Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDM(j1,i1,:) = &
                            Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDM(j1,i1,:) &
                            + real(bloch*Hamiltonian%vBandMatrix(k)%H(j+j1-1,i+i1-1,:))
                       if( Param%Option%optimize ) then
                          Hamiltonian%vAtomMatrix(b,a,l)%Ptr%EDM(j1,i1) = &
                               Hamiltonian%vAtomMatrix(b,a,l)%Ptr%EDM(j1,i1) &
                               + real(bloch*Hamiltonian%vBandMatrix(k)%S(j+j1-1,i+i1-1))
                       end if
                    endif

                 end do

              end do
           end do
        end do
     end do
  end do

  return
end subroutine DensityMatrix__calc

subroutine DensityMatrix__update( dEden, iter )
  use ac_misc_module
  implicit none
  real(8), intent(inout) :: dEden
  integer, intent(in)    :: iter

  select case( Param%SCF%mix_type )
  case('Simple')
     call DensityMatrix__updateSimple  ( dEden, iter )
  case('Pulay')
     call DensityMatrix__updatePulay   ( dEden, iter )
  case('Anderson')
     call DensityMatrix__updateAnderson( dEden, iter )
  end select

  return
end subroutine DensityMatrix__update

subroutine DensityMatrix__updateSimple( dEden, iter )
  use ac_misc_module
  use ac_mpi_module
  implicit none

  real(8), intent(inout) :: dEden
  integer, intent(in) :: iter

  integer :: a, b, l
  type(AtomMatrix_type), pointer :: amat

  integer :: i1, j1, ispin

  if( Param%SCF%mix_history /= 1 ) then
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,*) '      ++++++ Warning!: mixing history should be 1 for Simple mixing'
     close(16)
     Param%SCF%mix_history = 1
  end if

  if( iter<0 ) then
     dEden = 0.d0
     return
  end if


  if( iter==0 ) then
     dEden = 0.d0

     do l=0, Param%Cell%nL-1
        do a=MPI%isatom, MPI%ieatom
           do b=1, Param%Data%natom
              if( .not. associated(Hamiltonian%vAtomMatrix(b,a,l)%Ptr) ) then
                 cycle
              end if

              amat => Hamiltonian%vAtomMatrix(b,a,l)%Ptr

              if( Param%Option%spin_orbit ) then
                 amat%vpast(1)%CDMLS(:,:,:) = amat%CDMLS(:,:,:)
                 do ispin=1, Param%Option%nspin
                    do i1=MPI%ispao(a), MPI%iepao(a)
                       do j1=1, Base%vnpao(b)
                          if( dEden < cdabs(amat%vpast(1)%CDMLS(j1,i1,ispin)) ) then
                             dEden = cdabs(amat%vpast(1)%CDMLS(j1,i1,ispin))
                          end if
                       end do
                    end do
                 end do
              else
                 amat%vpast(1)%CDM(:,:,:) = amat%CDM(:,:,:)
                 do ispin=1, Param%Option%nspin
                    do i1=MPI%ispao(a), MPI%iepao(a)
                       do j1=1, Base%vnpao(b)
                          if( dEden < abs(amat%vpast(1)%CDM(j1,i1,ispin)) ) then
                             dEden = abs(amat%vpast(1)%CDM(j1,i1,ispin))
                          end if
                       end do
                    end do
                 end do
              end if
           end do
        end do
     end do

     call MPI__Allreduce_Error_Max( dEden )

     return
  end if

  do l=0, Param%Cell%nL-1
     do a=MPI%isatom, MPI%ieatom
        do b=1, Param%Data%natom
           if( .not. associated(Hamiltonian%vAtomMatrix(b,a,l)%Ptr) ) then
              cycle
           end if

           amat => Hamiltonian%vAtomMatrix(b,a,l)%Ptr

           if( Param%Option%spin_orbit ) then
              amat%vpast(1)%dCDMLS(:,:,:) = amat%CDMLS(:,:,:) - amat%vpast(1)%CDMLS(:,:,:)
           else
              amat%vpast(1)%dCDM(:,:,:) = amat%CDM(:,:,:) - amat%vpast(1)%CDM(:,:,:)
           end if
        end do
     end do
  end do

  do l=0, Param%Cell%nL-1
     do a=MPI%isatom, MPI%ieatom
        do b=1, Param%Data%natom
           if( .not. associated(Hamiltonian%vAtomMatrix(b,a,l)%Ptr) ) then
              cycle
           end if

           amat => Hamiltonian%vAtomMatrix(b,a,l)%Ptr

           if( Param%Option%spin_orbit ) then
              amat%CDMLS(:,:,:) = amat%CDMLS(:,:,:) + amat%vpast(1)%dCDMLS(:,:,:) * (Param%SCF%mix_weight_s-1.0)
              amat%vpast(1)%CDMLS(:,:,:) = amat%CDMLS(:,:,:)
           else
              amat%CDM(:,:,:) = amat%CDM(:,:,:) + amat%vpast(1)%dCDM(:,:,:) * (Param%SCF%mix_weight_s-1.0)
              amat%vpast(1)%CDM(:,:,:) = amat%CDM(:,:,:)
           end if
        end do
     end do
  end do

  dEden = 0.d0

  do l=0, Param%Cell%nL-1
     do a=MPI%isatom, MPI%ieatom
        do b=1, Param%Data%natom
           if( .not. associated(Hamiltonian%vAtomMatrix(b,a,l)%Ptr) ) then
              cycle
           end if

           amat => Hamiltonian%vAtomMatrix(b,a,l)%Ptr

           if( Param%Option%spin_orbit ) then
              do ispin=1, Param%Option%nspin
                 do i1=MPI%ispao(a), MPI%iepao(a)
                    do j1=1, Base%vnpao(b)
                       if( dEden < cdabs(amat%vpast(1)%dCDMLS(j1,i1,ispin)) ) then
                          dEden = cdabs(amat%vpast(1)%dCDMLS(j1,i1,ispin))
                       end if
                    end do
                 end do
              end do
           else
              do ispin=1, Param%Option%nspin
                 do i1=MPI%ispao(a), MPI%iepao(a)
                    do j1=1, Base%vnpao(b)
                       if( dEden < abs(amat%vpast(1)%dCDM(j1,i1,ispin)) ) then
                          dEden = abs(amat%vpast(1)%dCDM(j1,i1,ispin))
                       end if
                    end do
                 end do
              end do
           end if
        end do
     end do
  end do

  call MPI__Allreduce_Error_Max( dEden )

  return
end subroutine DensityMatrix__updateSimple

subroutine DensityMatrix__updatePulay( dEden, iter )
  use ac_misc_module
  use ac_mpi_module
  implicit none

  real(8), intent(inout) :: dEden
  integer, intent(in) :: iter

  integer :: a, b, l
  type(AtomMatrix_type), pointer :: amat

  real(8), allocatable :: matrix(:,:)
  real(8), allocatable :: alpha(:)
  integer, allocatable :: ipiv(:)
  real(8), allocatable :: work(:)
  integer :: n, m
  integer :: info
  real(8) :: sumalpha

  integer :: i1, j1, ispin

  if( Param%SCF%mix_start < Param%SCF%mix_history ) then
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,*) '      ++++++ Warning!: too small mixing start for Pulay mixing'
     close(16)
     Param%SCF%mix_start = Param%SCF%mix_history
  end if

  if( iter<0 ) then
     dEden = 0.d0
     return
  end if

  if( iter==0 ) then
     dEden = 0.d0

     do l=0, Param%Cell%nL-1
        do a=MPI%isatom, MPI%ieatom
           do b=1, Param%Data%natom
              if( .not. associated(Hamiltonian%vAtomMatrix(b,a,l)%Ptr) ) then
                 cycle
              end if

              amat => Hamiltonian%vAtomMatrix(b,a,l)%Ptr

              if( Param%Option%spin_orbit ) then
                 amat%vpast(1)%CDMLS = amat%CDMLS
                 do ispin=1, Param%Option%nspin
                    do i1=MPI%ispao(a), MPI%iepao(a)
                       do j1=1, Base%vnpao(b)
                          if( dEden < cdabs(amat%vpast(1)%CDMLS(j1,i1,ispin)) ) then
                             dEden = cdabs(amat%vpast(1)%CDMLS(j1,i1,ispin))
                          end if
                       end do
                    end do
                 end do
              else
                 amat%vpast(1)%CDM = amat%CDM
                 do ispin=1, Param%Option%nspin
                    do i1=MPI%ispao(a), MPI%iepao(a)
                       do j1=1, Base%vnpao(b)
                          if( dEden < abs(amat%vpast(1)%CDM(j1,i1,ispin)) ) then
                             dEden = abs(amat%vpast(1)%CDM(j1,i1,ispin))
                          end if
                       end do
                    end do
                 end do
              end if
           end do
        end do
     end do

     call MPI__Allreduce_Error_Max( dEden )

     return
  end if

  do l=0, Param%Cell%nL-1
     do a=MPI%isatom, MPI%ieatom
        do b=1, Param%Data%natom
           if( .not. associated(Hamiltonian%vAtomMatrix(b,a,l)%Ptr) ) then
              cycle
           end if

           amat => Hamiltonian%vAtomMatrix(b,a,l)%Ptr

           if( Param%Option%spin_orbit ) then
              amat%vpast(1)%dCDMLS = amat%CDMLS - amat%vpast(1)%CDMLS
           else
              amat%vpast(1)%dCDM = amat%CDM - amat%vpast(1)%CDM
           end if
        end do
     end do
  end do

  if( iter <= Param%SCF%mix_start ) then
     do l=0, Param%Cell%nL-1
        do a=MPI%isatom, MPI%ieatom
           do b=1, Param%Data%natom
              if( .not. associated(Hamiltonian%vAtomMatrix(b,a,l)%Ptr) ) then
                 cycle
              end if

              amat => Hamiltonian%vAtomMatrix(b,a,l)%Ptr

              if( Param%Option%spin_orbit ) then
                 amat%CDMLS = amat%CDMLS + amat%vpast(1)%dCDMLS * (Param%SCF%mix_weight_s-1.0)
              else
                 amat%CDM = amat%CDM + amat%vpast(1)%dCDM * (Param%SCF%mix_weight_s-1.0)
              end if
           end do
        end do
     end do

  else
     allocate( matrix(Param%SCF%mix_history,Param%SCF%mix_history) )
     allocate( alpha(Param%SCF%mix_history) )
     allocate( ipiv(Param%SCF%mix_history) )
     allocate( work(4*Param%SCF%mix_history) )

     matrix(:,:) = 0.d0

     do l=0, Param%Cell%nL-1
        do a=MPI%isatom, MPI%ieatom
           do b=1, Param%Data%natom
              if( .not. associated(Hamiltonian%vAtomMatrix(b,a,l)%Ptr) ) then
                 cycle
              end if

              amat => Hamiltonian%vAtomMatrix(b,a,l)%Ptr
              do n=1, Param%SCF%mix_history
                 do m=n, Param%SCF%mix_history
                    if( Param%Option%spin_orbit ) then
                       matrix(n,m) = matrix(n,m) + sum( dreal(dconjg(amat%vpast(n)%dCDMLS(:,:,1)) * amat%vpast(m)%dCDMLS(:,:,1) ))
                       matrix(n,m) = matrix(n,m) + sum( dreal(dconjg(amat%vpast(n)%dCDMLS(:,:,4)) * amat%vpast(m)%dCDMLS(:,:,4) ))
                    else
                       matrix(n,m) = matrix(n,m) + sum( amat%vpast(n)%dCDM * amat%vpast(m)%dCDM )
                    end if
                 end do
              end do
           end do
        end do
     end do

     call MPI__Allreduce_HistoryPulay( matrix )

     do n=1, Param%SCF%mix_history
        alpha(n) = 1.d0
     end do

     call dsysv( 'U', Param%SCF%mix_history, 1, matrix, &
          Param%SCF%mix_history, ipiv, alpha, &
          Param%SCF%mix_history, work, 4*Param%SCF%mix_history, info, 1 )

     sumalpha=0.d0
     do n=1, Param%SCF%mix_history
        sumalpha = sumalpha + alpha(n)
     end do
     sumalpha = 1.d0/sumalpha
     do n=1, Param%SCF%mix_history
        alpha(n) = alpha(n)*sumalpha
     end do

     do l=0, Param%Cell%nL-1
        do a=MPI%isatom, MPI%ieatom
           do b=1, Param%Data%natom
              if( .not. associated(Hamiltonian%vAtomMatrix(b,a,l)%Ptr) ) then
                 cycle 
              end if

              amat => Hamiltonian%vAtomMatrix(b,a,l)%Ptr

              if( Param%Option%spin_orbit ) then
                 amat%CDMLS = 0.d0
                 do n=1, Param%SCF%mix_history
                    amat%CDMLS = amat%CDMLS + amat%vpast(n)%CDMLS * alpha(n)
                    amat%CDMLS = amat%CDMLS + amat%vpast(n)%dCDMLS * (alpha(n)*Param%SCF%mix_weight)
                 end do
              else
                 amat%CDM = 0.d0
                 do n=1, Param%SCF%mix_history
                    amat%CDM = amat%CDM + amat%vpast(n)%CDM * alpha(n)
                    amat%CDM = amat%CDM + amat%vpast(n)%dCDM * (alpha(n)*Param%SCF%mix_weight)
                 end do
              end if
           end do
        end do
     end do

     deallocate( matrix )
     deallocate( alpha )
     deallocate( ipiv )
     deallocate( work )

  end if

  do l=0, Param%Cell%nL-1
     do a=MPI%isatom, MPI%ieatom
        do b=1, Param%Data%natom
           if( .not. associated(Hamiltonian%vAtomMatrix(b,a,l)%Ptr) ) then
              cycle
           end if

           amat => Hamiltonian%vAtomMatrix(b,a,l)%Ptr

           do n=Param%SCF%mix_history, 2, -1
              if( Param%Option%spin_orbit ) then
                 amat%vpast(n)%CDMLS  = amat%vpast(n-1)%CDMLS
                 amat%vpast(n)%dCDMLS = amat%vpast(n-1)%dCDMLS
              else
                 amat%vpast(n)%CDM  = amat%vpast(n-1)%CDM
                 amat%vpast(n)%dCDM = amat%vpast(n-1)%dCDM
              end if
           end do

           if( Param%Option%spin_orbit ) then
              amat%vpast(1)%CDMLS = amat%CDMLS
           else
              amat%vpast(1)%CDM = amat%CDM
           end if
        end do
     end do
  end do

  dEden = 0.d0

  do l=0, Param%Cell%nL-1
     do a=MPI%isatom, MPI%ieatom
        do b=1, Param%Data%natom
           if( .not. associated(Hamiltonian%vAtomMatrix(b,a,l)%Ptr) ) then
              cycle
           end if

           amat => Hamiltonian%vAtomMatrix(b,a,l)%Ptr

           if( Param%Option%spin_orbit ) then
              do ispin=1, Param%Option%nspin
                 do i1=MPI%ispao(a), MPI%iepao(a)
                    do j1=1, Base%vnpao(b)
                       if( dEden < cdabs(amat%vpast(1)%dCDMLS(j1,i1,ispin)) ) then
                          dEden = cdabs(amat%vpast(1)%dCDMLS(j1,i1,ispin))
                       end if
                    end do
                 end do
              end do
           else
              do ispin=1, Param%Option%nspin
                 do i1=MPI%ispao(a), MPI%iepao(a)
                    do j1=1, Base%vnpao(b)
                       if( dEden < abs(amat%vpast(1)%dCDM(j1,i1,ispin)) ) then
                          dEden = abs(amat%vpast(1)%dCDM(j1,i1,ispin))
                       end if
                    end do
                 end do
              end do
           end if
        end do
     end do
  end do

  call MPI__Allreduce_Error_Max( dEden )

  return
end subroutine DensityMatrix__updatePulay

subroutine DensityMatrix__updateAnderson( dEden, iter )
  use ac_misc_module
  use ac_mpi_module
  implicit none

  real(8), intent(inout) :: dEden
  integer, intent(in) :: iter

  integer :: a, b, l
  type(AtomMatrix_type), pointer :: amat

  real(kind=8), parameter :: detol = 1d-9
  real(kind=8) :: theta1, theta2, det
  real(kind=8) :: matrix(2:3,3)

  integer :: i1, j1, ispin

  if( Param%SCF%mix_history /= 3 ) then
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,*) '      ++++++ Warning!: mixing history should be 3 for Anderson mixing'
     close(16)
     Param%SCF%mix_history = 3
  end if

  if( iter<0 ) then
     dEden = 0.d0
     return
  end if

  if( iter==0 ) then
     dEden = 0.d0

     do l=0, Param%Cell%nL-1
        do a=MPI%isatom, MPI%ieatom
           do b=1, Param%Data%natom
              if( .not. associated(Hamiltonian%vAtomMatrix(b,a,l)%Ptr) ) then
                 cycle
              end if

              amat => Hamiltonian%vAtomMatrix(b,a,l)%Ptr

              if( Param%Option%spin_orbit ) then
                 amat%vpast(1)%CDMLS = amat%CDMLS
                 do ispin=1, Param%Option%nspin
                    do i1=MPI%ispao(a), MPI%iepao(a)
                       do j1=1, Base%vnpao(b)
                          if( dEden < cdabs(amat%vpast(1)%CDMLS(j1,i1,ispin)) ) then
                             dEden = cdabs(amat%vpast(1)%CDMLS(j1,i1,ispin))
                          end if
                       end do
                    end do
                 end do
              else
                 amat%vpast(1)%CDM = amat%CDM
                 do ispin=1, Param%Option%nspin
                    do i1=MPI%ispao(a), MPI%iepao(a)
                       do j1=1, Base%vnpao(b)
                          if( dEden < abs(amat%vpast(1)%CDM(j1,i1,ispin)) ) then
                             dEden = abs(amat%vpast(1)%CDM(j1,i1,ispin))
                          end if
                       end do
                    end do
                 end do
              end if
           end do
        end do
     end do

     call MPI__Allreduce_Error_Max( dEden )

     return
  end if

  do l=0, Param%Cell%nL-1
     do a=MPI%isatom, MPI%ieatom
        do b=1, Param%Data%natom
           if( .not. associated(Hamiltonian%vAtomMatrix(b,a,l)%Ptr) ) then
              cycle
           end if

           amat => Hamiltonian%vAtomMatrix(b,a,l)%Ptr

           if( Param%Option%spin_orbit ) then
              amat%vpast(1)%dCDMLS = amat%CDMLS - amat%vpast(1)%CDMLS
              amat%vpast(2)%CDMLS  = amat%vpast(2)%CDMLS  - amat%vpast(1)%CDMLS
              amat%vpast(2)%dCDMLS = amat%vpast(2)%dCDMLS - amat%vpast(1)%dCDMLS
           else
              amat%vpast(1)%dCDM = amat%CDM - amat%vpast(1)%CDM
              amat%vpast(2)%CDM  = amat%vpast(2)%CDM  - amat%vpast(1)%CDM
              amat%vpast(2)%dCDM = amat%vpast(2)%dCDM - amat%vpast(1)%dCDM
           end if
        end do
     end do
  end do

  if( iter==1 .or. Param%SCF%mix_history == 1 ) then
     theta1 = 0.0d0
     theta2 = 0.0d0
  else if( iter==2 .or. Param%SCF%mix_history == 2 ) then
     matrix(:,:) = 0.d0

     do l=0, Param%Cell%nL-1
        do a=MPI%isatom, MPI%ieatom
           do b=1, Param%Data%natom
              if( .not. associated(Hamiltonian%vAtomMatrix(b,a,l)%Ptr) ) then
                 cycle
              end if

              amat => Hamiltonian%vAtomMatrix(b,a,l)%Ptr

              if( Param%Option%spin_orbit ) then
                 matrix(2,2) = matrix(2,2) + sum( dreal(dconjg(amat%vpast(2)%dCDMLS(:,:,1)) * amat%vpast(2)%dCDMLS(:,:,1)) )
                 matrix(2,2) = matrix(2,2) + sum( dreal(dconjg(amat%vpast(2)%dCDMLS(:,:,4)) * amat%vpast(2)%dCDMLS(:,:,4)) )
                 matrix(2,1) = matrix(2,1) + sum( dreal(dconjg(amat%vpast(2)%dCDMLS(:,:,1)) * amat%vpast(1)%dCDMLS(:,:,1)) )
                 matrix(2,1) = matrix(2,1) + sum( dreal(dconjg(amat%vpast(2)%dCDMLS(:,:,4)) * amat%vpast(1)%dCDMLS(:,:,4)) )
              else
                 matrix(2,2) = matrix(2,2) + sum( amat%vpast(2)%dCDM * amat%vpast(2)%dCDM )
                 matrix(2,1) = matrix(2,1) + sum( amat%vpast(2)%dCDM * amat%vpast(1)%dCDM )
              end if
           end do
        end do
     end do

     call MPI__Allreduce_HistoryAnderson( matrix )

     theta1 = -matrix(2,1)/matrix(2,2)
     theta2 = 0.0d0

  else
     matrix(:,:) = 0.d0

     do l=0, Param%Cell%nL-1
        do a=MPI%isatom, MPI%ieatom
           do b=1, Param%Data%natom
              if( .not. associated(Hamiltonian%vAtomMatrix(b,a,l)%Ptr) ) then
                 cycle
              end if

              amat => Hamiltonian%vAtomMatrix(b,a,l)%Ptr

              if( Param%Option%spin_orbit ) then
                 matrix(2,2) = matrix(2,2) + sum( dreal(dconjg(amat%vpast(2)%dCDMLS(:,:,1)) * amat%vpast(2)%dCDMLS(:,:,1)) )
                 matrix(2,2) = matrix(2,2) + sum( dreal(dconjg(amat%vpast(2)%dCDMLS(:,:,4)) * amat%vpast(2)%dCDMLS(:,:,4)) )

                 matrix(2,3) = matrix(2,3) + sum( dreal(dconjg(amat%vpast(2)%dCDMLS(:,:,1)) * amat%vpast(3)%dCDMLS(:,:,1)) )
                 matrix(2,3) = matrix(2,3) + sum( dreal(dconjg(amat%vpast(2)%dCDMLS(:,:,4)) * amat%vpast(3)%dCDMLS(:,:,4)) )

                 matrix(3,3) = matrix(3,3) + sum( dreal(dconjg(amat%vpast(3)%dCDMLS(:,:,1)) * amat%vpast(3)%dCDMLS(:,:,1)) )
                 matrix(3,3) = matrix(3,3) + sum( dreal(dconjg(amat%vpast(3)%dCDMLS(:,:,4)) * amat%vpast(3)%dCDMLS(:,:,4)) )

                 matrix(2,1) = matrix(2,1) + sum( dreal(dconjg(amat%vpast(2)%dCDMLS(:,:,1)) * amat%vpast(1)%dCDMLS(:,:,1)) )
                 matrix(2,1) = matrix(2,1) + sum( dreal(dconjg(amat%vpast(2)%dCDMLS(:,:,4)) * amat%vpast(1)%dCDMLS(:,:,4)) )

                 matrix(3,1) = matrix(3,1) + sum( dreal(dconjg(amat%vpast(3)%dCDMLS(:,:,1)) * amat%vpast(1)%dCDMLS(:,:,1)) )
                 matrix(3,1) = matrix(3,1) + sum( dreal(dconjg(amat%vpast(3)%dCDMLS(:,:,4)) * amat%vpast(1)%dCDMLS(:,:,4)) )
              else
                 matrix(2,2) = matrix(2,2) + sum( amat%vpast(2)%dCDM * amat%vpast(2)%dCDM )
                 matrix(2,3) = matrix(2,3) + sum( amat%vpast(2)%dCDM * amat%vpast(3)%dCDM )
                 matrix(3,3) = matrix(3,3) + sum( amat%vpast(3)%dCDM * amat%vpast(3)%dCDM )
                 matrix(2,1) = matrix(2,1) + sum( amat%vpast(2)%dCDM * amat%vpast(1)%dCDM )
                 matrix(3,1) = matrix(3,1) + sum( amat%vpast(3)%dCDM * amat%vpast(1)%dCDM )
              end if
           end do
        end do
     end do

     call MPI__Allreduce_HistoryAnderson( matrix )

     det = matrix(2,2)*matrix(3,3) - matrix(2,3)*matrix(2,3)

     if( dabs(det/(matrix(2,2)*matrix(3,3))) < detol ) then
        theta1 = -matrix(2,1)/matrix(2,2)
        theta2 = 0.0d0
     else
        theta1 = (-matrix(3,3)*matrix(2,1)+matrix(2,3)*matrix(3,1))/det
        theta2 = (+matrix(2,3)*matrix(2,1)-matrix(2,2)*matrix(3,1))/det
     end if
  end if



  do l=0, Param%Cell%nL-1
     do a=MPI%isatom, MPI%ieatom
        do b=1, Param%Data%natom
           if( .not. associated(Hamiltonian%vAtomMatrix(b,a,l)%Ptr) ) then
              cycle
           end if

           amat => Hamiltonian%vAtomMatrix(b,a,l)%Ptr

           if( Param%Option%spin_orbit ) then
              amat%CDMLS = amat%vpast(1)%CDMLS + theta1*amat%vpast(2)%CDMLS  + theta2*amat%vpast(3)%CDMLS &
                   + Param%SCF%mix_weight*( amat%vpast(1)%dCDMLS + theta1*amat%vpast(2)%dCDMLS + theta2*amat%vpast(3)%dCDMLS )

              amat%vpast(3)%CDMLS  = amat%vpast(2)%CDMLS
              amat%vpast(2)%CDMLS  = amat%vpast(1)%CDMLS
              amat%vpast(1)%CDMLS  = amat%CDMLS
              amat%vpast(3)%dCDMLS = amat%vpast(2)%dCDMLS
              amat%vpast(2)%dCDMLS = amat%vpast(1)%dCDMLS
           else
              amat%CDM = amat%vpast(1)%CDM + theta1*amat%vpast(2)%CDM  + theta2*amat%vpast(3)%CDM &
                   + Param%SCF%mix_weight*( amat%vpast(1)%dCDM + theta1*amat%vpast(2)%dCDM + theta2*amat%vpast(3)%dCDM )

              amat%vpast(3)%CDM  = amat%vpast(2)%CDM
              amat%vpast(2)%CDM  = amat%vpast(1)%CDM
              amat%vpast(1)%CDM  = amat%CDM
              amat%vpast(3)%dCDM = amat%vpast(2)%dCDM
              amat%vpast(2)%dCDM = amat%vpast(1)%dCDM
           end if
        end do
     end do
  end do

  dEden = 0.d0

  do l=0, Param%Cell%nL-1
     do a=MPI%isatom, MPI%ieatom
        do b=1, Param%Data%natom
           if( .not. associated(Hamiltonian%vAtomMatrix(b,a,l)%Ptr) ) then
              cycle
           end if

           amat => Hamiltonian%vAtomMatrix(b,a,l)%Ptr

           if( Param%Option%spin_orbit ) then
              do ispin=1, Param%Option%nspin
                 do i1=MPI%ispao(a), MPI%iepao(a)
                    do j1=1, Base%vnpao(b)
                       if( dEden < cdabs(amat%vpast(1)%dCDMLS(j1,i1,ispin)) ) then
                          dEden = cdabs(amat%vpast(1)%dCDMLS(j1,i1,ispin))
                       end if
                    end do
                 end do
              end do
           else
              do ispin=1, Param%Option%nspin
                 do i1=MPI%ispao(a), MPI%iepao(a)
                    do j1=1, Base%vnpao(b)
                       if( dEden < abs(amat%vpast(1)%dCDM(j1,i1,ispin)) ) then
                          dEden = abs(amat%vpast(1)%dCDM(j1,i1,ispin))
                       end if
                    end do
                 end do
              end do
           end if
        end do
     end do
  end do

  call MPI__Allreduce_Error_Max( dEden )

  return
end subroutine DensityMatrix__updateAnderson

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Naoki WATANABE, Nobutaka NISHIKAWA (Mizuho I.R.)   @@ !
! @@             Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine Energy__sort(nE,vE)
  use ac_misc_module
  implicit none
  integer, intent(in)  :: nE
  real(8), intent(out) :: vE(nE)

  integer :: spin
  integer :: k, n, m
  real(8) :: work

  if( Param%Option%spin_orbit ) then
     m=0
     do k=1, Param%SCF%nK
        do n=1, Base%npao*2
           m=m+1
           vE(m) = Hamiltonian%vBandMatrix(k)%E(n,1)
        end do
     end do
  else
     m=0
     do k=1, Param%SCF%nK
        do n=1, Base%npao
           do spin=1, Param%Option%nspin
              m=m+1
              vE(m) = Hamiltonian%vBandMatrix(k)%E(n,spin)
           end do
        end do
     end do
  end if

  do n=1, nE
     do m=n+1, nE
        if( vE(n) > vE(m) ) then
           work  = vE(n)
           vE(n) = vE(m)
           vE(m) = work
        end if
     end do
  end do

  return
end subroutine Energy__sort

subroutine Energy__fermifunc(f, E)
  use ac_misc_module

  implicit none
  real(8), intent(in) :: E
  real(8), intent(out) :: f

  real(8) :: cri,h

  if( Param%SCF%Te == 0.d0 ) then
     if( E <= Energy%Ef ) then
        f=1.d0
     else
        f=0.d0
     end if
     return
  end if

  cri=1.d+3
  h=0.5d0*(E-Energy%Ef)/Param%SCF%Te
  if( h > -cri .and. h < cri ) then
     f=0.5d0*(1.d0-tanh(h))
  else
     if( h < -cri ) then
        f=1.d0
     else
        f=0.d0
     end if
  end if

  return
end subroutine Energy__fermifunc

subroutine Energy__numberfunc(n,nE,vE)
  use ac_misc_module

  implicit none
  integer, intent(in)       :: nE
  real(8), intent(in) :: vE(nE)
  real(8), intent(out) :: n

  integer :: m
  real(8) :: eff

  n=0.d0
  do m=1, nE
     call Energy__fermifunc(eff, vE(m))
     n = n + Param%Data%g * eff
  end do
  n = n/Param%SCF%nK

  return
end subroutine Energy__numberfunc

subroutine Energy__findFermi(Ef,nE,vE)
  use ac_misc_module

  implicit none
  integer, intent(in)       :: nE
  real(8), intent(in) :: vE(nE)

  real(8), intent(out) :: Ef
  integer       :: i
  real(8) :: Ea, Eb
  real(8) :: Na, Nb, Nc, No

  integer       :: i_cou

  i = int((Param%SCF%nK*Param%Data%Ne-1.0)/Param%Data%g)+1

  Energy%Ef = vE(i)

  if( Param%SCF%Te == 0.d0 ) then
     Ef = Energy%Ef
     return
  end if

  No = Param%Data%Ne
  Ea = vE(1)
  Energy%Ef = Ea
  call Energy__numberfunc(Na,nE,vE)
  Eb = vE(nE)
  Energy%Ef = Eb
  call Energy__numberfunc(Nb,nE,vE)

  i_cou=0
  do while( .true. )
     if( Na == No ) then
        Energy%Ef = Ea
        exit
     end if
     if( Nb == No ) then
        Energy%Ef = Eb
        exit
     end if

     Energy%Ef = (Ea+Eb)*.5d0
     call Energy__numberfunc(Nc,nE,vE)

     if( Nc < No ) then
        Ea = Energy%Ef
        Na = Nc
     else
        Eb = Energy%Ef
        Nb = Nc
     end if

     i_cou=i_cou+1

     if( abs(Ea-Eb) < 1.0e-14 ) then
        exit
     end if
     if( i_cou > 50 ) then
        exit
     end if
  end do

  Ef = Energy%Ef

  return
end subroutine Energy__findFermi

subroutine Energy__calcOrbital(E,nE,vE)
  use ac_misc_module

  implicit none
  integer, intent(in)       :: nE
  real(8), intent(in) :: vE(nE)

  real(8),intent(out) :: E
  integer :: m

  real(8) :: eff

  E=0.d0
  do m=1, nE
     call Energy__fermifunc(eff,vE(m))
     E = E + Param%Data%g * eff * vE(m)
  end do
  E = E/Param%SCF%nK

  return
end subroutine Energy__calcOrbital

subroutine Energy__calcLattice(E)
  use ac_misc_module

  implicit none
  real(8), intent(out) :: E
  integer        :: l, i, j
  type(Element_type), pointer :: elemi
  type(Element_type), pointer :: elemj
  real(8) :: R(3)
  real(8)  :: dR
  type(PPcharge_type) :: rrhoval
  type(PPloc_type)    :: Vval
  real(8)  :: Ehar
  real(8)  :: ec_t,dbs_t

  E=0.d0
  if( Param%Option%na ) then
     do i=1, Param%Data%natom
        elemi => Param__Data__getElement( Param%Data%vatom(i)%name )
        call PPcharge__set( rrhoval, Param%Data%vatom(i)%Ro, elemi%rhoval )

        do j=1, Param%Data%natom
           elemj => Param__Data__getElement( Param%Data%vatom(j)%name )
           call PPloc__set(Vval, Param%Data%vatom(j)%Ro, elemj%Vval )

           do l=1-Param%Cell%nL, Param%Cell%nL-1 
              R = Param%Data%vatom(i)%Ro - Param%Data%vatom(j)%Ro &
                   - Param%Cell%vL(:,l)
              dR = sqrt(dot_product(R,R))

              if( dR > rrhoval%Rc + Vval%Rc ) cycle

              if( dabs(dR) > 1.d-14 ) then
                 E = E + 0.5d0*Param%Data%vatom(i)%Q * Param%Data%vatom(j)%Q / dR
              end if
              if( .not. Param%Option%cluster ) then
                 call Density__bracketS( dbs_t, rrhoval, Vval, Param%Cell%vL(:,l) )
                 E = E - 0.5d0*dbs_t
              end if
           end do
        end do
     end do

     if( .not. Param%Option%cluster ) then
        call Hartree__calcEnergy1( Ehar, Density%rhoval )
        E = E + Ehar
     end if
  else

     do i=1, Param%Data%natom 
        do j=i+1, Param%Data%natom
           R = Param%Data%vatom(i)%Ro - Param%Data%vatom(j)%Ro
           dR = sqrt(dot_product(R,R))
           E = E + Param%Data%vatom(i)%Q * Param%Data%vatom(j)%Q / dR
        end do
     end do

     if( .not. Param%Option%cluster ) then
        do i=1, Param%Data%natom
           do j=1, Param%Data%natom
              call Ewald__calc( ec_t, Param%Data%vatom(j)%Q, &
                   Param%Data%vatom(j)%Ro, Param%Data%vatom(i)%Ro )
              E = E + 0.5d0*Param%Data%vatom(i)%Q * ec_t
           end do
        end do
     end if

  end if

  return 
end subroutine Energy__calcLattice

subroutine Energy__calcInternal(E)
  use ac_misc_module

  implicit none
  real(8), intent(out) :: E
  real(8) :: Eexc, Ehar

  E=0.d0

  if( .not. Param%Option%nohar ) then
     if( Param%Option%spin_orbit ) then
        call HartreeLS__calcEnergy2( Ehar, Density%rhoLS )
     else
        call Hartree__calcEnergy2( Ehar, Density%rho )
     end if
     E = E + Ehar
  else
     Ehar = 0.0d0
  end if

  if( .not. Param%Option%noexc ) then
     if( Param%Option%spin_orbit ) then
        call ExchangeLS__calcPotential( Eexc, Potential%Vexc, Density%rhoLS, Density%rhopcc )
     else
        call Exchange__calcPotential( Eexc, Potential%Vexc, Density%rho, Density%rhopcc )
     end if
     E = E + Eexc
  else
     Eexc = 0.0d0
  end if

  return
end subroutine Energy__calcInternal

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Naoki WATANABE, Nobutaka NISHIKAWA (Mizuho I.R.)   @@ !
! @@             Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

module ac_parameter
  implicit none

  real(8), parameter :: M_PI       = 3.141592653589793238462d0 
  real(8), parameter :: SQRT_PI    = 1.77245385090551602729d0 
  real(8), parameter :: M_2_SQRTPI = 1.12837916709551257390d0 
  real(8), parameter :: M_1_PI     = 0.31830988618379067154d0 
  real(8), parameter :: M_SQRT1_2  = 0.70710678118654752440d0 
  real(8), parameter :: M_LN2      = 0.69314718055994530942d0 
  real(8), parameter :: M_CBRT2    = 1.259921049894873191d0 
  real(8), parameter :: M_CBRT3    = 1.442249570307408302d0 
  real(8), parameter :: M_CBRTPI   = 1.464591887561523142d0 

  complex(8), parameter :: C1 = (1.0d0, 0.0d0 )
  complex(8), parameter :: C0 = (0.0d0, 0.0d0 )

  real(8), parameter :: RY_TO_AU = 1.d0/2.d0 
  real(8), parameter :: AU_TO_RY = 1.d0/RY_TO_AU 
  real(8), parameter :: AU_TO_AA = 0.529177249d0 
  real(8), parameter :: AA_TO_AU = 1.d0/AU_TO_AA 
  real(8), parameter :: AU_TO_EV = 27.211396212 
  real(8), parameter :: EV_TO_AU = 1.d0/AU_TO_EV 
  real(8), parameter :: KELVIN_TO_AU = 3.166829936860255d-06 
  real(8), parameter :: AU_TO_KELVIN = 1.d0/KELVIN_TO_AU 

  type Atom_type
     character(5)   :: name   
     integer        :: number 
     real(8)  :: Ro(3)  
     real(8)  :: Rc     
     real(8)  :: Q      
     real(8)  :: polarization 
     real(8)  :: force(3)  
     logical  :: optimize     
     real(8) :: opt_position(3)  
     real(8) :: opt_direction(3) 
     real(8), pointer :: force_past(:,:) 
  end type Atom_type

  type Spline_type
     integer :: N 
     real(8), pointer ::  vx(:) 
     real(8), pointer ::  vf(:) 
     real(8), pointer ::  vb(:) 
     real(8), pointer ::  vc(:) 
     real(8), pointer ::  vd(:) 
  end type Spline_type

  type RadialFunc_type
     integer          ::  l    
     real(8)          ::  Rc   
     real(8), pointer :: vR(:) 
     type(Spline_type):: fR    
     real(8), pointer :: vK(:) 
     real(8)          ::  Q    
  end type RadialFunc_type

  type SphericalBessel_type
     integer          :: Nr     
     integer          :: Nk     
     real(8), pointer :: vrx(:) 
     real(8), pointer :: vrw(:) 
     real(8), pointer :: vkx(:) 
     real(8), pointer :: vkw(:) 
  end type SphericalBessel_type

  type Element_type
     character(5)     :: name 
     integer          :: atomic_number 

     type(RadialFunc_type) :: rhoval 
     type(RadialFunc_type) :: Vval   

     integer          :: npao 
     type(RadialFunc_type), pointer :: vpao(:) 

     type(RadialFunc_type) :: Vloc 

     logical          :: dirac 
     integer          :: nVnon 
     type(RadialFunc_type), pointer :: vVnon(:,:) 


     integer          :: npao2 
     type(RadialFunc_type), pointer :: vpao2(:) 
     type(RadialFunc_type), pointer :: vpao2bar(:) 

     integer          :: nVloc 
     type(RadialFunc_type), pointer :: vVloc(:) 

     logical          :: pcc 
     type(RadialFunc_type) :: rhopcc 

     character(10)    :: namexc_pao 
     character(10)    :: namexc_vps 
  end type Element_type

  type Option_type
     logical :: na      = .true.           
     logical :: cluster = .false.          
     logical :: pcc     = .false.          
     logical :: spin_polar = .false.          
     logical :: spin_orbit = .false.          
     integer :: nspin   = 0                
     logical :: nohar   = .false.          
     logical :: noexc   = .false.          
     logical :: indirect_overlap = .false. 
     logical :: mx      = .false.          
     logical :: projection = .false.      
     logical :: ascot_negf = .false.       
     logical :: optimize   = .false.       
     logical :: atom_move   = .false. 
     character(50) :: optimize_method = "cg" 

     character(50) :: fname_accel_c  = ""  
     character(50) :: fname_accel_r  = ""  
     character(50) :: fname_accel_l  = ""  
     character(50) :: fname_ascot_vd = ""  
     character(50) :: fname_ascot_in = ""  

     character(50) :: fname_rhoscf_in   = "" 
     character(50) :: fname_matrices_in = "" 

     character(10) :: saveat = "every" 
     character(50) :: field_format = ".cube" 
     character(50) :: fname_rhoscf   = "" 
     character(50) :: fname_rhopcc = "" 
     character(50) :: fname_rhoval = "" 
     character(50) :: fname_vext = "" 
     character(50) :: fname_vhar = "" 
     character(50) :: fname_vexc = "" 
     character(50) :: fname_vtot = "" 
     character(50) :: fname_matrices = "" 

     character(50) :: file_ac_tempout
  end type Option_type

  type Cell_type
     real(8) :: La(3)    
     real(8) :: Lb(3)    
     real(8) :: Lc(3)    
     real(8) :: Lo(3)    
     integer        :: Na    
     integer        :: Nb    
     integer        :: Nc    
     real(8) :: dLa(3)   
     real(8) :: dLb(3)   
     real(8) :: dLc(3)   
     real(8) :: dKa(3)   
     real(8) :: dKb(3)   
     real(8) :: dKc(3)   
     real(8)        :: dKa1  
     real(8)        :: dKb1  
     real(8)        :: dKc1  
     real(8)        :: V     
     real(8)        :: dV    
     integer        :: nL    

     real(8), pointer :: vL(:,:) 
     integer, pointer :: vLna(:) 
     integer, pointer :: vLnb(:) 
     integer, pointer :: vLnc(:) 
  end type Cell_type

  type SCF_type
     character(10) :: exc_type = 'PZ81'     
     real(8) :: Te = 300.d0 * KELVIN_TO_AU  
     real(8) :: Ecutoff = 150.d0 * RY_TO_AU 
     integer :: Nka = 1 
     integer :: Nkb = 1 
     integer :: Nkc = 1 
     integer :: nK = 1                      
     real(8), pointer :: vK(:,:)       
     integer, pointer :: i_vK(:)
     complex(8), pointer :: vbloch(:,:)     

     character(16) :: mix_type = 'Simple'   
     character(16) :: mix_target = 'density_matrix'   
     real(8) :: mix_weight  =  0.3d0 
     real(8) :: mix_weight_s  =  -0.3d0
     integer :: mix_history = 4      
     integer :: mix_start   = 4      

     character(16) :: cri_type = 'fermi'    
     real(8) :: criterion = 1.e-6           
     integer ::  iter_max =  100 

     real(8) :: force_criterion = 1.0e-3    
     integer :: opt_iter_max =  0 
  end type SCF_type

  type Integral1D_type
     integer       ::  Nr = 900        
     integer       ::  Nk = 900        
     real(8) :: Ecutoff = 2500.d0 * RY_TO_AU 
  end type Integral1D_type

  type Kpath_type
     real(8) :: ks(3)   
     real(8) :: ke(3)   
     integer :: mesh 
  end type Kpath_type

  type Band_type
     character(64)  :: fname = ""                    
     character(64)  :: fname1 = ""                    
     real(8) :: La(3) = (/0,0,0/)          
     real(8) :: Lb(3) = (/0,0,0/)          
     real(8) :: Lc(3) = (/0,0,0/)          
     real(8) :: dKa(3)                           
     real(8) :: dKb(3)                           
     real(8) :: dKc(3)                           

     integer        :: nKpath                        
     type(Kpath_type), pointer :: vKpath(:)               
     integer        :: nK = 1                        
     real(8), pointer :: vK(:,:)                
     integer        :: num_band = 0                  
  end type Band_type

  type DOS_type
     character(50) :: fname = ""           
     real(8) :: Emin = -10.d0 * EV_TO_AU   
     real(8) :: Emax = +10.d0 * EV_TO_AU   
     real(8) :: GB = 0.1 * EV_TO_AU
     real(8) :: dE                         
     integer :: Ne = 101                   
     integer :: Nka = 0                    
     integer :: Nkb = 0                    
     integer :: Nkc = 0                    
     integer :: nK = 0                     
     character(16) :: method = 'gaussian' 
  end type DOS_type

  type MO_type
     character(50)  :: fbase = ""                    
     character(16)  :: method = 'ho_lumo'            
     integer        :: band_min=0                    
     integer        :: band_max=0                    
     real(8) :: La(3) = (/0,0,0/)          
     real(8) :: Lb(3) = (/0,0,0/)          
     real(8) :: Lc(3) = (/0,0,0/)          
     real(8) :: dKa(3)                           
     real(8) :: dKb(3)                           
     real(8) :: dKc(3)                           
     integer        :: nK = 0                        
     real(8), pointer :: vK(:,:)                 
  end type MO_type

  type Data_type
     character(50) :: path_pao = "." 
     character(50) :: path_vps = "." 
     character(50) :: element_type  = "ciao" 

     real(8) :: Ne_extra 
     real(8) :: Ne 
     real(8) :: g 
     integer                :: nelem    
     type(Element_type), pointer :: velem(:) 
     integer                :: natom    
     type(Atom_type), pointer    :: vatom(:) 

     integer       :: natom_left  = 0   
     integer       :: natom_right = 0   
     character(50), pointer, dimension(:,:) :: velem_file 

     integer          :: npao     
     integer, pointer :: vnpao(:) 
     integer, pointer :: vipao(:) 
     integer          :: nvps     
  end type Data_type

  type Param_type
     character(20)         :: name  = "" 
     type(Option_type)     :: Option     
     type(Cell_type)       :: Cell       
     type(SCF_type)        :: SCF        
     type(Integral1D_type) :: Integral1D 
     type(Band_type)       :: Band       
     type(DOS_type)        :: DOS        
     type(MO_type)         :: MO         
     type(Data_type)       :: Data       
  end type Param_type

  type Screening_type
     real(8) :: alpha 
     real(8), pointer :: PhiK(:,:,:) 
  end type Screening_type

  type Ewald_type
     real(8) :: alpha 
  end type Ewald_type

  type PAO_type
     real(8) :: Ro(3) 
     integer          :: m  
     integer          :: l  
     real(8)          :: Rc 
     type(RadialFunc_type), pointer :: RF 
     integer          :: range(6) 
     real(8), pointer :: wave(:,:,:) 
     real(8), pointer :: waveV(:,:,:) 
     real(8), pointer :: gwave(:,:,:,:) 
     real(8), pointer :: gwaveV(:,:,:,:) 
  end type PAO_type

  type Base_type
     integer            :: npao     
     type(PAO_type), pointer :: vpao(:)  
     integer, pointer   :: vnpao(:) 
     integer, pointer   :: vipao(:) 
  end type Base_type

  type PPcharge_type
     real(8) :: Ro(3) 
     real(8) :: Rc 
     type(RadialFunc_type), pointer :: RF 
  end type PPcharge_type

  type DensityPast_type
     real(8), pointer :: rho(:,:,:,:)    
     real(8), pointer :: drho(:,:,:,:)   
     complex(8), pointer :: rhoLS(:,:,:,:)    
     complex(8), pointer :: drhoLS(:,:,:,:)   
  end type DensityPast_type

  type Density_type
     real(8), pointer :: rho(:,:,:,:)    
     complex(8), pointer :: rhoLS(:,:,:,:)    
     real(8), pointer :: rhoval(:,:,:) 
     real(8), pointer :: rhopcc(:,:,:) 
     type(DensityPast_type), pointer :: vpast(:) 
  end type Density_type

  type PPloc_type
     real(8)        :: Ro(3) 
     real(8)        ::  Q 
     real(8)        :: Rc 
     type(RadialFunc_type), pointer ::  RF 
  end type PPloc_type

  type PPnon_type
     real(8) :: Ro(3) 
     integer        :: m  
     real(8)        :: E  
     integer        :: l  
     real(8)        :: Rc 
     type(RadialFunc_type), pointer :: RF 
  end type PPnon_type

  type Potential_type
     integer :: nVpsnon 
     type(PPnon_type), pointer :: vVpsnon(:,:) 
     integer, pointer :: vnVpsnon(:) 
     integer, pointer :: viVpsnon(:) 

     integer :: nVpsloc 
     integer, pointer :: vnVpsloc(:) 
     integer, pointer :: viVpsloc(:) 
     type(PPnon_type), pointer :: vVpsloc(:) 

     real(8), pointer :: Vext(:,:,:) 
     real(8), pointer :: dVhar(:,:,:) 
     real(8), pointer :: Vexc(:,:,:,:) 
     real(8), pointer :: Vtot(:,:,:,:) 
  end type Potential_type

  type Energy_type
     real(8) :: Ef 
     real(8) :: Etot 
  end type Energy_type

  type DensityMatrixPast_type
     real(8), pointer :: CDM(:,:,:)    
     real(8), pointer :: dCDM(:,:,:)   
     complex(8), pointer :: CDMLS(:,:,:)    
     complex(8), pointer :: dCDMLS(:,:,:)   
  end type DensityMatrixPast_type

  type AtomMatrix_type
     real(8), pointer :: S(:,:)     
     real(8), pointer :: H0(:,:,:)  
     real(8), pointer :: H (:,:,:)  
     complex(8), pointer :: H0LS(:,:,:)  
     complex(8), pointer :: HLS (:,:,:)  
     real(8), pointer :: CDM(:,:,:) 
     real(8), pointer :: EDM(:,:)   
     complex(8), pointer :: CDMLS(:,:,:) 
     real(8), pointer :: EDMLS(:,:)   
     type(DensityMatrixPast_type), pointer :: vpast(:) 
  end type AtomMatrix_type

  type AtomMatrix_Ptr_type
     type(AtomMatrix_type), pointer :: Ptr 
  end type AtomMatrix_Ptr_type

  type BandMatrix_type
     complex(8), pointer :: S(:,:)   
     complex(8), pointer :: H(:,:,:) 
     real(8),    pointer :: E(:,:)   
     real(8),    pointer :: F(:,:)   
  end type BandMatrix_type

  type Hamiltonian_type
     type(AtomMatrix_Ptr_type), pointer :: vAtomMatrix(:,:,:) 
     type(BandMatrix_type), pointer     :: vBandMatrix(:)     
  end type Hamiltonian_type

  type(Param_type), save, public     :: Param 
  type(Base_type), public            :: Base 
  type(Hamiltonian_type), public     :: Hamiltonian 
  type(Density_type), public         :: Density 
  type(Potential_type), public       :: Potential 
  type(Energy_type), public          :: Energy 
  type(Ewald_type), public           :: Ewald 
  type(SphericalBessel_type), public :: SphericalBessel 
  type(Screening_type), public       :: Screening 

  type SpinMatrix_type
     complex(8) :: element(2,2)
  end type SpinMatrix_type

contains

  function Position__oprod( r1, r2 ) result(r)
    real(8), intent(in) :: r1(3), r2(3)
    real(8) :: r(3)

    r(1) = r1(2)*r2(3) - r1(3)*r2(2)
    r(2) = r1(3)*r2(1) - r1(1)*r2(3)
    r(3) = r1(1)*r2(2) - r1(2)*r2(1)

    return
  end function Position__oprod

  function modp( n, m ) result(r)
    implicit none
    integer, intent(in) :: n, m
    integer :: r

    if( n>=1 ) then
       r=mod(n-1,m)+1
       return
    end if

    r=mod(n-1,m)
    r=mod(r+m,m)+1

    return
  end function modp

  function polar( theta ) result(c)
    implicit none
    real(8), intent(in) :: theta
    complex(8) :: c

    c = Cmplx( cos(theta), sin(theta) )

    return
  end function polar

  function cbrt(a) result(b)
    implicit none
    real(8), intent(in) :: a
    real(8) :: b

    if( a<0.d0 ) then
       b = (-1.0d0)*((-1.0d0)*a)**(1.d0/3.d0)
    else
       b = a**(1.d0/3.d0)
    end if

    return
  end function cbrt

  function Param__Data__getElement(name) result(elem)

    implicit none
    character(len=*), intent(in) :: name
    type(Element_type), pointer :: elem
    integer :: i

    do i=1, Param%Data%nelem
       if( Param%Data%velem(i)%name == name ) then
          elem => Param%Data%velem(i)
          return
       end if
    end do
    elem => Param%Data%velem(1) ! to suppress a warning

    write(*,*) '# Error!: atom ', trim(name), ' is not available'
    stop
  end function Param__Data__getElement

  function TO_AU( unit ) result(c)
    character(len=*), intent(in) :: unit
    real(8) :: c

    c = 1.d0
    select case(unit)
    case("au", "AU", "a.u.", "A.U.")
       c = 1.d0
    case("hartree", "Hartree", "HARTREE")
       c = 1.d0
    case("hartree/bohr", "Hartree/Bohr", "HARTREE/BOHR")
       c = 1.d0
    case("eV", "ev", "EV")
       c = EV_TO_AU
    case("ry", "Ry", "RY", "rydberg", "Rydberg")
       c = RY_TO_AU
    case("K","kelvin","Kelvin")
       c = KELVIN_TO_AU
    case("ang","Ang","angstrom","Angstrom")
       c = AA_TO_AU
    case default
       open(unit=16,file=Param%Option%file_ac_tempout,position='append')
       write(16,'(a,a)') '      ++++++ Error: unknown unit ', trim(unit)
       close(16)
       stop
    end select

    return
  end function TO_AU

end module ac_parameter

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine set_for_gf_se_c

  use condition_ini
  use hamiltonian_sgf
  use hamiltonian_c
  use gf_se_c

  implicit none
  integer :: i_w_num,i1_do,i2_do
  complex(8) :: w,w_int

  if( calc_type == 'trans' ) then
     i_w_num=0
     do i1_do=1,om_block_num
        i_w_num=i_w_num+num_om_par(i1_do)
     end do
     iw_max_gs=i_w_num
     call alo_condition_omega_gs(om_block_num)
     i_w_num=0
     do i1_do=1,om_block_num
        omega_par_gs(i1_do)=i_w_num
        i_w_num=i_w_num+num_om_par(i1_do)
        omega_par_num_gs(i1_do)=i_w_num
        if( om_con_method(i1_do) == 'linear' ) then
           i_w_num=num_om_par(i1_do)
           w_int=(omega_if(i1_do,2)-omega_if(i1_do,1))/dfloat(i_w_num)
           w=omega_if(i1_do,1)-w_int*.5d0
           do i2_do=1,iw_max_gs
              w=w+w_int
              omega_gs(i2_do)=w
           end do
        end if
     end do
  else
     if( calc_type == 'iv' ) then
        if( dabs(cp_l-cp_r) < eps_ini ) then
           open(unit=30,file='iv.dat')
           write(30,*) 'cp_l=',cp_l
           write(30,*) 'cp_r=',cp_r
           write(30,*) 0.d0,0.d0
           close(30)
           stop
        end if
        iw_max_gs=num_iv_mesh
        call alo_condition_omega_gs(1)
        w_int=dcmplx((cp_l-cp_r)/dfloat(num_iv_mesh),0.d0)
        w=dcmplx(cp_r,om_sum)-w_int*.5d0
        do i2_do=1,iw_max_gs
           w=w+w_int
           omega_gs(i2_do)=w
        end do
     else
        if( calc_type /= 'scf_only' ) then
           write(6,*) 'error: gra or iv;; set_for_gf_se_c'
           stop
        end if
     end if
  end if

  !                       ------------------------------------                       !

  num_block_gr=m_num_block_l+m_num_block_m+m_num_block_r

  call alo_gf_se_c(m_mat_max_c,kx_max_ll,ky_max_ll,kx_max_rr,ky_max_rr)
  call alo_gf_se_gra(spin_switch_cc,ka_tr*kb_tr)

  return
end subroutine set_for_gf_se_c

subroutine unset_for_gf_se_c

  use condition_ini
  use gf_se_c
  use scf_negf

  implicit none

  if( calc_type /= 'scf_only' ) then
     call unset_condition_omega_gs
  end if
  call unset_gf_se_c
  call unset_gf_se_gra
  if( ham_model_ini /= 'input' .and. ham_model_ini /= 'scf_accel' ) then
     call unset_c
  end if

  return
end subroutine unset_for_gf_se_c

! ******************************************************************************** !
! ******************************************************************************** !
! ******************************************************************************** !
module para

  implicit none
     character(100) :: file_parameter
     character(100) :: file_parameter1
     character(100) :: file_parameter2
     character(10) :: switch
     character(10) :: switch_dr
     character(30) :: ba
     character(200) :: buf
     character(10) :: c_temp
     character(10) :: d_temp
     character(105) :: nfile_strans
     character(20) :: name_input_mol

     integer, parameter :: isi_l=0,ibo_l=2,isi_r=0,ibo_r=3

     integer :: mat_max
     integer :: mat_ini,level,m_mat_max_m

     integer :: iatomnum,iatomnum_c,iatomnum_l,iatomnum_r,iatom_total
     integer :: num_atom_l,num_atom_m,num_atom_r

     integer :: input_num,itemp_rot
     integer :: input_num_site,input_num_ch
     integer :: kp

     integer :: min_print_site,max_print_site
     integer :: num_h00_r1,num_h00_r2,num_s00_r !,num_h00_r
     integer :: i_sum_switch,i_sum_s,i_sum_e
     integer :: i_sumk_switch,i_sumk_s,i_sumk_e

     integer :: i_do,i1_do,i2_do,i3_do,i4_do,i5_do,iw_max_gs
     integer :: l1,l2,ier,itemp,l_con
     integer :: itemp1,itemp2,itemp3,itemp4,itemp5,itemp6,ispin

     real(8) :: pai
     real(8) :: tempp,tempr,tempi,dummy

     complex(8) :: temp_la

     integer, allocatable :: i_num(:)
     integer, allocatable :: i_orbital_temp(:),i_orbital(:),i_orb_jj(:),i_r_num(:)
     integer, allocatable :: level_temp(:),l_site_temp(:),l_sss(:),l_ch(:)

     real(8), allocatable :: den_temp(:,:),den_site(:,:),den(:,:),den_total_site(:)
     real(8), allocatable :: den_up_temp1(:,:),den_up_temp2(:,:),den_up_temp3(:)
     real(8), allocatable :: den_sumk_temp1(:,:,:),den_sumk_temp2(:,:,:)
     real(8), allocatable :: den_sumk_temp3(:,:),w_temp(:)
     real(8), allocatable :: d_eigen(:,:),eigen_la(:),w(:)
     real(8), allocatable :: rwork(:)

     complex(8), allocatable :: h00(:,:),s00(:,:)
     complex(8), allocatable :: hss(:,:),sss(:,:)
     complex(8), allocatable :: ev(:,:)
     complex(8), allocatable :: den_c(:,:),den2_c(:,:),temp_com(:),den_temp_c(:,:)
     complex(8), allocatable :: cwork(:)

!+++++++++++++++++++++

!     real(8), allocatable :: s_ev(:)
!     real(8), allocatable :: ev_vec(:,:)
!     real(8), allocatable :: ev_vec1(:,:),ev_vec2(:,:)
!     real(8), allocatable :: temp(:,:),temp_mat2(:),d(:)
!     real(8), allocatable :: den2(:,:)

end module para
! ******************************************************************************** !
! ******************************************************************************** !
! ******************************************************************************** !
program main
  use para
  implicit none
     integer :: iargc
! -------------------------------------------------------------------------------- !

      if( iargc() >= 1 ) then
        call getarg(1,file_parameter)
      else
        write(*,*) 'no file'
        stop
      end if

      switch=''
      name_input_mol='partial'
      file_parameter1=''
      file_parameter2=''
      switch_dr='accel'
      open(unit=60,file=file_parameter)
        do
          read(60,'(a)',end=121) buf
          if( buf == '' ) then
            cycle
          end if
          read(buf,*) ba
          select case(ba)
            case('#file_type')
              read(buf,*) ba,c_temp,switch
            case('#name_input_mol')
              read(buf,*) ba,c_temp,name_input_mol
            case('#input_junc_cond')
              read(buf,*) ba,c_temp,file_parameter1
            case('#input_mol')
              read(buf,*) ba,c_temp,file_parameter2
            case('#switch_dr')
              read(buf,*) ba,c_temp,switch_dr
            end select
        end do
  121   continue
      close(60)

!                       ------------------------------------                       !

      call set_orb

!                       ------------------------------------                       !

      itemp_rot=mat_max

      allocate(level_temp(itemp_rot),l_site_temp(itemp_rot),l_sss(itemp_rot)       &
              ,l_ch(itemp_rot),stat=ier)
      if( ier /= 0 ) then
        write(*,*) 'error allocate2',itemp_rot
        stop
      end if

      input_num=0
      input_num_site=0
      input_num_ch=0
      i_sum_switch=0
      open(unit=60,file=file_parameter)
        do
          read(60,'(a)',end=120) buf
          if( buf == '' ) then
            cycle
          end if
          read(buf,*) ba
          if( ba(1:1) == '#' ) then
            cycle
          end if
          read(buf,*) ba
          select case(ba)
            case('ini')
              read(buf,*) ba,level
              mat_ini=level
            case('k')
              read(buf,*) ba,c_temp !,kp
              if( c_temp == 'sum' ) then
                read(buf,*) ba,c_temp,i_sumk_e
                i_sumk_s=1
                i_sumk_switch=1
              else
                read(buf,*) ba,c_temp,i_sumk_e
                i_sumk_s=i_sumk_e
                i_sumk_switch=0
              end if
             ! mat_ini=level
            case('b')
              read(buf,*) ba,level
              if( level > mat_max ) then
                write(*,*) 'error: level',level
                cycle
              end if
              input_num=input_num+1
              level_temp(input_num)=level
            case('a')
              read(buf,*) ba,level
              if( level > iatom_total ) then
                write(*,*) 'error: site',level
                cycle
              end if
              input_num_site=input_num_site+1
              l_sss(input_num_site)=level
            case('sum_a')
              read(buf,*) ba,i_sum_s,i_sum_e
              i_sum_switch=1
            case('c')
              read(buf,*) ba,level
              input_num_ch=input_num_ch+1
              l_ch(input_num_ch)=level
            end select
        end do
  120   continue
      close(60)

!                       ------------------------------------                       !

      call set_orb2

!                         ---------------------------------                        !

      do kp=i_sumk_s,i_sumk_e
        if( switch == 'all' ) then
          if( input_num /= 0 ) then
            call pldos
          else
            if( input_num_site /= 0 ) then
              call ldos_1
            end if
          end if
        end if
        if( switch == 'dia' .or. switch == 'diagonal' ) then
          if( input_num_site /= 0 ) then
            call ldos_2
          end if
        end if
      end do

! -------------------------------------------------------------------------------- !
  stop
end program main
! ******************************************************************************** !
! ******************************************************************************** !
! ******************************************************************************** !
subroutine set_orb
  use para
  implicit none
! -------------------------------------------------------------------------------- !

      if( switch_dr == 'accel' ) then
        open(unit=50,file=file_parameter1)
          read(50,*)
          read(50,*)
          read(50,*) d_temp,c_temp,ispin
          read(50,*)
          read(50,*)
          read(50,*)
          read(50,*)
          read(50,*)
          read(50,*)
          read(50,*) itemp2
          do i1_do=1, itemp2
            read(50,*)
          end do
          read(50,*)
          read(50,*)
          read(50,*)
          read(50,*)

          read(50,*)
          read(50,*) iatomnum, iatomnum_l, iatomnum_r
          iatomnum_c=iatomnum-iatomnum_l-iatomnum_r

          allocate(i_orbital_temp(iatomnum),stat=ier)
          if( ier /= 0 ) then
            write(*,*) 'error allocate-1'
            stop
          end if

          do i1_do=1,iatomnum
            read(50,*) itemp4,c_temp,tempr,tempi,tempp,dummy,i_orbital_temp(i1_do)
          end do
        close(50)

        itemp2=itemp4
        itemp4=itemp2

        iatom_total=iatomnum
        num_atom_l=iatomnum_l
        num_atom_m=iatom_total
        num_atom_r=iatomnum_r
!        write(*,*)  num_atom_l,num_atom_m,num_atom_r
      end if

      if( switch_dr == 'abred' ) then
        open(unit=50,file=file_parameter1)
        !  read(50,*)
          read(50,*) iatomnum
          read(50,*) iatomnum_c
          read(50,*) iatomnum_l
          read(50,*) iatomnum_r
          read(50,*) ispin

          allocate(i_orbital_temp(iatomnum),stat=ier)
          if( ier /= 0 ) then
            write(*,*) 'error allocate-1'
            stop
          end if

          do i1_do=1,ispin+1
            read(50,*)
            do i2_do=1,iatomnum
              read(50,*) itemp
              do i3_do=1,itemp+1
                read(50,*) itemp1
                read(50,*) itemp2
                read(50,*) itemp3
                read(50,*) itemp4
                read(50,*) itemp5,itemp6
                if( itemp1 == itemp3 ) then
                  i_orbital_temp(i2_do)=itemp5
                end if
                do i4_do=1,itemp5
                  do i5_do=1,itemp6
                    read(50,*) dummy
                  end do
                end do
              end do
            end do
          end do
        close(50)

        itemp2=itemp4
        itemp4=itemp2

        iatom_total=iatomnum_l*isi_l/ibo_l+iatomnum+iatomnum_r*isi_r/ibo_r
        num_atom_l=iatomnum_l
        num_atom_m=iatom_total
        num_atom_r=iatomnum_r
!        write(*,*)  num_atom_l,num_atom_m,num_atom_r
      end if

      if( file_parameter2 /= '' ) then
        mat_max=-100
        if( name_input_mol /= 'partial' ) then
          open(unit=18,file=file_parameter2) !,status='old')
        else
          nfile_strans=file_parameter2
          if( i_sumk_e > 0 ) then
            call makefilename_in(i_sumk_e,nfile_strans)
          else
            call makefilename_in(1,nfile_strans)
          end if
          open(unit=18,file=nfile_strans) !,status='old')
        end if
          read(18,*,end=100) i1_do,mat_max
  100     continue
        close(18)
        if( mat_max < 0 ) then
          mat_max=0
          do i1_do=1,iatomnum
            mat_max=mat_max+i_orbital_temp(i1_do)
          end do
        end if
      else
        mat_max=0
        do i1_do=1,iatomnum
          mat_max=mat_max+i_orbital_temp(i1_do)
        end do
      end if

! -------------------------------------------------------------------------------- !
  return
end subroutine set_orb
! ******************************************************************************** !
! ******************************************************************************** !
! ******************************************************************************** !
subroutine set_orb2
  use para
  implicit none
! -------------------------------------------------------------------------------- !

      if( switch_dr == 'accel' ) then
       allocate(i_orbital(iatom_total),i_orb_jj(iatom_total+1),stat=ier)
        if( ier /= 0 ) then
          write(*,*) 'error allocate-1'
          stop
        end if

        ier=0
        i_orb_jj(1)=0
        do i1_do=1,iatom_total
          ier=ier+1
          i_orbital(ier)=i_orbital_temp(i1_do)
          i_orb_jj(ier+1)=i_orb_jj(ier)+i_orbital(ier)
        end do

        do i2_do=1,ier
          write(*,*) i2_do,i_orbital(i2_do)
        end do
        write(*,*)
        write(*,*) iatom_total,mat_max
        write(*,*)
      end if

      if( switch_dr == 'abred' ) then
        allocate(i_r_num(iatomnum),stat=ier)
        if( ier /= 0 ) then
          write(*,*) 'error allocate'
          stop
        end if

        do i1_do=1,iatomnum_l
          i_r_num(i1_do)=iatomnum_c+i1_do
        end do
        do i1_do=1,iatomnum_c
          i_r_num(i1_do+iatomnum_l)=i1_do
        end do
        do i1_do=1,iatomnum_r
          i_r_num(i1_do+iatomnum_l+iatomnum_c)=i1_do+iatomnum_l+iatomnum_c
        end do

        allocate(i_orbital(iatom_total),i_orb_jj(iatom_total+1),stat=ier)
        if( ier /= 0 ) then
          write(*,*) 'error allocate-1'
          stop
        end if

        ier=0
        i_orb_jj(1)=0
        do i1_do=1,iatomnum_l*isi_l/ibo_l
          ier=ier+1
          i_orbital(ier)                                                           &
                =i_orbital_temp(i_r_num(iatomnum-iatomnum_l*isi_l/ibo_l+i1_do))
          i_orb_jj(ier+1)=i_orb_jj(ier)+i_orbital(ier)
        end do
        do i1_do=1,iatomnum
          ier=ier+1
          i_orbital(ier)=i_orbital_temp(i_r_num(i1_do))
          i_orb_jj(ier+1)=i_orb_jj(ier)+i_orbital(ier)
        end do
        do i1_do=1,iatomnum_r*isi_r/ibo_r
          ier=ier+1
          i_orbital(ier)=i_orbital_temp(i_r_num(i1_do))
          i_orb_jj(ier+1)=i_orb_jj(ier)+i_orbital(ier)
        end do

        do i2_do=1,ier
          write(*,*) i2_do,i_orbital(i2_do)
        end do
        write(*,*)
        write(*,*) iatom_total,mat_max
        write(*,*)
      end if

! -------------------------------------------------------------------------------- !
  return
end subroutine set_orb2
! ******************************************************************************** !
! ******************************************************************************** !
! ******************************************************************************** !
subroutine pldos
  use para
  implicit none
! -------------------------------------------------------------------------------- !

      allocate(d_eigen(2,mat_max),stat=ier)
      if( ier /= 0 ) then
        write(*,*) 'pldos'
        stop
      end if

!                         ---------------------------------                        !
!                         ---------------------------------                        !
!                                        up                                        !
!                         ---------------------------------                        !
!                         ---------------------------------                        !

      if( name_input_mol /= 'partial' ) then
        open(unit=18,file=file_parameter2,status='old')
      else
        nfile_strans=file_parameter2
        call makefilename_in(kp,nfile_strans)
        open(unit=18,file=nfile_strans,status='old')
      end if

        read(18,*) i1_do,mat_max
        read(18,*) 
        read(18,*) num_h00_r1,num_h00_r2,num_s00_r
        read(18,*) 
        read(18,*) 

        allocate(h00(mat_max,mat_max),s00(mat_max,mat_max)                         &
                ,hss(mat_max,mat_max),sss(mat_max,mat_max),eigen_la(mat_max)       &
                ,stat=ier)
        if( ier /= 0 ) then
          write(*,*) 'error allocate1'
          stop
        end if
        h00=dcmplx(0.d0,0.d0)
        s00=dcmplx(0.d0,0.d0)

        read(18,*) 
        do i1_do=1,num_h00_r1
          read(18,999) itemp,l1,l2,tempr,tempi
          h00(l1,l2)=dcmplx(tempr,tempi)
        end do
        if( ispin == 1 ) then
          read(18,*) 
          do i1_do=1,num_h00_r2
            read(18,*) !itemp,l1,l2,tempr,tempi
          end do
        end if
        read(18,*) 
        do i1_do=1,num_s00_r
          read(18,999) itemp,l1,l2,tempr,tempi
          s00(l1,l2)=dcmplx(tempr,tempi)
        end do

      close(18)

!      num_h00_r=num_h00_r1

!                         ---------------------------------                        !

      allocate(cwork(4*mat_max),rwork(4*mat_max),stat=ier)
      if( ier /= 0 ) then
        write(*,*) 'error allocate1'
        stop
      end if

      hss=h00
      sss=s00
      call zhegv(1,'V','L',mat_max,hss,mat_max,sss,mat_max,eigen_la                &
                ,cwork,4*mat_max,rwork,ier)

      deallocate(cwork,rwork,stat=ier)
      if( ier /= 0 ) then
        write(*,*) 'error allocate1'
        stop
      end if

      allocate(i_num(mat_max),stat=ier)
      if( ier /= 0 ) then
        write(*,*) 'error allocate21'
        stop
      end if

      do i1_do=1,mat_max
        i_num(i1_do)=i1_do
      end do
      do i1_do=1,mat_max
        do i2_do=i1_do+1,mat_max
          if( eigen_la(i_num(i1_do)) > eigen_la(i_num(i2_do)) ) then
            i3_do=i_num(i1_do)
            i_num(i1_do)=i_num(i2_do)
            i_num(i2_do)=i3_do
          end if
        end do
      end do

      do i2_do=1,mat_max
        do i1_do=1,mat_max
          sss(i1_do,i2_do)=hss(i1_do,i_num(i2_do))
        end do
        d_eigen(1,i2_do)=eigen_la(i_num(i2_do))
      end do

      deallocate(i_num,stat=ier)
      if( ier /= 0 ) then
        write(*,*) 'error allocate21'
        stop
      end if

!                         ---------------------------------                        !

      allocate(cwork(mat_max),stat=ier)
      if( ier /= 0 ) then
        write(*,*) 'error allocate1'
        stop
      end if

      do i2_do=1,mat_max
        do i3_do=1,mat_max
          cwork(i3_do)=dcmplx(0.d0,0.d0)
        end do
        do i4_do=1,mat_max
          do i3_do=1,mat_max
            cwork(i3_do)=cwork(i3_do)+h00(i3_do,i4_do)*sss(i4_do,i2_do)
          end do
        end do
        do i1_do=1,mat_max
          temp_la=dcmplx(0.d0,0.d0)
          do i3_do=1,mat_max
            temp_la=temp_la+dconjg(sss(i3_do,i1_do))*cwork(i3_do)
          end do
          if( cdabs(temp_la) > 1.d-10 ) then
            write(*,*) i1_do,i2_do,temp_la
          end if
        end do
      end do

      deallocate(cwork,stat=ier)
      if( ier /= 0 ) then
        write(*,*) 'error allocate1'
        stop
      end if

!                         ---------------------------------                        !

   !   write(*,*) 'start calculation_up',input_num,input_num_site

      pai=datan(1.d0)*4.d0

      if( ispin == 0 ) then
        nfile_strans='gfc'
        call makefilename_in(kp,nfile_strans)
      else
        nfile_strans='gfc_up'
        call makefilename_in(kp,nfile_strans)
      end if
      open(unit=50,file=nfile_strans,status='old')

        read(50,*)
        read(50,*)
        read(50,'(a)') buf
        read(buf,*,end=120) iw_max_gs,m_mat_max_m,min_print_site,max_print_site
        go to 121
  120   continue
        read(buf,*) iw_max_gs,m_mat_max_m
        min_print_site=1
        max_print_site=m_mat_max_m
  121   continue

        write(*,*) 'start calculation_up',input_num,input_num_site                 &
                                ,min_print_site,max_print_site !,iw_max_gs,m_mat_max_m

        allocate(ev(m_mat_max_m,m_mat_max_m),stat=ier)
        if( ier /= 0 ) then
          write(*,*) 'error allocate2'
          stop
        end if
        do i1_do=1,m_mat_max_m
          do i2_do=1,m_mat_max_m
            ev(i1_do,i2_do)=dcmplx(0.d0,0.d0)
          end do
          ev(i1_do,i1_do)=dcmplx(1.d0,0.d0)
        end do
        do i1_do=1,mat_max
          do i2_do=1,mat_max
            ev(i_orb_jj(mat_ini)+i1_do,i_orb_jj(mat_ini)+i2_do)=sss(i1_do,i2_do)
          end do
        end do

        allocate(den_c(m_mat_max_m,m_mat_max_m),w(iw_max_gs)                       &
                ,den2_c(m_mat_max_m,m_mat_max_m),temp_com(m_mat_max_m),stat=ier)
        if( ier /= 0 ) then
          write(*,*) 'error allocate2'
          stop
        end if

        allocate(den_temp(iw_max_gs,input_num),den_site(iw_max_gs,input_num_site)  &
                ,den_total_site(iw_max_gs),stat=ier)
        if( ier /= 0 ) then
          write(*,*) 'error allocate2'
          stop
        end if

        den_site=0.d0
    !    den_total_site=0.d0

        do i5_do=1,iw_max_gs
          write(6,*) 'now_w',i5_do,'(max=',iw_max_gs,')'

          den2_c=dcmplx(0.d0,0.d0)

          do i1_do=min_print_site,max_print_site !1,m_mat_max_m
            read(50,*) itemp,w(i5_do)
            do i2_do=min_print_site,max_print_site !1,m_mat_max_m
              read(50,*) itemp,tempr,tempi
!              read(50,*) itemp,tempi
              den_c(i1_do,i2_do)=dcmplx(tempr,tempi)
            end do
          end do

          do i3_do=1,input_num_site
            level=i_orb_jj(l_sss(i3_do))
            do i2_do=1,i_orbital(l_sss(i3_do))
              den_site(i5_do,i3_do)                                                &
                       =den_site(i5_do,i3_do)+dimag(den_c(level+i2_do,level+i2_do))
            end do
            den_site(i5_do,i3_do)=-den_site(i5_do,i3_do)/pai
          end do

          if( i_sum_switch == 1 ) then
            den_total_site(i5_do)=0.d0
            do i3_do=i_sum_s,i_sum_e
              level=i_orb_jj(i3_do)
              do i2_do=1,i_orbital(i3_do)
                den_total_site(i5_do)                                                &
                       =den_total_site(i5_do)+dimag(den_c(level+i2_do,level+i2_do))
              end do
            end do
            den_total_site(i5_do)=-den_total_site(i5_do)/pai
          end if

          do i_do=1,input_num
            i2_do=i_orb_jj(mat_ini)+level_temp(i_do)
            do i3_do=1,m_mat_max_m
              temp_com(i3_do)=dcmplx(0.d0,0.d0)
            end do
            do i4_do=i_orb_jj(mat_ini)+1,i_orb_jj(mat_ini)+mat_max+1
              do i3_do=i_orb_jj(mat_ini)+1,i_orb_jj(mat_ini)+mat_max+1
                temp_com(i3_do)=temp_com(i3_do)+den_c(i3_do,i4_do)*ev(i4_do,i2_do)
              end do
            end do
            i1_do=i_orb_jj(mat_ini)+level_temp(i_do)
            do i3_do=i_orb_jj(mat_ini)+1,i_orb_jj(mat_ini)+mat_max+1
              den2_c(i1_do,i2_do)=den2_c(i1_do,i2_do)                              &
                                 +dconjg(ev(i3_do,i1_do))*temp_com(i3_do)
            end do
          end do

          do i1_do=1,input_num
            level=level_temp(i1_do)
            den_temp(i5_do,i1_do)                                                  &
                =-dimag(den2_c(i_orb_jj(mat_ini)+level,i_orb_jj(mat_ini)+level))/pai
          end do

        end do

      close(50)

!                         ---------------------------------                        !

      if( ispin == 0 ) then
        nfile_strans='pdos'
        call makefilename_out(kp,nfile_strans)
        open(unit=54,file=nfile_strans)
          do i1_do=1,input_num
            level=level_temp(i1_do)
            write(54,*) '**************************************'
            write(54,*) 'level=',level
            write(54,*) '**************************************'
            do i3_do=1,iw_max_gs
              write(54,*) w(i3_do),den_temp(i3_do,i1_do)
            end do
          end do
        close(54)
        if( input_num_site > 0 ) then
          nfile_strans='ldos'
          call makefilename_out(kp,nfile_strans)
          open(unit=55,file=nfile_strans)
            do i1_do=1,input_num_site
              level=l_sss(i1_do)
              write(55,*) '**************************************'
              write(55,*) 'level=',level
              write(55,*) '**************************************'
              do i3_do=1,iw_max_gs
                write(55,*) w(i3_do),den_site(i3_do,i1_do)
              end do
            end do
          close(55)
        end if
        if( i_sum_switch == 1 ) then
          nfile_strans='ldos_suma'
          call makefilename_out(kp,nfile_strans)
          open(unit=55,file=nfile_strans)
            write(55,*) '**************************************'
            do i3_do=1,iw_max_gs
              write(55,*) w(i3_do),den_total_site(i3_do)
            end do
          close(55)
        end if
      else
        allocate(den_up_temp1(iw_max_gs,input_num)                                 &
                ,den_up_temp2(iw_max_gs,input_num_site),den_up_temp3(iw_max_gs)    &
                ,stat=ier)
        if( ier /= 0 ) then
          write(*,*) 'error allocate2'
          stop
        end if
        do i1_do=1,input_num
          do i3_do=1,iw_max_gs
            den_up_temp1(i3_do,i1_do)=den_temp(i3_do,i1_do)
          end do
        end do
        if( input_num_site > 0 ) then
          do i1_do=1,input_num_site
            do i3_do=1,iw_max_gs
              den_up_temp2(i3_do,i1_do)=den_site(i3_do,i1_do)
            end do
          end do
        end if
        if( i_sum_switch == 1 ) then
          do i3_do=1,iw_max_gs
            den_up_temp3(i3_do)=den_total_site(i3_do)
          end do
        end if
      end if

      if( i_sumk_switch == 1 ) then
        if( kp == i_sumk_s ) then
          allocate(den_sumk_temp1(ispin+1,iw_max_gs,input_num)                     &
                  ,den_sumk_temp2(ispin+1,iw_max_gs,input_num_site)                &
                  ,den_sumk_temp3(ispin+1,iw_max_gs),w_temp(iw_max_gs),stat=ier)
          if( ier /= 0 ) then
            write(*,*) 'error allocate2'
            stop
          end if
          den_sumk_temp1=0.d0
          den_sumk_temp2=0.d0
          den_sumk_temp3=0.d0
          do i3_do=1,iw_max_gs
            w_temp(i3_do)=w(i3_do)
          end do
        end if
        do i1_do=1,input_num
          do i3_do=1,iw_max_gs
            den_sumk_temp1(1,i3_do,i1_do)                                          &
                                =den_sumk_temp1(1,i3_do,i1_do)+den_temp(i3_do,i1_do)
          end do
        end do
        if( input_num_site > 0 ) then
          do i1_do=1,input_num_site
            do i3_do=1,iw_max_gs
              den_sumk_temp2(1,i3_do,i1_do)                                        &
                                =den_sumk_temp2(1,i3_do,i1_do)+den_site(i3_do,i1_do)
            end do
          end do
        end if
        if( i_sum_switch == 1 ) then
          do i3_do=1,iw_max_gs
            den_sumk_temp3(1,i3_do)=den_sumk_temp3(1,i3_do)+den_total_site(i3_do)
          end do
        end if
      end if

      deallocate(h00,s00,hss,sss,eigen_la,ev,den_c,den2_c,temp_com                 &
                ,w,den_temp,den_site,den_total_site,stat=ier)
      if( ier /= 0 ) then
        write(*,*) 'de: error allocate2'
        stop
      end if

!                         ---------------------------------                        !
!                         ---------------------------------                        !
!                                       down                                       !
!                         ---------------------------------                        !
!                         ---------------------------------                        !

      if( ispin == 0 ) then
        do i2_do=1,mat_max
          d_eigen(2,i2_do)=d_eigen(1,i2_do)
        end do
        go to 100
      end if

      if( name_input_mol /= 'partial' ) then
        open(unit=18,file=file_parameter2,status='old')
      else
        nfile_strans=file_parameter2
        call makefilename_in(kp,nfile_strans)
        open(unit=18,file=nfile_strans,status='old')
      end if

        read(18,*) i1_do,mat_max
        read(18,*) 
        read(18,*) num_h00_r1,num_h00_r2,num_s00_r
        read(18,*) 
        read(18,*) 

        allocate(h00(mat_max,mat_max),s00(mat_max,mat_max)                         &
                ,hss(mat_max,mat_max),sss(mat_max,mat_max),eigen_la(mat_max)       &
                ,stat=ier)
        if( ier /= 0 ) then
          write(*,*) 'error allocate1'
          stop
        end if
        h00=dcmplx(0.d0,0.d0)
        s00=dcmplx(0.d0,0.d0)

        read(18,*) 
        do i1_do=1,num_h00_r1
          read(18,*) ! itemp,l1,l2,tempr,tempi
        end do
        if( ispin == 1 ) then
          read(18,*) 
          do i1_do=1,num_h00_r2
            read(18,999) itemp,l1,l2,tempr,tempi
          h00(l1,l2)=dcmplx(tempr,tempi)
          end do
        end if
        read(18,*) 
        do i1_do=1,num_s00_r
          read(18,999) itemp,l1,l2,tempr,tempi
          s00(l1,l2)=dcmplx(tempr,tempi)
        end do

      close(18)

!                         ---------------------------------                        !

      allocate(cwork(4*mat_max),rwork(4*mat_max),stat=ier)
      if( ier /= 0 ) then
        write(*,*) 'error allocate1'
        stop
      end if

      hss=h00
      sss=s00
      call zhegv(1,'V','L',mat_max,hss,mat_max,sss,mat_max,eigen_la                &
                ,cwork,4*mat_max,rwork,ier)

      deallocate(cwork,rwork,stat=ier)
      if( ier /= 0 ) then
        write(*,*) 'error allocate1'
        stop
      end if

      allocate(i_num(mat_max),stat=ier)
      if( ier /= 0 ) then
        write(*,*) 'error allocate21'
        stop
      end if

      do i1_do=1,mat_max
        i_num(i1_do)=i1_do
      end do
      do i1_do=1,mat_max
        do i2_do=i1_do+1,mat_max
          if( eigen_la(i_num(i1_do)) > eigen_la(i_num(i2_do)) ) then
            i3_do=i_num(i1_do)
            i_num(i1_do)=i_num(i2_do)
            i_num(i2_do)=i3_do
          end if
        end do
      end do

      do i2_do=1,mat_max
        do i1_do=1,mat_max
          sss(i1_do,i2_do)=hss(i1_do,i_num(i2_do))
        end do
        d_eigen(2,i2_do)=eigen_la(i_num(i2_do))
      end do

      deallocate(i_num,stat=ier)
      if( ier /= 0 ) then
        write(*,*) 'error allocate21'
        stop
      end if

!                         ---------------------------------                        !

      allocate(cwork(mat_max),stat=ier)
      if( ier /= 0 ) then
        write(*,*) 'error allocate1'
        stop
      end if

      do i2_do=1,mat_max
        do i3_do=1,mat_max
          cwork(i3_do)=dcmplx(0.d0,0.d0)
        end do
        do i4_do=1,mat_max
          do i3_do=1,mat_max
            cwork(i3_do)=cwork(i3_do)+h00(i3_do,i4_do)*sss(i4_do,i2_do)
          end do
        end do
        do i1_do=1,mat_max
          temp_la=dcmplx(0.d0,0.d0)
          do i3_do=1,mat_max
            temp_la=temp_la+dconjg(sss(i3_do,i1_do))*cwork(i3_do)
          end do
          if( cdabs(temp_la) > 1.d-10 ) then
            write(*,*) i1_do,i2_do,temp_la
          end if
        end do
      end do

      deallocate(cwork,stat=ier)
      if( ier /= 0 ) then
        write(*,*) 'error allocate1'
        stop
      end if

!                         ---------------------------------                        !

 !     write(*,*) 'start calculation_do',input_num,input_num_site

      pai=datan(1.d0)*4.d0

      nfile_strans='gfc_do'
      call makefilename_in(kp,nfile_strans)
      open(unit=50,file=nfile_strans,status='old')

        read(50,*)
        read(50,*)
        read(50,'(a)') buf
        read(buf,*,end=122) iw_max_gs,m_mat_max_m,min_print_site,max_print_site
        go to 123
  122   continue
        read(buf,*) iw_max_gs,m_mat_max_m
        min_print_site=1
        max_print_site=m_mat_max_m
  123   continue

        write(*,*) 'start calculation_do',input_num,input_num_site                 &
                                ,min_print_site,max_print_site !,iw_max_gs,m_mat_max_m

        allocate(ev(m_mat_max_m,m_mat_max_m),stat=ier)
        if( ier /= 0 ) then
          write(*,*) 'error allocate2'
          stop
        end if
        do i1_do=1,m_mat_max_m
          do i2_do=1,m_mat_max_m
            ev(i1_do,i2_do)=dcmplx(0.d0,0.d0)
          end do
          ev(i1_do,i1_do)=dcmplx(1.d0,0.d0)
        end do
        do i1_do=1,mat_max
          do i2_do=1,mat_max
            ev(i_orb_jj(mat_ini)+i1_do,i_orb_jj(mat_ini)+i2_do)=sss(i1_do,i2_do)
          end do
        end do

        allocate(den_c(m_mat_max_m,m_mat_max_m),w(iw_max_gs)                       &
                ,den2_c(m_mat_max_m,m_mat_max_m),temp_com(m_mat_max_m),stat=ier)
        if( ier /= 0 ) then
          write(*,*) 'error allocate2'
          stop
        end if

        allocate(den_temp(iw_max_gs,input_num),den_site(iw_max_gs,input_num_site)  &
                ,den_total_site(iw_max_gs),stat=ier)
        if( ier /= 0 ) then
          write(*,*) 'error allocate2'
          stop
        end if

        den_site=0.d0
     !   den_total_site=0.d0

        do i5_do=1,iw_max_gs
          write(6,*) 'now_w',i5_do,'(max=',iw_max_gs,')'

          den2_c=dcmplx(0.d0,0.d0)

          do i1_do=min_print_site,max_print_site !1,m_mat_max_m
            read(50,*) itemp,w(i5_do)
            do i2_do=min_print_site,max_print_site !1,m_mat_max_m
              read(50,*) itemp,tempr,tempi
!              read(50,*) itemp,tempi
              den_c(i1_do,i2_do)=dcmplx(tempr,tempi)
            end do
          end do

          do i3_do=1,input_num_site
            level=i_orb_jj(l_sss(i3_do))
            do i2_do=1,i_orbital(l_sss(i3_do))
              den_site(i5_do,i3_do)                                                &
                      =den_site(i5_do,i3_do)+dimag(den_c(level+i2_do,level+i2_do))
            end do
            den_site(i5_do,i3_do)=-den_site(i5_do,i3_do)/pai
          end do

          if( i_sum_switch == 1 ) then
            den_total_site(i5_do)=0.d0
            do i3_do=i_sum_s,i_sum_e
              level=i_orb_jj(i3_do)
              do i2_do=1,i_orbital(i3_do)
                den_total_site(i5_do)                                                &
                       =den_total_site(i5_do)+dimag(den_c(level+i2_do,level+i2_do))
              end do
            end do
            den_total_site(i5_do)=-den_total_site(i5_do)/pai
          end if

          do i_do=1,input_num
            i2_do=i_orb_jj(mat_ini)+level_temp(i_do)
            do i3_do=1,m_mat_max_m
              temp_com(i3_do)=dcmplx(0.d0,0.d0)
            end do
            do i4_do=i_orb_jj(mat_ini)+1,i_orb_jj(mat_ini)+mat_max+1
              do i3_do=i_orb_jj(mat_ini)+1,i_orb_jj(mat_ini)+mat_max+1
                temp_com(i3_do)=temp_com(i3_do)+den_c(i3_do,i4_do)*ev(i4_do,i2_do)
              end do
            end do
            i1_do=i_orb_jj(mat_ini)+level_temp(i_do)
            do i3_do=i_orb_jj(mat_ini)+1,i_orb_jj(mat_ini)+mat_max+1
              den2_c(i1_do,i2_do)=den2_c(i1_do,i2_do)                              &
                                 +dconjg(ev(i3_do,i1_do))*temp_com(i3_do)
            end do
          end do

          do i1_do=1,input_num
            level=level_temp(i1_do)
            den_temp(i5_do,i1_do)                                                  &
                =-dimag(den2_c(i_orb_jj(mat_ini)+level,i_orb_jj(mat_ini)+level))/pai
          end do

        end do

      close(50)

!                         ---------------------------------                        !

      nfile_strans='pdos'
      call makefilename_out(kp,nfile_strans)
      open(unit=56,file=nfile_strans)
        do i1_do=1,input_num
          level=level_temp(i1_do)
          write(56,*) '**************************************'
          write(56,*) 'level=',level
          write(56,*) '**************************************'
          do i3_do=1,iw_max_gs
            write(56,*) w(i3_do),den_up_temp1(i3_do,i1_do),den_temp(i3_do,i1_do)
          end do
        end do
      close(56)

      if( input_num_site > 0 ) then
        nfile_strans='ldos'
        call makefilename_out(kp,nfile_strans)
        open(unit=57,file=nfile_strans)
          do i1_do=1,input_num_site
            level=l_sss(i1_do)
            write(57,*) '**************************************'
            write(57,*) 'level=',level
            write(57,*) '**************************************'
            do i3_do=1,iw_max_gs
              write(57,*) w(i3_do),den_up_temp2(i3_do,i1_do),den_site(i3_do,i1_do)
            end do
          end do
        close(57)
      end if

      if( i_sum_switch == 1 ) then
        nfile_strans='ldos_suma'
        call makefilename_out(kp,nfile_strans)
        open(unit=55,file=nfile_strans)
          write(55,*) '**************************************'
          do i3_do=1,iw_max_gs
            write(55,*) w(i3_do),den_up_temp3(i3_do),den_total_site(i3_do)
          end do
        close(55)
      end if

      deallocate(den_up_temp1,den_up_temp2,den_up_temp3,stat=ier)
      if( ier /= 0 ) then
        write(*,*) 'error allocate2'
        stop
      end if

      if( i_sumk_switch == 1 ) then
        do i1_do=1,input_num
          do i3_do=1,iw_max_gs
            den_sumk_temp1(2,i3_do,i1_do)                                          &
                                =den_sumk_temp1(2,i3_do,i1_do)+den_temp(i3_do,i1_do)
          end do
        end do
        if( input_num_site > 0 ) then
          do i1_do=1,input_num_site
            do i3_do=1,iw_max_gs
              den_sumk_temp2(2,i3_do,i1_do)                                        &
                                =den_sumk_temp2(2,i3_do,i1_do)+den_site(i3_do,i1_do)
            end do
          end do
        end if
        if( i_sum_switch == 1 ) then
          do i3_do=1,iw_max_gs
            den_sumk_temp3(2,i3_do)=den_sumk_temp3(2,i3_do)+den_total_site(i3_do)
          end do
        end if
      end if

      deallocate(h00,s00,hss,sss,eigen_la,ev,den_c,den2_c,temp_com                 &
                ,w,den_temp,den_site,den_total_site,stat=ier)
      if( ier /= 0 ) then
        write(*,*) 'de: error allocate2'
        stop
      end if

  100 continue

!                         ---------------------------------                        !

      if( i_sumk_switch == 1 .and. kp == i_sumk_e ) then
        nfile_strans='pdos_sumk.dat'
        open(unit=56,file=nfile_strans)
          do i1_do=1,input_num
            level=level_temp(i1_do)
            write(56,*) '**************************************'
            write(56,*) 'level=',level
            write(56,*) '**************************************'
            if( ispin == 0 ) then
              do i3_do=1,iw_max_gs
                write(56,*) w_temp(i3_do)                                          &
                           ,den_sumk_temp1(1,i3_do,i1_do)/dfloat(i_sumk_e)
              end do
            else
              do i3_do=1,iw_max_gs
                write(56,*) w_temp(i3_do)                                          &
                           ,den_sumk_temp1(1,i3_do,i1_do)/dfloat(i_sumk_e)         &
                           ,den_sumk_temp1(2,i3_do,i1_do)/dfloat(i_sumk_e)
              end do
            end if
          end do
        close(56)

        if( input_num_site > 0 ) then
          nfile_strans='ldos_sumk.dat'
          open(unit=57,file=nfile_strans)
            do i1_do=1,input_num_site
              level=l_sss(i1_do)
              write(57,*) '**************************************'
              write(57,*) 'level=',level
              write(57,*) '**************************************'
              if( ispin == 0 ) then
                do i3_do=1,iw_max_gs
                  write(57,*) w_temp(i3_do)                                        &
                             ,den_sumk_temp2(1,i3_do,i1_do)/dfloat(i_sumk_e)
                end do
              else
                do i3_do=1,iw_max_gs
                  write(57,*) w_temp(i3_do)                                        &
                             ,den_sumk_temp2(1,i3_do,i1_do)/dfloat(i_sumk_e)       &
                             ,den_sumk_temp2(2,i3_do,i1_do)/dfloat(i_sumk_e)
                end do
              end if
            end do
          close(57)
        end if

        if( i_sum_switch == 1 ) then
          nfile_strans='ldos_suma_sumk.dat'
          open(unit=55,file=nfile_strans)
            write(55,*) '**************************************'
            if( ispin == 0 ) then
              do i3_do=1,iw_max_gs
                write(55,*) w_temp(i3_do),den_sumk_temp3(1,i3_do)/dfloat(i_sumk_e)
              end do
            else
              do i3_do=1,iw_max_gs
                write(55,*) w_temp(i3_do),den_sumk_temp3(1,i3_do)/dfloat(i_sumk_e) &
                                         ,den_sumk_temp3(2,i3_do)/dfloat(i_sumk_e)
              end do
            end if
          close(55)
        end if

        deallocate(den_sumk_temp1,den_sumk_temp2,den_sumk_temp3,w_temp,stat=ier)
        if( ier /= 0 ) then
          write(*,*) 'error allocate2'
          stop
        end if
      end if

      nfile_strans='level'
      call makefilename_out(kp,nfile_strans)
      open(unit=56,file=nfile_strans)
        do i1_do=1,mat_max
          write(56,*) i1_do,d_eigen(1,i1_do),d_eigen(2,i1_do)
        end do
      close(56)

      deallocate(d_eigen,stat=ier)
      if( ier /= 0 ) then
        write(*,*) 'de: pldos'
        stop
      end if

!                         ---------------------------------                        !

  999 format(i10,i10,i10,d28.19,d28.19)

! -------------------------------------------------------------------------------- !
  return
end subroutine pldos
! ******************************************************************************** !
! ******************************************************************************** !
! ******************************************************************************** !
subroutine ldos_1
  use para
  implicit none
! -------------------------------------------------------------------------------- !

!                         ---------------------------------                        !
!                         ---------------------------------                        !
!                                        up                                        !
!                         ---------------------------------                        !
!                         ---------------------------------                        !

      write(*,*) 'start calculation_up',input_num,input_num_site

      pai=datan(1.d0)*4.d0

      if( ispin == 0 ) then
        nfile_strans='gfc'
        call makefilename_in(kp,nfile_strans)
      else
        nfile_strans='gfc_up'
        call makefilename_in(kp,nfile_strans)
      end if
      open(unit=50,file=nfile_strans,status='old')

        read(50,*)
        read(50,*)
        read(50,'(a)') buf
        read(buf,*,end=120) iw_max_gs,m_mat_max_m,min_print_site,max_print_site
        go to 121
  120   continue
        read(buf,*) iw_max_gs,m_mat_max_m
        min_print_site=1
        max_print_site=m_mat_max_m
  121   continue

        allocate(den(m_mat_max_m,m_mat_max_m),w(iw_max_gs)                         &
                ,den_site(iw_max_gs,input_num_site),den_total_site(iw_max_gs)      &
                ,stat=ier)
        if( ier /= 0 ) then
          write(*,*) 'error allocate2'
          stop
        end if

        do i3_do=1,input_num_site
          do i2_do=1,iw_max_gs
            den_site(i2_do,i3_do)=0.d0
          end do
        end do

        do i5_do=1,iw_max_gs
          write(6,*) 'now_w',i5_do,'(max=',iw_max_gs,')'

          do i1_do=min_print_site,max_print_site !1,m_mat_max_m
            read(50,*) itemp,w(i5_do)
            do i2_do=min_print_site,max_print_site !1,m_mat_max_m
              read(50,*) itemp,tempr,tempi
!              read(50,*) itemp,tempi
              den(i1_do,i2_do)=tempi
            end do
          end do

          do i3_do=1,input_num_site
            level=i_orb_jj(l_sss(i3_do))
            do i2_do=1,i_orbital(l_sss(i3_do))
              den_site(i5_do,i3_do)                                                &
                       =den_site(i5_do,i3_do)+den(level+i2_do,level+i2_do)
            end do
            den_site(i5_do,i3_do)=-den_site(i5_do,i3_do)/pai
          end do

          if( i_sum_switch == 1 ) then
            den_total_site(i5_do)=0.d0
            do i3_do=i_sum_s,i_sum_e
              level=i_orb_jj(i3_do)
              do i2_do=1,i_orbital(i3_do)
                den_total_site(i5_do)                                                &
                       =den_total_site(i5_do)+den(level+i2_do,level+i2_do)
              end do
            end do
            den_total_site(i5_do)=-den_total_site(i5_do)/pai
          end if

        end do

      close(50)

!                         ---------------------------------                        !

      if( ispin == 0 ) then
        nfile_strans='ldos'
        call makefilename_out(kp,nfile_strans)
        open(unit=55,file=nfile_strans)
          do i1_do=1,input_num_site
            level=l_sss(i1_do)
            write(55,*) '**************************************'
            write(55,*) 'level=',level
            write(55,*) '**************************************'
            do i3_do=1,iw_max_gs
              write(55,*) w(i3_do),den_site(i3_do,i1_do)
            end do
          end do
        close(55)
        if( i_sum_switch == 1 ) then
          nfile_strans='ldos_suma'
          call makefilename_out(kp,nfile_strans)
          open(unit=55,file=nfile_strans)
            write(55,*) '**************************************'
            do i3_do=1,iw_max_gs
              write(55,*) w(i3_do),den_total_site(i3_do)
            end do
          close(55)
        end if
      else
        allocate(den_up_temp2(iw_max_gs,input_num_site),den_up_temp3(iw_max_gs)    &
                ,stat=ier)
        if( ier /= 0 ) then
          write(*,*) 'error allocate2'
          stop
        end if
        do i1_do=1,input_num_site
          do i3_do=1,iw_max_gs
            den_up_temp2(i3_do,i1_do)=den_site(i3_do,i1_do)
          end do
        end do
        if( i_sum_switch == 1 ) then
          do i3_do=1,iw_max_gs
            den_up_temp3(i3_do)=den_total_site(i3_do)
          end do
        end if
      end if

      if( i_sumk_switch == 1 ) then
        if( kp == i_sumk_s ) then
          allocate(den_sumk_temp2(ispin+1,iw_max_gs,input_num_site)                &
                  ,den_sumk_temp3(ispin+1,iw_max_gs),w_temp(iw_max_gs),stat=ier)
          if( ier /= 0 ) then
            write(*,*) 'error allocate2'
            stop
          end if
          den_sumk_temp2=0.d0
          den_sumk_temp3=0.d0
          do i3_do=1,iw_max_gs
            w_temp(i3_do)=w(i3_do)
          end do
        end if
        do i1_do=1,input_num_site
          do i3_do=1,iw_max_gs
            den_sumk_temp2(1,i3_do,i1_do)                                          &
                              =den_sumk_temp2(1,i3_do,i1_do)+den_site(i3_do,i1_do)
          end do
        end do
        if( i_sum_switch == 1 ) then
          do i3_do=1,iw_max_gs
            den_sumk_temp3(1,i3_do)=den_sumk_temp3(1,i3_do)+den_total_site(i3_do)
          end do
        end if
      end if

      deallocate(den,w,den_site,den_total_site,stat=ier)
      if( ier /= 0 ) then
        write(*,*) 'error allocate2'
        stop
      end if

!                         ---------------------------------                        !
!                         ---------------------------------                        !
!                                       down                                       !
!                         ---------------------------------                        !
!                         ---------------------------------                        !

      if( ispin == 0 ) then
        go to 100
      end if

      write(*,*) 'start calculation_do',input_num,input_num_site

      pai=datan(1.d0)*4.d0

      nfile_strans='gfc_do'
      call makefilename_in(kp,nfile_strans)
      open(unit=50,file=nfile_strans,status='old')

        read(50,*)
        read(50,*)
        read(50,'(a)') buf
        read(buf,*,end=122) iw_max_gs,m_mat_max_m,min_print_site,max_print_site
        go to 123
  122   continue
        read(buf,*) iw_max_gs,m_mat_max_m
        min_print_site=1
        max_print_site=m_mat_max_m
  123   continue

        allocate(den(m_mat_max_m,m_mat_max_m),w(iw_max_gs)                         &
                ,den_site(iw_max_gs,input_num_site),den_total_site(iw_max_gs)      &
                ,stat=ier)
        if( ier /= 0 ) then
          write(*,*) 'error allocate2'
          stop
        end if

        do i3_do=1,input_num_site
          do i2_do=1,iw_max_gs
            den_site(i2_do,i3_do)=0.d0
          end do
        end do

        do i5_do=1,iw_max_gs
          write(6,*) 'now_w',i5_do,'(max=',iw_max_gs,')'

          do i1_do=min_print_site,max_print_site !1,m_mat_max_m
            read(50,*) itemp,w(i5_do)
            do i2_do=min_print_site,max_print_site !1,m_mat_max_m
              read(50,*) itemp,tempr,tempi
!              read(50,*) itemp,tempi
              den(i1_do,i2_do)=tempi
            end do
          end do

          do i3_do=1,input_num_site
            level=i_orb_jj(l_sss(i3_do))
            do i2_do=1,i_orbital(l_sss(i3_do))
              den_site(i5_do,i3_do)                                                &
                      =den_site(i5_do,i3_do)+den(level+i2_do,level+i2_do)
            end do
            den_site(i5_do,i3_do)=-den_site(i5_do,i3_do)/pai
          end do

          if( i_sum_switch == 1 ) then
            den_total_site(i5_do)=0.d0
            do i3_do=i_sum_s,i_sum_e
              level=i_orb_jj(i3_do)
              do i2_do=1,i_orbital(i3_do)
                den_total_site(i5_do)                                                &
                       =den_total_site(i5_do)+den(level+i2_do,level+i2_do)
              end do
            end do
            den_total_site(i5_do)=-den_total_site(i5_do)/pai
          end if

        end do

      close(50)

!                         ---------------------------------                        !

      nfile_strans='ldos'
      call makefilename_out(kp,nfile_strans)
      open(unit=57,file=nfile_strans)
        do i1_do=1,input_num_site
          level=l_sss(i1_do)
          write(57,*) '**************************************'
          write(57,*) 'level=',level
          write(57,*) '**************************************'
          do i3_do=1,iw_max_gs
            write(57,*) w(i3_do),den_up_temp2(i3_do,i1_do),den_site(i3_do,i1_do)
          end do
        end do
      close(57)

      if( i_sum_switch == 1 ) then
        nfile_strans='ldos_suma'
        call makefilename_out(kp,nfile_strans)
        open(unit=55,file=nfile_strans)
          write(55,*) '**************************************'
          do i3_do=1,iw_max_gs
            write(55,*) w(i3_do),den_up_temp3(i3_do),den_total_site(i3_do)
          end do
        close(55)
      end if

      if( i_sumk_switch == 1 ) then
        do i1_do=1,input_num_site
          do i3_do=1,iw_max_gs
            den_sumk_temp2(2,i3_do,i1_do)                                          &
                              =den_sumk_temp2(2,i3_do,i1_do)+den_site(i3_do,i1_do)
          end do
        end do
        if( i_sum_switch == 1 ) then
          do i3_do=1,iw_max_gs
            den_sumk_temp3(2,i3_do)=den_sumk_temp3(2,i3_do)+den_total_site(i3_do)
          end do
        end if
      end if

      deallocate(den_up_temp2,den_up_temp3,stat=ier)
      if( ier /= 0 ) then
        write(*,*) 'error allocate2'
        stop
      end if

      deallocate(den,w,den_site,den_total_site,stat=ier)
      if( ier /= 0 ) then
        write(*,*) 'error allocate2'
        stop
      end if

  100 continue

!                         ---------------------------------                        !

      if( i_sumk_switch == 1 .and. kp == i_sumk_e ) then
        nfile_strans='ldos_sumk.dat'
        open(unit=57,file=nfile_strans)
          do i1_do=1,input_num_site
            level=l_sss(i1_do)
            write(57,*) '**************************************'
            write(57,*) 'level=',level
            write(57,*) '**************************************'
            if( ispin == 0 ) then
              do i3_do=1,iw_max_gs
                write(57,*) w_temp(i3_do)                                          &
                           ,den_sumk_temp2(1,i3_do,i1_do)/dfloat(i_sumk_e)
              end do
            else
              do i3_do=1,iw_max_gs
                write(57,*) w_temp(i3_do)                                          &
                           ,den_sumk_temp2(1,i3_do,i1_do)/dfloat(i_sumk_e)         &
                           ,den_sumk_temp2(2,i3_do,i1_do)/dfloat(i_sumk_e)
              end do
            end if
          end do
        close(57)

        if( i_sum_switch == 1 ) then
          nfile_strans='ldos_suma_sumk.dat'
          open(unit=55,file=nfile_strans)
            write(55,*) '**************************************'
            if( ispin == 0 ) then
              do i3_do=1,iw_max_gs
                write(55,*) w_temp(i3_do),den_sumk_temp3(1,i3_do)/dfloat(i_sumk_e)
              end do
            else
              do i3_do=1,iw_max_gs
                write(55,*) w_temp(i3_do),den_sumk_temp3(1,i3_do)/dfloat(i_sumk_e) &
                                         ,den_sumk_temp3(2,i3_do)/dfloat(i_sumk_e)
              end do
            end if
          close(55)
        end if

        deallocate(den_sumk_temp2,den_sumk_temp3,w_temp,stat=ier)
        if( ier /= 0 ) then
          write(*,*) 'error allocate2'
          stop
        end if
      end if

!                         ---------------------------------                        !

  999 format(i10,i10,i10,d28.19,d28.19)

! -------------------------------------------------------------------------------- !
  return
end subroutine ldos_1
! ******************************************************************************** !
! ******************************************************************************** !
! ******************************************************************************** !
subroutine ldos_2
  use para
  implicit none
! -------------------------------------------------------------------------------- !

!                         ---------------------------------                        !
!                         ---------------------------------                        !
!                                        up                                        !
!                         ---------------------------------                        !
!                         ---------------------------------                        !

      write(*,*) 'start calculation_up',input_num_site

      pai=datan(1.d0)*4.d0

      if( ispin == 0 ) then
        nfile_strans='gfc'
        call makefilename_in(kp,nfile_strans)
      else
        nfile_strans='gfc_up'
        call makefilename_in(kp,nfile_strans)
      end if
      open(unit=50,file=nfile_strans,status='old')

        read(50,*)
        read(50,*)
        read(50,*) iw_max_gs,m_mat_max_m

        allocate(den(m_mat_max_m,1),w(iw_max_gs)                                   &
                ,den_site(iw_max_gs,input_num_site),den_total_site(iw_max_gs)      &
                ,stat=ier)
        if( ier /= 0 ) then
          write(*,*) 'error allocate2'
          stop
        end if

        den_site=0.d0

        do i5_do=1,iw_max_gs
          write(6,*) 'now_w',i5_do,'(max=',iw_max_gs,')'

          do i1_do=1,m_mat_max_m
            read(50,*) w(i5_do),itemp,tempr,tempi
            den(i1_do,1)=tempi
          end do

          do i3_do=1,input_num_site
            level=i_orb_jj(l_sss(i3_do))
            do i2_do=1,i_orbital(l_sss(i3_do))
              den_site(i5_do,i3_do)                                                &
                       =den_site(i5_do,i3_do)+den(level+i2_do,1)
            end do
            den_site(i5_do,i3_do)=-den_site(i5_do,i3_do)/pai
          end do

          if( i_sum_switch == 1 ) then
            den_total_site(i5_do)=0.d0
            do i3_do=i_sum_s,i_sum_e
              level=i_orb_jj(i3_do)
              do i2_do=1,i_orbital(i3_do)
                den_total_site(i5_do)                                                &
                       =den_total_site(i5_do)+den(level+i2_do,1)
              end do
            end do
            den_total_site(i5_do)=-den_total_site(i5_do)/pai
          end if

        end do

      close(50)

!                         ---------------------------------                        !

      if( ispin == 0 ) then
        nfile_strans='ldos'
        call makefilename_out(kp,nfile_strans)
        open(unit=55,file=nfile_strans)
          do i1_do=1,input_num_site
            level=l_sss(i1_do)
            write(55,*) '**************************************'
            write(55,*) 'level=',level
            write(55,*) '**************************************'
            do i3_do=1,iw_max_gs
              write(55,*) w(i3_do),den_site(i3_do,i1_do)
            end do
          end do
        close(55)
        if( i_sum_switch == 1 ) then
          nfile_strans='ldos_suma'
          call makefilename_out(kp,nfile_strans)
          open(unit=55,file=nfile_strans)
            write(55,*) '**************************************'
            do i3_do=1,iw_max_gs
              write(55,*) w(i3_do),den_total_site(i3_do)
            end do
          close(55)
        end if
      else
        allocate(den_up_temp2(iw_max_gs,input_num_site),den_up_temp3(iw_max_gs)    &
                ,stat=ier)
        if( ier /= 0 ) then
          write(*,*) 'error allocate2'
          stop
        end if
        do i1_do=1,input_num_site
          do i3_do=1,iw_max_gs
            den_up_temp2(i3_do,i1_do)=den_site(i3_do,i1_do)
          end do
        end do
        if( i_sum_switch == 1 ) then
          do i3_do=1,iw_max_gs
            den_up_temp3(i3_do)=den_total_site(i3_do)
          end do
        end if
      end if

      if( i_sumk_switch == 1 ) then
        if( kp == i_sumk_s ) then
          allocate(den_sumk_temp2(ispin+1,iw_max_gs,input_num_site)                &
                  ,den_sumk_temp3(ispin+1,iw_max_gs),w_temp(iw_max_gs),stat=ier)
          if( ier /= 0 ) then
            write(*,*) 'error allocate2'
            stop
          end if
          den_sumk_temp2=0.d0
          den_sumk_temp3=0.d0
          do i3_do=1,iw_max_gs
            w_temp(i3_do)=w(i3_do)
          end do
        end if
        do i1_do=1,input_num_site
          do i3_do=1,iw_max_gs
            den_sumk_temp2(1,i3_do,i1_do)                                          &
                              =den_sumk_temp2(1,i3_do,i1_do)+den_site(i3_do,i1_do)
          end do
        end do
        if( i_sum_switch == 1 ) then
          do i3_do=1,iw_max_gs
            den_sumk_temp3(1,i3_do)=den_sumk_temp3(1,i3_do)+den_total_site(i3_do)
          end do
        end if
      end if

      deallocate(den,w,den_site,den_total_site,stat=ier)
      if( ier /= 0 ) then
        write(*,*) 'error allocate2'
        stop
      end if

!                         ---------------------------------                        !
!                         ---------------------------------                        !
!                                       down                                       !
!                         ---------------------------------                        !
!                         ---------------------------------                        !

      if( ispin == 0 ) then
        go to 100
      end if

      write(*,*) 'start calculation_do',input_num_site

      pai=datan(1.d0)*4.d0

      nfile_strans='gfc_do'
      call makefilename_in(kp,nfile_strans)
      open(unit=50,file=nfile_strans,status='old')

        read(50,*)
        read(50,*)
        read(50,*) iw_max_gs,m_mat_max_m

        allocate(den(m_mat_max_m,1),w(iw_max_gs)                                   &
                ,den_site(iw_max_gs,input_num_site),den_total_site(iw_max_gs)      &
                ,stat=ier)
        if( ier /= 0 ) then
          write(*,*) 'error allocate2'
          stop
        end if

        den_site=0.d0

        do i5_do=1,iw_max_gs
          write(6,*) 'now_w',i5_do,'(max=',iw_max_gs,')'

          do i1_do=1,m_mat_max_m
            read(50,*) w(i5_do),itemp,tempr,tempi
            den(i1_do,1)=tempi
          end do

          do i3_do=1,input_num_site
            level=i_orb_jj(l_sss(i3_do))
            do i2_do=1,i_orbital(l_sss(i3_do))
              den_site(i5_do,i3_do)                                                &
                      =den_site(i5_do,i3_do)+den(level+i2_do,1)
            end do
            den_site(i5_do,i3_do)=-den_site(i5_do,i3_do)/pai
          end do

          if( i_sum_switch == 1 ) then
            den_total_site(i5_do)=0.d0
            do i3_do=i_sum_s,i_sum_e
              level=i_orb_jj(i3_do)
              do i2_do=1,i_orbital(i3_do)
                den_total_site(i5_do)                                                &
                       =den_total_site(i5_do)+den(level+i2_do,1)
              end do
            end do
            den_total_site(i5_do)=-den_total_site(i5_do)/pai
          end if

        end do

      close(50)

!                         ---------------------------------                        !

      nfile_strans='ldos'
      call makefilename_out(kp,nfile_strans)
      open(unit=57,file=nfile_strans)
        do i1_do=1,input_num_site
          level=l_sss(i1_do)
          write(57,*) '**************************************'
          write(57,*) 'level=',level
          write(57,*) '**************************************'
          do i3_do=1,iw_max_gs
            write(57,*) w(i3_do),den_up_temp2(i3_do,i1_do),den_site(i3_do,i1_do)
          end do
        end do
      close(57)

      if( i_sum_switch == 1 ) then
        nfile_strans='ldos_suma'
        call makefilename_out(kp,nfile_strans)
        open(unit=55,file=nfile_strans)
          write(55,*) '**************************************'
          do i3_do=1,iw_max_gs
            write(55,*) w(i3_do),den_up_temp3(i3_do),den_total_site(i3_do)
          end do
        close(55)
      end if

      if( i_sumk_switch == 1 ) then
        do i1_do=1,input_num_site
          do i3_do=1,iw_max_gs
            den_sumk_temp2(2,i3_do,i1_do)                                          &
                              =den_sumk_temp2(2,i3_do,i1_do)+den_site(i3_do,i1_do)
          end do
        end do
        if( i_sum_switch == 1 ) then
          do i3_do=1,iw_max_gs
            den_sumk_temp3(2,i3_do)=den_sumk_temp3(2,i3_do)+den_total_site(i3_do)
          end do
        end if
      end if

      deallocate(den_up_temp2,den_up_temp3,stat=ier)
      if( ier /= 0 ) then
        write(*,*) 'error allocate2'
        stop
      end if

      deallocate(den,w,den_site,den_total_site,stat=ier)
      if( ier /= 0 ) then
        write(*,*) 'error allocate2'
        stop
      end if

  100 continue

!                         ---------------------------------                        !

      if( i_sumk_switch == 1 .and. kp == i_sumk_e ) then
        nfile_strans='ldos_sumk.dat'
        open(unit=57,file=nfile_strans)
          do i1_do=1,input_num_site
            level=l_sss(i1_do)
            write(57,*) '**************************************'
            write(57,*) 'level=',level
            write(57,*) '**************************************'
            if( ispin == 0 ) then
              do i3_do=1,iw_max_gs
                write(57,*) w_temp(i3_do)                                          &
                           ,den_sumk_temp2(1,i3_do,i1_do)/dfloat(i_sumk_e)
              end do
            else
              do i3_do=1,iw_max_gs
                write(57,*) w_temp(i3_do)                                          &
                           ,den_sumk_temp2(1,i3_do,i1_do)/dfloat(i_sumk_e)         &
                           ,den_sumk_temp2(2,i3_do,i1_do)/dfloat(i_sumk_e)
              end do
            end if
          end do
        close(57)

        if( i_sum_switch == 1 ) then
          nfile_strans='ldos_suma_sumk.dat'
          open(unit=55,file=nfile_strans)
            write(55,*) '**************************************'
            if( ispin == 0 ) then
              do i3_do=1,iw_max_gs
                write(55,*) w_temp(i3_do),den_sumk_temp3(1,i3_do)/dfloat(i_sumk_e)
              end do
            else
              do i3_do=1,iw_max_gs
                write(55,*) w_temp(i3_do),den_sumk_temp3(1,i3_do)/dfloat(i_sumk_e) &
                                         ,den_sumk_temp3(2,i3_do)/dfloat(i_sumk_e)
              end do
            end if
          close(55)
        end if

        deallocate(den_sumk_temp2,den_sumk_temp3,w_temp,stat=ier)
        if( ier /= 0 ) then
          write(*,*) 'error allocate2'
          stop
        end if
      end if

!                         ---------------------------------                        !

  999 format(i10,i10,i10,d28.19,d28.19)

! -------------------------------------------------------------------------------- !
  return
end subroutine ldos_2
! ******************************************************************************** !
! ******************************************************************************** !
! ******************************************************************************** !
subroutine makefilename_in(kt,nfile_strans)

  implicit none
    integer, intent(in) :: kt
   ! character(50), intent(in) :: name
    character(105), intent(inout) :: nfile_strans

    character(1) :: character_temk(4),a(10)
    integer :: i1,i2,k1,i_temp1,i_temp2
! -------------------------------------------------------------------------------- !

      a(1)='0'
      a(2)='1'
      a(3)='2'
      a(4)='3'
      a(5)='4'
      a(6)='5'
      a(7)='6'
      a(8)='7'
      a(9)='8'
      a(10)='9'

      i_temp1=kt
      do i2=1,4
        i_temp2=i_temp1/(10**(4-i2))
        character_temk(i2)=a(i_temp2+1)
        i_temp1=i_temp1-(10**(4-i2))*i_temp2
      end do
      nfile_strans=trim(nfile_strans)                                         &
                   //'_'//character_temk(1)//character_temk(2)                &
                        //character_temk(3)//character_temk(4)//'.data'

! -------------------------------------------------------------------------------- !
    return
end subroutine makefilename_in
! ******************************************************************************** !
subroutine makefilename_out(kt,nfile_strans)

  implicit none
    integer, intent(in) :: kt
   ! character(50), intent(in) :: name
    character(105), intent(inout) :: nfile_strans

    character(1) :: character_temk(4),a(10)
    integer :: i1,i2,k1,i_temp1,i_temp2
! -------------------------------------------------------------------------------- !

      a(1)='0'
      a(2)='1'
      a(3)='2'
      a(4)='3'
      a(5)='4'
      a(6)='5'
      a(7)='6'
      a(8)='7'
      a(9)='8'
      a(10)='9'

      i_temp1=kt
      do i2=1,4
        i_temp2=i_temp1/(10**(4-i2))
        character_temk(i2)=a(i_temp2+1)
        i_temp1=i_temp1-(10**(4-i2))*i_temp2
      end do
      nfile_strans=trim(nfile_strans)                                         &
                   //'_'//character_temk(1)//character_temk(2)                &
                        //character_temk(3)//character_temk(4)//'.dat'

! -------------------------------------------------------------------------------- !
    return
end subroutine makefilename_out
! ******************************************************************************** !
! ******************************************************************************** !
! ******************************************************************************** !

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@             Naoki WATANABE (Mizuho I.R.)                       @@ !
! @@             Nobutaka NISHIKAWA (Mizuho I.R.)                   @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

module hamiltonian_temp

  implicit none

  integer :: natom_ac_ct,natom_ac_cl,natom_ac_cr
  integer :: natom_ac_lt,natom_ac_ll,natom_ac_lr
  integer :: natom_ac_rt,natom_ac_rl,natom_ac_rr
  integer :: nl_ac_c,nl_ac_l,nl_ac_r
  integer :: spin_ll,spin_cc,spin_rr
  real(8) :: ele_num_ll,ele_num_rr
  real(8) :: cell_tempabc(3,3)

  integer, pointer :: i_over_c(:,:,:),i_over_l(:,:,:),i_over_r(:,:,:)
  integer, pointer :: i_orb_c(:),i_orb_l(:),i_orb_r(:)
  real(8), pointer :: rac_c(:,:),rac_l(:,:),rac_r(:,:)
  complex(8), pointer :: hcc_t(:,:,:),scc_t(:,:) 

  complex(8), pointer :: h00_l_t(:,:,:),h01_l_t(:,:,:),h10_l_t(:,:,:) 
  complex(8), pointer :: s00_l_t(:,:),s01_l_t(:,:),s10_l_t(:,:) 
  complex(8), pointer :: h00_r_t(:,:,:),h01_r_t(:,:,:),h10_r_t(:,:,:) 
  complex(8), pointer :: s00_r_t(:,:),s01_r_t(:,:),s10_r_t(:,:) 

  type ham_negf_type
     real(8), pointer :: s(:,:)
     real(8), pointer :: h(:,:,:)
     complex(8), pointer :: hls(:,:,:)
  end type ham_negf_type

  type(ham_negf_type), pointer :: ht_hs_c(:,:,:)
  type(ham_negf_type), pointer :: ht_hs_l(:,:,:)
  type(ham_negf_type), pointer :: ht_hs_r(:,:,:)
contains
  subroutine alo_ham_temp_ham(descCC,descLL,descRR)
    use ac_mpi_module
    implicit none

    type(MPI_MatDesc), intent(in) :: descCC, descLL, descRR
    integer :: ic_spin,il_spin,ir_spin
    integer :: ier

    if( spin_cc == 2 ) then
       ic_spin=2
    else
       ic_spin=1
    end if
    if( spin_ll == 2 ) then
       il_spin=2
    else
       il_spin=1
    end if
    if( spin_rr == 2 ) then
       ir_spin=2
    else
       ir_spin=1
    end if

    allocate(scc_t(descCC%nrow,descCC%scol:descCC%ecol),stat=ier) 
    allocate(hcc_t(descCC%nrow,descCC%scol:descCC%ecol,ic_spin),stat=ier) 

    allocate(s00_l_t(descLL%nrow,descLL%scol:descLL%ecol),stat=ier) 
    allocate(s01_l_t(descLL%nrow,descLL%scol:descLL%ecol),stat=ier) 
    allocate(s10_l_t(descLL%nrow,descLL%scol:descLL%ecol),stat=ier) 
    allocate(s00_r_t(descRR%nrow,descRR%scol:descRR%ecol),stat=ier) 
    allocate(s01_r_t(descRR%nrow,descRR%scol:descRR%ecol),stat=ier) 
    allocate(s10_r_t(descRR%nrow,descRR%scol:descRR%ecol),stat=ier) 

    allocate(h00_l_t(descLL%nrow,descLL%scol:descLL%ecol,ir_spin),stat=ier) 
    allocate(h01_l_t(descLL%nrow,descLL%scol:descLL%ecol,ir_spin),stat=ier) 
    allocate(h10_l_t(descLL%nrow,descLL%scol:descLL%ecol,ir_spin),stat=ier) 
    allocate(h00_r_t(descRR%nrow,descRR%scol:descRR%ecol,ir_spin),stat=ier) 
    allocate(h01_r_t(descRR%nrow,descRR%scol:descRR%ecol,ir_spin),stat=ier) 
    allocate(h10_r_t(descRR%nrow,descRR%scol:descRR%ecol,ir_spin),stat=ier) 
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_ham_temp_ham'
       stop
    end if

    return
  end subroutine alo_ham_temp_ham

  subroutine dealo_ham_temp_ham
    implicit none
    integer :: ier

    deallocate(hcc_t,scc_t) 
    deallocate(h00_l_t,h01_l_t,h10_l_t,s00_l_t,s01_l_t,s10_l_t) 
    deallocate(h00_r_t,h01_r_t,h10_r_t,s00_r_t,s01_r_t,s10_r_t,stat=ier) 
    if( ier /= 0 ) then
       write(6,*) 'error deallocate: dealo_ham_temp_ham'
       stop
    end if

    return
  end subroutine dealo_ham_temp_ham

  subroutine alo_ham_negf_type_c1
    implicit none
    integer :: i1_do,i2_do,i3_do,ier

    allocate(ht_hs_c(natom_ac_ct,natom_ac_ct,nl_ac_c)                            &
         ,i_over_c(natom_ac_ct,natom_ac_ct,nl_ac_c)                           &
         ,i_orb_c(natom_ac_ct),rac_c(3,nl_ac_c),stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_ham_negf_type_c1'
       stop
    end if

    do i1_do=1,natom_ac_ct
       do i2_do=1,nl_ac_c
          do i3_do=1,natom_ac_ct
             i_over_c(i1_do,i3_do,i2_do)=1
          end do
       end do
    end do

    return
  end subroutine alo_ham_negf_type_c1

  subroutine alo_ham_negf_type_c2(i1,i2,l1,j1,j2)
    implicit none
    integer, intent(in) :: i1,i2,l1,j1,j2
    integer :: ier

    if( spin_cc /= 4 ) then
       allocate(ht_hs_c(i2,i1,l1)%h(spin_cc,j2,j1)                                &
            ,ht_hs_c(i2,i1,l1)%s(j2,j1),stat=ier)
    else
       allocate(ht_hs_c(i2,i1,l1)%hls(spin_cc,j2,j1)                              &
            ,ht_hs_c(i2,i1,l1)%s(j2,j1),stat=ier)
    end if
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_ham_negf_type_c2'
       stop
    end if

    return
  end subroutine alo_ham_negf_type_c2

  subroutine dealo_ham_negf_type_c
    implicit none
    integer :: i1_do,i2_do,i3_do,ier

    if( spin_cc /= 4 ) then
       do i1_do=1,natom_ac_ct
          do i2_do=1,nl_ac_c
             do i3_do=1,natom_ac_ct
                if( i_over_c(i3_do,i1_do,i2_do) == 0 ) then
                   deallocate(ht_hs_c(i3_do,i1_do,i2_do)%h                            &
                        ,ht_hs_c(i3_do,i1_do,i2_do)%s,stat=ier)
                   if( ier /= 0 ) then
                      write(6,*) 'error allocate: dealo_ham_negf_type_c2'
                   end if
                end if
             end do
          end do
       end do
    else
       do i1_do=1,natom_ac_ct
          do i2_do=1,nl_ac_c
             do i3_do=1,natom_ac_ct
                if( i_over_c(i3_do,i1_do,i2_do) == 0 ) then
                   deallocate(ht_hs_c(i3_do,i1_do,i2_do)%hls                          &
                        ,ht_hs_c(i3_do,i1_do,i2_do)%s,stat=ier)
                   if( ier /= 0 ) then
                      write(6,*) 'error allocate: dealo_ham_negf_type_c2'
                   end if
                end if
             end do
          end do
       end do
    end if

    deallocate(ht_hs_c,i_over_c,i_orb_c,rac_c,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: dealo_ham_negf_type_c'
       stop
    end if

    return
  end subroutine dealo_ham_negf_type_c

  subroutine alo_ham_negf_type_l1
    implicit none
    integer :: i1_do,i2_do,i3_do,ier

    allocate(ht_hs_l(natom_ac_lt,natom_ac_lt,nl_ac_l)                            &
         ,i_over_l(natom_ac_lt,natom_ac_lt,nl_ac_l)                           &
         ,i_orb_l(natom_ac_lt),rac_l(3,nl_ac_l),stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_ham_negf_type_l1'
       stop
    end if

    do i1_do=1,natom_ac_lt
       do i2_do=1,nl_ac_l
          do i3_do=1,natom_ac_lt
             i_over_l(i1_do,i3_do,i2_do)=1
          end do
       end do
    end do

    return
  end subroutine alo_ham_negf_type_l1

  subroutine alo_ham_negf_type_l2(i1,i2,l1,j1,j2)
    implicit none
    integer, intent(in) :: i1,i2,l1,j1,j2
    integer :: ier

    if( spin_ll /= 4 ) then
       allocate(ht_hs_l(i2,i1,l1)%h(spin_ll,j2,j1)                                &
            ,ht_hs_l(i2,i1,l1)%s(j2,j1),stat=ier)
    else
       allocate(ht_hs_l(i2,i1,l1)%hls(spin_ll,j2,j1)                              &
            ,ht_hs_l(i2,i1,l1)%s(j2,j1),stat=ier)
    end if
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_ham_negf_type_l2'
       stop
    end if

    return
  end subroutine alo_ham_negf_type_l2

  subroutine dealo_ham_negf_type_l
    implicit none
    integer :: i1_do,i2_do,i3_do,ier

    if( spin_ll /= 4 ) then
       do i1_do=1,natom_ac_lt
          do i2_do=1,nl_ac_l
             do i3_do=1,natom_ac_lt
                if( i_over_l(i3_do,i1_do,i2_do) == 0 ) then
                   deallocate(ht_hs_l(i3_do,i1_do,i2_do)%h                            &
                        ,ht_hs_l(i3_do,i1_do,i2_do)%s,stat=ier)
                   if( ier /= 0 ) then
                      write(6,*) 'error allocate: dealo_ham_negf_type_l2'
                   end if
                end if
             end do
          end do
       end do
    else
       do i1_do=1,natom_ac_lt
          do i2_do=1,nl_ac_l
             do i3_do=1,natom_ac_lt
                if( i_over_l(i3_do,i1_do,i2_do) == 0 ) then
                   deallocate(ht_hs_l(i3_do,i1_do,i2_do)%hls                          &
                        ,ht_hs_l(i3_do,i1_do,i2_do)%s,stat=ier)
                   if( ier /= 0 ) then
                      write(6,*) 'error allocate: dealo_ham_negf_type_l2'
                   end if
                end if
             end do
          end do
       end do
    end if

    deallocate(ht_hs_l,i_over_l,i_orb_l,rac_l,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: dealo_ham_negf_type_l'
       stop
    end if

    return
  end subroutine dealo_ham_negf_type_l

  subroutine alo_ham_negf_type_r1
    implicit none
    integer :: i1_do,i2_do,i3_do,ier

    allocate(ht_hs_r(natom_ac_rt,natom_ac_rt,nl_ac_r)                            &
         ,i_over_r(natom_ac_rt,natom_ac_rt,nl_ac_r)                           &
         ,i_orb_r(natom_ac_rt),rac_r(3,nl_ac_r),stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_ham_negf_type_r1'
       stop
    end if

    do i1_do=1,natom_ac_rt
       do i2_do=1,nl_ac_r
          do i3_do=1,natom_ac_rt
             i_over_r(i1_do,i3_do,i2_do)=1
          end do
       end do
    end do

    return
  end subroutine alo_ham_negf_type_r1

  subroutine alo_ham_negf_type_r2(i1,i2,l1,j1,j2)
    implicit none
    integer, intent(in) :: i1,i2,l1,j1,j2
    integer :: ier

    if( spin_rr /= 4 ) then
       allocate(ht_hs_r(i2,i1,l1)%h(spin_rr,j2,j1)                                &
            ,ht_hs_r(i2,i1,l1)%s(j2,j1),stat=ier)
    else
       allocate(ht_hs_r(i2,i1,l1)%hls(spin_rr,j2,j1)                              &
            ,ht_hs_r(i2,i1,l1)%s(j2,j1),stat=ier)
    end if
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_ham_negf_type_r2'
       stop
    end if

    return
  end subroutine alo_ham_negf_type_r2

  subroutine dealo_ham_negf_type_r
    implicit none
    integer :: i1_do,i2_do,i3_do,ier

    if( spin_rr /= 4 ) then
       do i1_do=1,natom_ac_rt
          do i2_do=1,nl_ac_r
             do i3_do=1,natom_ac_rt
                if( i_over_r(i3_do,i1_do,i2_do) == 0 ) then
                   deallocate(ht_hs_r(i3_do,i1_do,i2_do)%h                            &
                        ,ht_hs_r(i3_do,i1_do,i2_do)%s,stat=ier)
                   if( ier /= 0 ) then
                      write(6,*) 'error allocate: dealo_ham_negf_type_r2'
                   end if
                end if
             end do
          end do
       end do
    else
       do i1_do=1,natom_ac_rt
          do i2_do=1,nl_ac_r
             do i3_do=1,natom_ac_rt
                if( i_over_r(i3_do,i1_do,i2_do) == 0 ) then
                   deallocate(ht_hs_r(i3_do,i1_do,i2_do)%hls                          &
                        ,ht_hs_r(i3_do,i1_do,i2_do)%s,stat=ier)
                   if( ier /= 0 ) then
                      write(6,*) 'error allocate: dealo_ham_negf_type_r2'
                   end if
                end if
             end do
          end do
       end do
    end if

    deallocate(ht_hs_r,i_over_r,i_orb_r,rac_r,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: dealo_ham_negf_type_r'
       stop
    end if

    return
  end subroutine dealo_ham_negf_type_r

end module hamiltonian_temp

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine set_chemical_potential(i_rl)

  use condition_ini
  use condition
  use hamiltonian_zper
  use hamiltonian_sgf
  use hamiltonian_c
  use hamiltonian_temp
  use eigen_values
  use gf_se_c
  use mod_mpi

  implicit none
  include 'mpif.h'
  integer, intent(in) :: i_rl

  integer :: kx,ky,kz,mat_max,ispin
  integer :: mul
  real(8) :: st1,st2,stdel

  integer :: i1_do,i2_do,i3_do,i4_do,i5_do,i_temp,ier
  real(8), allocatable :: tr_temp1(:,:,:),tr_temp2(:,:,:,:,:,:)

  character(50) :: switch_eigen

  integer :: kt
  real(8) :: qx_tr,qy_tr

  !                                                ==================================
  !                                                  set chemical potential
  !                                               for tight-binding method, basically
  !                                                ==================================

  if( i_rl == 1 ) then
     switch_eigen=switch_l_eigen
  else
     switch_eigen=switch_r_eigen
  end if

  open(unit=16,file=file_tempout,position='append')
  write(16,*)
  write(16,*) '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'
  if( i_rl == 1 ) then
     write(16,*) '++++++++++++ chemical_potential: left'
  else
     write(16,*) '++++++++++++ chemical_potential: right'
  end if
  write(16,*) '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'
  close(16)

  call myclock(st1)

  call alo_hamiltonian_zper

  mat_max=mat_max_zper
  mat_ev_max=2*mat_max

  !                       ------------------------------------                       !

  do kt=1,ka_tr*kb_tr
     if( ham_model == 'input' .or. ham_model == 'scf_accel' ) then
        qx_tr=po_kt_tr(2,kt)
        qy_tr=po_kt_tr(3,kt)
     end if

     do ispin=1,spin_switch_temp

        do kx=1,kx_max
           do ky=1,ky_max
              if( p_or_f == 'periodic' ) then
                 open(unit=16,file=file_tempout,position='append')
                 write(16,*) 'cal_eigen',kx_max,ky_max,kx,ky
                 close(16)
              end if
              if( ham_model == 'input' .or. ham_model == 'scf_accel' ) then
                 call alo_ham_temp_ham(m_mat_max_c,mat_max_ll,mat_max_rr)
                 if( lr_switch == -1 ) then
                    call set_ham_temp_ham_l(qx_tr,qy_tr)
                 end if
                 if( lr_switch == 1 ) then
                    call set_ham_temp_ham_r(qx_tr,qy_tr)
                 end if
              end if
              do kz=1+myrank,kz_max/2+1,nprocs
                 if( p_or_f == 'free' ) then
                    open(unit=16,file=file_tempout,position='append')
                    write(16,*) 'cal_eigen',kz_max,kz
                    close(16)
                 end if
                 open(unit=16,file=file_tempout,position='append')
                 call set_hamiltonian_zper(kx,ky,kz,ispin)
                 if( switch_eigen == 'on' ) then
                    if( eigen_s_as == 'symmetry' ) then
                       call cal_eigen(kx,ky,kz,ispin,kt)
                    else
                       if( eigen_s_as == 'general' ) then
                          call cal_eigen_as(kx,ky,kz,ispin,kt)
                       else
                          write(6,*) 'error: method_eigen;; set_chemical_potential'
                          stop
                       end if
                    end if
                 end if
                 if( dos_on_off == 'on' ) then
                    if( kz == 1 .or. kz == (kz_max/2+1) ) then
                       mul=1
                    else
                       mul=2
                    end if
                    call gf_bulk(mul,ispin,kt)
                 end if
                 close(16)
              end do
              if( ham_model == 'input' .or. ham_model == 'scf_accel' ) then
                 call dealo_ham_temp_ham
              end if
           end do
        end do
     end do
  end do

  !                       ------------------------------------                       !

  allocate(tr_temp1(omega_par_num(num_gra_te),spin_switch_temp,ka_tr*kb_tr)  &
       ,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: alo_density_temp'
     stop
  end if
  tr_temp1(:,:,:)=0.d0

  i_temp=omega_par_num(num_gra_te)*spin_switch_temp*ka_tr*kb_tr

  call MPI_REDUCE(dos,tr_temp1,i_temp,MPI_DOUBLE_PRECISION,MPI_SUM,0           &
       ,mpi_comm_world,ierr)

  dos(:,:,:) = tr_temp1(:,:,:)

  deallocate(tr_temp1,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: alo_density_temp'
     stop
  end if

  allocate(tr_temp2(mat_max_eigen,kz_max,ky_max,kx_max,spin_switch_temp      &
       ,ka_tr*kb_tr),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: alo_density_temp'
     stop
  end if

  tr_temp2(:,:,:,:,:,:) = 0.0d0

  i_temp=mat_max_eigen*kz_max*ky_max*kx_max*spin_switch_temp*ka_tr*kb_tr
  call MPI_REDUCE(ev_mat,tr_temp2,i_temp,MPI_DOUBLE_PRECISION,MPI_SUM,0        &
       ,mpi_comm_world,ierr)

  ev_mat(:,:,:,:,:,:) = tr_temp2(:,:,:,:,:,:)

  deallocate(tr_temp2,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: alo_density_temp'
     stop
  end if

  i_temp=omega_par_num(num_gra_te)*spin_switch_temp*ka_tr*kb_tr
  call MPI_BCAST(dos,i_temp,MPI_DOUBLE_PRECISION,0,mpi_comm_world,ierr)
  i_temp=mat_max_eigen*kz_max*ky_max*kx_max*spin_switch_temp*ka_tr*kb_tr
  call MPI_BCAST(ev_mat,i_temp,MPI_DOUBLE_PRECISION,0,mpi_comm_world,ierr)

  !                       ------------------------------------                       !

  call cal_chemical_potential(ka_tr*kb_tr)

  !                       ------------------------------------                       !

  call unset_hamiltonian_zper

  !                       ------------------------------------                       !

  open(unit=16,file=file_tempout,position='append')
  call myclock(st2)
  stdel=st2-st1
  write(16,*) '           t=',stdel
  close(16)

  return
end subroutine set_chemical_potential

subroutine cal_eigen(kx,ky,kz,ispin,kt)

  use condition
  use hamiltonian_zper
  use eigen_values

  implicit none

  integer, intent(in) :: kx,ky,kz,ispin,kt
  integer :: i1_do,i2_do,i3_do,i4_do,i_count,l_con,mat_max,ier
  real(8) :: norm_temp
  complex(8) :: temp,temp1
  complex(8), allocatable :: temp_mat1(:,:),temp_mat2(:)

  mat_max=mat_max_zper

  call alo_eigen_values_1

  do i2_do=1,mat_max
     do i1_do=1,mat_max
        a(2*i1_do-1,2*i2_do-1)=dreal(s00_mat(i1_do,i2_do))
        a(2*i1_do-1,2*i2_do)=-dimag(s00_mat(i1_do,i2_do))
        a(2*i1_do,2*i2_do-1)=dimag(s00_mat(i1_do,i2_do))
        a(2*i1_do,2*i2_do)=dreal(s00_mat(i1_do,i2_do))
     end do
  end do
  l_con=1
  call ep1(a,d,mat_ev_max,l_con)
  do i1_do=1,mat_ev_max
     i_num(i1_do)=i1_do
  end do
  do i1_do=1,mat_ev_max
     do i2_do=i1_do+1,mat_ev_max
        if( d(i_num(i1_do)) > d(i_num(i2_do)) ) then
           i3_do=i_num(i1_do)
           i_num(i1_do)=i_num(i2_do)
           i_num(i2_do)=i3_do
        end if
     end do
  end do

  call alo_eigen_values_2

  do i1_do=1,mat_ev_max
     e_temp(i1_do)=d(i_num(i1_do))
     do i2_do=1,mat_max
        ev_vec_temp(i2_do,i1_do)                                                 &
             =dcmplx(a(2*i2_do-1,i_num(i1_do)),a(2*i2_do,i_num(i1_do)))
     end do
  end do

  call unset_eigen_values_1
  call alo_eigen_values_3

  do i1_do=1,mat_max
     s_ev(i1_do)=e_temp(2*i1_do)
     do i2_do=1,mat_max
        ev_vec(i2_do,i1_do)=ev_vec_temp(i2_do,2*i1_do)
     end do
  end do

  !                         ---------------------------------                        !

  i_count=0
10 continue
  do i1_do=1,mat_max
     do i2_do=1,mat_max
        temp=dcmplx(0.d0,0.d0)
        if( i1_do == i2_do ) then
           do i3_do=1,mat_max
              temp=temp+dconjg(ev_vec(i3_do,i1_do))*ev_vec(i3_do,i1_do)
           end do
        else
           do i3_do=1,mat_max
              temp=temp+dconjg(ev_vec(i3_do,i1_do))*ev_vec(i3_do,i2_do)
           end do
           if( cdabs(temp) > 1.d-10 ) then
              temp1=temp
              temp=dcmplx(0.d0,0.d0)
              norm_temp=0.d0
              do i3_do=1,mat_max
                 ev_vec(i3_do,i2_do)=ev_vec(i3_do,i2_do)-temp1*ev_vec(i3_do,i1_do)
                 norm_temp=norm_temp+dconjg(ev_vec(i3_do,i2_do))*ev_vec(i3_do,i2_do)
                 temp=temp+dconjg(ev_vec(i3_do,i1_do))*ev_vec(i3_do,i2_do)
              end do
              if( norm_temp < 1.d-15 ) then
                 i_count=i_count+1
                 do i3_do=1,mat_max
                    ev_vec(i3_do,i2_do)=ev_vec_temp(i3_do,2*i2_do-1)
                 end do
                 if( i_count > mat_max*2 ) then
                    write(6,*) 'error - eigen_vector',i_count,norm_temp
                    stop
                 end if
                 go to 10
              else
                 do i3_do=1,mat_max
                    ev_vec(i3_do,i2_do)=ev_vec(i3_do,i2_do)/dsqrt(norm_temp)
                 end do
              end if
           end if
        end if
     end do
  end do

  call unset_eigen_values_2

  !                         ---------------------------------                        !

  call alo_eigen_values_1

  allocate(temp_mat2(mat_max),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: cal_eigen'
     stop
  end if

  do i1_do=1,mat_max
     s_ev(i1_do)=1.d0/dsqrt(s_ev(i1_do))
  end do
  do i2_do=1,mat_max
     temp_mat2=dcmplx(0.d0,0.d0)
     do i4_do=1,mat_max
        do i3_do=1,mat_max
           temp_mat2(i3_do)=temp_mat2(i3_do)                                      &
                +h00_mat(i3_do,i4_do)*ev_vec(i4_do,i2_do)
        end do
     end do
     do i1_do=1,mat_max
        temp=dcmplx(0.d0,0.d0)
        do i3_do=1,mat_max
           temp=temp+dconjg(ev_vec(i3_do,i1_do))*temp_mat2(i3_do)
        end do
        temp=s_ev(i1_do)*temp*s_ev(i2_do)
        a(2*i1_do-1,2*i2_do-1)=dreal(temp)
        a(2*i1_do-1,2*i2_do)=-dimag(temp)
        a(2*i1_do,2*i2_do-1)=dimag(temp)
        a(2*i1_do,2*i2_do)=dreal(temp)
     end do
  end do

  deallocate(temp_mat2,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error deallocate: cal_eigen'
     stop
  end if

  call unset_eigen_values_3

  l_con=0
  call ep1(a,d,mat_ev_max,l_con)

  do i1_do=1,mat_ev_max
     i_num(i1_do)=i1_do
  end do
  do i1_do=1,mat_ev_max
     do i2_do=i1_do+1,mat_ev_max
        if( d(i_num(i1_do)) > d(i_num(i2_do)) ) then
           i3_do=i_num(i1_do)
           i_num(i1_do)=i_num(i2_do)
           i_num(i2_do)=i3_do
        end if
     end do
  end do
  do i1_do=1,mat_max
     ev_mat(i1_do,kz,ky,kx,ispin,kt)=d(i_num(2*i1_do))
  end do

  call unset_eigen_values_1

  return
end subroutine cal_eigen

subroutine cal_eigen_as(kx,ky,kz,ispin,kt)

  use condition
  use hamiltonian_zper
  use eigen_values

  implicit none

  integer, intent(in) :: kx,ky,kz,ispin,kt
  integer :: i1_do,i2_do,i3_do,mat_max,ier,ier_ev
  complex(8), allocatable :: temp_mat1(:,:),temp_mat2(:,:)

  mat_max=mat_max_zper

  allocate(temp_mat1(mat_max,mat_max),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: cal_eigen_as 1'
     stop
  end if

  call inverse_mat1(mat_max,s00_mat,temp_mat1)

  allocate(temp_mat2(mat_max,mat_max),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: cal_eigen_as 2'
     stop
  end if

  call mat_mul(mat_max,temp_mat1,h00_mat,temp_mat2)

  call alo_eigen_values_as

  do i2_do=1,mat_max
     do i1_do=1,mat_max
        a_as(2*i1_do-1,2*i2_do-1)=dreal(temp_mat2(i1_do,i2_do))
        a_as(2*i1_do-1,2*i2_do)=-dimag(temp_mat2(i1_do,i2_do))
        a_as(2*i1_do,2*i2_do-1)=dimag(temp_mat2(i1_do,i2_do))
        a_as(2*i1_do,2*i2_do)=dreal(temp_mat2(i1_do,i2_do))
     end do
  end do

  deallocate(temp_mat2,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error deallocate: cal_eigen_as 1'
     stop
  end if

  call ep_as1(a_as,d_as,mat_ev_max,ier_ev)

  if( ier_ev == 0) then
     do i1_do=1,mat_ev_max
        if( dabs(dimag(d_as(i1_do))) > 1.d-10 ) then
           write(16,*) 'error: eigen_as (imaginaly part)',d_as(i1_do)
           ier_ev=1
        end if
     end do
  end if

  if( ier_ev == 0 ) then
     deallocate(temp_mat1,stat=ier)
     if( ier /= 0 ) then
        write(6,*) 'error deallocate: cal_eigen_as 2'
        stop
     end if
     go to 10
  end if

  !                         ---------------------------------                        !

  allocate(temp_mat2(mat_max,mat_max),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: cal_eigen_as 3'
     stop
  end if

  call mat_mul(mat_max,h00_mat,temp_mat1,temp_mat2)

  call alo_eigen_values_as

  do i2_do=1,mat_max
     do i1_do=1,mat_max
        a_as(2*i1_do-1,2*i2_do-1)=dreal(temp_mat2(i1_do,i2_do))
        a_as(2*i1_do-1,2*i2_do)=-dimag(temp_mat2(i1_do,i2_do))
        a_as(2*i1_do,2*i2_do-1)=dimag(temp_mat2(i1_do,i2_do))
        a_as(2*i1_do,2*i2_do)=dreal(temp_mat2(i1_do,i2_do))
     end do
  end do

  deallocate(temp_mat1,temp_mat2,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error deallocate: cal_eigen_as 3'
     stop
  end if

  call ep_as1(a_as,d_as,mat_ev_max,ier_ev)

  if( ier_ev == 0) then
     do i1_do=1,mat_ev_max
        if( dabs(dimag(d_as(i1_do))) > 1.d-10 ) then
           write(16,*) 'error: eigen_as (imaginaly part)',d_as(i1_do)
           ier_ev=1
        end if
     end do
  end if

  if( ier_ev /= 0 ) then
     write(16,*) 'error: eigen_as '
     call unset_eigen_values_as
     call cal_eigen(kx,ky,kz,ispin,kt)
     return
  end if

  !                         ---------------------------------                        !

10 continue

  do i1_do=1,mat_ev_max
     i_num(i1_do)=i1_do
  end do
  do i1_do=1,mat_ev_max
     do i2_do=i1_do+1,mat_ev_max
        if( dreal(d_as(i_num(i1_do))) > dreal(d_as(i_num(i2_do))) ) then
           i3_do=i_num(i1_do)
           i_num(i1_do)=i_num(i2_do)
           i_num(i2_do)=i3_do
        end if
     end do
  end do
  do i1_do=1,mat_max
     ev_mat(i1_do,kz,ky,kx,ispin,kt)=dreal(d_as(i_num(2*i1_do)))
  end do

  call unset_eigen_values_as

  return
end subroutine cal_eigen_as

subroutine cal_chemical_potential(kt_num)

  use condition
  use hamiltonian_zper
  use eigen_values

  implicit none
  integer, intent(in) :: kt_num

  integer :: num_total_ele
  integer :: i1_do,i2_do,kx,ky,kz,iter,mat_max,ier,ispin,kt
  real(8) :: temp_t
  real(8), allocatable :: temp(:)

  mat_max=mat_max_zper

  do kt=1,kt_num
     do ispin=1,spin_switch_temp
        do kx=1,kx_max
           do ky=1,ky_max
              do kz=2,kz_max/2
                 do i1_do=1,mat_max
                    ev_mat(i1_do,kz_max-kz+2,ky,kx,ispin,kt)                         &
                         =ev_mat(i1_do,kz,ky,kx,ispin,kt)
                 end do
              end do
           end do
        end do
     end do
  end do

  !                         ---------------------------------                        !

  allocate(temp(kx_max*ky_max*kz_max*mat_max*kt_num*2),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: cal_chemical_potential'
     stop
  end if

  iter=0
  do kt=1,kt_num
     do kx=1,kx_max
        do ky=1,ky_max
           do kz=1,kz_max
              do i1_do=1,mat_max
                 if( spin_switch_temp == 1 ) then
                    iter=iter+1
                    temp(iter)=ev_mat(i1_do,kz,ky,kx,1,kt)
                    iter=iter+1
                    temp(iter)=ev_mat(i1_do,kz,ky,kx,1,kt)
                 else
                    iter=iter+1
                    temp(iter)=ev_mat(i1_do,kz,ky,kx,1,kt)
                    iter=iter+1
                    temp(iter)=ev_mat(i1_do,kz,ky,kx,2,kt)
                 end if
              end do
           end do
        end do
     end do
  end do

  do i1_do=1,kx_max*ky_max*kz_max*mat_max*kt_num*2
     do i2_do=i1_do+1,kx_max*ky_max*kz_max*mat_max*kt_num*2
        if( temp(i1_do) > temp(i2_do) ) then
           temp_t=temp(i1_do)
           temp(i1_do)=temp(i2_do)
           temp(i2_do)=temp_t
        end if
     end do
  end do

  !                         ---------------------------------                        !

  if( ham_model == 'input' .or. ham_model == 'scf_accel' ) then
     num_total_ele=ele_num_temp
  else
     num_total_ele=0.d0
     do i1_do=1,num_atom
        num_total_ele=num_total_ele+atom_electron(atom_kindn(i1_do))
     end do
  end if
  num_total_ele=num_total_ele*kx_max*ky_max*kz_max*kt_num

  if( num_total_ele < kx_max*ky_max*kz_max*mat_max*kt_num*2 ) then
     cp=(temp(num_total_ele)+temp(num_total_ele+1))*.5d0
  else
     cp=temp(kx_max*ky_max*kz_max*mat_max*kt_num*2)
  end if

  !                         ---------------------------------                        !

  deallocate(temp,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error deallocate: cal_chemical_potential'
     stop
  end if

  return
end subroutine cal_chemical_potential

subroutine gf_bulk(mul,ispin,kt)

  use condition
  use hamiltonian_zper

  implicit none
  integer , intent(in) :: mul,ispin,kt
  integer :: i1_do,i2_do,j1_do,j2_do,ier,mat_max
  complex(8) :: w
  complex(8), allocatable :: a_mat(:,:),b_mat(:,:)

  mat_max=mat_max_zper

  allocate(a_mat(mat_max,mat_max),b_mat(mat_max,mat_max),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: gf_bulk'
     stop
  end if

  do j1_do=1,omega_par_num(num_gra_te)
     w=omega(omega_par(num_gra_te)+j1_do)
     do i2_do=1,mat_max
        do i1_do=1,mat_max
           a_mat(i1_do,i2_do)=w*s00_mat(i1_do,i2_do)-h00_mat(i1_do,i2_do)
        end do
     end do
     call inverse_mat1(mat_max,a_mat,b_mat)
     do j2_do=1,mat_max
        dos(j1_do,ispin,kt)=dos(j1_do,ispin,kt)                                  &
             -dimag(b_mat(j2_do,j2_do))*dfloat(mul)
     end do
  end do

  deallocate(a_mat,b_mat,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error deallocate: gf_bulk'
     stop
  end if

  return
end subroutine gf_bulk

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

module locate_atom

  implicit none
  integer :: num_atom_lt,num_atom_ctotal,num_atom_rt
  integer, pointer :: atom_kindn_ccal(:),pair_num_ccal(:,:),i_lmr(:),i_locate(:)
  real(8), pointer :: r_l(:,:),r_c(:,:),r_r(:,:)

contains
  subroutine alo_locate_atom

    implicit none
    integer :: ier

    allocate(r_l(num_atom_lt,3),r_c(num_atom_ctotal,3),r_r(num_atom_rt,3)        &
         ,atom_kindn_ccal(num_atom_ctotal),i_lmr(num_atom_ctotal)             &
         ,i_locate(num_atom_ctotal),stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_locate_atom'
       stop
    end if

    return
  end subroutine alo_locate_atom

  subroutine unset_locate_atom

    implicit none
    integer :: ier

    deallocate(r_l,r_c,r_r,atom_kindn_ccal,i_lmr,i_locate,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: unset_locate_atom'
       stop
    end if

    return
  end subroutine unset_locate_atom

  subroutine alo_locate_atom_pair

    implicit none
    integer :: ier

    allocate(pair_num_ccal(num_atom_ctotal,num_atom_ctotal),stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_locate_atom_pair'
       stop
    end if

    return
  end subroutine alo_locate_atom_pair

  subroutine unset_locate_atom_pair

    implicit none
    integer :: ier

    deallocate(pair_num_ccal,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: unset_locate_atom_pair'
       stop
    end if

    return
  end subroutine unset_locate_atom_pair

end module locate_atom

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine print_text_l

  use condition_ini
  use condition
  use constant

  implicit none
  integer :: iw_do,kz,kt
  real(8) :: temp1,temp2,param

  pai=datan(1.d0)*4.d0
  param=1.d0/pai/dfloat(mat_max_eigen*kx_max*ky_max*kz_max*ka_tr*kb_tr)

  if( dos_on_off == 'on' ) then
     open(unit=31,file='nogf_l.dat')
     write(31,*) '+ total'
     write(31,*) '++++++++++++++++++++++++++++++++++++++++++++++++++'
     do iw_do=1,iw_max
        if( spin_switch_temp == 1 ) then
           temp1=0.d0
           do kt=1,ka_tr*kb_tr
              temp1=temp1+dos(iw_do,1,kt)
           end do
           write(31,*) dreal(omega(iw_do)),temp1*param
        else
           temp1=0.d0
           temp2=0.d0
           do kt=1,ka_tr*kb_tr
              temp1=temp1+dos(iw_do,1,kt)
              temp2=temp2+dos(iw_do,2,kt)
           end do
           write(31,*) dreal(omega(iw_do)),temp1*param,temp2*param
        end if
     end do
     close(31)
  end if


  open(unit=41,file='ev_l.dat')

  write(41,*) '* cp_l=',cp
  write(41,*) '**************************************************'
  do kt=1,ka_tr*kb_tr
     write(41,*) '+  n_k=',kt
     write(41,*) '++++++++++++++++++++++++++++++++++++++++++++++++++'
     do kz=1,kz_max+1
        do iw_do=1,mat_max_eigen
           if( kz <= kz_max ) then
              if( spin_switch_temp == 1 ) then
                 write(41,*) kz-1,ev_mat(iw_do,kz,1,1,1,kt)
              else
                 write(41,*) kz-1,ev_mat(iw_do,kz,1,1,1,kt)                       &
                      ,ev_mat(iw_do,kz,1,1,2,kt)
              end if
           else
              if( spin_switch_temp == 1 ) then
                 write(41,*) kz-1,ev_mat(iw_do,kz-kz_max,1,1,1,kt)
              else
                 write(41,*) kz-1,ev_mat(iw_do,kz-kz_max,1,1,1,kt)                &
                      ,ev_mat(iw_do,kz-kz_max,1,1,2,kt)
              end if
           end if
        end do
     end do
     write(41,*)
  end do

  close(41)

end subroutine print_text_l

subroutine print_text_r

  use condition_ini
  use condition
  use constant

  implicit none
  integer :: iw_do,kz,kt
  real(8) :: temp1,temp2,param

  pai=datan(1.d0)*4.d0
  param=1.d0/pai/dfloat(mat_max_eigen*kx_max*ky_max*kz_max*ka_tr*kb_tr)


  if( dos_on_off == 'on' ) then
     open(unit=31,file='nogf_r.dat')
     write(31,*) '+ total'
     write(31,*) '++++++++++++++++++++++++++++++++++++++++++++++++++'
     do iw_do=1,iw_max
        if( spin_switch_temp == 1 ) then
           temp1=0.d0
           do kt=1,ka_tr*kb_tr
              temp1=temp1+dos(iw_do,1,kt)
           end do
           write(31,*) dreal(omega(iw_do)),temp1*param
        else
           temp1=0.d0
           temp2=0.d0
           do kt=1,ka_tr*kb_tr
              temp1=temp1+dos(iw_do,1,kt)
              temp2=temp2+dos(iw_do,2,kt)
           end do
           write(31,*) dreal(omega(iw_do)),temp1*param,temp2*param
        end if
     end do
     close(31)
  end if


  open(unit=41,file='ev_r.dat')

  write(41,*) '* cp_r=',cp
  write(41,*) '**************************************************'
  do kt=1,ka_tr*kb_tr
     write(41,*) '+  n_k=',kt
     write(41,*) '++++++++++++++++++++++++++++++++++++++++++++++++++'
     do kz=1,kz_max+1
        do iw_do=1,mat_max_eigen
           if( kz <= kz_max ) then
              if( spin_switch_temp == 1 ) then
                 write(41,*) kz-1,ev_mat(iw_do,kz,1,1,1,kt)
              else
                 write(41,*) kz-1,ev_mat(iw_do,kz,1,1,1,kt)                       &
                      ,ev_mat(iw_do,kz,1,1,2,kt)
              end if
           else
              if( spin_switch_temp == 1 ) then
                 write(41,*) kz-1,ev_mat(iw_do,kz-kz_max,1,1,1,kt)
              else
                 write(41,*) kz-1,ev_mat(iw_do,kz-kz_max,1,1,1,kt)                &
                      ,ev_mat(iw_do,kz-kz_max,1,1,2,kt)
              end if
           end if
        end do
     end do
     write(41,*)
  end do

  close(41)

end subroutine print_text_r

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine set_bound_cell_lr

  use condition_ini
  use scf_negf

  implicit none
  integer :: i_do
  integer, allocatable :: num_temp(:)

  do i_do=1,num_atom_scf
     i_atom_num(i_do)=i_do
  end do
  do i_do=1,num_atom_scf
     i_atom_invnum(i_do)=i_do
  end do

  i_orb(1)=0
  do i_do=1,num_atom_scf
     i_orb(i_do+1)=i_orb(i_do)+iatom_orb_num(i_do)
  end do

  return
end subroutine set_bound_cell_lr
subroutine make_cell_lr

  use scf_negf
  use constant

  implicit none
  integer :: n1,n2,n3,ier,m1,m2
  real(8) :: temp_l,temp_r,th1,th2,h1,h2,r1,r2,al1,al2,be1,be2

  cell_dlabc(1,1)=cell_labc(1,1)/dfloat(n_a)
  cell_dlabc(1,2)=cell_labc(1,2)/dfloat(n_a)
  cell_dlabc(1,3)=cell_labc(1,3)/dfloat(n_a)
  cell_dlabc(2,1)=cell_labc(2,1)/dfloat(n_b)
  cell_dlabc(2,2)=cell_labc(2,2)/dfloat(n_b)
  cell_dlabc(2,3)=cell_labc(2,3)/dfloat(n_b)
  cell_dlabc(3,1)=cell_labc(3,1)/dfloat(n_c)
  cell_dlabc(3,2)=cell_labc(3,2)/dfloat(n_c)
  cell_dlabc(3,3)=cell_labc(3,3)/dfloat(n_c)

  del_cell_l=dsqrt(cell_dlabc(3,1)*cell_dlabc(3,1)                             &
       +cell_dlabc(3,2)*cell_dlabc(3,2)+cell_dlabc(3,3)*cell_dlabc(3,3))

  ier=0
  do n1=0,n_a-1
     do n2=0,n_b-1
        do n3=0,n_c-1
           ier=ier+1
           cell_lr(1,ier)=dfloat(n1)*cell_dlabc(1,1)+dfloat(n2)*cell_dlabc(2,1)   &
                +dfloat(n3)*cell_dlabc(3,1)
           cell_lr(2,ier)=dfloat(n1)*cell_dlabc(1,2)+dfloat(n2)*cell_dlabc(2,2)   &
                +dfloat(n3)*cell_dlabc(3,2)
           cell_lr(3,ier)=dfloat(n1)*cell_dlabc(1,3)+dfloat(n2)*cell_dlabc(2,3)   &
                +dfloat(n3)*cell_dlabc(3,3)
        end do
     end do
  end do


  do n3=0,n_c
     cell_lr_z(n3+1)=dfloat(n3)*cell_dlabc(3,1)
  end do


  pai=datan(1.d0)*4.d0

  th1=datan2(cell_labc(1,3),cell_labc(1,2))
  th2=datan2(cell_labc(2,3),cell_labc(2,2))
  al1=dcos(th1)
  al2=dsin(th1)
  be1=dcos(th2)
  be2=dsin(th2)

  r1=2.d0*pai/dsqrt(cell_labc(1,2)*cell_labc(1,2)+cell_labc(1,3)*cell_labc(1,3))
  r2=2.d0*pai/dsqrt(cell_labc(2,2)*cell_labc(2,2)+cell_labc(2,3)*cell_labc(2,3))
  r1=dsqrt(cell_dkabc(1,2)*cell_dkabc(1,2)+cell_dkabc(1,3)*cell_dkabc(1,3))
  r2=dsqrt(cell_dkabc(2,2)*cell_dkabc(2,2)+cell_dkabc(2,3)*cell_dkabc(2,3))

  do m1=0,n_a-1
     if( m1 < n_a/2 )then
        n1=m1
     else
        n1=m1-n_a
     end if
     do m2=0,n_b-1
        if( m2 < n_b/2 )then
           n2=m2
        else
           n2=m2-n_b
        end if
        h1=dfloat(n1)*r1
        h2=dfloat(n2)*r2
        g2_temp(m1*n_b+m2+1)=dsqrt((al1*al1+be1*be1)*h1*h1                       &
             +(al2*al2+be2*be2)*h2*h2                    &
             +2.d0*(al1*al2+be1*be2)*h1*h2)
     end do
  end do


  do m1=0,n_a-1
     if( m1 < n_a/2 )then
        n1=m1
     else
        n1=m1-n_a
     end if
     do m2=0,n_b-1
        if( m2 < n_b/2 )then
           n2=m2
        else
           n2=m2-n_b
        end if
        r_cell_dk(1,m1*n_b+m2+1)=dfloat(n1)*cell_dkabc(1,2)                      &
             +dfloat(n2)*cell_dkabc(2,2)
        r_cell_dk(2,m1*n_b+m2+1)=dfloat(n1)*cell_dkabc(1,3)                      &
             +dfloat(n2)*cell_dkabc(2,3)
     end do
  end do


  temp_l=dabs(cell_labc_l(3,1))/dfloat(n_c_l)
  temp_r=dabs(cell_labc_r(3,1))/dfloat(n_c_r)

  do n3=1,n_c
     if( (dfloat(l_cell_l_bound_l-1)+.5d0)*temp_l                               &
          >= cell_lr(1,n3)+del_cell_l*.5d0 ) then
        l_cell_l_bound=n3
        del_bound_l=(dfloat(l_cell_l_bound_l-1)+.5d0)*temp_l                     &
             -(cell_lr(1,n3)+del_cell_l*.5d0)
     end if
     if( (dfloat(r_cell_l_bound_r-1)+.5d0)*temp_r                               &
          -cell_labc_r(3,1)+cell_labc(3,1)                             &
          > cell_lr(1,n3)+del_cell_l*.5d0 ) then
        r_cell_l_bound=n3+1
        del_bound_r=(dfloat(r_cell_l_bound_r-1)+.5d0)*temp_r                     &
             -cell_labc_r(3,1)+cell_labc(3,1)                              &
             -(cell_lr(1,n3+1)+del_cell_l*.5d0)
     else
        exit
     end if
  end do

  r_cell_l_bound_num=n_c-r_cell_l_bound+1
  c_num_cell_l=n_c-l_cell_l_bound-r_cell_l_bound+2

  return
end subroutine make_cell_lr
subroutine bound_cell_lr_l

  use scf_negf
  use constant
  use mod_mpi

  implicit none
  integer ::n3,i1_do,i_num_temp
  real(8) :: temp_l,temp_r

  i_num_temp=0
  temp_r=0.d0
  temp_l=0.d0
  do i1_do=1,num_atom_scf
     if( atom_ro(i1_do,1)-atom_rcut(i1_do) < 0.d0 ) then
        i_num_temp=i1_do
        temp_l=atom_ro(i_num_temp,1)+atom_rcut(i_num_temp)
     end if
     if( atom_ro(i1_do,1)+atom_rcut(i1_do)-cell_labc(3,1) > temp_r ) then
        temp_r=atom_ro(i1_do,1)+atom_rcut(i1_do)-cell_labc(3,1)
     end if
  end do
  if( temp_l < temp_r ) then
     temp_l=temp_r
  end if

  if( dis_chara == 'def' ) then
     res_bound_l=temp_l
     open(unit=36,file=file_tempout,position='append')
     write(36,997) res_bound_l*dis_scale
     close(36)
  end if
  if( dis_chara == 'on' .and. res_bound_l < temp_l ) then
     open(unit=36,file=file_tempout,position='append')
     write(36,998) res_bound_l*dis_scale,temp_l*dis_scale
     close(36)
  end if
  if( lay_chara == 'def' ) then
     atom_parlay_l=i_num_temp
  end if
  if( lay_chara == 'on' .and. atom_parlay_l > i_num_temp ) then
     open(unit=36,file=file_tempout,position='append')
     write(36,999) res_bound_l*dis_scale                                      &
          ,(atom_ro(atom_parlay_l,1)+atom_rcut(atom_parlay_l))*dis_scale
     close(36)
  end if

997 format('                         set boundary ( left):',f11.6)
998 format('                      !!!!!! boundary ( left):',f11.6,f11.6,'?')
999 format('             !!!!!! boundary for atom ( left):',f11.6,f11.6,'?')


  temp_l=dabs(cell_labc_l(3,1))/dfloat(n_c_l)

  do n3=0,n_c_l-1
     if( res_bound_l > n3*temp_l ) then
        l_cell_l_bound_l=n3+1
     else
        exit
     end if
  end do

  return
end subroutine bound_cell_lr_l
subroutine bound_cell_lr_r

  use scf_negf
  use constant
  use mod_mpi

  implicit none
  integer :: n3,i1_do,i_num_temp
  real(8) :: temp,temp_r,temp_l

  i_num_temp=0
  temp_l=0.d0
  temp_r=0.d0
  n3=0
  do i1_do=num_atom_scf,1,-1
     n3=n3+1
     if( atom_ro(i1_do,1)+atom_rcut(i1_do) > cell_labc(3,1) ) then
        i_num_temp=n3
        temp_r=cell_labc(3,1)-(atom_ro(i1_do,1)-atom_rcut(i1_do))
     end if
     if( atom_ro(i1_do,1)-atom_rcut(i1_do) < -temp_l ) then
        temp_l=-(atom_ro(i1_do,1)-atom_rcut(i1_do))
     end if
  end do
  if( temp_r < temp_l ) then
     temp_r=temp_l
  end if

  if( dis_chara == 'def' ) then
     res_bound_r=temp_r
     open(unit=36,file=file_tempout,position='append')
     write(36,997) res_bound_r*dis_scale
     close(36)
  end if
  if( dis_chara == 'on' .and. res_bound_r < temp_r ) then
     open(unit=36,file=file_tempout,position='append')
     write(36,998) res_bound_r*dis_scale,temp_r*dis_scale
     close(36)
  end if
  if( lay_chara == 'def' ) then
     atom_parlay_r=i_num_temp
  end if
  if( lay_chara == 'on' .and. atom_parlay_r > i_num_temp ) then
     open(unit=36,file=file_tempout,position='append')
     write(36,999) res_bound_r*dis_scale                                      &
          ,(cell_labc(3,1)-(atom_ro(num_atom_scf-atom_parlay_r+1,1)   &
          -atom_rcut(atom_parlay_r-atom_parlay_r+1)))*dis_scale
     close(36)
  end if

997 format('                         set boundary (right):',f11.6)
998 format('                      !!!!!! boundary (right):',f11.6,f11.6,'?')
999 format('             !!!!!! boundary for atom (right):',f11.6,f11.6,'?')


  temp_r=dabs(cell_labc_r(3,1))/dfloat(n_c_r)
  temp=dsqrt(cell_labc_r(3,1)*cell_labc_r(3,1)                                 &
       +cell_labc_r(3,2)*cell_labc_r(3,2)                           &
       +cell_labc_r(3,3)*cell_labc_r(3,3))                          &
       -res_bound_r

  do n3=0,n_c_r-1
     if( temp > n3*temp_r ) then
        r_cell_l_bound_r=n3+2
     else
        exit
     end if
  end do

  return
end subroutine bound_cell_lr_r

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine trans(w,iw_do,px,py,qx,qy,ispin,kt)

  use hamiltonian_sgf
  use hamiltonian_c
  use gf_se_c
  use constant
  use condition_ini
  use mod_mpi

  implicit none
  include 'mpif.h'
  integer, intent(in) :: iw_do
  integer, intent(in) :: px,py,qx,qy,ispin,kt
  complex(8), intent(in) :: w

  integer :: i1_do,i2_do,ier
  complex(8), allocatable :: amat_temp5(:,:),amat_temp6(:,:)
  complex(8), allocatable :: bmat_temp5(:,:),bmat_temp6(:,:)

  character(50) :: nfile_strans

  if( iw_do > iw_max_gs ) then
     go to 100
  end if

  call alo_hami_c3
  if( ham_model_ini == 'input' .or. ham_model_ini == 'scf_accel' ) then
     if( ham_model_ini == 'input' ) then
        call set_hami_c_cc_input(ispin)
     else
        call set_hami_c_cc_scf(ispin)
     end if
  else
     call set_hami_c_cc(px,py,qx,qy)
  end if
  allocate(amat_temp6(m_mat_max_c,m_mat_max_c),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: trans 1'
     stop
  end if
  do i2_do=1,m_mat_max_c
     do i1_do=1,m_mat_max_c
        amat_temp6(i1_do,i2_do)                                                  &
             =(w*scc_mat(i1_do,i2_do)-hcc_mat(i1_do,i2_do))
     end do
  end do
  call unset_hami_c31

  do i2_do=1,m_mat_max_c
     do i1_do=1,m_mat_max_c
        amat_temp6(i1_do,i2_do)                                                  &
             =amat_temp6(i1_do,i2_do)                                           &
             -se_l_mat_per(i1_do,i2_do,px,py)-se_r_mat_per(i1_do,i2_do,qx,qy)
     end do
  end do

  allocate(bmat_temp6(m_mat_max_c,m_mat_max_c),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: trans 2'
     stop
  end if

  call inverse_mat1(m_mat_max_c,amat_temp6,bmat_temp6)

  call mat_mul(m_mat_max_c,bmat_temp6,scc_mat,amat_temp6)
  call unset_hami_c32

  call cal_print_text2(iw_do,amat_temp6,ispin,kt)

100 continue

  do i1_do=1,nprocs
     call MPI_BARRIER(mpi_comm_world,ierr)
     if( iw_do > iw_max_gs ) then
        cycle
     end if
     if( i1_do == myrank+1 ) then
        if( iw_do /= 1 ) then
           if( spin_switch_cc /= 2 ) then
              if( switch_out_gf /= 'off' ) then
                 nfile_strans='gfc'
                 call makefilename_strans(kt,nfile_strans)
                 open(unit=50,file=nfile_strans,position='append')
              end if
              if( switch_out_tr == 'all' ) then
                 nfile_strans='ftg'
                 call makefilename_strans(kt,nfile_strans)
                 open(unit=46,file=nfile_strans,position='append')
              end if
           else
              if( switch_out_gf /= 'off' ) then
                 nfile_strans='gfc_up'
                 call makefilename_strans(kt,nfile_strans)
                 open(unit=50,file=nfile_strans,position='append')
                 nfile_strans='gfc_do'
                 call makefilename_strans(kt,nfile_strans)
                 open(unit=52,file=nfile_strans,position='append')
              end if
              if( switch_out_tr == 'all' ) then
                 nfile_strans='ftg_up'
                 call makefilename_strans(kt,nfile_strans)
                 open(unit=46,file=nfile_strans,position='append')
                 nfile_strans='ftg_do'
                 call makefilename_strans(kt,nfile_strans)
                 open(unit=47,file=nfile_strans,position='append')
              end if
           end if
        else
           if( spin_switch_cc /= 2 ) then
              if( switch_out_gf /= 'off' ) then
                 nfile_strans='gfc'
                 call makefilename_strans(kt,nfile_strans)
                 open(unit=50,file=nfile_strans)
              end if
              if( switch_out_tr == 'all' ) then
                 nfile_strans='ftg'
                 call makefilename_strans(kt,nfile_strans)
                 open(unit=46,file=nfile_strans)
              end if
           else
              if( switch_out_gf /= 'off' ) then
                 nfile_strans='gfc_up'
                 call makefilename_strans(kt,nfile_strans)
                 open(unit=50,file=nfile_strans)
                 nfile_strans='gfc_do'
                 call makefilename_strans(kt,nfile_strans)
                 open(unit=52,file=nfile_strans)
              end if
              if( switch_out_tr == 'all' ) then
                 nfile_strans='ftg_up'
                 call makefilename_strans(kt,nfile_strans)
                 open(unit=46,file=nfile_strans)
                 nfile_strans='ftg_do'
                 call makefilename_strans(kt,nfile_strans)
                 open(unit=47,file=nfile_strans)
              end if
           end if
        end if
        call print_site_sel(w,amat_temp6,bmat_temp6,ispin)
        if( spin_switch_cc /= 2 ) then
           if( switch_out_gf /= 'off' ) then
              close(50)
           end if
           if( switch_out_tr == 'all' ) then
              close(46)
           end if
        else
           if( switch_out_gf /= 'off' ) then
              close(50)
              close(52)
           end if
           if( switch_out_tr == 'all' ) then
              close(46)
              close(47)
           end if
        end if
     end if
  end do

  if( iw_do > iw_max_gs ) then
     go to 110
  end if

  allocate(amat_temp5(m_mat_max_c,m_mat_max_c)                                 &
       ,bmat_temp5(m_mat_max_c,m_mat_max_c),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: trans 3'
     stop
  end if

  !                       ------------------------------------                       !

  do i2_do=1,m_mat_max_c
     do i1_do=1,m_mat_max_c
        amat_temp5(i1_do,i2_do)                                                  &
             =dcmplx(0.d0,1.d0)*(se_r_mat_per(i1_do,i2_do,qx,qy)            &
             -dconjg(se_r_mat_per(i2_do,i1_do,qx,qy)))
     end do
  end do
  do i2_do=1,m_mat_max_c
     do i1_do=1,m_mat_max_c
        bmat_temp5(i1_do,i2_do)=dconjg(bmat_temp6(i2_do,i1_do))
     end do
  end do
  call mat_mul(m_mat_max_c,amat_temp5,bmat_temp5,amat_temp6)

  do i2_do=1,m_mat_max_c
     do i1_do=1,m_mat_max_c
        amat_temp5(i1_do,i2_do)                                                  &
             =dcmplx(0.d0,1.d0)*(se_l_mat_per(i1_do,i2_do,px,py)            &
             -dconjg(se_l_mat_per(i2_do,i1_do,px,py)))
     end do
  end do
  call mat_mul(m_mat_max_c,amat_temp5,bmat_temp6,bmat_temp5)

  call mat_mul(m_mat_max_c,bmat_temp5,amat_temp6,amat_temp5)

  call cal_print_text3(iw_do,amat_temp5,ispin,kt)

110 continue

  do i1_do=1,nprocs
     call MPI_BARRIER(mpi_comm_world,ierr)
     if( iw_do > iw_max_gs ) then
        cycle
     end if
     if( i1_do == myrank+1 ) then
        if( iw_do /= 1 ) then
           if( spin_switch_cc /= 2 ) then
              if( switch_out_tr /= 'off' ) then
                 nfile_strans='tra'
                 call makefilename_strans(kt,nfile_strans)
                 open(unit=51,file=nfile_strans,position='append')
              end if
              if( switch_out_tr == 'all' ) then
                 nfile_strans='gam'
                 call makefilename_strans(kt,nfile_strans)
                 open(unit=48,file=nfile_strans,position='append')
              end if
              open(unit=55,file='sf_gf.dat',position='append')
           else
              if( switch_out_tr /= 'off' ) then
                 nfile_strans='tra_up'
                 call makefilename_strans(kt,nfile_strans)
                 open(unit=51,file=nfile_strans,position='append')
                 nfile_strans='tra_do'
                 call makefilename_strans(kt,nfile_strans)
                 open(unit=53,file=nfile_strans,position='append')
              end if
              if( switch_out_tr == 'all' ) then
                 nfile_strans='gam_up'
                 call makefilename_strans(kt,nfile_strans)
                 open(unit=48,file=nfile_strans,position='append')
                 nfile_strans='gam_do'
                 call makefilename_strans(kt,nfile_strans)
                 open(unit=49,file=nfile_strans,position='append')
              end if
              open(unit=55,file='sf_gf_up.dat',position='append')
              open(unit=56,file='sf_gf_do.dat',position='append')
           end if
           open(unit=57,file='em_gf.dat',position='append')
           open(unit=58,file='trans.dat',position='append')
        else
           if( spin_switch_cc /= 2 ) then
              if( switch_out_tr /= 'off' ) then
                 nfile_strans='tra'
                 call makefilename_strans(kt,nfile_strans)
                 open(unit=51,file=nfile_strans)
              end if
              if( kt /= 1 ) then
                 open(unit=55,file='sf_gf.dat',position='append')
              else
                 open(unit=55,file='sf_gf.dat')
              end if
              if( switch_out_tr == 'all' ) then
                 nfile_strans='gam'
                 call makefilename_strans(kt,nfile_strans)
                 open(unit=48,file=nfile_strans)
              end if
           else
              if( switch_out_tr /= 'off' ) then
                 nfile_strans='tra_up'
                 call makefilename_strans(kt,nfile_strans)
                 open(unit=51,file=nfile_strans)
                 nfile_strans='tra_do'
                 call makefilename_strans(kt,nfile_strans)
                 open(unit=53,file=nfile_strans)
              end if
              if( switch_out_tr == 'all' ) then
                 nfile_strans='gam_up'
                 call makefilename_strans(kt,nfile_strans)
                 open(unit=48,file=nfile_strans)
                 nfile_strans='gam_do'
                 call makefilename_strans(kt,nfile_strans)
                 open(unit=49,file=nfile_strans)
              end if
              if( kt /= 1 ) then
                 open(unit=55,file='sf_gf_up.dat',position='append')
                 open(unit=56,file='sf_gf_do.dat',position='append')
              else
                 open(unit=55,file='sf_gf_up.dat')
                 open(unit=56,file='sf_gf_do.dat')
              end if
           end if
           if( kt /= 1 ) then
              open(unit=57,file='em_gf.dat',position='append')
              open(unit=58,file='trans.dat',position='append')
           else
              open(unit=57,file='em_gf.dat')
              open(unit=58,file='trans.dat')
           end if
        end if
        call print_site_tra(w,amat_temp5,ispin)
        call print_text_t(w,iw_do,ispin,kt)
        if( spin_switch_cc /= 2 ) then
           if( switch_out_tr /= 'off' ) then
              close(51)
           end if
           close(55)
           close(57)
           close(58)
           if( switch_out_tr == 'all' ) then
              close(48)
           end if
        else
           if( switch_out_tr /= 'off' ) then
              close(51)
              close(53)
           end if
           close(55)
           close(56)
           close(57)
           close(58)
           if( switch_out_tr == 'all' ) then
              close(48)
              close(49)
           end if
        end if
     end if
  end do

  if( iw_do > iw_max_gs ) then
     go to 120
  end if

  deallocate(amat_temp5,amat_temp6,bmat_temp5,bmat_temp6,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error deallocate: trans'
     stop
  end if

120 continue

  return
end subroutine trans

subroutine makefilename_strans(kt,nfile_strans)

  implicit none
  integer, intent(in) :: kt
  character(50), intent(inout) :: nfile_strans

  character(1) :: character_temk(4),a(10)
  integer :: i1,i2,k1,i_temp1,i_temp2

  a(1)='0'
  a(2)='1'
  a(3)='2'
  a(4)='3'
  a(5)='4'
  a(6)='5'
  a(7)='6'
  a(8)='7'
  a(9)='8'
  a(10)='9'

  i_temp1=kt
  do i2=1,4
     i_temp2=i_temp1/(10**(4-i2))
     character_temk(i2)=a(i_temp2+1)
     i_temp1=i_temp1-(10**(4-i2))*i_temp2
  end do
  nfile_strans=trim(nfile_strans)                                         &
       //'_'//character_temk(1)//character_temk(2)                &
       //character_temk(3)//character_temk(4)//'.data'

  return
end subroutine makefilename_strans

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Naoki WATANABE, Nobutaka NISHIKAWA (Mizuho I.R.)   @@ !
! @@             Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine vector3d__save1( v, fname )
  use ac_parameter

  implicit none
  real(8), intent(in)  :: v(Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)
  character(len=*), intent(in) :: fname

  if( index( fname, ".dx", .true. ) + 2 == len_trim(fname) ) then
     call vector3d__save1DX( v, fname )
  else if( index( fname, ".cube", .true. ) + 4 == len_trim(fname) ) then
     call vector3d__save1Cube( v, fname )
  else
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,999) trim(fname)
999  format('      +++++++ Error vecter3d::save1 : unknown format: ',a)
     close(16)
     stop
  end if

  return
end subroutine vector3d__save1

subroutine vector3d__save2( v, fname )
  use ac_parameter

  implicit none
  real(8), intent(in)  :: v(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)
  character(len=*), intent(in) :: fname

  if( index( fname, ".dx", .true. ) + 2 == len_trim(fname) ) then
     call vector3d__save2DX( v, fname )
  else if( index( fname, ".cube", .true. ) + 4 == len_trim(fname) ) then
     call vector3d__save2Cube( v, fname )
  else
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,999) trim(fname)
999  format('      +++++++ Error vecter3d::save2 : unknown format: ',a)
     close(16)
     stop
  end if

  return
end subroutine vector3d__save2

subroutine vector3d__save4( v, fname )
  use ac_parameter

  implicit none
  complex(8), intent(in) :: v(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)
  character(len=*), intent(in) :: fname

  if( index( fname, ".dx", .true. ) + 2 == len_trim(fname) ) then
     call vector3d__save4DX( v, fname )
  else if( index( fname, ".cube", .true. ) + 4 == len_trim(fname) ) then
     call vector3d__save4Cube( v, fname )
  else
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,999) trim(fname)
999  format('      +++++++ Error vecter3d::save4 : unknown format: ',a)
     close(16)
     stop
  end if

  return
end subroutine vector3d__save4

subroutine vector3d__load1( v, fname )
  use ac_parameter

  implicit none
  real(8), intent(out) :: v(Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)
  character(len=*), intent(in) :: fname

  if( index( fname, ".dx", .true. ) + 2 == len_trim(fname) ) then
     call vector3d__load2DX( v, fname )
  else if( index( fname, ".cube", .true. ) + 4 == len_trim(fname) ) then
     call vector3d__load2Cube( v, fname )
  else
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,999) trim(fname)
999  format('      +++++++ Error vecter3d::load1 : unknown format: ',a)
     close(16)
     stop
  end if

  return
end subroutine vector3d__load1

subroutine vector3d__load2( v, fname )
  use ac_parameter

  implicit none
  real(8), intent(out) :: v(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)
  character(len=*), intent(in) :: fname

  if( index( fname, ".dx", .true. ) + 2 == len_trim(fname) ) then
     call vector3d__load2DX( v, fname )
  else if( index( fname, ".cube", .true. ) + 4 == len_trim(fname) ) then
     call vector3d__load2Cube( v, fname )
  else
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,999) trim(fname)
999  format('      +++++++ Error vecter3d::load2 : unknown format: ',a)
     close(16)
     stop
  end if

  return
end subroutine vector3d__load2

subroutine vector3d__load4( v, fname )
  use ac_parameter

  implicit none
  complex(8), intent(out) :: v(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)
  character(len=*), intent(in) :: fname

  if( index( fname, ".dx", .true. ) + 2 == len_trim(fname) ) then
     call vector3d__load4DX( v, fname )
  else if( index( fname, ".cube", .true. ) + 4 == len_trim(fname) ) then
     call vector3d__load4Cube( v, fname )
  else
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,999) trim(fname)
999  format('      +++++++ Error vecter3d::load4 : unknown format: ',a)
     close(16)
     stop
  end if

  return
end subroutine vector3d__load4

subroutine vector3d__save1DX( v, fname )
  use ac_parameter

  implicit none
  real(8), intent(in)  :: v(Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)

  character(len=*), intent(in) :: fname
  integer :: ia, ib, ic
  integer :: iunit

  iunit = 1
  open(iunit,file=fname)

  write(iunit,'(a,3i5)') 'object 1 class gridpositions counts ', &
       Param%Cell%Na, Param%Cell%Nb, Param%Cell%Nc
  write(iunit,'(a,3f20.15)') 'origin ', &
       Param%Cell%Lo(1)*AU_TO_AA, Param%Cell%Lo(2)*AU_TO_AA, Param%Cell%Lo(3)*AU_TO_AA 
  write(iunit,'(a,3f20.15)') 'delta ', &
       Param%Cell%dLa(1)*AU_TO_AA, Param%Cell%dLa(2)*AU_TO_AA, Param%Cell%dLa(3)*AU_TO_AA 
  write(iunit,'(a,3f20.15)') 'delta ', &
       Param%Cell%dLb(1)*AU_TO_AA, Param%Cell%dLb(2)*AU_TO_AA, Param%Cell%dLb(3)*AU_TO_AA 
  write(iunit,'(a,3f20.15)') 'delta ', &
       Param%Cell%dLc(1)*AU_TO_AA, Param%Cell%dLc(2)*AU_TO_AA, Param%Cell%dLc(3)*AU_TO_AA 
  write(iunit,'(a,3i5)') 'object 2 class gridconnections counts', &
       Param%Cell%Na, Param%Cell%Nb, Param%Cell%Nc
  write(iunit,'(a,i5,a)') 'object 3 class array type float category real rank 0 items', &
       Param%Cell%Na*Param%Cell%Nb*Param%Cell%Nc, ' data follows'

  do ia=1, Param%Cell%Na
     do ib=1, Param%Cell%Nb
        do ic=1, Param%Cell%Nc
           write(iunit,'(e25.15)') v(ia,ib,ic)
        end do
     end do
  end do

  write(iunit,'(a)') 'object "density" class field'
  write(iunit,'(a)') 'component "positions" value 1'
  write(iunit,'(a)') 'component "connections" value 2'
  write(iunit,'(a)') 'component "data" value 3'

  close(iunit)

  return
end subroutine vector3d__save1DX

subroutine vector3d__save1Cube( v, fname )
  use ac_parameter
  implicit none
  real(8), intent(in)  :: v(Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)

  character(len=*), intent(in) :: fname
  integer :: ia, ib, ic, i
  integer :: iunit

  iunit = 1
  open(iunit,file=fname)
  write(iunit,*) 'ACCEL'
  write(iunit,*) trim(fname)
  write(iunit,993) Param%Data%natom, Param%Cell%Lo(1), Param%Cell%Lo(2), Param%Cell%Lo(3)
  write(iunit,993) Param%Cell%Na, Param%Cell%dLa(1), Param%Cell%dLa(2), Param%Cell%dLa(3)
  write(iunit,993) Param%Cell%Nb, Param%Cell%dLb(1), Param%Cell%dLb(2), Param%Cell%dLb(3)
  write(iunit,993) Param%Cell%Nc, Param%Cell%dLc(1), Param%Cell%dLc(2), Param%Cell%dLc(3)
  do i=1, Param%Data%natom
     write(iunit,992) Param%Data%vatom(i)%number, Param%Data%vatom(i)%Q                  &
          , Param%Data%vatom(i)%Ro(1), Param%Data%vatom(i)%Ro(2), Param%Data%vatom(i)%Ro(3)
  end do
  do ia=1,Param%Cell%Na
     do ib=1,Param%Cell%Nb
        write(iunit,999) (v(ia,ib,ic),ic=0,Param%Cell%Nc-1)
     end do
  end do

  close(iunit)

999 format(6f17.10)
993 format(i4,3f17.10)
992 format(i4,4f17.10)

  return
end subroutine vector3d__save1Cube

subroutine vector3d__save2DX( v, fname )
  use ac_parameter

  implicit none
  real(8), intent(in)  :: v(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)

  character(len=*), intent(in) :: fname
  integer :: ia, ib, ic
  integer :: iunit

  iunit = 1
  open(iunit,file=fname)

  write(iunit,'(a,3i5)') 'object 1 class gridpositions counts ', &
       Param%Cell%Na, Param%Cell%Nb, Param%Cell%Nc
  write(iunit,'(a,3f20.15)') 'origin ', &
       Param%Cell%Lo(1)*AU_TO_AA, Param%Cell%Lo(2)*AU_TO_AA, Param%Cell%Lo(3)*AU_TO_AA 
  write(iunit,'(a,3f20.15)') 'delta ', &
       Param%Cell%dLa(1)*AU_TO_AA, Param%Cell%dLa(2)*AU_TO_AA, Param%Cell%dLa(3)*AU_TO_AA 
  write(iunit,'(a,3f20.15)') 'delta ', &
       Param%Cell%dLb(1)*AU_TO_AA, Param%Cell%dLb(2)*AU_TO_AA, Param%Cell%dLb(3)*AU_TO_AA 
  write(iunit,'(a,3f20.15)') 'delta ', &
       Param%Cell%dLc(1)*AU_TO_AA, Param%Cell%dLc(2)*AU_TO_AA, Param%Cell%dLc(3)*AU_TO_AA 
  write(iunit,'(a,3i5)') 'object 2 class gridconnections counts', &
       Param%Cell%Na, Param%Cell%Nb, Param%Cell%Nc
  write(iunit,'(a,i5,a)') 'object 3 class array type float category real rank 0 items', &
       Param%Cell%Na*Param%Cell%Nb*Param%Cell%Nc, ' data follows'

  do ia=1, Param%Cell%Na
     do ib=1, Param%Cell%Nb
        do ic=1, Param%Cell%Nc
           write(iunit,'(2e25.15)') v(:,ia,ib,ic)
        end do
     end do
  end do

  write(iunit,'(a)') 'object "density" class field'
  write(iunit,'(a)') 'component "positions" value 1'
  write(iunit,'(a)') 'component "connections" value 2'
  write(iunit,'(a)') 'component "data" value 3'

  close(iunit)

  return
end subroutine vector3d__save2DX

subroutine vector3d__save2Cube( v, fname )
  use ac_parameter

  implicit none
  real(8), intent(in)  :: v(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)

  character(len=*), intent(in) :: fname
  integer :: ia, ib, ic
  integer :: iunit

  iunit = 1
  open(iunit,file=fname)

  write(iunit,'(a)') 'ACCEL'
  write(iunit,'(a)') trim(fname)
  write(iunit,'(i5,3f20.15)') 0, &
       Param%Cell%Lo(1)*AU_TO_AA, Param%Cell%Lo(2)*AU_TO_AA, Param%Cell%Lo(3)*AU_TO_AA 

  write(iunit,'(i5,3f20.15)') Param%Cell%Na, &
       Param%Cell%dLa(1)*AU_TO_AA, Param%Cell%dLa(2)*AU_TO_AA, Param%Cell%dLa(3)*AU_TO_AA 

  write(iunit,'(i5,3f20.15)') Param%Cell%Nb, &
       Param%Cell%dLb(1)*AU_TO_AA, Param%Cell%dLb(2)*AU_TO_AA, Param%Cell%dLb(3)*AU_TO_AA 

  write(iunit,'(i5,3f20.15)') Param%Cell%Nc, &
       Param%Cell%dLc(1)*AU_TO_AA, Param%Cell%dLc(2)*AU_TO_AA, Param%Cell%dLc(3)*AU_TO_AA 

  do ia=1, Param%Cell%Na
     do ib=1, Param%Cell%Nb
        do ic=1, Param%Cell%Nc
           write(iunit,'(2e25.15)') v(:,ia,ib,ic)
        end do
     end do
  end do

  close(iunit)

  return
end subroutine vector3d__save2Cube

subroutine vector3d__save4DX( v, fname )
  use ac_parameter

  implicit none
  complex(8), intent(in)  :: v(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)

  character(len=*), intent(in) :: fname
  integer :: ia, ib, ic
  integer :: iunit

  iunit = 1
  open(iunit,file=fname)

  write(iunit,'(a,3i5)') 'object 1 class gridpositions counts ', &
       Param%Cell%Na, Param%Cell%Nb, Param%Cell%Nc
  write(iunit,'(a,3f20.15)') 'origin ', &
       Param%Cell%Lo(1)*AU_TO_AA, Param%Cell%Lo(2)*AU_TO_AA, Param%Cell%Lo(3)*AU_TO_AA 
  write(iunit,'(a,3f20.15)') 'delta ', &
       Param%Cell%dLa(1)*AU_TO_AA, Param%Cell%dLa(2)*AU_TO_AA, Param%Cell%dLa(3)*AU_TO_AA 
  write(iunit,'(a,3f20.15)') 'delta ', &
       Param%Cell%dLb(1)*AU_TO_AA, Param%Cell%dLb(2)*AU_TO_AA, Param%Cell%dLb(3)*AU_TO_AA 
  write(iunit,'(a,3f20.15)') 'delta ', &
       Param%Cell%dLc(1)*AU_TO_AA, Param%Cell%dLc(2)*AU_TO_AA, Param%Cell%dLc(3)*AU_TO_AA 
  write(iunit,'(a,3i5)') 'object 2 class gridconnections counts', &
       Param%Cell%Na, Param%Cell%Nb, Param%Cell%Nc
  write(iunit,'(a,i5,a)') 'object 3 class array type float category real rank 0 items', &
       Param%Cell%Na*Param%Cell%Nb*Param%Cell%Nc, ' data follows'

  do ia=1, Param%Cell%Na
     do ib=1, Param%Cell%Nb
        do ic=1, Param%Cell%Nc
           write(iunit,'(8e25.15)') v(:,ia,ib,ic)
        end do
     end do
  end do

  write(iunit,'(a)') 'object "density" class field'
  write(iunit,'(a)') 'component "positions" value 1'
  write(iunit,'(a)') 'component "connections" value 2'
  write(iunit,'(a)') 'component "data" value 3'

  close(iunit)

  return
end subroutine vector3d__save4DX

subroutine vector3d__save4Cube( v, fname )
  use ac_parameter

  implicit none
  complex(8), intent(in)  :: v(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)

  character(len=*), intent(in) :: fname
  integer :: ia, ib, ic
  integer :: iunit

  iunit = 1
  open(iunit,file=fname)

  write(iunit,'(a)') 'ACCEL'
  write(iunit,'(a)') trim(fname)
  write(iunit,'(i5,3f20.15)') 0, &
       Param%Cell%Lo(1)*AU_TO_AA, Param%Cell%Lo(2)*AU_TO_AA, Param%Cell%Lo(3)*AU_TO_AA 

  write(iunit,'(i5,3f20.15)') Param%Cell%Na, &
       Param%Cell%dLa(1)*AU_TO_AA, Param%Cell%dLa(2)*AU_TO_AA, Param%Cell%dLa(3)*AU_TO_AA 

  write(iunit,'(i5,3f20.15)') Param%Cell%Nb, &
       Param%Cell%dLb(1)*AU_TO_AA, Param%Cell%dLb(2)*AU_TO_AA, Param%Cell%dLb(3)*AU_TO_AA 

  write(iunit,'(i5,3f20.15)') Param%Cell%Nc, &
       Param%Cell%dLc(1)*AU_TO_AA, Param%Cell%dLc(2)*AU_TO_AA, Param%Cell%dLc(3)*AU_TO_AA 

  do ia=1, Param%Cell%Na
     do ib=1, Param%Cell%Nb
        do ic=1, Param%Cell%Nc
           write(iunit,'(8e25.15)') v(:,ia,ib,ic)
        end do
     end do
  end do

  close(iunit)

  return
end subroutine vector3d__save4Cube

subroutine vector3d__load1DX( v, fname )
  use ac_parameter

  implicit none
  real(8), intent(out) :: v(Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)

  character(len=*), intent(in) :: fname

  integer          :: nx, ny, nz
  integer          :: ia, ib, ic
  integer          :: iunit
  logical          :: ex
  character(128)   :: buf

  inquire( file=fname, exist = ex )
  if( .not. ex ) then
     write(*,'(a50,a20)') '# Error: vecter3d::loadDX : can not open file ', fname 
     stop
  end if
  iunit = 1
  open(iunit,file=fname)

  read(iunit,'(a)') buf

  if( buf(1:35) == 'object 1 class gridpositions counts' ) then
     read( buf(36:66),*) nx, ny, nz
  endif

  if( nx /= Param%Cell%Na .or. ny /= Param%Cell%Nb .or. nz /= Param%Cell%Nc ) then
     write(*,*) 'size mismatch in', fname
     close(iunit)
     stop
  end if

  do 
     read(iunit, '(a)', end=100) buf
     if( buf(1:20) == 'object 3 class array' ) exit
  end do
100 continue

  do ia=1, Param%Cell%Na
     do ib=1, Param%Cell%Nb
        do ic=1, Param%Cell%Nc
           read(iunit,'(a)') buf
           read(buf,*) v(ia,ib,ic)
        end do
     end do
  end do

  close(iunit)

  return
end subroutine vector3d__load1DX

subroutine vector3d__load1Cube( v, fname )
  use ac_parameter

  implicit none
  real(8), intent(out) :: v(Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)

  character(len=*), intent(in) :: fname

  integer          :: natom, n
  integer          :: nx, ny, nz
  integer          :: ia, ib, ic, i
  integer          :: iunit
  logical          :: ex
  character(128)   :: buf

  inquire( file=fname, exist = ex )
  if( .not. ex ) then
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,899) trim(fname)
899  format('      +++++++ Error vecter3d::loadCube : can not open file: ',a)
     close(16)
     stop
  end if

  iunit = 1
  open(iunit,file=fname)
  read(iunit,*) 
  read(iunit,*) 
  read(iunit,*) natom
  read(iunit,*) nx
  read(iunit,*) ny
  read(iunit,*) nz
  if( natom < 0 ) natom = -natom
  if( nx < 0 ) nx = -nx
  if( ny < 0 ) ny = -ny
  if( nz < 0 ) nz = -nz

  if( nx /= Param%Cell%Na .or. ny /= Param%Cell%Nb .or. nz /= Param%Cell%Nc ) then
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,888) trim(fname)
888  format('      +++++++ Error vecter3d::loadCube : size mismatch in: ',a)
     close(16)
     close(iunit)
     stop
  end if

  do i=1, natom
     read(iunit,*)
  end do

  do ia=1, Param%Cell%Na
     do ib=1, Param%Cell%Nb
        read(iunit,999) (v(ia,ib,ic),ic=1,Param%Cell%Nc)
     end do
  end do

  close(iunit)

999 format(6f17.10)

  return
end subroutine vector3d__load1Cube

subroutine vector3d__load2DX( v, fname )
  use ac_parameter

  implicit none
  real(8), intent(out) :: v(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)

  character(len=*), intent(in) :: fname

  integer          :: nx, ny, nz
  integer          :: ia, ib, ic
  integer          :: iunit
  logical          :: ex
  character(128)   :: buf

  inquire( file=fname, exist = ex )
  if( .not. ex ) then
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,999) trim(fname)
999  format('      +++++++ Error vecter3d::loadDX : can not open file: ',a)
     close(16)
     stop
  end if
  iunit = 1
  open(iunit,file=fname)

  read(iunit,'(a)') buf

  if( buf(1:35) == 'object 1 class gridpositions counts' ) then
     read( buf(36:66),*) nx, ny, nz
  endif

  if( nx /= Param%Cell%Na .or. ny /= Param%Cell%Nb .or. nz /= Param%Cell%Nc ) then
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,998) trim(fname)
998  format('      +++++++ Error vecter3d::loadDX : size mismatch in: ',a)
     close(16)
     close(iunit)
     stop
  end if

  do 
     read(iunit, '(a)', end=100) buf
     if( buf(1:20) == 'object 3 class array' ) exit
  end do
100 continue

  do ia=1, Param%Cell%Na
     do ib=1, Param%Cell%Nb
        do ic=1, Param%Cell%Nc
           read(iunit,'(a)') buf
           read(buf,*) v(:,ia,ib,ic)
        end do
     end do
  end do

  close(iunit)

  return
end subroutine vector3d__load2DX

subroutine vector3d__load2Cube( v, fname )
  use ac_parameter

  implicit none
  real(8), intent(out) :: v(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)

  character(len=*), intent(in) :: fname

  integer          :: natom, n
  integer          :: nx, ny, nz
  integer          :: ia, ib, ic
  integer          :: iunit
  logical          :: ex
  character(128)   :: buf

  inquire( file=fname, exist = ex )
  if( .not. ex ) then
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,899) trim(fname)
899  format('      +++++++ Error vecter3d::loadCube : can not open file: ',a)
     close(16)
     stop
  end if
  iunit = 1
  open(iunit,file=fname)

  read(iunit,'(a)') buf 
  read(iunit,'(a)') buf 

  read(iunit,'(a)') buf
  read(buf,*) natom
  if( natom < 0 ) natom = -natom

  read(iunit,'(a)') buf
  read(buf,*) nx
  if( nx < 0 ) nx = -nx

  read(iunit,'(a)') buf
  read(buf,*) ny
  if( ny < 0 ) ny = -ny

  read(iunit,'(a)') buf
  read(buf,*) nz
  if( nz < 0 ) nz = -nz

  if( nx /= Param%Cell%Na .or. ny /= Param%Cell%Nb .or. nz /= Param%Cell%Nc ) then
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,888) trim(fname)
888  format('      +++++++ Error vecter3d::loadCube : size mismatch in: ',a)
     close(16)
     close(iunit)
     stop
  end if

  do n=1, natom
     read(iunit,'(a)') buf 
  end do

  do ia=1, Param%Cell%Na
     do ib=1, Param%Cell%Nb
        do ic=1, Param%Cell%Nc
           read(iunit,'(a)') buf
           read(buf,*) v(:,ia,ib,ic)
        end do
     end do
  end do

  close(iunit)

  return
end subroutine vector3d__load2Cube

subroutine vector3d__load4DX( v, fname )
  use ac_parameter

  implicit none
  complex(8), intent(out) :: v(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)

  character(len=*), intent(in) :: fname

  integer          :: nx, ny, nz
  integer          :: ia, ib, ic
  integer          :: iunit
  logical          :: ex
  character(128)   :: buf

  inquire( file=fname, exist = ex )
  if( .not. ex ) then
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,999) trim(fname)
999  format('      +++++++ Error vecter3d::loadDX : can not open file: ',a)
     close(16)
     stop
  end if
  iunit = 1
  open(iunit,file=fname)

  read(iunit,'(a)') buf

  if( buf(1:35) == 'object 1 class gridpositions counts' ) then
     read( buf(36:66),*) nx, ny, nz
  endif

  if( nx /= Param%Cell%Na .or. ny /= Param%Cell%Nb .or. nz /= Param%Cell%Nc ) then
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,998) trim(fname)
998  format('      +++++++ Error vecter3d::loadDX : size mismatch in: ',a)
     close(16)
     close(iunit)
     stop
  end if

  do 
     read(iunit, '(a)', end=100) buf
     if( buf(1:20) == 'object 3 class array' ) exit
  end do
100 continue

  do ia=1, Param%Cell%Na
     do ib=1, Param%Cell%Nb
        do ic=1, Param%Cell%Nc
           read(iunit,'(a)') buf
           read(buf,*) v(:,ia,ib,ic)
        end do
     end do
  end do

  close(iunit)

  return
end subroutine vector3d__load4DX

subroutine vector3d__load4Cube( v, fname )
  use ac_parameter

  implicit none
  complex(8), intent(out) :: v(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)

  character(len=*), intent(in) :: fname

  integer          :: natom, n
  integer          :: nx, ny, nz
  integer          :: ia, ib, ic
  integer          :: iunit
  logical          :: ex
  character(128)   :: buf

  inquire( file=fname, exist = ex )
  if( .not. ex ) then
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,899) trim(fname)
899  format('      +++++++ Error vecter3d::loadCube : can not open file: ',a)
     close(16)
     stop
  end if
  iunit = 1
  open(iunit,file=fname)

  read(iunit,'(a)') buf 
  read(iunit,'(a)') buf 

  read(iunit,'(a)') buf
  read(buf,*) natom
  if( natom < 0 ) natom = -natom

  read(iunit,'(a)') buf
  read(buf,*) nx
  if( nx < 0 ) nx = -nx

  read(iunit,'(a)') buf
  read(buf,*) ny
  if( ny < 0 ) ny = -ny

  read(iunit,'(a)') buf
  read(buf,*) nz
  if( nz < 0 ) nz = -nz

  if( nx /= Param%Cell%Na .or. ny /= Param%Cell%Nb .or. nz /= Param%Cell%Nc ) then
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,888) trim(fname)
888  format('      +++++++ Error vecter3d::loadCube : size mismatch in: ',a)
     close(16)
     close(iunit)
     stop
  end if

  do n=1, natom
     read(iunit,'(a)') buf 
  end do

  do ia=1, Param%Cell%Na
     do ib=1, Param%Cell%Nb
        do ic=1, Param%Cell%Nc
           read(iunit,'(a)') buf
           read(buf,*) v(:,ia,ib,ic)
        end do
     end do
  end do

  close(iunit)

  return
end subroutine vector3d__load4Cube

subroutine vector3d__save_mo( v, fname )
  use ac_parameter

  implicit none
  real(8), intent(in)  :: v(Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)
  character(len=*), intent(in) :: fname

  call vector3d__saveCube_mo( v, fname )

  return
end subroutine vector3d__save_mo

subroutine vector3d__saveCube_mo( v, fname )
  use ac_parameter

  implicit none
  real(8), intent(in)  :: v(Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)
  character(len=*), intent(in) :: fname
  integer :: ia, ib, ic, i, ii, i4
  integer :: iunit

  iunit = 1
  open(iunit,file=fname)
  write(iunit,*) 'SYS1'
  write(iunit,*) 'SYS1'
  write(iunit,993) Param%Data%natom, Param%Cell%Lo(1), Param%Cell%Lo(2), Param%Cell%Lo(3)
  write(iunit,993) Param%Cell%Na, Param%Cell%dLa(1), Param%Cell%dLa(2), Param%Cell%dLa(3)
  write(iunit,993) Param%Cell%Nb, Param%Cell%dLb(1), Param%Cell%dLb(2), Param%Cell%dLb(3)
  write(iunit,993) Param%Cell%Nc, Param%Cell%dLc(1), Param%Cell%dLc(2), Param%Cell%dLc(3)
  do i=1, Param%Data%natom
     write(iunit,992) Param%Data%vatom(i)%number, Param%Data%vatom(i)%Q                  &
          , Param%Data%vatom(i)%Ro(1), Param%Data%vatom(i)%Ro(2), Param%Data%vatom(i)%Ro(3)
  end do
  do ia=1, Param%Cell%Na
     do ib=1, Param%Cell%Nb
        write(iunit,999) (v(ia,ib,ic),ic=1,Param%Cell%Nc)
     end do
  end do

  close(iunit)

999 format(6f13.6)
993 format(i4,3f13.6)
992 format(i4,4f13.6)

  return
end subroutine vector3d__saveCube_mo

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@             Naoki WATANABE (Mizuho I.R.)                       @@ !
! @@             Nobutaka NISHIKAWA (Mizuho I.R.)                   @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine set_hamiltonian_zper(descZZ,kx,ky,kz,ispin)
  use condition
  use hamiltonian_zper
  use ac_mpi_module
  implicit none

  type(MPI_MatDesc), intent(in) :: descZZ
  integer, intent(in) :: kx,ky,kz,ispin
  integer :: i1_do,i2_do


  h00_mat(:,:) = dcmplx(0.d0,0.d0) 
  s00_mat(:,:) = dcmplx(0.d0,0.d0) 

  if( ham_model == 'input' .or. ham_model == 'scf_accel' ) then
     if( lr_switch == -1 ) then
        call set_hamiltonian_zper_input_l(descZZ,kz,ispin)
     end if
     if( lr_switch == 1 ) then
        call set_hamiltonian_zper_input_r(descZZ,kz,ispin)
     end if
  else
     if( p_or_f == 'free' ) then
        call set_hamiltonian_zper_free(descZZ,kz)
     else
        if( p_or_f == 'periodic' ) then
           call set_hamiltonian_zper_periodic(descZZ,kx,ky,kz)
        else
           write(6,*) 'error: set_hamiltonian_zper'
           stop
        end if
     end if
  end if

  return
end subroutine set_hamiltonian_zper

subroutine alo_hamiltonian_zper(descZZ)
  use condition
  use hamiltonian_zper
  use ac_mpi_module
  implicit none

  type(MPI_MatDesc), intent(in) :: descZZ

  mat_max_zper=mat_max_eigen

  if( ham_model == 'input' .or. ham_model == 'scf_accel' ) then
     call alo_hamiltonian_zper_input(descZZ)
  else
     if( p_or_f == 'free' ) then
        call alo_hamiltonian_zper_free(descZZ,num_atom,num_unit)
     end if
     if( p_or_f == 'periodic' .or.  p_or_f == 'periodic-1d' ) then
        call alo_hamiltonian_zper_periodic(descZZ,num_atom)
     end if
  end if

  return
end subroutine alo_hamiltonian_zper

subroutine unset_hamiltonian_zper

  use condition
  use hamiltonian_zper

  if( ham_model == 'input' .or. ham_model == 'scf_accel' ) then
     call unset_hamiltonian_zper_input
  else
     if( p_or_f == 'free' ) then
        call unset_hamiltonian_zper_free
     end if
     if( p_or_f == 'periodic' .or.  p_or_f == 'periodic-1d' ) then
        call unset_hamiltonian_zper_periodic
     end if
  end if

  return
end subroutine unset_hamiltonian_zper

subroutine set_hamiltonian_zper_input_l(descZZ,qz,ispin)
  use condition
  use hamiltonian_zper
  use hamiltonian_temp
  use scf_negf
  use ac_mpi_module

  implicit none

  type(MPI_MatDesc), intent(in) :: descZZ
  integer, intent(in) :: qz,ispin

  integer :: kz,iz,i2_do,i3_do
  real(8) :: cs,sn,pai

  pai=datan(1.d0)*4.d0
  mat_max_zper=mat_max_eigen


  kz=qz
  iz=1
  cs=dcos(2.d0*pai*(dfloat((kz-1)*iz)/dfloat(kz_max)))
  sn=dsin(2.d0*pai*(dfloat((kz-1)*iz)/dfloat(kz_max)))

  h00_mat(:,:) = h00_mat(:,:) + h00_l_t(:,:,ispin) 
  h00_mat(:,:) = h00_mat(:,:) + h01_l_t(:,:,ispin)*dcmplx(cs,-sn) 
  h00_mat(:,:) = h00_mat(:,:) + h10_l_t(:,:,ispin)*dcmplx(cs,+sn) 

  s00_mat(:,:) = s00_mat(:,:) + s00_l_t(:,:) 
  s00_mat(:,:) = s00_mat(:,:) + s01_l_t(:,:)*dcmplx(cs,-sn) 
  s00_mat(:,:) = s00_mat(:,:) + s10_l_t(:,:)*dcmplx(cs,+sn) 

  return
end subroutine set_hamiltonian_zper_input_l

subroutine set_hamiltonian_zper_input_r(descZZ,qz,ispin)
  use condition
  use hamiltonian_zper
  use hamiltonian_temp
  use scf_negf
  use ac_mpi_module

  implicit none
  type(MPI_MatDesc), intent(in) :: descZZ
  integer, intent(in) :: qz,ispin

  integer :: kz,iz,i2_do,i3_do
  real(8) :: cs,sn,pai

  pai=datan(1.d0)*4.d0
  mat_max_zper=mat_max_eigen


  kz=qz
  iz=1
  cs=dcos(2.d0*pai*(dfloat((kz-1)*iz)/dfloat(kz_max)))
  sn=dsin(2.d0*pai*(dfloat((kz-1)*iz)/dfloat(kz_max)))

  h00_mat(:,:) = h00_mat(:,:) + h00_r_t(:,:,ispin) 
  h00_mat(:,:) = h00_mat(:,:) + h01_r_t(:,:,ispin)*dcmplx(cs,+sn) 
  h00_mat(:,:) = h00_mat(:,:) + h10_r_t(:,:,ispin)*dcmplx(cs,-sn) 

  s00_mat(:,:) = s00_mat(:,:) + s00_r_t(:,:) 
  s00_mat(:,:) = s00_mat(:,:) + s01_r_t(:,:)*dcmplx(cs,+sn) 
  s00_mat(:,:) = s00_mat(:,:) + s10_r_t(:,:)*dcmplx(cs,-sn) 

  return
end subroutine set_hamiltonian_zper_input_r

subroutine set_hamiltonian_zper_free(descZZ,qz)
  use condition
  use hamiltonian_zper
  use ac_mpi_module

  implicit none
  type(MPI_MatDesc), intent(in) :: descZZ
  integer, intent(in) :: qz

  integer :: max_atom_orbital
  integer :: kx,ky,kz,lx,ly,iz
  integer :: i1_do,i2_do,i3_do,i4_do,i1_count,i2_count,ier
  real(8) :: cs,sn,pai
  complex(8), allocatable :: h_ijmn(:,:),s_ijmn(:,:)
  integer :: i, j

  pai=datan(1.d0)*4.d0

  mat_max_zper=mat_max_eigen

  max_atom_orbital=0
  do i1_do=1,num_atom_kind
     if( max_atom_orbital < atom_orbital(i1_do) ) then
        max_atom_orbital=atom_orbital(i1_do)
     end if
  end do

  allocate(h_ijmn(max_atom_orbital,max_atom_orbital)                           &
       ,s_ijmn(max_atom_orbital,max_atom_orbital),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: set_hamiltonian_zper_free'
     stop
  end if


  i1_count=0
  do kx=1,num_unit(1)
     do ky=1,num_unit(2)
        do i1_do=1,num_atom
           itemp(kx,ky,i1_do)=i1_count
           i1_count=i1_count+atom_orbital(atom_kindn(i1_do))
        end do
     end do
  end do

  kz=qz
  do kx=0,num_unit(1)-1
     do ky=0,num_unit(2)-1
        do i1_do=1,num_atom
           i1_count=itemp(kx+1,ky+1,i1_do)
           do iz=-neighbor_z_max,neighbor_z_max
              do lx=0,num_unit(1)-1
                 do ly=0,num_unit(2)-1
                    do i2_do=1,num_atom
                       i2_count=itemp(lx+1,ly+1,i2_do)
                       if( i1_count == i2_count .and. iz == 0 ) then
                          if( ham_model .eq. 'gsp' ) then
                             call onsite_gsp_hamiltonian(max_atom_orbital,i1_do,i2_do,h_ijmn,s_ijmn)
                          else
                             if( ham_model .eq. 'rtb_h' ) then
                                call onsite_rtbh_hamiltonian(max_atom_orbital,i1_do,h_ijmn,s_ijmn)
                             else
                                write(6,*) 'error - ham_model: set_hamiltonian_zper 1'
                                stop
                             end if
                          end if
                          cs=1.d0
                          sn=0.d0
                       else
                          if( ham_model .eq. 'gsp' ) then
                             call off_gsp_hamiltonian(iz,kx,ky,lx,ly,i1_do,i2_do        &
                                  ,max_atom_orbital,h_ijmn,s_ijmn)
                          else
                             if( ham_model .eq. 'rtb_h' ) then
                                call off_rtbh_hamiltonian(iz,kx,ky,lx,ly,i1_do,i2_do     &
                                     ,max_atom_orbital,h_ijmn,s_ijmn)
                             else
                                write(6,*) 'error - ham_model: set_hamiltonian_zper 2'
                                stop
                             end if
                          end if
                          cs=dcos(2.d0*pai*(dfloat((kz-1)*iz)/dfloat(kz_max)))
                          sn=dsin(2.d0*pai*(dfloat((kz-1)*iz)/dfloat(kz_max)))
                       end if
                       do i4_do=1,atom_orbital(atom_kindn(i2_do))
                          do i3_do=1,atom_orbital(atom_kindn(i1_do))
                             i = i1_count+i3_do
                             j = i2_count+i4_do

                             if( i<descZZ%srow .or. descZZ%erow<i ) cycle
                             if( j<descZZ%scol .or. descZZ%ecol<j ) cycle
                             h00_mat(i,j) = h00_mat(i,j) + h_ijmn(i3_do,i4_do)*dcmplx(cs,sn) 
                             s00_mat(i,j) = s00_mat(i,j) + s_ijmn(i3_do,i4_do)*dcmplx(cs,sn) 
                          end do
                       end do
                    end do
                 end do
              end do
           end do
        end do
     end do
  end do


  deallocate(h_ijmn,s_ijmn,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error deallocate: set_hamiltonian_zper_free'
     stop
  end if

  return
end subroutine set_hamiltonian_zper_free

subroutine set_hamiltonian_zper_periodic(descZZ,qx,qy,qz)
  use condition
  use hamiltonian_zper
  use ac_mpi_module

  implicit none
  type(MPI_MatDesc), intent(in) :: descZZ
  integer, intent(in) :: qx,qy,qz
  integer :: max_atom_orbital
  integer :: kx,ky,kz,lx,ly,iz
  integer :: i1_do,i2_do,i3_do,i4_do,i1_count,i2_count,ier
  real(8) :: pai,cs,sn
  complex(8), allocatable :: h_ijmn(:,:),s_ijmn(:,:)
  integer :: i, j

  pai=datan(1.d0)*4.d0

  mat_max_zper=mat_max_eigen

  max_atom_orbital=0
  do i1_do=1,num_atom_kind
     if( max_atom_orbital < atom_orbital(i1_do) ) then
        max_atom_orbital=atom_orbital(i1_do)
     end if
  end do

  allocate(h_ijmn(max_atom_orbital,max_atom_orbital)                           &
       ,s_ijmn(max_atom_orbital,max_atom_orbital),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: set_hamiltonian_zper_periodic'
     stop
  end if


  i1_count=0
  do i1_do=1,num_atom
     jtemp(i1_do)=i1_count
     i1_count=i1_count+atom_orbital(atom_kindn(i1_do))
  end do

  kx=qx
  ky=qy
  kz=qz
  do i1_do=1,num_atom
     i1_count=jtemp(i1_do)
     do lx=-neighbor_x_max,neighbor_x_max
        do ly=-neighbor_y_max,neighbor_y_max
           do iz=-neighbor_z_max,neighbor_z_max
              do i2_do=1,num_atom
                 i2_count=jtemp(i2_do)
                 if( i1_do == i2_do .and. lx == 0 .and. ly == 0 .and. iz == 0 ) then
                    if( ham_model .eq. 'gsp' ) then
                       call onsite_gsp_hamiltonian(max_atom_orbital,i1_do             &
                            ,i2_do,h_ijmn,s_ijmn)
                    else
                       if( ham_model .eq. 'rtb_h' ) then
                          call onsite_rtbh_hamiltonian(max_atom_orbital,i1_do          &
                               ,h_ijmn,s_ijmn)
                       else
                          write(6,*)                                                   &
                               'error - ham_model: set_hamiltonian_zper_periodic 1'
                          stop
                       end if
                    end if
                    cs=1.d0
                    sn=0.d0
                 else
                    if( ham_model .eq. 'gsp' ) then
                       call off_gsp_hamiltonian(iz,lx,ly,0,0,i1_do,i2_do              &
                            ,max_atom_orbital,h_ijmn,s_ijmn)
                    else
                       if( ham_model .eq. 'rtb_h' ) then
                          call off_rtbh_hamiltonian(iz,lx,ly,0,0,i1_do,i2_do           &
                               ,max_atom_orbital,h_ijmn,s_ijmn)
                       else
                          write(6,*)                                                   &
                               'error - ham_model: set_hamiltonian_zper_periodic 2'
                          stop
                       end if
                    end if
                    cs=dcos(2.d0*pai*(dfloat((kx-1)*lx)/dfloat(kx_max)               &
                         +dfloat((ky-1)*ly)/dfloat(ky_max)               &
                         +dfloat((kz-1)*iz)/dfloat(kz_max)))
                    sn=dsin(2.d0*pai*(dfloat((kx-1)*lx)/dfloat(kx_max)               &
                         +dfloat((ky-1)*ly)/dfloat(ky_max)               &
                         +dfloat((kz-1)*iz)/dfloat(kz_max)))
                 end if
                 do i4_do=1,atom_orbital(atom_kindn(i2_do))
                    do i3_do=1,atom_orbital(atom_kindn(i1_do))
                       i = i1_count+i3_do
                       j = i2_count+i4_do
                       if( i<descZZ%srow .or. descZZ%erow<i ) cycle
                       if( j<descZZ%scol .or. descZZ%ecol<j ) cycle
                       h00_mat(i,j) = h00_mat(i,j) + h_ijmn(i3_do,i4_do)*dcmplx(cs,sn) 
                       s00_mat(i,j) = s00_mat(i,j) + s_ijmn(i3_do,i4_do)*dcmplx(cs,sn) 
                    end do
                 end do
              end do
           end do
        end do
     end do
  end do


  deallocate(h_ijmn,s_ijmn,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error deallocate: set_hamiltonian_zper_periodic'
     stop
  end if

  return
end subroutine set_hamiltonian_zper_periodic

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine output_print

  use condition_ini

  if( calc_type == 'trans' ) then
     call print_text
  else
     if( calc_type == 'iv' ) then
        call print_text
        call cal_iv
     else
        write(6,*) 'error: calc_type'
     end if
  end if

end subroutine output_print

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine read_rtbh_parameter

  use condition_ini
  use rtbh_parameter

  implicit none
  integer :: i_do

  open(unit=19,file=file_parameter_tb_par,status='old')

  read(19,*) num_atom_kind_ini
  call alo_input_condition_1
  do i_do=1,num_atom_kind_ini
     read(19,*) atom_sign_ini(i_do),atom_num_ini(i_do),atom_mass_ini(i_do)    &
          ,atom_electron_ini(i_do),atom_orbital_ini(i_do)
  end do

  call alo_rtbh_parameter(num_atom_kind_ini)

  do i_do=1,num_atom_kind_ini
     read(19,*) 
     read(19,*) atomh_parameter(i_do)
     read(19,*) h_s(i_do)
     read(19,*) h_p(i_do)
     read(19,*) h_d(i_do)
     read(19,*) v_ss(i_do)
     read(19,*) v_ps(i_do)
     read(19,*) v_pp(i_do)
     read(19,*) v_ds(i_do)
     read(19,*) v_dp(i_do)
     read(19,*) v_dd(i_do)
     read(19,*) u_ss(i_do)
     read(19,*) u_ps(i_do)
     read(19,*) u_pp(i_do)
     read(19,*) u_ds(i_do)
     read(19,*) u_dp(i_do)
     read(19,*) u_dd(i_do)
     read(19,*) r_ss(i_do)
     read(19,*) r_ps(i_do)
     read(19,*) r_pp(i_do)
     read(19,*) r_ds(i_do)
     read(19,*) r_dp(i_do)
     read(19,*) r_dd(i_do)
  end do
  read(19,*)
  read(19,*) r1
  read(19,*) r2
  read(19,*) a
  read(19,*) b
  close(19)

  return
end subroutine read_rtbh_parameter

subroutine read_gsp_parameter

  use condition_ini
  use gsp_parameter

  implicit none
  integer :: i_do

  open(unit=19,file=file_parameter_tb_par,status='old')

  read(19,*) num_atom_kind_ini
  call alo_input_condition_1
  do i_do=1,num_atom_kind_ini
     read(19,*) atom_sign_ini(i_do),atom_num_ini(i_do),atom_mass_ini(i_do)    &
          ,atom_electron_ini(i_do),atom_orbital_ini(i_do)
  end do

  call alo_gsp_parameter(num_atom_kind_ini)

  do i_do=1,num_atom_kind_ini*num_atom_kind_ini
     read(19,*) 
     read(19,*) atom_parameter(i_do,1),atom_parameter(i_do,2)
     read(19,*) cutoff_r(i_do)
     read(19,*) r0(i_do)
     read(19,*) n(i_do)
     read(19,*) e_0(i_do)
     read(19,*) hs(i_do)
     read(19,*) hp(i_do)
     read(19,*) hd_t2g(i_do)
     read(19,*) hd_eg(i_do)
     read(19,*)
     read(19,*) h_sss(i_do)
     read(19,*) h_sps(i_do)
     read(19,*) h_pps(i_do)
     read(19,*) h_ppp(i_do)
     read(19,*) h_sds(i_do)
     read(19,*) h_pds(i_do)
     read(19,*) h_pdp(i_do)
     read(19,*) h_dds(i_do)
     read(19,*) h_ddp(i_do)
     read(19,*) h_ddd(i_do)
     read(19,*)
     read(19,*) nc_sss(i_do)
     read(19,*) nc_sps(i_do)
     read(19,*) nc_pps(i_do)
     read(19,*) nc_ppp(i_do)
     read(19,*) nc_sds(i_do)
     read(19,*) nc_pds(i_do)
     read(19,*) nc_pdp(i_do)
     read(19,*) nc_dds(i_do)
     read(19,*) nc_ddp(i_do)
     read(19,*) nc_ddd(i_do)
     read(19,*)
     read(19,*) rc_sss(i_do)
     read(19,*) rc_sps(i_do)
     read(19,*) rc_pps(i_do)
     read(19,*) rc_ppp(i_do)
     read(19,*) rc_sds(i_do)
     read(19,*) rc_pds(i_do)
     read(19,*) rc_pdp(i_do)
     read(19,*) rc_dds(i_do)
     read(19,*) rc_ddp(i_do)
     read(19,*) rc_ddd(i_do)
     read(19,*)
     read(19,*) m(i_do)
     read(19,*) mc(i_do)
     read(19,*) dc(i_do)
     read(19,*) c1(i_do)
     read(19,*) c2(i_do)
     read(19,*) c3(i_do)
     read(19,*) c4(i_do)
     read(19,*)
     read(19,*) phi0(i_do)
     read(19,*) d0(i_do)
     read(19,*)
     read(19,*) r1(i_do)
     read(19,*) tsc0(i_do)
     read(19,*) tsc1(i_do)
     read(19,*) tsc2(i_do)
     read(19,*) tsc3(i_do)
     read(19,*)
     read(19,*) d1(i_do)
     read(19,*) tpc0(i_do)
     read(19,*) tpc1(i_do)
     read(19,*) tpc2(i_do)
     read(19,*) tpc3(i_do)
  end do
  close(19)

  return
end subroutine read_gsp_parameter

subroutine set_pair_ini(atom_parameter)

  use condition_ini

  implicit none
  character(4), intent(in) ::                                                    &
       atom_parameter(num_atom_kind_ini*num_atom_kind_ini,2)
  integer :: i1_do,i2_do,i3_do

  do i1_do=1,num_atom_l
     do i2_do=1,num_atom_l
        do i3_do=1,num_atom_kind_ini*num_atom_kind_ini
           if( atom_kind_l(i1_do) == atom_parameter(i3_do,1)                      &
                .and. atom_kind_l(i2_do) == atom_parameter(i3_do,2) ) then
              pair_num_l(i1_do,i2_do)=i3_do
              go to 10
           end if
        end do
        write(6,*) 'error - set_pair_ini (ll)'
        stop
10      continue
     end do
  end do

  do i1_do=1,num_atom_r
     do i2_do=1,num_atom_r
        do i3_do=1,num_atom_kind_ini*num_atom_kind_ini
           if( atom_kind_r(i1_do) == atom_parameter(i3_do,1)                      &
                .and. atom_kind_r(i2_do) == atom_parameter(i3_do,2) ) then
              pair_num_r(i1_do,i2_do)=i3_do
              go to 20
           end if
        end do
        write(6,*) 'error - set_pair_ini (rr)'
        stop
20      continue
     end do
  end do

  do i1_do=1,num_atom_c
     do i2_do=1,num_atom_l
        do i3_do=1,num_atom_kind_ini*num_atom_kind_ini
           if( atom_kind_c(i1_do) == atom_parameter(i3_do,1)                      &
                .and. atom_kind_l(i2_do) == atom_parameter(i3_do,2) ) then
              pair_num_cl(i1_do,i2_do)=i3_do
              go to 30
           end if
        end do
        write(6,*) 'error - set_pair_ini (ml)'
        stop
30      continue
     end do
  end do

  do i1_do=1,num_atom_c
     do i2_do=1,num_atom_c
        do i3_do=1,num_atom_kind_ini*num_atom_kind_ini
           if( atom_kind_c(i1_do) == atom_parameter(i3_do,1)                      &
                .and. atom_kind_c(i2_do) == atom_parameter(i3_do,2) ) then
              pair_num_cc(i1_do,i2_do)=i3_do
              go to 40
           end if
        end do
        write(6,*) 'error - set_pair_ini (mm)'
        stop
40      continue
     end do
  end do

  do i1_do=1,num_atom_c
     do i2_do=1,num_atom_r
        do i3_do=1,num_atom_kind_ini*num_atom_kind_ini
           if( atom_kind_c(i1_do) == atom_parameter(i3_do,1)                      &
                .and. atom_kind_r(i2_do) == atom_parameter(i3_do,2) ) then
              pair_num_cr(i1_do,i2_do)=i3_do
              go to 50
           end if
        end do
        write(6,*) 'error - set_pair_ini (mr)'
        stop
50      continue
     end do
  end do

  return
end subroutine set_pair_ini

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@             Naoki WATANABE (Mizuho I.R.)                       @@ !
! @@             Nobutaka NISHIKAWA (Mizuho I.R.)                   @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

module mod_mpi

  implicit none
  character(50) :: file_tempout
  character(50), pointer :: file_sf_scf(:,:,:,:) 
  character(50), pointer :: file_sf_tr(:,:) 

contains
  subroutine alo_mod_sftr(kt,file_selfenergy)
    use ac_mpi_module

    implicit none
    integer, intent(in) :: kt
    character(50), intent(in) :: file_selfenergy
    character(1) :: character_temp(4),character_temk(4),a(10)
    character(50) :: filename_temp
    character(60) :: filename_com
    integer :: i1,i2,k1,i_temp1,i_temp2,ier
    integer :: k, p

    if( file_selfenergy == 'none' ) then
       filename_temp='sel.data'
       filename_temp=adjustr(filename_temp)
    else
       filename_temp=adjustr(file_selfenergy)
    end if

    allocate(file_sf_tr(kt,0:MPI%size2-1),stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: lo_mod_sftr'
       stop
    end if


    do k=1, kt
       do p=0, MPI%size2-1
          write( filename_com,'("_k",i4.4,"_p",i4.4)') k, p

          file_sf_tr(k,p) = adjustl(trim(filename_temp)//filename_com)
       end do
    end do


    return
  end subroutine alo_mod_sftr

  subroutine dealo_mod_sftr

    implicit none
    integer :: ier

    deallocate(file_sf_tr,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: delo_mod_sftr'
       stop
    end if

    return
  end subroutine dealo_mod_sftr

  subroutine alo_tempout
    use ac_mpi_module
    implicit none
    character(1) :: character_temp(4),a(10)
    integer :: i2,i_temp1,i_temp2
    character(50) :: filename_temp
    character(60) :: filename_com

    integer :: p

    filename_temp = "g.output"
    p = MPI%rank2

    write( filename_com,'("_p",i4.4)') p

    file_tempout = adjustl(trim(filename_temp)//filename_com)


    return
  end subroutine alo_tempout

  subroutine alo_mod_mpi(iw,ispin,kt,file_selfenergy_scf)
    use ac_mpi_module

    implicit none
    integer, intent(in) :: iw,ispin,kt
    character(50), intent(in) :: file_selfenergy_scf
    character(1) :: character_temp(4),character_temk(4),a(10)
    character(50) :: filename_temp
    character(60) :: filename_com
    integer :: i1,i2,i3,k1,i_temp1,i_temp2,ier
    integer :: s, k, w, p

    if( file_selfenergy_scf == 'none' ) then
       filename_temp='sel.in'
       filename_temp=adjustr(filename_temp)
    else
       filename_temp=adjustr(file_selfenergy_scf)
    end if

    allocate(file_sf_scf(ispin,kt,iw,0:MPI%size2-1),stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_mod_mpi'
       stop
    end if

    do s=1,ispin
       do k=1, kt
          do w=1, iw
             do p=0, MPI%size2-1
                write( filename_com,'("_k",i4.4,"_s",i1.1,"_w",i4.4,"_p",i4.4)') &
                     k, s, w, p

                file_sf_scf(s,k,w,p) = adjustl(trim(filename_temp)//filename_com)

             end do
          end do
       end do
    end do


    return
  end subroutine alo_mod_mpi

  subroutine dealo_mod_mpi

    implicit none
    integer :: ier

    deallocate(file_sf_scf,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: dealo_mod_mpi'
       stop
    end if

    return
  end subroutine dealo_mod_mpi

end module mod_mpi

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Naoki WATANABE, Nobutaka NISHIKAWA (Mizuho I.R.)   @@ !
! @@             Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine Screening__setup
  use ac_misc_module

  implicit none
  integer        :: ia, ib, ic
  real(8) :: R(3)
  real(8)  :: dR
  integer        :: ika, ikb, ikc
  real(8) :: K(3)
  real(8)  :: kk
  real(8) :: pkl_t

  Screening%alpha = 5.d0/sqrt(dot_product(Param%Cell%La,Param%Cell%La))
  allocate( Screening%PhiK(2*(Param%Cell%Na/2+1),Param%Cell%Nb,Param%Cell%Nc) )

  do ic=1, Param%Cell%Nc
     do ib=1, Param%Cell%Nb
        do ia=1, Param%Cell%Na
           if( 2*ia-2 < Param%Cell%Na ) then
              R = Param%Cell%dLa*dble(ia-1)
           else
              R = Param%Cell%dLa*dble(ia-1-Param%Cell%Na)
           endif

           if( 2*ib-2 < Param%Cell%Nb ) then
              R = R + Param%Cell%dLb*dble(ib-1)
           else
              R = R + Param%Cell%dLb*dble(ib-1-Param%Cell%Nb)
           endif

           if( 2*ic-2 < Param%Cell%Nc ) then
              R = R + Param%Cell%dLc*dble(ic-1)
           else
              R = R + Param%Cell%dLc*dble(ic-1-Param%Cell%Nc)
           endif

           dR = sqrt(dot_product(R,R))

           call Screening__PhiRlong(Screening%PhiK(ia,ib,ic),dR)
        end do
     end do
  end do

  call FFT__forward( &
       Param%Cell%Na, Param%Cell%Nb, Param%Cell%Nc, &
       Screening%PhiK, Screening%PhiK )

  do ikc=1, Param%Cell%Nc
     do ikb=1, Param%Cell%Nb
        do ika=1, Param%Cell%Na/2+1
           call Param__Cell__K(K,ika,ikb,ikc)
           kk = dot_product(K,K)

           call Screening__PhiKlong(pkl_t,kk)
           Screening%PhiK(2*ika-1,ikb,ikc) = &
                Screening%PhiK(2*ika-1,ikb,ikc)*Param%Cell%dV - pkl_t

           Screening%PhiK(2*ika-0,ikb,ikc) = 0.d0
        end do
     end do
  end do

  return
end subroutine Screening__setup

subroutine Screening__deallocate
  use ac_misc_module

  implicit none

  if( associated(Screening%PhiK) ) deallocate( Screening%PhiK )

  return
end subroutine Screening__deallocate

subroutine Screening__PhiRlong(Phi,dR)
  use ac_misc_module

  implicit none
  real(8), intent(in) ::dR
  real(8), intent(out) :: Phi
  real(8) :: derf

  if( dabs(dR) < 1.d-14 ) then
     Phi = Screening%alpha*M_2_SQRTPI
  else
     Phi = derf(Screening%alpha*dR)/dR
  endif

  return
end subroutine Screening__PhiRlong

subroutine Screening__PhiKlong(Phi,kk)
  use ac_misc_module

  implicit none
  real(8), intent(in) :: kk
  real(8), intent(out) :: Phi

  if( dabs(kk) < 1.d-14 ) then
     Phi = - M_PI/(Screening%alpha*Screening%alpha)
  else
     Phi = 4*M_PI/kk * exp(-kk/(4*Screening%alpha*Screening%alpha))
  endif

  return
end subroutine Screening__PhiKlong

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine set_hami_c_cc(px,py,qx,qy)

  implicit none
  integer, intent(in) :: px,py,qx,qy

  !                                                ==================================
  !                                          set Hamiltonian Hcc, Hcl, Hcr
  !                                       set overlap matrix Scc, Scl, Scr
  !                                                  for tight-binding method
  !                                                ==================================

  call set_hami_c_cc_cc
  call set_hami_c_cc_lc(px,py)
  call set_hami_c_cc_rc(qx,qy)

  return
end subroutine set_hami_c_cc

subroutine set_hami_c_cc_cc

  use condition_ini
  use hamiltonian_sgf
  use locate_atom
  use hamiltonian_c

  implicit none
  integer :: max_atom_orbital
  complex(8), allocatable :: h_ijmn(:,:),s_ijmn(:,:)

  integer :: i1_do,ier
  integer :: i3_do,i4_do
  integer :: i1_count,i2_count,j1_count,j2_count
  real(8) :: r_per_temp(3)
  real(8) :: cs,sn,v

  max_atom_orbital=0
  do i1_do=1,num_atom_kind_ini
     if( max_atom_orbital < atom_orbital_ini(i1_do) ) then
        max_atom_orbital=atom_orbital_ini(i1_do)
     end if
  end do

  allocate(h_ijmn(max_atom_orbital,max_atom_orbital)                           &
       ,s_ijmn(max_atom_orbital,max_atom_orbital),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: set_hami_c_cc_cc'
     stop
  end if

  !                       ------------------------------------                       !


  do j1_count=1,num_atom_ctotal
     i1_count=itemp_c(j1_count)
     do j2_count=1,num_atom_ctotal
        i2_count=itemp_c(j2_count)
        if( i_lmr(j1_count) == 0 .and. i_lmr(j2_count) == 0 ) then
           r_per_temp=0.d0
           cs=1.d0
           sn=0.d0
           v=v_c
           if( j1_count /= j2_count ) then
              if( ham_model_ini .eq. 'gsp' ) then
                 call off_gsp_hami_cc(j1_count,j2_count,max_atom_orbital            &
                      ,h_ijmn,s_ijmn,r_per_temp)
              else
                 if( ham_model_ini .eq. 'rtb_h' ) then
                    call off_ham_hami_cc(j1_count,j2_count,max_atom_orbital          &
                         ,h_ijmn,s_ijmn,r_per_temp)
                 else
                    write(6,*) 'error - ham_model: set_hami_c_cc_cc 1'
                    stop
                 end if
              end if
           else
              if( ham_model_ini .eq. 'gsp' ) then
                 call onsite_gsp_hami_cc(j1_count,j2_count,max_atom_orbital         &
                      ,h_ijmn,s_ijmn,v)
              else
                 if( ham_model_ini .eq. 'rtb_h' ) then
                    call onsite_ham_hami_cc(j1_count,max_atom_orbital                &
                         ,h_ijmn,s_ijmn,v)
                 else
                    write(6,*) 'error - ham_model: set_hami_c_cc_cc 2'
                    stop
                 end if
              end if
           end if
           do i4_do=1,atom_orbital_ini(atom_kindn_ccal(j2_count))
              do i3_do=1,atom_orbital_ini(atom_kindn_ccal(j1_count))
                 hcc_mat(i1_count+i3_do,i2_count+i4_do)                             &
                      =hcc_mat(i1_count+i3_do,i2_count+i4_do)                          &
                      +h_ijmn(i3_do,i4_do)*dcmplx(cs,sn)
                 scc_mat(i1_count+i3_do,i2_count+i4_do)                             &
                      =scc_mat(i1_count+i3_do,i2_count+i4_do)                          &
                      +s_ijmn(i3_do,i4_do)*dcmplx(cs,sn)
              end do
           end do
        end if
     end do
  end do

  !                       ------------------------------------                       !

  deallocate(h_ijmn,s_ijmn,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error deallocate: set_hami_c_cc_cc'
     stop
  end if

  return
end subroutine set_hami_c_cc_cc

subroutine set_hami_c_cc_lc(px,py)

  use condition_ini
  use hamiltonian_sgf
  use locate_atom
  use hamiltonian_c

  implicit none
  integer, intent(in) :: px,py

  integer :: max_atom_orbital
  complex(8), allocatable :: h_ijmn(:,:),s_ijmn(:,:)

  integer :: kx,ky
  integer :: i1_do,ier
  integer :: i3_do,i4_do
  integer :: i1_count,i2_count,j1_count,j2_count
  integer :: num_unit_temp11,num_unit_temp12,num_unit_temp21,num_unit_temp22
  integer :: jr_do
  real(8) :: r_per_temp(3)
  real(8) :: cs,sn,v
  real(8) :: pai

  max_atom_orbital=0
  do i1_do=1,num_atom_kind_ini
     if( max_atom_orbital < atom_orbital_ini(i1_do) ) then
        max_atom_orbital=atom_orbital_ini(i1_do)
     end if
  end do

  allocate(h_ijmn(max_atom_orbital,max_atom_orbital)                           &
       ,s_ijmn(max_atom_orbital,max_atom_orbital),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: set_hami_c_cc_lc'
     stop
  end if

  !                       ------------------------------------                       !

  pai=datan(1.d0)*4.d0

  !                       ------------------------------------                       !

  do j1_count=1,num_atom_ctotal
     i1_count=itemp_c(j1_count)
     if( i_lmr(j1_count) == -1 ) then
        do j2_count=1,num_atom_ctotal
           i2_count=itemp_c(j2_count)
           if( iabs(i_lmr(j1_count)-i_lmr(j2_count)) == 2 ) then
              cycle
           else
              if( i_lmr(j2_count) == -1 ) then
                 if( p_or_f_l == 'free' ) then
                    num_unit_temp11=0
                    num_unit_temp12=0
                    num_unit_temp21=0
                    num_unit_temp22=0
                 else
                    if( p_or_f_l == 'periodic' ) then
                       num_unit_temp11=-neighbor_x_max_l
                       num_unit_temp12=-neighbor_y_max_l
                       num_unit_temp21=neighbor_x_max_l
                       num_unit_temp22=neighbor_y_max_l
                    else
                       write(6,*) 'error_locate: set_hami_c_cc_lc'
                       stop
                    end if
                 end if
                 do kx=num_unit_temp11,num_unit_temp21
                    do ky=num_unit_temp12,num_unit_temp22
                       if( j1_count == j2_count .and. kx == 0 .and. ky == 0  ) then
                          cs=1.d0
                          sn=0.d0
                          v=v_l
                          if( ham_model_ini .eq. 'gsp' ) then
                             call onsite_gsp_hami_cc(j1_count,j2_count                  &
                                  ,max_atom_orbital,h_ijmn,s_ijmn,v)
                          else
                             if( ham_model_ini .eq. 'rtb_h' ) then
                                call onsite_ham_hami_cc(j1_count                         &
                                     ,max_atom_orbital,h_ijmn,s_ijmn,v)
                             else
                                write(6,*) 'error - ham_model: set_hami_c_cc_lc 2'
                                stop
                             end if
                          end if
                       else
                          if( p_or_f_l == 'free' ) then
                             r_per_temp=0.d0
                             cs=1.d0
                             sn=0.d0
                          else
                             if( p_or_f_l == 'periodic' ) then
                                do jr_do=1,3
                                   r_per_temp(jr_do)=dfloat(kx)*unit_block_l(1,jr_do)     &
                                        +dfloat(ky)*unit_block_l(2,jr_do)
                                end do
                                cs=dcos(2.d0*pai*(dfloat((px-1)*kx)/dfloat(kx_max_l)     &
                                     +dfloat((py-1)*ky)/dfloat(ky_max_l)))
                                sn=dsin(2.d0*pai*(dfloat((px-1)*kx)/dfloat(kx_max_l)     &
                                     +dfloat((py-1)*ky)/dfloat(ky_max_l)))
                             end if
                          end if
                          if( ham_model_ini .eq. 'gsp' ) then
                             call off_gsp_hami_cc(j1_count,j2_count                     &
                                  ,max_atom_orbital,h_ijmn,s_ijmn,r_per_temp)
                          else
                             if( ham_model_ini .eq. 'rtb_h' ) then
                                call off_ham_hami_cc(j1_count,j2_count                   &
                                     ,max_atom_orbital,h_ijmn,s_ijmn,r_per_temp)
                             else
                                write(6,*) 'error - ham_model: set_hami_c_cc_lc 3'
                                stop
                             end if
                          end if
                       end if
                       do i4_do=1,atom_orbital_ini(atom_kindn_ccal(j2_count))
                          do i3_do=1,atom_orbital_ini(atom_kindn_ccal(j1_count))
                             hcc_mat(i1_count+i3_do,i2_count+i4_do)                     &
                                  =hcc_mat(i1_count+i3_do,i2_count+i4_do)                  &
                                  +h_ijmn(i3_do,i4_do)*dcmplx(cs,sn)
                             scc_mat(i1_count+i3_do,i2_count+i4_do)                     &
                                  =scc_mat(i1_count+i3_do,i2_count+i4_do)                  &
                                  +s_ijmn(i3_do,i4_do)*dcmplx(cs,sn)
                          end do
                       end do
                    end do
                 end do
              else
                 if( p_or_f_l == 'free' ) then
                    r_per_temp=0.d0
                    cs=1.d0
                    sn=0.d0
                 else
                    if( p_or_f_l == 'periodic' ) then
                       do jr_do=1,3
                          r_per_temp(jr_do)=dfloat(kx)*unit_block_l(1,jr_do)           &
                               +dfloat(ky)*unit_block_l(2,jr_do)
                       end do
                       cs=dcos(2.d0*pai*(dfloat((px-1)*kx)/dfloat(kx_max_l)           &
                            +dfloat((py-1)*ky)/dfloat(ky_max_l)))
                       sn=dsin(2.d0*pai*(dfloat((px-1)*kx)/dfloat(kx_max_l)           &
                            +dfloat((py-1)*ky)/dfloat(ky_max_l)))
                    end if
                 end if
                 if( ham_model_ini .eq. 'gsp' ) then
                    call off_gsp_hami_cc(j1_count,j2_count,max_atom_orbital          &
                         ,h_ijmn,s_ijmn,r_per_temp)
                 else
                    if( ham_model_ini .eq. 'rtb_h' ) then
                       call off_ham_hami_cc(j1_count,j2_count,max_atom_orbital        &
                            ,h_ijmn,s_ijmn,r_per_temp)
                    else
                       write(6,*) 'error - ham_model: set_hami_c_cc_lc 4'
                       stop
                    end if
                 end if
                 do i4_do=1,atom_orbital_ini(atom_kindn_ccal(j2_count))
                    do i3_do=1,atom_orbital_ini(atom_kindn_ccal(j1_count))
                       hcc_mat(i1_count+i3_do,i2_count+i4_do)                         &
                            =hcc_mat(i1_count+i3_do,i2_count+i4_do)                      &
                            +h_ijmn(i3_do,i4_do)*dcmplx(cs,sn)
                       scc_mat(i1_count+i3_do,i2_count+i4_do)                         &
                            =scc_mat(i1_count+i3_do,i2_count+i4_do)                      &
                            +s_ijmn(i3_do,i4_do)*dcmplx(cs,sn)
                       hcc_mat(i2_count+i4_do,i1_count+i3_do)                         &
                            =hcc_mat(i2_count+i4_do,i1_count+i3_do)                      &
                            +dconjg(h_ijmn(i3_do,i4_do)*dcmplx(cs,sn))
                       scc_mat(i2_count+i4_do,i1_count+i3_do)                         &
                            =scc_mat(i2_count+i4_do,i1_count+i3_do)                      &
                            +dconjg(s_ijmn(i3_do,i4_do)*dcmplx(cs,sn))
                    end do
                 end do
              end if
           end if
        end do
     end if
  end do

  !                       ------------------------------------                       !

  deallocate(h_ijmn,s_ijmn,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error deallocate: set_hami_c_cc_lc'
     stop
  end if

  return
end subroutine set_hami_c_cc_lc

subroutine set_hami_c_cc_rc(px,py)

  use condition_ini
  use hamiltonian_sgf
  use locate_atom
  use hamiltonian_c

  implicit none
  integer, intent(in) :: px,py

  integer :: max_atom_orbital
  complex(8), allocatable :: h_ijmn(:,:),s_ijmn(:,:)

  integer :: kx,ky
  integer :: i1_do,ier
  integer :: i3_do,i4_do
  integer :: i1_count,i2_count,j1_count,j2_count
  integer :: num_unit_temp11,num_unit_temp12,num_unit_temp21,num_unit_temp22
  integer :: jr_do
  real(8) :: r_per_temp(3)
  real(8) :: cs,sn,v
  real(8) :: pai

  max_atom_orbital=0
  do i1_do=1,num_atom_kind_ini
     if( max_atom_orbital < atom_orbital_ini(i1_do) ) then
        max_atom_orbital=atom_orbital_ini(i1_do)
     end if
  end do

  allocate(h_ijmn(max_atom_orbital,max_atom_orbital)                           &
       ,s_ijmn(max_atom_orbital,max_atom_orbital),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: set_hami_c_cc_rc'
     stop
  end if

  !                       ------------------------------------                       !

  pai=datan(1.d0)*4.d0

  !                       ------------------------------------                       !

  do j1_count=1,num_atom_ctotal
     i1_count=itemp_c(j1_count)
     if( i_lmr(j1_count) == 1 ) then
        do j2_count=1,num_atom_ctotal
           i2_count=itemp_c(j2_count)
           if( iabs(i_lmr(j1_count)-i_lmr(j2_count)) == 2 ) then
              cycle
           else
              if( i_lmr(j2_count) == 1 ) then
                 if( p_or_f_r == 'free' ) then
                    num_unit_temp11=0
                    num_unit_temp12=0
                    num_unit_temp21=0
                    num_unit_temp22=0
                 else
                    if( p_or_f_r == 'periodic' ) then
                       num_unit_temp11=-neighbor_x_max_r
                       num_unit_temp12=-neighbor_y_max_r
                       num_unit_temp21=neighbor_x_max_r
                       num_unit_temp22=neighbor_y_max_r
                    else
                       write(6,*) 'error_locate: set_hami_c_cc_rc'
                       stop
                    end if
                 end if
                 do kx=num_unit_temp11,num_unit_temp21
                    do ky=num_unit_temp12,num_unit_temp22
                       if( j1_count == j2_count .and. kx == 0 .and. ky == 0 ) then
                          cs=1.d0
                          sn=0.d0
                          v=v_r
                          if( ham_model_ini .eq. 'gsp' ) then
                             call onsite_gsp_hami_cc(j1_count,j2_count                  &
                                  ,max_atom_orbital,h_ijmn,s_ijmn,v)
                          else
                             if( ham_model_ini .eq. 'rtb_h' ) then
                                call onsite_ham_hami_cc(j1_count                         &
                                     ,max_atom_orbital,h_ijmn,s_ijmn,v)
                             else
                                write(6,*) 'error - ham_model: set_hami_c_cc_rc 1'
                                stop
                             end if
                          end if
                       else
                          if( p_or_f_r == 'free' ) then
                             r_per_temp=0.d0
                             cs=1.d0
                             sn=0.d0
                          else
                             if( p_or_f_r == 'periodic' ) then
                                do jr_do=1,3
                                   r_per_temp(jr_do)=dfloat(kx)*unit_block_r(1,jr_do)     &
                                        +dfloat(ky)*unit_block_r(2,jr_do)
                                end do
                                cs=dcos(2.d0*pai*(dfloat((px-1)*kx)/dfloat(kx_max_r)     &
                                     +dfloat((py-1)*ky)/dfloat(ky_max_r)))
                                sn=dsin(2.d0*pai*(dfloat((px-1)*kx)/dfloat(kx_max_r)     &
                                     +dfloat((py-1)*ky)/dfloat(ky_max_r)))
                             end if
                          end if
                          if( ham_model_ini .eq. 'gsp' ) then
                             call off_gsp_hami_cc(j1_count,j2_count                     &
                                  ,max_atom_orbital,h_ijmn,s_ijmn,r_per_temp)
                          else
                             if( ham_model_ini .eq. 'rtb_h' ) then
                                call off_ham_hami_cc(j1_count,j2_count                   &
                                     ,max_atom_orbital,h_ijmn,s_ijmn,r_per_temp)
                             else
                                write(6,*) 'error - ham_model: set_hami_c_cc_rc 2'
                                stop
                             end if
                          end if
                       end if
                       do i4_do=1,atom_orbital_ini(atom_kindn_ccal(j2_count))
                          do i3_do=1,atom_orbital_ini(atom_kindn_ccal(j1_count))
                             hcc_mat(i1_count+i3_do,i2_count+i4_do)                     &
                                  =hcc_mat(i1_count+i3_do,i2_count+i4_do)                  &
                                  +h_ijmn(i3_do,i4_do)*dcmplx(cs,sn)
                             scc_mat(i1_count+i3_do,i2_count+i4_do)                     &
                                  =scc_mat(i1_count+i3_do,i2_count+i4_do)                  &
                                  +s_ijmn(i3_do,i4_do)*dcmplx(cs,sn)
                          end do
                       end do
                    end do
                 end do
              else
                 if( p_or_f_r == 'free' ) then
                    r_per_temp=0.d0
                    cs=1.d0
                    sn=0.d0
                 else
                    if( p_or_f_r == 'periodic' ) then
                       do jr_do=1,3
                          r_per_temp(jr_do)=dfloat(kx)*unit_block_r(1,jr_do)           &
                               +dfloat(ky)*unit_block_r(2,jr_do)
                       end do
                       cs=dcos(2.d0*pai*(dfloat((px-1)*kx)/dfloat(kx_max_r)           &
                            +dfloat((py-1)*ky)/dfloat(ky_max_r)))
                       sn=dsin(2.d0*pai*(dfloat((px-1)*kx)/dfloat(kx_max_r)           &
                            +dfloat((py-1)*ky)/dfloat(ky_max_r)))
                    end if
                 end if
                 r_per_temp=0.d0
                 if( ham_model_ini .eq. 'gsp' ) then
                    call off_gsp_hami_cc(j1_count,j2_count,max_atom_orbital          &
                         ,h_ijmn,s_ijmn,r_per_temp)
                 else
                    if( ham_model_ini .eq. 'rtb_h' ) then
                       call off_ham_hami_cc(j1_count,j2_count,max_atom_orbital        &
                            ,h_ijmn,s_ijmn,r_per_temp)
                    else
                       write(6,*) 'error - ham_model: set_hami_c_cc_rc 3'
                       stop
                    end if
                 end if
                 do i4_do=1,atom_orbital_ini(atom_kindn_ccal(j2_count))
                    do i3_do=1,atom_orbital_ini(atom_kindn_ccal(j1_count))
                       hcc_mat(i1_count+i3_do,i2_count+i4_do)                         &
                            =hcc_mat(i1_count+i3_do,i2_count+i4_do)                      &
                            +h_ijmn(i3_do,i4_do)*dcmplx(cs,sn)
                       scc_mat(i1_count+i3_do,i2_count+i4_do)                         &
                            =scc_mat(i1_count+i3_do,i2_count+i4_do)                      &
                            +s_ijmn(i3_do,i4_do)*dcmplx(cs,sn)
                       hcc_mat(i2_count+i4_do,i1_count+i3_do)                         &
                            =hcc_mat(i2_count+i4_do,i1_count+i3_do)                      &
                            +dconjg(h_ijmn(i3_do,i4_do)*dcmplx(cs,sn))
                       scc_mat(i2_count+i4_do,i1_count+i3_do)                         &
                            =scc_mat(i2_count+i4_do,i1_count+i3_do)                      &
                            +dconjg(s_ijmn(i3_do,i4_do)*dcmplx(cs,sn))
                    end do
                 end do
              end if
           end if
        end do
     end if
  end do

  !                       ------------------------------------                       !

  deallocate(h_ijmn,s_ijmn,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error deallocate: set_hami_c_cc_rc'
     stop
  end if

  return
end subroutine set_hami_c_cc_rc

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine green_function_scf(w,w_weight,iw_do,px,py,qx,qy,ispin)

  use scf_negf
  use hamiltonian_sgf
  use hamiltonian_c
  use gf_se_c
  use constant
  use condition_ini

  implicit none
  integer, intent(in) :: iw_do,ispin
  integer, intent(in) :: px,py,qx,qy
  complex(8), intent(in) :: w,w_weight

  integer :: i1_do,i2_do,ier
  complex(8), allocatable :: amat_temp6(:,:),bmat_temp6(:,:),cmat_temp6(:,:)

  call alo_hami_c3
  call set_hami_c_cc_scf(ispin)

  allocate(amat_temp6(m_mat_max_c,m_mat_max_c),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: green_function_scf 1'
     stop
  end if

  do i2_do=1,m_mat_max_c
     do i1_do=1,m_mat_max_c
        amat_temp6(i1_do,i2_do)                                                  &
             =(w*scc_mat(i1_do,i2_do)-hcc_mat(i1_do,i2_do))
     end do
  end do
  call unset_hami_c31
  call unset_hami_c32

  do i2_do=1,m_mat_max_c
     do i1_do=1,m_mat_max_c
        amat_temp6(i1_do,i2_do)                                                  &
             =amat_temp6(i1_do,i2_do)                                           &
             -se_l_mat_per(i1_do,i2_do,px,py)-se_r_mat_per(i1_do,i2_do,qx,qy)
     end do
  end do

  allocate(bmat_temp6(m_mat_max_c,m_mat_max_c),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: green_function_scf 3'
     stop
  end if

  call inverse_mat1(m_mat_max_c,amat_temp6,bmat_temp6)

  !                       ------------------------------------                       !

  if( i_bios_omega_scf(iw_do) == 1 ) then

     do i2_do=1,m_mat_max_c
        do i1_do=1,m_mat_max_c
           dens(ispin,i1_do,i2_do)=dens(ispin,i1_do,i2_do)                        &
                +dreal(bmat_temp6(i1_do,i2_do)*w_weight)        &
                +dreal(dconjg(bmat_temp6(i2_do,i1_do)*w_weight))
           dens2(ispin,i1_do,i2_do)=dens2(ispin,i1_do,i2_do)                      &
                +dimag(bmat_temp6(i1_do,i2_do)*w_weight)       &
                +dimag(dconjg(bmat_temp6(i2_do,i1_do)*w_weight))
        end do
     end do

  else

     allocate(cmat_temp6(m_mat_max_c,m_mat_max_c),stat=ier)
     if( ier /= 0 ) then
        write(6,*) 'error allocate: green_function_scf 2'
        stop
     end if

     if( dreal(w) <= cp_l ) then
        do i2_do=1,m_mat_max_c
           do i1_do=1,m_mat_max_c
              cmat_temp6(i1_do,i2_do)                                              &
                   =-(se_l_mat_per(i1_do,i2_do,px,py)                              &
                   -dconjg(se_l_mat_per(i2_do,i1_do,px,py)))
           end do
        end do
     else
        do i2_do=1,m_mat_max_c
           do i1_do=1,m_mat_max_c
              cmat_temp6(i1_do,i2_do)=dcmplx(0.d0,0.d0)
           end do
        end do
     end if
     if( dreal(w) <= cp_r ) then
        do i2_do=1,m_mat_max_c
           do i1_do=1,m_mat_max_c
              cmat_temp6(i1_do,i2_do)                                              &
                   =cmat_temp6(i1_do,i2_do)                                        &
                   -(se_r_mat_per(i1_do,i2_do,qx,qy)                               &
                   -dconjg(se_r_mat_per(i2_do,i1_do,qx,qy)))
           end do
        end do
     end if

     call mat_mul(m_mat_max_c,bmat_temp6,cmat_temp6,amat_temp6)

     do i2_do=1,m_mat_max_c
        do i1_do=1,m_mat_max_c
           cmat_temp6(i1_do,i2_do)=dconjg(bmat_temp6(i2_do,i1_do))
        end do
     end do

     call mat_mul(m_mat_max_c,amat_temp6,cmat_temp6,bmat_temp6)

     deallocate(cmat_temp6,stat=ier)
     if( ier /= 0 ) then
        write(6,*) 'error deallocate: green_function_scf 2'
        stop
     end if

     do i2_do=1,m_mat_max_c
        do i1_do=1,m_mat_max_c
           dens(ispin,i1_do,i2_do)=dens(ispin,i1_do,i2_do)                        &
                +dreal(bmat_temp6(i1_do,i2_do)*w_weight)
           dens2(ispin,i1_do,i2_do)=dens2(ispin,i1_do,i2_do)                      &
                +dimag(bmat_temp6(i1_do,i2_do)*w_weight)
        end do
     end do

  end if

  !                       ------------------------------------                       !

  deallocate(amat_temp6,bmat_temp6,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error deallocate: green_function_scf 3'
     stop
  end if

  return
end subroutine green_function_scf

subroutine calc_edm(ispin)

  use scf_negf
  use hamiltonian_sgf
  use hamiltonian_c
  use gf_se_c
  use constant
  use condition_ini

  implicit none
  integer, intent(in) :: ispin

  integer :: i1_do,i2_do,ier
  complex(8), allocatable :: amat_temp6(:,:),bmat_temp6(:,:)
  complex(8), allocatable :: cmat_temp6(:,:),dmat_temp6(:,:)

  call alo_hami_c3
  call set_hami_c_cc_scf(ispin)

  allocate(amat_temp6(m_mat_max_c,m_mat_max_c)                                 &
       ,bmat_temp6(m_mat_max_c,m_mat_max_c)                                 &
       ,cmat_temp6(m_mat_max_c,m_mat_max_c)                                 &
       ,dmat_temp6(m_mat_max_c,m_mat_max_c),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: green_function_scf 1'
     stop
  end if

  do i2_do=1,m_mat_max_c
     do i1_do=1,m_mat_max_c
        amat_temp6(i1_do,i2_do)=scc_mat(i1_do,i2_do)
     end do
  end do
  call inverse_mat1(m_mat_max_c,amat_temp6,bmat_temp6)

  do i2_do=1,m_mat_max_c
     do i1_do=1,m_mat_max_c
        amat_temp6(i1_do,i2_do)=hcc_mat(i1_do,i2_do)
     end do
  end do

  call unset_hami_c31
  call unset_hami_c32

  call mat_mul(m_mat_max_c,bmat_temp6,amat_temp6,cmat_temp6)
  call mat_mul(m_mat_max_c,amat_temp6,bmat_temp6,dmat_temp6)

  do i2_do=1,m_mat_max_c
     do i1_do=1,m_mat_max_c
        amat_temp6(i1_do,i2_do)                                                  &
             =dcmplx(dens(ispin,i1_do,i2_do),dens2(ispin,i1_do,i2_do))*.5d0
     end do
  end do

  call mat_mul(m_mat_max_c,cmat_temp6,amat_temp6,bmat_temp6)
  do i2_do=1,m_mat_max_c
     do i1_do=1,m_mat_max_c
        edens(ispin,i1_do,i2_do)=edens(ispin,i1_do,i2_do)                        &
             +dreal(bmat_temp6(i1_do,i2_do))
        edens2(ispin,i1_do,i2_do)=edens2(ispin,i1_do,i2_do)                      &
             +dimag(bmat_temp6(i1_do,i2_do))
     end do
  end do

  call mat_mul(m_mat_max_c,amat_temp6,dmat_temp6,bmat_temp6)
  do i2_do=1,m_mat_max_c
     do i1_do=1,m_mat_max_c
        edens(ispin,i1_do,i2_do)=edens(ispin,i1_do,i2_do)                        &
             +dreal(bmat_temp6(i1_do,i2_do))
        edens2(ispin,i1_do,i2_do)=edens2(ispin,i1_do,i2_do)                      &
             +dimag(bmat_temp6(i1_do,i2_do))
     end do
  end do

  !                       ------------------------------------                       !

  deallocate(amat_temp6,bmat_temp6,cmat_temp6,dmat_temp6,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error deallocate: green_function_scf 3'
     stop
  end if

  return
end subroutine calc_edm

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Naoki WATANABE, Nobutaka NISHIKAWA (Mizuho I.R.)   @@ !
! @@             Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine AtomMatrix__allocate( amat, sizej, sizei )
  use ac_misc_module
  implicit none
  type(AtomMatrix_type), target :: amat
  integer, intent(in) :: sizei, sizej
  integer :: i, j, n

  allocate( amat%S (sizej, sizei ) )
  amat%S  = 0.d0

  if( Param%Option%spin_orbit ) then
     allocate( amat%H0LS(sizej, sizei, Param%Option%nspin ) )
     allocate( amat%HLS (sizej, sizei, Param%Option%nspin ) )
     amat%H0LS = 0.d0
     amat%HLS  = 0.d0

     allocate( amat%CDMLS(sizej, sizei, Param%Option%nspin ) )
     amat%CDMLS = 0.d0

     if( Param%Option%optimize ) then
        allocate( amat%EDMLS(sizej, sizei ) )
        amat%EDMLS = 0.d0
     else
        nullify(amat%EDMLS)
     end if

     if( Param%SCF%mix_target == 'density_matrix' ) then
        allocate( amat%vpast(Param%SCF%mix_history) )
        do n=1, Param%SCF%mix_history
           allocate( amat%vpast(n)%CDMLS (sizej, sizei, Param%Option%nspin ) )
           allocate( amat%vpast(n)%dCDMLS(sizej, sizei, Param%Option%nspin ) )
        end do
     end if

  else
     allocate( amat%H0(sizej, sizei, Param%Option%nspin ) )
     allocate( amat%H (sizej, sizei, Param%Option%nspin ) )
     amat%H0 = 0.d0
     amat%H  = 0.d0

     allocate( amat%CDM(sizej, sizei, Param%Option%nspin ) )
     amat%CDM = 0.d0

     if( Param%Option%optimize ) then
        allocate( amat%EDM(sizej, sizei ) )
        amat%EDM = 0.d0
     else
        nullify(amat%EDM)
     end if

     if( Param%SCF%mix_target == 'density_matrix' ) then
        allocate( amat%vpast(Param%SCF%mix_history) )
        do n=1, Param%SCF%mix_history
           allocate( amat%vpast(n)%CDM (sizej, sizei, Param%Option%nspin ) )
           allocate( amat%vpast(n)%dCDM(sizej, sizei, Param%Option%nspin ) )
        end do
     end if
  end if

  return
end subroutine AtomMatrix__allocate

subroutine AtomMatrix__deallocate( amat )
  use ac_misc_module
  implicit none
  type(AtomMatrix_type), target :: amat
  integer :: n

  if( associated(amat%S ) ) deallocate(amat%S )

  if( Param%Option%spin_orbit ) then
     if( associated(amat%H0LS) ) deallocate(amat%H0LS)
     if( associated(amat%HLS ) ) deallocate(amat%HLS )
     if( associated(amat%CDMLS) ) deallocate(amat%CDMLS)

     if( Param%Option%optimize ) then
        if( associated(amat%EDMLS) ) deallocate(amat%EDMLS)
     end if

     if( Param%SCF%mix_target == 'density_matrix' ) then
        do n=1, Param%SCF%mix_history
           if( associated(amat%vpast(n)%CDMLS) )  deallocate(amat%vpast(n)%CDMLS)
           if( associated(amat%vpast(n)%dCDMLS) ) deallocate(amat%vpast(n)%dCDMLS)
        end do
        if( associated(amat%vpast) ) deallocate( amat%vpast )
     end if
  else
     if( associated(amat%H0) ) deallocate(amat%H0)
     if( associated(amat%H ) ) deallocate(amat%H )
     if( associated(amat%CDM) ) deallocate(amat%CDM)

     if( Param%Option%optimize ) then
        if( associated(amat%EDM) ) deallocate(amat%EDM)
     end if

     if( Param%SCF%mix_target == 'density_matrix' ) then
        do n=1, Param%SCF%mix_history
           if( associated(amat%vpast(n)%CDM) )  deallocate(amat%vpast(n)%CDM)
           if( associated(amat%vpast(n)%dCDM) ) deallocate(amat%vpast(n)%dCDM)
        end do
        if( associated(amat%vpast) ) deallocate( amat%vpast )
     end if
  end if


  return
end subroutine AtomMatrix__deallocate

subroutine AtomMatrix__calcSK
  use ac_misc_module
  use ac_mpi_module
  implicit none
  integer :: l
  integer :: a, i, i1
  integer :: b, j, j1
  real(8) :: S, K

  do l=0, Param%Cell%nL-1
     do a=MPI%isatom, MPI%ieatom
        i=Base%vipao(a)

        do b=1, Param%Data%natom
           j=Base%vipao(b)

           if( .not. associated(Hamiltonian%vAtomMatrix(b,a,l)%Ptr) ) then
              cycle
           end if

           do i1=MPI%ispao(a), MPI%iepao(a)
              do j1=1, Base%vnpao(b)

                 call Base__bracketSK( S, K, &
                      Base%vpao(i+i1-1), Base%vpao(j+j1-1), Param%Cell%vL(:,l) )

                 Hamiltonian%vAtomMatrix(b,a,l)%Ptr%S(j1,i1) = S

                 if( Param%Option%spin_orbit ) then
                    Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0LS(j1,i1,1) = K
                    Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0LS(j1,i1,2) = 0.d0
                    Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0LS(j1,i1,3) = 0.d0
                    Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0LS(j1,i1,4) = K
                 else if( Param%Option%spin_polar ) then
                    Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0(j1,i1,2) = K
                    Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0(j1,i1,1) = K
                 else
                    Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0(j1,i1,1) = K
                 end if

              end do
           end do
        end do
     end do
  end do

  return
end subroutine AtomMatrix__calcSK

subroutine AtomMatrix__calcL
  use ac_misc_module
  use ac_mpi_module
  implicit none
  integer :: l
  integer :: a, i, i1
  integer :: b, j, j1
  integer :: c, k, k1
  integer :: lc, lbc
  real(8) :: Vloc

  type UVMatrixL
     real(8), pointer :: uv(:,:)
     real(8), pointer ::  E(:)
  end type UVMatrixL
  type UVMatrixL_Ptr
     type(UVMatrixL), pointer :: Ptr
  end type UVMatrixL_Ptr
  type(UVMatrixL_Ptr), pointer :: vUV(:,:,:)

  if( .not. Param%Option%projection ) return

  allocate( vUV(Param%Data%natom, 1-Param%Cell%nL:Param%Cell%nL-1, Param%Data%natom ) )

  do a=1, Param%Data%natom
     do l=1-Param%Cell%nL, Param%Cell%nL-1
        do c=1, Param%Data%natom
           vUV(a,l,c)%Ptr => null()
        end do
     end do
  end do

  do l=0, Param%Cell%nL-1
     do a=MPI%isatom, MPI%ieatom
        i=Base%vipao(a)

        do b=1, Param%Data%natom
           j=Base%vipao(b)

           if( .not. associated(Hamiltonian%vAtomMatrix(b,a,l)%Ptr) ) then
              cycle
           end if

           do lc=1-Param%Cell%nL, Param%Cell%nL-1
              lbc = Param__Cell__relative( l, lc )
              if( lbc == -100 ) cycle

              do c=1, Param%Data%natom
                 if( Potential%vnVpsloc(c) == 0 ) cycle

                 k=Potential%viVpsloc(c)

                 if( .not. Potential__intersect( Base%vpao(i), &
                      Potential%vVpsloc(k),  Param%Cell%vL(:,lc) ) ) then
                    cycle
                 end if

                 if( .not. Potential__intersect( Base%vpao(j), &
                      Potential%vVpsloc(k),  Param%Cell%vL(:,lbc) ) ) then
                    cycle
                 end if

                 if( .not. associated( vUV(c,lc,a)%Ptr ) ) then
                    allocate( vUV(c,lc,a)%Ptr )
                    allocate( vUV(c,lc,a)%Ptr%uv( Potential%vnVpsloc(c), Base%vnpao(a) ) )
                    allocate( vUV(c,lc,a)%Ptr%E( Potential%vnVpsloc(c) ) )

                    do k1=1, Potential%vnVpsloc(c)
                       do i1=1, Base%vnpao(a)
                          call Potential__bracketS( vUV(c,lc,a)%Ptr%uv(k1,i1), &
                               Base%vpao(i+i1-1), Potential%vVpsloc(k+k1-1), Param%Cell%vL(:,lc) )
                       end do
                       vUV(c,lc,a)%Ptr%E(k1) = Potential%vVpsloc(k+k1-1)%E
                    end do
                 end if

                 if( .not. associated( vUV(c,lbc,b)%Ptr ) ) then
                    allocate( vUV(c,lbc,b)%Ptr )
                    allocate( vUV(c,lbc,b)%Ptr%uv( Potential%vnVpsloc(c), Base%vnpao(b) ) )
                    allocate( vUV(c,lbc,b)%Ptr%E( Potential%vnVpsloc(c) ) )

                    do k1=1, Potential%vnVpsloc(c)
                       do j1=1, Base%vnpao(b)
                          call Potential__bracketS( vUV(c,lbc,b)%Ptr%uv(k1,j1), &
                               Base%vpao(j+j1-1), Potential%vVpsloc(k+k1-1), Param%Cell%vL(:,lbc) )
                       end do
                       vUV(c,lbc,b)%Ptr%E(k1) = Potential%vVpsloc(k+k1-1)%E
                    end do
                 end if

                 do i1=MPI%ispao(a), MPI%iepao(a)
                    do j1=1, Base%vnpao(b)
                       do k1=1, Potential%vnVpsloc(c)
                          Vloc = &
                               + vUV(c,lc,a)%Ptr%uv(k1,i1) &
                               * vUV(c,lc,a)%Ptr%E(k1) &
                               * vUV(c,lbc,b)%Ptr%uv(k1,j1)

                          if( Param%Option%spin_orbit ) then
                             Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0LS(j1,i1,1) = &
                                  Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0LS(j1,i1,1) + Vloc
                             Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0LS(j1,i1,4) = &
                                  Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0LS(j1,i1,4) + Vloc

                          else if( Param%Option%spin_polar ) then
                             Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0(j1,i1,1) = &
                                  Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0(j1,i1,1) + Vloc
                             Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0(j1,i1,2) = &
                                  Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0(j1,i1,2) + Vloc
                          else
                             Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0(j1,i1,1) = &
                                  Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0(j1,i1,1) + Vloc
                          end if

                       end do
                    end do
                 end do
              end do
           end do
        end do
     end do
  end do

  do a=1, Param%Data%natom
     do l=1-Param%Cell%nL, Param%Cell%nL-1
        do c=1, Param%Data%natom
           if( associated( vUV(c,l,a)%Ptr ) ) then
              deallocate( vUV(c,l,a)%Ptr%uv )
              deallocate( vUV(c,l,a)%Ptr%E  )
              deallocate( vUV(c,l,a)%Ptr )
           end if
        end do
     end do
  end do

  if( associated(vUV) ) deallocate(vUV)

  return
end subroutine AtomMatrix__calcL

subroutine AtomMatrix__calcN
  use ac_misc_module
  use ac_mpi_module
  implicit none
  integer :: spin
  integer :: l
  integer :: a, i, i1
  integer :: b, j, j1
  integer :: c, k, k1
  integer :: lc, lbc

  type UVMatrix
     real(8),    pointer :: uv(:,:)
     complex(8), pointer :: uvLS(:,:,:)
     real(8), pointer ::  E(:,:)
  end type UVMatrix

  type UVMatrix_Ptr
     type(UVMatrix), pointer :: Ptr
  end type UVMatrix_Ptr

  type(UVMatrix_Ptr), pointer :: vUV(:,:,:)

  real(8) :: uv0, uvm
  complex(8), parameter :: CI = ( 0.0d0, 1.0d0 )
  integer :: psl, psm
  real(8)    :: Vnon
  complex(8) :: VnonLS

  allocate( vUV(Param%Data%natom, 1-Param%Cell%nL:Param%Cell%nL-1, Param%Data%natom ) )

  do a=1, Param%Data%natom
     do l=1-Param%Cell%nL, Param%Cell%nL-1
        do c=1, Param%Data%natom
           vUV(a,l,c)%Ptr => null()
        end do
     end do
  end do

  do l=0, Param%Cell%nL-1
     do a=MPI%isatom, MPI%ieatom
        i=Base%vipao(a)

        do b=1, Param%Data%natom
           j=Base%vipao(b)

           if( .not. associated(Hamiltonian%vAtomMatrix(b,a,l)%Ptr) ) then
              cycle
           end if

           do lc=1-Param%Cell%nL, Param%Cell%nL-1
              lbc = Param__Cell__relative( l, lc )
              if( lbc == -100 ) cycle

              do c=1, Param%Data%natom
                 if( Potential%vnVpsnon(c) == 0 ) cycle

                 k=Potential%viVpsnon(c)

                 if( .not. Potential__intersect( Base%vpao(i), &
                      Potential%vVpsnon(k,1),  Param%Cell%vL(:,lc) ) ) then
                    cycle
                 end if

                 if( .not. Potential__intersect( Base%vpao(j), &
                      Potential%vVpsnon(k,1),  Param%Cell%vL(:,lbc) ) ) then
                    cycle
                 end if

                 if( .not. associated( vUV(c,lc,a)%Ptr ) ) then
                    if( Param%Option%spin_orbit ) then
                       allocate( vUV(c,lc,a)%Ptr )
                       allocate( vUV(c,lc,a)%Ptr%uvLS( Potential%vnVpsnon(c), Base%vnpao(a), 2 ) )
                       allocate( vUV(c,lc,a)%Ptr%E   ( Potential%vnVpsnon(c),2 ) )

                       do k1=1, Potential%vnVpsnon(c)
                          psm = Potential%vVpsnon(k+k1-1,1)%m
                          do i1=1, Base%vnpao(a)
                             do spin=1, 2
                                call Potential__bracketS( uvm, &
                                     Base%vpao(i+i1-1), Potential%vVpsnon(k+k1-1-2*psm,spin), Param%Cell%vL(:,lc) )
                                call Potential__bracketS( uv0, &
                                     Base%vpao(i+i1-1), Potential%vVpsnon(k+k1-1,spin), Param%Cell%vL(:,lc) )

                                if( psm > 0 ) then
                                   vUV(c,lc,a)%Ptr%uvLS(k1,i1,spin) = M_SQRT1_2*(-uv0 - CI*uvm)
                                else if( psm < 0 ) then
                                   vUV(c,lc,a)%Ptr%uvLS(k1,i1,spin) = M_SQRT1_2*(+uvm - CI*uv0)
                                else if( psm == 0 ) then
                                   vUV(c,lc,a)%Ptr%uvLS(k1,i1,spin) = uv0
                                end if
                             end do
                          end do
                          vUV(c,lc,a)%Ptr%E(k1,:) = Potential%vVpsnon(k+k1-1,:)%E
                       end do
                    else
                       allocate( vUV(c,lc,a)%Ptr )
                       allocate( vUV(c,lc,a)%Ptr%uv( Potential%vnVpsnon(c), Base%vnpao(a) ) )
                       allocate( vUV(c,lc,a)%Ptr%E ( Potential%vnVpsnon(c),1 ) )

                       do k1=1, Potential%vnVpsnon(c)
                          do i1=1, Base%vnpao(a)
                             call Potential__bracketS( uv0, &
                                  Base%vpao(i+i1-1), Potential%vVpsnon(k+k1-1,1), Param%Cell%vL(:,lc) )
                             vUV(c,lc,a)%Ptr%uv(k1,i1) = uv0
                          end do
                          vUV(c,lc,a)%Ptr%E(k1,1) = Potential%vVpsnon(k+k1-1,1)%E
                       end do
                    end if

                 end if

                 if( .not. associated( vUV(c,lbc,b)%Ptr ) ) then
                    if( Param%Option%spin_orbit ) then
                       allocate( vUV(c,lbc,b)%Ptr )
                       allocate( vUV(c,lbc,b)%Ptr%uvLS( Potential%vnVpsnon(c), Base%vnpao(b), 2 ) )
                       allocate( vUV(c,lbc,b)%Ptr%E   ( Potential%vnVpsnon(c),2 ) )

                       do k1=1, Potential%vnVpsnon(c)
                          psm = Potential%vVpsnon(k+k1-1,1)%m
                          do j1=1, Base%vnpao(b)
                             do spin=1, 2
                                call Potential__bracketS( uvm, &
                                     Base%vpao(j+j1-1), Potential%vVpsnon(k+k1-1-2*psm,spin), Param%Cell%vL(:,lbc) )
                                call Potential__bracketS( uv0, &
                                     Base%vpao(j+j1-1), Potential%vVpsnon(k+k1-1,spin), Param%Cell%vL(:,lbc) )

                                if( psm > 0 ) then
                                   vUV(c,lbc,b)%Ptr%uvLS(k1,j1,spin) = M_SQRT1_2*(-uv0 - CI*uvm)
                                else if( psm < 0 ) then
                                   vUV(c,lbc,b)%Ptr%uvLS(k1,j1,spin) = M_SQRT1_2*(+uvm - CI*uv0)
                                else if( psm == 0 ) then
                                   vUV(c,lbc,b)%Ptr%uvLS(k1,j1,spin) = uv0
                                end if
                             end do
                          end do
                          vUV(c,lbc,b)%Ptr%E(k1,:) = Potential%vVpsnon(k+k1-1,:)%E
                       end do
                    else
                       allocate( vUV(c,lbc,b)%Ptr )
                       allocate( vUV(c,lbc,b)%Ptr%uv( Potential%vnVpsnon(c), Base%vnpao(b) ) )
                       allocate( vUV(c,lbc,b)%Ptr%E ( Potential%vnVpsnon(c),1 ) )

                       do k1=1, Potential%vnVpsnon(c)
                          do j1=1, Base%vnpao(b)
                             call Potential__bracketS( uv0, &
                                  Base%vpao(j+j1-1), Potential%vVpsnon(k+k1-1,1), Param%Cell%vL(:,lbc) )
                             vUV(c,lbc,b)%Ptr%uv(k1,j1) = uv0
                          end do
                          vUV(c,lbc,b)%Ptr%E(k1,1) = Potential%vVpsnon(k+k1-1,1)%E
                       end do
                    end if
                 end if

                 do i1=MPI%ispao(a), MPI%iepao(a)
                    do j1=1, Base%vnpao(b)
                       do k1=1, Potential%vnVpsnon(c)

                          if( Param%Option%spin_orbit ) then
                             psl = Potential%vVpsnon(k+k1-1,1)%l
                             psm = Potential%vVpsnon(k+k1-1,1)%m

                             VnonLS = &
                                  + vUV(c,lc, a)%Ptr%E(k1,1) &
                                  * (dble(psl+psm+1)/dble(2*psl+1)) &
                                  * vUV(c,lc, a)%Ptr%uvLS(k1,i1,1) * dconjg(vUV(c,lbc,b)%Ptr%uvLS(k1,j1,1))

                             Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0LS(j1,i1,1) = &
                                  Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0LS(j1,i1,1) + VnonLS

                             VnonLS = &
                                  + vUV(c,lc, a)%Ptr%E(k1,2) &
                                  * (dble(psl-psm)/dble(2*psl+1)) &
                                  * vUV(c,lc, a)%Ptr%uvLS(k1,i1,2) * dconjg(vUV(c,lbc,b)%Ptr%uvLS(k1,j1,2))

                             Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0LS(j1,i1,1) = &
                                  Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0LS(j1,i1,1) + VnonLS

                             if( psl > psm ) then
                                VnonLS = &
                                     + vUV(c,lc, a)%Ptr%E(k1,1) &
                                     * sqrt(dble(psl+psm+1)/dble(2*psl+1)) * sqrt(dble(psl-psm)/dble(2*psl+1)) &
                                     * vUV(c,lc, a)%Ptr%uvLS(k1+1,i1,1) * dconjg(vUV(c,lbc,b)%Ptr%uvLS(k1,j1,1))

                                Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0LS(j1,i1,2) = &
                                     Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0LS(j1,i1,2) + VnonLS

                                VnonLS = &
                                     + vUV(c,lc, a)%Ptr%E(k1,2) &
                                     * sqrt(dble(psl+psm+1)/dble(2*psl+1)) * sqrt(dble(psl-psm)/dble(2*psl+1)) &
                                     * vUV(c,lc, a)%Ptr%uvLS(k1+1,i1,2) * dconjg(vUV(c,lbc,b)%Ptr%uvLS(k1,j1,2))

                                Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0LS(j1,i1,2) = &
                                     Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0LS(j1,i1,2) - VnonLS
                             end if

                             if( psl > psm ) then
                                VnonLS = &
                                     + vUV(c,lc, a)%Ptr%E(k1,1) &
                                     * sqrt(dble(psl+psm+1)/dble(2*psl+1)) * sqrt(dble(psl-psm)/dble(2*psl+1)) &
                                     * vUV(c,lc, a)%Ptr%uvLS(k1,i1,1) * dconjg(vUV(c,lbc,b)%Ptr%uvLS(k1+1,j1,1))

                                Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0LS(j1,i1,3) = &
                                     Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0LS(j1,i1,3) + VnonLS

                                VnonLS = &
                                     + vUV(c,lc, a)%Ptr%E(k1,2) &
                                     * sqrt(dble(psl+psm+1)/dble(2*psl+1)) * sqrt(dble(psl-psm)/dble(2*psl+1)) &
                                     * vUV(c,lc, a)%Ptr%uvLS(k1,i1,2) * dconjg(vUV(c,lbc,b)%Ptr%uvLS(k1+1,j1,2))

                                Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0LS(j1,i1,3) = &
                                     Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0LS(j1,i1,3) - VnonLS
                             end if

                             VnonLS = &
                                  + vUV(c,lc, a)%Ptr%E(k1,1) &
                                  * (dble(psl-psm+1)/dble(2*psl+1)) &
                                  * vUV(c,lc, a)%Ptr%uvLS(k1,i1,1) * dconjg(vUV(c,lbc,b)%Ptr%uvLS(k1,j1,1))

                             Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0LS(j1,i1,4) = &
                                  Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0LS(j1,i1,4) + VnonLS

                             VnonLS = &
                                  + vUV(c,lc, a)%Ptr%E(k1,2) &
                                  * (dble(psl+psm)/dble(2*psl+1)) &
                                  * vUV(c,lc, a)%Ptr%uvLS(k1,i1,2) * dconjg(vUV(c,lbc,b)%Ptr%uvLS(k1,j1,2))

                             Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0LS(j1,i1,4) = &
                                  Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0LS(j1,i1,4) + VnonLS

                          else if( Param%Option%spin_polar ) then
                             Vnon = &
                                  + vUV(c,lc, a)%Ptr%uv(k1,i1) &
                                  * vUV(c,lc, a)%Ptr%E (k1, 1) &
                                  * vUV(c,lbc,b)%Ptr%uv(k1,j1)

                             Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0(j1,i1,1) = &
                                  Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0(j1,i1,1) + Vnon

                             Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0(j1,i1,2) = &
                                  Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0(j1,i1,2) + Vnon
                          else
                             Vnon = &
                                  + vUV(c,lc, a)%Ptr%uv(k1,i1) &
                                  * vUV(c,lc, a)%Ptr%E (k1, 1) &
                                  * vUV(c,lbc,b)%Ptr%uv(k1,j1)

                             Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0(j1,i1,1) = &
                                  Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0(j1,i1,1) + Vnon
                          end if

                       end do

                    end do
                 end do

              end do
           end do
        end do
     end do
  end do

  do a=1, Param%Data%natom
     do l=1-Param%Cell%nL, Param%Cell%nL-1
        do c=1, Param%Data%natom
           if( associated( vUV(c,l,a)%Ptr ) ) then
              if( Param%Option%spin_orbit ) then
                 deallocate( vUV(c,l,a)%Ptr%uvLS )
              else
                 deallocate( vUV(c,l,a)%Ptr%uv )
              end if
              deallocate( vUV(c,l,a)%Ptr%E  )
              deallocate( vUV(c,l,a)%Ptr )
           end if
        end do
     end do
  end do

  if( associated(vUV) ) deallocate(vUV)

  return
end subroutine AtomMatrix__calcN

subroutine AtomMatrix__calcT
  use ac_misc_module
  use ac_mpi_module
  implicit none
  integer :: spin
  integer :: a, i, i1
  integer :: l, b, j1
  real(8), pointer :: V(:,:)
  complex(8), parameter :: CI = ( 0.0d0, 1.0d0 )

  do spin=1, Param%Option%nspin
     do a=MPI%isatom, MPI%ieatom
        i=Base%vipao(a)

        do i1=MPI%ispao(a), MPI%iepao(a)
           call PAO__calcWaveV( Base%vpao(i+i1-1), spin )
        end do

        do l=0, Param%Cell%nL-1
           do b=1, Param%Data%natom
              if( .not. associated(Hamiltonian%vAtomMatrix(b,a,l)%Ptr) ) then
                 cycle
              end if

              allocate( V(Base%vnpao(b),Base%vnpao(a)) )

              call Base__bracketV( V, a, b, l )

              if( Param%Option%spin_orbit ) then
                 select case(spin)
                 case(1)
                    do i1=MPI%ispao(a), MPI%iepao(a)
                       do j1=1, Base%vnpao(b)
                          Hamiltonian%vAtomMatrix(b,a,l)%Ptr%HLS(j1,i1,1) = &
                               + Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0LS(j1,i1,1) &
                               + V(j1,i1)
                       end do
                    end do
                 case(2)
                    do i1=MPI%ispao(a), MPI%iepao(a)
                       do j1=1, Base%vnpao(b)
                          Hamiltonian%vAtomMatrix(b,a,l)%Ptr%HLS(j1,i1,2) = &
                               + Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0LS(j1,i1,2) &
                               + V(j1,i1)
                          Hamiltonian%vAtomMatrix(b,a,l)%Ptr%HLS(j1,i1,3) = &
                               + Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0LS(j1,i1,3) &
                               + V(j1,i1)
                       end do
                    end do
                 case(3)
                    do i1=MPI%ispao(a), MPI%iepao(a)
                       do j1=1, Base%vnpao(b)
                          Hamiltonian%vAtomMatrix(b,a,l)%Ptr%HLS(j1,i1,2) = &
                               + Hamiltonian%vAtomMatrix(b,a,l)%Ptr%HLS(j1,i1,2) &
                               + V(j1,i1)*CI
                          Hamiltonian%vAtomMatrix(b,a,l)%Ptr%HLS(j1,i1,3) = &
                               + Hamiltonian%vAtomMatrix(b,a,l)%Ptr%HLS(j1,i1,3) &
                               - V(j1,i1)*CI
                       end do
                    end do
                 case(4)
                    do i1=MPI%ispao(a), MPI%iepao(a)
                       do j1=1, Base%vnpao(b)
                          Hamiltonian%vAtomMatrix(b,a,l)%Ptr%HLS(j1,i1,4) = &
                               + Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0LS(j1,i1,4) &
                               + V(j1,i1)
                       end do
                    end do
                 end select

              else
                 do i1=MPI%ispao(a), MPI%iepao(a)
                    do j1=1, Base%vnpao(b)
                       Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H(j1,i1,spin) = &
                            + Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0(j1,i1,spin) &
                            + V(j1,i1)
                    end do
                 end do
              end if

              if(associated(V)) deallocate(V)
           end do
        end do

        do i1=MPI%ispao(a), MPI%iepao(a)
           call PAO__freeWaveV( Base%vpao(i+i1-1) )
        end do

     end do

  end do

  return
end subroutine AtomMatrix__calcT

subroutine AtomMatrix__save
  use ac_misc_module
  use ac_mpi_module
  implicit none

  type(Element_type), pointer :: elem

  integer :: l
  integer :: a, i1
  integer :: b, j1
  integer :: iunit

  integer :: i2,i_temp1,i_temp2
  character(1) :: character_temp(4),a_c(10)
  character(55) :: fname

  integer, allocatable :: i_orb(:)
  integer :: i_c, n
  integer :: i_cyc
  integer :: mat_max_ll,mat_max_rr,mat_max_cc,ele_num_ll,ele_num_rr

  allocate( i_orb(0:Param%Data%natom) )

  i_orb(0)=0
  do a=1, Param%Data%natom
     elem => Param__Data__getElement( Param%Data%vatom(a)%name )
     i_c=0
     do n=1, elem%npao
        i_c = i_c + 2*(elem%vpao(n)%l) + 1
     end do
     i_orb(a)=i_orb(a-1)+i_c
  end do

  if( Param%Option%nspin < 4 ) then
     mat_max_cc=Base%npao
     mat_max_ll=i_orb(Param%Data%natom_left)
     mat_max_rr=Base%npao-i_orb(Param%Data%natom-Param%Data%natom_right)
  else
     mat_max_cc=Base%npao*2
     mat_max_ll=i_orb(Param%Data%natom_left)*2
     mat_max_rr=(Base%npao-i_orb(Param%Data%natom-Param%Data%natom_right))*2
  end if

  ele_num_ll=0
  do a=1, Param%Data%natom_left
     elem => Param__Data__getElement( Param%Data%vatom(a)%name )
     ele_num_ll=ele_num_ll+Param%Data%vatom(a)%Q
  end do
  ele_num_rr=0
  do a=Param%Data%natom-Param%Data%natom_right+1, Param%Data%natom
     elem => Param__Data__getElement( Param%Data%vatom(a)%name )
     ele_num_rr=ele_num_rr+Param%Data%vatom(a)%Q
  end do

  deallocate( i_orb )

  a_c(1)='0'
  a_c(2)='1'
  a_c(3)='2'
  a_c(4)='3'
  a_c(5)='4'
  a_c(6)='5'
  a_c(7)='6'
  a_c(8)='7'
  a_c(9)='8'
  a_c(10)='9'

  do a=1, Param%Data%natom

     i_temp1=a+1-1
     do i2=1,4
        i_temp2=i_temp1/(10**(4-i2))
        character_temp(i2)=a_c(i_temp2+1)
        i_temp1=i_temp1-(10**(4-i2))*i_temp2
     end do
     fname=trim(Param%Option%fname_matrices)               &
          //'_'//character_temp(1)//character_temp(2) &
          //character_temp(3)//character_temp(4)
     iunit=1
     if( MPI%root ) then
        open(iunit,file=fname)
        write(iunit,886) Param%Data%natom, Param%Data%natom_left, Param%Data%natom_right, &
             Param%Cell%nL, Param%Option%nspin-1, mat_max_ll, mat_max_cc, mat_max_rr, &
             ele_num_ll, ele_num_rr
886     format(10i6,'      = natom, nL, mat_max')
        write(iunit,*) Param%Cell%La(:)
        write(iunit,*) Param%Cell%Lb(:)
        write(iunit,*) Param%Cell%Lc(:)
        close(iunit)
     end if

     do l=0, Param%Cell%nL-1
        do b=1, Param%Data%natom

           do i_cyc=0,MPI%size-1
              if( i_cyc == MPI%rank ) then
                 if( a >= MPI%isatom .and. a <= MPI%ieatom ) then

                    if( .not. associated(Hamiltonian%vAtomMatrix(b,a,l)%Ptr) ) then
                       if( MPI%ispao(a) == 1 ) then
                          open(iunit,file=fname,position='append')
                          i_temp1=1
                          write(iunit,*)
                          write(iunit,887) a-1,l,b-1,i_temp1,Base%vnpao(a),Base%vnpao(b)
                          write(iunit,885) Param%Cell%vL(:,l)
                          close(iunit)
                       end if
                       go to 100
                    else
                       if( MPI%ispao(a) == 1 ) then
                          open(iunit,file=fname,position='append')
                          i_temp1=0
                          write(iunit,*)
                          write(iunit,887) a-1,l,b-1,i_temp1,Base%vnpao(a),Base%vnpao(b)
                          write(iunit,885) Param%Cell%vL(:,l)
                          close(iunit)
                       end if
                    end if
887                 format(6i6,'      *****************')
885                 format(3d25.16,'      =vL.x, vL.y, vL. z')

                    do i1=MPI%ispao(a), MPI%iepao(a)

                       open(iunit,file=fname,position='append')
                       do j1=1, Base%vnpao(b)
                          if( Param%Option%nspin-1 == 0 ) then
                             write(iunit,889) &
                                  Hamiltonian%vAtomMatrix(b,a,l)%Ptr%S  (j1,i1), &
                                  Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0 (j1,i1,1), &
                                  Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H  (j1,i1,1), &
                                  Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDM(j1,i1,1)*.5d0
889                          format(4d25.16)
                          else
                             if( Param%Option%nspin-1 == 1 ) then
                                write(iunit,888) &
                                     Hamiltonian%vAtomMatrix(b,a,l)%Ptr%S(j1,i1),          &
                                     (Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0(j1,i1,1)        &
                                     +Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0(j1,i1,2))*.5d0, &
                                     Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H(j1,i1,1),        &
                                     Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H(j1,i1,2),        &
                                     Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDM(j1,i1,1),      &
                                     Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDM(j1,i1,2)
888                             format(6d25.16)
                             else
                                write(iunit,876) &
                                     Hamiltonian%vAtomMatrix(b,a,l)%Ptr%S(j1,i1)
                                write(iunit,877) &
                                     Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0LS(j1,i1,1),     &
                                     Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0LS(j1,i1,2)
                                write(iunit,877) &
                                     Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0LS(j1,i1,3),     &
                                     Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0LS(j1,i1,4)
                                write(iunit,877) &
                                     Hamiltonian%vAtomMatrix(b,a,l)%Ptr%HLS(j1,i1,1),      &
                                     Hamiltonian%vAtomMatrix(b,a,l)%Ptr%HLS(j1,i1,2)
                                write(iunit,877) &
                                     Hamiltonian%vAtomMatrix(b,a,l)%Ptr%HLS(j1,i1,3),      &
                                     Hamiltonian%vAtomMatrix(b,a,l)%Ptr%HLS(j1,i1,4)
                                write(iunit,877) &
                                     Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDMLS(j1,i1,1),    &
                                     Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDMLS(j1,i1,2)
                                write(iunit,877) &
                                     Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDMLS(j1,i1,3),    &
                                     Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDMLS(j1,i1,4)
876                             format(1d25.16)
877                             format(4d25.16)
                             end if
                          end if
                       end do
                       close(iunit)
                    end do
                 end if
              end if
100           continue
              call MPI__Barrier
           end do

        end do
     end do

  end do

  return
end subroutine AtomMatrix__save

subroutine AtomMatrix__load
  use ac_misc_module
  use ac_mpi_module
  implicit none

  integer :: l
  integer :: a, i1
  integer :: b, j1
  integer :: iunit
  logical :: ex

  integer :: l_t,a_t,b_t
  integer :: i2,i_temp1,i_temp2,i_temp3,i_temp4,i_temp5
  character(1) :: character_temp(4),a_c(10)
  character(55) :: fname
  real(8) :: temp1,temp2,temp3,temp4

  real(8) :: t_L(3)

  open(unit=16,file=Param%Option%file_ac_tempout,position='append')
  write(16,*) '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'
  write(16,*) '+++++++++++        loading hamiltonian matrices'
  write(16,999) trim(Param%Option%fname_matrices_in)
  write(16,*) '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'
  write(16,*)
999 format(' +++++++++++        read file:: ',a)
  close(16)

  a_c(1)='0'
  a_c(2)='1'
  a_c(3)='2'
  a_c(4)='3'
  a_c(5)='4'
  a_c(6)='5'
  a_c(7)='6'
  a_c(8)='7'
  a_c(9)='8'
  a_c(10)='9'

  do a=MPI%isatom, MPI%ieatom

     i_temp1=a+1-1
     do i2=1,4
        i_temp2=i_temp1/(10**(4-i2))
        character_temp(i2)=a_c(i_temp2+1)
        i_temp1=i_temp1-(10**(4-i2))*i_temp2
     end do
     fname=trim(Param%Option%fname_matrices_in)               &
          //'_'//character_temp(1)//character_temp(2) &
          //character_temp(3)//character_temp(4)

     inquire(file=fname,exist=ex)
     if( .not. ex ) then
        open(unit=16,file=Param%Option%file_ac_tempout,position='append')
        write(16,'(a,a)') '      ++++++ Error!: can not open file ', fname
        close(16)
        stop
     end if

     iunit=1
     open(iunit,file=fname)
     read(iunit,*) i_temp1,i_temp2,i_temp3,i_temp4,i_temp5
     read(iunit,*)
     read(iunit,*)
     read(iunit,*)

     if(i_temp5/=Param%Option%nspin-1) then
        open(unit=16,file=Param%Option%file_ac_tempout,position='append')
        write(16,'(a,a)') '      ++++++ Error!: spin ', fname
        close(16)
        stop
     end if

     do
        read(iunit,*,end=1000)
        read(iunit,*) a_t,l,b_t,i_temp1,i_temp2,i_temp3
        read(iunit,*) t_L(:)
        b=b_t+1

        if(a/=a_t+1) then
           open(unit=16,file=Param%Option%file_ac_tempout,position='append')
           write(16,'(a,a)') '      ++++++ Error!: a ', fname
           close(16)
           stop
        end if
        if( Param%Data%natom < b ) then
           open(unit=16,file=Param%Option%file_ac_tempout,position='append')
           write(16,'(a,a)') '      ++++++ Error!: b ', fname
           close(16)
           stop
        end if
        if(Base%vnpao(a)/=i_temp2) then
           open(unit=16,file=Param%Option%file_ac_tempout,position='append')
           write(16,'(a,a)') '      ++++++ Error!: Base%vnpao(a) ', fname
           close(16)
           stop
        end if
        if(Base%vnpao(b)/=i_temp3) then
           open(unit=16,file=Param%Option%file_ac_tempout,position='append')
           write(16,'(a,a)') '      ++++++ Error!: Base%vnpao(b) ', fname
           close(16)
           stop
        end if

        if( i_temp1 /= 1 ) then
           l=Param%Cell%nL
           do l_t=0, Param%Cell%nL-1
              if( sqrt(dot_product(Param%Cell%vL(:,l_t)-t_L(:),Param%Cell%vL(:,l_t)-t_L(:))) < 1.d-8 ) then
                 l=l_t
                 exit
              end if
           end do
           if( Param%Cell%nL-1 < l ) then
              do i1=1, Base%vnpao(a)
                 do j1=1, Base%vnpao(b)
                    if( Param%Option%nspin-1 < 3 ) then
                       read(iunit,*)
                    else
                       read(iunit,*)
                       read(iunit,*)
                       read(iunit,*)
                       read(iunit,*)
                       read(iunit,*)
                       read(iunit,*)
                       read(iunit,*)
                    end if
                 end do
              end do
              cycle
           end if
           if( associated(Hamiltonian%vAtomMatrix(b,a,l)%Ptr) ) then
              do i1=1, Base%vnpao(a)
                 do j1=1, Base%vnpao(b)
                    if( i1 >= MPI%ispao(a) .and. i1 <= MPI%iepao(a) ) then
                       if( Param%Option%nspin-1 == 0 ) then
                          read(iunit,*) &
                               Hamiltonian%vAtomMatrix(b,a,l)%Ptr%S(j1,i1), &
                               Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0(j1,i1,1), &
                               Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H(j1,i1,1), &
                               Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDM(j1,i1,1)
                          Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDM(j1,i1,1) &
                               =2.d0*Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDM(j1,i1,1)
                       else
                          if( Param%Option%nspin-1 == 1 ) then
                             read(iunit,*) &
                                  Hamiltonian%vAtomMatrix(b,a,l)%Ptr%S(j1,i1),     &
                                  Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0(j1,i1,1),  &
                                  Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H(j1,i1,1),   &
                                  Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H(j1,i1,2),   &
                                  Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDM(j1,i1,1), &
                                  Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDM(j1,i1,2)
                             Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0(j1,i1,2) &
                                  =Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0(j1,i1,1)
                          else
                             read(iunit,*) Hamiltonian%vAtomMatrix(b,a,l)%Ptr%S(j1,i1)
                             read(iunit,*) temp1,temp2,temp3,temp4
                             Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0LS(j1,i1,1)  &
                                  =dcmplx(temp1,temp2)
                             Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0LS(j1,i1,2)  &
                                  =dcmplx(temp3,temp4)
                             read(iunit,*) temp1,temp2,temp3,temp4
                             Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0LS(j1,i1,3)  &
                                  =dcmplx(temp1,temp2)
                             Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0LS(j1,i1,4)  &
                                  =dcmplx(temp3,temp4)
                             read(iunit,*) temp1,temp2,temp3,temp4
                             Hamiltonian%vAtomMatrix(b,a,l)%Ptr%HLS(j1,i1,1)   &
                                  =dcmplx(temp1,temp2)
                             Hamiltonian%vAtomMatrix(b,a,l)%Ptr%HLS(j1,i1,2)   &
                                  =dcmplx(temp3,temp4)
                             read(iunit,*) temp1,temp2,temp3,temp4
                             Hamiltonian%vAtomMatrix(b,a,l)%Ptr%HLS(j1,i1,3)   &
                                  =dcmplx(temp1,temp2)
                             Hamiltonian%vAtomMatrix(b,a,l)%Ptr%HLS(j1,i1,4)   &
                                  =dcmplx(temp3,temp4)
                             read(iunit,*) temp1,temp2,temp3,temp4
                             Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDMLS(j1,i1,1) &
                                  =dcmplx(temp1,temp2)
                             Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDMLS(j1,i1,2) &
                                  =dcmplx(temp3,temp4)
                             read(iunit,*) temp1,temp2,temp3,temp4
                             Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDMLS(j1,i1,3) &
                                  =dcmplx(temp1,temp2)
                             Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDMLS(j1,i1,4) &
                                  =dcmplx(temp3,temp4)
                          end if
                       end if
                    else
                       if( Param%Option%nspin-1 < 3 ) then
                          read(iunit,*)
                       else
                          read(iunit,*)
                          read(iunit,*)
                          read(iunit,*)
                          read(iunit,*)
                          read(iunit,*)
                          read(iunit,*)
                          read(iunit,*)
                       end if
                    end if
                 end do
              end do
           else
              do i1=1, Base%vnpao(a)
                 do j1=1, Base%vnpao(b)
                    if( Param%Option%nspin-1 < 3 ) then
                       read(iunit,*)
                    else
                       read(iunit,*)
                       read(iunit,*)
                       read(iunit,*)
                       read(iunit,*)
                       read(iunit,*)
                       read(iunit,*)
                       read(iunit,*)
                    end if
                 end do
              end do
           end if
        end if

     end do

1000 continue

     close(iunit)
  end do

  return
end subroutine AtomMatrix__load

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine cal_vhart_easier
  use scf_negf
  use ac_mpi_module
  implicit none

  integer :: i1,i2,i3
  integer :: i4,ii,gnj,ier

  complex(8), allocatable :: work1(:), work3(:,:,:)
  complex(8), allocatable :: result(:)
  integer :: i

  real(8) :: kk, phi
  real(8) :: K(3)

  allocate( result(0:n_c-1),stat=ier )
  allocate( work1(0:n_c-1),stat=ier )
  allocate( work3(0:n_a-1,0:n_b-1,0:n_c-1),stat=ier )

  do i3=0,n_c-1
     do i2=0,n_b-1
        do i1=0,n_a-1
           i = i1*n_b*n_c+i2*n_c+i3+1
           if( ispin_pol_scf < 4 ) then
              if( ispin_pol_scf == 1 ) then
                 work3(i1,i2,i3) = 2.d0*rho(i,1) - rhoval(i)
              else
                 work3(i1,i2,i3) = rho(i,1) + rho(i,2) - rhoval(i)
              end if
           else
              work3(i1,i2,i3) = dreal(rhols(i,1)+rhols(i,4)) - rhoval(i)
           end if
        end do
     end do
  end do

  call ZFFT3D_backward(n_a,n_b,n_c,work3)

  do i3=0,n_c-1
     do i2=0,n_b-1
        do i1=0,n_a-1
           call Param__Cell__K(K,i1+1,i2+1,i3+1)
           kk = dot_product(K,K)
           call Hartree__PhiK(phi,kk)
           work3(i1,i2,i3) = work3(i1,i2,i3)*phi
        end do
     end do
  end do

  do i2=0,n_b-1
     do i1=0,n_a-1
        do i3=0,n_c-1
           work1(i3) = work3(i1,i2,i3)
        end do

        call make_boucon(i1,i2,work1)

        call ZFFT1D_forward(n_c,work1)
        work1(:) = work1(:)*(1.0d0/dble(n_c))

        if( i1 == 0 .and. i2 == 0 )then
           if( i_gzero_method == 0 ) then
              call cal_vhartea_gzero_1(result)
           else
              call cal_vhartea_gzero_2(result)
           end if

           do i3=l_cell_l_bound+1-1,r_cell_l_bound-1-1
              i = i1*n_b*n_c+i2*n_c+i3+1
              work1(i3) = work1(i3) + result(i3)
           end do
        else
           do i3=l_cell_l_bound+1-1,r_cell_l_bound-1-1
              call cal_vh_temp1(i1,i2,i3+1,result(i3))

              i = i1*n_b*n_c+i2*n_c+i3+1
              work1(i3) = work1(i3) + result(i3)
           end do
        end if

        do i3=0,n_c-1
           work3(i1,i2,i3) = work1(i3)
        end do
     end do
  end do

  do i3=l_cell_l_bound+1-1,r_cell_l_bound-1-1
     call ZFFT2D_forward(n_a,n_b,work3(:,:,i3))
     work3(:,:,i3) = work3(:,:,i3)*(1.0d0/dble(n_a*n_b))

     do i2=0,n_b-1
        do i1=0,n_a-1
           i = i1*n_b*n_c+i2*n_c+i3+1
           v_hartree(i) = dreal(work3(i1,i2,i3))
        end do
     end do
  end do

  deallocate( result )
  deallocate( work1, work3 )

  if( MPI%root ) then
     open(unit=90,file='negf_vh.cube')
     write(90,*) 'SYS1'
     write(90,*) 'SYS1'
     write(90,993) num_atom_scf,cell_lo(1),cell_lo(2),cell_lo(3)
     write(90,993) n_a,cell_dlabc(1,1),cell_dlabc(1,2),cell_dlabc(1,3)
     write(90,993) n_b,cell_dlabc(2,1),cell_dlabc(2,2),cell_dlabc(2,3)
     write(90,993) n_c,cell_dlabc(3,1),cell_dlabc(3,2),cell_dlabc(3,3)

     do i1=1,num_atom_scf
        write(90,992) atom_name_num(i1), vatom_q(i1)-sum_charge(i1), &
             atom_ro(i1,1),atom_ro(i1,2),atom_ro(i1,3)
     end do

     do i1=0,n_a-1
        do i2=0,n_b-1
           ii=n_c+6
           do i3=0,n_c-1,6
              gnj=i1*n_b*n_c+i2*n_c+i3
              ii=ii-6
              if( ii >= 6 ) then
                 write(90,999) (v_hartree(gnj+i4),i4=1,6)
              else
                 if( ii == 5 ) write(90,998) (v_hartree(gnj+i4),i4=1,ii)
                 if( ii == 4 ) write(90,997) (v_hartree(gnj+i4),i4=1,ii)
                 if( ii == 3 ) write(90,996) (v_hartree(gnj+i4),i4=1,ii)
                 if( ii == 2 ) write(90,995) (v_hartree(gnj+i4),i4=1,ii)
                 if( ii == 1 ) write(90,994) (v_hartree(gnj+i4),i4=1,ii)
              end if
           end do
        end do
     end do
     close(90)
  end if

999 format(f13.6,f13.6,f13.6,f13.6,f13.6,f13.6)
998 format(f13.6,f13.6,f13.6,f13.6,f13.6)
997 format(f13.6,f13.6,f13.6,f13.6)
996 format(f13.6,f13.6,f13.6)
995 format(f13.6,f13.6)
994 format(f13.6)
993 format(i4,f13.6,f13.6,f13.6)
992 format(i4,f13.6,f13.6,f13.6,f13.6)

  return
end subroutine cal_vhart_easier

subroutine make_boucon(kx,ky,boucon_temp)

  use scf_negf
  use fft
  use dft
  use hamiltonian_sgf
  use hamiltonian_c
  use gf_se_c
  use constant
  use condition_ini

  implicit none
  integer, intent(in) :: kx,ky
  complex(8), intent(in) :: boucon_temp(n_c)

  integer :: i3,m3
  real(8) :: r1,r2,gx
  complex(8) :: temp_l,temp_r

  r1=cell_lr(1,l_cell_l_bound)+del_bound_l
  r2=cell_lr(1,r_cell_l_bound)-del_bound_r

  temp_l=dcmplx(0.d0,0.d0)
  temp_r=dcmplx(0.d0,0.d0)

  do i3=0,n_c-1
     if( i3 < n_c/2 ) then
        m3=i3
     else
        m3=i3-n_c
     end if
     gx=dfloat(m3)*cell_dkabc(3,1)
     temp_l=temp_l+boucon_temp(i3+1)*dcmplx(dcos(gx*r1),-dsin(gx*r1))
     temp_r=temp_r+boucon_temp(i3+1)*dcmplx(dcos(gx*r2),-dsin(gx*r2))
  end do

  boucon_l(kx*n_b+ky+1)=temp_l/dcmplx(dfloat(n_c),0.d0)
  boucon_r(kx*n_b+ky+1)=temp_r/dcmplx(dfloat(n_c),0.d0)

  return
end subroutine make_boucon

subroutine cal_vhartea_gzero_1(result)

  use scf_negf
  use fft
  use dft
  use hamiltonian_sgf
  use hamiltonian_c
  use gf_se_c
  use constant
  use condition_ini

  implicit none
  complex(8), intent(out) :: result(0:n_c-1)

  integer :: i3
  real(8) :: r2,r1
  complex(8) :: va,vb

  r1=cell_lr(1,l_cell_l_bound)+del_bound_l
  r2=cell_lr(1,r_cell_l_bound)-del_bound_r
  vb=vh_l_f(1)-boucon_l(1)
  va=(vh_r_f(1)-boucon_r(1)-vb)/dcmplx(r2-r1,0.d0)
  do i3=l_cell_l_bound+1-1,r_cell_l_bound-1-1  
     r2=cell_lr(1,i3+1)
     result(i3) = va*dcmplx(r2-r1,0.d0)+vb  
  end do

  return
end subroutine cal_vhartea_gzero_1

subroutine cal_vhartea_gzero_2(result)

  use scf_negf
  use fft
  use dft
  use hamiltonian_sgf
  use hamiltonian_c
  use gf_se_c
  use constant
  use condition_ini

  implicit none
  complex(8), intent(out) :: result(0:n_c-1)

  integer :: mat_gzero,i1,i2,i3,i4,ier
  real(8) :: g_temp,temp_r
  real(8) :: result1
  complex(8), allocatable :: temp(:),a(:,:),b(:,:),c(:),d(:)

  pai=datan(1.d0)*4.d0
  mat_gzero=r_cell_l_bound-l_cell_l_bound+1

  allocate(temp(n_c),a(mat_gzero,mat_gzero),b(mat_gzero,mat_gzero)             &
       ,c(mat_gzero),d(mat_gzero),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: cal_vhartea_gzero_2'
     stop
  end if
  do i3=1,n_c
     temp(i3)=dcmplx(0.d0,0.d0)
  end do

  do i3=l_cell_l_bound,r_cell_l_bound
     call cal_vh_temp1(0,0,i3,result(i3))
     del2_z(i3)=result(i3)
  end do

  g_temp=gzero_gamma*gzero_gamma
  i1=0
  do i3=l_cell_l_bound,r_cell_l_bound
     i1=i1+1
     i2=0
     do i4=l_cell_l_bound,r_cell_l_bound
        i2=i2+1
        temp_r=1.d0
        if( i4 == l_cell_l_bound ) then
           if( del_bound_l < del_cell_l*.5d0 ) then
              temp_r=.5d0*(del_cell_l-del_bound_l)/del_cell_l
           else
              temp_r=0.d0
           end if
        end if
        if( i4 == r_cell_l_bound ) then
           if( del_bound_r < del_cell_l*.5d0 ) then
              temp_r=.5d0*(del_cell_l-del_bound_r)/del_cell_l
           else
              temp_r=0.d0
           end if
        end if
        if( i4 == l_cell_l_bound+1 ) then
           if( del_bound_l > del_cell_l*.5d0 ) then
              temp_r=.5d0+.5d0*(del_cell_l-del_bound_l)/del_cell_l
           end if
        end if
        if( i4 == r_cell_l_bound-1 ) then
           if( del_bound_r > del_cell_l*.5d0 ) then
              temp_r=.5d0+.5d0*(del_cell_l-del_bound_r)/del_cell_l
           end if
        end if
        call cal_green1(0,0,i3,i4,result1)
        a(i1,i2)=-dcmplx(g_temp*del_cell_l*temp_r*result1,0.d0)
     end do
     a(i1,i1)=a(i1,i1)+dcmplx(1.d0,0.d0)
  end do

  do i3=l_cell_l_bound+1,r_cell_l_bound-1
     c(i3-l_cell_l_bound+1)=del2_z(i3)
  end do
  call linear_equation(mat_gzero,a,c,d)
  do i3=l_cell_l_bound+1-1,r_cell_l_bound-1-1  
     result(i3) = d(i3+1-l_cell_l_bound+1)  
  end do

  deallocate(temp,a,b,c,d,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error deallocate: cal_vhartea_gzero_2'
     stop
  end if

  return
end subroutine cal_vhartea_gzero_2

subroutine cal_vh_temp1(kx,ky,kz,result)

  use scf_negf
  use fft
  use dft
  use hamiltonian_sgf
  use hamiltonian_c
  use gf_se_c
  use constant
  use condition_ini

  implicit none
  integer, intent(in) :: kx,ky,kz
  complex(8), intent(out) :: result

  integer :: i1_do,i2_do,i3_do,i1
  real(8) :: g_temp,r1,r2,r3

  r1=cell_lr(1,l_cell_l_bound)+del_bound_l
  r2=cell_lr(1,r_cell_l_bound)-del_bound_r
  i1_do=kx
  i2_do=ky
  i1=i1_do*n_b+i2_do+1
  if( i1_do == 0 .and. i2_do == 0 ) then
     g_temp=gzero_gamma
  else
     g_temp=dsqrt(r_cell_dk(1,i1)*r_cell_dk(1,i1)                               &
          +r_cell_dk(2,i1)*r_cell_dk(2,i1))
  end if
  i3_do=kz
  r3=cell_lr(1,i3_do)
  result                                                                       &
       =((vh_r_f(i1_do*n_b+i2_do+1)-boucon_r(i1_do*n_b+i2_do+1))                 &
       *dcmplx(dexp(-g_temp*(r2-r3))-dexp(-g_temp*(r2-2.d0*r1+r3)),0.d0)  &
       +(vh_l_f(i1_do*n_b+i2_do+1)-boucon_l(i1_do*n_b+i2_do+1))                 &
       *dcmplx(dexp(-g_temp*(r3-r1))-dexp(-g_temp*(2.d0*r2-r1-r3)),0.d0)) &
       /dcmplx(1.d0-dexp(-2.d0*g_temp*(r2-r1)),0.d0)

  return
end subroutine cal_vh_temp1

subroutine cal_green1(kx,ky,kz1,kz2,result)

  use scf_negf
  use fft
  use dft
  use hamiltonian_sgf
  use hamiltonian_c
  use gf_se_c
  use constant
  use condition_ini

  implicit none
  integer, intent(in) :: kx,ky,kz1,kz2
  real(8), intent(out) :: result

  integer :: i1_do,i2_do,i3_do,i4_do,i1
  real(8) :: g_temp,r1,r2,r3,r4

  r1=cell_lr(1,l_cell_l_bound)+del_bound_l
  r2=cell_lr(1,r_cell_l_bound)-del_bound_r
  i2_do=ky
  i1_do=kx
  if( i1_do == 0 .and. i2_do == 0 ) then
     g_temp=gzero_gamma
  else
     i1=i1_do*n_b+i2_do+1
     g_temp=dsqrt(r_cell_dk(1,i1)*r_cell_dk(1,i1)                               &
          +r_cell_dk(2,i1)*r_cell_dk(2,i1))
  end if
  i3_do=kz1
  r3=cell_lr(1,i3_do)
  i4_do=kz2
  r4=cell_lr(1,i4_do)
  result=(dexp(-g_temp*dabs(r3-r4))+dexp(-g_temp*(2.d0*(r2-r1)-dabs(r3-r4)))   &
       -dexp(-g_temp*(2.d0*r2-r3-r4))-dexp(-g_temp*(r3+r4-2.d0*r1)))         &
       /(2.d0*g_temp*(1.d0-dexp(-2.d0*g_temp*(r2-r1))))

  return
end subroutine cal_green1

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine read_input_condition_ini(file_name)

  use condition_ini
  use scf_negf
  use hamiltonian_c
  use mod_mpi

  implicit none
  character(50), intent(in) :: file_name

  real(8) :: temp(4)
  integer :: i_do,i_temp,i_check,j_check

  character(256) :: buf
  character(50) :: dummy1,dummy2,dummy3
  character(50) :: tag1,tag2

  open(unit=16,file=file_tempout,position='append')
  write(16,*)
  write(16,*)
  write(16,*) '********************** **************** **********************'
  write(16,*) '*                input  condition  ! general !               *'
  write(16,*) '********************** **************** **********************'
  write(16,*)
  close(16)


  ham_model_ini=''
  calc_type=''
  file_selfe_outsw=''
  switch_out_gf=''
  switch_out_tr=''
  switch_out_ham=''
  eigen_s_as_ini=''
  open(unit=19,file=file_name,status='old')
  do 
     read(19,'(a)',end=100) buf
     if( buf == '' ) then
        cycle
     end if
     read(buf,*) tag1
     if( tag1(1:1) == '#' ) then
        cycle
     end if
     select case(tag1)
     case('general{')
        do 
           read(19,'(a)',end=100) buf
           if( buf == '' ) then
              cycle
           end if
           read(buf,*) tag2
           if( tag2(1:1) == '#' ) then
              cycle
           end if
           select case(tag2)
           case('model_type')
              read(buf,*) dummy1,dummy2,ham_model_ini
           case('calc_type')
              read(buf,*) dummy1,dummy2,calc_type
           case('read_SF_file')
              read(buf,*) dummy1,dummy2,file_selfe_outsw
           case('output_G&T')
              read(buf,*) dummy1,dummy2,dummy3
              if( switch_out_tr == '' ) then
                 switch_out_tr=dummy3
              end if
              if( switch_out_gf == '' ) then
                 switch_out_gf=dummy3
              end if
           case('output_G')
              read(buf,*) dummy1,dummy2,switch_out_gf
           case('output_T')
              read(buf,*) dummy1,dummy2,switch_out_tr
           case('output_H')
              read(buf,*) dummy1,dummy2,switch_out_ham
           case('band_calc_type')
              read(buf,*) dummy1,dummy2,eigen_s_as_ini
           case('}general')
              go to 100
           end select
        end do
     end select
  end do
100 continue
  close(19)
  if( ham_model_ini == '' ) then
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //general/model_type// => stop'
     close(17)
     stop
  end if
  if(  calc_type == '' ) then
     calc_type='trans'
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //general/calc_type// => def'
     close(17)
  end if
  if( file_selfe_outsw == '' ) then
     file_selfe_outsw='none'
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //general/read_SF_file// => def'
     close(17)
  end if
  if( switch_out_gf == '' ) then
     switch_out_gf='diagonal'
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //general/output_G// => def'
     close(17)
  end if
  if( switch_out_tr == '' ) then
     switch_out_tr='diagonal'
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //general/output_T// => def'
     close(17)
  end if
  if( switch_out_ham == '' ) then
     switch_out_ham='off'
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //general/output_H// => off'
     close(17)
  end if


  file_parameter_co=''
  file_parameter=''
  file_parameter1=''
  file_parameter2=''
  file_parameter3=''
  file_selfenergy=''
  file_parameter_tb_par=''
  open(unit=19,file=file_name,status='old')
  do 
     read(19,'(a)',end=120) buf
     if( buf == '' ) then
        cycle
     end if
     read(buf,*) tag1
     if( tag1(1:1) == '#' ) then
        cycle
     end if
     select case(tag1)
     case('file{')
        do 
           read(19,'(a)',end=120) buf
           if( buf == '' ) then
              cycle
           end if
           read(buf,*) tag2
           if( tag2(1:1) == '#' ) then
              cycle
           end if
           select case(tag2)
           case('tb_cordinate')
              read(buf,*) dummy1,dummy2,file_parameter_co
           case('tb_parameter')
              read(buf,*) dummy1,dummy2,file_parameter_tb_par
           case('input_central')
              read(buf,*) dummy1,dummy2,file_parameter1
           case('input_junc')
              read(buf,*) dummy1,dummy2,file_parameter1
           case('input_left')
              read(buf,*) dummy1,dummy2,file_parameter2
           case('input_right')
              read(buf,*) dummy1,dummy2,file_parameter3
           case('scf_file')
              read(buf,*) dummy1,dummy2,file_parameter
           case('self_e_file')
              read(buf,*) dummy1,dummy2,file_selfenergy
           case('}file')
              go to 120
           end select
        end do
     end select
  end do
120 continue
  close(19)

  if( ham_model_ini == 'gsp' .and. file_parameter_co == '' ) then
     file_parameter_co=file_name
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ???: gsp //file/tb_cordinate// => current'
     close(17)
  end if
  if( ham_model_ini == 'rtb_h' .and. file_parameter_co == '' ) then
     file_parameter_co=file_name
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ???: rtb_h //file/tb_cordinate// => current'
     close(17)
  end if
  if( ham_model_ini == 'input'                                                 &
       .and. (file_parameter1 == '' .or. file_parameter2 == ''                 &
       .or. file_parameter3 == '') ) then
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ???: input //file/input_**// => stop'
     close(17)
     stop
  end if
  if( ham_model_ini == 'scf_accel' .and. file_parameter == '' ) then
     file_parameter=file_name
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ???: scf //file/scf_file// => curren'
     close(17)
  end if
  if( file_selfenergy == '' ) then
     file_selfenergy='none'
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //file/self_e_file// => none'
     close(17)
  end if

  if( ham_model_ini == 'rtb_h' .and. file_parameter_tb_par == '' ) then
     file_parameter_tb_par='../data/rtbh_c_parameter.in'
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ???: rtb_h //file/tb_parameter// => def'
     close(17)
  end if
  if( ham_model_ini == 'gsp' .and. file_parameter_tb_par == '' ) then
     file_parameter_tb_par='../data/gsp_c_parameter.in'
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ???: gsp //file/tb_parameter// => def'
     close(17)
  end if


  sgf_method_ini=''
  iteration_max_ini=0
  eps_ini=0.0000d0
  open(unit=19,file=file_name)
  do 
     read(19,'(a)',end=110) buf
     if( buf == '' ) then
        cycle
     end if
     read(buf,*) tag1
     if( tag1(1:1) == '#' ) then
        cycle
     end if
     select case(tag1)
     case('surface_green_func{')
        do 
           read(19,'(a)',end=110) buf
           if( buf == '' ) then
              cycle
           end if
           read(buf,*) tag2
           if( tag2(1:1) == '#' ) then
              cycle
           end if
           select case(tag2)
           case('method')
              read(buf,*) dummy1,dummy2,i_temp
              if( i_temp == 1 ) then
                 sgf_method_ini='transfer'
              else
                 sgf_method_ini='direct'
              end if
           case('max_number')
              read(buf,*) dummy1,dummy2,iteration_max_ini
           case('criterion')
              read(buf,*) dummy1,dummy2,eps_ini
           case('}surface_green_func')
              go to 110
           end select
        end do
     end select
  end do
110 continue
  close(19)
  if( sgf_method_ini == '' ) then
     sgf_method_ini='transfer'
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //surface_green_func/method// => def'
     close(17)
  end if
  if( iteration_max_ini == 0 ) then
     iteration_max_ini=40
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //surface_green_func/max_number// => def'
     close(17)
  end if
  if( eps_ini == 0.0000d0 ) then
     eps_ini=0.00001d0
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //surface_green_func/criterion// => def'
     close(17)
  end if


  ka_tr=1
  kb_tr=1
  filename_kpoint=''
  if( ham_model_ini /= 'rtb_h' .and. ham_model_ini /= 'gsp' ) then
     ka_tr=0
     kb_tr=0
     open(unit=19,file=file_name)
     do 
        read(19,'(a)',end=180) buf
        if( buf == '' ) then
           cycle
        end if
        read(buf,*) tag1
        if( tag1(1:1) == '#' ) then
           cycle
        end if
        select case(tag1)
        case('gra_ksampling{')
           do 
              read(19,'(a)',end=180) buf
              if( buf == '' ) then
                 cycle
              end if
              read(buf,*) tag2
              if( tag2(1:1) == '#' ) then
                 cycle
              end if
              select case(tag2)
              case('point')
                 read(buf,*) dummy1,dummy2,dummy3
                 if( dummy3 == 'gamma' ) then
                    ka_tr=1
                    kb_tr=1
                 else
                    if( dummy3 == 'file' ) then
                       read(buf,*) dummy1,dummy2,dummy3,filename_kpoint
                       ka_tr=1
                       kb_tr=1
                    else
                       read(buf,*) dummy1,dummy2,ka_tr,kb_tr
                    end if
                 end if
              case('}gra_ksampling')
                 go to 180
              end select
           end do
        end select
     end do
180  continue
     close(19)

     if( ka_tr == 0 ) then
        ka_tr=1
        open(unit=17,file=file_tempout,position='append')
        write(17,*) '???     ??? //gra_ksampling/mesh// => ka_tr=1'
        close(17)
     end if
     if( kb_tr == 0 ) then
        kb_tr=1
        open(unit=17,file=file_tempout,position='append')
        write(17,*) '???     ??? //gra_ksampling/mesh// => kb_tr=1'
        close(17)
     end if
  end if


  method_sum_om=1
  om_block_num=1
  num_gra=1
  call alo_input_condition_2
  om_con_method(1)='linear'
  num_om_par(1)=200
  omega_if(1,1)=dcmplx(0.d0,0.d0)
  omega_if(1,2)=dcmplx(0.d0,0.d0)
  if( calc_type == 'trans' .or. calc_type == 'calc_dos' ) then
     i_check=0
     j_check=0
     temp(1)=0.d0
     temp(2)=0.d0
     temp(3)=0.d0
     temp(4)=0.d0
     num_om_par(1)=0
     open(unit=19,file=file_name)
     do 
        read(19,'(a)',end=170) buf
        if( buf == '' ) then
           cycle
        end if
        read(buf,*) tag1
        if( tag1(1:1) == '#' ) then
           cycle
        end if
        select case(tag1)
        case('gra_energy{')
           do 
              read(19,'(a)',end=170) buf
              if( buf == '' ) then
                 cycle
              end if
              read(buf,*) tag2
              if( tag2(1:1) == '#' ) then
                 cycle
              end if
              select case(tag2)
              case('mesh_number')
                 read(buf,*) dummy1,dummy2,num_om_par(1)
              case('start_energy')
                 read(buf,*) dummy1,dummy2,temp(1)
                 i_check=1
              case('end_energy')
                 read(buf,*) dummy1,dummy2,temp(2)
                 j_check=1
              case('im_energy')
                 read(buf,*) dummy1,dummy2,temp(3)
                 temp(4)=temp(3)
              case('}gra_energy')
                 go to 170
              end select
           end do
        end select
     end do
170  continue
     close(19)

     if( num_om_par(1) == 0 ) then
        open(unit=17,file=file_tempout,position='append')
        write(17,*) '??? broken ??? //gra_energy/mesh_number// => stop'
        close(17)
        stop
     end if
     if( i_check == 0 ) then
        open(unit=17,file=file_tempout,position='append')
        write(17,*) '??? broken ??? //gra_energy/start_energy// => stop'
        close(17)
        stop
     end if
     if( j_check == 0 ) then
        open(unit=17,file=file_tempout,position='append')
        write(17,*) '??? broken ??? //gra_energy/end_energy// => stop'
        close(17)
        stop
     end if
     if( temp(3) == 0.d0 ) then
        temp(3)=1.d-5
        temp(4)=1.d-5
        open(unit=17,file=file_tempout,position='append')
        write(17,*) '??? broken ??? //gra_energy/im_energy// => def'
        close(17)
     end if
     omega_if(1,1)=dcmplx(temp(1),temp(3))
     omega_if(1,2)=dcmplx(temp(2),temp(4))
  end if

  num_iv_mesh=20
  om_sum=0.0001d0
  if( calc_type == 'iv' ) then
     num_iv_mesh=0
     om_sum=0.d0
     open(unit=19,file=file_name)
     do 
        read(19,'(a)',end=160) buf
        if( buf == '' ) then
           cycle
        end if
        read(buf,*) tag1
        if( tag1(1:1) == '#' ) then
           cycle
        end if
        select case(tag1)
        case('iv_energy{')
           do 
              read(19,'(a)',end=160) buf
              if( buf == '' ) then
                 cycle
              end if
              read(buf,*) tag2
              if( tag2(1:1) == '#' ) then
                 cycle
              end if
              select case(tag2)
              case('mesh_number')
                 read(buf,*) dummy1,dummy2,num_iv_mesh
                 i_check=1
              case('im_energy')
                 read(buf,*) dummy1,dummy2,om_sum
              case('}iv_energy')
                 go to 160
              end select
           end do
        end select
     end do
160  continue
     close(19)

     if( num_iv_mesh == 0 ) then
        open(unit=17,file=file_tempout,position='append')
        write(17,*) '??? broken ??? //iv_energy/mesh_number// => stop'
        close(17)
        stop
     end if
     if( om_sum == 0.d0 ) then
        om_sum=1.d-5
        open(unit=17,file=file_tempout,position='append')
        write(17,*) '??? broken ??? //iv_energy/im_energy// => def'
        close(17)
     end if
  end if


  switch_l_eigen=''
  dos_on_off_ini_l=''
  kz_max_l=0
  open(unit=19,file=file_name)
  do 
     read(19,'(a)',end=140) buf
     if( buf == '' ) then
        cycle
     end if
     read(buf,*) tag1
     if( tag1(1:1) == '#' ) then
        cycle
     end if
     select case(tag1)
     case('electrode_left{')
        do 
           read(19,'(a)',end=140) buf
           if( buf == '' ) then
              cycle
           end if
           read(buf,*) tag2
           if( tag2(1:1) == '#' ) then
              cycle
           end if
           select case(tag2)
           case('s_band')
              read(buf,*) dummy1,dummy2,switch_l_eigen
           case('s_electrod_DOS')
              read(buf,*) dummy1,dummy2,dos_on_off_ini_l
           case('k_point_mesh')
              read(buf,*) dummy1,dummy2,kz_max_l
           case('}electrode_left')
              go to 140
           end select
        end do
     end select
  end do
140 continue
  close(19)

  if( switch_l_eigen == '' ) then
     switch_l_eigen='off'
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //electrode_left/s_band// => def'
     close(17)
  end if
  if( dos_on_off_ini_l == '' ) then
     dos_on_off_ini_l='off'
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //electrode_left/s_electrod_DOS// => def'
     close(17)
  end if
  if( kz_max_l == 0 ) then
     kz_max_l=32
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //electrode_left/k_point_mesh// => def'
     close(17)
  end if

  switch_r_eigen=''
  dos_on_off_ini_r=''
  kz_max_r=0
  open(unit=19,file=file_name)
  do 
     read(19,'(a)',end=130) buf
     if( buf == '' ) then
        cycle
     end if
     read(buf,*) tag1
     if( tag1(1:1) == '#' ) then
        cycle
     end if
     select case(tag1)
     case('electrode_right{')
        do 
           read(19,'(a)',end=130) buf
           if( buf == '' ) then
              cycle
           end if
           read(buf,*) tag2
           if( tag2(1:1) == '#' ) then
              cycle
           end if
           select case(tag2)
           case('s_band')
              read(buf,*) dummy1,dummy2,switch_r_eigen
           case('s_electrod_DOS')
              read(buf,*) dummy1,dummy2,dos_on_off_ini_r
           case('k_point_mesh')
              read(buf,*) dummy1,dummy2,kz_max_r
           case('}electrode_right')
              go to 130
           end select
        end do
     end select
  end do
130 continue
  close(19)

  if( switch_r_eigen == '' ) then
     switch_r_eigen='off'
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //electrode_right/s_band// => def'
     close(17)
  end if
  if( dos_on_off_ini_r == '' ) then
     dos_on_off_ini_r='off'
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //electrode_right/s_electrod_DOS// => def'
     close(17)
  end if
  if( kz_max_r == 0 ) then
     kz_max_r=32
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //electrode_right/k_point_mesh// => def'
     close(17)
  end if

  if( eigen_s_as_ini == ''                                                     &
       .and. (switch_l_eigen == 'on' .or. switch_r_eigen == 'on') ) then
     eigen_s_as_ini='symmetry'
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //general/band_calc_type// => def'
     close(17)
  end if


  open(unit=16,file=file_tempout,position='append')
  write(16,*)

  if( ham_model_ini == 'scf_accel' ) then
     ham_model_ini='scf_calc'
  end if
  write(16,900) ham_model_ini
900 format('                           model: ',a20)
  if( ham_model_ini == 'scf_calc' ) then
     ham_model_ini='scf_accel'
  end if

  if( ham_model_ini /= 'input' ) then
     if( ham_model_ini /= 'rtb_h' .and. ham_model_ini /= 'gsp' ) then
        write(16,902) file_parameter
902     format('                       file name: ',a40)
     else
        write(16,934) file_parameter_co
        write(16,935) file_parameter_tb_par
934     format('             cordinate file name: ',a40)
935     format('                  data file name: ',a40)
     end if
  else
     write(16,931) file_parameter1
931  format('               file name - junc : ',a40)
     write(16,932) file_parameter2
932  format('               file name - left : ',a40)
     write(16,933) file_parameter3
933  format('               file name - right: ',a40)
  end if

  write(16,915) file_selfenergy
915 format('             file of self energy: ',a20)
  write(16,921) file_selfe_outsw
921 format('   /switch/  file of self energy: ',a10)

  write(16,*) 
  write(16,904) calc_type
904 format('                       calc type: ',a10)
  write(16,905) switch_out_gf
905 format('                        output_G: ' ,a10)
  write(16,928) switch_out_tr
928 format('                        output_T: ' ,a10)
  write(16,950) switch_out_ham
950 format('                        output_H: ' ,a10)

  if( sgf_method_ini == 'transfer' ) then
     i_temp=1
  else
     i_temp=2
  end if
  write(16,*)
  write(16,903) i_temp
903 format('           surface GF     method: ',i15)
  write(16,914) iteration_max_ini
914 format('           surface GF  iter. max: ',i15)
  write(16,918) eps_ini
918 format('           surface GF  criterion: ',e15.5)

  write(16,*) 
  write(16,906) switch_l_eigen
906 format('   /switch/ band of  left region: ',a10)
  write(16,908) dos_on_off_ini_l
908 format('   /switch/  DOS of  left region: ',a10)
  write(16,907) switch_r_eigen
907 format('   /switch/ band of right region: ',a10)
  write(16,923) dos_on_off_ini_r
923 format('   /switch/  DOS of right region: ',a10)

  if( switch_l_eigen == 'on' .or. switch_r_eigen == 'on'                       &
       .or. dos_on_off_ini_l == 'on' .or. dos_on_off_ini_r == 'on' ) then
     write(16,*)
     write(16,919) kz_max_l,kz_max_r
919  format('               k-point mesh(l,r): ',i5,i5)
  end if
  if( switch_l_eigen == 'on' .or. switch_r_eigen == 'on' ) then
     write(16,920) eigen_s_as_ini
920  format('                 eigen calc type: ',a10)
  end if

  if( ham_model_ini /= 'rtb_h' .and. ham_model_ini /= 'gsp' ) then
     write(16,*)
     write(16,*)                                                              &
          '======================= calc ksampling ======================='
     write(16,*)

     if( filename_kpoint == '' ) then
        write(16,941) ka_tr,kb_tr
941     format('                     mesh (a,b) : (',i5,',',i5,')')
     else
        write(16,942) filename_kpoint
942     format('                    mesh (file) : ',a40)
     end if
  end if

  if( calc_type == 'trans' ) then
     write(16,*)
     write(16,*)                                                              &
          '==================== calc energy of T & G ===================='
     write(16,*)

     do i_do=1,om_block_num
        write(16,916) omega_if(i_do,1),omega_if(i_do,2)
        write(16,917) num_om_par(i_do)
     end do
916  format(f10.5,' + ',e10.5,' i ->',f10.5,' + ',e10.5,' i (eV)')
917  format('                    mesh number : ',i10)
  end if

  if( calc_type == 'iv' ) then
     write(16,*)
     write(16,*)                                                              &
          '===================== calc energy of I-V ====================='
     write(16,*)
     write(16,924) num_iv_mesh
924  format('                    mesh number : ',i10)
     write(16,922) om_sum
922  format('       imag part of calc energy : ',e10.5)
  end if

  write(16,*) 
  write(16,*)

  close(16)

  kx_max_l=1
  ky_max_l=1
  kx_max_r=1
  ky_max_r=1
  scf_bias='off'

  if( file_selfe_outsw == 'none' ) then
     file_selfe_outsw='off'
  end if
  if( file_selfe_outsw == 'exist' ) then
     file_selfe_outsw='on'
  end if

  return
end subroutine read_input_condition_ini

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@             Naoki WATANABE (Mizuho I.R.)                       @@ !
! @@             Nobutaka NISHIKAWA (Mizuho I.R.)                   @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine selfenergy_r(descCC, descCR, descRR, w,iw_do,qx,qy,ispin,kt)

  use hamiltonian_sgf
  use hamiltonian_c
  use gf_se_c
  use constant
  use condition_ini
  use scf_negf
  use ac_mpi_module

  implicit none
  type(MPI_MatDesc), intent(in) :: descRR, descCR, descCC
  integer, intent(in) :: iw_do,ispin,kt
  integer, intent(in) :: qx,qy
  complex(8), intent(in) :: w

  integer :: ier
  integer :: i, j
  complex(8), allocatable :: bmat_temp1(:,:),bmat_temp2(:,:)
  complex(8), allocatable :: bmat_temp3(:,:),bmat_temp4(:,:)
  complex(8), allocatable :: bmat_temp5(:,:)

  complex(8) :: trace
  allocate(bmat_temp1(descCR%nrow,descCR%scol:descCR%ecol),stat=ier)
  allocate(bmat_temp2(descRR%nrow,descRR%scol:descRR%ecol),stat=ier)
  allocate(bmat_temp4(descCR%nrow,descCR%scol:descCR%ecol),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: selfenergy_r'
     stop
  end if

  call surf_gf_r(descRR,w,bmat_temp2,qx,qy,ispin)

  if( gra_onoff /= 'off') then
     call MPI__ZLATRA_ASCOT( descRR, bmat_temp2, trace )
     call cal_print_text12(iw_do,trace,ispin,kt)
  end if

  call alo_hami_c2(descCR)

  if( ham_model_ini == 'input' .or. ham_model_ini == 'scf_accel') then
     call set_hami_c_rr_input(descCR,descRR,ispin)
  else
     call set_hami_c_rr(descCR,qx,qy)
  end if

  bmat_temp1(:,:) = w*scr_mat(:,:) - hcr_mat(:,:) 
  bmat_temp4(:,:) = dconjg(w)*scr_mat(:,:) - hcr_mat(:,:) 

  call unset_hami_c2

  allocate(bmat_temp3(descCR%nrow,descCR%scol:descCR%ecol),stat=ier)
  allocate(bmat_temp5(descCC%nrow,descCC%scol:descCC%ecol),stat=ier)

  call MPI__ZGEMM2_ASCOT( 'N', 'N', descCR, descRR, descCR, &
       C1, bmat_temp1, bmat_temp2, C0, bmat_temp3 )
  call MPI__ZGEMM2_ASCOT( 'N', 'C', descCR, descCR, descCC, &
       C1, bmat_temp3, bmat_temp4, C0, bmat_temp5 )

  se_r_mat_per(:,:,qx,qy) = bmat_temp5(:,:) 

  deallocate(bmat_temp1,bmat_temp2,bmat_temp3,bmat_temp4,bmat_temp5,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error deallocate: selfenergy_r 2'
     stop
  end if

  return
end subroutine selfenergy_r

subroutine surf_gf_r(descRR,w,bmat_temp2,kx,ky,ispin)

  use condition_ini
  use surface_green_function
  use hamiltonian_sgf
  use hamiltonian_e
  use ac_mpi_module

  implicit none
  type(MPI_MatDesc), intent(in) :: descRR
  complex(8), intent(in) :: w
  complex(8), intent(out) :: bmat_temp2(descRR%nrow,descRR%scol:descRR%ecol)
  integer, intent(in) :: kx,ky,ispin

  integer :: i, j

  mat_max=mat_max_rr

  call set_condition_r
  call set_hamiltonian_r(descRR,kx,ky,ispin)

  if( sgf_method_ini == 'transfer' ) then
     call alo_surface_gf_transefer(descRR)
  else
     if( sgf_method_ini == 'direct' ) then
        call alo_surface_gf_direct(descRR)
     else
        write(6,*) 'error - sgf_method_r'
     end if
  end if

  if( sgf_method_ini == 'transfer' ) then
     call su_gf_trans(descRR,iteration_max_ini,eps_ini, &
          h00_mat,h01_mat,h10_mat,s00_mat,s01_mat,s10_mat,w) 
  else
     if( sgf_method_ini == 'direct' ) then
        call su_gf_direct(descRR,iteration_max_ini,eps_ini, &
             h00_mat,h01_mat,h10_mat,s00_mat,s01_mat,s10_mat,w) 
     end if
  end if

  bmat_temp2(:,:) = gr00(:,:)

  if( sgf_method_ini == 'transfer' ) then
     call unset_surface_gf_transefer
  else
     if( sgf_method_ini == 'direct' ) then
        call unset_surface_gf_direct
     end if
  end if

  call unset_hamiltonian
  call unset_condition_r

  return
end subroutine surf_gf_r

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Naoki WATANABE, Nobutaka NISHIKAWA (Mizuho I.R.)   @@ !
! @@             Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine SphericalBessel__setup( Nr, Nk, Ecutoff )
  use ac_misc_module

  implicit none
  integer, intent(in)       :: Nr, Nk
  real(8), intent(in) :: Ecutoff
  real(8) :: Kcutoff

  SphericalBessel%Nr = Nr
  SphericalBessel%Nk = Nk
  allocate( SphericalBessel%vrx(SphericalBessel%Nr) )
  allocate( SphericalBessel%vrw(SphericalBessel%Nr) )
  allocate( SphericalBessel%vkx(SphericalBessel%Nk) )
  allocate( SphericalBessel%vkw(SphericalBessel%Nk) )

  Kcutoff = sqrt(2*Ecutoff)

  if( Param%Option%mx ) then
     call GaussLegendre__getPointsMX( SphericalBessel%Nk, 0.d0, Kcutoff, SphericalBessel%vkx, SphericalBessel%vkw ) 

     call GaussLegendre__getPointsMX( SphericalBessel%Nr, 0.d0, 1.d0, SphericalBessel%vrx, SphericalBessel%vrw )
  else
     call GaussLegendre__getPoints( SphericalBessel%Nk, 0.d0, Kcutoff, SphericalBessel%vkx, SphericalBessel%vkw ) 

     call GaussLegendre__getPoints( SphericalBessel%Nr, 0.d0, 1.d0, SphericalBessel%vrx, SphericalBessel%vrw )
  end if

  return
end subroutine SphericalBessel__setup

subroutine SphericalBessel__transpose( vK, fR, l )
  use ac_misc_module

  implicit none
  real(8), intent(out) :: vK(SphericalBessel%Nk)
  type(Spline_type), intent(in)   :: fR
  integer, intent(in)        :: l

  integer :: ik, i
  real(8) :: k, r, w, sum

  do ik=1, SphericalBessel%Nk
     k = SphericalBessel%vkx(ik)

     sum=0.d0
     do i=1, SphericalBessel%Nr
        r = Spline__xback(fR) * SphericalBessel%vrx(i)
        w = Spline__xback(fR) * SphericalBessel%vrw(i)

        sum = sum + w*r*r* Spline__evaluate(fR, r) * SphericalBessel__J(l,k*r)
     end do
     vK(ik) = sum*M_2_SQRTPI*M_SQRT1_2
  end do

  return
end subroutine SphericalBessel__transpose

subroutine SphericalBessel__transposetail( vK, fR, Q )
  use ac_misc_module

  implicit none
  real(8), intent(out) :: vK(SphericalBessel%Nk)
  type(Spline_type), intent(in)   :: fR
  real(8), intent(in)  :: Q

  integer       :: ik
  real(8) :: k, rs, re, sum

  do ik=1, SphericalBessel%Nk
     k  = SphericalBessel%vkx(ik)
     rs = Spline__xback(fR)
     re = Spline__xback(fR)*3

     if( dabs(k)<1.d-14 ) then
        sum = 0.5*(re*re-rs*rs)
     else
        sum = (cos(k*rs)-cos(k*re))/(k*k)
     endif
     vK(ik) = vK(ik) + sum*Q*M_2_SQRTPI*M_SQRT1_2
  end do

  return
end subroutine SphericalBessel__transposetail

subroutine SphericalBessel__integrateSK( sumS, sumK, Ra, Rb, l, r )
  use ac_misc_module

  implicit none
  real(8) :: sumS, sumK
  real(8), intent(in) :: Ra(SphericalBessel%Nk)
  real(8), intent(in) :: Rb(SphericalBessel%Nk)
  integer, intent(in) :: l
  real(8), intent(in) :: r

  integer :: ik
  real(8) :: k, w, f

  sumS=0.d0
  sumK=0.d0

  if( dabs(r) < 1.d-14 ) then
     do ik=1, SphericalBessel%Nk
        k = SphericalBessel%vkx(ik)
        w = SphericalBessel%vkw(ik)
        f = w*(k**(l+2)) * Ra(ik)*Rb(ik)
        sumS = sumS + f
        sumK = sumK + f*k*k
     end do

     sumS = sumS*4*M_PI*SphericalBessel__Jxl(l,0.d0)
     sumK = sumK*2*M_PI*SphericalBessel__Jxl(l,0.d0)
     return
  end if

  do ik=1, SphericalBessel%Nk
     k = SphericalBessel%vkx(ik)
     w = SphericalBessel%vkw(ik)
     f = w*SphericalBessel__Jx2(l,k*r) * Ra(ik)*Rb(ik)
     sumS = sumS + f
     sumK = sumK + f*k*k
  end do

  sumS = sumS*4*M_PI/r**(l+2)
  sumK = sumK*2*M_PI/r**(l+2)

  return
end subroutine SphericalBessel__integrateSK

subroutine SphericalBessel__integratedSK( sumdS, sumdK, Ra, Rb, l, r )
  use ac_misc_module

  implicit none
  real(8) :: sumdS, sumdK
  real(8), intent(in) :: Ra(SphericalBessel%Nk)
  real(8), intent(in) :: Rb(SphericalBessel%Nk)
  integer, intent(in)       :: l
  real(8), intent(in) :: r

  integer       :: ik
  real(8) :: k, w, f, df

  sumdS = 0.d0
  sumdK = 0.d0

  if( dabs(r) < 1.d-14 ) then
     do ik=1, SphericalBessel%Nk
        k = SphericalBessel%vkx(ik)
        w = SphericalBessel%vkw(ik)

        sumdS = sumdS + w*(k**(l+2)) * k**2 * Ra(ik)*Rb(ik)
        sumdK = sumdK + w*(k**(l+4)) * k**2 * Ra(ik)*Rb(ik)
     end do

     sumdS = sumdS*4*M_PI*SphericalBessel__dJxlx(l,0.d0)
     sumdK = sumdK*2*M_PI*SphericalBessel__dJxlx(l,0.d0)
     return
  end if

  do ik=1, SphericalBessel%Nk
     k = SphericalBessel%vkx(ik)
     w = SphericalBessel%vkw(ik)

     f  = w*SphericalBessel__Jx2 (l,k*r) * Ra(ik)*Rb(ik)
     df = w*SphericalBessel__dJx2(l,k*r) * Ra(ik)*Rb(ik)
     sumdS = sumdS + (df*(k*r) - f*(l+2))
     sumdK = sumdK + (df*(k*r) - f*(l+2))* k*k
  end do

  sumdS = sumdS*4*M_PI/r**(l+4)
  sumdK = sumdK*2*M_PI/r**(l+4)

end subroutine SphericalBessel__integratedSK

subroutine SphericalBessel__deallocate
  use ac_misc_module

  implicit none
  if(associated(SphericalBessel%vrx)) deallocate( SphericalBessel%vrx )
  if(associated(SphericalBessel%vrw)) deallocate( SphericalBessel%vrw )
  if(associated(SphericalBessel%vkx)) deallocate( SphericalBessel%vkx )
  if(associated(SphericalBessel%vkw)) deallocate( SphericalBessel%vkw )

  return
end subroutine SphericalBessel__deallocate

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Naoki WATANABE, Nobutaka NISHIKAWA (Mizuho I.R.)   @@ !
! @@             Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine DOS__calc( vdos, vE, n_npao )
  use ac_misc_module

  implicit none
  integer, intent(in) :: n_npao
  real(8), intent(out) :: vdos(Param%DOS%Ne)
  real(8), intent(in)  :: vE(Param%DOS%Nka, Param%DOS%Nkb, Param%DOS%Nkc, n_npao )
  integer :: b

  vdos(:) = 0.d0

  select case( Param%DOS%method )
  case('boxes','histogram')
     call DOS__calc_Histogram  ( vdos, vE, n_npao )
  case('gaussian')
     call DOS__calc_Gaussian   ( vdos, vE, n_npao )
  case('tetrahedron')
     call DOS__calc_Tetrahedron( vdos, vE, n_npao )
  end select

  vdos(:) = vdos(:) * 1.0/Param%DOS%nK

  return
end subroutine DOS__calc

subroutine DOS__calc_Histogram( vdos, vE, n_npao )
  use ac_misc_module
  implicit none
  integer, intent(in) :: n_npao
  real(8), intent(out) :: vdos(Param%DOS%Ne)
  real(8), intent(in)  :: vE(Param%DOS%Nka, Param%DOS%Nkb, Param%DOS%Nkc, n_npao )

  integer :: ika, ikb, ikc, m, b
  real(8) :: E
  real(8) :: dos,pdbe_t

  do m=1, n_npao
     do ikc=1, Param%DOS%Nkc
        do ikb=1, Param%DOS%Nkb
           do ika=1, Param%DOS%Nka
              E = vE(ika,ikb,ikc,m)
              call Param__DOS__binIndex(b,E)

              if( 0<b .and. b<=Param%DOS%Ne ) then
                 call Param__DOS__binEnergy(pdbe_t,b)
                 call DOS__histogram( dos, pdbe_t, E, Param%DOS%dE )
                 vdos(b) = vdos(b) + dos
              end if
           end do
        end do
     end do
  end do

  return
end subroutine DOS__calc_Histogram

subroutine DOS__calc_Gaussian( vdos, vE, n_npao )
  use ac_misc_module
  implicit none
  integer, intent(in) :: n_npao
  real(8), intent(out) :: vdos(Param%DOS%Ne)
  real(8), intent(in)  :: vE(Param%DOS%Nka, Param%DOS%Nkb, Param%DOS%Nkc, n_npao)

  integer :: ika, ikb, ikc, m, b, bs, be
  real(8) :: E
  real(8) :: dos,pdbe_t

  do m=1, n_npao
     do ikc=1, Param%DOS%Nkc
        do ikb=1, Param%DOS%Nkb
           do ika=1, Param%DOS%Nka
              E = vE(ika,ikb,ikc,m)
              do b=1, Param%DOS%Ne
                 if( 0<b .and. b<=Param%DOS%Ne ) then
                    call Param__DOS__binEnergy(pdbe_t,b)
                    call DOS__gaussian( dos, pdbe_t, E, Param%DOS%GB )
                    vdos(b) = vdos(b) + dos
                 end if
              end do
           end do
        end do
     end do
  end do

  return
end subroutine DOS__calc_Gaussian

subroutine DOS__calc_Tetrahedron( vdos, vE, n_npao )
  use ac_misc_module
  implicit none
  integer, intent(in) :: n_npao
  real(8), intent(out) :: vdos(Param%DOS%Ne)
  real(8), intent(in)  :: vE(Param%DOS%Nka, Param%DOS%Nkb, Param%DOS%Nkc, n_npao )

  integer :: ika, ikb, ikc, m, t, n, l
  integer :: jka, jkb, jkc, j
  integer :: b, bs, be

  real(8) :: E(4), work
  real(8) :: dos,pdbe_t

  integer       :: index(4,6)
  index(:,1) = (/ 0,2,1,5 /)
  index(:,2) = (/ 3,1,2,5 /)
  index(:,3) = (/ 0,4,2,5 /)
  index(:,4) = (/ 6,2,4,5 /)
  index(:,5) = (/ 3,2,7,5 /)
  index(:,6) = (/ 6,7,2,5 /)

  do m=1, n_npao
     do ikc=1, Param%DOS%Nkc
        do ikb=1, Param%DOS%Nkb
           do ika=1, Param%DOS%Nka
              do t=1, 6
                 do n=1, 4
                    j = index(n,t)
                    !!                    jka = mod(ika+mod(j/4,2),Param%DOS%Nka)
                    !!                    jkb = mod(ikb+mod(j/2,2),Param%DOS%Nkb)
                    !!                    jkc = mod(ikc+mod(j/1,2),Param%DOS%Nkc)
                    jka = modp(ika+mod(j/4,2),Param%DOS%Nka)
                    jkb = modp(ikb+mod(j/2,2),Param%DOS%Nkb)
                    jkc = modp(ikc+mod(j/1,2),Param%DOS%Nkc)

                    E(n)  = vE(jka,jkb,jkc,m)
                 end do

                 do n=1, 4
                    do l=n+1, 4
                       if( E(n) > E(l) ) then
                          work = E(n)
                          E(n) = E(l)
                          E(l) = work
                       end if
                    end do
                 end do

                 call Param__DOS__binIndex(bs,E(1))
                 call Param__DOS__binIndex(be,E(4))

                 do b=bs, be
                    if( 0<b .and. b<=Param%DOS%Ne ) then
                       call Param__DOS__binEnergy(pdbe_t,b)
                       call DOS__tetrahedron( dos, pdbe_t, E )
                       vdos(b) = vdos(b) + dos
                    end if
                 end do

              end do
           end do
        end do
     end do
  end do

  return
end subroutine DOS__calc_Tetrahedron

subroutine DOS__histogram( dos, E, E1, Esigma )
  use ac_misc_module

  implicit none
  real(8), intent(in) :: E, E1, Esigma
  real(8), intent(out) :: dos

  if( E1-0.5*Esigma/2<=E .and. E<E1+0.5*Esigma ) then
     dos = 1.0/Esigma
  else
     dos = 0.0
  end if

  return
end subroutine DOS__histogram

subroutine DOS__gaussian( dos, E, E1, Esigma )
  use ac_misc_module

  implicit none
  real(8), intent(in) :: E, E1, Esigma
  real(8), intent(out) :: dos

  dos = 0.5*M_SQRT1_2*M_2_SQRTPI/Esigma*exp(-0.5*(E-E1)**2/Esigma**2)

  return
end subroutine DOS__gaussian

subroutine DOS__tetrahedron( dos, E, vE )
  use ac_misc_module

  implicit none
  real(8), intent(in) :: E, vE(4)
  real(8), intent(out) :: dos

  if( E < vE(1) ) then
     dos = 0.d0
  else if( vE(1)<=E .and. E<vE(2) ) then
     dos = &
          + 0.5*(E-vE(1))*(E-vE(1))/((vE(2)-vE(1))*(vE(3)-vE(1)))/(vE(4)-vE(1))
  else if( vE(2)<=E .and. E<vE(3) ) then
     dos = &
          + 0.5*(E-vE(1))*(E-vE(1))/((vE(2)-vE(1))*(vE(3)-vE(1)))/(vE(4)-vE(1)) &
          - 0.5*(E-vE(2))*(E-vE(2))/((vE(2)-vE(1))*(vE(3)-vE(2)))/(vE(4)-vE(2))
  else if( vE(3)<=E .and. E<vE(4) ) then
     dos = &
          + 0.5*(E-vE(4))*(E-vE(4))/((vE(4)-vE(2))*(vE(4)-vE(3)))/(vE(4)-vE(1))
  else
     dos = 0.d0
  end if

  return
end subroutine DOS__tetrahedron

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Naoki WATANABE, Nobutaka NISHIKAWA (Mizuho I.R.)   @@ !
! @@             Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine Hartree__PhiK(PhiK,kk)
  use ac_parameter
  implicit none
  real(8), intent(in)  :: kk
  real(8), intent(out) :: PhiK

  if(kk<1.d-14) then
     PhiK = 0.d0
  else
     PhiK = 4.d0*M_PI/kk
  end if

  return
end subroutine Hartree__PhiK

subroutine HartreeLS__calcPotential( Ehar, Vhar, rhoLS, rhoval )
  use ac_parameter
  implicit none
  real(8), intent(out) :: Ehar
  real(8), intent(out) :: Vhar(Param%Cell%Na, Param%Cell%Nb, Param%Cell%Nc)
  complex(8), intent(in)  :: rhoLS(Param%Option%nspin,Param%Cell%Na, Param%Cell%Nb, Param%Cell%Nc)
  real(8), intent(in)  :: rhoval(Param%Cell%Na, Param%Cell%Nb, Param%Cell%Nc)

  integer :: ia, ib, ic
  integer :: ika, ikb, ikc
  real(8) :: kk
  real(8) :: K(3)
  real(8) :: phi, c
  real(8) :: rhoKr, rhoKi, workr, worki
  real(8), allocatable :: rhoK(:,:,:)   

  allocate( rhoK(2*(Param%Cell%Na/2+1),Param%Cell%Nb,Param%Cell%Nc) )

  if( Param%Option%na ) then
     do ic=1, Param%Cell%Nc
        do ib=1, Param%Cell%Nb
           do ia=1, Param%Cell%Na
              rhoK(ia,ib,ic) = &
                   dreal(rhoLS(1,ia,ib,ic)) + dreal(rhoLS(4,ia,ib,ic)) - rhoval(ia,ib,ic)
           end do
        end do
     end do
  else
     do ic=1, Param%Cell%Nc
        do ib=1, Param%Cell%Nb
           do ia=1, Param%Cell%Na
              rhoK(ia,ib,ic) = dreal(rhoLS(1,ia,ib,ic)) + dreal(rhoLS(4,ia,ib,ic))
           end do
        end do
     end do
  end if

  call RFFT3D__forward( &
       Param%Cell%Na, Param%Cell%Nb, Param%Cell%Nc, &
       rhoK, rhoK )

  Ehar = 0.d0
  c = 1.d0/(Param%Cell%Na*Param%Cell%Nb*Param%Cell%Nc)

  do ikc=1, Param%Cell%Nc
     do ikb=1, Param%Cell%Nb
        do ika=1, Param%Cell%Na/2+1
           call Param__Cell__K(K,ika,ikb,ikc)
           kk = dot_product(K,K)

           if( Param%Option%cluster ) then
              call Hartree__PhiK(phi,kk)
              phi = c*(phi+Screening%PhiK(2*ika-1,ikb,ikc))
           else
              call Hartree__PhiK(phi,kk)
              phi = c*phi
           end if

           rhoKr = rhoK(2*ika-1,ikb,ikc)
           rhoKi = rhoK(2*ika-0,ikb,ikc)
           workr = rhoKr*phi
           worki = rhoKi*phi

           if( ika == 1 ) then
              Ehar = Ehar + (rhoKr*workr+rhoKi*worki)
           else
              Ehar = Ehar + (rhoKr*workr+rhoKi*worki)*2
           end if

           rhoK(2*ika-1,ikb,ikc) = workr
           rhoK(2*ika-0,ikb,ikc) = worki
        end do
     end do
  end do

  call RFFT3D__backward( &
       Param%Cell%Na, Param%Cell%Nb, Param%Cell%Nc, &
       rhoK, Vhar )

  Ehar = Ehar*0.5d0*Param%Cell%dV

  deallocate( rhoK )

  return
end subroutine HartreeLS__calcPotential

subroutine Hartree__calcPotential( Ehar, Vhar, rho, rhoval )
  use ac_parameter
  implicit none
  real(8), intent(out) :: Ehar
  real(8), intent(out) :: Vhar(Param%Cell%Na, Param%Cell%Nb, Param%Cell%Nc)
  real(8), intent(in)  :: rho(Param%Option%nspin,Param%Cell%Na, Param%Cell%Nb, Param%Cell%Nc)
  real(8), intent(in)  :: rhoval(Param%Cell%Na, Param%Cell%Nb, Param%Cell%Nc)

  integer :: ia, ib, ic
  integer :: ika, ikb, ikc
  real(8) :: kk
  real(8) :: K(3)
  real(8) :: phi, c
  real(8) :: rhoKr, rhoKi, workr, worki
  real(8), allocatable :: rhoK(:,:,:)   

  allocate( rhoK(2*(Param%Cell%Na/2+1),Param%Cell%Nb,Param%Cell%Nc) )

  if( Param%Option%na ) then
     do ic=1, Param%Cell%Nc
        do ib=1, Param%Cell%Nb
           do ia=1, Param%Cell%Na
              rhoK(ia,ib,ic) = sum(rho(:,ia,ib,ic)) - rhoval(ia,ib,ic)
           end do
        end do
     end do
  else
     do ic=1, Param%Cell%Nc
        do ib=1, Param%Cell%Nb
           do ia=1, Param%Cell%Na
              rhoK(ia,ib,ic) = sum(rho(:,ia,ib,ic))
           end do
        end do
     end do
  end if

  call RFFT3D__forward( &
       Param%Cell%Na, Param%Cell%Nb, Param%Cell%Nc, &
       rhoK, rhoK )

  Ehar = 0.d0
  c = 1.d0/(Param%Cell%Na*Param%Cell%Nb*Param%Cell%Nc)

  do ikc=1, Param%Cell%Nc
     do ikb=1, Param%Cell%Nb
        do ika=1, Param%Cell%Na/2+1
           call Param__Cell__K(K,ika,ikb,ikc)
           kk = dot_product(K,K)

           if( Param%Option%cluster ) then
              call Hartree__PhiK(phi,kk)
              phi = c*(phi+Screening%PhiK(2*ika-1,ikb,ikc))
           else
              call Hartree__PhiK(phi,kk)
              phi = c*phi
           end if

           rhoKr = rhoK(2*ika-1,ikb,ikc)
           rhoKi = rhoK(2*ika-0,ikb,ikc)
           workr = rhoKr*phi
           worki = rhoKi*phi

           if( ika == 1 ) then
              Ehar = Ehar + (rhoKr*workr+rhoKi*worki)
           else
              Ehar = Ehar + (rhoKr*workr+rhoKi*worki)*2
           end if

           rhoK(2*ika-1,ikb,ikc) = workr
           rhoK(2*ika-0,ikb,ikc) = worki
        end do
     end do
  end do

  call RFFT3D__backward( &
       Param%Cell%Na, Param%Cell%Nb, Param%Cell%Nc, &
       rhoK, Vhar )

  Ehar = Ehar*0.5d0*Param%Cell%dV

  deallocate( rhoK )

  return
end subroutine Hartree__calcPotential

subroutine Hartree__calcEnergy1( Ehar, rhoval )
  use ac_parameter

  implicit none
  real(8), intent(out) :: Ehar
  real(8), intent(in)  :: rhoval(Param%Cell%Na, Param%Cell%Nb, Param%Cell%Nc)

  integer        :: ika, ikb, ikc
  real(8)  :: kk
  real(8) :: K(3)
  real(8)  :: phi, c
  real(8)  :: rhoKr, rhoKi, workr, worki
  integer :: ia, ib, ic

  real(8), allocatable :: rhoK(:,:,:)   

  allocate( rhoK(2*(Param%Cell%Na/2+1),Param%Cell%Nb,Param%Cell%Nc) )

  do ic=1, Param%Cell%Nc
     do ib=1, Param%Cell%Nb
        do ia=1, Param%Cell%Na
           rhoK(ia,ib,ic) = rhoval(ia,ib,ic)
        end do
     end do
  end do

  call RFFT3D__forward( &
       Param%Cell%Na, Param%Cell%Nb, Param%Cell%Nc, &
       rhoK, rhoK )

  Ehar = 0.d0
  c = 1.d0/(Param%Cell%Na*Param%Cell%Nb*Param%Cell%Nc)

  do ikc=1, Param%Cell%Nc
     do ikb=1, Param%Cell%Nb
        do ika=1, Param%Cell%Na/2+1
           call Param__Cell__K(K,ika,ikb,ikc)
           kk = dot_product(K,K)

           if( Param%Option%cluster ) then
              call Hartree__PhiK(phi,kk)
              phi = c*(phi+Screening%PhiK(2*ika-1,ikb,ikc))
           else
              call Hartree__PhiK(phi,kk)
              phi = c*phi
           end if

           rhoKr = rhoK(2*ika-1,ikb,ikc)
           rhoKi = rhoK(2*ika-0,ikb,ikc)
           workr = rhoKr*phi
           worki = rhoKi*phi

           if( ika == 1 ) then
              Ehar = Ehar + (rhoKr*workr+rhoKi*worki)
           else
              Ehar = Ehar + (rhoKr*workr+rhoKi*worki)*2
           end if
        end do
     end do
  end do

  Ehar = Ehar*0.5d0*Param%Cell%dV

  deallocate( rhoK )

  return
end subroutine Hartree__calcEnergy1

subroutine HartreeLS__calcEnergy2( Ehar, rhoLS )
  use ac_parameter

  implicit none
  real(8), intent(out) :: Ehar
  complex(8), intent(in)  :: rhoLS(Param%Option%nspin,Param%Cell%Na, Param%Cell%Nb, Param%Cell%Nc)

  integer :: ika, ikb, ikc
  real(8) :: kk
  real(8) :: K(3)
  real(8) :: phi, c
  real(8) :: rhoKr, rhoKi, workr, worki
  integer :: ia, ib, ic

  real(8), allocatable :: rhoK(:,:,:)   

  allocate( rhoK(2*(Param%Cell%Na/2+1),Param%Cell%Nb,Param%Cell%Nc) )

  do ic=1, Param%Cell%Nc
     do ib=1, Param%Cell%Nb
        do ia=1, Param%Cell%Na
           rhoK(ia,ib,ic) = dreal(rhoLS(1,ia,ib,ic)) + dreal(rhoLS(4,ia,ib,ic))
        end do
     end do
  end do

  call RFFT3D__forward( &
       Param%Cell%Na, Param%Cell%Nb, Param%Cell%Nc, &
       rhoK, rhoK )

  Ehar = 0.d0
  c = 1.d0/(Param%Cell%Na*Param%Cell%Nb*Param%Cell%Nc)

  do ikc=1, Param%Cell%Nc
     do ikb=1, Param%Cell%Nb
        do ika=1, Param%Cell%Na/2+1
           call Param__Cell__K(K,ika,ikb,ikc)
           kk = dot_product(K,K)

           if( Param%Option%cluster ) then
              call Hartree__PhiK(phi,kk)
              phi = c*(phi+Screening%PhiK(2*ika-1,ikb,ikc))
           else
              call Hartree__PhiK(phi,kk)
              phi = c*phi
           end if

           rhoKr = rhoK(2*ika-1,ikb,ikc)
           rhoKi = rhoK(2*ika-0,ikb,ikc)
           workr = rhoKr*phi
           worki = rhoKi*phi

           if( ika == 1 ) then
              Ehar = Ehar + (rhoKr*workr+rhoKi*worki)
           else
              Ehar = Ehar + (rhoKr*workr+rhoKi*worki)*2
           end if
        end do
     end do
  end do

  Ehar = Ehar*0.5d0*Param%Cell%dV

  deallocate( rhoK )

  return
end subroutine HartreeLS__calcEnergy2

subroutine Hartree__calcEnergy2( Ehar, rho )
  use ac_parameter

  implicit none
  real(8), intent(out) :: Ehar
  real(8), intent(in)  :: rho(Param%Option%nspin,Param%Cell%Na, Param%Cell%Nb, Param%Cell%Nc)

  integer :: ika, ikb, ikc
  real(8) :: kk
  real(8) :: K(3)
  real(8) :: phi, c
  real(8) :: rhoKr, rhoKi, workr, worki
  integer :: ia, ib, ic

  real(8), allocatable :: rhoK(:,:,:)   

  allocate( rhoK(2*(Param%Cell%Na/2+1),Param%Cell%Nb,Param%Cell%Nc) )

  if( Param%Option%spin_orbit ) then
     do ic=1, Param%Cell%Nc
        do ib=1, Param%Cell%Nb
           do ia=1, Param%Cell%Na
              rhoK(ia,ib,ic) = rho(1,ia,ib,ic) + rho(4,ia,ib,ic)
           end do
        end do
     end do
  else
     do ic=1, Param%Cell%Nc
        do ib=1, Param%Cell%Nb
           do ia=1, Param%Cell%Na
              rhoK(ia,ib,ic) = sum(rho(:,ia,ib,ic))
           end do
        end do
     end do
  end if

  call RFFT3D__forward( &
       Param%Cell%Na, Param%Cell%Nb, Param%Cell%Nc, &
       rhoK, rhoK )

  Ehar = 0.d0
  c = 1.d0/(Param%Cell%Na*Param%Cell%Nb*Param%Cell%Nc)

  do ikc=1, Param%Cell%Nc
     do ikb=1, Param%Cell%Nb
        do ika=1, Param%Cell%Na/2+1
           call Param__Cell__K(K,ika,ikb,ikc)
           kk = dot_product(K,K)

           if( Param%Option%cluster ) then
              call Hartree__PhiK(phi,kk)
              phi = c*(phi+Screening%PhiK(2*ika-1,ikb,ikc))
           else
              call Hartree__PhiK(phi,kk)
              phi = c*phi
           end if

           rhoKr = rhoK(2*ika-1,ikb,ikc)
           rhoKi = rhoK(2*ika-0,ikb,ikc)
           workr = rhoKr*phi
           worki = rhoKi*phi

           if( ika == 1 ) then
              Ehar = Ehar + (rhoKr*workr+rhoKi*worki)
           else
              Ehar = Ehar + (rhoKr*workr+rhoKi*worki)*2
           end if
        end do
     end do
  end do

  Ehar = Ehar*0.5d0*Param%Cell%dV

  deallocate( rhoK )

  return
end subroutine Hartree__calcEnergy2

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

module fft

  implicit none
  integer :: ix_fft,iy_fft,iz_fft,iz_fft_l,iz_fft_r
  complex(8), pointer :: wxn(:),wyn(:),wzn(:),wxn_i(:),wyn_i(:),wzn_i(:)
  complex(8), pointer :: fft1(:),fft2(:),fft3(:)

contains
  subroutine alo_fft_1(n_a,n_b)

    implicit none
    integer, intent(in) :: n_a,n_b
    integer :: i_do,ier
    real(8) :: theta

    allocate(wxn(n_a),wyn(n_b),wxn_i(n_a),wyn_i(n_b),stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_fft_1'
       stop
    end if

    theta=2.d0*(datan(1.d0)*4.d0)/dfloat(n_a)
    do i_do=0,n_a-1
       wxn(i_do+1)=dcmplx(dcos(theta*dfloat(i_do)),dsin(theta*dfloat(i_do)))
    end do
    theta=2.d0*(datan(1.d0)*4.d0)/dfloat(n_b)
    do i_do=0,n_b-1
       wyn(i_do+1)=dcmplx(dcos(theta*dfloat(i_do)),dsin(theta*dfloat(i_do)))
    end do

    theta=-2.d0*(datan(1.d0)*4.d0)/dfloat(n_a)
    do i_do=0,n_a-1
       wxn_i(i_do+1)=dcmplx(dcos(theta*dfloat(i_do)),dsin(theta*dfloat(i_do)))
    end do
    theta=-2.d0*(datan(1.d0)*4.d0)/dfloat(n_b)
    do i_do=0,n_b-1
       wyn_i(i_do+1)=dcmplx(dcos(theta*dfloat(i_do)),dsin(theta*dfloat(i_do)))
    end do

    return
  end subroutine alo_fft_1

  subroutine alo_fft_21(n_a)

    implicit none
    integer, intent(in) :: n_a
    integer :: ier

    allocate(fft1(n_a),stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_fft_21'
       stop
    end if

    return
  end subroutine alo_fft_21

  subroutine alo_fft_22(n_b)

    implicit none
    integer, intent(in) :: n_b
    integer :: ier

    allocate(fft2(n_b),stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_fft_22'
       stop
    end if

    return
  end subroutine alo_fft_22

  subroutine unset_fft_1

    implicit none
    integer :: ier

    deallocate(wxn,wyn,wxn_i,wyn_i,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error deallocate: unset_unset_fft'
       stop
    end if

    return
  end subroutine unset_fft_1

  subroutine unset_fft_21

    implicit none
    integer :: ier

    deallocate(fft1,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error deallocate: unset_unset_fft21'
       stop
    end if

    return
  end subroutine unset_fft_21

  subroutine unset_fft_22

    implicit none
    integer :: ier

    deallocate(fft2,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error deallocate: unset_unset_fft22'
       stop
    end if

    return
  end subroutine unset_fft_22

  subroutine alo_fft_zz(n_c)

    implicit none
    integer, intent(in) :: n_c
    integer :: i_do,ier
    real(8) :: theta

    allocate(fft3(n_c),wzn(n_c),wzn_i(n_c),stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_fft_zz'
       stop
    end if

    theta=2.d0*(datan(1.d0)*4.d0)/dfloat(n_c)
    do i_do=0,n_c-1
       wzn(i_do+1)=dcmplx(dcos(theta*dfloat(i_do)),dsin(theta*dfloat(i_do)))
    end do
    theta=-2.d0*(datan(1.d0)*4.d0)/dfloat(n_c)
    do i_do=0,n_c-1
       wzn_i(i_do+1)=dcmplx(dcos(theta*dfloat(i_do)),dsin(theta*dfloat(i_do)))
    end do

    return
  end subroutine alo_fft_zz

  subroutine unset_fft_zz

    implicit none
    integer :: ier

    deallocate(fft3,wzn,wzn_i,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_fft_zz'
       stop
    end if

    return
  end subroutine unset_fft_zz

end module fft

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine set_hami_c_cc_scf(ispin)

  use condition_ini
  use hamiltonian_sgf
  use hamiltonian_c
  use hamiltonian_temp
  use scf_negf

  implicit none
  integer, intent(in) :: ispin
  integer :: i_do,j_do

  do j_do=1,m_mat_max_c
     do i_do=1,m_mat_max_c
        hcc_mat(i_do,j_do)=h_cc_scf(ispin,i_do,j_do)
     end do
  end do
  do j_do=1,m_mat_max_c
     do i_do=1,m_mat_max_c
        scc_mat(i_do,j_do)=s_cc_scf(i_do,j_do)
     end do
  end do

  return
end subroutine set_hami_c_cc_scf

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine set_fft

  use scf_negf
  use fft

  implicit none
  integer :: i_do,j_do,i_temp,j_temp,ier
  integer, allocatable :: n(:)

  call alo_fft_1(n_a,n_b)
  call alo_fft_21(n_a)
  call alo_fft_22(n_b)

  if( ft_switch == 'fft' ) then
     return
  end if

  allocate(n(4),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: set_fft'
     stop
  end if

  n(1)=7
  n(2)=5
  n(3)=3
  n(4)=2

  i_temp=n_a
  ix_fft=1
  j_temp=1
  do j_do=1,100
     do i_do=1,4
        if( mod(i_temp,n(i_do)) == 0 ) then
           if( ix_fft > j_temp ) then
              j_temp=j_temp*n(i_do)
           else
              ix_fft=ix_fft*n(i_do)
           end if
           i_temp=i_temp/n(i_do)
           exit
        end if
     end do
     if( i_temp == 1 ) then
        exit
     end if
  end do

  i_temp=n_b
  iy_fft=1
  j_temp=1
  do j_do=1,100
     do i_do=1,4
        if( mod(i_temp,n(i_do)) == 0 ) then
           if( iy_fft > j_temp ) then
              j_temp=j_temp*n(i_do)
           else
              iy_fft=iy_fft*n(i_do)
           end if
           i_temp=i_temp/n(i_do)
           exit
        end if
     end do
     if( i_temp == 1 ) then
        exit
     end if
  end do

  i_temp=n_c
  iz_fft=1
  j_temp=1
  do j_do=1,100
     do i_do=1,4
        if( mod(i_temp,n(i_do)) == 0 ) then
           if( iz_fft > j_temp ) then
              j_temp=j_temp*n(i_do)
           else
              iz_fft=iz_fft*n(i_do)
           end if
           i_temp=i_temp/n(i_do)
           exit
        end if
     end do
     if( i_temp == 1 ) then
        exit
     end if
  end do

  i_temp=n_c_l
  iz_fft_l=1
  j_temp=1
  do j_do=1,100
     do i_do=1,4
        if( mod(i_temp,n(i_do)) == 0 ) then
           if( iz_fft_l > j_temp ) then
              j_temp=j_temp*n(i_do)
           else
              iz_fft_l=iz_fft_l*n(i_do)
           end if
           i_temp=i_temp/n(i_do)
           exit
        end if
     end do
     if( i_temp == 1 ) then
        exit
     end if
  end do

  i_temp=n_c_r
  iz_fft_r=1
  j_temp=1
  do j_do=1,100
     do i_do=1,4
        if( mod(i_temp,n(i_do)) == 0 ) then
           if( iz_fft_r > j_temp ) then
              j_temp=j_temp*n(i_do)
           else
              iz_fft_r=iz_fft_r*n(i_do)
           end if
           i_temp=i_temp/n(i_do)
           exit
        end if
     end do
     if( i_temp == 1 ) then
        exit
     end if
  end do

  deallocate(n,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: set_fft'
     stop
  end if

  return
end subroutine set_fft

subroutine unset_fft

  use scf_negf
  use fft

  call unset_fft_1
  call unset_fft_21
  call unset_fft_22

  return
end subroutine unset_fft

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine made_fourier_arb(fft,wn,number)

  implicit none
  integer, intent(in) :: number
  complex(8), intent(inout) :: fft(number),wn(number)

  integer :: i_do,ier,num_temp,i_mul
  complex(8), allocatable :: fft_temp1(:)

  allocate(fft_temp1(number),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: fft'
     stop
  end if

  do i_do=1,number
     fft_temp1(i_do)=fft(i_do)
  end do

  num_temp=number
  i_mul=1
  call fft_recur(fft_temp1,wn,num_temp,number,i_mul)

  do i_do=1,number
     fft(i_do)=fft_temp1(i_do)
  end do

  deallocate(fft_temp1,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error deallocate: fft'
     stop
  end if

  return
end subroutine made_fourier_arb
recursive subroutine fft_recur(fft_temp1,wn,number,number_hold,i_mul)

  implicit none
  integer, intent(in) :: number,number_hold,i_mul
  complex(8), intent(inout) :: fft_temp1(number),wn(number_hold)

  integer :: n1,n2
  integer :: j1,j2,k1,k2,i1_do,ier,i_temp
  complex(8), allocatable :: fft_temp2(:),fft_temp3(:)

  if( number <= 1 ) then
     return
  end if

  n2=2
  do i1_do=1,number
     if( mod(number,n2) == 0 ) then
        exit
     end if
     n2=n2+1
  end do

  n1=number/n2

  allocate(fft_temp2(n1),fft_temp3(number),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: fft'
     stop
  end if

  i_temp=i_mul*n2
  do k1=0,n2-1
     do k2=0,n1-1
        fft_temp2(k2+1)=fft_temp1(k2*n2+k1+1)
     end do
     call fft_recur(fft_temp2,wn,n1,number_hold,i_temp)
     do k2=0,n1-1
        fft_temp3(k2*n2+k1+1)=fft_temp2(k2+1)
     end do
  end do

  deallocate(fft_temp2,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error deallocate: fft'
     stop
  end if

  do i1_do=1,number
     fft_temp1(i1_do)=dcmplx(0.d0,0.d0)
  end do
  do j1=0,n1-1
     do j2=0,n2-1
        do k1=0,n2-1
           i_temp=(j2*n1+j1)*k1*i_mul+1
           do i1_do=1,number_hold
              if( i_temp > number_hold ) then
                 i_temp=i_temp-number_hold
              else
                 exit
              end if
           end do
           fft_temp1(j2*n1+j1+1)=fft_temp1(j2*n1+j1+1)                            &
                +wn(i_temp)*fft_temp3(j1*n2+k1+1)
        end do
     end do
  end do

  deallocate(fft_temp3,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error deallocate: fft'
     stop
  end if

  return
end subroutine fft_recur

subroutine made_dft(fft_in,fft_out,r,p,number,i_dim,isign)

  implicit none
  integer, intent(in) :: number,i_dim,isign
  real(8), intent(in) :: r(i_dim,number),p(i_dim,number)
  complex(8), intent(in) :: fft_in(number)
  complex(8), intent(out) :: fft_out(number)

  integer :: i1_do,i2_do,i3_do
  real(8) :: theta
  complex(8) :: rot

  do i1_do=1,number
     fft_out(i1_do)=dcmplx(0.d0,0.d0)
  end do
  do i2_do=1,number
     do i1_do=1,number
        theta=0.d0
        do i3_do=1,i_dim
           theta=theta+r(i3_do,i1_do)*p(i3_do,i2_do)
        end do
        rot=dcmplx(dcos(theta),dfloat(isign)*dsin(theta))
        fft_out(i2_do)=fft_out(i2_do)+fft_in(i1_do)*rot
     end do
  end do

  return
end subroutine made_dft

subroutine made_fourier(fft,wn,number,n1)

  implicit none
  integer, intent(in) :: number,n1
  complex(8), intent(in) :: wn(number)
  complex(8), intent(inout) :: fft(number)

  integer :: n2
  complex(8), allocatable :: fft_temp(:)

  integer :: j0,j1,k0,k1,i_do,ier

  n2=number/n1

  allocate(fft_temp(number),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: fft'
     stop
  end if

  do j0=1,number
     fft_temp(j0)=dcmplx(0.d0,0.d0)
  end do

  do j0=0,n1-1
     do k0=0,n2-1
        do k1=0,n1-1
           j1=j0*k1*n2+1
           do i_do=1,number
              if( j1 > number ) then
                 j1=j1-number
              else
                 exit
              end if
           end do
           fft_temp(j0*n2+k0+1)=fft_temp(j0*n2+k0+1)+fft(k1*n2+k0+1)*wn(j1)
        end do
     end do
  end do

  do j0=1,number
     fft(j0)=dcmplx(0.d0,0.d0)
  end do

  do j0=0,n1-1
     do j1=0,n2-1
        do k0=0,n2-1
           k1=(j1*n1+j0)*k0+1
           do i_do=1,number
              if( k1 > number ) then
                 k1=k1-number
              else
                 exit
              end if
           end do
           fft(j1*n1+j0+1)=fft(j1*n1+j0+1)+fft_temp(j0*n2+k0+1)*wn(k1)
        end do
     end do
  end do

  deallocate(fft_temp,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error deallocate: fft'
     stop
  end if

  return
end subroutine made_fourier

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Naoki WATANABE, Nobutaka NISHIKAWA (Mizuho I.R.)   @@ !
! @@             Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine ExchangeLS__calcPotential( Exc, Vxc, rhoLS, rhopcc )
  use ac_parameter
  implicit none
  real(8), intent(out) :: Exc
  real(8), intent(out) :: Vxc(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)
  complex(8), intent(inout) :: rhoLS(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)
  real(8), intent(in)  :: rhopcc(Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)

  type(SpinMatrix_type), pointer :: U(:,:,:)
  type(SpinMatrix_type) :: M
  complex(8), parameter :: CI = ( 0.0d0, 1.0d0 )
  integer :: ia, ib, ic

  if( Param%Option%spin_orbit ) then
     allocate( U   (Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc) )

     do ic=1, Param%Cell%Nc    
        do ib=1, Param%Cell%Nb
           do ia=1, Param%Cell%Na
              M%element(1,1) = dreal(rhoLS(1,ia,ib,ic))
              M%element(2,1) = (rhoLS(2,ia,ib,ic)+dconjg(rhoLS(3,ia,ib,ic)))*.5d0
              M%element(1,2) = dconjg(M%element(2,1))
              M%element(2,2) = dreal(rhoLS(4,ia,ib,ic))
              call ExchangeLS__diagonalize( M, U(ia,ib,ic) )
              rhoLS(1,ia,ib,ic) = dreal(M%element(1,1))
              rhoLS(2,ia,ib,ic) = 0.0d0
              rhoLS(3,ia,ib,ic) = 0.0d0
              rhoLS(4,ia,ib,ic) = dreal(M%element(2,2))
           end do
        end do
     end do
  end if

  Exc = 0.0    
  select case( Param%SCF%exc_type )
  case('PZ81')
     call ExchangeLS__calcPotentialPZ81(Exc,Vxc,rhoLS,rhopcc)
  case('PW91')
     call ExchangeLS__calcPotentialPW91(Exc,Vxc,rhoLS,rhopcc)
  case('PBE')
     call ExchangeLS__calcPotentialPBE (Exc,Vxc,rhoLS,rhopcc)
  end select

  if( Param%Option%spin_orbit ) then
     do ic=1, Param%Cell%Nc    
        do ib=1, Param%Cell%Nb
           do ia=1, Param%Cell%Na
              M%element(1,1) = rhoLS(1,ia,ib,ic)
              M%element(2,1) = 0.0d0
              M%element(1,2) = 0.0d0
              M%element(2,2) = rhoLS(4,ia,ib,ic)
              call ExchangeLS__undiagonalize( U(ia,ib,ic),  M )
              rhoLS(1,ia,ib,ic) = M%element(1,1)
              rhoLS(2,ia,ib,ic) = M%element(2,1)
              rhoLS(3,ia,ib,ic) = M%element(1,2)
              rhoLS(4,ia,ib,ic) = M%element(2,2)


              M%element(1,1) = Vxc(1,ia,ib,ic)
              M%element(2,1) = 0.0d0
              M%element(1,2) = 0.0d0
              M%element(2,2) = Vxc(4,ia,ib,ic)
              call ExchangeLS__undiagonalize( U(ia,ib,ic),  M )
              Vxc(1,ia,ib,ic) = dreal(M%element(1,1))
              Vxc(2,ia,ib,ic) = dreal(M%element(2,1))
              Vxc(3,ia,ib,ic) = dimag(M%element(2,1))
              Vxc(4,ia,ib,ic) = dreal(M%element(2,2))
           end do
        end do
     end do

     deallocate( U )
  end if

  return
end subroutine ExchangeLS__calcPotential

subroutine Exchange__calcPotential( Exc, Vxc, rho, rhopcc )
  use ac_parameter
  implicit none
  real(8), intent(out) :: Exc
  real(8), intent(out) :: Vxc(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)
  real(8), intent(inout) :: rho(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)
  real(8), intent(in)  :: rhopcc(Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)
  integer :: ia, ib, ic

  Exc = 0.0    
  select case( Param%SCF%exc_type )
  case('PZ81')
     call Exchange__calcPotentialPZ81(Exc,Vxc,rho,rhopcc)
  case('PW91')
     call Exchange__calcPotentialPW91(Exc,Vxc,rho,rhopcc)
  case('PBE')
     call Exchange__calcPotentialPBE (Exc,Vxc,rho,rhopcc)
  end select

  return
end subroutine Exchange__calcPotential

subroutine ExchangeLS__calcPotentialPZ81( Exc, Vxc, rhoLS, rhopcc )
  use ac_parameter
  implicit none
  real(8), intent(out) :: Exc
  real(8), intent(out) :: Vxc(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)
  complex(8), intent(in)  :: rhoLS(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)
  real(8), intent(in)  :: rhopcc(Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)

  integer :: ia, ib, ic
  real(8) :: rhoat(2), dExc(2), Vxcat(2)

  dExc  = 0.d0
  Vxcat = 0.d0
  rhoat = 0.d0

  Exc = 0.0
  do ic=1, Param%Cell%Nc    
     do ib=1, Param%Cell%Nb
        do ia=1, Param%Cell%Na
           if( Param%Option%pcc ) then
              rhoat(1) = dreal(rhoLS(1,ia,ib,ic)) + 0.5d0*rhopcc(ia,ib,ic)
              rhoat(2) = dreal(rhoLS(4,ia,ib,ic)) + 0.5d0*rhopcc(ia,ib,ic)
           else
              rhoat(1) = dreal(rhoLS(1,ia,ib,ic))
              rhoat(2) = dreal(rhoLS(4,ia,ib,ic))
           end if

           call Exchange__calcPotentialPZ81at2 &
                ( Vxcat(1), Vxcat(2), dExc(1), dExc(2), rhoat(1), rhoat(2) )

           Vxc(1,ia,ib,ic) = Vxcat(1)
           Vxc(4,ia,ib,ic) = Vxcat(2)
           Exc = Exc + dreal(rhoLS(1,ia,ib,ic))*dExc(1) + dreal(rhoLS(4,ia,ib,ic))*dExc(2)
        end do
     end do
  end do

  Exc = Exc*Param%Cell%dV

  return
end subroutine ExchangeLS__calcPotentialPZ81

subroutine Exchange__calcPotentialPZ81( Exc, Vxc, rho, rhopcc )
  use ac_parameter
  implicit none
  real(8), intent(out) :: Exc
  real(8), intent(out) :: Vxc(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)
  real(8), intent(in)  :: rho(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)
  real(8), intent(in)  :: rhopcc(Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)

  integer :: ia, ib, ic
  real(8), allocatable :: rhoat(:)
  real(8), allocatable :: dExc(:), Vxcat(:)

  allocate( rhoat(Param%Option%nspin) )
  allocate( dExc (Param%Option%nspin) )
  allocate( Vxcat(Param%Option%nspin) )

  dExc  = 0.d0
  Vxcat = 0.d0
  rhoat = 0.d0

  Exc = 0.0
  do ic=1, Param%Cell%Nc    
     do ib=1, Param%Cell%Nb
        do ia=1, Param%Cell%Na
           if( Param%Option%pcc ) then
              if( .not. Param%Option%spin_polar ) then
                 rhoat(:) = rho(:,ia,ib,ic) + rhopcc(ia,ib,ic)
              else
                 rhoat(:) = rho(:,ia,ib,ic) + 0.5d0*rhopcc(ia,ib,ic)
              end if
           else
              rhoat(:) = rho(:,ia,ib,ic)
           end if

           if( Param%Option%spin_polar ) then
              call Exchange__calcPotentialPZ81at2 &
                   ( Vxcat(1), Vxcat(2), dExc(1), dExc(2), rhoat(1), rhoat(2) )
           else
              call Exchange__calcPotentialPZ81at1 &
                   ( Vxcat(1), dExc(1), rhoat(1) )
           end if

           Vxc(:,ia,ib,ic) = Vxcat(:)
           Exc = Exc + sum(rho(:,ia,ib,ic)*dExc(:))

        end do
     end do
  end do

  deallocate( rhoat )
  deallocate( dExc  )
  deallocate( Vxcat )

  Exc = Exc*Param%Cell%dV

  return
end subroutine Exchange__calcPotentialPZ81

subroutine ExchangeLS__calcPotentialPW91( Exc, Vxc, rhoLS, rhopcc )
  use ac_parameter
  implicit none
  real(8), intent(out) :: Exc
  real(8), intent(out) :: Vxc(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)
  complex(8), intent(in) :: rhoLS(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)
  real(8), intent(in)  :: rhopcc(Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)

  integer :: ia, ib, ic
  real(8) :: rhoat(2), dExc(2), Vxcat(2)

  dExc  = 0.d0
  Vxcat = 0.d0
  rhoat = 0.d0

  Exc = 0.0
  do ic=1, Param%Cell%Nc    
     do ib=1, Param%Cell%Nb
        do ia=1, Param%Cell%Na
           if( Param%Option%pcc ) then
              rhoat(1) = dreal(rhoLS(1,ia,ib,ic)) + 0.5d0*rhopcc(ia,ib,ic)
              rhoat(2) = dreal(rhoLS(4,ia,ib,ic)) + 0.5d0*rhopcc(ia,ib,ic)
           else
              rhoat(1) = dreal(rhoLS(1,ia,ib,ic))
              rhoat(2) = dreal(rhoLS(4,ia,ib,ic))
           end if

           call Exchange__calcPotentialPW91at2 &
                ( Vxcat(1), Vxcat(2), dExc(1), dExc(2), rhoat(1), rhoat(2) )

           Vxc(1,ia,ib,ic) = Vxcat(1)
           Vxc(4,ia,ib,ic) = Vxcat(2)
           Exc = Exc + dreal(rhoLS(1,ia,ib,ic))*dExc(1) + dreal(rhoLS(4,ia,ib,ic))*dExc(2)
        end do
     end do
  end do

  Exc = Exc*Param%Cell%dV

  return
end subroutine ExchangeLS__calcPotentialPW91

subroutine Exchange__calcPotentialPW91( Exc, Vxc, rho, rhopcc )
  use ac_parameter
  implicit none
  real(8), intent(out) :: Exc
  real(8), intent(out) :: Vxc(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)
  real(8), intent(in)  :: rho(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)
  real(8), intent(in)  :: rhopcc(Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)

  integer :: ia, ib, ic
  real(8), allocatable :: rhoat(:), dExc(:), Vxcat(:)

  allocate( rhoat(Param%Option%nspin) )
  allocate( dExc(Param%Option%nspin) )
  allocate( Vxcat(Param%Option%nspin) )

  dExc  = 0.d0
  Vxcat = 0.d0
  rhoat = 0.d0

  Exc = 0.0
  do ic=1, Param%Cell%Nc    
     do ib=1, Param%Cell%Nb
        do ia=1, Param%Cell%Na
           if( Param%Option%pcc ) then
              if( .not. Param%Option%spin_polar ) then
                 rhoat(:) = rho(:,ia,ib,ic) + rhopcc(ia,ib,ic)
              else
                 rhoat(:) = rho(:,ia,ib,ic) + 0.5d0*rhopcc(ia,ib,ic)
              end if
           else
              rhoat(:) = rho(:,ia,ib,ic)
           end if

           if( Param%Option%spin_polar ) then
              call Exchange__calcPotentialPW91at2 &
                   ( Vxcat(1), Vxcat(2), dExc(1), dExc(2), rhoat(1), rhoat(2) )
           else
              call Exchange__calcPotentialPW91at1 &
                   ( Vxcat(1), dExc(1), rhoat(1) )
           end if

           Vxc(:,ia,ib,ic) = Vxcat(:)
           Exc = Exc + sum(rho(:,ia,ib,ic)*dExc(:))
        end do
     end do
  end do

  Exc = Exc*Param%Cell%dV

  deallocate( rhoat )
  deallocate( dExc )
  deallocate( Vxcat )

  return
end subroutine Exchange__calcPotentialPW91

subroutine ExchangeLS__calcPotentialPBE( Exc, Vxc, rhoLS, rhopcc )
  use ac_parameter
  implicit none
  real(8), intent(out) :: Exc
  real(8), intent(out) :: Vxc(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)
  complex(8), intent(in) :: rhoLS(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)
  real(8), intent(in)  :: rhopcc(Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)

  real(8), allocatable :: rhoK(:,:,:,:) 
  real(8), allocatable :: grhoK(:,:,:,:,:) 
  real(8), allocatable :: gVxcK(:,:,:,:,:) 
  real(8), allocatable :: dgVxcK(:,:,:,:) 

  integer :: spin
  integer :: ia, ib, ic
  real(8) :: rhoat(2), dExc(2), Vxcat(2)
  real(8) :: gVxcKat(3,2), grhoKat(3,2)

  dExc  = 0.d0
  Vxcat = 0.d0
  rhoat = 0.d0
  gVxcKat = 0.d0
  grhoKat = 0.d0

  allocate( rhoK  (  2*(Param%Cell%Na/2+1),Param%Cell%Nb,Param%Cell%Nc, 2) )
  allocate( grhoK (3,2*(Param%Cell%Na/2+1),Param%Cell%Nb,Param%Cell%Nc, 2) )
  allocate( gVxcK (3,2*(Param%Cell%Na/2+1),Param%Cell%Nb,Param%Cell%Nc, 2) )
  allocate( dgVxcK(  2*(Param%Cell%Na/2+1),Param%Cell%Nb,Param%Cell%Nc, 2) )

  do ic=1, Param%Cell%Nc
     do ib=1, Param%Cell%Nb
        do ia=1, Param%Cell%Na
           if( Param%Option%pcc ) then
              rhoK(ia,ib,ic,1) = dreal(rhoLS(1,ia,ib,ic)) + 0.5d0*rhopcc(ia,ib,ic)
              rhoK(ia,ib,ic,2) = dreal(rhoLS(4,ia,ib,ic)) + 0.5d0*rhopcc(ia,ib,ic)
           else
              rhoK(ia,ib,ic,1) = dreal(rhoLS(1,ia,ib,ic))
              rhoK(ia,ib,ic,2) = dreal(rhoLS(4,ia,ib,ic))
           end if
        end do
     end do
  end do

  call Exchange__calcGradient( grhoK(:,:,:,:,1), rhoK(:,:,:,1) )
  call Exchange__calcGradient( grhoK(:,:,:,:,2), rhoK(:,:,:,2) )

  Exc = 0.0
  do ic=1, Param%Cell%Nc    
     do ib=1, Param%Cell%Nb
        do ia=1, Param%Cell%Na
           if( Param%Option%pcc ) then
              rhoat(1) = dreal(rhoLS(1,ia,ib,ic)) + 0.5d0*rhopcc(ia,ib,ic)
              rhoat(2) = dreal(rhoLS(4,ia,ib,ic)) + 0.5d0*rhopcc(ia,ib,ic)
           else
              rhoat(1) = dreal(rhoLS(1,ia,ib,ic))
              rhoat(2) = dreal(rhoLS(4,ia,ib,ic))
           end if

           grhoKat(:,:) = grhoK(:,ia,ib,ic,:)

           call Exchange__calcPotentialPBEat2 &
                ( Vxcat(1), Vxcat(2), &
                dExc(1), dExc(2), gVxcKat(:,1), gVxcKat(:,2), &
                rhoat(1), rhoat(2), grhoKat(:,1), grhoKat(:,2) )

           Vxc(:,ia,ib,ic) = Vxcat(:)
           Exc = Exc + dreal(rhoLS(1,ia,ib,ic))*dExc(1) + dreal(rhoLS(4,ia,ib,ic))*dExc(2)
           gVxcK(:,ia,ib,ic,:) = gVxcKat(:,:)
        end do
     end do
  end do

  call Exchange__calcDivergence( dgVxcK(:,:,:,1), gVxcK(:,:,:,:,1) )
  call Exchange__calcDivergence( dgVxcK(:,:,:,2), gVxcK(:,:,:,:,2) )


  do ic=1, Param%Cell%Nc    
     do ib=1, Param%Cell%Nb
        do ia=1, Param%Cell%Na
           if( Param%Option%pcc ) then
              rhoat(1) = dreal(rhoLS(1,ia,ib,ic)) + 0.5d0*rhopcc(ia,ib,ic)
              rhoat(2) = dreal(rhoLS(4,ia,ib,ic)) + 0.5d0*rhopcc(ia,ib,ic)
           else
              rhoat(1) = dreal(rhoLS(1,ia,ib,ic))
              rhoat(2) = dreal(rhoLS(4,ia,ib,ic))
           end if
           dExc(:)  = dgVxcK(ia,ib,ic,:)
           Vxc(:,ia,ib,ic) = Vxc(:,ia,ib,ic) + dExc(:)
           Exc = Exc + dreal(rhoLS(1,ia,ib,ic))*dExc(1) + dreal(rhoLS(4,ia,ib,ic))*dExc(2)
        end do
     end do
  end do

  Exc = Exc*Param%Cell%dV

  return
end subroutine ExchangeLS__calcPotentialPBE


subroutine Exchange__calcPotentialPBE( Exc, Vxc, rho, rhopcc )
  use ac_parameter
  implicit none
  real(8), intent(out) :: Exc
  real(8), intent(out) :: Vxc(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)
  real(8), intent(in)  :: rho(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)
  real(8), intent(in)  :: rhopcc(Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)

  real(8), allocatable :: rhoK(:,:,:) 
  real(8), allocatable :: grhoK(:,:,:,:,:) 
  real(8), allocatable :: gVxcK(:,:,:,:,:) 
  real(8), allocatable :: dgVxcK(:,:,:,:) 

  integer :: spin
  integer :: ia, ib, ic

  real(8), allocatable :: rhoat(:), dExc(:), Vxcat(:)
  real(8), allocatable :: gVxcKat(:,:), grhoKat(:,:)

  allocate( rhoat(Param%Option%nspin) )
  allocate( dExc(Param%Option%nspin) )
  allocate( Vxcat(Param%Option%nspin) )
  allocate( gVxcKat(3,Param%Option%nspin) )
  allocate( grhoKat(3,Param%Option%nspin) )

  dExc  = 0.d0
  Vxcat = 0.d0
  rhoat = 0.d0
  gVxcKat = 0.d0
  grhoKat = 0.d0

  allocate( rhoK(2*(Param%Cell%Na/2+1),Param%Cell%Nb,Param%Cell%Nc) )
  allocate( grhoK(3,2*(Param%Cell%Na/2+1),Param%Cell%Nb,Param%Cell%Nc,Param%Option%nspin) )
  allocate( gVxcK(3,2*(Param%Cell%Na/2+1),Param%Cell%Nb,Param%Cell%Nc,Param%Option%nspin) )
  allocate( dgVxcK(2*(Param%Cell%Na/2+1),Param%Cell%Nb,Param%Cell%Nc,Param%Option%nspin) )

  do spin=1, Param%Option%nspin

     do ic=1, Param%Cell%Nc
        do ib=1, Param%Cell%Nb
           do ia=1, Param%Cell%Na
              if( Param%Option%pcc ) then
                 if( .not. Param%Option%spin_polar ) then
                    rhoK(ia,ib,ic) = rho(spin,ia,ib,ic) + rhopcc(ia,ib,ic)
                 else
                    rhoK(ia,ib,ic) = rho(spin,ia,ib,ic) + 0.5d0*rhopcc(ia,ib,ic)
                 end if
              else
                 rhoK(ia,ib,ic) = rho(spin,ia,ib,ic)
              end if
           end do
        end do
     end do

     call Exchange__calcGradient( grhoK(:,:,:,:,spin), rhoK )
  end do

  Exc = 0.0
  do ic=1, Param%Cell%Nc    
     do ib=1, Param%Cell%Nb
        do ia=1, Param%Cell%Na
           if( Param%Option%pcc ) then
              if( .not. Param%Option%spin_polar ) then
                 rhoat(:) = rho(:,ia,ib,ic) + rhopcc(ia,ib,ic)
              else
                 rhoat(:) = rho(:,ia,ib,ic) + 0.5d0*rhopcc(ia,ib,ic)
              end if
           else
              rhoat(:) = rho(:,ia,ib,ic)
           end if

           grhoKat(:,:) = grhoK(:,ia,ib,ic,:)

           if( Param%Option%spin_polar ) then
              call Exchange__calcPotentialPBEat2 &
                   ( Vxcat(1), Vxcat(2), &
                   dExc(1), dExc(2), gVxcKat(:,1), gVxcKat(:,2), &
                   rhoat(1), rhoat(2), grhoKat(:,1), grhoKat(:,2) )
           else
              call Exchange__calcPotentialPBEat1 &
                   ( Vxcat(1), &
                   dExc(1), gVxcKat(:,1), &
                   rhoat(1), grhoKat(:,1) )
           end if

           Vxc(:,ia,ib,ic) = Vxcat(:)
           Exc = Exc + sum(rho(:,ia,ib,ic)*dExc(:))
           gVxcK(:,ia,ib,ic,:) = gVxcKat(:,:)
        end do
     end do
  end do

  do spin=1, Param%Option%nspin
     call Exchange__calcDivergence( dgVxcK(:,:,:,spin), gVxcK(:,:,:,:,spin) )
  end do

  do ic=1, Param%Cell%Nc    
     do ib=1, Param%Cell%Nb
        do ia=1, Param%Cell%Na
           if( Param%Option%pcc ) then
              if( .not. Param%Option%spin_polar ) then
                 rhoat(:) = rho(:,ia,ib,ic) + rhopcc(ia,ib,ic)
              else
                 rhoat(:) = rho(:,ia,ib,ic) + 0.5d0*rhopcc(ia,ib,ic)
              end if
           else
              rhoat(:) = rho(:,ia,ib,ic)
           end if
           dExc(:)  = dgVxcK(ia,ib,ic,:)
           Vxc(:,ia,ib,ic) = Vxc(:,ia,ib,ic) + dExc(:)
           Exc = Exc + sum(rho(:,ia,ib,ic)*dExc(:))
        end do
     end do
  end do

  Exc = Exc*Param%Cell%dV

  deallocate( rhoK )
  deallocate( grhoK )
  deallocate( gVxcK )
  deallocate( dgVxcK )

  deallocate( rhoat )
  deallocate( dExc )
  deallocate( Vxcat )
  deallocate( gVxcKat )
  deallocate( grhoKat )

  return
end subroutine Exchange__calcPotentialPBE

subroutine Exchange__calcPotentialPZ81at1( Vxc, dExc, rho )
  use ac_parameter

  implicit none
  real(8), intent(out) :: Vxc, dExc
  real(8), intent(in)  :: rho

  real(8) :: rs

  real(8) :: Ex, dEx, Vx
  real(8) :: Ec, dEc, Vc

  real(8) :: f, df

  if( rho<1.0e-15 ) then
     Vxc = 0.d0
     dExc = 0.d0
     return
  end if

  rs  =  0.5d0*M_CBRT3*M_CBRT2/M_CBRTPI/cbrt(rho)
  Vx  = -cbrt(+3.0d0/M_PI*rho)
  Ex  = 0.75d0*Vx
  dEx =  Vx - Ex

  if( rs>=1.d0 ) then
     f   = 1.d0 + 1.0529d0*sqrt(rs) + 0.3334d0*rs
     df  = (1.0529d0/2.0d0*sqrt(rs) + 0.3334d0*rs)*(-1.d0/3.d0)
     Ec  = -0.1423d0/f
     dEc = -Ec/f*df
  else
     f   = log(rs)
     Ec  = 0.0311d0*f - 0.048d0 + 0.0020d0*rs*f - 0.0116d0*rs
     dEc = (0.0311d0 + 0.0020d0*rs*f + (0.0020d0-0.0116d0)*rs)*(-1.0d0/3.0d0)
  end if

  Vc  = Ec + dEc

  Vxc  = Vx  + Vc
  dExc = dEx + dEc

  return
end subroutine Exchange__calcPotentialPZ81at1

subroutine Exchange__calcPotentialPZ81at2 &
     ( Vxc_u, Vxc_d, dExc_u, dExc_d, rho_u, rho_d )
  use ac_parameter

  implicit none
  real(8), intent(out) :: Vxc_u, Vxc_d
  real(8), intent(out) :: dExc_u, dExc_d
  real(8), intent(in)  :: rho_u, rho_d

  real(8) :: rho_t, zeta, rs

  real(8) :: Ex, dEx(2), Vx(2)
  real(8) :: Ec, dEc(2), Vc(2)
  real(8) :: EcP, EcF, dEcP, dEcF
  real(8) :: fP, dfP, fF, dfF
  real(8) :: z(2), f, df

  if( rho_u+rho_d<1.0e-15 ) then
     Vxc_u = 0.0d0
     Vxc_d = 0.0d0
     dExc_u = 0.0d0
     dExc_d = 0.0d0
     return
  end if

  rho_t  = rho_u + rho_d
  zeta = (rho_u - rho_d)/rho_t
  rs  =  0.5d0*M_CBRT3*M_CBRT2/M_CBRTPI/cbrt(rho_t)

  Vx(1) = -cbrt(+6.0d0/M_PI*rho_u)
  Vx(2) = -cbrt(+6.0d0/M_PI*rho_d)
  Ex = 0.75d0*(Vx(1)*rho_u + Vx(2)*rho_d)/rho_t
  dEx(1) = Vx(1) - Ex
  dEx(2) = Vx(2) - Ex

  if( rs>=1.0d0 ) then
     fP   = 1.d0 + 1.0529d0*sqrt(rs) + 0.3334d0*rs
     dfP  = (1.0529d0/2.0d0*sqrt(rs) + 0.3334d0*rs)*(-1.d0/3.d0)
     EcP  = -0.1423d0/fP
     dEcP = -EcP/fP*dfP

     fF   = 1.d0 + 1.3981d0*sqrt(rs) + 0.2611d0*rs
     dfF  = (1.3981d0/2.0d0*sqrt(rs) + 0.2611d0*rs)*(-1.d0/3.d0)
     EcF  = -0.0843d0/fF
     dEcF = -EcF/fF*dfF
  else
     f    = log(rs)
     EcP  = 0.0311d0*f - 0.048d0 + 0.0020d0*rs*f - 0.0116d0*rs
     dEcP = (0.0311d0 + 0.0020d0*rs*f + (0.0020d0-0.0116d0)*rs)*(-1.0d0/3.0d0)

     EcF  = 0.01555d0*f - 0.0269d0 + 0.0007d0*rs*f - 0.0048d0*rs
     dEcF = (0.01555d0 + 0.0007d0*rs*f + (0.0007d0-0.0048d0)*rs)*(-1.d0/3.d0)
  end if

  z(1) = cbrt(1.d0+zeta)
  z(2) = cbrt(1.d0-zeta)
  f = 0.5d0/(M_CBRT2-1.0d0)*( (1.0d0+zeta)*z(1) + (1.0d0-zeta)*z(2) - 2.0d0)
  df = 2.0d0/3.0d0/(M_CBRT2-1.0d0)*(z(1) - z(2))
  Ec =  EcP + ( EcF- EcP)*f

  dEc(1) = dEcP + (dEcF-dEcP)*f + (EcF-EcP)*(+1.0d0-zeta)*df
  dEc(2) = dEcP + (dEcF-dEcP)*f + (EcF-EcP)*(-1.0d0-zeta)*df

  Vc(1)  = Ec + dEc(1)
  Vc(2)  = Ec + dEc(2)

  Vxc_u  = Vx(1) + Vc(1)
  Vxc_d  = Vx(2) + Vc(2)
  dExc_u = dEx(1) + dEc(1)
  dExc_d = dEx(2) + dEc(2)

  return
end subroutine Exchange__calcPotentialPZ81at2

subroutine Exchange__calcPotentialPW91at1( Vxc, dExc, rho )
  use ac_parameter

  implicit none
  real(8), intent(out) :: Vxc, dExc
  real(8), intent(in)  :: rho

  real(8) :: rs
  real(8) :: Ex, dEx, Vx
  real(8) :: b, db
  real(8) :: Ec, dEc, Vc

  if( rho<1.0e-15 ) then
     Vxc = 0.0d0
     dExc = 0.0d0
     return
  end if

  rs  =  0.5d0*M_CBRT3*M_CBRT2/M_CBRTPI/cbrt(rho)
  Vx  = -cbrt(+3.0d0/M_PI*rho)
  Ex  = 0.75d0*Vx
  dEx =  Vx - Ex

  b  = 2.0d0*0.0310910d0*(7.5957000d0*sqrt(rs)+3.5876000d0*rs+1.6382000d0*rs*sqrt(rs)+0.4929400d0*rs*rs)
  db  = 2.0d0*0.0310910d0*(7.5957000d0*0.5d0*sqrt(rs)+3.5876000d0*rs+1.6382000d0*1.5d0*rs*sqrt(rs)+0.4929400d0*2.0d0*rs*rs)
  Ec  = -2.0d0*0.0310910d0*(1.0d0+0.2137000d0*rs)*log(1.0d0+1.0d0/b)

  dEc = +2.0d0*0.0310910d0/3.0d0*(0.2137000d0*rs)*log(1.0d0+1.0d0/b) &
       - 2.0d0*0.0310910d0/3.0d0*(1.0d0+0.2137000d0*rs)*(db/(b*b+b))
  Vc  = Ec + dEc

  Vxc  = Vx  + Vc
  dExc = dEx + dEc

  return
end subroutine Exchange__calcPotentialPW91at1

subroutine Exchange__calcPotentialPW91at2 &
     ( Vxc_u, Vxc_d, dExc_u, dExc_d, rho_u, rho_d )
  use ac_parameter

  implicit none
  real(8), intent(out) :: Vxc_u, Vxc_d, dExc_u, dExc_d
  real(8), intent(in)  :: rho_u, rho_d

  real(8) :: rho_t, zeta, rs

  real(8) :: Vx(2), Ex, dEx(2)
  real(8) :: bP, dbP, EcP, dEcP
  real(8) :: bF, dbF, EcF, dEcF
  real(8) :: bA, dbA, EcA, dEcA
  real(8) :: zeta3, zeta4, z(2), f, df, ddf
  real(8) :: Ec, dEcdrs, dEcdz, dEc(2), Vc(2)

  if( rho_u+rho_d<1.0e-15 ) then
     Vxc_u  = 0.0d0
     Vxc_d  = 0.0d0
     dExc_u = 0.0d0
     dExc_d = 0.0d0
     return
  end if

  rho_t  = rho_u + rho_d
  zeta = (rho_u - rho_d)/rho_t
  rs  =  0.5d0*M_CBRT3*M_CBRT2/M_CBRTPI/cbrt(rho_t)

  Vx(1) = -cbrt(+6.0d0/M_PI*rho_u)
  Vx(2) = -cbrt(+6.0d0/M_PI*rho_d)
  Ex = 0.75d0*(Vx(1)*rho_u + Vx(2)*rho_d)/rho_t
  dEx(1) = Vx(1) - Ex
  dEx(2) = Vx(2) - Ex

  bP = 2.0d0*0.0310910d0*(7.5957000d0*sqrt(rs)+3.5876000d0*rs+1.6382000d0*rs*sqrt(rs)+0.4929400d0*rs*rs)
  dbP = 2.0d0*0.0310910d0*(7.5957000d0*0.5d0*sqrt(rs)+3.5876000d0*rs+1.6382000d0*1.5d0*rs*sqrt(rs)+0.4929400d0*2.0d0*rs*rs)

  EcP = -2.0d0*0.0310910d0*(1.0d0+0.2137000d0*rs)*log(1.0d0+1.0d0/bP)
  dEcP = -2.0d0*0.0310910d0*(0.2137000d0*rs)*log(1.0d0+1.0d0/bP) &
       + 2.0d0*0.0310910d0*(1.0d0+0.2137000d0*rs)*(dbP/(bP*bP+bP))

  bF = 2.0d0*0.0155450d0*(14.1189000d0*sqrt(rs)+6.1977000d0*rs+3.3662000d0*rs*sqrt(rs)+0.6251700d0*rs*rs)
  dbF = 2.0d0*0.0155450d0*(14.1189000d0*0.5d0*sqrt(rs)+6.1977000d0*rs+3.3662000d0*1.5d0*rs*sqrt(rs)+0.6251700d0*2.0d0*rs*rs)

  EcF = -2.0d0*0.0155450d0*(1.0d0+0.2054800d0*rs)*log(1.0d0+1.0d0/bF)
  dEcF = -2.0d0*0.0155450d0*(0.2054800d0*rs)*log(1.0d0+1.0d0/bF) &
       + 2.0d0*0.0155450d0*(1.0d0+0.2054800d0*rs)*(dbF/(bF*bF+bF))

  bA = 2.0d0*0.0168870d0*(10.3570000d0*sqrt(rs)+3.6231000d0*rs+0.8802600d0*rs*sqrt(rs)+0.4967100d0*rs*rs)
  dbA = 2.0d0*0.0168870d0*(10.3570000d0*0.5d0*sqrt(rs)+3.6231000d0*rs+0.8802600d0*1.5d0*rs*sqrt(rs)+0.4967100d0*2.0d0*rs*rs)

  EcA = -2.0d0*0.0168870d0*(1.0d0+0.1112500d0*rs)*log(1.0d0+1.0d0/bA)
  dEcA = -2.0d0*0.0168870d0*(0.1112500d0*rs)*log(1.0d0+1.0d0/bA) &
       + 2.0d0*0.0168870d0*(1.0d0+0.1112500d0*rs)*(dbA/(bA*bA+bA))

  zeta3  = zeta**3
  zeta4  = zeta**4
  z(1)   = cbrt(1.0d0+zeta)
  z(2)   = cbrt(1.0d0-zeta)
  f      = 0.5d0/(M_CBRT2-1.0)*( (1.0d0+zeta)*z(1) + (1.0d0-zeta)*z(2) - 2.0d0)
  df     = 2.0d0/3.0d0/(M_CBRT2-1.0d0)*(z(1) - z(2))
  ddf    = 4.0d0/9.0d0/(M_CBRT2-1.0d0)

  Ec     = EcP - EcA*f/ddf*(1.0d0-zeta4) + (EcF-EcP)*f*zeta4

  dEcdrs = dEcP - dEcA*f/ddf*(1.0d0-zeta4) + (dEcF-dEcP)*f*zeta4
  dEcdz  = - EcA/ddf*(df*(1.0d0 - zeta4) - f*4.0d0*zeta3) &
       + (EcF-EcP)*(df*zeta4 + f*4.0d0*zeta3)

  dEc(1)  = - dEcdrs/3.0d0 + dEcdz*(+1.0d0-zeta)
  dEc(2)  = - dEcdrs/3.0d0 + dEcdz*(-1.0d0-zeta)

  Vc(1)   = Ec + dEc(1)
  Vc(2)   = Ec + dEc(2)

  Vxc_u  = Vx(1) + Vc(1)
  Vxc_d  = Vx(2) + Vc(2)
  dExc_u = dEx(1) + dEc(1)
  dExc_d = dEx(2) + dEc(2)

  return
end subroutine Exchange__calcPotentialPW91at2

subroutine Exchange__calcPotentialPBEat1( Vxc, dExc, gVxc, rho, grho )
  use ac_parameter

  implicit none
  real(8), intent(out) :: Vxc, dExc
  real(8), intent(in)  :: rho
  real(8), intent(out) :: gVxc(3)
  real(8), intent(in)  :: grho(3)

  real(8)  :: rs

  real(8)  :: bP, dbP
  real(8)  :: EcP, dEcP
  real(8)  :: Ecunif, dEcunif, Vcunif

  real(8)  :: gamma, phi, gp3

  real(8)  :: f1, f2, f3, f4
  real(8)  :: A, ks2, t2, At2, H
  real(8)  :: df1drho, df2drho, df3drho, df4drho
  real(8)  :: dAdrho, dks2drho, dt2drho, dAt2drho, dHdrho
  real(8)  :: Vc, dEc
  real(8)  :: dt2dgrho(3), dAt2dgrho(3), df3dgrho(3), df4dgrho(3), dHdgrho(3)
  real(8)  :: gVc(3)


  real(8), parameter :: kappa = 0.804
  real(8), parameter :: mu = 0.0667250*M_PI*M_PI/3.0

  real(8)  :: kF, s2, Fx, dFxdrho
  real(8) :: dFxdgrho(3)
  real(8)  :: Vxunif, dExunif, Exunif, Vx, dEx
  real(8) :: gVx(3)

  if( rho<1.0e-15 ) then
     Vxc  = 0.0d0
     dExc = 0.0d0
     gVxc = 0.0d0
     return
  end if

  rs  =  0.5*M_CBRT3*M_CBRT2/M_CBRTPI/cbrt(rho)

  bP = 2*0.0310910*(7.5957000*sqrt(rs)+3.5876000*rs+1.6382000*rs*sqrt(rs)+0.4929400*rs*rs)
  dbP = 2*0.0310910*(7.5957000*0.5*sqrt(rs)+3.5876000*rs+1.6382000*1.5*rs*sqrt(rs)+0.4929400*2.0*rs*rs)

  EcP = -2.0*0.0310910*(1.0+0.2137000*rs)*log(1.0d0+1.0/bP)
  dEcP = -2.0*0.0310910*(0.2137000*rs)*log(1.0d0+1.0/bP) &
       + 2.0*0.0310910*(1.0+0.2137000*rs)*(dbP/(bP*bP+bP))

  Ecunif = EcP
  dEcunif = - dEcP/3
  Vcunif = Ecunif + dEcunif

  gamma = (1.0 - M_LN2)*M_1_PI*M_1_PI
  phi = 1.0
  gp3  = gamma*phi*phi*phi

  f1 = Ecunif/gp3
  f2 = exp(-f1) - 1.0d0
  A  = (0.0667250/gamma)/f2

  ks2  = 4.0/M_PI*cbrt(3.0*M_PI*M_PI*rho)

  t2  = dot_product(grho,grho)/(4.0*phi*phi*ks2*rho*rho)
  At2 = A*t2 
  f3  = 1.0 - 1.0/(1.0+At2+At2*At2)

  f4 = f2*f3
  H  = gp3 * log(1.0d0+f4)

  dks2drho   = ks2/(3.0*rho)
  df1drho = (dEcunif/(Ecunif*rho))*f1
  df2drho = -(f2 + 1.0)*df1drho
  dAdrho = -A/f2*df2drho
  dt2drho = t2*(-1.0*dks2drho/ks2-2.0/rho)
  dAt2drho = dAdrho*t2 + A*dt2drho
  df3drho = (1.0-f3)*(1.0-f3)*(1.0+2*At2)*dAt2drho
  df4drho = df2drho*f3 + f2*df3drho
  dHdrho = gp3/(1.0+f4)*df4drho
  dt2dgrho = 2.0*t2/dot_product(grho,grho)*grho
  dAt2dgrho = A*dt2dgrho
  df3dgrho = (1.0-f3)*(1.0-f3)*(1.0+2*At2)*dAt2dgrho
  df4dgrho = f2*df3dgrho
  dHdgrho = gp3/(1.0+f4)*df4dgrho

  Vc = Vcunif + H + rho*dHdrho
  dEc = dEcunif + rho*dHdrho
  gVc = rho*dHdgrho

  kF = cbrt(3.0*M_PI*M_PI*rho)
  s2 = dot_product(grho,grho)/(2.0*kF*rho)**2
  Fx = 1.0 + kappa - kappa/(1.0+mu/kappa*s2)
  dFxdrho = -8.0/3.0*mu/(1.0+mu/kappa*s2)**2 *s2/rho
  dFxdgrho = (2.0*mu/(1.0+mu/kappa*s2)**2 *s2/dot_product(grho,grho))*grho

  Vxunif = - cbrt(3.0/M_PI*rho)
  dExunif = 0.25*Vxunif
  Exunif = 0.75*Vxunif

  Vx  = Vxunif*Fx + rho*Exunif*dFxdrho
  dEx = dExunif*Fx + rho*Exunif*dFxdrho
  gVx = (Exunif*rho)*dFxdgrho

  Vxc = Vx + Vc
  dExc = dEx + dEc
  gVxc = gVx + gVc

  return
end subroutine Exchange__calcPotentialPBEat1

subroutine Exchange__calcPotentialPBEat2 &
     ( Vxc_u, Vxc_d, dExc_u, dExc_d, gVxc_u, gVxc_d, &
     rho_u, rho_d, grho_u, grho_d )
  use ac_parameter
  implicit none
  real(8), intent(out)  :: Vxc_u, Vxc_d, dExc_u, dExc_d
  real(8), intent(in)   :: rho_u, rho_d 
  real(8), intent(out) :: gVxc_u(3), gVxc_d(3)
  real(8), intent(in)  :: grho_u(3), grho_d(3)

  real(8) :: rho_t, zeta, rs
  real(8) :: bP, dbP, EcP, dEcP
  real(8) :: bF, dbF, EcF, dEcF
  real(8) :: bA, dbA, EcA, dEcA
  real(8) :: zeta3, zeta4, z(2), f, df, ddf
  real(8) :: Ecunif, dEcdrs, dEcdz
  real(8) :: dEcunif(2), Vcunif(2)

  real(8) :: grho_t(3)

  real(8) :: gamma, phi, gp3
  real(8) :: f1, f2, f3, f4
  real(8) :: A, ks2, t2, At2, H
  real(8) :: dphidrho(2), dks2drho_t
  real(8) :: df1drho(2), df2drho(2)
  real(8) :: df3drho(2), df4drho(2)
  real(8) :: dAdrho(2), dt2drho(2)
  real(8) :: dAt2drho(2), dHdrho(2)
  real(8) :: dt2dgrho_t(3), dAt2dgrho_t(3)
  real(8) :: df3dgrho_t(3), df4dgrho_t(3), dHdgrho_t(3)
  real(8) :: Vc(2), dEc(2)
  real(8) :: gVc(3,2)

  real(8), parameter :: kappa = 0.804
  real(8), parameter :: mu = 0.0667250d0*M_PI*M_PI/3.0d0

  real(8) :: kF(2), s2(2)
  real(8) :: Fx(2), dFxdrho(2)

  real(8) :: dFxdgrho(3,2)

  real(8) :: Vxunif(2), dExunif(2)
  real(8) :: Exunif(2)
  real(8) :: Vx(2), dEx(2)
  real(8) :: gVx(3,2)

  if( rho_u+rho_d<1.0e-15 ) then
     Vxc_u  = 0.0d0
     Vxc_d  = 0.0d0
     dExc_u = 0.0d0
     dExc_d = 0.0d0
     gVxc_u = 0.0d0
     gVxc_d = 0.0d0
     return
  end if

  rho_t  = rho_u + rho_d
  zeta = (rho_u - rho_d)/rho_t
  rs  =  0.5*M_CBRT3*M_CBRT2/M_CBRTPI/cbrt(rho_t)

  bP  = 2*0.0310910*(7.5957000*sqrt(rs)+3.5876000*rs+1.6382000*rs*sqrt(rs)+0.4929400*rs*rs)
  dbP = 2*0.0310910*(7.5957000*0.5*sqrt(rs)+3.5876000*rs+1.6382000*1.5*rs*sqrt(rs)+0.4929400*2.0*rs*rs)

  EcP  = -2.0*0.0310910*(1.0+0.2137000*rs)*log(1.0d0+1.0/bP)
  dEcP = -2.0*0.0310910*(0.2137000*rs)*log(1.0d0+1.0/bP) &
       + 2.0*0.0310910*(1.0+0.2137000*rs)*(dbP/(bP*bP+bP))

  bF  = 2*0.0155450*(14.1189000*sqrt(rs)+6.1977000*rs+3.3662000*rs*sqrt(rs)+0.6251700*rs*rs)
  dbF = 2*0.0155450*(14.1189000*0.5*sqrt(rs)+6.1977000*rs+3.3662000*1.5*rs*sqrt(rs)+0.6251700*2.0*rs*rs)

  EcF  = -2.0*0.0155450*(1.0+0.2054800*rs)*log(1.0d0+1.0/bF)
  dEcF = -2.0*0.0155450*(0.2054800*rs)*log(1.0d0+1.0/bF) &
       + 2.0*0.0155450*(1.0+0.2054800*rs)*(dbF/(bF*bF+bF))

  bA  = 2*0.0168870*(10.3570000*sqrt(rs)+3.6231000*rs+0.8802600*rs*sqrt(rs)+0.4967100*rs*rs)
  dbA = 2*0.0168870*(10.3570000*0.5*sqrt(rs)+3.6231000*rs+0.8802600*1.5*rs*sqrt(rs)+0.4967100*2.0*rs*rs)

  EcA  = -2.0*0.0168870*(1.0+0.1112500*rs)*log(1.0d0+1.0/bA)
  dEcA = -2.0*0.0168870*(0.1112500*rs)*log(1.0d0+1.0/bA) &
       + 2.0*0.0168870*(1.0+0.1112500*rs)*(dbA/(bA*bA+bA))

  zeta3  = zeta**3
  zeta4  = zeta**4
  z(1)   = cbrt(1.0+zeta)
  z(2)   = cbrt(1.0-zeta)

  f   = 0.5/(M_CBRT2-1.0)*( (1.0+zeta)*z(1) + (1.0-zeta)*z(2) - 2.0)
  df  = 2.0/3.0/(M_CBRT2-1.0)*(z(1) - z(2))
  ddf = 4.0/9.0/(M_CBRT2-1.0)

  Ecunif = EcP - EcA*f/ddf*(1.0-zeta4) + (EcF-EcP)*f*zeta4

  dEcdrs = dEcP - dEcA*f/ddf*(1.0-zeta4) + (dEcF-dEcP)*f*zeta4
  dEcdz  = - EcA/ddf*(df*(1.0-zeta4) - f*4.0*zeta3) &
       + (EcF-EcP)*(df*zeta4 + f*4.0*zeta3)

  dEcunif(1) = - dEcdrs/3 + dEcdz*(+1.0-zeta)
  dEcunif(2) = - dEcdrs/3 + dEcdz*(-1.0-zeta)

  Vcunif(1) = Ecunif + dEcunif(1)
  Vcunif(2) = Ecunif + dEcunif(2)

  grho_t = grho_u + grho_d

  gamma = (1.0 - M_LN2)*M_1_PI*M_1_PI
  phi   = 0.5*z(1)*z(1) + 0.5*z(2)*z(2)
  gp3   = gamma*phi*phi*phi

  f1 = Ecunif/gp3
  f2 = exp(-f1) - 1.0d0
  A  = (0.0667250/gamma)/f2

  ks2  = 4.0/M_PI*cbrt(3.0*M_PI*M_PI*rho_t)

  t2  = dot_product(grho_t,grho_t)/(4.0*phi*phi*ks2*rho_t*rho_t)
  At2 = A*t2 
  f3  = 1.0 - 1.0/(1.0+At2+At2*At2)

  f4 = f2*f3
  H  = gp3 * log(1.0d0+f4)

  dphidrho(1) = 1.0/3.0*(+1.0-zeta)/rho_t*(1.0/z(1)-1.0/z(2))
  dphidrho(2) = 1.0/3.0*(-1.0-zeta)/rho_t*(1.0/z(1)-1.0/z(2))
  dks2drho_t  = ks2/(3.0*rho_t)

  df1drho(1) = (dEcunif(1)/(Ecunif*rho_t)-3.0/phi*dphidrho(1))*f1
  df1drho(2) = (dEcunif(2)/(Ecunif*rho_t)-3.0/phi*dphidrho(2))*f1

  df2drho(1) = -(f2 + 1.0)*df1drho(1)
  df2drho(2) = -(f2 + 1.0)*df1drho(2)

  dAdrho(1) = -A/f2*df2drho(1)
  dAdrho(2) = -A/f2*df2drho(2)

  dt2drho(1) = t2*(-2.0*dphidrho(1)/phi-1.0*dks2drho_t/ks2-2.0/rho_t)
  dt2drho(2) = t2*(-2.0*dphidrho(2)/phi-1.0*dks2drho_t/ks2-2.0/rho_t)

  dAt2drho(1) = dAdrho(1)*t2 + A*dt2drho(1)
  dAt2drho(2) = dAdrho(2)*t2 + A*dt2drho(2)

  df3drho(1) = (1.0-f3)*(1.0-f3)*(1.0+2*At2)*dAt2drho(1)
  df3drho(2) = (1.0-f3)*(1.0-f3)*(1.0+2*At2)*dAt2drho(2)

  df4drho(1) = df2drho(1)*f3 + f2*df3drho(1)
  df4drho(2) = df2drho(2)*f3 + f2*df3drho(2)

  dHdrho(1) = 3.0*H/phi*dphidrho(1) + gp3/(1.0+f4)*df4drho(1)
  dHdrho(2) = 3.0*H/phi*dphidrho(2) + gp3/(1.0+f4)*df4drho(2)

  dt2dgrho_t = 2.0*t2/dot_product(grho_t,grho_t)*grho_t

  dAt2dgrho_t = A*dt2dgrho_t
  df3dgrho_t  = (1.0-f3)*(1.0-f3)*(1.0+2*At2)*dAt2dgrho_t
  df4dgrho_t  = f2*df3dgrho_t
  dHdgrho_t   = gp3/(1.0+f4)*df4dgrho_t

  Vc(1) = Vcunif(1) + H + rho_t*dHdrho(1)
  Vc(2) = Vcunif(2) + H + rho_t*dHdrho(2)

  dEc(1) = dEcunif(1) + rho_t*dHdrho(1)
  dEc(2) = dEcunif(2) + rho_t*dHdrho(2)

  gVc(:,1) = rho_t*dHdgrho_t
  gVc(:,2) = rho_t*dHdgrho_t

  kF(1) = cbrt(6.0*M_PI*M_PI*rho_u)
  kF(2) = cbrt(6.0*M_PI*M_PI*rho_d)
  s2(1) = dot_product(grho_u,grho_u)/(2.0*kF(1)*rho_u)**2
  s2(2) = dot_product(grho_d,grho_d)/(2.0*kF(2)*rho_d)**2

  Fx(1) = 1.0 + kappa - kappa/(1.0+mu/kappa*s2(1))
  Fx(2) = 1.0 + kappa - kappa/(1.0+mu/kappa*s2(2))
  dFxdrho(1)  = -8.0/3.0*mu/(1.0+mu/kappa*s2(1))**2 *s2(1)/rho_u
  dFxdrho(2)  = -8.0/3.0*mu/(1.0+mu/kappa*s2(2))**2 *s2(2)/rho_d
  dFxdgrho(:,1) = (2.0*mu/(1.0+mu/kappa*s2(1))**2 *s2(1)/dot_product(grho_u,grho_u))*grho_u
  dFxdgrho(:,2) = (2.0*mu/(1.0+mu/kappa*s2(2))**2 *s2(2)/dot_product(grho_d,grho_d))*grho_d

  Vxunif(1) = - cbrt(6.0/M_PI*rho_u)
  Vxunif(2) = - cbrt(6.0/M_PI*rho_d)

  dExunif(1) = 0.25*Vxunif(1)
  dExunif(2) = 0.25*Vxunif(2)
  Exunif(1)  = 0.75*Vxunif(1)
  Exunif(2)  = 0.75*Vxunif(2)

  Vx(1) = Vxunif(1)*Fx(1) + rho_u*Exunif(1)*dFxdrho(1)
  Vx(2) = Vxunif(2)*Fx(2) + rho_d*Exunif(2)*dFxdrho(2)

  dEx(1) = dExunif(1)*Fx(1) + rho_u*Exunif(1)*dFxdrho(1)
  dEx(2) = dExunif(2)*Fx(2) + rho_d*Exunif(2)*dFxdrho(2)

  gVx(:,1) = (Exunif(1)*rho_u)*dFxdgrho(:,1)
  gVx(:,2) = (Exunif(2)*rho_d)*dFxdgrho(:,2)

  Vxc_u  = Vx(1) + Vc(1)
  Vxc_d  = Vx(2) + Vc(2)
  dExc_u = dEx(1) + dEc(1)
  dExc_d = dEx(2) + dEc(2)
  gVxc_u = gVx(:,1) + gVc(:,1)
  gVxc_d = gVx(:,2) + gVc(:,2)

  return
end subroutine Exchange__calcPotentialPBEat2

subroutine Exchange__calcGradient( gradF, F )
  use ac_parameter

  implicit none
  real(8), intent(out) :: gradF(3,2*(Param%Cell%Na/2+1),Param%Cell%Nb,Param%Cell%Nc)
  real(8), intent(inout) ::     F(2*(Param%Cell%Na/2+1),Param%Cell%Nb,Param%Cell%Nc)

  integer        :: ia, ib, ic
  integer        :: ika, ikb, ikc
  real(8) :: K(3)
  real(8) :: c

  real(8), allocatable :: workK(:,:,:) 

  allocate( workK(2*(Param%Cell%Na/2+1),Param%Cell%Nb,Param%Cell%Nc) )

  call RFFT3D__forward( &
       Param%Cell%Na, Param%Cell%Nb, Param%Cell%Nc, &
       F, F )

  c = 1.d0/(Param%Cell%Na*Param%Cell%Nb*Param%Cell%Nc)
  do ikc=1, Param%Cell%Nc
     do ikb=1, Param%Cell%Nb
        do ika=1, Param%Cell%Na/2+1
           F(2*ika-1,ikb,ikc) = F(2*ika-1,ikb,ikc)*c
           F(2*ika-0,ikb,ikc) = F(2*ika-0,ikb,ikc)*c
        end do
     end do
  end do

  do ikc=1, Param%Cell%Nc
     do ikb=1, Param%Cell%Nb
        do ika=1, Param%Cell%Na/2+1
           call Param__Cell__K(K,ika,ikb,ikc)
           workK(2*ika-1,ikb,ikc) = F(2*ika-0,ikb,ikc) * (-K(1))
           workK(2*ika-0,ikb,ikc) = F(2*ika-1,ikb,ikc) * (+K(1))
        end do
     end do
  end do

  call RFFT3D__backward( &
       Param%Cell%Na, Param%Cell%Nb, Param%Cell%Nc, &
       workK, workK )

  do ic=1, Param%Cell%Nc
     do ib=1, Param%Cell%Nb
        do ia=1, Param%Cell%Na
           gradF(1,ia,ib,ic) = workK(ia,ib,ic)
        end do
     end do
  end do

  do ikc=1, Param%Cell%Nc
     do ikb=1, Param%Cell%Nb
        do ika=1, Param%Cell%Na/2+1
           call Param__Cell__K(K,ika,ikb,ikc)
           workK(2*ika-1,ikb,ikc) = F(2*ika-0,ikb,ikc) * (-K(2))
           workK(2*ika-0,ikb,ikc) = F(2*ika-1,ikb,ikc) * (+K(2))
        end do
     end do
  end do

  call RFFT3D__backward( &
       Param%Cell%Na, Param%Cell%Nb, Param%Cell%Nc, &
       workK, workK )

  do ic=1, Param%Cell%Nc
     do ib=1, Param%Cell%Nb
        do ia=1, Param%Cell%Na
           gradF(2,ia,ib,ic) = workK(ia,ib,ic)
        end do
     end do
  end do

  do ikc=1, Param%Cell%Nc
     do ikb=1, Param%Cell%Nb
        do ika=1, Param%Cell%Na/2+1
           call Param__Cell__K(K,ika,ikb,ikc)
           workK(2*ika-1,ikb,ikc) = F(2*ika-0,ikb,ikc) * (-K(3))
           workK(2*ika-0,ikb,ikc) = F(2*ika-1,ikb,ikc) * (+K(3))
        end do
     end do
  end do

  call RFFT3D__backward( &
       Param%Cell%Na, Param%Cell%Nb, Param%Cell%Nc, &
       workK, workK )

  do ic=1, Param%Cell%Nc
     do ib=1, Param%Cell%Nb
        do ia=1, Param%Cell%Na
           gradF(3,ia,ib,ic) = workK(ia,ib,ic)
        end do
     end do
  end do

  deallocate( workK )

  return
end subroutine Exchange__calcGradient

subroutine Exchange__calcDivergence( divF, F )
  use ac_parameter

  implicit none
  real(8), intent(out) :: divF(2*(Param%Cell%Na/2+1),Param%Cell%Nb,Param%Cell%Nc)
  real(8), intent(in)  ::  F(3,2*(Param%Cell%Na/2+1),Param%Cell%Nb,Param%Cell%Nc)

  integer        :: ia, ib, ic
  integer        :: ika, ikb, ikc
  real(8) :: K(3)
  real(8) :: c

  real(8), allocatable :: workK(:,:,:) 

  allocate( workK(2*(Param%Cell%Na/2+1),Param%Cell%Nb,Param%Cell%Nc) )

  c = 1.d0/(Param%Cell%Na*Param%Cell%Nb*Param%Cell%Nc)

  do ikc=1, Param%Cell%Nc
     do ikb=1, Param%Cell%Nb
        do ika=1, Param%Cell%Na/2+1
           divF(2*ika-1,ikb,ikc) = 0.d0
           divF(2*ika-0,ikb,ikc) = 0.d0
        end do
     end do
  end do

  do ic=1, Param%Cell%Nc
     do ib=1, Param%Cell%Nb
        do ia=1, Param%Cell%Na
           workK(ia,ib,ic) = F(1,ia,ib,ic)
        end do
     end do
  end do

  call RFFT3D__forward( &
       Param%Cell%Na, Param%Cell%Nb, Param%Cell%Nc, &
       workK, workK )

  do ikc=1, Param%Cell%Nc
     do ikb=1, Param%Cell%Nb
        do ika=1, Param%Cell%Na/2+1
           call Param__Cell__K(K,ika,ikb,ikc)

           divF(2*ika-1,ikb,ikc) = &
                divF(2*ika-1,ikb,ikc) + workK(2*ika-0,ikb,ikc)*(-c*K(1))
           divF(2*ika-0,ikb,ikc) = &
                divF(2*ika-0,ikb,ikc) + workK(2*ika-1,ikb,ikc)*(+c*K(1))
        end do
     end do
  end do


  do ic=1, Param%Cell%Nc
     do ib=1, Param%Cell%Nb
        do ia=1, Param%Cell%Na
           workK(ia,ib,ic) = F(2,ia,ib,ic)
        end do
     end do
  end do

  call RFFT3D__forward( &
       Param%Cell%Na, Param%Cell%Nb, Param%Cell%Nc, &
       workK, workK )

  do ikc=1, Param%Cell%Nc
     do ikb=1, Param%Cell%Nb
        do ika=1, Param%Cell%Na/2+1
           call Param__Cell__K(K,ika,ikb,ikc)

           divF(2*ika-1,ikb,ikc) = &
                divF(2*ika-1,ikb,ikc) + workK(2*ika-0,ikb,ikc)*(-c*K(2))
           divF(2*ika-0,ikb,ikc) = &
                divF(2*ika-0,ikb,ikc) + workK(2*ika-1,ikb,ikc)*(+c*K(2))
        end do
     end do
  end do

  do ic=1, Param%Cell%Nc
     do ib=1, Param%Cell%Nb
        do ia=1, Param%Cell%Na
           workK(ia,ib,ic) = F(3,ia,ib,ic)
        end do
     end do
  end do

  call RFFT3D__forward( &
       Param%Cell%Na, Param%Cell%Nb, Param%Cell%Nc, &
       workK, workK )

  do ikc=1, Param%Cell%Nc
     do ikb=1, Param%Cell%Nb
        do ika=1, Param%Cell%Na/2+1
           call Param__Cell__K(K,ika,ikb,ikc)

           divF(2*ika-1,ikb,ikc) = &
                divF(2*ika-1,ikb,ikc) + workK(2*ika-0,ikb,ikc)*(-c*K(3))
           divF(2*ika-0,ikb,ikc) = &
                divF(2*ika-0,ikb,ikc) + workK(2*ika-1,ikb,ikc)*(+c*K(3))
        end do
     end do
  end do

  call RFFT3D__backward( &
       Param%Cell%Na, Param%Cell%Nb, Param%Cell%Nc, &
       divF, divF )

  deallocate( workK )

  return
end subroutine Exchange__calcDivergence

subroutine ExchangeLS__diagonalize( M, U )
  use ac_parameter
  implicit none

  type(SpinMatrix_type), intent(inout) :: M
  type(SpinMatrix_type), intent(out)   :: U

  real(8) :: A, B, AB, CC
  real(8) :: factor


  if( M%element(1,2) == 0.d0 ) then
     U%element(1,1) = 1.0d0
     U%element(2,1) = 0.0d0
     U%element(1,2) = 0.0d0
     U%element(2,2) = 1.0d0
     return
  end if

  A = dreal(M%element(1,1))
  B = dreal(M%element(2,2))
  AB = 0.5d0*(A-B)
  CC = dreal(M%element(1,2))**2 + dimag(M%element(1,2))**2

  U%element(1,1) = AB + sqrt(AB*AB+CC)
  U%element(2,1) = M%element(2,1)
  U%element(1,2) = M%element(1,2)
  U%element(2,2) = (-1.0d0)*U%element(1,1)

  M%element(1,1) = B - U%element(2,2)
  M%element(2,1) = 0.d0
  M%element(1,2) = 0.d0
  M%element(2,2) = A - U%element(1,1)

  factor = 1.d0/sqrt( dreal(U%element(1,1))**2 + CC )
  U%element(1,1) = factor*U%element(1,1)
  U%element(2,1) = factor*U%element(2,1)
  U%element(1,2) = factor*U%element(1,2)
  U%element(2,2) = factor*U%element(2,2)
  return
end subroutine ExchangeLS__diagonalize

subroutine ExchangeLS__undiagonalize( U, M )
  use ac_parameter
  implicit none

  type(SpinMatrix_type), intent(inout) :: M
  type(SpinMatrix_type), intent(in)    :: U
  type(SpinMatrix_type) :: W

  W%element(1,1) = U%element(1,1) * M%element(1,1) + U%element(1,2) * M%element(2,1)
  W%element(2,1) = U%element(2,1) * M%element(1,1) + U%element(2,2) * M%element(2,1)
  W%element(1,2) = U%element(1,1) * M%element(1,2) + U%element(1,2) * M%element(2,2)
  W%element(2,2) = U%element(2,1) * M%element(1,2) + U%element(2,2) * M%element(2,2)

  M%element(1,1) = W%element(1,1) * dconjg(U%element(1,1)) + W%element(1,2) * dconjg(U%element(1,2))
  M%element(2,1) = W%element(2,1) * dconjg(U%element(1,1)) + W%element(2,2) * dconjg(U%element(1,2))
  M%element(1,2) = W%element(1,1) * dconjg(U%element(2,1)) + W%element(1,2) * dconjg(U%element(2,2))
  M%element(2,2) = W%element(2,1) * dconjg(U%element(2,1)) + W%element(2,2) * dconjg(U%element(2,2))

  return
end subroutine ExchangeLS__undiagonalize

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

module surface_green_function

  implicit none
  complex(8), pointer :: gr00(:,:),gr01(:,:),gr02(:,:),temp(:,:)
  complex(8), pointer :: tr1(:,:),tr2(:,:),tm(:,:),tm_temp(:,:)
  complex(8), pointer :: es0(:,:),e00(:,:),alp(:,:),bet(:,:)

contains
  subroutine alo_surface_gf_transefer(mat_max)

    implicit none
    integer, intent(in) :: mat_max
    integer :: ier

    allocate(gr00(mat_max,mat_max),gr01(mat_max,mat_max),gr02(mat_max,mat_max)   &
         ,tr1(mat_max,mat_max),tr2(mat_max,mat_max),tm(mat_max,mat_max)       &
         ,tm_temp(mat_max,mat_max),temp(mat_max,mat_max),stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_surface_gf_transefer'
       stop
    end if

    return
  end subroutine alo_surface_gf_transefer

  subroutine unset_surface_gf_transefer

    implicit none
    integer :: ier

    deallocate(gr00,gr01,gr02,tr1,tr2,tm,tm_temp,temp,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error deallocate: unset_surface_gf_transefer'
       stop
    end if

    return
  end subroutine unset_surface_gf_transefer

  subroutine alo_surface_gf_direct(mat_max)

    implicit none
    integer, intent(in) :: mat_max
    integer :: ier

    allocate(gr00(mat_max,mat_max),gr01(mat_max,mat_max),gr02(mat_max,mat_max)   &
         ,es0(mat_max,mat_max),e00(mat_max,mat_max),alp(mat_max,mat_max)      &
         ,bet(mat_max,mat_max),temp(mat_max,mat_max),stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_surface_gf_direct'
       stop
    end if

    return
  end subroutine alo_surface_gf_direct

  subroutine unset_surface_gf_direct

    implicit none
    integer :: ier

    deallocate(gr00,gr01,gr02,es0,e00,alp,bet,temp,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error deallocate: unset_surface_gf_direct'
       stop
    end if

    return
  end subroutine unset_surface_gf_direct
end module surface_green_function

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

module mod_mpi

  implicit none
  integer :: nprocs,myrank,ierr
  character(50) :: file_tempout
  character(50), pointer :: file_sf_scf(:,:,:)
  character(50), pointer :: file_sf_tr(:,:)

contains
  subroutine alo_mod_sftr(kt,file_selfenergy)

    implicit none
    integer, intent(in) :: kt
    character(50), intent(in) :: file_selfenergy
    character(1) :: character_temp(4),character_temk(4),a(10)
    character(50) :: filename_temp
    character(60) :: filename_com
    integer :: i1,i2,k1,i_temp1,i_temp2,ier

    if( file_selfenergy == 'none' ) then
       filename_temp='sel.data'
       filename_temp=adjustr(filename_temp)
    else
       filename_temp=adjustr(file_selfenergy)
    end if

    allocate(file_sf_tr(kt,nprocs),stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: lo_mod_sftr'
       stop
    end if

    a(1)='0'
    a(2)='1'
    a(3)='2'
    a(4)='3'
    a(5)='4'
    a(6)='5'
    a(7)='6'
    a(8)='7'
    a(9)='8'
    a(10)='9'

    do k1=1,kt
       i_temp1=k1
       do i2=1,4
          i_temp2=i_temp1/(10**(4-i2))
          character_temk(i2)=a(i_temp2+1)
          i_temp1=i_temp1-(10**(4-i2))*i_temp2
       end do
       do i1=1,nprocs
          i_temp1=i1
          do i2=1,4
             i_temp2=i_temp1/(10**(4-i2))
             character_temp(i2)=a(i_temp2+1)
             i_temp1=i_temp1-(10**(4-i2))*i_temp2
          end do
          filename_com=filename_temp//'_'//character_temk(1)//character_temk(2)    &
               //character_temk(3)//character_temk(4)    &
               //'_'//character_temp(1)//character_temp(2)    &
               //character_temp(3)//character_temp(4)
          file_sf_tr(k1,i1)=adjustl(filename_com)
       end do
    end do

    return
  end subroutine alo_mod_sftr

  subroutine dealo_mod_sftr

    implicit none
    integer :: ier

    deallocate(file_sf_tr,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: delo_mod_sftr'
       stop
    end if

    return
  end subroutine dealo_mod_sftr

  subroutine alo_tempout

    implicit none
    character(1) :: character_temp(4),a(10)
    integer :: i2,i_temp1,i_temp2

    a(1)='0'
    a(2)='1'
    a(3)='2'
    a(4)='3'
    a(5)='4'
    a(6)='5'
    a(7)='6'
    a(8)='7'
    a(9)='8'
    a(10)='9'

    i_temp1=myrank+1
    do i2=1,4
       i_temp2=i_temp1/(10**(4-i2))
       character_temp(i2)=a(i_temp2+1)
       i_temp1=i_temp1-(10**(4-i2))*i_temp2
    end do
    file_tempout='g.output'//'_'//character_temp(1)//character_temp(2)           &
         //character_temp(3)//character_temp(4)

    return
  end subroutine alo_tempout

  subroutine alo_mod_mpi(iw,ispin,kt,file_selfenergy_scf)

    implicit none
    integer, intent(in) :: iw,ispin,kt
    character(50), intent(in) :: file_selfenergy_scf
    character(1) :: character_temp(4),character_temk(4),a(10)
    character(50) :: filename_temp
    character(60) :: filename_com
    integer :: i1,i2,i3,k1,i_temp1,i_temp2,ier

    if( file_selfenergy_scf == 'none' ) then
       filename_temp='sel.in'
       filename_temp=adjustr(filename_temp)
    else
       filename_temp=adjustr(file_selfenergy_scf)
    end if

    allocate(file_sf_scf(ispin,kt,iw),stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_mod_mpi'
       stop
    end if

    a(1)='0'
    a(2)='1'
    a(3)='2'
    a(4)='3'
    a(5)='4'
    a(6)='5'
    a(7)='6'
    a(8)='7'
    a(9)='8'
    a(10)='9'

    do i3=1,ispin
       do k1=1,kt
          i_temp1=k1
          do i2=1,4
             i_temp2=i_temp1/(10**(4-i2))
             character_temk(i2)=a(i_temp2+1)
             i_temp1=i_temp1-(10**(4-i2))*i_temp2
          end do
          do i1=1,iw
             i_temp1=i1
             do i2=1,4
                i_temp2=i_temp1/(10**(4-i2))
                character_temp(i2)=a(i_temp2+1)
                i_temp1=i_temp1-(10**(4-i2))*i_temp2
             end do
             if( i3 == 1 ) then
                character_temp(1)='1'
             else
                character_temp(1)='2'
             end if
             filename_com=filename_temp//'_'//character_temk(1)//character_temk(2)  &
                  //character_temk(3)//character_temk(4)  &
                  //'_'//character_temp(1)//character_temp(2)  &
                  //character_temp(3)//character_temp(4)
             file_sf_scf(i3,k1,i1)=adjustl(filename_com)
          end do
       end do
    end do

    return
  end subroutine alo_mod_mpi

  subroutine dealo_mod_mpi

    implicit none
    integer :: ier

    deallocate(file_sf_scf,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: dealo_mod_mpi'
       stop
    end if

    return
  end subroutine dealo_mod_mpi
end module mod_mpi

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine set_scf_general(i_omega_switch,i_omega_switch2,omega_del_temp           &
     ,omega_ef_temp)

  use condition_ini
  use scf_negf
  use constant
  use mod_mpi

  implicit none
  integer, intent(inout) :: i_omega_switch,i_omega_switch2
  real(8), intent(inout) :: omega_del_temp,omega_ef_temp

  integer :: i_do

  character(50) :: temp_chara,temp_chara1
  integer :: i_check,j_check
  character(256) :: buf
  character(50) :: dummy1,dummy2
  character(50) :: tag1,tag2,tag3

  open(unit=16,file=file_tempout,position='append')
  write(16,*)
  write(16,*)
  write(16,*) '********************** **************** **********************'
  write(16,*) '*                 input  condition  ! f_scf !                *'
  write(16,*) '********************** **************** **********************'
  write(16,*)
  close(16)


  restart_onoff=''
  file_selfenergy_onoff=''
  ft_switch='fftw' 
  method_sum_om_scf=1
  i_gzero_method=0
  hartree_switch=0
  gzero_gamma=0.d0
  force_calc_onoff=''
  open(unit=19,file=file_parameter,status='old')
  do 
     read(19,'(a)',end=110) buf
     if( buf == '' ) then
        cycle
     end if
     read(buf,*) tag1
     if( tag1(1:1) == '#' ) then
        cycle
     end if
     select case(tag1)
     case('negf_scf_general{')
        do 
           read(19,'(a)',end=110) buf
           if( buf == '' ) then
              cycle
           end if
           read(buf,*) tag2
           if( tag2(1:1) == '#' ) then
              cycle
           end if
           select case(tag2)
           case('read_self_file')
              read(buf,*) dummy1,dummy2,file_selfenergy_onoff
           case('calc_start')
              read(buf,*) dummy1,dummy2,restart_onoff
           case('fft_type')
              read(buf,*) dummy1,dummy2,ft_switch
           case('method_charge_sum')
              read(buf,*) dummy1,dummy2,temp_chara
              if( temp_chara == 'square' ) then
                 method_sum_om_scf=1
              end if
              if( temp_chara == 'u_temp' ) then
                 method_sum_om_scf=2
              end if
           case('poisson_mathod','poisson_method')
              read(buf,*) dummy1,dummy2,temp_chara
              if( temp_chara == 'ft' ) then
                 hartree_switch=0
              end if
              if( temp_chara == 'gf' ) then
                 hartree_switch=1
                 i_gzero_method=1
              end if
           case('poisson_K_value')
              read(buf,*) dummy1,dummy2,gzero_gamma
           case('calc_force')
              read(buf,*) dummy1,dummy2,force_calc_onoff
           case('}negf_scf_general')
              go to 110
           end select
        end do
     end select
  end do
110 continue
  close(19)
  if( method_sum_om_scf == 0 ) then
     open(unit=17,file=file_tempout,position='append')
     write(17,*)                                                              &
          '??? broken ??? //negf_scf_general/method_charge_sum// => def'
     method_sum_om_scf=1
     close(17)
  end if
  if( file_selfenergy_onoff == '' ) then
     file_selfenergy_onoff='none'
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //negf_scf_general/read_self_file// => def'
     close(17)
  end if
  if( restart_onoff == '' ) then
     restart_onoff='f_density'
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //negf_scf_general/calc_start// => def'
     close(17)
  end if
  if( ft_switch == '' ) then
     ft_switch='fftw' 
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //negf_scf_general/fft_type// => def'
     close(17)
  end if
  if( gzero_gamma == 0.d0 .and. i_gzero_method == 1 ) then
     gzero_gamma=0.1d-05
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //negf_scf_general/poisson_K_value// => def'
     close(17)
  end if
  if( force_calc_onoff == '' ) then
     force_calc_onoff='off'
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //negf_scf_general/calc_force// => off'
     close(17)
  end if


  file_parameter_hc_scf=''
  file_parameter_hl_scf=''
  file_parameter_hr_scf=''
  file_parameter_cv1_pot=''
  file_parameter_ham_pot=''
  file_parameter_lv1_scf=''
  file_parameter_rv1_scf=''
  file_parameter_out_pot=''
  file_parameter_out_vh0=''
  file_selfenergy_scf=''
  open(unit=19,file=file_parameter,status='old')
  do 
     read(19,'(a)',end=100) buf
     if( buf == '' ) then
        cycle
     end if
     read(buf,*) tag1
     if( tag1(1:1) == '#' ) then
        cycle
     end if
     select case(tag1)
     case('negf_scf_file{')
        do 
           read(19,'(a)',end=100) buf
           if( buf == '' ) then
              cycle
           end if
           read(buf,*) tag2
           if( tag2(1:1) == '#' ) then
              cycle
           end if
           select case(tag2)
           case('input_hs_central')
              read(buf,*) dummy1,dummy2,file_parameter_hc_scf
           case('input_hs_junc')
              read(buf,*) dummy1,dummy2,file_parameter_hc_scf
           case('input_hs_left')
              read(buf,*) dummy1,dummy2,file_parameter_hl_scf
           case('input_hs_right')
              read(buf,*) dummy1,dummy2,file_parameter_hr_scf
           case('input_accel_cond')
              read(buf,*) dummy1,dummy2,file_parameter_ham_pot
           case('input_junc_cond')
              read(buf,*) dummy1,dummy2,file_parameter_ham_pot
           case('input_pr_central')
              read(buf,*) dummy1,dummy2,file_parameter_cv1_pot
           case('input_pr_junc')
              read(buf,*) dummy1,dummy2,file_parameter_cv1_pot
           case('input_pr_left')
              read(buf,*) dummy1,dummy2,file_parameter_lv1_scf
           case('input_pr_right')
              read(buf,*) dummy1,dummy2,file_parameter_rv1_scf
           case('input_pp_central')
              read(buf,*) dummy1,dummy2,file_parameter_cv1_pot
           case('input_pp_junc')
              read(buf,*) dummy1,dummy2,file_parameter_cv1_pot
           case('input_pp_left')
              read(buf,*) dummy1,dummy2,file_parameter_lv1_scf
           case('input_pp_right')
              read(buf,*) dummy1,dummy2,file_parameter_rv1_scf
           case('output_pr_central')
              read(buf,*) dummy1,dummy2,file_parameter_out_pot
           case('output_pr_junc')
              read(buf,*) dummy1,dummy2,file_parameter_out_pot
           case('output_pp_central')
              read(buf,*) dummy1,dummy2,file_parameter_out_pot
           case('output_hs_junc')
              read(buf,*) dummy1,dummy2,file_parameter_out_vh0
           case('output_junc_vh0')
              read(buf,*) dummy1,dummy2,file_parameter_out_vh0
           case('output_accel_vh0')
              read(buf,*) dummy1,dummy2,file_parameter_out_vh0
           case('self_e_file')
              read(buf,*) dummy1,dummy2,file_selfenergy_scf
           case('}negf_scf_file')
              go to 100
           end select
        end do
     end select
  end do
100 continue
  close(19)
  if( file_parameter_hc_scf == '' ) then
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //negf_scf_file/input_hs_junc// => stop'
     close(17)
     stop
  end if
  if( file_parameter_hl_scf == '' ) then
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //negf_scf_file/input_hs_left// => stop'
     close(17)
     stop
  end if
  if( file_parameter_hr_scf == '' ) then
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //negf_scf_file/input_hs_right// => stop'
     close(17)
     stop
  end if
  if( file_parameter_ham_pot == '' .and. ham_model_ini == 'scf_accel' ) then
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //negf_scf_file/input_accel_cond// => stop'
     close(17)
     stop
  end if
  if( file_parameter_cv1_pot == '' ) then
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //negf_scf_file/input_pr_junc// => stop'
     close(17)
     stop
  end if
  if( file_parameter_lv1_scf == '' ) then
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //negf_scf_file/input_pr_left// => stop'
     close(17)
     stop
  end if
  if( file_parameter_rv1_scf == '' ) then
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //negf_scf_file/input_pr_right// => stop'
     close(17)
     stop
  end if
  if( file_selfenergy_scf == '' .and. file_selfenergy_onoff == 'exist' ) then
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //negf_scf_file/self_e_file// => stop'
     close(17)
     stop
  end if
  if( file_parameter_out_pot == '' ) then
     file_parameter_out_pot='ascot_pot.output'
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //negf_scf_file/output_pr_junc// => def'
     close(17)
  end if
  if( file_parameter_out_vh0 == '' ) then
     file_parameter_out_vh0='ascot_vh0.output'
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //negf_scf_file/output_hs_junc// => def'
     close(17)
  end if


  max_num_scf=-1
  eps_scf=0.d0
  ka_scf=0
  kb_scf=0
  sw_shift_chem='off'
  open(unit=19,file=file_parameter,status='old')
  do 
     read(19,'(a)',end=120) buf
     if( buf == '' ) then
        cycle
     end if
     read(buf,*) tag1
     if( tag1(1:1) == '#' ) then
        cycle
     end if
     select case(tag1)
     case('negf_scf_accuracy{')
        do 
           read(19,'(a)',end=120) buf
           if( buf == '' ) then
              cycle
           end if
           read(buf,*) tag2
           if( tag2(1:1) == '#' ) then
              cycle
           end if
           select case(tag2)
           case('num_max_iteration')
              read(buf,*) dummy1,dummy2,max_num_scf
           case('scf_convergence')
              read(buf,*) dummy1,dummy2,eps_scf
           case('ksampling')
              read(buf,*) dummy1,dummy2,tag3
              if( tag3 == 'gamma' ) then
                 ka_scf=1
                 kb_scf=1
              else
                 read(buf,*) dummy1,dummy2,ka_scf,kb_scf
              end if
           case('sw_shift_chem')
              read(buf,*) dummy1,dummy2,sw_shift_chem
           case('}negf_scf_accuracy')
              go to 120
           end select
        end do
     end select
  end do
120 continue
  close(19)
  if( max_num_scf < 0 ) then
     max_num_scf=0
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //negf_scf_accuracy/num_max_iteration// => 0'
     close(17)
  end if
  if( eps_scf == 0.d0 ) then
     eps_scf=1.d-2
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //negf_scf_accuracy/scf_convergence// => def'
     close(17)
  end if
  if( ka_scf*kb_scf == 0 ) then
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '???     ??? //negf_scf_accuracy/ksampling//',ka_scf,kb_scf
     close(17)
  end if


  scf_bias=''
  v_scf_l=0.d0
  v_scf_r=0.d0
  om_im_bias=0.d0
  num_om_bias=0
  i_check=0
  open(unit=19,file=file_parameter,status='old')
  do 
     read(19,'(a)',end=130) buf
     if( buf == '' ) then
        cycle
     end if
     read(buf,*) tag1
     if( tag1(1:1) == '#' ) then
        cycle
     end if
     select case(tag1)
     case('negf_scf_bias{')
        do 
           read(19,'(a)',end=130) buf
           if( buf == '' ) then
              cycle
           end if
           read(buf,*) tag2
           if( tag2(1:1) == '#' ) then
              cycle
           end if
           select case(tag2)
           case('switch')
              read(buf,*) dummy1,dummy2,scf_bias
           case('v_left')
              read(buf,*) dummy1,dummy2,v_scf_l
           case('v_right')
              read(buf,*) dummy1,dummy2,v_scf_r
           case('cdm_mesh_num')
              read(buf,*) dummy1,dummy2,num_om_bias
           case('cdm_im_energy')
              read(buf,*) dummy1,dummy2,om_im_bias
           case('cdm_om_del_energy')
              read(buf,*) dummy1,dummy2,om_del_bias
              i_check=1
           case('}negf_scf_bias')
              go to 130
           end select
        end do
     end select
  end do
130 continue
  close(19)
  if( scf_bias == 'on' .and. om_im_bias == 0.d0 ) then
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //negf_scf_bias/cdm_im_energy// => stop'
     close(17)
     stop
  end if
  if( scf_bias == 'on' .and. num_om_bias == 0 ) then
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //negf_scf_bias/cdm_mesh_num// => stop'
     close(17)
     stop
  end if
  if( scf_bias == '' ) then
     scf_bias='off'
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //negf_scf_bias/switch// => off'
     close(17)
  end if
  if( scf_bias /= 'off' .and. dabs(v_scf_r)+dabs(v_scf_l) == 0.d0 ) then
     scf_bias='off'
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //negf_scf_bias/v// switch => off'
     close(17)
  end if
  if( scf_bias == 'on' .and. i_check == 0 ) then
     om_del_bias=0.d0
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //negf_scf_bias/cdm_om_del_energy// => def'
     close(17)
  end if
  if( scf_bias /= 'on' ) then
     v_scf_l=0.d0
     v_scf_r=0.d0
  end if


  i_rotspin_l=0
  i_rotspin_r=0
  i_check=0
  j_check=0
  shift_cell_l1=100000.d0
  shift_cell_l2=100000.d0
  open(unit=19,file=file_parameter,status='old')
  do 
     read(19,'(a)',end=140) buf
     if( buf == '' ) then
        cycle
     end if
     read(buf,*) tag1
     if( tag1(1:1) == '#' ) then
        cycle
     end if
     select case(tag1)
     case('negf_spin_rot{')
        do 
           read(19,'(a)',end=140) buf
           if( buf == '' ) then
              cycle
           end if
           read(buf,*) tag2
           if( tag2(1:1) == '#' ) then
              cycle
           end if
           select case(tag2)
           case('switch_left')
              read(buf,*) dummy1,dummy2,temp_chara
              if( temp_chara == 'on' ) then
                 i_rotspin_l=1
              end if
              if( temp_chara == 'off' ) then
                 i_rotspin_l=0
              end if
           case('switch_right')
              read(buf,*) dummy1,dummy2,temp_chara
              if( temp_chara == 'on' ) then
                 i_rotspin_r=1
              end if
              if( temp_chara == 'off' ) then
                 i_rotspin_r=0
              end if
           case('boundary_g_num')
              read(buf,*) dummy1,dummy2,shift_cell_l1
           case('boundary_g_den')
              read(buf,*) dummy1,dummy2,shift_cell_l2
              i_check=1
           case('}negf_spin_rot')
              go to 140
           end select
        end do
     end select
  end do
140 continue
  close(19)
  if( i_rotspin_l < 0 ) then
     i_rotspin_l=0
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //negf_spin_rot/switch_left// => off'
     close(17)
  end if
  if( i_rotspin_r < 0 ) then
     i_rotspin_r=0
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //negf_spin_rot/switch_right// => off'
     close(17)
  end if
  if( shift_cell_l2 == 0) then
     shift_cell_l1=0
     shift_cell_l2=1
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '       changed: shift_cell_l2 == 0'
     close(17)
  end if


  dis_chara='def'
  res_bound_l=0.d0
  res_bound_r=0.d0
  lay_chara='def'
  atom_parlay_l=0
  atom_parlay_r=0
  i_check=0
  j_check=0
  open(unit=19,file=file_parameter,status='old')
  do 
     read(19,'(a)',end=150) buf
     if( buf == '' ) then
        cycle
     end if
     read(buf,*) tag1
     if( tag1(1:1) == '#' ) then
        cycle
     end if
     select case(tag1)
     case('negf_to_manually{')
        do 
           read(19,'(a)',end=150) buf
           if( buf == '' ) then
              cycle
           end if
           read(buf,*) tag2
           if( tag2(1:1) == '#' ) then
              cycle
           end if
           select case(tag2)
           case('switch_fix_boundary')
              read(buf,*) dummy1,dummy2,dis_chara
           case('fix_boundary_left')
              read(buf,*) dummy1,dummy2,res_bound_l
           case('fix_boundary_right')
              read(buf,*) dummy1,dummy2,res_bound_r
           case('switch_fix_atom_num')
              read(buf,*) dummy1,dummy2,lay_chara
           case('fix_atom_num_left')
              read(buf,*) dummy1,dummy2,atom_parlay_l
           case('fix_atom_num_right')
              read(buf,*) dummy1,dummy2,atom_parlay_r
           case('}negf_to_manually')
              go to 150
           end select
        end do
     end select
  end do
150 continue
  close(19)
  if( dis_chara == 'on' .and. dabs(res_bound_l)+dabs(res_bound_r) == 0.d0 ) then
     dis_chara='def'
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //negf_to_manually/fix_boundary// => off'
     close(17)
  end if
  if( lay_chara == 'on'                                                        &
       .and. iabs(atom_parlay_l)+iabs(atom_parlay_r) == 0.d0 ) then
     lay_chara='def'
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //negf_to_manually/fix_atom_num// => off'
     close(17)
  end if

  lay_shift_l=1
  lay_shift_r=1
  res_bound_l=res_bound_l/dis_scale
  res_bound_r=res_bound_r/dis_scale


  iter_conv=-100
  mixing=0.d0
  mixing_rho=0.d0
  mixing_vto=0.d0
  mixing_max=0.d0
  mixing_dm=0.d0
  mixing_dm_s=0.d0
  negf_mix_history=0
  negf_mix_start=0
  iter_mm=0
  i_check=0
  open(unit=19,file=file_parameter,status='old')
  do 
     read(19,'(a)',end=160) buf
     if( buf == '' ) then
        cycle
     end if
     read(buf,*) tag1
     if( tag1(1:1) == '#' ) then
        cycle
     end if
     select case(tag1)
     case('negf_scf_mixing{')
        do 
           read(19,'(a)',end=160) buf
           if( buf == '' ) then
              cycle
           end if
           read(buf,*) tag2
           if( tag2(1:1) == '#' ) then
              cycle
           end if
           select case(tag2)
           case('mixing_methods')
              read(buf,*) dummy1,dummy2,temp_chara
              i_check=1
              if( temp_chara == 'ham' ) then
                 iter_conv=0
              end if
              if( temp_chara == 'rho' ) then
                 iter_conv=1
              end if
              if( temp_chara == 'vtot' ) then
                 iter_conv=-1
              end if
              if( temp_chara == 'u_ma' ) then
                 iter_conv=2
              end if
              if( temp_chara == 's_nu' ) then
                 iter_conv=3
              end if
              if( temp_chara == 'anderson_ham' ) then
                 iter_conv=4
              end if
              if( temp_chara == 'simple_dm' ) then
                 iter_conv=11
              end if
              if( temp_chara == 'pulay_dm' ) then
                 iter_conv=12
              end if
              if( temp_chara == 'anderson_dm' ) then
                 iter_conv=13
              end if
              if( temp_chara == 'simple_rho'                                 &
                   .or. temp_chara == 'simple_density' ) then
                 iter_conv=21
              end if
              if( temp_chara == 'pulay_rho'                                  &
                   .or. temp_chara == 'pulay_density' ) then
                 iter_conv=22
              end if
              if( temp_chara == 'anderson_rho'                               &
                   .or. temp_chara == 'anderson_density' ) then
                 iter_conv=23
              end if
           case('mixing_ham_weight')
              read(buf,*) dummy1,dummy2,mixing
           case('mixing_ham_w_max')
              read(buf,*) dummy1,dummy2,mixing_max
           case('mixing_rho_weight')
              read(buf,*) dummy1,dummy2,mixing_rho
           case('mixing_vto_weight')
              read(buf,*) dummy1,dummy2,mixing_vto
           case('switch_num_mw')
              read(buf,*) dummy1,dummy2,iter_mm
           case('mixing_dm_weight')
              read(buf,*) dummy1,dummy2,mixing_dm
           case('mixing_dm_s_weight')
              read(buf,*) dummy1,dummy2,mixing_dm_s
           case('pulay_mix_history')
              read(buf,*) dummy1,dummy2,negf_mix_history
           case('pulay_mix_start')
              read(buf,*) dummy1,dummy2,negf_mix_start
           case('}negf_scf_mixing')
              go to 160
           end select
        end do
     end select
  end do
160 continue
  close(19)
  if( iter_conv < 10 ) then
     iter_conv=12
     open(unit=17,file=file_tempout,position='append')
     write(17,*)                                                              &
          '??? broken ??? //negf_scf_mixing/mixing_methods// => pulay_dm'
     close(17)
  end if
  if( mixing_dm == 0.d0 .and. ( iter_conv > 10 .and. iter_conv < 30 ) ) then
     mixing_dm=0.1d0
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //negf_scf_mixing/mixing_dm_weight// => 0.1'
     close(17)
  end if
  if( mixing_dm_s == 0.d0 .and. ( iter_conv > 10 .and. iter_conv < 30 ) ) then
     mixing_dm_s=0.01d0
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //negf_scf_mixing/mixing_dm_s_weight// => 0.01'
     close(17)
  end if
  if( negf_mix_history == 0 .and. ( iter_conv > 10 .and. iter_conv < 30 ) ) then
     negf_mix_history=4
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //negf_scf_mixing/pulay_mix_history// => 4'
     close(17)
  end if
  if( negf_mix_start == 0 .and. ( iter_conv > 10 .and. iter_conv < 30 ) ) then
     negf_mix_start=10
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '??? broken ??? //negf_scf_mixing/pulay_mix_start// => 10'
     close(17)
  end if

  if( iter_conv == 1 ) then
     mixing=1.d0
     mixing_vto=1.d0
     mixing_dm=1.d0
     mixing_dm_s=1.d0
  else
     if( iter_conv == -1 ) then
        mixing=1.d0
        mixing_rho=1.d0
        mixing_dm=1.d0
        mixing_dm_s=1.d0
     else
        if( iter_conv < 10 ) then
           mixing_rho=1.d0
           mixing_vto=1.d0
           mixing_dm=1.d0
           mixing_dm_s=1.d0
        else
           mixing=1.d0
           mixing_rho=1.d0
           mixing_vto=1.d0
        end if
     end if
  end if


  if( method_sum_om_scf == 1 ) then
     om_block_num_scf=0
     open(unit=19,file=file_parameter,status='old')
     do 
        read(19,'(a)',end=170) buf
        if( buf == '' ) then
           cycle
        end if
        read(buf,*) tag1
        if( tag1(1:1) == '#' ) then
           cycle
        end if
        select case(tag1)
        case('negf_scf_energy_m1{')
           do 
              read(19,'(a)',end=170) buf
              if( buf == '' ) then
                 cycle
              end if
              read(buf,*) tag2
              if( tag2(1:1) == '#' ) then
                 cycle
              end if
              select case(tag2)
              case('block_num')
                 read(buf,*) dummy1,dummy2,om_block_num_scf
              case('}negf_scf_energy_m1')
                 go to 170
              end select
           end do
        end select
     end do
170  continue
     close(19)
  end if
  if( method_sum_om_scf == 2 ) then
     om_block_num_scf=1
     open(unit=19,file=file_parameter,status='old')
     do 
        read(19,'(a)',end=175) buf
        if( buf == '' ) then
           cycle
        end if
        read(buf,*) tag1
        if( tag1(1:1) == '#' ) then
           cycle
        end if
        select case(tag1)
        case('negf_scf_energy_m2{')
           do 
              read(19,'(a)',end=175) buf
              if( buf == '' ) then
                 cycle
              end if
              read(buf,*) tag2
              if( tag2(1:1) == '#' ) then
                 cycle
              end if
              select case(tag2)
              case('block_num')
                 read(buf,*) dummy1,dummy2,om_block_num_scf
              case('}negf_scf_energy_m2')
                 go to 175
              end select
           end do
        end select
     end do
175  continue
     close(19)
  end if
  if( om_block_num_scf == 0 .and. method_sum_om_scf == 1 ) then
     om_block_num_scf=1
  end if
  if( om_block_num_scf /= 1 .and. method_sum_om_scf == 2 ) then
     om_block_num_scf=1
  end if
  call alo_scf_negf_omega1

  if( method_sum_om_scf == 1 ) then
     i_omega_switch=-1
     omega_del_temp=0.d0
     i_check=0
     j_check=0
     do i_do=1,om_block_num_scf
        num_om_par_scf(i_do,1)=0
        num_om_par_scf(i_do,2)=0
        num_om_par_scf(i_do,3)=0
        omega_if_scf(i_do,3)=0.d0
        omega_if_scf(i_do,4)=0.d0
        om_con_method_scf(i_do)=''
     end do
     open(unit=19,file=file_parameter,status='old')
     do 
        read(19,'(a)',end=180) buf
        if( buf == '' ) then
           cycle
        end if
        read(buf,*) tag1
        if( tag1(1:1) == '#' ) then
           cycle
        end if
        select case(tag1)
        case('negf_scf_energy_m1{')
           do 
              read(19,'(a)',end=180) buf
              if( buf == '' ) then
                 cycle
              end if
              read(buf,*) tag2
              if( tag2(1:1) == '#' ) then
                 cycle
              end if
              select case(tag2)
              case('min_energy_pos')
                 read(buf,*) dummy1,dummy2,omega_del_temp
                 i_check=1
              case('m_v_min_energy_pos')
                 read(buf,*) dummy1,dummy2,temp_chara
                 if( temp_chara == 'real' ) then
                    i_omega_switch=0
                 end if
                 if( temp_chara == 'relative' ) then
                    i_omega_switch=1
                 end if
              case('block_cond_add{')
                 read(buf,*) dummy1,i_do
                 if( i_do >= om_block_num_scf .or. i_do < 1 ) then
                    cycle
                 end if
                 do 
                    read(19,'(a)',end=180) buf
                    if( buf == '' ) then
                       cycle
                    end if
                    read(buf,*) tag3
                    if( tag3(1:1) == '#' ) then
                       cycle
                    end if
                    select case(tag3)
                    case('blank_min_energy')
                       read(buf,*) dummy1,dummy2,omega_if_scf(i_do,2)
                       j_check=j_check+1
                    case('blank_max_energy')
                       read(buf,*) dummy1,dummy2,omega_if_scf(i_do+1,1)
                       j_check=j_check+1
                    case('im_energy')
                       read(buf,*) dummy1,dummy2,omega_if_scf(i_do,4)
                    case('mesh_num_min')
                       read(buf,*) dummy1,dummy2,num_om_par_scf(i_do,1)
                    case('mesh_num_ima')
                       read(buf,*) dummy1,dummy2,num_om_par_scf(i_do,2)
                    case('mesh_num_max')
                       read(buf,*) dummy1,dummy2,num_om_par_scf(i_do,3)
                    case('mesh_method_ef')
                       read(buf,*) dummy1,dummy2,om_con_method_scf(i_do)
                    case('}block_cond_add')
                       exit
                    end select
                 end do
              case('block_cond0{')
                 i_do=om_block_num_scf
                 do 
                    read(19,'(a)',end=180) buf
                    if( buf == '' ) then
                       cycle
                    end if
                    read(buf,*) tag3
                    if( tag3(1:1) == '#' ) then
                       cycle
                    end if
                    select case(tag3)
                    case('im_energy')
                       read(buf,*) dummy1,dummy2,omega_if_scf(i_do,4)
                    case('mesh_num_min')
                       read(buf,*) dummy1,dummy2,num_om_par_scf(i_do,1)
                    case('mesh_num_ima')
                       read(buf,*) dummy1,dummy2,num_om_par_scf(i_do,2)
                    case('mesh_num_ef')
                       read(buf,*) dummy1,dummy2,num_om_par_scf(i_do,3)
                    case('mesh_method_ef')
                       read(buf,*) dummy1,dummy2,om_con_method_scf(i_do)
                    case('}block_cond0')
                       exit
                    end select
                 end do
              case('}negf_scf_energy_m1')
                 go to 180
              end select
           end do
        end select
     end do
180  continue
     close(19)
     if( j_check /= 2*om_block_num_scf-2 .and. om_block_num_scf > 1 ) then
        open(unit=17,file=file_tempout,position='append')
        write(17,*)                                                            &
             '??? broken ???: //negf_scf_energy_m1/blank_**_energy// => stop'
        close(17)
        stop
     end if
     if( i_check == 0 ) then
        omega_del_temp=5.d0
        i_omega_switch=1
        open(unit=17,file=file_tempout,position='append')
        write(17,*)                                                            &
             '??? broken ???: //negf_scf_energy_m1/min_energy_pos// => def'
        close(17)
     end if
     if( i_omega_switch < 0 ) then
        i_omega_switch=1
        open(unit=17,file=file_tempout,position='append')
        write(17,*)                                                            &
             '??? broken ???: //negf_scf_energy_m1/m_v_min_energy_pos// => def'
        close(17)
     end if
     do i_do=1,om_block_num_scf
        if( num_om_par_scf(i_do,1) == 0 ) then
           num_om_par_scf(i_do,1)=5
           open(unit=17,file=file_tempout,position='append')
           write(17,*)                                                          &
                i_do,'??? broken ???: //negf_scf_energy_m1/mesh_num_min// => def'
           close(17)
        end if
        if( num_om_par_scf(i_do,2) == 0 ) then
           num_om_par_scf(i_do,2)=15
           open(unit=17,file=file_tempout,position='append')
           write(17,*)                                                          &
                i_do,'??? broken ???: //negf_scf_energy_m1/mesh_num_min// => def'
           close(17)
        end if
        if( num_om_par_scf(i_do,3) == 0 ) then
           num_om_par_scf(i_do,3)=10
           open(unit=17,file=file_tempout,position='append')
           write(17,*)                                                          &
                i_do,'??? broken ???: //negf_scf_energy_m1/mesh_num_min// => def'
           close(17)
        end if
        if( omega_if_scf(i_do,4) == 0.d0 ) then
           omega_if_scf(i_do,4)=0.63d0
           open(unit=17,file=file_tempout,position='append')
           write(17,*)                                                          &
                i_do,'??? broken ???: //negf_scf_energy_m1/mesh_num_min// => def'
           close(17)
        end if
        if( om_con_method_scf(i_do) == '' ) then
           om_con_method_scf(i_do)='linear'
           open(unit=17,file=file_tempout,position='append')
           write(17,*)                                                          &
                i_do,'??? broken ???: //negf_scf_energy_m1/mesh_num_min// => def'
           close(17)
        end if
        if( om_con_method_scf(i_do) == 'log' ) then 
           omega_if_scf(i_do,3)=1.d-15
        end if
     end do
  end if

  if( method_sum_om_scf == 2 ) then
     i_do=1
     om_con_method_scf(i_do)='linear'
     omega_del_temp=0.d0
     omega_gamm(i_do)=0.d0
     omega_tem(i_do)=0.d0
     omega_if_scf(i_do,3)=0.d0
     omega_if_scf(i_do,4)=0.d0
     omega_ef_temp=0.d0
     num_om_par_scf(i_do,1)=0
     num_om_par_scf(i_do,2)=0
     i_omega_switch=-1
     i_omega_switch2=-1
     i_check=0
     j_check=0
     open(unit=19,file=file_parameter,status='old')
     do 
        read(19,'(a)',end=185) buf
        if( buf == '' ) then
           cycle
        end if
        read(buf,*) tag1
        if( tag1(1:1) == '#' ) then
           cycle
        end if
        select case(tag1)
        case('negf_scf_energy_m2{')
           do 
              read(19,'(a)',end=185) buf
              if( buf == '' ) then
                 cycle
              end if
              read(buf,*) tag2
              if( tag2(1:1) == '#' ) then
                 cycle
              end if
              select case(tag2)
              case('mesh_method_cir')
                 read(buf,*) dummy1,dummy2,om_con_method_scf(i_do)
              case('min_energy_pos')
                 read(buf,*) dummy1,dummy2,omega_del_temp
                 i_check=1
              case('max_energy_pos')
                 read(buf,*) dummy1,dummy2,omega_ef_temp
                 j_check=1
              case('temperature')
                 read(buf,*) dummy1,dummy2,omega_tem(i_do)
              case('im_energy')
                 read(buf,*) dummy1,dummy2,omega_if_scf(i_do,4)
              case('energy_len_ima')
                 read(buf,*) dummy1,dummy2,omega_gamm(i_do)
              case('mesh_num_cir')
                 read(buf,*) dummy1,dummy2,num_om_par_scf(i_do,1)
              case('mesh_num_ima')
                 read(buf,*) dummy1,dummy2,num_om_par_scf(i_do,2)
              case('m_v_min_energy_pos')
                 read(buf,*) dummy1,dummy2,temp_chara
                 if( temp_chara == 'real' ) then
                    i_omega_switch=0
                 end if
                 if( temp_chara == 'relative' ) then
                    i_omega_switch=1
                 end if
              case('m_v_max_energy_pos')
                 read(buf,*) dummy1,dummy2,temp_chara
                 if( temp_chara == 'real' ) then
                    i_omega_switch2=0
                 end if
                 if( temp_chara == 'relative' ) then
                    i_omega_switch2=1
                 end if
              case('}negf_scf_energy_m2')
                 go to 185
              end select
           end do
        end select
     end do
185  continue
     close(19)
     if( num_om_par_scf(i_do,1) == 0 ) then
        num_om_par_scf(i_do,1)=30
        open(unit=17,file=file_tempout,position='append')
        write(17,*) '??? broken ???: //negf_scf_energy_m2/mesh_num_cir// => def'
        close(17)
     end if
     if( num_om_par_scf(i_do,2) == 0 ) then
        num_om_par_scf(i_do,2)=21
        open(unit=17,file=file_tempout,position='append')
        write(17,*) '??? broken ???: //negf_scf_energy_m2/mesh_num_ima// => def'
        close(17)
     end if
     if( omega_if_scf(i_do,4) == 0.d0 ) then
        omega_if_scf(i_do,4)=0.63d0
        open(unit=17,file=file_tempout,position='append')
        write(17,*) '??? broken ???: //negf_scf_energy_m2/im_energy// => def'
        close(17)
     end if
     if( omega_tem(i_do) == 0.d0 ) then
        omega_tem(i_do)=0.008617342
        open(unit=17,file=file_tempout,position='append')
        write(17,*) '??? broken ???: //negf_scf_energy_m2/temperature// => def'
        close(17)
     end if
     if( i_check == 0 ) then
        omega_del_temp=5.d0
        i_omega_switch=1
        open(unit=17,file=file_tempout,position='append')
        write(17,*)                                                            &
             '??? broken ???: //negf_scf_energy_m2/min_energy_pos// => def'
        close(17)
     end if
     if( j_check == 0 ) then
        omega_ef_temp=2.1d0
        i_omega_switch2=1
        open(unit=17,file=file_tempout,position='append')
        write(17,*)                                                            &
             '??? broken ???: //negf_scf_energy_m2/max_energy_pos// => def'
        close(17)
     end if
     if( omega_gamm(i_do) == 0.d0 ) then
        omega_gamm(i_do)=omega_ef_temp+.05d0
        open(unit=17,file=file_tempout,position='append')
        write(17,*)                                                            &
             '??? broken ???: //negf_scf_energy_m2/energy_len_ima// => def'
        close(17)
     end if
     if( omega_gamm(i_do) < omega_ef_temp ) then
        omega_gamm(i_do)=omega_ef_temp+.05d0
        open(unit=17,file=file_tempout,position='append')
        write(17,*)'!!! short !!!: //negf_scf_energy_m2/energy_len_ima// => def'
        close(17)
     end if
     if( om_con_method_scf(i_do) /= 'linear' ) then
        om_con_method_scf(i_do)='linear'
        open(unit=17,file=file_tempout,position='append')
        write(17,*)                                                            &
             '       changed: //negf_scf_energy_m2/mesh_method_cir// -> linear'
        close(17)
     end if
     if( i_omega_switch < 0 ) then
        i_omega_switch=1
        open(unit=17,file=file_tempout,position='append')
        write(17,*)                                                            &
             '??? broken ???: //negf_scf_energy_m2/m_v_min_energy_pos// => def'
        close(17)
     end if
     if( i_omega_switch2 < 0 ) then
        i_omega_switch2=1
        open(unit=17,file=file_tempout,position='append')
        write(17,*)                                                            &
             '??? broken ???: //negf_scf_energy_m2/m_v_max_energy_pos// => def'
        close(17)
     end if
     if( om_con_method_scf(i_do) == 'log' ) then
        omega_if_scf(i_do,3)=1.d-15
     end if
  end if


  open(unit=16,file=file_tempout,position='append')

  write(16,*) 
  write(16,911) file_selfenergy_onoff
911 format('   /switch/  file of self energy: ',a10)
  write(16,917) restart_onoff
917 format('       /switch/  calc start file: ',a15)
  write(16,960) force_calc_onoff
960 format('     /switch/  force calculation: ',a15)

  write(16,*) 
  write(16,913) eps_scf
913 format('                 scf convergence: ',e10.5)
  write(16,914) max_num_scf
914 format('         max number of iteration: ' ,i10)

  if( iter_conv == 0 ) then
     temp_chara='ham'
  end if
  if( iter_conv == 1 ) then
     temp_chara='rho'
  end if
  if( iter_conv == -1 ) then
     temp_chara='vtot'
  end if
  if( iter_conv == 2 ) then
     temp_chara='u_ma'
  end if
  if( iter_conv == 3 ) then
     temp_chara='s_nu'
  end if
  if( iter_conv == 4 ) then
     temp_chara='anderson_ham'
  end if
  if( iter_conv == 11 ) then
     temp_chara='simple_dm'
  end if
  if( iter_conv == 12 ) then
     temp_chara='pulay_dm'
  end if
  if( iter_conv == 13 ) then
     temp_chara='anderson_dm'
  end if
  if( iter_conv == 21 ) then
     temp_chara='simple_rho'
  end if
  if( iter_conv == 22 ) then
     temp_chara='pulay_rho'
  end if
  if( iter_conv == 23 ) then
     temp_chara='anderson_rho'
  end if
  write(16,*) 
  write(16,915) temp_chara
915 format('                   mixing method: ',a15)
  if( iter_conv < 10 ) then
     write(16,916) mixing,mixing_rho,mixing_vto
916  format('   mixing weight (ham, den, vto): ',f9.4,' ',f9.4,' ',f9.4)
     if( iter_conv == 2 .or. iter_conv == 3 ) then
        write(16,940) mixing_max
940     format('       mixing weight (ham_w_max): ',f9.4)
     end if
  end if
  if( iter_conv > 11 .and. iter_conv < 20 ) then
     write(16,950) mixing_dm
950  format('  mixing weight (DM, not simple): ',f9.4)
  end if
  if( iter_conv > 10 .and. iter_conv < 13 ) then
     write(16,951) mixing_dm_s
951  format('      mixing weight (DM, simple): ',f9.4)
  end if
  if( iter_conv == 12 ) then
     write(16,952) negf_mix_start,negf_mix_history
952  format('          pulay (start, history): ',i5,i5)
  end if

  if( method_sum_om_scf == 1 ) then
     temp_chara='square'
  else
     temp_chara='u_temp'
  end if
  write(16,*) 
  write(16,936) temp_chara,om_block_num_scf
936 format(' method of integrate (block num): ',a10,'(',i5,')')

  write(16,918) ft_switch
918 format('                      fft method: ',a10)

  if( hartree_switch == 0 ) then
     temp_chara='ft'
  else
     temp_chara='gf'
  end if
  write(16,919) temp_chara
919 format('        hartree term calc method: ',a10)
  if( temp_chara == 'gf' ) then
     write(16,920) gzero_gamma
920  format('       hartree term normal_1, K=: ',e10.5)
  end if

  if( scf_bias /= 'off' ) then
     write(16,*)
     write(16,*)                                                              &
          '============================ bias ============================'
     write(16,*)

     write(16,921) scf_bias
921  format('                  /switch/  bias: ',a10)
     write(16,922) v_scf_l,v_scf_r
922  format('                     value (l,r): ',f10.5,' ',f10.5,' [V]')

     write(16,*)
     write(16,923) num_om_bias
923  format('  mesh num of charge calc energy: ',i5)
     write(16,924) om_im_bias
924  format('   im part of charge calc energy: ',f15.10,' [eV]')
     if( dabs(om_del_bias) > 1.d-10 ) then
        write(16,925) om_del_bias
925     format('  +re part of charge calc energy: ',f15.10,' [eV]')
     end if
  end if

  if( i_rotspin_l == 1 .or. i_rotspin_r == 1 ) then
     write(16,*)
     write(16,*)                                                              &
          '======================= spin  rotation ======================='
     write(16,*)

     if( i_rotspin_l == 1 ) then
        temp_chara='on'
     else
        temp_chara='off'
     end if
     if( i_rotspin_r == 1 ) then
        temp_chara1='on'
     else
        temp_chara1='off'
     end if
     write(16,927) temp_chara,temp_chara1
927  format('                 /switch/  (l,r): ',a5,a5)
     write(16,928) dfloat(shift_cell_l1)/dfloat(shift_cell_l2)                &
          ,1.d0-dfloat(shift_cell_l1)/dfloat(shift_cell_l2)
928  format('     position of boundary (l,r) : ',f10.5,f10.5)
  end if

  i_check=0
  if( dis_chara /= 'def' ) then
     i_check=1
  end if
  if( lay_chara /= 'def' ) then
     i_check=1
  end if

  if( i_check == 1 ) then
     write(16,*)
     write(16,*)                                                              &
          '===================== manually condition ====================='
     write(16,*)
  end if

  if( dis_chara /= 'def' ) then
     write(16,930) res_bound_l,res_bound_r
930  format('              fix boundary (l,r): ',f10.5,'   ',f10.5,' [au]')
     i_check=1
  end if
  if( lay_chara /= 'def' ) then
     write(16,931) atom_parlay_l,atom_parlay_r
931  format('              fix atom num (l,r): ',i5,i5)
     i_check=1
  end if

  write(16,*)
  write(16,*) '========================= file  name ========================='
  write(16,*)

  write(16,900) file_parameter_hc_scf
900 format(' /input/ file name -      junc_h: ',a29)
  write(16,901) file_parameter_hl_scf
901 format(' /input/ file name -      left_h: ',a29)
  write(16,902) file_parameter_hr_scf
902 format(' /input/ file name -     right_h: ',a29)

  write(16,*)
  if( ham_model_ini == 'scf_accel' ) then
     write(16,906) file_parameter_ham_pot
906  format(' /input/ file name -      junc_c: ',a29)
  end if

  write(16,907) file_parameter_cv1_pot
907 format(' /input/ file name -     junc_vd: ',a29)

  write(16,*)
  write(16,908) file_parameter_lv1_scf
908 format(' /input/ file name -     left_vd: ',a29)
  write(16,909) file_parameter_rv1_scf
909 format(' /input/ file name -    right_vd: ',a29)

  write(16,*)
  write(16,910) file_selfenergy_scf
910 format('             file of self energy: ',a29)

  write(16,*)
  write(16,954) file_parameter_out_vh0
954 format('     /output/ file name - junc_h: ',a29)
  write(16,904) file_parameter_out_pot
904 format('    /output/ file name - junc_vd: ',a29)
  write(16,*)
  write(16,*)

  close(16)


  if( restart_onoff == 'f_CDM' .or. restart_onoff == 'f_DM'                    &
       .or. restart_onoff == 'f_cdm' .or. restart_onoff == 'f_dm' ) then
     restart_onoff='off'
  else
     if(  restart_onoff /= 'f_density' ) then
        open(unit=17,file=file_tempout,position='append')
        write(17,*) '       change //negf_scf_general/calc_start// => f_density'
        close(17)
     end if
     restart_onoff='on'
  end if

  if(  file_selfenergy_onoff == 'exist' ) then
     file_selfenergy_onoff='on'
  else
     file_selfenergy_onoff='off'
  end if

  return
end subroutine set_scf_general

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Nobutaka NISHIKAWA (Mizuho I.R.)                   @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine ac_phonon
  use ac_misc_module
  use ac_mpi_module

  implicit none
  integer im,ia,id,is
  integer i
  type(element_type),pointer :: elem

  call set_phonon_parameter

  if(MPI%root) open(unit=62,file='mode.dat')

  if(MPI%root) then
     write(62,'(a)') 'lattice vector:'
     write(62,'(3f15.10)') param%cell%la
     write(62,'(3f15.10)') param%cell%lb
     write(62,'(3f15.10)') param%cell%lc
     write(62,'(a,i5)') 'atom:', param%data%natom
     do ia = 1, param%data%natom
        elem => Param__Data__getElement(param%data%vatom(ia)%name)
        write(62,'(i5,2x,a5,3f15.10,f20.5)') ia,param%data%vatom(ia)%name,param%data%vatom(ia)%ro,elem%mass
     end do
     write(62,'(a,3i5)') 'mode:',0,0,0
     do i=1, param%phonon%num_atom
        write(62,'(i5,6f15.10)') i,param%data%vatom(i)%ro,param%data%vatom(i)%force
     end do
  end if

  do im = 1, param%phonon%num_mode

     ia = param%phonon%mode(im)%atom_id
     id = param%phonon%mode(im)%direction

     do is = 1, 2

        do i=1, param%phonon%num_atom
           param%data%vatom(i)%ro = param%phonon%atom(i)%ro
        end do
        param%data%vatom(ia)%ro(id) = param%data%vatom(ia)%ro(id) + (-1.0d0)**is*param%phonon%displacement

        !call Param__Structure__show
        call ac_solve
        call Force__calc
        !call Force__show

        ! set fp force
        do i=1, param%phonon%num_atom
           param%phonon%mode(im)%force(i,:,is) = param%data%vatom(i)%force
        end do

        if(MPI%root) then
           write(62,'(a,3i5)') 'mode:',im,ia,id
           do i=1, param%phonon%num_atom
              write(62,'(i5,6f15.10)') i,param%data%vatom(i)%ro,param%data%vatom(i)%force
           end do
        end if

     end do
  end do

  call force_constant_matrix
  call phonon

  close(62)

end subroutine ac_phonon

subroutine set_phonon_parameter
  use ac_misc_module

  implicit none
  integer im, ia, id, index

  param%phonon%num_atom = param%data%natom
  param%phonon%num_element = param%data%nelem

  param%phonon%num_mode = param%phonon%num_atom * 3
  param%phonon%num_order = 1

  allocate(param%phonon%mode(param%phonon%num_mode))
  allocate(param%phonon%atom(param%phonon%num_atom))

  index=0
  do ia = 1, param%phonon%num_atom
     do id = 1, 3
        index=index+1
        param%phonon%mode(index)%atom_id = ia
        param%phonon%mode(index)%direction = id        
     end do
     param%phonon%atom(ia)%ro = param%data%vatom(ia)%ro
  end do

  do im = 1, param%phonon%num_mode
     allocate(param%phonon%mode(im)%force(param%phonon%num_atom,3,param%phonon%num_order*2))
  end do

end subroutine set_phonon_parameter

subroutine force_constant_matrix
  use ac_misc_module
  use ac_mpi_module

  implicit none
  integer im1,im2,ia,id
  real(8) ui
  integer ia1,ia2,id1,id2
  real(8),allocatable :: fsum(:,:)
  type(element_type),pointer :: elem

  allocate(param%phonon%force_const_matrix(param%phonon%num_mode,param%phonon%num_mode,1))

  ui = dble(param%phonon%num_order)/param%phonon%displacement
  select case(param%phonon%num_order)
  case(1)
     ui = -ui/2.0d0
  case(2)
     ui = -ui/12.0d0
  end select

  if(MPI%root) write(62,'(a)') 'forces'
  do im1 = 1, param%phonon%num_mode
     ia = param%phonon%mode(im1)%atom_id
     id = param%phonon%mode(im1)%direction
     do im2 = 1, param%phonon%num_mode
        if(MPI%root) write(62,'(2i5,6f15.10)') im1,im2,param%phonon%mode(im2)%force(ia,id,1),param%phonon%mode(im2)%force(ia,id,2)
        select case(param%phonon%num_order)
        case(1)
           param%phonon%force_const_matrix(im1,im2,1) &
                = (param%phonon%mode(im2)%force(ia,id,2) &
                - param%phonon%mode(im2)%force(ia,id,1))*ui
        case(2)
           param%phonon%force_const_matrix(im1,im2,1) &
                = (-8.0d0*param%phonon%mode(im2)%force(ia,id,1) &
                + param%phonon%mode(im2)%force(ia,id,2) &
                - param%phonon%mode(im2)%force(ia,id,3) &
                + 8.0d0*param%phonon%mode(im2)%force(ia,id,2))*ui
        end select
     end do
  end do

  if(MPI%root) then
     write(62,'(a)') 'force const mat'
     do im1 = 1, param%phonon%num_mode
        do im2 = 1, param%phonon%num_mode
           write(62,'(2i5,f20.12)') im1,im2,param%phonon%force_const_matrix(im1,im2,1)
        end do
     end do
  end if

  ! check sum
  allocate(fsum(param%phonon%num_mode,3))
  do ia1 = 1,param%phonon%num_atom
     do id1 = 1,3
        im1 = (ia1-1)*3+id1
        do id2 = 1,3
           fsum(im1,id2) = 0.0d0
           do ia2 = 1,param%phonon%num_atom
              im2 = (ia2-1)*3+id2
              if(ia1==ia2) cycle
              fsum(im1,id2) = fsum(im1,id2) + param%phonon%force_const_matrix(im1,im2,1);
           end do
        end do
     end do
  end do
  do im1 = 1,param%phonon%num_mode
     ia = param%phonon%mode(im1)%atom_id
     do id = 1,3
        im2 = (ia-1)*3+id
        param%phonon%force_const_matrix(im1,im2,1) = -fsum(im1,id)
     end do
  end do
  deallocate(fsum)

  if(MPI%root) then
     write(62,'(a)') 'force const mat (check sum)'
     do im1 = 1, param%phonon%num_mode
        do im2 = 1, param%phonon%num_mode
           write(62,'(2i5,f20.12)') im1,im2,param%phonon%force_const_matrix(im1,im2,1)
        end do
     end do
     if(param%phonon%output_force_constant_matrix) then
        open(63,file='force_constant_matrix.dat')
        write(63,'(a)') 'lattice vector:'
        write(63,'(3f15.10)') param%cell%la
        write(63,'(3f15.10)') param%cell%lb
        write(63,'(3f15.10)') param%cell%lc
        write(63,'(a,i5)') 'atom:', param%data%natom
        do ia = 1, param%data%natom
           elem => Param__Data__getElement(param%data%vatom(ia)%name)
           write(63,'(i5,2x,a5,3f15.10,f15.5)') ia,param%data%vatom(ia)%name,param%data%vatom(ia)%ro,elem%mass
        end do
        write(63,'(a,2i5)') 'force constant matrix:', param%phonon%num_mode, param%phonon%num_atom
        do im1 = 1, param%phonon%num_mode
           do im2 = 1, param%phonon%num_mode
              write(63,'(2i5,e20.12)') im1,im2,param%phonon%force_const_matrix(im1,im2,1)
           end do
        end do
        close(63)
     end if
  end if

end subroutine force_constant_matrix

subroutine phonon
  use ac_misc_module
  use ac_mpi_module

  implicit none
  integer im,im1,im2,ia1,ia2,ia
  real(8) mass1,mass2
  character(5) name
  type(element_type),pointer :: elem

  real(8), parameter :: ha2ev = 27.211383411 ! 1 Ha = 27.211383411 eV
  real(8), parameter :: ev2cminv = 1.d0/1.23984185d-4 ! 1 cm^-1 = 1.233984185e-4 eV

  allocate(param%phonon%dynamical_matrix(param%phonon%num_mode,param%phonon%num_mode,1))
  allocate(param%phonon%dynamical_matrix_g(param%phonon%num_mode,param%phonon%num_mode,1))

  !mass1 = 51577.5d0  ! si mass
  !mass2 = 51577.5d0

  do im1 = 1,param%phonon%num_mode
     ia1 = param%phonon%mode(im1)%atom_id
     elem => Param__Data__getElement(param%data%vatom(ia1)%name)
     mass1 = elem%mass

     do im2 = 1,param%phonon%num_mode
        ia2 = param%phonon%mode(im2)%atom_id
        elem => Param__Data__getElement(param%data%vatom(ia2)%name)
        mass2 = elem%mass

        param%phonon%dynamical_matrix_g(im1,im2,1) = dcmplx(param%phonon%force_const_matrix(im1,im2,1),0.0d0)/sqrt(mass1*mass2)
     end do
  end do

  if(MPI%root) then
     write(62,'(a)') 'dynamical mat'
     do im1 = 1, param%phonon%num_mode
        do im2 = 1, param%phonon%num_mode
           write(62,'(2i5,2e20.12)') im1,im2,param%phonon%dynamical_matrix_g(im1,im2,1)
        end do
     end do
     if(param%phonon%output_dynamical_matrix) then
        open(63,file='dynamical_matrix.dat')
        write(63,'(a)') 'lattice vector:'
        write(63,'(3f15.10)') param%cell%la
        write(63,'(3f15.10)') param%cell%lb
        write(63,'(3f15.10)') param%cell%lc
        write(63,'(a,i5)') 'atom:', param%data%natom
        do ia = 1, param%data%natom
           elem => Param__Data__getElement(param%data%vatom(ia)%name)
           write(63,'(i5,2x,a5,3f15.10,f15.5)') ia,param%data%vatom(ia)%name,param%data%vatom(ia)%ro,elem%mass
        end do
        write(63,'(a,2i5)') 'dynamical matrix', param%phonon%num_mode, param%phonon%num_atom
        do im1 = 1, param%phonon%num_mode
           do im2 = 1, param%phonon%num_mode
              write(63,'(2i5,2e20.12)') im1,im2,param%phonon%dynamical_matrix_g(im1,im2,1)
           end do
        end do
        close(63)
     end if
  end if

  allocate(param%phonon%omega(param%phonon%num_mode,1))
  allocate(param%phonon%modes(param%phonon%num_mode,param%phonon%num_mode,1))

  call diagonalize(param%phonon%num_mode,param%phonon%dynamical_matrix_g(:,:,1),param%phonon%omega(:,1),param%phonon%modes(:,:,1))

  if(MPI%root) write(62,*) 'omega'
  do im = 1, param%phonon%num_mode
     if(MPI%root) write(62,'(i5,e20.12)') im,param%phonon%omega(im,1)
     !if(abs(param%phonon%omega(im,1)) < 1.0d-16) param%phonon%omega(im,1) = 0.0d0
     if(abs(param%phonon%omega(im,1)) < 1.0d-10) param%phonon%omega(im,1) = 0.0d0
     if(param%phonon%omega(im,1) > 0.0d0) then
        param%phonon%omega(im,1) = sqrt(param%phonon%omega(im,1))
     else
        param%phonon%omega(im,1) = -sqrt(param%phonon%omega(im,1))  ! for soft mode
     end if
  end do

  if(MPI%root) then
     write(62,*) 'omega'
     do im1=1,param%phonon%num_mode
        write(62,'(i5,e20.12)') im1,param%phonon%omega(im1,1)
        do im2=1,param%phonon%num_mode
           write(62,'(2i5,2e20.12)') im1,im2,param%phonon%modes(im1,im2,1)
        end do
     end do

     write(62,*) 'mode: hbarW (Ha,ev),Freq(nu) (cm-1)'
     do im=1,param%phonon%num_mode
        write(62,'(i5,3e20.12)') im,param%phonon%omega(im,1),param%phonon%omega(im,1)*ha2ev,param%phonon%omega(im,1)*ha2ev*ev2cminv
     end do

     write(6,*) '-----'
     write(6,*) 'mode: hbarW (Ha,ev),Freq(nu) (cm-1)'
     do im=1,param%phonon%num_mode
        write(6,'(i5,3e20.12)') im,param%phonon%omega(im,1),param%phonon%omega(im,1)*ha2ev,param%phonon%omega(im,1)*ha2ev*ev2cminv
     end do
  end if

end subroutine phonon

subroutine diagonalize(n,h,e,x)

  implicit none
  integer n, lda, lwork, info
  complex(8) h(n,n), x(n,n), e(n)
  complex(8) a(n,n)
  real(8),allocatable :: rwork(:)
  complex(8),allocatable :: work(:)
  character(1) jobz, uplo

  jobz = 'v'
  uplo = 'u'
  lda = n
  lwork = 4*n
  allocate(work(lwork))
  allocate(rwork(4*n))
  work = 0.0d0
  rwork = 0.0d0

  a = h

  call zheev(jobz,uplo,n,a,lda,e,work,lwork,rwork,info)

  x = a

  deallocate(work)
  deallocate(rwork)

end subroutine diagonalize

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@             Naoki WATANABE (Mizuho I.R.)                       @@ !
! @@             Nobutaka NISHIKAWA (Mizuho I.R.)                   @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine set_hami_c_cc_input( desc, ispin )

  use condition_ini
  use hamiltonian_sgf
  use hamiltonian_c
  use hamiltonian_temp
  use constant
  use ac_mpi_module

  implicit none
  type(MPI_MatDesc), intent(in) :: desc
  integer, intent(in) :: ispin

  hcc_mat(:,:) = hcc_t(:,:,ispin) 
  scc_mat(:,:) = scc_t(:,:) 

  return
end subroutine set_hami_c_cc_input

subroutine set_hami_c_ll_input(descCL,descLL,ispin)
  use condition_ini
  use hamiltonian_sgf
  use hamiltonian_c
  use hamiltonian_e
  use hamiltonian_temp
  use scf_negf
  use constant
  use ac_mpi_module

  implicit none
  type(MPI_MatDesc), intent(in) :: descCL, descLL
  integer, intent(in) :: ispin

  integer :: i, j
  complex(8), allocatable :: work(:,:)

  allocate( work(descLL%nrow, descLL%ncol) )

  do j=descLL%scol,descLL%ecol
     do i=1,descLL%nrow
        work(i,j) = h01_l_t(i,j,ispin) 
     end do
  end do

  call MPI__Allgather_MatrixM_ASCOT( descLL, work )

  do j=descCL%scol,descCL%ecol
     do i=1,descCL%nrow
        if( i > descLL%nrow ) cycle
        hcl_mat(i,j) = work(i,j) 
     end do
  end do

  do j=descLL%scol,descLL%ecol
     do i=1,descLL%nrow
        work(i,j) = s01_l_t(i,j) 
     end do
  end do

  call MPI__Allgather_MatrixM_ASCOT( descLL, work )

  do j=descCL%scol,descCL%ecol
     do i=1,descCL%nrow
        if( i > descLL%nrow ) cycle
        scl_mat(i,j) = work(i,j) 
     end do
  end do

  deallocate(work)

  return
end subroutine set_hami_c_ll_input

subroutine set_hami_c_rr_input(descCR,descRR,ispin)
  use condition_ini
  use hamiltonian_sgf
  use hamiltonian_c
  use hamiltonian_e
  use hamiltonian_temp
  use scf_negf
  use constant
  use ac_mpi_module

  implicit none
  type(MPI_MatDesc), intent(in) :: descCR, descRR
  integer, intent(in) :: ispin

  integer :: i, j
  complex(8), allocatable :: work(:,:)

  allocate( work(descRR%nrow, descRR%ncol) )

  do j=descRR%scol,descRR%ecol
     do i=1,descRR%nrow
        work(i,j) = h01_r_t(i,j,ispin) 
     end do
  end do

  call MPI__Allgather_MatrixM_ASCOT( descRR, work )

  do j=descCR%scol,descCR%ecol
     do i=1,descCR%nrow
        if( i<=descCR%nrow-descRR%nrow ) cycle
        hcr_mat(i,j) = work(i-descCR%nrow+descRR%nrow,j) 
     end do
  end do

  do j=descRR%scol,descRR%ecol
     do i=1,descRR%nrow
        work(i,j) = s01_r_t(i,j) 
     end do
  end do

  call MPI__Allgather_MatrixM_ASCOT( descRR, work )

  do j=descCR%scol,descCR%ecol
     do i=1,descCR%nrow
        if( i<=descCR%nrow-descRR%nrow ) cycle
        scr_mat(i,j) = work(i-descCR%nrow+descRR%nrow,j) 
     end do
  end do

  deallocate(work)

  return
end subroutine set_hami_c_rr_input

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Naoki WATANABE, Nobutaka NISHIKAWA (Mizuho I.R.)   @@ !
! @@             Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine Potential__setExtLocal
  use ac_misc_module

  implicit none
  type(Element_type), pointer :: elem
  type(PPloc_type) :: Vpsloc
  type(PPloc_type) :: Vpsval
  integer     :: a

  if( Param%Option%cluster ) then
     call Screening__setup
  endif

  if( Param%Option%projection ) then
     return
  end if

  do a=1, Param%Data%natom
     elem => Param__Data__getElement( Param%Data%vatom(a)%name )

     if( Param%Option%na .and. (.not. Param%Option%nohar) ) then
        call PPloc__set( Vpsloc, Param%Data%vatom(a)%Ro, elem%Vloc )
        call PPloc__set( Vpsval, Param%Data%vatom(a)%Ro, elem%Vval )
        call Potential__addExt2( Potential%Vext, Vpsloc, Vpsval )
     else
        call PPloc__set( Vpsloc, Param%Data%vatom(a)%Ro, elem%Vloc )
        call Potential__addExt1( Potential%Vext, Vpsloc )
     end if
  end do

  return
end subroutine Potential__setExtLocal

subroutine Potential__addExt1( Vext, Vpsloc )
  use ac_misc_module
  implicit none
  real(8), intent(inout)  :: Vext(Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)
  type(PPloc_type), intent(in) :: Vpsloc

  integer        :: ia, ib, ic
  integer        :: ia0, ib0, ic0
  real(8) :: R(3)
  integer        :: range(6)
  real(8)        :: ppw_t, ec_t

  if( Param%Option%projection ) then
     return
  end if

  call Param__Cell__getRange( range, Vpsloc%Ro, Vpsloc%Rc )

  do ic = range(5), range(6)
     ic0 = modp(ic,Param%Cell%Nc)
     do ib = range(3), range(4)
        ib0 = modp(ib,Param%Cell%Nb)
        do ia = range(1), range(2)
           ia0 = modp(ia,Param%Cell%Na)

           call Param__Cell__R(R,ia,ib,ic)

           if( 0<ic .and. ic<=Param%Cell%Nc .and. &
                0<ib .and. ib<=Param%Cell%Nb .and.&
                0<ia .and. ia<=Param%Cell%Na ) then
              call PPloc__W( ppw_t, Vpsloc, R )
              Vext(ia0,ib0,ic0) = Vext(ia0,ib0,ic0) + ppw_t
           else 
              call PPloc__Wdiff( ppw_t, Vpsloc, R )
              Vext(ia0,ib0,ic0) = Vext(ia0,ib0,ic0) + ppw_t
           end if
        end do
     end do
  end do

  do ic=1, Param%Cell%Nc
     do ib=1, Param%Cell%Nb
        do ia=1, Param%Cell%Na
           if(  range(5)<=ic .and. ic<=range(6) .and. &
                range(3)<=ib .and. ib<=range(4) .and. &
                range(1)<=ia .and. ia<=range(2) ) then
           else
              call Param__Cell__R(R,ia,ib,ic)
              call PPloc__W( ppw_t, Vpsloc, R )
              Vext(ia,ib,ic) = Vext(ia,ib,ic) + ppw_t
           end if
        end do
     end do
  end do

  if( .not. Param%Option%cluster ) then
     do ic=1, Param%Cell%Nc
        do ib=1, Param%Cell%Nb
           do ia=1, Param%Cell%Na
              call Param__Cell__R(R,ia,ib,ic)
              call Ewald__calc( ec_t, Vpsloc%Q, Vpsloc%Ro, R )
              Vext(ia,ib,ic) = Vext(ia,ib,ic) + ec_t
           end do
        end do
     end do
  end if

  return
end subroutine Potential__addExt1

subroutine Potential__addExt2( Vext, Vpsloc, Vpsval )
  use ac_misc_module
  implicit none
  real(8), intent(inout)  :: Vext(Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)
  type(PPloc_type), intent(in) :: Vpsloc
  type(PPloc_type), intent(in) :: Vpsval

  integer        :: ia, ib, ic
  integer        :: ia0, ib0, ic0
  real(8) :: R(3)
  integer        :: range(6)
  real(8)        :: ppw_t1,ppw_t2


  if( Param%Option%projection ) then
     return
  end if

  call Param__Cell__getRange( range, Vpsval%Ro, Vpsval%Rc )

  do ic = range(5), range(6)
     ic0 = modp(ic,Param%Cell%Nc)
     do ib = range(3), range(4)
        ib0 = modp(ib,Param%Cell%Nb)
        do ia = range(1), range(2)
           ia0 = modp(ia,Param%Cell%Na)

           call Param__Cell__R(R,ia,ib,ic)
           call PPloc__W( ppw_t1, Vpsloc, R )
           call PPloc__W( ppw_t2, Vpsval, R )

           Vext(ia0,ib0,ic0) = Vext(ia0,ib0,ic0) + ppw_t1 + ppw_t2
        end do
     end do
  end do

  return
end subroutine Potential__addExt2

subroutine Potential__setGradient1( gVext, Vpsloc )
  use ac_misc_module

  implicit none
  real(8), intent(inout)  :: gVext(3,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)
  type(PPloc_type), intent(in) :: Vpsloc

  integer        :: ia, ib, ic
  integer        :: ia0, ib0, ic0
  real(8) :: R(3)
  integer        :: range(6)
  real(8) :: ppw_t(3), ec_t(3)

  if( Param%Option%projection ) then
     return
  end if

  call Param__Cell__getRange( range, Vpsloc%Ro, Vpsloc%Rc )

  do ic = range(5), range(6)
     ic0 = modp(ic,Param%Cell%Nc)
     do ib = range(3), range(4)
        ib0 = modp(ib,Param%Cell%Nb)
        do ia = range(1), range(2)
           ia0 = modp(ia,Param%Cell%Na)

           call Param__Cell__R(R,ia,ib,ic)

           if( 0<ic .and. ic<=Param%Cell%Nc .and. &
                0<ib .and. ib<=Param%Cell%Nb .and.&
                0<ia .and. ia<=Param%Cell%Na ) then
              call PPloc__gW( ppw_t, Vpsloc, R )
              gVext(:,ia0,ib0,ic0) = gVext(:,ia0,ib0,ic0) + ppw_t
           else 
              call PPloc__gWdiff( ppw_t, Vpsloc, R )
              gVext(:,ia0,ib0,ic0) = gVext(:,ia0,ib0,ic0) + ppw_t
           end if
        end do
     end do
  end do

  do ic=1, Param%Cell%Nc
     do ib=1, Param%Cell%Nb
        do ia=1, Param%Cell%Na
           if(  range(5)<=ic .and. ic<=range(6) .and. &
                range(3)<=ib .and. ib<=range(4) .and. &
                range(1)<=ia .and. ia<=range(2) ) then
           else
              call Param__Cell__R(R,ia,ib,ic)
              call PPloc__gW( ppw_t, Vpsloc, R )
              gVext(:,ia,ib,ic) = gVext(:,ia,ib,ic) + ppw_t
           end if
        end do
     end do
  end do


  if( .not. Param%Option%cluster ) then
     do ic=1, Param%Cell%Nc
        do ib=1, Param%Cell%Nb
           do ia=1, Param%Cell%Na
              call Param__Cell__R(R,ia,ib,ic)
              call Ewald__calcForce( ec_t, Vpsloc%Q, Vpsloc%Ro, R )
              gVext(:,ia,ib,ic) = gVext(:,ia,ib,ic) - ec_t
           end do
        end do
     end do
  end if

  return
end subroutine Potential__setGradient1

subroutine Potential__setGradient2( gVext, Vpsloc, Vpsval )
  use ac_misc_module

  implicit none
  real(8), intent(inout)  :: gVext(3,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc)
  type(PPloc_type), intent(in) :: Vpsloc
  type(PPloc_type), intent(in) :: Vpsval

  integer        :: ia, ib, ic
  integer        :: ia0, ib0, ic0
  real(8) :: R(3)
  integer        :: range(6)
  real(8) :: ppw_t1(3),ppw_t2(3)

  if( Param%Option%projection ) then
     return
  end if

  call Param__Cell__getRange( range, Vpsval%Ro, Vpsval%Rc )

  do ic = range(5), range(6)
     ic0 = modp(ic,Param%Cell%Nc)
     do ib = range(3), range(4)
        ib0 = modp(ib,Param%Cell%Nb)
        do ia = range(1), range(2)
           ia0 = modp(ia,Param%Cell%Na)

           call Param__Cell__R(R,ia,ib,ic)
           call PPloc__gW( ppw_t1, Vpsloc, R )
           call PPloc__gW( ppw_t2, Vpsval, R )

           gVext(:,ia0,ib0,ic0) = gVext(:,ia0,ib0,ic0) + ppw_t1 + ppw_t2
        end do
     end do
  end do

  return
end subroutine Potential__setGradient2

subroutine Potential__setExtNonLocal
  use ac_misc_module

  implicit none
  type(Element_type), pointer :: elem
  integer :: a, n, i, l, m, naVpsnon

  allocate( Potential%vnVpsnon(Param%Data%natom) )
  allocate( Potential%viVpsnon(Param%Data%natom) )

  Potential%nVpsnon=0
  do a=1, Param%Data%natom
     elem => Param__Data__getElement( Param%Data%vatom(a)%name )

     Potential%viVpsnon(a) = Potential%nVpsnon+1
     Potential%vnVpsnon(a) = Element__getNumberOfVPS( elem )
     Potential%nVpsnon = Potential%nVpsnon + Potential%vnVpsnon(a)
  end do



  if( Param%Option%spin_orbit ) then
     do a=1, Param%Data%natom
        elem => Param__Data__getElement( Param%Data%vatom(a)%name )
        if( .not. elem%dirac ) then
           open(unit=16,file=Param%Option%file_ac_tempout,position='append')
           write(16,*) '      ++++++ Warning!: it is not spin-dependent potential ', &
                trim(Param%Data%vatom(a)%name),'(',a,')' 
           close(16)
        end if

     end do
  else
     do a=1, Param%Data%natom
        elem => Param__Data__getElement( Param%Data%vatom(a)%name )
        if( elem%dirac ) then
           open(unit=16,file=Param%Option%file_ac_tempout,position='append')
           write(16,*) '      ++++++ Warning!: spin-dependent potentials are averaged ', &
                trim(Param%Data%vatom(a)%name),'(',a,')'
           close(16)
           call Element__averageVPS(elem)
        end if
     end do
  end if

  if( Param%Option%spin_orbit ) then
     allocate( Potential%vVpsnon(Potential%nVpsnon,2) )
  else
     allocate( Potential%vVpsnon(Potential%nVpsnon,1) )
  end if

  i=0
  do a=1, Param%Data%natom
     elem => Param__Data__getElement( Param%Data%vatom(a)%name )

     do n=1, elem%nVnon
        l = elem%vVnon(n,1)%l
        if((Param%Data%element_type=='ciao_ls') &
             .and.(.not. Param%Option%spin_orbit) &
             .and.(elem%dirac) &
             .and.(elem%vVnon(n,1)%l==elem%Vloc%l)) then
           cycle
        end if
        do m=-l, +l
           i=i+1
           if( Param%Option%spin_orbit ) then
              if( elem%dirac ) then
                 call PPnon__set( Potential%vVpsnon(i,1), Param%Data%vatom(a)%Ro, m, elem%vVnon(n,1) )
                 call PPnon__set( Potential%vVpsnon(i,2), Param%Data%vatom(a)%Ro, m, elem%vVnon(n,2) )
              else
                 call PPnon__set( Potential%vVpsnon(i,1), Param%Data%vatom(a)%Ro, m, elem%vVnon(n,1) )
                 call PPnon__set( Potential%vVpsnon(i,2), Param%Data%vatom(a)%Ro, m, elem%vVnon(n,1) )
              end if
           else
              call PPnon__set( Potential%vVpsnon(i,1), Param%Data%vatom(a)%Ro, m, elem%vVnon(n,1) )
           end if
        end do
     end do
  end do


  if( .not. Param%Option%projection ) then
     return
  end if

  allocate( Potential%vnVpsloc(Param%Data%natom) )
  allocate( Potential%viVpsloc(Param%Data%natom) )

  Potential%nVpsloc=0
  do a=1, Param%Data%natom
     elem => Param__Data__getElement( Param%Data%vatom(a)%name )

     Potential%viVpsloc(a) = Potential%nVpsloc
     Potential%vnVpsloc(a) = Element__getNumberOfPAO2( elem )
     Potential%nVpsloc = Potential%nVpsloc + Potential%vnVpsloc(a)
  end do

  allocate( Potential%vVpsloc(Potential%nVpsloc) )

  i=0
  do a=1, Param%Data%natom
     elem => Param__Data__getElement( Param%Data%vatom(a)%name )

     do n=1, elem%nVloc
        l = elem%vVloc(n)%l
        do m=-l, +l
           call PPnon__set( Potential%vVpsloc(i), Param%Data%vatom(a)%Ro, m, elem%vVloc(n) )
           i=i+1
        end do
     end do
  end do

  return
end subroutine Potential__setExtNonLocal

subroutine PPloc__set( pploc, Ro, RF )
  use ac_misc_module

  implicit none
  type(PPloc_type), intent(out)   :: pploc
  real(8), intent(in) :: Ro(3)
  type(RadialFunc_type), intent(in), target :: RF

  pploc%Ro = Ro
  pploc%Q  = RF%Q
  pploc%Rc = RF%Rc
  pploc%RF => RF

  return
end subroutine PPloc__set

subroutine PPloc__W( V, pploc, Rg )
  use ac_misc_module

  implicit none
  type(PPloc_type), intent(in)    :: pploc
  real(8), intent(in) :: Rg(3)
  real(8), intent(out)  :: V

  real(8) :: R(3)
  real(8)  :: dR
  R  = Rg-pploc%Ro
  dR = sqrt(dot_product(R,R))

  if( dR < pploc%Rc ) then
     V = Spline__evaluate( pploc%RF%fR, dR )
  else
     V = pploc%Q/dR
  end if

  return
end subroutine PPloc__W

subroutine PPloc__gW( gV, pploc, Rg )
  use ac_misc_module
  implicit none
  type(PPloc_type), intent(in)    :: pploc
  real(8), intent(in) :: Rg(3)
  real(8), intent(out) :: gV(3)

  real(8) :: R(3)
  real(8)  :: dR

  R  = Rg-pploc%Ro
  dR = sqrt(dot_product(R,R))

  if( dR < pploc%Rc ) then
     if( dR < 1.d-14 ) then
        gV = 0.d0
     else
        gV = Spline__derivative( pploc%RF%fR, dR ) / dR * R
     end if
  else
     gV = (-pploc%Q)/(dR*dR) / dR * R
  end if

  return
end subroutine PPloc__gW

subroutine PPloc__Wdiff( Vdiff, pploc, Rg )
  use ac_misc_module

  implicit none
  type(PPloc_type), intent(in)    :: pploc
  real(8), intent(in) :: Rg(3)
  real(8), intent(out) :: Vdiff

  real(8) :: R(3)
  real(8)  :: dR
  R  = Rg-pploc%Ro
  dR = sqrt(dot_product(R,R))
  if( dR < pploc%Rc ) then
     call PPloc__W( Vdiff, pploc, Rg )
     Vdiff = Vdiff - pploc%Q/dR
  else
     Vdiff = 0.d0
  end if

  return
end subroutine PPloc__Wdiff

subroutine PPloc__gWdiff( gVdiff, pploc, Rg )
  use ac_misc_module

  implicit none
  type(PPloc_type), intent(in)    :: pploc
  real(8), intent(in) :: Rg(3)
  real(8), intent(out) :: gVdiff(3)

  real(8) :: R(3)
  real(8)  :: dR

  R  = Rg-pploc%Ro
  dR = sqrt(dot_product(R,R))
  if( dR < pploc%Rc ) then
     call PPloc__gW( gVdiff, pploc, Rg )
     gVdiff = gVdiff + pploc%Q/(dR*dR) /dR*R
  else
     gVdiff = 0.d0
  end if

  return
end subroutine PPloc__gWdiff

subroutine PPnon__set( ppnon, Ro, m, RF )
  use ac_misc_module

  implicit none
  type(PPnon_type), intent(out)   :: ppnon
  real(8), intent(in) :: Ro(3)
  integer, intent(in)        :: m
  type(RadialFunc_type), intent(in), target :: RF

  ppnon%Ro = Ro
  ppnon%m  = m
  ppnon%E  = RF%Q
  ppnon%l  = RF%l
  ppnon%Rc = RF%Rc
  ppnon%RF => RF

  return
end subroutine PPnon__set

subroutine Potential__bracketS( sum, pao1, pao2, L )
  use ac_misc_module

  implicit none
  type(PAO_type), intent(in)   :: pao1
  type(PPnon_type), intent(in) :: pao2
  real(8), intent(in) :: L(3)

  real(8), intent(out) :: sum

  real(8) :: R(3)
  real(8)  :: dR
  integer        :: l0, m0
  real(8)  :: g, gy, y

  sum = 0.d0

  R  = pao2%Ro + L - pao1%Ro
  dR = sqrt(dot_product(R,R))

  if( dR > pao1%Rc + pao2%Rc ) then
     return
  end if

  do l0=0, min( 2*max( pao1%l, pao2%l ), 6 )
     gy=0.0
     do m0=-l0, +l0
        g = SphericalHarmonic__Gaunt( pao1%l, pao1%m, pao2%l, pao2%m, l0, m0 )
        if( g == 0.0 ) cycle

        y = SphericalHarmonic__rlY( l0, m0, R )
        gy = gy + g*y
     end do
     if( gy == 0.d0 ) cycle

     sum = sum + gy * SphericalBessel__integrateS( pao1%RF%vK, pao2%RF%vK, l0, dR )
  end do

  return
end subroutine Potential__bracketS

subroutine Potential__bracketdS( dS, pao1, pao2, L )
  use ac_misc_module

  implicit none
  type(PAO_type), intent(in)   :: pao1
  type(PPnon_type), intent(in) :: pao2
  real(8), intent(in) :: L(3)

  real(8), intent(out) :: dS(3)

  real(8) :: R(3)
  real(8)  :: dR
  integer        :: l0, m0
  real(8)  :: g, gy, y
  real(8) :: dgy(3), dy(3)

  dS = 0.d0

  R  = pao2%Ro + L - pao1%Ro
  dR = sqrt(dot_product(R,R))

  if( dR > pao1%Rc + pao2%Rc ) then
     return
  end if

  do l0=0, min( 2*max( pao1%l, pao2%l ), 6 )
     gy=0.0
     dgy=0.d0
     do m0=-l0, +l0
        g = SphericalHarmonic__Gaunt( pao1%l, pao1%m, pao2%l, pao2%m, l0, m0 )
        if( g == 0.0 ) cycle
        y = SphericalHarmonic__rlY( l0, m0, R )
        dy = SphericalHarmonic__drlY( l0, m0, R )

        gy = gy + g*y
        dgy = dgy + g*dy
     end do

     if( .not. gy == 0.d0 ) then
        dS = dS + gy * &
             SphericalBessel__integratedS( pao1%RF%vK, pao2%RF%vK, l0, dR ) * R
     end if
     if( .not. dot_product(dgy,dgy) == 0.0d0 ) then
        dS = dS + dgy * &
             SphericalBessel__integrateS( pao1%RF%vK, pao2%RF%vK, l0, dR )
     end if

  end do

  return
end subroutine Potential__bracketdS

subroutine Density__bracketS( sum, pao1, pao2, L )
  use ac_misc_module

  implicit none
  real(8), intent(out)       :: sum
  type(PPcharge_type), intent(in) :: pao1
  type(PPloc_type), intent(in)    :: pao2
  real(8), intent(in) :: L(3)

  real(8) :: R(3)
  real(8)  :: dR
  real(8)  :: g, y, j

  R  = pao2%Ro + L - pao1%Ro
  dR = sqrt(dot_product(R,R))
  g = SphericalHarmonic__Gaunt( 0, 0, 0, 0, 0, 0 )
  y = SphericalHarmonic__rlY( 0, 0, R )
  j = SphericalBessel__integrateS( pao1%RF%vK, pao2%RF%vK, 0, dR )

  sum = 4.d0*M_PI*g*y*j

  return
end subroutine Density__bracketS

subroutine Density__bracketdS( dS, pao1, pao2, L )
  use ac_misc_module

  implicit none
  type(PPcharge_type), intent(in) :: pao1
  type(PPloc_type), intent(in)    :: pao2
  real(8), intent(in) :: L(3)

  real(8), intent(out) :: dS(3)

  real(8) :: R(3)
  real(8)  :: dR
  real(8)  :: g, y, j
  real(8) :: dy(3), dj(3)

  R  = pao2%Ro + L - pao1%Ro
  dR = sqrt(dot_product(R,R))
  g = SphericalHarmonic__Gaunt( 0, 0, 0, 0, 0, 0 )
  y = SphericalHarmonic__rlY( 0, 0, R )
  dy = SphericalHarmonic__drlY( 0, 0, R )
  j = SphericalBessel__integrateS( pao1%RF%vK, pao2%RF%vK, 0, dR )
  dj = SphericalBessel__integratedS( pao1%RF%vK, pao2%RF%vK, 0, dR )*R

  dS = 4.d0*M_PI*g*dy*j + 4.d0*M_PI*g*y*dj

  return
end subroutine Density__bracketdS

subroutine Potential__setup
  use ac_misc_module

  implicit none

  call Potential__deallocate

  if( .not. Param%Option%projection ) then
     allocate( Potential%Vext(Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc) )
     Potential%Vext = 0.d0
  end if

  if( .not. Param%Option%nohar ) then
     allocate( Potential%dVhar(Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc) )
     Potential%dVhar = 0.d0
  end if

  if( .not. Param%Option%noexc ) then
     allocate( Potential%Vexc(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc) )
     Potential%Vexc = 0.d0
  end if

  allocate( Potential%Vtot(Param%Option%nspin,Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc) )
  Potential%Vtot = 0.d0

  call Potential__setExtLocal
  call Potential__setExtNonLocal

  return
end subroutine Potential__setup

subroutine Potential__update
  use ac_misc_module

  implicit none
  integer :: spin
  real(8) :: Ehar, Eexc

  if( .not. Param%Option%projection ) then
     if( Param%Option%spin_orbit ) then
        Potential%Vtot(1,:,:,:) = Potential%Vext(:,:,:)
        Potential%Vtot(2,:,:,:) = 0.d0
        Potential%Vtot(3,:,:,:) = 0.d0
        Potential%Vtot(4,:,:,:) = Potential%Vext(:,:,:)
     else
        do spin=1, Param%Option%nspin
           Potential%Vtot(spin,:,:,:) = Potential%Vext(:,:,:)
        end do
     end if
  else
     Potential%Vtot = 0.d0
  end if

  if( .not. Param%Option%nohar ) then
     if( Param%Option%spin_orbit ) then
        call HartreeLS__calcPotential( Ehar, Potential%dVhar, Density%rhoLS, Density%rhoval )

        Potential%Vtot(1,:,:,:) = Potential%Vtot(1,:,:,:) + Potential%dVhar(:,:,:)
        Potential%Vtot(4,:,:,:) = Potential%Vtot(4,:,:,:) + Potential%dVhar(:,:,:)
     else
        call Hartree__calcPotential( Ehar, Potential%dVhar, Density%rho, Density%rhoval )

        do spin=1, Param%Option%nspin
           Potential%Vtot(spin,:,:,:) = Potential%Vtot(spin,:,:,:) + Potential%dVhar(:,:,:)
        end do
     end if
  end if

  if( .not. Param%Option%noexc ) then
     if( Param%Option%spin_orbit ) then
        call ExchangeLS__calcPotential( Eexc, Potential%Vexc, Density%rhoLS, Density%rhopcc )
     else
        call Exchange__calcPotential( Eexc, Potential%Vexc, Density%rho, Density%rhopcc )
     end if
     Potential%Vtot = Potential%Vtot + Potential%Vexc
  end if

  return
end subroutine Potential__update

subroutine Potential__deallocate
  use ac_misc_module

  implicit none

  if( associated(Potential%Vext) ) deallocate( Potential%Vext )
  if( associated(Potential%dVhar) ) deallocate( Potential%dVhar )
  if( associated(Potential%Vexc) ) deallocate( Potential%Vexc )
  if( associated(Potential%Vtot) ) deallocate( Potential%Vtot )
  if( associated(Potential%vnVpsnon) ) deallocate( Potential%vnVpsnon )
  if( associated(Potential%viVpsnon) ) deallocate( Potential%viVpsnon )
  if( associated(Potential%vVpsnon) ) deallocate( Potential%vVpsnon )
  if( associated(Potential%vVpsloc) ) deallocate( Potential%vVpsloc )
  if( associated(Potential%vnVpsloc) ) deallocate( Potential%vnVpsloc )
  if( associated(Potential%viVpsloc) ) deallocate( Potential%viVpsloc )

  if( Param%Option%cluster ) then
     call Screening__deallocate
  endif

  return
end subroutine Potential__deallocate

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine cal_hamiltonian_accel

  use scf_negf
  use fft
  use hamiltonian_sgf
  use hamiltonian_c
  use gf_se_c
  use constant
  use condition_ini
  use mod_mpi

  implicit none

  call Hamiltonian__calcAMT__as2ac
  call AtomMatrix__calcT

  return
end subroutine cal_hamiltonian_accel

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine get_negfordft(file_name,calc_t_negfordft)

  use mod_mpi

  implicit none
  character(50), intent(inout) :: file_name,calc_t_negfordft

  character(256) :: buf
  character(50) :: dummy1,dummy2
  character(50) :: tag1,tag2

  open(unit=16,file=file_tempout,position='append')
  write(16,*) '********************** **************** **********************'
  write(16,*) '*               get condition // NEGF or DFT                 *'
  write(16,*) '*                      ++++++++++++++++                      *'
  close(16)

  calc_t_negfordft=''
  open(unit=19,file=file_name,status='old')
  do 
     read(19,'(a)',end=100) buf
     if( buf == '' ) then
        cycle
     end if
     read(buf,*) tag1
     if( tag1(1:1) == '#' ) then
        cycle
     end if
     select case(tag1)
     case('general{')
        do 
           read(19,'(a)',end=100) buf
           if( buf == '' ) then
              cycle
           end if
           read(buf,*) tag2
           if( tag2(1:1) == '#' ) then
              cycle
           end if
           select case(tag2)
           case('dft__negf')
              read(buf,*) dummy1,dummy2,calc_t_negfordft
              go to 100
           case('}general')
              go to 100
           end select
        end do
     end select
  end do
100 continue
  close(19)
  if( calc_t_negfordft == "" ) then
     open(unit=17,file=file_tempout,position='append')
     write(17,*) '!!! broken !!! //general/dft__negf// => stop'
     close(17)
     stop
  end if

  open(unit=16,file=file_tempout,position='append')
  write(16,999) calc_t_negfordft
  write(16,*) '********************** **************** **********************'
  write(16,*)
  write(16,*)
  close(16)
999 format(' *                   condition ::  ',a10,'                 *')

  return
end subroutine get_negfordft

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Naoki WATANABE, Nobutaka NISHIKAWA (Mizuho I.R.)   @@ !
! @@             Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine Param__Cell__setup(move)
  use ac_misc_module
  use ac_mpi_module
  implicit none

  integer, intent(in) :: move

  real(8) :: Kcutoff

  integer :: i, j
  real(8) :: L(3)
  real(8) :: Rg(3)
  real(8) :: a, b, c
  real(8) :: Rcmax
  integer :: Namax, Nbmax, Ncmax, Nmax
  integer :: na, nb, nc

  logical :: allinside, anyintersected

  Param%Cell%V   = dot_product( Param%Cell%La, Position__oprod( Param%Cell%Lb , Param%Cell%Lc ) )
  Param%Cell%dKa = Position__oprod( Param%Cell%Lb, Param%Cell%Lc) * (2.d0*M_PI/Param%Cell%V)
  Param%Cell%dKb = Position__oprod( Param%Cell%Lc, Param%Cell%La) * (2.d0*M_PI/Param%Cell%V)
  Param%Cell%dKc = Position__oprod( Param%Cell%La, Param%Cell%Lb) * (2.d0*M_PI/Param%Cell%V)

  if( Param%Cell%V < 0.d0 ) then
     Param%Cell%V = -Param%Cell%V
  end if

  Param%Cell%dKa1 = sqrt(dot_product(Param%Cell%dKa,Param%Cell%dKa))
  Param%Cell%dKb1 = sqrt(dot_product(Param%Cell%dKb,Param%Cell%dKb))
  Param%Cell%dKc1 = sqrt(dot_product(Param%Cell%dKc,Param%Cell%dKc))

  Kcutoff = sqrt(2.d0*Param%SCF%Ecutoff)

  call Param__Cell__findAppNumber(Param%Cell%Na,int(ceiling(2.d0*Kcutoff/Param%Cell%dKa1)))
  call Param__Cell__findAppNumber(Param%Cell%Nb,int(ceiling(2.d0*Kcutoff/Param%Cell%dKb1)))
  call Param__Cell__findAppNumber(Param%Cell%Nc,int(ceiling(2.d0*Kcutoff/Param%Cell%dKc1)))

  Param%Cell%dLa = Param%Cell%La*(1.d0/dble(Param%Cell%Na))
  Param%Cell%dLb = Param%Cell%Lb*(1.d0/dble(Param%Cell%Nb))
  Param%Cell%dLc = Param%Cell%Lc*(1.d0/dble(Param%Cell%Nc))

  Param%Cell%dV  = Param%Cell%V    &
       *(1.d0/dble(Param%Cell%Na)) &
       *(1.d0/dble(Param%Cell%Nb)) &
       *(1.d0/dble(Param%Cell%Nc))

  if( Param%Option%mx ) then
     Rg = 0.d0
     do i=1, Param%Data%natom
        Rg = Rg + Param%Data%vatom(i)%Ro
     end do
     Rg = Rg*(1.d0/Param%Data%natom)

     Param%Cell%Lo = Rg                           &
          - ( Param%Cell%La-Param%Cell%dLa        &
          + Param%Cell%Lb-Param%Cell%dLb          &
          + Param%Cell%Lc-Param%Cell%dLc )*0.5d0
  else
     Param%Cell%Lo = ( Param%Cell%dLa + Param%Cell%dLb + Param%Cell%dLc ) * 0.5d0
  end if

  if( Param%Data%natom == 0 ) then
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,'(a)') '      ++++++ Error!: no atoms are located.'
     close(16)
     stop
  end if

  if( move == 0 ) then
     allinside=.true.
     if( Param%Option%cluster ) then
        do i=1, Param%Data%natom
           if( .not. Param__Cell__inside( &
                Param%Data%vatom(i)%Ro, Param%Data%vatom(i)%Rc ) ) then
              allinside=.false.
              exit
           end if
        end do

        if( .not. allinside ) then
           open(unit=16,file=Param%Option%file_ac_tempout,position='append')
           write(16,'(a,a)') '      ++++++ Error!: not all atoms are located inside the central unit cell.'
           close(16)
           stop
        end if

     else
        do i=1, Param%Data%natom
           L = Param%Data%vatom(i)%Ro

           a = 0.5d0*M_1_PI*( sum(Param%Cell%dKa(:)*L(:)) )
           b = 0.5d0*M_1_PI*( sum(Param%Cell%dKb(:)*L(:)) )
           c = 0.5d0*M_1_PI*( sum(Param%Cell%dKc(:)*L(:)) )

           if( a < 0.d0 .or. a >= 1.d0 ) then
              Param%Data%vatom(i)%Ro = &
                   Param%Data%vatom(i)%Ro - Param%Cell%La*dble(floor(a))
              allinside=.false.
           end if

           if( b < 0.d0 .or. b >= 1.d0 ) then
              Param%Data%vatom(i)%Ro = &
                   Param%Data%vatom(i)%Ro - Param%Cell%Lb*dble(floor(b))
              allinside=.false.
           end if
           if( c < 0.d0 .or. c >= 1.d0 ) then
              Param%Data%vatom(i)%Ro = &
                   Param%Data%vatom(i)%Ro - Param%Cell%Lc*dble(floor(c))
              allinside=.false.
           end if
        end do

        if( .not. allinside ) then
           Param%Option%atom_move = .true. 
        end if
     end if
  end if

  if( Param%Option%cluster ) then
     Param%Cell%nL    = 1

     allocate( Param%Cell%vL(3,0:0) )
     Param%Cell%vL(:,0) = 0.d0

     allocate( Param%Cell%vLna(0:0) )
     Param%Cell%vLna(0) = 0
     allocate( Param%Cell%vLnb(0:0) )
     Param%Cell%vLnb(0) = 0
     allocate( Param%Cell%vLnc(0:0) )
     Param%Cell%vLnc(0) = 0

     return
  end if

  Rcmax=0.d0
  do i=1, Param%Data%natom
     if( Rcmax < Param%Data%vatom(i)%Rc ) Rcmax = Param%Data%vatom(i)%Rc
  end do

  Namax = int(2.d0*Rcmax/sqrt(dot_product(Param%Cell%La,Param%Cell%La)))+1
  Nbmax = int(2.d0*Rcmax/sqrt(dot_product(Param%Cell%Lb,Param%Cell%Lb)))+1
  Ncmax = int(2.d0*Rcmax/sqrt(dot_product(Param%Cell%Lc,Param%Cell%Lc)))+1
  Nmax  = (2*Namax+1)*(2*Nbmax+1)*(2*Ncmax+1)

  allocate( Param%Cell%vL(3,1-Nmax:Nmax-1) )
  allocate( Param%Cell%vLna(1-Nmax:Nmax-1) )
  allocate( Param%Cell%vLnb(1-Nmax:Nmax-1) )
  allocate( Param%Cell%vLnc(1-Nmax:Nmax-1) )

  Param%Cell%nL=0
  do nc=0, +Ncmax
     do nb=-Nbmax, +Nbmax
        if( nc==0 .and. nb<0 ) cycle
        do na=-Namax, +Namax
           if( nc==0 .and. nb==0 .and. na<0 ) cycle

           call Param__Cell__L(L,na,nb,nc)
           anyintersected = .false.

           if( Param%Option%indirect_overlap ) then
              anyintersected = .true.
           end if

           paoloop: do i=1, Param%Data%natom
              do j=1, Param%Data%natom
                 if( Param__Cell__intersect( &
                      Param%Data%vatom(i)%Ro, Param%Data%vatom(i)%Rc,&
                      Param%Data%vatom(j)%Ro+L, Param%Data%vatom(j)%Rc ) ) then
                    anyintersected = .true.
                    exit paoloop
                 end if

              end do
           end do paoloop

           if( anyintersected ) then
              Param%Cell%vL  (:,Param%Cell%nL) = L(:)
              Param%Cell%vLna(Param%Cell%nL) = na*Param%Cell%Na
              Param%Cell%vLnb(Param%Cell%nL) = nb*Param%Cell%Nb
              Param%Cell%vLnc(Param%Cell%nL) = nc*Param%Cell%Nc

              Param%Cell%vL  (:,-Param%Cell%nL) = (-1.d0)*L(:)
              Param%Cell%vLna(-Param%Cell%nL) = (-1)*na*Param%Cell%Na
              Param%Cell%vLnb(-Param%Cell%nL) = (-1)*nb*Param%Cell%Nb
              Param%Cell%vLnc(-Param%Cell%nL) = (-1)*nc*Param%Cell%Nc

              Param%Cell%nL = Param%Cell%nL + 1 
           end if
        end do
     end do
  end do

  return
end subroutine Param__Cell__setup

subroutine Param__SCF__setup
  use ac_misc_module
  implicit none

  integer        :: ika, ikb, ikc
  real(8) :: vK(3)
  integer        :: l, k
  real(8) :: temp

  allocate(Param%SCF%vK(3,Param%SCF%Nka*Param%SCF%Nkb*Param%SCF%Nkc) )

  allocate(Param%SCF%i_vK(Param%SCF%Nka*Param%SCF%Nkb*Param%SCF%Nkc) )

  Param%SCF%nK=0
  do ika=1, Param%SCF%Nka
     do ikb=1, Param%SCF%Nkb
        do ikc=1, Param%SCF%Nkc
           vK = Param%Cell%dKa*( 0.5d0*dble(2*ika-1)/Param%SCF%Nka - 0.5d0 ) &
                + Param%Cell%dKb*( 0.5d0*dble(2*ikb-1)/Param%SCF%Nkb - 0.5d0 ) &
                + Param%Cell%dKc*( 0.5d0*dble(2*ikc-1)/Param%SCF%Nkc - 0.5d0 )

           Param%SCF%nK = Param%SCF%nK + 1 
           Param%SCF%vK(:,Param%SCF%nK) = vK(:)
        end do
     end do
  end do

  if( .not. Param%Option%spin_orbit ) then
     do k=1, Param%SCF%nK
        Param%SCF%i_vK(k)=-100
     end do
     do k=1, Param%SCF%nK
        if( Param%SCF%i_vK(k) /= -100 ) then
           cycle
        end if
        Param%SCF%i_vK(k)=-1
        vK=Param%SCF%vK(:,k)
        temp=sqrt(dot_product(vK,vK))
        if( temp < 1.d-14 ) then
           cycle
        end if
        do l=k+1, Param%SCF%nK
           vK=Param%SCF%vK(:,k)+Param%SCF%vK(:,l)
           temp=sqrt(dot_product(vK,vK))
           if( temp < 1.d-14 ) then
              Param%SCF%i_vK(k)=-2
              Param%SCF%i_vK(l)=k
              exit
           end if
        end do
     end do
  else
     do k=1, Param%SCF%nK
        Param%SCF%i_vK(k)=-1
     end do
  end if

  allocate( Param%SCF%vbloch(Param%SCF%nK,0:Param%Cell%nL-1) )
  do l=0, Param%Cell%nL-1
     do k=1, Param%SCF%nK
        Param%SCF%vbloch(k,l) = polar( (-1.0d0) * dot_product(Param%SCF%vK(:,k),Param%Cell%vL(:,l)) )
     end do
  end do

  return
end subroutine Param__SCF__setup

subroutine Param__Band__setup
  use ac_misc_module
  implicit none

  integer :: i, j, k
  real(8) :: V
  real(8) :: f

  if( Param%Band%fname == "" ) then
     allocate( Param%Band%vK(3,1:1) )
     Param%Band%vK(:,1) = 0.d0
     Param%Band%nK    = 1
     return
  end if

  if( dot_product( Param%Band%La,Param%Band%La ) == 0.0d0 ) then
     V = Param%Cell%V
     Param%Band%dKa = Param%Cell%dKa
     Param%Band%dKb = Param%Cell%dKb
     Param%Band%dKc = Param%Cell%dKc
  else
     V = dot_product( Param%Band%La, Position__oprod( Param%Band%Lb, Param%Band%Lc) )
     Param%Band%dKa = Position__oprod( Param%Band%Lb, Param%Band%Lc) * (2*M_PI/V)
     Param%Band%dKb = Position__oprod( Param%Band%Lc, Param%Band%La) * (2*M_PI/V)
     Param%Band%dKc = Position__oprod( Param%Band%La, Param%Band%Lb) * (2*M_PI/V)
  end if

  do i=1, Param%Band%nKpath
     Param%Band%vKpath(i)%ks = &
          Param%Band%dKa*Param%Band%vKpath(i)%ks(1) &
          + Param%Band%dKb*Param%Band%vKpath(i)%ks(2) &
          + Param%Band%dKc*Param%Band%vKpath(i)%ks(3)
     Param%Band%vKpath(i)%ke = &
          Param%Band%dKa*Param%Band%vKpath(i)%ke(1) &
          + Param%Band%dKb*Param%Band%vKpath(i)%ke(2) &
          + Param%Band%dKc*Param%Band%vKpath(i)%ke(3)
  end do

  Param%Band%nK = 0
  do i=1, Param%Band%nKpath
     Param%Band%nK = Param%Band%nK + Param%Band%vKpath(i)%mesh
  end do
  allocate( Param%Band%vK(3,Param%Band%nK) )

  k=0
  do i=1, Param%Band%nKpath
     if( Param%Band%vKpath(i)%mesh == 1 ) then
        k = k + 1
        Param%Band%vK(:,k) = Param%Band%vKpath(i)%ks
        cycle
     end if

     do j=1, Param%Band%vKpath(i)%mesh
        f = dble(j-1)/dble(Param%Band%vKpath(i)%mesh-1)
        k = k + 1
        Param%Band%vK(:,k) = Param%Band%vKpath(i)%ks*(1.d0-f) + Param%Band%vKpath(i)%ke*(f)
     end do
  end do

  return
end subroutine Param__Band__setup

subroutine Param__DOS__setup
  use ac_misc_module
  use ac_mpi_module
  implicit none

  if( Param%DOS%fname == "" ) then
     return
  end if

  if( Param%DOS%Nka == 0 .and. Param%DOS%Nkb == 0 .and. Param%DOS%Nkc == 0 ) then
     Param%DOS%Nka = Param%SCF%Nka
     Param%DOS%Nkb = Param%SCF%Nkb
     Param%DOS%Nkc = Param%SCF%Nkc
  end if

  Param%DOS%nK = Param%DOS%Nka * Param%DOS%Nkb * Param%DOS%Nkc
  Param%DOS%dE = (Param%DOS%Emax - Param%DOS%Emin)/(Param%DOS%Ne-1)

  if( MPI%root ) then
     if( Param%DOS%method == "tetrahedron" .and. Param%DOS%nK == 1 ) then
        open(unit=16,file=Param%Option%file_ac_tempout,position='append')
        write(16,'(a)') '      ++++++ Error!: Insufficient Dos.Kgrid for method tetrahedron.'
        close(16)
        stop
     end if
  end if

  return
end subroutine Param__DOS__setup

subroutine Param__MO__setup
  use ac_misc_module
  implicit none

  integer :: i
  real(8) :: V

  if( Param%MO%fbase == "" ) then
     return
  end if

  if( dot_product(Param%MO%La,Param%MO%La) == 0.0d0 ) then
     V = Param%Cell%V
     Param%MO%dKa = Param%Cell%dKa
     Param%MO%dKb = Param%Cell%dKb
     Param%MO%dKc = Param%Cell%dKc
  else
     V = dot_product( Param%MO%La, Position__oprod( Param%MO%Lb, Param%MO%Lc) )
     Param%MO%dKa = Position__oprod( Param%MO%Lb, Param%MO%Lc) * (2*M_PI/V)
     Param%MO%dKb = Position__oprod( Param%MO%Lc, Param%MO%La) * (2*M_PI/V)
     Param%MO%dKc = Position__oprod( Param%MO%La, Param%MO%Lb) * (2*M_PI/V)
  end if

  if( Param%MO%band_min == 0 .and. Param%MO%band_max == 0 ) then
     if( Param%MO%method == "band_num" ) then
        Param%MO%band_min = 1
        Param%MO%band_max = 5
     else if( Param%MO%method == "ho_lumo" ) then
        Param%MO%band_min = -5
        Param%MO%band_max = +5
     end if
  end if

  do i=1, Param%MO%nK
     Param%MO%vK(:,i) = Param%MO%dKa * Param%MO%vK(1,i) + Param%MO%dKb * Param%MO%vK(2,i) + Param%MO%dKc * Param%MO%vK(3,i)
  end do

  return
end subroutine Param__MO__setup

subroutine Param__Cell__getRange( range, Ro, Rc )
  use ac_misc_module
  implicit none

  integer, intent(out)       :: range(6)
  real(8), intent(in) :: Ro(3)
  real(8), intent(in)        :: Rc

  real(8) :: L(3)

  L = Ro - Param%Cell%Lo

  range(1) = int(floor  (0.5d0*M_1_PI*( sum(Param%Cell%dKa(:)*L(:)) - Param%Cell%dKa1*Rc )*Param%Cell%Na))+1
  range(2) = int(ceiling(0.5d0*M_1_PI*( sum(Param%Cell%dKa(:)*L(:)) + Param%Cell%dKa1*Rc )*Param%Cell%Na))+1
  range(3) = int(floor  (0.5d0*M_1_PI*( sum(Param%Cell%dKb(:)*L(:)) - Param%Cell%dKb1*Rc )*Param%Cell%Nb))+1
  range(4) = int(ceiling(0.5d0*M_1_PI*( sum(Param%Cell%dKb(:)*L(:)) + Param%Cell%dKb1*Rc )*Param%Cell%Nb))+1
  range(5) = int(floor  (0.5d0*M_1_PI*( sum(Param%Cell%dKc(:)*L(:)) - Param%Cell%dKc1*Rc )*Param%Cell%Nc))+1
  range(6) = int(ceiling(0.5d0*M_1_PI*( sum(Param%Cell%dKc(:)*L(:)) + Param%Cell%dKc1*Rc )*Param%Cell%Nc))+1

  return
end subroutine Param__Cell__getRange

subroutine Param__Data__setup
  use ac_misc_module
  implicit none

  integer :: i, a, n, npao, nvps
  type(Element_type), pointer :: elem


  call SphericalBessel__setup( Param%Integral1D%Nr, Param%Integral1D%Nk, Param%Integral1D%Ecutoff )

  do i=1, Param%Data%nelem
     call Element__setup( Param%Data%velem(i) )
  end do

  Param%Data%Ne = 0.d0
  do a=1, Param%Data%natom
     Param%Data%Ne = Param%Data%Ne + Param%Data%vatom(a)%Q
  end do
  if( Param%Data%Ne_extra /= 0.0d0 ) then
     Param%Data%Ne = Param%Data%Ne + Param%Data%Ne_extra
  end if

  if( .not. Param%Option%spin_polar ) then
     Param%Data%g = 2.d0
  else
     Param%Data%g = 1.d0
  end if

  if( Param%Data%Ne == 1.d0 ) Param%Data%g = 1.d0

  Param%Data%npao=0
  Param%Data%nvps=0
  allocate( Param%Data%vnpao(Param%Data%natom) )
  allocate( Param%Data%vipao(Param%Data%natom) )
  do a=1, Param%Data%natom
     elem => Param__Data__getElement( Param%Data%vatom(a)%name )

     npao = Element__getNumberOfPAO(elem)
     nvps = Element__getNumberOfVPS(elem)

     Param%Data%vipao(a) = Param%Data%npao + 1
     Param%Data%vnpao(a) = npao
     Param%Data%npao = Param%Data%npao + npao
     Param%Data%nvps = Param%Data%nvps + nvps
  end do

  return
end subroutine Param__Data__setup

subroutine Param__Option__show
  use ac_misc_module
  implicit none

  integer :: i

  write(16,*)
  write(16,*) '========================= file  name ========================='
  write(16,*)


  do i=1, Param%Data%nelem
     write(16,904) trim(Param%Data%velem_file(i,1))                           &
          ,trim(Param%Data%velem_file(i,2))
904  format(' /input/ file name -     PAO  ',a2,': ',a)
     write(16,905) trim(Param%Data%velem_file(i,1))                           &
          ,trim(Param%Data%velem_file(i,4))
905  format(' /input/ file name -     VPS  ',a2,': ',a)
  end do

  write(16,*)

  if( Param%Option%fname_rhoscf_in /= "" ) then
     write(16,900) trim(Param%Option%fname_rhoscf_in)
900  format(' /input/ file name -     density: ',a)
  end if

  if( Param%Option%fname_matrices_in /= "" ) then
     write(16,903) trim(Param%Option%fname_matrices_in)
903  format(' /input/ file name - hamiltonian: ',a)
  end if

  write(16,*)

  write(16,920) trim(Param%Option%fname_rhoscf)
920 format('/output/ file name -     density: ',a)
  write(16,923) trim(Param%Option%fname_rhoval)
923 format('/output/ file name -       Diso : ',a)
  write(16,924) trim(Param%Option%fname_rhopcc)
924 format('/output/ file name -       Dpcc : ',a)

  write(16,*)

  write(16,930) trim(Param%Option%fname_vtot)
930 format('/output/ file name -       Vtot : ',a)

  write(16,926) trim(Param%Option%fname_vhar)
926 format('/output/ file name -         Vh : ',a)

  write(16,927) trim(Param%Option%fname_vexc)
927 format('/output/ file name -        Vxc : ',a)

  write(16,925) trim(Param%Option%fname_vext)
925 format('/output/ file name -       Vext : ',a)

  write(16,*)

  write(16,933) trim(Param%Option%fname_matrices)
933 format('/output/ file name - hamiltonian: ',a)

  write(16,*)

  if( Param%Band%fname /= "" ) then
     if( .not. Param%Option%spin_polar ) then
        write(16,940) trim(Param%Band%fname)
940     format('/output/ file name -       BAND : ',a)
     else
        write(16,943) trim(Param%Band%fname),trim(Param%Band%fname1)
943     format('/output/ file name -       BAND : ',a,' & ',a)
     end if
  end if
  if( Param%DOS%fname /= "" ) then
     write(16,941) trim(Param%DOS%fname)
941  format('/output/ file name -        DOS : ',a)
  end if
  if( Param%MO%fbase /= "" ) then
     write(16,942) trim(Param%MO%fbase)
942  format('/output/ file name -         MO : ',a)
  end if

  write(16,*)
  write(16,*) '--------------------- file name for NEGF ---------------------'
  write(16,*)

  write(16,953) trim(Param%Option%fname_ascot_vd)
953 format('  /output/ file name -        vd: ',a)
  write(16,954) trim(Param%Option%fname_ascot_in)
954 format('  /output/ file name - condition: ',a)
  write(16,950) trim(Param%Option%fname_accel_c)
950 format('  /output/ file name -    junc_h: ',a)

  return
end subroutine Param__Option__show

subroutine Param__SCF__show
  use ac_misc_module
  use ac_mpi_module
  implicit none
  character(10) :: chara_temp

  write(16,*)

  write(16,921) Param%SCF%exc_type
921 format('                        Vxc type: ',a)

  if( Param%Option%projection ) then
     chara_temp='on'
  else
     chara_temp='off'
  end if
  write(16,951) chara_temp
951 format('                 Vloc projection: ',a)

  write(16,922) Param%SCF%Te*AU_TO_KELVIN
922 format('         electric temperature[K]: ',f10.4)
  write(16,923) Param%SCF%Ecutoff
923 format('  real space energy cutoff[a.u.]: ',f10.4)

  write(16,925) Param%SCF%Nka, Param%SCF%Nkb, Param%SCF%Nkc
925 format('                        K points: (',i3,',',i3,',',i3,')')

  write(16,*)
  if( Param%Option%spin_polar ) then
     chara_temp='on'
  else
     chara_temp='off'
  end if
  write(16,924) chara_temp
924 format('               spin polarization: ',a)
  if( Param%Option%spin_orbit ) then
     chara_temp='on'
  else
     chara_temp='off'
  end if
  write(16,950) chara_temp
950 format('             spin orbit coupling: ',a)

  if( Param%Option%cluster ) then
     chara_temp='on'
  else
     chara_temp='off'
  end if
  write(16,928) chara_temp
928 format('                         cluster: ',a)

  write(16,*) 
  write(16,912) Param%SCF%cri_type
912 format('                        scf diff: ',a)
  write(16,913) Param%SCF%criterion
913 format('          scf convergence [a.u.]: ',e10.5)
  write(16,914) Param%SCF%iter_max
914 format('         max number of iteration: ' ,i10)

  write(16,915) Param%SCF%mix_type
915 format('                   mixing method: ',a10)
  write(16,935) Param%SCF%mix_target
935 format('                          target: ',a)
  if( Param%SCF%mix_type == "Pulay" ) then
     write(16,917) Param%SCF%mix_history
917  format('            Pulay-  mixing steps: ',i10)
     write(16,926) Param%SCF%mix_start
926  format('            Pulay- starting step: ',i10)
  end if
  if( Param%SCF%mix_type /= "Simple" ) then
     write(16,916) Param%SCF%mix_weight
916  format('                   mixing weight: ',f10.4)
  end if
  if( Param%SCF%mix_type /= "Anderson" ) then
     write(16,958) Param%SCF%mix_weight_s
958  format('          mixing weight (simple): ',f10.4)
  end if

  write(16,*)
  write(16,927) trim(Param%Option%saveat)
927 format('                        output at: ',a)

  write(16,*)
  write(16,*) '===========            force calculation            =========='
  write(16,*)
  if( Param%Option%optimize ) then
     if( Param%SCF%opt_iter_max > 0 ) then
        chara_temp='optimize'
        write(16,942) chara_temp
        write(16,945) Param%Option%optimize_method
        write(16,943) Param%SCF%force_criterion
        write(16,944) Param%SCF%opt_iter_max
     else
        chara_temp='on'
        write(16,942) chara_temp
     end if
  else
     chara_temp='off'
     write(16,942) chara_temp
  end if
942 format('               force calculation: ',a)
943 format('    opt force convergence [a.u.]: ',e10.5)
944 format('   max_num of optimization iter.: ' ,i10)
945 format('                          method: ',a)


  write(16,*)
  write(16,*) '=========== one-dimensional integration calculation =========='
  write(16,*)
  write(16,918) Param%Integral1D%Nr
918 format('          real space grid points: ',i10)
  write(16,919) Param%Integral1D%Nk
919 format('          reciprocal grid points: ',i10)
  write(16,920) Param%Integral1D%Ecutoff
920 format('             energy cutoff [a.u]: ',e10.5)


  if( MPI%num_sc_work2space >= -1.d0 ) then
     write(16,*)
     write(16,*) '===========              for ScaLapack              =========='
     write(16,*)
     write(16,953) MPI%num_sc_work2space
953  format('               num_sc_work2space: ',f10.2)
     write(16,952) MPI%num_check_sc
952  format('                    num_check_sc: ',i10)
  end if

  return
end subroutine Param__SCF__show

subroutine Param__Band__show
  use ac_misc_module
  implicit none

  type(Element_type), pointer :: elem
  integer :: i,a,n

  if( Param%Band%fname == "" ) return

  i=0

  write(16,*)
  write(16,*) '====================== Band calculation ======================'
  write(16,*)
  write(16,910) Param%Band%num_band
910 format('                show band number: ',i10)

  if( Param%Band%num_band == 0 ) then
     Param%Data%Ne=0.d0
     do a=1, Param%Data%natom
        Param%Data%Ne = Param%Data%Ne + Param%Data%vatom(a)%Q
     end do
     Param%Band%num_band=Param%Data%Ne
     if( Param%Option%spin_orbit ) then
        Param%Band%num_band=Param%Band%num_band+5
     else
        !!            Param%Band%num_band=Param%Data%Ne/2+imod(Param%Band%num_band,2)+5
        Param%Band%num_band=Param%Data%Ne/2+mod(Param%Band%num_band,2)+5
     end if
     i=1
  end if

  Base%npao=0
  do a=1, Param%Data%natom
     elem => Param__Data__getElement( Param%Data%vatom(a)%name )
     do n=1, elem%npao
        Base%npao = Base%npao + 2*(elem%vpao(n)%l) + 1
     end do
  end do
  if( Param%Band%num_band > Base%npao ) then
     Param%Band%num_band=Base%npao
     i=1
  end if

  if( i == 1 )then
     write(16,912) Param%Band%num_band
912  format('                               => ',i10,' !! (def)')
  end if

  write(16,911) Param%Band%nK
911 format('                  total K points: ',i10)

  return
end subroutine Param__Band__show

subroutine Param__DOS__show
  use ac_misc_module
  implicit none

  if( Param%DOS%fname == "" ) return

  write(16,*)
  write(16,*) '================ Density of states calculation ==============='
  write(16,*)
  write(16,912) Param%DOS%method
912 format('                          method: ',a)
  write(16,925) Param%DOS%Nka, Param%DOS%Nkb, Param%DOS%Nkc
925 format('                        K points: (',i3,',',i3,',',i3,')')

  write(16,*)
  write(16,911) Param%DOS%Emin*AU_TO_EV, Param%DOS%Emax*AU_TO_EV
911 format('                energy range[eV]: ',e12.5,' -> ',e12.5)
  write(16,910) Param%DOS%Ne
910 format('                     energy grid: ',i10)
  if( Param%DOS%method == 'gaussian' ) then
     write(16,914) Param%DOS%GB*AU_TO_EV
914  format('         gaussian broadening[eV]: ',e12.5)
  end if

  return
end subroutine Param__DOS__show

subroutine Param__MO__show
  use ac_misc_module
  implicit none

  if( Param%MO%fbase == "" ) return

  write(16,*)
  write(16,*) '================ Molecular orbital calculation ==============='
  write(16,*)
  write(16,912) Param%MO%method
912 format('        band range specification: ',a)
  write(16,911) Param%MO%band_min, Param%MO%band_max
911 format('               output band range: ',i10,' -> ',i10)
  write(16,913) Param%MO%nK
913 format('                  total K points: ',i10)

  return
end subroutine Param__MO__show

subroutine Param__Data__show
  use ac_misc_module
  implicit none
  integer :: a, n, napao, ll
  character(10) :: chara_temp
  integer, allocatable :: vnpao_temp(:)
  type(Element_type), pointer :: elem

  write(16,*)
  write(16,*)
  write(16,*) '--------------------------------------------------------------'
  write(16,*) '------------   PAO bases and Pseudo-potentials:'
  write(16,*) '--------------------------------------------------------------'
  write(16,950) trim(Param%Data%element_type)
950 format('                    element type: 'a)
  write(16,*)

  do a=1, Param%Data%nelem

     if( Param%Data%velem(a)%pcc ) then
        chara_temp='on'
     else
        chara_temp='off'
     end if

     if((Param%Data%element_type=='ciao_ls') &
          .and.(.not. Param%Option%spin_orbit) &
          .and.(Param%Data%velem(a)%dirac)) then
        ll=1
     else
        ll=0
     end if
     write(16,940) a,Param%Data%velem(a)%name,Param%Data%velem(a)%npao      &
          ,Param%Data%velem(a)%nVnon-ll,chara_temp
940  format('  (',i3,') name: ',a2,' ,PAO:',i2,' ,VPS:',i2,' ,PCC:',a4)

     write(16,941) '       PAO (l,Rc) ='
941  format(a,$)
     do n=1, Param%Data%velem(a)%npao
        write(16,942) ' ('
942     format(a,$)
        write(16,943) Param%Data%velem(a)%vpao(n)%l, Param%Data%velem(a)%vpao(n)%Rc
943     format(i1,1x,f4.2,$)
        write(16,944) ')'
944     format(a,$)
     end do
     write(16,*)

     write(16,945) '     VPS (l,E,Rc) ='
945  format(a,$)
     if( Param%Data%velem(a)%nVnon-ll == 0 ) then
        write(16,946) ' none'
946     format(a,$)
     end if
     do n=1, Param%Data%velem(a)%nVnon
        if((Param%Data%element_type=='ciao_ls') &
             .and.(.not. Param%Option%spin_orbit) &
             .and.(Param%Data%velem(a)%dirac) &
             .and.(Param%Data%velem(a)%vVnon(n,1)%l==Param%Data%velem(a)%Vloc%l)) then
           cycle
        end if
        write(16,947) ' ('
947     format(a,$)
        write(16,948) &
             Param%Data%velem(a)%vVnon(n,1)%l, &
             Param%Data%velem(a)%vVnon(n,1)%Q, &
             Param%Data%velem(a)%vVnon(n,1)%Rc
948     format(i1,1x,e8.2,1x,f4.2,$)
        write(16,949) ')'
949     format(a,$)
     end do
     write(16,*)

  end do

  write(16,*) '--------------------------------------------------------------'
  write(16,*)
  write(16,*) '--------------------------------------------------------------'
  write(16,*) '------------   Unit cell:'
  write(16,*) '--------------------------------------------------------------'

  write(16,*) '   real space unit vectors[a.u.]'
  write(16,923) Param%Cell%La(:)
923 format('                               A: ',f9.4,' ',f9.4,' ',f9.4)
  write(16,924) Param%Cell%Lb(:)
924 format('                               B: ',f9.4,' ',f9.4,' ',f9.4)
  write(16,925) Param%Cell%Lc(:)
925 format('                               C: ',f9.4,' ',f9.4,' ',f9.4)

  write(16,*)
  write(16,921) Param%Cell%V
921 format('          unit cell volume[a.u.]: ',e10.4)
  write(16,*)

  write(16,*) '   reciprocal space unit vectors'
  write(16,926) Param%Cell%dKa(:)
926 format('                             dKa: ',f9.4,' ',f9.4,' ',f9.4)
  write(16,927) Param%Cell%dKb(:)
927 format('                             dKb: ',f9.4,' ',f9.4,' ',f9.4)
  write(16,928) Param%Cell%dKc(:)
928 format('                             dKc: ',f9.4,' ',f9.4,' ',f9.4)

  write(16,*)

  write(16,920) Param%Cell%Na, Param%Cell%Nb, Param%Cell%Nc
920 format('          real space grid points: (',i4,',',i4,',',i4,')')
  write(16,922) Param%Cell%nL
922 format('    total neighboring unit cells: ',i10)

  allocate( vnpao_temp(Param%Data%natom) )

  Param%Data%Ne=0.d0
  do a=1, Param%Data%natom
     Param%Data%Ne = Param%Data%Ne + Param%Data%vatom(a)%Q
  end do
  Base%npao=0
  do a=1, Param%Data%natom
     napao = 0
     elem => Param__Data__getElement( Param%Data%vatom(a)%name )
     do n=1, elem%npao
        napao = napao + 2*(elem%vpao(n)%l) + 1
     end do
     vnpao_temp(a) = napao
     Base%npao = Base%npao + napao
  end do

  write(16,*) '--------------------------------------------------------------'
  write(16,*)
  write(16,*) '--------------------------------------------------------------'
  write(16,*) '------------   Atoms:'
  write(16,*) '--------------------------------------------------------------'
  if( Param%Option%atom_move ) then
     write(16,*) ' !Warning!: some atoms are moved inside the central unit cell.'
     write(16,*)
  end if

  write(16,932) Base%npao
932 format('                 total PAO bases: ',i10)
  write(16,930) Param%Data%natom
930 format('                     total atoms: ',i10)
  write(16,931) Param%Data%Ne
931 format('                 total electrons: ',f10.4)

  write(16,*)

  write(16,*) ' atom   Q         Rc       PAO    Ro'
  do a=1, Param%Data%natom
     if( Param%Data%vatom(a)%optimize .and. Param%SCF%opt_iter_max /= 0 ) then
        chara_temp='free'
     else
        chara_temp='fixed'
     end if
     write(16,933) a,Param%Data%vatom(a)%name, Param%Data%vatom(a)%Q,       &
          Param%Data%vatom(a)%Rc,vnpao_temp(a),                      &
          Param%Data%vatom(a)%Ro(:),        &
          chara_temp
933  format(i4,'  ',a2,f9.4,f9.4,i5,'  ',f9.4,f9.4,f9.4,'  ',a5)
  end do

  write(16,*) '--------------------------------------------------------------'
  write(16,*)

  deallocate( vnpao_temp )

  return
end subroutine Param__Data__show

subroutine Param__deallocate
  use ac_misc_module
  implicit none

  integer :: a

  if( associated(Param%Cell%vL) ) deallocate( Param%Cell%vL )
  if( associated(Param%Cell%vLna) ) deallocate( Param%Cell%vLna )
  if( associated(Param%Cell%vLnb) ) deallocate( Param%Cell%vLnb )
  if( associated(Param%Cell%vLnc) ) deallocate( Param%Cell%vLnc )
  if( associated(Param%SCF%vbloch) )   deallocate( Param%SCF%vbloch )
  if( associated(Param%SCF%vK) )   deallocate( Param%SCF%vK )
  if( associated(Param%SCF%i_vK) )   deallocate( Param%SCF%i_vK )

  if( associated(Param%Band%vKpath) ) deallocate( Param%Band%vKpath )
  if( associated(Param%Band%vK) ) deallocate( Param%Band%vK )

  if( associated(Param%MO%vK) ) deallocate( Param%MO%vK )

  do a=1, Param%Data%nelem
     call Element__deallocate( Param%Data%velem(a) )
  end do
  do a=1, Param%Data%natom
     call Atom__deallocate( Param%Data%vatom(a) )
  end do

  if( associated(Param%Data%velem) ) deallocate( Param%Data%velem )
  if( associated(Param%Data%vatom) ) deallocate( Param%Data%vatom )
  if( associated(Param%Data%vnpao) ) deallocate( Param%Data%vnpao )
  if( associated(Param%Data%vipao) ) deallocate( Param%Data%vipao )

  if( associated(Param%Data%velem_file) ) deallocate( Param%Data%velem_file )

  call SphericalBessel__deallocate

  return
end subroutine Param__deallocate

subroutine Param__read( fname )
  use ac_misc_module
  use ac_mpi_module
  implicit none

  character(len=*) fname

  integer        :: iunit
  logical        :: ex
  character(256) :: buf
  character(32)  :: tag

  integer        :: i, j
  real(8)  :: MOL_TO_AU, CEL_TO_AU
  character(16)  :: name
  character(64)  :: name_pao, mode, name_vps, mode2
  character(256) :: fname_pao, fname_vps
  character(16)  :: str

  real(8) :: R(3)
  real(8) :: ks(3), ke(3)
  integer        :: mesh
  type(Element_type), pointer :: elem

  logical        :: internal_coordinate = .false.
  real(8)        :: Qu, Qd
  logical        :: optimize
  character(256) :: dummy

  integer        :: is_opt=0
  real(8) :: mass = 0.0d0

  open(unit=16,file=Param%Option%file_ac_tempout,position='append')
  write(16,*) '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'
  write(16,999) fname
  write(16,*)
999 format(' +++++++++++ start: read file:: ',a15)
  close(16)

  inquire(file=fname,exist=ex)
  if( .not. ex ) then
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,'(a,a)') '      ++++++ Error!: can not open file', trim(fname)
     close(16)
     stop
  end if
  iunit=1
  open(iunit, file=fname)

  MOL_TO_AU = AA_TO_AU
  CEL_TO_AU = AA_TO_AU

  do 
     read(iunit, '(a)', end=100) buf
     if( uncomment(buf) ) cycle
     read(buf,*) tag

     select case(tag)

     case('general{')
        do
           read(iunit, '(a)', end=100) buf
           if( uncomment(buf) ) cycle
           read(buf,*) tag

           select case(tag)
           case('system_name')
              read(buf,*) tag, Param%name
           case('dft__negf')
              cycle
           case('model_type')
              cycle
           case('calc_type')
              cycle
           case('read_SF_file')
              cycle
           case('output_G&T')
              cycle
           case('output_G')
              cycle
           case('output_T')
              cycle
           case('output_H')
              cycle
           case('band_calc_type')
              cycle

           case('}general')
              exit

           case default
              open(unit=16,file=Param%Option%file_ac_tempout,position='append')
              write(16,'(a,a,a)') '??? broken ??? //general{} has an unknown tag ', trim(tag), '// => stop'
              close(16)
              go to 1111

           end select
        end do
     case('}general')
        open(unit=16,file=Param%Option%file_ac_tempout,position='append')
        write(16,'(a)') '??? broken ??? //general{}// => stop'
        close(16)
        go to 1111


     case('accuracy{')
        do 
           read(iunit, '(a)', end=100) buf
           if( uncomment(buf) ) cycle
           read(buf,*) tag

           select case(tag)
           case('energy_cutoff')
              read(buf,*,end=1001) tag, Param%SCF%Ecutoff, str
              Param%SCF%Ecutoff = Param%SCF%Ecutoff * TO_AU(str)
              goto 1002
1001          continue
              Param%SCF%Ecutoff = Param%SCF%Ecutoff * RY_TO_AU
1002          continue

           case('temperature')
              read(buf,*,end=1011) tag, Param%SCF%Te, str
              Param%SCF%Te = Param%SCF%Te * TO_AU(str)
              goto 1012
1011          continue
              Param%SCF%Te = Param%SCF%Te * KELVIN_TO_AU
1012          continue

           case('scf_criterion_type')
              read(buf,*) tag, str
              select case(str)
              case('fermi')
                 Param%SCF%cri_type = 'fermi'
              case('orbital')
                 Param%SCF%cri_type = 'orbital'
              case('total')
                 Param%SCF%cri_type = 'total'
              case('density')
                 Param%SCF%cri_type = 'density'
              case default
                 open(unit=16,file=Param%Option%file_ac_tempout,position='append')
                 write(16,'(a)') '??? broken ??? //accuracy/scf_criterion_type// => stop'
                 close(16)
                 go to 1111
              end select

           case('scf_convergence')
              read(buf,*,end=1021) tag, Param%SCF%criterion, str
              Param%SCF%criterion = Param%SCF%criterion * TO_AU(str)
              goto 1022
1021          continue
              Param%SCF%criterion = Param%SCF%criterion
1022          continue

           case('num_max_iteration')
              read(buf,*) tag, Param%SCF%iter_max

           case('ksampling{')
              do
                 read(iunit, '(a)', end=100) buf
                 if( uncomment(buf) ) cycle
                 read(buf,*) tag

                 select case(tag)
                 case('method')
                    read(buf,*) tag, str
                    select case(str)
                    case("gamma")
                       Param%SCF%Nka=1
                       Param%SCF%Nkb=1
                       Param%SCF%Nkc=1
                    case("mesh")
                       read(iunit,'(a)') buf
                       read(iunit,'(a)') buf
                       read(buf,*) Param%SCF%Nka, Param%SCF%Nkb, Param%SCF%Nkc
                       read(iunit,'(a)') buf
                    case default
                       open(unit=16,file=Param%Option%file_ac_tempout,position='append')
                       write(16,'(a)') '??? broken ??? //accuracy/ksampling/method//'
                       close(16)
                    end select

                 case('}ksampling')
                    exit

                 case default
                    open(unit=16,file=Param%Option%file_ac_tempout,position='append')
                    write(16,'(a,a,a)') '??? broken ??? //accuracy/ksampling{} has an unknown tag ', trim(tag), '// => stop'
                    close(16)
                    go to 1111


                 end select
              end do

           case('}ksampling')
              open(unit=16,file=Param%Option%file_ac_tempout,position='append')
              write(16,'(a)') '??? broken ??? //accuracy/ksampling{}// => stop'
              close(16)
              go to 1111


           case('xctype')
              read(buf,*) tag, str
              select case(str)
              case('ldapz81')
                 Param%SCF%exc_type = 'PZ81'
              case('ldapw91')
                 Param%SCF%exc_type = 'PW91'
              case('ggapbe')
                 Param%SCF%exc_type = 'PBE'
              case default
                 open(unit=16,file=Param%Option%file_ac_tempout,position='append')
                 write(16,'(a)') '??? broken ??? //accuracy/xctype// => stop'
                 close(16)
                 go to 1111
              end select


           case('element_data_path_vps')
              read(buf,*) tag, Param%Data%path_vps
              if( Param%Data%path_vps == "" ) then
                 Param%Data%path_vps = "."
              end if

           case('element_data_path_pao')
              read(buf,*) tag, Param%Data%path_pao
              if( Param%Data%path_pao == "" ) then
                 Param%Data%path_pao = "."
              end if

           case('element_type')
              read(buf,*) tag, str
              select case(str)
              case('ciao')
                 Param%Data%element_type = "ciao"
              case('ciao_ls')
                 Param%Data%element_type = "ciao_ls"
              case('adpack')
                 Param%Data%element_type = "adpack"
              case default
                 open(unit=16,file=Param%Option%file_ac_tempout,position='append')
                 write(16,'(a)') '??? broken ??? //accuracy/element_type// => stop'
                 close(16)
                 go to 1111
              end select

           case('num_element')
              read(buf,*) tag, Param%Data%nelem

           case('element_list{')
              if( Param%Data%nelem <= 0 ) then
                 open(unit=16,file=Param%Option%file_ac_tempout,position='append')
                 write(16,'(a)') '??? broken ??? //accuracy/num_element// => stop'
                 close(16)
                 goto 1111
              end if

              allocate( Param%Data%velem(Param%Data%nelem))
              allocate( Param%Data%velem_file(Param%Data%nelem,5))

              do i=1, Param%Data%nelem
                 read(iunit, '(a)') buf

                 read(buf,*,end=1115) name, name_pao, name_vps, mode, dummy, mass
                 mode2 = ""
                 goto 1114
1115             continue
                 read(buf,*,end=1112) name, name_pao, name_vps, mode, mode2
                 goto 1114
1112             continue
                 read(buf,*,end=1113) name, name_pao, name_vps, mode
                 mode2 = ""
                 goto 1114
1113             continue
                 mode  = ""
                 mode2 = ""
                 goto 1114
1114             continue

                 fname_pao = trim(Param%Data%path_pao) // "/" // trim(name_pao)
                 fname_vps = trim(Param%Data%path_vps) // "/" // trim(name_vps)

                 Param%Data%velem_file(i,1)=name
                 Param%Data%velem_file(i,2)=fname_pao
                 Param%Data%velem_file(i,3)=mode
                 Param%Data%velem_file(i,4)=fname_vps
                 Param%Data%velem_file(i,5)=mode2

                 select case(Param%Data%element_type)
                 case('ciao')
                    call Element__readPAO_ciao  ( Param%Data%velem(i), name, fname_pao, mode, mode2 )
                    call Element__readVPS_ciao  ( Param%Data%velem(i), name, fname_vps )
                 case('ciao_ls')
                    call Element__readPAO_ciao  ( Param%Data%velem(i), name, fname_pao, mode, mode2 )
                    call Element__readVPS_ciao_ls( Param%Data%velem(i), name, fname_vps )
                 case('adpack')
                    call Element__readPAO_adpack( Param%Data%velem(i), name, fname_pao, mode, mode2 )
                    call Element__readVPS_adpack( Param%Data%velem(i), name, fname_vps )
                 end select

                 Param%Data%velem(i)%mass = mass * ATOM_MASS_TO_AU
              end do
              read(iunit, '(a)') buf

           case('}element_list')
              open(unit=16,file=Param%Option%file_ac_tempout,position='append')
              write(16,'(a)') '??? broken ??? //accuracy/element_list{}// => stop'
              close(16)
              go to 1111

           case('opt_switch','calc_force')
              read(buf,*) tag, str
              select case(str)
              case('opt','Opt','OPT')
                 Param%Option%optimize = .true.
                 is_opt=0
              case('on','On','ON')
                 Param%Option%optimize = .true.
                 is_opt=1
              case('off','Off','OFF')
                 Param%Option%optimize = .false.
              case default
                 open(unit=16,file=Param%Option%file_ac_tempout,position='append')
                 write(16,'(a)') '??? broken ??? //accuracy/opt_switch{}// => stop'
                 close(16)
                 go to 1111
              end select

           case('opt_method')
              read(buf,*) tag, str
              select case(str)
              case('cg','CG','Cg','conjgate gradient')
                 Param%Option%optimize_method = "cg"
              case('sd','SDf','Sd','steepest descent')
                 Param%Option%optimize_method = "sd"
              case('diis','DIIS','gdiis','GDIIS','gDIIS','pulay','Pulay')
                 Param%Option%optimize_method = "diis"
              case default
                 open(unit=16,file=Param%Option%file_ac_tempout,position='append')
                 write(16,'(a)') '??? broken ??? //accuracy/opt_method// => stop'
                 close(16)
                 go to 1111
              end select

           case('force_convergence','opt_force_convergence')
              read(buf,*,end=1051) tag, Param%SCF%force_criterion, str
              Param%SCF%force_criterion = Param%SCF%force_criterion * TO_AU(str)
              goto 1052
1051          continue
              Param%SCF%force_criterion = Param%SCF%force_criterion
1052          continue

           case('opt_num_max_iteration')
              read(buf,*) tag, Param%SCF%opt_iter_max

           case('projection')
              read(buf,*) tag, str
              select case(str)
              case('on','On','ON')
                 Param%Option%projection = .true.

              case('off','Off','OFF')
                 Param%Option%projection = .false.
              case default
                 open(unit=16,file=Param%Option%file_ac_tempout,position='append')
                 write(16,'(a)') '??? broken ??? //accuracy/projection// => stop'
                 close(16)
                 go to 1111
              end select

           case('}accuracy')
              exit

           case default
              open(unit=16,file=Param%Option%file_ac_tempout,position='append')
              write(16,'(a,a,a)') '??? broken ??? //accuracy{} has an unknown tag ', trim(tag), '// => stop'
              close(16)
              go to 1111

           end select

        end do

     case('structure{')
        do 
           read(iunit, '(a)', end=100) buf
           if( uncomment(buf) ) cycle
           read(buf,*) tag

           select case(tag)

           case('spin_polarization')
              read(buf,*) tag, str
              select case(str)
              case('on','On','ON')
                 Param%Option%spin_polar = .true.
                 if( .not. Param%Option%spin_orbit ) then
                    Param%Option%nspin = 2
                 end if
              case('off','Off','OFF')
                 if( .not. Param%Option%spin_orbit ) then
                    Param%Option%spin_polar = .false.
                    Param%Option%nspin = 1
                 else
                    open(unit=16,file=Param%Option%file_ac_tempout,position='append')
                    write(16,'(a)') '??? SO ??? //structure/spin_polarization// -> ON'
                    close(16)
                 end if
              case default
                 open(unit=16,file=Param%Option%file_ac_tempout,position='append')
                 write(16,'(a)') '??? broken ??? //structure/spin_polarization// => stop'
                 close(16)
                 go to 1111
              end select

           case('spin_orbit_coupling')
              read(buf,*) tag, str
              select case(str)
              case('on','On','ON')
                 if( Param%Option%nspin == 1 ) then
                    open(unit=16,file=Param%Option%file_ac_tempout,position='append')
                    write(16,'(a)') '??? SP ??? //structure/spin_polarization// -> ON'
                    close(16)
                 end if
                 Param%Option%spin_orbit = .true.
                 Param%Option%spin_polar = .true.
                 Param%Option%nspin  = 4
              case('off','Off','OFF')
                 Param%Option%spin_orbit = .false.
              case default
                 open(unit=16,file=Param%Option%file_ac_tempout,position='append')
                 write(16,'(a)') '??? broken ??? //structure/spin_orbit_coupling// => stop'
                 close(16)
                 go to 1111
              end select

           case('sw_cluster')
              read(buf,*) tag, str
              select case(str)
              case('on','On','ON')
                 Param%Option%cluster = .true.
              case('off','Off','OFF')
                 Param%Option%cluster = .false.
              case default
                 open(unit=16,file=Param%Option%file_ac_tempout,position='append')
                 write(16,'(a)') '??? broken ??? //structure/sw_cluster// => stop'
                 close(16)
                 go to 1111
              end select

           case('unit_cell{')
              do
                 read(iunit, '(a)', end=100) buf
                 if( uncomment(buf) ) cycle
                 read(buf,*) tag

                 select case(tag)
                 case('unit')
                    read(buf,*) tag, str
                    CEL_TO_AU = TO_AU(str)

                 case('vector{')
                    read(iunit,'(a)') buf
                    read(buf,*) Param%Cell%La(:)

                    read(iunit,'(a)') buf
                    read(buf,*) Param%Cell%Lb(:)

                    read(iunit,'(a)') buf
                    read(buf,*) Param%Cell%Lc(:)

                    Param%Cell%La = Param%Cell%La * CEL_TO_AU
                    Param%Cell%Lb = Param%Cell%Lb * CEL_TO_AU
                    Param%Cell%Lc = Param%Cell%Lc * CEL_TO_AU
                    read(iunit,'(a)') buf

                 case('}vector')
                    open(unit=16,file=Param%Option%file_ac_tempout,position='append')
                    write(16,'(a)') '??? broken ??? //structure/cell/vector{}// => stop'
                    close(16)
                    go to 1111

                 case('}unit_cell')
                    exit

                 case default
                    open(unit=16,file=Param%Option%file_ac_tempout,position='append')
                    write(16,'(a,a,a)') '??? broken ??? //structure/cell{} has an unknown tag ', trim(tag), '// => stop'
                    close(16)
                    go to 1111

                 end select
              end do

           case('}unit_cell')
              open(unit=16,file=Param%Option%file_ac_tempout,position='append')
              write(16,'(a)') '??? broken ??? //structure/cell{}// => stop'
              close(16)
              go to 1111

           case('atom_list{')
              Param%Data%Ne_extra = 0.0d0

              do
                 read(iunit, '(a)', end=100) buf
                 if( uncomment(buf) ) cycle
                 read(buf,*) tag

                 select case(tag)
                 case('num_atom')
                    read(buf,*) tag, Param%Data%natom
                 case('num_left_atom')
                    read(buf,*) tag, Param%Data%natom_left
                 case('num_right_atom')
                    read(buf,*) tag, Param%Data%natom_right
                 case('unit')
                    read(buf,*) tag, str
                    MOL_TO_AU = TO_AU(str)

                 case('coordinate_system')
                    read(buf,*) tag, str
                    select case(str)
                    case('internal')
                       internal_coordinate = .true.
                    case('cartesian')
                       internal_coordinate = .false.
                    case default
                       open(unit=16,file=Param%Option%file_ac_tempout,position='append')
                       write(16,'(a)') '??? broken ??? //structure/atom_list/coordinate_system// => stop'
                       close(16)
                       go to 1111
                    end select

                 case('extra_charge')
                    read(buf,*) tag, Param%Data%Ne_extra

                 case('atoms{')
                    if( Param%Data%natom <= 0 ) then
                       open(unit=16,file=Param%Option%file_ac_tempout,position='append')
                       write(16,'(a)') '??? broken ??? //structure/atom_list/num_atom// => stop'
                       close(16)
                       go to 1111
                    end if

                    allocate( Param%Data%vatom(Param%Data%natom))
                    do i=1, Param%Data%natom
                       read(iunit,'(a)') buf
                       read(buf,*,end=1081) dummy, name, R(:), Qu, Qd, str
                       if( dummy == dummy ) then
                       endif
                       goto 1082
1081                   continue
                       read(buf,*) dummy, name, R(:), Qu, Qd
                       str = "free"
1082                   continue
                       select case(str)
                       case("free","optimize")
                          optimize = .true.
                       case("fix", "fixed")
                          optimize = .false.
                       case default
                          optimize = .true.
                       end select

                       if( internal_coordinate ) then
                          R = Param%Cell%La * R(1) + Param%Cell%Lb * R(2) + Param%Cell%Lc * R(3) + Param%Cell%Lo
                       else if( MOL_TO_AU /= 1.d0 ) then
                          R = R*MOL_TO_AU
                       end if

                       elem => Param__Data__getElement( name )

                       call Atom__set( Param%Data%vatom(i), name, R, &
                            elem%vpao(1)%Rc, -elem%Vloc%Q, elem%atomic_number, (Qu-Qd)/(Qu+Qd), optimize )
                    end do
                    read(iunit,'(a)') buf

                 case('}atoms')
                    open(unit=16,file=Param%Option%file_ac_tempout,position='append')
                    write(16,'(a)') '??? broken ??? //structure/atom_list/atoms{}// => stop'
                    close(16)
                    go to 1111

                 case('}atom_list')
                    exit

                 case default
                    open(unit=16,file=Param%Option%file_ac_tempout,position='append')
                    write(16,'(a,a,a)') '??? broken ??? //structure/atom_list{} has an unknown tag ', trim(tag), '// => stop'
                    close(16)
                    go to 1111


                 end select
              end do

           case('}atom_list')
              open(unit=16,file=Param%Option%file_ac_tempout,position='append')
              write(16,'(a)') '??? broken ??? //structure/atom_list{}// => stop'
              close(16)
              goto 1111

           case('}structure')
              exit

           case default
              open(unit=16,file=Param%Option%file_ac_tempout,position='append')
              write(16,'(a,a,a)') '??? broken ??? //structure{} has an unknown tag ', trim(tag), '// => stop'
              close(16)

              go to 1111

           end select
        end do


     case('charge_mixing{')
        do
           read(iunit, '(a)', end=100) buf
           if( uncomment(buf) ) cycle
           read(buf,*) tag

           select case(tag)

           case('mixing_methods','method','methods')
              read(buf,*) tag, str
              select case(str)
              case('simple','Simple')
                 Param%SCF%mix_type    = 'Simple'
                 Param%SCF%mix_start   = 0
                 Param%SCF%mix_history = 1
              case('pulay','Pulay','rmm-diis','Rmm-Diis','RMM-DIIS')
                 Param%SCF%mix_type = 'Pulay'
              case('Anderson','anderson')
                 Param%SCF%mix_type = 'Anderson'
                 Param%SCF%mix_start   = 0
                 Param%SCF%mix_history = 3
              case default
                 open(unit=16,file=Param%Option%file_ac_tempout,position='append')
                 write(16,'(a)') '??? broken ??? //charge_mixing/mixing_methods// => stop'
                 close(16)
                 go to 1111
              end select

           case('target')
              read(buf,*) tag, str
              select case(str)
              case('density','Density')
                 Param%SCF%mix_target = 'density'
              case('density_matrix','Density_Matrix','matrix','Matrix','DM')
                 Param%SCF%mix_target = 'density_matrix'
              case default
                 open(unit=16,file=Param%Option%file_ac_tempout,position='append')
                 write(16,'(a)') '??? broken ??? //charge_mixing/mixing_target// => stop'
                 close(16)
                 go to 1111
              end select


           case('mixing_weight','weight')
              read(buf,*) tag, Param%SCF%mix_weight

           case('mixing_weight_simple','weight_simple')
              read(buf,*) tag, Param%SCF%mix_weight_s

           case('pulay_start','rmmdiis_start','mix_start','mixing_start','start')
              read(buf,*) tag, Param%SCF%mix_start

           case('pulay_history','rmmdiis_history','mix_history','mixing_history','history')
              read(buf,*) tag, Param%SCF%mix_history

           case('}charge_mixing')
              exit

           case default
              open(unit=16,file=Param%Option%file_ac_tempout,position='append')
              write(16,'(a,a,a)') '??? broken ??? //charge_mixing{} has an unknown tag ', trim(tag), '// => stop'
              close(16)
              go to 1111

           end select
        end do

     case('}charge_mixing')
        open(unit=16,file=Param%Option%file_ac_tempout,position='append')
        write(16,'(a)') '??? broken ??? //charge_mixing{}// => stop'
        close(16)
        goto 1111

     case('file_in{')
        do
           read(iunit, '(a)', end=100) buf
           if( uncomment(buf) ) cycle
           read(buf,*) tag

           select case(tag)
           case('density_scf')
              read(buf,*) tag, Param%Option%fname_rhoscf_in

           case('matrices')
              read(buf,*) tag, Param%Option%fname_matrices_in

           case('}file_in')
              exit

           case default
              open(unit=16,file=Param%Option%file_ac_tempout,position='append')
              write(16,'(a,a,a)') '??? broken ??? //file_in{} has an unknown tag ', trim(tag), '// => stop'
              close(16)
              go to 1111
           end select
        end do

     case('}file_in')
        open(unit=16,file=Param%Option%file_ac_tempout,position='append')
        write(16,'(a)') '??? broken ??? //file_in{}// => stop'
        close(16)
        goto 1111



     case('file_out{')
        if( Param%name == "" ) then
           open(unit=16,file=Param%Option%file_ac_tempout,position='append')
           write(16,'(a)') '??? not given ??? //general/system_name// => stop'
           close(16)
           go to 1111
        end if

        do
           read(iunit, '(a)', end=100) buf
           if( uncomment(buf) ) cycle
           read(buf,*) tag

           select case(tag)
           case('save_at')
              read(buf,*) tag, str
              select case(str)
              case("never")
                 Param%Option%saveat = "never"
              case("everystep")
                 Param%Option%saveat = "everstep"
              case("finalstep")
                 Param%Option%saveat = "finalstep"
              case default
                 open(unit=16,file=Param%Option%file_ac_tempout,position='append')
                 write(16,'(a)') '??? broken ??? //file_out/save_at// => stop'
                 close(16)
                 go to 1111
              end select

           case('field_format')
              read(buf,*) tag, str
              select case(str)
              case('cube')
                 Param%Option%field_format = ".cube"
              case('dx')
                 Param%Option%field_format = ".dx"
              case default
                 open(unit=16,file=Param%Option%file_ac_tempout,position='append')
                 write(16,'(a)') '??? broken ??? //file_out/field_format// => stop'
                 close(16)
                 go to 1111
              end select

           case('density_scf')
              read(buf,*) tag, str
              select case(str)
              case('on','On','ON')
                 Param%Option%fname_rhoscf   = trim(Param%name) // ".density.scf" // trim(Param%Option%field_format)
              case('off','Off','OFF')
                 Param%Option%fname_rhoscf   = ""
              case default
                 open(unit=16,file=Param%Option%file_ac_tempout,position='append')
                 write(16,'(a)') '??? broken ??? //file_out/density_scf// => stop'
                 close(16)
                 go to 1111
              end select

           case('density_val')
              read(buf,*) tag, str
              select case(str)
              case('on','On','ON')
                 Param%Option%fname_rhoval  = trim(Param%name) // ".density.val" // trim(Param%Option%field_format)
              case('off','Off','OFF')
                 Param%Option%fname_rhoval  = ""
              case default
                 open(unit=16,file=Param%Option%file_ac_tempout,position='append')
                 write(16,'(a)') '??? broken ??? //file_out/density_val// => stop'
                 close(16)
                 go to 1111
              end select

           case('density_pcc')
              read(buf,*) tag, str
              select case(str)
              case('on','On','ON')
                 Param%Option%fname_rhopcc  = trim(Param%name) // ".density.pcc" // trim(Param%Option%field_format)
              case('off','Off','OFF')
                 Param%Option%fname_rhopcc  = ""
              case default
                 open(unit=16,file=Param%Option%file_ac_tempout,position='append')
                 write(16,'(a)') '??? broken ??? //file_out/density_pcc// => stop'
                 close(16)
                 go to 1111
              end select

           case('potential_ext')
              read(buf,*) tag, str
              select case(str)
              case('on','On','ON')
                 Param%Option%fname_vext   = trim(Param%name) // ".potential.ext" // trim(Param%Option%field_format)
              case('off','Off','OFF')
                 Param%Option%fname_vext   = ""
              case default
                 open(unit=16,file=Param%Option%file_ac_tempout,position='append')
                 write(16,'(a)') '??? broken ??? //file_out/potential_ext// => stop'
                 close(16)
                 go to 1111
              end select

           case('potential_har')
              read(buf,*) tag, str
              select case(str)
              case('on','On','ON')
                 Param%Option%fname_vhar  = trim(Param%name) // ".potential.har" // trim(Param%Option%field_format)
              case('off','Off','OFF')
                 Param%Option%fname_vhar  = ""
              case default
                 open(unit=16,file=Param%Option%file_ac_tempout,position='append')
                 write(16,'(a)') '??? broken ??? //file_out/potential_har// => stop'
                 close(16)
                 go to 1111
              end select

           case('potential_exc')
              read(buf,*) tag, str
              select case(str)
              case('on','On','ON')
                 Param%Option%fname_vexc   = trim(Param%name) // ".potential.exc" // trim(Param%Option%field_format)
              case('off','Off','OFF')
                 Param%Option%fname_vexc   = ""
              case default
                 open(unit=16,file=Param%Option%file_ac_tempout,position='append')
                 write(16,'(a)') '??? broken ??? //file_out/potential_exc// => stop'
                 close(16)
                 go to 1111

              end select

           case('potential_tot')
              read(buf,*) tag, str
              select case(str)
              case('on','On','ON')
                 Param%Option%fname_vtot   = trim(Param%name) // ".potential.tot" // trim(Param%Option%field_format)
              case('off','Off','OFF')
                 Param%Option%fname_vtot   = ""
              case default
                 open(unit=16,file=Param%Option%file_ac_tempout,position='append')
                 write(16,'(a)') '??? broken ??? //file_out/potential_tot// => stop'
                 close(16)
                 go to 1111
              end select

           case('matrices')
              read(buf,*) tag, str
              select case(str)
              case('on','On','ON')
                 Param%Option%fname_matrices = trim(Param%name) // ".matrices.dat"
              case('off','Off','OFF')
                 Param%Option%fname_matrices = ""
              case default
                 open(unit=16,file=Param%Option%file_ac_tempout,position='append')
                 write(16,'(a)') '??? broken ??? //file_out/matrices// => stop'
                 close(16)
                 go to 1111

              end select

           case('f_negf')
              read(buf,*) tag, str
              select case(str)
              case('on','On','ON')
                 Param%Option%ascot_negf = .true.
                 Param%Option%fname_accel_c  = ""
                 Param%Option%fname_accel_r  = ""
                 Param%Option%fname_accel_l  = ""
                 Param%Option%fname_ascot_vd = trim(Param%name) // ".vd.data"
                 Param%Option%fname_ascot_in = trim(Param%name) // ".in.data"
              case('off','Off','OFF')
                 Param%Option%fname_accel_c  = ""
                 Param%Option%fname_accel_r  = ""
                 Param%Option%fname_accel_l  = ""
                 Param%Option%fname_ascot_vd = ""
                 Param%Option%fname_ascot_in = ""
              case default
                 open(unit=16,file=Param%Option%file_ac_tempout,position='append')
                 write(16,'(a)') '??? broken ??? //file_out/f_negf// => stop'
                 close(16)
                 go to 1111
              end select

           case('gamma_matrix')
              read(buf,*) tag, str
              select case(str)
              case('on','On','ON')
                 Param%Option%fname_accel_c  = trim(Param%name) // ".ascot_c.dat"
                 Param%Option%fname_accel_r  = ""
                 Param%Option%fname_accel_l  = ""
              case('off','Off','OFF')
                 Param%Option%fname_accel_c  = ""
                 Param%Option%fname_accel_r  = ""
                 Param%Option%fname_accel_l  = ""
              case default
                 open(unit=16,file=Param%Option%file_ac_tempout,position='append')
                 write(16,'(a)') '??? broken ??? //file_out/gamma_matrix// => stop'
                 close(16)
                 go to 1111
              end select

           case('}file_out')
              exit

           case default
              open(unit=16,file=Param%Option%file_ac_tempout,position='append')
              write(16,'(a,a,a)') '??? broken ??? //file_out{} has an unknown tag ', trim(tag), '// => stop'
              close(16)
              go to 1111


           end select
        end do

     case('}file_out')
        open(unit=16,file=Param%Option%file_ac_tempout,position='append')
        write(16,'(a)') '??? broken ??? //file_out{}// => stop'
        close(16)
        goto 1111


     case('atom_int{')
        do
           read(iunit, '(a)', end=100) buf
           if( uncomment(buf) ) cycle
           read(buf,*) tag

           select case(tag)
           case('num_k')
              read(buf,*) tag, Param%Integral1D%Nk

           case('num_r')
              read(buf,*) tag, Param%Integral1D%Nr

           case('energy_cutoff')
              read(buf,*,end=1031) tag, Param%Integral1D%Ecutoff, str
              Param%Integral1D%Ecutoff = Param%Integral1D%Ecutoff * TO_AU(str)
              goto 1032
1031          continue
              Param%Integral1D%Ecutoff = Param%Integral1D%Ecutoff * RY_TO_AU
1032          continue

           case('}atom_int')
              exit

           case default
              open(unit=16,file=Param%Option%file_ac_tempout,position='append')
              write(16,'(a,a,a)') '??? broken ??? //atom_int{} has an unknown tag ', trim(tag), '// => stop'
              close(16)
              go to 1111


           end select
        end do

     case('}atom_int')
        open(unit=16,file=Param%Option%file_ac_tempout,position='append')
        write(16,'(a)') '??? broken ??? //atom_int{}// => stop'
        close(16)
        goto 1111


     case('mpi_condition{')
        do
           read(iunit, '(a)', end=100) buf
           if( uncomment(buf) ) cycle
           read(buf,*) tag

           select case(tag)
           case('num_sc_work2space')
              read(buf,*) tag, MPI%num_sc_work2space
              if( MPI%num_sc_work2space < -1.d0 ) then
                 open(unit=16,file=Param%Option%file_ac_tempout,position='append')
                 write(16,'(a,a,a)') '??? change ??? //mpi_condition/num_sc_work2space// => -1'
                 close(16)
                 MPI%num_sc_work2space=-1.d0
              end if

           case('num_check_sc')
              read(buf,*) tag, MPI%num_check_sc

           case('}mpi_condition')
              exit

           case default
              open(unit=16,file=Param%Option%file_ac_tempout,position='append')
              write(16,'(a,a,a)') '??? broken ??? //mpi_condition{} has an unknown tag ', trim(tag), '// => stop'
              close(16)
              go to 1111

           end select
        end do

     case('}mpi_condition')
        open(unit=16,file=Param%Option%file_ac_tempout,position='append')
        write(16,'(a)') '??? broken ??? //mpi_condition{}// => stop'
        close(16)
        goto 1111

     case('postprocessing{','Postprocessing{')
        if( Param%name == "" ) then
           open(unit=16,file=Param%Option%file_ac_tempout,position='append')
           write(16,'(a)') '??? broken ??? //general/system_name// => stop'
           close(16)
           go to 1111
        end if

        do
           read(iunit, '(a)', end=100) buf
           if( uncomment(buf) ) cycle
           read(buf,*) tag

           select case(tag)
           case('band{')
              do
                 read(iunit, '(a)', end=100) buf
                 if( uncomment(buf) ) cycle
                 read(buf,*) tag

                 select case(tag)
                 case('sw_band')
                    read(buf,*) tag, str
                    select case(str)
                    case('on','On','ON')
                       Param%Band%fname = trim(Param%name) // ".band.dat"
                    case('off','Off','OFF')
                       Param%Band%fname = ""
                    case default
                       open(unit=16,file=Param%Option%file_ac_tempout,position='append')
                       write(16,'(a)') '??? broken ??? //post/band/sw_band// => stop'
                       close(16)
                       go to 1111
                    end select

                 case('num_show_band')
                    read(buf,*) tag, Param%Band%num_band

                 case('unit_cell{')
                    do
                       read(iunit, '(a)', end=100) buf
                       if( uncomment(buf) ) cycle
                       read(buf,*) tag

                       select case(tag)
                       case('unit')
                          read(buf,*) tag, str
                          CEL_TO_AU = TO_AU(str)

                       case('vector{')
                          read(iunit,'(a)') buf
                          read(buf,*) Param%Band%La(:)

                          read(iunit,'(a)') buf
                          read(buf,*) Param%Band%Lb(:)

                          read(iunit,'(a)') buf
                          read(buf,*) Param%Band%Lc(:)

                          Param%Band%La = Param%Band%La * CEL_TO_AU
                          Param%Band%Lb = Param%Band%Lb * CEL_TO_AU
                          Param%Band%Lc = Param%Band%Lc * CEL_TO_AU

                          read(iunit,'(a)') buf

                       case('}vector')
                          open(unit=16,file=Param%Option%file_ac_tempout,position='append')
                          write(16,'(a)') '??? broken ??? //post/band/cell/vector{}// => stop'
                          close(16)
                          goto 1111

                       case('}unit_cell')
                          exit

                       case default
                          open(unit=16,file=Param%Option%file_ac_tempout,position='append')
                          write(16,'(a,a,a)') '??? broken ??? //post/band/cell{} has an unknown tag ', trim(tag), '// => stop'
                          close(16)
                          go to 1111

                       end select
                    end do

                 case('}unit_cell')
                    open(unit=16,file=Param%Option%file_ac_tempout,position='append')
                    write(16,'(a)') '??? broken ??? //post/band/cell{}// => stop'
                    close(16)
                    goto 1111

                 case('num_band_path')
                    read(buf,*) tag, Param%Band%nKpath
                    if( Param%Band%nKpath == 0 ) then
                       Param%Band%fname = ""
                    end if

                 case('band_path{')
                    if( Param%Band%nKpath<=0 ) then
                       open(unit=16,file=Param%Option%file_ac_tempout,position='append')
                       write(16,'(a)') '??? broken ??? //post/band/num_band_path// => stop'
                       close(16)
                       goto 1111
                    end if

                    allocate( Param%Band%vKpath(Param%Band%nKpath) )
                    do i=1, Param%Band%nKpath
                       read(iunit,'(a)') buf
                       read(buf,*) ks(:), ke(:), mesh

                       Param%Band%vKpath(i)%ks = ks
                       Param%Band%vKpath(i)%ke = ke
                       Param%Band%vKpath(i)%mesh = mesh
                    end do
                    read(iunit,'(a)') buf

                 case('}band')
                    exit

                 case default
                    open(unit=16,file=Param%Option%file_ac_tempout,position='append')
                    write(16,'(a,a,a)') '??? broken ??? //post/band{} has an unknown tag ', trim(tag), '// => stop'
                    close(16)
                    goto 1111

                 end select
              end do

           case('}band')
              open(unit=16,file=Param%Option%file_ac_tempout,position='append')
              write(16,'(a)') '??? broken ??? //post/band{}// => stop'
              close(16)
              goto 1111


           case('dos{')
              do
                 read(iunit, '(a)', end=100) buf
                 if( uncomment(buf) ) cycle
                 read(buf,*) tag

                 select case(tag)
                 case('sw_dos')
                    read(buf,*) tag, str
                    select case(str)
                    case('on','On','ON')
                       Param%DOS%fname = trim(Param%name) // ".dos.dat"
                    case('off','Off','OFF')
                       Param%DOS%fname = ""
                    case default
                       open(unit=16,file=Param%Option%file_ac_tempout,position='append')
                       write(16,'(a)') '??? broken ??? //post/dos/sw_dos// => stop'
                       close(16)
                       go to 1111
                    end select

                 case('method')
                    read(buf,*) tag, str
                    select case(str)
                    case('boxes','histogram')
                       Param%DOS%method = 'histogram'
                    case('gaussian')
                       Param%DOS%method = 'gaussian'
                    case('tetrahedron')
                       Param%DOS%method = 'tetrahedron'
                    case default 
                       open(unit=16,file=Param%Option%file_ac_tempout,position='append')
                       write(16,'(a)') '??? broken ??? //post/dos/method// => stop'
                       close(16)
                       go to 1111
                    end select

                 case('gaussian_broadening')
                    read(buf,*,end=1043) tag, Param%DOS%GB, str
                    Param%DOS%GB = Param%DOS%GB * TO_AU(str)
                    goto 1044
1043                continue
                    Param%DOS%GB = Param%DOS%GB * EV_TO_AU
1044                continue

                 case('e_range{')
                    do
                       read(iunit, '(a)', end=100) buf
                       if( uncomment(buf) ) cycle
                       read(buf,*) tag
                       if( tag == "}e_range" ) exit

                       read(buf,*,end=1041) Param%DOS%Ne, Param%DOS%Emin, Param%DOS%Emax, str
                       Param%DOS%Emin = Param%DOS%Emin * TO_AU(str)
                       Param%DOS%Emax = Param%DOS%Emax * TO_AU(str)
                       goto 1042
1041                   continue
                       Param%DOS%Emin = Param%DOS%Emin * EV_TO_AU
                       Param%DOS%Emax = Param%DOS%Emax * EV_TO_AU
1042                   continue
                    end do

                 case('ksampling{')
                    do
                       read(iunit, '(a)', end=100) buf
                       if( uncomment(buf) ) cycle
                       read(buf,*) tag
                       if( tag == "}ksampling" ) exit
                       read(buf,*) Param%DOS%Nka, Param%DOS%Nkb, Param%DOS%Nkc
                    end do

                 case('}dos')
                    exit

                 case default
                    open(unit=16,file=Param%Option%file_ac_tempout,position='append')
                    write(16,'(a,a,a)') '??? broken ??? //post/dos{} has an unknown tag ', trim(tag), '// => stop'
                    close(16)
                    go to 1111

                 end select
              end do

           case('}dos')
              open(unit=16,file=Param%Option%file_ac_tempout,position='append')
              write(16,'(a)') '??? broken ??? //post/dos{}// => stop'
              close(16)
              goto 1111



           case('mo{')
              do
                 read(iunit, '(a)', end=100) buf
                 if( uncomment(buf) ) cycle
                 read(buf,*) tag

                 select case(tag)
                 case('sw_mo')
                    read(buf,*) tag, str
                    select case(str)
                    case('on','On','ON')
                       Param%MO%fbase = trim(Param%name) // ".mo"
                    case('off','Off','OFF')
                       Param%MO%fbase = ""
                    case default
                       open(unit=16,file=Param%Option%file_ac_tempout,position='append')
                       write(16,'(a)') '??? broken ??? //post/mo/sw_mo// => stop'
                       close(16)
                       go to 1111
                    end select

                 case('m_bandnum')
                    read(buf,*) tag, str
                    select case(str)
                    case('band_num','bandnum')
                       Param%MO%method = 'band_num'
                    case('ho_lumo','homolumo')
                       Param%MO%method = 'ho_lumo'
                    case default 
                       open(unit=16,file=Param%Option%file_ac_tempout,position='append')
                       write(16,'(a)') '??? broken ??? //post/mo/method// => stop'
                       close(16) 
                       go to 1111
                    end select

                 case('band_range{')
                    do
                       read(iunit, '(a)', end=100) buf
                       if( uncomment(buf) ) cycle
                       read(buf,*) tag
                       if( tag == "}band_range" ) exit
                       read(buf,*) Param%MO%band_min, Param%MO%band_max
                    end do


                 case('unit_cell{')
                    do
                       read(iunit, '(a)', end=100) buf
                       if( uncomment(buf) ) cycle
                       read(buf,*) tag

                       select case(tag)
                       case('unit')
                          read(buf,*) tag, str
                          CEL_TO_AU = TO_AU(str)

                       case('vector{')
                          read(iunit,'(a)') buf
                          read(buf,*) Param%MO%La(:)

                          read(iunit,'(a)') buf
                          read(buf,*) Param%MO%Lb(:)

                          read(iunit,'(a)') buf
                          read(buf,*) Param%MO%Lc(:)

                          Param%MO%La = Param%MO%La * CEL_TO_AU
                          Param%MO%Lb = Param%MO%Lb * CEL_TO_AU
                          Param%MO%Lc = Param%MO%Lc * CEL_TO_AU

                          read(iunit,'(a)') buf

                       case('}vector')
                          open(unit=16,file=Param%Option%file_ac_tempout,position='append')
                          write(16,'(a)') '??? broken ??? //post/mo/cell/vector{}// => stop'
                          close(16)
                          goto 1111

                       case('}unit_cell')
                          exit

                       case default
                          open(unit=16,file=Param%Option%file_ac_tempout,position='append')
                          write(16,'(a,a,a)') '??? broken ??? //post/mo/cell{} has an unknown tag ', trim(tag), '// => stop'
                          close(16) 
                          go to 1111


                       end select
                    end do

                 case('}unit_cell')
                    open(unit=16,file=Param%Option%file_ac_tempout,position='append')
                    write(16,'(a)') '??? broken ??? //post/mo/cell{}// => stop'
                    close(16) 
                    goto 1111

                 case('num_k_points')
                    read(buf,*) tag, Param%MO%nK
                    allocate( Param%MO%vK(3,Param%MO%nK) )

                 case('k_points{')
                    if( .not. associated(Param%MO%vK) ) then
                       open(unit=16,file=Param%Option%file_ac_tempout,position='append')
                       write(16,'(a)') '??? broken ??? //post/mo/num_k_points// => stop'
                       close(16) 
                       go to 1111
                    end if

                    do i=1, Param%MO%nK
                       read(iunit,'(a)') buf
                       read(buf,*) Param%MO%vK(:,i)
                    end do
                    read(iunit,'(a)') buf

                 case('}mo')
                    exit

                 case default
                    open(unit=16,file=Param%Option%file_ac_tempout,position='append')
                    write(16,'(a,a,a)') '??? broken ??? //post/mo{} has an unknown tag ', trim(tag), '// => stop'
                    close(16) 
                    go to 1111

                 end select
              end do

           case('}mo')
              open(unit=16,file=Param%Option%file_ac_tempout,position='append')
              write(16,'(a)') '??? broken ??? //post/mo{}// => stop'
              close(16) 
              goto 1111


           case('}postprocessing','}Postprocessing')
              exit

           case default
              open(unit=16,file=Param%Option%file_ac_tempout,position='append')
              write(16,'(a,a,a)') '??? broken ??? //post{} has an unknown tag ', trim(tag), '// => stop'
              close(16) 
              go to 1111

           end select
        end do

        ! phonon
     case('phonon{','Phonon{')
        Param%Option%phonon = .true.
        do
           read(iunit, '(a)', end=100) buf
           if( uncomment(buf) ) cycle
           read(buf,*) tag

           select case(tag)
           case('displacement')
              read(buf,*) tag, Param%phonon%displacement

           case('output_force_constant_matrix')
              read(buf,*) tag, str
              select case(str)
              case('on','On','ON')
                 Param%phonon%output_force_constant_matrix = .true.
              case('off','Off','OFF')
                 Param%phonon%output_force_constant_matrix = .false.
              end select

           case('output_dynamical_matrix')
              read(buf,*) tag, str
              select case(str)
              case('on','On','ON')
                 Param%phonon%output_dynamical_matrix = .true.
              case('off','Off','OFF')
                 Param%phonon%output_dynamical_matrix = .false.
              end select

           case('}phonon')
              exit

           case default
              open(unit=16,file=Param%Option%file_ac_tempout,position='append')
              write(16,'(a,a,a)') '??? broken ??? //phonon{} has an unknown tag ', trim(tag), '// => stop'
              close(16)
              go to 1111

           end select
        end do

     end select
  end do

100 continue

  close(iunit)

  if( is_opt == 0 ) then
     if( Param%SCF%opt_iter_max == 0 ) then
        open(unit=16,file=Param%Option%file_ac_tempout,position='append')
        write(16,'(a)') '??? to ??? //accuracy/calc_force{}// :: opt -> ON'
        close(16)
     end if
  else
     Param%SCF%opt_iter_max=0
  end if
  if( Param%SCF%mix_weight_s < 0.d0 ) then
     Param%SCF%mix_weight_s=Param%SCF%mix_weight
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,'(a)') '??? to ??? //charge_mixing/mixing_weight_simple{}// :: -> mixing_weight'
     close(16)
  end if
  if( Param%Option%nspin == 0 ) then
     Param%Option%nspin = 1
  end if
  if( Param%Option%nspin == 2 .and. Param%Band%fname /="" ) then
     Param%Band%fname = trim(Param%name) // ".band_u.dat"
     Param%Band%fname1 = trim(Param%name) // ".band_d.dat"
  end if

  return

1111 continue

  close(iunit)
  stop

end subroutine Param__read

subroutine Param__setup(move)
  use ac_misc_module
  implicit none
  integer, intent(in) :: move

  call Param__Cell__setup(move)
  call Param__SCF__setup
  call Param__Band__setup
  call Param__DOS__setup
  call Param__MO__setup
  call Param__Data__setup

  return
end subroutine Param__setup

subroutine Param__show
  use ac_misc_module
  implicit none

  open(unit=16,file=Param%Option%file_ac_tempout,position='append')
  write(16,*)
  write(16,*)
  write(16,*) '********************** **************** **********************'
  write(16,*) '*                 input  condition  !  dft  !                *'
  write(16,*) '********************** **************** **********************'
  write(16,*)

  call Param__SCF__show
  call Param__Band__show
  call Param__DOS__show
  call Param__MO__show
  call Param__Option__show
  call Param__Data__show

  write(16,*) '++++++++++++  end : read file'
  write(16,*) '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'
  write(16,*)
  close(16)

  return
end subroutine Param__show

subroutine Param__Cell__R( R, ia, ib, ic )
  use ac_misc_module

  implicit none
  integer, intent(in) :: ia, ib, ic
  real(8), intent(out) :: R(3)

  R =  Param%Cell%Lo + Param%Cell%dLa*dble(ia-1) &
       + Param%Cell%dLb*dble(ib-1) + Param%Cell%dLc*dble(ic-1)

  return
end subroutine Param__Cell__R

subroutine Param__Cell__L(L,na,nb,nc)
  use ac_misc_module

  implicit none
  integer, intent(in) :: na, nb, nc
  real(8), intent(out) :: L(3)

  L = Param%Cell%La*dble(na) + Param%Cell%Lb*dble(nb) &
       + Param%Cell%Lc*dble(nc)

  return
end subroutine Param__Cell__L

subroutine Param__Cell__K(K,ika,ikb,ikc)
  use ac_misc_module

  implicit none
  integer, intent(in) :: ika, ikb, ikc
  real(8), intent(out) :: K(3)

  K = 0.d0

  if( 2*ika-2 < Param%Cell%Na ) then
     K = K + Param%Cell%dKa*dble(ika-1)
  else
     K = K - Param%Cell%dKa*dble(Param%Cell%Na+1-ika)
  end if

  if( 2*ikb-2 < Param%Cell%Nb ) then
     K = K + Param%Cell%dKb*dble(ikb-1)
  else
     K = K - Param%Cell%dKb*dble(Param%Cell%Nb+1-ikb)
  end if

  if( 2*ikc-2 < Param%Cell%Nc ) then
     K = K + Param%Cell%dKc*dble(ikc-1)
  else
     K = K - Param%Cell%dKc*dble(Param%Cell%Nc+1-ikc)
  end if

  return
end subroutine Param__Cell__K

subroutine Param__DOS__binIndex(i,E)
  use ac_misc_module

  implicit none
  real(8), intent(in) :: E
  integer, intent(out) :: i

  i = int((E - Param%DOS%Emin + Param%DOS%dE/2)/Param%DOS%dE) + 1

  return
end subroutine Param__DOS__binIndex

subroutine Param__DOS__binEnergy(E,i)
  use ac_misc_module

  implicit none
  integer, intent(in) :: i
  real(8), intent(out) :: E

  E = Param%DOS%Emin + Param%DOS%dE*(i-1)

  return
end subroutine Param__DOS__binEnergy

subroutine Param__DOS__K(K,ika,ikb,ikc)
  use ac_misc_module

  implicit none
  integer, intent(in) :: ika, ikb, ikc
  real(8), intent(out) :: K(3)

  K = Param%Cell%dKa*( 0.5d0*dble(2*ika-1)/Param%DOS%Nka - 0.5d0 ) &
       + Param%Cell%dKb*( 0.5d0*dble(2*ikb-1)/Param%DOS%Nkb - 0.5d0 ) &
       + Param%Cell%dKc*( 0.5d0*dble(2*ikc-1)/Param%DOS%Nkc - 0.5d0 )

  return
end subroutine Param__DOS__K

subroutine Param__Cell__findAppNumber(n,no_in)
  use ac_misc_module

  implicit none
  integer, intent(out) :: n
  integer, intent(in) :: no_in
  integer :: a,no,dn
  logical :: found

  no=no_in

  if( Param%Option%mx ) then
     dn = 1
  else
     dn = 2
     if( mod(no,2) == 1 ) no = no+1
  end if

  do n=no, 2*no-1, dn
     a=n
     found=.false.

     do 
        if( mod(a,5) == 0 ) then
           a = a/5
           cycle
        end if
        if( mod(a,3) == 0 ) then
           a = a/3
           cycle
        end if
        if( mod(a,2) == 0 ) then
           a = a/2
           cycle
        end if
        if( a==1 ) then
           found=.true.
           exit
        else
           found=.false.
           exit
        end if
     end do

     if( found ) then
        return
     end if
  end do

  n = 0

  return
end subroutine Param__Cell__findAppNumber

subroutine Param__readdata_ASCOT
  use ac_misc_module

  implicit none
  integer       :: i,n,i_c
  character(5)   :: chara_temp
  type(Element_type), pointer :: elem

  open(unit=90,file=Param%Option%fname_ascot_in)

  write(90,900) Param%name
900 format(a15,'    system_name')

  write(90,*)
  write(90,905) Param%Data%element_type,Param%SCF%exc_type,Param%Option%nspin-1
905 format(a15,a15,i5,'    element_type, exc_type, spin')

  write(90,913) Param%SCF%Te, Param%SCF%Ecutoff
913 format(d28.18,d28.18,'    temperature,   energy_cutoff')

  write(90,*)
  write(90,912) Param%SCF%Nka, Param%SCF%Nkb, Param%SCF%Nkc
912 format(i10,i10,i10,'    ksampling')

  write(90,*)
  write(90,911) Param%Integral1D%Nk, Param%Integral1D%Nr, Param%Integral1D%Ecutoff
911 format(i10,i10,d28.18,'    Integral1D')

  if( Param%Option%projection ) then
     chara_temp='on'
  else
     chara_temp='off'
  end if

  write(90,*)
  write(90,*) Param%Data%nelem,'      ',trim(chara_temp),'    num_element'
  do i=1, Param%Data%nelem
     write(90,901) trim(Param%Data%velem_file(i,1))     &
          ,trim(Param%Data%velem_file(i,2))     &
          ,trim(Param%Data%velem_file(i,3))     &
          ,trim(Param%Data%velem_file(i,4))     &
          ,trim(Param%Data%velem_file(i,5))
901  format(a,'  "',a,'"  "',a,'"   "',a,'"   "',a,'"    element_list')
  end do

  write(90,*)
  write(90,904)Param%Cell%La(:)
  write(90,904)Param%Cell%Lb(:)
  write(90,904)Param%Cell%Lc(:)
904 format(d28.18,d28.18,d28.18)

  write(90,*)
  write(90,902) Param%Data%natom, Param%Data%natom_left, Param%Data%natom_right
902 format(i10,i10,i10,'    num_atom:: c, l, r')
  do i=1, Param%Data%natom
     elem => Param__Data__getElement( Param%Data%vatom(i)%name )
     i_c=0
     do n=1, elem%npao
        i_c = i_c + 2*(elem%vpao(n)%l) + 1
     end do
     write(90,903) i, Param%Data%vatom(i)%name, &
          Param%Data%vatom(i)%Ro(:),   &
          Param%Data%vatom(i)%polarization,i_c, Param%Data%vatom(i)%Q
903  format(i5,'   ',a5,d28.18,d28.18,d28.18,d28.18,i10,d28.18)
  end do

  close(90)

  return
end subroutine Param__readdata_ASCOT

subroutine Param__Structure__show
  use ac_misc_module
  use ac_mpi_module

  implicit none
  integer :: a
  integer, allocatable :: vnpao_temp(:)
  type(Element_type), pointer :: elem

  if( MPI%root ) then
     open(unit=60,file='structure.dat')
     write(60,*) '--------------------------------------------------------------'
     write(60,*) '------------   Atoms:'
     write(60,*) '--------------------------------------------------------------'

     write(60,*) ' atom   Q         Ro'
     do a=1, Param%Data%natom
        write(60,933) a,Param%Data%vatom(a)%name,                              &
             Param%Data%vatom(a)%Ro*AU_TO_AA, Param%Data%vatom(a)%Q
     end do

     write(60,*) '--------------------------------------------------------------'
     write(60,*)
     close(60)
  end if

933 format(i4,'  ',a2,3f20.15,f9.4)
932 format(i4,'  ',a2,3f15.10,f9.4)

  return
end subroutine Param__Structure__show

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@             Naoki WATANABE (Mizuho I.R.)                       @@ !
! @@             Nobutaka NISHIKAWA (Mizuho I.R.)                   @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine green_function_scf(descCC,w,w_weight,iw_do,px,py,qx,qy,ispin)

  use scf_negf
  use hamiltonian_sgf
  use hamiltonian_c
  use gf_se_c
  use constant
  use condition_ini
  use ac_mpi_module

  implicit none
  type(MPI_MatDesc), intent(in) :: descCC
  integer, intent(in) :: iw_do,ispin
  integer, intent(in) :: px,py,qx,qy
  complex(8), intent(in) :: w,w_weight

  integer :: i1_do,i2_do,ier
  complex(8), allocatable :: amat_temp6(:,:),bmat_temp6(:,:),cmat_temp6(:,:)

  integer :: i, j

  allocate(amat_temp6(descCC%nrow, descCC%scol:descCC%ecol),stat=ier)
  allocate(bmat_temp6(descCC%nrow, descCC%scol:descCC%ecol),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: green_function_scf 1'
     stop
  end if

  bmat_temp6(:,:) = w*s_cc_scf(:,:) - h_cc_scf(:,:,ispin)

  amat_temp6(:,:) = se_l_mat_per(:,:,px,py) + se_r_mat_per(:,:,qx,qy) 

  bmat_temp6(:,:) = bmat_temp6(:,:) - amat_temp6(:,:)

  call MPI__ZGETRI_ASCOT( descCC, bmat_temp6 )

  allocate(cmat_temp6(descCC%nrow, descCC%scol:descCC%ecol),stat=ier)

  if( i_bios_omega_scf(iw_do) == 1 ) then
     cmat_temp6(:,:) = bmat_temp6(:,:)*w_weight
     amat_temp6(:,:) = cmat_temp6(:,:)

     call MPI__ZTRANC_ASCOT( descCC, C1, cmat_temp6, C1, amat_temp6 ) 

     cdens(:,:,ispin) = cdens(:,:,ispin) + cmat_temp6(:,:)
  else
     if( dreal(w) <= cp_l ) then
        cmat_temp6(:,:) = -se_l_mat_per(:,:,px,py) 
        amat_temp6(:,:) = +se_l_mat_per(:,:,px,py) 

        call MPI__ZTRANC_ASCOT( descCC, C1, cmat_temp6, C1, amat_temp6 ) 
     else
        cmat_temp6(:,:)=dcmplx(0.d0,0.d0)
     end if

     if( dreal(w) <= cp_r ) then
        cmat_temp6(:,:) = -se_r_mat_per(:,:,qx,qy) + cmat_temp6(:,:)  
        amat_temp6(:,:) = +se_r_mat_per(:,:,px,py) 

        call MPI__ZTRANC_ASCOT( descCC, C1, cmat_temp6, C1, amat_temp6 ) 
     end if

     call MPI__ZGEMM_ASCOT( 'N', 'N', descCC, &
          C1, bmat_temp6, cmat_temp6, C0, amat_temp6 )

     call MPI__ZGEMM_ASCOT( 'N', 'C', descCC, &
          C1, amat_temp6, bmat_temp6, C0, cmat_temp6 )

     cmat_temp6(:,:) = cmat_temp6(:,:)*w_weight

     cdens(:,:,ispin) = cdens(:,:,ispin) + cmat_temp6(:,:)
  end if

  deallocate(amat_temp6,bmat_temp6,cmat_temp6,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error deallocate: green_function_scf 3'
     stop
  end if

  return
end subroutine green_function_scf

subroutine calc_edm(descCC,ispin)

  use scf_negf
  use hamiltonian_sgf
  use hamiltonian_c
  use gf_se_c
  use constant
  use condition_ini
  use ac_mpi_module

  implicit none
  type(MPI_MatDesc), intent(in) :: descCC
  integer, intent(in) :: ispin

  integer :: i1_do,i2_do,ier
  complex(8), allocatable :: amat_temp6(:,:),bmat_temp6(:,:)
  complex(8), allocatable :: cmat_temp6(:,:),dmat_temp6(:,:)

  integer :: i, j

  allocate(amat_temp6(descCC%nrow, descCC%scol:descCC%ecol),stat=ier)
  allocate(bmat_temp6(descCC%nrow, descCC%scol:descCC%ecol),stat=ier)
  allocate(cmat_temp6(descCC%nrow, descCC%scol:descCC%ecol),stat=ier)
  allocate(dmat_temp6(descCC%nrow, descCC%scol:descCC%ecol),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: green_function_scf 1'
     stop
  end if

  call alo_hami_c3(descCC)
  call set_hami_c_cc_scf(descCC,ispin)

  bmat_temp6(:,:) = scc_mat(:,:)

  call MPI__ZGETRI_ASCOT( descCC, bmat_temp6 )

  amat_temp6(:,:) = hcc_mat(:,:)

  call unset_hami_c31
  call unset_hami_c32

  call MPI__ZGEMM_ASCOT( 'N', 'N', descCC, &
       C1, bmat_temp6, amat_temp6, C0, cmat_temp6 )

  call MPI__ZGEMM_ASCOT( 'N', 'N', descCC, &
       C1, amat_temp6, bmat_temp6, C0, dmat_temp6 )

  amat_temp6(:,:) = cdens(:,:,ispin)*0.5d0

  call MPI__ZGEMM_ASCOT( 'N', 'N', descCC, &
       C1, cmat_temp6, amat_temp6, C0, bmat_temp6 )

  edens(:,:,ispin) = edens(:,:,ispin) + bmat_temp6(:,:)

  call MPI__ZGEMM_ASCOT( 'N', 'N', descCC, &
       C1, amat_temp6, dmat_temp6, C0, bmat_temp6 )

  edens(:,:,ispin) = edens(:,:,ispin) + bmat_temp6(:,:)

  deallocate(amat_temp6,bmat_temp6,cmat_temp6,dmat_temp6,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error deallocate: green_function_scf 3'
     stop
  end if

  return
end subroutine calc_edm

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine cal_vhartree

  use scf_negf
  use fft
  use dft
  use hamiltonian_sgf
  use hamiltonian_c
  use gf_se_c
  use constant
  use condition_ini
  use mod_mpi

  implicit none
  real(8) :: tmp0

  integer :: i1,i2,i3,i4,ii,gnj,ier

  complex(8), allocatable :: temp(:)

  pai=datan(1.d0)*4.d0

  !                       ------------------------------------                       !

  if( ft_switch == 'f_2_ft' .or. ft_switch == 'fft' ) then
     do i3=l_cell_l_bound,r_cell_l_bound
        do i2=0,n_b-1
           do i1=0,n_a-1
              if( ispin_pol_scf < 4 ) then
                 if( ispin_pol_scf == 1 ) then
                    tmp0=2.d0*rho(i1*n_b*n_c+i2*n_c+i3,1)                            &
                         -rhoval(i1*n_b*n_c+i2*n_c+i3)
                 else
                    tmp0=rho(i1*n_b*n_c+i2*n_c+i3,1)                                 &
                         +rho(i1*n_b*n_c+i2*n_c+i3,2)                                 &
                         -rhoval(i1*n_b*n_c+i2*n_c+i3)
                 end if
              else
                 tmp0=dreal(rhols(i1*n_b*n_c+i2*n_c+i3,1)                           &
                      +rhols(i1*n_b*n_c+i2*n_c+i3,4))                          &
                      -rhoval(i1*n_b*n_c+i2*n_c+i3)
              end if
              fft1(i1+1)=dcmplx(tmp0,0.d0)
           end do
           if( ft_switch == 'f_2_ft' ) then
              call made_fourier(fft1,wxn,n_a,ix_fft)
           else
              call made_fourier_arb(fft1,wxn,n_a)
           end if
           do i1=0,n_a-1
              rho_f(i1*n_b*n_c+i2*n_c+i3)=fft1(i1+1)
           end do
        end do
        do i1=0,n_a-1
           do i2=0,n_b-1
              fft2(i2+1)=rho_f(i1*n_b*n_c+i2*n_c+i3)
           end do
           if( ft_switch == 'f_2_ft' ) then
              call made_fourier(fft2,wyn,n_b,iy_fft)
           else
              call made_fourier_arb(fft2,wyn,n_b)
           end if
           do i2=0,n_b-1
              rho_f(i1*n_b*n_c+i2*n_c+i3)=fft2(i2+1)
           end do
        end do
     end do
  else
     do i3=l_cell_l_bound,r_cell_l_bound
        do i2=0,n_b-1
           do i1=0,n_a-1
              r_tem(1,i1*n_b+i2+1)=dfloat(i1)
              r_tem(2,i1*n_b+i2+1)=dfloat(i2)
              p_tem(1,i1*n_b+i2+1)=dfloat(i1)*2.d0*pai/dfloat(n_a)
              p_tem(2,i1*n_b+i2+1)=dfloat(i2)*2.d0*pai/dfloat(n_b)
              if( ispin_pol_scf < 4 ) then
                 if( ispin_pol_scf == 1 ) then
                    tmp0=2.d0*rho(i1*n_b*n_c+i2*n_c+i3,1)                            &
                         -rhoval(i1*n_b*n_c+i2*n_c+i3)
                 else
                    tmp0=rho(i1*n_b*n_c+i2*n_c+i3,1)                                 &
                         +rho(i1*n_b*n_c+i2*n_c+i3,2)                                 &
                         -rhoval(i1*n_b*n_c+i2*n_c+i3)
                 end if
              else
                 tmp0=dreal(rhols(i1*n_b*n_c+i2*n_c+i3,1)                           &
                      +rhols(i1*n_b*n_c+i2*n_c+i3,4))                          &
                      -rhoval(i1*n_b*n_c+i2*n_c+i3)
              end if
              fft_in(i1*n_b+i2+1)=dcmplx(tmp0,0.d0)
           end do
        end do
        call made_dft(fft_in,fft_out,r_tem,p_tem,n_a*n_b,2,1)
        do i2=0,n_b-1
           do i1=0,n_a-1
              rho_f(i1*n_b*n_c+i2*n_c+i3)=fft_out(i1*n_b+i2+1)
           end do
        end do
     end do
  end if

  !                       ------------------------------------                       !

  allocate(temp(n_c+1),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: dens_atom2cell_lr'
     stop
  end if
  do i2=0,n_b-1
     do i1=0,n_a-1
        if( i1 == 0 .and. i2 == 0) then
           call cal_vhart_gzero_2
        else
           call cal_vhart_gnonzero(i1,i2,n_c,temp)
        end if
     end do
  end do
  deallocate(temp,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error deallocate: dens_atom2cell_lr'
     stop
  end if

  !                       ------------------------------------                       !

  if( ft_switch == 'f_2_ft' .or. ft_switch == 'fft' ) then
     do i3=l_cell_l_bound+1,r_cell_l_bound-1
        do i2=0,n_b-1
           do i1=0,n_a-1
              fft1(i1+1)=rho_f(i1*n_b*n_c+i2*n_c+i3)
           end do
           if( ft_switch == 'f_2_ft' ) then
              call made_fourier(fft1,wxn_i,n_a,ix_fft)
           else
              call made_fourier_arb(fft1,wxn_i,n_a)
           end if
           do i1=0,n_a-1
              rho_f(i1*n_b*n_c+i2*n_c+i3)=fft1(i1+1)
           end do
        end do
        do i1=0,n_a-1
           do i2=0,n_b-1
              fft2(i2+1)=rho_f(i1*n_b*n_c+i2*n_c+i3)
           end do
           if( ft_switch == 'f_2_ft' ) then
              call made_fourier(fft2,wyn_i,n_b,iy_fft)
           else
              call made_fourier_arb(fft2,wyn_i,n_b)
           end if
           do i2=0,n_b-1
              v_hartree(i1*n_b*n_c+i2*n_c+i3)                                      &
                   =dreal(fft2(i2+1))/dfloat(n_a*n_b)
           end do
        end do
     end do
  else
     do i3=l_cell_l_bound+1,r_cell_l_bound-1
        do i2=0,n_b-1
           do i1=0,n_a-1
              r_tem(1,i1*n_b+i2+1)=dfloat(i1)
              r_tem(2,i1*n_b+i2+1)=dfloat(i2)
              p_tem(1,i1*n_b+i2+1)=dfloat(i1)*2.d0*pai/dfloat(n_a)
              p_tem(2,i1*n_b+i2+1)=dfloat(i2)*2.d0*pai/dfloat(n_b)
              fft_in(i1*n_b+i2+1)=rho_f(i1*n_b*n_c+i2*n_c+i3)
           end do
        end do
        call made_dft(fft_in,fft_out,p_tem,r_tem,n_a*n_b,2,-1)
        do i2=0,n_b-1
           do i1=0,n_a-1
              v_hartree(i1*n_b*n_c+i2*n_c+i3)                                      &
                   =dreal(fft_out(i1*n_b+i2+1))/dfloat(n_a*n_b)
           end do
        end do
     end do
  end if

  !                       -----------------------------------                        !

  if( myrank ==0 ) then

     open(unit=90,file='negf_vh.cube')
     write(90,*) 'SYS1'
     write(90,*) 'SYS1'
     write(90,993) num_atom_scf,cell_lo(1),cell_lo(2),cell_lo(3)
     write(90,993) n_a,cell_dlabc(1,1),cell_dlabc(1,2),cell_dlabc(1,3)
     write(90,993) n_b,cell_dlabc(2,1),cell_dlabc(2,2),cell_dlabc(2,3)
     write(90,993) n_c,cell_dlabc(3,1),cell_dlabc(3,2),cell_dlabc(3,3)
     do i1=1,num_atom_scf
        write(90,992) atom_name_num(i1)                                        &
             ,vatom_q(i1)-sum_charge(i1)                                 &
             ,atom_ro(i1,1),atom_ro(i1,2),atom_ro(i1,3)
     end do
     do i1=0,n_a-1
        do i2=0,n_b-1
           ii=n_c+6
           do i3=0,n_c-1,6
              gnj=i1*n_b*n_c+i2*n_c+i3
              ii=ii-6
              if( ii >= 6 ) then
                 write(90,999) (v_hartree(gnj+i4),i4=1,6)
              else
                 if( ii == 5 ) write(90,998) (v_hartree(gnj+i4),i4=1,ii)
                 if( ii == 4 ) write(90,997) (v_hartree(gnj+i4),i4=1,ii)
                 if( ii == 3 ) write(90,996) (v_hartree(gnj+i4),i4=1,ii)
                 if( ii == 2 ) write(90,995) (v_hartree(gnj+i4),i4=1,ii)
                 if( ii == 1 ) write(90,994) (v_hartree(gnj+i4),i4=1,ii)
              end if
           end do
        end do
     end do
     close(90)
  end if

999 format(f13.6,f13.6,f13.6,f13.6,f13.6,f13.6)
998 format(f13.6,f13.6,f13.6,f13.6,f13.6)
997 format(f13.6,f13.6,f13.6,f13.6)
996 format(f13.6,f13.6,f13.6)
995 format(f13.6,f13.6)
994 format(f13.6)
993 format(i4,f13.6,f13.6,f13.6)
992 format(i4,f13.6,f13.6,f13.6,f13.6)

  return
end subroutine cal_vhartree

subroutine cal_vhart_gnonzero(i1,i2,n_c_in,temp)

  use scf_negf
  use fft
  use dft
  use hamiltonian_sgf
  use hamiltonian_c
  use gf_se_c
  use constant
  use condition_ini

  implicit none
  integer, intent(in) :: i1,i2,n_c_in
  complex(8), intent(inout) :: temp(n_c_in+1)

  integer :: i3,i4

  complex(8) :: c1,c2,result
  real(8) :: result1,result2

  pai=datan(1.d0)*4.d0

  !                       ------------------------------------                       !

  do i3=l_cell_l_bound,r_cell_l_bound
     temp(i3)=dcmplx(0.d0,0.d0)
  end do
  do i3=l_cell_l_bound,r_cell_l_bound
     do i4=l_cell_l_bound+1,r_cell_l_bound
        c1=dcmplx(1.d0,0.d0)
        c2=dcmplx(1.d0,0.d0)
        if( i4 == l_cell_l_bound+1 ) then
           if( del_bound_l < del_cell_l*.5d0 ) then
              c1=dcmplx((del_cell_l-del_bound_l)/del_cell_l,0.d0)
           else
              c1=dcmplx(0.d0,0.d0)
              c2=dcmplx((del_cell_l-del_bound_l)/del_cell_l,0.d0)
           end if
        end if
        if( i4 == r_cell_l_bound ) then
           if( del_bound_r < del_cell_l*.5d0 ) then
              c2=dcmplx((del_cell_l-del_bound_r)/del_cell_l,0.d0)
           else
              c1=dcmplx((del_cell_l-del_bound_r)/del_cell_l,0.d0)
              c2=dcmplx(0.d0,0.d0)
           end if
        end if
        call cal_green(i1,i2,i3,i4-1,result1)
        call cal_green(i1,i2,i3,i4,result2)
        temp(i3)=temp(i3)+c1*dcmplx(result1,0.d0)                                &
             *rho_f(i1*n_b*n_c+i2*n_c+i4-1)                     &
             +c2*dcmplx(result2,0.d0)                                &
             *rho_f(i1*n_b*n_c+i2*n_c+i4)
     end do
  end do
  do i3=l_cell_l_bound+1,r_cell_l_bound-1
     call cal_vh_temp(i1,i2,i3,result)
     rho_f(i1*n_b*n_c+i2*n_c+i3)                                                &
          =result+dcmplx(2.d0*pai*del_cell_l,0.d0)*temp(i3)
  end do

  return
end subroutine cal_vhart_gnonzero

subroutine cal_vhart_gzero_2

  use scf_negf
  use fft
  use dft
  use hamiltonian_sgf
  use hamiltonian_c
  use gf_se_c
  use constant
  use condition_ini

  implicit none
  integer :: mat_gzero,i1,i2,i3,i4,ier
  real(8) :: g_temp,temp_r
  complex(8) :: c1,c2,result
  real(8) :: result1,result2
  complex(8), allocatable :: temp(:),a(:,:),b(:,:),c(:),d(:)

  pai=datan(1.d0)*4.d0
  mat_gzero=r_cell_l_bound-l_cell_l_bound+1

  allocate(temp(n_c),a(mat_gzero,mat_gzero),b(mat_gzero,mat_gzero)             &
       ,c(mat_gzero),d(mat_gzero),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: cal_vhart_gzero_2'
     stop
  end if
  do i3=1,n_c
     temp(i3)=dcmplx(0.d0,0.d0)
  end do

  do i3=l_cell_l_bound,r_cell_l_bound
     do i4=l_cell_l_bound+1,r_cell_l_bound
        c1=dcmplx(1.d0,0.d0)
        c2=dcmplx(1.d0,0.d0)
        if( i4 == l_cell_l_bound+1 ) then
           if( del_bound_l < del_cell_l*.5d0 ) then
              c1=dcmplx((del_cell_l-del_bound_l)/del_cell_l,0.d0)
           else
              c1=dcmplx(0.d0,0.d0)
              c2=dcmplx((del_cell_l-del_bound_l)/del_cell_l,0.d0)
           end if
        end if
        if( i4 == r_cell_l_bound ) then
           if( del_bound_r < del_cell_l*.5d0 ) then
              c2=dcmplx((del_cell_l-del_bound_r)/del_cell_l,0.d0)
           else
              c1=dcmplx((del_cell_l-del_bound_r)/del_cell_l,0.d0)
              c2=dcmplx(0.d0,0.d0)
           end if
        end if
        call cal_green(0,0,i3,i4-1,result1)
        call cal_green(0,0,i3,i4,result2)
        temp(i3)=temp(i3)+c1*dcmplx(result1,0.d0)*rho_f(i4-1)                    &
             +c2*dcmplx(result2,0.d0)*rho_f(i4)
     end do
  end do
  do i3=l_cell_l_bound,r_cell_l_bound
     call cal_vh_temp(0,0,i3,result)
     del2_z(i3)=result+dcmplx(2.d0*pai*del_cell_l,0.d0)*temp(i3)
  end do

  g_temp=gzero_gamma*gzero_gamma
  i1=0
  do i3=l_cell_l_bound,r_cell_l_bound
     i1=i1+1
     i2=0
     do i4=l_cell_l_bound,r_cell_l_bound
        i2=i2+1
        temp_r=1.d0
        if( i4 == l_cell_l_bound ) then
           if( del_bound_l < del_cell_l*.5d0 ) then
              temp_r=.5d0*(del_cell_l-del_bound_l)/del_cell_l
           else
              temp_r=0.d0
           end if
        end if
        if( i4 == r_cell_l_bound ) then
           if( del_bound_r < del_cell_l*.5d0 ) then
              temp_r=.5d0*(del_cell_l-del_bound_r)/del_cell_l
           else
              temp_r=0.d0
           end if
        end if
        if( i4 == l_cell_l_bound+1 ) then
           if( del_bound_l > del_cell_l*.5d0 ) then
              temp_r=.5d0+.5d0*(del_cell_l-del_bound_l)/del_cell_l
           end if
        end if
        if( i4 == r_cell_l_bound-1 ) then
           if( del_bound_r > del_cell_l*.5d0 ) then
              temp_r=.5d0+.5d0*(del_cell_l-del_bound_r)/del_cell_l
           end if
        end if
        call cal_green(0,0,i3,i4,result1)
        a(i1,i2)=-dcmplx(g_temp*del_cell_l*temp_r*result1,0.d0)
     end do
     a(i1,i1)=a(i1,i1)+dcmplx(1.d0,0.d0)
  end do

  do i3=l_cell_l_bound+1,r_cell_l_bound-1
     c(i3-l_cell_l_bound+1)=del2_z(i3)
  end do
  call linear_equation(mat_gzero,a,c,d)
  do i3=l_cell_l_bound+1,r_cell_l_bound-1
     rho_f(i3)=d(i3-l_cell_l_bound+1)
  end do

  deallocate(temp,a,b,c,d,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error deallocate: cal_vhart_gzero_2'
     stop
  end if

  return
end subroutine cal_vhart_gzero_2

subroutine cal_vh_temp(kx,ky,kz,result)

  use scf_negf
  use fft
  use dft
  use hamiltonian_sgf
  use hamiltonian_c
  use gf_se_c
  use constant
  use condition_ini

  implicit none
  integer, intent(in) :: kx,ky,kz
  complex(8), intent(out) :: result

  integer :: i1_do,i2_do,i3_do,i1
  real(8) :: g_temp,r1,r2,r3

  r1=cell_lr(1,l_cell_l_bound)+del_bound_l
  r2=cell_lr(1,r_cell_l_bound)-del_bound_r
  i2_do=ky
  i1_do=kx
  if( i1_do == 0 .and. i2_do == 0 ) then
     g_temp=gzero_gamma
  else
     i1=i1_do*n_b+i2_do+1
     g_temp=dsqrt(r_cell_dk(1,i1)*r_cell_dk(1,i1)                               &
          +r_cell_dk(2,i1)*r_cell_dk(2,i1))
  end if
  i3_do=kz
  r3=cell_lr(1,i3_do)
  result                                                                       &
       =(vh_r_f(i1_do*n_b+i2_do+1)                                               &
       *dcmplx(dexp(-g_temp*(r2-r3))-dexp(-g_temp*(r2-2.d0*r1+r3)),0.d0)  &
       +vh_l_f(i1_do*n_b+i2_do+1)                                                 &
       *dcmplx(dexp(-g_temp*(r3-r1))-dexp(-g_temp*(2.d0*r2-r1-r3)),0.d0)) &
       /dcmplx(1.d0-dexp(-2.d0*g_temp*(r2-r1)),0.d0)

  return
end subroutine cal_vh_temp

subroutine cal_green(kx,ky,kz1,kz2,result)

  use scf_negf
  use fft
  use dft
  use hamiltonian_sgf
  use hamiltonian_c
  use gf_se_c
  use constant
  use condition_ini

  implicit none
  integer, intent(in) :: kx,ky,kz1,kz2
  real(8), intent(out) :: result

  integer :: i1_do,i2_do,i3_do,i4_do,i1
  real(8) :: g_temp,r1,r2,r3,r4

  r1=cell_lr(1,l_cell_l_bound)+del_bound_l
  r2=cell_lr(1,r_cell_l_bound)-del_bound_r
  i2_do=ky
  i1_do=kx
  if( i1_do == 0 .and. i2_do == 0 ) then
     g_temp=gzero_gamma
  else
     i1=i1_do*n_b+i2_do+1
     g_temp=dsqrt(r_cell_dk(1,i1)*r_cell_dk(1,i1)                               &
          +r_cell_dk(2,i1)*r_cell_dk(2,i1))
  end if
  i3_do=kz1
  r3=cell_lr(1,i3_do)
  i4_do=kz2
  r4=cell_lr(1,i4_do)
  result=(dexp(-g_temp*dabs(r3-r4))+dexp(-g_temp*(2.d0*(r2-r1)-dabs(r3-r4)))   &
       -dexp(-g_temp*(2.d0*r2-r3-r4))-dexp(-g_temp*(r3+r4-2.d0*r1)))         &
       /(2.d0*g_temp*(1.d0-dexp(-2.d0*g_temp*(r2-r1))))

  return
end subroutine cal_green

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Naoki WATANABE, Nobutaka NISHIKAWA (Mizuho I.R.)   @@ !
! @@             Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine ac_main( filename )
  use ac_parameter
  use ac_mpi_module
  implicit none

  character(len=*), intent(in) :: filename

  integer scount, ecount, rate, count_max

  call system_clock(scount, rate, count_max )

  call Param__read(filename)

  call Param__setup(0)

  call Param__show

  if( Param%Option%optimize ) then
     if( Param%SCF%opt_iter_max == 0 ) then
        call ac_solve
        call Force__calc
        call Force__show
     else
        call ac_optimize
     end if
  else
     call ac_solve
  end if

  if( Param%Band%fname /= "" ) then
     call Hamiltonian__calcBandMap
  end if

  if( Param%DOS%fname /= "" ) then
     call Hamiltonian__calcDOS
  end if

  if( Param%MO%fbase /= "" ) then
     call Hamiltonian__calcMO
  end if

  call Hamiltonian__deallocate
  call Potential__deallocate
  call Density__deallocate
  call Base__deallocate
  call Param__deallocate

  open(unit=16,file=Param%Option%file_ac_tempout,position='append')
  write(16,*)
  write(16,*) '******************** **************** ********************'
  write(16,*) '*                      output files                      *'
  write(16,*) '******************** **************** ********************'
  write(16,*)
  write(16,*) '          Chemical potential & Total energy -> energy.dat'
  write(16,*) '                               Energy level -> level_**.dat'
  write(16,*) '                             charge at site -> charge_per.dat'
  if( Param%Option%optimize ) then
     write(16,*) '                                 Force data -> force.dat'
     if( Param%SCF%opt_iter_max /= 0 ) then
        write(16,*) '                             Structure data -> structure.dat'
     end if
  end if
  write(16,*)
  write(16,*)
  write(16,*)
  write(16,*) ':-:-:-:-:-:-:-:-:-:-:-:-:-:-:-::-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:'
  write(16,*) ':-:-:-:-:-:-:-:-:-:-:-:-:-:-:-::-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:'
  write(16,*) ':-:-:-:-:-:-:-:-:                            :-:-:-:-:-:-:-:-:'
  write(16,*) ':-:-:-:-:-:-:-:-:           finished         :-:-:-:-:-:-:-:-:'
  write(16,*) ':-:-:-:-:-:-:-:-:                            :-:-:-:-:-:-:-:-:'
  write(16,*) ':-:-:-:-:-:-:-:-:-:-:-:-:-:-:-::-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:'
  write(16,*) ':-:-:-:-:-:-:-:-:-:-:-:-:-:-:-::-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:'
  write(16,*)
  close(16)

  call system_clock(ecount, rate, count_max )
  !!if(MPI%root) write(*,*) 'execute time: ', real(ecount-scount)/rate, '(sec)'

  return
end subroutine ac_main

subroutine ac_solve
  use ac_parameter
  use ac_mpi_module
  implicit none

  call MPI__setup

  call Base__setup

  call Density__setup

  call Potential__setup

  call Hamiltonian__calcSCF

  return
end subroutine ac_solve

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine selfenergy_l(w,iw_do,px,py,ispin,kt)

  use hamiltonian_sgf
  use hamiltonian_c
  use gf_se_c
  use constant
  use condition_ini
  use scf_negf

  implicit none
  integer, intent(in) :: iw_do,ispin,kt
  integer, intent(in) :: px,py
  complex(8), intent(in) :: w

  integer :: i1_do,i2_do,ier,i_smd=1,i_block
  complex(8), allocatable :: amat_temp1(:,:),amat_temp2(:,:)
  complex(8), allocatable :: amat_temp3(:,:),amat_temp4(:,:)
  complex(8), allocatable :: amat_temp5(:,:)
  complex(8), allocatable :: bmat_temp1(:,:),bmat_temp2(:,:)
  complex(8), allocatable :: bmat_temp3(:,:),bmat_temp4(:,:)
  complex(8), allocatable :: bmat_temp5(:,:)

  allocate(amat_temp2(m_mat_max_l,m_mat_max_l),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: selfenergy_l 1'
     stop
  end if

  call surf_gf_l(w,amat_temp2,m_mat_max_l,px,py,ispin)
  if( gra_onoff /= 'off' ) then
     call cal_print_text11(iw_do,amat_temp2,ispin,kt)
  end if

  call alo_hami_c1
  if( ham_model_ini == 'input' .or. ham_model_ini == 'scf_accel') then
     call set_hami_c_ll_input(ispin)
  else
     call set_hami_c_ll(px,py)
  end if

  allocate(amat_temp1(m_mat_max_c,m_mat_max_l)                                 &
       ,amat_temp4(m_mat_max_l,m_mat_max_c),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: selfenergy_l 2'
     stop
  end if
  do i2_do=1,m_mat_max_l
     do i1_do=1,m_mat_max_c
        amat_temp1(i1_do,i2_do)=w*scl_mat(i1_do,i2_do)-hcl_mat(i1_do,i2_do)
     end do
  end do
  if( m_mat_max_c .ge. 8 ) then
     i_block=m_mat_max_c/4
  else
     i_block=1
  end if
  do i_smd=1,m_mat_max_c,i_block
     do i1_do=1,m_mat_max_l
        do i2_do=i_smd,min(i_smd+i_block-1,m_mat_max_c)
           amat_temp4(i1_do,i2_do)=w*dconjg(scl_mat(i2_do,i1_do))                 &
                -dconjg(hcl_mat(i2_do,i1_do))
        end do
     end do
  end do
  call unset_hami_c1

  allocate(amat_temp3(m_mat_max_c,m_mat_max_l),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: selfenergy_l 3'
     stop
  end if

  call mat_mul2(m_mat_max_c,m_mat_max_l,m_mat_max_l,m_mat_max_l               &
       ,m_mat_max_c,m_mat_max_l,amat_temp1,amat_temp2,amat_temp3)

  deallocate(amat_temp1,amat_temp2,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error deallocate: selfenergy_l 1'
     stop
  end if
  allocate(amat_temp5(m_mat_max_c,m_mat_max_c),stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error allocate: selfenergy_l 4'
     stop
  end if

  call mat_mul2(m_mat_max_c,m_mat_max_l,m_mat_max_l,m_mat_max_c                &
       ,m_mat_max_c,m_mat_max_c,amat_temp3,amat_temp4,amat_temp5)
  do i2_do=1,m_mat_max_c
     do i1_do=1,m_mat_max_c
        se_l_mat_per(i1_do,i2_do,px,py)=amat_temp5(i1_do,i2_do)
     end do
  end do

  deallocate(amat_temp4,amat_temp3,amat_temp5,stat=ier)
  if( ier /= 0 ) then
     write(6,*) 'error deallocate: selfenergy_l 2'
     stop
  end if

  return
end subroutine selfenergy_l

subroutine surf_gf_l(w,amat_temp2,m_mat_max_l,kx,ky,ispin)

  use condition_ini
  use surface_green_function
  use hamiltonian_sgf
  use hamiltonian_e

  implicit none
  integer, intent(in) :: m_mat_max_l,kx,ky,ispin
  complex(8), intent(in) :: w
  complex(8), intent(out) :: amat_temp2(m_mat_max_l,m_mat_max_l)

  integer :: i2_do,i3_do

  mat_max=mat_max_ll

  call set_condition_l
  call set_hamiltonian_l(kx,ky,ispin)

  if( sgf_method_ini == 'transfer' ) then
     call alo_surface_gf_transefer(mat_max_ll)
  else
     if( sgf_method_ini == 'direct' ) then
        call alo_surface_gf_direct(mat_max_ll)
     else
        write(6,*) 'error - sgf_method_l'
     end if
  end if

  !                       ------------------------------------                       !

  if( sgf_method_ini == 'transfer' ) then
     call su_gf_trans(iteration_max_ini,mat_max_ll,eps_ini                      &
          ,h00_mat,h01_mat,h10_mat,s00_mat,s01_mat,s10_mat,w)
  else
     if( sgf_method_ini == 'direct' ) then
        call su_gf_direct(iteration_max_ini,mat_max_ll,eps_ini                   &
             ,h00_mat,h01_mat,h10_mat,s00_mat,s01_mat,s10_mat,w)
     end if
  end if
  do i3_do=1,mat_max_ll
     do i2_do=1,mat_max_ll
        amat_temp2(i2_do,i3_do)=gr00(i2_do,i3_do)
     end do
  end do

  !                       ------------------------------------                       !

  if( sgf_method_ini == 'transfer' ) then
     call unset_surface_gf_transefer
  else
     if( sgf_method_ini == 'direct' ) then
        call unset_surface_gf_direct
     end if
  end if

  call unset_hamiltonian
  call unset_condition_l

  return
end subroutine surf_gf_l

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine ep1(a,d,n,l_con)  ! l_con=0 -> only eigen values
  ! d: output -> eigen values
  ! a: input -> symmetry matrix, output -> eigen vectors

  implicit none
  integer, intent(in) :: n,l_con
  real(8), intent(inout) :: a(n,n)
  real(8), intent(out) :: d(n)
  integer :: ier,i1_do,i2_do

  character(1) :: jobz,uplo
  real(8), allocatable :: ap(:),z(:,:),w(:),work(:)
  integer :: ldz,info

  if( l_con /= 0 ) then
     jobz='V'
  else
     jobz='N'
  end if
  uplo='U'
  ldz=n
  allocate(ap(n*(n+1)/2),w(n),z(ldz,n),work(3*n),stat=ier)
  if( ier /= 0 ) then
     write(16,*) 'error allocate: cal_eigen'
     stop
  end if
  do i2_do=1,n
     do i1_do=1,n
        if( i1_do <= i2_do ) then
           ap(i1_do+(i2_do-1)*i2_do/2)=a(i1_do,i2_do)
        end if
     end do
  end do
  call dspev(jobz,uplo,n,ap,w,z,ldz,work,info)
  if( info /= 0 ) then
     write(16,*) '         info: dspev-1',info
  end if
  do i2_do=1,n
     d(i2_do)=w(i2_do)
     if( l_con /= 0 ) then
        do i1_do=1,n
           a(i1_do,i2_do)=z(i1_do,i2_do)
        end do
     end if
  end do
  deallocate(ap,w,z,work,stat=ier)
  if( ier /= 0 ) then
     write(16,*) 'error allocate: cal_eigen'
     stop
  end if

  return
end subroutine ep1

subroutine ep_as1(a,d,n,ier_ev)
  ! d: output -> eigen values
  ! a: input -> symmetry matrix, output -> eigen vectors

  implicit none
  integer, intent(in) :: n
  integer, intent(out) :: ier_ev
  real(8), intent(inout) :: a(n,n)
  complex(8), intent(out) :: d(n)
  integer :: ier,i1_do,i2_do

  character(1) :: jobvl,jobvr
  real(8), allocatable :: ap(:,:),wr(:),wi(:),vl(:,:),vr(:,:),work(:)
  integer :: lda,ldvl,ldvr,info,lwork

  jobvl='N'
  jobvr='N'
  lda=n
  ldvl=n
  ldvr=n
  lwork=3*n
  allocate(ap(lda,n),wr(n),wi(n),vl(ldvl,n),vr(ldvr,n),work(lwork),stat=ier)
  if( ier /= 0 ) then
     write(16,*) 'error allocate: cal_eigen'
     stop
  end if
  do i2_do=1,n
     do i1_do=1,n
        ap(i1_do,i2_do)=a(i1_do,i2_do)
     end do
  end do

  call dgeev(jobvl,jobvr,n,ap,lda,wr,wi,vl,ldvl,vr,ldvr,work,lwork,info)

  do i1_do=1,n
     d(i1_do)=dcmplx(wr(i1_do),wi(i1_do))
  end do
  ier_ev=info
  if( info /= 0 ) then
     write(16,*) '         info: dgeev-1',info
  end if
  deallocate(ap,wr,wi,vl,vr,work,stat=ier)
  if( ier /= 0 ) then
     write(16,*) 'error allocate: cal_eigen'
     stop
  end if

  return
end subroutine ep_as1

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine onsite_rtbh_hamiltonian(max_atom_orbital,i1_do,h_ijmn,s_ijmn)

  use condition
  use rtbh_parameter

  implicit none
  integer, intent(in) :: max_atom_orbital,i1_do
  complex(8), intent(out) :: h_ijmn(max_atom_orbital,max_atom_orbital)
  complex(8), intent(out) :: s_ijmn(max_atom_orbital,max_atom_orbital)
  integer :: id

  id=atom_kindn(i1_do)

  h_ijmn=dcmplx(0.d0,0.d0)
  s_ijmn=dcmplx(0.d0,0.d0)

  h_ijmn(1,1)=dcmplx(h_s(id)+v_lr,0.d0)
  h_ijmn(2,2)=dcmplx(h_p(id)+v_lr,0.d0)
  h_ijmn(3,3)=dcmplx(h_p(id)+v_lr,0.d0)
  h_ijmn(4,4)=dcmplx(h_p(id)+v_lr,0.d0)

  s_ijmn(1,1)=dcmplx(1.d0,0.d0)
  s_ijmn(2,2)=dcmplx(1.d0,0.d0)
  s_ijmn(3,3)=dcmplx(1.d0,0.d0)
  s_ijmn(4,4)=dcmplx(1.d0,0.d0)

  return
end subroutine onsite_rtbh_hamiltonian

subroutine off_rtbh_hamiltonian(iz,kx,ky,lx,ly,i1_do,i2_do,max_atom_orbital        &
     ,h_ijmn,s_ijmn)

  use condition
  use rtbh_parameter

  implicit none
  integer, intent(in) :: max_atom_orbital,kx,ky,lx,ly,iz,i1_do,i2_do
  complex(8), intent(out) :: h_ijmn(max_atom_orbital,max_atom_orbital)
  complex(8), intent(out) :: s_ijmn(max_atom_orbital,max_atom_orbital)

  integer :: id1,id2,j_do,jr_do
  real(8) :: r_distance,rab_distance(3),r_temp_a(3),r_temp_b(3)

  do jr_do=1,3
     r_temp_a(jr_do)=dfloat(kx)*unit_block(1,jr_do)                             &
          +dfloat(ky)*unit_block(2,jr_do)                             &
          +dfloat(iz)*unit_block(3,jr_do)+ra(i1_do,jr_do)
     r_temp_b(jr_do)=dfloat(lx)*unit_block(1,jr_do)                             &
          +dfloat(ly)*unit_block(2,jr_do)+ra(i2_do,jr_do)
  end do

  do jr_do=1,3
     rab_distance(jr_do)=r_temp_b(jr_do)-r_temp_a(jr_do)
  end do

  r_distance=0.d0
  do j_do=1,3
     r_distance=r_distance+rab_distance(j_do)**2
  end do
  r_distance=dsqrt(r_distance)

  rab_distance=rab_distance/r_distance

  id1=atom_kindn(i1_do)
  id2=atom_kindn(i2_do)

  call set_off_rtbh(r_distance,rab_distance,id1,id2                            &
       ,max_atom_orbital,h_ijmn,s_ijmn)

  return
end subroutine off_rtbh_hamiltonian

subroutine set_off_rtbh(r_distance,rab_distance,id1,id2                            &
     ,max_atom_orbital,h_ijmn,s_ijmn)

  use condition
  use rtbh_parameter

  implicit none
  integer, intent(in) :: max_atom_orbital
  integer, intent(in) :: id1,id2
  real(8), intent(in) :: r_distance,rab_distance(3)
  complex(8), intent(out) :: h_ijmn(max_atom_orbital,max_atom_orbital)
  complex(8), intent(out) :: s_ijmn(max_atom_orbital,max_atom_orbital)

  integer :: j_do

  real(8) :: hsss,hsps,hpps,hppp
  real(8) :: hsss_b,hsps_b,hpps_b,hppp_b
  real(8) :: ssss,ssps,spps,sppp
  real(8) :: ssss_b,ssps_b,spps_b,sppp_b
  real(8) :: h_r0(2)

  h_ijmn=dcmplx(0.d0,0.d0)

  call h_ss_sigma_rtbh(id1,id2,r_distance,hsss)
  call h_ss_sigma_rtbh(id1,id2,r_distance,hsss_b)

  call h_sp_sigma_rtbh(id1,id2,r_distance,hsps)
  call h_sp_sigma_rtbh(id1,id2,r_distance,hsps_b)

  call h_pp_sigma_rtbh(id1,id2,r_distance,hpps)
  call h_pp_sigma_rtbh(id1,id2,r_distance,hpps_b)
  call h_pp_pi_rtbh(id1,id2,r_distance,hppp)
  call h_pp_pi_rtbh(id1,id2,r_distance,hppp_b)

  h_ijmn(1,1)=hsss

  do j_do=1,3
     h_ijmn(1,j_do+1)=hsps*rab_distance(j_do)
     h_ijmn(j_do+1,1)=-1.d0*hsps_b*rab_distance(j_do)
  end do

  do j_do=1,3
     h_r0(1)=hpps*rab_distance(j_do)**2
     h_r0(2)=hppp*(1.d0-rab_distance(j_do)**2)
     h_ijmn(j_do+1,j_do+1)=h_r0(1)+h_r0(2) 
  end do

  do j_do=2,3
     h_r0(1)=hpps*rab_distance(1)*rab_distance(j_do)
     h_r0(2)=hppp*rab_distance(1)*rab_distance(j_do)
     h_ijmn(2,j_do+1)=h_r0(1)-h_r0(2) 

     h_r0(1)=hpps_b*rab_distance(1)*rab_distance(j_do)
     h_r0(2)=hppp_b*rab_distance(1)*rab_distance(j_do)
     h_ijmn(j_do+1,2)=h_r0(1)-h_r0(2) 
  end do

  h_r0(1)=hpps*rab_distance(2)*rab_distance(3)
  h_r0(2)=hppp*rab_distance(2)*rab_distance(3)
  h_ijmn(3,4)=h_r0(1)-h_r0(2) 

  h_r0(1)=hpps_b*rab_distance(2)*rab_distance(3)
  h_r0(2)=hppp_b*rab_distance(2)*rab_distance(3)
  h_ijmn(4,3)=h_r0(1)-h_r0(2) 


  s_ijmn=dcmplx(0.d0,0.d0)

  call s_ss_sigma_rtbh(id1,id2,r_distance,ssss)
  call s_ss_sigma_rtbh(id1,id2,r_distance,ssss_b)

  call s_sp_sigma_rtbh(id1,id2,r_distance,ssps)
  call s_sp_sigma_rtbh(id1,id2,r_distance,ssps_b)

  call s_pp_sigma_rtbh(id1,id2,r_distance,spps)
  call s_pp_sigma_rtbh(id1,id2,r_distance,spps_b)
  call s_pp_pi_rtbh(id1,id2,r_distance,sppp)
  call s_pp_pi_rtbh(id1,id2,r_distance,sppp_b)

  s_ijmn(1,1)=ssss

  do j_do=1,3
     s_ijmn(1,j_do+1)=ssps*rab_distance(j_do)
     s_ijmn(j_do+1,1)=-1.d0*ssps_b*rab_distance(j_do)
  end do

  do j_do=1,3
     h_r0(1)=spps*rab_distance(j_do)**2
     h_r0(2)=sppp*(1.d0-rab_distance(j_do)**2)
     s_ijmn(j_do+1,j_do+1)=h_r0(1)+h_r0(2) 
  end do

  do j_do=2,3
     h_r0(1)=spps*rab_distance(1)*rab_distance(j_do)
     h_r0(2)=sppp*rab_distance(1)*rab_distance(j_do)
     s_ijmn(2,j_do+1)=h_r0(1)-h_r0(2) 

     h_r0(1)=spps_b*rab_distance(1)*rab_distance(j_do)
     h_r0(2)=sppp_b*rab_distance(1)*rab_distance(j_do)
     s_ijmn(j_do+1,2)=h_r0(1)-h_r0(2) 
  end do

  h_r0(1)=spps*rab_distance(2)*rab_distance(3)
  h_r0(2)=sppp*rab_distance(2)*rab_distance(3)
  s_ijmn(3,4)=h_r0(1)-h_r0(2) 

  h_r0(1)=spps_b*rab_distance(2)*rab_distance(3)
  h_r0(2)=sppp_b*rab_distance(2)*rab_distance(3)
  s_ijmn(4,3)=h_r0(1)-h_r0(2) 

  return
end subroutine set_off_rtbh

subroutine h_ss_sigma_rtbh(id1,id2,r,hsss)

  use rtbh_parameter

  implicit none
  integer, intent(in) :: id1,id2
  real(8), intent(in) :: r
  real(8), intent(out) :: hsss
  real(8) :: rc,nc,qr,x,pai

  nc=-b*dsqrt(v_ss(id1)*v_ss(id2))

  x=a*r/(r_ss(id1)+r_ss(id2))
  rc=dexp(-x)*(1.d0+x+x*x/3.d0)

  if( r < r1 ) then
     qr=1.d0
  else
     if( r > r2 ) then
        qr=0.d0
     else
        pai=datan(1.d0)*4.d0
        qr=.5d0*(1.d0+dcos(pai*(r-r1)/(r2-r1)))
     end if
  end if

  hsss=nc*rc*qr

  return
end subroutine h_ss_sigma_rtbh

subroutine h_sp_sigma_rtbh(id1,id2,r,hsps)

  use rtbh_parameter

  implicit none
  integer, intent(in) :: id1,id2
  real(8), intent(in) :: r
  real(8), intent(out) :: hsps
  real(8) :: rc,nc,qr,x,pai

  nc=-b*dsqrt(v_ss(id1)*v_ps(id2))

  x=a*r/(r_ss(id1)+r_ps(id2))
  rc=-dexp(-x)*(x+x*x/3.d0)

  if( r < r1 ) then
     qr=1.d0
  else
     if( r > r2 ) then
        qr=0.d0
     else
        pai=datan(1.d0)*4.d0
        qr=.5d0*(1.d0+dcos(pai*(r-r1)/(r2-r1)))
     end if
  end if

  hsps=nc*rc*qr

  return
end subroutine h_sp_sigma_rtbh

subroutine h_pp_sigma_rtbh(id1,id2,r,hpps)

  use rtbh_parameter

  implicit none
  integer, intent(in) :: id1,id2
  real(8), intent(in) :: r
  real(8), intent(out) :: hpps
  real(8) :: rc,nc,qr,x,pai

  nc=-b*dsqrt(v_ps(id1)*v_ps(id2))

  x=a*r/(r_ps(id1)+r_ps(id2))
  rc=-dexp(-x)*(-1.d0+x+x*x/3.d0)

  if( r < r1 ) then
     qr=1.d0
  else
     if( r > r2 ) then
        qr=0.d0
     else
        pai=datan(1.d0)*4.d0
        qr=.5d0*(1.d0+dcos(pai*(r-r1)/(r2-r1)))
     end if
  end if

  hpps=nc*rc*qr

  return
end subroutine h_pp_sigma_rtbh

subroutine h_pp_pi_rtbh(id1,id2,r,hppp)

  use rtbh_parameter

  implicit none
  integer, intent(in) :: id1,id2
  real(8), intent(in) :: r
  real(8), intent(out) :: hppp
  real(8) :: rc,nc,qr,x,pai

  nc=-b*dsqrt(v_pp(id1)*v_pp(id2))

  x=a*r/(r_pp(id1)+r_pp(id2))
  rc=dexp(-x)*(1.d0+x+x*x/3.d0)

  if( r < r1 ) then
     qr=1.d0
  else
     if( r > r2 ) then
        qr=0.d0
     else
        pai=datan(1.d0)*4.d0
        qr=.5d0*(1.d0+dcos(pai*(r-r1)/(r2-r1)))
     end if
  end if

  hppp=nc*rc*qr

  return
end subroutine h_pp_pi_rtbh

subroutine s_ss_sigma_rtbh(id1,id2,r,ssss)

  use rtbh_parameter

  implicit none
  integer, intent(in) :: id1,id2
  real(8), intent(in) :: r
  real(8), intent(out) :: ssss
  real(8) :: rc,nc,qr,x,pai

  nc=dsqrt(u_ss(id1)*u_ss(id2))

  x=a*r/(r_ss(id1)+r_ss(id2))
  rc=dexp(-x)*(1.d0+x+x*x/3.d0)

  if( r < r1 ) then
     qr=1.d0
  else
     if( r > r2 ) then
        qr=0.d0
     else
        pai=datan(1.d0)*4.d0
        qr=.5d0*(1.d0+dcos(pai*(r-r1)/(r2-r1)))
     end if
  end if

  ssss=nc*rc*qr

  return
end subroutine s_ss_sigma_rtbh

subroutine s_sp_sigma_rtbh(id1,id2,r,ssps)

  use rtbh_parameter

  implicit none
  integer, intent(in) :: id1,id2
  real(8), intent(in) :: r
  real(8), intent(out) :: ssps
  real(8) :: rc,nc,qr,x,pai

  nc=dsqrt(u_ss(id1)*u_ps(id2))

  x=a*r/(r_ss(id1)+r_ps(id2))
  rc=-dexp(-x)*(x+x*x/3.d0)

  if( r < r1 ) then
     qr=1.d0
  else
     if( r > r2 ) then
        qr=0.d0
     else
        pai=datan(1.d0)*4.d0
        qr=.5d0*(1.d0+dcos(pai*(r-r1)/(r2-r1)))
     end if
  end if

  ssps=nc*rc*qr

  return
end subroutine s_sp_sigma_rtbh

subroutine s_pp_sigma_rtbh(id1,id2,r,spps)

  use rtbh_parameter

  implicit none
  integer, intent(in) :: id1,id2
  real(8), intent(in) :: r
  real(8), intent(out) :: spps
  real(8) :: rc,nc,qr,x,pai

  nc=dsqrt(u_ps(id1)*u_ps(id2))

  x=a*r/(r_ps(id1)+r_ps(id2))
  rc=-dexp(-x)*(-1.d0+x+x*x/3.d0)

  if( r < r1 ) then
     qr=1.d0
  else
     if( r > r2 ) then
        qr=0.d0
     else
        pai=datan(1.d0)*4.d0
        qr=.5d0*(1.d0+dcos(pai*(r-r1)/(r2-r1)))
     end if
  end if

  spps=nc*rc*qr

  return
end subroutine s_pp_sigma_rtbh

subroutine s_pp_pi_rtbh(id1,id2,r,sppp)

  use rtbh_parameter

  implicit none
  integer, intent(in) :: id1,id2
  real(8), intent(in) :: r
  real(8), intent(out) :: sppp
  real(8) :: rc,nc,qr,x,pai

  nc=dsqrt(u_pp(id1)*u_pp(id2))

  x=a*r/(r_pp(id1)+r_pp(id2))
  rc=dexp(-x)*(1.d0+x+x*x/3.d0)

  if( r < r1 ) then
     qr=1.d0
  else
     if( r > r2 ) then
        qr=0.d0
     else
        pai=datan(1.d0)*4.d0
        qr=.5d0*(1.d0+dcos(pai*(r-r1)/(r2-r1)))
     end if
  end if

  sppp=nc*rc*qr

  return
end subroutine s_pp_pi_rtbh

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@             Naoki WATANABE (Mizuho I.R.)                       @@ !
! @@             Nobutaka NISHIKAWA (Mizuho I.R.)                   @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

program ascot_main

  use condition_ini
  use scf_negf
  use mod_mpi
  use ac_mpi_module

  implicit none

  integer :: iargc

  character(50) :: calc_t_negfordft
  character(50) :: file_name
  character(256) token(2)
  integer :: i
  logical :: skip

  integer scount, ecount, rate, count_max

  call system_clock(scount, rate, count_max )
  time_scount = scount

  call MPI__Initialize

  call alo_tempout
  call gen_outf

  open(unit=16,file=file_tempout)
  write(16,*) ':-:-:-:-:-:-:-:-:-:-:-:-:-:-:-::-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:'
  write(16,*) ':-:-:-:-:-:-:-:-:-:-:-:-:-:-:-::-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:'
  write(16,*) ':-:-:-:-:-:-:-:-:                            :-:-:-:-:-:-:-:-:'
  write(16,*) ':-:-:-:-:-:-:-:-: Welcome to ASCOT ver. 4.5  :-:-:-:-:-:-:-:-:'
  write(16,*) ':-:-:-:-:-:-:-:-:                            :-:-:-:-:-:-:-:-:'
  write(16,*) ':-:-:-:-:-:-:-:-:-:-:-:-:-:-:-::-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:'
  write(16,*) ':-:-:-:-:-:-:-:-:-:-:-:-:-:-:-::-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:'
  close(16)

  if( MPI%root ) then
     file_name = ""
     skip = .false.
     do i=1, iargc()
        if( skip ) then
           skip = .false.
           cycle
        end if
        call getarg(i,token(1))

        select case(token(1))
        case('-Ne','-ne')
           call getarg(i+1,token(2))
           read(token(2),*) MPI%sizeE
           skip = .true.
        case('-Nm','-nm')
           call getarg(i+1,token(2))
           read(token(2),*) MPI%sizeM
           skip = .true.
        case default
           file_name=token(1)
           exit
        end select
     end do
  end if

  call MPI_Bcast( MPI%sizeE, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, MPI%info )
  call MPI_Bcast( MPI%sizeM, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, MPI%info )

  MPI%sizeA = MPI%sizeM
  call MPI_Bcast( MPI%sizeA, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, MPI%info )

  call MPI_Bcast( file_name, 50, MPI_CHARACTER, 0, MPI_COMM_WORLD, MPI%info )
  if( file_name == "" ) then
     open(unit=16,file=file_tempout,position='append')
     write(16,*) '    ??? inputfile ???'
     close(16)
     call MPI__Finalize
     stop
  end if

  call get_negfordft(file_name,calc_t_negfordft)

  select case(calc_t_negfordft)

  case('dft','DFT')
     call ac_main(file_name)

  case('negf','NEGF')
     call set_parameter(file_name)

     call set_condition_l
     if( switch_l_eigen == 'on' .or. dos_on_off_ini_l == 'on' ) then
        call set_chemical_potential(1)
        if( MPI%root ) then
           call print_text_l
        end if
     end if
     call save_hamiltonian_sgf_l
     call unset_condition_l

     call set_condition_r
     if( switch_r_eigen == 'on' .or. dos_on_off_ini_r == 'on' ) then
        call set_chemical_potential(2)
        if( MPI%root ) then
           call print_text_r
        end if
     end if

     call save_hamiltonian_sgf_r
     call unset_condition_r

     if( calc_type /= 'off' ) then
        if( ham_model_ini /= 'input' .and. ham_model_ini /= 'scf_accel' ) then
           call set_locate_atom
           call set_hami_c_pre
        end if

        call set_for_gf_se_c

        if( ham_model_ini == 'scf_accel' ) then
           call scf_main_negf_ac
        end if

        if( calc_type /= 'scf_only' ) then
           if( file_selfenergy == 'none' .or. file_selfe_outsw /= 'on' ) then
              call cal_gf_se_c
           else
              call cal_gf_se_read             
           end if
           if( MPI%root ) then
              if( calc_type == 'trans' ) then
                 call print_text
              else if( calc_type == 'iv' ) then
                 call print_text
                 call cal_iv
              end if
           end if
        end if
        call unset_for_gf_se_c
        if( ham_model_ini == 'scf_accel') then
           call scf_main_unset_negf
        end if
     end if

     open(unit=16,file=file_tempout,position='append')
     write(16,*)
     write(16,*)                                                              &
          '******************** ******************** ********************'
     write(16,*)                                                              &
          '*                        output files                        *'
     write(16,*)                                                              &
          '******************** ******************** ********************'
     write(16,*)
     if( ham_model_ini == 'scf_accel' ) then
        write(16,*)                                                              &
             '                             charge at site -> charge_open.dat'
        write(16,*) '                                  V_hartree -> negf_vh.cube'
        write(16,*)                                                              &
             '                                      V_tot -> negf_vtot*.cube'
        write(16,*)'                                    density -> negf_den*.cube'
        if( force_calc_onoff == 'on' ) then
           write(16,*)                                                            &
                '                                      force -> force_negf.dat'
        end if
     end if
     if( calc_type /= 'off' .and. calc_type /= 'scf_only' ) then
        if( calc_type == 'trans' ) then
           write(16,*) '                transmission against energy -> trans.dat'
           write(16,*) '          LDOS of all system against energy -> em_gf.dat'
           write(16,*) '     trace of the surface GF against energy -> sf_gf*.dat'
        end if
        if( calc_type == 'iv' ) then
           write(16,*) '                              current value -> iv.dat'
        end if
        if( switch_out_gf /= 'off' ) then
           if( switch_out_gf == 'all' ) then
              write(16,*)
              write(16,*) '                                     G(E) S -> gfc*.data'
           else
              write(16,*)
              write(16,*) '                diagonal elements of G(E) S -> gfc*.data'
           end if
        end if
        if( switch_out_tr /= 'off' ) then
           if( switch_out_tr == 'all' ) then
              write(16,*) '                                       G(E) -> ftg*.data'
              write(16,*) '                                   Gamma(E) -> gam*.data'
           else
              if( switch_out_tr == 'tr' ) then
                 write(16,*)                                                        &
                      '                                       T(E) -> tra*.data'
              else
                 write(16,*)                                                        &
                      '                  diagonal elements of T(E) -> tra*.data'
              end if
           end if
        end if
        if( switch_out_ham /= 'off' ) then
           write(16,*) '                         Hamiltonian matrix -> ham*.data'
        end if
        if( file_selfe_outsw /= 'off' .and. file_selfenergy == 'none' ) then
           write(16,*) '                        data of self energy -> sel.data*'
        end if
        write(16,*)
     end if
     if( switch_l_eigen == 'on' ) then
        write(16,*) '          band structure of left electrode  -> ev_l.dat'
     end if
     if( switch_r_eigen == 'on' ) then
        write(16,*) '          band structure of right electrode -> ev_r.dat'
     end if
     if( dos_on_off_ini_l == 'on' ) then
        write(16,*) '                     DOS of left electrode  -> nogf_l.dat'
     end if
     if( dos_on_off_ini_r == 'on' ) then
        write(16,*) '                     DOS of right electrode -> nogf_r.dat'
     end if
     write(16,*)
     write(16,*) ':-:-:-:-:-:-:-:-:-:-:-:-:-:-:-::-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:'
     write(16,*) ':-:-:-:-:-:-:-:-:-:-:-:-:-:-:-::-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:'
     write(16,*) ':-:-:-:-:-:-:-:-:                            :-:-:-:-:-:-:-:-:'
     write(16,*) ':-:-:-:-:-:-:-:-:           finished         :-:-:-:-:-:-:-:-:'
     write(16,*) ':-:-:-:-:-:-:-:-:                            :-:-:-:-:-:-:-:-:'
     write(16,*) ':-:-:-:-:-:-:-:-:-:-:-:-:-:-:-::-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:'
     write(16,*) ':-:-:-:-:-:-:-:-:-:-:-:-:-:-:-::-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:'
     write(16,*)
     close(16)

     call unset

  case default
     open(unit=16,file=file_tempout,position='append')
     write(16,*) '    +++++ error:: calc_type -  ',calc_t_negfordft
     close(16)
     stop

  end select

  call MPI__Finalize

  !!if(MPI%root) call output_time

  call system_clock(ecount, rate, count_max )
  !!if(MPI%root) write(*,*) 'execute time: ', real(ecount-scount)/rate, '(sec)'

end program

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine set_locate_atom

  use condition_ini
  use locate_atom

  implicit none
  integer :: kx,ky,i1_do,i2_do,i1_count,i2_count,num_unit_temp1,num_unit_temp2
  integer :: jr_do
  real(8) :: rz_temp

  if( p_or_f_l == 'free' ) then
     num_atom_lt=num_atom_l*neighbor_x_max_l*neighbor_y_max_l
  else
     if( p_or_f_l == 'periodic' ) then
        num_atom_lt=num_atom_l
     else
        write(6,*) 'error_locate: set_locate_atom 1'
        stop
     end if
  end if
  if( p_or_f_r == 'free' ) then
     num_atom_rt=num_atom_r*neighbor_x_max_r*neighbor_y_max_r
  else
     if( p_or_f_r == 'periodic' ) then
        num_atom_rt=num_atom_r
     else
        write(6,*) 'error_locate: set_locate_atom 2'
        stop
     end if
  end if

  num_atom_ctotal=m_num_block_l*num_atom_lt+m_num_block_m*num_atom_c           &
       +m_num_block_r*num_atom_rt

  call alo_locate_atom


  i1_count=0
  if( p_or_f_l == 'free' ) then
     num_unit_temp1=num_unit_l(1)
     num_unit_temp2=num_unit_l(2)
  else
     if( p_or_f_l == 'periodic' ) then
        num_unit_temp1=1
        num_unit_temp2=1
     else
        write(6,*) 'error_locate: set_locate_atom 3'
        stop
     end if
  end if
  do kx=1,num_unit_temp1
     do ky=1,num_unit_temp2
        do i1_do=1,num_atom_l
           i1_count=i1_count+1
           do jr_do=1,3
              r_l(i1_count,jr_do)=ra_l(i1_do,jr_do)                                &
                   +dfloat(kx-1)*unit_block_l(1,jr_do)              &
                   +dfloat(ky-1)*unit_block_l(2,jr_do)
           end do
        end do
     end do
  end do


  rz_temp=0.d0
  i1_count=0
  i2_count=0

  if( p_or_f_l == 'free' ) then
     num_unit_temp1=num_unit_l(1)
     num_unit_temp2=num_unit_l(2)
  else
     if( p_or_f_l == 'periodic' ) then
        num_unit_temp1=1
        num_unit_temp2=1
     else
        write(6,*) 'error_locate: set_locate_atom 4'
        stop
     end if
  end if
  do i1_do=1,m_num_block_l
     i2_count=i2_count+1
     rz_temp=rz_temp+unit_block_l(3,3)
     do kx=1,num_unit_temp1
        do ky=1,num_unit_temp2
           do i2_do=1,num_atom_l
              i1_count=i1_count+1
              do jr_do=1,3
                 r_c(i1_count,jr_do)=ra_l(i2_do,jr_do)                              &
                      +dfloat(kx-1)*unit_block_l(1,jr_do)             &
                      +dfloat(ky-1)*unit_block_l(2,jr_do)
              end do
              r_c(i1_count,3)=r_c(i1_count,3)+rz_temp
              atom_kindn_ccal(i1_count)=atom_kindn_l(i2_do)
              i_lmr(i1_count)=-1
              i_locate(i1_count)=i2_count
           end do
        end do
     end do
  end do

  rz_temp=rz_temp+r_dis_l
  do i2_do=1,m_num_block_m
     i2_count=i2_count+1
     do i1_do=1,num_atom_c
        i1_count=i1_count+1
        r_c(i1_count,1)=ra_c(i1_do,1)
        r_c(i1_count,2)=ra_c(i1_do,2)
        r_c(i1_count,3)=ra_c(i1_do,3)+rz_temp
        atom_kindn_ccal(i1_count)=atom_kindn_c(i1_do)
        i_lmr(i1_count)=0
        i_locate(i1_count)=i2_count
     end do
     rz_temp=rz_temp+unit_block_c(3,3)
  end do

  if( p_or_f_r == 'free' ) then
     num_unit_temp1=num_unit_r(1)
     num_unit_temp2=num_unit_r(2)
  else
     if( p_or_f_r == 'periodic' ) then
        num_unit_temp1=1
        num_unit_temp2=1
     else
        write(6,*) 'error_locate: set_locate_atom 5'
        stop
     end if
  end if
  rz_temp=rz_temp+r_dis_r
  do i1_do=1,m_num_block_r
     i2_count=i2_count+1
     do kx=1,num_unit_temp1
        do ky=1,num_unit_temp2
           do i2_do=1,num_atom_r
              i1_count=i1_count+1
              do jr_do=1,3
                 r_c(i1_count,jr_do)=ra_r(i2_do,jr_do)                              &
                      +dfloat(kx-1)*unit_block_r(1,jr_do)            &
                      +dfloat(ky-1)*unit_block_r(2,jr_do)
              end do
              r_c(i1_count,3)=r_c(i1_count,3)+rz_temp
              atom_kindn_ccal(i1_count)=atom_kindn_r(i2_do)
              i_lmr(i1_count)=1
              i_locate(i1_count)=i2_count
           end do
        end do
     end do
     rz_temp=rz_temp+unit_block_r(3,3)
  end do


  rz_temp=dfloat(m_num_block_l)*unit_block_l(3,3)                              &
       +r_dis_l+dfloat(m_num_block_m)*unit_block_c(3,3)+r_dis_r              &
       +dfloat(m_num_block_r)*unit_block_r(3,3)
  i1_count=0

  if( p_or_f_r == 'free' ) then
     num_unit_temp1=num_unit_r(1)
     num_unit_temp2=num_unit_r(2)
  else
     if( p_or_f_r == 'periodic' ) then
        num_unit_temp1=1
        num_unit_temp2=1
     else
        write(6,*) 'error_locate: set_locate_atom 6'
        stop
     end if
  end if
  do kx=1,num_unit_temp1
     do ky=1,num_unit_temp2
        do i1_do=1,num_atom_r
           i1_count=i1_count+1
           do jr_do=1,3
              r_r(i1_count,jr_do)=ra_r(i1_do,jr_do)                                &
                   +dfloat(kx-1)*unit_block_r(1,jr_do)              &
                   +dfloat(ky-1)*unit_block_r(2,jr_do)
           end do
           r_r(i1_count,3)=r_r(i1_count,3)+rz_temp
        end do
     end do
  end do


  if( ham_model_ini .eq. 'gsp' ) then
     call set_locate_atom_pair
  end if

  return
end subroutine set_locate_atom

subroutine set_locate_atom_pair                                     ! for GSP model

  use condition_ini
  use locate_atom
  use gsp_parameter

  implicit none
  integer :: i1_do,i2_do,i3_do

  call alo_locate_atom_pair


  do i1_do=1,num_atom_ctotal
     do i2_do=1,num_atom_ctotal
        do i3_do=1,num_atom_kind_ini*num_atom_kind_ini
           if( atom_sign_ini(atom_kindn_ccal(i1_do))                              &
                == atom_parameter(i3_do,1)                      &
                .and. atom_sign_ini(atom_kindn_ccal(i2_do))                       &
                == atom_parameter(i3_do,2) ) then
              pair_num_ccal(i1_do,i2_do)=i3_do
              go to 10
           end if
        end do
        write(6,*) 'error - set_pair (lo_mm)'
        stop
10      continue
     end do
  end do

  return
end subroutine set_locate_atom_pair

subroutine Param__readMX( fname )
  use ac_misc_module
  implicit none

  character(len=*) fname

  integer        :: iunit
  logical        :: ex
  character(256) :: buf, tag

  integer        :: i, j
  real(8)  :: MOL_TO_AU, CEL_TO_AU
  character(16)  :: name
  character(64)  :: name_pao, mode, name_vps
  character(256) :: fname_pao, fname_vps
  character(16)  :: str

  real(8) :: R(3)
  real(8) :: ks(3), ke(3)
  integer        :: mesh
  type(Element_type), pointer :: elem
  real(8)  :: Qu, Qd
  character(256) :: dummy

  !*************************************************************
  open(unit=16,file=Param%Option%file_ac_tempout,position='append')
  write(16,*) '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'
  write(16,999) fname
  write(16,*)
999 format(' +++++++++++ start: read file:: ',a15)
  close(16)
  !*************************************************************

  inquire(file=fname,exist=ex)
  if( .not. ex ) then
     write(*,'(a,a)') '# Error!: can not open file', trim(fname) 
     stop
  end if
  iunit=1
  open(iunit, file=fname)

  MOL_TO_AU = AA_TO_AU ! default angstrom
  CEL_TO_AU = AA_TO_AU ! default angstrom

  do 
     read(iunit, '(a)', end=100) buf
     if( uncomment(buf) ) cycle
     read(buf,*) tag

     select case(tag)
     case('System.Name')
        read(buf,*) tag, Param%name

     case('Species.Number')
        read(buf,*) tag, Param%Data%nelem
        allocate( Param%Data%velem(Param%Data%nelem))
        allocate( Param%Data%velem_file(Param%Data%nelem,4))

     case('<Definition.of.Atomic.Species')
        do i=1, Param%Data%nelem
           read(iunit, '(a)') buf

           do j=1, len_trim(buf)
              if( buf(j:j) == '-' ) then
                 buf(j:j) = ' '
              endif
           end do

           read(buf,*) name, name_pao, mode, name_vps

           fname_pao = trim(Param%Data%path_pao) // "/" // trim(name_pao) // ".pao"
           fname_vps = trim(Param%Data%path_vps) // "/" // trim(name_vps) // ".vps"

           Param%Data%velem_file(i,1)=name
           Param%Data%velem_file(i,2)=fname_pao
           Param%Data%velem_file(i,4)=fname_vps
           Param%Data%velem_file(i,3)=mode

           call Element__readPAO_adpack( Param%Data%velem(i), name, fname_pao, mode, "" )
           call Element__readVPS_adpack( Param%Data%velem(i), name, fname_vps )

        end do
        read(iunit, '(a)') buf

     case('Atoms.Number')
        read(buf,*) tag, Param%Data%natom
        allocate( Param%Data%vatom(Param%Data%natom))

     case('Atoms.Number.Left')
        read(buf,*) tag, Param%Data%natom_left

     case('Atoms.Number.Right')
        read(buf,*) tag, Param%Data%natom_right

     case('Atoms.SpeciesAndCoordinates.Unit')
        read(buf,*) tag, str
        MOL_TO_AU = TO_AU(str)

     case('<Atoms.SpeciesAndCoordinates')
        do i=1, Param%Data%natom
           read(iunit,'(a)') buf
           read(buf,*) dummy, name, R(:), Qu, Qd
           if( dummy == dummy ) then ! to suppress a warning
           endif

           elem => Param__Data__getElement( name )

           call Atom__set( Param%Data%vatom(i), name, R*MOL_TO_AU, &
                elem%vpao(1)%Rc, -elem%Vloc%Q, elem%atomic_number, (Qu-Qd)/(Qu+Qd), .true. )
        end do
        read(iunit,'(a)') buf

     case('Atoms.UnitVectors.Unit')
        read(buf,*) tag, str
        CEL_TO_AU = TO_AU(str)

     case('<Atoms.UnitVectors')
        read(iunit,'(a)') buf
        read(buf,*) Param%Cell%La(:)

        read(iunit,'(a)') buf
        read(buf,*) Param%Cell%Lb(:)

        read(iunit,'(a)') buf
        read(buf,*) Param%Cell%Lc(:)

        Param%Cell%La = Param%Cell%La * CEL_TO_AU
        Param%Cell%Lb = Param%Cell%Lb * CEL_TO_AU
        Param%Cell%Lc = Param%Cell%Lc * CEL_TO_AU
        read(iunit,'(a)') buf

     case('scf.XcType')
        read(buf,*) tag, str
        select case(str)
        case('PZ81','LDA','LSDA-CA')
           Param%SCF%exc_type = 'PZ81'
        case('PW91','LSDA-PW')
           Param%SCF%exc_type = 'PW91'
        case('PBE')
           Param%SCF%exc_type = 'PBE'
        case default
           write(*,'(a,a)') '# Error!: scf.XcType is broken in file ', trim(fname)
           go to 1111
        end select

     case('scf.SpinPolarization')
        read(buf,*) tag, str
        select case(str)
        case('on','On','ON')
           Param%Option%spin_polar = .true.
           Param%Option%nspin  = 2
        case('off','Off','OFF')
           Param%Option%spin_polar = .false.
           Param%Option%nspin  = 1
        case default
           write(*,'(a,a)') &
                '# Error!: scf.SpinPolarization is broken in file ', trim(fname)
           go to 1111
        end select

     case('scf.cluster')
        read(buf,*) tag, str
        select case(str)
        case('on','On','ON')
           Param%Option%cluster = .true.
        case('off','Off','OFF')
           Param%Option%cluster = .false.
        case default
           write(*,'(a,a)') &
                '# Error!: scf.cluster is broken in file ', trim(fname)
           go to 1111
        end select

     case('scf.ElectronicTemperature')
        read(buf,*) tag, Param%SCF%Te
        Param%SCF%Te = Param%SCF%Te * KELVIN_TO_AU

     case('scf.energycutoff')
        read(buf,*) tag, Param%SCF%Ecutoff
        Param%SCF%Ecutoff = Param%SCF%ECUTOFF * RY_TO_AU

     case('scf.Kgrid')
        read(buf,*) tag, Param%SCF%Nka, Param%SCF%Nkb, Param%SCF%Nkc

     case('scf.Mixing.Type')
        read(buf,*) tag, str
        select case(str)
        case('simple','Simple')
           Param%SCF%mix_type = 'Simple'
           Param%SCF%mix_start = 0
           Param%SCF%mix_history = 1
        case('pulay','Pulay')
           Param%SCF%mix_type = 'Pulay'
        case('rmm-diis','Rmm-Diis','RMM-DIIS')
           Param%SCF%mix_type = 'Pulay'
        case('Anderson','anderson')
           Param%SCF%mix_type = 'Anderson'
           Param%SCF%mix_start = 0
           Param%SCF%mix_history = 3
        case default
           write(*,'(a,a)') '# Error!: scf.Mixing.Type is broken in file ', trim(fname)
           go to 1111
        end select

     case('scf.Init.Mixing.Weight')
        read(buf,*) tag, Param%SCF%mix_weight
     case('scf.Mixing.History')
        if( Param%SCF%mix_type /= 'Simple' .and. Param%SCF%mix_type /= 'Anderson' ) then
           read(buf,*) tag, Param%SCF%mix_history
        end if
     case('scf.Mixing.Start')
        if( Param%SCF%mix_type /= 'Simple' .and. Param%SCF%mix_type /= 'Anderson' ) then
           read(buf,*) tag, Param%SCF%mix_start
        end if

     case('scf.criterion.Type')
        read(buf,*) tag, str
        select case(str)
        case('fermi')
           Param%SCF%cri_type = 'fermi'
        case('orbital')
           Param%SCF%cri_type = 'orbital'
        case('total')
           Param%SCF%cri_type = 'total'
        case('density')
           Param%SCF%cri_type = 'density'
        case default
           write(*,'(a,a)') '# Error!: scf.criterion.Type is broken in file ', trim(fname)
           go to 1111
        end select

     case('scf.criterion')
        read(buf,*) tag, Param%SCF%criterion

     case('scf.maxIter')
        read(buf,*) tag, Param%SCF%iter_max

     case('1DFFT.NumGridK')
        read(buf,*) tag, Param%Integral1D%Nk

     case('1DFFT.NumGridR')
        read(buf,*) tag, Param%Integral1D%Nr

     case('1DFFT.EnergyCutoff')
        read(buf,*) tag, Param%Integral1D%Ecutoff
        Param%Integral1D%Ecutoff = Param%Integral1D%Ecutoff * RY_TO_AU

     case('Band.dispersion')
        read(buf,*) tag, str
        select case(str)
        case('on','On','ON')
           Param%Band%fname = trim(Param%name) // ".band.dat"
        case('off','Off','OFF')
           Param%Band%fname = ""
        case default
           write(*,'(a,a)') '# Error!: Band.dispersion is broken in file ', trim(fname)
           go to 1111

        end select

     case('<Band.KPath.UnitCell')
        read(iunit,'(a)') buf
        read(buf,*) Param%Band%La(:)

        read(iunit,'(a)') buf
        read(buf,*) Param%Band%Lb(:)

        read(iunit,'(a)') buf
        read(buf,*) Param%Band%Lc(:)

        Param%Band%La = Param%Band%La * CEL_TO_AU
        Param%Band%Lb = Param%Band%Lb * CEL_TO_AU
        Param%Band%Lc = Param%Band%Lc * CEL_TO_AU

        read(iunit,'(a)') buf

     case('Band.Nkpath')
        read(buf,*) tag, Param%Band%nKpath
        allocate( Param%Band%vKpath(Param%Band%nKpath) )

     case('<Band.kpath')

        do i=1, Param%Band%nKpath
           read(iunit,'(a)') buf
           read(buf,*) mesh, ks(:), ke(:)

           Param%Band%vKpath(i)%ks = ks(:)
           Param%Band%vKpath(i)%ke = ke(:)
           Param%Band%vKpath(i)%mesh = mesh
        end do
        read(iunit,'(a)') buf

     case('Dos.fileout')
        read(buf,*) tag, str
        select case(str)
        case('on','On','ON')
           Param%DOS%fname = trim(Param%name) // ".dos.dat"
        case('off','Off','OFF')
           Param%DOS%fname = ""

        case default
           write(*,'(a,a)') '# Error!: Dos.fileout is broken in file ', trim(fname)
           go to 1111

        end select


     case('Dos.Erange')
        read(buf,*) tag, Param%DOS%Emin, Param%DOS%Emax
        Param%DOS%Emin = Param%DOS%Emin * RY_TO_AU
        Param%DOS%Emax = Param%DOS%Emax * RY_TO_AU

     case('Dos.Egrid')
        read(buf,*) tag, Param%DOS%Ne

     case('Dos.Kgrid')
        read(buf,*) tag, Param%DOS%Nka, Param%DOS%Nkb, Param%DOS%Nkc

     case('Dos.method')
        read(buf,*) tag, str
        select case(str)
        case('boxes','histogram')
           Param%DOS%method = 'histogram'
        case('gaussian')
           Param%DOS%method = 'gaussian'
        case('tetrahedron')
           Param%DOS%method = 'tetrahedron'
        case default 
           write(*,'(a,a)') '# Error!: Dos.method is broken in file ', trim(fname)
           go to 1111
        end select

     case('Vh.fileout')
        read(buf,*) tag, str
        select case(str)
        case('on','On','ON')
           Param%Option%fname_rhoscf   = trim(Param%name) // ".density.scf" // trim(Param%Option%field_format)
        case('off','Off','OFF')
           Param%Option%fname_rhoscf   = ""
        case default
           write(*,'(a,a)') &
                '# Error!: Vh.fileout is broken in file ', trim(fname)
           go to 1111
        end select

     end select
  end do
100 continue

  close(iunit)

  return

1111 continue ! error_block

  close(iunit)
  stop

end subroutine Param__readMX


subroutine Element__readPAO_adpack( elem, name, fname, mode, mode2 )
  use ac_misc_module

  implicit none
  type(Element_type), intent(out)   :: elem
  character(len=*), intent(in) :: name
  character(len=*), intent(in) :: fname
  character(len=*), intent(in) :: mode
  character(len=*), intent(in) :: mode2

  integer        :: iunit
  logical        :: ex
  character(256) :: buf, tag

  real(8)  :: Rc
  integer        :: nr
  real(8), allocatable :: vr(:)
  integer, parameter :: npaoLmax=3 ! F orbital
  integer, parameter :: npao2Lmax=6 ! I orbital
  integer        :: npaoL (0:npaoLmax)
  integer        :: ipaoL (0:npaoLmax)
  integer        :: npao2L(0:npao2Lmax)
  integer        :: ipao2L(0:npao2Lmax)
  real(8)  :: logr
  real(8)  :: R(10)
  character(32) :: dummy
  character(1024) :: msg
  integer        :: i, l, n
  integer        :: maxLpao, numpao

  elem%name = name

  inquire( file=fname, exist=ex )
  if( .not. ex ) then
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,999) trim(fname)
999  format('      ++++++ Error! readPAO/ can not open file: ',a)
     close(16)
     !!     write(*,'(a,a)') '# Error!: Element::readPAO : can not open file ', fname 
     stop
  end if

  iunit=2
  open(iunit,file=fname)

  Rc = 0.d0
  nr = 0

  do 
     read(iunit,'(a)',end=100) buf
     if( buf=='' ) cycle
     read(buf,*) tag

     select case(tag)
     case('#')
     case('grid.num.output')
        read(buf,*) tag, nr
     case('maxL.pao')
        read(buf,*) tag, maxLpao
     case('num.pao')
        read(buf,*) tag, numpao

     case('radial.cutoff.pao')
        read(buf,*) tag, Rc
     end select

     if( nr /= 0 .and. Rc /= 0.d0 ) exit
  end do
100 continue

  if( nr == 0 ) then
     msg = "grid.num.output is not given"
     goto 1111
  end if
  if( Rc == 0.d0 ) then
     msg = "radial.cutoff is not given"
     goto 1111
  end if

  allocate( vr(nr) )

  do l=0, npaoLmax
     npaoL(l) = 0
  end do

  if( mode == "" ) then
     do l = 0, maxLpao
        npaoL(l) = numpao
     end do
  else if( mode(1:1) /= 's' ) then
     if( len_trim(mode) == 1 ) then
        npaoL(0) = numpao
     else
        read(mode(2:2),*) npao2L(0)
     end if

     select case( mode(1:1) )
     case('p')
        npaoL(1:1) = npaoL(0)
     case('d')
        npaoL(1:2) = npaoL(0)
     case('f')
        npaoL(1:3) = npaoL(0)
     end select
  else
     do i=1, len_trim(mode), 2
        select case( mode(i:i) )
        case('s')
           read( mode(i+1:i+1), * ) npaoL(0)
        case('p')
           read( mode(i+1:i+1), * ) npaoL(1)
        case('d')
           read( mode(i+1:i+1), * ) npaoL(2)
        case('f')
           read( mode(i+1:i+1), * ) npaoL(3)
        end select
     end do
  end if

  do l=0, npaoLmax
     if( npaoL(l) > numpao ) then
        open(unit=16,file=Param%Option%file_ac_tempout,position='append')
        write(16,*) '      ++++++ Warning!: too many radial PAO bases requested for band calculations. Reduced to', numpao
        close(16)
        !    write(*,'(a,i2)') '# Warning!: too many radial PAO bases requested for band calculations. Reduced to', numpao
        npaoL(l) = numpao
     end if
  end do

  do l=0, npao2Lmax
     npao2L(l)=0
  end do

  if( mode2 == "" ) then
     do l = 0, npao2Lmax
        npao2L(l) = numpao
     end do
  else if( mode2(1:1) /= 's' ) then
     if( len_trim(mode2) == 1 ) then
        npao2L(0) = numpao
     else
        read(mode2(2:2),*) npao2L(0)
     end if

     select case( mode2(1:1) )
     case('p')
        npao2L(1:1) = npao2L(0)
     case('d')
        npao2L(1:2) = npao2L(0)
     case('f')
        npao2L(1:3) = npao2L(0)
     case('g')
        npao2L(1:4) = npao2L(0)
     case('h')
        npao2L(1:5) = npao2L(0)
     case('i')
        npao2L(1:6) = npao2L(0)
     end select
  else
     do i=1, len_trim(mode2), 2
        select case( mode2(i:i) )
        case('s')
           read( mode2(i+1:i+1), * ) npao2L(0)
        case('p')
           read( mode2(i+1:i+1), * ) npao2L(1)
        case('d')
           read( mode2(i+1:i+1), * ) npao2L(2)
        case('f')
           read( mode2(i+1:i+1), * ) npao2L(3)
        case('g')
           read( mode2(i+1:i+1), * ) npao2L(4)
        case('h')
           read( mode2(i+1:i+1), * ) npao2L(5)
        case('i')
           read( mode2(i+1:i+1), * ) npao2L(6)
        end select
     end do
  end if

  do l=0, npao2Lmax
     if( npao2L(l) > numpao ) then
        open(unit=16,file=Param%Option%file_ac_tempout,position='append')
        write(16,*) '      ++++++ Warning!: too many radial PAO bases requested for projection. Reduced to', numpao
        close(16)
        ! write(*,'(a,i2)') '# Warning!: too many radial PAO bases requested for projection. Reduced to', numpao
        npao2L(l) = numpao
     end if
  end do

  elem%npao=0
  do l=0, npaoLmax
     ipaoL(l) = elem%npao+1
     elem%npao = elem%npao + npaoL(l)
  end do
  elem%npao2=0
  do l=0, npao2Lmax
     ipao2L(l) = elem%npao2+1
     elem%npao2 = elem%npao2 + npao2L(l)
  end do

  allocate(elem%vpao(elem%npao))

  if( Param%Option%projection ) then
     allocate(elem%vpao2(elem%npao2))
     allocate(elem%vpao2bar(elem%npao2))
  end if

  do
     read(iunit,'(a)',end=200) buf

     if(buf=='') cycle
     if(buf=='#') cycle
     read(buf,*) tag

     select case(tag)
     case('<valence.charge.density')
        elem%rhoval%l  = 0
        elem%rhoval%Rc = Rc
        allocate( elem%rhoval%vR(nr) )

        do i=1, nr
           read(iunit,'(a)') buf
           read(buf,*) logr, dummy, elem%rhoval%vR(i)
           if( dummy == dummy ) then ! to suppress a warning
           endif

           vr(i) = exp(logr)
        end do
        read(iunit,'(a)') buf

        call RadialFunc__set(elem%rhoval, vr, nr)

     case('<pseudo.atomic.orbitals.L=0', '<pseudo.atomic.orbitals.L=1', &
          '<pseudo.atomic.orbitals.L=2', '<pseudo.atomic.orbitals.L=3')
        select case(tag)
        case('<pseudo.atomic.orbitals.L=0')
           l = 0
        case('<pseudo.atomic.orbitals.L=1')
           l = 1
        case('<pseudo.atomic.orbitals.L=2')
           l = 2
        case('<pseudo.atomic.orbitals.L=3')
           l = 3
        end select

        if( npaoL(l)>0 ) then
           do n=1, npaoL(l)
              elem%vpao(ipaoL(l)+n-1)%l  = l
              elem%vpao(ipaoL(l)+n-1)%Rc = Rc
              allocate( elem%vpao(ipaoL(l)+n-1)%vR(nr) )
           end do
        end if

        if( npao2L(l)>0 .and. Param%Option%projection ) then
           do n=1, npao2L(l)
              elem%vpao2(ipao2L(l)+n-1)%l  = l
              elem%vpao2(ipao2L(l)+n-1)%Rc = Rc
              allocate( elem%vpao2(ipao2L(l)+n-1)%vR(nr) )

              elem%vpao2bar(ipao2L(l)+n-1)%l  = l
              elem%vpao2bar(ipao2L(l)+n-1)%Rc = Rc
              allocate( elem%vpao2bar(ipao2L(l)+n-1)%vR(nr) )
           end do
        end if

        if( npaoL(l)>0 .or. npao2L(l)>0 ) then
           do i=1, nr
              read(iunit,'(a)') buf
              read(buf,*) dummy, dummy, R(1:max(npaoL(l),npao2L(l)))

              do n=1, npaoL(l)
                 elem%vpao(ipaoL(l)+n-1)%vR(i) = R(n)
              end do

              if( Param%Option%projection ) then
                 do n=1, npao2L(l)
                    elem%vpao2(ipao2L(l)+n-1)%vR(i) = R(n)
                 end do
              end if
           end do

           read(iunit,'(a)') buf
        end if

        if( npaoL(l)>0 ) then
           do n=1, npaoL(l)
              call RadialFunc__set(elem%vpao(ipaoL(l)+n-1), vr, nr)
           end do
        end if

        if( npao2L(l)>0 .and. Param%Option%projection ) then
           do n=1, npao2L(l)
              call RadialFunc__set(elem%vpao2(ipao2L(l)+n-1), vr, nr)
           end do
        end if

     end select
  end do

200 continue


  if( Param%Option%projection ) then
     do l = maxLpao+1, npao2Lmax
        if( npao2L(l) == 0 ) cycle

        do n=1, npao2L(l)
           elem%vpao2(ipao2L(l)+n-1)%l  = l
           elem%vpao2(ipao2L(l)+n-1)%Rc = Rc
           allocate( elem%vpao2(ipao2L(l)+n-1)%vR(nr) )

           elem%vpao2bar(ipao2L(l)+n-1)%l  = l
           elem%vpao2bar(ipao2L(l)+n-1)%Rc = Rc
           allocate( elem%vpao2bar(ipao2L(l)+n-1)%vR(nr) )
        end do

        do n=1, npao2L(l)
           do i=1, nr
              elem%vpao2(ipao2L(l)+n-1)%vR(i) = &
                   vr(i)**(l-maxLpao) * elem%vpao2(ipao2L(maxLpao)+n-1)%vR(i)
           end do
        end do

        do n=1, npao2L(l)
           call RadialFunc__set(elem%vpao2(ipao2L(l)+n-1), vr, nr)
        end do
     end do
  end if

  if(allocated(vr)) deallocate(vr)

  if( .not. associated(elem%rhoval%vR) ) then
     msg = "valence.charge.density is not given"
     goto 1111
  end if

  do n=1, elem%npao
     if( .not. associated(elem%vpao(n)%vR) ) then
        msg = "pseudo.atomic.orbitals is not given"
        goto 1111
     endif
  end do

  close(iunit)
  return

1111 continue ! error_block
  close(iunit)

  write(*,'(a,a,a)') '# Error! : PAO data ', msg, fname
  !  write(*,'(a,a,a)') '# Error! : PAO data ', msg, fname
  open(unit=16,file=Param%Option%file_ac_tempout,position='append')
  write(16,998) msg,fname
998 format('      ++++++ Error! PAO data: ',a,a)
  close(16)
  stop

end subroutine Element__readPAO_adpack


subroutine Element__readVPS_adpack( elem, name, fname )
  use ac_misc_module

  implicit none
  type(Element_type), intent(out)   :: elem
  character(len=*), intent(in) :: name
  character(len=*), intent(in) :: fname

  integer         :: iunit
  logical         :: ex
  character(1024) :: buf
  character(32)   :: tag

  real(8)  :: Q
  real(8)  :: Rc
  integer        :: nr
  real(8), allocatable :: vr(:)
  real(8)  :: logr
  real(8)  :: vnon(2,12)
  character(8)   :: str
  character(32) :: dummy
  character(1024) :: msg
  integer        :: i, n

  elem%name = name

  inquire(file=fname,exist=ex)
  if( .not. ex ) then
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,999) trim(fname)
999  format('      ++++++ Error! readVPS/ can not open file: ',a)
     close(16)
     !!     write(*,'(a,a)') '# Error!: Element::readVPS : can not open file ', fname 
     stop
  end if

  iunit = 3
  open(iunit,file=fname)

  Q  = 0.d0
  Rc = 0.d0
  nr = 0

  elem%pcc = .false.
  elem%nVnon = -1

  do 
     read(iunit,'(a)',end=100) buf
     if( buf=='') cycle
     if( buf=='#') cycle
     read(buf,*) tag

     select case(tag)
     case('eq.type')
        read(buf,*) tag, str
        select case(str)
        case('dirac2')
           elem%dirac = .true.
        case('sch')
           elem%dirac = .false.
        case default
           elem%dirac = .false.
        end select
     case('AtomSpecies')
        read(buf,*) tag, elem%atomic_number
     case('valence.electron')
        read(buf,*) tag, Q
     case('grid.num.output')
        read(buf,*) tag, nr
     case('local.cutoff')
        read(buf,*) tag, Rc
     case('charge.pcc.calc')
        read(buf,*) tag, str
        if( str == 'on' .or. str == 'On' .or. str == 'ON' ) then
           elem%pcc = .true.
        else
           elem%pcc = .false.
        end if

        if( .not. Rc == 0.d0 ) exit
     case('radial.cutoff.pao')
        if( Rc == 0.d0 ) then
           read(buf,*) tag, Rc
        end if
        exit
     end select

  end do
100 continue

  if( nr == 0 ) then
     msg = 'Parameter grid.num.output is not given'
     go to 1111
  end if
  if( Rc == 0.d0 ) then
     msg = 'Parameter local.cutoff is not given'
     go to 1111
  end if
  if( Q  == 0.d0 ) then
     msg = 'Parameter valence.electron is not given'
     go to 1111
  end if

  allocate( vr(nr) )

  do 
     read(iunit,'(a)',end=200) buf

     if( buf=='') cycle
     if( buf=='#') cycle
     read(buf,*) tag

     select case(tag)
     case('num.projector')
        read(buf,*) tag, elem%nVnon

     case('<project.energies','<projection.energies')
        select case(tag)
        case('<project.energies')
           if( elem%nVnon == -1 ) then
              read(iunit,'(a)',end=200) buf
              read(buf,*) elem%nVnon
           end if
           if( elem%nVnon == -1 ) then
              msg = 'project.energies is broken or num.projector is not given'
              go to 1111
           end if

        case('<projection.energies')
           if( elem%nVnon == -1 ) then
              msg = 'Parameter num.projector is not given'
              go to 1111
           end if

        end select

        if( elem%nVnon>0 ) then
           if( elem%dirac ) then
              allocate(elem%vVnon(elem%nVnon,2))
           else
              allocate(elem%vVnon(elem%nVnon,1))
           end if

           elem%vVnon(:,:)%l = 0
           elem%vVnon(:,:)%Q = 0.0
        end if

        if( elem%nVnon>0 ) then
           do n=1, elem%nVnon
              read(iunit,'(a)') buf
              if( elem%dirac ) then
                 read(buf,*) elem%vVnon(n,1)%l, elem%vVnon(n,1:2)%Q
                 elem%vVnon(n,2)%l = elem%vVnon(n,1)%l
              else
                 read(buf,*) elem%vVnon(n,1)%l, elem%vVnon(n,1)%Q
              end if
           end do
        end if
        read(iunit,'(a)') buf

     case('<Pseudo.Potentials')
        elem%Vloc%l  = 0
        elem%Vloc%Q  = -Q
        elem%Vloc%Rc = Rc
        allocate( elem%Vloc%vR(nr) )

        do n=1, elem%nVnon
           if( elem%dirac ) then
              elem%vVnon(n,1)%Rc = Rc
              allocate(elem%vVnon(n,1)%vR(nr))
              elem%vVnon(n,2)%Rc = Rc
              allocate(elem%vVnon(n,2)%vR(nr))
           else
              elem%vVnon(n,1)%Rc = Rc
              allocate(elem%vVnon(n,1)%vR(nr))
           end if
        end do

        do i=1, nr
           read(iunit,'(a)') buf

           if( elem%dirac ) then
              read(buf,*) logr, dummy, elem%Vloc%vR(i), vnon(1:2,1:elem%nVnon)
              do n=1, elem%nVnon
                 elem%vVnon(n,1)%vR(i) = vnon(1,n)
                 elem%vVnon(n,2)%vR(i) = vnon(2,n)
              end do
           else
              read(buf,*) logr, dummy, elem%Vloc%vR(i), vnon(1,1:elem%nVnon)
              do n=1, elem%nVnon
                 elem%vVnon(n,1)%vR(i) = vnon(1,n)
              end do
           end if

           vr(i) = exp(logr)
           if( i<4 ) then
              write(*,*) i, vr(i), elem%Vloc%vR(i)
           end if

           if( dummy == dummy ) then ! to suppress a warning
           endif
        end do

        read(iunit,'(a)') buf

        call RadialFunc__set( elem%Vloc, vr, nr )
        do n=1, elem%nVnon
           if( elem%dirac ) then
              call RadialFunc__set( elem%vVnon(n,1), vr, nr )
              call RadialFunc__set( elem%vVnon(n,2), vr, nr )
           else
              call RadialFunc__set( elem%vVnon(n,1), vr, nr )
           end if
        end do

     case('<density.PCC')
        if( elem%pcc ) then
           elem%rhopcc%l  = 0
           elem%rhopcc%Rc = elem%vpao(1)%Rc ! use PAO's cutoff instead
           allocate( elem%rhopcc%vR(nr) )

           do i=1, nr
              read(iunit,'(a)') buf
              read(buf,*) dummy, dummy, elem%rhopcc%vR(i) 
           end do
           read(iunit,'(a)') buf

           call RadialFunc__set( elem%rhopcc, vr, nr )
        end if
     end select
  end do
200 continue

  if(allocated(vr)) deallocate(vr)

  if( .not. associated(elem%Vloc%vR) ) then
     msg = "Pseudo.Potentials is not given"
     goto 1111
  end if

  do n=1, elem%nVnon
     if( .not. associated(elem%vVnon(n,1)%vR) ) then
        msg = "Pseudo.Potentials is not given"
        goto 1111
     end if
  end do

  if( elem%pcc .and. (.not. associated(elem%rhopcc%vR)) ) then
     msg = "density.PCC not given"
     goto 1111
  end if

  close(iunit)
  return

1111 continue ! error_block
  close(iunit)

  open(unit=16,file=Param%Option%file_ac_tempout,position='append')
  write(16,998) msg,fname 
998 format(' +++++++ Error! VPS data: ',a,a)
  close(16)
  !  write(*,'(a,a,a)') '# Error! : VPS data ', msg, fname
  stop

end subroutine Element__readVPS_adpack

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

module dft

  implicit none
  real(8), pointer :: r_tem(:,:),p_tem(:,:),r_tem_z(:,:),p_tem_z(:,:)
  complex(8), pointer :: fft_in(:),fft_out(:),fft_in_z(:),fft_out_z(:)

contains
  subroutine alo_dft(n_a,n_b,i_dim)

    implicit none
    integer, intent(in) :: n_a,n_b,i_dim
    integer :: i_temp,ier

    i_temp=n_a*n_b
    allocate(fft_in(i_temp),fft_out(i_temp)                                      &
         ,r_tem(i_dim,i_temp),p_tem(i_dim,i_temp),stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_dft'
       stop
    end if

    return
  end subroutine alo_dft

  subroutine unset_dft

    implicit none
    integer :: ier

    deallocate(fft_in,fft_out,r_tem,p_tem,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error deallocate: unset_dft'
       stop
    end if

    return
  end subroutine unset_dft

  subroutine alo_dft_z(n_c)

    implicit none
    integer, intent(in) :: n_c
    integer :: ier

    allocate(fft_in_z(n_c),fft_out_z(n_c)                                        &
         ,r_tem_z(1,n_c),p_tem_z(1,n_c),stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_dft'
       stop
    end if

    return
  end subroutine alo_dft_z

  subroutine unset_dft_z

    implicit none
    integer :: ier

    deallocate(fft_in_z,fft_out_z,r_tem_z,p_tem_z,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error deallocate: unset_dft'
       stop
    end if

    return
  end subroutine unset_dft_z
end module dft

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

module scf_negf

  implicit none
  character(50) :: file_parameter_hc_scf
  character(50) :: file_parameter_hl_scf
  character(50) :: file_parameter_hr_scf
  character(50) :: file_parameter_lv1_scf
  character(50) :: file_parameter_lv2_scf
  character(50) :: file_parameter_rv1_scf
  character(50) :: file_parameter_rv2_scf
  character(50) :: file_parameter_cv1_pot
  character(50) :: file_parameter_ham_pot
  character(50) :: file_parameter_out_scf
  character(50) :: file_parameter_out_pot
  character(50) :: filecalc_onoff
  character(50) :: file_parameter_out_vh0

  integer :: num_atom_scf,numc_atom_scf,numl_atom_scf,numr_atom_scf
  integer :: nelem_num,num_cell_l,xc_type
  integer :: ispin_pol_scf,ispin_pol_scf_l,ispin_pol_scf_r
  integer :: i_rotspin_l,i_rotspin_r,shift_cell_l1,shift_cell_l2
  integer, pointer :: iatom_orb_num(:)

  integer :: method_sum_om_scf
  integer :: om_block_num_scf
  integer, pointer :: num_om_par_scf(:,:)
  real(8), pointer :: omega_if_scf(:,:)
  character(50), pointer :: om_con_method_scf(:)

  integer :: i_total_omega
  integer, pointer :: i_bios_omega_scf(:)
  complex(8), pointer :: omega_scf(:),omega_weight_scf(:)

  character(50) :: file_selfenergy_onoff
  character(50) :: file_selfenergy_scf
  character(50) :: restart_onoff
  character(50) :: ft_switch
  character(50) :: intp_switch

  real(8), pointer :: dens(:,:,:),dens2(:,:,:)
  real(8), pointer :: edens(:,:,:),edens2(:,:,:)
  real(8), pointer :: rho(:,:),rho_temp(:,:)
  complex(8), pointer :: rhols(:,:),rhols_temp(:,:)
  complex(8), pointer :: h_cc_scf(:,:,:),s_cc_scf(:,:)
  integer, pointer :: i_atom_num(:),i_atom_invnum(:),i_orb(:)

  real(8) :: eps_scf,eps_scf_cal,mixing,mixing_rho,mixing_max,mixing_vto
  integer :: max_num_scf,iter_conv,iter_mm

  character(50) :: gra_onoff

  integer :: n_a,n_b,n_c
  integer :: l_cell_l_bound,r_cell_l_bound,r_cell_l_bound_num,c_num_cell_l
  real(8), pointer :: cell_labc(:,:),cell_dkabc(:,:)
  real(8), pointer :: vh_l(:),v0_l(:,:),vh_r(:),v0_r(:,:)
  real(8), pointer :: cell_lr(:,:),cell_lr_z(:)
  real(8), pointer :: r_cell_dk(:,:),cell_dlabc(:,:),g2_temp(:)

  real(8), pointer :: den_l(:,:),den_r(:,:)
  complex(8), pointer :: denls_l(:,:),denls_r(:,:)
  complex(8), pointer :: dens_temp_l(:),dens_temp_r(:)
  integer :: hartree_switch

  real(8), pointer :: vh_temp_l(:),vh_temp_r(:)
  real(8), pointer :: v_hartree(:),v_tot(:,:),v_tot_temp(:,:),green(:,:,:)
  complex(8), pointer :: vh_l_f(:),vh_r_f(:),rho_f(:),del2_z(:)
  complex(8), pointer :: vh_temp(:)
  real(8) :: del_cell_l
  complex(8) :: v0_a,v0_b

  real(8), pointer :: v_xc(:),v_ext(:),rhoval(:),rhopcc(:)
  real(8), pointer :: h0(:,:,:,:),h0_accel(:,:,:)

  integer :: i_gzero_method
  real(8) :: gzero_gamma

  real(8) :: cp_scf_l,cp_scf_r,v_scf_l,v_scf_r
  real(8) :: om_im_bias,om_del_bias
  character(50) :: scf_bias
  integer :: num_om_bias

  real(8), pointer :: cell_labc_l(:,:),cell_labc_r(:,:)
  real(8) :: res_bound_l,res_bound_r,del_bound_l,del_bound_r
  integer :: n_a_l,n_b_l,n_c_l
  integer :: n_a_r,n_b_r,n_c_r
  integer :: l_cell_l_bound_l,r_cell_l_bound_r

  integer :: cutene_vt_swi
  real(8) :: cutene_vt_val

  real(8), pointer :: v_tot_l(:,:),v_tot_r(:,:)
  integer :: atom_parlay_l,atom_parlay_r,lay_shift_l,lay_shift_r
  character(50) :: ene_c_shift_swi
  real(8) :: ene_c_shift_val

  real(8), pointer :: omega_gamm(:),omega_tem(:)

  complex(8), pointer :: boucon_l(:),boucon_r(:)

  real(8), pointer :: cell_lo(:),vatom_q(:),atom_rcut(:)
  real(8), pointer :: atom_ro(:,:),sum_charge(:)
  integer, pointer :: atom_name_num(:)
  character(5), pointer :: atom_name(:)
  character(50) :: dis_chara,lay_chara

  real(8) :: min_level_l,min_level_c,min_level_r,cp_scf_c

  integer :: base_npao,param_cell_nl

  integer :: n_v_atom_matrix,n_v_nim_max
  integer, pointer :: hv_atom_matrix(:,:,:)

  real(8) :: tot_ele_num
  real(8) :: mixing_dm,mixing_dm_s
  integer :: negf_mix_history,negf_mix_start

  integer :: ka_scf,kb_scf,kt_num
  integer, pointer :: ksw_po_kt_scf(:)
  real(8), pointer :: po_kt_scf(:,:)
  real(8), pointer :: po_ka_scf(:,:),po_kb_scf(:,:)
  real(8), pointer :: param_cell_vl(:,:)

  character(50) :: force_calc_onoff
  character(50) :: param_option_projection
  character(50) :: sw_shift_chem

contains
  subroutine alo_scf_negf_kpoint

    implicit none
    integer :: ier

    allocate(po_ka_scf(3,ka_scf),po_kb_scf(3,kb_scf)                             &
         ,po_kt_scf(3,ka_scf*kb_scf),ksw_po_kt_scf(ka_scf*kb_scf),stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_scf_negf_kpoint'
       stop
    end if

    return
  end subroutine alo_scf_negf_kpoint

  subroutine alo_scf_negf_parameter_1

    implicit none
    integer :: ier

    allocate(cell_labc(3,3),cell_dkabc(3,3)                                      &
         ,atom_name(num_atom_scf),atom_name_num(num_atom_scf)                 &
         ,cell_lo(3),vatom_q(num_atom_scf)                                    &
         ,atom_rcut(num_atom_scf),atom_ro(num_atom_scf,3)                     &
         ,sum_charge(num_atom_scf),iatom_orb_num(num_atom_scf),stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_scf_negf_parameter_1'
       stop
    end if

    return
  end subroutine alo_scf_negf_parameter_1

  subroutine alo_scf_negf_parameter_11

    implicit none
    integer :: ier

    allocate(param_cell_vl(param_cell_nl,3),stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_scf_negf_parameter_1'
       stop
    end if

    return
  end subroutine alo_scf_negf_parameter_11

  subroutine alo_scf_accel_parameter

    implicit none
    integer :: ier

    allocate(i_orb(num_atom_scf+1),v_ext(num_cell_l)                             &
         ,rhoval(num_cell_l)                                                  &
         ,rhopcc(num_cell_l)                                                  &
         ,v_hartree(num_cell_l)                                               &
         ,i_atom_num(num_atom_scf),i_atom_invnum(num_atom_scf)                &
         ,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_scf_accel_parameter_3'
       stop
    end if

    if( ispin_pol_scf < 4 ) then
       allocate(rho_temp(num_cell_l,ispin_pol_scf),stat=ier)
       if( ier /= 0 ) then
          write(6,*) 'error allocate: alo_scf_accel_parameter_31'
          stop
       end if
    else
       allocate(rhols_temp(num_cell_l,ispin_pol_scf),stat=ier)
       if( ier /= 0 ) then
          write(6,*) 'error allocate: alo_scf_accel_parameter_31'
          stop
       end if
    end if

    return
  end subroutine alo_scf_accel_parameter

  subroutine alo_scf_negf_omega1

    implicit none
    integer :: ier

    allocate(num_om_par_scf(om_block_num_scf,3),omega_if_scf(om_block_num_scf,4) &
         ,om_con_method_scf(om_block_num_scf),omega_gamm(om_block_num_scf)    &
         ,omega_tem(om_block_num_scf),stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_scf_negf_omega1'
       stop
    end if

    return
  end subroutine alo_scf_negf_omega1

  subroutine alo_scf_negf_omega2

    implicit none
    integer :: ier

    allocate(omega_scf(i_total_omega),omega_weight_scf(i_total_omega)            &
         ,i_bios_omega_scf(i_total_omega),stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_scf_negf_omega2'
       stop
    end if

    return
  end subroutine alo_scf_negf_omega2

  subroutine alo_potential

    implicit none
    integer :: ier

    allocate(cell_lr(3,n_a*n_b*n_c),r_cell_dk(3,n_a*n_b)                         &
         ,cell_dlabc(3,3),v_tot(n_a*n_b*n_c,ispin_pol_scf)                    &
         ,g2_temp(n_a*n_b*n_c),cell_lr_z(n_c+1),stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_density'
       stop
    end if

    return
  end subroutine alo_potential

  subroutine alo_potential_l

    implicit none
    integer :: ier

    allocate(vh_l(n_a_l*n_b_l),v0_l(n_a_l*n_b_l,ispin_pol_scf_l)                 &
         ,dens_temp_l(n_a_l*n_b_l)                                            &
         ,v_tot_l(n_a_l*n_b_l*n_c_l,ispin_pol_scf_l)                          &
         ,vh_temp_l(n_a_l*n_b_l*n_c_l)                                        &
         ,vh_l_f(n_a*n_b),cell_labc_l(3,3),stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_density'
       stop
    end if

    if( ispin_pol_scf_l < 4 ) then
       allocate(den_l(n_a_l*n_b_l*n_c_l,ispin_pol_scf_l),stat=ier)
       if( ier /= 0 ) then
          write(6,*) 'error allocate: alo_density1'
          stop
       end if
    else
       allocate(denls_l(n_a_l*n_b_l*n_c_l,ispin_pol_scf_l),stat=ier)
       if( ier /= 0 ) then
          write(6,*) 'error allocate: alo_density1'
          stop
       end if
    end if

    return
  end subroutine alo_potential_l

  subroutine alo_potential_r

    implicit none
    integer :: ier

    allocate(vh_r(n_a_r*n_b_r),v0_r(n_a_r*n_b_r,ispin_pol_scf_r)                 &
         ,dens_temp_r(n_a_r*n_b_r)                                            &
         ,v_tot_r(n_a_r*n_b_r*n_c_r,ispin_pol_scf_r)                          &
         ,vh_temp_r(n_a_r*n_b_r*n_c_r)                                        &
         ,vh_r_f(n_a*n_b),cell_labc_r(3,3),stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_density'
       stop
    end if

    if( ispin_pol_scf_r < 4 ) then
       allocate(den_r(n_a_r*n_b_r*n_c_r,ispin_pol_scf_r),stat=ier)
       if( ier /= 0 ) then
          write(6,*) 'error allocate: alo_density1'
          stop
       end if
    else
       allocate(denls_r(n_a_r*n_b_r*n_c_r,ispin_pol_scf_r),stat=ier)
       if( ier /= 0 ) then
          write(6,*) 'error allocate: alo_density1'
          stop
       end if
    end if

    return
  end subroutine alo_potential_r

  subroutine unset_scf_accel_parameter

    implicit none
    integer :: ier

    deallocate(num_om_par_scf,omega_if_scf,om_con_method_scf                     &
         ,omega_scf,omega_weight_scf,v_tot,i_bios_omega_scf                 &
         ,vh_l,v0_l,vh_r,v0_r,vh_l_f,vh_r_f,v_ext,rhoval                    &
         ,cell_labc,cell_dkabc,cell_lr,r_cell_dk,cell_dlabc                 &
         ,rhopcc,cell_lr_z,dens_temp_l,dens_temp_r,v_tot_l,v_tot_r          &
         ,v_hartree,vh_temp_l,vh_temp_r,cell_lo,vatom_q,atom_rcut           &
         ,atom_ro,atom_name_num,atom_name,sum_charge,i_atom_num             &
         ,i_atom_invnum,po_ka_scf,po_kb_scf,po_kt_scf,ksw_po_kt_scf         &
         ,param_cell_vl,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error deallocate: unset_ham_parameter'
       stop
    end if

    if( ispin_pol_scf < 4 ) then
       deallocate(rho_temp,stat=ier)
       if( ier /= 0 ) then
          write(6,*) 'error deallocate: unset_ham_parameter_c'
          stop
       end if
    else
       deallocate(rhols_temp,stat=ier)
       if( ier /= 0 ) then
          write(6,*) 'error deallocate: unset_ham_parameter_c'
          stop
       end if
    end if

    if( ispin_pol_scf_l < 4 ) then
       deallocate(den_l,stat=ier)
       if( ier /= 0 ) then
          write(6,*) 'error deallocate: unset_ham_parameter_l'
          stop
       end if
    else
       deallocate(denls_l,stat=ier)
       if( ier /= 0 ) then
          write(6,*) 'error deallocate: unset_ham_parameter_l'
          stop
       end if
    end if

    if( ispin_pol_scf_r < 4 ) then
       deallocate(den_r,stat=ier)
       if( ier /= 0 ) then
          write(6,*) 'error deallocate: unset_ham_parameter_r'
          stop
       end if
    else
       deallocate(denls_r,stat=ier)
       if( ier /= 0 ) then
          write(6,*) 'error deallocate: unset_ham_parameter_r'
          stop
       end if
    end if

    return
  end subroutine unset_scf_accel_parameter

  subroutine unset_scf_accel_parameter1

    implicit none
    integer :: ier

    deallocate(i_orb,iatom_orb_num,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error deallocate: unset_ham_parameter'
       stop
    end if

    return
  end subroutine unset_scf_accel_parameter1

  subroutine alo_use_scf_3(m_mat_max_c)

    implicit none
    integer, intent(in) :: m_mat_max_c
    integer :: i1_do,i2_do,i3_do,ier

    allocate(v_tot_temp(n_a*n_b*n_c,ispin_pol_scf)                               &
         ,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_density'
       stop
    end if

    do i2_do=1,ispin_pol_scf
       do i1_do=1,n_a*n_b*n_c
          v_tot_temp(i1_do,i2_do)=v_tot(i1_do,i2_do)
       end do
    end do

    return
  end subroutine alo_use_scf_3

  subroutine unset_use_scf_32

    implicit none
    integer :: ier

    deallocate(v_tot_temp,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error deallocate: unset_ham_parameter'
       stop
    end if

    return
  end subroutine unset_use_scf_32

  subroutine alo_use_scf_4

    implicit none
    integer :: ier

    allocate(boucon_l(n_a*n_b),boucon_r(n_a*n_b),stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_density'
       stop
    end if

    return
  end subroutine alo_use_scf_4

  subroutine unset_use_scf_4

    implicit none
    integer :: ier

    deallocate(boucon_l,boucon_r,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error deallocate: unset_ham_parameter'
       stop
    end if

    return
  end subroutine unset_use_scf_4

  subroutine alo_density_1(m_mat_max_c)

    implicit none
    integer, intent(in) :: m_mat_max_c
    integer :: i1_do,i2_do,i3_do,ier,ic_spin

    if( ispin_pol_scf == 2 ) then
       ic_spin=2
    else
       ic_spin=1
    end if

    allocate(dens(ic_spin,m_mat_max_c,m_mat_max_c)                               &
         ,dens2(ic_spin,m_mat_max_c,m_mat_max_c)                              &
         ,edens(ic_spin,m_mat_max_c,m_mat_max_c)                              &
         ,edens2(ic_spin,m_mat_max_c,m_mat_max_c),stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_density'
       stop
    end if

    return
  end subroutine alo_density_1

  subroutine alo_density_2

    implicit none
    integer :: i1_do,ier

    allocate(rho_f(num_cell_l),del2_z(n_c+1),stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_density'
       stop
    end if

    do i1_do=1,n_c+1
       del2_z(i1_do)=dcmplx(0.d0,0.d0)
    end do

    return
  end subroutine alo_density_2

  subroutine unset_density_1

    implicit none
    integer :: ier

    deallocate(dens,dens2,edens,edens2,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error deallocate: unset_ham_parameter'
       stop
    end if

    return
  end subroutine unset_density_1

  subroutine unset_density_21

    implicit none
    integer :: ier

    deallocate(rho_f,del2_z,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error deallocate: unset_ham_parameter'
       stop
    end if

    return
  end subroutine unset_density_21

  subroutine alo_density_ini

    implicit none
    integer :: i1_do,i2_do,ier

    if( ispin_pol_scf < 4 ) then
       allocate(rho(num_cell_l,ispin_pol_scf),stat=ier)
       if( ier /= 0 ) then
          write(6,*) 'error allocate: alo_density'
          stop
       end if
       do i1_do=1,ispin_pol_scf
          do i2_do=1,num_cell_l
             rho(i2_do,i1_do)=rho_temp(i2_do,i1_do)
          end do
       end do
    else
       allocate(rhols(num_cell_l,ispin_pol_scf),stat=ier)
       if( ier /= 0 ) then
          write(6,*) 'error allocate: alo_density'
          stop
       end if
       do i1_do=1,ispin_pol_scf
          do i2_do=1,num_cell_l
             rhols(i2_do,i1_do)=rhols_temp(i2_do,i1_do)
          end do
       end do
    end if

    return
  end subroutine alo_density_ini

  subroutine unset_density_ini

    implicit none
    integer :: ier

    if( ispin_pol_scf < 4 ) then
       deallocate(rho,stat=ier)
       if( ier /= 0 ) then
          write(6,*) 'error deallocate: unset_ham_parameter'
          stop
       end if
    else
       deallocate(rhols,stat=ier)
       if( ier /= 0 ) then
          write(6,*) 'error deallocate: unset_ham_parameter'
          stop
       end if
    end if

    return
  end subroutine unset_density_ini

  subroutine alo_scf_ham(m_mat_max_c)

    implicit none
    integer, intent(in) :: m_mat_max_c
    integer :: i1_do,i2_do,i3_do,ier,ic_spin

    if( ispin_pol_scf == 2 ) then
       ic_spin=2
    else
       ic_spin=1
    end if

    allocate(h_cc_scf(ic_spin,m_mat_max_c,m_mat_max_c)                           &
         ,s_cc_scf(m_mat_max_c,m_mat_max_c),stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error allocate: alo_density'
       stop
    end if

    do i3_do=1,m_mat_max_c
       do i2_do=1,m_mat_max_c
          do i1_do=1,ic_spin
             h_cc_scf(i1_do,i2_do,i3_do)=dcmplx(0.d0,0.d0)
          end do
          s_cc_scf(i2_do,i3_do)=dcmplx(0.d0,0.d0)
       end do
    end do

    return
  end subroutine alo_scf_ham

  subroutine unset_scf_ham

    implicit none
    integer :: ier

    deallocate(h_cc_scf,s_cc_scf,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error deallocate: unset_ham_parameter'
       stop
    end if

    return
  end subroutine unset_scf_ham

  subroutine h_v_atom

    implicit none
    integer :: ier

    allocate(hv_atom_matrix(num_atom_scf,num_atom_scf,0:param_cell_nl-1) &
         ,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error deallocate: unset_ham_parameter'
       stop
    end if

    return
  end subroutine h_v_atom

  subroutine unset_h_v_atom

    implicit none
    integer :: ier

    deallocate(hv_atom_matrix,stat=ier)
    if( ier /= 0 ) then
       write(6,*) 'error deallocate: unset_ham_parameter'
       stop
    end if

    return
  end subroutine unset_h_v_atom
end module scf_negf

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@             Naoki WATANABE (Mizuho I.R.)                       @@ !
! @@             Nobutaka NISHIKAWA (Mizuho I.R.)                   @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine cal_gf_se_c_scf(descCC,descCL,descLL,descCR,descRR,ispin,kt)

  use scf_negf
  use condition_ini
  use hamiltonian_sgf
  use hamiltonian_c
  use gf_se_c
  use constant
  use ac_mpi_module
  use mod_mpi
  use hamiltonian_e

  implicit none
  type(MPI_MatDesc), intent(in) :: descCC, descCL, descLL, descCR, descRR
  integer, intent(in) :: ispin,kt
  integer :: iw_do,i1_do,i2_do,i3_do,icou,i_w_st 
  integer :: px,py,qx,qy
  complex(8) :: w,w_weight

  real(8) :: st1,st2,stdel,tot_t

  integer :: i, j

  open(unit=16,file=file_tempout,position='append')
  write(16,*) '         ------------ spin:',ispin,'------------'
  close(16)

  cdens(:,:,ispin) = 0.d0
  edens(:,:,ispin) = 0.d0

  tot_t=0.d0

  if( ispin == 1 ) then
     i_w_st=MPI%rankE
  else
     i_w_st=MPI%rankE-mod(i_total_omega,MPI%sizeE)
     if( i_w_st < 0 ) then
        i_w_st=i_w_st+MPI%sizeE
     end if
  end if

  do iw_do=1+i_w_st,i_total_omega,MPI%sizeE

     !!if(MPI%root) write(*,*) 'iw_do',iw_do,1+i_w_st,i_total_omega,MPI%sizeE

     open(unit=60,file=file_sf_scf(ispin,kt,iw_do,MPI%rank2))
     write(60,995) m_mat_max_c,i_total_omega
     close(60)

     w=omega_scf(iw_do)
     w_weight=omega_weight_scf(iw_do)


     call myclock(st1)

     open(unit=16,file=file_tempout,position='append')
     open(unit=60,file=file_sf_scf(ispin,kt,iw_do,MPI%rank2),position='append')

     write(60,997) w,w_weight,ispin
     close(60)
     do px=1,kx_max_ll                                           
        do py=1,ky_max_ll                                         
           call selfenergy_l(descCC,descCL,descLL,w,iw_do,px,py,ispin,kt)
           icou=0
           do j=descCC%scol,descCC%ecol
              do i=1,descCC%nrow
                 if( se_l_mat_per(i,j,px,py) /= dcmplx(0.d0,0.d0) ) then 
                    icou=icou+1
                 end if
              end do
           end do
           open(unit=60,file=file_sf_scf(ispin,kt,iw_do,MPI%rank2),position='append')
           write(60,*) icou
           do j=descCC%scol,descCC%ecol
              do i=1,descCC%nrow
                 if( se_l_mat_per(i,j,px,py) /= dcmplx(0.d0,0.d0) ) then 
                    write(60,999) i,j,se_l_mat_per(i,j,px,py) 
                 end if
              end do
           end do
           close(60)

        end do
     end do
     close(16)

     call myclock(st2)
     stdel=st2-st1
     tot_t=tot_t+stdel

     call myclock(st1)

     open(unit=16,file=file_tempout,position='append')
     open(unit=60,file=file_sf_scf(ispin,kt,iw_do,MPI%rank2),position='append')
     write(60,998) w,w_weight,ispin
     close(60)
     do qx=1,kx_max_rr                                           
        do qy=1,ky_max_rr                                         
           call selfenergy_r(descCC,descCR,descRR,w,iw_do,qx,qy,ispin,kt)
           icou=0
           do j=descCC%scol,descCC%ecol
              do i=1,descCC%nrow
                 if( se_r_mat_per(i,j,qx,qy) /= dcmplx(0.d0,0.d0) ) then 
                    icou=icou+1
                 end if
              end do
           end do
           open(unit=60,file=file_sf_scf(ispin,kt,iw_do,MPI%rank2),position='append')
           write(60,*) icou
           do j=descCC%scol,descCC%ecol
              do i=1,descCC%nrow
                 if( se_r_mat_per(i,j,qx,qy) /= dcmplx(0.d0,0.d0) ) then 
                    write(60,999) i,j,se_r_mat_per(i,j,qx,qy) 
                 end if
              end do
           end do
           close(60)

        end do
     end do
     close(16)

     call myclock(st2)
     stdel=st2-st1
     tot_t=tot_t+stdel

     call myclock(st1)

     open(unit=16,file=file_tempout,position='append')
     do px=1,kx_max_ll                                           
        do py=1,ky_max_ll                                         
           do qx=1,kx_max_rr                                       
              do qy=1,ky_max_rr                                     
                 call green_function_scf(descCC,w,w_weight,iw_do,px,py,qx,qy,ispin)
              end do
           end do
        end do
     end do
     close(16)

     call myclock(st2)
     stdel=st2-st1
     tot_t=tot_t+stdel


  end do

  call myclock(st1)
  call calc_edm(descCC,ispin)
  call myclock(st2)
  stdel=st2-st1
  tot_t=tot_t+stdel

  open(unit=16,file=file_tempout,position='append')
  write(16,*) '                t=',tot_t
  close(16)


995 format(i10,i10)
997 format(d28.19,d28.19,d28.19,d28.19,i5                                        &
       ,'    ** left  *******************************')
998 format(d28.19,d28.19,d28.19,d28.19,i5                                        &
       ,'    ** right *******************************')
999 format(i10,i10,d28.19,d28.19)

  return
end subroutine cal_gf_se_c_scf

subroutine cal_gf_se_read_scf(descCC,ispin,kt)

  use scf_negf
  use condition_ini
  use hamiltonian_sgf
  use hamiltonian_c
  use gf_se_c
  use constant
  use ac_mpi_module
  use mod_mpi

  implicit none
  type(MPI_MatDesc) :: descCC
  integer, intent(in) :: ispin,kt
  integer :: iw_do,i1_do,i2_do,i3_do,icou,i_total_omega_tt,i_w_st 
  integer :: px,py,qx,qy
  integer :: m_mat_max_read,itemp
  real(8) :: temp1,temp2,temp3,temp4
  complex(8) :: w,w_weight,w1

  real(8) :: st1,st2,stdel,tot_t
  integer :: i, j

  open(unit=16,file=file_tempout,position='append')
  write(16,*) '         ------------ spin:',ispin,'------------'
  close(16)

  cdens(:,:,ispin) = 0.d0
  edens(:,:,ispin) = 0.d0

  tot_t=0.d0

  if( ispin == 1 ) then
     i_w_st=MPI%rankE
  else
     i_w_st=MPI%rankE-mod(i_total_omega,MPI%sizeE)
     if( i_w_st < 0 ) then
        i_w_st=i_w_st+MPI%sizeE
     end if
  end if

  do iw_do=1+i_w_st,i_total_omega,MPI%sizeE

     !!if(MPI%root) write(*,*) 'iw_do',iw_do,1+i_w_st,i_total_omega,MPI%sizeE

     open(unit=60,file=file_sf_scf(ispin,kt,iw_do,MPI%rank2))

     read(60,*) m_mat_max_read,i_total_omega_tt

     if( i_total_omega /= i_total_omega_tt ) then
        close(60)
        open(unit=16,file=file_tempout,position='append')
        write(16,*) 'error- (i_total_omega /= i_total_omega_t)',iw_do
        write(16,*) '                 re-cal.'
        close(16)
        stop
     end if

     itemp=m_mat_max_c-m_mat_max_read

     do px=1,kx_max_ll
        do py=1,ky_max_ll
           se_l_mat_per(:,:,px,py) = dcmplx(0.d0,0.d0) 
        end do
     end do

     read(60,996) temp1,temp2,temp3,temp4
     w=dcmplx(temp1,temp2)
     w_weight=dcmplx(temp3,temp4)

     do px=1,kx_max_ll
        do py=1,ky_max_ll
           read(60,*) icou
           do i3_do=1,icou
              read(60,999) i,j,temp1,temp2
              se_l_mat_per(i,j,px,py) = dcmplx(temp1,temp2) 
           end do
        end do
     end do

     do qx=1,kx_max_rr
        do qy=1,ky_max_rr
           se_r_mat_per(:,:,qx,qy) = dcmplx(0.d0,0.d0) 
        end do
     end do

     read(60,996) temp1,temp2,temp3,temp4
     w1=dcmplx(temp1,temp2)
     if( w /= w1 ) then
        write(6,*) 'error--A  w /= w1', w, w1
        stop
     end if
     do qx=1,kx_max_rr
        do qy=1,ky_max_rr
           read(60,*) icou
           do i3_do=1,icou
              read(60,999) i,j,temp1,temp2
              se_r_mat_per(itemp+i,itemp+j,qx,qy) = dcmplx(temp1,temp2) 
           end do
        end do
     end do
     close(60)

     call myclock(st1)

     open(unit=16,file=file_tempout,position='append')
     do px=1,kx_max_ll
        do py=1,ky_max_ll
           do qx=1,kx_max_rr
              do qy=1,ky_max_rr
                 call green_function_scf(descCC,w,w_weight,iw_do,px,py,qx,qy,ispin)
              end do
           end do
        end do
     end do
     close(16)

     call myclock(st2)
     stdel=st2-st1
     tot_t=tot_t+stdel

  end do

  call myclock(st1)
  call calc_edm(descCC,ispin)
  call myclock(st2)
  stdel=st2-st1
  tot_t=tot_t+stdel



  open(unit=16,file=file_tempout,position='append')
  write(16,*) '                t=',tot_t
  close(16)


996 format(d28.19,d28.19,d28.19,d28.19)
999 format(i10,i10,d28.19,d28.19)

  return
end subroutine cal_gf_se_read_scf

subroutine cal_gf_se_c2_scf(descCC,descCL,descLL,descCR,descRR,ispin,kt)

  use scf_negf
  use condition_ini
  use hamiltonian_sgf
  use hamiltonian_c
  use gf_se_c
  use constant
  use ac_mpi_module
  use mod_mpi
  use hamiltonian_e

  implicit none
  type(MPI_MatDesc), intent(in) :: descCC, descCL, descLL, descCR, descRR
  integer, intent(in) :: ispin,kt
  integer :: iw_do,i1_do,i2_do,i3_do,icou,i_w_st 
  integer :: px,py,qx,qy
  complex(8) :: w,w_weight

  real(8) :: st1,st2,stdel,tot_t

  integer :: i, j

  open(unit=16,file=file_tempout,position='append')
  write(16,*) '         ------------ spin:',ispin,'------------'
  close(16)


  cdens(:,:,ispin) = 0.d0
  edens(:,:,ispin) = 0.d0

  tot_t=0.d0

  if( ispin == 1 ) then
     i_w_st=MPI%rankE
  else
     i_w_st=MPI%rankE-mod(i_total_omega,MPI%sizeE)
     if( i_w_st < 0 ) then
        i_w_st=i_w_st+MPI%sizeE
     end if
  end if

  do iw_do=1+i_w_st,i_total_omega,MPI%sizeE

     !!if(MPI%root) write(*,*) 'iw_do',iw_do,1+i_w_st,i_total_omega,MPI%sizeE


     w=omega_scf(iw_do)
     w_weight=omega_weight_scf(iw_do)


     call myclock(st1)

     open(unit=16,file=file_tempout,position='append')

     do px=1,kx_max_ll                                           
        do py=1,ky_max_ll                                         
           call selfenergy_l(descCC,descCL,descLL,w,iw_do,px,py,ispin,kt)

        end do
     end do
     close(16)

     call myclock(st2)
     stdel=st2-st1
     tot_t=tot_t+stdel

     call myclock(st1)

     open(unit=16,file=file_tempout,position='append')
     do qx=1,kx_max_rr                                           
        do qy=1,ky_max_rr                                         
           call selfenergy_r(descCC,descCR,descRR,w,iw_do,qx,qy,ispin,kt)

        end do
     end do
     close(16)

     call myclock(st2)
     stdel=st2-st1
     tot_t=tot_t+stdel

     call myclock(st1)

     open(unit=16,file=file_tempout,position='append')
     do px=1,kx_max_ll                                           
        do py=1,ky_max_ll                                         
           do qx=1,kx_max_rr                                       
              do qy=1,ky_max_rr                                     
                 call green_function_scf(descCC,w,w_weight,iw_do,px,py,qx,qy,ispin)
              end do
           end do
        end do
     end do
     close(16)

     call myclock(st2)
     stdel=st2-st1
     tot_t=tot_t+stdel


  end do

  call myclock(st1)
  call calc_edm(descCC,ispin)
  call myclock(st2)
  stdel=st2-st1
  tot_t=tot_t+stdel

  open(unit=16,file=file_tempout,position='append')
  write(16,*) '                t=',tot_t
  close(16)


995 format(i10,i10)
997 format(d28.19,d28.19,d28.19,d28.19,i5                                        &
       ,'    ** left  *******************************')
998 format(d28.19,d28.19,d28.19,d28.19,i5                                        &
       ,'    ** right *******************************')
999 format(i10,i10,d28.19,d28.19)

  return
end subroutine cal_gf_se_c2_scf

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine set_condition_l

  use condition_ini
  use condition
  use hamiltonian_sgf
  use hamiltonian_temp

  implicit none
  integer :: i_w_num,i_w_num1,i1_do,i2_do
  complex(8) :: w,w_int
  !                                                ==================================
  !                               substitute parameter of left region for general one
  !                                                ==================================

  ham_model=ham_model_ini
  sgf_method=sgf_method_ini
  iteration_max=iteration_max_ini
  eps=eps_ini
  num_atom_kind=num_atom_kind_ini

  p_or_f=p_or_f_l
  num_unit=num_unit_l
  neighbor_x_max=neighbor_x_max_l
  neighbor_y_max=neighbor_y_max_l
  kx_max=kx_max_l
  ky_max=ky_max_l
  neighbor_z_max=neighbor_z_max_l
  kz_max=kz_max_l
  num_atom=num_atom_l
  v_lr=v_l

  call alo_condition(num_atom_kind,num_atom)

  if( ham_model_ini == 'rtb_h' .or. ham_model_ini == 'gsp' ) then
     atom_sign=atom_sign_ini
     atom_num=atom_num_ini
     atom_mass=atom_mass_ini
     atom_electron=atom_electron_ini
     atom_orbital=atom_orbital_ini

     unit_block=unit_block_l
     atom_kind=atom_kind_l
     ra=ra_l
     atom_kindn=atom_kindn_l
  end if

  if( ham_model == 'gsp' ) then
     pair_num=pair_num_l
  end if

  l_or_r=1
  calc_type_c=calc_type

  dos_on_off=dos_on_off_ini_l
  eigen_s_as=eigen_s_as_ini

  if( ham_model_ini == 'gsp' .or. ham_model_ini == 'rtb_h' ) then
     spin_switch_temp=1
  else
     if( spin_ll == 2 ) then
        spin_switch_temp=2
     else
        spin_switch_temp=1
     end if
  end if

  !                       ------------------------------------                       !

  num_gra_te=num_gra

  i_w_num=0
  do i1_do=1,om_block_num
     i_w_num=i_w_num+num_om_par(i1_do)
  end do

  call alo_condition_omega(i_w_num,om_block_num)
  i_w_num1=0
  do i1_do=1,om_block_num
     omega_par(i1_do)=i_w_num1
     i_w_num1=i_w_num1+num_om_par(i1_do)
     omega_par_num(i1_do)=i_w_num1
     if( om_con_method(i1_do) == 'linear' ) then
        i_w_num=num_om_par(i1_do)
        w_int=(omega_if(i1_do,2)-omega_if(i1_do,1))/dfloat(i_w_num)
        w=omega_if(i1_do,1)-w_int*.5d0
        do i2_do=1,i_w_num
           w=w+w_int
           omega(i2_do)=w
        end do
     end if
  end do

  !                       ------------------------------------                       !

  if( ham_model_ini == 'input' .or. ham_model_ini == 'scf_accel' ) then
     mat_max_eigen=mat_max_ll
  else
     mat_max_eigen=0
     do i1_do=1,num_atom
        mat_max_eigen=mat_max_eigen+atom_orbital(atom_kindn(i1_do))
     end do
     if( p_or_f == 'free' ) then
        mat_max_eigen=mat_max_eigen*num_unit(1)*num_unit(2)
     end if
  end if

  call alo_condition_dos(ka_tr*kb_tr)

  !                       ------------------------------------                       !

  if( spin_ll < 4 ) then
     ele_num_temp=ele_num_ll
  else
     ele_num_temp=ele_num_ll*2
  end if
  lr_switch=-1

  return
end subroutine set_condition_l

subroutine unset_condition_l

  use condition_ini
  use condition

  implicit none

  call unset_condition
  call unset_condition_omega
  call unset_condition_dos

  return
end subroutine unset_condition_l

subroutine set_condition_r

  use condition_ini
  use condition
  use hamiltonian_sgf
  use hamiltonian_temp

  implicit none
  integer :: i_w_num,i_w_num1,i1_do,i2_do
  complex(8) :: w,w_int
  !                                                ==================================
  !                              substitute parameter of right region for general one
  !                                                ==================================

  ham_model=ham_model_ini
  sgf_method=sgf_method_ini
  iteration_max=iteration_max_ini
  eps=eps_ini
  num_atom_kind=num_atom_kind_ini

  p_or_f=p_or_f_r
  num_unit=num_unit_r
  neighbor_x_max=neighbor_x_max_r
  neighbor_y_max=neighbor_y_max_r
  kx_max=kx_max_r
  ky_max=ky_max_r
  neighbor_z_max=neighbor_z_max_r
  kz_max=kz_max_r
  num_atom=num_atom_r
  v_lr=v_r

  call alo_condition(num_atom_kind,num_atom)

  if( ham_model_ini == 'rtb_h' .or. ham_model_ini == 'gsp' ) then
     atom_sign=atom_sign_ini
     atom_num=atom_num_ini
     atom_mass=atom_mass_ini
     atom_electron=atom_electron_ini
     atom_orbital=atom_orbital_ini

     unit_block=unit_block_r
     atom_kind=atom_kind_r
     ra=ra_r
     atom_kindn=atom_kindn_r
  end if

  if( ham_model == 'gsp' ) then
     pair_num=pair_num_r
  end if

  l_or_r=1
  calc_type_c=calc_type

  dos_on_off=dos_on_off_ini_r
  eigen_s_as=eigen_s_as_ini

  if( ham_model_ini == 'gsp' .or. ham_model_ini == 'rtb_h' ) then
     spin_switch_temp=1
  else
     if( spin_rr == 2 ) then
        spin_switch_temp=2
     else
        spin_switch_temp=1
     end if
  end if

  !                       ------------------------------------                       !

  num_gra_te=num_gra

  i_w_num=0
  do i1_do=1,om_block_num
     i_w_num=i_w_num+num_om_par(i1_do)
  end do

  call alo_condition_omega(i_w_num,om_block_num)
  i_w_num1=0
  do i1_do=1,om_block_num
     omega_par(i1_do)=i_w_num1
     i_w_num1=i_w_num1+num_om_par(i1_do)
     omega_par_num(i1_do)=i_w_num1
     if( om_con_method(i1_do) == 'linear' ) then
        i_w_num=num_om_par(i1_do)
        w_int=(omega_if(i1_do,2)-omega_if(i1_do,1))/dfloat(i_w_num)
        w=omega_if(i1_do,1)-w_int*.5d0
        do i2_do=1,i_w_num
           w=w+w_int
           omega(i2_do)=w
        end do
     end if
  end do

  !                       ------------------------------------                       !

  if( ham_model_ini == 'input' .or. ham_model_ini == 'scf_accel' ) then
     mat_max_eigen=mat_max_rr
  else
     mat_max_eigen=0
     do i1_do=1,num_atom
        mat_max_eigen=mat_max_eigen+atom_orbital(atom_kindn(i1_do))
     end do
     if( p_or_f == 'free' ) then
        mat_max_eigen=mat_max_eigen*num_unit(1)*num_unit(2)
     end if
  end if

  call alo_condition_dos(ka_tr*kb_tr)

  !                       ------------------------------------                       !

  if( spin_rr < 4 ) then
     ele_num_temp=ele_num_rr
  else
     ele_num_temp=ele_num_rr*2
  end if
  lr_switch=1

  return
end subroutine set_condition_r

subroutine unset_condition_r

  use condition_ini
  use condition

  implicit none

  call unset_condition
  call unset_condition_omega
  call unset_condition_dos

  return
end subroutine unset_condition_r

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Naoki WATANABE, Nobutaka NISHIKAWA (Mizuho I.R.)   @@ !
! @@             Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine Spline__set( spline, vf, vx_out, N )
  use ac_misc_module

  implicit none
  type(Spline_type), intent(out) :: spline
  integer, intent(in)       :: N
  real(8), intent(in)       :: vf(N)
  real(8), intent(in)       :: vx_out(N)

  real(8), allocatable :: vdx(:)
  real(8), allocatable :: vdf(:)
  real(8), allocatable ::  vu(:)
  integer       :: i

  spline%N = N 

  allocate( vdx(spline%N) )
  allocate( vdf(spline%N) )
  allocate(  vu(spline%N) )

  allocate( spline%vf(spline%N) )
  allocate( spline%vx(spline%N) )

  do i=1, spline%N
     spline%vf(i) = vf(i)
     spline%vx(i) = vx_out(i)
  end do

  allocate( spline%vb(spline%N) )
  allocate( spline%vc(spline%N) )
  allocate( spline%vd(spline%N) )

  do i=1, spline%N-1
     vdx(i) = vx_out(i+1) - vx_out(i+0)
  end do
  vdx(spline%N)=0.d0

  do i=1, spline%N-1
     vdf(i) = (vf(i+1)-vf(i))*(1.0/vdx(i))
  end do
  vdf(spline%N) = 0.d0

  spline%vc(1) = 0.d0
  do i=2, spline%N-1
     spline%vc(i) = (vdf(i+0)-vdf(i-1))*3.0
  end do
  spline%vc(spline%N) = 0.d0

  vu(1) = 0.d0
  do i=2, spline%N-1
     vu(i) = 1.0/( 2*(vdx(i+1)+vdx(i)) - vdx(i)*vdx(i)*vu(i-1) )
  end do
  vu(spline%N) = 0.d0

  do i=2, spline%N-1
     spline%vc(i) = spline%vc(i) - spline%vc(i-1)*(vdx(i-1)*vu(i-1))
  end do
  do i=spline%N-1, 2, -1
     spline%vc(i) = (spline%vc(i) - spline%vc(i+1)*vdx(i))*vu(i)
  end do

  do i=1, spline%N-1
     spline%vd(i) = (spline%vc(i+1)-spline%vc(i))*(1.0/(3.0*vdx(i)))
     spline%vb(i) = vdf(i) - spline%vc(i)*vdx(i) - spline%vd(i)*(vdx(i)*vdx(i))
  end do
  spline%vb(spline%N) = 0.d0
  spline%vd(spline%N) = 0.d0

  deallocate( vdx, vdf, vu )

  return
end subroutine Spline__set

subroutine Spline__reset( spline, vf )
  use ac_misc_module

  implicit none
  type(Spline_type), intent(inout) :: spline
  real(8), intent(in)       :: vf(spline%N)


  real(8), allocatable :: vdx(:)
  real(8), allocatable :: vdf(:)
  real(8), allocatable ::  vu(:)
  integer       :: i

  allocate( vdx(spline%N) )
  allocate( vdf(spline%N) )
  allocate(  vu(spline%N) )

  do i=1, spline%N
     spline%vf(i) = vf(i)
  end do

  do i=1, spline%N-1
     vdx(i) = spline%vx(i+1) - spline%vx(i+0)
  end do
  vdx(spline%N)=0.d0

  do i=1, spline%N-1
     vdf(i) = (vf(i+1)-vf(i))*(1.0/vdx(i))
  end do
  vdf(spline%N) = 0.d0

  spline%vc(1) = 0.d0
  do i=2, spline%N-1
     spline%vc(i) = (vdf(i+0)-vdf(i-1))*3.0
  end do
  spline%vc(spline%N) = 0.d0

  vu(1) = 0.d0
  do i=2, spline%N-1
     vu(i) = 1.0/( 2*(vdx(i+1)+vdx(i)) - vdx(i)*vdx(i)*vu(i-1) )
  end do
  vu(spline%N) = 0.d0

  do i=2, spline%N-1
     spline%vc(i) = spline%vc(i) - spline%vc(i-1)*(vdx(i-1)*vu(i-1))
  end do
  do i=spline%N-1, 2, -1
     spline%vc(i) = (spline%vc(i) - spline%vc(i+1)*vdx(i))*vu(i)
  end do

  do i=1, spline%N-1
     spline%vd(i) = (spline%vc(i+1)-spline%vc(i))*(1.0/(3.0*vdx(i)))
     spline%vb(i) = vdf(i) - spline%vc(i)*vdx(i) - spline%vd(i)*(vdx(i)*vdx(i))
  end do
  spline%vb(spline%N) = 0.d0
  spline%vd(spline%N) = 0.d0

  deallocate( vdx, vdf, vu )

  return
end subroutine Spline__reset

subroutine Spline_deallocate(spline)
  use ac_misc_module

  implicit none
  type(Spline_type) :: spline

  if( associated(spline%vx) ) deallocate(spline%vx)
  if( associated(spline%vf) ) deallocate(spline%vf)
  if( associated(spline%vb) ) deallocate(spline%vb)
  if( associated(spline%vc) ) deallocate(spline%vc)
  if( associated(spline%vd) ) deallocate(spline%vd)

  return
end subroutine Spline_deallocate

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Naoki WATANABE, Nobutaka NISHIKAWA (Mizuho I.R.)   @@ !
! @@             Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine RadialFunc__set( RF, vr, N )
  use ac_misc_module
  implicit none
  integer, intent(in)          :: N
  type(RadialFunc_type), intent(inout) :: RF
  real(8), intent(in)    :: vr(N)

  RF%vK => null()

  if( .not. associated(RF%vR) ) then
     write(*,*) "Error: vR is not allocated"
     stop
  end if

  call Spline__set( RF%fR, RF%vR, vr, N )

  return
end subroutine RadialFunc__set

subroutine RadialFunc__reset( RF )
  use ac_misc_module
  implicit none
  type(RadialFunc_type), intent(out) :: RF

  if( associated(RF%vK) ) deallocate(RF%vK)

  call Spline__reset( RF%fR, RF%vR )

  return
end subroutine RadialFunc__reset

subroutine RadialFunc__transpose( RF )
  use ac_misc_module

  implicit none
  type(RadialFunc_type), intent(inout) :: RF

  allocate( RF%vK(SphericalBessel%Nk) )
  call SphericalBessel__transpose( RF%vK, RF%fR, RF%l )

  return
end subroutine RadialFunc__transpose

subroutine RadialFunc__transposetail( RF )
  use ac_misc_module

  implicit none
  type(RadialFunc_type), intent(inout) :: RF

  call SphericalBessel__transposetail( RF%vK, RF%fR, RF%Q )

  return
end subroutine RadialFunc__transposetail

subroutine RadialFunc__deallocate( RF )
  use ac_misc_module

  implicit none
  type(RadialFunc_type), intent(out) :: RF

  if( associated(RF%vR) ) deallocate(RF%vR)
  if( associated(RF%vK) ) deallocate(RF%vK)
  call Spline_deallocate(RF%fR)

  return
end subroutine RadialFunc__deallocate

subroutine RadialFunc__bracketS( sum, RF1, RF2 )
  use ac_misc_module

  implicit none
  type(RadialFunc_type), intent(in) :: RF1, RF2

  real(8)  :: sum
  real(8) :: R(3)

  real(8)  :: g, y, j

  R = 0.d0

  g = SphericalHarmonic__Gaunt( 0, 0, 0, 0, 0, 0 )
  y = SphericalHarmonic__rlY( 0, 0, R )
  j = SphericalBessel__integrateS( RF1%vK, RF2%vK, 0, 0.d0 )

  sum = g*y*j

  return
end subroutine RadialFunc__bracketS

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Naoki WATANABE, Nobutaka NISHIKAWA (Mizuho I.R.)   @@ !
! @@             Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine Ewald__calc( V, Q, Ro, R1 )
  use ac_parameter

  implicit none
  real(8), intent(in)  :: Q
  real(8), intent(in) :: Ro(3)
  real(8), intent(in) :: R1(3)

  real(8), intent(out) :: V

  integer :: ika, ikb, ikc
  integer :: na, nb, nc
  integer :: Nr, Nk
  real(8) :: K(3)
  real(8) :: kk
  real(8) :: R(3)
  real(8)  :: dR
  real(8)  :: epk_t, eprl_t, eprs_t

  Ewald%alpha = sqrt(0.84d0*M_PI/(sum(Param%Cell%La*Param%Cell%La)))
  Nk = 4
  Nr = 4

  V=0.d0
  do ika=-Nk, Nk
     do ikb=-Nk, +Nk
        do ikc=-Nk, +Nk
           K = Param%Cell%dKa*dble(ika) + Param%Cell%dKb*dble(ikb) + Param%Cell%dKc*dble(ikc)
           kk = dot_product(K,K)

           call Ewald__PhiKlong(epk_t,kk)
           V = V + cos( sum(k*(Ro-R1)) )*epk_t
        end do
     end do
  end do
  V = V * 1.d0/Param%Cell%V

  do  na=-Nr, +Nr
     do nb=-Nr,+Nr
        do nc=-Nr, +Nr
           call Param__Cell__L(R,na,nb,nc)
           R = Ro + R - R1
           dR = sqrt(dot_product(R,R))

           if( na==0 .and.  nb==0 .and. nc==0 ) then
              call Ewald__PhiRlong(eprl_t,dR)
              V = V - eprl_t
           else
              call Ewald__PhiRshort(eprs_t,dR)
              V = V + eprs_t
           end if
        end do
     end do
  end do

  V = V*Q

  return
end subroutine Ewald__calc

subroutine Ewald__calcForce( F, Q, Ro, R1 )
  use ac_parameter

  implicit none
  real(8), intent(in)  :: Q
  real(8), intent(in) :: Ro(3)
  real(8), intent(in) :: R1(3)

  real(8), intent(out) :: F(3)

  integer :: ika, ikb, ikc
  integer :: na, nb, nc
  integer :: Nr, Nk
  real(8) :: K(3)
  real(8) :: kk
  real(8) :: R(3)
  real(8) :: dR
  real(8) :: epk_t, eprl_t, eprs_t

  Ewald%alpha = sqrt(0.84d0*M_PI/(sum(Param%Cell%La*Param%Cell%La)))
  Nk = 4
  Nr = 4

  F = 0.d0
  do ika=-Nk, Nk
     do ikb=-Nk, +Nk
        do ikc=-Nk, +Nk
           K = Param%Cell%dKa*dble(ika) + Param%Cell%dKb*dble(ikb) + Param%Cell%dKc*dble(ikc)
           kk = dot_product(K,K)

           call Ewald__PhiKlong(epk_t,kk)
           F = F - k*sin(k*(Ro-R1))*epk_t
        end do
     end do
  end do
  F = F * 1.d0/Param%Cell%V

  do  na=-Nr, +Nr
     do nb=-Nr,+Nr
        do nc=-Nr, +Nr
           call Param__Cell__L(R,na,nb,nc)
           R = Ro + R - R1
           dR = sqrt(dot_product(R,R))

           if( na==0 .and.  nb==0 .and. nc==0 ) then
              if( dR < 1.d-14 ) then
              else
                 call Ewald__dPhiRlong(eprl_t,dR)
                 F = F - eprl_t/dR*R
              end if
           else
              call Ewald__dPhiRshort(eprs_t,dR)
              F = F + eprs_t/dR*R
           end if
        end do
     end do
  end do

  F = F*Q

  return
end subroutine Ewald__calcForce

subroutine Ewald__PhiKlong(Phi,kk)
  use ac_parameter

  implicit none
  real(8), intent(in) :: kk

  real(8), intent(out) :: Phi

  if( kk < 1.d-14 ) then
     Phi = - M_PI/(Ewald%alpha*Ewald%alpha)
  else
     Phi = 4*M_PI/kk*exp(-kk/(4*Ewald%alpha*Ewald%alpha))
  end if

  return
end subroutine Ewald__PhiKlong

subroutine Ewald__PhiRlong(Phi,dR)
  use ac_parameter

  implicit none
  real(8), intent(in) :: dR

  real(8) :: Phi
  real(8) :: derf 

  if( dR < 1.d-14 ) then
     Phi = Ewald%alpha*M_2_SQRTPI
  else
     Phi = derf(Ewald%alpha*dR)/dR
  end if

  return
end subroutine Ewald__PhiRlong

subroutine Ewald__dPhiRlong(dPhi,dR)
  use ac_parameter

  implicit none
  real(8), intent(in) :: dR

  real(8) :: dPhi
  real(8) :: derf 

  if( dR < 1.d-14 ) then
     dPhi = 0.d0
  else
     dPhi = M_2_SQRTPI*Ewald%alpha*exp(-(Ewald%alpha*dR)**2 )/dR &
          - derf(Ewald%alpha*dR)/(dR**2)
  end if

  return
end subroutine Ewald__dPhiRlong

subroutine Ewald__PhiRshort(Phi,dR) 
  use ac_parameter

  implicit none
  real(8), intent(in) :: dR

  real(8) :: Phi
  real(8) :: derfc 

  Phi = derfc(Ewald%alpha*dR)/dR

  return
end subroutine Ewald__PhiRshort

subroutine Ewald__dPhiRshort(dPhi,dR) 
  use ac_parameter

  implicit none
  real(8), intent(in) :: dR

  real(8) :: dPhi
  real(8) :: derfc 

  dPhi = - M_2_SQRTPI*Ewald%alpha*exp(-(Ewald%alpha*dR)**2 )/dR &
       - derfc(Ewald%alpha*dR)/(dR**2)
  return
end subroutine Ewald__dPhiRshort

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine set_hami_c_pre

  use condition_ini
  use hamiltonian_sgf
  use locate_atom
  use hamiltonian_c

  implicit none
  integer :: kx,ky,i1_do
  integer :: i1_count
  integer :: num_unit_temp1,num_unit_temp2
  integer :: num_unit_temp11,num_unit_temp12,num_unit_temp21,num_unit_temp22

  if( ham_model_ini /= 'input' .and. ham_model_ini /= 'scf_accel') then
     m_mat_max_l=0
     do i1_do=1,num_atom_l
        m_mat_max_l=m_mat_max_l+atom_orbital_ini(atom_kindn_l(i1_do))
     end do
     if( p_or_f_l == 'free' ) then
        m_mat_max_l=m_mat_max_l*num_unit_l(1)*num_unit_l(2)
     end if

     m_mat_max_c=0
     do i1_do=1,num_atom_ctotal
        m_mat_max_c=m_mat_max_c+atom_orbital_ini(atom_kindn_ccal(i1_do))
     end do

     m_mat_max_r=0
     do i1_do=1,num_atom_r
        m_mat_max_r=m_mat_max_r+atom_orbital_ini(atom_kindn_r(i1_do))
     end do
     if( p_or_f_r == 'free' ) then
        m_mat_max_r=m_mat_max_r*num_unit_r(1)*num_unit_r(2)
     end if
  end if

  !                       ------------------------------------                       !

  if( p_or_f_l == 'free' ) then
     num_unit_temp11=num_unit_l(1)
     num_unit_temp12=num_unit_l(2)
  else
     if( p_or_f_l == 'periodic' ) then
        num_unit_temp11=1
        num_unit_temp12=1
     else
        write(6,*) 'error_locate: set_hami_c_pre 1'
        stop
     end if
  end if
  if( p_or_f_r == 'free' ) then
     num_unit_temp21=num_unit_r(1)
     num_unit_temp22=num_unit_r(2)
  else
     if( p_or_f_r == 'periodic' ) then
        num_unit_temp21=1
        num_unit_temp22=1
     else
        write(6,*) 'error_locate: set_hami_c_pre 2'
        stop
     end if
  end if
  call alo_hami_c(num_atom_ctotal,num_atom_l,num_atom_r                        &
       ,num_unit_temp11,num_unit_temp12,num_unit_temp21,num_unit_temp22)

  !                       ------------------------------------                       !

  if( p_or_f_r == 'free' ) then
     num_unit_temp1=num_unit_l(1)
     num_unit_temp2=num_unit_l(2)
  else
     if( p_or_f_r == 'periodic' ) then
        num_unit_temp1=1
        num_unit_temp2=1
     else
        write(6,*) 'error_locate: set_hami_c_pre 3'
        stop
     end if
  end if
  i1_count=0
  do kx=1,num_unit_temp1
     do ky=1,num_unit_temp2
        do i1_do=1,num_atom_l
           itemp_l(kx,ky,i1_do)=i1_count
           i1_count=i1_count+atom_orbital_ini(atom_kindn_l(i1_do))
        end do
     end do
  end do

  i1_count=0
  do i1_do=1,num_atom_ctotal
     itemp_c(i1_do)=i1_count
     i1_count=i1_count+atom_orbital_ini(atom_kindn_ccal(i1_do))
  end do

  if( p_or_f_r == 'free' ) then
     num_unit_temp1=num_unit_r(1)
     num_unit_temp2=num_unit_r(2)
  else
     if( p_or_f_r == 'periodic' ) then
        num_unit_temp1=1
        num_unit_temp2=1
     else
        write(6,*) 'error_locate: set_hami_c_pre 4'
        stop
     end if
  end if
  i1_count=0
  do kx=1,num_unit_temp1
     do ky=1,num_unit_temp2
        do i1_do=1,num_atom_r
           itemp_r(kx,ky,i1_do)=i1_count
           i1_count=i1_count+atom_orbital_ini(atom_kindn_r(i1_do))
        end do
     end do
  end do

  return
end subroutine set_hami_c_pre

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine cal_print_text11(iw_do,trace,ispin,kt)
  use condition_ini
  use hamiltonian_sgf
  use hamiltonian_c
  use gf_se_c
  use locate_atom

  implicit none
  integer, intent(in) :: iw_do,ispin,kt
  complex(8), intent(in) :: trace

  tr_gr_l(ispin,iw_do,kt)=tr_gr_l(ispin,iw_do,kt)+trace

  return
end subroutine cal_print_text11

subroutine cal_print_text12(iw_do,trace,ispin,kt)
  use condition_ini
  use hamiltonian_sgf
  use hamiltonian_c
  use gf_se_c
  use locate_atom

  implicit none
  integer, intent(in) :: iw_do,ispin,kt
  complex(8), intent(in) :: trace

  tr_gr_r(ispin,iw_do,kt)=tr_gr_r(ispin,iw_do,kt)+trace

  return
end subroutine cal_print_text12
subroutine cal_print_text2(iw_do,trace,ispin,kt)

  use condition_ini
  use hamiltonian_sgf
  use hamiltonian_c
  use gf_se_c
  use locate_atom

  implicit none
  integer, intent(in) :: iw_do,ispin,kt
  complex(8), intent(in) :: trace
  integer :: i1_do,i2_do,i_temp1,i_temp2

  tr_gr_c(ispin,iw_do,kt)=tr_gr_c(ispin,iw_do,kt)+trace

  return
end subroutine cal_print_text2

subroutine cal_print_text3(iw_do,trace,ispin,kt)

  use condition_ini
  use hamiltonian_sgf
  use hamiltonian_c
  use gf_se_c
  use locate_atom

  implicit none
  integer, intent(in) :: iw_do,ispin,kt
  complex(8), intent(in) :: trace
  integer :: i1_do

  tr_tr(ispin,iw_do,kt)=tr_tr(ispin,iw_do,kt)+trace

  return
end subroutine cal_print_text3

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine unset

  use condition_ini
  use gsp_parameter
  use rtbh_parameter
  use hamiltonian_temp
  use gf_se_c

  implicit none

  call unset_condition_ini_1

  if( ham_model_ini .eq. 'gsp' ) then
     call unset_condition_ini
     call unset_gsp_parameter
     call unset_pair_ini
  end if
  if( ham_model_ini .eq. 'rtb_h' ) then
     call unset_condition_ini
     call unset_rtbh_parameter
  end if
  if( ham_model_ini .eq. 'input' ) then
     call dealo_ham_negf_type_c
     call dealo_ham_negf_type_l
     call dealo_ham_negf_type_r
  end if
  if( ham_model_ini /= 'rtb_h' .and. ham_model_ini /= 'gsp' ) then
     call dealo_tr_negf_kpoint
  end if

  return
end subroutine unset

subroutine unset_c

  use condition_ini
  use locate_atom
  use hamiltonian_c

  implicit none

  call unset_hami_c
  call unset_locate_atom
  if( ham_model_ini .eq. 'gsp' ) then
     call unset_locate_atom_pair
  end if

  return
end subroutine unset_c

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.53)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine onsite_ham_hami_cc(j1_count,max_atom_orbital,h_ijmn,s_ijmn,v)

  use condition_ini
  use locate_atom
  use rtbh_parameter

  implicit none
  integer, intent(in) :: max_atom_orbital,j1_count
  real(8), intent(in) :: v
  complex(8), intent(out) :: h_ijmn(max_atom_orbital,max_atom_orbital)
  complex(8), intent(out) :: s_ijmn(max_atom_orbital,max_atom_orbital)
  integer :: id

  id=atom_kindn_ccal(j1_count)

  h_ijmn=dcmplx(0.d0,0.d0)
  s_ijmn=dcmplx(0.d0,0.d0)

  h_ijmn(1,1)=dcmplx(h_s(id)+v,0.d0)
  h_ijmn(2,2)=dcmplx(h_p(id)+v,0.d0)
  h_ijmn(3,3)=dcmplx(h_p(id)+v,0.d0)
  h_ijmn(4,4)=dcmplx(h_p(id)+v,0.d0)

  s_ijmn(1,1)=dcmplx(1.d0,0.d0)
  s_ijmn(2,2)=dcmplx(1.d0,0.d0)
  s_ijmn(3,3)=dcmplx(1.d0,0.d0)
  s_ijmn(4,4)=dcmplx(1.d0,0.d0)

  return
end subroutine onsite_ham_hami_cc

subroutine off_ham_hami_cc(j1_count,j2_count,max_atom_orbital,h_ijmn,s_ijmn        &
     ,r_per_temp)

  use condition_ini
  use locate_atom

  implicit none
  integer, intent(in) :: max_atom_orbital,j1_count,j2_count
  real(8), intent(in) :: r_per_temp(3)
  complex(8), intent(out) :: h_ijmn(max_atom_orbital,max_atom_orbital)
  complex(8), intent(out) :: s_ijmn(max_atom_orbital,max_atom_orbital)

  integer :: id1,id2,j_do,jr_do
  real(8) :: r_distance,rab_distance(3),r_temp_a(3),r_temp_b(3)

  do jr_do=1,3
     r_temp_a(jr_do)=r_c(j1_count,jr_do)+r_per_temp(jr_do)
     r_temp_b(jr_do)=r_c(j2_count,jr_do)
  end do

  rab_distance=r_temp_b-r_temp_a

  r_distance=0.d0
  do j_do=1,3
     r_distance=r_distance+rab_distance(j_do)**2
  end do
  r_distance=dsqrt(r_distance)

  rab_distance=rab_distance/r_distance

  id1=atom_kindn_ccal(j1_count)
  id2=atom_kindn_ccal(j2_count)

  call set_off_rtbh(r_distance,rab_distance,id1,id2                            &
       ,max_atom_orbital,h_ijmn,s_ijmn)

  return
end subroutine off_ham_hami_cc

subroutine off_rtbh_hami_lc(i1_do,j2_count,max_atom_orbital,h_ijmn                 &
     ,s_ijmn,r_per_temp)

  use condition_ini
  use locate_atom

  implicit none
  integer, intent(in) :: max_atom_orbital,i1_do,j2_count
  real(8), intent(in) :: r_per_temp(3)
  complex(8), intent(out) :: h_ijmn(max_atom_orbital,max_atom_orbital)
  complex(8), intent(out) :: s_ijmn(max_atom_orbital,max_atom_orbital)

  integer :: id1,id2,j_do,jr_do
  real(8) :: r_distance,rab_distance(3),r_temp_a(3),r_temp_b(3)
  do jr_do=1,3
     r_temp_a(jr_do)=r_l(i1_do,jr_do)+r_per_temp(jr_do)
     r_temp_b(jr_do)=r_c(j2_count,jr_do)
  end do

  rab_distance=r_temp_b-r_temp_a

  r_distance=0.d0
  do j_do=1,3
     r_distance=r_distance+rab_distance(j_do)**2
  end do
  r_distance=dsqrt(r_distance)

  rab_distance=rab_distance/r_distance

  id1=atom_kindn_l(i1_do)
  id2=atom_kindn_ccal(j2_count)

  call set_off_rtbh(r_distance,rab_distance,id1,id2                            &
       ,max_atom_orbital,h_ijmn,s_ijmn)

  return
end subroutine off_rtbh_hami_lc

subroutine off_rtbh_hami_rc(i1_do,j2_count,max_atom_orbital,h_ijmn,s_ijmn          &
     ,r_per_temp)

  use condition_ini
  use locate_atom

  implicit none
  integer, intent(in) :: max_atom_orbital,i1_do,j2_count
  real(8), intent(in) :: r_per_temp(3)
  complex(8), intent(out) :: h_ijmn(max_atom_orbital,max_atom_orbital)
  complex(8), intent(out) :: s_ijmn(max_atom_orbital,max_atom_orbital)

  integer :: id1,id2,j_do,jr_do
  real(8) :: r_distance,rab_distance(3),r_temp_a(3),r_temp_b(3)

  do jr_do=1,3
     r_temp_a(jr_do)=r_r(i1_do,jr_do)+r_per_temp(jr_do)
     r_temp_b(jr_do)=r_c(j2_count,jr_do)
  end do

  rab_distance=r_temp_b-r_temp_a

  r_distance=0.d0
  do j_do=1,3
     r_distance=r_distance+rab_distance(j_do)**2
  end do
  r_distance=dsqrt(r_distance)

  rab_distance=rab_distance/r_distance

  id1=atom_kindn_r(i1_do)
  id2=atom_kindn_ccal(j2_count)

  call set_off_rtbh(r_distance,rab_distance,id1,id2                            &
       ,max_atom_orbital,h_ijmn,s_ijmn)

  return
end subroutine off_rtbh_hami_rc

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@             Naoki WATANABE, Nobutaka NISHIKAWA (Mizuho I.R.)   @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine gen_outf
  use ac_misc_module
  use mod_mpi

  implicit none

  Param%Option%file_ac_tempout=file_tempout

  return
end subroutine gen_outf

subroutine Param__read__ASCOT(fname)
  use ac_misc_module
  use scf_negf

  implicit none

  character(len=*) fname

  character(16) :: name
  character(64) :: mode,mode2
  character(256) :: fname_pao,fname_vps
  character(256) :: dummy

  integer :: i,i_c
  real(8) :: polarization_t
  logical :: optimize

  real(8) :: R(3)
  type(Element_type), pointer :: elem

  Param%Option%na = .true.
  optimize = .false.

  open(unit=90,file=fname)

  read(90,*) Param%name

  read(90,*)
  read(90,*) Param%Data%element_type,Param%SCF%exc_type,i_c
  read(90,*) Param%SCF%Te,Param%SCF%Ecutoff

  if( i_c == 0 ) then
     Param%Option%spin_orbit = .false.
     Param%Option%spin_polar = .false.
     ispin_pol_scf=1
     Param%Option%nspin=1
  else
     if( i_c == 1 ) then
        Param%Option%spin_orbit = .false.
        Param%Option%spin_polar = .true.
        ispin_pol_scf=2
        Param%Option%nspin=2
     else
        Param%Option%spin_orbit = .true.
        Param%Option%spin_polar = .true.
        ispin_pol_scf=4
        Param%Option%nspin=4
     end if
  end if

  read(90,*)
  read(90,*) Param%SCF%Nka,Param%SCF%Nkb,Param%SCF%Nkc

  read(90,*)
  read(90,*) Param%Integral1D%Nk,Param%Integral1D%Nr,Param%Integral1D%Ecutoff

  read(90,*)
  read(90,'(a)') dummy
  read(dummy,*,end=100) Param%Data%nelem,mode2
  if( mode2 == 'on' ) then
     Param%Option%projection=.true.
  else
     Param%Option%projection=.false.
  end if
100 continue
  allocate( Param%Data%velem(Param%Data%nelem))
  allocate( Param%Data%velem_file(Param%Data%nelem,5))
  do i=1,Param%Data%nelem
     if( Param%Option%projection ) then
        read(90,*) name,fname_pao,mode,fname_vps,mode2
     else
        read(90,*) name,fname_pao,mode,fname_vps
        mode2=""
     end if

     Param%Data%velem_file(i,1)=name
     Param%Data%velem_file(i,2)=fname_pao
     Param%Data%velem_file(i,3)=mode
     Param%Data%velem_file(i,4)=fname_vps
     Param%Data%velem_file(i,5)=mode2

     select case(Param%Data%element_type)
     case('ciao')
        call Element__readPAO_ciao( Param%Data%velem(i), name, fname_pao, mode, mode2 )
        call Element__readVPS_ciao( Param%Data%velem(i), name, fname_vps )
     case('ciao_ls')
        call Element__readPAO_ciao  ( Param%Data%velem(i), name, fname_pao, mode, mode2 )
        call Element__readVPS_ciao_ls( Param%Data%velem(i), name, fname_vps )
     end select
  end do

  read(90,*)
  read(90,*) Param%Cell%La(:)
  read(90,*) Param%Cell%Lb(:)
  read(90,*) Param%Cell%Lc(:)

  read(90,*)
  read(90,*) Param%Data%natom,Param%Data%natom_left,Param%Data%natom_right
  allocate( Param%Data%vatom(Param%Data%natom) )
  do i=1,Param%Data%natom
     read(90,*) dummy,name,R(:),polarization_t
     if( dummy == dummy ) then
     endif
     elem => Param__Data__getElement( name )
     call Atom__set( Param%Data%vatom(i),name,R                               &
          ,elem%vpao(1)%Rc,-elem%Vloc%Q,elem%atomic_number                 &
          ,polarization_t,optimize )
  end do

  close(90)

  num_atom_scf=Param%Data%natom
  nelem_num=Param%Data%nelem

  numl_atom_scf=Param%Data%natom_left
  numr_atom_scf=Param%Data%natom_right
  numc_atom_scf=num_atom_scf-numr_atom_scf-numl_atom_scf
  xc_type=1

  Param%Option%fname_matrices_in=file_parameter_hc_scf

  if( file_parameter_out_vh0 /= '' ) then
     Param%Option%fname_matrices=file_parameter_out_vh0
  else
     Param%Option%fname_matrices=''
  end if

  return
end subroutine Param__read__ASCOT

subroutine Param__show__ASCOT
  use ac_misc_module

  implicit none

  open(unit=16,file=Param%Option%file_ac_tempout,position='append')
  write(16,*)
  write(16,*)
  write(16,*) '********************** **************** **********************'
  write(16,*) '*                    condition  !  dft  !                    *'
  write(16,*) '********************** **************** **********************'

  call Param__SCF__show__ASCOT
  call Param__Data__show
  close(16)

  return
end subroutine Param__show__ASCOT

subroutine Param__SCF__show__ASCOT
  use ac_misc_module

  implicit none
  character(10) :: chara_temp

  write(16,*)

  write(16,921) Param%SCF%exc_type
921 format('                        Vxc type: ',a)
  write(16,922) Param%SCF%Te*AU_TO_KELVIN
922 format('         electric temperature[K]: ',f10.4)
  write(16,923) Param%SCF%Ecutoff
923 format('  real space energy cutoff[a.u.]: ',f10.4)
  if( Param%Option%spin_polar ) then
     chara_temp='on'
  else
     chara_temp='off'
  end if
  write(16,924) chara_temp
924 format('               spin polarization: ',a)

  if( Param%Option%projection ) then
     chara_temp='on'
  else
     chara_temp='off'
  end if
  write(16,929) chara_temp
929 format('                 Vloc projection: ',a)

  if( Param%Option%cluster ) then
     chara_temp='on'
  else
     chara_temp='off'
  end if
  write(16,928) chara_temp
928 format('                         cluster: ',a)

  write(16,*)
  write(16,*) '=========== one-dimensional integration calculation =========='
  write(16,*)
  write(16,918) Param%Integral1D%Nr
918 format('          real space grid points: ',i10)
  write(16,919) Param%Integral1D%Nr
919 format('          reciprocal grid points: ',i10)
  write(16,920) Param%Integral1D%Ecutoff
920 format('             energy cutoff [a.u]: ',e10.5)

  return
end subroutine Param__SCF__show__ASCOT

subroutine MPI__Initialize__ASCOT
  use ac_mpi_module
  use mod_mpi

  implicit none

  MPI%rank=myrank
  MPI%size=nprocs

  if( MPI%rank == 0 ) then
     MPI%root = .true.
  else
     MPI%root = .false.
  end if

  !!      call MPI_Type_Contiguous(3,MPI_DOUBLE_PRECISION,MPI%DOUBLE_POSITION,MPI%info)
  !!      call MPI_Type_Commit(MPI%DOUBLE_POSITION,MPI%info)
  !!      call MPI_Op_create(MPI__Sum_Position,.true.,MPI%SUM_POSITION,MPI%info)

  call SL_Init( MPI%SL_ID, 1, MPI%size )

  return
end subroutine MPI__Initialize__ASCOT

subroutine Param__setup__ASCOT
  use ac_misc_module
  use scf_negf

  implicit none
  integer :: a,l

  n_a=Param%Cell%Na
  n_b=Param%Cell%Nb
  n_c=Param%Cell%Nc
  num_cell_l=n_a*n_b*n_c

  param_cell_nl=Param%Cell%nL
  call alo_scf_negf_parameter_11
  do l=1,param_cell_nl
     param_cell_vl(l,:)=Param%Cell%vL(:,l-1)
  end do

  cell_labc(1,:)=Param%Cell%La(:)
  cell_labc(2,:)=Param%Cell%Lb(:)
  cell_labc(3,:)=Param%Cell%Lc(:)

  cell_dkabc(1,:)=Param%Cell%dKa(:)
  cell_dkabc(2,:)=Param%Cell%dKb(:)
  cell_dkabc(3,:)=Param%Cell%dKc(:)

  cell_lo(:)=Param%Cell%Lo(:)

  tot_ele_num=0.d0
  do a=1,Param%Data%natom
     atom_name(a)=Param%Data%vatom(a)%name
     atom_name_num(a)=Param%Data%vatom(a)%number
     vatom_q(a)=Param%Data%vatom(a)%Q
     atom_ro(a,:)=Param%Data%vatom(a)%Ro(:)
     atom_rcut(a)=Param%Data%vatom(a)%Rc
     tot_ele_num=tot_ele_num+Param%Data%vatom(a)%Q
  end do

  if( iter_conv == 11 ) then
     Param%SCF%mix_target='density_matrix'
     Param%SCF%mix_type='Simple'
     Param%SCF%mix_history=1
  end if
  if( iter_conv == 12 ) then
     Param%SCF%mix_target='density_matrix'
     Param%SCF%mix_type='Pulay'
     Param%SCF%mix_history=negf_mix_history
     Param%SCF%mix_start=negf_mix_start
  end if
  if( iter_conv == 13 ) then
     Param%SCF%mix_target='density_matrix'
     Param%SCF%mix_type='Anderson'
     Param%SCF%mix_history=3
  end if
  if( iter_conv == 21 ) then
     Param%SCF%mix_target='density'
     Param%SCF%mix_type='Simple'
     Param%SCF%mix_history=1
  end if
  if( iter_conv == 22 ) then
     Param%SCF%mix_target='density'
     Param%SCF%mix_type='Pulay'
     Param%SCF%mix_history=negf_mix_history
     Param%SCF%mix_start=negf_mix_start
  end if
  if( iter_conv == 23 ) then
     Param%SCF%mix_target='density'
     Param%SCF%mix_type='Anderson'
     Param%SCF%mix_history=3
  end if
  Param%SCF%mix_weight=mixing_dm
  Param%SCF%mix_weight_s=mixing_dm_s

  if( force_calc_onoff == 'on' ) then
     Param%Option%optimize=.true.
  else
     Param%Option%optimize=.false.
  end if

  if( Param%Option%projection ) then
     param_option_projection='on'
  else
     param_option_projection='off'
  end if

  return
end subroutine Param__setup__ASCOT

subroutine MPI__setup_ASCOT
  use ac_mpi_module

  implicit none

  call MPI__setup

  return
end subroutine MPI__setup_ASCOT

subroutine Base__setup__ASCOT
  use ac_misc_module
  use scf_negf

  implicit none
  integer :: a

  do a=1,Param%Data%natom
     iatom_orb_num(a)=Base%vnpao(a)
  end do
  base_npao=Base%npao

  return
end subroutine Base__setup__ASCOT

subroutine Density__setup__ASCOT
  use ac_misc_module
  use scf_negf

  implicit none
  integer :: ia,ib,ic

  if( Param%Option%na ) then
     do ia=1,Param%Cell%Na
        do ib=1,Param%Cell%Nb
           do ic=1,Param%Cell%Nc
              rhoval((ia-1)*n_b*n_c+(ib-1)*n_c+(ic-1)+1)=Density%rhoval(ia,ib,ic)
           end do
        end do
     end do
  else
     do ia=1,Param%Cell%Na
        do ib=1,Param%Cell%Nb
           do ic=1,Param%Cell%Nc
              rhoval((ia-1)*n_b*n_c+(ib-1)*n_c+(ic-1)+1)=0.d0
           end do
        end do
     end do
  end if

  if( Param%Option%pcc ) then
     do ia=1,Param%Cell%Na
        do ib=1,Param%Cell%Nb
           do ic=1,Param%Cell%Nc
              rhopcc((ia-1)*n_b*n_c+(ib-1)*n_c+(ic-1)+1)=Density%rhopcc(ia,ib,ic)*.5d0
           end do
        end do
     end do
  else
     do ia=1,Param%Cell%Na
        do ib=1,Param%Cell%Nb
           do ic=1,Param%Cell%Nc
              rhopcc((ia-1)*n_b*n_c+(ib-1)*n_c+(ic-1)+1)=0.d0
           end do
        end do
     end do
  end if

  return
end subroutine Density__setup__ASCOT

subroutine Potential__setup__ASCOT
  use ac_misc_module
  use scf_negf

  implicit none
  integer :: ia,ib,ic

  if( .not. Param%Option%projection ) then
     do ia=1,Param%Cell%Na
        do ib=1,Param%Cell%Nb
           do ic=1,Param%Cell%Nc
              v_ext((ia-1)*n_b*n_c+(ib-1)*n_c+(ic-1)+1)=Potential%Vext(ia,ib,ic)
           end do
        end do
     end do
  else
     do ia=1,Param%Cell%Na
        do ib=1,Param%Cell%Nb
           do ic=1,Param%Cell%Nc
              v_ext((ia-1)*n_b*n_c+(ib-1)*n_c+(ic-1)+1)=0.d0
           end do
        end do
     end do
  end if

  return
end subroutine Potential__setup__ASCOT

subroutine Hamiltonian__setup__ASCOT                                               &
     (num_atom_scf,param_cell_nl,hv_atom_matrix,n_v_atom_matrix,n_v_nim_max)
  use ac_misc_module
  use ac_mpi_module

  implicit none
  integer, intent(in) :: num_atom_scf,param_cell_nl
  integer, intent(inout) :: n_v_atom_matrix,n_v_nim_max
  integer, intent(inout) :: hv_atom_matrix(num_atom_scf,num_atom_scf,0:param_cell_nl-1)

  integer       :: l, a, i, b, j
  integer       :: li, c, k
  logical       :: overlap

  n_v_atom_matrix=0
  n_v_nim_max=0

  do l=0, Param%Cell%nL-1
     do a=MPI%isatom, MPI%ieatom
        i=Base%vipao(a)
        do b=1, Param%Data%natom
           j=Base%vipao(b)
           if( associated(Hamiltonian%vAtomMatrix(b,a,l)%Ptr) ) then
              n_v_atom_matrix=n_v_atom_matrix+1
              hv_atom_matrix(b,a,l)=n_v_atom_matrix
           else
              hv_atom_matrix(b,a,l)=0
           end if
           if( n_v_nim_max < Base%vipao(a)-1 ) then
              n_v_nim_max=Base%vipao(a)-1
           end if
        end do
     end do
  end do

  return
end subroutine Hamiltonian__setup__ASCOT

subroutine Hamiltonian__loadAM_ASCOT
  use ac_misc_module
  use ac_mpi_module

  implicit none
  integer :: l
  integer :: a,i1
  integer :: b,j1
  integer :: iunit
  logical :: ex

  integer :: l_t,a_t,b_t
  integer :: i2,i_temp1,i_temp2,i_temp3,i_temp4,i_temp5
  character(1) :: character_temp(4),a_c(10)
  character(55) :: fname

  real(8) :: temp1,temp2,temp3,temp4

  real(8) :: t_L(3)

  open(unit=16,file=Param%Option%file_ac_tempout,position='append')
  write(16,*) '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'
  write(16,*) '+++++++++++        loading hamiltonian matrices'
  write(16,999) trim(Param%Option%fname_matrices_in)
  write(16,*) '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'
  write(16,*)
999 format(' +++++++++++        read file:: ',a)
  close(16)

  a_c(1)='0'
  a_c(2)='1'
  a_c(3)='2'
  a_c(4)='3'
  a_c(5)='4'
  a_c(6)='5'
  a_c(7)='6'
  a_c(8)='7'
  a_c(9)='8'
  a_c(10)='9'

  do a=MPI%isatom,MPI%ieatom

     i_temp1=a
     do i2=1,4
        i_temp2=i_temp1/(10**(4-i2))
        character_temp(i2)=a_c(i_temp2+1)
        i_temp1=i_temp1-(10**(4-i2))*i_temp2
     end do
     fname=trim(Param%Option%fname_matrices_in)                                 &
          //'_'//character_temp(1)//character_temp(2)                      &
          //character_temp(3)//character_temp(4)
     inquire(file=fname,exist=ex)
     if( .not. ex ) then
        open(unit=16,file=Param%Option%file_ac_tempout,position='append')
        write(16,'(a,a)') '      ++++++ Error!: can not open file ',fname
        close(16)
        stop
     end if

     iunit=1
     open(iunit,file=fname)
     read(iunit,*) i_temp1,i_temp2,i_temp3,i_temp4,i_temp5
     read(iunit,*)
     read(iunit,*)
     read(iunit,*)

     if(i_temp5/=Param%Option%nspin-1) then
        open(unit=16,file=Param%Option%file_ac_tempout,position='append')
        write(16,'(a,a)') '      ++++++ Error!: spin ', fname
        close(16)
        stop
     end if

     do
        read(iunit,*,end=1000)
        read(iunit,*) a_t,l,b_t,i_temp1,i_temp2,i_temp3
        read(iunit,*) t_L
        b = b_t +1

        if(a/=a_t+1) then
           open(unit=16,file=Param%Option%file_ac_tempout,position='append')
           write(16,'(a,a)') '      ++++++ Error!: a ',fname,a,a_t
           close(16)
           stop
        end if
        if( Param%Data%natom < b ) then
           open(unit=16,file=Param%Option%file_ac_tempout,position='append')
           write(16,'(a,a)') '      ++++++ Error!: b ', fname
           close(16)
           stop
        end if
        if(Base%vnpao(a)/=i_temp2) then
           open(unit=16,file=Param%Option%file_ac_tempout,position='append')
           write(16,'(a,a)') '      ++++++ Error!: Base%vnpao(a) ', fname
           close(16)
           stop
        end if
        if(Base%vnpao(b)/=i_temp3) then
           open(unit=16,file=Param%Option%file_ac_tempout,position='append')
           write(16,'(a,a)') '      ++++++ Error!: Base%vnpao(b) ', fname
           close(16)
           stop
        end if

        if( i_temp1 /= 1 ) then
           l=Param%Cell%nL
           do l_t=0, Param%Cell%nL-1
              if( sqrt(dot_product(Param%Cell%vL(:,l_t)-t_L,Param%Cell%vL(:,l_t)-t_L)) < 1.d-8 ) then
                 l=l_t
                 exit
              end if
           end do
           if( Param%Cell%nL-1 < l ) then
              do i1=1, Base%vnpao(a)
                 do j1=1, Base%vnpao(b)
                    if( Param%Option%nspin-1 < 3 ) then
                       read(iunit,*)
                    else
                       read(iunit,*)
                       read(iunit,*)
                       read(iunit,*)
                       read(iunit,*)
                       read(iunit,*)
                       read(iunit,*)
                       read(iunit,*)
                    end if
                 end do
              end do
              cycle
           end if
           if( associated(Hamiltonian%vAtomMatrix(b,a,l)%Ptr) ) then
              do i1=1,Base%vnpao(a)
                 do j1=1,Base%vnpao(b)
                    if( i1 >= MPI%ispao(a) .and. i1 <= MPI%iepao(a) ) then
                       if( Param%Option%nspin-1 == 0 ) then
                          read(iunit,*)                                           &
                               Hamiltonian%vAtomMatrix(b,a,l)%Ptr%S(j1,i1),        &
                               Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0(j1,i1,1),     &
                               Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H(j1,i1,1),      &
                               Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDM(j1,i1,1)
                       else
                          if( Param%Option%nspin-1 == 1 ) then
                             read(iunit,*)                                         &
                                  Hamiltonian%vAtomMatrix(b,a,l)%Ptr%S(j1,i1),        &
                                  Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0(j1,i1,1),     &
                                  Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H(j1,i1,1),      &
                                  Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H(j1,i1,2),      &
                                  Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDM(j1,i1,1),    &
                                  Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDM(j1,i1,2)
                             Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0(j1,i1,2)        &
                                  =Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0(j1,i1,1)
                          else
                             read(iunit,*) Hamiltonian%vAtomMatrix(b,a,l)%Ptr%S(j1,i1)
                             read(iunit,*) temp1,temp2,temp3,temp4
                             Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0LS(j1,i1,1) &
                                  =dcmplx(temp1,temp2)
                             Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0LS(j1,i1,2) &
                                  =dcmplx(temp3,temp4)
                             read(iunit,*) temp1,temp2,temp3,temp4
                             Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0LS(j1,i1,3) &
                                  =dcmplx(temp1,temp2)
                             Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0LS(j1,i1,4) &
                                  =dcmplx(temp3,temp4)
                             read(iunit,*) temp1,temp2,temp3,temp4
                             Hamiltonian%vAtomMatrix(b,a,l)%Ptr%HLS(j1,i1,1)  &
                                  =dcmplx(temp1,temp2)
                             Hamiltonian%vAtomMatrix(b,a,l)%Ptr%HLS(j1,i1,2)  &
                                  =dcmplx(temp3,temp4)
                             read(iunit,*) temp1,temp2,temp3,temp4
                             Hamiltonian%vAtomMatrix(b,a,l)%Ptr%HLS(j1,i1,3)  &
                                  =dcmplx(temp1,temp2)
                             Hamiltonian%vAtomMatrix(b,a,l)%Ptr%HLS(j1,i1,4)  &
                                  =dcmplx(temp3,temp4)
                             read(iunit,*) temp1,temp2,temp3,temp4
                             Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDMLS(j1,i1,1) &
                                  =dcmplx(temp1,temp2)
                             Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDMLS(j1,i1,2) &
                                  =dcmplx(temp3,temp4)
                             read(iunit,*) temp1,temp2,temp3,temp4
                             Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDMLS(j1,i1,3) &
                                  =dcmplx(temp1,temp2)
                             Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDMLS(j1,i1,4) &
                                  =dcmplx(temp3,temp4)
                          end if
                       end if
                    else
                       if( Param%Option%nspin-1 < 3 ) then
                          read(iunit,*)
                       else
                          read(iunit,*)
                          read(iunit,*)
                          read(iunit,*)
                          read(iunit,*)
                          read(iunit,*)
                          read(iunit,*)
                          read(iunit,*)
                       end if
                    end if
                 end do
              end do
           else
              do i1=1, Base%vnpao(a)
                 do j1=1, Base%vnpao(b)
                    if( Param%Option%nspin-1 < 3 ) then
                       read(iunit,*)
                    else
                       read(iunit,*)
                       read(iunit,*)
                       read(iunit,*)
                       read(iunit,*)
                       read(iunit,*)
                       read(iunit,*)
                       read(iunit,*)
                    end if
                 end do
              end do
           end if
        end if

     end do

1000 continue

     close(iunit)
  end do

  return
end subroutine Hamiltonian__loadAM_ASCOT

subroutine Hamiltonian__saveAM_ASCOT
  use ac_misc_module
  use ac_mpi_module

  implicit none
  type(Element_type), pointer :: elem

  integer :: l,a,i1,b,j1
  integer :: iunit

  integer :: i2,i_temp1,i_temp2
  character(1) :: character_temp(4),a_c(10)
  character(55) :: fname

  integer, allocatable :: i_orb(:)
  integer :: i_c,n
  integer :: ispin,i_cyc
  integer :: mat_max_ll,mat_max_rr,mat_max_cc,ele_num_ll,ele_num_rr

  if( .not. Param%Option%spin_polar ) then
     ispin=0
  else
     ispin=1
  end if

  allocate(i_orb(0:Param%Data%natom))

  i_orb(0)=0
  do a=1,Param%Data%natom
     elem => Param__Data__getElement(Param%Data%vatom(a)%name)
     i_c=0
     do n=1,elem%npao
        i_c=i_c+2*(elem%vpao(n)%l)+1
     end do
     i_orb(a)=i_orb(a-1)+i_c
  end do

  if( Param%Option%nspin < 4 ) then
     mat_max_cc=Base%npao
     mat_max_ll=i_orb(Param%Data%natom_left)
     mat_max_rr=Base%npao-i_orb(Param%Data%natom-Param%Data%natom_right)
  else
     mat_max_cc=Base%npao*2
     mat_max_ll=i_orb(Param%Data%natom_left)*2
     mat_max_rr=(Base%npao-i_orb(Param%Data%natom-Param%Data%natom_right))*2
  end if

  ele_num_ll=0
  do a=1,Param%Data%natom_left
     elem => Param__Data__getElement(Param%Data%vatom(a)%name)
     ele_num_ll=ele_num_ll+Param%Data%vatom(a)%Q
  end do
  ele_num_rr=0
  do a=Param%Data%natom-Param%Data%natom_right+1,Param%Data%natom
     elem => Param__Data__getElement(Param%Data%vatom(a)%name)
     ele_num_rr=ele_num_rr+Param%Data%vatom(a)%Q
  end do

  deallocate(i_orb)

  !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++!

  a_c(1)='0'
  a_c(2)='1'
  a_c(3)='2'
  a_c(4)='3'
  a_c(5)='4'
  a_c(6)='5'
  a_c(7)='6'
  a_c(8)='7'
  a_c(9)='8'
  a_c(10)='9'

  do a=1, Param%Data%natom

     i_temp1=a
     do i2=1,4
        i_temp2=i_temp1/(10**(4-i2))
        character_temp(i2)=a_c(i_temp2+1)
        i_temp1=i_temp1-(10**(4-i2))*i_temp2
     end do
     fname=trim(Param%Option%fname_matrices)                                    &
          //'_'//character_temp(1)//character_temp(2)                      &
          //character_temp(3)//character_temp(4)
     iunit=1
     if( MPI%root ) then
        open(iunit,file=fname)
        write(iunit,886)                                                       &
             Param%Data%natom,Param%Data%natom_left,Param%Data%natom_right, &
             Param%Cell%nL,Param%Option%nspin-1,                            &
             mat_max_ll,mat_max_cc,mat_max_rr,ele_num_ll,ele_num_rr
        write(iunit,*) Param%Cell%La(:)
        write(iunit,*) Param%Cell%Lb(:)
        write(iunit,*) Param%Cell%Lc(:)
        close(iunit)
886     format(10i6,'      = natom, nL, mat_max')
     end if

     do l=0, Param%Cell%nL-1
        do b=1, Param%Data%natom

           do i_cyc=0,MPI%size-1
              if( i_cyc == MPI%rank ) then
                 if( a >= MPI%isatom .and. a <= MPI%ieatom ) then

                    if( .not. associated(Hamiltonian%vAtomMatrix(b,a,l)%Ptr) ) then
                       if( MPI%ispao(a) == 0 ) then
                          open(iunit,file=fname,position='append')
                          i_temp1=1
                          write(iunit,*)
                          write(iunit,887) a-1,l,b-1,i_temp1,Base%vnpao(a),Base%vnpao(b)
                          write(iunit,885) Param%Cell%vL(:,l)
                          close(iunit)
                       end if
                       go to 100
                    else
                       if( MPI%ispao(a) == 1 ) then
                          open(iunit,file=fname,position='append')
                          i_temp1=1
                          write(iunit,*)
                          write(iunit,887) a-1,l,b-1,i_temp1,Base%vnpao(a),Base%vnpao(b)
                          write(iunit,885) Param%Cell%vL(:,l)
                          close(iunit)
                       end if
                    end if
887                 format(6i6,'      *****************')
885                 format(3d25.16,'      =vL.x, vL.y, vL. z')

                    do i1=MPI%ispao(a), MPI%iepao(a)

                       open(iunit,file=fname,position='append')
                       do j1=1, Base%vnpao(b)
                          if( Param%Option%nspin-1 == 0 ) then
                             write(iunit,889) &
                                  Hamiltonian%vAtomMatrix(b,a,l)%Ptr%S  (j1,i1),      &
                                  Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0 (j1,i1,1),    &
                                  Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H  (j1,i1,1),    &
                                  Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDM(j1,i1,1)
889                          format(4d25.16)
                          else
                             if( Param%Option%nspin-1 == 1 ) then
                                write(iunit,888) &
                                     Hamiltonian%vAtomMatrix(b,a,l)%Ptr%S(j1,i1),        &
                                     Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0(j1,i1,1),     &
                                     Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H(j1,i1,1),      &
                                     Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H(j1,i1,2),      &
                                     Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDM(j1,i1,1),    &
                                     Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDM(j1,i1,2)
888                             format(6d25.16)
                             else
                                write(iunit,876) &
                                     Hamiltonian%vAtomMatrix(b,a,l)%Ptr%S(j1,i1)
                                write(iunit,877) &
                                     Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0LS(j1,i1,1), &
                                     Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0LS(j1,i1,2)
                                write(iunit,877) &
                                     Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0LS(j1,i1,3), &
                                     Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H0LS(j1,i1,4)
                                write(iunit,877) &
                                     Hamiltonian%vAtomMatrix(b,a,l)%Ptr%HLS(j1,i1,1),  &
                                     Hamiltonian%vAtomMatrix(b,a,l)%Ptr%HLS(j1,i1,2)
                                write(iunit,877) &
                                     Hamiltonian%vAtomMatrix(b,a,l)%Ptr%HLS(j1,i1,3),  &
                                     Hamiltonian%vAtomMatrix(b,a,l)%Ptr%HLS(j1,i1,4)
                                write(iunit,877) &
                                     Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDMLS(j1,i1,1), &
                                     Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDMLS(j1,i1,2)
                                write(iunit,877) &
                                     Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDMLS(j1,i1,3), &
                                     Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDMLS(j1,i1,4)
876                             format(1d25.16)
877                             format(4d25.16)
                             end if
                          end if
                       end do
                       close(iunit)
                    end do
                 end if
              end if
100           continue
              call MPI__Barrier
           end do

        end do
     end do

  end do

  return
end subroutine Hamiltonian__saveAM_ASCOT

subroutine Hamiltonian__rotAM_ASCOT
  use ac_misc_module
  use ac_mpi_module
  use scf_negf

  implicit none
  integer :: l,a,i1,b,j1,i_cont
  real(8) :: del_lc,temp

  del_lc=Param%Cell%Lc(1)/dfloat(Param%Cell%Nc)
  del_lc=del_lc*(n_c*shift_cell_l1/shift_cell_l2)

  do a=MPI%isatom,MPI%ieatom
     do l=0,Param%Cell%nL-1
        do b=1,Param%Data%natom
           if( .not. associated(Hamiltonian%vAtomMatrix(b,a,l)%Ptr) ) then
              cycle
           end if
           i_cont=0
           if( dabs(Param%Data%vatom(a)%Ro(1)-del_lc)                              &
                > dabs(Param%Data%vatom(b)%Ro(1)-del_lc) ) then
              if( i_rotspin_l==1 .and. (Param%Data%vatom(a)%Ro(1)-del_lc)<0.d0 ) then
                 i_cont=1
              end if
              if( i_rotspin_r==1 .and. (Param%Data%vatom(a)%Ro(1)-del_lc)>0.d0 ) then
                 i_cont=-1
              end if
           else
              if( i_rotspin_l==1 .and. (Param%Data%vatom(b)%Ro(1)-del_lc)<0.d0 ) then
                 i_cont=1
              end if
              if( i_rotspin_r==1 .and. (Param%Data%vatom(b)%Ro(1)-del_lc)>0.d0 ) then
                 i_cont=-1
              end if
           end if

           if( i_cont /= 0 ) then
              do i1=MPI%ispao(a), MPI%iepao(a)
                 do j1=1,Base%vnpao(b)
                    temp=Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDM(j1,i1,1)
                    Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDM(j1,i1,1)                  &
                         =Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDM(j1,i1,2)
                    Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDM(j1,i1,2)=temp
                 end do
              end do
           end if

        end do
     end do
  end do

  return
end subroutine Hamiltonian__rotAM_ASCOT

subroutine Hamiltonian__calcAMT__as2ac
  use ac_misc_module
  use scf_negf

  implicit none
  integer :: ia,ib,ic,ispin,gn

  do ispin=1,Param%Option%nspin
     do ia=1,Param%Cell%Na
        do ib=1,Param%Cell%Nb
           do ic=1,Param%Cell%Nc
              gn=(ia-1)*n_b*n_c+(ib-1)*n_c+(ic-1)+1
              Potential%Vtot(ispin,ia,ib,ic)=v_tot_temp(gn,ispin)
              v_tot(gn,ispin)=v_tot_temp(gn,ispin)
           end do
        end do
     end do
  end do

  return
end subroutine Hamiltonian__calcAMT__as2ac

subroutine Hamiltonian__calcD__acbas(temp_rho)
  use ac_misc_module
  use ac_mpi_module
  use scf_negf

  implicit none
  real(8) ::                                                                     &
       temp_rho(Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc,ispin_pol_scf)
  integer :: ia0,ib0,ic0,ispin

  do ic0=1,Param%Cell%Nc
     do ib0=1,Param%Cell%Nb
        do ia0=1,Param%Cell%Na
           do ispin=1,Param%Option%nspin
              temp_rho(ia0,ib0,ic0,ispin) = Density%rho(ispin,ia0,ib0,ic0)
           end do
        end do
     end do
  end do

  return
end subroutine Hamiltonian__calcD__acbas

subroutine Hamiltonian__calcD_ls__acbas(temp_rhols)
  use ac_misc_module
  use ac_mpi_module
  use scf_negf

  implicit none
  complex(8) :: temp_rhols(Param%Cell%Na,Param%Cell%Nb,Param%Cell%Nc,ispin_pol_scf)
  integer :: ia0,ib0,ic0,ispin

  do ic0=1,Param%Cell%Nc
     do ib0=1,Param%Cell%Nb
        do ia0=1,Param%Cell%Na
           temp_rhols(ia0,ib0,ic0,1) = dcmplx(dreal(Density%rhoLS(1,ia0,ib0,ic0)),0.d0)
           temp_rhols(ia0,ib0,ic0,2)  &
                = (Density%rhoLS(2,ia0,ib0,ic0)+dconjg(Density%rhoLS(3,ia0,ib0,ic0)))*.5d0
           temp_rhols(ia0,ib0,ic0,3) = dconjg(temp_rhols(ia0,ib0,ic0,2))
           temp_rhols(ia0,ib0,ic0,4) = dcmplx(dreal(Density%rhoLS(4,ia0,ib0,ic0)),0.d0)
        end do
     end do
  end do

  return
end subroutine Hamiltonian__calcD_ls__acbas

subroutine Hamiltonian__calcD__ac2as
  use ac_misc_module
  use ac_mpi_module
  use scf_negf

  implicit none
  integer :: ia0,ib0,ic0,ispin

  if( Param%Option%nspin < 4 ) then
     do ic0=1,Param%Cell%Nc
        do ib0=1,Param%Cell%Nb
           do ia0=1,Param%Cell%Na
              do ispin=1,Param%Option%nspin
                 Density%rho(ispin,ia0,ib0,ic0)=rho((ia0-1)*n_b*n_c+(ib0-1)*n_c+(ic0-1)+1,ispin)
              end do
           end do
        end do
     end do
  else
     do ic0=1,Param%Cell%Nc
        do ib0=1,Param%Cell%Nb
           do ia0=1,Param%Cell%Na
              do ispin=1,Param%Option%nspin
                 Density%rhoLS(ispin,ia0,ib0,ic0)=rhols((ia0-1)*n_b*n_c+(ib0-1)*n_c+(ic0-1)+1,ispin)
              end do
           end do
        end do
     end do
  end if

  return
end subroutine Hamiltonian__calcD__ac2as

subroutine Hamiltonian__calcD__as2ac(qx_scf,qy_scf,qq_con,kt)
  use ac_misc_module
  use ac_mpi_module
  use scf_negf
  use hamiltonian_temp

  use hamiltonian_c

  implicit none
  integer, intent(in) :: kt
  real(8), intent(in) :: qx_scf,qy_scf,qq_con
  integer :: l,a,b,i1,j1,ispin
  real(8) :: co,sn
  complex(8) :: temp1,temp2
  integer :: i, j

  if( kt == 1 ) then
     do a=MPI%isatom,MPI%ieatom
        do b=1,num_atom_scf
           if( a <= numl_atom_scf .and. b > num_atom_scf-numr_atom_scf ) then
              cycle
           end if
           if( b <= numl_atom_scf .and. a > num_atom_scf-numr_atom_scf ) then
              cycle
           end if
           do l=0,param_cell_nl-1
              if( .not. associated(Hamiltonian%vAtomMatrix(b,a,l)%Ptr) ) then
                 cycle
              end if
              do i1=MPI%ispao(a), MPI%iepao(a)
                 do j1=1,iatom_orb_num(b)
                    if( Param%Option%nspin < 4 ) then
                       do ispin=1,Param%Option%nspin
                          Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDM(j1,i1,ispin)=0.d0
                       end do
                       if( Param%Option%optimize ) then
                          Hamiltonian%vAtomMatrix(b,a,l)%Ptr%EDM(j1,i1)=0.d0
                       end if
                    else
                       do ispin=1,Param%Option%nspin
                          Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDMLS(j1,i1,ispin)=dcmplx(0.d0,0.d0)
                       end do
                       if( Param%Option%optimize ) then
                          Hamiltonian%vAtomMatrix(b,a,l)%Ptr%EDMLS(j1,i1)=0.d0
                       end if
                    end if
                 end do
              end do
           end do
        end do
     end do
  end if

  do a=MPI%isatom,MPI%ieatom
     do b=1,num_atom_scf
        if( a <= numl_atom_scf .and. b > num_atom_scf-numr_atom_scf ) then
           cycle
        end if
        if( b <= numl_atom_scf .and. a > num_atom_scf-numr_atom_scf ) then
           cycle
        end if
        do l=0,param_cell_nl-1
           if( .not. associated(Hamiltonian%vAtomMatrix(b,a,l)%Ptr) ) then
              cycle
           end if
           co=dcos(-qx_scf*rac_c(2,l+1)-qy_scf*rac_c(3,l+1))                    &
                *qq_con/dfloat(kt_num)
           sn=dsin(-qx_scf*rac_c(2,l+1)-qy_scf*rac_c(3,l+1))                    &
                *qq_con/dfloat(kt_num)
           do i1=MPI%ispao(a), MPI%iepao(a)
              do j1=1,iatom_orb_num(b)
                 i = i_orb(a)+i1
                 j = i_orb(b)+j1
                 if( Param%Option%nspin < 4 ) then
                    do ispin=1,Param%Option%nspin
                       Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDM(j1,i1,ispin)          &
                            =Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDM(j1,i1,ispin)    &
                            +dens(ispin,j,i)*co - dens2(ispin,j,i)*sn
                       if( Param%Option%optimize ) then
                          Hamiltonian%vAtomMatrix(b,a,l)%Ptr%EDM(j1,i1)              &
                               =Hamiltonian%vAtomMatrix(b,a,l)%Ptr%EDM(j1,i1)            &
                               +edens(ispin,j,i)*co*EV_TO_AU &
                               -edens2(ispin,j,i)*sn*EV_TO_AU
                       end if
                    end do
                 else
                    temp1=dcmplx(co,sn)
                    temp2                                                          &
                         =dcmplx(dens(1,j*2-1,i*2-1) &
                         ,dens2(1,j*2-1,i*2-1))
                    Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDMLS(j1,i1,1)              &
                         =Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDMLS(j1,i1,1)        &
                         +temp1*temp2
                    temp2                                                          &
                         =dcmplx(dens(1,j*2-1,i*2)   &
                         ,dens2(1,j*2-1,i*2))
                    Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDMLS(j1,i1,2)              &
                         =Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDMLS(j1,i1,2)        &
                         +temp1*temp2
                    temp2                                                          &
                         =dcmplx(dens(1,j*2,i*2-1)   &
                         ,dens2(1,j*2,i*2-1))
                    Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDMLS(j1,i1,3)              &
                         =Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDMLS(j1,i1,3)        &
                         +temp1*temp2
                    temp2                                                          &
                         =dcmplx(dens(1,j*2,i*2)     &
                         ,dens2(1,j*2,i*2))
                    Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDMLS(j1,i1,4)              &
                         =Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDMLS(j1,i1,4)        &
                         +temp1*temp2

                    if( Param%Option%optimize ) then
                       temp1=dcmplx(co,sn)*EV_TO_AU
                       temp2                                                        &
                            =dcmplx(edens(1,j*2-1,i*2-1) &
                            ,edens2(1,j*2-1,i*2-1)) &
                            +dcmplx(edens(1,j*2,i*2)     &
                            ,edens2(1,j*2,i*2))
                       Hamiltonian%vAtomMatrix(b,a,l)%Ptr%EDMLS(j1,i1)              &
                            =Hamiltonian%vAtomMatrix(b,a,l)%Ptr%EDMLS(j1,i1)          &
                            +dreal(temp1*temp2)
                    end if
                 end if
              end do
           end do
        end do
     end do
  end do

  return
end subroutine Hamiltonian__calcD__as2ac

subroutine Hamiltonian__delDM(dif_max_rho,rho_max)
  use ac_misc_module
  use ac_mpi_module
  use scf_negf
  use mod_mpi
  use hamiltonian_c

  implicit none
  real(8), intent(out) :: dif_max_rho,rho_max

  real(8), allocatable :: rho_temp1(:,:),rho_temp2(:,:)
  integer :: ier,i_temp,i1_do,i2_do

  integer :: a,b,l,i1,j1,ispin

  dif_max_rho=0.d0

  do a=MPI%isatom,MPI%ieatom
     do b=1,num_atom_scf
        if( a <= numl_atom_scf .and. b > num_atom_scf-numr_atom_scf ) then
           cycle
        end if
        if( b <= numl_atom_scf .and. a > num_atom_scf-numr_atom_scf ) then
           cycle
        end if
        do l=0,param_cell_nl-1
           if( .not. associated(Hamiltonian%vAtomMatrix(b,a,l)%Ptr) ) then
              cycle
           end if
           do i1=MPI%ispao(a), MPI%iepao(a)
              do j1=1,iatom_orb_num(b)
                 do ispin=1,Param%Option%nspin
                    if( Param%Option%nspin < 4 ) then
                       if( dif_max_rho                                                 &
                            < dabs(Hamiltonian%vAtomMatrix(b,a,l)%Ptr%vpast(1)%dCDM(j1,i1,ispin)) ) &
                            then
                          dif_max_rho                                                   &
                               =dabs(Hamiltonian%vAtomMatrix(b,a,l)%Ptr%vpast(1)%dCDM(j1,i1,ispin))
                          rho_max=Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDM(j1,i1,ispin)
                       end if
                    else
                       if( dif_max_rho                                                 &
                            < cdabs(Hamiltonian%vAtomMatrix(b,a,l)%Ptr%vpast(1)%dCDMLS(j1,i1,ispin)) ) &
                            then
                          dif_max_rho                                                   &
                               =cdabs(Hamiltonian%vAtomMatrix(b,a,l)%Ptr%vpast(1)%dCDMLS(j1,i1,ispin))
                          rho_max=cdabs(Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDMLS(j1,i1,ispin))
                       end if
                    end if
                 end do
              end do
           end do
        end do
     end do
  end do


  allocate(rho_temp1(2,MPI%size),rho_temp2(2,MPI%size),stat=ier)
  if( ier /= 0 ) then
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,*) 'error allocate'
     close(16)
     stop
  end if
  do i2_do=1,MPI%size
     do i1_do=1,2
        rho_temp1(i1_do,i2_do)=0.d0
        rho_temp2(i1_do,i2_do)=0.d0
     end do
  end do
  rho_temp1(1,MPI%rank+1)=dif_max_rho
  rho_temp1(2,MPI%rank+1)=rho_max
  i_temp=2*MPI%size
  call MPI_ALLREDUCE(rho_temp1,rho_temp2,i_temp,MPI_DOUBLE_PRECISION,MPI_SUM  &
       ,mpi_comm_world,ier)
  dif_max_rho=0.d0
  do i2_do=1,MPI%size
     if( dif_max_rho < rho_temp2(1,i2_do) ) then
        dif_max_rho=rho_temp2(1,i2_do)
        rho_max=rho_temp2(2,i2_do)
     end if
  end do
  deallocate(rho_temp1,rho_temp2,stat=ier)
  if( ier /= 0 ) then
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,*) 'error deallocate:'
     close(16)
     stop
  end if

  return
end subroutine Hamiltonian__delDM

subroutine Hamiltonian__delDR(dif_max_rho,rho_max)
  use ac_misc_module
  use ac_mpi_module
  use scf_negf
  use mod_mpi
  use hamiltonian_c

  implicit none
  real(8), intent(out) :: dif_max_rho,rho_max

  real(8), allocatable :: rho_temp1(:,:),rho_temp2(:,:)
  integer :: ier,i_temp,i1_do,i2_do

  integer :: ispin,ia0,ib0,ic0

  dif_max_rho=0.d0

  do ic0=1,Param%Cell%Nc
     if( ic0 > l_cell_l_bound .and. ic0 < r_cell_l_bound ) then
        do ib0=1,Param%Cell%Nb
           do ia0=1,Param%Cell%Na
              do ispin=1,Param%Option%nspin
                 if( Param%Option%nspin < 4 ) then
                    if( dif_max_rho < dabs(Density%vpast(1)%drho(ispin,ia0,ib0,ic0)) ) then
                       dif_max_rho=dabs(Density%vpast(1)%drho(ispin,ia0,ib0,ic0))
                       rho_max=Density%rho(ispin,ia0,ib0,ic0)
                    end if
                 else
                    if( dif_max_rho < cdabs(Density%vpast(1)%drhoLS(ispin,ia0,ib0,ic0)) ) then
                       dif_max_rho=cdabs(Density%vpast(1)%drhoLS(ispin,ia0,ib0,ic0))
                       rho_max=cdabs(Density%rhoLS(ispin,ia0,ib0,ic0))
                    end if
                 end if
              end do
           end do
        end do
     end if
  end do


  allocate(rho_temp1(2,MPI%size),rho_temp2(2,MPI%size),stat=ier)
  if( ier /= 0 ) then
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,*) 'error allocate'
     close(16)
     stop
  end if
  do i2_do=1,MPI%size
     do i1_do=1,2
        rho_temp1(i1_do,i2_do)=0.d0
        rho_temp2(i1_do,i2_do)=0.d0
     end do
  end do
  rho_temp1(1,MPI%rank+1)=dif_max_rho
  rho_temp1(2,MPI%rank+1)=rho_max
  i_temp=2*MPI%size
  call MPI_ALLREDUCE(rho_temp1,rho_temp2,i_temp,MPI_DOUBLE_PRECISION,MPI_SUM  &
       ,mpi_comm_world,ier)
  dif_max_rho=0.d0
  do i2_do=1,MPI%size
     if( dif_max_rho < rho_temp2(1,i2_do) ) then
        dif_max_rho=rho_temp2(1,i2_do)
        rho_max=rho_temp2(2,i2_do)
     end if
  end do
  deallocate(rho_temp1,rho_temp2,stat=ier)
  if( ier /= 0 ) then
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,*) 'error deallocate:'
     close(16)
     stop
  end if

  return
end subroutine Hamiltonian__delDR

subroutine set_ham_scf_ham_c(qx_scf,qy_scf)

  use ac_misc_module
  use ac_mpi_module

  use scf_negf
  use mod_mpi
  use hamiltonian_c
  use hamiltonian_sgf
  use hamiltonian_temp
  use constant

  implicit none
  real(8), intent(in) :: qx_scf,qy_scf

  complex(8), allocatable :: h_temp1(:,:,:),h_temp2(:,:,:)
  complex(8) :: const
  integer :: ier,i_temp,i1_do,i2_do,i3_do

  integer :: a,i1
  integer :: l,b,j1
  integer :: i_do,j_do,ispin,ic_spin
  real(8) :: co,sn
  integer :: i, j

  if( ispin_pol_scf == 2 ) then
     ic_spin=2
  else
     ic_spin=1
  end if

  do i_do=1,m_mat_max_c
     do j_do=1,m_mat_max_c
        do ispin=1,ic_spin
           h_cc_scf(ispin,i_do,j_do)=dcmplx(0.d0,0.d0)
        end do
        s_cc_scf(i_do,j_do)=dcmplx(0.d0,0.d0)
     end do
  end do

  do a=MPI%isatom,MPI%ieatom
     do b=1,num_atom_scf
        if( a <= numl_atom_scf .and. b > num_atom_scf-numr_atom_scf ) then
           cycle
        end if
        if( b <= numl_atom_scf .and. a > num_atom_scf-numr_atom_scf ) then
           cycle
        end if
        do l=0,param_cell_nl-1
           if( .not. associated(Hamiltonian%vAtomMatrix(b,a,l)%Ptr) ) then
              cycle
           end if
           co=dcos(qx_scf*rac_c(2,l+1)+qy_scf*rac_c(3,l+1))
           sn=dsin(qx_scf*rac_c(2,l+1)+qy_scf*rac_c(3,l+1))
           if( l /= 0 ) then
              const=dcmplx(co,sn)
           else
              const=dcmplx(.5d0*co,.5d0*sn)
           end if
           do i1=MPI%ispao(a), MPI%iepao(a)
              do j1=1,iatom_orb_num(b)
                 i = i_orb(a)+i1
                 j = i_orb(b)+j1
                 if( Param%Option%nspin < 4 ) then
                    do ispin=1,Param%Option%nspin
                       h_cc_scf(ispin,j,i)               &
                            =h_cc_scf(ispin,j,i)         &
                            +Hamiltonian%vAtomMatrix(b,a,l)%Ptr%H(j1,i1,ispin)*const
                    end do
                    s_cc_scf(j,i)                       &
                         =s_cc_scf(j,i)                 &
                         +Hamiltonian%vAtomMatrix(b,a,l)%Ptr%S(j1,i1)*const
                 else
                    h_cc_scf(1,j*2-1,i*2-1)         &
                         =h_cc_scf(1,j*2-1,i*2-1)   &
                         +Hamiltonian%vAtomMatrix(b,a,l)%Ptr%HLS(j1,i1,1)*const
                    h_cc_scf(1,j*2-1,i*2)           &
                         =h_cc_scf(1,j*2-1,i*2)     &
                         +Hamiltonian%vAtomMatrix(b,a,l)%Ptr%HLS(j1,i1,2)*const
                    h_cc_scf(1,j*2,i*2-1)           &
                         =h_cc_scf(1,j*2,i*2-1)     &
                         +Hamiltonian%vAtomMatrix(b,a,l)%Ptr%HLS(j1,i1,3)*const
                    h_cc_scf(1,j*2,i*2)             &
                         =h_cc_scf(1,j*2,i*2)       &
                         +Hamiltonian%vAtomMatrix(b,a,l)%Ptr%HLS(j1,i1,4)*const
                    s_cc_scf(j*2-1,i*2-1)           &
                         =s_cc_scf(j*2-1,i*2-1)     &
                         +Hamiltonian%vAtomMatrix(b,a,l)%Ptr%S(j1,i1)*const
                    s_cc_scf(j*2,i*2)               &
                         =s_cc_scf(j*2,i*2)         &
                         +Hamiltonian%vAtomMatrix(b,a,l)%Ptr%S(j1,i1)*const
                 end if
              end do
           end do
        end do
     end do
  end do


  allocate(h_temp1(ic_spin+1,m_mat_max_c,m_mat_max_c)                         &
       ,h_temp2(ic_spin+1,m_mat_max_c,m_mat_max_c),stat=ier)
  if( ier /= 0 ) then
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,*) 'error allocate:'
     close(16)
     stop
  end if
  do i3_do=1,m_mat_max_c
     do i2_do=1,m_mat_max_c
        do i1_do=1,ic_spin
           h_temp1(i1_do,i2_do,i3_do)=h_cc_scf(i1_do,i2_do,i3_do)
           h_temp2(i1_do,i2_do,i3_do)=dcmplx(0.d0,0.d0)
        end do
        h_temp1(ic_spin+1,i2_do,i3_do)=s_cc_scf(i2_do,i3_do)
        h_temp2(ic_spin+1,i2_do,i3_do)=dcmplx(0.d0,0.d0)
     end do
  end do
  i_temp=(ic_spin+1)*m_mat_max_c*m_mat_max_c
  call MPI_ALLREDUCE(h_temp1,h_temp2,i_temp,MPI_DOUBLE_COMPLEX,MPI_SUM        &
       ,mpi_comm_world,ier)
  do i3_do=1,m_mat_max_c
     do i2_do=1,m_mat_max_c
        do i1_do=1,ic_spin
           h_cc_scf(i1_do,i2_do,i3_do)=h_temp2(i1_do,i2_do,i3_do)
        end do
        s_cc_scf(i2_do,i3_do)=h_temp2(ic_spin+1,i2_do,i3_do)
     end do
  end do
  deallocate(h_temp1,h_temp2,stat=ier)
  if( ier /= 0 ) then
     open(unit=16,file=Param%Option%file_ac_tempout,position='append')
     write(16,*) 'error deallocate:'
     close(16)
     stop
  end if

  do i3_do=1,m_mat_max_c
     do i2_do=i3_do,m_mat_max_c
        do i1_do=1,ic_spin
           h_cc_scf(i1_do,i2_do,i3_do)                                           &
                =(h_cc_scf(i1_do,i2_do,i3_do)+dconjg(h_cc_scf(i1_do,i3_do,i2_do))) &
                *ene_scale
           h_cc_scf(i1_do,i3_do,i2_do)=dconjg(h_cc_scf(i1_do,i2_do,i3_do))
        end do
        s_cc_scf(i2_do,i3_do)=s_cc_scf(i2_do,i3_do)                           &
             +dconjg(s_cc_scf(i3_do,i2_do))
        s_cc_scf(i3_do,i2_do)=dconjg(s_cc_scf(i2_do,i3_do))
     end do
  end do


  if( ispin_pol_scf < 4 ) then
     do j_do=1,m_mat_max_c
        do i_do=1,m_mat_max_c
           if( i_do <= i_orb(atom_parlay_l*lay_shift_l+1)                       &
                .and. j_do <= i_orb(atom_parlay_l*lay_shift_l+1) ) then
              do ispin=1,ic_spin
                 h_cc_scf(ispin,i_do,j_do)=h00_l_t(ispin,i_do,j_do)
              end do
              s_cc_scf(i_do,j_do)=s00_l_t(i_do,j_do)
              cycle
           end if
           if( i_do > i_orb(num_atom_scf-atom_parlay_r*lay_shift_r+1) .and.     &
                j_do > i_orb(num_atom_scf-atom_parlay_r*lay_shift_r+1) ) then
              do ispin=1,ic_spin
                 h_cc_scf(ispin,i_do,j_do)                                        &
                      =h00_r_t(ispin,mat_max_rr-m_mat_max_c+i_do                 &
                      ,mat_max_rr-m_mat_max_c+j_do)
              end do
              s_cc_scf(i_do,j_do)=s00_r_t(mat_max_rr-m_mat_max_c+i_do            &
                   ,mat_max_rr-m_mat_max_c+j_do)
              cycle
           end if
        end do
     end do
  else
     do j_do=1,m_mat_max_c
        do i_do=1,m_mat_max_c
           if( i_do <= i_orb(atom_parlay_l*lay_shift_l+1)*2 .and.               &
                j_do <= i_orb(atom_parlay_l*lay_shift_l+1)*2 ) then
              h_cc_scf(1,i_do,j_do)=h00_l_t(1,i_do,j_do)
              s_cc_scf(i_do,j_do)=s00_l_t(i_do,j_do)
              cycle
           end if
           if( i_do > i_orb(num_atom_scf-atom_parlay_r*lay_shift_r+1)*2 .and.   &
                j_do > i_orb(num_atom_scf-atom_parlay_r*lay_shift_r+1)*2 ) then
              h_cc_scf(1,i_do,j_do)                                              &
                   =h00_r_t(1,mat_max_rr-m_mat_max_c+i_do                 &
                   ,mat_max_rr-m_mat_max_c+j_do)
              s_cc_scf(i_do,j_do)=s00_r_t(mat_max_rr-m_mat_max_c+i_do            &
                   ,mat_max_rr-m_mat_max_c+j_do)
              cycle
           end if
        end do
     end do
  end if

  return
end subroutine set_ham_scf_ham_c

subroutine calc_charge_open
  use scf_negf
  use ac_misc_module
  use ac_mpi_module

  implicit none
  real(8), allocatable :: ca(:,:),ca_sen(:,:),ca_rec(:,:)
  real(8) :: sum_u,sum_d
  real(8) :: const
  integer :: l,a,b,i1,j1,i_temp,ispin

  if( Param%Option%nspin == 4 ) then
     call calc_charge_open_ls
     return
  end if

  allocate( ca(2,Param%Data%natom) )
  do a=1,Param%Data%natom
     do ispin=1,2
        ca(ispin,a)=0.d0
     end do
  end do

  do l=0,Param%Cell%nL-1
     do a=MPI%isatom,MPI%ieatom
        do b=1,Param%Data%natom
           if( .not. associated(Hamiltonian%vAtomMatrix(b,a,l)%Ptr) ) then
              cycle
           end if
           do i1=MPI%ispao(a), MPI%iepao(a)
              do j1=1,Base%vnpao(b)
                 do ispin=1,Param%Option%nspin
                    ca(ispin,a)                                                          &
                         =ca(ispin,a)+Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDM(j1,i1,ispin)  &
                         *Hamiltonian%vAtomMatrix(b,a,l)%Ptr%S(j1,i1)
                    if( l > 0 ) then
                       ca(ispin,b)                                                        &
                            =ca(ispin,b)+Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDM(j1,i1,ispin)  &
                            *Hamiltonian%vAtomMatrix(b,a,l)%Ptr%S(j1,i1)
                    end if
                 end do
              end do
           end do
        end do
     end do
  end do

  if( Param%Option%nspin == 1 ) then
     do a=MPI%isatom,MPI%ieatom
        ca(2,a)=ca(1,a)
     end do
  end if

  allocate(ca_sen(2,Param%Data%natom))
  allocate(ca_rec(2,Param%Data%natom))
  do a=1,Param%Data%natom
     do ispin=1,2
        ca_sen(ispin,a)=ca(ispin,a)
        ca_rec(ispin,a)=0.d0
     end do
  end do
  i_temp=2*Param%Data%natom
  call MPI_ALLREDUCE(ca_sen,ca_rec,i_temp,MPI_DOUBLE_PRECISION,MPI_SUM         &
       ,MPI_COMM_WORLD,MPI%info)
  do a=1,Param%Data%natom
     do ispin=1,2
        ca(ispin,a)=ca_rec(ispin,a)
     end do
  end do
  deallocate(ca_sen)
  deallocate(ca_rec)

  if( MPI%root ) then
     sum_u=0.d0
     sum_d=0.d0
     open(unit=37,file='charge_open.dat')
     write(37,*)                                                              &
          '--------------------------------------------------------------'
     write(37,*) '------------   Charge:'
     write(37,*)                                                              &
          '--------------------------------------------------------------'
     write(37,*)                                                              &
          '   number    up             down           total          diff'
     do a=numl_atom_scf,num_atom_scf-numr_atom_scf-1
        write(37,980) a,ca(1,a),ca(2,a),ca(1,a)+ca(2,a),ca(1,a)-ca(2,a)
980     format(5x,i5,4f15.6)
     end do
     write(37,*)                                                              &
          '--------------------------------------------------------------'
981  format(10x,4f15.6)
     close(37)
  end if

  deallocate(ca)

  return
end subroutine calc_charge_open

subroutine calc_charge_open_ls
  use scf_negf
  use ac_misc_module
  use ac_mpi_module

  implicit none
  complex(8), allocatable :: ca(:,:),ca_sen(:,:),ca_rec(:,:)
  real(8) :: sum_u,sum_d,sum_x,sum_y
  real(8) :: const
  integer :: l,a,b,i1,j1,i_temp,ispin

  allocate( ca(4,Param%Data%natom) )
  do a=1,Param%Data%natom
     do ispin=1,4
        ca(ispin,a)=dcmplx(0.d0,0.d0)
     end do
  end do
  const=0.5d0

  do l=0,Param%Cell%nL-1
     do a=MPI%isatom,MPI%ieatom
        do b=1,Param%Data%natom
           if( .not. associated(Hamiltonian%vAtomMatrix(b,a,l)%Ptr) ) then
              cycle
           end if
           do i1=MPI%ispao(a), MPI%iepao(a)
              do j1=1,Base%vnpao(b)
                 do ispin=1,4
                    ca(ispin,a)                                                      &
                         =ca(ispin,a)                                                  &
                         +Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDMLS(j1,i1,ispin)        &
                         *Hamiltonian%vAtomMatrix(b,a,l)%Ptr%S(j1,i1)*const
                    if( l > 0 ) then
                       ca(ispin,b)                                                    &
                            =ca(ispin,b)                                                  &
                            +Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDMLS(j1,i1,ispin)        &
                            *Hamiltonian%vAtomMatrix(b,a,l)%Ptr%S(j1,i1)*const
                    end if
                 end do
              end do
           end do
        end do
     end do
  end do

  allocate(ca_sen(4,Param%Data%natom))
  allocate(ca_rec(4,Param%Data%natom))
  do a=1,Param%Data%natom
     do ispin=1,4
        ca_sen(ispin,a)=ca(ispin,a)
        ca_rec(ispin,a)=dcmplx(0.d0,0.d0)
     end do
  end do
  i_temp=4*Param%Data%natom
  call MPI_ALLREDUCE(ca_sen,ca_rec,i_temp,MPI_DOUBLE_COMPLEX,MPI_SUM           &
       ,MPI_COMM_WORLD,MPI%info)
  do a=1,Param%Data%natom
     do ispin=1,4
        ca(ispin,a)=ca_rec(ispin,a)
     end do
  end do
  deallocate(ca_sen)
  deallocate(ca_rec)

  do a=1,Param%Data%natom
     ca(1,a)=ca(1,a)+dconjg(ca(1,a))
     ca(2,a)=ca(2,a)+dconjg(ca(3,a))
     ca(3,a)=dconjg(ca(2,a))
     ca(4,a)=ca(4,a)+dconjg(ca(4,a))
  end do

  if( MPI%root ) then
     sum_u=0.d0
     sum_d=0.d0
     sum_x=0.d0
     sum_y=0.d0
     open(unit=37,file='charge_open.dat')
     write(37,*)                                                              &
          '--------------------------------------------------------------'
     write(37,*) '------------   Charge:'
     write(37,*)                                                              &
          '--------------------------------------------------------------'
     write(37,*)                                                              &
          '   number    total          Mz             Mx             My'
     do a=numl_atom_scf,num_atom_scf-numr_atom_scf-1
        write(37,980) a,dreal(ca(1,a))+dreal(ca(4,a))                        &
             ,dreal(ca(1,a))-dreal(ca(4,a))                        &
             ,dreal(ca(2,a)+ca(3,a))                               &
             ,dimag(ca(2,a)-ca(3,a))
980     format(5x,i5,4f15.6)
     end do
     write(37,*)                                                              &
          '--------------------------------------------------------------'
981  format(10x,4f15.6)
     close(37)
  end if

  deallocate(ca)

  return
end subroutine calc_charge_open_ls

subroutine Force__calc__negf
  use ac_misc_module
  use ac_mpi_module
  use scf_negf

  implicit none
  integer :: a, b, l, i1, j1, ia0, ib0, ic0, ispin

  open(unit=16,file=Param%Option%file_ac_tempout,position='append')
  write(16,*)
  write(16,*) '**************************************************************'
  write(16,*) '************ start calculating forces on each atom'
  write(16,*) '**************************************************************'
  close(16)

  if( .not. Param%Option%spin_polar ) then
     do a=MPI%isatom,MPI%ieatom
        do b=1,Param%Data%natom
           do l=0,Param%Cell%nL-1
              if( .not. associated(Hamiltonian%vAtomMatrix(b,a,l)%Ptr) ) then
                 cycle
              end if
              do i1=MPI%ispao(a), MPI%iepao(a)
                 do j1=1, Base%vnpao(b)
                    Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDM(j1,i1,1)                &
                         =Hamiltonian%vAtomMatrix(b,a,l)%Ptr%CDM(j1,i1,1)*2.d0
                    if( Param%Option%optimize ) then
                       Hamiltonian%vAtomMatrix(b,a,l)%Ptr%EDM(j1,i1)                &
                            =Hamiltonian%vAtomMatrix(b,a,l)%Ptr%EDM(j1,i1)*2.d0
                    end if
                 end do
              end do
           end do
        end do
     end do
  end if

  do ic0=1,Param%Cell%Nc
     do ib0=1,Param%Cell%Nb
        do ia0=1,Param%Cell%Na
           Potential%dVhar(ia0,ib0,ic0) = v_hartree((ia0-1)*n_b*n_c+(ib0-1)*n_c+(ic0-1)+1)
           do ispin=1,Param%Option%nspin
              if( Param%Option%nspin == 1 ) then
                 Density%rho(ispin,ia0,ib0,ic0)                                         &
                      =rho_temp((ia0-1)*n_b*n_c+(ib0-1)*n_c+(ic0-1)+1,ispin)*2.d0
              else
                 if( Param%Option%nspin == 2 ) then
                    Density%rho(ispin,ia0,ib0,ic0)                                       &
                         =rho_temp((ia0-1)*n_b*n_c+(ib0-1)*n_c+(ic0-1)+1,ispin)
                 else
                    Density%rhoLS(ispin,ia0,ib0,ic0)                                     &
                         =rhols_temp(ia0*n_b*n_c+ib0*n_c+ic0+1,ispin)
                 end if
              end if
              Potential%Vtot(ispin,ia0,ib0,ic0)=v_tot((ia0-1)*n_b*n_c+(ib0-1)*n_c+(ic0-1)+1,ispin)
              if( .not. Param%Option%projection ) then
                 if( Param%Option%nspin < 2 ) then
                    Potential%Vexc(ispin,ia0,ib0,ic0)                                    &
                         = Potential%Vtot(ispin,ia0,ib0,ic0)                            &
                         - Potential%dVhar(ia0,ib0,ic0)-Potential%Vext(ia0,ib0,ic0)
                 else
                    if( ispin == 1 .or. ispin == 4 ) then
                       Potential%Vexc(ispin,ia0,ib0,ic0)                                  &
                            = Potential%Vtot(ispin,ia0,ib0,ic0)                         &
                            - Potential%dVhar(ia0,ib0,ic0)-Potential%Vext(ia0,ib0,ic0)
                    else
                       Potential%Vexc(ispin,ia0,ib0,ic0)                                  &
                            = Potential%Vtot(ispin,ia0,ib0,ic0)
                    end if
                 end if
              end if
           end do
        end do
     end do
  end do

  do a=1, Param%Data%natom
     Param%Data%vatom(a)%force = 0.d0
  end do

  call Force__calcSK
  call Force__calcT
  call Force__calcN
  if( Param%Option%projection ) then
     call Force__calcL
  end if
  call Force__calcI
  call Force__calcQ

  call MPI__Allreduce_Force( Param%Data%vatom )

  call Force__show__negf

  return
end subroutine Force__calc__negf

subroutine Force__show__negf
  use ac_misc_module
  use ac_mpi_module
  use scf_negf

  implicit none
  integer :: a

  if( MPI%root ) then
     open(unit=60,file='force_negf.dat')
     write(60,*) '--------------------------------------------------------------'
     write(60,*) '------------   Atoms:'
     write(60,*) '--------------------------------------------------------------'

     write(60,*) ' atom    Force'
     do a=numl_atom_scf+1,num_atom_scf-numr_atom_scf
        write(60,933) a,Param%Data%vatom(a)%name,                              &
             Param%Data%vatom(a)%force
     end do

     write(60,*) '--------------------------------------------------------------'
     write(60,*)
     close(60)
  end if
933 format(i4,'  ',a2,6f20.15)

  open(unit=16,file=Param%Option%file_ac_tempout,position='append')
  write(16,*) '--------------------------------------------------------------'
  write(16,*) '------------   Atoms:'
  write(16,*) '--------------------------------------------------------------'

  write(16,*) ' atom   Ro                            Force'
  do a=numl_atom_scf+1,num_atom_scf-numr_atom_scf
     write(16,932) a,Param%Data%vatom(a)%name,                              &
          Param%Data%vatom(a)%Ro*AU_TO_AA, Param%Data%vatom(a)%force
  end do

  write(16,*) '--------------------------------------------------------------'
  write(16,*)
932 format(i4,'  ',a2,6f10.5)
  close(16)

  return
end subroutine Force__show__negf

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

subroutine make_scf_ksampling_scf

  use scf_negf
  use constant
  use mod_mpi

  implicit none
  integer :: i1_do,i2_do,i3_do,i_temp
  real(8) :: temp,v_temp_a(3),v_temp_b(3)

  pai=datan(1.d0)*4.d0

  kt_num=ka_scf*kb_scf

  call alo_scf_negf_kpoint

  !                       ------------------------------------                       !

  temp=cell_labc(1,2)*cell_labc(2,3)-cell_labc(1,3)*cell_labc(2,2)
  temp=2.d0*pai/temp

  v_temp_a(1)= 0.d0
  v_temp_a(2)= cell_labc(2,3)*temp
  v_temp_a(3)=-cell_labc(2,2)*temp
  v_temp_b(1)= 0.d0
  v_temp_b(2)=-cell_labc(1,3)*temp
  v_temp_b(3)= cell_labc(1,2)*temp

  i_temp=(ka_scf-mod(ka_scf,2))/2
  i_temp=0
  do i1_do=1,ka_scf
     po_ka_scf(1,i1_do)=0.d0
     po_ka_scf(2,i1_do)=v_temp_a(2)                                             &
          *.5d0*dfloat(2*(i1_do+i_temp)-ka_scf-1)/dfloat(ka_scf)
     po_ka_scf(3,i1_do)=v_temp_a(3)                                             &
          *.5d0*dfloat(2*(i1_do+i_temp)-ka_scf-1)/dfloat(ka_scf)
  end do
  i_temp=(kb_scf-mod(kb_scf,2))/2
  i_temp=0
  do i1_do=1,kb_scf
     po_kb_scf(1,i1_do)=0.d0
     po_kb_scf(2,i1_do)=v_temp_b(2)                                             &
          *.5d0*dfloat(2*(i1_do+i_temp)-kb_scf-1)/dfloat(kb_scf)
     po_kb_scf(3,i1_do)=v_temp_b(3)                                             &
          *.5d0*dfloat(2*(i1_do+i_temp)-kb_scf-1)/dfloat(kb_scf)
  end do

  !                       ------------------------------------                       !

  open(unit=16,file=file_tempout,position='append')
  write(16,*)
  write(16,*) '--------------------------------------------------------------'
  write(16,998) ka_scf,kb_scf
998 format('------------   K-sampling (SCF):',2i4)
  write(16,*) '--------------------------------------------------------------'
  i_temp=0
  do i1_do=1,ka_scf
     do i2_do=1,kb_scf
        i_temp=i_temp+1
        po_kt_scf(1,i_temp)=0.d0
        po_kt_scf(2,i_temp)=po_ka_scf(2,i1_do)+po_kb_scf(2,i2_do)
        po_kt_scf(3,i_temp)=po_ka_scf(3,i1_do)+po_kb_scf(3,i2_do)

        if( ispin_pol_scf < 4 ) then
           temp=po_kt_scf(2,i_temp)**2+po_kt_scf(3,i_temp)**2
           if( dabs(temp) > 1.d-14 ) then
              ksw_po_kt_scf(i_temp)=2
              do i3_do=1,i_temp-1
                 temp=(po_kt_scf(2,i_temp)+po_kt_scf(2,i3_do))**2                   &
                      +(po_kt_scf(3,i_temp)+po_kt_scf(3,i3_do))**2
                 if( dabs(temp) < 1.d-14 ) then
                    ksw_po_kt_scf(i_temp)=0
                    exit
                 end if
              end do
           else
              ksw_po_kt_scf(i_temp)=1
           end if
        else
           ksw_po_kt_scf(i_temp)=1
        end if

        write(16,999) i_temp,ksw_po_kt_scf(i_temp)                             &
             ,po_kt_scf(2,i_temp),po_kt_scf(3,i_temp)
     end do
  end do
  write(16,*) '--------------------------------------------------------------'
999 format(i5,i4,d23.13,d25.13)
  close(16)

  return
end subroutine make_scf_ksampling_scf

subroutine set_ksampling_tr
  use condition_ini
  use hamiltonian_temp
  use gf_se_c
  use constant

  implicit none
  integer :: i1_do,i2_do,i_temp
  real(8) :: temp,v_temp_a(3),v_temp_b(3)

  if( filename_kpoint /= '' ) then
     open(unit=90,file=filename_kpoint)
     read(90,*) ka_tr
     kb_tr=1
     kt_tr=ka_tr*kb_tr
     call alo_tr_negf_kpoint(ka_tr,kb_tr)
     do i1_do=1,ka_tr
        po_kt_tr(1,i1_do)=0.d0
        read(90,*) i2_do,po_kt_tr(2,i1_do),po_kt_tr(3,i1_do)
     end do
     close(90)
  end if

  pai=datan(1.d0)*4.d0
  kt_tr=ka_tr*kb_tr
  call alo_tr_negf_kpoint(ka_tr,kb_tr)

  temp=cell_tempabc(1,2)*cell_tempabc(2,3)-cell_tempabc(1,3)*cell_tempabc(2,2)
  temp=2.d0*pai/temp

  v_temp_a(1)= 0.d0
  v_temp_a(2)= cell_tempabc(2,3)*temp
  v_temp_a(3)=-cell_tempabc(2,2)*temp
  v_temp_b(1)= 0.d0
  v_temp_b(2)=-cell_tempabc(1,3)*temp
  v_temp_b(3)= cell_tempabc(1,2)*temp

  i_temp=(ka_tr-mod(ka_tr,2))/2
  do i1_do=1,ka_tr
     po_ka_tr(1,i1_do)=0.d0
     po_ka_tr(2,i1_do)                                                        &
          =v_temp_a(2)*.5d0*dfloat(2*(i1_do+i_temp)-ka_tr-1)/dfloat(ka_tr)
     po_ka_tr(3,i1_do)                                                        &
          =v_temp_a(3)*.5d0*dfloat(2*(i1_do+i_temp)-ka_tr-1)/dfloat(ka_tr)
  end do
  i_temp=(kb_tr-mod(kb_tr,2))/2
  do i1_do=1,kb_tr
     po_kb_tr(1,i1_do)=0.d0
     po_kb_tr(2,i1_do)                                                        &
          =v_temp_b(2)*.5d0*dfloat(2*(i1_do+i_temp)-kb_tr-1)/dfloat(kb_tr)
     po_kb_tr(3,i1_do)                                                        &
          =v_temp_b(3)*.5d0*dfloat(2*(i1_do+i_temp)-kb_tr-1)/dfloat(kb_tr)
  end do

  i_temp=0
  do i1_do=1,ka_tr
     do i2_do=1,kb_tr
        i_temp=i_temp+1
        po_kt_tr(1,i_temp)=0.d0
        po_kt_tr(2,i_temp)=po_ka_tr(2,i1_do)+po_kb_tr(2,i2_do)
        po_kt_tr(3,i_temp)=po_ka_tr(3,i1_do)+po_kb_tr(3,i2_do)
     end do
  end do

  do i_temp=ka_tr*kb_tr,1,-1
     po_kt_tr(1,i_temp)=po_kt_tr(1,i_temp)-po_kt_tr(1,1)
     po_kt_tr(2,i_temp)=po_kt_tr(2,i_temp)-po_kt_tr(2,1)
     po_kt_tr(3,i_temp)=po_kt_tr(3,i_temp)-po_kt_tr(3,1)
  end do

  return
end subroutine set_ksampling_tr

subroutine show_ksampling
  use condition_ini
  use hamiltonian_temp
  use gf_se_c
  use mod_mpi

  implicit none
  integer :: i1_do

  if( ham_model_ini /= 'rtb_h' .and. ham_model_ini /= 'gsp' ) then

     open(unit=16,file=file_tempout,position='append')
     write(16,*)                                                              &
          '>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<'
     if( filename_kpoint /= '' ) then
        write(16,997) ka_tr
     else
        write(16,998) ka_tr,kb_tr
     end if
     do i1_do=1,ka_tr*kb_tr
        write(16,999) i1_do,po_kt_tr(2,i1_do),po_kt_tr(3,i1_do)
     end do
     write(16,*)                                                              &
          '>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<'
997  format(' >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>    K-sampling :      ',i6,' <<')
998  format(' >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>    K-sampling :',2i6,' <<')
999  format(' >>  ',i5,d25.15,d25.15,' <<')
     close(16)

  end if

  return
end subroutine show_ksampling

! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !
! @@                                                                @@ !
! @@       PROGRAM  ASCOT 2014.440 (ver.4.40)                       @@ !
! @@     "Abinitio Simulation Code for Quantum Transport"           @@ !
! @@                                                                @@ !
! @@                                                                @@ !
! @@  AUTHOR(S): Hisashi KONDO (Univ. Tokyo)                        @@ !
! @@             Naoki WATANABE, Nobutaka NISHIKAWA (Mizuho I.R.)   @@ !
! @@                                                09/May/2014     @@ !
! @@                                                                @@ !
! @@  Contact address: Phase System Consortium                      @@ !
! @@                                                                @@ !
! @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ !

program ascot_main

  use condition_ini
  use scf_negf
  use mod_mpi

  implicit none
  include 'mpif.h'

    integer       :: iargc
    character(50) :: calc_t_negfordft
    character(50) :: file_name

      call MPI_INIT(ierr)
      call MPI_COMM_SIZE(mpi_comm_world,nprocs,ierr)
      call MPI_COMM_RANK(mpi_comm_world,myrank,ierr)

      call MPI__Initialize__ASCOT

      call alo_tempout
      call gen_outf

!                       ------------------------------------                       !

      open(unit=16,file=file_tempout,position='append')
        write(16,*) ':-:-:-:-:-:-:-:-:-:-:-:-:-:-:-::-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:'
        write(16,*) ':-:-:-:-:-:-:-:-:-:-:-:-:-:-:-::-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:'
        write(16,*) ':-:-:-:-:-:-:-:-:                            :-:-:-:-:-:-:-:-:'
        write(16,*) ':-:-:-:-:-:-:-:-: Welcome to ASCOT ver. 4.4  :-:-:-:-:-:-:-:-:'
        write(16,*) ':-:-:-:-:-:-:-:-:                            :-:-:-:-:-:-:-:-:'
        write(16,*) ':-:-:-:-:-:-:-:-:-:-:-:-:-:-:-::-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:'
        write(16,*) ':-:-:-:-:-:-:-:-:-:-:-:-:-:-:-::-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:'
      close(16)

!                       ------------------------------------                       !

      if( myrank == 0 ) then
         if( iargc() >= 1 ) then
           call getarg(1,file_name)
         else
           file_name = ""
         end if
      end if
      call MPI_Bcast( file_name, 50, MPI_CHARACTER, 0, MPI_COMM_WORLD, ierr )
      if( file_name == "" ) then
         open(unit=16,file=file_tempout,position='append')
           write(16,*) '    ??? inputfile ???'
         close(16)
         call MPI_FINALIZE(ierr)
         stop
      end if

      call get_negfordft(file_name,calc_t_negfordft)

      if( calc_t_negfordft == 'dft' .or. calc_t_negfordft == 'DFT' ) then
        call ac_main(file_name)
        call MPI_FINALIZE(ierr)
        stop
      end if

      if( calc_t_negfordft /= 'negf' .and. calc_t_negfordft /= 'NEGF' ) then
        open(unit=16,file=file_tempout,position='append')
          write(16,*) '    +++++ error:: calc_type -  ',calc_t_negfordft
        close(16)
        stop
      end if

      call set_parameter(file_name)

!                       ------------------------------------                       !

      call set_condition_l
      if( switch_l_eigen == 'on' .or. dos_on_off_ini_l == 'on' ) then
        call set_chemical_potential(1)
        if( myrank == 0 ) then
          call print_text_l
        end if
      end if
      call save_hamiltonian_sgf_l
      call unset_condition_l

!                       ------------------------------------                       !

      call set_condition_r
      if( switch_r_eigen == 'on' .or. dos_on_off_ini_r == 'on' ) then
        call set_chemical_potential(2)
        if( myrank == 0 ) then
          call print_text_r
        end if
      end if
      call save_hamiltonian_sgf_r
      call unset_condition_r

!                       ------------------------------------                       !

      if( calc_type /= 'off' ) then
        if( ham_model_ini /= 'input' .and. ham_model_ini /= 'scf_accel' ) then
          call set_locate_atom
          call set_hami_c_pre
        end if
        call set_for_gf_se_c

        if( ham_model_ini == 'scf_accel' ) then
          call scf_main_negf_ac
        end if

        if( calc_type /= 'scf_only' ) then
          if( file_selfenergy == 'none' .or. file_selfe_outsw /= 'on' ) then
            call cal_gf_se_c
          else
            call cal_gf_se_read             ! Self-energies : from input file.
          end if
          if( myrank == 0 ) then
            call output_print
          end if
        end if
        call unset_for_gf_se_c
        if( ham_model_ini == 'scf_accel') then
          call scf_main_unset_negf
        end if
      end if

!                       ------------------------------------                       !

      open(unit=16,file=file_tempout,position='append')
          write(16,*)
          write(16,*)                                                              &
                    '******************** ******************** ********************'
          write(16,*)                                                              &
                    '*                        output files                        *'
          write(16,*)                                                              &
                    '******************** ******************** ********************'
          write(16,*)
        if( ham_model_ini == 'scf_accel' ) then
          write(16,*)                                                              &
                    '                             charge at site -> charge_open.dat'
          write(16,*) '                                  V_hartree -> negf_vh.cube'
          write(16,*)                                                              &
                    '                                      V_tot -> negf_vtot*.cube'
          write(16,*)'                                    density -> negf_den*.cube'
          if( force_calc_onoff == 'on' ) then
            write(16,*)                                                            &
                    '                                      force -> force_negf.dat'
          end if
        end if
        if( calc_type /= 'off' .and. calc_type /= 'scf_only' ) then
          if( calc_type == 'trans' ) then
            write(16,*) '                transmission against energy -> trans.dat'
            write(16,*) '          LDOS of all system against energy -> em_gf.dat'
            write(16,*) '     trace of the surface GF against energy -> sf_gf*.dat'
          end if
          if( calc_type == 'iv' ) then
            write(16,*) '                              current value -> iv.dat'
          end if
          if( switch_out_gf /= 'off' ) then
            if( switch_out_gf == 'all' ) then
              write(16,*)
              write(16,*) '                                     G(E) S -> gfc*.data'
            else
              write(16,*)
              write(16,*) '                diagonal elements of G(E) S -> gfc*.data'
            end if
          end if
          if( switch_out_tr /= 'off' ) then
            if( switch_out_tr == 'all' ) then
              write(16,*) '                                       G(E) -> ftg*.data'
              write(16,*) '                                   Gamma(E) -> gam*.data'
            else
              if( switch_out_tr == 'tr' ) then
                write(16,*)                                                        &
                          '                                       T(E) -> tra*.data'
              else
                write(16,*)                                                        &
                          '                  diagonal elements of T(E) -> tra*.data'
              end if
            end if
          end if
          if( switch_out_ham /= 'off' ) then
            write(16,*) '                         Hamiltonian matrix -> ham*.data'
          end if
          if( file_selfe_outsw /= 'off' .and. file_selfenergy == 'none' ) then
            write(16,*) '                        data of self energy -> sel.data*'
          end if
          write(16,*)
        end if
        if( switch_l_eigen == 'on' ) then
          write(16,*) '          band structure of left electrode  -> ev_l.dat'
        end if
        if( switch_r_eigen == 'on' ) then
          write(16,*) '          band structure of right electrode -> ev_r.dat'
        end if
        if( dos_on_off_ini_l == 'on' ) then
          write(16,*) '                     DOS of left electrode  -> nogf_l.dat'
        end if
        if( dos_on_off_ini_r == 'on' ) then
          write(16,*) '                     DOS of right electrode -> nogf_r.dat'
        end if
        write(16,*)
        write(16,*) ':-:-:-:-:-:-:-:-:-:-:-:-:-:-:-::-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:'
        write(16,*) ':-:-:-:-:-:-:-:-:-:-:-:-:-:-:-::-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:'
        write(16,*) ':-:-:-:-:-:-:-:-:                            :-:-:-:-:-:-:-:-:'
        write(16,*) ':-:-:-:-:-:-:-:-:           finished         :-:-:-:-:-:-:-:-:'
        write(16,*) ':-:-:-:-:-:-:-:-:                            :-:-:-:-:-:-:-:-:'
        write(16,*) ':-:-:-:-:-:-:-:-:-:-:-:-:-:-:-::-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:'
        write(16,*) ':-:-:-:-:-:-:-:-:-:-:-:-:-:-:-::-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:'
        write(16,*)
      close(16)

!                       ------------------------------------                       !

      call unset

!                       ------------------------------------                       !

      call MPI_FINALIZE(ierr)

  stop
end program ascot_main
